<?php

class Zend_FcmPush_Fcm extends Zend_FcmPush_Abstract
{
	const SERVER_URI = 'https://fcm.googleapis.com/fcm/send';

	protected $_httpClient;

	protected $_apiKey;

	public function getApiKey()
    {
        return $this->_apiKey;
    }
	
	public function setApiKey($key)
    {
        if (!is_string($key) || empty($key)) {
            // throw new Zend_Mobile_Push_Exception('The api key must be a string and not empty');
            echo "API key empty not a string";
            return;
        }

        $this->_apiKey = $key;
        return $this;
    }

    public function getHttpClient()
    {
        if (!$this->_httpClient) {
            $this->_httpClient = new Zend_Http_Client();
            $this->_httpClient->setConfig(array(
                'strictredirects' => true,
            ));
        }
        return $this->_httpClient;
    }

    public function setHttpClient(Zend_Http_Client $client)
    {
        $this->_httpClient = $client;
        return $this;
    }


    public function send(Zend_FcmPush_Message_Abstract $message)
    {
        if (!$message->validate()) {
        	echo "invalid message"; die();
            // throw new Zend_Mobile_Push_Exception('The message is not valid.');
        }

        $this->connect();

        $client = $this->getHttpClient();
        $client->setUri(self::SERVER_URI);
        $client->setHeaders('Authorization', 'key=' . $this->getApiKey());

        $json = array('registration_ids' => $message->getToken());
        if ($data = $message->getData()) {
            $json['data'] = $data;
        }
        if ($id = $message->getId()) {
            $json['id'] = $id;
        }
        
       

        $response = $client->setRawData($message->toJson(), 'application/json')
                           ->request('POST');
        $this->close();

        $response_message = json_decode($response->getBody());
        $status = array();
        if(empty($response_message)){
            $status['sent'] = 400;
        }else if ($response_message->success == 1) {
            $status['sent'] = 200;
        } elseif ($response_message->failure = 1) {
            $status['sent'] = 400;
            $status['error'] = $response_message->results[0]->error;
        }
        return $status;
    }

}