<?php

/**
 * Zend Framework
 *
 * LICENSE
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://framework.zend.com/license/new-bsd
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@zend.com so we can send you a copy immediately.
 *
 * @category   Zend
 * @package    Zend_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2005-2012 Zend Technologies USA Inc. (http://www.zend.com)
 * @license    http://framework.zend.com/license/new-bsd     New BSD License
 * @version    $Id: FormPassword.php 24750 2012-05-05 01:24:21Z adamlundrigan $
 */
/**
 * Abstract class for extension
 */
// require_once 'Zend/View/Helper/FormElement.php';

/**
 * Helper to generate a "recaptcha" element
 *
 * @category   Zend
 * @package    Zend_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2005-2012 Zend Technologies USA Inc. (http://www.zend.com)
 * @license    http://framework.zend.com/license/new-bsd     New BSD License
 */
class Zend_View_Helper_FormRecaptcha extends Zend_View_Helper_FormElement {

    public function formRecaptcha($name, $value = null, $attribs = null) {
        if (!isset($attribs['siteKey']) || !isset($attribs['secretKey'])) {
            throw new \Zend_Exception('Site key is not set in the view helper');
        }

        $customClasses = '';
        if (isset($attribs['classes'])) {
            if (is_array($attribs['classes'])) {
                $customClasses = implode(' ', $attribs['classes']);
            } else {
                $customClasses = $attribs['classes'];
            }
        }

        return '<div id="grecap" class="g-recaptcha ' . $customClasses . '" data-sitekey="' . $attribs['siteKey'] . '"></div>';
    }

}
