<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Advancedactivity
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: List.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Advancedactivitypost_Model_Category extends Core_Model_Item_Abstract {

  protected $_type = 'advancedactivity_category';

  public function getType($inflect = false) {
    if ($inflect) {
      return str_replace(' ', '', ucwords(str_replace('_', ' ', $this->_type)));
    }

    return $this->_type;
  }

  public function getTitle() {
    return $this->category_name;
  }

  /**
   * Gets an absolute URL to the page to view this item
   *
   * @return string
   */
  public function getHref($params = array()) {
    $slug = Engine_Api::_()->seaocore()->getSlug($this->category_name, 225);

    $params = array_merge(array(
        'route' => 'aafactivty_category_view',
        'reset' => true,
        'category_id' => $this->category_id,
        'slug' => $slug,
            ), $params);
    $route = $params['route'];
    $reset = $params['reset'];
    unset($params['route']);
    unset($params['reset']);
    return Zend_Controller_Front::getInstance()->getRouter()
                    ->assemble($params, $route, $reset);
  }

  protected function _delete() {
    if ($this->_disableHooks)
      return;

    Engine_Api::_()->getDbtable('actions', 'activity')->update(array('category_id' => 0), array('category_id = ? ' => $this->category_id));
    Engine_Api::_()->getItemTable('advancedactivity_list_item')->delete(array('child_type = ? ' => $this->getType(), 'child_id = ? ' => $this->category_id));
    parent::_delete();
  }

}