<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Allure
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Highlights.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Allure_Form_Admin_Settings_Landingpage_Highlights extends Engine_Form
{

  public function init()
  {
    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can configure settings related to the highlights block. <a title='Preview - Highlight Block' href='application/modules/Allure/externals/images/screenshots/Aided-section.png' target='_blank' class='allure_icon_view' > </a>"));
    
    $this->setTitle("General Settings");
    $this->setDescription("$description");
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setAttrib('id', 'form-upload');

    $imgOptions = Engine_Api::_()->allure()->getImages(array('0' => 'Default image'));

      $this->addElement('Select', 'allure_landing_highlights_image', array(
        'label' => 'Select Center Image',
        'multiOptions' => $imgOptions,
        'value' => $coreSettings->getSetting('allure.landing.highlights.image', ''),
      ));

      $this->addElement('Radio', 'allure_landing_highlights_attachVideo', array(
        'label' => 'Attach Video',
        'description' => "Do you want to attach a video along with centered image?",
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No'
        ),
        'onclick' => 'showVideoUrl()',
        'value' => $coreSettings->getSetting('allure.landing.highlights.attachVideo', 0),
      ));

      $this->addElement('Textarea', 'allure_landing_highlights_videoEmbed', array(
        'label' => 'Video Embed Code',
        'description' => "Please enter embed coded of video.",
        'value' => $coreSettings->getSetting('allure.landing.highlights.videoEmbed', ''),
      ));

      $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'decorators' => array(
          'ViewHelper',
        ),
      ));
  }

}
?>
