<?php

class Bigstep_AdminDemoController extends Core_Controller_Action_Admin {

    protected $_httpHost;
    
    public function init() {
        
        $this->_httpHost = $_SERVER['HTTP_HOST'];
    }

    public function indexAction() {

        // Zend_Feed required DOMDocument
        // @todo add to sanity check
        if (!class_exists('DOMDocument', false)) {
            $this->view->badPhpVersion = true;
            return;
        }

        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        }

        $this->view->form = $form = new Bigstep_Form_Admin_Demo();


        if (!$this->getRequest()->isPost()) {
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();

        if (strstr($values['site_link'], 'http')) {
            $form->getDecorator('errors')->setOption('escape', false);
            $form->addError('Please do not enter "http" or "https" in Site URL field.');
            return;
        }

        //CALLING FUNCTION FROM COMMON QUERY.
        $string = $this->makeSqlQuery($values);

        if (!empty($string)) {
            $this->view->success = true;
            $ZIP_NAME = 'demosql.tar';
            $files_to_zip = array();
            $files_to_zip[] = "demosql.sql";
            //$files_to_zip[] = "readme.php";
            $zipPath = APPLICATION_PATH . "/public/demosql/";
            $result = $this->createZip($files_to_zip, $ZIP_NAME, $zipPath);
        } else {
            $this->view->success = false;
            $this->view->message = array("Sorry! We can not create sql files, Problem could be in server responce OR demosql directory not exist at '/application/modules/Bigstep/controllers/demosql' location. Please check manualy.");
        }
        $form->addNotice('You have succes created a demo setup sql file.');
    }

    /* creates a compressed tar file */

    protected function createZip($files = array(), $ZIP_NAME, $destination = '', $overwrite = false) {

        // EMPTY THE DIRECTORY.
        // we open the directory
        $destination = APPLICATION_PATH . "/public/demosql/";

        // CREATE A DIRECTORY, IF DIRECTORY ARE NOT AVAILABLE.
        $filename = $destination;
        $zipPath = $filename . $ZIP_NAME;
        $is_dir = is_dir($filename);
        if (empty($is_dir)) {
            @mkdir($filename);
        }
        @chmod($filename, 0777);
        @chmod($destination, 0777);
        @chmod($zipPath, 0777);
        $destination = $zipPath;


        // Delete Content from the directory, if available any type of directory.
// 		$handle = opendir($destination);
// 		$is_files = readdir($handle); 
// 		if( !empty($is_files) ) {
// 			// and scan through the items inside
// 			while (FALSE !== ($item = readdir($handle))) {
// 				if($item != '.' && $item != '..') {
// 					// we build the new path to delete
// 					$path = $destination . $item;
// 					unlink($path);
// 				}
// 			}
// 		}
//     // close the directory
//     closedir($handle);

        $valid_files = array();
        if (is_array($files)) {
            //cycle through each file
            foreach ($files as $file) {
                //make sure the file exists
                //if(file_exists($file)) {
                $valid_files[] = $file;
            }
        }

        //if we have good files...
        if (count($valid_files)) {
            //create the archive
            $zip = new Archive_Tar($destination);

            //add the files
            foreach ($valid_files as $file) {
                $filePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/" . $file;
                $getArray[] = $filePath;
            }
            $dontIncludeInDirectoryName = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";

            $zip->addModify($getArray, '', $dontIncludeInDirectoryName);
            //close the zip -- done!
            // $zip->close();
            @chmod($destination, 0777);

// 	    // Kill zend's ob
//       $isGZIPEnabled = false;
//       if (ob_get_level()) {
//         $isGZIPEnabled = true;
//         @ob_end_clean();
//       }
// 
// 			header("Pragma: public");
// 			header("Expires: 0");
// 			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
// 			header("Cache-Control: private", false);
// 			header("Content-Type: application/zip");
// 			header("Content-Disposition: attachment; filename=" . basename($destination) . ";" );
// 			header("Content-Transfer-Encoding: binary");
// 			if(empty($isGZIPEnabled)){
//         header("Content-Length: " . filesize($destination));
//         @flush();
//       }
// 			readfile($destination);
            //check to make sure the file exists
            return file_exists($destination);
        } else {
            return false;
        }
    }

    public function makeSqlQuery($params = array()) {

        $not_include = array('activity', 'authorization', 'announcement', 'messages', 'core', 'fields', 'invite', 'network', 'payment', 'storage', 'user', 'bigstep');
        $module_table = Engine_Api::_()->getDbTable('modules', 'core');
        $module_name = $module_table->info('name');
        $select = $module_table->select()
                ->from($module_name, array('name'))
                ->where($module_name . '.name not in(?)', $not_include);

        $contentModule = $select->query()->fetchAll();
        foreach ($contentModule as $modules) {
            $contentModuleArray[$modules['name']] = $modules['name'];
        }

        $db = Engine_Db_Table::getDefaultAdapter();
        $replace_url = $params["site_link"];
        $site_title = $params['site_title'];

        $final_query = '';
        
        $table_exist = $db->query("SHOW TABLES LIKE 'engine4_dbbackup_backupauthentications'")->fetch();
        if (!empty($table_exist)) {
            $final_query .= 'UPDATE `engine4_dbbackup_backupauthentications` SET htpassword_password = REPLACE(htpassword_password, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE htpassword_password LIKE "%'.$this->_httpHost.'%";';
        }
        
        $final_query = '
UPDATE `engine4_storage_files` SET `service_id` = "1" WHERE `engine4_storage_files`.`service_id` =2;
DELETE FROM `engine4_storage_services` WHERE `engine4_storage_services`.`service_id` = 2;
UPDATE `engine4_storage_services` SET `default` = "1" WHERE `engine4_storage_services`.`service_id` =1;
UPDATE  `engine4_users` SET  `email` =  "' . $params['site_admin_email'] . '" WHERE  `engine4_users`.`user_id` ="1" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_title'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.title" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_description'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.description" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_license_key'] . '" WHERE `engine4_core_settings`.`name` = "core.license.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_admin_email'] . '" WHERE `engine4_core_settings`.`name` = "core.mail.contact" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "no-reply@' . $params['site_link'] . '" WHERE `engine4_core_settings`.`name` = "core.mail.from" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.static.baseurl" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.analytics.code" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.site.keywords" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.general.analytics" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.appid" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.facebook.enable" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.twitter.enable" LIMIT 1 ;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitepage.defaultpagecreate.email" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "bigstep"; 
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "core.html-block";
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "birthdayemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "event.contactemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "siteeventemail.admin" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "testemail.admin" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.secret.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "document.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "eventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "groupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "siteeventdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitegroupdocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "sitepagedocument.api.key";
UPDATE `engine4_core_settings` SET `value` = "csv" WHERE `engine4_core_settings`.`name` = "core.translate.adapter" LIMIT 1 ;
UPDATE `engine4_core_themes` SET `active` = "0" WHERE `engine4_core_themes`.`name` ="demotheme" LIMIT 1 ;
TRUNCATE TABLE `engine4_announcement_announcements`;
TRUNCATE TABLE `engine4_core_reports`;
TRUNCATE TABLE `engine4_core_bannedemails`;
TRUNCATE TABLE `engine4_core_bannedips`;
TRUNCATE TABLE `engine4_core_bannedusernames`;
TRUNCATE TABLE `engine4_user_logins`;
TRUNCATE TABLE `engine4_core_jobs`;
TRUNCATE TABLE `engine4_core_adcampaigns`;
TRUNCATE TABLE `engine4_core_statistics`;
TRUNCATE TABLE `engine4_core_referrers`;
TRUNCATE TABLE `engine4_payment_transactions`;
TRUNCATE TABLE `engine4_activity_notifications`;
TRUNCATE TABLE `engine4_core_session`;
TRUNCATE TABLE `engine4_user_facebook`;
TRUNCATE TABLE `engine4_user_twitter`;
TRUNCATE TABLE `engine4_user_verify`;
TRUNCATE TABLE `engine4_payment_gateways`;
TRUNCATE engine4_messages_conversations;
TRUNCATE engine4_messages_messages;
TRUNCATE engine4_messages_recipients;
TRUNCATE engine4_activity_actions;
TRUNCATE engine4_activity_attachments;
TRUNCATE engine4_activity_comments;
TRUNCATE engine4_activity_likes;
TRUNCATE engine4_activity_stream;
TRUNCATE engine4_core_adphotos;
TRUNCATE engine4_core_ads;
TRUNCATE engine4_core_bannedwords;
TRUNCATE engine4_core_links;
TRUNCATE engine4_core_processes;
TRUNCATE engine4_user_block;
TRUNCATE engine4_user_online;
TRUNCATE engine4_seaocore_locations;
TRUNCATE engine4_seaocore_integratedtype;
TRUNCATE engine4_invites;
TRUNCATE engine4_core_styles;
TRUNCATE engine4_userconnection_setting;
INSERT INTO `engine4_payment_gateways` (`title`, `description`, `enabled`, `plugin`, `config`, `test_mode`) VALUES
("2Checkout", NULL, 0, "Payment_Plugin_Gateway_2Checkout", NULL, 0),
("PayPal", NULL, 0, "Payment_Plugin_Gateway_PayPal", NULL, 0),
("Testing", NULL, 0, "Payment_Plugin_Gateway_Testing", NULL, 1);
DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "544" LIMIT 1;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "seaocore.google.map.key" LIMIT 1 ;
UPDATE `engine4_feedbacks` SET `anonymous_email` = "" WHERE `engine4_feedbacks`.`anonymous_email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitefaq_questions` SET `anonymous_email` = "" WHERE `engine4_sitefaq_questions`.`anonymous_email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitemailtemplates_templates` SET `testemail_admin` = "" WHERE `engine4_sitemailtemplates_templates`.`testemail_admin` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitereview_reviews` SET `anonymous_email` = "" WHERE `engine4_sitereview_reviews`.`anonymous_email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitestaticpage_page_fields_options` SET `email` = "" WHERE `engine4_sitestaticpage_page_fields_options`.`email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitestoreproduct_addresses` SET `email` = "" WHERE `engine4_sitestoreproduct_addresses`.`email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitestoreproduct_gateways` SET `email` = "" WHERE `engine4_sitestoreproduct_gateways`.`email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitestoreproduct_notify_emails` SET `buyer_email` = "" WHERE `engine4_sitestoreproduct_notify_emails`.`buyer_email` LIKE "%bigsteptech.com%";
UPDATE `engine4_sitestoreproduct_order_addresses` SET `email` = "" WHERE `engine4_sitestoreproduct_order_addresses`.`email` LIKE "%bigsteptech.com%";
DELETE FROM `engine4_core_content` WHERE `name` LIKE "%bigstep.%";
UPDATE `engine4_core_content` SET params = REPLACE(params, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE params LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_links` SET uri = REPLACE(uri, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE uri LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_links` SET title = REPLACE(title, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE title LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_links` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE value LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "socialengineaddons.com", "' . $replace_url . '") WHERE value LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE email_signature_en LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "socialengineaddons.com", "' . $replace_url . '") WHERE email_signature_en LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "SocialEngineAddOns", "' . $params['site_title'] . '") WHERE email_signature_en LIKE "%SocialEngineAddOns%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "SocialEngineAddOns.com", "' . $replace_url . '") WHERE body LIKE "%SocialEngineAddOns.com%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%socialengineaddons.com%";
UPDATE `engine4_album_categories` SET banner_url = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE banner_url LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_forum_posts` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_forum_topics` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_sitemobile_menuitems` SET params = REPLACE(params, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE params LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_sitereview_listings` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_sitereview_posts` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_sitestoreoffer_offers` SET url = REPLACE(url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE url LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_suggestion_introductions` SET content = REPLACE(content, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE content LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_sitestoreproduct_startuppages` SET description = REPLACE(description, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE description LIKE "%'.$this->_httpHost.'%";
UPDATE `engine4_siteevent_organizers` SET web_url = REPLACE(web_url, "socialengineaddons.com", "' . $replace_url . '") WHERE web_url LIKE "%socialengineaddons.com%";
UPDATE `engine4_feedbacks` SET anonymous_email = REPLACE(anonymous_email, "socialengineaddons.com", "' . $replace_url . '") WHERE anonymous_email LIKE "%socialengineaddons.com%";
UPDATE `engine4_sitepagenote_notes` SET body = REPLACE(body, "socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%socialengineaddons.com%";
UPDATE `engine4_advancedslideshow_images` SET caption = REPLACE(caption, "socialengineaddons", "' . $site_title . '") WHERE caption LIKE "%socialengineaddons%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "socialengineaddons", "' . $site_title . '") WHERE email_signature_en LIKE "%socialengineaddons%";
UPDATE `engine4_core_search` SET title = REPLACE(title, "socialengineaddons", "' . $site_title . '") WHERE title LIKE "%socialengineaddons%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "socialengineaddons", "' . $site_title . '") WHERE description LIKE "%socialengineaddons%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "socialengineaddons", "' . $site_title . '") WHERE value LIKE "%socialengineaddons%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "socialengineaddons", "' . $site_title . '") WHERE body LIKE "%socialengineaddons%";
UPDATE `engine4_facebookse_mixsettings` SET title = REPLACE(title, "socialengineaddons", "' . $site_title . '") WHERE title LIKE "%socialengineaddons%";
UPDATE `engine4_facebookse_mixsettings` SET description = REPLACE(description, "socialengineaddons", "' . $site_title . '") WHERE description LIKE "%socialengineaddons%";
UPDATE `engine4_siteevent_organizers` SET twitter_url = REPLACE(twitter_url, "socialengineaddons", "' . $site_title . '") WHERE twitter_url LIKE "%socialengineaddons%";
UPDATE `engine4_siteevent_organizers` SET facebook_url = REPLACE(facebook_url, "socialengineaddons", "' . $site_title . '") WHERE facebook_url LIKE "%socialengineaddons%";
UPDATE `engine4_sitefaq_categories` SET category_name = REPLACE(category_name, "socialengineaddons", "' . $site_title . '") WHERE category_name LIKE "%socialengineaddons%";
UPDATE `engine4_sitefaq_questions` SET title = REPLACE(title, "socialengineaddons", "' . $site_title . '") WHERE title LIKE "%socialengineaddons%";
UPDATE `engine4_sitereview_priceinfo` SET title = REPLACE(title, "socialengineaddons", "' . $site_title . '") WHERE title LIKE "%socialengineaddons%";
UPDATE `engine4_sitestaticpage_page_fields_options` SET email = REPLACE(email, "niranjan@bigsteptech.com", "") WHERE email LIKE "%niranjan@bigsteptech.com%";

DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` IN ("backup.navi.auth", "sitestaticpage.navi.auth", "grouppoll.navi.auth","siteestore.navi.auth","suggestion.navi.auth","userconnection.navi.auth","feedback.navi.auth","facebookse.navi.auth","facebooksefeed.navi.auth","facebooksepage.navi.auth","nestedcomment.navi.auth","documentsv4.navi.auth","eventdocument.navi.auth","groupdocument.navi.auth","sitegroupdocument.navi.auth", "sitepagedocument.navi.auth", "eventdocument.isActivate", "sitegroupdocument.isActivate", "sitepagedocument.isActivate", "sitestaticpage.isActivate", "grouppoll.isActivate", "siteestore.isActivate", "feedback.isActivate", "sitecoupon.isActivate", "nestedcomment.isActivate");

DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "communityad" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "communityadsponsored" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "sitemobile" LIMIT 1;
DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "sitemobileapp" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemenu.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemenu.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemenu.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobile.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "sitemobileapp.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityad.lsettings" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.isActivate" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.navi.auth" LIMIT 1;
DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "communityadsponsored.lsettings" LIMIT 1;
UPDATE `engine4_core_modules` SET `enabled` = "0" WHERE `engine4_core_modules`.`name` = "mobi" LIMIT 1 ;
UPDATE `engine4_core_content` SET `params` = "" WHERE `engine4_core_content`.`name` ="sitemenu.menu-footer" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "core.menu-footer" WHERE `engine4_core_content`.`name` ="sitemenu.menu-footer" LIMIT 1 ;
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.layout-width";
UPDATE `engine4_core_content` SET `params` = "" WHERE `engine4_core_content`.`name` ="sitemenu.menu-mini" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "core.menu-mini" WHERE `engine4_core_content`.`name` ="sitemenu.menu-mini" LIMIT 1 ;
UPDATE `engine4_core_content` SET `params` = "" WHERE `engine4_core_content`.`name` ="sitemenu.menu-main" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "core.menu-main" WHERE `engine4_core_content`.`name` ="sitemenu.menu-main" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "advancedslideshow.fullwidth1-advancedslideshows" WHERE `engine4_core_content`.`content_id` ="7989" LIMIT 1 ;
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "siteevent.special-events" AND `engine4_core_content`.`page_id` = "3";
DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitepage.recently-popular-random-sitepage" AND `engine4_core_content`.`page_id` = "3";
UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="41" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="42" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;
UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="40" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;

';

        //start update query for user table.
        $usertable = Engine_Api::_()->getDbtable('users', 'user');
        $select = $usertable->select()->from($usertable->info('name'), 'email')->where('email LIKE ?', '%seaddons.com%');
        $usersitepages = $usertable->fetchAll($select);
        foreach ($usersitepages->toarray() as $email) {
            $replace_email = '@' . $params["site_link"];
            $email = $email['email'];
            $emails = str_replace('@seaddons.com', $replace_email, $email);
            $final_query .= 'UPDATE `engine4_users` SET `email` = "' . $emails . '" WHERE `engine4_users`.`email` = "' . $email . '";';
        }
        //END UPDATE QUERY FOR USER TABLE.
        //UPDATE DEMO.SOCIALENGINEADDONS.COM AND SOCIALENGINEADDONS.COM TO SITE URL.
        if (in_array('advancedslideshow', $contentModuleArray)) {
            $replace_url = $params["site_link"];
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "socialengineaddons.com", "' . $replace_url . '") WHERE `url` LIKE "%socialengineaddons.com%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE `slide_html` LIKE "%'.$this->_httpHost.'%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "socialengineaddons.com", "' . $replace_url . '") WHERE `slide_html` LIKE "%socialengineaddons.com%";';
        }

        //start update query for user table.
        if (in_array('sitestoreproduct', $contentModuleArray)) {
            $orderaddressesTable = Engine_Api::_()->getDbtable('orderaddresses', 'sitestoreproduct');
            $select = $orderaddressesTable->select()->from($orderaddressesTable->info('name'), 'email')->where('email LIKE ?', '%bigsteptech.com%');
            $results = $orderaddressesTable->fetchAll($select);
            foreach ($results->toarray() as $email) {
                $replace_email = '@' . $params["site_link"];
                $email = $email['email'];
                $emails = str_replace('@bigsteptech.com', $replace_email, $email);
                $final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET `email` = "' . $emails . '" WHERE `engine4_sitestoreproduct_order_addresses`.`email` = "' . $email . '";';
            }
            //END UPDATE QUERY FOR USER TABLE.
        }

        //start custom pages delete.
        $corepagesTable = Engine_Api::_()->getDbtable('pages', 'core');
        $select = $corepagesTable->select()->from($corepagesTable->info('name'), 'page_id')->where('url != ?', '0');
        $results = $corepagesTable->fetchAll($select);
        foreach ($results->toarray() as $page_id) {
            $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = "' . $page_id['page_id'] . '";';
            $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "' . $page_id['page_id'] . '";';
        }
        //end delete costom pages delete.

        if (in_array('sitestaticpage', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitestaticpage_pages` SET body = REPLACE(body, "'.$this->_httpHost.'", "' . $replace_url . '") WHERE body LIKE "%'.$this->_httpHost.'%";';
        }

        if (in_array('poke', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "634" LIMIT 1;';
        }

        if (in_array('advancedslideshow', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "635" LIMIT 1;';
        }

        if (in_array('suggestion', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "636" LIMIT 1;';
        }

        if (in_array('facebookse', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "637" LIMIT 1;';
        }

        if (in_array('sitereview', $contentModuleArray) && in_array('sitereviewlistingtype', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1208" LIMIT 1;';
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1218" LIMIT 1;';
        }

        if (in_array('sitefaq', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1219" LIMIT 1;';
        }

        if (in_array('sitebusiness', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1454" LIMIT 1;';
        }

        if (in_array('siteevent', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2612" LIMIT 1;';
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2614" LIMIT 1;';
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2619" LIMIT 1;';
        }

        if (in_array('sitestaticpage', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2772" LIMIT 1;';
        }

        if (in_array('sitemobile', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitemobile_menuitems` SET `params` = REPLACE(params, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `params` LIKE "%'.$this->_httpHost.'%";';
        }

        if (in_array('sitereview', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitereview_categories` SET `banner_url` = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `banner_url` LIKE "%'.$this->_httpHost.'%";';

            $final_query .= 'UPDATE `engine4_sitereview_priceinfo` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';

            $final_query .= 'UPDATE `engine4_sitereview_otherinfo` SET `overview` = REPLACE(overview, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `overview` LIKE "%'.$this->_httpHost.'%";';
        }


        if (in_array('siteevent', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_siteevent_categories` SET `banner_url` = REPLACE(banner_url, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `banner_url` LIKE "%'.$this->_httpHost.'%";';
        }

        if (in_array('sitepageoffer', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitepageoffer_offers` SET `url` = REPLACE(url, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `url` LIKE "%'.$this->_httpHost.'%";';
        }

        $final_query .= 'UPDATE `engine4_core_menuitems` SET `params` = REPLACE(params, "'.$this->_httpHost.'", "' . $params['site_link'] . '") WHERE `params` LIKE "%'.$this->_httpHost.'%";';

        //HERE WE HAVE TO DROP WHICH MODULE ALL TABLE WHICH WE DO NOT WANT TO SETUP AT HIS SITE.
        $table_name = array();
        $module_array = !empty($params['modules_name']) ? $params['modules_name'] : array();

        //delete modules which are not release and reinstalled.
//        $module_not_include = array('sitemobile', 'sitemobileapp', 'sitemenu', 'communityad', 'communityadsponsored', 'document', 'eventdocument', 'groupdocument', 'sitestaticpage', 'poll', 'siteeventdocument', 'sitepagedocument', 'sitegroupdocument', 'siteestore', 'dbbackup', 'grouppoll', 'suggestion', 'userconnection', 'blog', 'classified', 'event', 'forum', 'group', 'music', 'poll', 'video', 'feedback', 'sitecoupon', 'facebookse', 'facebooksefeed', 'facebooksepage', 'nestedcomment');
        
        $module_not_include = array('sitemobile', 'sitemobileapp', 'communityad', 'communityadsponsored', 'document', 'eventdocument', 'groupdocument', 'poll', 'siteeventdocument', 'sitepagedocument', 'sitegroupdocument', 'siteestore', 'dbbackup', 'grouppoll', 'suggestion', 'userconnection', 'blog', 'classified', 'event', 'group', 'music', 'poll', 'feedback', 'sitecoupon', 'facebookse', 'facebooksefeed', 'facebooksepage', 'nestedcomment');        

        $module_array = array_merge($module_not_include, $module_array);

        foreach ($module_array as $module) {

            $tables_array = $db->query("SHOW tables like '%engine4_" . $module . "_%'")->fetchAll();
            foreach ($tables_array as $table) {
                $temp = "Tables_in_" . $params['site_dbname'] . " (%engine4_" . $module . "_%)";
                $table_name = $table[$temp];
                $table_exist = $db->query("SHOW TABLES LIKE '$table_name'")->fetch();
                if (!empty($table_exist)) {
                    $final_query .= "DROP TABLE IF EXISTS `$table_name`;";
                }
            }

            //We have disabled the all modules which do not want to installed on the site.
            $final_query .= 'DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "' . $module . '" LIMIT 1;';
            $final_query .= 'DELETE FROM `engine4_activity_notificationtypes` WHERE `engine4_activity_notificationtypes`.`module` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_seaocores` WHERE `engine4_seaocores`.`module_name` = "' . $module . '";';
            $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` LIKE "' . $module . '.%";';

            //delete page from 'engine4_core_pages' table.
            $moduleNew = $module . "_";
            $tables_array = $db->query("SELECT * FROM `engine4_core_pages` WHERE `name` LIKE '$moduleNew%'")->fetchAll();
            foreach ($tables_array as $table) {
                $page_name = $table['name'];
                $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`name` = "' . $page_name . '";';
            }

            //delete settings from 'engine4_core_settings' table.
            $tables_array = $db->query("SELECT * FROM `engine4_core_settings` WHERE `name` LIKE '$module%'")->fetchAll();
            foreach ($tables_array as $table) {
                $name = $table['name'];
                $final_query .= 'DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "' . $name . '";';
            }

            //delete page from 'engine4_core_menuitems' table.
            $tables_array = $db->query("SELECT * FROM `engine4_core_menuitems` WHERE `module` LIKE '%$module%'")->fetchAll();
            foreach ($tables_array as $table) {
                $page_name = $table['name'];
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = "' . $module . '";';
            }

            //DELETE THE CONTENT FROM OTHER TABLES @THIS IS NOT THE RIGHT METHOD INSTEAD OF THIS WE SHOULD DELETE THE CONTENT USING ITEM OBJECT
            $final_query .= 'DELETE FROM `engine4_core_comments` WHERE `engine4_core_comments`.`resource_type` = "' . $module . '" OR `engine4_core_comments`.`resource_type` LIKE "' . $moduleNew . '%";';
            $final_query .= 'DELETE FROM `engine4_core_likes` WHERE `engine4_core_likes`.`resource_type` = "' . $module . '" OR `engine4_core_likes`.`resource_type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_core_styles` WHERE `engine4_core_styles`.`type` = "' . $module . '" OR `engine4_core_styles`.`type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_core_search` WHERE `engine4_core_search`.`type` = "' . $module . '" OR `engine4_core_search`.`type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_core_tagmaps` WHERE `engine4_core_tagmaps`.`resource_type` = "' . $module . '" OR `engine4_core_tagmaps`.`resource_type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_storage_files` WHERE `engine4_storage_files`.`parent_type` = "' . $module . '" OR `engine4_storage_files`.`parent_type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_activity_actiontypes` WHERE `engine4_activity_actiontypes`.`module` = "' . $module . '";';

            $final_query .= 'DELETE FROM `engine4_authorization_allow` WHERE `engine4_authorization_allow`.`resource_type` = "' . $module . '" OR `engine4_authorization_allow`.`resource_type` LIKE "' . $moduleNew . '%";';

            $final_query .= 'DELETE FROM `engine4_authorization_permissions` WHERE `engine4_authorization_permissions`.`type` = "' . $module . '" OR `engine4_authorization_permissions`.`type` LIKE "' . $moduleNew . '%";';
        }

        $final_query = trim($final_query);
        $sqlFilePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";
        @chmod($sqlFilePath, 0777);

        // Make a sql file here.
        $myFile = $sqlFilePath . "demosql.sql";
        $is_file_exist = file_exists($myFile);
        if (empty($is_file_exist)) {
            return;
        }
        $fh = fopen($myFile, 'w') or die("can't open file");
        fwrite($fh, $final_query); // Correct code.
        fclose($fh);
        return true;
    }

}
