<?php

class Bigstep_AdminLocationdemoController extends Core_Controller_Action_Admin {

    public function indexAction() {

        // Zend_Feed required DOMDocument
        // @todo add to sanity check
        if (!class_exists('DOMDocument', false)) {
            $this->view->badPhpVersion = true;
            return;
        }

        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        }

        $this->view->form = $form = new Bigstep_Form_Admin_Demo();


        if (!$this->getRequest()->isPost()) {
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        $values = $form->getValues();

        //CALLING FUNCTION FROM COMMON QUERY.
        $string = $this->makeSqlQuery($values);

        if (!empty($string)) {
            $this->view->success = true;
            $ZIP_NAME = 'demosql.tar';
            $files_to_zip = array();
            $files_to_zip[] = "demosql.sql";
            //$files_to_zip[] = "readme.php";
            $zipPath = APPLICATION_PATH . "/public/demosql/";
            $result = $this->createZip($files_to_zip, $ZIP_NAME, $zipPath);
        } else {
            $this->view->success = false;
            $this->view->message = array("Sorry! We can not create sql files, Problem could be in server responce OR demosql directory not exist at '/application/modules/Bigstep/controllers/demosql' location. Please check manualy.");
        }
        $form->addNotice('You have succes created a demo setup sql file.');
    }

    /* creates a compressed tar file */

    protected function createZip($files = array(), $ZIP_NAME, $destination = '', $overwrite = false) {

        // EMPTY THE DIRECTORY.
        // we open the directory
        $destination = APPLICATION_PATH . "/public/demosql/";

        // CREATE A DIRECTORY, IF DIRECTORY ARE NOT AVAILABLE.
        $filename = $destination;
        $zipPath = $filename . $ZIP_NAME;
        $is_dir = is_dir($filename);
        if (empty($is_dir)) {
            @mkdir($filename);
        }
        @chmod($filename, 0777);
        @chmod($destination, 0777);
        @chmod($zipPath, 0777);
        $destination = $zipPath;


        // Delete Content from the directory, if available any type of directory.
// 		$handle = opendir($destination);
// 		$is_files = readdir($handle); 
// 		if( !empty($is_files) ) {
// 			// and scan through the items inside
// 			while (FALSE !== ($item = readdir($handle))) {
// 				if($item != '.' && $item != '..') {
// 					// we build the new path to delete
// 					$path = $destination . $item;
// 					unlink($path);
// 				}
// 			}
// 		}
//     // close the directory
//     closedir($handle);

        $valid_files = array();
        if (is_array($files)) {
            //cycle through each file
            foreach ($files as $file) {
                //make sure the file exists
                //if(file_exists($file)) {
                $valid_files[] = $file;
            }
        }

        //if we have good files...
        if (count($valid_files)) {
            //create the archive
            $zip = new Archive_Tar($destination);

            //add the files
            foreach ($valid_files as $file) {
                $filePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/" . $file;
                $getArray[] = $filePath;
            }
            $dontIncludeInDirectoryName = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";

            $zip->addModify($getArray, '', $dontIncludeInDirectoryName);
            //close the zip -- done!
            // $zip->close();
            @chmod($destination, 0777);

// 	    // Kill zend's ob
//       $isGZIPEnabled = false;
//       if (ob_get_level()) {
//         $isGZIPEnabled = true;
//         @ob_end_clean();
//       }
// 
// 			header("Pragma: public");
// 			header("Expires: 0");
// 			header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
// 			header("Cache-Control: private", false);
// 			header("Content-Type: application/zip");
// 			header("Content-Disposition: attachment; filename=" . basename($destination) . ";" );
// 			header("Content-Transfer-Encoding: binary");
// 			if(empty($isGZIPEnabled)){
//         header("Content-Length: " . filesize($destination));
//         @flush();
//       }
// 			readfile($destination);
            //check to make sure the file exists
            return file_exists($destination);
        } else {
            return false;
        }
    }

    public function makeSqlQuery($params = array()) {

        $not_include = array('activity', 'authorization', 'announcement', 'messages', 'core', 'fields', 'invite', 'network', 'payment', 'storage', 'user', 'bigstep');
        $module_table = Engine_Api::_()->getDbTable('modules', 'core');
        $module_name = $module_table->info('name');
        $select = $module_table->select()
                ->from($module_name, array('name'))
                ->where($module_name . '.name not in(?)', $not_include);

        $contentModule = $select->query()->fetchAll();
        foreach ($contentModule as $modules) {
            $contentModuleArray[$modules['name']] = $modules['name'];
        }

        $db = Engine_Db_Table::getDefaultAdapter();
        $replace_url = $params["site_link"];
        $site_title = $params['site_title'];

        $final_query = '';
        $final_query = '
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_title'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.title" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "' . $params['site_description'] . '" WHERE `engine4_core_settings`.`name` = "core.general.site.description" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.static.baseurl" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.appid" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.facebook.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.facebook.enable" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.key" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "" WHERE `engine4_core_settings`.`name` = "core.twitter.secret" LIMIT 1 ;
UPDATE `engine4_core_settings` SET `value` = "none" WHERE `engine4_core_settings`.`name` = "core.twitter.enable" LIMIT 1 ;
TRUNCATE TABLE `engine4_announcement_announcements`;
TRUNCATE TABLE `engine4_core_reports`;
TRUNCATE TABLE `engine4_user_logins`;
TRUNCATE TABLE `engine4_core_adcampaigns`;
TRUNCATE TABLE `engine4_core_statistics`;
TRUNCATE TABLE `engine4_core_referrers`;
TRUNCATE TABLE `engine4_payment_transactions`;
TRUNCATE TABLE `engine4_core_session`;
TRUNCATE TABLE `engine4_user_facebook`;
TRUNCATE TABLE `engine4_user_twitter`;
TRUNCATE TABLE `engine4_user_verify`;
TRUNCATE engine4_core_links;
TRUNCATE engine4_core_processes;
TRUNCATE engine4_user_block;
TRUNCATE engine4_user_online;
TRUNCATE engine4_invites;
TRUNCATE engine4_userconnection_setting;
UPDATE `engine4_core_content` SET params = REPLACE(params, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE params LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_links` SET uri = REPLACE(uri, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE uri LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_links` SET title = REPLACE(title, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE title LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_links` SET description = REPLACE(description, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE value LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_settings` SET value = REPLACE(value, "socialengineaddons.com", "' . $replace_url . '") WHERE value LIKE "%socialengineaddons.com%";
UPDATE `engine4_core_search` SET description = REPLACE(description, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_mailtemplates` SET email_signature_en = REPLACE(email_signature_en, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE email_signature_en LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_status` SET body = REPLACE(body, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_album_categories` SET banner_url = REPLACE(banner_url, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE banner_url LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_dbbackup_backupauthentications` SET htpassword_password = REPLACE(htpassword_password, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE htpassword_password LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_forum_posts` SET body = REPLACE(body, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_forum_topics` SET description = REPLACE(description, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_sitemobile_menuitems` SET params = REPLACE(params, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE params LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_sitereview_listings` SET body = REPLACE(body, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_sitereview_posts` SET body = REPLACE(body, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_sitestoreoffer_offers` SET url = REPLACE(url, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE url LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_suggestion_introductions` SET content = REPLACE(content, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE content LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_sitestoreproduct_startuppages` SET description = REPLACE(description, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE description LIKE "%demo.socialengineaddons.com%";
UPDATE `engine4_core_settings` SET `value` = "csv" WHERE `engine4_core_settings`.`name` = "core.translate.adapter" LIMIT 1 ;
';

        //start update query for user table.
//     $usertable = Engine_Api::_()->getDbtable('users', 'user');
// 		$select = $usertable->select()->from($usertable->info('name'), 'email')->where('email LIKE ?', '%seaddons.com%');
// 		$usersitepages = $usertable->fetchAll($select);
// 		foreach ($usersitepages->toarray() as $email)  {
// 		  $replace_email = '@'. $params["site_link"];
// 		  $email = $email['email'];
// 			$emails = str_replace('@seaddons.com', $replace_email, $email);
//       $final_query .= 'UPDATE `engine4_users` SET `email` = "'.$emails.'" WHERE `engine4_users`.`email` = "'.$email.'";';
// 		}
        //END UPDATE QUERY FOR USER TABLE.
        //UPDATE DEMO.SOCIALENGINEADDONS.COM AND SOCIALENGINEADDONS.COM TO SITE URL.
        if (in_array('advancedslideshow', $contentModuleArray)) {
            $replace_url = $params["site_link"];
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE `url` LIKE "%demo.socialengineaddons.com%";';
            //$final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `url` = REPLACE(url, "socialengineaddons.com", "'.$replace_url.'") WHERE `url` LIKE "%socialengineaddons.com%";';
            $final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE `slide_html` LIKE "%demo.socialengineaddons.com%";';
            //$final_query .= 'UPDATE `engine4_advancedslideshow_images` SET `slide_html` = REPLACE(slide_html, "socialengineaddons.com", "'.$replace_url.'") WHERE `slide_html` LIKE "%socialengineaddons.com%";';
        }

        //start update query for user table.
// 		if(in_array('sitestoreproduct', $contentModuleArray)) {
// 			$orderaddressesTable = Engine_Api::_()->getDbtable('orderaddresses', 'sitestoreproduct');
// 			$select = $orderaddressesTable->select()->from($orderaddressesTable->info('name'), 'email')->where('email LIKE ?', '%bigsteptech.com%');
// 			$results = $orderaddressesTable->fetchAll($select);
// 			foreach ($results->toarray() as $email)  {
// 				$replace_email = '@'. $params["site_link"];
// 				$email = $email['email'];
// 				$emails = str_replace('@bigsteptech.com', $replace_email, $email);
// 				$final_query .= 'UPDATE `engine4_sitestoreproduct_order_addresses` SET `email` = "'.$emails.'" WHERE `engine4_sitestoreproduct_order_addresses`.`email` = "'.$email.'";';
// 			}
// 			//END UPDATE QUERY FOR USER TABLE.
// 		}
        //start custom pages delete.
// 	  $corepagesTable = Engine_Api::_()->getDbtable('pages', 'core');
// 		$select = $corepagesTable->select()->from($corepagesTable->info('name'), 'page_id')->where('url != ?', '0');
// 		$results = $corepagesTable->fetchAll($select);
// 		foreach ($results->toarray() as $page_id)  {
// 			$final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = "'.$page_id['page_id'].'";';
// 			$final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "'.$page_id['page_id'].'";';
// 		}
        //end delete costom pages delete.

        if (in_array('sitestaticpage', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitestaticpage_pages` SET body = REPLACE(body, "demo.socialengineaddons.com", "' . $replace_url . '") WHERE body LIKE "%demo.socialengineaddons.com%";';
        }

// 		if(in_array('poke', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "634" LIMIT 1;';
// 		}
// 		if(in_array('advancedslideshow', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "635" LIMIT 1;';
// 		}
// 		if(in_array('suggestion', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "636" LIMIT 1;';
// 		}
// 		if(in_array('facebookse', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "637" LIMIT 1;';
// 		}
// 		if(in_array('sitereview', $contentModuleArray) && in_array('sitereviewlistingtype', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1208" LIMIT 1;';
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1218" LIMIT 1;';
// 		}
// 		if(in_array('sitefaq', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1219" LIMIT 1;';
// 		}

        if (in_array('sitebusiness', $contentModuleArray)) {
            $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1454" LIMIT 1;';
        }

// 		if(in_array('siteevent', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2612" LIMIT 1;';
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2614" LIMIT 1;';
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2619" LIMIT 1;';
// 		}
// 		if(in_array('sitestaticpage', $contentModuleArray)) {
// 			$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2772" LIMIT 1;';
// 		}

        if (in_array('sitemobile', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitemobile_menuitems` SET `params` = REPLACE(params, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `params` LIKE "%demo.socialengineaddons.com%";';
        }

        if (in_array('sitereview', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitereview_categories` SET `banner_url` = REPLACE(banner_url, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `banner_url` LIKE "%demo.socialengineaddons.com%";';

            $final_query .= 'UPDATE `engine4_sitereview_priceinfo` SET `url` = REPLACE(url, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `url` LIKE "%demo.socialengineaddons.com%";';

            $final_query .= 'UPDATE `engine4_sitereview_otherinfo` SET `overview` = REPLACE(overview, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `overview` LIKE "%demo.socialengineaddons.com%";';
        }


        if (in_array('siteevent', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_siteevent_categories` SET `banner_url` = REPLACE(banner_url, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `banner_url` LIKE "%demo.socialengineaddons.com%";';
        }

        if (in_array('sitepageoffer', $contentModuleArray)) {
            $final_query .= 'UPDATE `engine4_sitepageoffer_offers` SET `url` = REPLACE(url, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `url` LIKE "%demo.socialengineaddons.com%";';
        }

        $final_query .= 'UPDATE `engine4_core_menuitems` SET `params` = REPLACE(params, "demo.socialengineaddons.com", "' . $params['site_link'] . '") WHERE `params` LIKE "%demo.socialengineaddons.com%";';


        //HERE WE HAVE TO DROP WHICH MODULE ALL TABLE WHICH WE DO NOT WANT TO SETUP AT HIS SITE.
        $table_name = array();
        $module_array = $params['modules_name'];
        //delete modules which are not release and reinstalled.
//     $module_not_include = array('sitemobile', 'sitemobileapp', 'sitemenu', 'communityad', 'communityadsponsored', 'document', 'eventdocument', 'sitepagedocument', 'sitegroupdocument', 'groupdocument', 'sitestaticpage', 'grouppoll', 'poll', 'siteeventdocument', 'sitepagedocument', 'sitegroupdocument', 'siteestore', 'dbbackup', 'grouppoll','suggestion', 'userconnection', 'blog', 'classified', 'event', 'forum', 'group', 'music', 'poll', 'video', 'feedback', 'sitecoupon', 'facebookse', 'facebooksefeed', 'facebooksepage', 'nestedcomment');
        $module_not_include = array('document', 'eventdocument', 'groupdocument', 'grouppoll', 'poll', 'siteestore', 'blog', 'classified', 'event', 'group', 'poll', 'dbbackup', 'mapprofiletypelevel', 'mcard', 'siteslideshow');
        if (!empty($module_array)) {
            $module_array = array_merge($module_not_include, $module_array);
        } else {
            $module_array = $module_not_include;
        }

        if (!empty($module_array)) {

            foreach ($module_array as $module) {
                $tables_array = $db->query("SHOW tables like '%engine4_" . $module . "_%'")->fetchAll();
                foreach ($tables_array as $table) {
                    $temp = "Tables_in_" . $params['site_dbname'] . " (%engine4_" . $module . "_%)";
                    $table_name = $table[$temp];
                    $table_exist = $db->query("SHOW TABLES LIKE '$table_name'")->fetch();
                    if (!empty($table_exist)) {
                        $final_query .= "DROP TABLE IF EXISTS `$table_name`;";
                    }
                }
            }

            //We have disabled the all modules which do not want to installed on the site.
            foreach ($module_array as $module) {
                //$final_query .= "UPDATE `engine4_core_modules` SET `enabled` = '0' WHERE `engine4_core_modules`.`name` = '$module';";
                $final_query .= 'DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = "' . $module . '" LIMIT 1;';
                $final_query .= 'DELETE FROM `engine4_activity_notificationtypes` WHERE `engine4_activity_notificationtypes`.`module` = "' . $module . '";';
                $final_query .= 'DELETE FROM `engine4_seaocores` WHERE `engine4_seaocores`.`module_name` = "' . $module . '";';
                $final_query .= 'DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` LIKE "' . $module . '.%";';
            }

            //delete page from 'engine4_core_pages' table.
            foreach ($module_array as $module) {
                $tables_array = $db->query("SELECT * FROM `engine4_core_pages` WHERE `name` LIKE '%$module%'")->fetchAll();
                foreach ($tables_array as $table) {
                    $page_name = $table['name'];
                    $final_query .= 'DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`name` = "' . $page_name . '";';
                }
            }

            //delete settings from 'engine4_core_settings' table.
            foreach ($module_array as $module) {
                $module = $module . '.%';
                $tables_array = $db->query("SELECT * FROM `engine4_core_settings` WHERE `name` LIKE '$module'")->fetchAll();
                foreach ($tables_array as $table) {
                    $name = $table['name'];
                    $final_query .= 'DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = "' . $name . '";';
                }
            }

            //delete page from 'engine4_core_menuitems' table.
            foreach ($module_array as $module) {
                $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = "' . $module . '";';
// 				$tables_array =   $db->query("SELECT * FROM `engine4_core_menuitems` WHERE `module` LIKE '%$module%'")->fetchAll(); 
// 				foreach($tables_array as $table) {
// 				  $page_name = $table['name']; 
//           $final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = "'.$module.'";';
// 				}
            }
        }


        $final_query = trim($final_query);
        $sqlFilePath = APPLICATION_PATH . "/application/modules/Bigstep/controllers/demosql/";
        @chmod($sqlFilePath, 0777);

        // Make a sql file here.
        $myFile = $sqlFilePath . "demosql.sql";
        $is_file_exist = file_exists($myFile);
        if (empty($is_file_exist)) {
            return;
        }
        $fh = fopen($myFile, 'w') or die("can't open file");
        fwrite($fh, $final_query); // Correct code.
        fclose($fh);
        return true;
    }

}