<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Controller.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Bigstep_Widget_MenuMainController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $action = $front->getRequest()->getActionName();
        $controller = $front->getRequest()->getControllerName();

        if ($module == 'bigstep' && $controller == 'index' && $action == 'advanced-menu') {
            $this->view->showAdvancedMenu = true;
            $this->getElement()->removeDecorator('Title');
            $this->getElement()->removeDecorator('Container');
        } else {
            $this->view->navigation = $navigation = Engine_Api::_()
                    ->getApi('menus', 'bigstep')
                    ->getNavigation('core_main');

            $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
            $require_check = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.browse', 1);
            if (!$require_check && !$viewer->getIdentity()) {
                $navigation->removePage($navigation->findOneBy('route', 'user_general'));
            }
        }
    }

    public function getCacheKey() {
        //return Engine_Api::_()->user()->getViewer()->getIdentity();
    }

}