<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Widget_PushSubscriptionController extends Engine_Content_Widget_Abstract {

    public function init() {
        parent::init();

        // Set time zone
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);
    }

    public function indexAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->uid = $uid = $viewer->getIdentity();
        $this->view->webPushId = $webPushId = Engine_Api::_()->getDbtable('settings', 'core')->getSetting('sitepushnotification.webpushid', '');
        $this->view->subdomain = $subdomain = Engine_Api::_()->getDbtable('settings', 'core')->getSetting('sitepushnotification.subdomain', '');
        $check = Engine_Api::_()->getDbtable('settings', 'core')->getSetting('sitepushnotification.protocol', '');
        $this->view->userPushSetting = $userPushSetting = Engine_Api::_()->getApi('core', 'sitepushnotification')->getUserPushSetting($uid);
        $pushenabled = Zend_Registry::isRegistered('sitepushnotification_pushenabled') ? Zend_Registry::get('sitepushnotification_pushenabled') : null;
        if (empty($pushenabled)) {
            return;
        }
        if ($userPushSetting == '0') {
            Engine_Api::_()->getDbtable('users', 'sitepushnotification')->deleteUserSubscription($uid);
        }

        if ($check == '1') {
            $this->view->protocol = $protocol = 'http:';
        } elseif ($check == '') {
            $this->view->protocol = $protocol = 'https:';
        }

        // $isHttpProtocol = ($protocol === "https:") ? false : true;
        // if ($isHttpProtocol && empty($subdomain)) {
        //     return $this->setNoRender();
        // }
    }

}
