<?php

/**
* SocialEngine
*
* @category   Application_Extensions
* @package    Birthday
* @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
* @license    http://www.socialengineaddons.com/license/
* @version    $Id: install.php 6590 2010-17-11 9:40:21Z SocialEngineAddOns $
* @author     SocialEngineAddOns
*/
class Birthday_Installer extends Engine_Package_Installer_Module
{
  function onInstall()
  {
    $db = $this->getDb() ;

    // Delete the module of birthday email
    $db->query('DELETE FROM `engine4_core_modules` WHERE `name` = "birthdayemail";');
    
    $db->query('UPDATE `engine4_core_mailtemplates` SET `module` = "birthday" WHERE `type` = "birthday_wish";');
    $db->query('UPDATE `engine4_core_mailtemplates` SET `module` = "birthday" WHERE `type` = "birthday_reminder";');
    $db->query('UPDATE `engine4_activity_notificationtypes` SET `module` = "birthday" WHERE `type` = "birthday_reminder";');
    $db->query('UPDATE `engine4_core_menuitems` SET `name` = "birthday_admin_main_emailsettings", `params` = \'{"route":"admin_default","module":"birthday","controller":"emailsettings"}\' WHERE `module` = "birthday" AND `order` = 2 ;');
    
    $select = new Zend_Db_Select( $db ) ;
    //user index page
    $select
		->from( 'engine4_core_pages' )
		->where( 'name = ?' , 'user_index_home' )
		->limit( 1 ) ;
    $page_id = $select->query()->fetchObject()->page_id ;
    if ( !empty( $page_id ) ) {
      // container_id (will always be there)
      $select = new Zend_Db_Select( $db ) ;
      $select
			  ->from( 'engine4_core_content' )
			  ->where( 'page_id = ?' , $page_id )
			  ->where( 'type = ?' , 'container' )
			  ->where( 'name = ?' , 'main' )
			  ->limit( 1 ) ;
      $container_id = $select->query()->fetchObject()->content_id ;
      if ( !empty( $container_id ) ) {
				// right_id (will always be there)
				$select = new Zend_Db_Select( $db ) ;
				$select
				    ->from( 'engine4_core_content' )
				    ->where( 'parent_content_id = ?' , $container_id )
				    ->where( 'type = ?' , 'container' )
				    ->where( 'name = ?' , 'right' )
				    ->limit( 1 ) ;
				$right_id = $select->query()->fetchObject()->content_id ;

				// Check right_id is empty or not
				if ( !empty( $right_id ) ) {

				  // Check if it's already been placed
				  $select = new Zend_Db_Select( $db ) ;
				  $select
				      ->from( 'engine4_core_content' )
				      ->where( 'page_id = ?' , $page_id )
				      ->where( 'type = ?' , 'widget' )
				      ->where( 'name = ?' , 'birthday.show-birthdays' ) ;
				  $info = $select->query()->fetch() ;
				  if ( empty( $info ) ) {
				    // tab on profile
				    $db->insert( 'engine4_core_content' , array (
				      'page_id' => $page_id ,
				      'type' => 'widget' ,
				      'name' => 'birthday.show-birthdays' ,
				      'parent_content_id' => $right_id ,
				      'order' => 23 ,
				      'params' => '{"title":"Birthdays","titleCount":"true"}',
					) ) ;
				  }
				}
      }
    }
    
    $select = new Zend_Db_Select($db);  
    $select
            ->from('engine4_activity_actiontypes')
            ->where('type = ?', 'birthday_post')
            ->where('module = ?', 'birthday')
            ->limit(1);
    $row = $select->query()->fetchObject();
    if (empty($row)) {
      $enable = 0;
      $select = new Zend_Db_Select($db);     
      $select
              ->from('engine4_core_modules')
              ->where('name = ?', 'advancedactivity')
              ->limit(1);
      $moduleAdvancedactivity = $select->query()->fetchObject();
      if ($moduleAdvancedactivity)
        $enable = 1;
      
      $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES
(\'birthday_post\', \'birthday\', \'{actors:$subject:$object}:\r\n{body:$body}\', ' . $enable . ', 3, 1, 1, 1, 0);');
    }
    
    $select = new Zend_Db_Select($db);
    $select
        ->from('engine4_core_modules')
        ->where('name = ?', 'core')
        ->limit(1);
    $core_version =  $select->query()->fetchAll();
    if ( !empty($core_version) ) {
			$version = $core_version[0]['version'];
			if( empty($this->checkVersion($version, '4.1.0')) ) {
				$select = new Zend_Db_Select($db);
				$select
						->from('engine4_core_tasks')
						->where('plugin = ?', 'Birthday_Plugin_Task_ReminderMail')
						->where('title = ?', 'Birthday Reminder')
						->limit(1);
				$task = $select->query()->fetchAll();
				if (empty($task)) {
					$db->insert('engine4_core_tasks', array(
					'title' => "Birthday Reminder",
					'category' => 'system',
					'module' => 'birthday',
					'system' => '1',
					'plugin' => "Birthday_Plugin_Task_ReminderMail",
					'timeout' => "86400",
					'type' => 'automatic',
					'state' => 'dormant',
					'data' => NULL,
					'enabled' => "1",
					'executing' => "0",
					'executing_id' => "0",
					'started_last' => "0",
					'started_count' => "0",
					'completed_last' => "0",
					'completed_count' => "0",
					'failure_last' => "0",
					'failure_count' => "0",
					'success_last' => "0",
					'success_count' => "0",
				));
				}
				// Insert the 
				$select = new Zend_Db_Select($db);
				$select
						->from('engine4_core_tasks')
						->where('plugin = ?', 'Birthday_Plugin_Task_WishMail')
						->where('title = ?', 'Birthday Wish')
						->limit(1);
				$task = $select->query()->fetchAll();
				if (empty($task)) {
					$db->insert('engine4_core_tasks', array(
					'title' => "Birthday Wish",
					'category' => 'system',
					'module' => 'birthday',
					'system' => '1',
					'plugin' => "Birthday_Plugin_Task_WishMail",
					'timeout' => "86400",
					'type' => 'automatic',
					'state' => 'dormant',
					'data' => NULL,
					'enabled' => "1",
					'executing' => "0",
					'executing_id' => "0",
					'started_last' => "0",
					'started_count' => "0",
					'completed_last' => "0",
					'completed_count' => "0",
					'failure_last' => "0",
					'failure_count' => "0",
					'success_last' => "0",
					'success_count' => "0",
				));
				}
			}else {
				$select = new Zend_Db_Select($db);
				$select
						->from('engine4_core_tasks')
						->where('plugin = ?', 'Birthday_Plugin_Task_ReminderMail')
						->where('title = ?', 'Birthday Reminder')
						->limit(1);
				$task = $select->query()->fetchAll();
				if (empty($task)) {
					$db->insert('engine4_core_tasks', array(
					'title' => "Birthday Reminder",
					'module' => 'birthday',
					'plugin' => "Birthday_Plugin_Task_ReminderMail",
					'timeout' => "86400",
					'processes' => "1",
					'semaphore' => "0",
					'started_last' => "0",
					'started_count' => "0",
					'completed_last' => "0",
					'completed_count' => "0",
					'failure_last' => "0",
					'failure_count' => "0",
					'success_last' => "0",
					'success_count' => "0",
				));
				}

				// Insert the 
				$select = new Zend_Db_Select($db);
				$select
						->from('engine4_core_tasks')
						->where('plugin = ?', 'Birthday_Plugin_Task_WishMail')
			->where('title = ?', 'Birthday Wish')
						->limit(1);
				$task = $select->query()->fetchAll();
				if (empty($task)) {
					$db->insert('engine4_core_tasks', array(
					'title' => "Birthday Wish",
					'module' => 'birthday',
					'plugin' => "Birthday_Plugin_Task_WishMail",
					'timeout' => "86400",
					'processes' => "1",
					'semaphore' => "0",
					'started_last' => "0",
					'started_count' => "0",
					'completed_last' => "0",
					'completed_count' => "0",
					'failure_last' => "0",
					'failure_count' => "0",
					'success_last' => "0",
					'success_count' => "0",
				));
				}
			}
		}
    parent::onInstall();
  }
      function checkVersion($databaseVersion, $checkDependancyVersion) {
        if (strcasecmp($databaseVersion, $checkDependancyVersion) == 0)
            return -1;
        $databaseVersionArr = explode(".", $databaseVersion);
        $checkDependancyVersionArr = explode('.', $checkDependancyVersion);
        $fValueCount = $count = count($databaseVersionArr);
        $sValueCount = count($checkDependancyVersionArr);
        if ($fValueCount > $sValueCount)
            $count = $sValueCount;
        for ($i = 0; $i < $count; $i++) {
            $fValue = $databaseVersionArr[$i];
            $sValue = $checkDependancyVersionArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                $result = $this->compareValues($fValue, $sValue);
                if ($result == -1) {
                    if (($i + 1) == $count) {
                        return $this->compareValues($fValueCount, $sValueCount);
                    } else
                        continue;
                }
                return $result;
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);
                $result = $this->compareValues($fsArr[0], $sValue);
                return $result == -1 ? 1 : $result;
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fValue, $ssArr[0]);
                return $result == -1 ? 0 : $result;
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fsArr[0], $ssArr[0]);
                if ($result != -1)
                    return $result;
                $result = $this->compareValues($fsArr[1], $ssArr[1]);
                return $result;
            }
        }
    }
    public function compareValues($firstVal, $secondVal) {
        $num = $firstVal - $secondVal;
        return ($num > 0) ? 1 : ($num < 0 ? 0 : -1);
    }
}
