<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2020 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Category.php 9747 2012-07-26 02:08:08Z john $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2020 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Blog_Form_Admin_Category extends Engine_Form
{
  protected $_field;

  public function init()
  {
    $category_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('id', 0);
    $category = Engine_Api::_()->getItem('blog_category', $category_id);
    
    $this->setMethod('post')
        ->setAttrib('class', 'global_form_box');

    /*
    $type = new Zend_Form_Element_Hidden('type');
    $type->setValue('heading');
    */
    
    $categoryTable = Engine_Api::_()->getDbTable('categories', 'blog');
    $blogTable = Engine_Api::_()->getDbTable('blogs', 'blog');
    
    $subcategory = $categoryTable->getSubcategory(array('category_id' => $category_id));
    $subsubcategory = $categoryTable->getSubsubcategory(array('category_id' => $category_id));
    
    $categoryBlog = $blogTable->isBlogExists('category_id', $category_id);
    $subcatBlog = $blogTable->isBlogExists('subcat_id', $category_id);
    $subsubcatBlog = $blogTable->isBlogExists('subsubcat_id', $category_id);
    
    if(count($subcategory) == 0 && count($subsubcategory) == 0 && empty($category->subsubcat_id) && empty($categoryBlog) && empty($subcatBlog) && empty($subsubcatBlog)) {
      
      $categories = $categoryTable->getEditCategories(array('category_id' => $category_id));
      if(count($categories) > 0) {
        $this->addElement('Select', 'parentcategory_id', array(
          'label' => 'Parent Category',
          'multiOptions' => $categories,
        ));
      }
    }

    $label = new Zend_Form_Element_Text('label');
    $label->setLabel('Category Name')
      ->addValidator('NotEmpty')
      ->setRequired(true)
      ->setAttrib('class', 'text');


    $id = new Zend_Form_Element_Hidden('id');


    $this->addElements(array(
      //$type,
      $label,
      $id
    ));
    
    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Add Category',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onClick'=> 'javascript:parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');


  }

  public function setField($category)
  {
    $this->_field = $category;

    // Set up elements
    //$this->removeElement('type');
    $this->label->setValue($category->category_name);
    $this->id->setValue($category->category_id);
    $this->submit->setLabel('Edit Category');

    // @todo add the rest of the parameters
  }
}
