<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteapi
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Core.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Calendar_Api_Siteapi_Core extends Core_Api_Abstract {
	/**
     * Return the Create Form. 
     * 
     * @return array
     */
    public function getCalendarForm() {
        $accountForm = array();
        $viewer = Engine_Api::_()->user()->getViewer();

        $accountForm[] = array(
            'type' => 'Text',
            'name' => 'title',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Title'),
            'hasValidator' => true
        );

        $accountForm[] = array(
            'type' => 'Text',
            'name' => 'toValues',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Existing Members')
        );

        $accountForm[] = array(
            'type' => 'Text',
            'name' => 'non_members',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Non-existing Members'),
            'description' => 'Please enter E-mail Addresses seperated by a comma(,). '
        );
        
        $accountForm[] = array(
            'type' => 'Checkbox',
            'name' => 'search',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Show this calendar entry in search results'),
            'value' => 1
        );

        $accountForm[] = array(
	        'type' => 'Submit',
	        'name' => 'submit',
	        'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Save')
	    );

	    return $accountForm;
    }

    public function getScheduleForm() {
        $accountForm = array();
        $viewer = Engine_Api::_()->user()->getViewer();

        $user = Engine_Api::_()->user()->getViewer();
        $calendars = Engine_Api::_()->getItemTable('calendar')->getAllCalendars();
        $options = array();
        foreach ($calendars as $calendar) {
            $options[$calendar->getIdentity()] = $calendar->getTitle();
        }

        $accountForm[] = array(
            'type' => 'Select',
            'name' => 'calendar_id',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Calendar'),
            'multiOptions' => $options,
            'hasValidator' => true
        );

        $accountForm[] = array(
            'type' => 'Text',
            'name' => 'title',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Title'),
            'hasValidator' => true
        );

        $accountForm[] = array(
            'type' => 'Date',
            'name' => 'start_datetime',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate("Start Time"),
            'hasValidator' => true
        );

        $accountForm[] = array(
            'type' => 'Date',
            'name' => 'end_datetime',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate("End Time"),
            'hasValidator' => true
        );
        
        $accountForm[] = array(
            'type' => 'Text',
            'name' => 'location',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Location'),
            'hasValidator' => true
        );

        $accountForm[] = array(
            'type' => 'textarea',
            'name' => 'body',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Details'),
        );

        $accountForm[] = array(
            'type' => 'Submit',
            'name' => 'submit',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Save')
        );

        return $accountForm;
    }



    public function getGroupForm($edit = 0) {
        $groupForm = array();
        $viewer = Engine_Api::_()->user()->getViewer();

        $groupForm[] = array(
            'type' => 'Text',
            'name' => 'title',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Group Name'),
            'hasValidator' => true
        );

        $groupForm[] = array(
            'type' => 'File',
            'name' => 'photo',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Profile Photo')
        );

        if($edit == 0){
            $groupForm[] = array(
                'type' => 'Text',
                'name' => 'to',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Existing Members')
            );

            $groupForm[] = array(
                'type' => 'Text',
                'name' => 'non_members',
                'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Non-existing Members'),
                'description' => 'Please enter E-mail Addresses seperated by a comma(,). '
            );
        }
        
        $groupForm[] = array(
            'type' => 'Submit',
            'name' => 'submit',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Save')
        );

        return $groupForm;
    }

    public function addGroupMemberForm() {
        $groupForm = array();
        $groupForm[] = array(
            'type' => 'Text',
            'name' => 'to',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Existing Members')
        );

        $groupForm[] = array(
            'type' => 'Text',
            'name' => 'non_members',
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Add Non-existing Members'),
            'description' => 'Please enter E-mail Addresses seperated by a comma(,). '
        );

        return $groupForm;
    }
}