<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteapi
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    FormValidators.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Calendar_Api_Siteapi_FormValidators extends Siteapi_Api_Validators {

    /**
     * Validations of Create OR Edit Form.
     * 
     * @param object $subject get object
     * @param array $formValidators array variable
     * @return array
     */
    public function getCalendarFormValidators($subject = array(), $formValidators = array()) {

    	$formValidators['title'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Title'),
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', false, array(3, 63))
            )
        );

        return $formValidators;
    }

    public function getScheduleFormValidator($formValidators = array()) {

        $formValidators['calendar_id'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Calendar'),
            'required' => true,
            'allowEmpty' => false,
        );

        $formValidators['title'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Title'),
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', false, array(3, 63))
            )
        );

        $formValidators['body'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Details'),
            'validators' => array(
                array('StringLength', false, array(0, 250))
            )
        );

        $formValidators['start_datetime'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Start Time'),
            'required' => true,
            'allowEmpty' => false,
        );

        $formValidators['end_datetime'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('End Time'),
            'required' => true,
            'allowEmpty' => false,
        );

        $formValidators['location'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Location'),
            'required' => true,
            'allowEmpty' => false,
        );

        return $formValidators;
    }

    public function getGroupFormValidators($subject = array(), $formValidators = array()) {

        $formValidators['title'] = array(
            'label' => Engine_Api::_()->getApi('Core', 'siteapi')->translate('Group Name'),
            'required' => true,
            'allowEmpty' => false,
            'label' => 'Group Name',
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', false, array(1, 64))
            )
        );

        return $formValidators;
    }

}