<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Form_Admin_Global extends Engine_Form
{
  public function init()
  {
    
    $this
      ->setTitle('Global Settings')
      ->setDescription('These settings affect all members in your community.');

    $options = array('0' => 'No Mapping');

    if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventticket'))
      $options['1'] = 'Advanced Events - Events Booking, Tickets Selling & Paid Events Extension';

    if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebooking'))
      $options['2'] = 'Services Booking & Appointments Plugin';

    if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebooking') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventticket'))
      $options['3'] = 'Both Advanced Events - Events Booking, Tickets Selling & Paid Events Extension and Services Booking & Appointments Plugin';

    $this->addElement('Radio', 'calendar_integration', array(
                'label' => 'Integration of Plugins',
                'description' => 'Do you want to enable the integration of calendar module with other plugins? (No Mapping would be automatically selected if no integrable modules are present on your website.)',
                'multiOptions' => $options,
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('calendar.integration', 0),
            ));
    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}