<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Level.php 10100 2013-10-24 23:09:16Z guido $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Calendar_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract
{
    public function init()
    {
        parent::init();
        unset($this->level_id->options[5]);
        $this
            ->setTitle('Member Level Settings')
            ->setDescription("CALENDAR_FORM_ADMIN_LEVEL_DESCRIPTION");

        if( !$this->isPublic() ) {
        // Element: view
        $this->addElement('Radio', 'view', array(
            'label' => 'Allow Viewing of Calendars?',
            'description' => 'Do you want to let members view calendars? If set to no, some other settings on this page may not apply.',
            'multiOptions' => array(
                1 => 'Yes, allow viewing of calendars.',
                0 => 'No, do not allow calendars to be viewed.',
            ),
            'value' => ( $this->isModerator() ? 1 : 0 ),
        ));
        if( !$this->isModerator() ) {
            unset($this->view->options[2]);
        }



            // Element: create
            $this->addElement('Radio', 'create', array(
                'label' => 'Allow Creation of Calendars?',
                'description' => 'Do you want to let members create calendars? If set to no, some other settings on this page may not apply. This is useful if you want members to be able to view calendars, but only want certain levels to be able to create calendars.',
                'multiOptions' => array(
                    1 => 'Yes, allow creation of calendars.',
                    0 => 'No, do not allow calendars to be created.'
                ),
                'value' => 1,
            ));

            // Element: edit
            $this->addElement('Radio', 'edit', array(
                'label' => 'Allow Editing of Calendars?',
                'description' => 'Do you want to let members edit calendars?',
                'multiOptions' => array(
                    1 => 'Yes, allow members to edit their own calendars.',
                    0 => 'No, do not allow members to edit their calendars.',
                ),
                'value' => ( $this->isModerator() ? 1 : 0 ),
            ));
            if( !$this->isModerator() ) {
                unset($this->edit->options[2]);
            }

            // Element: delete
            $this->addElement('Radio', 'delete', array(
                'label' => 'Allow Deletion of Calendars?',
                'description' => 'Do you want to let members delete calendars?',
                'multiOptions' => array(
                    1 => 'Yes, allow members to delete their own calendars.',
                    0 => 'No, do not allow members to delete their calendars.',
                ),
                'value' => ( $this->isModerator() ? 1 : 0 ),
            ));
            if( !$this->isModerator() ) {
                unset($this->delete->options[2]);
            }

            // Element: delete
            $this->addElement('Radio', 'claim', array(
                'label' => 'Allow Claiming of Calendars?',
                'description' => 'Allow Members to Claim Calendars?',
                'multiOptions' => array(
                    1 => 'Yes, allow members to claim calendars.',
                    0 => 'No, do not allow members to claim calendars.',
                ),
                'value' => ( $this->isModerator() ? 1 : 0 ),
            ));

            $this->addElement('Text', 'max', array(
                'label' => 'Maximum Allowed Calendars?',
                'description' => 'Enter the maximum number of calendars of this level can create. The field must contain an integer between 1 and 999, or 0 for unlimited.',
                'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(0),
              ),
            ));
        }
    }
}