<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Form_Create extends Engine_Form
{
    protected $_bgcolor = '#000000';
    protected $_photoRequired = true;
    protected function setBackGroundColor($color) {
    $this->_bgcolor = $color;
        return $this;
    }
    public $_error = array();

    public function init()
    {
        $this->setTitle('Create New Calendar')
            ->setAttrib('name', 'calendar_create');

        $this->addElement('Text', 'title', array(
            'label' => 'Title',
            'allowEmpty' => false,
            'required' => true,
            'minlength' => '3',
            'filters' => array(
                new Engine_Filter_Censor(),
                'StripTags',
                new Engine_Filter_StringLength(array('max' => '63'))
            ),
            'autofocus' => 'autofocus',
        ));

        $this->addElement('Text', 'to', array(
            'label' => 'Add Existing Members',
            'required' => false
        ));

        $this->addElement('Text', 'non_members', array(
            'label' => 'Add Non-existing Members',
            'description' => "Please enter E-mail Addresses seperated by a comma(,). ",
            'required' => false,
        ));

        $this->addElement('Hidden', 'toValues', array(
          'label' => 'Added Members',
          'order' => 2,
          'validators' => array(
            'NotEmpty'
          ),
          'filters' => array(
            'HtmlEntities'
          ),
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        //COLOR VALUE FOR BACKGROUND COLOR
        $this->addElement('Text', 'background_color', array(
          'decorators' => array(
            array('ViewScript', array(
                'viewScript' => '_formImageRainbowSearchBackground.tpl',
                'bgcolor' => $this->_bgcolor,
                'class' => 'form element'
              )))
        ));

        $this->addElement('Checkbox', 'search', array(
            'label' => 'Show this calendar entry in search results',
            'value' => 1,
        ));

        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Save',
            'type' => 'submit',
        ));

    }
}