<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Form_Groupmember_Add extends Engine_Form
{
    public function init()
    {
        $this
            ->setTitle('Add Members')
            ->setAttrib('name', 'calendar_group_add');

        $this->addElement('Text', 'to', array(
            'label' => 'Add Existing Members',
            'required' => false
        ));

        $this->addElement('Text', 'non_members', array(
            'label' => 'Add Non-existing Members',
            'description' => "Please enter E-mail Addresses seperated by a comma(,). ",
            'required' => false,
        ));

        $this->addElement('Hidden', 'toValues', array(
          'label' => 'Added Members',
          'order' => 1,
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        // Buttons
        $this->addElement('Button', 'submit', array(
            'label' => 'Add Members',
            'type' => 'submit',
            'ignore' => true,
            'decorators' => array(
                'ViewHelper',
            ),
        ));

        $this->addElement('Cancel', 'cancel', array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            'onclick' => 'javascript:parent.Smoothbox.close()',
            'decorators' => array(
                'ViewHelper',
            ),
        ));

        $this->addDisplayGroup(array('submit', 'cancel'), 'buttons', array(
            'decorators' => array(
                'FormElements',
                'DivDivDivWrapper',
            ),
        ));
    }
}