<?php
class Calendar_Form_Schedule_Move extends Engine_Form
{

  protected $_item = 0;
  protected function setCalendar($id) {
    $this->_item = $id;
        return $this;
  }

  public function init()
  {
    $this->setTitle('Move Schedule')
        ->setDescription('You can move this schedule to other calendars.')
                ->setAttrib('class', 'global_form global_form_popup');
    
    $calendars = Engine_Api::_()->getItemTable('calendar')->getAllCalendars($this->_item);

    foreach ($calendars as $calendar) {
        $options[$calendar->getIdentity()] = $calendar->getTitle();
    }
    $this->addElement('Select', 'calendar', array(
            'label' => 'Calendar Title',
            'multiOptions' => $options,
    ));

     // Buttons
    $this->addElement('Button', 'submit', array(
        'label' => 'Move',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'link' => true,
        'prependText' => ' or ',
        'onclick' => 'javascript:parent.Smoothbox.close()',
        'decorators' => array(
            'ViewHelper',
        ),
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons', array(
        'decorators' => array(
            'FormElements',
            'DivDivDivWrapper',
        ),
    ));

  }
}
?>