<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_Model_DbTable_Owners extends Core_Model_Item_DbTable_Abstract
{
    protected $_rowClass = "Calendar_Model_Owner";

    public function getOwners($calendar_id) {
      $select = $this->select()
                      ->where('calendar_id = ?', $calendar_id);

      return $this->fetchAll($select);
    }

    public function isCalendarOwner($calendar_id) {
      $viewer = Engine_Api::_()->user()->getViewer();

      $select = $this->select()->where('calendar_id = ?', $calendar_id)
                              ->where('user_id = ?', $viewer->getIdentity());
      
      $row = $this->fetchRow($select);
      if(!empty($row->user_id)) {
        return true;
      }
      return false;
    }

    public function getUsers($title, $limit = 10, $calendar_id) {

      //MAKE QUERY
          $viewer = Engine_Api::_()->user()->getViewer();
          $table = Engine_Api::_()->getDbtable('users', 'user');
          $getAddedMembers = $this->getOwners($calendar_id);
          $data = array();
          foreach ($getAddedMembers as $member) {
            $data[] = $member->user_id;
          }
          $select = $table->select()
                  ->from($table->info('name'), array('user_id', 'displayname', 'photo_id', 'email'));
                  
          $select->where($table->info('name') . ".displayname LIKE ? ", '%' . $title . '%');
          if(!empty($data)) {
            $select = $select->where('user_id NOT IN (?)', $data);
          }
          $select->where('enabled = ?', '1')
                  ->where('user_id != ?', $viewer->getIdentity())
                  ->where('verified = ?', '1')
                  ->where('approved = ?', '1')
                  ->order('displayname ASC')
                  ->limit($limit);

          //FETCH RESULTS
          return $table->fetchAll($select);
      }
}
?>