<?php

class Calendar_AdminGroupsController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGE GROUPS
  public function indexAction() {

    //TAB CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('calendar_admin_main', array(), 'calendar_admin_main_groups');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Calendar_Form_Admin_Groups_Filter();

    //GET GROUP ID
    $group = $this->_getParam('page', 1);

    //MAKE QUERY
    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');

    $tableGroup = Engine_Api::_()->getDbtable('groups', 'calendar');
    $tableGroupName = $tableGroup->info('name');
    
    $values = array();
      $select = $tableGroup->select()
              ->setIntegrityCheck(false)
              ->from($tableGroupName)
              ->joinLeft($tableUser, "$tableGroupName.owner_id = $tableUser.user_id", 'username');
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    foreach ($values as $key => $value) {

      if (null == $value) {
        unset($values[$key]);
      }
    }

    //SEARCHING
    $this->view->owner = '';
    $this->view->title = '';

    $values = array_merge(array(
        'order' => 'group_id',
        'order_direction' => 'DESC',
            ), $values);


    if (!empty($_POST['owner'])) {
      $user_name = $_POST['owner'];
    } elseif (!empty($_GET['owner'])) {
      $user_name = $_GET['owner'];
    } else {
      $user_name = '';
    }


    if (!empty($_POST['title'])) {
      $group_name = $_POST['title'];
    } elseif (!empty($_GET['title'])) {
      $group_name = $_GET['title'];
    } elseif ($this->_getParam('title', '')) {
      $group_name = $this->_getParam('title', '');
    } else {
      $group_name = '';
    }

    //SEARCHING
    $this->view->owner = $values['owner'] = $user_name;
    $this->view->title = $values['title'] = $group_name;

    if (!empty($group_name)) {
      $select->where($tableGroupName . '.title  LIKE ?', '%' . $group_name . '%');
    }

    if (!empty($user_name)) {
      $select->where($tableUser . '.displayname  LIKE ?', '%' . $user_name . '%');
    }

    $this->view->formValues = array_filter($values);
    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'group_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(15);
    $this->view->paginator = $paginator->setCurrentPageNumber($group);
  }

  //VIEW GROUP DETAIL
  public function detailAction() {

    $id = $this->_getParam('id');

    $tableGroup = Engine_Api::_()->getDbtable('groups', 'calendar');
    $tableGroupName = $tableGroup->info('name');

    $select = $tableGroup->select()
            ->setIntegrityCheck(false)
            ->from($tableGroupName)
            ->where($tableGroupName . '.group_id = ?', $id)
            ->limit(1);
    $this->view->sitegroupDetail = $detail = $tableGroup->fetchRow($select);
  }

  //ACTION FOR MULTI-DELETE OF GROUPS
  public function multiDeleteAction() {

    if ($this->getRequest()->isPost()) {

      $values = $this->getRequest()->getPost();

      foreach ($values as $key => $value) {

        if ($key == 'delete_' . $value) {

          //DELETE SITEGROUPS FROM DATABASE
          $group_id = (int) $value;
          $group = Engine_Api::_()->getItem('calendar_group', $group_id);
          // Get all members
            $members = Engine_Api::_()->getItemTable('calendar_groupmember')->getAllMembers($group_id); 
            foreach ($members as $member) {
                $member->delete();
            }
            $group->delete();
        }
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }
    
    //ACTION FOR CHANGE THE OWNER OF THE GROUP
  public function changeOwnerAction() {

    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET GROUP ID
    $this->view->group_id = $group_id = $this->_getParam('id');

    //FORM
    $form = $this->view->form = new Calendar_Form_Admin_Groups_Changeowner();

    //SET ACTION
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('calendar_group', $group_id);

    //OLD OWNER ID
    $oldownerid = $sitegroup->owner_id;

    //CHECK FORM VALIDATION
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      //GET FORM VALUES
      $values = $form->getValues();

      //GET USER ID WHICH IS NOW NEW USER
      $changeuserid = $values['user_id'];

      //CHANGE USER TABLE
      $changed_user = Engine_Api::_()->getItem('user', $changeuserid);

      //OWNER USER TABLE
      $user = Engine_Api::_()->getItem('user', $sitegroup->owner_id);

      //GET DB
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //UPDATE GROUP TABLE
        Engine_Api::_()->getDbtable('groups', 'calendar')->update(array('owner_id' => $changeuserid), array('group_id = ?' => $group_id));

          $membershipTable = Engine_Api::_()->getDbtable('groupmembers', 'calendar');
          $select = $membershipTable->select()->from($membershipTable->info('name'))->where('user_email = ?', $user->email)->where('group_id = ?', $sitegroup->group_id);
          $getRow = $membershipTable->fetchRow($select);
          
          $select = $membershipTable->select()->from($membershipTable->info('name'), 'groupmember_id')->where('user_email = ?', $changed_user->email)->where('group_id = ?', $sitegroup->group_id);
          $getNewOwnerRow = (integer) $select->query()->fetchColumn();          
          
          if(!empty($getRow) && empty($getNewOwnerRow)) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
              $memberShip = $membershipTable->createRow();
              $getRowArray = $getRow->toArray();
              unset($getRowArray['groupmember_id']);
              $memberShip->setFromArray($getRowArray);
              $memberShip->user_email = $changed_user->email;
              $memberShip->save();
              $db->commit();
            } catch (Exception $e) {
              $db->rollBack();
              throw $e;
            }              
          }

        //COMMIT
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      //SUCCESS
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 3000,
              'parentRefresh' => 3000,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_('The group owner has been changed succesfully.'))
      ));
    }
  }

  public function viewMembersAction() {
    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET GROUP ID
    $this->view->group_id = $group_id = $this->_getParam('id');

    //GET GROUP ITEM
    $this->view->group = $group = Engine_Api::_()->getItem('calendar_group', $group_id);

    // Get all members
    $this->view->members = $members = Engine_Api::_()->getItemTable('calendar_groupmember')->getAllMembers($group_id);
  }

  public function editAction()
    {
        $viewer = Engine_Api::_()->user()->getViewer();
        $group = Engine_Api::_()->getItem('calendar_group', $this->_getParam('group_id'));

        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');
        
        // Prepare form
        $this->view->form = $form = new Calendar_Form_Group_Edit();

        // Populate form
        $form->populate($group->toArray());

        // Check post/form
        if( !$this->getRequest()->isPost() ) {
            return;
        }
        if( !$form->isValid($this->getRequest()->getPost()) ) {
            return;
        }

        // Process
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();

        try {
            $values = $form->getValues();

            $group->setFromArray($values);
            $group->modified_date = date('Y-m-d H:i:s');
            $group->save();

            if( !empty($values['photo']) ) {
                $group->setPhoto($form->photo);
            }

            $db->commit();

        }
        catch( Exception $e ) {
            $db->rollBack();
            throw $e;
        }
         $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 3000,
          'parentRefresh' => 3000,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Details Updated Successfully.'))
      ));
    }

  public function deleteAction()
  {
        $viewer = Engine_Api::_()->user()->getViewer();
        $group = Engine_Api::_()->getItem('calendar_group', $this->getRequest()->getParam('group_id'));

        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');

        $this->view->form = $form = new Calendar_Form_Group_Delete();

        if( !$group ) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_("Group doesn't exist or not authorized to delete");
            return;
        }

        if( !$this->getRequest()->isPost() ) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
            return;
        }

        $db = $group->getTable()->getAdapter();
        $db->beginTransaction();

        try {
            // Get all members
            $members = Engine_Api::_()->getItemTable('calendar_groupmember')->getAllMembers($this->getRequest()->getParam('group_id')); 
            foreach ($members as $member) {
                $member->delete();
            }
            $group->delete();

            $db->commit();
        } catch( Exception $e ) {
            $db->rollBack();
            throw $e;
        }

        $this->view->status = true;
        $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your group has been deleted Successfully.');
        return $this->_forward('success' ,'utility', 'core', array(
            'smoothboxClose' => 3000,
            'parentRefresh' => 3000,
            'messages' => Array($this->view->message)
        ));
    }
}

?>