<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Calendar
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBannerController.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Calendar_AdminSettingsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('calendar_admin_main', array(), 'calendar_admin_main_settings');

    $this->view->form  = $form = new Calendar_Form_Admin_Global();
    
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) )
    {
      $values = $form->getValues();

      foreach ($values as $key => $value){
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function faqAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('calendar_admin_main', array(), 'calendar_admin_main_faqs');
  }

  //ACTION FOR DELETE 
  public function deleteAction()
  {
    //SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET CALENDAR ID
    $this->view->calendar_id = $calendar_id = $this->_getParam('calendar_id');

    if( $this->getRequest()->isPost()){

      //DELETE CALENDAR OBJECT
      Engine_Api::_()->getItem('calendar', $calendar_id)->delete();

      $this->_forward('success', 'utility', 'core', array(
         'smoothboxClose' => 10,
         'parentRefresh'=> 10,
         'messages' => array('')
      ));
    }
    $this->renderScript('admin-settings/delete.tpl');
  }

  //ACTION FOR MULTI DELETE
  public function multiDeleteAction()
  {
    if ($this->getRequest()->isPost()) {

      //GET FORM VALUES
      $values = $this->getRequest()->getPost();
      foreach ($values as $key=>$value) {
        if ($key == 'delete_' . $value) {

          //GET Calendar ID
          $calendar_id = (int)$value;

          //DELETE Calendar OBJECT
          Engine_Api::_()->getItem('calendar', $calendar_id)->delete();
        }
      }
    }

    //REDIRECT
    return $this->_helper->redirector->gotoRoute(array('action' => 'calendar'));
  }

  //ACTION FOR MANAGE CALENDARS
  public function calendarAction() {

    //TAB CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('calendar_admin_main', array(), 'calendar_admin_main_calendar');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Calendar_Form_Admin_Groups_Filter();

    $calendar = $this->_getParam('page', 1);

    //MAKE QUERY
    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');

    $tableCalendar = Engine_Api::_()->getDbtable('calendars', 'calendar');
    $tableCalendarName = $tableCalendar->info('name');
    
    $values = array();
      $select = $tableCalendar->select()
              ->setIntegrityCheck(false)
              ->from($tableCalendarName)
              ->joinLeft($tableUser, "$tableCalendarName.owner_id = $tableUser.user_id", 'username');
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    foreach ($values as $key => $value) {

      if (null == $value) {
        unset($values[$key]);
      }
    }

    //SEARCHING
    $this->view->owner = '';
    $this->view->title = '';

    $values = array_merge(array(
        'order' => 'calendar_id',
        'order_direction' => 'DESC',
            ), $values);


    if (!empty($_POST['owner'])) {
      $user_name = $_POST['owner'];
    } elseif (!empty($_GET['owner'])) {
      $user_name = $_GET['owner'];
    } else {
      $user_name = '';
    }


    if (!empty($_POST['title'])) {
      $calendar_name = $_POST['title'];
    } elseif (!empty($_GET['title'])) {
      $calendar_name = $_GET['title'];
    } elseif ($this->_getParam('title', '')) {
      $calendar_name = $this->_getParam('title', '');
    } else {
      $calendar_name = '';
    }

    //SEARCHING
    $this->view->owner = $values['owner'] = $user_name;
    $this->view->title = $values['title'] = $calendar_name;

    if (!empty($calendar_name)) {
      $select->where($tableCalendarName . '.title  LIKE ?', '%' . $calendar_name . '%');
    }

    if (!empty($user_name)) {
      $select->where($tableUser . '.displayname  LIKE ?', '%' . $user_name . '%');
    }

    $this->view->formValues = array_filter($values);
    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'calendar_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(15);
    $this->view->paginator = $paginator->setCurrentPageNumber($calendar);
  }
}