<?php return array (
  'package' => 
  array (
    'type' => 'module',
    'name' => 'calendar',
    'version' => '5.7.1',
    'path' => 'application/modules/Calendar',
    'title' => 'Advanced Calendar Plugin',
    'description' => 'Advanced Calendar Plugin',
    'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
    'callback' => array(
      'path' => 'application/modules/Calendar/settings/install.php',
      'class' => 'Calendar_Installer',
    ),
    'actions' => 
    array (
      0 => 'install',
      1 => 'upgrade',
      2 => 'refresh',
      3 => 'enable',
      4 => 'disable',
    ),
    'directories' => 
    array (
      0 => 'application/modules/Calendar',
    ),
    'files' => 
    array (
      0 => 'application/languages/en/calendar.csv',
    ),
  ),
  // Hooks ---------------------------------------------------------------------
  'hooks' => array(
    array(
      'event' => 'onUserDeleteBefore',
      'resource' => 'Calendar_Plugin_Core',
    ),
  ),
  // Routes --------------------------------------------------------------------
  'items' => array(
    'calendar',
    'calendar_member',
    'calendar_group',
    'calendar_groupmember',
    'calendar_schedule',
    'calendar_claim',
    'calendar_schedulelocation'
  ),
  // Routes --------------------------------------------------------------------
  'routes' => array(
    // Public
    'calendar_specific' => array(
      'route' => 'calendars/:action/:calendar_id/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'index',
        'action' => 'edit',
      ),
      'reqs' => array(
        'calendar_id' => '\d+',
        'action' => '(delete|edit|ical|add-owners|remove-owner)',
      ),
    ),
    'calendar_group_specific' => array(
      'route' => 'calendar-group/:action/:group_id/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'group',
        'action' => 'view',
      ),
      'reqs' => array(
        'group_id' => '\d+',
        'action' => '(delete|edit|view|add-members|remove-member)',
      ),
    ),
    'calendar_general' => array(
      'route' => 'calendars/:action/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'index',
        'action' => 'index',
      ),
      'reqs' => array(
        'action' => '(index|create|create-calendar|manage|getusers|manage-schedule|get-members|get-owners|claim-calendars|browse-schedules|claim|status|owned)',
      ),
    ),
    'schedule_general' => array(
      'route' => 'schedules/:action/:calendar_id/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'schedule',
        'action' => 'view',
      ),
      'reqs' => array(
        'calendar_id' => '\d+',
        'action' => '(view|manage|import-schedules)',
      ),
    ),
    'schedule_specific' => array(
      'route' => 'schedules/:action/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'schedule',
        'action' => 'edit',
      ),
      'reqs' => array(
        // 'group_id' => '\d+',
        'action' => '(create|update|delete|edit|get-schedules|move)',
      ),
    ),
    'calendar_group_general' => array(
      'route' => 'calendar-groups/:action/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'group',
        'action' => 'manage',
      ),
      'reqs' => array(
        'action' => '(index|create|create|manage|getusers|tag|upload-photo)',
      ),
    ),
    'calendar_view' => array(
      'route' => 'calendars/:user_id/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'index',
        'action' => 'list',
      ),
      'reqs' => array(
        'user_id' => '\d+',
      ),
    ),
    'calendar_smoothbox_view' => array(
      'route' => 'calendars/smoothbox/:schedule_id/*',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'index',
        'action' => 'smoothbox',
      ),
      'reqs' => array(
        'schedule_id' => '\d+',
      ),
    ),
    'calendar_entry_view' => array(
      'route' => 'calendars/:calendar_id/',
      'defaults' => array(
        'module' => 'calendar',
        'controller' => 'index',
        'action' => 'view',
      ),
      'reqs' => array(
        'calendar_id' => '\d+'
      ),
    ),
  ),
); ?>