<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Communityadsponsored
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-12-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Communityadsponsored_IndexController extends Core_Controller_Action_Standard {

    protected $_navigation;

    public function init() {

        $getStoryStatus = Engine_Api::_()->getItemTable('communityad_adtype')->getStatus('sponsored_stories');
        if (empty($getStoryStatus)) {
            return $this->_forward('notfound', 'error', 'core');
        }

        $this->view->viewer = $this->_viewer = Engine_Api::_()->user()->getViewer();

        if (!$this->_helper->requireAuth()->setAuthParams('communityad', $this->_viewer, 'view')->isValid()) {
            return;
        }

        $this->_viewer_id = $this->_viewer->getIdentity();
        // It will show the navigation bar.
        $this->view->navigation = $this->_navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('communityad_main');
    }

    // DISPLAY SPONSORED STORY ON ADBOARD
    public function adboardAction() {
        if (!$this->_helper->requireUser()->isValid())
            return;

        Zend_Registry::set('sitemobileNavigationName', 'communityad_main');
        $this->view->headTitle($this->view->translate("Ad Board"), Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);
        // Hack navigation
        foreach ($this->_navigation->getPages() as $page) {
            if ($page->route != 'communityad_display')
                continue;
            $page->active = true;
            break;
        }
        $this->view->rootTitleTruncationLimit = Engine_Api::_()->getApi('settings', 'core')->getSetting('ad.char.title', 25);
        $this->view->titleTruncationLimit = Engine_Api::_()->getApi('settings', 'core')->getSetting('story.char.title', 35);
        $this->view->viewer_object = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->user_id = $viewer->getIdentity();
        $this->view->baseurl = Zend_Controller_Front::getInstance()->getBaseUrl();
        $this->view->getCommunityadTitle = Engine_Api::_()->communityad()->getCommunityadTitle();
        $limit = Engine_Api::_()->getApi('settings', 'core')->getSetting('ad.board.limit', 30);
        // FEATCH ADS
        $params = array();
        $params['limit'] = $limit;
        $params['placement_id'] = 0; //$page_setting[0]['pagesetting_id'];
        $fetch_community_ads = Engine_Api::_()->getApi('SponcerdStories', 'communityad')->getSponcerdStories($params);
        if (!empty($fetch_community_ads)) {
            $this->view->communityads_array = $fetch_community_ads;
        } else {
            $this->view->noResult = 1;
        }
        if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
            $this->_helper->content
                    // ->setNoRender()
                    ->setEnabled();
        } else {
            $this->_helper->content
                    ->setContentName("communityad_display_adboard")
                    //->setNoRender()
                    ->setEnabled();
        }
    }

}
