
<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Create.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Form_Admin_CreateCsvFile extends Engine_Form {

    public function init() {
        $tabIndex = 1;
        $settings = Engine_Api::_()->getApi('settings', 'core');
        $this->setTitle('Download Example CSV Template File')
                ->setDescription("From here, you can download the CSV template file with respect to the profile type available on your website. [Note: Please don’t change any setting related to document after downloading the example CSV template file. Otherwise, it will throw error while uploading the CSV or importing the document details in that CSV file.]");
        $this->setAttrib('id', 'create_file');

        // User can either choose profile type or upload for all categories
        $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('document');
        if (count($topStructure) == 1 && $topStructure[0]->getChild()->type == 'profile_type') {
            $profileTypeField = $topStructure[0]->getChild();
            $options = $profileTypeField->getOptions();
            if (count($options) > 0) {
                $options = $profileTypeField->getElementParams('document');
                unset($options['options']['order']);
                $options['options']['multiOptions'][''] = 'All (Excluding Profile Fields)';
                unset($options['options']['required']);
                unset($options['options']['allowEmpty']);
                $this->addElement('Select', 'profile_type', array_merge($options['options'], array(
                    'tabindex' => 1,
                    'label' => 'Document Profile Type',
                )));
            } else if (count($options) == 0) {
                $this->addElement('Hidden', 'profile_type', array(
                    'order' => 99999,
                    'value' => ''
                ));
            }
        }

        $this->addElement('Button', 'submitButton', array(
            'label' => 'Download',
            'type' => 'button',
            'onclick' => 'manageSubmit()',
            'tabindex' => 3,
            'order' => 10000,
        ));
    }

}
