<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Item.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Form_Admin_Items_Item extends Engine_Form {

    protected $_field;

    public function init() {
        $this->setMethod('post');
        $this->setTitle('Add a Document of the Day')
                ->setDescription("Select a start date and end date below and the corresponding Document from the auto-suggest Document field. The selected Document will be displayed as 'Document of the Day' for this duration and if more than one documents are found to be displayed in the same duration then they will be dispalyed randomly one at a time.");

        $label = new Zend_Form_Element_Text('title');
        $label->setLabel('Document')
                ->addValidator('NotEmpty')
                ->setRequired(true)
                ->setAttrib('class', 'text')
                ->setAttrib('style', 'width:300px;');

        $this->addElement('Hidden', 'document_id', array('order' => 99999));

        $this->addElements(array(
            $label,
        ));

        $starttime = new Engine_Form_Element_CalendarDateTime('starttime');
        $starttime->setLabel("Start Date");
        $starttime->setAllowEmpty(false);
        $starttime->setValue(date('Y-m-d H:i:s'));
        $this->addElement($starttime);

        $endtime = new Engine_Form_Element_CalendarDateTime('endtime');
        $endtime->setLabel("End Date");
        $endtime->setAllowEmpty(false);
        $endtime->setValue(date('Y-m-d H:i:s'));
        $this->addElement($endtime);

        $this->addElement('Button', 'submit', array(
            'label' => 'Add Document',
            'type' => 'submit',
            'ignore' => true,
            'decorators' => array('ViewHelper')
        ));

        $this->addElement('Cancel', 'cancel', array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            'onclick' => 'javascript:parent.Smoothbox.close()',
            'decorators' => array(
                'ViewHelper',
            ),
        ));

        $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
        $button_group = $this->getDisplayGroup('buttons');
    }

}
