<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Template.php 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Form_Admin_Template extends Engine_Form {

    public function init() {

        $this->setTitle('Layout Template Settings')
                ->setDescription('You can choose from the following widgetized pages to reset it\'s present settings to the default settings of the plugin.')
                ->setAttrib('name', 'template');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        $pages = array(
            'documentHome' => 'Documents - Document Home Page',
            'documentBrowse' => 'Documents - Browse Documents',
            'documentManage' => 'Documents - My Documents Page',
            'documentCreation' => 'Documents - Upload New Document',
            'documentEdit' => 'Documents - Document Edit Page',
            'documentView' => 'Documents - Document View Page',
            'documentCategoriesHome' => 'Documents - Document Categories Home',
            'documentMemberProfile' => "Member Profile Page - My Documents Widget"
        );


        $this->addElement('MultiCheckbox', 'document_pagestemplate', array(
            'label' => 'Widgetized Pages',
            'multiOptions' => $pages,
            'escape' => false,
            'value' => $coreSettings->getSetting('document.pagestemplate'),
        ));

        $this->addElement('Button', 'save', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
