<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Documents
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: DocumentShareLinks.php 6590 2016-07-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_View_Helper_DocumentShareLinks extends Zend_View_Helper_Abstract {

    public function documentShareLinks($subject, $params = array(), $showText = false) {

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Seaocore/externals/scripts/like.js');
        $urlencode = urlencode(((!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"])) ? "https://" : "http://") . $_SERVER['HTTP_HOST'] . $subject->getHref());
        $object_link = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $subject->getHref();
        $resource_id = $subject->getIdentity();
        $resource_type = $subject->getType();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        ?>
        <script type="text/javascript">
            var seaocore_content_type = '<?php echo $resource_type; ?>';
            var seaocore_like_url = en4.core.baseUrl + 'seaocore/like/like';
        </script>
        <?php if (!in_array('hideShareDiv', $params)) : ?>
            <div class="seao_share_links">
                <div class="">
                    <div class="view_button">
                        <a href="<?php echo $subject->getHref(); ?>"><?php echo $view->translate("View"); ?></a>
                    </div>    

                    <div class="social_share_wrap">
                    <?php endif; ?>
                    <?php if (in_array('facebook', $params)) : ?>
                        <a target="_blank" href="https://www.facebook.com/sharer/sharer.php?u=<?php echo $urlencode; ?>" class="seao_icon_facebook" title="<?php echo $view->translate("Facebook"); ?>"></a>
                    <?php endif; ?>
                    <?php if (in_array('twitter', $params)) : ?>
                        <a href="https://twitter.com/share?text=<?php echo $subject->getTitle(); ?>" target="_blank" class="seao_icon_twitter" title="Twitter"></a>
                    <?php endif; ?>
                    <?php if (in_array('linkedin', $params)) : ?>
                        <a href="https://www.linkedin.com/shareArticle?mini=true&url=<?php echo $object_link; ?>" target="_blank" class="seao_icon_linkedin" title="Linkedin"></a>
                    <?php endif; ?> 
                    <?php if (in_array('googleplus', $params)) : ?>
                        <a href="https://plus.google.com/share?url=<?php echo $urlencode; ?>&t=<?php echo $subject->getTitle(); ?>" target="_blank" class="seao_icon_google_plus" title="Google Plus"></a>
                    <?php endif; ?>
                    <?php
                    if (in_array('likeButton', $params) && $viewer_id) :
                        ?>
                        <?php $hasLike = Engine_Api::_()->getApi('like', 'seaocore')->hasLike($resource_type, $resource_id); ?>
                        <a href = "javascript:void(0);" onclick = "seaocore_content_type_likes('<?php echo $resource_id; ?>', '<?php echo $resource_type; ?>');"  id="<?php echo $resource_type; ?>_unlikes_<?php echo $resource_id; ?>" style ='display:<?php echo $hasLike ? "inline-block" : "none" ?>' class="seaocore_icon_dislike  <?php echo $resource_type; ?>_unlikes_<?php echo $resource_id; ?>" title="<?php echo $view->translate("Unlike"); ?>">
                        </a>


                        <a href = "javascript:void(0);" onclick = "seaocore_content_type_likes('<?php echo $resource_id; ?>', '<?php echo $resource_type; ?>');" id="<?php echo $resource_type; ?>_most_likes_<?php echo $resource_id; ?>" style ='display:<?php echo empty($hasLike) ? "inline-block" : "none" ?>' class="seaocore_icon_like <?php echo $resource_type; ?>_most_likes_<?php echo $resource_id; ?>" title="<?php echo $view->translate("Like"); ?>">

                        </a>


                        <input type ="hidden" id = "<?php echo $resource_type; ?>_like_<?php echo $resource_id; ?>" value = '<?php echo $hasLike ? $hasLike[0]['like_id'] : 0; ?>' />
                    <?php endif; ?>


                    <?php if (!in_array('hideShareDiv', $params)) : ?>
                    </div>
                </div>
            </div>
        <?php endif; ?>
        <?php
    }

}
