<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminAccountInformationController.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Document/Api/GDSEMedia.php';

class Document_AdminAccountInformationController extends Core_Controller_Action_Admin {

    protected $_document_google_email;
    protected $_document_client_id;
    protected $_document_service_account_name;
    protected $_document_private_key_url_path;
    protected $_GDSEMedia;

    //COMMON ACTION WHICH CALL BEFORE EVERY ACTION OF THIS CONTROLLER
    public function init() {
        $coreApi = Engine_Api::_()->document();

        $document_client_id = $this->_document_client_id = $coreApi->getGoogleClientId();
        $getGoogleClientSecretKey = $this->_getGoogleClientSecretKey = $coreApi->getGoogleClientSecretKey();
        $document_google_email = $this->_document_google_email = $coreApi->getGoogleEmail();
        $document_hide_old_fields = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.hide.old.fields', 0);
        if ($document_hide_old_fields) {
            $this->_GDSEMedia = new GDSEMedia($document_client_id, null, null, $getGoogleClientSecretKey);
        } else {
            $document_service_account_name = $this->_document_service_account_name = $coreApi->getGoogleServiceAccountName();
            $document_private_key_url_path = $this->_document_private_key_url_path = $coreApi->getPrivateKeyUrl();
            if ($document_google_email && $document_client_id && $document_service_account_name && $document_private_key_url_path) {
                $this->_GDSEMedia = new GDSEMedia($document_client_id, $document_service_account_name, $document_private_key_url_path);
            }
        }
    }

    public function indexAction() {

        global $gdsem_apiConfig;
        $gdsem_apiConfig['use_objects'] = true;
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_accountinformation');

        include APPLICATION_PATH . '/application/modules/Document/controllers/license/license2.php';
        // TO PREVENT FATAL ERROR IN TPL
        if (empty($this->view->ebot)) {
            $this->view->ebotError = $this->_GDSEMedia->getAboutError();
        }
    }

}
