<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminImportlistingController.php 6590 2013-04-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Document/Api/GDSEMedia.php';

class Document_AdminImportController extends Core_Controller_Action_Admin {

    protected $_GDSEMedia;

    /*
     * Action for displaying import instructions
     * 
     */

    public function indexAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_bulk_import');
        $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('document');
        $profileTypeField = $topStructure[0]->getChild();
        $options = $profileTypeField->getOptions();

        $this->view->directDownload = true;
        if (count($options) > 0) {
            $this->view->directDownload = false;
        } else {
            $this->view->profileType = $profileType = '';
        }
    }

    /*
     * Action for downloading sample CSV File
     * 
     */

    public function downloadSampleAction() {
        $directDownload = $this->_getParam('directDownload', false);

        if (!$directDownload) {
            // Generate Form for CSV
            $this->view->form = $form = new Document_Form_Admin_CreateCsvFile();
            if (!$this->getRequest()->isPost()) {
                return;
            }

            if (!$form->isValid($this->getRequest()->getPost())) {
                $form->populate($form->getValues());
                return;
            }

            $profileType = $form->getValues()['profile_type'];
        } else {
            $profileType = $this->_getParam('profile_type');
        }

        $table1 = Engine_Api::_()->getDbtable('levels', 'authorization');
        $sqlquery = $table1->select()
                ->from($table1->info('name'))
                ->where('flag like ?', 'default');
        $userMemberLevelIs = $table1->fetchAll($sqlquery)->toarray();

        $form1 = new Document_Form_Admin_Addnewdocument(array(
            'profileType' => $profileType,
        ));

        // GetField Structure for all data here.
        $allDataFormIsas = array();
        $indexForm = 0;

        foreach ($form1->getElements() as $key => $value) {
            $allDataFormIsas[$indexForm]['key'] = $key;
            $allDataFormIsas[$indexForm]['multiple'] = $value->multiple;
            $allDataFormIsas[$indexForm]['helper'] = $value->helper;
            $allDataFormIsas[$indexForm]['options'] = $value->options;
            $allDataFormIsas[$indexForm]['allowEmpty'] = $value->getAllowEmpty();
            $allDataFormIsas[$indexForm]['label'] = $value->getLabel();
            $allDataFormIsas[$indexForm]['name'] = $value->getName();
            $allDataFormIsas[$indexForm]['class'] = $value->class;
            $indexForm++;
        }

        $finalStringIs = array();
        $indexIsAs = 0;

        foreach ($allDataFormIsas as $keyform => $formValueIsAs) {
            if ($formValueIsAs['helper'] == 'formHeading') {
                continue;
            } else if ($formValueIsAs['label'] == '') {
                continue;
            }

            $finalStringIs[$indexIsAs]['label'] = $formValueIsAs['label'];
            if ($formValueIsAs['helper'] == 'formDate') {
                $finalStringIs[$indexIsAs]['type'] = "Date yyyy-mm-dd";
            } else {
                $finalStringIs[$indexIsAs]['type'] = str_replace("form", "", $formValueIsAs['helper']);
            }

            $finalStringIs[$indexIsAs]['name'] = $formValueIsAs['name'];
            $finalStringIs[$indexIsAs]['required'] = 'Required';
            if (($formValueIsAs['helper'] == 'formMultiCheckbox') || ( $formValueIsAs['multiple'] == 'multiple' )) {
                $finalStringIs[$indexIsAs]['valueTimes'] = 'multiple allow';
            } else {
                $finalStringIs[$indexIsAs]['valueTimes'] = 'Single Value';
            }
            // if value contain option here.
            if ($finalStringIs[$indexIsAs]['type'] == 'Radio' || $finalStringIs[$indexIsAs]['type'] == 'Checkbox') {
                $finalStringIs[$indexIsAs]['optionStore'][1] = "Yes";
                $finalStringIs[$indexIsAs]['optionStore'][2] = "No";
                $finalStringIs[$indexIsAs]['option'] = $finalStringIs[$indexIsAs]['option'] . "Yes" . ':' . "No";
            } else {
                if (!is_null($formValueIsAs['options'])) {
                    foreach ($formValueIsAs['options'] as $keyOption => $option) {
                        if ($option != "") {
                            $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
                            $finalStringIs[$indexIsAs]['option'] = $finalStringIs[$indexIsAs]['option'] . $option . ':';
                        }
                    }
                }
            }
            $indexIsAs++;
        }

        $resultedStringIsAs = array();
        $resultStringIndex = 0;
        $finalCsvStringIs = "";

        foreach ($finalStringIs as $key => $value) {
            if ($value['name'] == 'submit' || $value['name'] == 'profile_type') {
                continue;
            }
            // Add a condition when to check if required is set.
            if (isset($value['required'])) {
                $resultedStringIsAs[$resultStringIndex] = '[' . $value['label'] . ']' . '[' . $value['required'] . ': ' . $value['valueTimes'] . ']' . '[' . $value['type'] . ']';
            } else {
                $resultedStringIsAs[$resultStringIndex] = '[' . $value['label'] . ']' . '[' . $value['valueTimes'] . ']' . '[' . $value['type'] . ']';
            }

            if (!is_null($value['option'])) {
                $resultedStringIsAs[$resultStringIndex] = $resultedStringIsAs[$resultStringIndex] . '(' . $value['option'] . ')';
            }
            if ($resultStringIndex > 0) {
                $finalCsvStringIs = $finalCsvStringIs . '|' . $resultedStringIsAs[$resultStringIndex];
            } else {
                $finalCsvStringIs = $resultedStringIsAs[$resultStringIndex];
            }

            $resultStringIndex++;
        }

        $Path = realpath(APPLICATION_PATH . "/temporary");
        $filePath = "$Path/document_upload_data.csv";
        @chmod($path, 0777);
        @chmod($file_path, 0777);
        $fp = fopen($filePath, 'w+');
        fwrite($fp, $finalCsvStringIs);
        fclose($fp);

        //KILL ZEND'S OB
        $isGZIPEnabled = false;
        if (ob_get_level()) {
            $isGZIPEnabled = true;
            @ob_end_clean();
        }

        header("Content-Disposition: attachment; filename=" . urlencode(basename($filePath)), true);
        header("Content-Transfer-Encoding: Binary", true);
        header("Content-Type: application/octet-stream", true);
        header("Content-Type: application/download", true);
        header("Content-Description: File Transfer", true);
        if (empty($isGZIPEnabled)) {
            header("Content-Length: " . filesize($filePath), true);
        }

        readfile("$filePath");
        exit();
    }

    /*
     * Action for uploading CSV File
     * 
     */

    public function importAction() {
        //INCREASE THE MEMORY ALLOCATION SIZE AND INFINITE SET TIME OUT
        ini_set('memory_limit', '2048M');
        set_time_limit(0);

        $this->_helper->layout->setLayout('default-simple');
        $this->view->form = $form = new Document_Form_Admin_Import();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            //MAKE SURE THAT FILE EXTENSION SHOULD NOT DIFFER FROM ALLOWED TYPE
            $ext = str_replace(".", "", strrchr($_FILES['filename']['name'], "."));
            if (!in_array($ext, array('csv', 'CSV'))) {
                $error = $this->view->translate("Invalid file extension. Only 'csv' extension is allowed.");
                $error = Zend_Registry::get('Zend_Translate')->_($error);
                $form->getDecorator('errors')->setOption('escape', false);
                $form->addError($error);
                return;
            }

            $formData = array();
            $formData = $form->getValues();
            if ($formData['profile_type'] == '' || empty($formData['profile_type']) || $formData['profile_type'] == NULL) {
                $formData['profile_type'] = 0;
            }
            $profile_type = $formData['profile_type'];
            $finalStringIs = $this->getColumnStructure($profile_type);

            //START READING DATA FROM CSV FILE
            $temp_name = $_FILES['filename']['tmp_name'];
            $pos = strrpos($temp_name, "/");
            $substring = substr($temp_name, 0, $pos + 1);
            $fname = $substring . $_FILES['filename']['name'];
            @chmod($fname, 0777);
            $fp = fopen($fname, "r");
            if ((!$fp)) {
                echo "$fname File opening error";
                exit;
            }
            if ($formData['import_seperate'] == 1) {
                while ($buffer = fgets($fp, 10000)) {
                    $buffer = str_replace('"', '', $buffer);
                    $explode_array[] = explode('|', $buffer);
                }
            } else {
                while ($buffer = fgets($fp, 10000)) {
                    $buffer = str_replace('"', '', $buffer);
                    $buffer = str_replace("|", ',', $buffer);
                    $explode_array[] = explode(',', $buffer);
                }
            }
            $countNumberOfColumn = 0;
            foreach ($finalStringIs as $columnValue) {
                if ($columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type') {
                    continue;
                }
                $countNumberOfColumn++;
            }
            $countNumberOfCsvColumn = 0;
            foreach ($explode_array as $explodearrayKey => $explode_data) {

                if ($explodearrayKey == 0) {
                    foreach ($explode_data as $countColumn) {
                        $countNumberOfCsvColumn++;
                    }
                    break;
                }
            }
            if ($countNumberOfCsvColumn != $countNumberOfColumn) {
                $form->addError('Fields listed in the CSV file do not match with the fields of the selected profile type.');
                return;
            } else if (count($explode_array) < 2) {
                $form->addError('CSV file does not contain any document detail. Csv file must have details of atleast one document.');
                return;
            } else if (count($explode_array) > 501) {
                $form->addError('CSV file contains details of more then 500 document. Only 500 or less document can be add by a single CSV file.');
                return;
            } else {
                $getStructureCsv = $this->getCsvFileColumnStructure($finalStringIs);
                while ($countNumberOfCsvColumn > 0) {
                    $str1 = explode(']', $explode_array[0][$countNumberOfCsvColumn - 1])[0];
                    $str2 = explode(']', $getStructureCsv[$countNumberOfCsvColumn - 1])[0];
                    if (strcasecmp($str1, $str2) != 0) {
                        $form->addError('Fields listed in the CSV file do not match with the fields of the selected profile type.');
                        return;
                    }
                    $countNumberOfCsvColumn--;
                }
            }
            $db = Engine_Db_Table::getDefaultAdapter();
            try {
                $getFileName = str_replace(" ", "", $_FILES['filename']['name']);
                $getFileName = str_replace(".csv", "", $getFileName);
                $db = Engine_Api::_()->getDbtable('addFileDetails', 'document')->getAdapter();
                $db->beginTransaction();
                try {
                    //SAVE OTHER DATA IN engine4_document_fileimport TABLE
                    $importFileDb = Engine_Api::_()->getDbtable('addFileDetails', 'document');
                    $importFile = $importFileDb->createRow();
                    $importFile->filename = $_FILES['filename']['name'];
                    $importFile->status = 'Pending';
                    $date = $importFile->creation_date = date('Y-m-d H:i:s');
                    $importFile->documentthumbnail = NULL;
                    $importFile->documentfilename = NULL;
                    $importFile->total_count = 0;
                    $importFile->profile_type = $profile_type;
                    $importFile->save();
                    //COMMIT
                    $db->commit();
                    $sqlquery = $importFileDb->select()
                            ->from($importFileDb->info('name'), 'fileimport_id')
                            ->where('creation_date = ?', $date)
                            ->where('filename = ?', $_FILES['filename']['name']);
                    $getFileId = $importFileDb->fetchRow($sqlquery);
                } catch (Exception $e) {
                    $db->rollBack();
                    throw $e;
                }
                if (strlen($getFileName) > 20) {
                    $getTableName = "";
                    $getNameTable = explode("_", $getFileName);
                    foreach ($getNameTable as $key => $getNameT) {
                        $getTableName = $getTableName . substr($getNameT, 0, 2) . '_';
                    }
                    if (strlen($getTableName) < 5) {
                        $getTableName = $getTableName . substr($getFileName, 0, 5);
                    }
                } else {
                    $getTableName = "" . $getFileName;
                }
                $getFileName = $getTableName;
                $tableName = engine4_document_ . $getFileName . '_' . $importFileId . $getFileId['fileimport_id'];
                $sqlqueryIsAs = "CREATE TABLE IF NOT EXISTS `$tableName` ( `unique_Id` int(11) unsigned NOT NULL AUTO_INCREMENT,";
                foreach ($finalStringIs as $columnValue) {
                    if ($columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type') {
                        continue;
                    }
                    $sqlqueryIsAs = $sqlqueryIsAs . '`' . $columnValue['name'] . '` varchar(255),';
                }
                $sqlqueryIsAs = $sqlqueryIsAs . '`error_is` text, primary key(`unique_Id`))';
                // Execuite query.
                $db->query($sqlqueryIsAs);
            } catch (Exception $e) {
                if (isset($getFileId['fileimport_id']) && !empty($getFileId['fileimport_id']))
                    $importFileDb->delete(array('fileimport_id = ?' => $getFileId['fileimport_id']));
                throw $e;
            }
            $import_count = 0;
            foreach ($explode_array as $explodearrayKey => $explode_data) {
                if ($explodearrayKey == 0) {
                    continue;
                }
                $getInsertData = array();
                $indexRow = 0;
                foreach ($finalStringIs as $columnValue) {
                    if ($columnValue['name'] == 'submit' || $columnValue['name'] == 'profile_type') {
                        continue;
                    }
                    $getInsertData[$columnValue['name']] = $explode_data[$indexRow];
                    $indexRow++;
                }
                $db = Engine_Db_Table::getDefaultAdapter();
                $db->beginTransaction();

                try {
                    // Make  structure for insert  
                    $insertQuery = "insert into `$tableName` ";
                    $insertKeyIs = " (";
                    $insertValueIs = " (";
                    foreach ($getInsertData as $key => $value) {
                        $value = str_replace("'", " \'", $value);
                        $insertKeyIs = $insertKeyIs . '`' . $key . '`, ';
                        $insertValueIs = $insertValueIs . " '$value', ";
                    }
                    $insertKeyIs = $insertKeyIs . ') ';
                    $insertKeyIs = str_replace(", )", " )", $insertKeyIs);
                    $insertValueIs = $insertValueIs . ') ';
                    $insertValueIs = str_replace(", )", " )", $insertValueIs);
                    $insertQuery = $insertQuery . $insertKeyIs . ' VALUES ' . $insertValueIs;
                    $db->query($insertQuery);
                    //COMMIT
                    $db->commit();
                    $import_count++;
                } catch (Exception $e) {
                    $db->rollBack();
                    if (isset($getFileId['fileimport_id']) && !empty($getFileId['fileimport_id']))
                        $importFileDb->delete(array('fileimport_id = ?' => $getFileId['fileimport_id']));
                    throw $e;
                }
            }

            try {
                $importFileDb->update(array('table_name' => $tableName, 'total_count' => $import_count), array('fileimport_id = ?' => $getFileId['fileimport_id']));
            } catch (Exception $e) {
                throw $e;
            }

            //CLOSE THE SMOOTHBOX
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => true,
                'parentRedirect' => $this->_helper->url->url(array('module' => 'document', 'controller' => 'import', 'action' => 'manage')),
                'parentRedirectTime' => '15',
                'format' => 'smoothbox',
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('CSV file has been imported succesfully !'))
            ));
        }
    }

    // Make index for that profile Type 
    public function getColumnStructure($profileType) {
        $form1 = new Document_Form_Admin_Addnewdocument(
                array(
            'profileType' => $profileType,
                )
        );
        $allDataFormIsas = array();
        $indexForm = 0;
        foreach ($form1->getElements() as $key => $value) {
            $allDataFormIsas[$indexForm]['key'] = $key;
            $allDataFormIsas[$indexForm]['multiple'] = $value->multiple;
            $allDataFormIsas[$indexForm]['helper'] = $value->helper;
            $allDataFormIsas[$indexForm]['options'] = $value->options;
            $allDataFormIsas[$indexForm]['allowEmpty'] = $value->getAllowEmpty();
            $allDataFormIsas[$indexForm]['label'] = $value->getLabel();
            $allDataFormIsas[$indexForm]['name'] = $value->getName();
            $allDataFormIsas[$indexForm]['class'] = $value->class;
            $indexForm++;
        }
        $finalStringIs = array();
        $indexIsAs = 0;
        foreach ($allDataFormIsas as $keyform => $formValueIsAs) {
            if ($formValueIsAs['helper'] == 'formHeading') {
                continue;
            } else if ($formValueIsAs['label'] == '') {
                continue;
            }


            // Label
            $finalStringIs[$indexIsAs]['label'] = $formValueIsAs['label'];
            // Type of Value
            $finalStringIs[$indexIsAs]['type'] = str_replace("form", "", $formValueIsAs['helper']);
            // Get value name here.
            $finalStringIs[$indexIsAs]['name'] = $formValueIsAs['name'];
            // For rules here

            if (is_null($formValueIsAs['allowEmpty']) || $formValueIsAs['allowEmpty'] == true) {
                
            } else {

                $finalStringIs[$indexIsAs]['required'] = 'Required';
            }
            if (($formValueIsAs['helper'] == 'formMultiCheckbox') || ( $formValueIsAs['multiple'] == 'multiple' )) {
                $finalStringIs[$indexIsAs]['valueTimes'] = 'multiple allow';
            } else {
                $finalStringIs[$indexIsAs]['valueTimes'] = 'Single Value';
            }
            // if value contain option here then but only for dynamic field.
            if (!preg_match('/[^0-9_]/', $formValueIsAs['name'])) {
                if (!is_null($formValueIsAs['options'])) {
                    //$finalStringIs[$indexIsAs]['option'] = '' ;
                    foreach ($formValueIsAs['options'] as $keyOption => $option) {
                        # code...
                        if ($option != "") {

                            $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
                            $finalStringIs[$indexIsAs]['option'] = $finalStringIs[$indexIsAs]['option'] . $option . ':';
                        }
                    }
                }
            } else {
                if (!is_null($formValueIsAs['options'])) {
                    if ($finalStringIs[$indexIsAs]['type'] == 'Radio' || $finalStringIs[$indexIsAs]['type'] == 'Checkbox') {
                        $finalStringIs[$indexIsAs]['optionStore'][0] = 'No';
                        $finalStringIs[$indexIsAs]['optionStore'][1] = 'Yes';
                        $finalStringIs[$indexIsAs]['option'] = $finalStringIs[$indexIsAs]['option'] . 'Yes' . ':' . 'No';
                    } else if ($finalStringIs[$indexIsAs]['type'] == 'Select') {
                        foreach ($formValueIsAs['options'] as $keyOption => $option) {
                            if ($option != "") {

                                $finalStringIs[$indexIsAs]['optionStore'][$keyOption] = $option;
                                $finalStringIs[$indexIsAs]['option'] = $finalStringIs[$indexIsAs]['option'] . $option . ':';
                            }
                        }
                    }
                }
            }
            $indexIsAs++;
        }
        return $finalStringIs;
    }

    public function getCsvFileColumnStructure($finalStringIs) {
        $resultedStringIsAs = array();
        $resultStringIndex = 0;
        $finalCsvStringIs = "";

        foreach ($finalStringIs as $key => $value) {
            if ($value['name'] == 'submit' || $value['name'] == 'profile_type') {
                continue;
            }
            if (isset($value['required'])) {
                $resultedStringIsAs[$resultStringIndex] = '[' . $value['label'] . ']' . '[' . $value['required'] . ': ' . $value['valueTimes'] . ']' . '[' . $value['type'] . ']';
            } else {
                $resultedStringIsAs[$resultStringIndex] = '[' . $value['label'] . ']' . '[' . $value['valueTimes'] . ']' . '[' . $value['type'] . ']';
            }

            if (!is_null($value['option'])) {
                $resultedStringIsAs[$resultStringIndex] = $resultedStringIsAs[$resultStringIndex] . '(' . $value['option'] . ')';
            }
            $resultStringIndex++;
        }
        return $resultedStringIsAs;
    }

    /*
     * Action for managing uploaded CSV Files
     * 
     */

    public function manageAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_bulk_import');

        //FORM CREATION FOR SORTING
        $this->view->formFilter = $formFilter = new Document_Form_Admin_Filter();
        $page = $this->_getParam('page', 1);

        $tableImportFile = Engine_Api::_()->getDbTable('addFileDetails', 'document');
        $select = $tableImportFile->select();

        //IF IMPORT IS IN RUNNING STATUS FOR SOME FILE THAN DONT SHOW THE START BUTTON FOR ALL
        $importFileStatusData = $tableImportFile->fetchRow(array('status = ?' => 'Running'));
        $this->view->runningSomeImport = 0;
        if (!empty($importFileStatusData)) {
            $this->view->runningSomeImport = 1;
        }

        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        foreach ($values as $key => $value) {
            if (null === $value) {
                unset($values[$key]);
            }
        }

        $values = array_merge(array(
            'order' => 'fileimport_id',
            'order_direction' => 'DESC',
                ), $values);

        $this->view->assign($values);

        $select->order((!empty($values['order']) ? $values['order'] : 'fileimport_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
        $this->view->paginator = $paginator = Zend_Paginator::factory($select);

        $this->view->total_slideshows = $paginator->getTotalItemCount();
        $this->view->paginator->setItemCountPerPage(10);
        $this->view->paginator = $paginator->setCurrentPageNumber($page);
    }

    /*
     * Action for editing values uploaded form CSV File
     * 
     */

    public function editAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_bulk_import');

        $this->view->documentTable = $documentTable = Engine_Api::_()->getDbTable('documents', 'document');
        $this->view->fileImportId = $fileImportId = $this->_getParam('fileimport_id');
        $this->view->page = $page = $this->_getParam('page', 1);
        $this->view->itemCountPerPage = $itemCountPerPage = $this->_getParam('itemCountPerPage', 20);
        $this->view->isAjax = $ajax = $this->_getParam('is_ajax', false);
        $tableFileDetails = Engine_Api::_()->getDbtable('addFileDetails', 'document');
        $sqlquery = $tableFileDetails->select()
                ->from($tableFileDetails->info('name'))
                ->where('fileimport_id = ?', $fileImportId);
        $fileDetailsIs = $tableFileDetails->fetchAll($sqlquery)->toarray();
        $this->view->fileName = $fileDetailsIs[0]['filename'];

        $db = Engine_Db_Table::getDefaultAdapter();
        try {
            $getTableIfExist = $db->describeTable($fileDetailsIs[0]['table_name']);
        } catch (Exception $e) {
            return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
        }

        try {
            $getFinalStringAs = $this->getColumnStructure($fileDetailsIs[0]['profile_type']);
            $nameLabels = array();
            foreach ($getFinalStringAs as $value) {
                if ($value['name'] == 'submit')
                    continue;
                $nameLabels[$value['name']] = $value['label'];
            }
            $settings = Engine_Api::_()->getApi('settings', 'core');
            if (!$settings->getSetting('document.thumbnail', 0)) {
                if (isset($nameLabels['documentthumbnail']))
                    unset($nameLabels['documentthumbnail']);
            }
            $this->view->nameLabels = $nameLabels;
            $select = new Zend_Db_Select($db);
            $select->from($fileDetailsIs[0]['table_name']);
            $this->view->getEditData = $getEditData = $select->query()->fetchAll();

            // Get Table Columns 
            $this->view->TotalNumberRow = $TotalNumberRow = count($getEditData);
            if ($TotalNumberRow == 0) {
                $this->view->ShowData = "Their is no data to show ";
            } else {
                $this->view->paginator = $paginator = Zend_Paginator::factory($getEditData);
                $this->view->totalCount = $paginator->getTotalItemCount();
                $paginator->setItemCountPerPage($itemCountPerPage);
                $paginator->setCurrentPageNumber($page);
                $this->view->paginator = $paginator;
            }
            $query = $db->query('SELECT COUNT(1) as `errors` FROM `' . $fileDetailsIs[0]['table_name'] . '` WHERE `error_is` IS NOT NULL');
            $errorsCount = $query->fetch();
            $this->view->errorCount = $errorsCount = $errorsCount['errors'];
            $this->view->sNo = $sNo = $this->_getParam('sNo', 1);

            if ($ajax) {
                $html = '';
                foreach ($paginator as $item) {
                    $html.='<tr><td><input name="' . 'd_' . $item['unique_Id'] . '" type="checkbox" class="checkbox" value="' . $item['unique_Id'] . '"/></td>';
                    $html.='<td><b>' . ($sNo++) . '<b></td>';
                    $errors = json_decode($item['error_is']);
                    $renderError = false;
                    foreach ($item as $key => $data) {
                        if (($key == 'unique_Id' && $errorsCount == 0) || $key == 'error_is') {
                            continue;
                        }

                        $html.='<td width="100%" >';
                        if ($errorsCount > 0 && !$renderError) {
                            $renderError = true;
                            $html.='<div width="1%" align="left"  style="max-width:305px !important; max-height: 43px !important; overflow:auto;  "> 
                            <ul>';
                            foreach ($errors as $name => $error) {
                                $html.='<li>' . $nameLabels[$name] . ' : ' . $error . '</li>';
                            }
                            $html.='</ul></div>';
                        } else {
                            $errorClass = "";
                            if (array_key_exists($key, $errors)) {
                                $errorClass = "error";
                            } else {
                                $html.='<input name="' . $key . '" class="data_' . $item['unique_Id'] . ' ' . $errorClass . '" type="text" id="' . $this->fileImportId . '" value="' . $data . '"/>';
                            }
                        }
                        $html.='</td>';
                    }
                    $html.='';
                }

                $data = array('data' => $html, 'sNo' => $sNo);
                echo json_encode($data);
                die();
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /*
     * Action for Get the files & profile picture folder upload 
     *
     */

    public function uploadDocumentAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_bulk_import');
        try {
            // Get id of file from which file is going to upload
            $this->view->importfile_id = $importfile_id = $this->_getParam('importfile_id');

            $this->view->importFile = Engine_Api::_()->getItem('document_addFileDetail', $importfile_id);
            $this->view->type = $this->_getParam('type');

            $tableImportFile = Engine_Api::_()->getDbTable('addFileDetails', 'document');
            $select = $tableImportFile->select();
        } catch (Exception $ex) {
            
        }
        // If already a file then remove it.
    }

    /*
     * Action for saving the files in folder stucture
     *
     */

    public function uploadAction() {
        $fileimport_id = $this->_getParam('fileimport_id');
        $fileType = $this->_getParam('type');
        $basePath = 'document/fileimport_' . $fileimport_id;
        if ($fileType == 1) {
            $photo = 'documentthumbnail';
        } else {
            $photo = 'documentfilename';
        }
        if (is_dir(APPLICATION_PATH . "/public/$basePath/$photo") != 1) {
            @mkdir(APPLICATION_PATH . "/public/$basePath/$photo", 0777, true);
        }
        @chmod(APPLICATION_PATH . "/public/$basePath/$photo", 0777);
        $this->view->path = $path = APPLICATION_PATH . "/public/$basePath/$photo";
        $getSubDirInfo = scandir($path);
        if (!$this->getRequest()->isPost()) {
            return;
        }
        // Check ul bit
        if (null === $this->_getParam('ul')) {
            return;
        }

        // Prepare
        if (empty($_FILES['Filedata'])) {
            $this->view->error = 'File failed to upload. Check your server settings (such as php.ini max_upload_filesize).';
            return;
        }

        $disallowedExtensions = array('zip');
        if (!in_array(end(explode(".", $_FILES['Filedata']['name'])), $disallowedExtensions)) {
            $this->view->error = 'File type or extension forbidden.';
            return;
        }

        $info = $_FILES['Filedata'];
        $targetFile = $path . '/' . $info['name'];
        $vals = array();

        if (file_exists($targetFile)) {
            $this->view->error = Zend_Registry::get('Zend_Translate')->_("File already exists.");
            return;
        }

        //If their is already a file at that location remove that with folder.
        foreach ($getSubDirInfo as $dirKey => $subDir) {
            if ($subDir === '.' or $subDir === '..')
                continue;
            if (is_dir($archiveProfilePhoto . $subDir)) {
                $getExtractFileName = $archiveProfilePhoto . $subDir;
                break;
            }
        }

        // Try to move uploaded file
        @chmod(APPLICATION_PATH . "/public/document", 0777);
        if (!move_uploaded_file($info['tmp_name'], $targetFile)) {
            $this->view->error = Zend_Registry::get('Zend_Translate')->_("Unable to move file to upload directory.");
            return;
        }

        $reviewimportfileTable = Engine_Api::_()->getDbtable('addFileDetails', 'document');

        $selectImportTable = $reviewimportfileTable->select()
                ->from($reviewimportfileTable->info('name'), $photo)
                ->where('fileimport_id = ?', $fileimport_id);
        $fileName = $selectImportTable->query()->fetchColumn();

        if (!empty($fileName)) {
            $import_image_path = "$basePath/$photo/$fileName";
            @unlink(APPLICATION_PATH . "/public/" . $import_image_path);
        }

        $reviewimportfileTable->update(array($photo => $_FILES['Filedata']['name']), array('fileimport_id = ?' => $fileimport_id));

        $this->view->target_path = $info['tmp_name'];
        $this->view->status = 1;

        // Redirect
        if (null === $this->_helper->contextSwitch->getCurrentContext()) {
            return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
        } else if ('smoothbox' === $this->_helper->contextSwitch->getCurrentContext()) {
            return $this->_forward('success', 'utility', 'core', array(
                        'smoothboxClose' => true,
                        'parentRefresh' => true,
            ));
        }
    }

    /*
     * Action for importing data uploaded from CSV file
     *
     * returns json array 
     */

    public function bulkInsertionAction() {
        $data = $this->getRequest()->getPost();

        // get file details here.
        $fileId = $this->_getParam('fileimport_id');
        $this->_helper->content->setNoRender();

        //profile type
        $table = Engine_Api::_()->getDbtable('addFileDetails', 'document');
        $db = $table->getAdapter();
        $sqlQuery = $table->select()
                ->from($table->info('name'))
                ->where('fileimport_id = ?', $fileId);

        $documentProfileType = $table->fetchRow($sqlQuery)->toarray();

        // Check if a document file and profile photo zip is uploaded or not.
        $archiveProfilePhoto = APPLICATION_PATH . "/public/document" . DIRECTORY_SEPARATOR . "fileimport_" . $fileId . DIRECTORY_SEPARATOR . "documentthumbnail/";
        $isProfilePhotoZip = false;
        $isFilename = false;
        // Assign values here.
        Document_Form_Admin_Addnewdocument:: $getProfilePhoto = $isProfilePhotoZip;
        Document_Form_Admin_Addnewdocument:: $getFilename = $isFilename;
        Document_Form_Admin_Addnewdocument:: $getFileId = $fileId;
        $isProfilePhotoRequired = false;
        $settings = Engine_Api::_()->getApi('settings', 'core');
        if ($settings->getSetting('document.thumbnail', 0)) {
            $isProfilePhotoRequired = true;
        }
        if ($documentProfileType['documentthumbnail'] != NULL && $isProfilePhotoRequired) {
            $archiveProfilePhoto = APPLICATION_PATH . "/public/document" . DIRECTORY_SEPARATOR . "fileimport_" . $fileId . DIRECTORY_SEPARATOR . "documentthumbnail/";
            if (file_exists($archiveProfilePhoto . $documentProfileType['documentthumbnail'])) {
                $zip = new ZipArchive;
                $res = $zip->open($archiveProfilePhoto . $documentProfileType['documentthumbnail']);
                $zip->extractTo($archiveProfilePhoto);
                $zip->close();
                $getSubDirInfo = scandir($archiveProfilePhoto);
                foreach ($getSubDirInfo as $dirKey => $subDir) {
                    if ($subDir === '.' or $subDir === '..') {
                        continue;
                    }

                    if (is_dir($archiveProfilePhoto . $subDir)) {
                        $getExtractFileName = $archiveProfilePhoto . $subDir;
                        break;
                    }
                }
                @chmod($getExtractFileName, 0777);
                $isProfilePhotoZip = true;
            }
        }
        if ($documentProfileType['documentfilename'] != NULL) {
            $archiveDocumentFile = APPLICATION_PATH . "/public/document" . DIRECTORY_SEPARATOR . "fileimport_" . $fileId . DIRECTORY_SEPARATOR . "documentfilename/";
            if (file_exists($archiveDocumentFile . $documentProfileType['documentfilename'])) {
                // Extract
                $zip = new ZipArchive;
                $res = $zip->open($archiveDocumentFile . $documentProfileType['documentfilename']);
                $result = $zip->extractTo($archiveDocumentFile);
                $zip->close();

                $getSubDirInfo = scandir($archiveDocumentFile);
                foreach ($getSubDirInfo as $dirKey => $subDir) {
                    if ($subDir === '.' or $subDir === '..')
                        continue;
                    if (is_dir($archiveDocumentFile . $subDir)) {
                        $getExtractFileName = $archiveDocumentFile . $subDir;
                        break;
                    }
                }
                @chmod($getExtractFileName, 0777);
                $isFilename = true;
            }
        }

        // Document File & Profile Photo Info to The Form
        Document_Form_Admin_Addnewdocument:: $getProfilePhoto = $isProfilePhotoZip;
        Document_Form_Admin_Addnewdocument:: $getFilename = $isFilename;
        $finalStringIs = $this->getColumnStructure($documentProfileType['profile_type']);
        $dynamicField = array();
        foreach ($finalStringIs as $value) {
            if ($value['name'] == 'profile_type') {
                continue;
            }
            $dynamicField[$value['name']] = $value;
        }

        $jsonData = array();
        $data['data'] = json_decode($data['data']);
        foreach ($data['data'] as $key => $Values) {

            $Values = (array) $Values;
            $formData = array();
            $error = null;
            $formData['profile_type'] = $documentProfileType['profile_type'];
            $formData['submit'] = "";

            foreach ($Values as $elementKey => $elementValue) {
                if ($elementKey == 'error_is')
                    continue;

                if (!preg_match('/[^0-9_]/', $elementKey)) {

                    $testElementKey = explode('_', $elementKey);
                    if ($testElementKey[0] != '1' && $elementValue != NULL) {
                        $checkParent = explode('_', $elementKey);
                        $getResultKeyValue = $this->checkArrayKey(array_keys($Values), $checkParent[0]);
                        // Make radio and Multi select box to decide one value.
                        $dynamicFieldType = strtolower($dynamicField[$getResultKeyValue]['type']);
                        if ($dynamicFieldType == 'select' || $dynamicFieldType == 'radio') {
                            if ($formData[$getResultKeyValue] != $checkParent[1]) {
                                // Set Error
                                $error[$elementKey] = " This field must be empty for the selected value of parent field " . $dynamicField[$getResultKeyValue]['label'] . ".";
                            } else {
                                $formData[$elementKey] = $elementValue;
                            }
                        } else {
                            $flagCheck = false;
                            foreach ($formData[$getResultKeyValue] as $getElementForm) {
                                if ($getElementForm == $checkParent[1] || $elementValue == Null || $elementValue == '') {
                                    $flagCheck = true;
                                    break;
                                }
                            }
                            if ($flagCheck == false) {
                                $error[$elementKey] = "This field must be empty for the selected value of parent field " . $dynamicField[$getResultKeyValue]['label'] . ".";
                            } else {
                                $formData[$elementKey] = $elementValue;
                            }
                        }
                    }

                    if (is_null($dynamicField[$elementKey]['option'])) {

                        $formData[$elementKey] = $elementValue;
                    } else {
                        $index = 0;
                        $elementValue = strtolower($elementValue);

                        // Get type here
                        $dynamicFieldType = strtolower($dynamicField[$elementKey]['type']);
                        if ($dynamicFieldType == 'select' || $dynamicFieldType == 'radio') {

                            foreach ($dynamicField[$elementKey]['optionStore'] as $key1 => $value) {
                                # code...
                                $value = strtolower($value);
                                $flag = false;
                                if (strpos($elementValue, $value) !== false) {
                                    $formData[$elementKey] = $key1;
                                    $flag = true;
                                    break;
                                }
                            }
                            if ($flag == false && !empty($elementValue)) {
                                $error[$elementKey] = "This option is not available in this fields " . $dynamicFieldType . ".";
                            }
                            if (count(explode(',', $elementValue)) > 1) {
                                $error[$elementKey] = "Cannot select more than one value.";
                            }
                        } else {

                            if (!empty($elementValue)) {
                                $getElementValue = explode(',', $elementValue);
                                foreach ($getElementValue as $elementString) {
                                    if (!in_array($elementString, array_map('strtolower', $dynamicField[$elementKey]['optionStore']))) {
                                        $error[$elementKey] = "It contains values which are not the part of this field.";
                                    }
                                }
                            }
                            $formData[$elementKey] = NULL;
                            $index = 0;
                            foreach ($dynamicField[$elementKey]['optionStore'] as $key1 => $value) {
                                $value = strtolower($value);
                                if (strpos($elementValue, $value) !== false) {
                                    $formData[$elementKey][$index] = $key1;
                                    $index++;
                                }
                            }
                        }
                    }
                } else {
                    $dynamicFieldType = strtolower($dynamicField[$elementKey]['type']);
                    if ($dynamicFieldType == 'select' || $dynamicFieldType == 'radio' || $dynamicFieldType == 'checkbox') {
                        foreach ($dynamicField[$elementKey]['optionStore'] as $key1 => $value) {
                            $value = strtolower($value);
                            $elementValue = strtolower($elementValue);
                            $flag = false;
                            if (strpos($elementValue, $value) !== false) {
                                $formData[$elementKey] = $key1;
                                $flag = true;
                                break;
                            }
                        }
                        if ($flag == false && !empty($elementValue)) {
                            $error[$elementKey] = "This option is not available in this fields " . $dynamicFieldType . ". ";
                        }
                        if (count(explode(',', $elementValue)) > 1) {
                            $error[$elementKey] = "Cannot select more than one value.";
                        }
                    } else {
                        $formData[$elementKey] = $elementValue;
                    }
                }
            }
            $form = new Document_Form_Admin_Addnewdocument(
                    array(
                'profileType' => $formData['profile_type'],
            ));
            $form->setControllerName('bulkInsertionAction');
            $isValid = false;
            $isValid = $form->isValid($formData);

            if (isset($form->documentthumbnail) && $form->documentthumbnail->getErrorMessages() != null) {
                $isValid = false;
                $error['documentthumbnail'] = $form->documentthumbnail->getErrorMessages()[0];
            }
            if (isset($form->filename) && $form->filename->getErrorMessages() != null) {
                $isValid = false;
                $error['filename'] = $form->filename->getErrorMessages()[0];
            }
            $getFormErrorMessage = $form->getMessages();
            if ($getFormErrorMessage != null) {
                $isValid = false;
                foreach ($getFormErrorMessage as $keyErrormsg => $errorMsg) {
                    foreach ($errorMsg as $errorMsgChild) {
                        $error[$keyErrormsg] = $errorMsgChild;
                    }
                }
            }
            if ($error != null) {
                $isValid = false;
            }
            $db = Engine_Db_Table::getDefaultAdapter();
            if ($isValid == false) {
                // Store this error in the database.
                $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'document');
                $fileId = $this->_getParam('fileimport_id');
                $getTableRow = $getFileTable->fetchRow($getFileTable->select()->where('fileimport_id = ?', $fileId));
                $jsonError = json_encode($error);
                $Values['error_is'] = $jsonError;
                $db->update($getTableRow['table_name'], $Values, "unique_Id = $key");
            }

            if ($isValid == true) {
                if (empty($formData['documentthumbnail'])) {
                    $formData['documentthumbnail'] = NULL;
                }
                if (empty($formData['filename'])) {
                    $formData['filename'] = NULL;
                }

                $jsonData[] = $formData;
                $uniqueKeys[] = $key;
            }
        }

        $returnData = array();
        $returnData['data'] = $jsonData;
        $returnData['keys'] = $uniqueKeys;
        echo Zend_Json_Encoder::encode($returnData);
        die;
    }

    /*
     * Action to save document 10 at a time 
     *
     */

    public function bulkSaveAction() {
        $result = array();
        $getPost = $this->getRequest()->getPost();
        $post = $getPost['data'];
        $params = $getPost['params'];
        if (empty($post)) {
            $result['status'] = 'error';
            $result['msg'] = 'Chunk Posted is empty';
        }
        if (isset($post) && count($post) > 0) {

            $file = NULL;
            if (!empty($params['fileId'])) {
                $file = $params['fileId'];
            }

            $isDummy = false;
            if (!empty($getPost['referer']) && $getPost['referer'] == 'add-bulk-data-csv') {
                $isDummy = true;
            }

            $db = Zend_Db_Table_Abstract::getDefaultAdapter();
            try {

                foreach ($post as $documentData) {
                    $this->saveDocument($documentData, $file, $documentData['documentthumbnail'], $documentData['filename']);
                }
                $db->commit();
                $result['status'] = 'success';
                $result['count'] = count($post);
                $result['msg'] = 'Saved Successfully';
            } catch (Exception $e) {
                $db->rollback();
                $result['status'] = 'error';
                $result['msg'] = $e->getMessage();
            }
        }
        echo json_encode($result);
        die();
    }

    /**
     * @param $getFormData - Document Data. 
     * @return $getFileId - when saving uploaded data, this keeps details of file.
     * */
    public function saveDocument($getFormData, $getFileId = NULL, $photo = null, $filename = null) {
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');
        $coreApi = Engine_Api::_()->document();
        $document_client_id = $this->_document_client_id = $coreApi->getGoogleClientId();
        $getGoogleClientSecretKey = $this->_getGoogleClientSecretKey = $coreApi->getGoogleClientSecretKey();
        $document_google_email = $this->_document_google_email = $coreApi->getGoogleEmail();
        $document_hide_old_fields = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.hide.old.fields', 0);

        if ($document_hide_old_fields) {
            $this->_GDSEMedia = new GDSEMedia($document_client_id, null, null, $getGoogleClientSecretKey);
        } else {
            $document_service_account_name = $this->_document_service_account_name = $coreApi->getGoogleServiceAccountName();
            $document_private_key_url_path = $this->_document_private_key_url_path = $coreApi->getPrivateKeyUrl();
            if ($document_google_email && $document_client_id && $document_service_account_name && $document_private_key_url_path) {
                $this->_GDSEMedia = new GDSEMedia($document_client_id, $document_service_account_name, $document_private_key_url_path);
            }
        }

        //BEGIN TRANSCATION
        $db = $documentTable->getAdapter();
        $db->beginTransaction();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $level_id = $viewer->level_id;

        //GET FROM VALUES
        $values = $getFormData;

        //DOCUMENT CREATION CODE
        try {

            $values = array_merge($values, array(
                'owner_type' => $viewer->getType(),
                'owner_id' => $viewer_id,
                'parent_type' => $parent_type,
                'parent_id' => $parent_id,
            ));

            //FILE EXTENSION SHOULD NOT DIFFER FROM ALLOWED TYPE
            $ext = str_replace(".", "", strrchr($filename, "."));
            $settings = Engine_Api::_()->getApi('settings', 'core');


            // SET DEFAULT VIEW TYPE OF DOCUMENTS
            if (empty($documentGlobalType) && ($documentInfoType != $tempGlobalView)) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('document.viewtypeinfo.settings', 0);
                Engine_Api::_()->getApi('settings', 'core')->setSetting('document.viewtypeinfo.type', 0);
            }

            if (empty($values['subcategory_id'])) {
                $values['subcategory_id'] = 0;
            }
            if (empty($values['subsubcategory_id'])) {
                $values['subsubcategory_id'] = 0;
            }

            if (Engine_Api::_()->document()->documentBaseNetworkEnable()) {
                if (isset($values['networks_privacy']) && !empty($values['networks_privacy'])) {
                    if (in_array(0, $values['networks_privacy'])) {
                        unset($values['networks_privacy']);
                    }
                }
            }

            //CREATE THE MAIN DOCUMENT
            $documentRow = $documentTable->createRow();
            $documentRow->setFromArray($values);
            $documentRow->owner_id = $viewer_id;

            //MAKE PROFILE DOCUMENT WORK
            $profile_doc = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'profile_doc');
            $profile_doc_show = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'profile_doc_show');
            if ($profile_doc == 1 && $profile_doc_show == 1 && !empty($documentRow->profile_doc)) {
                //REMOVE OTHER DOCUMENT AS A PROFILE DOCUMENT
                $documentTable->removeProfileDoc($documentRow->owner_id);
            }

            $documentRow->save();

            //DOWNLOAD ALLOW CHECK
            $download_allow = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'download_allow');
            $download_show = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'download_show');
            if (empty($download_allow)) {
                $documentRow->download_allow = 0;
            } elseif (empty($download_show)) {
                $documentRow->download_allow = 1;
            } else {
                $documentRow->download_allow = $values['download_allow'];
            }
            $access = 'public';
            $documentRow->document_private = $access;

            if ($documentRow->document_private == 'public') {
                $documentRow->secure_allow = 0;
            }

            if (!empty($filename)) {
                $archiveProfilePhoto = APPLICATION_PATH . "/public/document" . DIRECTORY_SEPARATOR . "fileimport_" . $getFileId . DIRECTORY_SEPARATOR . "documentfilename/";
                $getSubDirInfo = scandir($archiveProfilePhoto);
                foreach ($getSubDirInfo as $dirKey => $subDir) {

                    if ($subDir === '.' or $subDir === '..')
                        continue;
                    if (is_dir($archiveProfilePhoto . $subDir)) {
                        $getProfilePhotoFile = $archiveProfilePhoto . $subDir;
                        break;
                    }
                }
                @chmod($getProfilePhotoFile . '/' . $filename, 0777);
                // check if photo is present or not  
                if (!file_exists($getProfilePhotoFile . '/' . $filename)) {
                    throw new User_Model_Exception('Document file not found.');
                }
                $file = $getProfilePhotoFile . '/' . $filename;
                $path = $archiveProfilePhoto;
                $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

                $local_info = $documentRow->setFile($file);

                $name = $values['filename'];

                $document_description = $values['document_description'];
                $folderId = $this->_GDSEMedia->getFolder($viewer->email . '-' . $viewer_id);
                $this->_GDSEMedia->setPermissions($folderId, $this->_document_google_email);
                $fileParent = new Google_ParentReference();
                $fileParent->setId($folderId);

                $base = Zend_Controller_Front::getInstance()->getBaseUrl();

                $storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
                $storageversion = $storagemodule->version;
                if ($storageversion < '4.1.1') {
                    $doc_base_url = "http://" . $_SERVER['HTTP_HOST'] . $base . "/";
                } else {
                    $doc_base_url = "http://" . $_SERVER['HTTP_HOST'];
                }

                $doc_base_url = str_replace("index.php/", '', $doc_base_url);
                $google_upload_url = $doc_base_url . $local_info['file_path'];

                $db = Engine_Db_Table::getDefaultAdapter();
                $type_array = $db->query("SHOW COLUMNS FROM engine4_storage_servicetypes LIKE 'enabled'")->fetch();

                if ($storageversion >= '4.1.6' && !empty($type_array)) {
                    $storageServiceTypeTable = Engine_Api::_()->getDbtable('serviceTypes', 'storage');
                    $storageServiceTypeTableName = $storageServiceTypeTable->info('name');

                    $storageServiceTable = Engine_Api::_()->getDbtable('services', 'storage');
                    $storageServiceTableName = $storageServiceTable->info('name');

                    $select = $storageServiceTypeTable->select()
                            ->setIntegrityCheck(false)
                            ->from($storageServiceTypeTableName, array(''))
                            ->join($storageServiceTableName, "$storageServiceTypeTableName.servicetype_id = $storageServiceTableName.servicetype_id", array('enabled', 'default'))
                            ->where("$storageServiceTypeTableName.plugin = ?", "Storage_Service_Local")
                            ->where("$storageServiceTypeTableName.enabled = ?", 1)
                            ->limit(1);
                    $storageCheck = $storageServiceTypeTable->fetchRow($select);
                    if (!empty($storageCheck)) {
                        if ($storageCheck->enabled == 1 && $storageCheck->default == 1) {
                            $google_upload_url = $doc_base_url . $local_info['file_path'];
                        } else {
                            $google_upload_url = $local_info['file_path'];
                        }
                    }
                }

                //GET STORAGE FILE OBJECT	
                $storage_file = Engine_Api::_()->getItem('storage_file', $documentRow->filename_id);
                $google_upload_url = $storage_file->temporary();
                $mimeType = Engine_Api::_()->document()->get_mime_content_type($google_upload_url);
                if ($documentInfoType == $tempGlobalView)
                    $fileId = $this->_GDSEMedia->createFileFromPath($google_upload_url, $name, $document_description, $fileParent, $mimeType, $documentRow->download_allow);

                $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                $documentRow->google_folder_id = $folderId;
                $documentRow->google_file_id = $fileId;
                $documentRow->status = 1;
                $documentRow->save();
                $gdsem_apiConfig['use_objects'] = true;
                $file = $this->_GDSEMedia->files->get($fileId);
            }

            $documentRow->save();
            if (Engine_Api::_()->getApi('settings', 'core')->getSetting('document.thumbnail', 0) && $photo) {
                $archiveProfilePhoto = APPLICATION_PATH . "/public/document" . DIRECTORY_SEPARATOR . "fileimport_" . $getFileId . DIRECTORY_SEPARATOR . "documentthumbnail/";
                $getSubDirInfo = scandir($archiveProfilePhoto);
                foreach ($getSubDirInfo as $dirKey => $subDir) {

                    if ($subDir === '.' or $subDir === '..')
                        continue;
                    if (is_dir($archiveProfilePhoto . $subDir)) {
                        $getProfilePhotoFile = $archiveProfilePhoto . $subDir;
                        break;
                    }
                }
                @chmod($getProfilePhotoFile . '/' . $photo, 0777);
                // check if photo is present or not  
                if (!file_exists($getProfilePhotoFile . '/' . $photo)) {
                    throw new User_Model_Exception('Thumbnail file not found.');
                }
                $file = $getProfilePhotoFile . '/' . $photo;
                $documentRow->setPhoto($file);
            }

            //CHECKS FOR DOCUMENT APPROVEL AT CREATION TIME
            $document_approved = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'approved');
            if ($document_approved == 1) {
                $documentRow->approved = 1;
            } else {
                $documentRow->approved = 0;
            }

            //CHECKS FOR DOCUMENT FEATURED AT CREATION TIME
            $document_featured = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'featured');
            if ($document_featured == 1) {
                $documentRow->featured = 1;
            } else {
                $documentRow->featured = 0;
            }

            //CHECKS FOR DOCUMENT SPONSORED AT CREATION TIME
            $document_sponsored = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'sponsored');
            if ($document_sponsored == 1) {
                $documentRow->sponsored = 1;
            } else {
                $documentRow->sponsored = 0;
            }

            //EMAIL ALLOW CHECK
            $email_allow = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'email_allow');
            $email_show = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'email_show');
            if (empty($email_allow)) {
                $documentRow->email_allow = 0;
            } elseif (empty($email_show)) {
                $documentRow->email_allow = 1;
            } else {
                $documentRow->email_allow = $values['email_allow'];
            }

            $documentRow->filemime = $mimeType;
            $documentRow->filesize = @filesize($file);
            $documentRow->migrated = 1;
            $documentRow->activity_feed = 0;
            $documentRow->save();

            //DOCUMENT VIEW PRIVACY WORK
            $auth = Engine_Api::_()->authorization()->context;
            $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered', 'everyone');

            if ($values['auth_view'])
                $auth_view = $values['auth_view'];
            else
                $auth_view = "everyone";
            $viewMax = array_search($auth_view, $roles);

            foreach ($roles as $i => $role) {
                $auth->setAllowed($documentRow, $role, 'view', ($i <= $viewMax));
            }

            //DOCUMENT COMMENT PRIVACY WORK
            $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'registered');
            if ($values['auth_comment'])
                $auth_comment = $values['auth_comment'];
            else
                $auth_comment = "everyone";
            $commentMax = array_search($auth_comment, $roles);

            foreach ($roles as $i => $role) {
                $auth->setAllowed($documentRow, $role, 'comment', ($i <= $commentMax));
            }

            //ADDING TAGS
            if (!empty($values['tags'])) {
                $tags = preg_split('/[,]+/', $values['tags']);
                $tags = array_filter(array_map("trim", $tags));
                $documentRow->tags()->addTagMaps($viewer, $tags);
            }
            $documentRow->save();

            $getResultData = $this->getFieldValues($values, $documentRow->getIdentity());
            foreach ($getResultData as $tuple) {
                $fieldvalueTable = Engine_Api::_()->fields()->getTable('document', 'values');
                $userFieldsValues = $fieldvalueTable->createRow();
                $userFieldsValues->setFromArray($tuple);
                $userFieldsValues->save();
                unset($userFieldsValues);
            }

            $draft_value = 0;
            if (isset($values['draft'])) {
                $draft_value = $values['draft'];
            }

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    public function multiDeleteAction() {

        if (!$this->getRequest()->isPost()) {
            return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
        }
        // Now get ids of file here which is going to delete.
        $fileIdIs = $this->getRequest()->getPost();
        if (is_null($fileIdIs)) {
            return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
        }
        // first delete photos from this location.
        foreach ($fileIdIs as $fileId) {
            $reviewimportfileTable = Engine_Api::_()->getDbtable('addFileDetails', 'document');
            $selectImportTable = $reviewimportfileTable->select()
                    ->from($reviewimportfileTable->info('name'))
                    ->where('fileimport_id = ?', $fileId);
            $fileRow = $reviewimportfileTable->fetchRow($selectImportTable);

            if (count($fileRow) < 1) {
                return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
            }

            // delete row from table as well as drop table.
            try {
                $db = Engine_Db_Table::getDefaultAdapter();
                $dropTable = "DROP TABLE IF EXISTS `" . $fileRow['table_name'] . "`";

                $status1 = $db->query($dropTable);
                $status2 = $reviewimportfileTable->delete(array('fileimport_id = ?' => $fileRow['fileimport_id']));

                $path = APPLICATION_PATH . "/public/document/fileimport_" . $fileRow['fileimport_id'];
                $reviewimportfileTable->removeDirectory($path);
            } catch (Exception $e) {
                throw $e;
            }
        }
        return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
    }

    // delete Row from Data here.
    public function deleteDataAction() {
        if (!$this->getRequest()->isPost()) {
            return;
        }
        // Handle all keys
        $deleteValues = $this->getRequest()->getPost();
        foreach ($deleteValues as $key => $value) {
            if (!preg_match('/d_[0-9]+$/', $key)) {
                unset($deleteValues[$key]);
            }
        }
        $fileId = $this->_getParam('fileimport_id');
        $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'document');
        if (is_null($deleteValues)) {
            return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
        }

        $flag = $getFileTable->deleteRow($fileId, $deleteValues);
        if ($flag == 0) {
            return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'manage',));
        }
        return $this->_helper->redirector->gotoRoute(array('module' => 'document', 'controller' => 'import', 'action' => 'edit', 'fileimport_id' => $fileId));
    }

    public function afterBulkSaveAction($referer, $params = null) {
        $data = array('status' => 'error');
        try {
            $post = $this->_getAllParams();
            if (empty($post)) {
                throw new Exception('Required status approval data missing');
            }

            $params = $post['params'];
            $referer = $post['referer'];

            if ($referer == 'edit') {
                $getFileTable = Engine_Api::_()->getDbtable('addFileDetails', 'document');
                $getFileTable->deleteRow($params['fileId'], $params['keys']);
            }
            $data['status'] = 'success';
        } catch (Exception $e) {
            $data['msg'] = $e->getMessage();
        }
        echo json_encode($data);
        die();
    }

    /**
     *  @param Send all form data here.
     *  @param Send all User id here.
     *  @return  get value of every field
     */
    public function getFieldValues($getData = NUll, $userId) {

        if (is_null($getData)) {
            return NUll;
        }
        if (is_null($getData['profile_type'])) {
            $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
            $options = $topStructure[0]->getChild()->getOptions();
            $getData['profile_type'] = $options[0]->option_id;
        }

        $customer_id = $userId;
        $makeFieldarray = array();
        $index = 1;

        //note: value will be profile type.
        $addprofilefieldsvalues = array(
            'item_id' => $userId,
            'field_id' => 1,
            'index' => 0,
            'value' => $getData['profile_type'],
        );
        $makeFieldarray = array(
            0 => $addprofilefieldsvalues,
        );

        foreach ($getData as $key => $fieldvalue) {
            // if field are dynaimic then key will be as given
            if (!preg_match('/[^0-9_]/', $key)) {

                $arrayValues = explode("_", $key);
                // third value will be our fields_id in database.
                $fieldIdIs = $arrayValues[2];
                //this will only show profile dynamic fields.
                if ($fieldvalue == NULL) {
                    $fieldvalue = "";
                }
                if (is_array($fieldvalue)) {
                    foreach ($fieldvalue as $internalKey => $internalValue) {
                        $indexIDIs = $internalKey;
                        $ValueIs = $internalValue;

                        $addprofilefieldsvalues = array(
                            'item_id' => $customer_id,
                            'field_id' => $fieldIdIs,
                            'index' => $indexIDIs,
                            'value' => $ValueIs,
                        );
                        $makeFieldarray[$index] = $addprofilefieldsvalues;
                        $index++;
                    }
                } else {
                    $indexIDIs = 0;
                    $ValueIs = $fieldvalue;

                    $addprofilefieldsvalues = array(
                        'item_id' => $customer_id,
                        'field_id' => $fieldIdIs,
                        'index' => $indexIDIs,
                        'value' => $ValueIs,
                    );
                    $makeFieldarray[$index] = $addprofilefieldsvalues;
                    $index++;
                }
            }
        }

        return $makeFieldarray;
    }

}
