<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Document/Api/GDSEMedia.php';

class Document_AdminSettingsController extends Core_Controller_Action_Admin {

    protected $_document_google_email;
    protected $_document_client_id;
    protected $_document_service_account_name;
    protected $_document_private_key_url_path;
    protected $_GDSEMedia;

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */
        if (!empty($method) && $method == 'Document_Form_Admin_Settings_Global') {
            
        }
        return true;
    }

    //ACTION FOR GLOBAL SETTINGS
    public function indexAction() {
        $this->view->route = $this->_getParam('route', '');
        global $gdsem_apiConfig;
        $this->view->hasLanguageDirectoryPermissions = $hasLanguageDirectoryPermissions = Engine_Api::_()->getApi('language', 'document')->hasDirectoryPermissions();
        $coreApi = Engine_Api::_()->document();
        $document = Engine_Api::_()->getApi('settings', 'core')->getSetting( "language.phrases.document", "document");
        $documents = Engine_Api::_()->getApi('settings', 'core')->getSetting( "language.phrases.documents", "documents");   
        $document_client_id = $this->_document_client_id = $coreApi->getGoogleClientId();
        $getGoogleClientSecretKey = $this->_getGoogleClientSecretKey = $coreApi->getGoogleClientSecretKey();
        $document_google_email = $this->_document_google_email = $coreApi->getGoogleEmail();
        $document_hide_old_fields = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.hide.old.fields', 0);
        if ($document_hide_old_fields) {
            $this->_GDSEMedia = new GDSEMedia($document_client_id, null, null, $getGoogleClientSecretKey);
        } else {
            $document_service_account_name = $this->_document_service_account_name = $coreApi->getGoogleServiceAccountName();
            $document_private_key_url_path = $this->_document_private_key_url_path = $coreApi->getPrivateKeyUrl();
            if ($document_google_email && $document_client_id && $document_service_account_name && $document_private_key_url_path) {
                $this->_GDSEMedia = new GDSEMedia($document_client_id, $document_service_account_name, $document_private_key_url_path);
            }
        }

        if (!empty($_POST['document_controllersettings'])) {
            $_POST['document_controllersettings'] = trim($_POST['document_controllersettings']);
        }

        if (isset($_POST['document_api_key']) && !empty($_POST['document_api_key'])) {
            $_POST['document_api_key'] = trim($_POST['document_api_key']);
        }

        if (isset($_POST['document_secret_key']) && !empty($_POST['document_secret_key'])) {
            $_POST['document_secret_key'] = trim($_POST['document_secret_key']);
        }

        $gdsem_apiConfig['use_objects'] = true;

        if ($this->_GDSEMedia) {
            $this->view->ebot = $this->_GDSEMedia->getAbout();
        }
        $this->view->isModsSupport = Engine_Api::_()->document()->isModulesSupport();
if (isset($_POST['language_phrases_documents']) && $_POST['language_phrases_documents'] != $documents && isset($_POST['language_phrases_document']) && $_POST['language_phrases_document'] != $document && !empty($hasLanguageDirectoryPermissions)) {

            $db = Zend_Db_Table_Abstract::getDefaultAdapter();

            //Work for raplace facebook plugin.
            if (Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled( 'facebooksefeed' ) && Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled( 'facebookse' )) {
                    $facebookseMixsettingstable = Engine_Api::_()->getDbtable('mixsettings', 'facebookse');

                    $select = $facebookseMixsettingstable->select()->from($facebookseMixsettingstable->info('name'), array('streampublish_message', 'streampublish_caption', 'streampublish_action_link_text', 'activityfeedtype_text', 'resource_type', 'module'))
                    ->where('module LIKE ?', '%' . 'document' . '%'); 
                    $results = $select->query()->fetchAll();
                    $replaceWord = ucfirst($_POST['language_phrases_document']);
                    $orignal_word = ucfirst($document);
                    foreach($results as $result) {

                            $streampublish_message = str_replace(" $orignal_word", " $replaceWord", $result["streampublish_message"]); 

                            $streampublish_caption = str_replace(" $orignal_word", " $replaceWord", $result["streampublish_caption"]);

                            $streampublish_action_link_text = str_replace(" $orignal_word", " $replaceWord", $result["streampublish_action_link_text"]);

                            $activityfeedtype_text = str_replace(" $orignal_word", " $replaceWord", $result["activityfeedtype_text"]);

                            $db->query('UPDATE  `engine4_facebookse_mixsettings` SET  `streampublish_message` =  \''.$streampublish_message.'\' WHERE  `engine4_facebookse_mixsettings`.`resource_type` =\''.$result["resource_type"].'\' and `engine4_facebookse_mixsettings`.`module` =\''.$result["module"].'\';');

                            $db->query('UPDATE  `engine4_facebookse_mixsettings` SET  `streampublish_caption` =  \''.$streampublish_caption.'\' WHERE  `engine4_facebookse_mixsettings`.`resource_type` =\''.$result["resource_type"].'\' and `engine4_facebookse_mixsettings`.`module` =\''.$result["module"].'\';');

                            $db->query('UPDATE  `engine4_facebookse_mixsettings` SET  `streampublish_action_link_text` =  \''.$streampublish_action_link_text.'\' WHERE  `engine4_facebookse_mixsettings`.`resource_type` =\''.$result["resource_type"].'\' and `engine4_facebookse_mixsettings`.`module` =\''.$result["module"].'\';');

                            $db->query('UPDATE  `engine4_facebookse_mixsettings` SET  `activityfeedtype_text` =  \''.$activityfeedtype_text.'\' WHERE  `engine4_facebookse_mixsettings`.`resource_type` =\''.$result["resource_type"].'\' and `engine4_facebookse_mixsettings`.`module` =\''.$result["module"].'\';');
                    }
            }
				
                $db->query('UPDATE  `engine4_core_menuitems` SET  `label` =  \''.ucfirst($_POST['language_phrases_documents']).'\' WHERE  `engine4_core_menuitems`.`name` ="core_main_document";');


                $language_pharse = array('text_documents' => '$plural$' , 'text_document' => '$singular$'); 

                Engine_Api::_()->getApi('language', 'document')->setTranslateForListType($language_pharse, '', $document, $documents);

                $language_pharse = array('text_documents' => $_POST['language_phrases_documents'] , 'text_document' => $_POST['language_phrases_document']); 

                Engine_Api::_()->getApi('language', 'document')->setTranslateForListType($language_pharse, '', '$singular$', '$plural$');
        }
        include_once(APPLICATION_PATH . "/application/modules/Document/controllers/license/license1.php");
    }

    //ACTION FOR LEVEL SETTINGS
    public function levelAction() {
        //MAKE NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_level');

        //FETCH LEVEL ID 
        if (null !== ($level_id = $this->_getParam('id'))) {
            $level = Engine_Api::_()->getItem('authorization_level', $level_id);
        } else {
            $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
        }

        if (!$level instanceof Authorization_Model_Level) {
            throw new Engine_Exception($this->view->translate('missing level'));
        }

        //GET LEVEL ID
        $level_id = $level->level_id;

        //GENERATE FORM
        $this->view->form = $form = new Document_Form_Admin_Settings_Level(array(
            'public' => ( in_array($level->type, array('public')) ),
            'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
        ));

        if (!empty($level_id)) {
            $form->level_id->setValue($level_id);
        }

        //GET AUTHORIZATION
        $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');

        if (!$this->getRequest()->isPost()) {
            $form->populate($permissionsTable->getAllowed('document', $level_id, array_keys($form->getValues())));
            return;
        }

        //FORM VALIDATION
        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //GET POSTED VALUE
        $values = $form->getValues();

        $option_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.visibility.option', 1);
        $visibility = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.default.visibility', 'private');
        if ($visibility == 'public' && empty($option_show)) {
            unset($values['visibility_hide_options']);
        }

        //CHECK FOR FILESIZE
        if ($level->type != 'public') {
            if ($values['filesize'] < 0) {
                $values['filesize'] = (int) ini_get('upload_max_filesize') * 1024 * 1024;
            }
        }

        //BEGIN TRANSCATION
        $db = $permissionsTable->getAdapter();
        $db->beginTransaction();

        try {
            include APPLICATION_PATH . '/application/modules/Document/controllers/license/license2.php';

            $form->addNotice('Your changes have been saved.');
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

    //ACTION FOR GETTING THE CATGEORIES, SUBCATEGORIES AND 3RD LEVEL CATEGORIES
    public function categoriesAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_categories');
        //GET STORAGE API
        $this->view->storage = Engine_Api::_()->storage();
        //GET TASK
        if (isset($_POST['task'])) {
            $task = $_POST['task'];
        } elseif (isset($_GET['task'])) {
            $task = $_GET['task'];
        } else {
            $task = "main";
        }

        //GET CATEGORIES TABLE
        $tableCategory = Engine_Api::_()->getDbTable('categories', 'document');
        $tableCategoryName = $tableCategory->info('name');

        //GET DOCUMENT TABLE
        $tableDocument = Engine_Api::_()->getDbtable('documents', 'document');

        if ($task == "savecat") {

            //GET CATEGORY ID
            $category_id = $_GET['cat_id'];

            $cat_title_withoutparse = $_GET['cat_title'];

            //GET CATEGORY TITLE
            $cat_title = Engine_Api::_()->document()->parseString($_GET['cat_title']);

            //GET CATEGORY DEPENDANCY
            $cat_dependency = $_GET['cat_dependency'];
            $subcat_dependency = $_GET['subcat_dependency'];
            if ($cat_title == "") {
                if ($category_id != "new") {
                    if ($cat_dependency == 0) {
                        $row_ids = $tableCategory->getSubCategories($category_id);
                        foreach ($row_ids as $values) {
                            $tableCategory->delete(array('subcat_dependency = ?' => $values->category_id, 'cat_dependency = ?' => $values->category_id));
                            $tableCategory->delete(array('category_id = ?' => $values->category_id));
                        }

                        //SELECT DOCUMENTS WHICH HAVE THIS CATEGORY
                        $rows = $tableDocument->getCategoryDocument($category_id);

                        if (!empty($rows)) {
                            foreach ($rows as $key => $document_ids) {
                                $document_id = $document_ids['document_id'];

                                //DELETE ALL MAPPING VALUES FROM FIELD TABLES
                                Engine_Api::_()->fields()->getTable('document', 'values')->delete(array('item_id = ?' => $document_id));
                                Engine_Api::_()->fields()->getTable('document', 'search')->delete(array('item_id = ?' => $document_id));

                                //UPDATE THE PROFILE TYPE OF ALREADY CREATED DOCUMENTS
                                $tableDocument->update(array('profile_type' => 0), array('document_id = ?' => $document_id));
                            }
                        }

                        $tableDocument->update(array('category_id' => 0, 'subcategory_id' => 0, 'subsubcategory_id' => 0), array('category_id = ?' => $category_id));
                        $tableCategory->delete(array('category_id = ?' => $category_id));
                    } else {
                        $tableCategory->update(array('category_name' => $cat_title), array('category_id = ?' => $category_id, 'cat_dependency = ?' => $cat_dependency));

                        //SELECT DOCUMENTS WHICH HAVE THIS CATEGORY
                        $rows = $tableDocument->getCategoryDocument($category_id);

                        if (!empty($rows)) {
                            foreach ($rows as $key => $document_ids) {
                                $document_id = $document_ids['document_id'];

                                //DELETE ALL MAPPING VALUES FROM FIELD TABLES
                                Engine_Api::_()->fields()->getTable('document', 'values')->delete(array('item_id = ?' => $document_id));
                                Engine_Api::_()->fields()->getTable('document', 'search')->delete(array('item_id = ?' => $document_id));

                                //UPDATE THE PROFILE TYPE OF ALREADY CREATED DOCUMENTS
                                $tableDocument->update(array('profile_type' => 0), array('document_id = ?' => $document_id));
                            }
                        }

                        $tableDocument->update(array('subcategory_id' => 0, 'subsubcategory_id' => 0), array('subcategory_id = ?' => $category_id));
                        $tableDocument->update(array('subsubcategory_id' => 0), array('subsubcategory_id = ?' => $category_id));

                        $tableCategory->delete(array('cat_dependency = ?' => $category_id, 'subcat_dependency = ?' => $category_id));
                        $tableCategory->delete(array('category_id = ?' => $category_id));
                    }
                }
                //SEND AJAX CONFIRMATION
                echo "<html><head><meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><script type='text/javascript'>";
                echo "window.parent.removecat('$category_id');";
                echo "</script></head><body></body></html>";
                exit();
            } else {
                if ($category_id == 'new') {
                    $row_info = $tableCategory->fetchRow($tableCategory->select()->from($tableCategoryName, 'max(cat_order) AS cat_order'));
                    $cat_order = $row_info['cat_order'] + 1;
                    $row = $tableCategory->createRow();
                    $row->category_name = $cat_title_withoutparse;
                    $row->cat_order = $cat_order;
                    $row->cat_dependency = $cat_dependency;
                    $row->subcat_dependency = $subcat_dependency;
                    $newcat_id = $row->save();
                } else {
                    $tableCategory->update(array('category_name' => $cat_title_withoutparse), array('category_id = ?' => $category_id));
                    $newcat_id = $category_id;
                }

                //SEND AJAX CONFIRMATION
                echo "<html><head><meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><script type='text/javascript'>";
                echo "window.parent.savecat_result('$category_id', '$newcat_id', '$cat_title', '$cat_dependency', '$subcat_dependency');";
                echo "</script></head><body></body></html>";
                exit();
            }
        } elseif ($task == "changeorder") {
            $divId = $_GET['divId'];
            $documentOrder = explode(",", $_GET['documentorder']);
            //RESORT CATEGORIES
            if ($divId == "categories") {
                for ($i = 0; $i < count($documentOrder); $i++) {
                    $category_id = substr($documentOrder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            } elseif (substr($divId, 0, 7) == "subcats") {
                for ($i = 0; $i < count($documentOrder); $i++) {
                    $category_id = substr($documentOrder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            } elseif (substr($divId, 0, 11) == "treesubcats") {
                for ($i = 0; $i < count($documentOrder); $i++) {
                    $category_id = substr($documentOrder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            }
        }

        $categories = array();
        $category_info = $tableCategory->getCategories(1, 0);
        foreach ($category_info as $value) {
            $sub_cat_array = array();
            $subcategories = $tableCategory->getAllCategories($value->category_id, 'subcategory_id', 0, 'subcategory_id', 0, 0);
            foreach ($subcategories as $subresults) {
                $subsubcategories = $tableCategory->getAllCategories($subresults->category_id, 'subsubcategory_id', 0, 'subsubcategory_id', 0, 0);
                $treesubarrays[$subresults->category_id] = array();
                foreach ($subsubcategories as $subsubcategoriesvalues) {
                    $treesubarrays[$subresults->category_id][] = $treesubarray = array('tree_sub_cat_id' => $subsubcategoriesvalues->category_id,
                        'tree_sub_cat_name' => $subsubcategoriesvalues->category_name,
                        'order' => $subsubcategoriesvalues->cat_order,
                        'count' => $subsubcategoriesvalues->count,
                        'icon_id' => $subsubcategoriesvalues->icon_id,
                        'image_id' => $subsubcategoriesvalues->image_id);
                }

                $sub_cat_array[] = $tmp_array = array('sub_cat_id' => $subresults->category_id,
                    'sub_cat_name' => $subresults->category_name,
                    'tree_sub_cat' => $treesubarrays[$subresults->category_id],
                    'icon_id' => $subresults->icon_id,
                    'image_id' => $subresults->image_id,
                    'count' => $subresults->count,
                    'order' => $subresults->cat_order);
            }

            $categories[] = $category_array = array('category_id' => $value->category_id,
                'category_name' => $value->category_name,
                'icon_id' => $value->icon_id,
                'image_id' => $value->image_id,
                'order' => $value->cat_order,
                'count' => $value->count,
                'sub_categories' => $sub_cat_array);
        }

        include APPLICATION_PATH . '/application/modules/Document/controllers/license/license2.php';
    }

    //ACTINO FOR SEARCH FORM TAB
    public function formSearchAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_form_search');

        //GET SEARCH TABLE
        $tableSearchForm = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore');

        //CHECK POST
        if ($this->getRequest()->isPost()) {

            //BEGIN TRANSCATION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            $values = $_POST;
            $rowCategory = $tableSearchForm->getFieldsOptions('document', 'category_id');
            $defaultCategory = 0;
            $defaultAddition = 0;
            try {
                foreach ($values['order'] as $key => $value) {
                    $tableSearchForm->update(array('order' => $defaultAddition + $defaultCategory + $key + 1), array('module = ?' => 'document', 'searchformsetting_id = ?' => (int) $value));

                    if (!empty($rowCategory) && $value == $rowCategory->searchformsetting_id) {
                        $defaultCategory = 1;
                        $defaultAddition = 10000000;
                    }
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }

        //MAKE QUERY
        $select = $tableSearchForm->select()->where('module = ?', 'document')->order('order');

        //SEND DATA TO TPL
        include APPLICATION_PATH . '/application/modules/Document/controllers/license/license2.php';
    }

    //ACTION FOR DISPLAY/HIDE FIELDS OF SEARCH FORM
    public function diplayFormAction() {

        $field_id = $this->_getParam('id');
        $display = $this->_getParam('display');
        if (!empty($field_id)) {
            Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'document', 'searchformsetting_id =?' => (int) $field_id));
        }
        $this->_redirect('admin/document/settings/form-search');
    }

    //ACTION FOR FAQ SECTION
    public function faqAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_faq');

        $this->view->show = $this->_getParam('show');
    }

    //ACTION WHICH CALLS ONLY AT THE TIME OF PLUGIN INSTALLATION
    public function readmeAction() {
        
    }

    public function integrationsAction() {
        $pluginName = 'document';
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_integrations');
    }

    public function checkgoogledrive($v) {
        return;
    }

    //ACTION FOR ADD THE CATEGORY ICON
    Public function addIconAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        //CREATE FORM
        $this->view->form = $form = new Document_Form_Admin_Settings_Addicon();

        $this->view->close_smoothbox = 0;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //UPLOAD PHOTO
        if (isset($_FILES['photo']) && is_uploaded_file($_FILES['photo']['tmp_name'])) {
            //UPLOAD PHOTO
            $photoFile = $category->setPhoto($_FILES['photo'], 'thumb.icon');

            //UPDATE FILE ID IN CATEGORY TABLE
            if (!empty($photoFile->file_id)) {
                $category->icon_id = $photoFile->file_id;
                $category->save();
            }
        }

        $this->view->close_smoothbox = 1;
    }

    //ACTION FOR EDIT THE CATEGORY ICON
    Public function editIconAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');

        //GET CATEGORY ITEM
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        //CREATE FORM
        $this->view->form = $form = new Document_Form_Admin_Settings_Editicon();

        $this->view->close_smoothbox = 0;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //UPLOAD PHOTO
        if (isset($_FILES['photo']) && is_uploaded_file($_FILES['photo']['tmp_name'])) {
            //UPLOAD PHOTO
            $photoFile = $category->setPhoto($_FILES['photo'], 'thumb.icon');

            //UPDATE FILE ID IN CATEGORY TABLE
            if (!empty($photoFile->file_id)) {
                $previous_file_id = $category->icon_id;
                $category->icon_id = $photoFile->file_id;
                $category->save();

                //DELETE PREVIOUS CATEGORY ICON
                $file = Engine_Api::_()->getItem('storage_file', $previous_file_id);
                $file->delete();
            }
        }

        $this->view->close_smoothbox = 1;
    }

    //ACTION FOR DELETE THE CATEGORY ICON
    public function deleteIconAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');

        //GET CATEGORY ITEM
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        $this->view->close_smoothbox = 0;

        if ($this->getRequest()->isPost() && !empty($category->icon_id)) {

            //DELETE CATEGORY ICON
            $file = Engine_Api::_()->getItem('storage_file', $category->icon_id);
            $file->delete();

            //UPDATE FILE ID IN CATEGORY TABLE
            $category->icon_id = 0;
            $category->save();

            $this->view->close_smoothbox = 1;
        }
        $this->renderScript('admin-settings/delete-icon.tpl');
    }

    //ACTION FOR ADD THE CATEGORY ICON
    Public function addImageAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        //CREATE FORM
        $this->view->form = $form = new Document_Form_Admin_Settings_Addimage();

        $this->view->close_smoothbox = 0;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //UPLOAD PHOTO
        if (isset($_FILES['photo']) && is_uploaded_file($_FILES['photo']['tmp_name'])) {
            //UPLOAD PHOTO
            $photoFile = $category->setPhoto($_FILES['photo'], 'thumb.normal');

            //UPDATE FILE ID IN CATEGORY TABLE
            if (!empty($photoFile->file_id)) {
                $category->image_id = $photoFile->file_id;
                $category->save();
            }
        }

        $this->view->close_smoothbox = 1;
    }

    //ACTION FOR EDIT THE CATEGORY ICON
    Public function editImageAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');

        //GET CATEGORY ITEM
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        //CREATE FORM
        $this->view->form = $form = new Document_Form_Admin_Settings_Editimage();

        $this->view->close_smoothbox = 0;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        //UPLOAD PHOTO
        if (isset($_FILES['photo']) && is_uploaded_file($_FILES['photo']['tmp_name'])) {
            //UPLOAD PHOTO
            $photoFile = $category->setPhoto($_FILES['photo'], 'thumb.normal');

            //UPDATE FILE ID IN CATEGORY TABLE
            if (!empty($photoFile->file_id)) {
                $previous_file_id = $category->image_id;
                $category->image_id = $photoFile->file_id;
                $category->save();

                //DELETE PREVIOUS CATEGORY ICON
                $file = Engine_Api::_()->getItem('storage_file', $previous_file_id);
                $file->delete();
            }
        }

        $this->view->close_smoothbox = 1;
    }

    //ACTION FOR DELETE THE CATEGORY ICON
    public function deleteImageAction() {
        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID
        $this->view->category_id = $category_id = $this->_getParam('category_id');

        //GET CATEGORY ITEM
        $category = Engine_Api::_()->getItem('document_category', $category_id);

        $this->view->close_smoothbox = 0;

        if ($this->getRequest()->isPost() && !empty($category->image_id)) {

            //DELETE CATEGORY ICON
            $file = Engine_Api::_()->getItem('storage_file', $category->image_id);
            $file->delete();

            //UPDATE FILE ID IN CATEGORY TABLE
            $category->image_id = 0;
            $category->save();

            $this->view->close_smoothbox = 1;
        }
        $this->renderScript('admin-settings/delete-image.tpl');
    }

    public function getDocumentWidgetParamsAction() {
        $content_id = isset($_GET['content_id']) ? $_GET['content_id'] : 0;
        $toValues = $toValuesArray = array();
        $params = array('starttime' => '', 'endtime' => '');
        $toValuesString = '';
        if ($content_id) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');
            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('content_id = ?', $content_id)
                    ->where('name = ?', 'document.special-documents')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
                if (isset($params['toValues']) && !empty($params['toValues'])) {
                    $toValues = $params['toValues'];
                    if (!empty($toValues)) {
                        $toValues = explode(',', $toValues);
                        $toValues = array_unique($toValues);
                        $toValuesString = implode(',', $toValues);
                        $toValuesArray = array();
                        foreach ($toValues as $key => $id) {
                            $channel = Engine_Api::_()->getItem('document', $id);
                            if ($channel instanceof Core_Model_Item_Abstract) {
                                $toValuesArray[$key]['id'] = $id;
                                $toValuesArray[$key]['title'] = $channel->getTitle();
                            }
                        }
                    }
                }
            }
        }
        $this->view->toValuesArray = $toValuesArray;
        $this->view->toValuesString = $toValuesString;
    }

    function getDocumentsAction() {

        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');
        $documentTableName = $documentTable->info('name');

        //MAKE QUERY
        $select = $documentTable->select()
                ->where('document_title  LIKE ? ', '%' . $this->_getParam('text') . '%')
                ->where($documentTableName . '.search = ?', '1')
                ->order('document_title ASC')
                ->limit($this->_getParam('limit', 40));

        //FETCH RESULTS
        $documents = $documentTable->fetchAll($select);
        $data = array();
        $mode = $this->_getParam('struct');

        if ($mode == 'text') {
            foreach ($documents as $document) {
                $content_photo = $this->view->itemPhoto($document, 'thumb.icon');
                $data[] = array(
                    'id' => $document->document_id,
                    'label' => $document->document_title,
                    'photo' => $content_photo
                );
            }
        } else {
            foreach ($documents as $document) {
                $content_photo = $this->view->itemPhoto($document, 'thumb.icon');
                $data[] = array(
                    'id' => $document->document_id,
                    'label' => $document->document_title,
                    'photo' => $content_photo
                );
            }
        }
        return $this->_helper->json($data);
    }

    public function setTemplateAction() {

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main', array(), 'document_admin_main_template');

        $this->view->form = $form = new Document_Form_Admin_Template();
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            $templateApi = Engine_Api::_()->getApi('settemplate', 'document');
            $coreSettings = Engine_Api::_()->getApi('settings', 'core');

            include APPLICATION_PATH . '/application/modules/Document/controllers/license/license2.php';

            $templateApi = Engine_Api::_()->getApi('settemplate', 'document');
            if (!empty($values['document_pagestemplate']) && in_array('documentHome', $values['document_pagestemplate'])) {
                $templateApi->documentHome(true);
            }
            if (!empty($values['document_pagestemplate']) && in_array('documentBrowse', $values['document_pagestemplate'])) {
                $templateApi->documentBrowse(true);
            }
            if (!empty($values['document_pagestemplate']) && in_array('documentManage', $values['document_pagestemplate'])) {
                $templateApi->documentManage(true);
            }

            if (!empty($values['document_pagestemplate']) && in_array('documentCreation', $values['document_pagestemplate'])) {
                $templateApi->documentCreation(true);
            }

            if (!empty($values['document_pagestemplate']) && in_array('documentEdit', $values['document_pagestemplate'])) {
                $templateApi->documentEdit(true);
            }

            if (!empty($values['document_pagestemplate']) && in_array('documentView', $values['document_pagestemplate'])) {
                $templateApi->documentView(true);
            }

            if (!empty($values['document_pagestemplate']) && in_array('documentCategoriesHome', $values['document_pagestemplate'])) {
                $templateApi->documentCategoriesHome(true);
            }

            if (!empty($values['document_pagestemplate']) && in_array('documentMemberProfile', $values['document_pagestemplate'])) {
                $templateApi->documentMemberProfile(true);
            }

            $form->addNotice('Your changes have been saved.');
        }
    }

    public function templateAction() {
        
    }

}
