<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Installer extends Engine_Package_Installer_Module {

    function onPreInstall() {
        $db = $this->getDb();
        $doWeHaveOldDocument = $this->_doWeHaveOldDocument();
        if (!empty($doWeHaveOldDocument)) {
            $db->query("DELETE FROM `engine4_core_modules` WHERE `engine4_core_modules`.`name` = 'document' LIMIT 1");
            $db->query("DELETE FROM `engine4_seaocores` WHERE `engine4_seaocores`.`module_name` = 'document' LIMIT 1");
            $db->query("DELETE FROM `engine4_core_settings` WHERE `engine4_core_settings`.`name` = 'document.isActivate' LIMIT 1");
            $db->query("DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`module` = 'document'");
        }

        $PRODUCT_TYPE = 'document';
        $PLUGIN_TITLE = 'Document';
        $PLUGIN_VERSION = '5.9.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'Documents Sharing Plugin - Google Docs Viewer allows your users to upload and display documents; share, print and download them; add tags to documents, categorize them and give comments.';
        $PRODUCT_TITLE = 'Documents Sharing Plugin - Google Docs Viewer';
        $_PRODUCT_FINAL_FILE = 0;
        $_BASE_FILE_NAME = 'document2016';
        $SocialEngineAddOns_version = '4.8.12';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod))
                include_once $file_path;
        }

        parent::onPreInstall();
    }

    function onInstall() {
        $db = $this->getDb();

        // Adding it for Nested Comment integration
        $this->_setActivityFeeds();

        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("document_sitepage_document_new", "document", \'{item:$subject} created a new document in the page {item:$object}:\', "1", "7", "2", "1", "1", "1");');

        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("document_sitebusiness_document_new", "document", \'{item:$subject} created a new document in the business {item:$object}:\', "1", "7", "2", "1", "1", "1");');

        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("document_sitegroup_document_new", "document", \'{item:$subject} created a new document in the group {item:$object}:\', "1", "7", "2", "1", "1", "1");');

        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("document_sitestore_document_new", "document", \'{item:$subject} created a new document in the store {item:$object}:\', "1", "7", "2", "1", "1", "1");');

        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("document_siteevent_document_new", "document", \'{item:$subject} created a new document in the event {item:$object}:\', "1", "7", "2", "1", "1", "1");');

        // Adding for Suggestion Plugin integration
        $this->_setSuggestion();
        $db->query("DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`name` = 'document_admin_main_dayitem'");
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` = '1' WHERE  `engine4_seaocores`.`module_name` ='document';");

        $db->query("CREATE TABLE IF NOT EXISTS `engine4_document_modules` (
  `module_id` int(64) NOT NULL AUTO_INCREMENT,
  `item_type` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `item_id` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `item_module` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `item_title` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '0',
  `integrated` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`module_id`),
  UNIQUE KEY `item_type` (`item_type`),
  KEY `item_module` (`item_module`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;");

        $engine4DocumentRatings = $db->query("SHOW TABLES LIKE 'engine4_document_ratings'")->fetch();
        if ($engine4DocumentRatings) {
            if (!$this->_columnExist('engine4_document_ratings', 'resource_type')) {
                $db->query("ALTER  TABLE  engine4_document_ratings ADD COLUMN  `resource_type` varchar(255) DEFAULT NULl ;");
            }

            if (!$this->_columnExist('engine4_document_ratings', 'resource_id')) {
                $db->query("ALTER  TABLE  engine4_document_ratings ADD COLUMN  `resource_id` int(11) DEFAULT NULl ;");
            }
        }

        $isRowExist = $db->query('SELECT * FROM `engine4_core_menuitems` WHERE `name` LIKE \'document_bulk_import\' LIMIT 1')->fetch();
        if (empty($isRowExist)) {
            $db->query('INSERT INTO `engine4_core_menuitems` (`id`, `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES (NULL, "document_bulk_import", "document", "CSV Import", NULL, \'{"route":"admin_default","module":"document","controller":"import", "action":"index"}\', "document_admin_main", NULL, "1", "0", "995")');
        }

        $db->query("CREATE TABLE IF NOT EXISTS `engine4_document_fileimport` (
  `fileimport_id` int(11) NOT NULL AUTO_INCREMENT,  
  `filename` varchar(255) COLLATE latin1_swedish_ci NOT NULL,
  `status` varchar(32) COLLATE latin1_swedish_ci NOT NULL,
  `creation_date` datetime NOT NULL,
  `documentfilename` varchar(255) COLLATE latin1_swedish_ci ,
  `documentthumbnail` varchar(255) COLLATE latin1_swedish_ci ,
  `total_count` INT( 11 ) ,
  `table_name` varchar(255) COLLATE latin1_swedish_ci ,
  `profile_type` INT( 11 ) NOT NULL,
  PRIMARY KEY (`fileimport_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;");

        parent::onInstall();
    }

    function _columnExist($table, $column) {
        $db = $this->getDb();

        $columnName = $db->query("
        SHOW COLUMNS FROM `$table`
           LIKE '$column'")->fetch();
        if (!empty($columnName))
            return true;
        return false;
    }

    /*
     * SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL
     */

    public function onPostInstall() {
        $moduleName = 'document';
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES
('$moduleName','1')");
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_sitemobile_modules')
                    ->where('name = ?', $moduleName)
                    ->where('integrated = ?', 0);
            $is_sitemobile_object = $select->query()->fetchObject();
            if ($is_sitemobile_object) {
                $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
                $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
                if ($controllerName == 'manage' && $actionName == 'install') {
                    $view = new Zend_View();
                    $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/' . $moduleName . '/integrated/0/redirect/install');
                }
            }
        }
    }

    /*
     * Adding it for Nested Comment integration 
     */

    private function _setActivityFeeds() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'nestedcomment')
                ->where('enabled = ?', 1);
        $is_nestedcomment_object = $select->query()->fetchObject();
        if ($is_nestedcomment_object) {
            $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_document", "document", \'{item:$subject} replied to a comment on {item:$owner}\'\'s document {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
        }
    }

    /*
     * Adding for Suggestion Plugin integration
     */

    private function _setSuggestion() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'suggestion');
        $is_installed = $select->query()->fetchObject();
        if (!empty($is_installed)) {
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_gutter_suggest", "document", "Suggest to Friends", "Document_Plugin_Menus", "", "document_gutter", "", 1, 0, 6)');
        }

        return;
    }

    private function _doWeHaveOldDocument() {
        $db = $this->getDb();

        $errorMsg = '';
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'document' => '4.8.12'
        );

        $finalModules = array();
        foreach ($modArray as $key => $value) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')
                    ->where('name = ?', "$key");
            $isModEnabled = $select->query()->fetchObject();
            if (!empty($isModEnabled)) {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules', array('title', 'version'))
                        ->where('name = ?', "$key");
                $getModVersion = $select->query()->fetchObject();

                $running_version = $getModVersion->version;
                $product_version = $value;
                $isModSupport = $this->checkVersion($running_version, $product_version);
                if( empty($isModSupport) ) {
                  $finalModules[$key] = $getModVersion->title;
                }
            }
        }

        foreach ($finalModules as $modArray) {
            $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "' . $modArray . '".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }

  private function checkVersion($databaseVersion, $checkDependancyVersion)
  {
    $f = $databaseVersion;
    $s = $checkDependancyVersion;
    if( strcasecmp($f, $s) == 0 )
      return -1;

    $fArr = explode(".", $f);
    $sArr = explode('.', $s);
    if( count($fArr) <= count($sArr) )
      $count = count($fArr);
    else
      $count = count($sArr);

    for( $i = 0; $i < $count; $i++ ) {
      $fValue = $fArr[$i];
      $sValue = $sArr[$i];
      if( is_numeric($fValue) && is_numeric($sValue) ) {
        if( $fValue > $sValue )
          return 1;
        elseif( $fValue < $sValue )
          return 0;
        else {
          if( ($i + 1) == $count ) {
            return -1;
          } else
            continue;
        }
      }
      elseif( is_string($fValue) && is_numeric($sValue) ) {
        $fsArr = explode("p", $fValue);

        if( $fsArr[0] > $sValue )
          return 1;
        elseif( $fsArr[0] < $sValue )
          return 0;
        else {
          return 1;
        }
      } elseif( is_numeric($fValue) && is_string($sValue) ) {
        $ssArr = explode("p", $sValue);

        if( $fValue > $ssArr[0] )
          return 1;
        elseif( $fValue < $ssArr[0] )
          return 0;
        else {
          return 0;
        }
      } elseif( is_string($fValue) && is_string($sValue) ) {
        $fsArr = explode("p", $fValue);
        $ssArr = explode("p", $sValue);
        if( $fsArr[0] > $ssArr[0] )
          return 1;
        elseif( $fsArr[0] < $ssArr[0] )
          return 0;
        else {
          if( $fsArr[1] > $ssArr[1] )
            return 1;
          elseif( $fsArr[1] < $ssArr[1] )
            return 0;
          else {
            return -1;
          }
        }
      }
    }
  }

}
