<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_BrowseDocumentsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        //GET VIEWER ID
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $this->view->is_ajax = $isAjax = $this->_getParam('isajax', 0);
        $this->view->showContent = $this->_getParam('show_content', 2);
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));

        $this->view->layoutsViews = $layoutsViews = $this->_getParam('layoutsViews', array("1" => "1", "2" => "2"));
        $this->view->layoutsOrder = $layoutsOrder = $this->_getParam('layoutsOrder', 2);
        $this->view->countLayoutsViews = count($layoutsViews);
        $this->view->listView = 0;
        $this->view->gridView = 0;
        $this->view->params = array();
        if (in_array("1", $layoutsViews)) {
            $this->view->listView = 1;
            if ($layoutsOrder == 1)
                $this->view->defaultView = 0;
        }
        if (in_array("2", $layoutsViews)) {
            $this->view->gridView = 1;
            if ($layoutsOrder == 2)
                $this->view->defaultView = 1;
        }

        //START VIEW MORE LINK AND AUTOSCROLL CONTENT WORK
        if (!empty($isAjax)) {
            $this->getElement()->removeDecorator('Title');
            $this->getElement()->removeDecorator('Container');
        }
        //END VIEW MORE LINK AND AUTOSCROLL CONTENT WORK
        //GET USER LEVEL ID
        if (!empty($viewer_id)) {
            $level_id = $viewer->level_id;
        } else {
            $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }
        
        $documentBrowseDocuments = Zend_Registry::isRegistered('documentBrowseDocuments') ? Zend_Registry::get('documentBrowseDocuments') : null;
        if(empty($documentBrowseDocuments))
            return $this->setNoRender();

        //WHO CAN VIEW THE DOCUMENTS
        $can_view = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'view');
        if (empty($can_view)) {
            return $this->setNoRender();
        }

        //CHECK THAT VIEWER CAN Upload New Document
        $this->view->can_create = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'create');

        //CHECK THAT RATING IS VIEABLE OR NOT
        $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.rating', 1);
        $this->view->widgetSettings['show_rate'] = $this->view->show_rate;
        //FORM GENERATION
        $form = new Document_Form_Search();

//      if( $form->isValid($this->_getAllParams()) ) {
        if (!empty($_GET)) {
            $form->populate($_GET);
        }
        $values = $form->getValues();
//    } else {
//      $values = array();
//    }

        $values = array_merge($_GET, $values);

        $this->view->formValues = $values;

        if (empty($_GET['page'])) {
            $values['page'] = 1;
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $values['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $values['documentType'] = $values['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documentType = $values['documentType'];

        //GET USER IDS FOR SHOW DOCUMENT
        if (@$values['show'] == 2) {
            //FETCHING FRIENDS ID ARRAY
            $table = Engine_Api::_()->getItemTable('user');
            $select = $viewer->membership()->getMembersSelect('user_id');
            $friends = $table->fetchAll($select);

            $ids = array();
            foreach ($friends as $friend) {
                $ids[] = $friend->user_id;
            }
            $values['users'] = $ids;

            if (empty($values['users']) && $values['show'] == 2) {
                $values['owner_id'] = "0";
            }
        }

        if (isset($form->show) && $form->show->getValue() == 3 && !isset($_GET['show'])) {
            $values['show'] = 3;
        }

        $values['draft'] = "0";
        $values['status'] = "1";
        $values['approved'] = "1";

//    ADD CODE FOR MOBILE SITE CATEGORY AND TAG LINK REDIRECTION USING GET PARAMS METHOD
        $values['tag'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('tag', null);
        if (!empty($values['tag']))
            $_GET['tag'] = $values['tag'];

        if (isset($_GET['tag']) && !empty($_GET['tag'])) {
            $tag = $_GET['tag'];
            $_GET['tag'] = $tag;
        }
        //CATEGORY PARAMETER
        $values['category'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('category', null);
        if (!empty($values['category'])) {
            $this->view->params[ 'category'] = $values['category'];
            $_GET['category'] = $values['category'];
        }

        if (isset($_GET['category']) && !empty($_GET['category'])) {
            $category = $_GET['category'];
            $_GET['category'] = $category;
        }

        $values['category_id'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('category_id', null);
        if (!empty($values['category_id'])) {
            $this->view->params[ 'category_id'] = $values['category_id'];
            $_GET['category_id'] = $values['category_id'];
        }

        if (isset($_GET['category_id']) && !empty($_GET['category_id'])) {
            $category_id = $_GET['category_id'];
            $_GET['category_id'] = $category_id;
        }

        //SUB-CATEGORY PARAMETER
        $values['subcategory'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategory', null);
        if (!empty($values['subcategory'])) {
            $this->view->params[ 'subcategory'] = $values['subcategory'];
            $_GET['subcategory'] = $values['subcategory'];
        }

        if (isset($_GET['subcategory']) && !empty($_GET['subcategory'])) {
            $category = $_GET['subcategory'];
            $_GET['subcategory'] = $category;
        }

        $values['subcategory_id'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategory_id', null);
        if (!empty($values['subcategory_id'])) {
            $this->view->params[ 'subcategory_id'] = $values['subcategory_id'];
            $_GET['subcategory_id'] = $values['subcategory_id'];
        }

        if (isset($_GET['subcategory_id']) && !empty($_GET['subcategory_id'])) {
            $subcategory_id = $_GET['subcategory_id'];
            $_GET['subcategory_id'] = $subcategory_id;
        }

        //SUB-SUB-CATEGORY PARAMETER
        $values['subsubcategory'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subsubcategory', null);
        if (!empty($values['subsubcategory'])) {
            $this->view->params[ 'subsubcategory'] = $values['subsubcategory'];
            $_GET['subsubcategory'] = $values['subsubcategory'];
        }

        if (isset($_GET['subsubcategory']) && !empty($_GET['subsubcategory'])) {
            $subsubcategory = $_GET['subsubcategory'];
            $_GET['subsubcategory'] = $subsubcategory;
        }

        $values['subsubcategory_id'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subsubcategory_id', null);
        if (!empty($values['subsubcategory_id'])) {
            $this->view->params[ 'subsubcategory_id'] = $values['subsubcategory_id'];
            $_GET['subsubcategory_id'] = $values['subsubcategory_id'];
        }

        if (isset($_GET['subsubcategory_id']) && !empty($_GET['subsubcategory_id'])) {
            $subsubcategory_id = $_GET['subsubcategory_id'];
            $_GET['subsubcategory_id'] = $subsubcategory_id;
        }
        //END


        $values['categoryname'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('categoryname', null);
        if (!empty($values['categoryname'])) {
            $this->view->params[ 'categoryname'] = $values['categoryname'];
            $_GET['categoryname'] = $values['categoryname'];
        }

        $values['subcategoryname'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategoryname', null);
        if (!empty($values['subcategoryname'])) {
            $this->view->params[ 'subcategoryname'] = $values['subcategoryname'];
            $_GET['subcategoryname'] = $values['subcategoryname'];
        }

        $values['subsubcategoryname'] = Zend_Controller_Front::getInstance()->getRequest()->getParam('subsubcategoryname', null);
        if (!empty($values['subsubcategoryname'])) {
            $this->view->params[ 'subsubcategoryname'] = $values['subsubcategoryname'];
            $_GET['subsubcategoryname'] = $values['subsubcategoryname'];
        }

        $values['searchable'] = "1";
        if (!isset($_GET['orderby'])) {
            $this->view->orderby = $values['orderby'] = $this->_getParam('orderby', 'document_id');
        } elseif (isset($_GET['orderby']) && !empty($_GET['orderby'])) {
            $values['orderby'] = $_GET['orderby'];
        }
        $this->view->assign($values);

        //GET DOCUMENT TABLE
        $tableDocument = Engine_Api::_()->getDbtable('documents', 'document');

        $customFieldValues = array_intersect_key($values, $form->getFieldElements());

        if (!empty($values['category_id'])) {
            $this->view->category = $values['category_id'];
        } else {
            $this->view->category = $values['category'];
        }

        $values['network_based_content'] = 1;
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $values['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $values['documentType'] = $this->_getParam('documentType', 'All');
        }

        //GET PAGINATOR
        $this->view->paginator = $paginator = $tableDocument->getDocumentsPaginator($values, $customFieldValues);
        $this->view->totalCount = $paginator->getTotalItemCount();
        $this->view->total_count = $total_documents = $this->_getParam('itemCount', 10);
        $this->view->paginator->setItemCountPerPage($total_documents);
        $this->view->paginator->setCurrentPageNumber($values['page']);
    }

}
