<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_ContenttypedocumentsController extends Engine_Content_Widget_Abstract {

    protected $_childCount;

    public function indexAction() {
        //DONT RENDER THIS IF NOT AUTHORIZED
        $viewer = Engine_Api::_()->user()->getViewer();

        if (!Engine_Api::_()->core()->hasSubject()) {
            return $this->setNoRender();
        }
        $this->view->layoutsViews = $layoutsViews = $this->_getParam('layoutsViews', array("1" => "1", "2" => "2"));
        $this->view->layoutsOrder = $layoutsOrder = $this->_getParam('layoutsOrder', 2);
        $this->view->is_ajax = $isAjax = $this->_getParam('isajax', 0);
        $this->view->countLayoutsViews = count($layoutsViews);
        $this->view->listView = 0;
        $this->view->gridView = 0;
        if (in_array("1", $layoutsViews)) {
            $this->view->listView = 1;
            if ($layoutsOrder == 1)
                $this->view->defaultView = 0;
        }
        if (in_array("2", $layoutsViews)) {
            $this->view->gridView = 1;
            if ($layoutsOrder == 2)
                $this->view->defaultView = 1;
        }
        //GET VIEWER INFORMATION
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
        if (!empty($viewer_id)) {
            $this->view->level_id = $level_id = $viewer->level_id;
        } else {
            $this->view->level_id = $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }
        $subject = Engine_Api::_()->core()->getSubject();
        $this->view->subjectIdentity = $subjectIdentity = $subject->getIdentity();
        $this->view->subjectType = $subjectType = $subject->getType();
        $this->view->moduleName = $moduleName = strtolower($subject->getModuleName());
        $this->view->getShortType = $getShortType = ucfirst($subject->getShortType());
        //VIEW, EDIT, DELETE AND PROFILE DOCUMENT CHECKS FOR DOCUMENT
        $this->view->can_view = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'view');
        $this->view->can_edit = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'edit');
        $this->view->can_delete = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'delete');
        $this->view->can_profile_doc = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'profile_doc');
        $this->view->widgetSettings = $this->view->allParams = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        $documentContentTypeDocuments = Zend_Registry::isRegistered('documentContentTypeDocuments') ? Zend_Registry::get('documentContentTypeDocuments') : null;
        if(empty($documentContentTypeDocuments))
            return $this->setNoRender();

        if ($this->_getParam('widgetSettings')) {
            $this->view->widgetSettings = $this->_getParam('widgetSettings');
        }

        //GET SEARCHING PARAMETERS
        $this->view->page = $page = $this->_getParam('page', 1);
        $this->view->total_count = $total_count = $this->_getParam('itemCount', 10);
        $this->view->showContent = $this->_getParam('show_content', 2);
        $values = array();


        if (isset($subject->owner_id)) {
            $this->view->user_id = $user_id = $subject->owner_id;
        } else if (isset($subject->user_id)) {
            $this->view->user_id = $user_id = $subject->user_id;
        }
        $this->view->can_edit = Engine_Api::_()->document()->isEditPrivacy($subject->getType(), $subject->getIdentity(), $subject);
        $this->view->can_delete = Engine_Api::_()->document()->canDeletePrivacy($subject->getType(), $subject->getIdentity(), $subject);

        //DOCUMENT TABLE
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');

        //MAKE FEATURED/UN-FEATURED IS ALLOWED OR NOT
        $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.featured', 1);

        //CHECK THAT RATING IS VIEABLE OR NOT
        $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.rating', 1);

        //FETCH DOCUMENTS
        $values['parent_type'] = $subjectType;
        $values['parent_id'] = $subjectIdentity;

        if ($moduleName == 'sitereview' && isset($subject->listingtype_id)) {
            if (!(Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitereview_listing_' . $subject->listingtype_id, 'item_module' => 'sitereview', 'checked' => 'enabled'))))
                return $this->setNoRender();
        } else {
            if (!(Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => $subject->getType(), 'item_module' => strtolower($subject->getModuleName()), 'checked' => 'enabled'))))
                return $this->setNoRender();
        }

        if ($moduleName == 'sitepage' || $moduleName == 'sitebusiness' || $moduleName == 'sitegroup' || $moduleName == 'sitestore') {
            $this->view->user_layout = $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting($moduleName . '.layoutcreate', 0);
            $isModuleOwnerAllow = 'is' . $getShortType . 'OwnerAllow';
            $this->_childCount = $this->view->documentCount = Engine_Api::_()->$moduleName()->getTotalCount($subject->getIdentity(), 'document', 'documents');

            //START PACKAGE WORK
            if (Engine_Api::_()->$moduleName()->hasPackageEnable()) {

                if (!Engine_Api::_()->$moduleName()->allowPackageContent($subject->package_id, "modules", $moduleName . 'document')) {
                    return $this->setNoRender();
                }
            } else {
                $isOwnerAllow = Engine_Api::_()->$moduleName()->$isModuleOwnerAllow($subject, 'sdcreate');

                if (empty($isOwnerAllow)) {
                    return $this->setNoRender();
                }
            }
            //END PACKAGE WORK

            $this->view->canCreate = $canCreate = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'sdcreate');

            //START MANAGE-ADMIN CHECK
            $isManageAdmin = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'view');
            if (empty($isManageAdmin)) {
                return $this->setNoRender();
            }

            $isManageAdmin = Engine_Api::_()->$moduleName()->isManageAdmin($subject, 'edit');

            if (empty($isManageAdmin)) {
                $this->view->can_edit = $can_edit = 0;
            } else {
                $this->view->can_edit = $can_edit = 1;
            }

            if (empty($canCreate) && empty($this->view->documentCount) && empty($can_edit) && !(Engine_Api::_()->$moduleName()->showTabsWithoutContent())) {
                return $this->setNoRender();
            }
        } else if ($moduleName == 'siteevent') {
            $this->view->user_layout = 0;
            $this->view->can_edit = $can_edit = $subject->authorization()->isAllowed($viewer, "edit");
            $this->_childCount = $this->view->documentCount = Engine_Api::_()->$moduleName()->getTotalCount($subject->getIdentity(), 'document', 'documents');
            //AUTHORIZATION CHECK
            $this->view->canCreate = $canCreate = Engine_Api::_()->authorization()->isAllowed($subject, $viewer, 'document');

            if (empty($canCreate) && empty($this->view->documentCount) && empty($can_edit)) {
                return $this->setNoRender();
            }
        } else if ($moduleName == 'sitereview') {
            $this->view->user_layout = 0;
            //AUTHORIZATION CHECK
            $table = Engine_Api::_()->getDbtable('documents', 'document');

            $this->_childCount = $this->view->documentCount = $count = $table
                    ->select()
                    ->from($table->info('name'), array('count(*) as count'))
                    ->where("parent_type = ?", 'sitereview_listing_' . $subject->listingtype_id)
                    ->where("parent_id =?", $subject->getIdentity())
                    ->query()
                    ->fetchColumn();

            $this->view->canCreate = $canCreate = $subject->authorization()->isAllowed($viewer, "doc_listtype_$subject->listingtype_id");
            $this->view->can_edit = $can_edit = $subject->authorization()->isAllowed($viewer, "edit_listtype_$subject->listingtype_id");

            if (empty($canCreate) && empty($this->view->documentCount) && empty($can_edit)) {
                return $this->setNoRender();
            }

            $values['parent_type'] = $this->view->subjectType = $subjectType = 'sitereview_listing_' . $subject->listingtype_id;
            $values['parent_id'] = $subject->getIdentity();
        } else if ($moduleName == 'event') {
            $this->view->canCreate = $canCreate = Engine_Api::_()->authorization()->isAllowed($subject, $viewer, 'edcreate');
        } else if ($moduleName == 'group') {
            $this->view->canCreate = $canCreate = Engine_Api::_()->authorization()->isAllowed($subject, $viewer, 'gdcreate');
        }

        $this->view->paginator = $paginator = $documentTable->getDocumentsPaginator($values);

        //10 DOCUMENTS PER PAGE
        $paginator->setItemCountPerPage($total_count);
        $this->view->paginator->setCurrentPageNumber($page);
        $this->view->totalCount = $paginator->getTotalItemCount();
        //ADD NUMBER OF DOCUMENTS IN TAB
        if ($this->view->totalCount > 0) {
            $this->_childCount = $this->view->totalCount;
        }
    }

    public function getChildCount() {
        return $this->_childCount;
    }

}
