<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_NavigationDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //GET VIEWER DETAILS
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        //GET LEVEL ID
        if (!empty($viewer_id)) {
            $level_id = $viewer->level_id;
        } else {
            $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }

        //WHO CAN VIEW THE DOCUMENTS
        $documentNavigationDocuments = Zend_Registry::isRegistered('documentNavigationDocuments') ? Zend_Registry::get('documentNavigationDocuments') : null;
        
        $can_view = Engine_Api::_()->authorization()->getPermission($level_id, 'document', 'view');
        if (empty($can_view) || empty($documentNavigationDocuments)) {
            return $this->setNoRender();
        }

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_main');
    }

}
