<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_RecentDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        //FETCH DOCUMENTS
        $params = array();
        $params['limit'] = $this->_getParam('itemCount', 3);
        $params['category_id'] = $this->_getParam('category_id');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documentType = $params['documentType'];
        $documentRecentDocuments = Zend_Registry::isRegistered('documentRecentDocuments') ? Zend_Registry::get('documentRecentDocuments') : null;
        $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'document')->widgetDocumentsData($params);

        if(empty($documentRecentDocuments))
            return $this->setNoRender();
        
        if (Count($this->view->paginator) <= 0) {
            return $this->setNoRender();
        }
    }

}

?>