<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_SpecialDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        $starttime = $this->_getParam('starttime');
        $endtime = $this->_getParam('endtime');
        $currenttime = date('Y-m-d H:i:s');

        if (!empty($starttime) && $currenttime < $starttime) {
            return $this->setNoRender();
        }

        if (!empty($endtime) && $currenttime > $endtime) {
            return $this->setNoRender();
        }

        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));
        $params = array();
        $params['document_ids'] = $this->_getParam('toValues', array());

        if (!empty($params['document_ids'])) {
            $params['document_ids'] = explode(',', $params['document_ids']);
            $params['document_ids'] = array_unique($params['document_ids']);

            if (!empty($params['document_ids']) && Count($params['document_ids']) <= 0) {
                return $this->setNoRender();
            }
        } else {
            return $this->setNoRender();
        }

        $params['limit'] = $this->_getParam('itemCount');
        $this->view->itemCount = $params['limit'];

        $documentSpecialDocuments = Zend_Registry::isRegistered('documentSpecialDocuments') ? Zend_Registry::get('documentSpecialDocuments') : null;
        $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'document')->widgetDocumentsData($params);

        if(empty($documentSpecialDocuments))
            return $this->setNoRender();
        
        if (Count($this->view->paginator) <= 0) {
            return $this->setNoRender();
        }
    }

}
