<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Document
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Document_Widget_SponsoredDocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        //FETCH DOCUMENTS DATA
        $params = array();
        $params['sponsored'] = 1;
        $this->view->category_id = $params['category_id'] = $this->_getParam('category_id', 0);
        $this->view->interval = $this->_getParam('interval', 300);
        $this->view->titletruncation = $this->_getParam('truncation', 18);
        $this->view->widgetSettings = $this->_getAllParams();
        //in_array function gives warning if we document option do not come form settings, so used default params
        $this->view->widgetSettings['documentOption'] = $this->_getParam('documentOption', array('title', 'owner', 'featured', 'sponsored', 'view', 'like', 'comment', 'rating', 'likeButton', 'facebook', 'twitter', 'linkedin', 'googleplus'));

        //GET DOCUMENT TABLE
        $documentTable = Engine_Api::_()->getDbtable('documents', 'document');

        //GET SPONSORED DOCUMENTS COUNT
        $totalDocument = $documentTable->widgetDocumentsData($params);

        //DOCUMENTS LIMIT
        $this->view->limit = $params['limit'] = $this->_getParam('itemCount', 1);

        //NO RENDER IF SPONSORED DOCUMENTS ARE ZERO
        $this->view->totalSponsoredDocuments = Count($totalDocument);
        if (($this->view->totalSponsoredDocuments <= 0)) {
            return $this->setNoRender();
        }
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['documentType'] = $contentType = $request->getParam('documentType', null);
        if (empty($contentType)) {
            $params['documentType'] = $this->_getParam('documentType', 'All');
        }
        $this->view->documentType = $params['documentType'];
        //SEND DOCUMENT DATA TO TPL
        $this->view->documents = $documentTable->widgetDocumentsData($params);
        $documentSponsoredDocuments = Zend_Registry::isRegistered('documentSponsoredDocuments') ? Zend_Registry::get('documentSponsoredDocuments') : null;
        if(empty($documentSponsoredDocuments))
            return $this->setNoRender();
    }

}
