<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Documentintegration
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminImportdocumentController.php 6590 2015-1-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$settings = Engine_Api::_()->getApi('settings', 'core');

$scribd_api_key = $settings->getSetting('document.api.key', $settings->getSetting('sitepagedocument.api.key', $settings->getSetting('sitebusinessdocument.api.key', $settings->getSetting('sitegroupdocument.api.key', $settings->getSetting('sitestoredocument.api.key', $settings->getSetting('siteeventdocument.api.key'))))));

$scribd_secret = $settings->getSetting('document.secret.key', $settings->getSetting('sitepagedocument.secret.key', $settings->getSetting('sitebusinessdocument.secret.key', $settings->getSetting('sitegroupdocument.secret.key', $settings->getSetting('sitestoredocument.secret.key', $settings->getSetting('siteeventdocument.secret.key'))))));
if ($scribd_api_key && $scribd_secret) {
    include_once APPLICATION_PATH . '/application/modules/Document/Api/Scribd.php';
}

include_once APPLICATION_PATH . '/application/modules/Document/Api/GDSEMedia.php';

class Documentintegration_AdminImportdocumentController extends Core_Controller_Action_Admin {

    protected $_document_google_email;
    protected $_document_client_id;
    protected $_document_service_account_name;
    protected $_document_private_key_url_path;
    protected $_GDSEMedia;

    //COMMON ACTION WHICH CALL BEFORE EVERY ACTION OF THIS CONTROLLER
    public function init() {

        $coreApi = Engine_Api::_()->document();

        $document_google_email = $this->_document_google_email = $coreApi->getGoogleEmail();
        $document_client_id = $this->_document_client_id = $coreApi->getGoogleClientId();
        $getGoogleClientSecretKey = $this->_getGoogleClientSecretKey = $coreApi->getGoogleClientSecretKey();
        $document_hide_old_fields = Engine_Api::_()->getApi('settings', 'core')->getSetting('document.hide.old.fields', 0);
        if ($document_hide_old_fields) {
            $this->_GDSEMedia = new GDSEMedia($document_client_id, null, null, $getGoogleClientSecretKey);
        } else {
            $document_service_account_name = $this->_document_service_account_name = $coreApi->getGoogleServiceAccountName();
            $document_private_key_url_path = $this->_document_private_key_url_path = $coreApi->getPrivateKeyUrl();
            if ($document_google_email && $document_client_id && $document_service_account_name && $document_private_key_url_path) {
                $this->_GDSEMedia = new GDSEMedia($document_client_id, $document_service_account_name, $document_private_key_url_path);
            }
        }

        $settings = Engine_Api::_()->getApi('settings', 'core');


        $this->scribd_api_key = $settings->getSetting('document.api.key', $settings->getSetting('sitepagedocument.api.key', $settings->getSetting('sitebusinessdocument.api.key', $settings->getSetting('sitegroupdocument.api.key', $settings->getSetting('sitestoredocument.api.key', $settings->getSetting('siteeventdocument.api.key'))))));

        $this->scribd_secret = $settings->getSetting('document.secret.key', $settings->getSetting('sitepagedocument.secret.key', $settings->getSetting('sitebusinessdocument.secret.key', $settings->getSetting('sitegroupdocument.secret.key', $settings->getSetting('sitestoredocument.secret.key', $settings->getSetting('siteeventdocument.secret.key'))))));


        if ($this->scribd_api_key && $this->scribd_secret) {
            $this->scribd = new Scribd($this->scribd_api_key, $this->scribd_secret);
        }
    }

    //ACTION FOR SHOWING IMPORT INSTRUCTIONS
    public function indexAction() {
        global $gdsem_apiConfig;
        //GET VIEWER DETAILS
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $level_id = $viewer->level_id;

        $download_format = 'pdf';

        $folderId = $this->_GDSEMedia->getFolder($viewer->email . '-' . $viewer_id);

        $this->_GDSEMedia->setPermissions($folderId, $this->_document_google_email);
        $fileParent = new Google_ParentReference();
        $fileParent->setId($folderId);

        //INCREASE THE MEMORY ALLOCATION SIZE AND INFINITE SET TIME OUT
        ini_set('memory_limit', '2048M');
        set_time_limit(0);
        ini_set('upload_max_filesize', '100M');
        ini_set('post_max_size', '100M');
        ini_set('max_input_time', 600);
        ini_set('max_execution_time', 600);

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('document_admin_main', array(), 'document_admin_main_import');

        $this->view->subNavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('document_admin_main_import', array(), 'document_admin_main_importdocument');

        //START CODE FOR CREATING THE DocumentToDocumentImport.log FILE
        if (!file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
            $log = new Zend_Log();
            try {
                $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log'));
            } catch (Exception $e) {
                //CHECK DIRECTORY
                if (!@is_dir(APPLICATION_PATH . '/temporary/log') && @mkdir(APPLICATION_PATH . '/temporary/log', 0777, true)) {
                    $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log'));
                } else {
                    //Silence ...
                    if (APPLICATION_ENV !== 'production') {
                        $log->log($e->__toString(), Zend_Log::CRIT);
                    } else {
                        //MAKE SURE LOGGING DOESN'T CAUSE EXCEPTIONS
                        $log->addWriter(new Zend_Log_Writer_Null());
                    }
                }
            }
        }

        //GIVE WRITE PERMISSION IF FILE EXIST
        if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
            @chmod(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log', 0777);
        }

        $documentTable = Engine_Api::_()->getDbTable('documents', 'document');
        $documentTableName = $documentTable->info('name');

        $documentratingsTable = Engine_Api::_()->getDbTable('ratings', 'document');
        $documentratingsTableName = $documentratingsTable->info('name');

        $streamTable = Engine_Api::_()->getDbTable('stream', 'activity');

        $attachmentsTable = Engine_Api::_()->getDbtable('attachments', 'activity');
        $attachmentsTableName = $attachmentsTable->info('name');

        //GET STORAGE TABLE
        $storageTable = Engine_Api::_()->getDbtable('files', 'storage');

        //GET CORE LIKE TABLES
        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        $likeTableName = $likeTable->info('name');

        //GET CORE COMMENT TABLES
        $commentTable = Engine_Api::_()->getDbtable('comments', 'core');
        $commentTableName = $commentTable->info('name');

        //GET TAGMAPS TABLE
        $tagmapsTable = Engine_Api::_()->getDbtable('TagMaps', 'core');
        $tagmapsTableName = $tagmapsTable->info('name');

        //GET STYLE TABLES
        $stylesTable = Engine_Api::_()->getDbtable('styles', 'core');
        $stylesTableName = $stylesTable->info('name');

        //GET ACTIONS TABLE
        $actionsTable = Engine_Api::_()->getDbtable('actions', 'activity');
        $actionsTableName = $actionsTable->info('name');

        $this->view->first_eventdocument_id = $first_eventdocument_id = 0;
        $this->view->last_eventdocument_id = $last_eventdocument_id = 0;
        $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');
        $this->view->eventDocumentEnabled = $eventDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('eventdocument');

        if ($eventDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'event', 'item_module' => 'event')))) {
            $eventdocumentTable = Engine_Api::_()->getDbTable('documents', 'eventdocument');
            $eventdocumentTableName = $eventdocumentTable->info('name');

            $eventdocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'eventdocument');
            $eventdocumentratingsTableName = $eventdocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_eventdocument_import = $db->query("SHOW COLUMNS FROM engine4_eventdocument_documents LIKE 'is_eventdocument_import'")->fetch();
            if (empty($is_eventdocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_eventdocument_documents` ADD is_eventdocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $eventdocumentTable->select()
                    ->from($eventdocumentTableName, 'document_id')
                    ->where('is_eventdocument_import != ?', 1)
                    ->order('document_id ASC');
            $eventdocumentDatas = $eventdocumentTable->fetchAll($selectEventDocuments);

            if (!empty($eventdocumentDatas)) {

                $flag_first_eventdocument_id = 1;

                foreach ($eventdocumentDatas as $eventdocumentData) {

                    if ($flag_first_eventdocument_id == 1) {
                        $this->view->first_eventdocument_id = $first_eventdocument_id = $eventdocumentData->document_id;
                    }
                    $flag_first_eventdocument_id++;

                    $this->view->last_eventdocument_id = $last_eventdocument_id = $eventdocumentData->document_id;
                }

                if (isset($_GET['eventdocument_assigned_previous_id'])) {
                    $this->view->eventdocument_assigned_previous_id = $eventdocument_assigned_previous_id = $_GET['eventdocument_assigned_previous_id'];
                } else {
                    $this->view->eventdocument_assigned_previous_id = $eventdocument_assigned_previous_id = $first_eventdocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'eventdocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_eventdocument = $this->_getParam('activity_eventdocument');

                    $selectEventDocuments = $eventdocumentTable->select()
                            ->where('document_id >= ?', $eventdocument_assigned_previous_id)
                            ->from($eventdocumentTableName, 'document_id')
                            ->where('is_eventdocument_import != ?', 1)
                            ->order('document_id ASC');
                    $eventdocumentDatas = $eventdocumentTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $eventdocumentDatasArray = $eventdocumentDatas->toArray();
                    if ($eventdocumentDatasArray) {
                        foreach ($eventdocumentDatas as $eventdocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $eventdocument_id = $eventdocumentData->document_id;
                                if (!empty($eventdocument_id)) {
                                    $eventdocument = Engine_Api::_()->getItem('eventdocument_document', $eventdocument_id);
                                    $event = Engine_Api::_()->getItem('event', $eventdocument->event_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $eventdocument->title;
                                    $document->document_description = $eventdocument->description;
                                    $document->owner_id = $eventdocument->owner_id;
                                    $document->owner_type = $eventdocument->owner_type;
                                    $document->parent_type = 'event';
                                    $document->parent_id = $eventdocument->event_id;
                                    $document->creation_date = $eventdocument->creation_date;
                                    $document->modified_date = $eventdocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $eventdocument->creation_date;
                                    $document->modified_date = $eventdocument->modified_date;
                                    $document->views = 1;
                                    if ($eventdocument->view_count > 0) {
                                        $document->views = $eventdocument->view_count;
                                    }
                                    $document->search = $eventdocument->search;
                                    $document->featured = $eventdocument->featured;
                                    $document->filename_id = $eventdocument->filename_id;
                                    $document->storage_path = $eventdocument->storage_path;
                                    $document->document_license = $eventdocument->license;
                                    $document->document_private = $eventdocument->private;
                                    $document->filemime = $eventdocument->filemime;
                                    $document->filesize = $eventdocument->filesize;
                                    $document->doc_id = $eventdocument->doc_id;
                                    $document->secret_password = $eventdocument->secret_password;
                                    $document->access_key = $eventdocument->access_key;
                                    $document->fulltext = $eventdocument->fulltext;
                                    $document->comment_count = $eventdocument->comment_count;
                                    $document->like_count = $eventdocument->like_count;
                                    $document->rating = $eventdocument->rating;
                                    $document->email_allow = $eventdocument->email_allow;
                                    $document->download_allow = $eventdocument->download_allow;
                                    $document->secure_allow = $eventdocument->secure_allow;
                                    $document->draft = $eventdocument->draft;

                                    $document->approved = $eventdocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $eventdocument->activity_feed;
                                    $document->save();

                                    $this->scribd->my_user_id = $document->owner_id;
                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    //$gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    //$document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $eventdocument->is_eventdocument_import = 1;
                                    $eventdocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($event, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($event, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($event, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'eventdocument_document')
                                            ->where('resource_id = ?', $eventdocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'eventdocument_document')
                                            ->where('resource_id = ?', $eventdocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $eventdocumentratingsTable->select()
                                            ->from($eventdocumentratingsTableName, '*')
                                            ->where('document_id = ?', $eventdocument_id)
                                    ;
                                    $selectEventdocumentRatingDatas = $eventdocumentratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'eventdocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_eventdocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'event')
                                            ->where('object_id = ?', $event->getIdentity())
                                            ->where('type =?', 'eventdocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'eventdocument_document')
                                            ->where('object_id = ?', $eventdocument_id)
                                            ->where('type =?', 'like_eventdocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'eventdocument_document', 'id =?' => $eventdocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $eventdocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'eventdocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'eventdocument.profile-eventdocuments'));

                                $db->commit();
                                $this->view->eventdocument_assigned_previous_id = $eventdocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=eventdocument&recall=1&activity_eventdocument=$activity_eventdocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_groupdocument_id = $first_groupdocument_id = 0;
        $this->view->last_groupdocument_id = $last_groupdocument_id = 0;

        $this->view->groupDocumentEnabled = $groupDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('groupdocument');

        if ($groupDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'group', 'item_module' => 'group')))) {
            $groupdocumentTable = Engine_Api::_()->getDbTable('documents', 'groupdocument');
            $groupdocumentTableName = $groupdocumentTable->info('name');

            $groupdocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'groupdocument');
            $groupdocumentratingsTableName = $groupdocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_groupdocument_import = $db->query("SHOW COLUMNS FROM engine4_groupdocument_documents LIKE 'is_groupdocument_import'")->fetch();
            if (empty($is_groupdocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_groupdocument_documents` ADD is_groupdocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectGroupDocuments = $groupdocumentTable->select()
                    ->from($groupdocumentTableName, 'document_id')
                    ->where('is_groupdocument_import != ?', 1)
                    ->order('document_id ASC');
            $groupdocumentDatas = $groupdocumentTable->fetchAll($selectGroupDocuments);

            if (!empty($groupdocumentDatas)) {

                $flag_first_groupdocument_id = 1;

                foreach ($groupdocumentDatas as $groupdocumentData) {

                    if ($flag_first_groupdocument_id == 1) {
                        $this->view->first_groupdocument_id = $first_groupdocument_id = $groupdocumentData->document_id;
                    }
                    $flag_first_groupdocument_id++;

                    $this->view->last_groupdocument_id = $last_groupdocument_id = $groupdocumentData->document_id;
                }

                if (isset($_GET['groupdocument_assigned_previous_id'])) {
                    $this->view->groupdocument_assigned_previous_id = $groupdocument_assigned_previous_id = $_GET['groupdocument_assigned_previous_id'];
                } else {
                    $this->view->groupdocument_assigned_previous_id = $groupdocument_assigned_previous_id = $first_groupdocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'groupdocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_groupdocument = $this->_getParam('activity_groupdocument');

                    $selectGroupDocuments = $groupdocumentTable->select()
                            ->where('document_id >= ?', $groupdocument_assigned_previous_id)
                            ->from($groupdocumentTableName, 'document_id')
                            ->where('is_groupdocument_import != ?', 1)
                            ->order('document_id ASC');
                    $groupdocumentDatas = $groupdocumentTable->fetchAll($selectGroupDocuments);

                    $next_import_count = 0;
                    $groupdocumentDatasArray = $groupdocumentDatas->toArray();
                    if ($groupdocumentDatasArray) {
                        foreach ($groupdocumentDatas as $groupdocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $groupdocument_id = $groupdocumentData->document_id;
                                if (!empty($groupdocument_id)) {
                                    $groupdocument = Engine_Api::_()->getItem('groupdocument_document', $groupdocument_id);
                                    $group = Engine_Api::_()->getItem('group', $groupdocument->group_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $groupdocument->groupdocument_title;
                                    $document->document_description = $groupdocument->groupdocument_description;
                                    $document->owner_id = $groupdocument->owner_id;
                                    $document->owner_type = $groupdocument->owner_type;
                                    $document->parent_type = 'group';
                                    $document->parent_id = $groupdocument->group_id;
                                    $document->creation_date = $groupdocument->creation_date;
                                    $document->modified_date = $groupdocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $groupdocument->creation_date;
                                    $document->modified_date = $groupdocument->modified_date;
                                    $document->views = 1;
                                    if ($groupdocument->views > 0) {
                                        $document->views = $groupdocument->views;
                                    }
                                    $document->search = $groupdocument->search;
                                    $document->featured = $groupdocument->featured;
                                    $document->filename_id = $groupdocument->filename_id;
                                    $document->storage_path = $groupdocument->storage_path;
                                    // $document->document_license = $groupdocument->license;
                                    // $document->document_private = $groupdocument->private;
                                    $document->filemime = $groupdocument->filemime;
                                    $document->filesize = $groupdocument->filesize;
                                    $document->doc_id = $groupdocument->doc_id;
                                    $document->secret_password = $groupdocument->secret_password;
                                    $document->access_key = $groupdocument->access_key;
                                    $document->fulltext = $groupdocument->fulltext;
                                    $document->comment_count = $groupdocument->comment_count;
                                    $document->like_count = $groupdocument->like_count;
                                    $document->rating = $groupdocument->rating;
                                    $document->email_allow = $groupdocument->email_allow;
                                    $document->download_allow = $groupdocument->download_allow;
                                    $document->secure_allow = $groupdocument->secure_allow;
                                    $document->draft = $groupdocument->draft;

                                    $document->approved = $groupdocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $groupdocument->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    //$gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    // $document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $groupdocument->is_groupdocument_import = 1;
                                    $groupdocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesGroupDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesGroupDocuments as $rolesGroupDocument) {

                                        if ($auth->isAllowed($group, $rolesGroupDocument, 'view')) {
                                            $values['auth_view'] = $rolesGroupDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($group, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($group, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'groupdocument_document')
                                            ->where('resource_id = ?', $groupdocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'groupdocument_document')
                                            ->where('resource_id = ?', $groupdocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectGroupdocumentRating = $groupdocumentratingsTable->select()
                                            ->from($groupdocumentratingsTableName, '*')
                                            ->where('document_id = ?', $groupdocument_id);
                                    $selectGroupdocumentRatingDatas = $groupdocumentratingsTable->fetchAll($selectGroupdocumentRating);
                                    $selectGroupdocumentRatingDatas = $selectGroupdocumentRatingDatas->toArray();
                                    foreach ($selectGroupdocumentRatingDatas as $selectGroupdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'groupdocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectGroupdocumentRatingData['user_id'],
                                            'rating' => $selectGroupdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_groupdocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'group')
                                            ->where('object_id = ?', $group->getIdentity())
                                            ->where('type =?', 'groupdocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'groupdocument_document')
                                            ->where('object_id = ?', $groupdocument_id)
                                            ->where('type =?', 'like_groupdocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'groupdocument_document', 'id =?' => $groupdocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Group Document with ID ') . $groupdocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'groupdocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'groupdocument.profile-groupdocuments'));

                                $db->commit();
                                $this->view->groupdocument_assigned_previous_id = $groupdocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=groupdocument&recall=1&activity_groupdocument=$activity_groupdocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_sitepagedocument_id = $first_sitepagedocument_id = 0;
        $this->view->last_sitepagedocument_id = $last_sitepagedocument_id = 0;

        $this->view->sitepageDocumentEnabled = $sitepageDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepagedocument');

        if ($sitepageDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitepage_page', 'item_module' => 'sitepage')))) {
            $sitepagedocumentTable = Engine_Api::_()->getDbTable('documents', 'sitepagedocument');
            $sitepagedocumentTableName = $sitepagedocumentTable->info('name');

            $sitepagedocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitepagedocument');
            $sitepagedocumentratingsTableName = $sitepagedocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitepagedocument_import = $db->query("SHOW COLUMNS FROM engine4_sitepagedocument_documents LIKE 'is_sitepagedocument_import'")->fetch();
            if (empty($is_sitepagedocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitepagedocument_documents` ADD is_sitepagedocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $sitepagedocumentTable->select()
                    ->from($sitepagedocumentTableName, 'document_id')
                    ->where('is_sitepagedocument_import != ?', 1)
                    ->order('document_id ASC');
            $sitepagedocumentDatas = $sitepagedocumentTable->fetchAll($selectEventDocuments);

            if (!empty($sitepagedocumentDatas)) {

                $flag_first_sitepagedocument_id = 1;

                foreach ($sitepagedocumentDatas as $sitepagedocumentData) {

                    if ($flag_first_sitepagedocument_id == 1) {
                        $this->view->first_sitepagedocument_id = $first_sitepagedocument_id = $sitepagedocumentData->document_id;
                    }
                    $flag_first_sitepagedocument_id++;

                    $this->view->last_sitepagedocument_id = $last_sitepagedocument_id = $sitepagedocumentData->document_id;
                }

                if (isset($_GET['sitepagedocument_assigned_previous_id'])) {
                    $this->view->sitepagedocument_assigned_previous_id = $sitepagedocument_assigned_previous_id = $_GET['sitepagedocument_assigned_previous_id'];
                } else {
                    $this->view->sitepagedocument_assigned_previous_id = $sitepagedocument_assigned_previous_id = $first_sitepagedocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitepagedocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_sitepagedocument = $this->_getParam('activity_sitepagedocument');

                    $selectEventDocuments = $sitepagedocumentTable->select()
                            ->where('document_id >= ?', $sitepagedocument_assigned_previous_id)
                            ->from($sitepagedocumentTableName, 'document_id')
                            ->where('is_sitepagedocument_import != ?', 1)
                            ->order('document_id ASC');
                    $sitepagedocumentDatas = $sitepagedocumentTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $sitepagedocumentDatasArray = $sitepagedocumentDatas->toArray();
                    if ($sitepagedocumentDatasArray) {
                        foreach ($sitepagedocumentDatas as $sitepagedocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitepagedocument_id = $sitepagedocumentData->document_id;
                                if (!empty($sitepagedocument_id)) {
                                    $sitepagedocument = Engine_Api::_()->getItem('sitepagedocument_document', $sitepagedocument_id);
                                    $sitepage = Engine_Api::_()->getItem('sitepage_page', $sitepagedocument->page_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $sitepagedocument->sitepagedocument_title;
                                    $document->document_description = $sitepagedocument->sitepagedocument_description;
                                    $document->owner_id = $sitepagedocument->owner_id;
                                    $document->owner_type = 'user';
                                    $document->parent_type = 'sitepage_page';
                                    $document->parent_id = $sitepagedocument->page_id;
                                    $document->creation_date = $sitepagedocument->creation_date;
                                    $document->modified_date = $sitepagedocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $sitepagedocument->creation_date;
                                    $document->modified_date = $sitepagedocument->modified_date;
                                    $document->views = 1;
                                    if ($sitepagedocument->views > 0) {
                                        $document->views = $sitepagedocument->views;
                                    }
                                    $document->search = $sitepagedocument->search;
                                    $document->featured = $sitepagedocument->featured;
                                    $document->filename_id = $sitepagedocument->filename_id;
                                    $document->storage_path = $sitepagedocument->storage_path;
                                    $document->document_license = $sitepagedocument->sitepagedocument_license;
                                    $document->document_private = $sitepagedocument->sitepagedocument_private;
                                    $document->filemime = $sitepagedocument->filemime;
                                    $document->filesize = $sitepagedocument->filesize;
                                    $document->doc_id = $sitepagedocument->doc_id;
                                    $document->secret_password = $sitepagedocument->secret_password;
                                    $document->access_key = $sitepagedocument->access_key;
                                    $document->fulltext = $sitepagedocument->fulltext;
                                    $document->comment_count = $sitepagedocument->comment_count;
                                    $document->like_count = $sitepagedocument->like_count;
                                    $document->rating = $sitepagedocument->rating;
                                    $document->email_allow = $sitepagedocument->email_allow;
                                    $document->download_allow = $sitepagedocument->download_allow;
                                    $document->secure_allow = $sitepagedocument->secure_allow;
                                    $document->draft = $sitepagedocument->draft;

                                    $document->approved = $sitepagedocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $sitepagedocument->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    //$gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    //$document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $sitepagedocument->is_sitepagedocument_import = 1;
                                    $sitepagedocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($sitepage, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($sitepage, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($sitepage, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitepagedocument_document')
                                            ->where('resource_id = ?', $sitepagedocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitepagedocument_document')
                                            ->where('resource_id = ?', $sitepagedocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $sitepagedocumentratingsTable->select()
                                            ->from($sitepagedocumentratingsTableName, '*')
                                            ->where('document_id = ?', $sitepagedocument_id);
                                    $selectEventdocumentRatingDatas = $sitepagedocumentratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'sitepagedocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_sitepagedocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepage_page')
                                            ->where('object_id = ?', $sitepage->getIdentity())
                                            ->where('type =?', 'sitepagedocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitepagedocument_document')
                                            ->where('object_id = ?', $sitepagedocument_id)
                                            ->where('type =?', 'like_sitepagedocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'sitepagedocument_document', 'id =?' => $sitepagedocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $sitepagedocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitepagedocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitepagedocument.profile-sitepagedocuments'));

                                $db->commit();
                                $this->view->sitepagedocument_assigned_previous_id = $sitepagedocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=sitepagedocument&recall=1&activity_sitepagedocument=$activity_sitepagedocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_sitebusinessdocument_id = $first_sitebusinessdocument_id = 0;
        $this->view->last_sitebusinessdocument_id = $last_sitebusinessdocument_id = 0;

        $this->view->sitebusinessDocumentEnabled = $sitebusinessDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');

        if ($sitebusinessDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')))) {
            $sitebusinessdocumentTable = Engine_Api::_()->getDbTable('documents', 'sitebusinessdocument');
            $sitebusinessdocumentTableName = $sitebusinessdocumentTable->info('name');

            $sitebusinessdocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitebusinessdocument');
            $sitebusinessdocumentratingsTableName = $sitebusinessdocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitebusinessdocument_import = $db->query("SHOW COLUMNS FROM engine4_sitebusinessdocument_documents LIKE 'is_sitebusinessdocument_import'")->fetch();
            if (empty($is_sitebusinessdocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitebusinessdocument_documents` ADD is_sitebusinessdocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $sitebusinessdocumentTable->select()
                    ->from($sitebusinessdocumentTableName, 'document_id')
                    ->where('is_sitebusinessdocument_import != ?', 1)
                    ->order('document_id ASC');
            $sitebusinessdocumentDatas = $sitebusinessdocumentTable->fetchAll($selectEventDocuments);

            if (!empty($sitebusinessdocumentDatas)) {

                $flag_first_sitebusinessdocument_id = 1;

                foreach ($sitebusinessdocumentDatas as $sitebusinessdocumentData) {

                    if ($flag_first_sitebusinessdocument_id == 1) {
                        $this->view->first_sitebusinessdocument_id = $first_sitebusinessdocument_id = $sitebusinessdocumentData->document_id;
                    }
                    $flag_first_sitebusinessdocument_id++;

                    $this->view->last_sitebusinessdocument_id = $last_sitebusinessdocument_id = $sitebusinessdocumentData->document_id;
                }

                if (isset($_GET['sitebusinessdocument_assigned_previous_id'])) {
                    $this->view->sitebusinessdocument_assigned_previous_id = $sitebusinessdocument_assigned_previous_id = $_GET['sitebusinessdocument_assigned_previous_id'];
                } else {
                    $this->view->sitebusinessdocument_assigned_previous_id = $sitebusinessdocument_assigned_previous_id = $first_sitebusinessdocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitebusinessdocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_sitebusinessdocument = $this->_getParam('activity_sitebusinessdocument');

                    $selectEventDocuments = $sitebusinessdocumentTable->select()
                            ->where('document_id >= ?', $sitebusinessdocument_assigned_previous_id)
                            ->from($sitebusinessdocumentTableName, 'document_id')
                            ->where('is_sitebusinessdocument_import != ?', 1)
                            ->order('document_id ASC');
                    $sitebusinessdocumentDatas = $sitebusinessdocumentTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $sitebusinessdocumentDatasArray = $sitebusinessdocumentDatas->toArray();
                    if ($sitebusinessdocumentDatasArray) {
                        foreach ($sitebusinessdocumentDatas as $sitebusinessdocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitebusinessdocument_id = $sitebusinessdocumentData->document_id;
                                if (!empty($sitebusinessdocument_id)) {
                                    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $sitebusinessdocument_id);
                                    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessdocument->business_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $sitebusinessdocument->sitebusinessdocument_title;
                                    $document->document_description = $sitebusinessdocument->sitebusinessdocument_description;
                                    $document->owner_id = $sitebusinessdocument->owner_id;
                                    $document->owner_type = 'user';
                                    $document->parent_type = 'sitebusiness_business';
                                    $document->parent_id = $sitebusinessdocument->business_id;
                                    $document->creation_date = $sitebusinessdocument->creation_date;
                                    $document->modified_date = $sitebusinessdocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $sitebusinessdocument->creation_date;
                                    $document->modified_date = $sitebusinessdocument->modified_date;
                                    $document->views = 1;
                                    if ($sitebusinessdocument->views > 0) {
                                        $document->views = $sitebusinessdocument->views;
                                    }
                                    $document->search = $sitebusinessdocument->search;
                                    $document->featured = $sitebusinessdocument->featured;
                                    $document->filename_id = $sitebusinessdocument->filename_id;
                                    $document->storage_path = $sitebusinessdocument->storage_path;
                                    $document->document_license = $sitebusinessdocument->sitebusinessdocument_license;
                                    $document->document_private = $sitebusinessdocument->sitebusinessdocument_private;
                                    $document->filemime = $sitebusinessdocument->filemime;
                                    $document->filesize = $sitebusinessdocument->filesize;
                                    $document->doc_id = $sitebusinessdocument->doc_id;
                                    $document->secret_password = $sitebusinessdocument->secret_password;
                                    $document->access_key = $sitebusinessdocument->access_key;
                                    $document->fulltext = $sitebusinessdocument->fulltext;
                                    $document->comment_count = $sitebusinessdocument->comment_count;
                                    $document->like_count = $sitebusinessdocument->like_count;
                                    $document->rating = $sitebusinessdocument->rating;
                                    $document->email_allow = $sitebusinessdocument->email_allow;
                                    $document->download_allow = $sitebusinessdocument->download_allow;
                                    $document->secure_allow = $sitebusinessdocument->secure_allow;
                                    $document->draft = $sitebusinessdocument->draft;

                                    $document->approved = $sitebusinessdocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $sitebusinessdocument->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    // $gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    // $document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $sitebusinessdocument->is_sitebusinessdocument_import = 1;
                                    $sitebusinessdocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($sitebusiness, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($sitebusiness, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($sitebusiness, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitebusinessdocument_document')
                                            ->where('resource_id = ?', $sitebusinessdocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitebusinessdocument_document')
                                            ->where('resource_id = ?', $sitebusinessdocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $sitebusinessdocumentratingsTable->select()
                                            ->from($sitebusinessdocumentratingsTableName, '*')
                                            ->where('document_id = ?', $sitebusinessdocument_id);
                                    $selectEventdocumentRatingDatas = $sitebusinessdocumentratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'sitebusinessdocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_sitebusinessdocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusiness_business')
                                            ->where('object_id = ?', $sitebusiness->getIdentity())
                                            ->where('type =?', 'sitebusinessdocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitebusinessdocument_document')
                                            ->where('object_id = ?', $sitebusinessdocument_id)
                                            ->where('type =?', 'like_sitebusinessdocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'sitebusinessdocument_document', 'id =?' => $sitebusinessdocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $sitebusinessdocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitebusinessdocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitebusinessdocument.profile-sitebusinessdocuments'));

                                $db->commit();
                                $this->view->sitebusinessdocument_assigned_previous_id = $sitebusinessdocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=sitebusinessdocument&recall=1&activity_sitebusinessdocument=$activity_sitebusinessdocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_sitegroupdocument_id = $first_sitegroupdocument_id = 0;
        $this->view->last_sitegroupdocument_id = $last_sitegroupdocument_id = 0;

        $this->view->sitegroupDocumentEnabled = $sitegroupDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupdocument');

        if ($sitegroupDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitegroup_group', 'item_module' => 'sitegroup')))) {
            $sitegroupdocumentTable = Engine_Api::_()->getDbTable('documents', 'sitegroupdocument');
            $sitegroupdocumentTableName = $sitegroupdocumentTable->info('name');

            $sitegroupdocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitegroupdocument');
            $sitegroupdocumentratingsTableName = $sitegroupdocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitegroupdocument_import = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'is_sitegroupdocument_import'")->fetch();
            if (empty($is_sitegroupdocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD is_sitegroupdocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $sitegroupdocumentTable->select()
                    ->from($sitegroupdocumentTableName, 'document_id')
                    ->where('is_sitegroupdocument_import != ?', 1)
                    ->order('document_id ASC');
            $sitegroupdocumentDatas = $sitegroupdocumentTable->fetchAll($selectEventDocuments);

            if (!empty($sitegroupdocumentDatas)) {

                $flag_first_sitegroupdocument_id = 1;

                foreach ($sitegroupdocumentDatas as $sitegroupdocumentData) {

                    if ($flag_first_sitegroupdocument_id == 1) {
                        $this->view->first_sitegroupdocument_id = $first_sitegroupdocument_id = $sitegroupdocumentData->document_id;
                    }
                    $flag_first_sitegroupdocument_id++;

                    $this->view->last_sitegroupdocument_id = $last_sitegroupdocument_id = $sitegroupdocumentData->document_id;
                }

                if (isset($_GET['sitegroupdocument_assigned_previous_id'])) {
                    $this->view->sitegroupdocument_assigned_previous_id = $sitegroupdocument_assigned_previous_id = $_GET['sitegroupdocument_assigned_previous_id'];
                } else {
                    $this->view->sitegroupdocument_assigned_previous_id = $sitegroupdocument_assigned_previous_id = $first_sitegroupdocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitegroupdocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_sitegroupdocument = $this->_getParam('activity_sitegroupdocument');

                    $selectEventDocuments = $sitegroupdocumentTable->select()
                            ->where('document_id >= ?', $sitegroupdocument_assigned_previous_id)
                            ->from($sitegroupdocumentTableName, 'document_id')
                            ->where('is_sitegroupdocument_import != ?', 1)
                            ->order('document_id ASC');
                    $sitegroupdocumentDatas = $sitegroupdocumentTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $sitegroupdocumentDatasArray = $sitegroupdocumentDatas->toArray();
                    if ($sitegroupdocumentDatasArray) {
                        foreach ($sitegroupdocumentDatas as $sitegroupdocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitegroupdocument_id = $sitegroupdocumentData->document_id;
                                if (!empty($sitegroupdocument_id)) {
                                    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $sitegroupdocument_id);
                                    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $sitegroupdocument->sitegroupdocument_title;
                                    $document->document_description = $sitegroupdocument->sitegroupdocument_description;
                                    $document->owner_id = $sitegroupdocument->owner_id;
                                    $document->owner_type = 'user';
                                    $document->parent_type = 'sitegroup_group';
                                    $document->parent_id = $sitegroupdocument->group_id;
                                    $document->creation_date = $sitegroupdocument->creation_date;
                                    $document->modified_date = $sitegroupdocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $sitegroupdocument->creation_date;
                                    $document->modified_date = $sitegroupdocument->modified_date;
                                    $document->views = 1;
                                    if ($sitegroupdocument->views > 0) {
                                        $document->views = $sitegroupdocument->views;
                                    }
                                    $document->search = $sitegroupdocument->search;
                                    $document->featured = $sitegroupdocument->featured;
                                    $document->filename_id = $sitegroupdocument->filename_id;
                                    $document->storage_path = $sitegroupdocument->storage_path;
                                    $document->document_license = $sitegroupdocument->sitegroupdocument_license;
                                    $document->document_private = $sitegroupdocument->sitegroupdocument_private;
                                    $document->filemime = $sitegroupdocument->filemime;
                                    $document->filesize = $sitegroupdocument->filesize;
                                    $document->doc_id = $sitegroupdocument->doc_id;
                                    $document->secret_password = $sitegroupdocument->secret_password;
                                    $document->access_key = $sitegroupdocument->access_key;
                                    $document->fulltext = $sitegroupdocument->fulltext;
                                    $document->comment_count = $sitegroupdocument->comment_count;
                                    $document->like_count = $sitegroupdocument->like_count;
                                    $document->rating = $sitegroupdocument->rating;
                                    $document->email_allow = $sitegroupdocument->email_allow;
                                    $document->download_allow = $sitegroupdocument->download_allow;
                                    $document->secure_allow = $sitegroupdocument->secure_allow;
                                    $document->draft = $sitegroupdocument->draft;

                                    $document->approved = $sitegroupdocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $sitegroupdocument->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');

                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    //$document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $sitegroupdocument->is_sitegroupdocument_import = 1;
                                    $sitegroupdocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($sitegroup, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($sitegroup, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($sitegroup, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitegroupdocument_document')
                                            ->where('resource_id = ?', $sitegroupdocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitegroupdocument_document')
                                            ->where('resource_id = ?', $sitegroupdocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $sitegroupdocumentratingsTable->select()
                                            ->from($sitegroupdocumentratingsTableName, '*')
                                            ->where('document_id = ?', $sitegroupdocument_id);
                                    $selectEventdocumentRatingDatas = $sitegroupdocumentratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'sitegroupdocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_sitegroupdocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroup_group')
                                            ->where('object_id = ?', $sitegroup->getIdentity())
                                            ->where('type =?', 'sitegroupdocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitegroupdocument_document')
                                            ->where('object_id = ?', $sitegroupdocument_id)
                                            ->where('type =?', 'like_sitegroupdocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'sitegroupdocument_document', 'id =?' => $sitegroupdocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $sitegroupdocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitegroupdocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitegroupdocument.profile-sitegroupdocuments'));

                                $db->commit();
                                $this->view->sitegroupdocument_assigned_previous_id = $sitegroupdocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=sitegroupdocument&recall=1&activity_sitegroupdocument=$activity_sitegroupdocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_sitestoredocument_id = $first_sitestoredocument_id = 0;
        $this->view->last_sitestoredocument_id = $last_sitestoredocument_id = 0;

        $this->view->sitestoreDocumentEnabled = $sitestoreDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoredocument');

        if ($sitestoreDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitestore_store', 'item_module' => 'sitestore')))) {
            $sitestoredocumentTable = Engine_Api::_()->getDbTable('documents', 'sitestoredocument');
            $sitestoredocumentTableName = $sitestoredocumentTable->info('name');

            $sitestoredocumentratingsTable = Engine_Api::_()->getDbTable('ratings', 'sitestoredocument');
            $sitestoredocumentratingsTableName = $sitestoredocumentratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_sitestoredocument_import = $db->query("SHOW COLUMNS FROM engine4_sitestoredocument_documents LIKE 'is_sitestoredocument_import'")->fetch();
            if (empty($is_sitestoredocument_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_sitestoredocument_documents` ADD is_sitestoredocument_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $sitestoredocumentTable->select()
                    ->from($sitestoredocumentTableName, 'document_id')
                    ->where('is_sitestoredocument_import != ?', 1)
                    ->order('document_id ASC');
            $sitestoredocumentDatas = $sitestoredocumentTable->fetchAll($selectEventDocuments);

            if (!empty($sitestoredocumentDatas)) {

                $flag_first_sitestoredocument_id = 1;

                foreach ($sitestoredocumentDatas as $sitestoredocumentData) {

                    if ($flag_first_sitestoredocument_id == 1) {
                        $this->view->first_sitestoredocument_id = $first_sitestoredocument_id = $sitestoredocumentData->document_id;
                    }
                    $flag_first_sitestoredocument_id++;

                    $this->view->last_sitestoredocument_id = $last_sitestoredocument_id = $sitestoredocumentData->document_id;
                }

                if (isset($_GET['sitestoredocument_assigned_previous_id'])) {
                    $this->view->sitestoredocument_assigned_previous_id = $sitestoredocument_assigned_previous_id = $_GET['sitestoredocument_assigned_previous_id'];
                } else {
                    $this->view->sitestoredocument_assigned_previous_id = $sitestoredocument_assigned_previous_id = $first_sitestoredocument_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'sitestoredocument') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_sitestoredocument = $this->_getParam('activity_sitestoredocument');

                    $selectEventDocuments = $sitestoredocumentTable->select()
                            ->where('document_id >= ?', $sitestoredocument_assigned_previous_id)
                            ->from($sitestoredocumentTableName, 'document_id')
                            ->where('is_sitestoredocument_import != ?', 1)
                            ->order('document_id ASC');
                    $sitestoredocumentDatas = $sitestoredocumentTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $sitestoredocumentDatasArray = $sitestoredocumentDatas->toArray();
                    if ($sitestoredocumentDatasArray) {
                        foreach ($sitestoredocumentDatas as $sitestoredocumentData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $sitestoredocument_id = $sitestoredocumentData->document_id;
                                if (!empty($sitestoredocument_id)) {
                                    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $sitestoredocument_id);
                                    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);
                                    $document = $documentTable->createRow();
                                    $document->document_title = $sitestoredocument->sitestoredocument_title;
                                    $document->document_description = $sitestoredocument->sitestoredocument_description;
                                    $document->owner_id = $sitestoredocument->owner_id;
                                    $document->owner_type = 'user';
                                    $document->parent_type = 'sitestore_store';
                                    $document->parent_id = $sitestoredocument->store_id;
                                    $document->creation_date = $sitestoredocument->creation_date;
                                    $document->modified_date = $sitestoredocument->modified_date;
                                    $document->save();
                                    $document->creation_date = $sitestoredocument->creation_date;
                                    $document->modified_date = $sitestoredocument->modified_date;
                                    $document->views = 1;
                                    if ($sitestoredocument->views > 0) {
                                        $document->views = $sitestoredocument->views;
                                    }
                                    $document->search = $sitestoredocument->search;
                                    $document->featured = $sitestoredocument->featured;
                                    $document->filename_id = $sitestoredocument->filename_id;
                                    $document->storage_path = $sitestoredocument->storage_path;
                                    $document->document_license = $sitestoredocument->sitestoredocument_license;
                                    $document->document_private = $sitestoredocument->sitestoredocument_private;
                                    $document->filemime = $sitestoredocument->filemime;
                                    $document->filesize = $sitestoredocument->filesize;
                                    $document->doc_id = $sitestoredocument->doc_id;
                                    $document->secret_password = $sitestoredocument->secret_password;
                                    $document->access_key = $sitestoredocument->access_key;
                                    $document->fulltext = $sitestoredocument->fulltext;
                                    $document->comment_count = $sitestoredocument->comment_count;
                                    $document->like_count = $sitestoredocument->like_count;
                                    $document->rating = $sitestoredocument->rating;
                                    $document->email_allow = $sitestoredocument->email_allow;
                                    $document->download_allow = $sitestoredocument->download_allow;
                                    $document->secure_allow = $sitestoredocument->secure_allow;
                                    $document->draft = $sitestoredocument->draft;

                                    $document->approved = $sitestoredocument->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $sitestoredocument->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    //  $gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    // $document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();

                                    $sitestoredocument->is_sitestoredocument_import = 1;
                                    $sitestoredocument->save();

                                    $next_import_count++;

                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($sitestore, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($sitestore, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($sitestore, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'sitestoredocument_document')
                                            ->where('resource_id = ?', $sitestoredocument_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'sitestoredocument_document')
                                            ->where('resource_id = ?', $sitestoredocument_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $sitestoredocumentratingsTable->select()
                                            ->from($sitestoredocumentratingsTableName, '*')
                                            ->where('document_id = ?', $sitestoredocument_id);
                                    $selectEventdocumentRatingDatas = $sitestoredocumentratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'sitestoredocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_sitestoredocument) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestore_store')
                                            ->where('object_id = ?', $sitestore->getIdentity())
                                            ->where('type =?', 'sitestoredocument_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'sitestoredocument_document')
                                            ->where('object_id = ?', $sitestoredocument_id)
                                            ->where('type =?', 'like_sitestoredocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'sitestoredocument_document', 'id =?' => $sitestoredocument_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $sitestoredocument_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'sitestoredocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'sitestoredocument.profile-sitestoredocuments'));

                                $db->commit();
                                $this->view->sitestoredocument_assigned_previous_id = $sitestoredocument_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=sitestoredocument&recall=1&activity_sitestoredocument=$activity_sitestoredocument");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }

        $this->view->first_siteevent_id = $first_siteevent_id = 0;
        $this->view->last_siteevent_id = $last_siteevent_id = 0;

        $this->view->siteeventDocumentEnabled = $siteeventDocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventdocument');

        if ($siteeventDocumentEnabled && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'siteevent_event', 'item_module' => 'siteevent')))) {
            $siteeventTable = Engine_Api::_()->getDbTable('documents', 'siteeventdocument');
            $siteeventTableName = $siteeventTable->info('name');

            $siteeventratingsTable = Engine_Api::_()->getDbTable('ratings', 'siteeventdocument');
            $siteeventratingsTableName = $siteeventratingsTable->info('name');

            $db = Engine_Db_Table::getDefaultAdapter();
            $is_siteevent_import = $db->query("SHOW COLUMNS FROM engine4_siteeventdocument_documents LIKE 'is_siteevent_import'")->fetch();
            if (empty($is_siteevent_import)) {
                $run_query = $db->query("ALTER TABLE `engine4_siteeventdocument_documents` ADD is_siteevent_import TINYINT( 2 ) NOT NULL DEFAULT '0'");
            }

            //START IF IMPORTING IS BREAKED BY SOME REASON
            $selectEventDocuments = $siteeventTable->select()
                    ->from($siteeventTableName, 'document_id')
                    ->where('is_siteevent_import != ?', 1)
                    ->order('document_id ASC');
            $siteeventDatas = $siteeventTable->fetchAll($selectEventDocuments);

            if (!empty($siteeventDatas)) {

                $flag_first_siteevent_id = 1;

                foreach ($siteeventDatas as $siteeventData) {

                    if ($flag_first_siteevent_id == 1) {
                        $this->view->first_siteevent_id = $first_siteevent_id = $siteeventData->document_id;
                    }
                    $flag_first_siteevent_id++;

                    $this->view->last_siteevent_id = $last_siteevent_id = $siteeventData->document_id;
                }

                if (isset($_GET['siteevent_assigned_previous_id'])) {
                    $this->view->siteevent_assigned_previous_id = $siteevent_assigned_previous_id = $_GET['siteevent_assigned_previous_id'];
                } else {
                    $this->view->siteevent_assigned_previous_id = $siteevent_assigned_previous_id = $first_siteevent_id;
                }
            }

            //START IMPORTING IF REQUESTED
            if (isset($_GET['start_import']) && $_GET['start_import'] == 1 && $_GET['module'] == 'siteevent') {

                try {

                    //ACTIVITY FEED IMPORT
                    $activity_siteevent = $this->_getParam('activity_siteevent');

                    $selectEventDocuments = $siteeventTable->select()
                            ->where('document_id >= ?', $siteevent_assigned_previous_id)
                            ->from($siteeventTableName, 'document_id')
                            ->where('is_siteevent_import != ?', 1)
                            ->order('document_id ASC');
                    $siteeventDatas = $siteeventTable->fetchAll($selectEventDocuments);

                    $next_import_count = 0;
                    $siteeventDatasArray = $siteeventDatas->toArray();
                    if ($siteeventDatasArray) {
                        foreach ($siteeventDatas as $siteeventData) {
                            $db = Engine_Db_Table::getDefaultAdapter();
                            $db->beginTransaction();
                            try {
                                $siteevent_id = $siteeventData->document_id;
                                if (!empty($siteevent_id)) {
                                    $siteevent = Engine_Api::_()->getItem('siteeventdocument_document', $siteevent_id);

                                    $document = $documentTable->createRow();
                                    $document->document_title = $siteevent->title;
                                    $document->document_description = $siteevent->description;
                                    $document->owner_id = $siteevent->owner_id;
                                    $document->owner_type = 'user';
                                    $document->parent_type = 'siteevent_event';
                                    $document->parent_id = $siteevent->event_id;
                                    $document->creation_date = $siteevent->creation_date;
                                    $document->modified_date = $siteevent->modified_date;
                                    $document->save();
                                    $document->creation_date = $siteevent->creation_date;
                                    $document->modified_date = $siteevent->modified_date;
                                    $document->views = 1;
                                    if ($siteevent->view_count > 0) {
                                        $document->views = $siteevent->view_count;
                                    }
                                    $document->search = $siteevent->search;
                                    $document->featured = $siteevent->featured;
                                    $document->filename_id = $siteevent->filename_id;
                                    $document->storage_path = $siteevent->storage_path;
                                    $document->document_license = $siteevent->license;
                                    $document->document_private = $siteevent->private;
                                    $document->filemime = $siteevent->filemime;
                                    $document->filesize = $siteevent->filesize;
                                    $document->doc_id = $siteevent->doc_id;
                                    $document->secret_password = $siteevent->secret_password;
                                    $document->access_key = $siteevent->access_key;
                                    $document->fulltext = $siteevent->fulltext;
                                    $document->comment_count = $siteevent->comment_count;
                                    $document->like_count = $siteevent->like_count;
                                    $document->rating = $siteevent->rating;
                                    $document->email_allow = $siteevent->email_allow;
                                    $document->download_allow = $siteevent->download_allow;
                                    $document->secure_allow = $siteevent->secure_allow;
                                    $document->draft = $siteevent->draft;

                                    $document->approved = $siteevent->approved;
                                    $document->status = 1;
                                    $document->activity_feed = $siteevent->activity_feed;
                                    $document->save();

                                    if ($document->download_allow) {

                                        try {
                                            $link = $this->scribd->getDownloadUrl($document->doc_id, $download_format);
                                            $link = trim($link['download_link']);

                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;

                                            $curl_handle = curl_init();
                                            curl_setopt($curl_handle, CURLOPT_URL, $link);
                                            curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_TIMEOUT, 0);
                                            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, FALSE);
                                            curl_setopt($curl_handle, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                                            curl_setopt($curl_handle, CURLOPT_FOLLOWLOCATION, 1);
                                            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, TRUE);
                                            $JsonResponse = curl_exec($curl_handle);
                                            $http_code = curl_getinfo($curl_handle);
                                            $dir_name_temp = 'document_scribd';
                                            $temp_doc_file = APPLICATION_PATH . '/public/' . $dir_name_temp;
                                            if (!is_dir($temp_doc_file)) {
                                                mkdir($temp_doc_file, 0777, true);
                                            }
                                            $fileName = $temp_doc_file . '/' . $name;
                                            file_put_contents($fileName, $JsonResponse);
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        } catch (Exception $e) {
                                            $this->view->excep_error = 1;
                                        }

                                        if ($this->view->excep_error) {


                                            $filename_id = $document->filename_id;
                                            $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                            $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                            $ext = pathinfo($link, PATHINFO_EXTENSION);
                                            $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                            $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                            $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                        }
                                    } else {
                                        $filename_id = $document->filename_id;
                                        $fileObj = Engine_Api::_()->getItem('storage_file', $filename_id);
                                        $fileName = $link = APPLICATION_PATH . '/' . $fileObj->storage_path;
                                        $ext = pathinfo($link, PATHINFO_EXTENSION);
                                        $name = $document->document_title . '_' . $document->doc_id . '.' . $ext;
                                        $mimeType = Engine_Api::_()->document()->get_mime_content_type($fileName);
                                        $fileId = $this->_GDSEMedia->createFileFromPath($fileName, $name, $document->document_description, $fileParent, $mimeType, $document->download_allow);
                                    }
                                    $this->_GDSEMedia->setPermissions($fileId, 'me', 'reader', 'anyone');
                                    // $gdsem_apiConfig['use_objects'] = true;
                                    $file = $this->_GDSEMedia->files->get($fileId);
                                    //$document->thumbnail = $file['thumbnailLink'];
                                    $document->migrated = 1;
                                    $document->google_file_id = $fileId;
                                    $document->google_folder_id = $folderId;
                                    $document->save();
                                    $siteevent->is_siteevent_import = 1;
                                    $siteevent->save();

                                    $next_import_count++;
                                    $siteevent = Engine_Api::_()->getItem('siteevent_event', $siteevent->event_id);
                                    $values = array();

                                    //START FETCH PRIVACY
                                    $auth = Engine_Api::_()->authorization()->context;

                                    $values = array();

                                    $rolesEventDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesEventDocuments as $rolesEventDocument) {

                                        if ($auth->isAllowed($siteevent, $rolesEventDocument, 'view')) {
                                            $values['auth_view'] = $rolesEventDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $viewMax = array_search($values['auth_view'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($document, $rolesDocument, 'view', ($i >= $viewMax));
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    foreach ($rolesDocuments as $rolesDocument) {

                                        if ($auth->isAllowed($siteevent, $rolesDocument, 'comment')) {
                                            $values['auth_comment'] = $rolesDocument;
                                            break;
                                        }
                                    }
                                    $rolesDocuments = array('everyone', 'registered', 'owner_network', 'owner_member_member', 'owner_member', 'owner');
                                    $commentMax = array_search($values['auth_comment'], $rolesDocuments);

                                    foreach ($rolesDocuments as $i => $rolesDocument) {
                                        $auth->setAllowed($siteevent, $rolesDocument, 'comment', ($i >= $commentMax));
                                    }


                                    //START FETCH COMMENTS
                                    $selectComment = $commentTable->select()
                                            ->from($commentTableName, 'comment_id')
                                            ->where('resource_type = ?', 'siteeventdocument_document')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectCommentDatas = $commentTable->fetchAll($selectComment);
                                    foreach ($selectCommentDatas as $selectCommentData) {
                                        $comment = Engine_Api::_()->getItem('core_comment', $selectCommentData->comment_id);
                                        $newCommentEntry = $commentTable->createRow();
                                        $newCommentEntry->resource_type = 'document';
                                        $newCommentEntry->resource_id = $document->getIdentity();
                                        $newCommentEntry->poster_type = 'user';
                                        $newCommentEntry->poster_id = $comment->poster_id;
                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $newCommentEntry->like_count = $comment->like_count;
                                        $newCommentEntry->save();

                                        $newCommentEntry->creation_date = $comment->creation_date;
                                        $comment_id = $newCommentEntry->save();

                                        //START FETCH LIKES
                                        $selectLike = $likeTable->select()
                                                ->from($likeTableName, 'like_id')
                                                ->where('resource_type = ?', 'core_comment')
                                                ->where('resource_id = ?', $selectCommentData->comment_id);
                                        $selectLikeDatas = $likeTable->fetchAll($selectLike);
                                        foreach ($selectLikeDatas as $selectLikeData) {
                                            $like = Engine_Api::_()->getItem('core_like', $selectLikeData->like_id);
                                            $newLikeEntry = $likeTable->createRow();
                                            $newLikeEntry->resource_type = 'core_comment';
                                            $newLikeEntry->resource_id = $comment_id;
                                            $newLikeEntry->poster_type = 'user';
                                            $newLikeEntry->poster_id = $like->poster_id;
                                            $newLikeEntry->creation_date = $like->creation_date;

                                            $newLikeEntry->save();
                                            $newLikeEntry->creation_date = $like->creation_date;
                                            $newLikeEntry->save();
                                        }
                                        //END FETCH LIKES
                                    }
                                    //END FETCH COMMENTS

                                    $selectLikeCount = $likeTable->select()
                                            ->from($likeTableName, array('COUNT(*) AS like_count'))
                                            ->where('resource_type = ?', 'siteeventdocument_document')
                                            ->where('resource_id = ?', $siteevent_id);
                                    $selectLikeCounts = $likeTable->fetchAll($selectLikeCount);
                                    if (!empty($selectLikeCounts)) {
                                        $selectLikeCounts = $selectLikeCounts->toArray();
                                        $document->like_count = $selectLikeCounts[0]['like_count'];
                                        $document->save();
                                    }

                                    $selectEventdocumentRating = $siteeventratingsTable->select()
                                            ->from($siteeventratingsTableName, '*')
                                            ->where('document_id = ?', $siteevent_id);
                                    $selectEventdocumentRatingDatas = $siteeventratingsTable->fetchAll($selectEventdocumentRating);
                                    $selectEventdocumentRatingDatas = $selectEventdocumentRatingDatas->toArray();
                                    foreach ($selectEventdocumentRatingDatas as $selectEventdocumentRatingData) {
                                        $documentratingsTable->insert(array(
                                            'resource_type' => 'siteeventdocument_document',
                                            'resource_id' => $document->getIdentity(),
                                            'document_id' => $document->getIdentity(),
                                            'user_id' => $selectEventdocumentRatingData['user_id'],
                                            'rating' => $selectEventdocumentRatingData['rating'],
                                        ));
                                    }
                                }


                                //GENERATE ACITIVITY FEED
                                if ($activity_siteevent) {
                                    //START FETCH ACTIONS
                                    $selectActionIds = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteevent_event')
                                            ->where('object_id = ?', $siteevent->getIdentity())
                                            ->where('type =?', 'siteevent_new')
                                            ->query()
                                            ->fetchAll();
                                    foreach ($selectActionIds as $selectActionId) {
                                        $action = Engine_Api::_()->getItem('activity_action', $selectActionId);
                                        $action->type = 'document_new';
                                        $action->object_id = $document->getIdentity();
                                        $action->object_type = $document->getType();
                                        $action->save();
                                        $actionsTable->resetActivityBindings($action);
                                    }
                                    //END FETCH ACTIONS
                                    //START FETCH ACTIONS
                                    $selectActionId = $actionsTable->select()
                                            ->from($actionsTableName, 'action_id')
                                            ->where('object_type = ?', 'siteeventdocument_document')
                                            ->where('object_id = ?', $siteevent_id)
                                            ->where('type =?', 'like_siteeventdocument_document');
                                    $selectActionIds = $actionsTable->fetchAll($selectActionId);
                                    if ($selectActionIds) {
                                        foreach ($selectActionIds as $selectActionId) {
                                            $action = Engine_Api::_()->getItem('activity_action', $selectActionId['action_id']);
                                            $action->type = 'like_document';
                                            $action->object_id = $document->getIdentity();
                                            $action->object_type = $document->getType();
                                            $action->save();
                                            $actionsTable->resetActivityBindings($action);
                                        }
                                    }
                                    //END FETCH ACTIONS
                                    //UPDATE VIDEO TYPE 
                                    $attachmentsTable->update(array('type' => $document->getType(), 'id' => $document->getIdentity()), array('type = ?' => 'siteeventdocument_document', 'id =?' => $siteevent_id));
                                }

                                //CREATE LOG ENTRY IN LOG FILE
                                if (file_exists(APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log')) {
                                    $myFile = APPLICATION_PATH . '/temporary/log/DocumentToDocumentImport.log';
                                    $error = Zend_Registry::get('Zend_Translate')->_("can't open file");
                                    $fh = fopen($myFile, 'a') or die($error);
                                    $current_time = date('D, d M Y H:i:s T');
                                    $stringData = $this->view->translate('Event Document with ID ') . $siteevent_id . $this->view->translate(' is successfully imported into a Document with ID ') . $document->document_id . $this->view->translate(' at ') . $current_time . $this->view->translate(". Title of that Document is '") . $document->document_title . "'.\n\n";
                                    fwrite($fh, $stringData);
                                    fclose($fh);
                                }

                                $coreModuleTable->update(array('enabled' => 0), array('name = ?' => 'siteeventdocument'));
                                //Engine_Api::_()->getDbtable('content', 'core')->delete(array('name =?' => 'siteevent.profile-siteevents'));

                                $db->commit();
                                $this->view->siteevent_assigned_previous_id = $siteevent_id;
                            } catch (Exception $ex) {
                                $db->rollback();
                                throw($ex);
                            }

                            if ($next_import_count >= 100) {
                                $this->_redirect("admin/documentintegration/importdocument/index?start_import=1&module=siteevent&recall=1&activity_siteevent=$activity_siteevent");
                            }
                        }
                    } else {
                        if ($_GET['recall']) {
                            echo json_encode(array('success' => 1));
                            exit();
                        }
                    }
                } catch (Exception $ex) {
                    throw($ex);
                }
            }
        }
    }

}
