<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Documentintegration
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2010-08-11 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Documentintegration_Installer extends Engine_Package_Installer_Module {

    function onPreinstall() {
        $db = $this->getDb();

        $select = new Zend_Db_Select($db);
        $isAPIActivate = $select
                ->from('engine4_core_settings', 'value')
                ->where('name = ?', 'document.isActivate')
                ->limit(1)
                ->query()
                ->fetchColumn();
        $isAPIActivate = !empty($isAPIActivate) ? $isAPIActivate : 0;

        $select = new Zend_Db_Select($db);
        $isAPIEnabled = $select
                ->from('engine4_core_modules', 'enabled')
                ->where('name = ?', 'document')
                ->where('enabled = ?', 1)
                ->query()
                ->fetchColumn();

        if (empty($isAPIEnabled)) {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
            return $this->_error("<span style='color:red'>Note: You have not installed the '<a href='https://www.socialengineaddons.com/socialengine-documents-sharing-plugin-google-docs-viewer' target='_blank'>Documents Sharing Plugin - Google Docs Viewer</a>' on your site yet. Please install it first before installing the 'Documents Sharing - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension'. <a href='" . $base_url . "/manage'>Click here</a> to go to Manage Packages.</span>");
        } else {
            if (empty($isAPIActivate)) {
                $core_final_url = '';
                $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
                $explode_base_url = explode("/", $baseUrl);
                foreach ($explode_base_url as $url_key) {
                    if ($url_key != 'install') {
                        $core_final_url .= $url_key . '/';
                    }
                }
                return $this->_error("<span style='color:red'>Note: You have installed the 'Documents Sharing Plugin - Google Docs Viewer' but not activated it on your site yet. Please activate it first before installing the 'Documents Sharing - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension'.</span> <a href='" . 'http://' . $core_final_url . "admin/document/settings/readme'>Click here</a> to activate the 'Documents Sharing Plugin - Google Docs Viewer'.");
            }

            $PRODUCT_TYPE = 'documentintegration';
            $PLUGIN_TITLE = 'Document';
            $PLUGIN_VERSION = '5.6.1p2';
            $PLUGIN_CATEGORY = 'plugin';
            $PRODUCT_DESCRIPTION = 'Documents Sharing - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension';
            $PRODUCT_TITLE = 'Documents Sharing - Pages, Businesses, Groups, Multiple Listing Types, Events, Stores, etc Extension';
            $_PRODUCT_FINAL_FILE = 0;
            $SocialEngineAddOns_version = '4.8.12';
            $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
            $is_file = @file_exists($file_path);
            if (empty($is_file)) {
                include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
            } else {
                $db = $this->getDb();
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
                $is_Mod = $select->query()->fetchObject();
                if (empty($is_Mod))
                    include_once $file_path;
            }

            parent::onPreinstall();
        }
    }

    function onInstall() {
        $db = $this->getDb();

        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` = '1' WHERE  `engine4_seaocores`.`module_name` ='documentintegration';");

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_modules", "documentintegration", "Manage Modules", "", \'{"route":"admin_default","module":"documentintegration","controller":"modules"}\', "document_admin_main", "", 1, 0, 12)');

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("document_admin_main_importdocument", "documentintegration", "Import Documents of SocialApps.tech Extensions", "", \'{"route":"admin_default","module":"documentintegration","controller":"importdocument"}\', "document_admin_main_import", "", 1, 0, 13)');
        $this->setManageModules();
        parent::onInstall();
    }

    public function setManageModules() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitepage.isActivate')
                ->where('value = ?', 1);
        $sitepage_isActivate_object = $select->query()->fetchObject();
        if ($sitepage_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('sitepage_page', 'page_id', 'sitepage', '0', '0', 'Page Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitepage_admin_main_managedocument", "document", "Manage Documents", "", \'{"uri":"admin/document/manage-document/index/contentType/sitepage_page/contentModule/sitepage"}\', "sitepage_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.sitepage.page", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE DOCUMENT CREATION OPTIONS IN THE PAGE PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitepage_page' as `type`,
                'sdcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitepagemember.isActivate')
                    ->where('value = ?', 1);
            $sitepagemember_isActivate_object = $select->query()->fetchObject();
            if($sitepagemember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitepage_page' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitepage_page' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'event')
                ->where('enabled = ?', 1);
        $event_isActivate_object = $select->query()->fetchObject();
        if ($event_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('event', 'event_id', 'event', '0', '0', 'SE-Events Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.event", "1");');
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'group')
                ->where('enabled = ?', 1);
        $group_isActivate_object = $select->query()->fetchObject();
        if ($group_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('group', 'group_id', 'group', '0', '0', 'SE-Groups Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.group", "1");');
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitebusiness.isActivate')
                ->where('value = ?', 1);
        $sitebusiness_isActivate_object = $select->query()->fetchObject();
        if ($sitebusiness_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('sitebusiness_business', 'business_id', 'sitebusiness', '0', '0', 'Business Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitebusiness_admin_main_managedocument", "document", "Manage Documents", "", \'{"uri":"admin/document/manage-document/index/contentType/sitebusiness_business/contentModule/sitebusiness"}\', "sitebusiness_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.sitebusiness.business", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE DOCUMENT CREATION OPTIONS IN THE BUSINESS PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitebusiness_business' as `type`,
                'sdcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitebusinessmember.isActivate')
                    ->where('value = ?', 1);
            $sitebusinessmember_isActivate_object = $select->query()->fetchObject();
            if($sitebusinessmember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitebusiness_business' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitebusiness_business' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitegroup.isActivate')
                ->where('value = ?', 1);
        $sitegroup_isActivate_object = $select->query()->fetchObject();
        if ($sitegroup_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('sitegroup_group', 'group_id', 'sitegroup', '0', '0', 'Group Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitegroup_admin_main_managedocument", "document", "Manage Documents", "", \'{"uri":"admin/document/manage-document/index/contentType/sitegroup_group/contentModule/sitegroup"}\', "sitegroup_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.sitegroup.group", "1");');

            //ENTER THE MEMBER LEVEL SETTING FOR THE DOCUMENT CREATION OPTIONS IN THE GROUP PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'sitegroup_group' as `type`,
                'sdcreate' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");

            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', 'sitegroupmember.isActivate')
                    ->where('value = ?', 1);
            $sitegroupmember_isActivate_object = $select->query()->fetchObject();
            if($sitegroupmember_isActivate_object) {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitegroup_group' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            } else {
                $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
                  SELECT
                    level_id as `level_id`,
                    'sitegroup_group' as `type`,
                    'auth_sdcreate' as `name`,
                    5 as `value`,
                    '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"like_member\", \"owner\"]' as `params`
                  FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
                ");
            }
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitestore.isActivate')
                ->where('value = ?', 1);
        $sitestore_isActivate_object = $select->query()->fetchObject();
        if ($sitestore_isActivate_object) {
            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('sitestore_store', 'store_id', 'sitestore', '0', '0', 'Store Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitestore_admin_main_managedocument", "document", "Manage Documents", "", \'{"uri":"admin/document/manage-document/index/contentType/sitestore_store/contentModule/sitestore"}\', "sitestore_admin_main", "", 0, 0, 24);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.sitestore.store", "1");');

            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'sitestore_admin_main_sitestoredocument'");
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteevent.isActivate')
                ->where('value = ?', 1);
        $siteevent_isActivate_object = $select->query()->fetchObject();
        if ($siteevent_isActivate_object) {

            $db->query("INSERT IGNORE INTO `engine4_document_modules` (`item_type`, `item_id`, `item_module`, `enabled`, `integrated`, `item_title`) VALUES ('siteevent_event', 'event_id', 'siteevent', '0', '0', 'Events Documents')");
            $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("siteevent_admin_main_managedocument", "documentintegration", "Manage Documents", "", \'{"uri":"admin/document/manage-document/index/contentType/siteevent_event/contentModule/siteevent"}\', "siteevent_admin_main", "", 0, 0, 45);');
            $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "document.leader.owner.siteevent.event", "1");');

            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'siteevent_admin_main_document'");

            //ENTER THE MEMBER LEVEL SETTING FOR THE DOCUMENT CREATION OPTIONS IN THE EVENT PLUGIN
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'siteevent_event' as `type`,
                'document' as `name`,
                1 as `value`,
                NULL as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");
            $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
              SELECT
                level_id as `level_id`,
                'siteevent_event' as `type`,
                'auth_document' as `name`,
                5 as `value`,
                '[\"registered\",\"owner_network\",\"owner_member_member\", \"owner_member\", \"member\", \"leader\"]' as `params`
              FROM `engine4_authorization_levels` WHERE `type` NOT IN('public');
            ");
        }
    }

}