<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_Controller_Action_Helper_Eventdocuments extends Zend_Controller_Action_Helper_Abstract {

    function postDispatch() {
        //GET NAME OF MODULE, CONTROLLER AND ACTION
        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();
        $view = $this->getActionController()->view;

        //DON'T SHOW THE PRIVACY OPTIONS IF NOT ACTIVATED
        $eventdocument_isActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('eventdocument.isActivate', 0);
        if (empty($eventdocument_isActivate))
            return;

        if (Engine_Api::_()->hasModuleBootstrap('document') && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'event', 'item_module' => 'event', 'checked' => 'enabled')))) {
            return;
        }

        //ADD DOCUMENT PRIVACY FIELDS AT EVENT CREATION AND EDITION
        if (($module == 'event' || $module == 'advevent' || $module == 'ynevent') && ($action == 'create' || $action == 'edit') && ($controller == 'index' || $controller == 'event')) {
            $new_element = $view->form;
            if (!$new_element)
                return;

            //COUNT TOTAL ELEMENTS IN EVENT FORM
//      $total_elements = Count($new_element->getElements());
            $total_elements = 0;

            foreach ($new_element->getElements() as $value) {
                if ($value->helper != 'formHidden') {
                    $total_elements += 1;
                    ;
                }
            }

            $user = Engine_Api::_()->user()->getViewer();

            $availableLabels = array(
                'registered' => 'Registered Members',
                'owner_network' => 'Friends and Networks',
                'owner_member_member' => 'Friends of Friends',
                'owner_member' => 'Friends Only',
                'member' => "Event Guests Only",
                'owner' => 'Just Me'
            );

            $options = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('event', $user, 'auth_edcreate');
            $options_create = array_intersect_key($availableLabels, array_flip($options));

            if (!empty($options_create)) {
                $new_element->addElement('Select', 'edcreate', array(
                    'label' => 'Documents Creation Privacy',
                    'description' => 'Who may create documents in this event?',
                    'multiOptions' => $options_create,
                    'order' => $total_elements - 2,
                ));
                $new_element->edcreate->getDecorator('Description')->setOption('placement', 'append');
            }

            if ($action == 'edit') {
                $event_id = $front->getRequest()->getParam('event_id');
                $event = Engine_Api::_()->getItem('event', $event_id);

                $auth = Engine_Api::_()->authorization()->context;
                $roles = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered');

                foreach ($roles as $role) {
                    if (!empty($options_create)) {
                        if (1 === $auth->isAllowed($event, $role, 'edcreate')) {
                            $new_element->edcreate->setValue($role);
                        }
                    }
                }
            }
        }
    }

}
