<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_Plugin_Core {

  public function onItemDeleteBefore($event) {
    $payload = $event->getPayload();

    if ($payload instanceof Event_Model_Event) {

			//GET EVENT ID
      $event_id = $payload->getIdentity();

      if (!empty($event_id)) {

        //FETCH DOCUMENTS CORROSPONDING TO THAT EVENT ID
				$owner_id = 0;
        $documents = Engine_Api::_()->getItemTable('eventdocument_document')->getEventDocuments($event_id, $owner_id);

				foreach ($documents as $document) {

					//DELETE DOCUMENT BELONGINGS
					Engine_Api::_()->eventdocument()->deleteContent($document->document_id);
				}  
      }
    }
  }

  //DELETE USERS BELONGINGS BEFORE THAT USER DELETION
  public function onUserDeleteBefore($event) {

    $payload = $event->getPayload();

    if ($payload instanceof User_Model_User) {

			//FETCH DOCUMENTS CORROSPONDING TO THAT OWNER ID
			$owner_id = $payload->getIdentity();
			$event_id = 0;
			$documents = Engine_Api::_()->getItemTable('eventdocument_document')->getEventDocuments($event_id, $owner_id);

      foreach ($documents as $eventdocument) {

        //DELETE DOCUMENT BELONGINGS
        Engine_Api::_()->eventdocument()->deleteContent($eventdocument->document_id);
      }
    }
  }

  public function addActivity($event) {
    global $eventdocument_createactivity;
    $front = Zend_Controller_Front::getInstance();
    $module = $front->getRequest()->getModuleName();
    $controller = $front->getRequest()->getControllerName();
    $action = $front->getRequest()->getActionName();

		//DON'T SHOW THE PRIVACY OPTIONS IF NOT ACTIVATED
		$eventdocument_isActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('eventdocument.isActivate', 0);
		if(empty($eventdocument_isActivate))
			return;

    if (!empty($eventdocument_createactivity) && ($module == 'event' || $module == 'advevent' || $module == 'ynevent') && ($action == 'create' || $action == 'edit') && ($controller == 'index' || $controller == 'event')) {

			//GET EVENT ID
      $payload = $event->getPayload();
      $event_id = $payload['object']->event_id;

			//GET EVENT OBJECT
      $event = Engine_Api::_()->getItem('event', $event_id);

      //PROCESS PRIVACY WORK
      $auth = Engine_Api::_()->authorization()->context;

      $roles = array('owner', 'member', 'owner_member', 'owner_member_member', 'owner_network', 'registered');

      $edcreate = array_search($_POST['edcreate'], $roles);

      foreach ($roles as $i => $role) {
        $auth->setAllowed($event, $role, 'edcreate', ($i <= $edcreate));
      }
    }
  }
}