<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLevelController.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_AdminLevelController extends Core_Controller_Action_Admin {

  //ACTION FOR LEVEL SETTINGS
  public function indexAction() {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('eventdocument_admin_main', array(), 'eventdocument_admin_main_level');

    //FETCH LEVEL
    if (null !== ($id = $this->_getParam('id'))) {
      $level = Engine_Api::_()->getItem('authorization_level', $id);
    } else {
      $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
    }

    if (!$level instanceof Authorization_Model_Level) {
      throw new Engine_Exception($this->view->translate('missing level'));
    }

    //FETCH LEVEL ID
    $id = $level->level_id;

    //FORM GENERATION
    $this->view->form = $form = new Eventdocument_Form_Admin_Settings_Level(array(
                'public' => ( in_array($level->type, array('public')) ),
                'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
            ));

    if (!empty($id)) {
      $form->level_id->setValue($id);
    }

    //GET AUTHORIZATION TABLE
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');

    //FORM VALIDATION
    if (!$this->getRequest()->isPost()) {
      $form->populate($permissionsTable->getAllowed('event', $id, array_keys($form->getValues())));
      return;
    }

    //FORM VALIDATION
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //GET POSTED VALUE
    $values = $form->getValues();
    $eventdocument_admin_tab = 'member_level_settings';

    //CHECK FOR FILESIZE
    if ($level->type != 'public') {
      if ($values['filesize'] < 0) {
        $values['filesize'] = (int) ini_get('upload_max_filesize') * 1024 * 1024;
      }
    }

    include APPLICATION_PATH . '/application/modules/Eventdocument/controllers/license/license2.php';
  }

}