<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Event Profile Documents'),
        'description' => $view->translate('Displays a event’s documents on its profile.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.profile-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Event Profile Recent Documents'),
        'description' => $view->translate('Displays list of event’s recent documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.recent-eventdocuments',
				'isPaginatated' => true,
        'defaultParams' => array(
            'title' => $view->translate('Recent Event Documents'),
						'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
    array(
        'title' => $view->translate('Event Profile Popular Documents'),
        'description' => $view->translate('Displays list of event’s popular documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.popular-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Popular Event Documents'),
            'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
    array(
        'title' => $view->translate('Event Profile Most Commented Documents'),
        'description' => $view->translate('Displays list of event’s most commented documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.comment-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Event Documents'),
            'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
    array(
        'title' => $view->translate('Event Profile Most Liked Documents'),
        'description' => $view->translate('Displays list of event’s most liked documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.like-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Event Documents'),
            'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
    array(
        'title' => $view->translate('Event Profile Top Rated Documents'),
        'description' => $view->translate('Displays list of event’s top rated documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.rate-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Top Rated Event Documents'),
            'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
    array(
        'title' => $view->translate('Event Profile Featured Documents'),
        'description' => $view->translate('Displays list of event’s featured documents. Setting for this widget available in widget settings tab of Event - Documents admin.'),
        'category' => $view->translate('Events'),
        'type' => 'widget',
        'name' => 'eventdocument.featurelist-eventdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Featured Event Documents'),
            'titleCount' => true,
        ),
				'adminForm' => array(
						'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of documents to show)'),
											'value' => 3,
									)
							),
						),
					),
    ),
);