<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Eventdocument
 * @copyright  Copyright 20011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.tpl 2012-01-25 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Eventdocument_Widget_RateEventdocumentsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GET EVENT SUBJECT
    $event = Engine_Api::_()->core()->getSubject('event');

    $eventdocument_ratedoc = Zend_Registry::isRegistered('eventdocument_ratedoc') ? Zend_Registry::get('eventdocument_ratedoc') : null;

    //SET NO RENDER IF VIEWER CAN NOT VIEW THE DOCUMENTS
    $can_view = $event->authorization()->isAllowed($viewer, 'view');
    if (empty($can_view) || empty($eventdocument_ratedoc)) {
      return $this->setNoRender();
    }

    //CHECK THAT RATING IS VIEABLE OR NOT
    $show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('eventdocument.rating', 1);
    if (empty($show_rate) || empty($eventdocument_ratedoc)) {
      return $this->setNoRender();
    }

    //FETCH DOCUMENTS
    $params = array();
    $params['event_id'] = $event->event_id;
    $params['orderby'] = 'rating DESC';
    $params['zero_count'] = 'rating';
    $params['limit'] = $this->_getParam('itemCount', 3);
    $this->view->paginator = Engine_Api::_()->getDbtable('documents', 'eventdocument')->widgetDocumentsData($params);

    if (Count($this->view->paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}