<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebookse
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksefeed_Api_Core extends Core_Api_Abstract {

  /**
   * Gets a paginator for facebookse
   *
   * @param Core_Model_Item_Abstract $user The user to get the messages for
   * @return Zend_Paginator
   */
  public function sendFacebookFeed($event) {

    $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
    if (!empty($enable_fboldversion)) {
      $socialdnamodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('socialdna');
      $socialdnaversion = $socialdnamodule->version;
      if ($socialdnaversion >= '4.1.1') {
        $enable_fboldversion = 0;
      }
    }
    if (empty($enable_fboldmodule)) {
      //CHECK IF LIKE MODULE IS ENABLE OR NOT.WE ARE DOING THIS FOR INTEGRATING FACEBOOK LIKE TO SITE LIKE.
      $enable_facebooksemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');
      $front = Zend_Controller_Front::getInstance();
      $session = new Zend_Session_Namespace();
      $session->feed_reset = false;
      $session->fb_feed_allow = 0;
      $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();

      //NOW GETTING THE SENDING TYPE OF FEED .EITHER USING GRAPH API OR USING JAVASCRIPT SDK.
      $permissionTable_feedSettings = Engine_Api::_()->getDbtable('feedsettings', 'facebookse')->getUserFeedTypesSetting($user_id);
      $currentbase_time = time();
      $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.base.time');
      $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.checkset.var');
      $controllersettings_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.lsettings');
      $controller_result_lenght = strlen($controllersettings_result_show);

      if (!empty($permissionTable_feedSettings)) {
        if (!empty($permissionTable_feedSettings['feedpublish_types'])) {
          $permissionTable_feedSettings = unserialize($permissionTable_feedSettings['feedpublish_types']);
        }
      }
      $logged_user = array();
      $phase_variables = array();
      // Create our Application instance.

      $feed_enabled = Zend_Registry::isRegistered('facebookfeed_enabled') ? Zend_Registry::get('facebookfeed_enabled') : null;

      if (!empty($enable_facebooksemodule)) {
        $payload = $event;
        $view = Zend_Registry::get('Zend_View');
        $activitActionType = $payload['type'];
        $activitActionType = str_replace('_admin', "", $activitActionType);

        try {

          if (($currentbase_time - $base_result_time > 3456000) && empty($check_result_show)) {
            if ($controller_result_lenght != 20) {
              Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.config.type', 1);
              Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.flagtype.info', 1);
              return;
            } else {
              Engine_Api::_()->getApi('settings', 'core')->setSetting('facebooksefeed.checkset.var', 1);
            }
          }

          if (empty($feed_enabled)) {
            return;
          }
          $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
          $facebooksefeed_site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.site.title');
          $base_url = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $front->getBaseUrl();
          $curr_url = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
          $module = $module_parent = $this->lcfirst($payload['object']->getModuleName());
          if ($activitActionType == 'sitepagealbum_photo_new' || $activitActionType == 'sitebusinessalbum_photo_new' || $activitActionType == 'sitegroupalbum_photo_new' || $activitActionType == 'sitestorealbum_photo_new') {
            $module = $module . 'album';
          } else if ($activitActionType == $module . '_topic_create' || $activitActionType == $module . '_topic_reply') {
            $module = $module . 'discussion';
          }
          $permissionTable_feed = Engine_Api::_()->getDbtable('mixsettings', 'facebookse')->getActivityFeedInfo($module, $activitActionType);
          if (!empty($permissionTable_feed)) {
            $permissionTable_feed = $permissionTable_feed->toArray();
          } else {
            return;
          }
          //HERE WE WILL CHECK FOR EITHER ADMIN HAS ENABLE OR DISABLE FEED PUBLISHING FOR PERTICULAR TYPE CONTENT.
          if (empty($permissionTable_feed['streampublishenable'])) {
            return;
          }

          $feedinfo['profile_href'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $payload['object']->getHref();
          if (empty($facebooksefeed_site_title)) {
            return;
          }
          //Getting the information of the creater member
          $user = Engine_Api::_()->getItem('user', $user_id);
          $user_type = Zend_Registry::get('facebookfeed_usertype');
          //MAKING AN ARRAY OF PHASE VARIABLES.
          $phase_variables['{*actor*}'] = '{*actor*}';
          $phase_variables['{*user_name*}'] = $user->displayname;
          $phase_variables['{*site_title*}'] = $site_title;
          $phase_variables['{*site_url*}'] = $base_url;
          //EXPLOAD WITH _

          $module_type = explode("_", $permissionTable_feed['resource_type']);
          $plugins_prefix = $module_parent; 
          $plugin_postfix = '_' . $module_type[1];
          $plugin_var2 = $module_type[1] . 'items';
          $plugin_var3 = $module_type[1] . '_id';
          $plugin_var1 = '';
          switch ($module_type[0]) {

            case 'sitepage':
              $plugin_var1 = 'sitepages';
              break;

            case 'sitegroup':
              $plugin_var1 = 'sitegroups';
              break;

            case 'sitebusiness':
              $plugin_var1 = 'sitebusinesses';
              break;

            case 'sitestore':
              $plugin_var1 = 'sitestores';

            case 'sitestoreproduct':
              $plugin_var1 = 'sitestoreproducts';
              break;

            case 'siteevent':
              $plugin_var1 = 'siteevents';
              break;

            case 'siteforum':
              $plugin_var1 = 'siteforums';
              break;
            
            case 'sitevideo':
              $plugin_var1 = 'sitevideos';
              break;
          
          case 'sitenews':
              $plugin_var1 = 'sitenews';
              break;
          case 'sitecrowdfunding':
              $plugin_var1 = 'sitecrowdfundings';
              break;
          
          }

          //CHECKING EITHER USER HAS SELECTED THE AUTOMATICALLY FEED PUBLISH OR USING PROMPT OR NOT TO PUBLISH FEED.

          if (!empty($permissionTable_feedSettings[$plugins_prefix . '_new'])) {
            if ($permissionTable_feedSettings[$plugins_prefix . '_new'] == 3 || ($permissionTable_feedSettings[$plugins_prefix . '_new'] == 1 && empty($show_autopublish_option))) {
              return;
            }
          } else {
            $permissionTable_feedSettings[$plugins_prefix . '_new'] = '2';
          }

          $getModuleTitle = $permissionTable_feed['module_title'];
          $getModuleDescription = $permissionTable_feed['module_description'];
          $phase_variables['{*' . $module . '_title*}'] = $payload['object']->$getModuleTitle;
          $phase_variables['{*' . $module . '_url*}'] = $feedinfo['profile_href'];
          if (isset($payload['object']->$getModuleDescription )) {
            $phase_variables['{*' . $module . '_desc*}'] = $payload['object']->$getModuleDescription ;
          }
          else {
            $phase_variables['{*' . $module . '_desc*}'] = $payload['description'];
          }
          $phase_variables['{*' . $plugin_var1 . '_home_url*}'] = $base_url . '/' . $plugin_var2;

          $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $module);
          switch ($activitActionType) {

            case 'sitestoreproduct_new':



              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 's_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $phase_variables['{*sitestore_title*}'] = $payload['store_title'];
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;

            case $plugins_prefix . '_new':
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';

              break;


            case $plugins_prefix . 'album_photo_new':


              $front = Zend_Controller_Front::getInstance();

              $moduleobject_Album = $payload['object'];
              $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting($plugins_prefix . '.manifestUrlP', $plugin_var2);
              $phase_variables['{*browse_' . $plugins_prefix . 'albums_url*}'] = $base_url . '/' . $routeStartP . '/album/viewalbum/' . $plugin_var3 . '/' . $payload['object']->$plugin_var3 . '/slug/' . $moduleobject_Album->getSlug() . '/tab/' . $front->getRequest()->getParam('tab');
              $photos_album = $payload['file_ids'];


              $image_path = '';

              if (!empty($photos_album['file'][0])) {
                $image_path = Engine_Api::_()->getItem($plugins_prefix . '_photo', $photos_album['file'][0])->getPhotoUrl('thumb.normal');
              }

              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;


            case $plugins_prefix . 'event_new':

              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'events_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab_id');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;
            
            case $plugins_prefix . '_channel_new':

              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'events_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab_id');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;


            case $plugins_prefix . 'video_new':


              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . '_videos_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['code'] = $payload['object']->code;
              $feedinfo['video_type'] = $payload['object']->type;
              $feedinfo['image_type'] = 'video';
              $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;
            
            case $plugins_prefix . '_video_new':


              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . '_videos_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['code'] = $payload['object']->code;
              $feedinfo['video_type'] = $payload['object']->type;
              $feedinfo['image_type'] = 'video';
              $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;
          
          case $plugins_prefix . '_news_new':


              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . '_news_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              
              $feedinfo['news_type'] = $payload['object']->type;
              $feedinfo['image_type'] = 'news';
              $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;
          case $plugins_prefix . '_project_new':
              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . '_project_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['project_type'] = $payload['object']->type;
              $feedinfo['image_type'] = 'project';
              $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;

            case $plugins_prefix . 'review_new':


              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . '_reviews_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('content_id');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;

            case $plugins_prefix . 'offer_new':


              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'offer_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('content_id');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;


            case $plugins_prefix . 'poll_new':



              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'polls_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;

              break;

            case $plugins_prefix . 'note_new':



              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'notes_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');




              //IF NOTE PHOTO IS NOT AVAILABE THEN WE WILL CHECK FOR PAGE PHOTO .
              if (empty($payload['object']->photo_id)) {
                $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
                $image_path = $moduleobject->getPhotoUrl('thumb.normal');
                if (empty($image_path)) {
                  $image_path = Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/' . ucfirst($plugins_prefix) . 'note/externals/images/nophoto_note_thumb_icon.png';
                }
              } else {
                $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              }
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;


            case $plugins_prefix . '_topic_create':

              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'discussions_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;


            case $plugins_prefix . '_topic_reply':

              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'discussions_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = 'image';
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;

            case $plugins_prefix . 'music_playlist_new':
              $front = Zend_Controller_Front::getInstance();
              $moduleobject = Engine_Api::_()->getItem($plugins_prefix . $plugin_postfix, $payload['object']->$plugin_var3);
              $phase_variables['{*browse_' . $plugins_prefix . 'musics_url*}'] = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $moduleobject->getHref() . '/tab/' . $front->getRequest()->getParam('tab');
              $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
              $feedinfo['image_type'] = $plugins_prefix . 'music_song';
              $songs_music = $view->form->getValues();
              $songs_music = explode(" ", $songs_music['fancyuploadfileids']);
              if (!empty($songs_music['0']))
                $filepath = Engine_Api::_()->getItemTable('storage_file')->getFile($songs_music['0'], 'song')->storage_path;
              else
                $filepath = '';

              $feedinfo['storage_path'] = $filepath;
              $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
              $feedinfo['title'] = $payload['object']->title;
              $feedinfo['subject_id'] = $payload['object']->$plugin_var3;
              break;


            default:
              $feedinfo = '';
          }

          if (strpos($image_path, "http://", 0) === false && strpos($image_path, "https://", 0) === false) {
            $image_path = (_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $image_path;
          }
          $feedinfo['link_href'] = $payload['object']->getHref();
          $feedinfo['default_image'] = $image_path;
          $feedinfo['publish_type'] = $permissionTable_feedSettings[$plugins_prefix . '_new'];
          
          if (!empty($feedinfo) && !empty($user_type)) {
            $feedinfo['feed_type'] = $activitActionType;

            $session->feed_info = $feedinfo;
          }
        } catch (Exception $e) { /* do nothing */
        }
      } else {
        $session->feed_info = '';
      }
    }
  }

  public function mapfields($phase_variables, $permissionTable_feed) {

    $permissionTable_feed_temp['streampublish_message'] = $permissionTable_feed['streampublish_message'];
    $permissionTable_feed_temp['streampublish_story_title'] = $permissionTable_feed['streampublish_story_title'];
    $permissionTable_feed_temp['streampublish_link'] = $permissionTable_feed['streampublish_link'];
    $permissionTable_feed_temp['streampublish_caption'] = $permissionTable_feed['streampublish_caption'];
    $permissionTable_feed_temp['streampublish_description'] = $permissionTable_feed['streampublish_description'];
    $permissionTable_feed_temp['streampublish_action_link_text'] = $permissionTable_feed['streampublish_action_link_text'];
    $permissionTable_feed_temp['streampublish_action_link_url'] = $permissionTable_feed['streampublish_action_link_url'];

    foreach ($phase_variables as $key => $item) {

      $permissionTable_feed_temp['streampublish_message'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_message']);
      $permissionTable_feed_temp['streampublish_story_title'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_story_title']);
      $permissionTable_feed_temp['streampublish_link'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_link']);
      $permissionTable_feed_temp['streampublish_caption'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_caption']);
      $permissionTable_feed_temp['streampublish_description'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_description']);
      $permissionTable_feed_temp['streampublish_action_link_text'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_action_link_text']);
      $permissionTable_feed_temp['streampublish_action_link_url'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_action_link_url']);
    }


    $permissionTable_feed_array['message'] = $permissionTable_feed_temp['streampublish_message'];
    $permissionTable_feed_array['story_title'] = $permissionTable_feed_temp['streampublish_story_title'];
    $permissionTable_feed_array['link'] = $permissionTable_feed_temp['streampublish_link'];
    $permissionTable_feed_array['caption'] = $permissionTable_feed_temp['streampublish_caption'];
    $permissionTable_feed_array['description'] = $permissionTable_feed_temp['streampublish_description'];
    $permissionTable_feed_array['action_link_text'] = $permissionTable_feed_temp['streampublish_action_link_text'];
    $permissionTable_feed_array['action_link_url'] = $permissionTable_feed_temp['streampublish_action_link_url'];
    return $permissionTable_feed_array;
  }

  function lcfirst($str) {
    $str[0] = strtolower($str[0]);
    return $str;
  }

}
