<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebooksefeed
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Feedssetting.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Facebooksefeed_Form_Admin_Feedssetting extends Engine_Form
{
  public function init()
  {
    $this
      ->setTitle('Facebook Feed Stories Settings')
      ->setDescription("");

    $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
    $front = Zend_Controller_Front::getInstance();
    $base_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getBaseUrl();
    

    $description =  Zend_Registry::get('Zend_Translate')->_("This plugin enables your users to publish their actions on your site onto their Facebook streams. The Feed Stories are published on the Facebook Homepages of the users and their friends, as well as on the users' Facebook Profiles. The feed stories contain appropriate media like group photo, album photo, music, video, etc. Action links in the feed stories can attract traffic to your site.<br /><br />Below, you can configure the content of the Facebook Feed stories for various actions. Every story is built up of static text and variables/tokens, where the variables are replaced by the respective actual values before publishing. The common variables available to all feed stories are:<br /> {*actor*}: User's Facebook name<br />{*user_name*}: User's name on site<br />{*site_title*}: Site's Title [%1s]<br />{*site_url*}: Site's URL [%2s]<br />");
    $description = sprintf($description, $site_title,  $base_url);
  	
    
		$this->addElement('Text', 'facebooksefeed_lsettings', array(
		'label' => 'Enter License key',
		'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
		'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.lsettings'),
		));

	  if( APPLICATION_ENV == 'production' ) {
	    $this->addElement('Checkbox', 'environment_mode', array(
		'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
		'description' => 'System Mode',
		'value' => 1,
	    ));
	  } else {
	    $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
	  }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
      'label' => 'Activate Your Plugin Now',
      'type' => 'submit',
      'ignore' => true
    ));

    $setting_array = array(1 => 'Yes', 0 => 'No');
    $this->addElement('Radio', 'fb_my_facebook_link', array(
				'label' => 'My Facebook Link',
				'description' => "Do you want the 'My Facebook' link to appear in the left navigation on Member Home Page? <br />(This link will lead to the 'Settings' page of the user for Facebook Feeds.)",
				'multiOptions' => $setting_array,
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('fb.my.facebook.link', 1)
		));
  
      $this->fb_my_facebook_link->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND'));
     
    $this->addElement('Radio', 'show_autopublish', array(
				'label' => 'Auto Feed Publishing',
				'description' => "Do you want automatic facebook feed publishing to be enabled on your site for respective user actions? If enabled, users will see an option for it in their facebook feed publishing settings. [Note: Automatic facebook feed publishing for user actions might be against Facebook's recently updates terms.]",
				'multiOptions' => $setting_array,
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('show.autopublish', 1)
		));
  
      $this->show_autopublish->getDecorator('Description')->setOptions(array('escape' => false,'placement' => 'PREPEND'));
     
     $this->addElement('Dummy', 'show_manual', array(
      'content' => $description,
			
    ));

    $feed_type =  Zend_Controller_Front::getInstance()->getRequest()->getParam('type', null);
    $enabled_modules_array = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
    $enabled_modules_array[] = 'home';
    
    $mixsetting_table = Engine_Api::_()->getDbTable('mixsettings', 'facebookse');
    $mixsetting_table_name = $mixsetting_table->info('name');
    $select = $mixsetting_table->select()
            ->from($mixsetting_table_name, array('activityfeed_type', 'activityfeedtype_text', 'module'))
             ->where('module IN (?)', (array)$enabled_modules_array);
    $modules_ActivityTypes = $select->query()->fetchAll();
    
    $feedstype_array = array('' => 'Select');
    foreach ($modules_ActivityTypes as $module_feedtype) {
      $feedstype_array[$module_feedtype['activityfeed_type']] = $module_feedtype['activityfeedtype_text'];
      if ($module_feedtype['activityfeed_type'] == $feed_type)
        $module = $module_feedtype['module'];      
     }

    //$feedstype_array[0] = 'Select';
    $this->addElement('Select', 'activityfeed_type', array(
				'label' => 'Choose Action',
				'multiOptions' => $feedstype_array,
				'onchange' => 'javascript:fetchtypeSettings(this.value);',
				'ignore' => true
		));
    $plugins_temp = str_replace('sitepage', "", $feed_type);
    if ($plugins_temp == $feed_type) { 
      
      $plugins_temp = str_replace('sitebusiness', "", $feed_type);
      if ($plugins_temp == $feed_type) {
        
        $plugins_temp = str_replace('siteevent', "", $feed_type);
      if ($plugins_temp == $feed_type) {
        $plugins_prefix = 'sitegroup';
        $plugin_var1 = 'sitegroups';
      } else {
        $plugins_prefix = 'siteevent';
        $plugin_var1 = 'siteevent';
      }
      }
      else {
        $plugins_prefix = 'sitebusiness';
        $plugin_var1 = 'sitebusinesses';
      }
    }  
    else {
      $plugins_prefix = 'sitepage';
      $plugin_var1 = 'sitepages';
    }
    
    if (!empty($feed_type)) {
			switch ($module) { 
          
          case 'forum':
  				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*forum_title*}, {*forum_url*}, {*forum_desc*}, {*browse_forums_url*}, {*forumtopic_title*}, {*forumtopic_url*}, {*forumtopic_desc*}, {*browse_forumtopic_url*}';
  				  break;
  				case 'user':
  				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*profile_url*}';
  				  break;
  				  
  				case 'home':
  				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*site_description*}, {*signup_page*}';
  				  break;
  				  
  				case 'list':
  				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*listing_title*}, {*listing_url*}, {*listing_desc*}, {*browse_listing_url*}';
  				  break;
          
           case 'sitestoreproduct':
  				   $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*sitestore_title*}, {*sitestoreproduct_title*}, {*sitestoreproduct_url*}, {*sitestoreproduct_desc*}, {*browse_sitestoreproduct_url*}';
  				  break;
  				  
  				case ''. $plugins_prefix :
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'_title*}, {*'. $plugins_prefix .'_url*}, {*'. $plugins_prefix .'_desc*}, {*'. $plugin_var1 .'_home_url*}';
				  break;
				  
				case ''. $plugins_prefix .'event':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'event_title*}, {*'. $plugins_prefix .'event_url*}, {*'. $plugins_prefix .'event_desc*}, {*browse_'. $plugins_prefix .'events_url*}';
				  break;
				  
				case ''. $plugins_prefix .'note':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'note_title*}, {*'. $plugins_prefix .'note_url*}, {*'. $plugins_prefix .'note_desc*}, {*browse_'. $plugins_prefix .'notes_url*}';
				  break;

				case ''. $plugins_prefix .'review':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'review_title*}, {*'. $plugins_prefix .'review_url*}, {*'. $plugins_prefix .'review_desc*}, {*browse_'. $plugins_prefix .'reviews_url*}';
				  break;

				case ''. $plugins_prefix .'album':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'album_title*}, {*'. $plugins_prefix .'album_url*}, {*'. $plugins_prefix .'album_desc*}, {*browse_'. $plugins_prefix .'albums_url*}';
				  break;

				case ''. $plugins_prefix .'video':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'video_title*}, {*'. $plugins_prefix .'video_url*}, {*'. $plugins_prefix .'video_desc*}, {*browse_'. $plugins_prefix .'videos_url*}';
				  break;

				case ''. $plugins_prefix .'poll':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'poll_title*}, {*'. $plugins_prefix .'poll_url*}, {*'. $plugins_prefix .'poll_desc*}, {*browse_'. $plugins_prefix .'polls_url*}';
				  break;

				case ''. $plugins_prefix .'discussion':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'discussion_title*}, {*'. $plugins_prefix .'discussion_url*}, {*'. $plugins_prefix .'discussion_desc*}, {*browse_'. $plugins_prefix .'discussions_url*}';
				  break;

				case ''. $plugins_prefix .'discussion':
				  $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*'. $plugins_prefix .'discussion_title*}, {*'. $plugins_prefix .'discussion_url*}, {*'. $plugins_prefix .'discussion_desc*}, {*browse_'. $plugins_prefix .'discussions_url*}';
				  break;       
  			  
          default:
             $variable = '{*actor*}, {*user_name*}, {*site_title*}, {*site_url*}, {*' . $module . '_title*}, {*' . $module . '_url*}, {*' . $module . '_desc*}, {*browse_' . $module . '_url*}';
          
        }
         
			$this->addElement('Radio', 'streampublishenable', array(
				'label' => 'Enable Facebook Feeds',
				'description' => 'Do you want Facebook Feeds Publishing to be enabled for this action? (If yes, then users will be able to choose if they want Facebook Feeds to be published for this action, and whether the feed publishing should be automatic, or a dialog prompt should be shown for it.)',
				'multiOptions' => array(
					'1' => 'Yes',
					'0'=> 'No'	
				),
				'value' => 1,
				'onclick' => 'javascript:show_hideform(this);'
				
				));
			if (!empty($variable)) {
				$this->addElement('Dummy', 'feed_var', array (
						'content' => $variable,
						'description' => 'You may use these variables / tokens in the fields below.'
					));
			}
//			$this->addElement('Text', 'user_message_prompt', array(
//					'label' => 'User Message Prompt',
//					'description' => '',
//					'value' => '',
//					'style' => 'width:300px;', 
//			));

			 $this->addElement('Text', 'streampublish_message', array(
  					'label' => 'Message',
  					'description' => 'This is the message to prefill the text field that the user will type in.',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  
        $this->addElement('Text', 'streampublish_story_title', array(
  					'label' => 'Story Title',
  					'description' => 'This is the main title of the Facebook Feed Story. It appears in the story as a link pointing to the URL that you can specify in the Link field below.',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  			
  			$this->addElement('Text', 'streampublish_link', array(
  					'label' => 'Link',
  					'description' => 'This is the link URL of the Story Title attached to the feed post.',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  
  			$this->addElement('Text', 'streampublish_caption', array(
  					'label' => 'Caption',
  					'description' => 'This is the caption of the Story Title link (appears beneath the title).',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  
  	  	$this->addElement('Text', 'streampublish_description', array(
  					'label' => 'Description',
  					'description' => 'This is the description of the Feed story (appears beneath the story caption).',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  
  			$this->addElement('Text', 'streampublish_action_link_text', array(
  					'label' => 'Action Link Text',
  					'description' => 'This is the text of the action link that will appear next to the "Comment" and "Like" link under the Feed Story posts.',
  					'value' => '',
  					'style' => 'width:300px;',
  			));
  
  			$this->addElement('Text', 'streampublish_action_link_url', array(
  					'label' => 'Action Link URL',
  					'description' => 'This is the URL of the action link that will appear next to the "Comment" and "Like" link under the Feed Story posts.',
  					'value' => '',
  					'style' => 'width:300px;',
  			));

			$this->addElement('Button', 'submit', array(
					'label' => 'Save Settings',
					'type' => 'submit',
					'ignore' => true,
					
			));
		}
   }
 }
?>