<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Facebooksefeed
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2011-01-06 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facebooksefeed_Plugin_Core {

    //hook called always on creation of content for the facebook pop
    public function addActivity($event) {

        $request = Zend_Controller_Front::getInstance()->getRequest();
        //IF OUR SITEMOBILE MODULE IS ENABLED AND SITE IS IN MOBILE MODE THEN RETURN....

        $sitemobile = Engine_Api::_()->getDbTable('modules', 'core')->isModuleEnabled('sitemobile');
        if (!empty($sitemobile) && (Engine_API::_()->sitemobile()->checkMode('mobile-mode'))) {
            return;
        }

        //CHECK IF ADMIN
        if (substr($request->getPathInfo(), 1, 5) == "admin") {
            return;
        }

        //CHECK IF SOCIALENGINE MOBI PLUGIN IS ENABLED AND SITE IS IN MOBILE MODE THEN RETURN;
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('mobi')) {
            $mobile = $request->getParam("mobile");
            $session = new Zend_Session_Namespace('mobile');

            if ($mobile == "1") {
                $mobile = true;
                $session->mobile = true;
            } elseif ($mobile == "0") {
                $mobile = false;
                $session->mobile = false;
            } else {
                if (isset($session->mobile)) {
                    $mobile = $session->mobile;
                } else {
                    if (Engine_Api::_()->mobi()->isMobile()) {
                        $mobile = true;
                        $session->mobile = true;
                    } else {
                        $mobile = false;
                        $session->mobile = false;
                    }
                }
            }

            if ($mobile) {
                return;
            }
        }
        $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
        if (!empty($enable_fboldversion)) {
            $socialdnamodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('socialdna');
            $socialdnaversion = $socialdnamodule->version;
            if ($socialdnaversion >= '4.1.1') {
                $enable_fboldversion = 0;
            }
        }
        if (empty($enable_fboldmodule)) {
            //CHECK IF LIKE MODULE IS ENABLE OR NOT.WE ARE DOING THIS FOR INTEGRATING FACEBOOK LIKE TO SITE LIKE.
            $enable_facebooksemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse');
            $front = Zend_Controller_Front::getInstance();
            $session = new Zend_Session_Namespace();
            $session->feed_reset = false;
            $session->fb_feed_allow = 0;
            if (!empty($session->fb_redirect_uri)) {
                unset($session->fb_redirect_uri);
            }
            if (!empty($session->feed_info)) {
                unset($session->feed_info);
            }
            $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();

            //NOW GETTING THE SENDING TYPE OF FEED .EITHER USING GRAPH API OR USING JAVASCRIPT SDK.
            $permissionTable_feedSettings = Engine_Api::_()->getDbtable('feedsettings', 'facebookse')->getUserFeedTypesSetting($user_id);

            $currentbase_time = time();
            $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.base.time');
            $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.checkset.var');
            $controllersettings_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.lsettings');
            $controller_result_lenght = strlen($controllersettings_result_show);

            if (!empty($permissionTable_feedSettings)) {

                if (!empty($permissionTable_feedSettings['feedpublish_types'])) {
                    $permissionTable_feedSettings = unserialize($permissionTable_feedSettings['feedpublish_types']);
                }
            }
            $logged_user = array();
            $phase_variables = array();
            // Create our Application instance.

            $feed_enabled = Zend_Registry::isRegistered('facebookfeed_enabled') ? Zend_Registry::get('facebookfeed_enabled') : null;

            if (!empty($enable_facebooksemodule)) {
                $payload = $event->getPayload();
                $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
                $activitActionType = $payload['type'];
                try {

                    if (($currentbase_time - $base_result_time > 3456000) && empty($check_result_show)) {
                        if ($controller_result_lenght != 20) {
                            Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.config.type', 1);
                            Engine_Api::_()->getApi('settings', 'core')->setSetting('facebookse.flagtype.info', 1);
                            return;
                        } else {
                            Engine_Api::_()->getApi('settings', 'core')->setSetting('facebooksefeed.checkset.var', 1);
                        }
                    }

                    if (empty($feed_enabled)) {
                        return;
                    }
                    $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
                    $facebooksefeed_site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('facebooksefeed.site.title');
                    $base_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getBaseUrl();
                    $curr_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
                    $module = $this->lcfirst($payload['object']->getModuleName());
                    //CHECKING IF THE FEED IS COMING FROM SITEPAGE OR SITEBUSINESS OR SITEGROUP AND THEIR EXTENSIONS THEN WE WILL NOT HANDLE THOSE FEEDS FROM HERE. WE WILL HANDLE THOSE FEEDS FROM API/CORE.PHP FILE
                    $module_type = explode("_", $activitActionType);
                    $plugins_prefix = '';
                    switch (@$module_type[0]) {

                        case 'sitepage':
                            $plugins_prefix = 'sitepage';
                            break;
                        case 'sitegroup':
                            $plugins_prefix = 'sitegroup';
                            break;
                        case 'sitebusiness':
                            $plugins_prefix = 'sitebusiness';
                            break;
                        case 'sitestore':
                            $plugins_prefix = 'sitestore';
                            break;
                        case 'siteevent':
                            $plugins_prefix = 'siteevent';
                            break;
                        case 'sitestoreproduct':
                            $plugins_prefix = 'sitestoreproduct';
                            break;
                    }

                    if ($plugins_prefix)
                        return;

                    $permissionTable_feed = Engine_Api::_()->getDbtable('mixsettings', 'facebookse')->getActivityFeedInfo($module, $activitActionType);

                    //HERE WE WILL CHECK FOR EITHER ADMIN HAS ENABLE OR DISABLE FEED PUBLISHING FOR PERTICULAR TYPE CONTENT.
                    if (empty($permissionTable_feed) || empty($permissionTable_feed->streampublishenable)) {
                        return;
                    } else {
                        $permissionTable_feed = $permissionTable_feed->toarray();
                    }
                    $feedinfo['profile_href'] = 'http://' . $_SERVER['HTTP_HOST'] . $payload['object']->getHref();
                    if (empty($facebooksefeed_site_title)) {
                        return;
                    }
                    //Getting the information of the creater member
                    $user = Engine_Api::_()->getItem('user', $user_id);
                    $user_type = Zend_Registry::get('facebookfeed_usertype');
                    //MAKING AN ARRAY OF PHASE VARIABLES.
                    $phase_variables['{*actor*}'] = $user->displayname;
                    $phase_variables['{*user_name*}'] = $user->displayname;
                    $phase_variables['{*site_title*}'] = $site_title;
                    $phase_variables['{*site_url*}'] = $base_url;

                    //CHECKING IF ADMIN HAS ALLOWED USERS TO PUBLISH THEIR POST AUTO OR NOT.
                    $show_autopublish_option = Engine_Api::_()->getApi('settings', 'core')->getSetting('show.autopublish', 1);
                    //GETTING THE BROWSE URL OF THE CORROSPONDING MODULE.
                    $coreMenuItemTable = Engine_Api::_()->getDbtable('menuItems', 'core');

                    //THIS IS THE SPECIAL CASE OF SITEREVIEW PLUGIN.
                    if ($module == 'sitereview') {
                        $browserURLName = 'core_main_sitereview_listtype_' . $payload['object']->listingtype_id;
                    } else
                        $browserURLName = 'core_main_' . $module;
                    $browesUrlRow = $coreMenuItemTable->fetchRow(array('name = ?' => $browserURLName));


                    if ($browesUrlRow) {

                        $moduleBrowserURL = Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), $browesUrlRow->params['route'], true);
                    }

                    switch ($activitActionType) {

                        case 'signup':
                            $field = 'signup';
                            break;
                        case 'profile_photo_update':
                            $field = 'profile_update';
                            break;

                        case 'forum_topic_create':
                            $field = 'forum_create_post';
                            $module = 'forumtopic';
                            break;

                        case 'forum_topic_reply':
                            $field = 'forum_reply_post';
                            $module = 'forumtopic';
                            break;

                        case 'recipe_new':
                        case 'sitepage_new':
                        case 'sitebusiness_new':
                        case 'siteevent_new':
                        case 'sitegroup_new':
                        case 'sitestoreproduct_new':
                            $field = $activitActionType;
                            break;

                        case 'list_new':
                            $field = 'list_post';
                            $module = 'listing';

                            break;
                        
                        case 'sitenews_new':
                                $module = 'sitenews';
                                break;

                        default:
                            $field = $module . '_post';
                    }


                    if (!empty($permissionTable_feedSettings[$field])) {
                        if ($permissionTable_feedSettings[$field] == 3 || ($permissionTable_feedSettings[$field] == 1 && empty($show_autopublish_option))) {
                            return;
                        }
                    } else {
                        $permissionTable_feedSettings[$field] = '2';
                    }

                    $moduleTitle = $permissionTable_feed['module_title'];
                    $moduleDescription = $permissionTable_feed['module_description'];
                    if (isset($payload['object']->$moduleTitle)) {
                        $phase_variables['{*' . $module . '_title*}'] = $payload['object']->$moduleTitle;
                        $phase_variables['{*' . $module . '_url*}'] = $feedinfo['profile_href'];
                        $phase_variables['{*' . $module . '_desc*}'] = $payload['object']->$moduleDescription;
                        $phase_variables['{*browse_' . $module . '_url*}'] = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $moduleBrowserURL;
                    }
                    if ($activitActionType == 'profile_photo_update') {

                        $phase_variables['{*profile_url*}'] = $feedinfo['profile_href'];
                    }

                    if ($this->lcfirst($payload['object']->getModuleName()) == 'forum') {
                        $phase_variables['{*browse_' . $module . '_url*}'] = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $moduleBrowserURL . '/' . $payload['object']->forum_id;
                        $forum_obj = Engine_Api::_()->getItem('forum', $payload['object']->forum_id);
                        $phase_variables['{*forum_url*}'] = $base_url . '/forums/' . $payload['object']->forum_id;
                        $phase_variables['{*forum_title*}'] = $forum_obj->title;
                        $phase_variables['{*forum_desc*}'] = $forum_obj->description;
                        $phase_variables['{*browse_forums_url*}'] = $base_url . '/forums/';
                        $phase_variables['{*' . $module . '_desc*}'] = $_POST['body'];
                    }

                    $feedinfo = Engine_Api::_()->facebooksefeed()->mapfields($phase_variables, $permissionTable_feed);
                    $feedinfo['link_href'] = $payload['object']->getHref();
                    $feedinfo['image_type'] = 'image';
                    if ($activitActionType == 'album_photo_new') {
                        $photos_album = $view->form->getValues();

                        if (!empty($photos_album['file'][0])) {
                            $image_path = Engine_Api::_()->getItem('album_photo', $photos_album['file'][0])->getPhotoUrl('thumb.normal');
                        }
                    } else if ($activitActionType == 'music_playlist_new') {
                        $feedinfo['title'] = $payload['object']->title;
                        $songs_music = $view->form->getValues();
                        $songs_music = explode(" ", $songs_music['fancyuploadfileids']);
                        $filepath = Engine_Api::_()->getItemTable('storage_file')->getFile($songs_music['0'], 'song')->storage_path;
                        $feedinfo['storage_path'] = $filepath;
                        $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
                        $feedinfo['image_type'] = 'music_song';
                    } else if ($activitActionType == 'video_new') {
                        $feedinfo['image_type'] = 'video';
                        $feedinfo['video_type'] = $payload['object']->type;
                        $feedinfo['code'] = $payload['object']->code;
                        $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
                    } else if ($activitActionType == 'profile_photo_update') {

                        $image_path = Engine_Api::_()->user()->getViewer()->getPhotoUrl('thumb.normal');
                        if (!empty($image_path)) {
                            if (strpos($image_path, "http://", 0) === false && strpos($image_path, "https://", 0) === false) {
                                $image_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $image_path;
                            }
                        } else {
                            $image_path = $base_url . '/application/modules/User/externals/images/nophoto_user_thumb_profile.png';
                        }
                    } else if ($activitActionType == 'document_new') {
                        $feedinfo['image_type'] = 'document';
                        $feedinfo['document_id'] = $payload['object']->document_id;
                        $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
                    } else {
                        $image_path = Engine_Api::_()->facebookse()->itemphoto($payload['object'], $this->lcfirst($payload['object']->getModuleName()));
                    }


                    if (strpos($image_path, "http://", 0) === false && strpos($image_path, "https://", 0) === false) {
                        $image_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $image_path;
                    }
                    $feedinfo['default_image'] = $image_path;
                    $feedinfo['publish_type'] = $permissionTable_feedSettings[$field];

                    if (!empty($feedinfo) && !empty($user_type)) {
                        $feedinfo['feed_type'] = $activitActionType;
                        $session->feed_info = $feedinfo;
                    }
                } catch (Exception $e) { /* do nothing */
                }
            } else {
                $session->feed_info = '';
            }
        }
    }

    public function mapfields($phase_variables, $permissionTable_feed) {
        
        $permissionTable_feed_temp['streampublish_message'] = $permissionTable_feed['streampublish_message'];
        $permissionTable_feed_temp['streampublish_story_title'] = $permissionTable_feed['streampublish_story_title'];
        $permissionTable_feed_temp['streampublish_link'] = $permissionTable_feed['streampublish_link'];
        $permissionTable_feed_temp['streampublish_caption'] = $permissionTable_feed['streampublish_caption'];
        $permissionTable_feed_temp['streampublish_description'] = $permissionTable_feed['streampublish_description'];
        $permissionTable_feed_temp['streampublish_action_link_text'] = $permissionTable_feed['streampublish_action_link_text'];
        $permissionTable_feed_temp['streampublish_action_link_url'] = $permissionTable_feed['streampublish_action_link_url'];
        
        foreach ($phase_variables as $key => $item) {

            $permissionTable_feed_temp['streampublish_message'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_message']);
            $permissionTable_feed_temp['streampublish_story_title'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_story_title']);
            $permissionTable_feed_temp['streampublish_link'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_link']);
            $permissionTable_feed_temp['streampublish_caption'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_caption']);
            $permissionTable_feed_temp['streampublish_description'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_description']);
            $permissionTable_feed_temp['streampublish_action_link_text'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_action_link_text']);
            $permissionTable_feed_temp['streampublish_action_link_url'] = str_replace($key, $item, $permissionTable_feed_temp['streampublish_action_link_url']);
        }

        $permissionTable_feed_array['message'] = $permissionTable_feed_temp['streampublish_message'];
        $permissionTable_feed_array['story_title'] = $permissionTable_feed_temp['streampublish_story_title'];
        $permissionTable_feed_array['link'] = $permissionTable_feed_temp['streampublish_link'];
        $permissionTable_feed_array['caption'] = $permissionTable_feed_temp['streampublish_caption'];
        $permissionTable_feed_array['description'] = $permissionTable_feed_temp['streampublish_description'];
        $permissionTable_feed_array['action_link_text'] = $permissionTable_feed_temp['streampublish_action_link_text'];
        $permissionTable_feed_array['action_link_url'] = $permissionTable_feed_temp['streampublish_action_link_url'];
        return $permissionTable_feed_array;
    }

    function lcfirst($str) {
        $str[0] = strtolower($str[0]);
        return $str;
    }

}
