<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ItemCreate.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Form_Admin_Menu_ItemCreate extends Engine_Form
{
  public function init()
  {
    $this
      ->setTitle('Create New Link')
      ->setAttrib('class', 'global_form_popup')
      ;

    $this->addElement('Text', 'title', array(
      'label' => 'Label',
      'required' => true,
      'allowEmpty' => false,
    ));

    $this->addElement('Text', 'link', array(
      'label' => 'URL',
      'allowEmpty' => true,
      'style' => 'width: 300px',
    ));

    $this->addElement('file', 'icon', array(
      'label' => 'Icon For This Menu',
    ));

    $this->addElement('Checkbox', 'enabled', array(
      'label' => 'Enabled?',
      'checkedValue' => '1',
      'uncheckedValue' => '0',
      'value' => '1',
    ));

    // Buttons
    $this->addElement('Button', 'submit', array(
      'label' => 'Create',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));

    $this->addElement('Cancel', 'cancel', array(
      'label' => 'cancel',
      'link' => true,
      'prependText' => ' or ',
      'href' => '',
      'onclick' => 'parent.Smoothbox.close();',
      'decorators' => array(
        'ViewHelper'
      )
    ));
    
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }
}