<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Form_Admin_Settings extends Engine_Form {

    public function init() {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Global Settings")))
                ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("These settings affect all members in your community.")));


        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $baseURL = $view->baseUrl();
        $facelightLendingBlockValue = $coreSettings->getSetting('facelight.lending.block', null);
        if (empty($facelightLendingBlockValue) || is_array($facelightLendingBlockValue)) {
            $facelightLendingBlockValue = '<div id="show_help_content" style="width:1200px;margin:0 auto;display:table;"><div>
<span style="font-size:48px;color:#292929;float:left;width:100%;text-align:center;margin:80px 0 0 0;position:absolute;top:0;left:0;right:0;clear:both;">How It Works !</span>
<div style="float: left; margin: 10px 0; opacity: 1; padding: 125px 0; text-align: center; width: 33.3%;"><a href="' . $baseURL . '/videos"><span style=" background-position: center bottom; background-repeat: no-repeat;  height: 175px; margin: 0 auto; width: 175px; background-image: url(' . $baseURL . '/application/modules/Facelight/externals/images/post-video.png); display: block;">&nbsp;</span></a> <a href="' . $baseURL . '/videos"> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Ubuntu, sans-serif; font-size: 22px; margin-top: 40px; text-align: center; width: 100%;">Post & Watch Videos</span> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Open Sans, sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%;">Post the videos, watch the videos and share the videos.</span> </a></div>
<div style="float: left; margin: 10px 0; opacity: 1; padding: 125px 0; text-align: center; width: 33.3%;"><a href="' . $baseURL . '/channels"><span style=" background-position: center 50%; background-repeat: no-repeat;  height: 175px; margin: 0 auto; width: 175px; background-image: url(' . $baseURL . '/application/modules/Facelight/externals/images/create-channel.png); display: block;">&nbsp;</span></a> <a href="' . $baseURL . '/channels"> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Ubuntu, sans-serif; font-size: 22px; margin-top: 40px; text-align: center; width: 100%;">Create & Explore Channels</span> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Open Sans, sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%;">Create your channel and explore the channels.</span></a></div>
<div style="float: left; margin: 10px 0; opacity: 1; padding: 125px 0; text-align: center; width: 33.3%;"><a href="' . $baseURL . '/videos/playlists/browse"><span style=" background-position: center 50%; background-repeat: no-repeat;  height: 175px; margin: 0 auto; width: 175px; background-image: url(' . $baseURL . '/application/modules/Facelight/externals/images/create-playlist.png); display: block;">&nbsp;</span></a> <a href="' . $baseURL . '/videos/playlists/browse"> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Ubuntu, sans-serif; font-size: 22px; margin-top: 40px; text-align: center; width: 100%;">Create and Share Playlists</span> <span style="color: #fff;text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); float: left; font-family: Open Sans, sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%;">Create playlists for your loved videos and share the playlists.</span></a></div>
<a style="text-indent: 100px; height: 20px; width: 20px; position: absolute; top: 12px; background-image: url(' . $baseURL . '/application/modules/Facelight/externals/images/close-icon.png);" href="#">.</a></div></div>';
        } else {
            $facelightLendingBlockValue = @base64_decode($facelightLendingBlockValue);
        }

        //WORK FOR MULTILANGUAGES START
        $localeMultiOptions = Engine_Api::_()->facelight()->getLanguageArray();

        $defaultLanguage = $coreSettings->getSetting('core.locale.locale', 'en');
        $total_allowed_languages = Count($localeMultiOptions);
        if (!empty($localeMultiOptions)) {
            foreach ($localeMultiOptions as $key => $label) {
                $lang_name = $label;
                if (isset($localeMultiOptions[$label])) {
                    $lang_name = $localeMultiOptions[$label];
                }

                if (!strstr($key, '_')) {
                    $key = $key . '_default';
                }
                $page_block_tagline_field = "facelight_lending_page_block_tagline_$key";
                $page_block_title_field = "facelight_lending_page_block_title_$key";


                $keyForSettings = str_replace('_', '.', $key);

                $value = '<h3 style="font-size: 20px; line-height: 30px; font-weight: bold !important; margin-top: 40px; color: #0e385f;">Connect with friends and family around<br> the world with My World Go<br><img src="' . $baseURL . '/application/modules/Facelight/externals/images/tag4.png" alt="" width="521" height="237"><br><br><br></h3>';
                $facelightLendingBlockTaglineValueMulti = $coreSettings->getSetting('facelight.lending.page.block.tagline.languages.' . $keyForSettings, $value);
                if (empty($facelightLendingBlockTaglineValueMulti)) {
                    $facelightLendingBlockTaglineValueMulti = $facelightLendingBlockTaglineValueMulti;
                } else {
                    $facelightLendingBlockTaglineValueMulti = @base64_decode($facelightLendingBlockTaglineValueMulti);
                }


                $page_block_tagline_label = sprintf(Zend_Registry::get('Zend_Translate')->_("Sign Up Form Tagline and Image in %s"), $lang_name);
                if ($total_allowed_languages <= 1) {
                    $page_block_tagline_field = "facelight_lending_page_block_tagline";
                    $page_block_tagline_label = "Sign Up Form Icons and Taglines";
                } elseif ($label == 'en' && $total_allowed_languages > 1) {
                    $page_block_tagline_field = "facelight_lending_page_block_tagline";
                }
                $editorOptions = Engine_Api::_()->facelight()->tinymceEditorOptions();
                $editorOptions['height'] = '500px';
                
                $this->addElement('TinyMce', $page_block_tagline_field, array(
                    'label' => $page_block_tagline_label,
                    'description' => "Configure the tagline and image that gets displayed with Sign Up form on the landing page.",
                    'attribs' => array('rows' => 24, 'cols' => 80, 'style' => 'width:200px; max-width:200px; height:240px;'),
                    'value' => $facelightLendingBlockTaglineValueMulti,
                    'filters' => array(
                        new Engine_Filter_Html(),
                        new Engine_Filter_Censor()),
                    'editorOptions' => $editorOptions,
                ));
            }
        }
        //WORK FOR MULTILANGUAGES END
        //GET DESCRIPTION
        // $description = sprintf(Zend_Registry::get('Zend_Translate')->_(" You can change the columns width of any widgetized page by placing the 'Column Width' widget available at %s under SocialEngineAddOns Core widgets."), '<a href="admin/content" target="_blank">layout editor</a>');

        // $this->addElement('Dummy', 'facelight_column_width', array(
        //     'label' => 'Change Column Width of Widgetized Page',
        //     'description' => $description
        // ));
        // $this->facelight_column_width->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $apiSettings = Engine_Api::_()->getApi('settings', 'core');
        
        $this->addElement('Text', 'theme_left_width', array(
            'label' => 'Left Column Width (in px)',
            'description' => 'Enter the width for the left column of your site below.  [ Column width must be set in 200px-300px range. ]',
            'value' => $apiSettings->getSetting('theme.left.width', 250),
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(200),
            ),
        ));
        $this->theme_left_width->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $this->addElement('Text', 'theme_right_width', array(
            'label' => 'Right Column Width (in px)',
            'description' => 'Enter the width for the right column of your site below. [ Column width must be set in 200px-300px range. ]',
            'value' => $apiSettings->getSetting('theme.right.width', 300),
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(200),
            ),
        ));
        $this->theme_right_width->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $this->addElement('Radio', 'facelight_floating_header', array(
            'label' => 'Floating Header',
            'description' => 'Do you want to enable floating header ?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => $apiSettings->getSetting('facelight.floating.header', 1),
        ));

        $this->addElement('Radio', 'facelight_circular_image', array(
            'label' => 'Member\'s Thumbnail Images in Circular',
            'description' => 'Do you want to display member\'s thumbnail images in circular shape ?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => $apiSettings->getSetting('facelight.circular.image', 1),
        ));
        $this->addElement('Radio', 'facelight_navigation_drawer', array(
            'label' => 'Navigation Drawer',
            'description' => 'Do you want to show navigation drawer?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'onclick' => 'showHidePanelOption(this.value)',
            'value' => $apiSettings->getSetting('facelight.navigation.drawer', 1),
        ));
        $this->addElement('Radio', 'facelight_panel_menu_layout', array(
            'label' => 'Navigation Drawer Layout',
            'description' => 'Select the layout for Navigation Drawer.',
            'multiOptions' => array(
                'left_panel panel_layout_overlay' => 'Drawer Left With Overlay',
                'left_panel panel_layout_fixed' => 'Drawer Left Without Overlay',
                'right_panel panel_layout_overlay' => 'Drawer Right With Overlay',
                'right_panel panel_layout_fixed' => 'Drawer Right Without Overlay'
            ),
            'value' => $apiSettings->getSetting('facelight.panel.menu.layout','left_panel panel_layout_overlay'),
        ));
        // $this->addElement('Text', 'facelight_explore_link_view_more_limit', array(
        //     'label' => 'Explore Links Viewmore Limit',
        //     'description' => 'Enter the number after which you want to show view more option for explore links.',
        //     'value' => $apiSettings->getSetting('facelight.explore.link.view.more.limit', 2),
        // ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Submit',
            'type' => 'submit',
            'decorators' => array(
                'ViewHelper',
            ),
        ));
    }

}
