<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Form_Admin_Widget_Content extends Engine_Form {

    public function init() {

        $this
                ->setAttrib('id', 'form-upload');
        $this->addElement('Radio', 'showImages', array(
            'label' => "Select the images that you want to show in the image rotator on landing page? [You can upload new images and manage existing ones from the 'Images' tab available in the admin panel of FB Clone Theme.]",
            'multiOptions' => array(
                1 => 'Show All Images.',
                0 => 'Select the images.'
            ),
            'value' => 1,
            'onclick' => 'showMultiCheckboxImageOptions()'
        ));

        $listImage = Engine_Api::_()->getItemTable('facelight_image')->getImages(array('enabled' => 1));
        $listArray = array();
        foreach ($listImage->toArray() as $images) {
            $listArray[$images['image_id']] = $images['title'];
        }

        $this->addElement('MultiCheckbox', 'selectedImages', array(
            'multiOptions' => $listArray,
            'label' => 'Please select the images.',
                //'value' => 1,
        ));

        $this->addElement('Text', 'width', array(
            'label' => 'Enter the width for the images. [Left blank for 100% width]',
            'value' => '',
        ));

        $this->addElement('Text', 'height', array(
            'label' => 'Enter the height for the images.',
            'value' => 583,
        ));

        $this->addElement('Text', 'speed', array(
            'label' => 'Enter the delay for the images to rotate in image rotator in milliseconds (ms).',
            'value' => 5000,
        ));

        $this->addElement('Radio', 'order', array(
            'label' => 'How do you want to rotate the images?',
            'multiOptions' => array(
                2 => 'Random',
                1 => 'Descending',
                0 => 'Ascending'
            ),
            'value' => 2,
        ));

        // Get available files
        $logoOptions = Engine_Api::_()->facelight()->getImages(array('' => 'Text-only (No logo)'));

        $this->addElement('Radio', 'showLogo', array(
            'label' => "Do you want to display your website's logo on the top-left side on images rotator?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showLogoOptions()'
        ));

        $this->addElement('Select', 'logo', array(
            'label' => 'Select the site logo for your website. [You can upload a new file from: "Layout" > "File & Media Manager".]',
            'multiOptions' => $logoOptions,
        ));


        $this->addElement('Radio', 'facelightBrowseMenus', array(
            // 'label' => 'Browse Menus',
            'label' => "Do you want to enable main menu with more dropdown option in the header? [If enabled, all the main menu links of your website will show up with more dropdown option.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showBrowseMenusOptions()'
        ));

        $this->addElement('Text', 'max', array(
            'label' => "How many menus do you want to show in the header?",
            'value' => 20
        ));

        $this->addElement('Radio', 'facelightSignupLoginLink', array(
            // 'label' => 'Sign Up / Sign In Link',
            'label' => "Do you want to show Sign Up / Sign In links in the top header area?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
        ));

        $this->addElement('Radio', 'facelightFirstImprotantLink', array(
            //'label' => 'First Important link',
            'label' => "Do you want to show a button in the header area to display an important link of your website? [Configure the Title and URL for this button below.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
            'onclick' => 'showFirstLinksOptions()'
        ));

        $this->addElement('Text', 'facelightFirstTitle', array(
            'label' => 'Header Button Title',
            'value' => 'Important Title & Link',
            'style' => 'width:350px;',
        ));

        $this->addElement('Text', 'facelightFirstUrl', array(
            'label' => 'Header Button URL',
            'value' => '#',
            'style' => 'width:350px;',
        ));

        $this->addElement('Text', 'facelightHtmlTitle', array(
            'label' => 'Enter the title that you want to display on this image rotator.',
            'value' => 'BRING PEOPLE TOGETHER',
            'style' => 'width:350px;',
        ));

        $this->addElement('Text', 'facelightHtmlDescription', array(
            'label' => 'Enter the description that you want to display on this image rotator.',
            'value' => 'Watch Videos, Explore Channels and Create & Share Playlists.',
            'style' => 'width:350px;',
        ));

        $this->addElement('Radio', 'facelightHowItWorks', array(
            'label' => "Do you want to display an action button like 'Get Started', 'How It Works', etc on the image rotator? (You can configure this button from the administration of Facelight Theme, and can also configure the slide-down content that comes after clicking of this button.)",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1
        ));

        $this->addElement('Radio', 'facelightSignupLoginButton', array(
            'label' => "Do you want to show the Sign In and Sign Up buttons on this image rotator? [If enabled, they will get displayed at the bottom of the rotator.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
        ));
        $isEventModuleEnabled = Engine_Api::_()->hasModuleBootstrap('siteevent');
        $isVideoModuleEnabled = Engine_Api::_()->hasModuleBootstrap('sitevideo');
        $options = array();
        $value = 1;
        if ($isEventModuleEnabled) {
            $options[2] = 'Advanced Events Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-events-plugin\'>Advanced Events Plugin</a>")';
            $value = 2;
        }
        if ($isVideoModuleEnabled) {
            $options[3] = 'Advanced Videos Search (from "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-videos-plugin\'>Advanced Videos Plugin</a>")';
            $value = 3;
        }
        $options[1] = 'Advanced Search [Dependent on "<a target=\'_blank\' href=\'http://www.socialengineaddons.com/socialengine-advanced-search-plugin\'>Advanced Search Plugin</a>"] / Global Search';
        $options[0] = 'None';
        $this->addElement('Radio', 'facelightSearchBox', array(
            'label' => 'Select the Search Box that you want to display in the bottom part of this widget.',
            'multiOptions' => $options,
            'escape' => false,
            'value' => $value,
        ));
        if (Engine_Api::_()->hasModuleBootstrap('sitecitycontent') && Engine_Api::_()->hasModuleBootstrap('siteadvsearch')) {

            $this->addElement('Radio', 'showLocationBasedContent', array(
                'label' => 'Show results based on the location, saved in user’s browser cookie.',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => 0,
            ));

            $this->addElement('Radio', 'showLocationSearch', array(
                'label' => 'Do you want to enable location based searching?',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => 0,
            ));
        }
    }

}
?>

<script type="text/javascript">
    var form = document.getElementById("form-upload");
    window.addEvent('domready', function () {
        showFirstLinksOptions();
        showLogoOptions();
        showBrowseMenusOptions();
        showMultiCheckboxImageOptions();
    });

    function showMultiCheckboxImageOptions() {
        if (form.elements["showImages"].value == 1) {
            $('selectedImages-wrapper').style.display = 'none';
        } else {
            $('selectedImages-wrapper').style.display = 'block';
        }
    }
    function showBrowseMenusOptions() {
        if (form.elements["facelightBrowseMenus"].value == 1) {
            $('max-wrapper').style.display = 'block';
        } else {
            $('max-wrapper').style.display = 'none';
        }
    }

    function showLogoOptions() {
        if (form.elements["showLogo"].value == 1) {
            $('logo-wrapper').style.display = 'block';
        } else {
            $('logo-wrapper').style.display = 'none';
        }
    }
    function showFirstLinksOptions() {
        if (form.elements["facelightFirstImprotantLink"].value == 1) {
            $('facelightFirstTitle-wrapper').style.display = 'block';
            $('facelightFirstUrl-wrapper').style.display = 'block';
        } else {
            $('facelightFirstTitle-wrapper').style.display = 'none';
            $('facelightFirstUrl-wrapper').style.display = 'none';
        }
    }

</script>