<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function onRenderLayoutDefault($event) {
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $controllerName = $request->getControllerName();
        $moduleName = $request->getModuleName();
        $actionName = $request->getActionName();
        $view = $event->getPayload();
        $view->headTranslate(array("Forgot Password?", "Login with Twitter", "Login with Facebook", "Mark as Read", "Mark as Unread"));
        $view->headLink()->appendStylesheet('https://fonts.googleapis.com/css?family=Roboto|Source+Sans+Pro');
        $view->headLink()->appendStylesheet($view->layout()->staticBaseUrl . 'application/modules/Facelight/externals/styles/style.css');

        $view->headScript()->appendFile($view->layout()->staticBaseUrl . 'application/modules/Facelight/externals/scripts/core.js');

        $circularImageTheme = Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.circular.image', 1);
        if ($circularImageTheme) {
            $view->headLink()->appendStylesheet($view->layout()->staticBaseUrl . 'application/themes/facelight/theme_circular.css');
        }
        if($controllerName == 'signup'){
            
           $widgetParams = $this->getWidgetInfoByPage('core_index_index','facelight.login-signup-tagline');
          if (!empty($widgetParams)) {
          $showSignupFields = (!empty($widgetParams->params)) ? $widgetParams->params['showSignupFields'] : '';
          $showSignupElementDescription = empty($widgetParams->params['show_signup_field_description']) ? 0 : 1;
           if ($showSignupFields && in_array('timezone', $showSignupFields) && in_array('language', $showSignupFields)) {
$includeSignupFormScript = <<<EOF
                   
        en4.core.runonce.add(function(){
           var globalContentElement = en4.facelight.getDomElements('content');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper'))
              $(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper').setStyle('display', 'block');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper')) {
              $(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper').setStyle('display', 'block');
           } 
        });
EOF;
        
 } elseif ($showSignupFields && in_array('timezone', $showSignupFields)){
        $includeSignupFormScript = <<<EOF
                   
        en4.core.runonce.add(function(){
           var globalContentElement = en4.facelight.getDomElements('content');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper'))
              $(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper').setStyle('display', 'none');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper')) {
              $(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper').setStyle('display', 'block');
           } 
        });
EOF;
 } elseif ($showSignupFields && in_array('language', $showSignupFields)) {
        $includeSignupFormScript = <<<EOF
                   
        en4.core.runonce.add(function(){
           var globalContentElement = en4.facelight.getDomElements('content');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper'))
              $(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper').setStyle('display', 'block');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper')) {
              $(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper').setStyle('display', 'none');
           } 
        });
EOF;
 } else { 
        $includeSignupFormScript = <<<EOF
                   
        en4.core.runonce.add(function(){
           var globalContentElement = en4.facelight.getDomElements('content');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper'))
              $(globalContentElement).getElement('#signup_account_form').getElement('#language-wrapper').setStyle('display', 'none');
           if ($(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper')) {
              $(globalContentElement).getElement('#signup_account_form').getElement('#timezone-wrapper').setStyle('display', 'none');
           } 
        });
EOF;
}
           $includeSignupFormScript = $includeSignupFormScript . <<<EOF
                   
        en4.core.runonce.add(function(){
            var globalContentElement = en4.facelight.getDomElements('content');
            var showSignupElementDescription = ($showSignupElementDescription == 0) ? true : false;
            var topLevelId = 0;
            if($(globalContentElement).getElement('#signup_account_form') && $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type')){ 
                if($(globalContentElement).getElement('#signup_account_form').getElement('#profile_type-label')) $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type').getFirst('option').innerHTML = $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type-label').getFirst('label').innerHTML;
               $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type').addEvent('change',function(){ 
                if(this.value == '' && !this.hasClass('facelight_form_error_tip')){ this.addClass('facelight_form_error_tip'); }else if(this.value != ''){ this.removeClass('facelight_form_error_tip'); }
                topLevelId = this.value;
            });
            }
            if($(globalContentElement).getElement('#signup_account_form')) {
                $(globalContentElement).getElement('#signup_account_form').getElements("input[type!=hidden]").each(function (item) {
                var label = item.getParent().getParent().getFirst('.form-label');
                if(label && label.getFirst('label')) {
                    item.placeholder =  label.getFirst('label').textContent;
                }
                if(label && label.getFirst('label') && label.getFirst('label').hasClass('required')) {
                        item.addEvent('blur',function(){ if(item.value == '' && !item.hasClass('facelight_form_error_tip')) { item.addClass('facelight_form_error_tip'); } if(item.hasClass('facelight_form_error_display_tip')){ item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('keyup',function(){ if(item.value != '' && item.hasClass('facelight_form_error_tip')) { item.removeClass('facelight_form_error_tip'); item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('focus',function(){ if(item.value == '' && (item.hasClass('facelight_form_error_tip') && !item.hasClass('facelight_form_error_display_tip'))) { item.addClass('facelight_form_error_display_tip'); } });
                }
                 if(showSignupElementDescription && item.getParent().getFirst('.hint')) item.getParent().getFirst('.hint').hide();
                 if(item.getParent().getFirst('.description')){
                    if(showSignupElementDescription) item.getParent().getFirst('.description').setStyle('display','none');
                    item.getParent().getFirst('.description').inject(item.getParent(),'bottom');
                }
                  
                });
                
                if($(globalContentElement).getElement('#signup_account_form').getElements('label[for="birthdate"]')[0]) { 
                   $(globalContentElement).getElement('#signup_account_form').getElements('label[for="birthdate"]').getParent().getParent().inject($(globalContentElement).getElement('#signup_account_form').getElement('#terms-wrapper'),'before');
                   $(globalContentElement).getElement('#signup_account_form').getElements('label[for="birthdate"]').getParent().getParent().addClass('birthdate_element_wrapper');
                }
                if($(globalContentElement).getElement('#signup_account_form').getElements('label[for="gender"]')[0]) $(globalContentElement).getElement('#signup_account_form').getElements('label[for="gender"]').getParent().getParent().inject($(globalContentElement).getElement('#signup_account_form').getElement('#terms-wrapper'),'before');
            $(globalContentElement).getElement('#signup_account_form').addEvent('submit', function(event){
                var inValid = false;
                $(globalContentElement).getElement('#signup_account_form').getElements("input[type!=hidden]").each(function (item) {
                var label = item.getParent().getParent().getFirst('.form-label');
                if(label && label.getFirst('label') && label.getFirst('label').hasClass('required')) {
                    if(item.value == '' && (!item.get('data-field-id') ||(item.get('data-field-id') && item.hasClass('option_'+topLevelId)))) { item.addClass('facelight_form_error_tip'); inValid = true; }
                    }
                });
                if($(globalContentElement).getElement('#signup_account_form').getElement('#profile_type') && $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type').type != 'hidden'){ 
                    if($(globalContentElement).getElement('#signup_account_form').getElement('#profile_type').value == ''){ $(globalContentElement).getElement('#signup_account_form').getElement('#profile_type').addClass('facelight_form_error_tip'); inValid = true; }
                }
                if(inValid) event.stop();
            });
 
           }else if($(globalContentElement).getElement('form')){
               $(globalContentElement).getElement('form').getElements("input[type!=hidden]").each(function (item) {
                if(item.getParent().getParent().getFirst('.form-label').getFirst('label')) {
                    item.placeholder =  item.getParent().getParent().getFirst('.form-label').getFirst('label').textContent;
                 }
                 if(showSignupElementDescription && item.getParent().getFirst('.hint')) item.getParent().getFirst('.hint').hide();
                 if(item.getParent().getFirst('.description')){
                    if(showSignupElementDescription) item.getParent().getFirst('.description').setStyle('display','none');
                    item.getParent().getFirst('.description').inject(item.getParent(),'bottom');
                }
                 if(item.getParent().getParent().getFirst('.form-label').getFirst('label') && item.getParent().getParent().getFirst('.form-label').getFirst('label').hasClass('required')) {
                        item.addEvent('blur',function(){ if(item.value == '' && !item.hasClass('facelight_form_error_tip')) { item.addClass('facelight_form_error_tip'); } if(item.hasClass('facelight_form_error_display_tip')){ item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('keyup',function(){ if(item.value != '' && item.hasClass('facelight_form_error_tip')) { item.removeClass('facelight_form_error_tip'); item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('focus',function(){ if(item.value == '' && (item.hasClass('facelight_form_error_tip') && !item.hasClass('facelight_form_error_display_tip'))) { item.addClass('facelight_form_error_display_tip'); } });

                }
                });
           }    
        });
EOF;
           $view->headScript()->appendScript($includeSignupFormScript);
         }
        } elseif ($actionName == 'login' || $actionName == 'requireuser')   {
            $includeLoginFormScript =  <<<EOF
                   
        en4.core.runonce.add(function(){
            var globalContentElement = en4.facelight.getDomElements('content');
            if($(globalContentElement).getElement('#user_form_login')) {
               $(globalContentElement).getElement('#user_form_login').getElements("input[type!=hidden]").each(function (item) {
                    if(item.getParent().getParent().getFirst('.form-label').getFirst('label')) {
                    item.placeholder =  item.getParent().getParent().getFirst('.form-label').getFirst('label').textContent;
                    if(item.getParent().getParent().getFirst('.form-label').getFirst('label') && item.getParent().getParent().getFirst('.form-label').getFirst('label').hasClass('required')) {
                        item.addEvent('blur',function(){ if(item.value == '' && !item.hasClass('facelight_form_error_tip')) { item.addClass('facelight_form_error_tip'); } if(item.hasClass('facelight_form_error_display_tip')){ item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('keyup',function(){ if(item.value != '' && item.hasClass('facelight_form_error_tip')) { item.removeClass('facelight_form_error_tip'); item.removeClass('facelight_form_error_display_tip'); } });
                        item.addEvent('focus',function(){ if(item.value == '' && (item.hasClass('facelight_form_error_tip') && !item.hasClass('facelight_form_error_display_tip'))) { item.addClass('facelight_form_error_display_tip'); } });
                }
                 }
        });
           }    
        });
EOF;
         $view->headScript()->appendScript($includeLoginFormScript);
        }
        $floating_header = Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.floating.header', 1);
        $backgroundImage = '';
        if ((Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.customization', 0) == 3) && !Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.choose.website.image.color', 1)) {
            $backgroundImage = Engine_Api::_()->getApi('settings', 'core')->getSetting('facelight.theme.website.body.background.image', 0);
            $backgroundImage = Engine_Api::_()->core()->getFileUrl($backgroundImage);
        }
        $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
        $active = $themeTable->select()
                ->from($themeTable->info('name'), 'active')
                ->where('name = ?', 'facelight')
                ->where('active = ?', 1)
                ->query()
                ->fetchColumn()
        ;

        if ($active) {

            $includeThemeBasedClass = <<<EOF
                    var floating_header = '$floating_header';
                    var backgroundImage = '$backgroundImage';
        en4.core.runonce.add(function(){ 
        
                setTimeout(function () {
                    if(backgroundImage)    
                    document.getElementsByTagName("BODY")[0].setStyle('background-image', 'url("$backgroundImage")');
                    if(($$('.layout_siteusercoverphoto_user_cover_photo').length > 0) || ($$('.layout_sitecontentcoverphoto_content_cover_photo').length > 0)) {
                      
         
                   /*if ($$('.layout_main')) {
                     $$('.layout_main').setStyles({
                    'width' : '1200px',
                    'margin' : '0 auto'
                     });
                   }*/
           
             
                    } 
                }, 100);
                
                if(floating_header) {  
                  window.addEvent('scroll', function () { 
                    var scrollTop = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
                    if ( scrollTop > 0 && $$(".layout_page_header") && !$$(".layout_page_header").hasClass('fixed')[0]) {
                        $$(".layout_page_header").addClass("fixed");
                    } else {
                        if(scrollTop == 0) {
                          $$(".layout_page_header").removeClass("fixed");
                        }
                    }
                  });
                }
              
        });
EOF;
            $view->headScript()->appendScript($includeThemeBasedClass);
        }
    }

    public function onRenderLayoutDefaultSimple($event) {
        // Forward
        return $this->onRenderLayoutDefault($event, 'simple');
    }

    public function onUserLoginAfter($event) {
        $payload = $event->getPayload();
        if (isset($_COOKIE['seaocore_list_logins_users'])) {
            setcookie('seaocore_list_logins_users', Zend_Json::encode(array_unique(array_merge(array('user_id_' . $payload->getIdentity() => $payload->getIdentity()), Zend_Json::decode($_COOKIE['seaocore_list_logins_users'])))), time() + 3600, '/');
        } else {
            setcookie('seaocore_list_logins_users', Zend_Json::encode(array('user_id_' . $payload->getIdentity() => $payload->getIdentity())), time() + 3600, '/');
        }
    }
    public function getWidgetInfoByPage($pageName = '',$widgetName = ''){
            $tableNamePages = Engine_Api::_()->getDbtable('pages', 'core');
            $page_id = $tableNamePages->select()
                    ->from($tableNamePages->info('name'), array('page_id'))
                    ->where('name =?', $pageName)
                    ->query()
                    ->fetchColumn();
            if(!empty($page_id)){
                $tableContent = Engine_Api::_()->getDbtable('content', 'core');
                $tableContentName = $tableContent->info('name');
                //GET CONTENT
                $select = $tableContent->select()
                        ->from($tableContentName, array('content_id', 'params'))
                        ->where('page_id = ?', $page_id)
                        ->where('name = ?', $widgetName);

            return $tableContent->fetchRow($select);
        }
    }

    public function routeShutdown(Zend_Controller_Request_Abstract $request) {
      if(strpos($request->getPathInfo(), "admin") !== false) { return; }
      $layout = Zend_Layout::getMvcInstance();
      $layout->setViewBasePath(APPLICATION_PATH . "/application/modules/Facelight/layouts", 'Core_Layout_View')
        ->setViewSuffix('tpl')
        ->setLayout(null);

    }
}
