<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminCustomizationController.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_AdminCustomizationController extends Core_Controller_Action_Admin {

    private function _getCustomCSS($values) {
        $returnTheme = null;
        if (!empty($values) && isset($values['facelight_theme_customization'])) {
            switch ($values['facelight_theme_customization']) {
                case 0: // DEFAULT THEME 
                    $returnTheme .= 'theme_color: #3b5998; button_border_color:#29487d; landingpage_signinbtn:#4267b2; landingpage_signupbtn: #4267b2; theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #4267b2;';
                    break;

                case 1: // PINK COLOR BASED THEME
                    $returnTheme .= 'theme_color: #ff5a5f; button_border_color:#ff2f34; landingpage_signinbtn:#ff5a5f; landingpage_signupbtn: rgba(63, 200, 244, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #e6777a;';
                    break;

                case 2: // GREEN COLOR BASED THEME
                    $returnTheme .= 'theme_color: #038c7e; button_border_color:#007165; landingpage_signinbtn:#038c7e; landingpage_signupbtn: rgba(63, 200, 244, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #22a598;';
                    break;

                case 4: // DARK SKY BLUE COLOR BASED THEME
                    $returnTheme .= 'theme_color: #3eaacd; button_border_color:#047da5; landingpage_signinbtn:#3eaacd; landingpage_signupbtn: rgba(191, 84, 143, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #73bfd8;';
                    break;

                case 5: // VOILET COLOR BASED THEME
                    $returnTheme .= 'theme_color: #9351a6; button_border_color:#7c3490; landingpage_signinbtn:#9351a6; landingpage_signupbtn: rgba(63, 200, 244, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #ba74ce;';
                    break;

                case 6: // ORANGE COLOR BASED THEME
                    $returnTheme .= 'theme_color: #bc5300; button_border_color:#a24a05; landingpage_signinbtn:#bc5300; landingpage_signupbtn: rgba(255, 95, 63, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #cf752e;';
                    break;

                case 7: // SUNFLOWER COLOR BASED THEME
                    $returnTheme .= 'theme_color: #f1c40f; button_border_color:#c29d0b; landingpage_signinbtn:#f1c40f; landingpage_signupbtn: rgba(255, 95, 63, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #fedc53;';
                    break;

                case 8: // YELLOW COLOR BASED THEME
                    $returnTheme .= 'theme_color: #b0bf0a; button_border_color:#909d00; landingpage_signinbtn:#b0bf0a; landingpage_signupbtn: rgba(63, 200, 244, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #d2dd57;';
                    break;

                case 9: // EMERALD COLOR BASED THEME
                    $returnTheme .= 'theme_color: #2ecc71; button_border_color:#20a257; landingpage_signinbtn:#2ecc71; landingpage_signupbtn: rgba(255, 95, 63, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #56db8e;';
                    break;

                case 10: // DARK PINK COLOR BASED THEME
                    $returnTheme .= 'theme_color: #e63c61; button_border_color:#d90f3a; landingpage_signinbtn:#e63c61; landingpage_signupbtn: rgba(255, 95, 63, .5); theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #ea718b;';
                    break;

                case 3: // CUSTOM COLOR BASED THEME
                    $returnTheme .= 'theme_color: ' . $values['facelight_theme_color'] . '; button_border_color:' . $values['facelight_theme_button_border_color'] .
                     // '; landingpage_signinbtn: ' . $values['facelight_landingpage_signinbtn'] . 
                     ';theme_background_color: ' . $values['facelight_theme_background_color'] . '; theme_containers_background_color: ' . $values['facelight_theme_containers_background_color'] . ';';
                    break;
            }
        }

        $apiSettings = Engine_Api::_()->getApi('settings', 'core');
        $rightWidth = $apiSettings->getSetting('theme.right.width', 300);
        $leftWidth = $apiSettings->getSetting('theme.left.width', 250);
        $propertiesString = ' theme_content_columns_left_width: '. $leftWidth .'px; theme_content_columns_right_width: '. $rightWidth .'px;';

        return $returnTheme.$propertiesString;
    }

    public function indexAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('facelight_admin_main', array(), 'facelight_admin_theme_customization');

        $this->view->form = $form = new Facelight_Form_Admin_Customization();

        if (!$this->getRequest()->isPost())
            return;

        if (!$form->isValid($this->getRequest()->getPost()))
            return;

        $values = $form->getValues();

        $getCustomCSS = $this->_getCustomCSS($values);
        $global_directory_name = APPLICATION_PATH . '/public/seaocore_themes';
        $global_settings_file = $global_directory_name . '/facelightThemeConstants.css';
        $is_file_exist = @file_exists($global_settings_file);
        if (empty($is_file_exist)) {
            if (!is_dir($global_directory_name)) {
                @mkdir($global_directory_name, 0777);
            }
            @chmod($global_directory_name, 0777);

            $fh = @fopen($global_settings_file, 'w') or die('Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/, then try again.');
            @fwrite($fh, $getCustomCSS);
            @fclose($fh);

            @chmod($global_settings_file, 0777);
            $successfullyAdded = true;
        } else {
            if (!is_writable($global_settings_file)) {
                @chmod($global_settings_file, 0777);
                if (!is_writable($global_settings_file)) {
                    $form->addError('Unable to write Constant CSS file; please give the CHMOD 777 recursive permission to the directory /public/seaocore_themes/, then try again.');
                    return;
                }
            }
            $successfullyAdded = @file_put_contents($global_settings_file, $getCustomCSS);
        }

        foreach ($values as $key => $value) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
        }

        if (!empty($successfullyAdded)) {
            Core_Model_DbTable_Themes::clearScaffoldCache();

            $form->addNotice('Changes successfully saved. If changes not reflect to frontend then please change the mode to Development.');
        }
    }

}
