<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SignupController.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Facelight_SignupController extends Core_Controller_Action_Standard {

    public function indexAction() {
        // If the user is logged in, they can't sign up now can they?
        if (Engine_Api::_()->user()->getViewer()->getIdentity()) {
            return $this->_helper->redirector->gotoRoute(array(), 'default', true);
        }

        $formSequenceHelper = $this->_helper->formSequence;
        foreach (Engine_Api::_()->getDbtable('signup', 'user')->fetchAll() as $row) {
            if ($row->enable == 1) {
                $class = $row->class;
                $formSequenceHelper->setPlugin(new $class, $row->order);
            }
        }

        // This will handle everything until done, where it will return true
        if (!$this->_helper->formSequence()) {
            return;
        }
    }

    public function deleteAction() {
        $user_id = $this->_getParam('user_id');
        $seaocore_list_login_users = $_COOKIE['seaocore_list_logins_users'];
        $json_decode = (array) json_decode($seaocore_list_login_users);
        unset($json_decode['user_id_' . $user_id]);
        if (count($json_decode) == 0) {
            setcookie('seaocore_list_logins_users', "", time() - 3600, '/');
        } else {
            setcookie('seaocore_list_logins_users', json_encode($json_decode), time() + 3600, '/');
        }
    }

}
