<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Facelight_Installer extends Engine_Package_Installer_Module {

        protected $_deependencyVersion = array(
            'sitecontentcoverphoto' => '4.9.4',
            'sitemenu' => '4.9.4p10',
            'siteusercoverphoto' => '4.9.4',
            'sitenews' => '4.9.4p5',
            'sitereview' => '4.9.4p9',
            'sitequicksignup' => '4.9.4p7'
        );

    public function onPreInstall()
    {
        $errorMsg = $this->_checkDeependency();
        if( !empty($errorMsg) ) {
            $this->_error($errorMsg);
            return;
        }
        parent::onPreInstall();
    }

    public function onInstall() {
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $sitemobile = $select->query()->fetchObject();
        if (!empty($sitemobile)) {
            $db->query("UPDATE `engine4_core_modules` SET `enabled` = '0' WHERE `engine4_core_modules`.`name` = 'mobi';");
        }
        

        //CHECK THAT ALBUM PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemenu')
                ->where('enabled = ?', 1);
        $check_sitemenu = $select->query()->fetchObject();
        if (!empty($check_sitemenu)) {
            $db->query("INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES
('facelight_core_mini_admin', 'core', 'Admin', 'Facelight_Plugin_Menus', '', 'user_settings', '', 1, 0, 10),
( 'facelight_core_mini_auth', 'user', 'Sign Out', 'Facelight_Plugin_Menus', '', 'user_settings', '', 1, 0, 11),
( 'facelight_core_mini_signin', 'user', 'Sign In', 'Facelight_Plugin_Menus', '', 'core_mini', '', 1, 0, 12);
");
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'core_mini_auth';");
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'core_mini_admin';");

            //CHECK THAT ALBUM PLUGIN IS INSTALLED OR NOT
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'siteeventticket')
                    ->where('enabled = ?', 1);
            $check_siteeventticket = $select->query()->fetchObject();
            if (!empty($check_siteeventticket)) {
                $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '0' WHERE `engine4_core_menuitems`.`name` = 'core_mini_siteeventticketmytickets';");

                $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES
("facelight_siteeventticket_main_ticket", "siteeventticket", "My Tickets", "Facelight_Plugin_Menus", \'{"route":"siteeventticket_order", "action":"my-tickets"}\', "user_settings", "", 1, 0, 9)');
            }
        }



        $this->_createCustomizationFileInTheme("facelight");
        $this->updatePage('core_help_terms', 'Trust But Verify', 'We Believe on you so You Can');
        $this->updatePage('core_help_contact', 'We Cherish Interactions', 'Because We Know Your Time Is Precious So, Get In Touch Now..');
        parent::onInstall();
    }

    private function _createCustomizationFileInTheme($themeName) {
        $global_directory_name = APPLICATION_PATH . '/application/themes/' . $themeName;
        @chmod($global_directory_name, 0777);

        if (!is_readable($global_directory_name)) {
            return $this->_error("<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
  Path Name: <b>" . $global_directory_name . "</b></span>");
        }

        $global_settings_file = $global_directory_name . '/customization.css';
        $is_file_exist = @file_exists($global_settings_file);
        if (empty($is_file_exist)) {
            @chmod($global_directory_name, 0777);
            if (!is_writable($global_directory_name)) {
                return $this->_error("<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
  Path Name: " . $global_directory_name . "</span>");
            }

            $fh = @fopen($global_settings_file, 'w');
            @fwrite($fh, '/* ADD CUSTOM STYLE */');
            @fclose($fh);

            @chmod($global_settings_file, 0777);
        }
    }

    public function onPostInstall(){
        if($this->getSetting('facelight.default.setup',0)){ return false; }
        $this->defaulWidgetSettings();
        $db = Zend_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'core')
                ->where('enabled = ?', 1);
        $check_module = $select->query()->fetchObject();
        if(!empty($check_module) && $check_module->version < '4.9.4p4'){
            $global_directory_name = APPLICATION_PATH . '/application/libraries/Engine/View/';
            $local_directory_name = APPLICATION_PATH . '/application/modules/Facelight/externals/default';
            @chmod($global_directory_name, 0777);
            copy($local_directory_name . '/Layout.php',$global_directory_name . '/Layout.php');
            copy($local_directory_name . '/Content.php',$global_directory_name . '/Helper/Content.php');
        }
        
    }

    public function setDefaultLayout() {
        $this->getBackupOfHomePage();
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

        $db = Zend_Db_Table::getDefaultAdapter();
        $page_id = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'user_index_home')
                ->limit(1)
                ->query()
                ->fetchColumn();
        $page_parent_id = $db->select()
                ->from('engine4_core_content', 'content_id')
                ->where('type = ?', 'container')
                ->where('name = ?', 'left')
                ->where('page_id =? ',$page_id)
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (!empty($page_id) && !empty($page_parent_id)) {
        
        $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = 'user.home-photo'  OR `engine4_core_content`.`name`='facelight.user-shortcuts' OR `engine4_core_content`.`name`='facelight.explore-links' OR `engine4_core_content`.`name`='user.home-links' OR `engine4_core_content`.`name`='facelight.home-links' OR `engine4_core_content`.`name`='facelight.home-photo' OR `engine4_core_content`.`name`='sitemember.profile-photo-sitemembers'");       
        $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.home-photo',
                'page_id' => $page_id,
                'parent_content_id' => $page_parent_id,
                'params' => '',
                'order' => 1,
            ));
        $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.user-shortcuts',
                'page_id' => $page_id,
                'parent_content_id' => $page_parent_id,
                'params' => '{"title":"Shortcuts","name":"facelight.user-shortcuts"}',
                'order' => 2,
            ));
        $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.explore-links',
                'page_id' => $page_id,
                'parent_content_id' => $page_parent_id,
                'params' => '{"parent":"0","title":"Explore","nomobile":"0","name":"facelight.explore-links"}',
                'order' => 3,
            ));

    }
        $db = Zend_Db_Table::getDefaultAdapter();
        
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings', 'value')
                ->where('name = ?', 'core.general.site.title');
        $title = $select->query()->fetchColumn();
        $title = !empty($title) ? $title : $view->translate('_SITE_TITLE');
        
        $strLength = strlen($title);
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemenu')
                ->where('enabled = ?', 1);
        $check_module = $select->query()->fetchObject();
        $isSitemenuModEnabled = !empty($check_module) ? $check_module->enabled : 0;
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'siteadvsearch')
                ->where('enabled = ?', 1);
        $check_module = $select->query()->fetchObject();
        $isAdvSearchModEnabled = !empty($check_module) ? $check_module->enabled : 0;
        $page_id = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'footer')
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (!empty($page_id)) {
            $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");

            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $main_id = $db->lastInsertId();
            
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.language',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 2,
            ));
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.menu-footer',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 3,
            ));
        }

        $page_id = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'header')
                ->limit(1)
                ->query()
                ->fetchColumn();
        if (!empty($page_id)) {

            $db = Zend_Db_Table::getDefaultAdapter();
            $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 1,
            ));
            $main_id = $db->lastInsertId();

            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.html-block',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 2,
                'params' => '{"title":"","data":"<script type=\"text\/javascript\"> \r\nif(typeof(window.jQuery) !=  \"undefined\") {\r\njQuery.noConflict();\r\n}\r\n<\/script>","nomobile":"0","name":"core.html-block"}'
            ));

            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.menu-logo',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 3,
                'params' => '{"title":"","name":"core.menu-logo","logo":"","nomobile":"0"}'
            ));

            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.signup-button',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 4,
                'params' => '{"title":"","name":"facelight.signup-button"}'
            ));

            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.login-or-signup',
                'page_id' => $page_id,
                'parent_content_id' => $main_id,
                'order' => 5,
                'params' => '{"title":"","name":"facelight.login-or-signup"}'
            ));
            
         if ($isAdvSearchModEnabled) {
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'siteadvsearch.search-box',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                    'params' => '{"title":"","titleCount":true,"advsearch_search_box_width":"240","advsearch_search_box_width_for_nonloggedin":"275","nomobile":"0","name":"siteadvsearch.search-box"}'
                ));
            } else {
                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'facelight.search-box',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 6,
                    'params' => '{"facelight_on_logged_out":"0","facelight_search_width":"240","title":"","nomobile":"0","name":"facelight.search-box"}'
                ));
            }

            if ($isSitemenuModEnabled) {
                // $db->insert('engine4_core_content', array(
                //     'type' => 'widget',
                //     'name' => 'sitemenu.menu-main',
                //     'page_id' => $page_id,
                //     'parent_content_id' => $main_id,
                //     'order' => 7,
                //     'params' => '{"sitemenu_on_logged_out":"1","sitemenu_totalmenu":"2","sitemenu_truncation_limit_content":"20","sitemenu_truncation_limit_category":"20","sitemenu_is_more_link":"1","sitemenu_more_link_icon":"1","sitemenu_is_arrow":"1","sitemenu_separator_style":"3","sitemenu_show_cart":"1","sitemenu_show_in_main_options":"1","changeMyLocation":"0","sitemenu_is_fixed":"0","sitemenu_fixed_height":"0","sitemenu_show_extra_on":"0","sitemenu_style":"1","sitemenu_box_shadow":"1","sitemenu_menu_corners_style":"0","sitemenu_main_menu_height":"20","Dummy_label":null,"sitemenu_menu_link_color":"#ffffff","sitemenu_menu_background_color":"#000000","sitemenu_menu_hover_color":"#000000","sitemenu_menu_hover_background_color":"#ffffff","sitemenu_sub_link_color":"#000000","sitemenu_sub_background_color":"#ffffff","sitemenu_sub_hover_color":"#ffffff","sitemenu_totalmenu_mobile":"4","sitemenu_totalmenu_tablet":"6","title":"","nomobile":"0","name":"sitemenu.menu-main"}'
                // ));

                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'sitemenu.menu-mini',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 9,
                    'params' => '{"sitemenu_on_logged_out":"0","sitemenu_show_icon":"1","no_of_updates":"10","sitemenu_show_in_mini_options":"0","search_position":"1","changeMyLocation":"0","showLocationBasedContent":"0","sitemenu_mini_search_width":"275","sitemenu_location_box_width":"275","sitemenu_enable_login_lightbox":"1","sitemenu_enable_signup_lightbox":"1","title":"","nomobile":"0","name":"sitemenu.menu-mini"}'
                ));
            } else {
//                $db->insert('engine4_core_content', array(
//                    'type' => 'widget',
//                    'name' => 'facelight.browse-menu-main',
//                    'page_id' => $page_id,
//                    'parent_content_id' => $main_id,
//                    'order' => 7,
//                    'params' => '{"max":"3","title":"","nomobile":"0","name":"facelight.browse-menu-main"}'
//                ));

                $db->insert('engine4_core_content', array(
                    'type' => 'widget',
                    'name' => 'core.menu-mini',
                    'page_id' => $page_id,
                    'parent_content_id' => $main_id,
                    'order' => 9,
                    'params' => ''
                ));
            } 
        }
        $theme_id = $db->select()
                ->from('engine4_core_themes', 'theme_id')
                ->where('name = ?', 'facelight')
                ->limit(1)
                ->query()
                ->fetchColumn();
        if(empty($theme_id)){
            $db->query("UPDATE `engine4_core_themes` SET `active` = 0 WHERE `engine4_core_themes`.`active` = 1;");
            $db->insert('engine4_core_themes', array(
                'name' => 'facelight',
                'title' => 'FB Clone Theme',
                'description' => 'FB Clone Theme',
                'active' => 1,
            ));
        } else {
            $db->query("UPDATE `engine4_core_themes` SET `active` = 0 WHERE `engine4_core_themes`.`active` = 1;");
            $db->query("UPDATE `engine4_core_themes` SET `active` = 1 WHERE `engine4_core_themes`.`name` = 'facelight';");
        }
        $headerPageId = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'header')
                ->limit(1)->query()->fetchColumn();

        if (!empty($headerPageId)) {
            $parentContentId = $db->select()
                            ->from('engine4_core_content', 'content_id')
                            ->where('page_id = ?', $headerPageId)
                            ->where('name = ?', 'main')
                            ->where('type =?', 'container')
                            ->limit(1)->query()->fetchColumn();
            $layoutScrollContentId = $db->select()
                            ->from('engine4_core_content', 'content_id')
                            ->where('page_id = ?', $headerPageId)
                            ->where('name = ?', 'facelight.layout-scroll')
                            ->where('type =?', 'widget')
                            ->limit(1)->query()->fetchColumn();

            if (!empty($parentContentId) && empty($layoutScrollContentId)) {
                $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'facelight.layout-scroll',
                'page_id' => $headerPageId,
                'parent_content_id' => $parentContentId,
                'order' => 4,
                'params' => '[]'
            ));
            }
        }    
        // Enabled theme as well
    }

    /**
     * Get Widgetized PageId
     * @param $params
     */
    public function getBackupHomePageId($params = array()) {
        //GET CORE CONTENT TABLE
        $db = Zend_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $page = $select
                    ->from('engine4_core_pages', 'page_id')
                    ->where('url =?', 'home')
                    ->query()
                    ->fetchObject();
        return !empty($page) ? $page->page_id : 0;
    }

    public function getBackupOfHomePage() {

        $page_id = $this->getWidgetizedPageId(array('name' => 'core_index_index'));
        $tableNameContentName = 'engine4_core_content';
        $db = Zend_Db_Table::getDefaultAdapter();

        //CHECK PAGE EXIST OR NOT
        $home_backup_page_id = $this->getBackupHomePageId();

        //CREATE PAGE
        if (empty($home_backup_page_id)) {
            $db->query("INSERT IGNORE INTO `engine4_core_pages` ( `name`, `displayname`, `url`, `title`, `description`, `keywords`, `custom`, `fragment`, `layout`, `levels`, `provides`, `view_count`, `search`) VALUES (NULL, 'Landing Page - Backup of Landing Page on Installation of Facelight Theme', 'home', 'Backup of Landing Page on Installation of Facelight Theme Plugin', '', '', '0', '0', '', NULL, NULL, '0', '0');");
        }

        //GET EXISTING PAGE ID
        $home_backup_page_id = $this->getBackupHomePageId();

        $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $home_backup_page_id");
        //GET MAIN CONTAINER WORK
        $select = new Zend_Db_Select($db);
        $select = $select
                ->from($tableNameContentName, '*')
                ->where('page_id =?', $page_id)
                ->where('name =?', 'main')
                ->where('type =?', 'container');

        $mainRow = $select->query()->fetchObject();

        if (!empty($mainRow)) {

            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $home_backup_page_id,
                'parent_content_id' => null,
                'order' => $mainRow->order,
                'params' => $mainRow->params ? json_encode($mainRow->params) : ''
            ));
            $content_id = $db->lastInsertId('engine4_core_content');
            $select =  new Zend_Db_Select($db);
            $results = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $page_id)
                        ->where('name in (?)', array('left', 'middle', 'right'))
                        ->where('type =?', 'container')
                        ->where('parent_content_id =?', $mainRow->content_id)
                        ->query()
                        ->fetchAll();

            foreach ($results as $values) {
                $db->insert('engine4_core_content', array(
                    'type' => $values['type'],
                    'name' => $values['name'],
                    'page_id' => $home_backup_page_id,
                    'parent_content_id' => $content_id,
                    'order' => $values['order'],
                    'params' => $values['params']
                ));
            }

            //LEFT CONTAINER WIDGETS
            $select =  new Zend_Db_Select($db);
            $select =  $select
                            ->from($tableNameContentName, '*')
                            ->where('page_id =?', $page_id)
                            ->where('parent_content_id =?', $mainRow->content_id)
                            ->where('name =?', 'left')
                            ->where('type =?', 'container');

            $leftRow = $select->query()->fetchObject();

            if (!empty($leftRow)) {
                $select =  new Zend_Db_Select($db);
                $results =  $select
                                ->from($tableNameContentName, '*')
                                ->where('page_id =?', $page_id)
                                ->where('parent_content_id =?', $leftRow->content_id)
                                ->where('type =?', 'widget')
                                ->query()
                                ->fetchAll();

                $select = new Zend_Db_Select($db);
          $select = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $home_backup_page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'left')
                        ->where('type =?', 'container');

                $row = $select->query()->fetchObject();

                foreach ($results as $values) {
                    $db->insert('engine4_core_content', array(
                        'type' => $values['type'],
                        'name' => $values['name'],
                        'page_id' => $home_backup_page_id,
                        'parent_content_id' => $row->content_id,
                        'order' => $values['order'],
                        'params' => $values['params']
                    ));
                }
            }
            //END LEFT CONTAINER WIDGET
            //MIDDLE CONTAINER WIDGETS
            $select = new Zend_Db_Select($db);
            $select = $select
                    ->from($tableNameContentName, '*')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $mainRow->content_id)
                    ->where('name =?', 'middle')
                    ->where('type =?', 'container');

            $middleRow = $select->query()->fetchObject();

            if (!empty($middleRow)) {
                $select = new Zend_Db_Select($db);
                $results = $select
                                ->from($tableNameContentName, '*')
                                ->where('page_id =?', $page_id)
                                ->where('parent_content_id =?', $middleRow->content_id)
                                ->where('type =?', 'widget')
                                ->query()
                                ->fetchAll();

                $select = new Zend_Db_Select($db);
          $select = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $home_backup_page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->where('type =?', 'container');

                $row = $select->query()->fetchObject();

                foreach ($results as $values) {
                    $db->insert('engine4_core_content', array(
                        'type' => $values['type'],
                        'name' => $values['name'],
                        'page_id' => $home_backup_page_id,
                        'parent_content_id' => $row->content_id,
                        'order' => $values['order'],
                        'params' => $values['params']
                    ));
                }
            }
            //END MIDDLE CONTAINER WIDGET
            //RIGHT CONTAINER WIDGETS
            $select = new Zend_Db_Select($db);
            $select = $select
                    ->from($tableNameContentName, '*')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $mainRow->content_id)
                    ->where('name =?', 'right')
                    ->where('type =?', 'container');

            $rightRow = $select->query()->fetchObject();

            if (!empty($rightRow)) {
                $select = new Zend_Db_Select($db);
                $results = $select
                                ->from($tableNameContentName, '*')
                                ->where('page_id =?', $page_id)
                                ->where('parent_content_id =?', $rightRow->content_id)
                                ->where('type =?', 'widget')
                                ->query()
                                ->fetchAll();

                $select = new Zend_Db_Select($db);
                $select = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $home_backup_page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'right')
                        ->where('type =?', 'container');

                $row = $select->query()->fetchObject();

                foreach ($results as $values) {
                    $db->insert('engine4_core_content', array(
                        'type' => $values['type'],
                        'name' => $values['name'],
                        'page_id' => $home_backup_page_id,
                        'parent_content_id' => $row->content_id,
                        'order' => $values['order'],
                        'params' => $values['params']
                    ));
                }
            }
            //END RIGHT CONTAINER WIDGET
        }

        //TOP CONTAINER
        $select = new Zend_Db_Select($db);
        $select = $select
                ->from($tableNameContentName, '*')
                ->where('page_id =?', $page_id)
                ->where('name =?', 'top')
                ->where('type =?', 'container');

        $topRow = $select->query()->fetchObject();

        if (!empty($topRow)) {

            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $home_backup_page_id,
                'parent_content_id' => null,
                'order' => $topRow->order,
                //'params' => json_encode($topRow->params)
                'params' => $topRow->params ? json_encode($topRow->params) : ''
            ));
            $content_id = $db->lastInsertId('engine4_core_content');

            $select = new Zend_Db_Select($db);
            $results = $select
                    ->from($tableNameContentName, '*')
                    ->where('page_id =?', $page_id)
                    ->where('name in (?)', array('left', 'middle', 'right'))
                    ->where('type =?', 'container')
                    ->where('parent_content_id =?', $topRow->content_id)
                    ->query()
                    ->fetchAll();

            foreach ($results as $values) {
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => $values['name'],
                    'page_id' => $home_backup_page_id,
                    'parent_content_id' => $content_id,
                    'order' => $values['order'],
                    'params' => $values['params']
                ));
            }

            //MIDDLE CONTAINER WIDGETS
            $select = new Zend_Db_Select($db);
            $select = $select
                    ->from($tableNameContentName, '*')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $topRow->content_id)
                    ->where('name =?', 'middle')
                    ->where('type =?', 'container');

            $topMiddleRow = $select->query()->fetchObject();

            if (!empty($topMiddleRow)) {
                $select = new Zend_Db_Select($db);
                $results = $select
                                ->from($tableNameContentName, '*')
                                ->where('page_id =?', $page_id)
                                ->where('parent_content_id =?', $topMiddleRow->content_id)
                                ->where('type =?', 'widget')
                                ->query()
                                ->fetchAll();

                $select = new Zend_Db_Select($db);
                $select = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $home_backup_page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->where('type =?', 'container');

                $row = $select->query()->fetchObject();

                foreach ($results as $values) {
                    $db->insert('engine4_core_content', array(
                        'type' => $values['type'],
                        'name' => $values['name'],
                        'page_id' => $home_backup_page_id,
                        'parent_content_id' => $row->content_id,
                        'order' => $values['order'],
                        'params' => $values['params']
                    ));
                }
            }
            //END MIDDLE CONTAINER WIDGET
        }


        //GET BOTTOM CONTAINER
        $select = new Zend_Db_Select($db);
          $select = $select
                ->from($tableNameContentName, '*')
                ->where('page_id =?', $page_id)
                ->where('name =?', 'bottom')
                ->where('type =?', 'container');

        $bottomRow = $select->query()->fetchObject();

        if (!empty($bottomRow)) {

            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'bottom',
                'page_id' => $home_backup_page_id,
                'parent_content_id' => null,
                'order' => $bottomRow->order,
                'params' => $bottomRow->params ? json_encode($bottomRow->params) : ''
            ));
            $content_id = $db->lastInsertId('engine4_core_content');
            $select = new Zend_Db_Select($db);
            $results = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $page_id)
                        ->where('name in (?)', array('left', 'middle', 'right'))
                        ->where('type =?', 'container')
                        ->where('parent_content_id =?', $bottomRow->content_id)
                        ->query()
                        ->fetchAll();

            foreach ($results as $values) {
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => $values['name'],
                    'page_id' => $home_backup_page_id,
                    'parent_content_id' => $content_id,
                    'order' => $values['order'],
                    'params' => $values['params']
                ));
            }

            //MIDDLE CONTAINER WIDGETS
            $select = new Zend_Db_Select($db);
            $select = $select
                    ->from($tableNameContentName, '*')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $bottomRow->content_id)
                    ->where('name =?', 'middle')
                    ->where('type =?', 'container');

            $bottomMiddleRow = $select->query()->fetchObject();

            if (!empty($bottomMiddleRow)) {
                $select = new Zend_Db_Select($db);
                $results = $select
                                ->from($tableNameContentName, '*')
                                ->where('page_id =?', $page_id)
                                ->where('parent_content_id =?', $bottomMiddleRow->content_id)
                                ->where('type =?', 'widget')
                                ->query()
                                ->fetchAll();

                $select = new Zend_Db_Select($db);
                $select = $select
                        ->from($tableNameContentName, '*')
                        ->where('page_id =?', $home_backup_page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->where('type =?', 'container');

                $row = $select->query()->fetchObject();

                foreach ($results as $values) {
                    $db->insert('engine4_core_content', array(
                        'type' => $values['type'],
                        'name' => $values['name'],
                        'page_id' => $home_backup_page_id,
                        'parent_content_id' => $row->content_id,
                        'order' => $values['order'],
                        'params' => $values['params']
                    ));
                }
            }
            //END MIDDLE CONTAINER WIDGET
        }
    }

    /**
     * Get Widgetized PageId
     * @param $params
     */
    public function getWidgetizedPageId($params = array()) {
        //GET CORE CONTENT TABLE
        $db = Zend_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $page_id = $select
                    ->from('engine4_core_pages', 'page_id')
                    ->where('name =?', $params['name'])
                    ->query()
                    ->fetchColumn();
        return $page_id;
    }
    public function defaulWidgetSettings(){
        $db = Zend_Db_Table::getDefaultAdapter();

        $db->query('INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES ("facelight_admin_theme_customization", 1)');
        $view = Zend_Registry::get('Zend_View');
        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
            VALUES 
            ("facelight_admin_theme_customization", "facelight", "Theme Customization", "", \'{"route":"admin_default","module":"facelight","controller":"customization"}\', "facelight_admin_main", "", 1, 0, 4),
            ("facelight_admin_menus", "facelight", "Manage Explore Links", "", \'{"route":"admin_default","module":"facelight","controller":"menus"}\', "facelight_admin_main", "", 1, 0, 8),
            ("facelight_admin_settings_footer_menu", "facelight", "Footer Menu", "", \'{"route":"admin_default","module":"facelight","controller":"settings","action":"footer-menu"}\', "facelight_admin_main", "", 1, 0, 7),
            ("facelight_admin_layout_index", "facelight", "Layout Settings", "", \'{"route":"admin_default","module":"facelight","controller":"layout", "action": "index"}\', "facelight_admin_main", "", 1, 0, 2),
            ("facelight_mini_custom_home", "facelight", "Home", "", \'{"uri":"","icon":"","target":"","enabled":"1"}\', "core_mini", "", 1, 1, 2)
            ');

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES
            ("facelight_footer_first_column", "facelight", "First Row", NULL, \'{"uri":"javascript:void(0)"}\', "facelight_footer", NULL, "1", "1", "1"),
            ("facelight_footer_first_column_1", "facelight", "First Row - 1", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "2"), 
            ("facelight_footer_first_column_2", "facelight", "First Row - 2", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "3"), 
            ("facelight_footer_first_column_3", "facelight", "First Row - 3", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "4"), 

            ("facelight_footer_second_column", "facelight", "Second Row", NULL , \'{"uri":"javascript:void(0)"}\', "facelight_footer", NULL , "1", "1", "10"), 
            ("facelight_footer_second_column_1", "facelight", "Second Row - 1", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "11"), 
            ("facelight_footer_second_column_2", "facelight", "Second Row - 2", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "12"), 
            ("facelight_footer_second_column_3", "facelight", "Second Row - 3", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "13"), 


            ("facelight_footer_third_column", "facelight", "Third Row", NULL , \'{"uri":"javascript:void(0)"}\', "facelight_footer", NULL , "1", "1", "20"), 
            ("facelight_footer_third_column_1", "facelight", "Third Row - 1", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "21"), 
            ("facelight_footer_third_column_2", "facelight", "Third Row - 2", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "22"), 
            ("facelight_footer_third_column_3", "facelight", "Third Row - 3", "" , \'{"route":"default"}\', "facelight_footer", NULL , "1", "1", "23")
            ;');

        $db->query('INSERT IGNORE INTO `engine4_core_menus` (`name`, `type`, `title`, `order`) VALUES 
            ("facelight_footer", "standard", "FB Clone Theme - Footer Menu", "1");');
        $db->query('UPDATE `engine4_core_menuitems` SET `order` = 1 WHERE `name`="core_mini_profile"');
        $exploreModules = array( 'event' => 'Events','group' => 'Groups','sitepage' => 'Pages','album' =>'Photos','poke' => 'Pokes','blog' => 'Blogs','communityad' => 'Offers','sitecredit' => 'Credits' );
        $baseUrl = str_replace("install/", "", $view->baseUrl("/"));
        foreach ($exploreModules as $key => $module){
            $select = new Zend_Db_Select($db);
            $select
            ->from('engine4_core_modules')
            ->where('name = ?', $key)
            ->where('enabled = ?', 1);
            $check_module = $select->query()->fetchObject();
            if (!empty($check_module)) {
                $db->query('INSERT IGNORE INTO `engine4_facelight_menus` (`title`, `link`, `parent`, `order`, `params`, `enabled`) VALUES ("'.$module.'", "'.$baseUrl.$key.'s", 0, 99, \'{"icon":"'.$baseUrl."application/modules/Facelight/externals/images/default/".$module.'.png"}\', 1);');
            }
        }
        $this->setDefaultLayout();

        $global_directory_name = APPLICATION_PATH . '/public/seaocore_themes';
        $global_settings_file = $global_directory_name . '/facelightThemeConstants.css';
        $is_file_exist = @file_exists($global_settings_file);
        if (empty($is_file_exist)) {
            if (!is_dir($global_directory_name)) {
                @mkdir($global_directory_name, 0777);
            }
            @chmod($global_directory_name, 0777);

            $fh = @fopen($global_settings_file, 'w');
            $cssContent = "theme_color: #3b5998; button_border_color:#29487d; landingpage_signinbtn:#4267b2; landingpage_signupbtn: #4267b2; theme_background_color:#F0F1F2; navigation_background_color: #e1e1e1; button_color: #4267b2;";
            @fwrite($fh, $cssContent);
            @fclose($fh);

            @chmod($global_settings_file, 0777);
        }
        $tableNameContent = new Zend_Db_Select($db);
        $tableNameContentName = 'engine4_core_content';

        $db = Zend_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitecontentcoverphoto')
        ->where('enabled = ?', 1);
        $is_sitecontentcoverphoto_object = $select->query()->fetchObject();
        if ($is_sitecontentcoverphoto_object) {

            $select = new Zend_Db_Select($db);
            $page_id = $select
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'siteevent_index_view')
            ->query()
            ->fetchColumn();
            if ($page_id) {
                $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"siteevent_event","showContent_0":"","showContent_siteevent_event":["title","joinButton","inviteGuest","updateInfoButton","inviteRsvpButton","optionsButton","venue","startDate","endDate","location","hostName", "addToMyCalendar","shareOptions"],"profile_like_button":"0","columnHeight":"400","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","contentFullWidth":"1","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "siteevent.add-to-my-calendar-siteevent" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "siteevent.list-profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');

                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');

                $select = new Zend_Db_Select($db);
                $content_id = $select
                ->from('engine4_core_content', 'content_id')
                ->where('name = ?', 'top')
                ->where('page_id = ?', $page_id)
                ->query()
                ->fetchColumn();

                if ($content_id) {
                    $select = new Zend_Db_Select($db);
                    $content_id = $select
                    ->from('engine4_core_content', 'content_id')
                    ->where('name = ?', 'middle')
                    ->where('parent_content_id = ?', $content_id)
                    ->where('page_id = ?', $page_id)
                    ->query()
                    ->fetchColumn();
                    if ($content_id) {
                        $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                    }
                }
            }


            $select = new Zend_Db_Select($db);
            $page_id = $select
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'sitealbum_album_view')
            ->query()
            ->fetchColumn();
            if ($page_id) {
                $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"album","showContent_0":"","showContent_album":["mainPhoto","title","owner","description","totalPhotos","viewCount","likeCount","commentCount","location","CategoryLink","updateDate","optionsButton","shareOptions"],"showContent_sitebusiness_business":"","showContent_siteevent_event":"","showContent_sitegroup_group":"","showContent_sitepage_page":"","showContent_sitestore_store":"","showContent_sitestoreproduct_product":"","profile_like_button":"1","columnHeight":"235","showMember":"1","memberCount":"8","onlyMemberWithPhoto":"1","contentFullWidth":"1","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitealbum.profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');

                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
            }

            if (!$this->getSetting('sitepage.layoutcreate', 0)) {
                $select = new Zend_Db_Select($db);
                $page_id = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitepage_index_view')
                ->query()
                ->fetchColumn();
                if ($page_id) {
                    $tableNameContent = new Zend_Db_Select($db);
                    $top_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $page_id)
                    ->where('name =?', 'top')
                    ->query()
                    ->fetchColumn();
                    if (empty($top_content_id)) {
                        $db->insert('engine4_core_content', array(
                            'type' => 'container',
                            'name' => 'top',
                            'page_id' => $page_id,
                            'parent_content_id' => null,
                            'order' => 1,
                            'params' => ''
                            ));
                        $content_id = $db->lastInsertId('engine4_core_content');
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (empty($middle_content_id)) {
                            $db->insert('engine4_core_content', array(
                                'type' => 'container',
                                'name' => 'middle',
                                'page_id' => $page_id,
                                'parent_content_id' => $content_id,
                                'order' => 2,
                                'params' => ''
                                ));

                            $content_id = $db->lastInsertId('engine4_core_content');
                            if ($content_id) {
                                $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                            }
                        }
                    } else {
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $page_id)
                        ->where('parent_content_id =?', $top_content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (!empty($middle_content_id)) {
                            $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $middle_content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                        }
                    }

                    $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"sitepage_page","showContent_0":"","showContent_siteevent_event":"","showContent_sitepage_page":["mainPhoto","title","followButton","likeCount","followCount","optionsButton","shareOptions"],"profile_like_button":"1","columnHeight":"400","contentFullWidth":"1","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitepage.page-profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitepage.thumbphoto-sitepage" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                }
            }

            if (!$this->getSetting('sitebusiness.layoutcreate', 0)) {
                $select = new Zend_Db_Select($db);
                $business_id = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitebusiness_index_view')
                ->query()
                ->fetchColumn();
                if ($business_id) {
                    $tableNameContent = new Zend_Db_Select($db);
                    $top_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $business_id)
                    ->where('name =?', 'top')
                    ->query()
                    ->fetchColumn();
                    if (empty($top_content_id)) {
                        $db->insert('engine4_core_content', array(
                            'type' => 'container',
                            'name' => 'top',
                            'page_id' => $business_id,
                            'parent_content_id' => null,
                            'order' => 1,
                            'params' => ''
                            ));
                        $content_id = $db->lastInsertId('engine4_core_content');
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $business_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (empty($middle_content_id)) {
                            $db->insert('engine4_core_content', array(
                                'type' => 'container',
                                'name' => 'middle',
                                'page_id' => $business_id,
                                'parent_content_id' => $content_id,
                                'order' => 2,
                                'params' => ''
                                ));

                            $content_id = $db->lastInsertId('engine4_core_content');
                            if ($content_id) {
                                $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $business_id . '" LIMIT 1;');
                            }
                        }
                    } else {
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $business_id)
                        ->where('parent_content_id =?', $top_content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (!empty($middle_content_id)) {
                            $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $middle_content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $business_id . '" LIMIT 1;');
                        }
                    }

                    $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"sitebusiness_business","showContent_0":"","showContent_siteevent_event":"","showContent_sitebusiness_business":["mainPhoto","title","followButton","likeCount","followCount","optionsButton","shareOptions"],"profile_like_button":"1","columnHeight":"400","contentFullWidth":"1","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $business_id . '" LIMIT 1;');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitebusiness.business-profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $business_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $business_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitebusiness.thumbphoto-sitebusiness" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                }
            }

            if (!$this->getSetting('sitegroup.layoutcreate', 0)) {
                $select = new Zend_Db_Select($db);
                $group_id = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitegroup_index_view')
                ->query()
                ->fetchColumn();
                if ($group_id) {
                    $tableNameContent = new Zend_Db_Select($db);
                    $top_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $group_id)
                    ->where('name =?', 'top')
                    ->query()
                    ->fetchColumn();
                    if (empty($top_content_id)) {
                        $db->insert('engine4_core_content', array(
                            'type' => 'container',
                            'name' => 'top',
                            'page_id' => $group_id,
                            'parent_content_id' => null,
                            'order' => 1,
                            'params' => ''
                            ));
                        $content_id = $db->lastInsertId('engine4_core_content');
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $group_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (empty($middle_content_id)) {
                            $db->insert('engine4_core_content', array(
                                'type' => 'container',
                                'name' => 'middle',
                                'page_id' => $group_id,
                                'parent_content_id' => $content_id,
                                'order' => 2,
                                'params' => ''
                                ));

                            $content_id = $db->lastInsertId('engine4_core_content');
                            if ($content_id) {
                                $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $group_id . '" LIMIT 1;');
                            }
                        }
                    } else {
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $group_id)
                        ->where('parent_content_id =?', $top_content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (!empty($middle_content_id)) {
                            $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $middle_content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $group_id . '" LIMIT 1;');
                        }
                    }

                    $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"sitegroup_group","showContent_0":"","showContent_siteevent_event":"","showContent_sitegroup_group":["mainPhoto","title","followButton","likeCount","followCount","optionsButton","shareOptions"],"profile_like_button":"1","columnHeight":"400","contentFullWidth":"1","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $group_id . '" LIMIT 1;');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitegroup.group-profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $group_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $group_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitegroup.thumbphoto-sitegroup" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                }
            }

            if (!$this->getSetting('sitestore.layoutcreate', 0)) {
                $select = new Zend_Db_Select($db);
                $store_id = $select
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', 'sitestore_index_view')
                ->query()
                ->fetchColumn();
                if ($store_id) {
                    $tableNameContent = new Zend_Db_Select($db);
                    $top_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $store_id)
                    ->where('name =?', 'top')
                    ->query()
                    ->fetchColumn();
                    if (empty($top_content_id)) {
                        $db->insert('engine4_core_content', array(
                            'type' => 'container',
                            'name' => 'top',
                            'page_id' => $store_id,
                            'parent_content_id' => null,
                            'order' => 1,
                            'params' => ''
                            ));
                        $content_id = $db->lastInsertId('engine4_core_content');
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $store_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (empty($middle_content_id)) {
                            $db->insert('engine4_core_content', array(
                                'type' => 'container',
                                'name' => 'middle',
                                'page_id' => $store_id,
                                'parent_content_id' => $content_id,
                                'order' => 2,
                                'params' => ''
                                ));

                            $content_id = $db->lastInsertId('engine4_core_content');
                            if ($content_id) {
                                $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $store_id . '" LIMIT 1;');
                            }
                        }
                    } else {
                        $tableNameContent = new Zend_Db_Select($db);
                        $middle_content_id = $tableNameContent
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $store_id)
                        ->where('parent_content_id =?', $top_content_id)
                        ->where('name =?', 'middle')
                        ->query()
                        ->fetchColumn();

                        if (!empty($middle_content_id)) {
                            $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $middle_content_id . '" WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $store_id . '" LIMIT 1;');
                        }
                    }

                    $db->query('UPDATE `engine4_core_content` SET `params` = \'{"modulename":"sitestore_store","showContent_0":"","showContent_siteevent_event":"","showContent_sitestore_store":["mainPhoto","title","followButton","likeCount","followCount","optionsButton","shareOptions"],"profile_like_button":"1","columnHeight":"400","contentFullWidth":"1","sitecontentcoverphotoChangeTabPosition":"1","contacts":"","showMemberLevelBasedPhoto":"1","emailme":"1","editFontColor":"0","title":"","nomobile":"0","name":"sitecontentcoverphoto.content-cover-photo"}\' WHERE `engine4_core_content`.`name` = "sitecontentcoverphoto.content-cover-photo" AND `engine4_core_content`.`page_id` = "' . $store_id . '" LIMIT 1;');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitestore.store-profile-breadcrumb" AND `engine4_core_content`.`page_id` = "' . $store_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "seaocore.social-share-buttons" AND `engine4_core_content`.`page_id` = "' . $store_id . '" LIMIT 1');
                    $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitestore.thumbphoto-sitestore" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                }
            }
        }
        $select = new Zend_Db_Select($db);
        $select
        ->from('engine4_core_modules')
        ->where('name = ?', 'siteusercoverphoto')
        ->where('enabled = ?', 1);
        $is_siteusercoverphotoobject = $select->query()->fetchObject();
        if ($is_siteusercoverphotoobject) {
            $select = new Zend_Db_Select($db);
            $page_id = $select
            ->from('engine4_core_pages', 'page_id')
            ->where('name = ?', 'user_profile_index')
            ->query()
            ->fetchColumn();
            if ($page_id) {
                $tableNameContent = new Zend_Db_Select($db);
                $db->query('INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES ("siteusercoverphoto.content.full.width", 1)');
                $top_content_id = $tableNameContent
                ->from($tableNameContentName, 'content_id')
                ->where('page_id =?', $page_id)
                ->where('name =?', 'top')
                ->query()
                ->fetchColumn();
                if (empty($top_content_id)) {
                    $db->insert('engine4_core_content', array(
                        'type' => 'container',
                        'name' => 'top',
                        'page_id' => $page_id,
                        'parent_content_id' => null,
                        'order' => 1,
                        'params' => ''
                        ));
                    $content_id = $db->lastInsertId('engine4_core_content');
                    $tableNameContent = new Zend_Db_Select($db);
                    $middle_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $content_id)
                    ->where('name =?', 'middle')
                    ->query()
                    ->fetchColumn();

                    if (empty($middle_content_id)) {
                        $db->insert('engine4_core_content', array(
                            'type' => 'container',
                            'name' => 'middle',
                            'page_id' => $page_id,
                            'parent_content_id' => $content_id,
                            'order' => 2,
                            'params' => ''
                            ));

                        $content_id = $db->lastInsertId('engine4_core_content');
                        if ($content_id) {
                            $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $content_id . '" WHERE `engine4_core_content`.`name` = "siteusercoverphoto.user-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                        }
                    }
                } else {
                    $tableNameContent = new Zend_Db_Select($db);
                    $middle_content_id = $tableNameContent
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $top_content_id)
                    ->where('name =?', 'middle')
                    ->query()
                    ->fetchColumn();

                    if (!empty($middle_content_id)) {
                        $db->query('UPDATE `engine4_core_content` SET `parent_content_id` =  "' . $middle_content_id . '" WHERE `engine4_core_content`.`name` = "siteusercoverphoto.user-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                    }
                }

                $db->query('UPDATE `engine4_core_content` SET `params` = \'{"title":"","titleCount":"","showContent":["mainPhoto","title","updateInfoButton","settingsButton","optionsButton","friendShipButton","composeMessageButton"],"profile_like_button":"1","columnHeight":"400","editFontColor":"0","nomobile":"0","name":"siteusercoverphoto.user-cover-photo"}\' WHERE `engine4_core_content`.`name` = "siteusercoverphoto.user-cover-photo" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1;');
                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitealbum.photo-strips" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');
                $db->query('DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "user.profile-status" AND `engine4_core_content`.`page_id` = "' . $page_id . '" LIMIT 1');

                $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1 ;");
            }
        }
        $select = new Zend_Db_Select($db);
        $page_id = $select
        ->from('engine4_core_pages', 'page_id')
        ->where('name = ?', 'facelight_dashboard_panel')
        ->query()
        ->fetchColumn();
        if(!$page_id){
            $db->query('INSERT IGNORE INTO `engine4_core_pages` (`name`, `displayname`, `url`, `title`, `description`, `keywords`, `custom`, `fragment`, `layout`, `levels`, `provides`, `view_count`, `search`) VALUES
                (\'facelight_dashboard_panel\', \'Dashboard\', NULL, \'\', \'\', \'\', 1, 0, \'\', NULL, \'no-subject\', 0, 0);');
            $page_id = $db->lastInsertId('engine4_core_pages');
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'main',
                'page_id' => $page_id,
                'order' => 2,
                'params' => ''
                ));
            $content_id = $db->lastInsertId('engine4_core_content');
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'middle',
                'page_id' => $page_id,
                'parent_content_id' => $content_id,
                'order' => 6,
                'params' => ''
                ));
            $content_id = $db->lastInsertId('engine4_core_content');
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'core.menu-main',
                'page_id' => $page_id,
                'parent_content_id' => $content_id,
                'order' => 6,
                'params' => '{"menuType":"vertical","title":"","nomobile":"0","name":"core.menu-main"}'
                ));
            $db->insert('engine4_core_settings', array(
                'name' => 'facelight.panel.menu.layout',
                'value' => 'right_panel panel_layout_overlay' 
                ));
        }
    $db->query('INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES ("facelight.default.setup", 1)');
    }
    public function getSetting($key,$default){
            $db = Zend_Db_Table::getDefaultAdapter();
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_settings')
                    ->where('name = ?', $key)
                    ;
            $object = $select->query()->fetchObject();
            $default = !empty($object) ? $object->value : $default;
            return $default;
    }
    private function updatePage($pageName, $title, $description) {
        $db = $this->getDb();
        $page_id = $db->select()
                ->from('engine4_core_pages', 'page_id')
                ->where('name = ?', $pageName)
                ->limit(1)
                ->query()
                ->fetchColumn();
        $tableNameContentName = "engine4_core_content";
        $top_content_id = $db->select()
                ->from($tableNameContentName, 'content_id')
                ->where('page_id =?', $page_id)
                ->where('name =?', 'top')
                ->query()
                ->fetchColumn();
        if (empty($top_content_id)) {
            $db->insert('engine4_core_content', array(
                'type' => 'container',
                'name' => 'top',
                'page_id' => $page_id,
                'parent_content_id' => null,
                'order' => 1,
                'params' => ''
            ));
            $content_id = $db->lastInsertId('engine4_core_content');
            $middle_content_id = $db->select()
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $content_id)
                    ->where('name =?', 'middle')
                    ->query()
                    ->fetchColumn();

            if (empty($middle_content_id)) {
                $db->insert('engine4_core_content', array(
                    'type' => 'container',
                    'name' => 'middle',
                    'page_id' => $page_id,
                    'parent_content_id' => $content_id,
                    'order' => 2,
                    'params' => ''
                ));

                $content_id = $db->lastInsertId('engine4_core_content');

                $middle_banner_id = $db->select()
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $page_id)
                        ->where('parent_content_id =?', $content_id)
                        ->where('name =?', 'facelight.banner-images')
                        ->query()
                        ->fetchColumn();
                if (!$middle_banner_id) {
                    $db->insert('engine4_core_content', array(
                        'type' => 'widget',
                        'name' => 'facelight.banner-images',
                        'page_id' => $page_id,
                        'parent_content_id' => $content_id,
                        'order' => 1,
                        'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"280","speed":"5000","order":"2","facelightHtmlTitle":"' . $title . '","facelightHtmlDescription":"' . $description . '","title":"","nomobile":"0","name":"facelight.banner-images"}'
                    ));
                }
            }
            $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1 ;");
        } else {
            $middle_content_id = $db->select()
                    ->from($tableNameContentName, 'content_id')
                    ->where('page_id =?', $page_id)
                    ->where('parent_content_id =?', $top_content_id)
                    ->where('name =?', 'middle')
                    ->query()
                    ->fetchColumn();

            if (!empty($middle_content_id)) {

                $middle_banner_id = $db->select()
                        ->from($tableNameContentName, 'content_id')
                        ->where('page_id =?', $page_id)
                        ->where('parent_content_id =?', $middle_content_id)
                        ->where('name =?', 'facelight.banner-images')
                        ->query()
                        ->fetchColumn();

                if (!$middle_banner_id) {
                    $db->insert('engine4_core_content', array(
                        'type' => 'widget',
                        'name' => 'facelight.banner-images',
                        'page_id' => $page_id,
                        'parent_content_id' => $middle_content_id,
                        'order' => 1,
                        'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"280","speed":"5000","order":"2","facelightHtmlTitle":"' . $title . '","facelightHtmlDescription":"' . $description . '","title":"","nomobile":"0","name":"facelight.banner-images"}'
                    ));
                }
                $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1;");

                $select = new Zend_Db_Select($db);
                $select
                    ->from('engine4_core_modules')
                    ->where('name = ?', 'spectacular')
                    ->where('enabled = ?', 1);
                $check_module = $select->query()->fetchObject();
                if (!empty($check_module)) {
                    $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id AND `engine4_core_content`.`name` = 'spectacular.banner-images' LIMIT 1;");
                }
            }
        }
    }

     protected function _checkDeependency()
  {
    return $this->_checkDeependencyVersion();
  }
  protected function _checkDeependencyVersion()
  {
    $db = $this->getDb();
    $errorMsg = '';
    $finalModules = $getResultArray = array();
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
    $modArray = $this->_deependencyVersion;
    foreach( $modArray as $key => $value ) {
      $isMod = $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  '" . $key . "'")->fetch();
      if( !empty($isMod) && !empty($isMod['version']) ) {
        $isModSupport = $this->_compareDependancyVersion($isMod['version'], $value);
        if( empty($isModSupport) ) {
          $finalModules['modName'] = $key;
          $finalModules['title'] = $isMod['title'];
          $finalModules['versionRequired'] = $value;
          $finalModules['versionUse'] = $isMod['version'];
          $getResultArray[] = $finalModules;
        }
      }
    }
    foreach( $getResultArray as $modArray ) {
      $errorMsg .= '<div class="tip"><span>Note: Your website does not have the latest version of "' . $modArray['title'] . '". Please upgrade "' . $modArray['title'] . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with this plugin.<br/> Please <a href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
    }
    return $errorMsg;
  }
  private function _compareDependancyVersion($databaseVersion, $checkDependancyVersion)
  {
    $f = $databaseVersion;
    $s = $checkDependancyVersion;
    if( strcasecmp($f, $s) == 0 )
      return -1;
    $fArr = explode(".", $f);
    $sArr = explode('.', $s);
    if( count($fArr) <= count($sArr) )
      $count = count($fArr);
    else
      $count = count($sArr);
    for( $i = 0; $i < $count; $i++ ) {
      $fValue = $fArr[$i];
      $sValue = $sArr[$i];
      if( is_numeric($fValue) && is_numeric($sValue) ) {
        if( $fValue > $sValue )
          return 1;
        elseif( $fValue < $sValue )
          return 0;
        else {
          if( ($i + 1) == $count ) {
            return -1;
          } else
            continue;
        }
      }
      elseif( is_string($fValue) && is_numeric($sValue) ) {
        $fsArr = explode("p", $fValue);
        if( $fsArr[0] > $sValue )
          return 1;
        elseif( $fsArr[0] < $sValue )
          return 0;
        else {
          return 1;
        }
      } elseif( is_numeric($fValue) && is_string($sValue) ) {
        $ssArr = explode("p", $sValue);
        if( $fValue > $ssArr[0] )
          return 1;
        elseif( $fValue < $ssArr[0] )
          return 0;
        else {
          return 0;
        }
      } elseif( is_string($fValue) && is_string($sValue) ) {
        $fsArr = explode("p", $fValue);
        $ssArr = explode("p", $sValue);
        if( $fsArr[0] > $ssArr[0] )
          return 1;
        elseif( $fsArr[0] < $ssArr[0] )
          return 0;
        else {
          if( $fsArr[1] > $ssArr[1] )
            return 1;
          elseif( $fsArr[1] < $ssArr[1] )
            return 0;
          else {
            return -1;
          }
        }
      }
    }
  }

}
