<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Facelight
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Facelight_Widget_HomePhotoController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        // Don't render this if not logged in
        $viewer = Engine_Api::_()->user()->getViewer();
        if (!$viewer->getIdentity()) {
            return $this->setNoRender();
        }
        $this->view->editPermission = Engine_Api::_()->authorization()->isAllowed('user', $viewer, 'edit');
        $this->view->showNewsFeed = $this->_getParam('showNewsFeed',1);
        if(Engine_Api::_()->hasModuleBootstrap('primemessenger') && Engine_Api::_()->primemessenger()->isPrimeMessengerActive()){
        $this->view->showPrimeMessenger = $this->_getParam('showPrimeMessenger',1);
        }

    }

    public function getCacheKey() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!$viewer_id) {
            return parent::getCacheKey();
        }
        $translate = Zend_Registry::get('Zend_Translate');
        return $viewer_id . $translate->getLocale() . sprintf('%d', $viewer->photo_id);
    }

}
