<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Ffmpegconversion
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Ffmpegconversion_Form_Videos_Upload extends Engine_Form {

    public function init() {

        //GET DECORATORS
        $this->loadDefaultDecorators();
        $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Convert Your Video")))
                ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("To convert your video, please upload the video and submit this form. Upon submission of this form, you will see a tip having the link to convert the video, Please click on that link and upon successfully video conversion, a pop-up message will shown to you from where you can download the converted video .tar file. <br /><br />[<strong>Note:</strong> We never store any video on this server]")))->getDecorator('Description')->setOption('escape', false);

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $key = @base64_decode($request->getParam('key', null));

        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', 'ffmpegconversion_lkey', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialEngineAddOns from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => $key,
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('StringLength', false, array(16)),
            ),
        ));

        $this->ffmpegconversion_lkey->getValidator('NotEmpty')->setMessage('Please enter a valid license key.', 'isEmpty');

        $this->addElement('File', 'video', array(
            'label' => 'Upload your video',
            'description' => "Supported all video formats and Max video file size allowed:<strong style='font-weight:bold'> " . (int) ini_get("upload_max_filesize") / 2 . "MB</strong>",
            'required' => true,
            'allowEmpty' => false,
        ));
        $this->video->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::APPEND, 'escape' => false));

        $this->addElement('Button', 'upload', array(
            'label' => 'Upload Video',
            'type' => 'submit',
        ));
    }

}
