<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Ffmpegconversion
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Ffmpegconversion_IndexController extends Core_Controller_Action_Standard {

    public function indexAction() {

        //FILE DELETING
        if ($handle = opendir($this->getTmpDir())) {
            while (false !== ($entry = readdir($handle))) {
                if ($entry != "." && $entry != "..") {
                    if (time() >= (filemtime($this->getTmpDir() . '/' . $entry) + 1 * 60 * 60)) {
                        if (strpos($entry, "ffmpeg_converted_video") !== false && $this->getTmpDir() . '/' . $entry) {
                            unlink($this->getTmpDir() . '/' . $entry);
                        }
                    }
                }
            }
        }

        // Render
        $this->_helper->content
                //->setNoRender()
                ->setEnabled()
        ;

        $this->view->redirect_url = $redirect_url = @base64_decode($this->_getParam('redirect_url'));
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $key = @base64_decode($request->getParam('key', null));
        $url = @base64_decode($request->getParam('url', null));
        $this->view->slideshow_id = $slideshow_id =$request->getParam('slideshow_id', null);
        $this->view->valid = $this->checkKey($redirect_url, $key, $url);

        $form = $this->view->form = new Ffmpegconversion_Form_Videos_Upload();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

            $values = $this->getRequest()->getPost();
            $ffmpegconversionkey = $values['ffmpegconversion_lkey'];

            if ($ffmpegconversionkey != $key && $this->view->valid) {
                $form->addError('License key for ‘Home Page Background Videos Plugin’ is not valid. Please check your key again or contact SocialEngineAddOns support.');
                return;
            }

            $lkeytmpDir = $this->getTmpDir() . '/' . $lkey;
            $totalVideoExist = 0;
            if (is_dir($lkeytmpDir)) {

                $current_time_stamp = time();
                $next_day_time_stamp = time() + 24 * 60 * 60;

                clearstatcache();
                $lastUpdatedTimeStamp = '';
                if ($handle = opendir($lkeytmpDir)) {
                    while (false !== ($entry = readdir($handle))) {
                        if ($entry != "." && $entry != "..") {
                            if ($current_time_stamp <= (filemtime($lkeytmpDir . '/' . $entry) + 24 * 60 * 60)) {
                                $totalVideoExist++;
                                $lastUpdatedTimeStamp .= filemtime($lkeytmpDir . '/' . $entry) . '|';
                            } else {
                                unlink($lkeytmpDir . '/' . $entry);
                            }
                        }
                    }
                    closedir($handle);
                }
            }

            //FILE EXTENSION SHOULD NOT DIFFER FROM ALLOWED TYPE
            $ext = str_replace(".", "", strrchr($_FILES['video']['name'], "."));
            if (in_array($ext, array('pdf', 'txt', 'ps', 'rtf', 'epub', 'odt', 'odp', 'ods', 'odg', 'odf', 'sxw', 'sxc', 'sxi', 'sxd', 'doc', 'ppt', 'pps', 'xls', 'docx', 'pptx', 'ppsx', 'xlsx', 'tif', 'tiff', 'jpg', 'jpeg', 'png', 'gif'))) {
                $error = $this->view->translate("Invalid file extension.");
                $error = Zend_Registry::get('Zend_Translate')->_($error);
                $form->getDecorator('errors')->setOption('escape', false);
                $form->addError($error);
                return;
            }

            if ($totalVideoExist == 3 && $lastUpdatedTimeStamp) {
                $latestTimeStamp = explode("|", rtrim($lastUpdatedTimeStamp, '|'));
                arsort($latestTimeStamp);
                $lTime = reset($latestTimeStamp) + 86400 - time();
                $ltime = explode(":", gmdate("H:i:s", $lTime));
                if (isset($ltime)) {
                    $timeString = $ltime[0] . ' hour(s) ' . $ltime[1] . ' minute(s) ' . $ltime[2] . ' second(s) ';
                }
                $form->addError(sprintf(Zend_Registry::get('Zend_Translate')->_('Maximum 3 videos can be converted in a single day with 1 licence key. You can convert your next video in %s.'), $timeString));
                return;
            }

            if (empty($_FILES['video'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
                return;
            }

            if (!isset($_FILES['video']) || !is_uploaded_file($_FILES['video']['tmp_name'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
                return;
            }

            $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
            if (in_array(pathinfo($_FILES['video']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
                return;
            }

            //FILE SIZE SHOULD NOT EXCEED FROM ALLOWED LIMIT FOR THIS LEVEL
            $filesize = (int) ini_get('upload_max_filesize') * 1024 * 1024 / 2;
            if ($_FILES['video']['size'] > $filesize) {
                $error = $this->view->translate('File size can not be exceed from ') . ($filesize) . $this->view->translate(' MB ');
                $error = Zend_Registry::get('Zend_Translate')->_($error);

                $form->getDecorator('errors')->setOption('escape', false);
                $form->addError($error);
                return;
            }

            $tmp_name = $_FILES['video']['tmp_name'];
            $name = $_FILES['video']['name'];
            if (!is_dir($lkeytmpDir) && !mkdir($lkeytmpDir, 0777, true)) {
                throw new Ffmpegconversion_Model_Exception('Video temporary directory did not exist and could not be created.');
            }

            if (!is_writable($lkeytmpDir)) {
                throw new Ffmpegconversion_Model_Exception('Video temporary directory is not writable.');
            }
            $tmpDir = $this->getTmpDir();
            @move_uploaded_file($tmp_name, "$tmpDir/$name");

            if (is_dir($lkeytmpDir)) {
                if (!is_file($lkeytmpDir . '/' . $name)) {
                    fopen($lkeytmpDir . '/' . $name, 'w');
                    @chmod($lkeytmpDir . '/' . $name, 0777);
                }
            }
            $this->view->upload = 1;
            $this->view->name = "'" . $name . "'";
            $form->addNotice('Your video has been uploaded successfully, now <a href="javascript:void(0);" onclick="encodeVideos(' . $this->view->name . ');  return false">click here</a> to convert this video.');
        }
    }

    private function getTmpDir() {
        set_time_limit(0);
        $tmpDir = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary' .
                DIRECTORY_SEPARATOR . 'ffmpegcoversion_video';
        if (!is_dir($tmpDir) && !mkdir($tmpDir, 0777, true)) {
            throw new Ffmpegconversion_Model_Exception('Video temporary directory did not exist and could not be created.');
        }

        if (!is_writable($tmpDir)) {
            throw new Ffmpegconversion_Model_Exception('Video temporary directory is not writable.');
        }

        return $tmpDir;
    }

    private function getFFMPEGPath() {

        return 'ffmpeg/ffmpeg';
    }

    private function getDuration($videoOutput) {
        set_time_limit(0);
        $duration = 0;

        if (preg_match('/Duration:\s+(.*?)[.]/i', $videoOutput, $matches)) {
            list($hours, $minutes, $seconds) = preg_split('[:]', $matches[1]);
            $duration = ceil($seconds + ($minutes * 60) + ($hours * 3600));
        }

        return $duration;
    }

    private function generateThumbnail($outputPath, $output, $thumb_splice, $thumbPath) {
        $ffmpeg_path = $this->getFFMPEGPath();
        set_time_limit(0);
        // Thumbnail process command
        $thumbCommand = $ffmpeg_path . ' '
                . '-i ' . escapeshellarg($outputPath) . ' '
                . '-f image2' . ' '
                . '-ss ' . $thumb_splice . ' '
                . '-vframes 1' . ' '
                . '-v 2' . ' '
                . '-y ' . escapeshellarg($thumbPath) . ' '
                . '2>&1';

        // Process thumbnail
        $thumbOutput = $output .
                $thumbCommand . PHP_EOL .
                shell_exec($thumbCommand);

        // Check output message for success
        $thumbSuccess = true;
        if (preg_match('/video:0kB/i', $thumbOutput)) {
            $thumbSuccess = false;
        }

        if ($thumbSuccess) {
            try {
                $image = Engine_Image::factory();
                $image->open($thumbPath)
                        ->resize(1600, 500)
                        ->write($thumbPath)
                        ->destroy();
            } catch (Exception $e) {
                $this->_addMessage((string) $e->__toString());
                $thumbSuccess = false;
            }
        }

        return $thumbSuccess;
    }

    public function encodeVideosAction() {
        $name = $this->_getParam('video');

        if (pathinfo($name, PATHINFO_EXTENSION) == 'mp4') {

            $type = 'webm';
            $tmpDir = $this->getTmpDir();
            $originalPath = "$tmpDir/$name";
            @chmod($originalPath, 0777);
            $outputPath = $tmpDir . DIRECTORY_SEPARATOR . $name . '_vconverted.' . $type;
            $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $name . '_vthumb.jpg';
            @chmod($outputPath, 0777);
            @chmod($thumbPath, 0777);
            $ffmpeg_path = $this->getFFMPEGPath();
            $videoCommand = $ffmpeg_path . ' '
                    . '-i ' . escapeshellarg($originalPath) . ' ';

            if ($type == 'webm')
                $videoCommand .= '-acodec libvorbis -aq 5 -ac 2 -qmax 25 -threads 2' . ' '
                ;
            else
                $videoCommand .= '-vcodec flv -f flv ';

            $videoCommand .=
                    escapeshellarg($outputPath);

            // Prepare output header
            $output = PHP_EOL;
            $output .= $originalPath . PHP_EOL;
            $output .= $outputPath . PHP_EOL;
            $output .= $thumbPath . PHP_EOL;

            // Execute video encode command
            $videoOutput = $output .
                    $videoCommand . PHP_EOL .
                    shell_exec($videoCommand);

            // Get duration of the video to caculate where to get the thumbnail
            $duration = $this->getDuration($videoOutput);
            // Fetch where to take the thumbnail
            $thumb_splice = $duration / 4;
            $thumbSuccess = $this->generateThumbnail($outputPath, $output, $thumb_splice, $thumbPath);
            $tar_name = 'ffmpeg_converted_video_' . rand(0, 9999) . '.tar';
            $files_to_tar = array();
            $files_to_tar[] = $name . '_vconverted.' . $type;
            $files_to_tar[] = $name . '_vthumb.jpg';
            $files_to_tar[] = $name;
            $tarPath = APPLICATION_PATH . "/temporary/ffmpegcoversion_video/";
            $result = $this->createZip($files_to_tar, $tar_name, $tarPath);

            unlink($outputPath);
            unlink($thumbPath);
            unlink($originalPath);
            $this->view->tarName = $tar_name;
        } else {
            $type = 'mp4';
            $tmpDir = $this->getTmpDir();
            $originalPath = "$tmpDir/$name";
            @chmod($originalPath, 0777);
            $outputPath = $tmpDir . DIRECTORY_SEPARATOR . $name . '_vconverted.' . $type;
            $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $name . '_vthumb.jpg';
            @chmod($outputPath, 0777);
            @chmod($thumbPath, 0777);
            $ffmpeg_path = $this->getFFMPEGPath();
            $videoCommand = $ffmpeg_path . ' '
                    . '-i ' . escapeshellarg($originalPath) . ' ';

            if ($type == 'mp4')
                $videoCommand .= '-vcodec libx264' . ' '
                        . '-acodec aac' . ' '
                        . '-strict experimental' . ' '
                        . '-preset veryfast' . ' '
                        . '-f mp4' . ' '
                ;
            else
                $videoCommand .= '-vcodec flv -f flv ';

            $videoCommand .=
                    escapeshellarg($outputPath);

            // Prepare output header
            $output = PHP_EOL;
            $output .= $originalPath . PHP_EOL;
            $output .= $outputPath . PHP_EOL;
            $output .= $thumbPath . PHP_EOL;

            // Execute video encode command
            $videoOutput = $output .
                    $videoCommand . PHP_EOL .
                    shell_exec($videoCommand);

            // Get duration of the video to caculate where to get the thumbnail
            $duration = $this->getDuration($videoOutput);
            // Fetch where to take the thumbnail
            $thumb_splice = $duration / 4;
            $thumbSuccess = $this->generateThumbnail($outputPath, $output, $thumb_splice, $thumbPath);
            $tar_name = 'ffmpeg_converted_video_' . rand(0, 9999) . '.tar';
            $files_to_tar = array();
            $files_to_tar[] = $name . '_vconverted.' . $type;
            $files_to_tar[] = $name . '_vthumb.jpg';

            if (pathinfo($name, PATHINFO_EXTENSION) != 'webm') {
                $type = 'webm';
                $tmpDir = $this->getTmpDir();
                $originalPath = $outputPath;
                @chmod($originalPath, 0777);
                $outputPath = $tmpDir . DIRECTORY_SEPARATOR . $name . '_vconverted.' . $type;
                @chmod($outputPath, 0777);
                $ffmpeg_path = $this->getFFMPEGPath();
                $videoCommand = $ffmpeg_path . ' '
                        . '-i ' . escapeshellarg($originalPath) . ' ';

                if ($type == 'webm')
                    $videoCommand .= '-acodec libvorbis -aq 5 -ac 2 -qmax 25 -threads 2' . ' '
                    ;
                else
                    $videoCommand .= '-vcodec flv -f flv ';

                $videoCommand .=
                        escapeshellarg($outputPath);

                // Prepare output header
                $output = PHP_EOL;
                $output .= $originalPath . PHP_EOL;
                $output .= $outputPath . PHP_EOL;

                // Execute video encode command
                $videoOutput = $output .
                        $videoCommand . PHP_EOL .
                        shell_exec($videoCommand);
                $files_to_tar[] = $name . '_vconverted.' . $type;
            } else {
                $files_to_tar[] = $name;
            }

            //$files_to_tar[] = $name;
            $tarPath = APPLICATION_PATH . "/temporary/ffmpegcoversion_video/";
            $result = $this->createZip($files_to_tar, $tar_name, $tarPath);
            unlink($tarPath . '/' . $name);
            unlink($outputPath);
            unlink($thumbPath);
            unlink($originalPath);
            $this->view->tarName = $tar_name;
        }
    }

    public function downloadAction() {
        // Get path
        $name = $this->_getParam('tarname');

        $path = realpath(APPLICATION_PATH . "/temporary/ffmpegcoversion_video/$name");

        @chmod($path, 0777);
        @set_time_limit(0);
        $doFlush = true;
        if (ob_get_level()) {
            @ob_end_clean();
            $doFlush = false;
        }
        $fh = fopen($path, 'r');
        if (!$fh) {
          echo "Something wrong here, Please try again!";
          exit();
        }
        header("Content-Disposition: attachment; filename=" . urlencode(basename($path)), true);
        header("Content-Transfer-Encoding: Binary", true);
        header("Content-Type: application/x-tar", true);
        header("Content-Type: application/force-download", true);
        header("Content-Type: application/octet-stream", true);
        header("Content-Type: application/download", true);
        header("Content-Description: File Transfer", true);

        if (!Engine_Api::_()->seaocore()->isCdn() && $doFlush) {
            header("Content-Length: " . @filesize($path), true);
        }
        if ($doFlush) {
            flush();
        }

        //$len = 0;
        while (!feof($fh) /* $size > $len */) {
            $str = fread($fh, 8192);
            //$len += strlen($str);
            echo $str;
        }

        if ($doFlush) {
            flush();
        }
        fclose($fh);
        //unlink($path);
        exit();
    }

    /* creates a compressed zip file */

    protected function createZip($files = array(), $ZIP_NAME, $destination = '', $overwrite = false) {

        // EMPTY THE DIRECTORY.
        // we open the directory
        $destination = APPLICATION_PATH . "/temporary/ffmpegcoversion_video/";

        // CREATE A DIRECTORY, IF DIRECTORY ARE NOT AVAILABLE.
        $filename = $destination;
        $zipPath = $filename . $ZIP_NAME;
        $is_dir = is_dir($filename);
        if (empty($is_dir)) {
            @mkdir($filename);
        }
        @chmod($filename, 0777);
        $destination = $zipPath;
        $valid_files = array();
        if (is_array($files)) {
            foreach ($files as $file) {
                $valid_files[] = $file;
            }
        }

        //if we have good files...
        if (count($valid_files)) {
            //create the archive
            $zip = new Archive_Tar($destination);
            foreach ($valid_files as $file) {
                $filePath = APPLICATION_PATH . "/temporary/ffmpegcoversion_video/" . $file;
                $getArray[] = $filePath;
            }
            $zip->addModify($getArray, '', APPLICATION_PATH . "/temporary/ffmpegcoversion_video/");
            @chmod($filename, 0777);
            return file_exists($destination);
        } else {
            return false;
        }
    }

    public function checkKey($redirect_url, $key, $url) {

        $type = 'sitehomepagevideo';
        $isValid = false;
        $oposit_url = 'http://www.socialengineaddons.com/meraMODULEsitehomepagevideoplugin.php?checking=' . $key . '&surl=' . $url . '&type=' . $type;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $oposit_url);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $get_value = ob_get_contents();
        if (empty($get_value))
            $get_value = @file_get_contents($oposit_url);

        ob_end_clean();

        $Clean_module = strrev($type);
        if (strstr($get_value, $Clean_module))
            $isValid = true;

        return $isValid;
    }

}
