<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Controller_Action_Helper_Groupdocuments extends Zend_Controller_Action_Helper_Abstract {

    function postDispatch() {
        //GET NAME OF MODULE, CONTROLLER AND ACTION
        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();
        $view = $this->getActionController()->view;

        //DON'T SHOW THE PRIVACY OPTIONS IF NOT ACTIVATED
        $groupdocument_isActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.isActivate', 0);
        if (empty($groupdocument_isActivate))
            return;

        if (Engine_Api::_()->hasModuleBootstrap('document') && (Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'group', 'item_module' => 'group', 'checked' => 'enabled')))) {
            return;
        }

        //ADD DOCUMENT PRIVACY FIELDS AT GROUP CREATION AND EDITION
        if (($module == 'group' || $module == 'advgroup') && ($action == 'create' || $action == 'edit') && ($controller == 'index' || $controller == 'group')) {
            $new_element = $view->form;

            if (empty($new_element)) // Add this condtion for Mobile Plugin and call multipe page from one request
                return;
            //COUNT TOTAL ELEMENTS IN GROUP FORM
//      $total_elements = Count($new_element->getElements());
            $total_elements = 0;

            foreach ($new_element->getElements() as $value) {
                if ($value->helper != 'formHidden') {
                    $total_elements += 1;
                    ;
                }
            }

            $user = Engine_Api::_()->user()->getViewer();

            $availableLabels = array(
                'registered' => 'Registered Members',
                'member' => 'All Group Members',
                'officer' => 'Officers and Owner Only',
            );

            $options = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('group', $user, 'auth_gdcreate');
            $options_create = array_intersect_key($availableLabels, array_flip($options));

            if (!empty($options_create)) {
                $new_element->addElement('Select', 'gdcreate', array(
                    'label' => 'Documents Creation Privacy',
                    'description' => 'Who may create documents in this group?',
                    'multiOptions' => $options_create,
                    'order' => $total_elements - 2,
                ));
                $new_element->gdcreate->getDecorator('Description')->setOption('placement', 'append');
            }

            if ($action == 'edit') {
                $group_id = $front->getRequest()->getParam('group_id');
                $group = Engine_Api::_()->getItem('group', $group_id);

                $auth = Engine_Api::_()->authorization()->context;
                $roles = array('officer', 'member', 'registered', 'everyone');

                foreach ($roles as $role) {
                    if (!empty($options_create)) {
                        if (1 === $auth->isAllowed($group, $role, 'gdcreate')) {
                            $new_element->gdcreate->setValue($role);
                        }
                    }
                }

                $authorization_table = Engine_Api::_()->getDbtable('allow', 'authorization');
                $authorization_tableName = $authorization_table->info('name');
                $gd_create_authorization = $authorization_table->select()
                        ->from($authorization_tableName, 'role')
                        ->where('resource_id = ?', $group_id)
                        ->where('action = ?', 'gdcreate');
                $create_authorizations = $gd_create_authorization->query()->fetchAll();
                $create_authorization_count = Count($create_authorizations);
                if ($create_authorization_count > 0) {
                    if ($create_authorization_count == 1 && $create_authorizations['0']['role'] == 'group_list' && !empty($options_create)) {
                        $set_value = 'officer';
                        $new_element->gdcreate->setValue($set_value);
                    }
                }
            }
        }
    }

}
