<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Level.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract {

  public function init() {
    parent::init();

    $this
            ->setTitle('Member Level Settings')
            ->setDescription("These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.");

    if (!$this->isPublic()) {

      $this->addElement('Radio', 'gdcreate', array(
          'label' => 'Allow Creation of Documents in Groups?',
          'description' => 'Do you want to let members of this level to create documents in group ?',
          'multiOptions' => array(
              2 => 'Yes, allow members to create documents in all groups, including private ones.',
              1 => 'Yes, allow members to create documents in groups.',
              0 => 'No, do not allow members to create documents in groups.',
          ),
          'value' => ( $this->isModerator() ? 2 : 1 ),
      ));
      if (!$this->isModerator()) {
        unset($this->gdcreate->options[2]);
      }

      $this->addElement('MultiCheckbox', 'auth_gdcreate', array(
          'label' => 'Document Creation Options',
          'description' => 'Your users can choose from any of the options checked below when they decide who can create the documents in their group. If you do not check any options, everyone will be allowed to create.',
          'multiOptions' => array(
              'registered' => 'Registered Members',
              'member' => 'All Group Members',
              'officer' => 'Officers and Owner Only',
          )
      ));
    }
  }

}