<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'groupdocument_comment_widgets', array(
        'label' => 'Group Profile Most Commented Documents',
        'description' => 'How many documents should be shown in the Group Profile Most Commented Documents (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'groupdocument_like_widgets', array(
        'label' => 'Group Profile Most Liked Documents',
        'description' => 'How many documents should be shown in the Group Profile Most Liked Documents (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'groupdocument_featurelist_widgets', array(
        'label' => 'Group Profile Featured Documents',
        'description' => 'How many documents should be shown in the Group Profile Featured Documents (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.featurelist.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'groupdocument_popular_widgets', array(
        'label' => 'Group Profile Popular Documents',
        'description' => 'How many documents should be shown in the Group Profile Popular Documents (value cannot be empty or zero) ? [Note: Popularity here is based on the number of views.]',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.popular.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'groupdocument_rate_widgets', array(
        'label' => 'Group Profile Top Rated Documents',
        'description' => 'How many documents should be shown in the top Group Profile Top Rated Documents (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.rate.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'groupdocument_recent_widgets', array(
        'label' => 'Group Profile Recent Documents',
        'description' => 'How many documents should be shown in the Group Profile Recent Documents (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}