<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFieldsController.php 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Groupdocument_AdminFieldsController extends Fields_Controller_AdminAbstract {

  protected $_fieldType = 'groupdocument_document';
  protected $_requireProfileType = false;

  //ACTION FOR MANAGE CUSTOM FIELDS
  public function indexAction() {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('groupdocument_admin_main', array(), 'groupdocument_admin_main_fields');

    parent::indexAction();
  }

  //ACTION FOR CREATING NEW FIELD
  public function fieldCreateAction() {

    parent::fieldCreateAction();

    //GET FORM
    $form = $this->view->form;

    if ($form) {
      $form->setTitle('Add Group document Question');

      $form->removeElement('show');
      $form->addElement('hidden', 'show', array('value' => 0));

      $display = $form->getElement('display');
      $display->setLabel('Show on document page?');
      $display->setOptions(array('multiOptions' => array(
              1 => 'Show on document page',
              0 => 'Hide on document page'
              )));

      $form->addElement('hidden', 'search', array(
          'label' => 'Show on the search options?',
          'multiOptions' => array(
              1 => 'Hide on the search options',
              0 => 'Show on the search options'
          ),
          'value' => 1,
      ));
    }
  }

  //ACTION FOR EDIT THE FIELD
  public function fieldEditAction() {

    parent::fieldEditAction();

    //GET FORM
    $form = $this->view->form;

    if ($form) {
      $form->setTitle('Edit Group document Question');

      $form->removeElement('show');
      $form->addElement('hidden', 'show', array('value' => 0));

      $display = $form->getElement('display');
      $display->setLabel('Show on document page?');
      $display->setOptions(array('multiOptions' => array(
              1 => 'Show on document page',
              0 => 'Hide on document page'
              )));

      $form->addElement('hidden', 'search', array(
          'label' => 'Show on the search options?',
          'multiOptions' => array(
              1 => 'Hide on the search options',
              0 => 'Show on the search options'
          ),
          'value' => 1,
      ));
    }
  }

}