<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Groupgroupdocument
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.tpl 6590 2010-10-19 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Groupdocument/Api/Scribdgroup.php';

class Groupdocument_Widget_ProfileGroupdocumentsController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {
    //DONT RENDER THIS IF NOT AUTHORIZED
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $groupdoc_profiledoc = Zend_Registry::get('groupdocument_profiledoc');
    if (empty($groupdoc_profiledoc)) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = $viewer->level_id;
    } else {
      $this->view->level_id = $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
    }

    //GET SUBJECT AND GROUP ID
    $group_subject = Engine_Api::_()->core()->getSubject('group');
    $this->view->group_id = $group_id = $group_subject->group_id;

    //SET NO RENDER IF VIEWER CAN NOT VIEW THE DOCUMENTS
    $can_view = $group_subject->authorization()->isAllowed($viewer, 'view');
    if ($this->view->level_id != 1) {
      if (empty($can_view)) {
        return $this->setNoRender();
      }
    }

    $extend_group = Engine_Api::_()->getApi('settings', 'core')->core_gingdoc;
    if ($extend_group != 3 * 3) {
      return $this->setNoRender();
    }

    //GET SEARCHING PARAMETERS
    $this->view->page = $page = $this->_getParam('page', 1);
    $this->view->search = $search = $this->_getParam('search');
    $this->view->selectbox = $selectbox = $this->_getParam('selectbox');
    $this->view->checkbox = $checkbox = $this->_getParam('checkbox');
    $this->view->isAjax = $this->_getParam('isAjax', 0);

    $values = array();
    if (!empty($search)) {
      $values['search'] = $search;
    }
    if (!empty($selectbox) && $selectbox == 'featured') {
      $values['featured'] = 1;
      $values['orderby'] = 'document_id';
    } elseif (!empty($selectbox)) {
      $values['orderby'] = $selectbox;
    } else {
      $values['orderby'] = 'document_id';
    }
    if (!empty($checkbox) && $checkbox == 1) {
      $values['owner_id'] = $viewer_id;
    }

    //CHECK WHO CAN CREATE DOCUMENTS
    $this->view->can_create = Engine_Api::_()->authorization()->isAllowed($group_subject, $viewer, 'gdcreate');

		//GET OFFICER LIST
    $this->view->officerList = $group_subject->getOfficerList();

    //GET GROUP OWNER ID
    $this->view->group_user_id = $group_user_id = $group_subject->user_id;

    //BLOCK FOR UPDATING CONVERSION STATUS OF THE DOCUMENT
    $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->groupdocument_api_key;
    $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->groupdocument_secret_key;
    $this->scribdgroup = new Scribdgroup($this->scribd_api_key, $this->scribd_secret);

    //DOCUMENT TABLE
    $documentTable = Engine_Api::_()->getDbtable('documents', 'groupdocument');

    //DOCUMENTS FOR SCRIBD CONVERSION
    $doc_forUpdate = $documentTable->updateDocs($group_id);

    foreach ($doc_forUpdate as $value) {

      if (empty($value->doc_id)) {
        continue;
      }

      $this->scribdgroup->my_user_id = $value->owner_id;

      try {
        $stat = trim($this->scribdgroup->getConversionStatus($value->doc_id));
      } catch (Exception $e) {
        $message = $e->getMessage();
      }

      if ($stat == 'DONE') {
        try {
          //GETTING DOCUMENT'S FULL TEXT
          $texturl = $this->scribdgroup->getDownloadUrl($value->doc_id, 'txt');
          //for some reason, the URL comes back with leading and trailing spaces
          $texturl = trim($texturl['download_link']);

          $file_contents = file_get_contents($texturl);
          if (empty($file_contents)) {
            $site_url = $texturl;
            $ch = curl_init();
            $timeout = 0; //set to zero for no timeout
            curl_setopt($ch, CURLOPT_URL, $site_url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

            ob_start();
            curl_exec($ch);
            curl_close($ch);
            $file_contents = ob_get_contents();
            ob_end_clean();
          }
          $full_text = $file_contents;
          $value->fulltext = $full_text;
          $value->save();

        } catch (Exception $e) {
          if ($e->getCode() == 619) {
            $value->status = 3;
            $value->save();

            //SEND EMAIL TO DOCUMENT OWNER IF GROUP DOCUMENT HAS BEEN DELETED FROM SCRIBD
            Engine_Api::_()->groupdocument()->emailDocumentDelete($value, $group_subject->title, $group_subject->user_id);
          }
        }

        if($value->status != 3 && $value->status != 2) {
          $setting = $this->scribdgroup->getSettings($value->doc_id);
          $thumbnail_url = trim($setting['thumbnail_url']);          
          $value->thumbnail = $thumbnail_url;
          $value->status = 1;
          $value->save();
          
            //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
            $groupdocument = Engine_Api::_()->getItem('groupdocument_document', $value->document_id);
            if ($groupdocument->draft == 0 && $groupdocument->approved == 1 && $groupdocument->status == 1 && $groupdocument->activity_feed == 0) {
              $api = Engine_Api::_()->getDbtable('actions', 'activity');
              $creator = Engine_Api::_()->getItem('user', $groupdocument->owner_id);
              $action = $api->addActivity($creator, $group_subject, 'groupdocument_new');

              //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
              if ($action != null) {
                $api->attachActivity($action, $groupdocument);
                $groupdocument->activity_feed = 1;
                $groupdocument->save();
              }
            }
        }
      } elseif ($stat == 'ERROR') {
        $value->status = 2;
        $value->save();
      }

      //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
      $groupdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.save.local.server', 1);
      if ($groupdocument_save_local_server == 0 && ($value->status == 1 || $value->status == 2)) {
        Engine_Api::_()->groupdocument()->deleteServerDocument($value->document_id);
      }
    }

		//MAKE FEATURED/UN-FEATURED IS ALLOWED OR NOT
    $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.featured', 1);

    //CHECK THAT RATING IS VIEABLE OR NOT
    $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.rating', 1);

    //FETCH DOCUMENTS
    $values['group_id'] = $group_id;
    if ($viewer_id == $group_user_id || $level_id == 1) {
      $values['show_document'] = 0;
      $this->view->paginator = $paginator = $documentTable->getGroupdocumentsPaginator($values);
    } else {
      $values['show_document'] = 1;
      $values['document_owner_id'] = $viewer_id;
      $this->view->paginator = $paginator = $documentTable->getGroupdocumentsPaginator($values);
    }

    //10 DOCUMENTS PER PAGE
    $paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);

    //CHECK THAT CAROUSEL IS VIEABLE OR NOT
    $this->view->show_carousel = Engine_Api::_()->getApi('settings', 'core')->getSetting('groupdocument.carousel', 1);

    $this->view->featureDocuments = array();

    $this->view->total_featureDocuments = 0;

    if (!empty($this->view->show_carousel)) {

      //FETCH DOCUMENTS
      $this->view->featureDocuments = $documentTable->featuredDocuments($group_id);

      $this->view->total_featureDocuments = Count($this->view->featureDocuments);
    }

    //ADD NUMBER OF DOCUMENTS IN TAB
    if ($paginator->getTotalItemCount() > 0) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}
