<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Instaclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Instaclone_Form_Admin_Settings_Configure extends Engine_Form
{

  public function init()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Configure Pages")))
      ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can configure pages and can create backup of pages. If you want to get the previous set up of landing page and other sections of your website, you can configure it from here.")));

    $this->addElement('Radio', 'instaclone_landing_page_layout', array(
      'label' => 'Ultimate Insta Clone Landing Page',
      'description' => "Do you want Landing Page setup of Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Landing Page as default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous setup of Landing Page which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.landing.page.layout', 1),
    ));

    $this->addElement('Radio', 'instaclone_header_page_layout', array(
      'label' => 'Ultimate Insta Clone Header',
      'description' => "Do you want Header as Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the header as in default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous Header which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.header.page.layout', 1),
    ));

    $this->addElement('Radio', 'instaclone_footer_page_layout', array(
      'label' => 'Ultimate Insta Clone Footer',
      'description' => "Do you want Footer as Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Footer as in default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous Footer which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.footer.page.layout', 1),
    ));

    $this->addElement('Radio', 'instaclone_login_page_layout', array(
      'label' => 'Ultimate Insta Clone Login Page',
      'description' => "Do you want Login page setup of Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Login page as default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous setup of Login page which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.login.page.layout', 1),
    ));

    $this->addElement('Radio', 'instaclone_login_required_page_layout', array(
      'label' => 'Ultimate Insta Clone Login Required Page',
      'description' => "Do you want Login Required Page setup of Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Login Required Page as default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous setup of Login Required Page which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.login.required.page.layout', 1),
    ));

    $this->addElement('Radio', 'instaclone_signup_page_layout', array(
      'label' => 'Ultimate Insta Clone Sign Up Page',
      'description' => "Do you want Sign Up Page setup of Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Sign Up Page as default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous setup of Sign Up Page which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.signup.page.layout', 1),
    )); 

    $this->addElement('Radio', 'instaclone_forgot_password_page_layout', array(
      'label' => 'Ultimate Insta Clone Forgot Password Page',
      'description' => "Do you want Forgot Password Page setup of Ultimate Insta Clone Theme? If you choose ‘Yes’ you will get the Forgot Password Page as default setup of Ultimate Insta Clone Theme. If chosen ‘No’, you will get the previous setup of Forgot Password Page which was before the installation of Ultimate Insta Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('instaclone.forgot.password.page.layout', 1),
    )); 

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
