<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Instaclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Instaclone_Form_Admin_Settings_Header extends Engine_Form
{

  public function init()
  {
    $this->setTitle("Manage Header");
    $this->setDescription("Here you can manage settings related to header.");

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $isStoreproductEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestoreproduct');

    $imgOptions = Engine_Api::_()->instaclone()->getImages(array('application/modules/Instaclone/externals/images/insta_logo.png' => 'Default logo','' => "Text-only (No logo)"));

    $this->addElement('Select', 'instaclone_header_logo_image', array(
      'label' => 'Select Logo',
      'description' => 'Select the logo for your website. [Note: Logo must be uploaded prior from Admin Panel → Appearance → File & Media Manager.]',
      'multiOptions' => $imgOptions,
      'value' => $coreSettings->getSetting('instaclone.header.logo.image', ''),
    ));

    $headerOptions = array(
      'logo' => 'Site Logo',
      'mini_menu' => 'Mini Menu',
      'main_menu' => 'Main Menu ',
      'search_box' => 'Search Box',
    );

    $deafultHeaderOptions = array(
      'logo',
      'mini_menu',
      'main_menu',
      'search_box',
    );

    $this->addElement('MultiCheckbox', 'instaclone_header_loggedin_widgets', array(
      'label' => 'Header Elements for Logged In Members',
      'description' => 'Select the elements you want to display in header section for logged in members.',
      'multiOptions' => $headerOptions,
      'value' => $coreSettings->getSetting('instaclone.header.loggedin.widgets', $deafultHeaderOptions),
    ));
    
    $this->addElement('MultiCheckbox', 'instaclone_header_loggedout_widgets', array(
      'label' => 'Header Elements for Non-Logged In Members',
      'description' => 'Select the options you want to display in header section for non-logged in / guest members.',
      'multiOptions' => $headerOptions,
      'value' => $coreSettings->getSetting('instaclone.header.loggedout.widgets', $deafultHeaderOptions),
    ));

    $this->addElement('radio', 'instaclone_header_main_menu_position', array(
      'label' => 'Main menu Position',
      'description' => 'Select the position of main menu present in the header.',
      'multiOptions' => array('left' => 'Left Side', 'right' => 'Right Side'),
      'value' => $coreSettings->getSetting("instaclone.header.main.menu.position", "left")
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
