<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestories
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Genral.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Livestreamingvideo_Form_Admin_Manage_Global extends Engine_Form {


  public function init() {

    $this->setTitle('Global Settings')
          ->setDescription('These settings will affect all members in your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    
    $this->addElement('Text', 'livestreamingvideo_agora_app_id', array(
        'label' => 'Agora App ID',
        'description' => 'Create an <a href="https://www.agora.io/en" target="_blank"> Account on Agora </a> > Create a Project > and you will get Project ID that you need to fill above.',
        'required' => true,
        'value' => $settings->getSetting('livestreamingvideo_agora_app_id', ''),
    ));

    $this->livestreamingvideo_agora_app_id->getDecorator('Description')->setOption('escape', false)->setOption('placement', 'append');

    $this->addElement('Text', 'livestreamingvideo_agora_app_certificate', array(
        'label' => 'Agora App Certificate',
        'description' => 'Enter primary Certificate.',
        'required' => true,
        'value' => $settings->getSetting('livestreamingvideo_agora_app_certificate', ''),
    ));

    $this->livestreamingvideo_agora_app_certificate->getDecorator('Description')->setOption('escape', false)->setOption('placement', 'append');
    
    $this->addElement('Text', 'livestreamingvideo_url', array(
       'label' => 'Agora Server URL',
       'description' => 'Enter Agora Recording Server URL.<br><b>Note:</b> Agora URL must be with https if your SE website is SSL certified and must end with Slash("/"). For Example, http://localhost:3000/',
       'required' => true,
       'validators' => array(
          array('Regex', true, array('/\/$/')),
      ),
       'value' => $settings->getSetting('livestreamingvideo.url'),
    ));

    $this->livestreamingvideo_url->getValidator('Regex')->setMessage('Url Must end with Slash("/")');
    $this->livestreamingvideo_url->getDecorator('Description')->setOption('escape', false)->setOption('placement', 'append');

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelivestreaming')) {
      $this->addElement('Radio', 'livestreamingvideo_reactions', array(
          'label' => 'Do you want to use default GIF as reactions for this plugin?',
          'description' => 'Do you want to use default GIF reactions for this plugin for like, love, angry, haha, wow, sad ?',
          'multiOptions' => array(
            1 => 'Yes',
            0 => 'No',
          ),
          'value' => $settings->getSetting('livestreamingvideo.reactions', 1),
      ));
    }
    
    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
 
}

?>