<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Level.php 10100 2013-10-24 23:09:16Z guido $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Blog
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Livestreamingvideo_Form_Admin_Manage_Level extends Authorization_Form_Admin_Level_Abstract
{
  public function init()
  {
    parent::init();

    // My stuff
    $this
      ->setTitle('Member Level Settings')
      ->setDescription("LIVESTREAMING_FORM_ADMIN_LEVEL_DESCRIPTION");

    if( !$this->isPublic() ) {
      $this->addNotice('<b>Important Note:</b> A Member Level Setting "Storage Quota" is not considered for Live Videos so, you should carefully set the value of "Maximum allowed time for Live Videos" from the field below.');

      $this->addElement('Radio', 'go_live', array(
        'label' => 'Enable Go Live?',
        'description' => 'Do you want to enable Go Live Feature?',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No',
        ),
        'value' => 1,
      ));

      $this->addElement('Text', 'max_allowed_duration', array(
        'label' => 'Maximum Allowed Time for Live Videos (in minutes)',
        'description' => 'User will be informed about the allowed time for Live Videos before he goes live from the app. Enter the maximum time you want to allow this member level for Go Live Feature.',
        'value' => 2,
        'required' => true,
        'validators' => array(
          array('Int', true),
          array('Between', true, array('min' => 2, 'max' => 90, 'inclusive' => true))
        ),
      ));

      $this->addElement('Radio', 'allow_recording', array(
        'label' => 'Allow Recording?',
        'description' => 'Do you want to allow recording feature? If this feature is disabled, user will not be able to share or post the video.',
        'multiOptions' => array(
          1 => 'Yes',
          0 => 'No',
        ),
        'value' => 1,
      ));

      $this->addElement('Text', "max_streamings", array(
        'label' => 'Maximum Allowed Live Streamings',
        'description' => 'Enter the maximum number of live streamings that this level can create. This field must contain an integer, use zero for unlimited.',
        'required' => true,
        'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(0),
        ),
      ));

      $this->addElement('MultiCheckbox', 'auth_view', array(
        'label' => 'Live Streaming Privacy',
        'description' => 'Your members can choose from any of the options checked below and decide visibility of their streaming. These options will appear on your live streaming page. If you do not check any options, settings will be saved as per the last saved configuration. If you select only one option, members of this level will not have a choice.',
        'multiOptions' => array(
          'everyone'  => 'Everyone',
          'networks'  => 'Networks Only',
          'friends'   => 'Friends Only',
          'onlyme'    => 'Only Me',
        ),
        'value' => array('everyone', 'networks', 'friends', 'onlyme'),
      ));
    }
  }
}