<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteiosapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Livestreamingvideo_AdminSettingsController extends Core_Controller_Action_Admin {

    public function indexAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
        ->getNavigation('livestreamingvideo_admin_main', array(), 'livestreamingvideo_admin_main_settings');

        $this->view->form  = $form = new Livestreamingvideo_Form_Admin_Manage_Global();

        if( !$this->getRequest()->isPost() ) {
            return;
        }
        if( !$form->isValid($this->getRequest()->getPost()) ) {
            return;
        }
        $values = $form->getValues();

        foreach ($values as $key => $value) {
            if( !is_null($value) ) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            } else {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, '');
            }
        }
        $form->addNotice('Your changes have been saved.');
            
    }

    public function reportAction()
    {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('livestreamingvideo_admin_main', array(), 'livestreamingvideo_admin_main_report');

        //FORM GENERATION
        $this->view->formFilter = $formFilter = new Livestreamingvideo_Form_Admin_Filter();

        $page = $this->_getParam('page',1);

        //GET USER TABLE NAME
        $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');

        $getStreamTable = Engine_Api::_()->getDbtable('streams', 'livestreamingvideo');
        $streamTableName = $getStreamTable->info('name');
        //MAKE QUERY
        $select = $getStreamTable->select()->setIntegrityCheck(false)
                        ->from($streamTableName)
                        ->joinLeft($tableUserName, "$streamTableName.owner_id = $tableUserName.user_id", array('displayname', 'level_id'));

        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        foreach ($values as $key => $value) {
            if (null == $value)
                unset($values[$key]);
        }

        $values = array_merge(array(
            'order' => 'stream_id',
            'order_direction' => 'DESC',
        ), $values);

        if( !empty($values['displayname']) ) {
            $select->where('displayname LIKE ?', '%' . $values['displayname'] . '%');
        }

        if( !empty($values['title']) ) {
            $select->where('title LIKE ?', '%' . $values['title'] . '%');
        }

        if( !empty($values['level_id']) ) {
            $select->where('level_id = ?', $values['level_id']);
        }

        $select->order((!empty($values['order']) ? $values['order'] : 'stream_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

        $this->view->formValues = array_filter($values);
        $this->view->assign($values);

        $this->view->paginator = Zend_Paginator::factory($select);
        $this->view->paginator->setItemCountPerPage(20);
        $this->view->paginator->setCurrentPageNumber($page);
    }


    public function faqsAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('livestreamingvideo_admin_main', array(), 'livestreamingvideo_admin_main_faqs');
    }

}
