<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package	Mapprofiletypeleve
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license	http://www.socialengineaddons.com/license/
 * @version	$Id: Delete.php 2010-09-06 9:40:21Z SocialEngineAddOns $
 * @author 	SocialEngineAddOns
 */
class Mapprofiletypelevel_Form_Admin_Delete extends Engine_Form
{
  public function init()
  {
	    $this->setTitle("Delete Profile Type to Member Level mapping")
	      ->setDescription('Are you sure you want to delete this mapping ? You can move all the users of this Profile Type from their existing Member Level to a different one by selecting it below.');
	
     // Prepare user levels
    $levelOptions = array();
    foreach( Engine_Api::_()->getDbtable('levels', 'authorization')->fetchAll() as $level ) {
      $levelOptions[$level->level_id] = $level->getTitle();
    }

    // Element: level_id
    $this->addElement('Select', 'level_id', array(
      'label' => 'Member Level',
      'multiOptions' => $levelOptions,
      'ignore' => true,
			'value' => Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel()->level_id
    ));

	    $this->addElement('Button', 'submit', array(
	      'label' => 'Delete Mapping',
	      'type' => 'submit',
	      'ignore' => true,
	      'decorators' => array('ViewHelper'),
	    ));
	
	    $this->addElement('Cancel', 'cancel', array(
	      'label' => 'cancel',
	      'prependText' => ' or ',
	      'ignore' => true,
	      'link' => true,
	      'onClick' => 'parent.Smoothbox.close();',
	      'decorators' => array('ViewHelper'),
	    ));
	
	    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }
}
?>