<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Suggestions.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Peopleyoumayknow_Model_DbTable_Suggestions extends Engine_Db_Table {

  protected $_name = 'suggestion_suggestions';
  protected $_rowClass = 'Peopleyoumayknow_Model_Suggestion';

  public function setSuggestion($ownerId, $entity, $entityId, $notificationType) {

	$senderId = Engine_Api::_()->user()->getViewer()->getIdentity();
	$row = $this->createRow();
	$row->owner_id = $ownerId;
	$row->sender_id = $senderId;
	$row->entity = $entity;
	$row->entity_id = $entityId;
	$row->save();

	$ownerObj = Engine_Api::_()->getItem('user', $ownerId);
	$senderObj = Engine_Api::_()->getItem('user', $senderId);
	// $ownerObj : Object which are geting suggestion.
	// $senderObj : Object which are sending suggestion.
	// $row : Object from which table we'll link.
	// $notificationType :notification type.
	// $row->setType('suggestion');

	Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($ownerObj, $senderObj, $row, $notificationType);
  }

  public function removeSuggestion($entity, $entityId, $notificationType = null) {
	if (empty($notificationType)) {
	  $getModInfo = Engine_Api::_()->getApi('modInfo', 'peopleyoumayknow')->getPluginDetailed($entity);
	  $notificationType = $getModInfo[$entity]['notificationType'];
	}
	$ownerId = Engine_Api::_()->user()->getViewer()->getIdentity();
	$tableName = $this->info('name');
	$select = $this->select()
					->from($tableName, array('suggestion_id'))
					->where('owner_id = ?', $ownerId)
					->where('entity = ?', $entity)
					->where('entity_id = ?', $entityId);
	$fetchObj = $select->query()->fetchAll();
	if (!empty($fetchObj)) {
	  foreach ($fetchObj as $suggestionId) {
		$suggestionId = $suggestionId['suggestion_id'];
		Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('object_id = ?' => $suggestionId, 'type = ?' => $notificationType));
		$getSuggObj = Engine_Api::_()->getItem('suggestion', $suggestionId);
		if( !empty($getSuggObj) ) {
		  $getSuggObj->delete();
		}
		if ($entity == 'photo') {
		  Engine_Api::_()->getItem('suggestion_photo', $entityId)->delete();
		  Engine_Api::_()->getItem('suggestion_album', $suggestionId)->delete();
		}
	  }
	}
	// If entity is "Friend" then we are again re,oved the suggestion of "Few Friend" becouse there are entity is differ.
	if ($entity == 'friend') {
	  $this->removeSuggestion('friendfewfriend', $entityId, $notificationType);
	}
  }

  public function getSendSuggestion($entity) {
	$viewer = Engine_Api::_()->user()->getViewer();
	if (empty($entity)) {
	  return;
	}
	$select = $this->select()
					->where('entity = ?', $entity)
					->where('sender_id = ?', $viewer->getIdentity());

	$select = $select->query()->fetchAll();
	$suggestedUserStr = 0;
	foreach ($select as $notInUser) {
	  $suggestedUserStr .= "," . $notInUser['owner_id'];
	}
	$suggestedUserStr = trim($suggestedUserStr, ",");
	return $suggestedUserStr;
  }

  // We pass "suggestion_id" in this table and it will find out entity on that Id and then reurn to us the complate object of suggestion.
  public function getSuggestion($suggId, $getSenderIds = null) {
	if (empty($suggId)) {
	  return;
	}
	$viewer = Engine_Api::_()->user()->getViewer();
	$viewer_id = $viewer->getIdentity();
	$suggObj = Engine_Api::_()->getItem('suggestion', $suggId);
	if (empty($suggObj)) {
	  return;
	}
	$entity = $suggObj->entity;
	// if( $entity == 'friendfewfriend' ){ $entity = 'friend'; }
	$getModInfo = Engine_Api::_()->getApi('modInfo', 'peopleyoumayknow')->getPluginDetailed($entity);
	$senderObj = Engine_Api::_()->getItem('user', $suggObj->sender_id);
	if (!empty($suggObj) && !empty($getModInfo)) {
	  $modObj = Engine_Api::_()->getItem($getModInfo[$entity]['itemType'], $suggObj->entity_id);
	  // If "Mod Object" will be empty then it mense that content has been deleted but suggestion not deleted in that case we are deleting that suggestion forcefully.

	  if (!empty($modObj)) {
		$modArray['modInfos'] = $getModInfo[$entity];
		$modArray['senderName'] = $senderObj;
		$modArray['suggObj'] = $suggObj;
		$modArray['modObj'] = $modObj;

		if (!empty($getSenderIds)) {
		  $getUserIdsArray = explode(',', $getSenderIds);
		  $modArray['senderCount'] = @COUNT($getUserIdsArray);
		}
		return $modArray;
	  } else {
		$this->removeSuggestion($entity, $suggObj->entity_id);
		return;
	  }
	}
	return;
  }

}