<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Peopleyoumayknow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2010-08-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('People you may know'),
        'description' => $view->translate('This widget shows the Friend Suggestions.'),
        'category' => $view->translate('People You May Know'),
        'type' => 'widget',
        'name' => 'Peopleyoumayknow.suggestion-friend',
        'defaultParams' => array(
            'title' => $view->translate('People you may know')
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'getWidLimit',
                    array(
                        'label' => 'Friend Suggestions Widget',
                        'description' => 'How many suggestions do you want to display in the Friend Suggestions Widget ?',
                        'value' => 3
                    )
                ),
                array(
                    'Text',
                    'friendMaxLimit',
                    array(
                        'label' => 'Maximum Limit Of Friends.',
                        'description' => 'Suggestions will be displayed on Member home page if user has friends less than or equal to the "Maximum limit of friends".',
                        'default' => '100',
                        'value' => '100'
                    )
                ),
                array(
                    'Radio',
                    'suggestionView',
                    array(
                        'label' => $view->translate('Select the display type for Suggestions.'),
                        'multiOptions' => array(
                            'list' => $view->translate('List View'),
                            'grid' => $view->translate('Grid View'),
                        ),
                        'default' => 'list',
                        'value' => 'list',
                    )
                ),
                array(
                    'Radio',
                    'carouselView',
                    array(
                        'label' => $view->translate('Do you want Carousel View (Sliding effect) for Suggestions ? (Note: This Carousel View can work only when you select Grid View.)'),
                        'multiOptions' => array(
                            '1' => $view->translate('Yes'),
                            '0' => $view->translate('No'),
                        ),
                        'default' => '0',
                        'value' => '0',
                    )
                )
            ),
        ),
    )
);
?>