<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Phpfoximporter_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */

        if (!empty($method) && $method == 'Phpfoximporter_Form_Admin_Global') {
            
        }
        return true;
    }

    public function indexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('phpfoximporter_admin_main', array(), 'phpfoximporter_admin_settings_index');

        $this->view->form = $form = new Phpfoximporter_Form_Admin_Global();
        if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
            $values = $form->getValues();

            if (array_key_exists('phpfoximporter_data_import', $values)) {
                unset($values['phpfoximporter_data_import']);
            }

            foreach ($values as $key => $value) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            }

            $form->addNotice('Your changes have been saved.');
        }
    }

    public function logAction() {
        $this->_redirect('admin/log?file=import-phpfox&length=50&execute=');
    }

    public function faqAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('phpfoximporter_admin_main', array(), 'phpfoximporter_admin_settings_faq');
        $this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
    }

    public function readmeAction() {
        
    }

    public function phpfoxAction() {
        // Check auth
        $viewer = Engine_Api::_()->user()->getViewer();
        if (!$viewer || !$viewer->getIdentity()) {
            return $this->_helper->redirector->gotoRoute(array(), 'admin_default', true);
        }
        $viewerLevel = Engine_Api::_()->getDbtable('levels', 'authorization')->find($viewer->level_id)->current();
        if (null === $viewerLevel || $viewerLevel->flag != 'superadmin') {
            return $this->_helper->redirector->gotoRoute(array(), 'admin_default', true);
        }
        // Build package url
        $authKeyRow = Engine_Api::_()->getDbtable('auth', 'core')->getKey(Engine_Api::_()->user()->getViewer(), 'package');
        $this->view->authKey = $authKey = $authKeyRow->id;

        $installUrl = rtrim($this->view->baseUrl(), '/') . '/install';
        if (strpos($this->view->url(), 'index.php') !== false) {
            $installUrl .= '/index.php';
        }

        $http = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"])) ? "https://" : "http://";
        $return_url = $http . $_SERVER['HTTP_HOST'] . $installUrl . '/phpfoximport/phpfox-instructions';
        $installUrl .= '/auth/key' . '?key=' . $authKey . '&uid=' . Engine_Api::_()->user()->getViewer()->getIdentity() . '&return=' . $return_url;
        return $this->_helper->redirector->gotoUrl($installUrl, array('prependBase' => false));
    }

}
