<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Configuration.php 2017-06-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Primemessenger_Form_Admin_Configuration extends Engine_Form {

    public function init() {

        $this
                ->setTitle('Channelize.io Configuration')
                ->setAttrib('class', 'primemessenger_config_form')
                ->setDescription('Configure Channelize.io details. (Note: After making any Theme related changes in Channelize.io Dashboard, make sure you reconfigure here again.)');

        $this->addElement('hidden', 'primemessenger_error', array(
            'value' => '0',
            'order' => 999
        ));

        $this->addElement('Text', 'primemessenger_apikey', array(
            'label' => 'API key',
            'description' => 'Get API key from your "Account Dashboard" on <a href="https://channelize.io" target="_blank">https://channelize.io</a>.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey'),
            'required' => true
        ));
        $this->getElement('primemessenger_apikey')->getDecorator('Description')->setOptions(array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $this->addElement('Text', 'primemessenger_publickey', array(
            'label' => 'Public key',
            'description' => 'Get Public key from your "Account Dashboard" on <a href="https://channelize.io/">https://channelize.io/</a>.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.publickey'),
            'required' => true
        ));
        $this->getElement('primemessenger_publickey')->getDecorator('Description')->setOptions(array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $this->addElement('Text', 'primemessenger_subdomain', array(
            'label' => 'Subdomain',
            'description' => 'Subdomain is the part of your website domain. Get it from your "Account Dashboard" on <a href="https://channelize.io/">https://channelize.io/</a>.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.subdomain'),
            'required' => true
        ));
        $this->getElement('primemessenger_subdomain')->getDecorator('Description')->setOptions(array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));

        $pmColor = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.color');

        $this->addElement('hidden', 'primemessenger_color', array(
            'value' => $pmColor,
            'order' => 990
        ));

        // Add submit button
        $this->addElement('Button', 'primemessenger_submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true,
        ));
    }

}
