<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Actions.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

use PrimeMessenger\Primemessenger\User;

class PrimeMessenger_Model_DbTable_ClientServerTokens extends Engine_Db_Table {

    protected $_name = 'primemessenger_client_tokens';
    
    public $clientServerToken;   

    public function create($userId)
    {
      $hashedToken = hash('md5',rand());
      $tokenData = [
                    "token" => $hashedToken , 
                    "user_id" => $userId , 
                    "created_at" => new Zend_Db_Expr('NOW()') 
                   ];
      if($this->insert($tokenData)){
        $this->clientServerToken = $hashedToken;
        return $this->clientServerToken;
      }
    }

    public function getByUserId( $token , $userId)
    {

      $rows =  $this->select()
        ->from($this)
        ->where('user_id = ?', $userId)
        ->where('token = ?', $token)
        ->query()
        ->fetchAll();
        print_r($row);
      
      return $rows[0] ? $rows[0] : null;
    }


    public function deleteOldTokens($user_id, $offsetDays)
    { 
      // Delete old tokens
      $this->delete(array(
          'user_id = ?' => $user_id,
          'created_at <= ?' => new Zend_Db_Expr('DATE_SUB(NOW(),INTERVAL '.$offsetDays.' DAY)'),
      ));
    }
    
    public function deleteToken($token, $user_id)
    { 
      // Delete old tokens
      $this->delete(array(
          'user_id = ?' => $user_id,
          'token = ?' => $token
      ));
    }

}