<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    PrimeMessenger
 * @copyright  Copyright 2017-2018 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Core.php 10088 2017-06-12 13:34:37Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
use PrimeMessenger\Primemessenger\User;

class Primemessenger_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public $isCreatedActivity = false;

    public function routeShutdown(Zend_Controller_Request_Abstract $request) {

        // $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        // if (!$isPrimeMessengerActive) {
        //     return;
        // }

        // $loader = Engine_Loader::getInstance();
        // $membershipClassName = 'Primemessenger_Model_DbTable_Membership';
        // $blockClassName = 'Primemessenger_Model_DbTable_Block';
        // Engine_Loader::loadClass($membershipClassName);
        // Engine_Loader::loadClass($blockClassName);
        // if (method_exists($loader, 'setComponent')) {
        //     $loader->setComponent('User_Model_DbTable_Membership', new $membershipClassName());
        //     $loader->setComponent('User_Model_DbTable_Block', new $blockClassName());
        // }
    }

    public function onRenderLayoutDefault($event) {
        // Arg should be an instance of Zend_View
        $view = $event->getPayload();

        $viewer = Engine_Api::_()->user()->getViewer();
        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();

        // Get subject owner
        $subject = null;
        if( null === $subject && Engine_Api::_()->core()->hasSubject() ) {
          $subject = Engine_Api::_()->core()->getSubject();
        }

        $subjectOwnerIdentity = null;
        if ($subject) {
            if( $subject instanceof User_Model_User ) {
              $subjectOwnerIdentity = $subject->getIdentity();
            } else {
              try {
                $subjectOwnerIdentity = $subject->getOwner('user')->getIdentity();
              } catch( Exception $e ) {
              }
            }
        }
        $seaocoreApi = Engine_Api::_()->seaocore();
        if (method_exists($seaocoreApi, 'isSitePWAMode') && $seaocoreApi->isSitePWAMode()) {
          return;
        }
        if ($view instanceof Zend_View && $viewer->getIdentity() && $isPrimeMessengerActive ) {

            // Get public key
            $publicKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.publickey');
            $subdomain = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.subdomain');
            $color = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.color');
            
            $needLogin = false;
            $accessToken = '';

            if (empty($_COOKIE['pm_access_token']) || $_COOKIE['pm_access_token'] == "") {
                $needLogin = true;
            }
            else{
                $userParams = explode("uid", $_COOKIE['pm_access_token']);
                $needLogin = $userParams[1] != $viewer->user_id ? true : false;
                
                if(!$userParams[0] || $userParams[0] == "" || !$userParams[1]){
                   $needLogin = true;
                }
                else{
                    $accessToken = $userParams[0];
                }
            }

            try{
                if ($needLogin) {
                   $this->onUserLoginAfter($event, $viewer->user_id);
                    $userParams = explode("uid", $_COOKIE['pm_access_token']);
                    $accessToken = $userParams[0];
                }       
            } catch( Exception $e ) {}

            $script = <<<EOF
   var subjectOwnerIdentity = '{$subjectOwnerIdentity}';

   function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+ d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
  }

  (function(d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s); js.id = id;
    js.src = "https://apps.channelize.io/sdk/channelize-sdk.js";
    fjs.parentNode.insertBefore(js, fjs);
    window._pmOptions = {
        publicKey: '{$publicKey}',
        accessToken: '{$accessToken}',
        color: '{$color}',
        subdomain: '{$subdomain}'
    };
  }(document, "script", "primemessenger-jssdk"));
EOF;
            if (isset($_SERVER["HTTPS"])) {
                $headLink = new Zend_View_Helper_HeadLink();
                $headLink->headLink(array('rel' => 'manifest', 'href' => $view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/manifest.json'), 'PREPEND');

               $view->headScript()
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/core.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/firebase-app.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/firebase-messaging.js')
                    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/push-notification.js')
                    ->appendScript($script);
           }
            else{
		$view->headScript()
		    ->appendFile($view->layout()->staticBaseUrl . 'application/modules/Primemessenger/externals/scripts/core.js')
		    ->appendScript($script);
            }

        }
    }

    public function onUserCreateAfter($event) {
        $this->isCreatedActivity = true;
        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        $isPrimeMessengerMigrated = Engine_Api::_()->primemessenger()->hasMigrated();

        if (!$isPrimeMessengerActive && !$isPrimeMessengerMigrated) {
            return;
        }

        $user = $event->getPayload();
        if (!($user instanceof User_Model_User)) {
            return;
        }
        $translatedUser = $this->_translateUser($user);
        $translatedUser['password'] = str_replace("$2y$","$2a$",password_hash("123456", PASSWORD_DEFAULT));
        try {
            $user = new User();
            $user->create($translatedUser);
        } catch (Exception $e) {
        }
    }

    public function onUserDeleteAfter($event) {

        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        $isPrimeMessengerMigrated = Engine_Api::_()->primemessenger()->hasMigrated();

        if (!$isPrimeMessengerActive && !$isPrimeMessengerMigrated) {
            return;
        }

        $payload = $event->getPayload();
        try {
            $user = new User($payload['identity']);
            $user->delete();
        } catch (Exception $e) {
        }
    }

    public function onUserUpdateAfter($event) {

        $action = $this->isCreatedActivity ? 'created' :'updated';
        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        $isPrimeMessengerMigrated = Engine_Api::_()->primemessenger()->hasMigrated();

        if (!$isPrimeMessengerActive && !$isPrimeMessengerMigrated) {
            return;
        }

        $payload = $event->getPayload();

        if (!($payload instanceof User_Model_User)) {
            return;
        }
        $modifiedFields = $payload->getModifiedFieldsName();
        if (in_array('view_count', $modifiedFields)) {
            return;
        }

        $requiredFields = array('displayname','email','language','photo_id');

        if (!count(array_intersect($modifiedFields, $requiredFields))) {
            return;
        }

        $translatedUser = $this->_translateUser($payload);

        if(in_array('photo_id' , $modifiedFields) && !$translatedUser['profileImageUrl']){
          $translatedUser['profileImageUrl'] = "";
        }

        try {
            $user = new User($payload->user_id);
            $user->update($translatedUser);
        } catch (Exception $e) {

        }
    }
    
    public function onUserLoginAfter($event , $userId = null){
        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        if (!$isPrimeMessengerActive) {
            return;
        }        

        $payload = $event->getPayload();
        if (!($payload instanceof User_Model_User) && !$userId) {
            return;
        }
        $userId = $userId ? $userId : $event->getPayload()->user_id;
        if($userId){
            $clientServerToken = Engine_Api::_()->getDbTable('ClientServerTokens','primemessenger')->create($userId);
            // Login From P.M
            $token = $this->loginFromPm($clientServerToken,$userId);
            $_REQUEST['pmAccessToken'] = $token;
            
            // Set Cookie pm_access_token
            if($token && $token != ""){
                setcookie("pm_access_token", $token.'uid'.$userId);
            }
        }
    }

    public function loginFromPm($token, $userId){
      try {
          $user = new User();
          $loginData = ["pmClientServerToken" => (string) $token , "userId" => (string) $userId ,'authenticationType' => 0];
          $res = $user->login($loginData);
          $data = Zend_Json::decode($res->getBody());
          return $data['id'];
      } catch (Exception $e) {
      }      
    }

    public function onUserLogoutBefore($event) {

        $isPrimeMessengerActive = Engine_Api::_()->primemessenger()->isPrimeMessengerActive();
        if (!$isPrimeMessengerActive) {
            return;
        }
        
        $payload = $event->getPayload();
        if (!($payload instanceof User_Model_User)) {
            return;
        }
        
        $deviceId = $_REQUEST['device_uuid'] ? $_REQUEST['device_uuid'] : $_COOKIE['browser_fingerprint'];
        $cookieAccessToken = $_COOKIE['pm_access_token'] ? explode("uid", $_COOKIE['pm_access_token'])[0] : '';
        $pmAccessToken = $_REQUEST['pm_access_token'] ? $_REQUEST['pm_access_token'] : $cookieAccessToken;

        if (!empty($_COOKIE['pm_access_token'])) {
            unset($_COOKIE['pm_access_token']);
            setcookie("pm_access_token", "", time() - 3600);
        }
        
        if (!empty($_COOKIE['browser_fingerprint'])) {
            unset($_COOKIE['browser_fingerprint']);
            setcookie("browser_fingerprint", "", time() - 3600 , '/');
        }

        try {
            $user = new User($payload->user_id);
            $user->logout(['deviceId' => (string) $deviceId , 'accessToken' => (string) $pmAccessToken]);
        } catch (Exception $e) {}
    }

    private function _translateUser($user) {
        $newUser = array();
        $newUser['id'] = $user->user_id;
        $newUser['displayName'] = strtolower($user->getTitle());
        $newUser['email'] = $user->email;
        $newUser['language'] = $user->language;

        if (!Zend_Registry::isRegistered('Zend_View')) {
            $this->setView();
        }

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $newUser['profileUrl'] = $view->serverUrl() . $user->getHref();

        $photoUrl = $user->getPhotoUrl();
        if (!$photoUrl) {
            return $newUser;
        }

        if (!preg_match('/http:\/\//', $photoUrl) && !preg_match('/https:\/\//', $photoUrl)) {
            $photoUrl = str_replace($view->baseUrl(), "",  $photoUrl);
            $newUser['profileImageUrl'] = $view->serverUrl() . $view->baseUrl() . '/' . $photoUrl;
        } else {
            $newUser['profileImageUrl'] = $photoUrl;
        }

        return $newUser;
    }

    public function setView() {
        $view = new Zend_View();
        $view->setEncoding('utf-8');
        $view->addScriptPath(APPLICATION_PATH);
        $view->addHelperPath('Engine/View/Helper/', 'Engine_View_Helper_');
        Zend_Registry::set('Zend_View', $view);
    }
}
