<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    ChatRooms.php 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class PrimeMessenger_Migrate_Chat_ChatRooms extends PrimeMessenger_Migrate_DbAbstract {

    protected $_fromTable = 'engine4_chat_rooms';
    protected $_warningMessage = array();
    protected $_priority = 1000;
    protected $_jsonFileName = 'chat-rooms';

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'chat_rooms';
       
    }

    protected function _translateRow(array $data, array &$jsonData) {

        $members = $this->getMembers($data);
    
        $createdDate = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'chat_messages', 'date')
                ->where('room_id = (?)', $data['room_id'])
                ->order('message_id ASC')
                ->query()
                ->fetchColumn();

        $newData = array();
        $newData['roomId'] = $data['room_id'];
        $newData['memberCount'] = count($members);

        // This is for removing title key from one-to-one conversation
        if($newData['memberCount'] > 2){
            $newData['title'] = $data['title'] ? $data['title'] : 'Untitled';
        }

        $newData['ownerId'] = $members[0];
        $newData['resourceType'] = 'user';
        $newData['members'] = array_values(array_filter($members));
        $newData['createdAt'] = $createdDate ? $createdDate : $data['modified_date'];
        $newData['updatedAt'] = $data['modified_date'];     
        $jsonData[] =  $newData;
    }
    
    public function getMembers($data){
        $members = array();
        $levelIds = [1,2];
        $chatMembers = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'chat_messages' , 'user_id')
                ->where('room_id = (?)', $data['room_id'])
                ->distinct()
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);

        $adminIds = $this->getFromDb()->select()
                    ->from($this->getfromPrefix() . 'users', 'user_id')
                    ->where('level_id IN (?)', $levelIds)
                    ->order('level_id ASC')
                    ->query()
                    ->fetchAll(Zend_Db::FETCH_COLUMN);
       $members = array_unique(array_merge($adminIds, $chatMembers));
       return $members;
    }
}