<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    ChatRooms.php 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class PrimeMessenger_Migrate_CometChat_ChatRooms extends PrimeMessenger_Migrate_DbAbstract {

    protected $_fromTable = 'cometchat_chatrooms';
    protected $_warningMessage = array();
    protected $_priority = 1000;
    protected $_jsonFileName = 'chat-rooms';

    protected function _initPre() {
        $this->_fromTable = 'cometchat_chatrooms';
       
    }

    protected function _translateRow(array $data, array &$jsonData) {

        $members = $this->getMembers($data);
        
        // $timeZone = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.timezone');
        // date_default_timezone_set("$timeZone");
        $createdAt = $this->getFromDb()->select()
                ->from('cometchat_chatroommessages' , 'sent')
                ->where('chatroomid = (?)', $data['id'])
                ->order('id ASC')
                ->query()
                ->fetchColumn();
    
        $newData = array();
        $newData['roomId'] = $data['id'];
        $newData['memberCount'] = count($members);

        // This is for removing title key from one-to-one conversation
        if($newData['memberCount'] > 2){
           $newData['title'] = $data['name'] ? $data['name'] : 'Untitled';
        }

        $newData['ownerId'] = $data['createdby'];
        $newData['resourceType'] = 'user';
        $newData['members'] = array_values(array_filter($members));
        $newData['createdAt'] = date('Y-m-d H:i:s',$createdAt);
        $newData['updatedAt'] = date('Y-m-d H:i:s',$data['lastactivity']);
        
        $jsonData[] =  $newData;
    }
    
    public function getMembers($data){
        $members = $this->getFromDb()->select()
                ->from('cometchat_chatrooms_users' , 'userid')
                ->where('chatroomid = (?)', $data['id'])
                ->distinct()
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);
       return array_unique($members);
    }
}