<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Primemessenger
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    my.sql 2017-06-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class PrimeMessenger_Installer extends Engine_Package_Installer_Module {

    function onInstall() {
        $db = $this->getDb();

        $serviceWorkerfile = $_SERVER['DOCUMENT_ROOT'].'/firebase-messaging-sw.js';
	if(!file_exists($serviceWorkerfile)){
	     $pluginWorkerfile = dirname(dirname( __FILE__ )) . '/externals/scripts/firebase-messaging-sw.js';
		if (!copy($pluginWorkerfile, $serviceWorkerfile)) {
		    echo "failed to copy $file...\n";
		}
	}

        // Disable core mini message menu
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_menuitems')
                ->where('module = ?', 'messages')
                ->where('name = ?', 'core_mini_messages');

        $coreMiniMessageMenu = $select->query()->fetchObject();

        if (!empty($coreMiniMessageMenu)) {
            $db->query('UPDATE `engine4_core_menuitems` SET `enabled` = "0" WHERE `engine4_core_menuitems`.`module` = "messages" AND `engine4_core_menuitems`.`name` = "core_mini_messages" LIMIT 1');
        }

        parent::onInstall();
    }

    function onEnable() {
        $db = $this->getDb();

        // Disable core mini message menu
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_menuitems')
                ->where('module = ?', 'messages')
                ->where('name = ?', 'core_mini_messages');

        $coreMiniMessageMenu = $select->query()->fetchObject();

        if (!empty($coreMiniMessageMenu)) {
            $db->query('UPDATE `engine4_core_menuitems` SET `enabled` = "0" WHERE `engine4_core_menuitems`.`module` = "messages" AND `engine4_core_menuitems`.`name` = "core_mini_messages" LIMIT 1');
        }

        parent::onEnable();
    }

    function onDisable() {
        $db = $this->getDb();

        // Disable core mini message menu
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_menuitems')
                ->where('module = ?', 'messages')
                ->where('name = ?', 'core_mini_messages');

        $coreMiniMessageMenu = $select->query()->fetchObject();

        if (!empty($coreMiniMessageMenu)) {
            $db->query('UPDATE `engine4_core_menuitems` SET `enabled` = "1" WHERE `engine4_core_menuitems`.`module` = "messages" AND `engine4_core_menuitems`.`name` = "core_mini_messages" LIMIT 1');
        }

        parent::onDisable();
    }
}

?>
