<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Address.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Form_Address extends Fields_Form_Standard {

  public $_error = array();

  public function init() {
		// custom recipe fields
    if (!$this->_item) {
      $recipe_item = new Recipe_Model_Recipe(null);
      $this->setItem($recipe_item);
    }
    parent::init();
    $this->setTitle('Edit Location')
        ->setDescription('Edit your location below, then click "Save Location" to save your location.');
    $fields = $this->getElements();

    foreach ($fields as $k => $c) {
      if ($c->getType() != 'Fields_Form_Element_Location') {
        $this->removeElement($k);
      }
    }

    $this->removeElement('submit');

    $this->addElement('Button', 'submit', array(
            'label' => 'Save Location',
            'order' => '998',
            'type' => 'submit',
            'decorators' => array(
                    'ViewHelper',
            ),
    ));
    // Element: cancel
    $this->addElement('Cancel', 'cancel', array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            'order' => '999',
            'onclick' => "javascript:parent.Smoothbox.close();",
            'href' => "javascript:void(0);",
            'decorators' => array(
                    'ViewHelper',
            ),
    ));

    // DisplayGroup: buttons
    $this->addDisplayGroup(array(
            'submit',
            'cancel',
        ), 'buttons', array(
            'decorators' => array(
                    'FormElements',
                    'DivDivDivWrapper'
            ),
    ));
    $button_group = $this->getDisplayGroup('buttons');
    $button_group->setOrder('999');
  }
}