<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Item.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Form_Admin_Item extends Engine_Form {

  protected $_field;

  public function init() {
    $this->setMethod('post');
    $this->setTitle('Add a Recipe of the Day')
        ->setDescription('Select a start date and end date below and the corresponding recipe from the auto-suggest Recipe field. The selected recipe will be displayed as "Recipe of the Day" for this duration and if more than one recipes are found to be displayed in the same duration then they will be dispalyed randomly one at a time.');

    /*
      $type = new Zend_Form_Element_Hidden('type');
      $type->setValue('heading');
     */
    // Start time
//    $start = new Engine_Form_Element_Date('starttime');
//    $start->setLabel("Date");
//    $start->setAllowEmpty(false);
//    $this->addElement($start);

    // Start time
    $starttime = new Engine_Form_Element_CalendarDateTime('starttime');
    $starttime->setLabel("Start Date");
    $starttime->setAllowEmpty(false);
    $starttime->setValue(date('Y-m-d H:i:s'));
    $this->addElement($starttime);

    //Start End date work
    $endtime = new Engine_Form_Element_CalendarDateTime('endtime');
    $endtime->setLabel("End Date");
    $endtime->setAllowEmpty(false);
    $endtime->setValue(date('Y-m-d H:i:s'));
    $this->addElement($endtime);
    //End End date work

    
    $label = new Zend_Form_Element_Text('title');
    $label->setLabel('Recipe')
        ->addValidator('NotEmpty')
        ->setRequired(true)
        ->setAttrib('class', 'text')
        ->setAttrib('style', 'width:210px;');



    // init to
    $this->addElement('Hidden', 'recipe_id', array());

    $this->addElements(array(
            $label,
    ));

    // Buttons
    $this->addElement('Button', 'submit', array(
            'label' => 'Add Recipe',
            'type' => 'submit',
            'ignore' => true,
            'decorators' => array('ViewHelper')
    ));

    // Element: cancel
    $this->addElement('Cancel', 'cancel', array(
            'label' => 'cancel',
            'link' => true,
            'prependText' => ' or ',
            //'href' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage'), 'sitepage_general', true),
            'onclick' => 'javascript:parent.Smoothbox.close()',
            'decorators' => array(
                    'ViewHelper',
            ),
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }

}