<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Album.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Model_Album extends Core_Model_Item_Collection
{
	protected $_searchTriggers = false;
  protected $_modifiedTriggers = false;
  protected $_parent_type = 'recipe';

  protected $_owner_type = 'recipe';

  protected $_children_types = array('recipe_photo');

  protected $_collectible_type = 'recipe_photo';

  public function getHref($params = array())
  {
     return $this->getRecipe()->getHref($params);
  }

  public function getRecipe()
  {
    return $this->getOwner();
  }

  public function getAuthorizationItem()
  {
    return $this->getParent('recipe');
  }

  protected function _delete()
  {
    // Delete all child posts
    $photoTable = Engine_Api::_()->getItemTable('recipe_photo');
    $photoSelect = $photoTable->select()->where('album_id = ?', $this->getIdentity());
    foreach( $photoTable->fetchAll($photoSelect) as $recipePhoto ) {
      $recipePhoto->delete();
    }
    parent::_delete();
  }
}