<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Ratings.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Model_DbTable_Ratings extends Engine_Db_Table {

  protected $_rowClass = "Recipe_Model_Rating";

  public function getRatings($recipe_id) {
    $rName = $this->info('name');
    $select = $this->select()
            ->where($rName . '.recipe_id = ?', $recipe_id);
    $row = $this->fetchAll($select);
    return $row;
  }

  public function checkRated($recipe_id, $user_id) {
    $select = $this->select()
            ->setIntegrityCheck(false)
            ->where('recipe_id = ?', $recipe_id)
            ->where('user_id = ?', $user_id)
            ->limit(1);
    $row = $this->fetchRow($select);
    if (count($row) > 0)
      return true;
    return false;
  }

  public function ratingCount($recipe_id) {
    $rName = $this->info('name');
    $select = $this->select()
            ->setIntegrityCheck(false)
            ->from($rName, array("count(*) AS count"))
            ->where($rName . '.recipe_id = ?', $recipe_id);
    $row = $this->fetchRow($select);

    return $row->count;
  }

}