<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Plugin_Core extends Zend_Controller_Plugin_Abstract {

  public function routeShutdown(Zend_Controller_Request_Abstract $request) {

    if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('mobi'))
      return;
    // CHECK IF ADMIN
    if (substr($request->getPathInfo(), 1, 5) == "admin") {
      return;
    }

    $mobile = $request->getParam("mobile");
    $session = new Zend_Session_Namespace('mobile');

    if ($mobile == "1") {
      $mobile = true;
      $session->mobile = true;
    } elseif ($mobile == "0") {
      $mobile = false;
      $session->mobile = false;
    } else {
      if (isset($session->mobile)) {
        $mobile = $session->mobile;
      } else {
        // CHECK TO SEE IF MOBILE
        if (Engine_Api::_()->mobi()->isMobile()) {
          $mobile = true;
          $session->mobile = true;
        } else {
          $mobile = false;
          $session->mobile = false;
        }
      }
    }

    if (!$mobile) {
      return;
    }
    $module = $request->getModuleName();
    $controller = $request->getControllerName();
    $action = $request->getActionName();
    if ($module == "recipe") {
      if ($controller == "index" && $action == "home") {
        $request->setControllerName('mobi');
        $request->setActionName('home');
      }

      if ($controller == "index" && $action == "index") {
        $request->setControllerName('mobi');
        $request->setActionName('index');
      }

      if ($controller == "index" && $action == "view") {

        $request->setControllerName('mobi');
        $request->setActionName('view');
      }
    }

    // Create layout
    $layout = Zend_Layout::startMvc();

    // Set options
    $layout->setViewBasePath(APPLICATION_PATH . "/application/modules/Mobi/layouts", 'Core_Layout_View')
        ->setViewSuffix('tpl')
        ->setLayout(null);
  }

  public function onRenderLayoutDefault() {
  
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
//    $view->headLink()
//        ->appendStylesheet($view->layout()->staticBaseUrl
//            . 'application/modules/Recipe/externals/styles/style_recipe.css');
  }

  public function onStatistics($event) {

    $table = Engine_Api::_()->getDbTable('recipes', 'recipe');
    $select = new Zend_Db_Select($table->getAdapter());
    $select->from($table->info('name'), 'COUNT(*) AS count');
    $event->addResponse($select->query()->fetchColumn(0), 'recipe');
  }

  public function onUserDeleteBefore($event) {

    $payload = $event->getPayload();
    if ($payload instanceof User_Model_User) {

      // Delete recipes
      $recipeTable = Engine_Api::_()->getDbtable('recipes', 'recipe');
      $recipeSelect = $recipeTable->select()->where('owner_id = ?', $payload->getIdentity());
      foreach ($recipeTable->fetchAll($recipeSelect) as $recipe) {
        $recipe->deleteRecipe();
      }

      //LIKE COUNT DREASE FORM RECIPE TABLE.
      $likesTable = Engine_Api::_()->getDbtable( 'likes' , 'core' ) ;
      $$likesTableSelect = $likesTable->select()->where( 'poster_id = ?' , $payload->getIdentity() )->Where( 'resource_type = ?' , 'recipe' ) ;
      $results =  $likesTable->fetchAll( $$likesTableSelect );
      foreach ( $results as $user ) {
        $resource = Engine_Api::_()->getItem('recipe', $user->resource_id);
        $resource->like_count-- ;
        $resource->save() ;
      }
    }
  }

}