<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_AdminController extends Core_Controller_Action_Admin {

  //ACTION FOR MAKE THE RECIPE FEATURED/UNFEATURED
  public function featuredAction() {

    $id = $this->_getParam('id');
    if (!empty($id))
      $recipe = Engine_Api::_()->getItem('recipe', $id)->setFeatured();
    $this->_redirect('admin/recipe/viewrecipe');
  }

  //ACTION FOR MAKE SPONSORED /UNSPONSORED
  public function sponsoredAction() {

    $id = $this->_getParam('id');
    if (!empty($id))
      $recipe = Engine_Api::_()->getItem('recipe', $id)->setSponsored();
    $this->_redirect('admin/recipe/viewrecipe');
  }

  //ACTION FOR MAKE RECIPE APPROVE/DIS-APPROVE
  public function approvedAction() {

    $id = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    $email = array();
    try {

      $recipe = Engine_Api::_()->getItem('recipe', $id);

      $email['subject'] = 'Approved/ Disapproved notification';
      $email['title'] = $recipe->title;
      $owner_id = $recipe->owner_id;
      $owner = Engine_Api::_()->user()->getUser($owner_id);
      $email['mail_id'] = $owner->email;
      $recipe->approved = !$recipe->approved;

      if (!empty($recipe->approved)) {
        if (empty($recipe->aprrove_date))
          $recipe->aprrove_date = date('Y-m-d H:i:s');
        $email['message'] = "Your recipe  \"" . $email['title'] . " \" approved ";
        Engine_Api::_()->recipe()->aprovedEmailNotification($recipe, $email);
      } else {
        $email['message'] = "Your recipe " . $email['title'] . "  disapproved ";
        Engine_Api::_()->recipe()->aprovedEmailNotification($recipe, $email);
      }
      $recipe->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/recipe/viewrecipe');
  }

  //ACTION FOR DELETE THE RECIPE
  public function deleteAction() {

    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('id');
    $this->view->recipe_id = $id;

    if ($this->getRequest()->isPost()) {
      Engine_Api::_()->getItem('recipe', $id)->deleteRecipe();
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array('Deleted Succesfully.')
      ));
    }
    $this->renderScript('admin/delete.tpl');
  }

}
?>