<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminItemsController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_AdminItemsController extends Core_Controller_Action_Admin {

  public function dayAction()
  {  
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_admin_main', array(), 'recipe_admin_main_widget');

		$this->view->formFilter = $formFilter = new Recipe_Form_Admin_Filter();
		$page = $this->_getParam('page',1);
    
    $itemofthedaytable = Engine_Api::_()->getDbtable('itemofthedays', 'recipe');
    $itemofthedayName = $itemofthedaytable->info('name');

    $recipetable = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $recipeName = $recipetable->info('name');

    $itemofday->view->itemofday = $this->_getParam('category');

    $select = $recipetable->select();
		$select = $select
						->setIntegrityCheck(false)
						->from($recipeName)
						->join($itemofthedayName, $recipeName . '.recipe_id = ' . $itemofthedayName . '.recipe_id');

		$values = array();

    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    }

    foreach( $values as $key => $value ) {
      if( null == $value ) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
      'order' => 'date',
      'order_direction' => 'DESC',
    ), $values);
    
    $this->view->assign($values); 

		$select->order(( !empty($values['order']) ? $values['order'] : 'date' ) . ' ' . ( !empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

		$this->view->can_create = $row = $recipetable->fetchAll($select);
    $this->view->count = $count = count($row);

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(20);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);     
  }    
   
  public function addCategoryAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    // Generate and assign form
    $form = $this->view->form = new Recipe_Form_Admin_Item();
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
			
    // Check post
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )
    {     
      // we will add the category
      $values = $form->getValues();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try 
			{      
				// Transaction
				$table = Engine_Api::_()->getDbtable('itemofthedays', 'recipe');
				//Start End date work
				$select = $table->select()->where('recipe_id = ?', $values["recipe_id"]);
				//End End date work

        //$select = $table->select()->where('date = ?', $today);
 				$result = $table->fetchRow($select);

				if(empty($result)) {

					// insert the recipe category entry into the database
					$row = $table->createRow();
					$row->title   =$values["title"];
					$row->recipe_id   =$values["recipe_id"];
					$row->date = $values["starttime"];
          //Start End date work
          $row->endtime = $values["endtime"];
          //End End date work
					$row->save();  
				}
				else 
				{ 
					$table->update(array('title' =>$values["title"], 'date' =>$values["starttime"], 'endtime' => $values["endtime"]), array('recipe_id = ?' => $values["recipe_id"]));
				}
        $db->commit();
      }
      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 300,
          'parentRefresh'=> 300,
          'messages' => array('The Recipe of the Day has been added successfully.')
      ));
    }
  } 

  public function getrecipeitemAction() {

    $viewer = Engine_Api::_()->user()->getViewer();
    $values['user_id'] = $viewer->getIdentity();

    // get the record  of users table
    $recipetable = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $rName = $recipetable->info('name');
    //Select query started
    $select = $recipetable->select()
												->where('title  LIKE ? ', '%' . $this->_getParam('text') . '%') 
                        ->where($rName . '.closed = ?', '0')
												->where($rName . '.approved = ?', '1')
												->where($rName . '.draft = ?', '1')
												->order('title ASC')
												->limit($this->_getParam('limit', 40));

    $recipeName = $recipetable->info('name');

    //Fetch the all result
    $userrecipes = $recipetable->fetchAll($select);
    $data = array();
    $mode = $this->_getParam('struct');

    if ($mode == 'text') {
      foreach ($userrecipes as $userrecipe) {
      $content_photo = $this->view->itemPhoto($userrecipe, 'thumb.icon');
        $data[] = array(
                'id' => $userrecipe->recipe_id,
                'label' => $userrecipe->title,
                'photo' => $content_photo
        );
      }
    } else {
      foreach ($userrecipes as $userrecipe) {
       $content_photo = $this->view->itemPhoto($userrecipe, 'thumb.icon');
        $data[] = array(
                'id' => $userrecipe->recipe_id,
                'label' => $userrecipe->title,
                'photo' => $content_photo
        );
      }
    }
    return $this->_helper->json($data);
  }

  public function deleteCategoryAction()
  {
    // In smoothbox
    $id = $this->_getParam('id');

    // Check post
    if( $this->getRequest()->isPost())
    {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try
      {
				// go through logs and see which recipe used this category and set it to ZERO
				$recipeTable = Engine_Api::_()->getDbtable('itemofthedays', 'recipe');
				$recipeTable->delete(array('itemoftheday_id =?' => $id));
				$db->commit();
      }
      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh'=> 10,
          'messages' => array('')
      ));
    }
    // Output
    $this->renderScript('admin-items/delete.tpl');
  }
  //ACTION FOR MULTI DELETE OFFERS
  public function multiDeleteAction()
  {
    if ($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key=>$value) {
        if ($key == 'delete_' . $value) {
        	//DELETE OFFERS FROM DATABASE AND SCRIBD
          $recipe_itemofthedays = Engine_Api::_()->getItem('recipe_itemofthedays', (int)$value);

					//FINALLY DELETE OFFER MODEL
					if (!empty($recipe_itemofthedays)) {
// 						$item_type = 'sitepage_favourites';
// 						$item_id =   $sitepagefavourites->favourite_id;
// 						$item_page_id = $sitepagefavourites->page_id;
// 						Engine_Api::_()->getApi('search', 'sitepage')->deleteitem($item_type, $item_id, $item_page_id);
						$recipe_itemofthedays->delete();
					}
        }
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'day'));
  }
}
