<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: VideoController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_VideoController extends Core_Controller_Action_Standard {

  protected $_navigation;

  public function init() {

    $ajaxContext = $this->_helper->getHelper('AjaxContext');
    $ajaxContext
        ->addActionContext('rate', 'json')
        ->addActionContext('validation', 'html')
        ->initContext();

    $id = $this->_getParam('video_id', $this->_getParam('id', null));
    if ($id) {
      $video = Engine_Api::_()->getItem('video', $id);
      if ($video) {
        Engine_Api::_()->core()->setSubject($video);
      }
    }
  }

  public function indexAction() {

    // show utility of edit
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');

    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $this->view->owner_id = $owner_id = $recipe['owner_id'];
    $this->view->content_id = $content_id = $this->_getParam('content_id');
    //   if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) { return; }
    $this->view->canEdit = Engine_Api::_()->authorization()->isAllowed($recipe, $viewer, 'edit');
    $viewer_id = $viewer->getIdentity();
    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;
    $this->view->TabActive = "video";
    // Check for video
//    $allowed_upload_videoEnable = Engine_Api::_()->recipe()->enableVideoPlugin();
//    $allowed_upload_video_video = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'video', 'create');
//    $allowed_upload_video = Engine_Api::_()->authorization()->isAllowed($recipe, $viewer, 'video'); //Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'video');
//
//    if ((!empty($allowed_upload_video) && !empty($allowed_upload_videoEnable) && !empty($allowed_upload_video_video))) {
//      $this->view->allowed_upload_video = 1;
//    }

    if (Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }

    if (empty($this->view->allowed_upload_video)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($recipe, $viewer, 'photo');

    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }

    $video = null;
    $values['user_id'] = $viewer->getIdentity();

    $vTable = Engine_Api::_()->getDbtable('videos', 'video');
    $select = $vTable->select()
            ->where('status = ?', 1)
            ->where('owner_id = ?', $viewer_id);
    $videorecipes = $vTable->fetchAll($select);

    $this->view->videoCount = count($videorecipes);

    $row = Engine_Api::_()->getItemTable('recipe_clasfvideo', 'recipe')->getRecipeVideos($recipe_id);
//    $rName = $table->info('name');
//
//    $vName = $vTable->info('name');
//
//    $select = $vTable->select();
//    $select = $select
//            ->setIntegrityCheck(false)
//            ->from($vName)
//            ->join($rName, $vName . '.video_id = ' . $rName . '.video_id', array())
//            ->group($vName . '.video_id')
//            ->where($rName . '.recipe_id = ?', $recipe_id);
//
//    $row = $vTable->fetchAll($select);
    $video = $row;

    $message = null;
    $session = new Zend_Session_Namespace();
    if (isset($session->video_message)) {
      $message = $session->video_message;
      unset($session->video_message);
    }
    $this->view->message = $message;
    $this->view->video = $video;

    if (!$this->_helper->requireUser->isValid())
      return;

    if (!$this->_helper->requireAuth()->setAuthParams('video', null, 'create')->isValid())
      return;

    // Upload video
    if (isset($_GET['ul']) || isset($_FILES['Filedata'])) {
      return $this->_forward('upload-video', null, null, array('format' => 'json'));
    }

    // set up data needed to check quota
    $viewer = Engine_Api::_()->user()->getViewer();
    $values['user_id'] = $viewer->getIdentity();
    $paginator = Engine_Api::_()->getApi('core', 'video')->getVideosPaginator($values);

    $this->view->quota = $quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'video', 'max');
    $this->view->current_count = $paginator->getTotalItemCount();

    // Create form
    $this->view->form = $form = new Recipe_Form_Video_Video();

    if ($this->_getParam('type', false))
      $form->getElement('type')->setValue($this->_getParam('type'));

    $this->view->Display = 0;
    // if Post request is not set, then return
    if (!$this->getRequest()->isPost()) {
      return;
    }

    $this->view->Display = 1;
    if (!$form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues('url');
      // set title and description using getinfromation() here?
      return;
    }
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      // Process
      $values = $form->getValues();
      $values['owner_id'] = $viewer->getIdentity();
      $insert_action = false;
      $db = Engine_Api::_()->getDbtable('videos', 'video')->getAdapter();
      $db->beginTransaction();
      try {

        // Create video
        $table = Engine_Api::_()->getDbtable('videos', 'video');
        if ($values['type'] == 3) {
          $video = Engine_Api::_()->getItem('video', $this->_getParam('id'));
        }
        else
          $video = $table->createRow();
        $video->setFromArray($values);
        $video->save();

        // Now try to create thumbnail
        $thumbnail = $this->handleThumbnail($video->type, $video->code);
        $ext = ltrim(strrchr($thumbnail, '.'), '.');
        $thumbnail_parsed = @parse_url($thumbnail);

        if (@GetImageSize($thumbnail)) {
          $valid_thumb = true;
        } else {
          $valid_thumb = false;
        }

        if ($valid_thumb && $thumbnail && $ext && $thumbnail_parsed && in_array($ext, array('jpg', 'jpeg', 'gif', 'png'))) {

          $tmp_file = APPLICATION_PATH . '/temporary/link_' . md5($thumbnail) . '.' . $ext;
          $thumb_file = APPLICATION_PATH . '/temporary/link_thumb_' . md5($thumbnail) . '.' . $ext;
          $src_fh = fopen($thumbnail, 'r');
          $tmp_fh = fopen($tmp_file, 'w');
          stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 2);
          $image = Engine_Image::factory();
          $image->open($tmp_file)
              ->resize(120, 240)
              ->write($thumb_file)
              ->destroy();
          try {
            $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
                        'parent_type' => $video->getType(),
                        'parent_id' => $video->getIdentity()
                ));

            // Remove temp file
            @unlink($thumb_file);
            @unlink($tmp_file);
          } catch (Exception $e) {

          }
          $information = $this->handleInformation($video->type, $video->code);

          $video->duration = $information['duration'];
          if (!$video->description)
            $video->description = $information['description'];
          $video->photo_id = $thumbFileRow->file_id;
          $video->status = 1;
          $video->save();

          // Insert new action item
          $insert_action = true;
        }

        if ($values['ignore'] == true) {

          $video->status = 1;
          $video->save();

          // Insert new action item
          $insert_action = true;
          $owner = $video->getOwner();

          // Insert new action item
          $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($owner, $video, 'video_new');
          if ($action != null) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $video);
          }
        }
        // CREATE AUTH STUFF HERE
        $auth = Engine_Api::_()->authorization()->context;
        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'everyone');
        if (isset($values['auth_view']))
          $auth_view = $values['auth_view'];
        else
          $auth_view = "everyone";
        $viewMax = array_search($auth_view, $roles);

        foreach ($roles as $i => $role) {
          $auth->setAllowed($video, $role, 'view', ($i <= $viewMax));
        }

        $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'everyone');
        if (isset($values['auth_comment']))
          $auth_comment = $values['auth_comment'];
        else
          $auth_comment = "everyone";
        $commentMax = array_search($auth_comment, $roles);
        foreach ($roles as $i => $role) {
          $auth->setAllowed($video, $role, 'comment', ($i <= $commentMax));
        }
        // Add tags
        $tags = preg_split('/[,]+/', $values['tags']);
        $video->tags()->addTagMaps($viewer, $tags);
        $db->commit();
        $db->beginTransaction();
        try {
          if ($insert_action) {
            $owner = $video->getOwner();
            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($owner, $video, 'video_new');
            if ($action != null) {
              Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $video);
            }
          }

          // Rebuild privacy
          $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
          foreach ($actionTable->getActionsByObject($video) as $action) {
            $actionTable->resetActivityBindings($action);
          }
          $db->commit();
        } catch (Exception $e) {
          $db->rollBack();
          throw $e;
        }
        $id = $video->getIdentity();
        $table = Engine_Api::_()->getItemTable('recipe_clasfvideo', 'recipe');
        $select = $table->select();
        $rName = $table->info('name');
        $select->where($rName . '.recipe_id = ?', $recipe_id);
        $row = $table->fetchAll($select);
        if ($id != NULL) {
          try {

            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            $row = $table->createRow();
            $row->recipe_id = $recipe_id;
            $row->created = date('Y-m-d H:i:s');
            $row->video_id = $id;
            $row->save();

            $activityApi = Engine_Api::_()->getDbtable('actions', 'activity');
            $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
            if (!Engine_Api::_()->core()->hasSubject('recipe')) {
              Engine_Api::_()->core()->clearSubject();
              Engine_Api::_()->core()->setSubject($recipe);
            }
            $subject = Engine_Api::_()->core()->getSubject();
            $subjectOwner = $subject->getOwner('user');

            // Activity
            //         $action = $activityApi->addActivity($viewer, $subject, 'video_' . $subject->getType(), $video, array(
            //                     'owner' => $subjectOwner->getGuid(),
            // 										'title' => $subject->getTitle()
            //             ));

            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $subject, 'video_recipe', '', array(
                        'owner' => $subjectOwner->getGuid(),
                        'title' => $subject->getTitle()
                ));

            if ($action != null) {
              Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $video);
            }
            $db->commit();
            unset($_POST);
            if ($owner_id == $viewer_id) {
              return $this->_helper->redirector->gotoRoute(array('action' => 'edit', 'recipe_id' => $recipe_id), 'recipe_videospecific', true);
            } else {
              $content_id = $this->_getParam('content_id');
              return $this->_helper->redirector->gotoRoute(array('recipe_id' => $recipe_id, 'user_id' => $owner_id, 'slug' => $recipe->getSlug(), 'tab' => $content_id), 'recipe_entry_view', true);
            }
          } catch (Exception $e) {
            $db->rollBack();
            throw $e;
          }
        }
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
    }
  }

  //stored the selected search  video title into clasfvideo
  public function loadAction() {

    $url = '';
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');

    $session = new Zend_Session_Namespace();
    $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    // Check auth
    // if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) { return; }

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer = Engine_Api::_()->user()->getViewer();
    $values['user_id'] = $viewer->getIdentity();

    //process
    $table = Engine_Api::_()->getDbtable('videos', 'video');
    $select = $table->select()
            ->order('creation_date DESC');
    $rName = $table->info('name');
    $select->where($rName . '.owner_id = ?', $values['user_id']);

    if ($this->getRequest()->isPost()) {
      $values = $_POST;

      if (!empty($values['video_id'])) {
        $select->where($rName . '.video_id = ?', $values['video_id']);
      } else {
        $select->where($rName . '.video_id = ?', 0);
      }
    }
    $this->view->uploadvideorecipe = $uploadvideorecipe = $table->fetchAll($select);

    if (empty($uploadvideorecipe) || empty($values['video_id'])) {
      $session->video_message = 'No matching videos were found.';
      $this->_helper->redirector->gotoRoute(array('controller' => 'video', 'action' => 'index', 'recipe_id' => $recipe_id), video_upload);
    }
    foreach ($uploadvideorecipe as $recipe)
      $id = $recipe->video_id;

    $table = Engine_Api::_()->getItemTable('recipe_clasfvideo', 'recipe');
    $select = $table->select();
    $rName = $table->info('name');
    $select->where($rName . '.recipe_id = ?', $recipe_id);
    $row = $table->fetchAll($select);

    if ($id != NULL) {
      try {
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();

        $row = $table->createRow();
        $row->recipe_id = $recipe_id;
        $row->created = date('Y-m-d H:i:s');
        $row->video_id = $id;
        $row->save();

        $activityApi = Engine_Api::_()->getDbtable('actions', 'activity');

        $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
        if (!Engine_Api::_()->core()->hasSubject('recipe')) {
          Engine_Api::_()->core()->clearSubject();
          Engine_Api::_()->core()->setSubject($recipe);
        }
        $subject = Engine_Api::_()->core()->getSubject();
        $subjectOwner = $subject->getOwner('user');

        // Activity
//         $action = $activityApi->addActivity($viewer, $subject, 'video_' . $subject->getType(), '', array(
//                     'owner' => $subjectOwner->getGuid(),
// 										'title' => $subject->getTitle()
//             ));
        $video = Engine_Api::_()->getItem('video', $id);
        $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $subject, 'video_recipe', '', array(
                    'owner' => $subjectOwner->getGuid(),
                    'title' => $subject->getTitle()
            ));
        if ($action != null) {
          Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $video);
        }
        $db->commit();
        //  }
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
    }
    $owner_id = $recipe->owner_id;
    if ($owner_id == $values['user_id']) {
      return $this->_helper->redirector->gotoRoute(array('action' => 'edit', 'recipe_id' => $recipe_id), 'recipe_videospecific', true);
    } else {
      $content_id = $this->_getParam('content_id');
      return $this->_helper->redirector->gotoRoute(array('recipe_id' => $recipe_id, 'user_id' => $owner_id, 'slug' => $recipe->getSlug(), 'tab' => $content_id), 'recipe_entry_view', true);
    }

    //return $this->_helper->redirector->gotoRoute(array('action' => 'edit', 'recipe_id' => $recipe_id), 'recipe_videospecific', true);
  }

  public function uploadVideoAction() {

    if (!$this->_helper->requireUser()->checkRequire()) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
      return;
    }

    if (!$this->getRequest()->isPost()) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    $values = $this->getRequest()->getPost();
    $response = Seaocore_Service_FancyUpload::upload();

    if(!empty($response['error'])) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . $response['error'];
      return;
    }

    if(empty($response['path']) || empty(file_exists($response['path']))) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
      return;
    }

    $db = Engine_Api::_()->getDbtable('videos', 'video')->getAdapter();
    $db->beginTransaction();

    try {
      $viewer = Engine_Api::_()->user()->getViewer();
      $values['owner_id'] = $viewer->getIdentity();

      $params = array(
              'owner_type' => 'user',
              'owner_id' => $viewer->getIdentity()
      );
      $video = Engine_Api::_()->seaocore()->createCoreVideo($params, $response['path'], $values);
      $video->owner_id = $viewer->getIdentity();
      $video->save();
      $this->view->status = true;
      $this->view->name = $response['name'];
      $this->view->code = $video->code;
      $this->view->video_id = $video->getIdentity();

      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_($e->getMessage());
      // throw $e;
      return;
    }
    // @unlink($response['path']);
  }

  // validation for video upload
  public function validationAction() {

    $video_type = $this->_getParam('type');
    $code = $this->_getParam('code');
    $ajax = $this->_getParam('ajax', false);
    $valid = false;

    // check which API should be used
    if ($video_type == "youtube") {
      $valid = $this->checkYouTube($code);
    }

    if ($video_type == "vimeo") {
      $valid = $this->checkVimeo($code);
    }
    $this->view->code = $code;
    $this->view->ajax = $ajax;
    $this->view->valid = $valid;
  }

  // HELPER FUNCTIONS
  public function extractCode($url, $type) {

    switch ($type) {

      //youtube
      case "1":
        // change new youtube URL to old one
        $new_code = @pathinfo($url);
        $url = preg_replace("/#!/", "?", $url);

        // get v variable from the url
        $arr = array();
        $arr = @parse_url($url);
        if ($arr['host'] === 'youtu.be') {
          $data = explode("?", $new_code['basename']);
          $code = $data[0];
        } else {
          $parameters = $arr["query"];
          parse_str($parameters, $data);
          $code = $data['v'];
          if ($code == "") {
            $code = $new_code['basename'];
          }
        }
        return $code;

      //vimeo
      case "2":
        // get the first variable after slash
        $code = @pathinfo($url);
        return $code['basename'];
    }
  }

  // YouTube Functions
  public function checkYouTube($code){
    $key = Engine_Api::_()->getApi('settings', 'core')->getSetting('video.youtube.apikey');
    if (!$data = @file_get_contents('https://www.googleapis.com/youtube/v3/videos?part=id&id=' . $code . '&key=' . $key)) return false;

    $data = !empty($data) ? Zend_Json::decode($data) : array();
    if (empty($data['items'])) return false;
    return true;
  }

  // Vimeo Functions
  public function checkVimeo($code) {

    //http://www.vimeo.com/api/docs/simple-api
    //http://vimeo.com/api/v2/video
    $data = @simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
    $id = count($data->video->id);
    if ($id == 0)
      return false;
    return true;
  }

  // handles thumbnails
  public function handleThumbnail($type, $code = null) {
    switch ($type) {
      //youtube
      case "1":
        //https://i.ytimg.com/vi/Y75eFjjgAEc/default.jpg
        return "https://i.ytimg.com/vi/$code/default.jpg";
      //vimeo
      case "2":
        //thumbnail_medium
        $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
        $thumbnail = $data->video->thumbnail_medium;
        return $thumbnail;
    }
  }

  // retrieves infromation and returns title + desc
  public function handleInformation($type, $code) {
    switch ($type) {
      //youtube
      case "1":
        $key = Engine_Api::_()->getApi('settings', 'core')->getSetting('video.youtube.apikey');
        $data = file_get_contents('https://www.googleapis.com/youtube/v3/videos?part=snippet,contentDetails&id=' . $code . '&key=' . $key);
        if (empty($data)) {
          return;
        }
        $data = !empty($data) ? Zend_Json::decode($data) : array();
        $information = array();
        $youtube_video = $data['items'][0];
        $information['title'] = $youtube_video['snippet']['title'];
        $information['description'] = $youtube_video['snippet']['description'];
        $information['duration'] = Engine_Date::convertISO8601IntoSeconds($youtube_video['contentDetails']['duration']);
        return $information;
      //vimeo
      case "2":
        //thumbnail_medium
        $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
        $thumbnail = $data->video->thumbnail_medium;
        $information = array();
        $information['title'] = $data->video->title;
        $information['description'] = $data->video->description;
        $information['duration'] = $data->video->duration;
        //http://img.youtube.com/vi/Y75eFjjgAEc/default.jpg
        return $information;
    }
  }

}