<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: VideoeditController.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_VideoeditController extends Core_Controller_Action_Standard {

  public function init() {
    if (!$this->_helper->requireAuth()->setAuthParams('recipe', null, 'view')->isValid())
      return;

    $ajaxContext = $this->_helper->getHelper('AjaxContext');
    $ajaxContext
        ->addActionContext('rate', 'json')
        ->addActionContext('validation', 'html')
        ->initContext();

    $id = $this->_getParam('recipe_id', $this->_getParam('id', null));

    if ($id) {
      $recipe = Engine_Api::_()->getItem('recipe', $id);
      if ($recipe) {
        Engine_Api::_()->core()->setSubject($recipe);
      }
    }
  }

  public function editAction() {


    if (!$this->_helper->requireUser()->isValid())
      return;
    $this->view->recipe_id = $recipe_id = $this->_getParam('recipe_id');
    $this->view->package_id = $package_id = $this->_getParam('package_id');
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);
    $this->view->owner_id = $owner_id = $recipe['owner_id'];
    if (empty($recipe)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    // Check auth
    if (!$this->_helper->requireAuth()->setAuthParams($recipe, $viewer, 'edit')->isValid()) {
      return;
    }
    $viewer_id = $viewer->getIdentity();
    if ($recipe->owner_id != $viewer_id) {
      return $this->_forward('requireauth', 'error', 'core');
      return;
    }
    $this->view->TabActive = "video";
    $this->view->allowed_upload_photo = $allowed_upload_photo = 0;
    $this->view->allowed_upload_video = 0;

    // Check for video
//    $allowed_upload_videoEnable = Engine_Api::_()->recipe()->enableVideoPlugin();
//    $allowed_upload_video_video = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'video', 'create');
//    $allowed_upload_video =  $allowed_upload_video = Engine_Api::_()->authorization()->isAllowed($recipe, $viewer, 'video'); //Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'recipe', 'video');
//
//    if ($viewer_id == $owner_id && (!empty($allowed_upload_video) && !empty($allowed_upload_videoEnable) && !empty($allowed_upload_video_video))) {
//      $this->view->allowed_upload_video = 1;
//    }
    if (Engine_Api::_()->recipe()->allowVideo($recipe, $viewer)) {
      $this->view->allowed_upload_video = 1;
    }
    if (empty($this->view->allowed_upload_video)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    $subject_recipe = Engine_Api::_()->core()->getSubject();
    $allowed_upload_photo = Engine_Api::_()->authorization()->isAllowed($subject_recipe, $viewer, 'photo');
    ;
    if ($allowed_upload_photo) {
      $this->view->allowed_upload_photo = $allowed_upload_photo;
    }
    if (!$this->_helper->requireUser()->isValid())
      return;
    $viewer = Engine_Api::_()->user()->getViewer();

    //   $video = Engine_Api::_()->getItem('clasfvideo', $this->_getParam('recipe_id'));
    //   //Engine_Api::_()->core()->setSubject($video);
    if (!$this->_helper->requireSubject()->isValid())
      return;


//     if( $viewer->getIdentity() != $video->owner_id && !$this->_helper->requireAuth()->setAuthParams($video, null, 'edit')->isValid())
//     {
//       return $this->_forward('requireauth', 'error', 'core');
//     }
//     
    $row = array();
    if (Engine_Api::_()->recipe()->enableVideoPlugin()) {
      $row = Engine_Api::_()->getItemTable('recipe_clasfvideo', 'recipe')->getRecipeVideos($this->_getParam('recipe_id'));
//      $rName = $rTable->info('name');
//      $vTable = Engine_Api::_()->getDbtable('videos', 'video');
//      $vName = $vTable->info('name');
//      $select = $vTable->select();
//      $select = $select
//              ->setIntegrityCheck(false)
//              ->from($vName)
//              ->join($rName, $vName . '.video_id = ' . $rName . '.video_id', array())
//              ->group($vName . '.video_id')
//              ->where($rName . '.recipe_id = ?', $this->_getParam('recipe_id'));
//
//      $row = $vTable->fetchAll($select);
    }
    $this->view->count = $count = count($row);
    $this->view->video = $row;
    // Make form
    $this->view->form = $form = new Recipe_Form_Video_Editvideo();

    foreach ($row as $video) {

      $subform = new Recipe_Form_Video_Edit(array('elementsBelongTo' => $video->getGuid()));
//       $subform->removeElement('title');
      if ($video->status != 1) {
        if ($video->status == 0 || $video->status == 2):
          $msg = $this->view->translate("Your video is currently being processed - you will be notified when it is ready to be viewed.");
        elseif ($video->status == 3):
          $msg = $this->view->translate("Video conversion failed. Please try again.");
        elseif ($video->status == 4):
          $msg = $this->view->translate("Video conversion failed. Video format is not supported by FFMPEG. Please try again.");
        elseif ($video->status == 5):
          $msg = $this->view->translate("Video conversion failed. Audio files are not supported. Please try again.");
        elseif ($video->status == 7):
          $msg = $this->view->translate("Video conversion failed. You may be over the site upload limit.  Try  a smaller file, or delete some files to free up space.");
        endif;
        $subform->addElement('dummy', 'mssg' . $video->video_id, array(
                'description' => $msg,
                'decorators' => array(
                        'ViewHelper',
                        array('HtmlTag', array('tag' => 'div', 'class' => 'tip')),
                        array('Description', array('tag' => 'span', 'placement' => 'APPEND')),
                        array('Description', array('placement' => 'APPEND')),
                ),
        ));
        $t = 'mssg' . $video->video_id;
        $subform->$t->getDecorator("Description")->setOption("placement", "append");
      }
      $subform->populate($video->toArray());
      $form->addSubForm($subform, $video->getGuid());
    }
    if (!$this->getRequest()->isPost()) {
      return;
    }
    if (!$form->isValid($this->getRequest()->getPost())) {
      return;
    }
    // handle save for tags
    $values = $form->getValues();
    // video subform process in editing
    foreach ($row as $video) {
      $subform = $form->getSubForm($video->getGuid());

      $values = $subform->getValues();
      $values = $values[$video->getGuid()];
      if (isset($values['delete']) && $values['delete'] == '1') {



        $rTable->delete(array('video_id=?' => $video->video_id, 'recipe_id=?' => $recipe_id));
        Engine_Api::_()->getDbtable('actions', 'activity')->delete(array('type =?' => 'video_recipe', 'object_id =?' => $recipe_id));
      } else {
        $video->setFromArray($values);
        $video->save();
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'edit', 'recipe_id' => $recipe_id), 'recipe_videospecific', true);
  }

  public function deleteAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;

    $viewer = Engine_Api::_()->user()->getViewer();
    $recipe_id = $this->_getParam('recipe_id');
    $video_id = $this->_getParam('video_id');
    $this->view->recipe = $recipe = Engine_Api::_()->getItem('recipe', $recipe_id);

    if (!Engine_Api::_()->core()->hasSubject('recipe')) {
      Engine_Api::_()->core()->setSubject($recipe);
    }

    // Check auth
    if (!$this->_helper->requireSubject()->isValid()) {
      return;
    }


    if ($this->getRequest()->isPost() && $this->getRequest()->getPost('confirm') == true) {


      $videoClassTable = Engine_Api::_()->getDbtable('clasfvideos', 'recipe');

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        $videoClassTable->delete(array('recipe_id =?' => $recipe_id, 'video_id =?' => $video_id));
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => true,
              'parentRefresh' => '500',
              'parentRefreshTime' => '500',
              'format' => 'smoothbox',
              'messages' => Zend_Registry::get('Zend_Translate')->_('You have successfully delete this video.')
      ));
    }
  }

}