<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $PRODUCT_TYPE = 'recipe';
    $PLUGIN_TITLE = 'Recipe';
    $PLUGIN_VERSION = '5.6.0';
    $PLUGIN_CATEGORY = 'plugin';
    $PRODUCT_DESCRIPTION = 'Recipes Plugin';
    $_PRODUCT_FINAL_FILE = 0;
    $_BASE_FILE_NAME = 0;
    $PRODUCT_TITLE = 'Recipes Plugin';
    $SocialEngineAddOns_version = '4.8.9p3';
    $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
    $is_file = file_exists($file_path);
    if (empty($is_file)) {
      include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
    } else {
      if (!empty($_PRODUCT_FINAL_FILE)) {
        include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
      }
      $db = $this->getDb();
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
      $is_Mod = $select->query()->fetchObject();
      if( empty($is_Mod) ) {
	include_once $file_path;
      }
    }
    parent::onPreInstall();
  }

  function onInstall() {
    $db = $this->getDb();

    //WORK FOR CORE CONTENT PAGES
		$select = new Zend_Db_Select($db);

    $select->from('engine4_core_content',array('params'))
            ->where('name = ?', 'recipe.socialshare-recipe');
		$result = $select->query()->fetchObject();
    if(!empty($result->params)) {
			$params = Zend_Json::decode($result->params);
			if(isset($params['code'])) {
				$code = $params['code'];
				$db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
				('recipe.code.share','".$code. "');");
			}
    }

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'recipe.generic');
    $recipe_generic_check = $select->query()->fetchObject();
    if (!empty($recipe_generic_check)) {
      $db->delete('engine4_core_settings', array('name = ?' => 'recipe.generic'));
    }

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'recipe.showcase');
    $recipe_showcase_check = $select->query()->fetchObject();
    if (!empty($recipe_showcase_check)) {
      $db->delete('engine4_core_settings', array('name = ?' => 'recipe.showcase'));
    }

    $table_exist = $db->query('SHOW TABLES LIKE \'engine4_recipe_photos\'')->fetch();
    if (!empty($table_exist)) {

      $column_exist = $db->query('SHOW COLUMNS FROM engine4_recipe_photos LIKE \'description\'')->fetch();
      if (empty($column_exist)) {
        $db->query('ALTER TABLE `engine4_recipe_photos` CHANGE `description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL');
      }
    }

//     $select = new Zend_Db_Select($db);
//     $select
//         ->from('engine4_core_modules')
//         ->where('name = ?', 'recipe');
//     $check_module = $select->query()->fetchObject();
//     if (!empty($check_module)) {
// 
//       $curr_module_version = strcasecmp($check_module->version, '4.1.3');
//       if ($curr_module_version < 0) {
// 
//         $select = new Zend_Db_Select($db);
//         $select
//             ->from('engine4_core_pages')
//             ->where('name = ?', 'recipe_index_home')
//             ->limit(1);
//         $page = $select->query()->fetch();
//         if (!empty($page)) {
//           $page_id = $page['page_id'];
// 
//           $db = Zend_Db_Table_Abstract::getDefaultAdapter();
//           $db = $this->getDb();
// 
//           $db->delete('engine4_core_content', array(
//                   'page_id = ?' => $page_id,
//                   'name = ?' => "core.container-tabs"
//           ));
// 
//           $db->delete('engine4_core_content', array(
//                   'page_id = ?' => $page_id,
//                   'name = ?' => "recipe.random-recipe"
//           ));
//           $db->delete('engine4_core_content', array(
//                   'page_id = ?' => $page_id,
//                   'name = ?' => "recipe.mostviewed-recipe"
//           ));
//           $db->delete('engine4_core_content', array(
//                   'page_id = ?' => $page_id,
//                   'name = ?' => "recipe.recentlyposted-recipe"
//           ));
// 
// 
// 
//           $select = new Zend_Db_Select($db);
//           $select
//               ->from('engine4_core_content')
//               ->where('name = ?', 'middle')
//               ->where('page_id = ?', $page_id)
//               ->limit(1);
//           $middle = $select->query()->fetch();
//           if (!empty($middle)) {
//             $middle_id = $middle['content_id'];
//             $db->insert('engine4_core_content', array(
//                     'page_id' => $page_id,
//                     'type' => 'widget',
//                     'name' => 'recipe.recently-popular-random-recipe',
//                     'parent_content_id' => $middle_id,
//                     'order' => 16,
//                     'params' => '{"title":"","titleCount":""}',
//             ));
//           }
//         }
//       }
//     }
    //
    // Mobile Recipe Home
    // page
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'recipe_mobi_home')
            ->limit(1);
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {
      $db->insert('engine4_core_pages', array(
          'name' => 'recipe_mobi_home',
          'displayname' => 'Mobile Recipe Home',
          'title' => 'Mobile Recipe Home',
          'description' => 'This is the mobile verison of a recipe home page.',
          'custom' => 0
      ));
      $page_id = $db->lastInsertId('engine4_core_pages');

      // containers
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'main',
          'parent_content_id' => null,
          'order' => 1,
          'params' => '',
      ));
      $container_id = $db->lastInsertId('engine4_core_content');

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'middle',
          'parent_content_id' => $container_id,
          'order' => 2,
          'params' => '',
      ));
      $middle_id = $db->lastInsertId('engine4_core_content');

      // widgets entry
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.browsenevigation-recipe',
          'parent_content_id' => $middle_id,
          'order' => 1,
          'params' => '{"title":"","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.zerolisiting-recipe',
          'parent_content_id' => $middle_id,
          'order' => 2,
          'params' => '{"title":"","titleCount":"true"}',
      ));
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.search-recipe',
          'parent_content_id' => $middle_id,
          'order' => 3,
          'params' => '{"title":"","titleCount":"true"}',
      ));
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.recently-popular-random-recipe',
          'parent_content_id' => $middle_id,
          'order' => 4,
          'params' => '{"title":"","titleCount":"true"}',
      ));
    }

    // Mobile Browse Recipes
    // page
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'recipe_mobi_index')
            ->limit(1);
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {
      $db->insert('engine4_core_pages', array(
          'name' => 'recipe_mobi_index',
          'displayname' => 'Mobile Browse Recipes',
          'title' => 'Mobile Browse Recipes',
          'description' => 'This is the mobile verison of a recipe browse page.',
          'custom' => 0
      ));
      $page_id = $db->lastInsertId('engine4_core_pages');

      // containers
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'main',
          'parent_content_id' => null,
          'order' => 1,
          'params' => '',
      ));
      $container_id = $db->lastInsertId('engine4_core_content');

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'middle',
          'parent_content_id' => $container_id,
          'order' => 2,
          'params' => '',
      ));
      $middle_id = $db->lastInsertId('engine4_core_content');


      // widgets entry
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.browsenevigation-recipe',
          'parent_content_id' => $middle_id,
          'order' => 1,
          'params' => '{"title":"","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.search-recipe',
          'parent_content_id' => $middle_id,
          'order' => 2,
          'params' => '{"title":"","titleCount":"true"}',
      ));
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.recipes-recipe',
          'parent_content_id' => $middle_id,
          'order' => 3,
          'params' => '{"title":"","titleCount":"true"}',
      ));
    }

    $recipe_time_set = time();
    $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
		('recipe.base.time', $recipe_time_set ),
		('recipe.check.var', 0 ), 
		('recipe.time.var', 3456000 ),
		('recipe.var.name', 'lruc'),
		('recipe.get.path', 'Recipe/controllers/license/license2.php');");

    //
    // Mobile Recipe Profile
    // page
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'recipe_mobi_view')
            ->limit(1);
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {
      $db->insert('engine4_core_pages', array(
          'name' => 'recipe_mobi_view',
          'displayname' => 'Mobile Recipe Profile',
          'title' => 'Mobile Recipe Profile',
          'description' => 'This is the mobile verison of a recipe profile.',
          'custom' => 0
      ));
      $page_id = $db->lastInsertId('engine4_core_pages');

      // containers
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'main',
          'parent_content_id' => null,
          'order' => 1,
          'params' => '',
      ));
      $container_id = $db->lastInsertId('engine4_core_content');

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'container',
          'name' => 'middle',
          'parent_content_id' => $container_id,
          'order' => 2,
          'params' => '',
      ));
      $middle_id = $db->lastInsertId('engine4_core_content');

      // widgets entry
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.mainphoto-recipe',
          'parent_content_id' => $middle_id,
          'order' => 1,
          'params' => '{"title":"","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.title-recipe',
          'parent_content_id' => $middle_id,
          'order' => 2,
          'params' => '{"title":"","titleCount":"true"}',
      ));
//      $db->insert('engine4_core_content', array(
//              'page_id' => $page_id,
//              'type' => 'widget',
//              'name' => 'recipe.ratings-recipe',
//              'parent_content_id' => $middle_id,
//              'order' => 3,
//              'params' => '{"title":"","titleCount":"true"}',
//      ));
      // middle tabs
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'core.container-tabs',
          'parent_content_id' => $middle_id,
          'order' => 4,
          'params' => '{"max":"6"}',
      ));
      $tab_middle_id = $db->lastInsertId('engine4_core_content');


      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'activity.feed',
          'parent_content_id' => $tab_middle_id,
          'order' => 1,
          'params' => '{"title":"What\'s New","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.info-recipe',
          'parent_content_id' => $tab_middle_id,
          'order' => 2,
          'params' => '{"title":"Info","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.overview-recipe',
          'parent_content_id' => $tab_middle_id,
          'order' => 3,
          'params' => '{"title":"Overview","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.location-recipe',
          'parent_content_id' => $tab_middle_id,
          'order' => 4,
          'params' => '{"title":"Map","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.photos-recipe',
          'parent_content_id' => $tab_middle_id,
          'order' => 5,
          'params' => '{"title":"Photos","titleCount":"true"}',
      ));

      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'recipe.video-recipe',
          'parent_content_id' => $tab_middle_id,
          'order' => 6,
          'params' => '{"title":"Videos","titleCount":"true"}',
      ));
    }
    $table_exist = $db->query('SHOW TABLES LIKE \'engine4_recipe_photos\'')->fetch();
    if (!empty($table_exist)) {
      $column_exist = $db->query('SHOW COLUMNS FROM engine4_recipe_photos LIKE \'view_count\'')->fetch();
      if (empty($column_exist)) {
        $db->query('ALTER TABLE `engine4_recipe_photos` ADD `view_count` INT( 11 ) NOT NULL ');
      }
    }

//    //START CODE FOR LIGHTBOX
//    //HERE WE CHECKING THAT SITEPAGEALBUM ENTRY EXIST IN THE CORE MODULE TABLE OR NOT
//    $select = new Zend_Db_Select($db);
//    $select
//            ->from('engine4_core_modules', array('version'))
//            ->where("name =?", "recipe");
//    $recipeVersion = $select->query()->fetchAll();
//
//    //IF NOT EXIST THEN WE INSERTING THE LIGHTBOX SHOULD BE DISPLAY OR NOT
//    if (empty($recipeVersion)) {
//      $value = '';
//      $select = new Zend_Db_Select($db);
//      $value = $select
//              ->from('engine4_core_settings', array('value'))
//              ->where("name =?", "socialengineaddon.display.lightbox")
//              ->query()
//              ->fetchColumn();
//
//      //IF LIGHTBOX IS NOT DISPLAY THEN WE WILL INSERTING THE ACTIVITY FEED VALUE
//      if (empty($value)) {
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("name Like ?", "%socialengineaddon.lightbox.option.display%");
//        $name = $select->query()->fetchAll();
//
//        $count = count($name);
//
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("value =?", "recipe");
//        $name = $select->query()->fetchColumn();
//        if (empty($name)) {
//          $name = 'socialengineaddon.lightbox.option.display.' . ++$count;
//          $db->insert('engine4_core_settings', array(
//              'name' => $name,
//              'value' => 'recipe'
//          ));
//        }
//      }
//    }
//    //END CODE FOR LIGHTBOX      

		$db->query('UPDATE  `engine4_core_content` SET  `name` =  "seaocore.like-button" WHERE  `engine4_core_content`.`name` ="recipe.recipe-like-button";');
		
    $db->query('UPDATE  `engine4_core_content` SET  `name` =  "seaocore.people-like" WHERE  `engine4_core_content`.`name` ="recipe.recipe-like";');




		//START SOCIAL SHARE WIDGET WORK 
		//CHECK PLUGIN VERSION
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'recipe')
					->where('version <= ?', '4.2.0');
		$is_enabled_module = $select->query()->fetchObject();

		if(!empty($is_enabled_module)) {

			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"recipe.socialshare-recipe"}';

	  	$db->update('engine4_core_content', array('params' => $social_share_default_code,), array('name =?' => 'recipe.socialshare-recipe'));
		}
		//END SOCIAL SHARE WIDGET WORK 
    $this->setActivityFeeds();
    parent::onInstall();
  }

  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_recipe", "recipe", \'{item:$subject} replied to a comment on {item:$owner}\'\'s recipe {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
}

?>
