<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Widget_CategoriesController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

	  $cateTable = Engine_Api::_()->getDbtable('categories', 'recipe');
    $cateName = $cateTable->info('name');

    $table = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $rName = $table->info('name');

    $select =  $cateTable->select()
												->setIntegrityCheck(false)
												->from($cateName)
												->joinLeft($rName, $rName . '.category_id = ' . $cateName . '.category_id', array('count(' . $rName . '.category_id ) as count'))
												->where($cateName . '.cat_dependency = 0')
												->where($rName . '.closed = ?', '0')
												->where($rName . '.approved = ?', '1')
												->where($rName . '.draft = ?', '1')
												->group($cateName . '.category_id')
												->order('cat_order');

		    $select->where($rName . ".search = ?", 1);
    // Start Network work
    $enableNetwork = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.network', 0);
    if (!empty($enableNetwork)) {
      $viewer = Engine_Api::_()->user()->getViewer();
      $networkMembershipTable = Engine_Api::_()->getDbtable('membership', 'network');
      $viewerNetwork = $networkMembershipTable->fetchRow(array('user_id = ?' => $viewer->getIdentity()));

      if (!empty($viewerNetwork)) {
        $select->setIntegrityCheck(false)
            ->from($rName);
        $networkMembershipName = $networkMembershipTable->info('name');
        $select
            ->join($networkMembershipName, "`{$rName}`.owner_id = `{$networkMembershipName}`.user_id  ", null)
            ->join($networkMembershipName, "`{$networkMembershipName}`.`resource_id`=`{$networkMembershipName}_2`.resource_id", null)
            ->where("`{$networkMembershipName}_2`.user_id = ? ", $viewer->getIdentity())
            ->group($rName . ".recipe_id")
        ;
      }
    }
    // End Network work
		$categories = array();
		$category_info = $cateTable->fetchAll($select);
			
		foreach($category_info->toarray() as $value) {
			$sub_cat_array = array();
			$sub_cat =  $cateTable->select()
														->setIntegrityCheck(false)
														->from($cateName)
														->joinLeft($rName, $rName . '.subcategory_id = ' . $cateName . '.category_id', array('count(' . $rName . '.subcategory_id ) as count'))
														->where($cateName . '.cat_dependency = '.$value['category_id'])
														->where($rName . '.closed = ?', '0')
														->where($rName . '.approved = ?', '1')
														->where($rName . '.draft = ?', '1')
														->group($cateName . '.category_id')
														->order('cat_order'); 

			$category_info2 = $cateTable->fetchAll($sub_cat);
			foreach($category_info2->toarray() as $result_info) {
				$tmp_array = array('sub_cat_id' => $result_info['category_id'],
												 'sub_cat_name' => $result_info['category_name'],
												 'count' => $result_info['count'],
												 'order' => $result_info['cat_order']);
			  $sub_cat_array[] = $tmp_array;
			}
		  $category_array = array('category_id' => $value['category_id'],
		                        'category_name' => $value['category_name'],
		                        'order' => $value['cat_order'],
		                        'count' => $value['count'],
		                        'sub_categories' => $sub_cat_array);
			$categories[] = $category_array;                  
	  }
		$this->view->categories = $categories;
		$this->view->subcategorys = 0;
		$this->view->category = 0;
		if(!empty($_GET)) {
			if(!empty($_GET['subcategory']))
	    $this->view->subcategorys = $_GET['subcategory'];
			if(!empty($_GET['category']))
			$this->view->category		= $_GET['category'];
		} 
		$categoryid = Zend_Controller_Front::getInstance()->getRequest()->getParam('category_id');
		$subcategoryid = Zend_Controller_Front::getInstance()->getRequest()->getParam('subcategory_id');
		if(!empty($categoryid)) {
			$this->view->category	= $categoryid;
			$this->view->subcategorys	= $subcategoryid;
		}		
	  if (!(count($this->view->categories) > 0)) {
				return $this->setNoRender();
		}
  }
}