<?php
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Recipe_Widget_OptionsRecipeController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    // Don't render this if not authorized
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
		$recipe_options = Zend_Registry::get('recipe_options');

    if (!Engine_Api::_()->core()->hasSubject()) {  return $this->setNoRender(); }

    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
		$this->view->recipe_getsettings = Zend_Registry::get('recipe_getsettings');

    // Get subject and check auth
    $recipe = Engine_Api::_()->core()->getSubject('recipe');
    $this->view->recipe = $recipe;
    $this->view->closed = $recipe['closed'];
    $this->view->owner_id = $recipe['owner_id'];
    $this->view->draft = $recipe['draft'];

		$level_id = 0;
		if(!empty($viewer_id))
		$level_id = $viewer->level_id;

		//SHOW MESSAGE OWNER LINK TO USER IF MESSAGING IS ENABLED FOR THIS LEVEL
		$this->view->showMessageOwner = 0;
		$showMessageOwner = Engine_Api::_()->authorization()->getPermission($level_id, 'messages', 'auth');
		if($showMessageOwner != 'none') {
			$this->view->showMessageOwner = 1;
		}
		

		$can_delete = Engine_Api::_()->authorization()->getPermission($level_id, 'recipe', 'delete');
		if($can_delete == 2) {
			$this->view->can_delete = 1;
		}
		elseif($can_delete == 1) {
			if($this->view->owner_id == $viewer_id) {
				$this->view->can_delete = 1;
			}
			else {
				$this->view->can_delete = 0;
			}
		}
		else {
			$this->view->can_delete = 0;
		}
    // Get navigation
    $this->view->gutterNavigation = $gutterNavigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('recipe_gutter');

    // Check report is enable/disable
    $this->view->report = $report = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.report', 1);

    // Check share is enable/disable
    $this->view->share = $share = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.share', 1);

    // Check tell-a-friend is enable/disable
    $this->view->tell_a_friend = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.tellafriend', 1);

    // Check print is enable/disable
    $this->view->print = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.printer', 1);

		if(empty($recipe_options)) {  return $this->setNoRender();	}
  }
}