<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Widget_RecentlyPopularRandomRecipeController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $showTabArray = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.ajax.widgets.recipe', array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => "5"));
    $ShowViewArray = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.ajax.widgets.layout', array("0" => "1", "1" => "2", "2" => "3"));
	  $defaultOrder=Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.ajax.layouts.oder', 1);
    $this->view->list_view = 0;
    $this->view->grid_view = 0;
    $this->view->map_view = 0;
    $this->view->defaultView = -1;
    if (in_array("1", $ShowViewArray)) {
      $this->view->list_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder==1)
        $this->view->defaultView = 0;
    }
    if (in_array("2", $ShowViewArray)) {
      $this->view->grid_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder==2)
        $this->view->defaultView = 1;
    }
    if (in_array("3", $ShowViewArray)) {
      $this->view->map_view = 1;
      if ($this->view->defaultView == -1 || $defaultOrder==3)
        $this->view->defaultView = 2;
    }

    $recipeRecently = array();
    $recipeViewed = array();
    $recipeRandom = array();
		$recipeFeatured = array();
		$recipeSponosred = array();
    if (in_array("1", $showTabArray)) {
      // GET recipe recipe FOR RECENTLY POSTED
      $recipeRecently = Engine_Api::_()->recipe()->getLising('Recently Posted');
    }
    if (in_array("2", $showTabArray)) {
      // GET recipe recipe FOR MOST VIEWES
      $recipeViewed = Engine_Api::_()->recipe()->getLising('Most Viewed');
    }
    if (in_array("3", $showTabArray)) {
      $recipeRandom = Engine_Api::_()->recipe()->getLising('Random');
    }

    if (in_array("4", $showTabArray)) {
      $recipeFeatured = Engine_Api::_()->recipe()->getLising('Featured');
    }
    if (in_array("5", $showTabArray)) {
      $recipeSponosred = Engine_Api::_()->recipe()->getLising('Sponosred');
    }

    if ((!(count($recipeRecently) > 0) && !(count($recipeViewed) > 0) && !(count($recipeRandom) > 0 ) && !(count($recipeFeatured) > 0 ) && !(count($recipeSponosred) > 0 ) ) || ($this->view->defaultView == -1)) {
      return $this->setNoRender();
    }

    $this->view->active_tab1 = 0;
    $this->view->active_tab2 = 0;
    $this->view->active_tab3 = 0;
    $this->view->active_tab4 = 0;
    $this->view->active_tab5 = 0;
    $this->view->active_tab_recipe = 0;
    $this->view->active_tab_image = 0;

    if (count($recipeRecently) > 0) {
      $this->view->reciperecipe = $recipe = $recipeRecently;
      $this->view->active_tab1 = 1;
      $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.recent.widgets', 10);
      $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.recent.thumbs', 15);
    } else if (count($recipeViewed) > 0) {
      $this->view->reciperecipe = $recipe = $recipeViewed;
      $this->view->active_tab2 = 1;
      $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.popular.widgets', 10);
      $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.popular.thumbs', 15);
    } else if (count($recipeRandom) > 0) {
      $this->view->reciperecipe = $recipe = $recipeRandom;
      $this->view->active_tab3 = 1;
      $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.random.widgets', 10);
      $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.random.thumbs', 15);
    } else if (count($recipeFeatured) > 0) {
      $this->view->reciperecipe = $recipe = $recipeFeatured;
      $this->view->active_tab4 = 1;
      $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.featured.recipe', 10);
      $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.featured.thumbs', 15);
    } else if (count($recipeSponosred) > 0) {
      $this->view->reciperecipe = $recipe = $recipeFeatured;
      $this->view->active_tab5 = 1;
      $this->view->active_tab_recipe = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.sponsored.recipe', 10);
      $this->view->active_tab_image = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.sponsored.thumbs', 15);
    }

    if (count($recipeRecently) > 0) {
      $this->view->tab1_show = 1;
    }
    if (count($recipeViewed) > 0) {
      $this->view->tab2_show = 1;
    }
    if (count($recipeRandom) > 0) {
      $this->view->tab3_show = 1;
    }

    if (count($recipeFeatured) > 0) {
      $this->view->tab4_show = 1;
    }

    if (count($recipeSponosred) > 0) {
      $this->view->tab5_show = 1;
    }

//    $this->view->recipe_recent_view = $recipe_recent_post = Zend_Registry::get('recipe_recent_post');
//    $this->view->recipe_mostviewed = $recipe_mostviewed = Zend_Registry::get('recipe_mostviewed');


    $this->view->enableLocation = $checkLocation = Engine_Api::_()->recipe()->enableLocation();

    if (!empty($this->view->map_view)) {
      $this->view->flageSponsored = 0;
      if (!empty($checkLocation)) {
        $ids = array();
        $sponsored = array();
        foreach ($recipe as $recipe_recipe) {
          $id = $recipe_recipe->getIdentity();
          $ids[] = $id;
          $recipe_temp[$id] = $recipe_recipe;
        }
        $values['recipe_ids'] = $ids;

        $this->view->locations = $locations = Engine_Api::_()->recipe()->getLocation($values);
        foreach ($locations as $location) {
          if ($recipe_temp[$location->recipe_id]->sponsored){
            $this->view->flageSponsored = 1;
            break;
          }
        }
        $this->view->recipe = $recipe_temp;
      }
    }

    // Rating enable /disable
    $this->view->ratngShow = $ratingShow = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.rating', 1);

    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
//    if (empty($recipe_recent_post)) {
//      return $this->setNoRender();
//    }
  }

}
?>