<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Recipe
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Recipe_Widget_SearchRecipeController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $recipe_searching = Zend_Registry::get('recipe_searching');

    $recipetable = Engine_Api::_()->getDbtable('recipes', 'recipe');
    $recipeName = $recipetable->info('name');
    $viewer = Engine_Api::_()->user()->getViewer()->getIdentity();

    // serach form for searching on public page
    $this->view->form = $form = new Recipe_Form_Search();
		$form->setAction($this->view->url(array('action' => 'index'), 'recipe_general', true));
    $recipe_post = Zend_Registry::get('recipe_post');
    if (!empty($recipe_post)) {
      $this->view->recipe_post = Zend_Registry::get('recipe_post');
    }

    if (!isset($_POST['orderby']) || empty($_POST)) {
      $order = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.browseorder', 1);
      switch ($order) {
        case "1":
          $form->orderby->setValue("creation_date");
          break;
        case "2":
          $form->orderby->setValue("view_count");
          break;
        case "3":
          $form->orderby->setValue("title");
          break;
      }
    }
    $stusShow = Engine_Api::_()->getApi('settings', 'core')->getSetting('recipe.status.show', 1);
    if (( $stusShow == 0)) {
      $form->removeElement('closed');
    }
    if (isset($_GET['city']) && !empty($_GET['city'])) {
      $city = $_GET['city'];
      unset($_GET);
      $_GET['city'] = $city;
    }
    if (isset($_GET['tag']) && !empty($_GET['tag'])) {
      $tag = $_GET['tag'];
      unset($_GET);
      $_GET['tag'] = $tag;
    }
    if (!empty($_GET))
      $form->populate($_GET);

    if (!$viewer) {
      $form->removeElement('show');
    }
    $form->city->setValue("");
    $form->tag->setValue("");
    if (empty($recipe_searching)) {
      return $this->setNoRender();
    }
  }

}