<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Send.tpl 2017-02-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteevent_Form_Admin_Credits_Request extends Engine_Form {

	public function init() {

		$coreSettings = Engine_Api::_()->getApi('settings', 'core');
		$this->setTitle('Request Credits')
			->setDescription('You can Request credits to site Admin.');

		$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

		$this->addElement('Text', 'requested_credit', array(
			'label' => 'Credit Values',
			'description' => '',
			'required' => true,
			'validators' => array(
				array('NotEmpty', true),
				array('Int', true),
				new Engine_Validate_AtLeast(1),

			),
		));

		$this->addElement('Button', 'submit', array(
			'label' => 'Request Credits',
			'type' => 'submit',
			'ignore' => true,
			'decorators' => array('ViewHelper'),
		));

		$this->addElement('Cancel', 'cancel', array(
			'label' => 'cancel',
			'link' => true,
			'prependText' => ' or ',
			'href' => '',
			'onClick' => 'javascript:parent.Smoothbox.close();',
			'decorators' => array(
				'ViewHelper',
			),
		));
		$this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
		$button_group = $this->getDisplayGroup('buttons');

	}

}
