<?php 
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteaddlink
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2019-09-18 18:02:08Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteaddlink_Api_Core extends Core_Api_Abstract {

  public function addMenuItems() {
    // Get menu items
    $menuItemsTable = Engine_Api::_()->getDbtable('menuItems', 'core');
    $addLinkmenuItems = $menuItemsTable->select()
      ->from($menuItemsTable->info('name'), 'name')
      ->where('menu = ?', 'siteaddlink_navigation')
      ->order('order')
      ->query()
      ->fetchAll(Zend_Db::FETCH_COLUMN);

    $menuItemsSelect = $menuItemsTable->select()
      ->where('menu LIKE ?', '%_main%')
      ->order('order');
    $menuItems = $menuItemsTable->fetchAll($menuItemsSelect);
    $menuList = array();
    $icons = array();
    $needToAdd = array();
    foreach ($menuItems as $menuItem) {
      if (strpos($menuItem->name, 'core_main_') === 0 && !empty($menuItem->params['icon'])) {
        $icons[$menuItem->name] = $menuItem->params['icon'];
      }
      if (!$this->_canAddMenu($menuItem)) {
        continue;
      }
      if (in_array('addlink_' . $menuItem->name, $addLinkmenuItems)) {
        continue;
      }
      $needToAdd[] = $menuItem;
    }
    foreach ($needToAdd as $menuItem) {
      $data = $menuItem->toArray();
      unset($data['id']);
      $data['name'] = 'addlink_' . $menuItem->name;
      $data['menu'] = 'siteaddlink_navigation';
      if ($menuItem->plugin && strpos($menuItem->plugin, '::') === false) {
        $data['plugin'] .= '::onMenuInitialize_' . $this->_formatMenuName($menuItem->name);
      }
      if (empty($data['params']['icon']) && !empty($icons['core_main_' . $menuItem->module])) {
        $data['params']['icon'] = $icons['core_main_' . $menuItem->module];
      }

      $menuRow = $menuItemsTable->createRow();
      $menuRow->setFromArray($data);
      $menuRow->save();
      $menuList[$menuItem->name] = $data;
    }
  }

  protected function _canAddMenu($menuItem) {

    $menu = $menuItem->module . '_main';
    if (strpos($menuItem->menu, $menu) === false) {
      return;
    }
    return (strpos($menuItem->name, 'create') !== false || strpos($menuItem->name, 'upload') !== false || strpos($menuItem->name, 'post') !== false);
  }

  protected function _formatMenuName($name) {
    $name = str_replace('_', ' ', $name);
    $name = ucwords($name);
    $name = str_replace(' ', '', $name);
    return $name;
  }

}