<?php 
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteaddlink
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2019-09-18 18:02:08Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteaddlink_Plugin_Menus {

  public function onMenuInitialize_CoreMiniSiteaddlink($link) {
    $navigation = Engine_Api::_()
      ->getApi('menus', 'core')
      ->getNavigation('siteaddlink_navigation', array());
    if ($navigation->count() < 1) {
      return false;
    }

    $view = Zend_Registry::get('Zend_View');
    $content = $view->partial("_content.tpl", "siteaddlink", array("content_id" => 'mini-menu-add-link', 'position' => 'mini-menu', 'navigation' => $navigation, 'type' => 'pulldown'));
//    if (strlen($content) < 15) {
//      return false;
//    }

    $icon = (!empty($link->params['icon']) ? $link->params['icon'] : 'fas fa-plus');
    if (Zend_Uri::check($icon)) {
      $icon = '<i class="_background_icon" style="background-image: url(' . $icon . ')" title="' . $link->label . '"></i>';
    } else {
      $icon = '<i class="' . $icon . '" title="' . $link->label . '"></i>';
    }


    return array(
      'label' => $icon . $content . '',
      'title' => $link->label,
      'uri' => 'javascript:void(0);',
    );
  }

}