<?php 
 /**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteaddlink
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2019-09-18 18:02:08Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
require_once realpath(dirname(__FILE__)) . '/sitemodule_install.php';

class Siteaddlink_Installer extends Siteaddlink_SiteModule_Installer {
  /* If client are used the below plugins then need to check for upgrade */

  protected $_deependencyVersion = array(
  );
  protected $_installConfig = array(
    'sku' => 'siteaddlink',
  );

  public function onInstall() {
    $db = $this->getDb();
    if ($this->_databaseOperationType == 'install') {
      $this->_addWidgetInFooter();
    }

    parent::onInstall();
  }

  private function _addWidgetInFooter() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $page_id = $select
      ->from('engine4_core_pages', array('page_id'))
      ->where('name = ?', 'footer')
      ->query()
      ->fetchColumn();

    if (!empty($page_id)) {
      $select = new Zend_Db_Select($db);
      $parent_content_id = $select
        ->from('engine4_core_content', array('content_id'))
        ->where('page_id =?', $page_id)
        ->where('type =?', 'container')
        ->where('name =?', 'main')
        ->query()
        ->fetchColumn();

      $select = new Zend_Db_Select($db);
      $content_id = $select
        ->from('engine4_core_content', array('content_id'))
        ->where('page_id = ?', $page_id)
        ->where('name =?', 'seaocore.seaocores-lightbox')
        ->query()
        ->fetchColumn();
      if (empty($content_id)) {
        $db->insert('engine4_core_content', array(
          'type' => 'widget',
          'name' => 'siteaddlink.addlink-menu',
          'page_id' => $page_id,
          'parent_content_id' => $parent_content_id,
          'params' => '{"position":"sticky-bottom-round","title":"","nomobile":"0","name":"siteaddlink.addlink-menu"}',
          'order' => 10,
        ));
      }
    }
  }

}