<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Settings.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteandroidapp_Form_Admin_Maplocation extends Engine_Form {

    public function init() {

        $this->setTitle('Map & Location')
                ->setDescription('Below are the settings that can be used to configure map and location search for app.');

        $this->addElement('Radio', 'android_enable_location', array(
            'label' => 'Enable Location',
            'description' => 'Enabling the location feature in app will allow users to manually set/change the app location using location icon in App Header. If user set the app location, results on all Browse Pages (of SAT Modules only) will be location based, else all the results will be displayed irrespective to the location.',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("android.enable.location", 1),
           'onchange' => 'enablelocationsettings()'
        ));
        $this->getElement('android_enable_location')->getDecorator('Description')->setEscape(false);

        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();

        $getHost = Engine_Api::_()->getApi('core', 'siteapi')->getHost();
        $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
        $baseUrl = @trim($baseUrl, "/");

        $getHost = $getHost . '/' . $baseUrl . '/admin/seaocore/settings/map';
        $this->addElement('Radio', 'siteandroid_autodetect_enable', array(
            'label' => 'Location Auto-Detection',
            'description' => 'On enabling Location Auto-detection, location permission will be automatically shown to app users when they login into the app. Once permission is granted, their location will be auto-updated every time they get into the app.<br> <b>Note:</b> Location Auto-detection will work only when you have set "Enable Specific Locations" to "No" from "Location & Maps".  <a href=' . $getHost . ' target="_blank">click here</a>]',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteandroid.autodetect.enable", 0),
            'onchange' => 'enablelocation()'
        ));
        $this->getElement('siteandroid_autodetect_enable')->getDecorator('Description')->setEscape(false);


        $this->addElement('Radio', 'siteandroid_change_location', array(
            'label' => 'Change Location',
            'description' => 'Do you want users to change their location manually ?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siteandroid.change.location", 0),
        ));
        $this->getElement('siteandroid_change_location')->getDecorator('Description')->setEscape(false);

        $modules = array(
            "siteevent" => "Advanced Events",
            "sitereview" => "Reviews & Ratings - Multiple Listing Types",
            "sitegroup" => "Groups / Communities",
            "sitepage" => "Directory / Pages",
            "sitemember" => "Advanced Members",
            "sitestore"=>"Stores / Marketplace - Ecommerce"
        );
        $multioption = array();
        foreach ($modules as $k => $v) {
            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($k)) {
                $multioption[$k] = $v;
            }
        }

         if (!empty($multioption)) {

            $this->addElement('MultiCheckbox', 'siteandroid_maplocation', array(
                'label' => 'Select Modules for Location Based Results',
                'description' => "Only Modules that you select from the list below will display location based results. Results will display from Closest to Farthest distance from your current location.",
                'multiOptions' => $multioption,
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroid.maplocation', 0)
            ));
        }

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true,
            'order' => 500,
        ));
    }

}
