<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Pushnotification.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteandroidapp_Plugin_Pushnotification {

    /**
     * Variable to exist Google API key.
     *
     * @var String
     */
    public $_GOOGLE_API_KEY;

    /**
     * Loader for parsers
     * 
     * @var Zend_Loader_PluginLoader
     */
    public $_pluginLoader;

    /**
     * Hook: call whenever notification send.
     * 
     * @param object $event
     */
    public function onActivityNotificationCreateAfter($event) {
        $tempSitemenuLtype = 0;
        $notification = $payload = $event->getPayload();
        if($notification->type == 'live_streaming')
           return;
        $siteapiGlobalView = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.global.view', 0);
        $siteapiLSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.lsettings', 0);
        $siteapiInfoType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.androiddevice.type', 0);
        $siteapiGlobalType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.global.type', 0);

        // By pass for un supported modules.
        $getObject = $notification->getObject();
        if (!empty($getObject)) {
//            $objectModName = $this->getNotificationModuleName($notification);
//            $getDefaultAPPModules = Engine_Api::_()->getApi('Core', 'siteapi')->getAPIModulesName();
//            $getDefaultAPPModules[] = 'activity';
//            $getDefaultAPPModules[] = 'core';
//            $getDefaultAPPModules[] = 'user';
//            if (!in_array($objectModName, $getDefaultAPPModules))
//                return;
        } else {
            return;
        }

//        $getDefaultAPPModules = DEFAULT_APP_MODULES;
//        if (!empty($getDefaultAPPModules)) {
//            $getDefaultAPPModuleArray = @explode(",", DEFAULT_APP_MODULES);
//        }
        
        $user = Engine_Api::_()->user()->getUser($notification->user_id);
        $notificationSettingsTable = Engine_Api::_()->getDbtable('notificationSettings', 'activity');
        $notEnable = $notificationSettingsTable->checkEnabledNotification($user, $notification->type);
        if(empty($notEnable))
            return;

        try {
            if (!$notification->getTypeInfo()->siteandroidapp_pushtype)
                return;
        } catch (Exception $ex) {
            return;
        }

        if (empty($siteapiGlobalType)) {
            for ($check = 0; $check < strlen($siteapiLSettings); $check++) {
                $tempSitemenuLtype += @ord($siteapiLSettings[$check]);
            }
            $tempSitemenuLtype = $tempSitemenuLtype + $siteapiGlobalView;
        }

        if (empty($siteapiGlobalView) && ($tempSitemenuLtype != $siteapiInfoType))
            return;

        $subject = Engine_Api::_()->user()->getViewer();
        $subjectOwner = $subjectOwner = Engine_Api::_()->getItem('user', $notification->user_id);

        // User could be login in multiple devices that's why we need to send push notification on all devices.
        if ($this->canSendAndroidNotification()) {
            $registrationTokn = $this->getGCMUser($notification->user_id);
            if(!empty($registrationTokn))
            $this->sendAndroidNotification($registrationTokn, $notification);
        }
    }

    public function getNotificationModuleName($notification) {
        try {
            $getTypeInfo = $notification->getTypeInfo();
            if ($getTypeInfo->type == 'liked') {
                $getNotificationObj = $notification->getObject();
                if (isset($getNotificationObj->resource_type)) {
                    $isItemTypeAvailable = Engine_Api::_()->hasItemType($getNotificationObj->resource_type);
                    if (!empty($isItemTypeAvailable)) {
                        $item = Engine_Api::_()->getItem($getNotificationObj->resource_type, $getNotificationObj->resource_id);
                        if (!empty($item)) {
                            $getObjectModName = $item->getModuleName();
                        }
                    }
                } else if (isset($getNotificationObj->object_type)) {
                    $getTempObject = $getNotificationObj->getObject();
                    if (!empty($getTempObject))
                        $getObjectModName = $getTempObject->getModuleName();
                }
            }else if (($getTypeInfo->type == 'commented') || ($getTypeInfo->type == 'replied')) {
                $getTempObject = $notification->getObject();
                if (!empty($getTempObject) && isset($getTempObject->object_type)) {
                    $getObjectModName = $getTempObject->getObject()->getModuleName();
                } else if (is_object($getTempObject)) {
                    $getObjectModName = $getTempObject->getModuleName();
                }
            } else {
                // By pass for un supported modules.
                $getDefaultAPPModules = DEFAULT_APP_MODULES;
                if (!empty($getDefaultAPPModules)) {
                    $getDefaultAPPModuleArray = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames(); //@explode(",", DEFAULT_APP_MODULES);
                    if (in_array($getTypeInfo->module, $getDefaultAPPModuleArray)) {
                        $getTempObject = $notification->getObject();
                        if (isset($getTempObject))
                            $getObjectModName = $getTempObject->getModuleName();
                    }else {
                        $getObjectModName = $getTypeInfo->module;
                    }
                }
            }

            $getObjectModName = !empty($getObjectModName) ? strtolower($getObjectModName) : '';
            return $getObjectModName;
        } catch (Exception $ex) {
            return '';
        }
    }

    /**
     * Get the array of registration id's to send push notification on them.
     * 
     * @param intiger $user_id: user ID
     */
    public function getGCMUser($user_id) {
        $gcmTable = Engine_Api::_()->getDbtable('gcmusers', 'siteandroidapp');
        return $gcmTable->getUsers(array('user_id' => $user_id));
    }

    /**
     * Gets the plugin loader
     * 
     * @return Zend_Loader_PluginLoader
     */
    public function getPluginLoader() {
        if (null === $this->_pluginLoader) {
            $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'application' . DIRECTORY_SEPARATOR
                    . 'modules' . DIRECTORY_SEPARATOR
                    . 'Activity';
            $this->_pluginLoader = new Zend_Loader_PluginLoader(array(
                'Activity_Model_Helper_' => $path . '/Model/Helper/'
            ));
        }

        return $this->_pluginLoader;
    }

    /**
     * Get a helper
     * 
     * @param string $name
     * @return Activity_Model_Helper_Abstract
     */
    public function getHelper($name) {
        $name = $this->_normalizeHelperName($name);
        if (!isset($this->_helpers[$name])) {
            $helper = $this->getPluginLoader()->load($name);
            $this->_helpers[$name] = new $helper;
        }

        return $this->_helpers[$name];
    }

    /**
     * Normalize helper name
     * 
     * @param string $name
     * @return string
     */
    public function _normalizeHelperName($name) {
        $name = preg_replace('/[^A-Za-z0-9]/', '', $name);
        $name = ucfirst($name);
        return $name;
    }

    /**
     * Add base url in url
     * 
     * @param : string $url
     * @return string
     */
    public function addBaseUrl($url) {
        if (!preg_match("~^(?:f|ht)tps?://~i", $url)) {
            $url = $this->getHttpHostUrl() . $url;
        }
        return $url;
    }

    /**
     * Getting the notification title.
     * 
     * @param object $notification
     * @param float $flag: send (flag=1) to get subject and object array to redirect after click or (flag=0) to get simple notification title.
     * @return string / array call to the assemble() method.
     */
    public function getContent($notification, $flag = false) {
        $params = array_merge(
                $notification->toArray(), (array) $notification->params, array(
            'subject' => $notification->getSubject(),
            'object' => $notification->getObject()
                )
        );

        $params['flag'] = $flag;

        return $this->assemble($notification->getTypeInfo()->body, $params);
    }

    /**
     * Getting the notification title.
     * 
     * @param string $body
     * @param array $params
     * @return string / array
     */
    public function assemble($body, array $params = array()) {
        if('{item:$subject} {var:$stream_verb} live Now.' == $body){
            $body = '{item:$subject} is live Now.';
        }
        $body = Engine_Api::_()->getApi('Core', 'siteapi')->translate($body);

        // Do other stuff
        preg_match_all('~\{([^{}]+)\}~', $body, $matches, PREG_SET_ORDER);
        $feedParams = array();

        foreach ($matches as $match) {
            $tag = $match[0];
            $args = explode(':', $match[1]);
            $helper = array_shift($args);

            $tempParams = $helperArgs = array();
            $tempLabel = $tempType = $tempId = '';
            foreach ($args as $arg) {
                if (substr($arg, 0, 1) === '$') {
                    $arg = substr($arg, 1);
                    $helperArgs[] = ( isset($params[$arg]) ? $params[$arg] : null );
                } else {
                    $helperArgs[] = $arg;
                    $tempLabel .= $arg;
                }
            }

            try {
                $helper = $this->getHelper($helper);
                $r = new ReflectionMethod($helper, 'direct');
                $content = $r->invokeArgs($helper, $helperArgs);
            } catch (Exception $ex) {
                return $body;
            }

            if (isset($params['flag']) && !empty($params['flag'])) { // Make a feed type body params for dynamic Feed Title
                if (isset($helperArgs[0]) && !empty($helperArgs[0])) {
                    if (is_object($helperArgs[0])) {

                        $tempParams['search'] = $tag;
                        $tempParams['label'] = (isset($helperArgs[1]) && !empty($helperArgs[1]) && is_string($helperArgs[1])) ? $helperArgs[1] : $helperArgs[0]->getTitle();
                        $tempParams['type'] = $helperArgs[0]->getType();
                        $tempParams['id'] = $helperArgs[0]->getIdentity();

                        if (isset($helperArgs[1]) && is_object($helperArgs[1]) && strstr($tag, '{actors:$subject:$object}')) {
                            $tempParams['object']['label'] = $helperArgs[1]->getTitle();
                            $tempParams['object']['type'] = $helperArgs[1]->getType();
                            $tempParams['object']['id'] = $helperArgs[1]->getIdentity();
                        }
                    } else {
                        $tempParams['search'] = $tag;
                        $tempParams['label'] = preg_replace('/<\/?a[^>]*>/', '', $helperArgs[0]);

                        // In case of GUID, create object and send respective array to client.
                        if (isset($helperArgs[0]) && !empty($helperArgs[0]) && is_string($helperArgs[0]) && strstr($helperArgs[0], '_')) {
                            $explodeItemTypes = @explode("_", $helperArgs[0]);
                            $id = @end($explodeItemTypes);
                            array_pop($explodeItemTypes);
                            $type = @implode("_", $explodeItemTypes);
                            if (!empty($type) && !empty($id)) {
                                $getObj = Engine_Api::_()->getItem($type, $id);
                                if (!empty($getObj)) {
                                    $tempParams['search'] = $tag;
                                    $tempParams['label'] = $getObj->getTitle();
                                    $tempParams['type'] = $getObj->getType();
                                    $tempParams['id'] = $getObj->getIdentity();
                                }
                            }
                        }
                    }
                    $feedParams[] = $tempParams;
                }
            } else { // Make a Feed Title
                $content = preg_replace('/\$(\d)/', '\\\\$\1', $content);
                $body = preg_replace("/" . preg_quote($tag) . "/", $content, $body, 1);
            }
        }

        if (isset($params['flag']) && !empty($params['flag'])) {
            return $feedParams;
        } else {
            $body = strip_tags($body);
            return $body;
        }
    }

    /**
     * Send push notification to users by site administrator.
     * 
     * @param string $registrationTokn: registration ID
     * @param array $params
     * @return boolean
     */
    public function sendAdminBaseAndroidNotification($registrationToknarray, $params) {
        $GOOGLE_API_KEY = $this->canSendAndroidNotification(true);
        if (!$GOOGLE_API_KEY)
            return;
         $tokenBatch = array_chunk($registrationToknarray,1000);
         foreach($tokenBatch as $tokens)
          {
            $this->sendFcmNotification($tokens,$params);
          }
        return 1;
        
        $gcm = new Zend_Mobile_Push_Gcm();
        $gcm->setApiKey($GOOGLE_API_KEY);
        $messageGCM = new Zend_Mobile_Push_Message_Gcm();
        $messageGCMData = array();
        $messageGCM->addToken($registrationTokn);
        $messageGCMData['message'] = $params['message'];
        $view = new Zend_View();
        $messageGCMData['ticker'] = isset($params['ticker']) && $params['ticker'] ? $params['ticker'] : $view->translate('new update');
        $messageGCMData['title'] = isset($params['title']) && $params['title'] ? $params['title'] : $view->translate('new update');
        $messageGCMData['sound'] = 'audios/drip.wav';
        $messageGCMData['alert'] = 'default';

        $messageGCM->setData(
                $messageGCMData
        );

        return $gcm->send($messageGCM);
    }

    /**
     * Set the Google api key to send push notification.
     * 
     */
    public function canSendAndroidNotification($returnKey = false) {
        if (!$this->_GOOGLE_API_KEY) {
            $this->_GOOGLE_API_KEY = Engine_Api::_()->getApi('settings', 'core')->getSetting("siteandroidapp.google.server.api.key");
        }

        if (!$this->_GOOGLE_API_KEY)
            return false;

        return $returnKey ? $this->_GOOGLE_API_KEY : true;
    }

    /**
     * Send push notification to respective GCMUsers.
     * 
     * @param object $event
     */
    public function sendAndroidNotification($registrationTokn, $notification) {
        $hostType = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $siteapiGlobalView = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.global.view', 0);
        $siteapiManageType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.iosdevice.type', 0);
        $siteapiGlobalType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroidapp.global.type', 0);

        $GOOGLE_API_KEY = $this->canSendAndroidNotification(true);
        if (!$GOOGLE_API_KEY)
            return;

        try {
            $notificationTypeInfo = $notification->getTypeInfo();

            $hrefLinks = explode('href', $notification->__toString());
            $hrefArray = explode('"', $hrefLinks[count($hrefLinks) - 1]);

            if (count($hrefArray) == 1)
                $hrefArray = explode('\'', $hrefArray[0]);

            $hreflink = $this->addBaseUrl($hrefArray[1]);

            $fcm = new Zend_WebPush_Fcm();
            $fcm->setApiKey($GOOGLE_API_KEY);
            $messageFCM = new Zend_WebPush_Message_Fcm();
            $messageFCM->addMultiToken($registrationTokn);
            $messageFCMData = array(
                'href' => $hreflink
            );

            $tempHostType = '';
            if (empty($siteapiGlobalType)) {
                for ($check = 0; $check < strlen($hostType); $check++) {
                    $tempHostType += @ord($hostType[$check]);
                }
                $tempHostType = $tempHostType + $siteapiGlobalView;
            }

            $user_id = $notification->user_id;
            $user = Engine_Api::_()->user()->getUser($user_id);

            $translate = Zend_Registry::get('Zend_Translate');
            $oldlanguage = $translate->getLocale();
            $notificationObject = $notification->getObject();
            $notificationSubject = $notification->getSubject();
            $tempMessage['feed_title'] = $this->getContent($notification);
            if ($notification->type == 'siteverify_new' || $notification->type == 'siteverify_user_request' || $notification->type == 'siteverify_admin_approve' || $notification->type == 'siteverify_verify') {
                $tempMessage['object_params'] = array(
                    'type' => $notificationSubject->getType(),
                    'id' => $notificationSubject->getIdentity()
                );
            } elseif ($notificationObject->getType() == 'album_photo') {
                $tempMessage['object_params'] = array(
                    'type' => $notificationObject->getType(),
                    'id' => $notificationObject->getIdentity(),
                    'album_id' => $notificationObject->album_id
                );
            } elseif ($notificationObject->getType() == 'activity_comment') {
                if (isset($notificationObject->resource_id)) {
                    $resource_id = $notificationObject->resource_id;
                } else {
                    $resource_id = '';
                }
                $tempMessage['object_params'] = array(
                    'type' => $notificationObject->getType(),
                    'id' => $notificationObject->getIdentity(),
                    'resource_id' => $resource_id,
                    'sender_id' => $notification->subject_id
                );
            } else {
                $tempMessage['object_params'] = array(
                    'type' => $notificationObject->getType(),
                    'id' => $notificationObject->getIdentity(),
                    'sender_id' => $notification->subject_id
                );
            }
            
            if(isset($notification->type) && ($notification->type == 'live_streaming'))         {
                $params = (array)json_decode($notification->params);
                $tempMessage['object_params'] = array_merge($params,$tempMessage['object_params']);
            }

            //Reaction work for notification..........................................
            if ($notificationObject->getType() == 'activity_action')
                $ReactionDetails = $this->getFeedReactionDetail($notificationObject);
            if (!empty($ReactionDetails)) {
                $tempMessage['object_params']['reactionsEnabled'] = $ReactionDetails['reactionsEnabled'];
                $tempMessage['object_params']['feed_reactions'] = $ReactionDetails['feed_reactions'];
                $tempMessage['object_params']['attachment_count'] = $ReactionDetails['attachment_count'];
            }

            //push notification work for MLT plugin add listingtype_id in object params & send listing_id in case of sitereview_listing instead of review_id
            if (isset($tempMessage['object_params']['type']) && !empty($tempMessage['object_params']['type']) && isset($tempMessage['object_params']['id']) && !empty($tempMessage['object_params']['id']) && strstr($tempMessage['object_params']['type'], 'sitereview')) {

                if ($tempMessage['object_params']['type'] == 'sitereview_listing') {
                    $sitereviewObj = Engine_Api::_()->getItem('sitereview_listing', $tempMessage['object_params']['id']);
                    if (isset($sitereviewObj) && !empty($sitereviewObj)) {
                        $tempMessage['object_params']['listingtype_id'] = $sitereviewObj->listingtype_id;
                    }
                } else if ($tempMessage['object_params']['type'] == 'sitereview_review') {
                    $reviewObj = Engine_Api::_()->getItem('sitereview_review', $tempMessage['object_params']['id']);
                    if (isset($reviewObj) && !empty($reviewObj) && !empty($reviewObj->resource_id)) {
                        $sitereviewObj = Engine_Api::_()->getItem('sitereview_listing', $reviewObj->resource_id);
                        if (isset($sitereviewObj) && !empty($sitereviewObj)) {
                            $tempMessage['object_params']['listingtype_id'] = $sitereviewObj->listingtype_id;
                            $tempMessage['object_params']['id'] = $sitereviewObj->listing_id;
                        }
                    }
                }
            }

            if (isset($tempMessage['object_params']['id']) && isset($notification->type) && ($notification->type == 'friend_request'))
                $tempMessage['object_params']['id'] = $notification->subject_id;

            $view = new Zend_View();
            $messageFCMData['ticker'] = $view->translate('new update');
            $translate->setLocale($oldlanguage);
            $countUnread = Engine_Api::_()->getDbTable('notifications', 'activity')->hasNotifications($user);
            $notificationSubject = $notification->getSubject();
            if ($notificationSubject->getIdentity()) {
                $messageFCMData['title'] = $notificationSubject->getTitle();
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($notificationSubject);
                $messageFCMData['imgUrl'] = $getContentImages['image_icon'];
            } else {
                $messageFCMData['title'] = $view->translate(array('%s Update', '%s Updates', $countUnread), $countUnread);
            }

            if (4 & (int) $notificationTypeInfo->siteandroidapp_pushtype) {
                $messageFCMData['message'] = Zend_Json::encode($tempMessage);
            }
            if (2 & (int) $notificationTypeInfo->siteandroidapp_pushtype) {
                $messageFCMData['msgcnt'] = $countUnread;
            }
            if (1 & (int) $notificationTypeInfo->siteandroidapp_pushtype) {
                $messageFCMData['sound'] = 1;
            } else
                $messageFCMData['sound'] = 0;

            // @Todo: 
//            if ( 1 & ( int ) $notificationTypeInfo->siteandroidapp_pushtype ) {
//              $messageFCMData['sound'] = 'audios/drip.wav';
//              $messageFCMData['alert'] = 'default';
//            }

            if ((!empty($siteapiGlobalView)) || ($tempHostType == $siteapiManageType)) {
                $messageFCM->setData(
                        $messageFCMData
                );
            }

            $response = $fcm->send($messageFCM);

            return true;
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    /**
     * Get the host
     * 
     * @return string
     */
    public function getHttpHostUrl() {
        $request = Zend_Controller_Front::getInstance()->getRequest();
        if ($request == null) {
            $request = new Zend_Controller_Request_Http();
        }

        return $request->getScheme() . '://' . $request->getHttpHost();
    }

    private function getFeedReactionDetail($action = null) {
        $getBodyResponse = array();
        $getBodyResponse['reactionsEnabled'] = 0;
        $getBodyResponse['reactionsEnabled'] = array();
        if (Engine_Api::_()->getApi('Siteapi_Feed', 'advancedactivity')->isSitereactionPluginLive()) {
            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitereaction') && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitereaction.reaction.active', 1)) {
                $actionTable = Engine_Api::_()->getDbtable('actions', 'advancedactivity');
                $action = $actionTable->getActionById($action->action_id);

                $getBodyResponse['reactionsEnabled'] = 1;
                $getBodyResponse['attachment_count'] = $action->attachment_count;
                $popularity = Engine_Api::_()->getApi('core', 'sitereaction')->getLikesReactionPopularity($action);
                $getBodyResponse['feed_reactions'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitereaction')->getLikesReactionIcons($popularity, 1);
            }
        }

        return $getBodyResponse;
    }
    
    
        private function _sendBroadcastPushNotification($tokens, $data)
    {
        $GOOGLE_API_KEY = $this->canSendAndroidNotification(true);
        $messageFCMData = array();
        $messageFCMData['title'] = $data['title'];
        $messageFCMData['imgUrl'] = $data['imgUrl'];
        $messageFCMData['message'] = Zend_Json::encode($data['message']);
        $messageFCMData['sound'] = 1;
        $fcm = new Zend_WebPush_Fcm();
        $fcm->setApiKey($GOOGLE_API_KEY);
        $messageFCM = new Zend_WebPush_Message_Fcm();
        $messageFCM->addMultiToken($tokens);
        $messageFCM->setData(
                $messageFCMData
        );

        return $fcm->send($messageFCM);
    }
    
    public function sendFcmNotification($tokens, $data)
    {
        $GOOGLE_API_KEY = $this->canSendAndroidNotification(true);
        $fcm = new Zend_WebPush_Fcm();
        $fcm->setApiKey($GOOGLE_API_KEY);
        $messageFCM = new Zend_WebPush_Message_Fcm();
        $messageFCMData = array();
        $messageFCM->addMultiToken($tokens);
        $messageFCMData['message'] = $data['message'];
        $view = new Zend_View();
        $messageFCMData['title'] = isset($data['title']) && $data['title'] ? $data['title'] : $view->translate('new update');
        $messageFCMData['alert'] = 'default';
        $messageFCMData['sound'] = 'audios/drip.wav';
        $messageFCM->setData(
                $messageFCMData
        );

        return $fcm->send($messageFCM);
    }
    public function sendBroadcastNotification($fcmtokens, $data)
    {
        $tokenBatch = array_chunk($fcmtokens,1000);
         foreach($tokenBatch as $tokens)
          {
             $this->_sendBroadcastPushNotification($tokens,$data);
          }
    }

}
