<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminAppBuilderController.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteandroidapp_AdminAppBuilderController extends Core_Controller_Action_Admin {

    protected $_languagePath;
    protected $_getAPPBuilderBaseURL = 'public/app-builder';
    protected $_getAPPBuilderSettingsFileName = 'settings.php';
    protected $_getAPPBuilderTarFileName = 'app-builder.tar';
    protected $_directoryName = 'app-builder';
    protected $_tarFileSize = 0;
    protected $_tabOneError = 0;
    protected $_tabTwoError = 0;
    protected $_requiredFormImages;
    protected $_enabledTabsArray = array(
        1 => 'siteandroidapp_admin_general_settings',
        2 => 'siteandroidapp_admin_graphic_assets',
        4 => 'siteandroidapp_admin_language_assets',
        5 => 'siteandroidapp_admin_advertising',
        6 => 'siteandroidapp_admin_download',
        7 => 'siteandroidapp_admin_people',
    );
    protected $_advertisingEnabledTabsArray = array(
        1 => 'siteandroidapp_admin_advertising_type',
        2 => 'siteandroidapp_admin_advertising_modules',
    );
    protected $_graphicEnabledTabsArray = array(
        1 => 'siteandroidapp_admin_graphic',
        2 => 'siteandroidapp_admin_splash',
        3 => 'siteandroidapp_admin_slideshow',
    );
    protected $_displayquickImages1 = array(
        'feature_graphics',
        'hi_res_icon',
        'notification_icon',
        'notification_icon_large',
        'splash_portrait_1',
        'splash_portrait_2',
        'splash_portrait_3',
        'splash_portrait_4'
    );
    protected $_hidequickImages1 = array(
        'app_icon_2',
        'app_icon_3',
        'app_icon_4',
        'app_icon_5',
    );
    protected $_displayquickImages2 = array(
        'slideshow_slide_image_1_2',
        'slideshow_slide_image_2_2',
        'slideshow_slide_image_3_2',
        'slideshow_slide_plain_image_1_1',
        'slideshow_slide_plain_image_1_2',
        'slideshow_slide_plain_image_1_3',
        'slideshow_slide_plain_image_1_4',
        'slideshow_slide_plain_image_1_5',
        'slideshow_slide_plain_image_1_6',
        'slideshow_slide_plain_image_1_7',
    );
    protected $_hidequickImages2 = array(
        'slideshow_slide_image_1_1',
        'slideshow_slide_image_2_1',
        'slideshow_slide_image_3_1',
    );
    protected $_formFields = array(
        'google_play_details' => array(
            'publish_app',
            'google_play_login',
            'provide_google_play_account_details',
            'google_play_login_email',
            'gmail_permission_done',
            'google_play_login_password'
        ),
        'app_details' => array(
            'package_name',
            'firebase_google_services',
            'title',
            'short_description',
            'description',
            'default_language',
            'category',
            'content_rating',
        ),
        'contact_details' => array(
            'website_contact_details',
            'email_contact_details',
            'policy_url'
        ),
        'app_default_settings' => array(
            'siteapi_validate_ssl',
            'api_consumer_key',
            'api_key',
            'api_consumer_secret',
            'enabledModules',
            'app_webview',
            'isshow_app_name',
            'enable_primemessenger',
            'channelize_version',
            'header_cart_display',
            'rate_us',
            'showcase_app',
            'map_key',
            'giphy_api_key',
            'commit_chat_package',
        ),
        'social_website_details' => array(
            'social_website_details_login',
            'social_share',
            'social_login',
            'twitter_app_id',
            'twitter_post',
            'facebook_app_id',
            'facebook_post',
            'facebook_access_permission',
            'google_app_id'
        ),
        'live_broadcast_settings' => array(
            'enable_broadcast',
            //'agora_id',
            //'agora_server_url',
            
        ),
        'slideshow_first_slide' => array(
            'slideshow_slide_1_title',
            'slideshow_slide_1_description',
            'slideshow_slide_image_1_1',
            'slideshow_slide_image_1_2',
        ),
        'slideshow_second_slide' => array(
            'slideshow_slide_2_title',
            'slideshow_slide_2_description',
            'slideshow_slide_image_2_1',
            'slideshow_slide_image_2_2',
        ),
        'slideshow_third_slide' => array(
            'slideshow_slide_3_title',
            'slideshow_slide_3_description',
            'slideshow_slide_image_3_1',
            'slideshow_slide_image_3_2',
        ),
        'slideshow_first_plain_slide' => array(
            'slideshow_color_background_1',
            'slideshow_color_text_1',
            'slideshow_slide_plain_1_title',
            'slideshow_slide_plain_1_description',
            'slideshow_slide_plain_image_1_1',
        ),
        'slideshow_second_plain_slide' => array(
            'slideshow_color_background_2',
            'slideshow_color_text_2',
            'slideshow_slide_plain_2_title',
            'slideshow_slide_plain_2_description',
            'slideshow_slide_plain_image_1_2',
        ),
        'slideshow_third_plain_slide' => array(
            'slideshow_color_background_3',
            'slideshow_color_text_3',
            'slideshow_slide_plain_3_title',
            'slideshow_slide_plain_3_description',
            'slideshow_slide_plain_image_1_3',
        ),
        'slideshow_four_plain_slide' => array(
            'slideshow_color_background_4',
            'slideshow_color_text_4',
            'slideshow_slide_plain_4_title',
            'slideshow_slide_plain_4_description',
            'slideshow_slide_plain_image_1_4',
        ),
        'slideshow_five_plain_slide' => array(
            'slideshow_color_background_5',
            'slideshow_color_text_5',
            'slideshow_slide_plain_5_title',
            'slideshow_slide_plain_5_description',
            'slideshow_slide_plain_image_1_5',
        ),
        'slideshow_six_plain_slide' => array(
            'slideshow_color_background_6',
            'slideshow_color_text_6',
            'slideshow_slide_plain_6_title',
            'slideshow_slide_plain_6_description',
            'slideshow_slide_plain_image_1_6',
        ),
        'slideshow_seven_plain_slide' => array(
            'slideshow_color_background_7',
            'slideshow_color_text_7',
            'slideshow_slide_plain_7_title',
            'slideshow_slide_plain_7_description',
            'slideshow_slide_plain_image_1_7',
        ),
        'app_icon' => array(
            'app_icon_2',
            'app_icon_3',
            'app_icon_4',
            'app_icon_5',
            'notification_icon',
            'notification_icon_large',
            'hi_res_icon',
            'feature_graphics'
        ),
        'splash_screen' => array(
            'welcome_image_type',
            'animation_time',
        ),
        'splash_screen_portrait' => array(
            'splash_portrait_1',
            'splash_portrait_2',
            'splash_portrait_3',
            'splash_portrait_4'
        )
    );
    protected $_requiredFormFields = array(
        'title',
        'description',
        'short_description',
        'default_language',
        'category',
        'content_rating',
        'website_contact_details',
        'email_contact_details',
        'policy_url',
        'api_key',
        'font',
        'siteapi_validate_ssl',
        'app_webview',
    );
    protected $_dynamicImages = array(
        'splash_portrait_1',
        'splash_portrait_2',
        'splash_portrait_3',
        'splash_portrait_4',
    );
    protected $_EnabledModules = array(
        'siteevent',
        'sitepage',
        'advancedactivity',
        'sitegroup',
        'album',
        'blog',
        'classified',
        'event',
        'forum',
        'group',
        'music',
        'poll',
        'video',
        'sitestore',
        'sitevideo',
        'sitereview',
    );
    protected $_getAPPImageDetailsForUpload = array(
        'feature_graphics' => array(
            'title' => 'Feature Graphics (1024 x 500)',
            'width' => 1024,
            'height' => 500,
            'directoryName' => 'Hi-res_Icon',
            'fileName' => 'feature graphics 1024 x 500'
        ),
        'hi_res_icon' => array(
            'title' => 'Hi-res icon (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Hi-res_Icon',
            'fileName' => 'Hi-res icon 512 x 512'
        ),
        'app_icon_2' => array(
            'title' => 'APP Icon (48 x 48)',
            'width' => 48,
            'height' => 48,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 48 x 48'
        ),
        'notification_icon' => array(
            'title' => 'Notification APP Icon (48 x 48)',
            'width' => 48,
            'height' => 48,
            'directoryName' => 'App_Icons',
            'fileName' => 'Notification icon 48 x 48'
        ),
        'notification_icon_large' => array(
            'title' => 'Notification APP Icon (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'App_Icons',
            'fileName' => 'Notification icon 512 x 512'
        ),
        'comet_chat_icon' => array(
            'title' => 'Comet Chat APP Icon (48 x 48)',
            'width' => 48,
            'height' => 48,
            'directoryName' => 'App_Icons',
            'fileName' => 'Comet Chat App icon 48 x 48'
        ),
        'app_icon_3' => array(
            'title' => 'APP Icon (72 x 72)',
            'width' => 72,
            'height' => 72,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 72 x 72'
        ),
        'app_icon_4' => array(
            'title' => 'APP Icon (96 x 96)',
            'width' => 96,
            'height' => 96,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 96 x 96'
        ),
        'app_icon_5' => array(
            'title' => 'APP Icon (180 x 180)',
            'width' => 180,
            'height' => 180,
            'directoryName' => 'App_Icons',
            'fileName' => 'icon 180 x 180'
        ),
        'splash_portrait_1' => array(
            'title' => 'Splash Portrait Image (200 x 320)',
            'width' => 200,
            'height' => 320,
            'directoryName' => 'Splash_Screen_Images/Portrait',
            'fileName' => 'screen 200 x 320'
        ),
        'splash_portrait_2' => array(
            'title' => 'Splash Portrait Image (320 x 480)',
            'width' => 320,
            'height' => 480,
            'directoryName' => 'Splash_Screen_Images/Portrait',
            'fileName' => 'screen 320 x 480'
        ),
        'splash_portrait_3' => array(
            'title' => 'Splash Portrait Image (480 x 800)',
            'width' => 480,
            'height' => 800,
            'directoryName' => 'Splash_Screen_Images/Portrait',
            'fileName' => 'screen 480 x 800'
        ),
        'splash_portrait_4' => array(
            'title' => 'Splash Portrait Image (720 x 1280)',
            'width' => 720,
            'height' => 1280,
            'directoryName' => 'Splash_Screen_Images/Portrait',
            'fileName' => 'screen 720 x 1280'
        ),
        'slideshow_slide_image_1_1' => array(
            'title' => 'Slideshow - First Slide (480 x 800)',
            'width' => 480,
            'height' => 800,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 480 x 800',
            'fileName' => 'first'
        ),
        'slideshow_slide_image_1_2' => array(
            'title' => 'Slideshow - First Slide (720 x 1280)',
            'width' => 720,
            'height' => 1280,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 720 x 1280',
            'fileName' => 'first'
        ),
        'slideshow_slide_image_2_1' => array(
            'title' => 'Slideshow - Second Slide (480 x 800)',
            'width' => 480,
            'height' => 800,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 480 x 800',
            'fileName' => 'second'
        ),
        'slideshow_slide_image_2_2' => array(
            'title' => 'Slideshow - Second Slide (720 x 1280)',
            'width' => 720,
            'height' => 1280,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 720 x 1280',
            'fileName' => 'second'
        ),
        'slideshow_slide_image_3_1' => array(
            'title' => 'Slideshow - Third Slide (480 x 800)',
            'width' => 480,
            'height' => 800,
            'directoryName' => 'Slideshow_Images/Small_Images_Mobile 480 x 800',
            'fileName' => 'third'
        ),
        'slideshow_slide_image_3_2' => array(
            'title' => 'Slideshow - Third Slide (720 x 1280)',
            'width' => 720,
            'height' => 1280,
            'directoryName' => 'Slideshow_Images/Big_Images_Tablet 720 x 1280',
            'fileName' => 'third'
        ),
        'slideshow_slide_plain_image_1_1' => array(
            'title' => 'Slideshow - First Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'first'
        ),
        'slideshow_slide_plain_image_1_2' => array(
            'title' => 'Slideshow - Second Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'second'
        ),
        'slideshow_slide_plain_image_1_3' => array(
            'title' => 'Slideshow - Third Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'third'
        ),
        'slideshow_slide_plain_image_1_4' => array(
            'title' => 'Slideshow - Fourth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'four'
        ),
        'slideshow_slide_plain_image_1_5' => array(
            'title' => 'Slideshow - Fifth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'five'
        ),
        'slideshow_slide_plain_image_1_6' => array(
            'title' => 'Slideshow - Sixth Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'six'
        ),
        'slideshow_slide_plain_image_1_7' => array(
            'title' => 'Slideshow - Seventh Slide (512 x 512)',
            'width' => 512,
            'height' => 512,
            'directoryName' => 'Slideshow_Images/Plain_Slideshow 512 x 512',
            'fileName' => 'seven'
        ),
    );

    public function init() {
        $getWebsiteName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $websiteStr = str_replace(".", "-", $getWebsiteName);
        $this->_directoryName = 'android-' . $websiteStr . '-app-builder';
        $this->_getAPPBuilderTarFileName = $this->_directoryName . '.tar';
        $this->_getAPPBuilderBaseURL = 'public/' . $this->_directoryName;
        $enabledTab = $this->_getParam('tab', 1);
        $tempImageArray = $this->_getAPPImageDetailsForUpload;
        unset($tempImageArray['slideshow_slide_image_2_1']);
        unset($tempImageArray['slideshow_slide_image_2_2']);
        unset($tempImageArray['slideshow_slide_image_3_1']);
        unset($tempImageArray['slideshow_slide_image_3_2']);
        unset($tempImageArray['comet_chat_icon']);
        if (($enabledTab != 2) && ($enabledTab != 6)) {
            unset($tempImageArray['slideshow_slide_image_1_1']);
            unset($tempImageArray['slideshow_slide_image_1_2']);
        }
                
        $tempImageArray = array_keys($tempImageArray);
        $this->_requiredFormImages = $tempImageArray;

        // Set default language path
        $this->_languagePath = APPLICATION_PATH . '/application/languages';
        $this->view->enabledTabs = $this->_enabledTabsArray;
        $this->view->currentTab = $currentTab = $this->_getParam('tab', 1);
        $this->getFormFields($currentTab);
        $this->view->tabOneErrorDisplay = $this->_tabOneError;
        $this->view->tabTwoErrorDisplay = $this->_tabTwoError;
        $this->view->subTabError = $this->_subTabError;
    }

    public function indexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_app_create');
    }

    public function editGoogleAdModulesAction() {
        $key = $this->_getParam('key');
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->view->form = $form = new Siteandroidapp_Form_Admin_AppBuilder_GoogleAds_Edit();

        if (isset($appBuilderParams) && !empty($appBuilderParams) && isset($appBuilderParams['Ads'][$key]) && !empty($appBuilderParams['Ads'][$key])) {
            $form->populate($appBuilderParams['Ads'][$key]);
        }

        if(Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead'))
            $communityPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead');
        else
            $communityPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad');
        
        $storyPluginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled("communityadsponsored");


        if ($appBuilderParams['adv_type'] == 0) {
            $adMultiOptions[0] = 'Google Ads';
        } else {
            $adMultiOptions[1] = 'Facebook Ads';
        }
        if ($communityPluginEnabled) {
            $adMultiOptions[2] = 'Community Ads';
        }
        if ($storyPluginEnabled && strstr($key, 'advancedactivity')) {
            $adMultiOptions[4] = 'Sponsered Stories';
        }


        $form->getElement('module_ad_type')->setMultiOptions($adMultiOptions);

        if ($this->getRequest()->isPost()) {
            $formError = array();
            $values = $this->getRequest()->getPost();

            if (!empty($values)) {
                unset($values['submit']);
                $values['enabled_google_ad'] = (boolean) $values['enabled_google_ad'];
                $values['google_ad_show_after'] = (int) $values['google_ad_show_after'];
                $values['module_ad_type'] = $values['module_ad_type'];
                $appBuilderParams['Ads'][$key] = $values;
            }

            if (!empty($appBuilderParams)) {
                $file_contents = "<?php ";
                $file_contents .= '$appBuilderParams = ';
                $file_contents .= var_export($appBuilderParams, true);
                $file_contents .= " ?>";

                @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
                $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
            }

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 300,
                'parentRefresh' => 300,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('successfully saved'))
            ));
        }
    }

    public function statusAction() {
        $key = $this->_getParam('key');
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        if (isset($appBuilderParams) && !empty($appBuilderParams) && isset($appBuilderParams['Ads'][$key]) && !empty($appBuilderParams['Ads'][$key])) {
            $appBuilderParams['Ads'][$key]['enabled_google_ad'] = !$appBuilderParams['Ads'][$key]['enabled_google_ad'];
        } else {
            $appBuilderParams['Ads'][$key]['google_ad_show_after'] = 8;
            $appBuilderParams['Ads'][$key]['enabled_google_ad'] = true;
        }

        if (!empty($appBuilderParams)) {
            $file_contents = "<?php ";
            $file_contents .= '$appBuilderParams = ';
            $file_contents .= var_export($appBuilderParams, true);
            $file_contents .= " ?>";

            @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
            $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
        }

        $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => true,
            'parentRefresh' => true,
        ));
    }

    public function languageEditAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_app_create');
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_appsetup_main', array(), $this->_enabledTabsArray[4]);

        $this->view->isFileExist = false;
        $this->view->locale = $locale = $this->_getParam('locale');
        $this->view->page = $page = $this->_getParam('page');
        $translation = $this->_getParam('translation', 0);
        $show = $this->_getParam('show', null);
        $search = $this->_getParam('search', null);
        $translate = Zend_Registry::get('Zend_Translate');

        // Get existing language array.
        $getAPPLanguageDetailsForUpload = $this->_getAPPLanguageDetailsForUpload();

        $defaultTargetStringURL = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.xml';

        // Convert CSV to XML
        if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.csv') &&
                !file_exists($defaultTargetStringURL)) {
            $this->_modifyExistingLanguageXML(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.csv', $defaultTargetStringURL);
        }

        if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                @file_exists($defaultTargetStringURL)) {
            $this->view->isFileExist = true;
            @chmod($defaultTargetStringURL, 0777);

            // If exist xml file is corrupted then show error message.
            $getSimpleXMLLoadFile = simplexml_load_file($defaultTargetStringURL);
            if (empty($getSimpleXMLLoadFile)) {
                $this->view->taregtFileCorrupted = $defaultTargetStringURL;
                return;
            }

            $getExistingLanguageArray = $this->_ExplodeXMLToArray($defaultTargetStringURL);
        }
        // Process filter form
        $this->view->filterForm = $filterForm = new Core_Form_Admin_Language_Filter();
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $getAPPLanguageDetailsForUpload[$locale]['directoryName'] . '/' . $getAPPLanguageDetailsForUpload[$locale]['fileName'] . '.xml';

        // Get default language array.
        if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteandroidapp/settings/defaultstrings.xml')) {
            $getDefaultLanguageArray = $this->_ExplodeXMLToArray(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteandroidapp/settings/defaultstrings.xml');
            if (!empty($translation) && Engine_Api::_()->hasModuleBootstrap('sitetranslator') && $locale != 'en' && !file_exists($path)) {
                $variables = $this->_csv_to_array(APPLICATION_PATH . "/application/modules/Sitetranslator/settings/variables.csv");
                $responseData = Engine_Api::_()->sitetranslator()->getTranslatedBaseMessage($getDefaultLanguageArray, $locale, $variables);
                if ($responseData['responseCode'] != 200) {
                    $filterForm->addError('Fetching translation failed! Server response code:' . $responseData['responseCode'] . '<br /> Error description: ' . $responseData['responseData']['error']['errors'][0]['message']);
                } else {
                    $getDefaultTranslatedLanguageArray = $responseData['responseData'];
                }
            }
        }

        $filterForm->isValid($this->_getAllParams());
        $filterValues = $filterForm->getValues();
        extract($filterValues); // search, show
        // Make query
        $filterValues = array_filter($filterValues);
        $this->view->values = $filterValues;
        $this->view->query = ( empty($filterValues) ? '' : '?' . http_build_query($filterValues) );

        // Query plural system for max and sample space
        $sample = array();
        $max = 0;
        for ($i = 0; $i <= 1000; $i++) {
            $form = Zend_Translate_Plural::getPlural($i, $locale);
            $max = max($max, $form);
            if (@count($sample[$form]) < 3) {
                $sample[$form][] = $i;
            }
        }
        $pluralFormCount = ( $max + 1 );
        $this->view->pluralFormSample = $sample;
        // Build the fancy array
        $baseMessages = $getDefaultLanguageArray;
        $resultantMessages = array();
        $missing = 0;
        $index = 0;
        $missingLanguageCount = 0;
        foreach ($baseMessages as $key => $value) {
            // Build
            $composite = array(
                'uid' => ++$index,
                'key' => $key,
                'original' => $value
            );

            if (!empty($getExistingLanguageArray) &&
                    !isset($getExistingLanguageArray[$key]))
                $missingLanguageCount++;


            if (($show === 'missing') &&
                    !empty($getExistingLanguageArray) &&
                    isset($getExistingLanguageArray[$key]))
                continue;

            if ($show === 'translated' &&
                    !isset($getExistingLanguageArray[$key]))
                continue;

            $composite['plural'] = $isPlural = (bool) is_array($value);

            $composite['current'] = (!empty($getExistingLanguageArray) && isset($getExistingLanguageArray[$key]) && !empty($getExistingLanguageArray[$key])) ? $getExistingLanguageArray[$key] : (!empty($getDefaultTranslatedLanguageArray[$key]) ? $getDefaultTranslatedLanguageArray[$key] : $value);

            $composite['pluralFormCount'] = !empty($isPlural) ? COUNT($value) : 2;
            if ($search && !$this->_searchArrayRecursive($search, $composite)) {
                continue;
            }
            // Add
            $resultantMessages[] = $composite;
        }

        $this->view->missingLanguageCount = $missingLanguageCount;

        // Build the paginator
        $this->view->paginator = $paginator = Zend_Paginator::factory($resultantMessages);
        $paginator->setItemCountPerPage(50);
        $paginator->setCurrentPageNumber($page);


        // Process form POST
        if ($this->getRequest()->isPost()) {
            $keys = $this->_getParam('keys');
            $values = $this->_getParam('values');

            if (isset($getAPPLanguageDetailsForUpload[$locale]) &&
                    isset($getAPPLanguageDetailsForUpload[$locale]['fileName']) &&
                    !file_exists($path)) {
                if (!copy(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteandroidapp/settings/defaultstrings.xml', $path)) {
                    
                }
            }


            /*
             * 1) Check if language available then overright the value. [Singular and Plural]
             * 
             * 2) If language not available then need to add that language in the bottom of the file. [Singular and Plural]
             */

            $explodeXMLToArray = !empty($getDefaultTranslatedLanguageArray) ? $getDefaultTranslatedLanguageArray : $this->_ExplodeXMLToArray($path, 1);
            $valuesArray = $explodeXMLToArray['values'] ? $explodeXMLToArray['values'] : $explodeXMLToArray;
            $pluralsKeyArray = $this->_ExplodeXMLToArray(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteandroidapp/settings/defaultstrings.xml', 1);
            $pluralsKeyArray = $pluralsKeyArray['pluralsKey'];
            foreach ($keys as $key => $value) {
                // For Singular
                if (!is_array($value))
                    $valuesArray[$value] = $values[$key];
                else
                    $valuesArray[$value[0]] = $values[$key];
            }

            // Set the plurals key.
            foreach ($valuesArray as $key => $value) {
                if (is_array($value)) {
                    $tempValuesArray = array();
                    foreach ($value as $tempKey => $tempValue) {
                        if (isset($pluralsKeyArray[$key][$tempKey]) && !empty($pluralsKeyArray[$key][$tempKey]))
                            $tempValuesArray[$pluralsKeyArray[$key][$tempKey]] = $tempValue;
                    }

                    if (!empty($tempValuesArray))
                        $valuesArray[$key] = $tempValuesArray;
                }
            }

            // Set the languages
            $this->_setArrayToXML($path, $valuesArray);
            return $this->_redirect($this->view->url(array('module' => 'siteandroidapp', 'controller' => 'app-builder', 'action' => 'create', 'tab' => 4), 'admin_default', false), array('prependBase' => false));
        }
    }

    public function languageIndexAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_app_create');

        $enabledTab = $this->_getParam('tab', 1);
        $this->view->doWeHaveLatestVersion = $this->_getParam('doWeHaveLatestVersion', '');
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_appsetup_main', array(), $this->_enabledTabsArray[$enabledTab]);

        $translate = Zend_Registry::get('Zend_Translate');

        // Prepare language list
        $this->view->languageList = $languageList = $translate->getList();

        // remove the language which was earlier a part of the website but now is not.
        $fileList = glob(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . "Languages_App/*");

        $langaugeKeys = array_keys($this->_getAPPLanguageDetailsForUpload());

        foreach ($fileList as $row => $value) {
            $pathArray = explode("/", $value);
            $fileending = $pathArray[count($pathArray) - 1];
            $languageArray = explode("_language", $fileending);
            if (!in_array($languageArray[0], $langaugeKeys)) {
                unlink($value);
            }
        }

        // removing file
        //Get available language file.
        foreach ($this->_getAPPLanguageDetailsForUpload() as $key => $values) {
            @chmod(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.xml', 0777);
            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.xml'))
                $getDefaultAvailableLanguages[$key] = $values;
            elseif (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.csv'))
                $getDefaultAvailableCSVLanguages[$key] = $values;
        }
        $this->view->getAPPLanguageDetailsForUpload = !empty($getDefaultAvailableLanguages) ? $getDefaultAvailableLanguages : array();
        $this->view->getAPPCSVLanguageDetailsForUpload = !empty($getDefaultAvailableCSVLanguages) ? $getDefaultAvailableCSVLanguages : array();

        // Prepare default langauge
        $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
        if (!in_array($defaultLanguage, $languageList)) {
            if ($defaultLanguage == 'auto' && isset($languageList['en'])) {
                $defaultLanguage = 'en';
            } else {
                $defaultLanguage = null;
            }
        }
        $this->view->defaultLanguage = $defaultLanguage;

        // Init default locale
        $localeObject = Zend_Registry::get('Locale');

        $languages = Zend_Locale::getTranslationList('language', $localeObject);
        $territories = Zend_Locale::getTranslationList('territory', $localeObject);

        $localeMultiOptions = array();
        foreach (/* array_keys(Zend_Locale::getLocaleList()) */ $languageList as $key) {
            $languageName = null;
            if (!empty($languages[$key])) {
                $languageName = $languages[$key];
            } else {
                $tmpLocale = new Zend_Locale($key);
                $region = $tmpLocale->getRegion();
                $language = $tmpLocale->getLanguage();
                if (!empty($languages[$language]) && !empty($territories[$region])) {
                    $languageName = $languages[$language] . ' (' . $territories[$region] . ')';
                }
            }

            if ($languageName) {
                $localeMultiOptions[$key] = $languageName . ' [' . $key . ']';
            } else {
                $localeMultiOptions[$key] = $this->view->translate('Unknown') . ' [' . $key . ']';
            }
        }
        $localeMultiOptions = array_merge(array(
            $defaultLanguage => $defaultLanguage
                ), $localeMultiOptions);
        $this->view->languageNameList = $localeMultiOptions;
    }

    public function languageDeleteAction() {
        $this->_helper->layout->setLayout('admin-simple');
        $this->view->locale = $defaultLocale = $this->_getParam('locale');
        $languageList = Zend_Locale_Data::getList('en', 'language');
        $territoryList = Zend_Locale_Data::getList('en', 'territory');
        $localeCode = $this->_getParam('locale', null);
        if (empty($localeCode))
            return;
        if (FALSE !== strpos($localeCode, '_')) {
            list($locale, $territory) = explode('_', $localeCode);
        } else {
            $locale = $localeCode;
            $territory = null;
        }

        $languagePack = $languageList[$locale];
        if ($territory && !empty($territoryList[$territory]))
            $languagePack .= " ({$territoryList[$territory]})";
        $languagePack .= "  [$localeCode]";
        $this->view->languagePack = $languagePack;

        if ($this->getRequest()->isPost()) {
            // Delete existing string file.
            if (!empty($localeCode) && file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_android_mobileapp.xml'))
                @unlink(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_android_mobileapp.xml');

            // Delete existing csv file.
            if (!empty($localeCode) && file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_android_mobileapp.csv'))
                @unlink(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Languages_App/' . $defaultLocale . '_language_android_mobileapp.csv');

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted Successfully!'))
            ));
        }
    }

    public function createAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_app_create');
        $enabledTab = $this->_getParam('tab', 1);
        $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_appsetup_main', array(), $this->_enabledTabsArray[$enabledTab]);

        $this->view->doWeHaveLatestVersion = $doWeHaveLatestVersion = $this->_doWeHaveLatestVersion();

        $this->view->formFields = $this->_formFields;
        // Forward for language work.
        if ($enabledTab == 4) {
            return $this->_forward('language-index', 'admin-app-builder', 'siteandroidapp', array(
                        'tab' => $enabledTab,
                        'doWeHaveLatestVersion' => $doWeHaveLatestVersion
            ));
        }

        if ($enabledTab == 5) {
            $enableAdvertisementModule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitead');
            $this->view->subTab = $subTab = $this->_getParam('subTab', 1);
            $this->view->subsubnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_advertising', array(), $this->_advertisingEnabledTabsArray[$subTab]);
            if ($enableAdvertisementModule) {
                $multiOptions = array();
                $modules = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
                $enabledModules = array_intersect($this->_EnabledModules, $modules);
                foreach ($enabledModules as $module) {
                    $multiOptions[$module] = Engine_Api::_()->getDbTable('integrated', 'seaocore')->getModuleTitle($module);
                }
                $this->view->getEnabledModules = $multiOptions;
            } else {
                $this->view->errorMessage = $this->view->translate("Note: Please enable Advertisements, Community Ads & Marketing Campaigns Plugin by SocialApps.tech, so that Advertisement functions properly.");
            }
        }
        if ($enabledTab == 2) {
            $this->view->subTab = $subTab = $this->_getParam('subTab', 1);
            $this->view->subsubnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_graphic_assets', array(), $this->_graphicEnabledTabsArray[$subTab]);
        }

        $dontShowDownloadLink = false;
        $downloadTar = $this->_getParam('downloadTar', false);
        if (isset($downloadTar) && !empty($downloadTar))
            $this->view->downloadTar = true;

        // To check maximum file upload size.
        $upload_max_filesize = (int) @str_replace('M', '', @ini_get("upload_max_filesize"));
        if (isset($upload_max_filesize) &&
                !empty($upload_max_filesize) &&
                isset($this->_tarFileSize) &&
                !empty($this->_tarFileSize) &&
                $this->_tarFileSize > $upload_max_filesize
        ) {
            $this->view->showDownloadTip = true;
            $this->view->tarFileSize = $this->_tarFileSize;
            $this->view->upload_max_filesize = $upload_max_filesize;
        }

        $this->view->package = $package = $this->_getParam('package', null);
        $clientId = $this->_getParam('clientId', null);
        $clientEmail = $this->_getParam('email', null);

        // Validate subscription plane.
        if (empty($package)) {
            $getAvailableSubscriptionPlane = $this->validateSubscriptionPlane();
            if (is_array($getAvailableSubscriptionPlane)) {
                $this->view->getUserInfo = $getUserInfo = $getAvailableSubscriptionPlane[0];
                if (COUNT($getUserInfo['subscriptionPlane']) == 1) {
                    $this->_helper->redirector->gotoRoute(array(
                        'package' => $getUserInfo['subscriptionPlane'][0],
                        'clientId' => $getUserInfo['clientId'],
                        'email' => $getUserInfo['email']
                    ));
                    return;
                }
            } else if (strstr($getAvailableSubscriptionPlane, 'error')) {
                $this->view->errorMessage = @str_replace("error::", "", $getAvailableSubscriptionPlane);
            }
        }
        // Set the app builder settings file url.
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->view->form = $form = new Siteandroidapp_Form_Admin_AppBuilder_Settings(array('doWeHaveLatestVersion' => $doWeHaveLatestVersion, 'enabledTabName' => $this->_enabledTabsArray[$enabledTab]));

        // Populate form
        if (!empty($_POST)) {
            $form->populate($_POST);
        } elseif (isset($appBuilderParams) && !empty($appBuilderParams)) {
            $this->view->appBuilderParams = $appBuilderParams;
            $form->populate($appBuilderParams);
            $enableLivestreamingModule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('livestreamingvideo');
            if($enableLivestreamingModule)
            {
                if ($form->getElement('agora_app_id'))
                    $form->agora_app_id->setValue(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.id', ''));
                if ($form->getElement('live_stream_url'))
                    $form->live_stream_url->setValue(Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url', '')); 
             }
        }

        if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . 'google-services.json')) {
            $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
            $baseUrl = @trim($baseUrl, "/");
            $getHost = _ENGINE_SSL ? 'https://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl : 'http://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl;
            $getHost = @trim($getHost, "/");
            $getHost = str_replace("index.php/", "", $getHost);

            $filePath = $getHost . DIRECTORY_SEPARATOR
                    . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                    . $values['directoryName'] . DIRECTORY_SEPARATOR
                    . 'google-services.json';
            $description = "This file is required for Push Notifications. To check uploaded file. Please <a href='" . $filePath . "' target='_blank'>click here</a>.";
            if (isset($form->firebase_google_services)) {
                $form->firebase_google_services->setDescription($description);
                $form->firebase_google_services->getDecorator('Description')->setOptions(array('placement' => 'PREPEND', 'escape' => false));
            }
        }

        // Set description for uploaded images.
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
            $imageType = '.png';
            if (in_array($key, $this->_dynamicImages) && isset($appBuilderParams['welcome_image_type']) && empty($appBuilderParams['welcome_image_type']))
                $imageType = '.gif';

            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . $imageType)) {
//                if (empty($package) || (($package == 'starter') && ($key === 'hi_res_icon')))
//                    continue;

                $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
                $baseUrl = @trim($baseUrl, "/");
                $getHost = _ENGINE_SSL ? 'https://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl : 'http://' . $_SERVER['HTTP_HOST'] . DIRECTORY_SEPARATOR . $baseUrl;
                $getHost = @trim($getHost, "/");
                $getHost = str_replace("index.php/", "", $getHost);

                if ($imageType == '.gif') {
                    $filePath = $getHost . DIRECTORY_SEPARATOR
                            . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                            . $values['directoryName'] . DIRECTORY_SEPARATOR
                            . $values['fileName']
                            . '.gif';
                } else {
                    $filePath = $getHost . DIRECTORY_SEPARATOR
                            . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR
                            . $values['directoryName'] . DIRECTORY_SEPARATOR
                            . $values['fileName']
                            . '.png';
                }

                $tempWidth = $values['width'];
                $tempHeight = $values['height'];
                if (($values['width'] > 500)) {
                    $tempWidth = $values['width'] - 300;
                    $tempHeight = $values['height'] - 300;
                }
                $updatedFilePath = $filePath . '?imageversion=' . time();
                $description = "<a id='" . $key . "-show-hover' class='image-hover' href='" . $updatedFilePath . "' target='_blank'  ><i class='fa fa-picture-o'></i></a><img id='" . $key . "-hover' src='" . $updatedFilePath . "' '>";
                if (isset($form->$key)) {
                    $form->$key->setDescription($description);
                    if ($key == 'notification_icon') {
                        $addDesc = $description . '<span class="tooltip_main"><span class="tooltip"><span class="tooltiptext">Icon should be of white color with transparent background.</span><a class="admin help" href="" target="_blank" title= ""></a></span></span>';
                        $form->$key->setDescription($addDesc);
                        $form->$key->getDecorator('Description')->setOptions(array('placement' => 'APPEND', 'escape' => false));
                    } else if ($key == 'feature_graphics') {
                        $addDesc = $description . '<span class="tooltip_main"><span class="tooltip"><span class="tooltiptext">This image is displayed as main photo for your app Play Store <a target="_blank" class="mleft5" title="View Screenshot" href="application/modules/Siteandroidapp/externals/images/feature.png" target="_blank"><img src="application/modules/Siteandroidapp/externals/images/eye.png" /></a></span><a class="admin help" href="" target="_blank" title= ""></a></span></span>';
                        $form->$key->setDescription($addDesc);
                        $form->$key->getDecorator('Description')->setOptions(array('placement' => 'APPEND', 'escape' => false));
                    } else
                        $form->$key->getDecorator('Description')->setOptions(array('placement' => 'APPEND', 'escape' => false));
                }
            } else if (in_array($key, $this->_requiredFormImages)) {
                $dontShowDownloadLink = true;
            }
        }

        if (empty($dontShowDownloadLink)) {
            if (!empty($this->tabOneErrorDisplay) || $this->tabTwoErrorDisplay) {
                $dontShowDownloadLink = true;
            }
        }

        $this->view->requiredFormFields = array_merge($this->_requiredFormFields, $this->_requiredFormImages);

        if (($package == 'pro') && !isset($_POST['provide_google_play_account_details']) && !empty($_POST['provide_google_play_account_details'])) {
            $requireFieldsPro = array(
                'google_play_login_email',
                'google_play_login_password',
            );
            $this->_requiredFormFields = array_merge($requireFieldsPro, $this->_requiredFormFields);
        }
        $this->view->tab = $enabledTab;
        $this->view->dynamicImages = $this->_dynamicImages;
        $this->view->quickImage = $imageUploadProcess = isset($appBuilderParams['image_upload_type']) ? $appBuilderParams['image_upload_type'] : 1;

        if (!empty($dontShowDownloadLink)) {
            if (isset($form->download_text))
                $form->download_text->setLabel('<div class="seaocore_tip"><span>If you are unable to see "Download .tar" link, this means you have not filled all the form sections completely. Please check all the form sections and complete them as required.</span></div>');

            if (isset($form->download_tar))
                $form->removeElement('download_tar');
        }

        $errors = array();

        if ($this->getRequest()->isPost()) {
            $this->_requiredFormFields = array_diff($this->_requiredFormFields, array('api_key'));
            $this->_requiredFormFields = array_merge(array('api_consumer_key', 'api_consumer_secret'), $this->_requiredFormFields);

            $formError = array();
            $values = $this->getRequest()->getPost();
            if (!empty($appBuilderParams))
                $values = array_merge($appBuilderParams, $values);
            
            $agoraKey = Engine_Api::_()->getApi('Core', 'siteandroidapp')->getAgoraKey();
            if(!empty($agoraKey))
            {
                $values['agora_app_id'] = $agoraKey;
            }

            $primemessengerPublicKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.publickey');
            if(!empty($primemessengerPublicKey))
            {
                $values['pm_public_key'] = $primemessengerPublicKey;
            }
            
            if($values['live_stream_url']){
                 Engine_Api::_()->getApi('settings', 'core')->setSetting('livestreamingvideo_url', $values['live_stream_url']);
            }

            foreach ($this->_requiredFormFields as $element) {
                if (!isset($form->$element))
                    continue;

                //Checks to manage UI of form
                if (($element == 'google_play_login_email' || $element == 'google_play_login_password') && empty($values[$element])) {
                    $formError['google_play_login'] = $form->$element->getLabel() . " - Field  is required";
                }

                if ($element == 'primary_category' && empty($values[$element])) {
                    $formError['category'] = $form->$element->getLabel() . " - Field  is required";
                }

                if (($element == 'api_consumer_key' || $element == 'api_consumer_secret') && empty($values[$element])) {
                    $formError['api_key'] = "API Key - Field  is required";
                }

                if (in_array($element, array('siteapi_validate_ssl'))) {
                    if (!isset($values[$element]))
                        $formError['siteapi_validate_ssl'] = $form->$element->getLabel() . " - Field  is required";
                }else if (in_array($element, array('app_webview'))) {
                    if (!isset($values[$element]))
                        $formError['app_webview'] = $form->$element->getLabel() . " - Field  is required";
                }
                else if (empty($values[$element]))
                    if (!empty($form->$element->getLabel())) {
                        $formError[$element] = $form->$element->getLabel() . " - Field  is required";
                    }

                if ($element == 'email_contact_details' && !empty($values[$element])) {

                    // Validate emails
                    $validate = new Zend_Validate_EmailAddress();

                    if (!$validate->isValid(trim($values[$element]))) {
                        $formError['email_contact_details'] = $form->$element->getLabel() . " - Enter a valid Email Id";
                    }
                }

                if ($element == 'title' && !empty($values[$element])) {
                    $strLen = Engine_String::strlen($values[$element]);
                    $maxLength = 30;
                    if ($strLen >= $maxLength) {
                        $formError['title'] = $form->$element->getLabel() . " - Title should be less than 30 single-byte characters";
                    }
                }

                if ($element == 'short_description' && !empty($values[$element])) {
                    $strLen = Engine_String::strlen($values[$element]);
                    $maxLength = 80;
                    if ($strLen >= $maxLength) {
                        $formError['short_description'] = $form->$element->getLabel() . " - Title should be less than 80 single-byte characters";
                    }
                }

                if ($element == 'description' && !empty($values[$element])) {
                    $strLen = Engine_String::strlen($values[$element]);
                    $maxLength = 4000;
                    if ($strLen >= $maxLength) {
                        $formError['description'] = $form->$element->getLabel() . " - Description should be less than 4000 single-byte characters";
                    }
                }
            }

            if (isset($_FILES['firebase_google_services']["tmp_name"]) && !empty($_FILES['firebase_google_services']["tmp_name"])) {
                $firebaseFileName = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'google-services.json';
                $jsonFileType = @pathinfo($firebaseFileName, PATHINFO_EXTENSION);
                if ($jsonFileType != "json") {
                    $errors[] = 'Google Services File : Sorry, only json files are allowed.';
                }
                $isFileUpload = @move_uploaded_file($_FILES['firebase_google_services']["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'google-services.json');
                @chmod($firebaseFileName, 0777);
            }
            if (!@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . 'google-services.json')) {
                $formError['firebase_google_services'] = 'Google Services File - File  is required';
            }
            if (($package == 'pro') && empty($values['provide_google_play_account_details']) && empty($values['gmail_permission_done'])) {
                $formError['provide_google_play_account_details'] = 'Give permission to access Google Play Developer account.';
            } else if (($package == 'pro') && !empty($values['provide_google_play_account_details']) && empty($values['google_play_login_email']) && empty($values['google_play_login_password'])) {
                $formError[] = 'Enter `Google Play Login Email` and `Google Play Login Password` to access Google Play Developer account.';
            }

            if (($package == 'pro') &&
                    !empty($values['provide_google_play_account_details']) &&
                    !empty($values['google_play_login_email'])
            ) {
                // Validate emails
                $validate = new Zend_Validate_EmailAddress();

                if (!$validate->isValid(trim($values['google_play_login_email']))) {
                    $formError['google_play_login'] = "Enter a valid `Google Play Login Email`";
                }
            }

            if (isset($values['package_name']) && !empty($values['package_name'])) {
                $explodeArray = explode(".", $values['package_name']);
                if (COUNT($explodeArray) != 3) {
                    $formError['package_name'] = 'Please enter the correct App Package Name.';
                }
            }

            if (isset($values['facebook_app_id']) && !empty($values['facebook_app_id'])) {
                $isSocialDNAEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('socialdna');
                if (!empty($isSocialDNAEnabled)) {
                    $values['facebook_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('socialdna.facebook_api_key', null);
                    $values['facebook_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('socialdna.facebook_secret', null);
                } else {
                    $values['facebook_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.facebook.appid', null);
                    $values['facebook_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.facebook.secret', null);
                }

                if (empty($values['facebook_app_id']) || empty($values['facebook_app_secret']))
                    $formError['facebook_app_id'] = 'Facebook Api or Secret not found. Please configure it from "Facebook Settings" page.';
            }else {
                $values['facebook_app_secret'] = $values['facebook_app_id'] = "";
            }

            if (isset($values['twitter_app_id']) && !empty($values['twitter_app_id'])) {
                $values['twitter_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.twitter.key', null);
                $values['twitter_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.twitter.secret', null);

                if (empty($values['twitter_app_id']) || empty($values['twitter_app_secret']))
                    $formError['twitter_app_id'] = 'Twitter Api or Secret not found. Please configure it from "Twitter Settings" page.';
            }else {
                $values['twitter_app_id'] = $values['twitter_app_secret'] = "";
            }

            $isSocialLoginEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelogin');
            if ($isSocialLoginEnabled) {
                if (isset($values['google_app_id']) && !empty($values['google_app_id'])) {
                    
                    $values['google_app_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitelogin.google.clientId', null);
                    $values['google_app_secret'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitelogin.google.clientSecret', null);

                    $values['google_login_client_id'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitelogin.google.loginClientId', null);

                    if (empty($values['google_app_id']) || empty($values['google_app_secret']))
                        $formError['google_app_id'] = 'Google Client Id or Secret not found. Please configure it from "Social Integrations" page of Social Login and Signup Plugin.';
                } else {
                    $values['google_app_secret'] = $values['google_app_id']  = $values['google_login_client_id'] = "";
                }
            } else {
                $values['google_app_secret'] = $values['google_app_id']  = $values['google_login_client_id'] = "";
            }

            $this->createAPPBuilderDefaultDirectory();
            if (!empty($package))
                $values['package'] = $package;

            if (!empty($clientId))
                $values['clientId'] = $clientId;

            if (!empty($clientEmail))
                $values['email'] = $clientEmail;

            $getHost = (isset($values['siteapi_validate_ssl']) && !empty($values['siteapi_validate_ssl'])) ? 'https://' . $_SERVER['HTTP_HOST'] : 'http://' . $_SERVER['HTTP_HOST'];
            $siteHost = $this->view->url(array(), 'home', false);
            $values['api_calling_url'] = $getHost . $siteHost . 'api/rest/';
            $splashImagesType = isset($values['welcome_image_type']) ? $values['welcome_image_type'] : 1;

            // Validate consumer key
            $consumerTable = Engine_Api::_()->getDbtable('consumers', 'siteapi');
            $select = $consumerTable->getSelect(array('key' => $values['api_consumer_key'], 'secret' => $values['api_consumer_secret']));
            $getRow = $consumerTable->fetchRow($select);
            if (empty($getRow))
                $formError['api_key'] = 'Please enter correct `API Consumer Key` and `API Consumer Secret`.';

            if (!empty($formError) && $enabledTab == 1) {
                $this->view->formError = $formError;
                return $form->addErrors($formError);
            }

            if ($enabledTab == 1 && isset($values['enable_primemessenger']) && !empty($values['enable_primemessenger'])) {
                if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('primemessenger'))
                    $values['enable_primemessenger'] = 0;

                $validateMessengerSubscription = $this->validateMessengerSubscription();
                if (empty($validateMessengerSubscription))
                    $values['enable_primemessenger'] = 0;
            }

            //Start Primemessenger Code
            if ($enabledTab == 1 && isset($values['enable_primemessenger']) && !empty($values['enable_primemessenger'])) {
                $channelizeVersion = $values['channelize_version'];
                $messengerDetails = $this->savePrimemessengerFiles($channelizeVersion);
                if (!empty($messengerDetails) && is_array($messengerDetails)) {
                    $values = array_merge($values, $messengerDetails);
                }
            }

            //End Primemessenger Work
            //Calculate no of Slideshow Images Uploaded
            $slideshowCount = 0;
            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Big_Images_Tablet 720 x 1280/first.png') && @file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Small_Images_Mobile 480 x 800/first.png')) {
                $slideshowCount++;
                $values['slideshow_1'] = 1;
            }
            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Big_Images_Tablet 720 x 1280/second.png') && @file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Small_Images_Mobile 480 x 800/second.png')) {
                $slideshowCount++;
                $values['slideshow_2'] = 1;
            }
            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Big_Images_Tablet 720 x 1280/third.png') && @file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Slideshow_Images/Small_Images_Mobile 480 x 800/third.png')) {
                $slideshowCount++;
                $values['slideshow_3'] = 1;
            }
            $values['slideshowCount'] = $slideshowCount;
            //Calculate no of Slideshow Images Uploaded work ends
            //for Deep linking
            $deepLinkingDomain = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
            $baseParentUrl = Zend_Controller_Front::getInstance()->getBaseUrl();
            $baseParentUrl = @trim($baseParentUrl, "/");
            $values['deepLinkingDomain'] = $deepLinkingDomain;
            $values['deepLinkingSubDomain'] = $baseParentUrl ? $baseParentUrl:'';

            try {
                // Set the values in settings file.
                if ((is_file($getAPPBuilderSettingsFilePath) && is_writable($getAPPBuilderSettingsFilePath)) ||
                        (is_dir(dirname($getAPPBuilderSettingsFilePath)) && is_writable(dirname($getAPPBuilderSettingsFilePath)))) {
                    if (!empty($values)) {
                        $file_contents = "<?php ";
                        $file_contents .= '$appBuilderParams = ';
                        $file_contents .= var_export($values, true);
                        $file_contents .= " ?>";
                        @file_put_contents($getAPPBuilderSettingsFilePath, $file_contents);
                        $successMessage = 'Your changes have been saved successfully. Now please download the "tar file" and follow the given instructions, to get started with your APP creation.';
                    }
                } else {
                    return $form->addError('Unable to configure this setting due to the file ' . $getAPPBuilderSettingsFilePath . ' not having the correct permissions. Please CHMOD (change the permissions of) that file to 666, then try again.');
                }

                if (isset($imageUploadProcess) && !empty($imageUploadProcess)) {
                    $errors = $this->uploadMainImageBeforeQuick($splashImagesType, $subTab);
                    if (empty($errors)) {
                        $errors = $this->uploadImageQuick($splashImagesType, $subTab);
                        unset($_FILES);
                    } else {
                        // Display errors
                        if ($enabledTab == 2) {
                            $this->view->formError = $errors;
                            return $form->addErrors($errors);
                        }
                        return;
                    }
                }

                $slideshowType = $appBuilderParams['slide_show_type'];

                // Upload the selected image
                foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
                    // If image not uploaded by siteadministrator then check, is that image already uploaded? IF not then through error message.
                    if (empty($_FILES[$key]["tmp_name"])) {
                        if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif')) {
                                continue;
                            }
                        } else {
                            if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png'))
                                continue;
                        }
                        $continueOrShowError = $this->getImageError($enabledTab, $subTab, $key, $slideshowType);
                        if (empty($continueOrShowError))
                            continue;

                        $errors[$key] = $values['title'] . ': Image not found.';
                        continue;
                    }

                    // In case: IF image uploaded by siteadministrator.
                    if (isset($_FILES[$key]) && !empty($_FILES[$key]) && $_FILES[$key]["tmp_name"]) {
                        // Validate: file type
                        $check = @getimagesize($_FILES[$key]["tmp_name"]);
                        if ($check === false) {
                            $errors[$key] = $values['title'] . ': File is not an image.';
                            continue;
                        }

                        // Validate: image extension
                        $target_file = @basename($_FILES[$key]["name"]);
                        $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);

                        //GIF Images Work Start
                        if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                            if ($imageFileType != "gif") {
                                $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                                continue;
                            }
                        } else {
                            if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                                $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                                continue;
                            } else if ($imageFileType != "png") {
                                $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                                continue;
                            }
                        }

                        //GIF Images Work End
                        // Validate: image width and height
                        if (($check[0] !== $values['width']) && ($check[1] !== $values['height'])) {
                            $errors[$key] = $values['title'] . ': Please upload ' . $values['width'] . ' x ' . $values['height'] . ' pixels image.';
                            continue;
                        }

                        // Validate file size
                        // 1MB => 1000000BYTES
                        if ($_FILES[$key]["size"] > 1000000) {
                            $errors[$key] = $values['title'] . ': The uploaded file size has been increased, please upload the image(s) less then 1MB';
                            continue;
                        }

                        // Validate: authrization permission
                        $isImageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType);
                        if (empty($isImageUpload)) {
                            $errors[$key] = $values['title'] . ': Not able to upload image. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                            continue;
                        }
                    }
                }

                // Details for language File to be uploaded
                $getLanguagesFiles = $this->_getAPPLanguageDetailsForUpload();

                // Upload the selected language file
                foreach ($getLanguagesFiles as $key => $values) {

                    // In case: IF language file is uploaded by siteadministrator.
                    if (isset($_FILES[$key]["tmp_name"]) && !empty($_FILES[$key]["tmp_name"])) {

                        // Validate: language file extension
                        $target_file = @basename($_FILES[$key]["name"]);
                        $languageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);

                        $isLanguageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $languageFileType);

                        if (empty($isLanguageUpload)) {
                            $errors[$key] = $values['title'] . ': Not able to upload language file. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                            continue;
                        }
                    }
                }
            } catch (Exception $ex) {
                throw $ex;
            }

            // Display errors
            if (!empty($errors)) {
                if ($enabledTab == 2 || $enabledTab == 3) {
                    $this->view->formError = $errors;
                    return $form->addErrors($errors);
                }

                return;
            } else if ($enabledTab == 5 && isset($subTab) && !empty($subTab) && $subTab == 1) {
                $this->_helper->redirector->gotoRoute(array('tab' => $enabledTab, 'subTab' => ++$subTab));
                return;
            } else if ($enabledTab == 2 && isset($subTab) && !empty($subTab) && ($subTab == 1 || $subTab == 2)) {
                $this->_helper->redirector->gotoRoute(array('tab' => $enabledTab, 'subTab' => ++$subTab));
                return;
            } else if ($enabledTab == 2 && isset($subTab) && !empty($subTab) && ($subTab == 3)) {
                $this->_helper->redirector->gotoRoute(array('tab' => $enabledTab + 2));
                return;
            } else if ($enabledTab < 6) {
                $this->_helper->redirector->gotoRoute(array('tab' => ++$enabledTab));
                return;
            } else if ($enabledTab == 7) {
                $this->_helper->redirector->gotoRoute(array('tab' => 6));
                return;
            }
        }

        if (!empty($successMessage))
            $form->addNotice($successMessage);
    }

    public function downloadAction() {
        $this->view->package = $this->_getParam('package', false);
        $this->view->clientId = $this->_getParam('clientId', false);
        $this->view->email = $this->_getParam('email', false);

        if (!$_POST)
            return;

        $this->view->redirectToCreateForm = true;
    }

    public function downloadTarAction() {
        if (!class_exists('DOMDocument', false))
            return $form->addError('Bad PHP version.');

        $createZipSuccessfully = $this->createZip(APPLICATION_PATH . '/public/' . $this->_directoryName . '/');

        if (!empty($createZipSuccessfully)) {
            $path = $tarFilePath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                    . 'public' . DIRECTORY_SEPARATOR
                    . $this->_getAPPBuilderTarFileName;

            if (file_exists($path) && is_file($path)) {
                // Kill zend's ob
                while (ob_get_level() > 0) {
                    ob_end_clean();
                }

                $this->_tarFileSize = filesize($path);
                $this->_tarFileSize = $this->_formatBytes($this->_tarFileSize);
                $this->_tarFileSize = (int) @ceil($this->_tarFileSize);

                header("Content-Disposition: attachment; filename=" . urlencode(basename($path)), true);
                header("Content-Transfer-Encoding: Binary", true);
                header("Content-Type: application/force-download", true);
                header("Content-Type: application/octet-stream", true);
                header("Content-Type: application/download", true);
                header("Content-Description: File Transfer", true);
                header("Content-Length: " . filesize($path), true);
                flush();

                $fp = fopen($path, "r");
                while (!feof($fp)) {
                    echo fread($fp, 65536);
                    flush();
                }
                fclose($fp);
            }
            exit();
        }
    }

    /*
     * creates a compressed tar file  
     */
    protected function createZip() {
        $uploadToTar = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR;

        $tarFileParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . 'public' . DIRECTORY_SEPARATOR;

        $tarFilePath = $tarFileParentPath . $this->_getAPPBuilderTarFileName;

        // Create the root directory, If not exist.        
        $is_dir = @is_dir($tarFileParentPath);
        if (empty($is_dir))
            @mkdir($tarFileParentPath);

        @chmod($tarFileParentPath, 0777);
        @chmod($uploadToTar, 0777);
        @chmod($tarFilePath, 0777);

        // Create the archive
        $zip = new Archive_Tar($tarFilePath);

        // Remove uploaded tar file first.
        @unlink($tarFilePath);

        $getArray = APPLICATION_PATH . '/public/' . $this->_directoryName . '/';

        // Add content into tar file.
        $zip->addModify(array($uploadToTar), '', APPLICATION_PATH . '/public/');
        @chmod($tarFilePath, 0777);

        //check to make sure the file exists
        return file_exists($tarFilePath);
    }

    /*
     * End point to validate website authorization.
     */
    protected function validateSubscriptionPlane() {
        $apiURL = 'https://www.socialengineaddons.com/check-subscriptions-endpoint';
        $website = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $tempAdminMenuPost = array(
            'websites' => serialize(
                    array(
                        $website
                    )
            )
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $apiURL);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $tempAdminMenuPost);
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $getCurlResponse = ob_get_contents();
        ob_end_clean();

        if (strstr($getCurlResponse, 'error::'))
            return $getCurlResponse;

        $getCurlResponse = unserialize($getCurlResponse);

        $getResult = $enabledPlan = array();
        if (isset($getCurlResponse[$website])) {
            $getWebsitePlans = $getCurlResponse[$website];
            foreach ($getWebsitePlans as $planObj) {

                if (($planObj->title == 'Mobile Pro Plan') || ($planObj->title == 'Mobile Apps Plan') || ($planObj->title == 'Premium Plan') || ($planObj->title == 'Mobile Apps - Product Support and App Upgrade Support'))
                    $enabledPlan[] = 'pro';

                if ($planObj->title == 'Mobile Starter Plan')
                    $enabledPlan[] = 'starter';


                if (empty($getResult) && (($planObj->title == 'Mobile Pro Plan') || ($planObj->title == 'Mobile Apps - Product Support and App Upgrade Support') || ($planObj->title == 'Mobile Apps Plan') || ($planObj->title == 'Premium Plan') || ($planObj->title == 'Mobile Starter Plan'))) {
                    $getResult['clientId'] = $planObj->uid;
                    $getResult['email'] = $planObj->mail;
                }
            }

            if (!empty($getResult) && !empty($enabledPlan))
                $getResult['subscriptionPlane'] = $enabledPlan;
        }

        if (!empty($getResult))
            return array($getResult);
        else
            return 'error::There is a problem getting your subscription plan record. Please configure your Mobile Apps Subscription Plan from the <a href="https://www.socialengineaddons.com/page/steps-follow-before-filing-support-ticket-mobile-apps-setup" target="_blank">"Subscriptions / Recurring Fees"</a> section of your SocialApps.tech Client Area. You can log in from here to configure your subscription. If you still have any problems then contact to SocialApps.tech support team.';
    }

    /*
     * Create blank directory in case, if not exist on server.
     */
    protected function createAPPBuilderDefaultDirectory() {
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        if (!@is_dir($getAPPBuilderParentPath))
            @mkdir($getAPPBuilderParentPath);

        @chmod($getAPPBuilderParentPath, 0777);


        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'App_Icons', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Hi-res_Icon')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Hi-res_Icon');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Hi-res_Icon', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 720 x 1280')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 720 x 1280');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Big_Images_Tablet 720 x 1280', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Plain_Slideshow 512 x 512', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 480 x 800')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 480 x 800');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Slideshow_Images' . DIRECTORY_SEPARATOR . 'Small_Images_Mobile 480 x 800', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Portrait')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Portrait');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Splash_Screen_Images' . DIRECTORY_SEPARATOR . 'Portrait', 0777);
        }

        if (!@is_dir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App')) {
            @mkdir($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App');
            @chmod($getAPPBuilderParentPath . DIRECTORY_SEPARATOR . 'Languages_App', 0777);
        }

        // Create settings file.
        $ourFileName = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR . "settings.php";
        if (!is_file($ourFileName)) {
            $ourFileHandle = @fopen($ourFileName, 'w');
            @fclose($ourFileHandle);
            @chmod($ourFileName, 0777);
        }


        return;
    }

    /*
     * Set array to xml
     */
    protected function _setArrayToXML($path, $values) {
        $explodeDefaultXMLToArray = $this->_ExplodeXMLToArray(APPLICATION_PATH . DIRECTORY_SEPARATOR . '/application/modules/Siteandroidapp/settings/defaultstrings.xml');

        $content = '<resources>';
        $flagStringArray = array();
        foreach ($values as $key => $value) {
            // Key's if not exist in newly added "defaultString.xml" file then not include it now.
            if (!array_key_exists($key, $explodeDefaultXMLToArray))
                continue;

            if (!is_array($value)) {
                $flagStringArray[$key] = '<string name="' . $key . '">' . $this->_validateString($value) . '</string>';
            } else {
                $tempPluralStr = '';
                foreach ($value as $tempKey => $tempValue) {
                    $tempPluralStr .= '<item quantity="' . $tempKey . '">' . $this->_validateString($tempValue) . '</item>';
                }
                $tempPluralStr = @trim($tempPluralStr);
                $flagStringArray[$key] = '<plurals name="' . $key . '">' . $tempPluralStr . '</plurals>';
            }
        }

        $content .= @implode("\n", $flagStringArray);
        $content .= '</resources>';

        // Remove unwanted space and blank lines from the string.
        $content = @preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $content);
        $content = str_replace("><", ">\n<", $content);

        if (@file_exists($path)) {
            @chmod($path, 0777);
            if (is_writable($path)) {
                if (!empty($content)) {
                    $fh = fopen($path, 'w') or die("can't open file");
                    @fwrite($fh, $content);
                    @fclose($fh);
                }
            }
        }

        return;
    }

    /*
     * Get default available languages.
     */
    private function _getAPPLanguageDetailsForUpload() {
        $getLanguages = Engine_Api::_()->getApi('Core', 'siteapi')->getLanguages(true);
        if (isset($getLanguages)) {
            $languageArray = array();
            foreach ($getLanguages as $key => $label) {
                $languageArray[$key] = array(
                    'title' => 'Upload Language File For: [' . $label . ']',
                    'directoryName' => 'Languages_App',
                    'fileName' => $key . '_language_android_mobileapp'
                );
            }
        }

        return $languageArray;
    }

    private function _formatBytes($size, $precision = 2) {
        $base = log($size, 1024);
        $suffixes = array('');

        return round(pow(1024, $base - floor($base)), $precision) . $suffixes[floor($base)];
    }

    /*
     * Listed modules should be in latest version
     */
    private function _doWeHaveLatestVersion() {
        $errorInPlugins = array();
        $pluginsArray = array(
            'seaocore' => 'seaddons-core',
            'siteapi' => 'siteapi',
            'siteiosapp' => 'sitemobileiosapp',
            'siteandroidapp' => 'sitemobileandroidapp',
            'advancedactivity' => 'advancedactivity',
            'sitetagcheckin' => 'sitetagcheckin'
        );

        if ($_COOKIE['getMobileDependentModulesList']) {
            $tempValues = unserialize($_COOKIE['getMobileDependentModulesList']);
        } else {
            $rss = Zend_Feed::import('http://www.socialengineaddons.com/plugins/feed');
            $channel = array(
                'title' => $rss->title(),
                'link' => $rss->link(),
                'description' => $rss->description(),
                'items' => array()
            );
            $tempValues = $flagArray = array();
            foreach ($rss as $item) {
                if (in_array($item->ptype(), $pluginsArray)) {
                    $flagArray['productType'] = $item->ptype();
                    $flagArray['availableVersion'] = $item->version();
                    $flagArray['title'] = $item->title();
                    $tempValues[] = $flagArray;
                }
            }

            $cookieData = @serialize($tempValues);
            setcookie("getMobileDependentModulesList", $cookieData, time() + 86400);
        }
        foreach ($tempValues as $values) {
            if (in_array($values['productType'], $pluginsArray)) {
                $flipedArray = array_flip($pluginsArray);
                if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($flipedArray[$values['productType']]))
                    continue;

                $getModVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule($flipedArray[$values['productType']]);
                $isModSupport = $this->_checkVersion($getModVersion->version, $values['availableVersion']);
                if (!empty($isModSupport)) {
                    $errorInPlugins[] = $values['title'];
                }
            }
        }

        return $errorInPlugins;
    }

    /*
     * Calling from _doWeHaveLatestVersion()
     */
    private function _checkVersion($databaseVersion, $checkDependancyVersion) {
        $running_version = $databaseVersion;
        $product_version = $checkDependancyVersion;
        $shouldUpgrade = false;
        if (!empty($running_version) && !empty($product_version)) {
            $temp_running_verion_2 = $temp_product_verion_2 = 0;
            if (strstr($product_version, "p")) {
                $temp_starting_product_version_array = @explode("p", $product_version);
                $temp_product_verion_1 = $temp_starting_product_version_array[0];
                $temp_product_verion_2 = $temp_starting_product_version_array[1];
            } else {
                $temp_product_verion_1 = $product_version;
            }
            $temp_product_verion_1 = @str_replace(".", "", $temp_product_verion_1);


            if (strstr($running_version, "p")) {
                $temp_starting_running_version_array = @explode("p", $running_version);
                $temp_running_verion_1 = $temp_starting_running_version_array[0];
                $temp_running_verion_2 = $temp_starting_running_version_array[1];
            } else {
                $temp_running_verion_1 = $running_version;
            }
            $temp_running_verion_1 = @str_replace(".", "", $temp_running_verion_1);


            if (($temp_running_verion_1 < $temp_product_verion_1) || (($temp_running_verion_1 == $temp_product_verion_1) && ($temp_running_verion_2 < $temp_product_verion_2))) {
                $shouldUpgrade = true;
            }
        }
        return $shouldUpgrade;
    }

    /*
     * Validate strings, while make the .xml file for Android App languages.
     */
    private function _validateString($string) {
        $stringArray = array();
        $tempStr = '';
        $breakString = @str_split($string);
        $restrictedWordArray = array(34, 35, 42, 47, 58, 59, 60, 61, 62, 91, 93, 94, 95, 96, 123, 124, 125, 126, 127);
        foreach ($breakString as $word) {
            // Convert to ASCII
            $getASCIINumber = @ord($word);
            if (!in_array($getASCIINumber, $restrictedWordArray))
                $stringArray[] = $getASCIINumber;
        }

        // Convert ASCII to String
        foreach ($stringArray as $ASCII) {
            $tempStr .= @chr($ASCII);
        }

        $tempStr = str_replace("\'", "'", $tempStr);
        $tempStr = str_replace("'", "\'", $tempStr);

        $tempStr = @htmlspecialchars($tempStr, ENT_QUOTES);
        return trim($tempStr);
    }

    /*
     * Explode existing xml file to array
     */
    private function _ExplodeXMLToArray($path, $getPluralKeys = false) {
        @chmod($path, 0777);
        $xml = @simplexml_load_file($path);

        // Make an array of all singular values.
        foreach ($xml->string as $item)
            $setResponseArray[(string) $item['name']] = (string) $item;

        // Make an array of all plurals values.
        foreach ($xml->plurals as $item) {
            $pluralKeysArray = $pluralItemArray = array();
            foreach ($item->item as $pluralItem) {
                $pluralItemArray[] = (string) $pluralItem;
                if (!empty($getPluralKeys))
                    $pluralKeysArray[] = (string) $pluralItem['quantity'];
            }

            $setResponseArray[(string) $item['name']] = $pluralItemArray;
            if (!empty($getPluralKeys))
                $setResponsePluralKeysArray[(string) $item['name']] = $pluralKeysArray;
        }

        if (empty($getPluralKeys))
            return $setResponseArray;

        return array(
            'values' => $setResponseArray,
            'pluralsKey' => $setResponsePluralKeysArray
        );
    }

    /*
     * Function to convert csv file to Xml File
     */
    private function _modifyExistingLanguageXML($fromFilePath, $destinationPath = null) {
        @chmod($fromFilePath, 0777);
        @chmod($destinationPath, 0777);

        if (@file_exists($fromFilePath)) {
            if (($handle = @fopen($fromFilePath, "r")) !== FALSE) {
                while (($data = fgetcsv($handle, 100000, ";")) !== FALSE) {
                    $count = COUNT($data);

                    // Check for comments, blank line and empty string
                    if (!isset($data[0]) || empty($data[0]) || $count < 2 || $data[0] == '#')
                        continue;

                    if (array_key_exists($data[0], $dataArray) && !in_array($data[0], array(
                                'view_count',
                                'play_count'
                            )))
                        continue;

                    if ($count == 2)
                        $dataArray[$data[0]] = (string) $data[1]; //htmlspecialchars($data[1], ENT_QUOTES);

                    if ($count == 3) {
                        $dataArray[$data[0]] = array(
                            "one" => (string) $data[1], //htmlspecialchars($data[1], ENT_QUOTES),
                            "other" => (string) $data[2] //htmlspecialchars($data[2], ENT_QUOTES)
                        );
                    }

                    if ($count == 4) {
                        $dataArray[$data[0]] = array(
                            "zero" => (string) $data[1], //htmlspecialchars($data[1], ENT_QUOTES),
                            "one" => (string) $data[2], //htmlspecialchars($data[2], ENT_QUOTES),
                            "other" => (string) $data[3] // htmlspecialchars($data[3], ENT_QUOTES)
                        );
                    }
                }
            }

            // Ceate destination file, If not exist.
            if (!file_exists($destinationPath)) {
                @fopen($destinationPath, "w");
                @fclose($myfile);
                @chmod($destinationPath, 0777);
            }

            // Write in newly created xml file.
            if (!empty($dataArray))
                $this->_setArrayToXML($destinationPath, $dataArray);

            @chmod($destinationPath, 0777);
        }

        return;
    }

    protected function _searchArrayRecursive($searchStr, $searchValue) {
        $found = false;
        if (is_array($searchValue)) {
            foreach ($searchValue as $key => $value) {
                if (is_string($value) && stripos($value, $searchStr) !== false) {
                    $found = true;
                    break;
                } else if (is_array($value)) {
                    if ($this->_searchArrayRecursive($searchStr, $value)) {
                        $found = true;
                        break;
                    }
                }
            }
        }

        return $found;
    }

    public function savePrimemessengerFiles($channelizeVersion = 0) {
        $apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey', '');
        $messengerDetails = array();
        
        if(empty($channelizeVersion))
            $apiURL = 'https://api.channelize.io/v1/settings';
        else
            $apiURL = 'https://api.channelize.io/v2/settings';
        $website = str_replace('www.', '', $apiURL);
        $auth = 'Basic ' . base64_encode($apiKey);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $website);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "authorization: $auth",
        ));
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $getCurlResponse = ob_get_contents();
        ob_end_clean();
        $getCurlArray = Zend_Json_Decoder::decode($getCurlResponse);

        if (empty($getCurlResponse) || strstr($getCurlResponse, 'error::'))
            return;

        //Save Setting File
        if (isset($getCurlArray['pushNotificationSettings']['firebase']['androidConfigFileUrl']) && !empty($getCurlArray['pushNotificationSettings']['firebase']['androidConfigFileUrl'])) {
            $temp_doc_file = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Primemessenger';
            //$content = file_get_contents($getCurlArray['pushNotificationSettings']['androidConfigFileUrl']);
             $content = $this->getPrimemessengerContent($getCurlArray['pushNotificationSettings']['firebase']['androidConfigFileUrl']);
            if (isset($content) && !empty($content)) {
                if (!is_dir($temp_doc_file))
                    mkdir($temp_doc_file, 0777, true);

                $fileName = $temp_doc_file . '/' . 'google-services.json';
                file_put_contents($fileName, $content);
            }
        }

        //Save Language Files
        if (isset($getCurlArray['languages']) && !empty($getCurlArray['languages'])) {
            foreach ($getCurlArray['languages'] as $files) {
                if (isset($files['filePaths']['android']) && !empty($files['filePaths']['android'])) {
                    $temp_doc_file = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . 'Primemessenger/Languages_App';
                    if (!is_dir($temp_doc_file)) {
                        mkdir($temp_doc_file, 0777, true);
                    }
                    //$content = file_get_contents($files['filePaths']['android']);
                    $content = $this->getPrimemessengerContent($files['filePaths']['android']);
                    if (isset($content) && !empty($content)) {
                        $fileName = $temp_doc_file . '/' . $files['code'] . '_language_android_mobileapp.xml';
                        file_put_contents($fileName, $content);
                    }
                }
            }
        }

        if (isset($getCurlArray['apiUrl']) && !empty($getCurlArray['apiUrl'])) {
            $messengerDetails['apiUrl'] = $getCurlArray['apiUrl'];
        }

        if (isset($getCurlArray['mqttUrl']) && !empty($getCurlArray['mqttUrl'])) {
            $messengerDetails['mqttUrl'] = $getCurlArray['mqttUrl'];
        }

        $apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey', '');
        if (isset($apiKey) && !empty($apiKey)) {
            $messengerDetails['apiKey'] = $apiKey;
        }

        return $messengerDetails;
        
    }

    public function uploadMainImageBeforeQuick($splashImagesType, $tab) {
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
            if (!in_array($key, $this->_displayquickImages1) && $tab == 2)
                continue;

            if (!in_array($key, $this->_displayquickImages2) && $tab == 3)
                continue;

            if (isset($_FILES[$key]["tmp_name"]) && !empty($_FILES[$key]["tmp_name"])) {

                // Validate: file type
                $check = @getimagesize($_FILES[$key]["tmp_name"]);
                if ($check === false) {
                    $errors[$key] = $values['title'] . ': File is not an image.';
                    continue;
                }

                // Validate: image extension
                $target_file = @basename($_FILES[$key]["name"]);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                //GIF Images Work Start
                if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                    if ($imageFileType != "gif") {
                        $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                        continue;
                    }
                } else {
                    if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                        continue;
                    } else if ($imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                        continue;
                    }
                }
                //GIF Images Work End
                // Validate: image width and height
                if (($check[0] !== $values['width']) && ($check[1] !== $values['height'])) {
                    $errors[$key] = $values['title'] . ': Please upload ' . $values['width'] . ' x ' . $values['height'] . ' pixels image.';
                    continue;
                }

                // Validate file size
                // 1MB => 1000000BYTES
                if ($_FILES[$key]["size"] > 1000000) {
                    $errors[$key] = $values['title'] . ': The uploaded file size has been increased, please upload the image(s) less then 1MB';
                    continue;
                }
                $location = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType;
                // Validate: authrization permission
                $isImageUpload = @move_uploaded_file($_FILES[$key]["tmp_name"], APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType);
                if (empty($isImageUpload)) {
                    $errors[] = $values['title'] . ': Not able to upload image. Please give 777 permission to /public/' . $this->_directoryName . ' directory.';
                }
                @chmod($location, 0777);
            }
        }

        return $errors;
    }

    public function uploadImageQuick($splashImagesType, $tab) {
        foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
            $imageToBeCreatedTo = $key;

            if ($tab == 2)
                $imageToBeCreatedFrom = $key = $this->getMatchingImageTabTwo($key);
            else if ($tab == 3)
                $imageToBeCreatedFrom = $key = $this->getMatchingImageTabThree($key);

            $values = $this->_getAPPImageDetailsForUpload[$key];

            if (empty($imageToBeCreatedFrom))
                continue;
            $imageUploaded = 0;
            if (in_array($imageToBeCreatedFrom, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif')) {
                    $imageUploaded = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.gif';
                }
            } else {
                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png'))
                    $imageUploaded = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.png';
            }
            if (isset($imageUploaded) && !empty($imageUploaded)) {
                @chmod($imageUploaded, 0777);
                // Validate: file type
                $check = @getimagesize($imageUploaded);
                if ($check === false) {
                    $errors[] = $values['title'] . ': File is not an image.';
                    continue;
                }

                // Validate: image extension
                $target_file = @basename($imageUploaded);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                //GIF Images Work Start
                if (in_array($key, $this->_dynamicImages) && isset($splashImagesType) && empty($splashImagesType)) {
                    if ($imageFileType != "gif") {
                        $errors[$key] = $values['title'] . ': You have selected GIF image type for splash screen, so please choose GIF files.';
                        continue;
                    }
                } else {
                    if (in_array($key, $this->_dynamicImages) && $imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': You have selected PNG image type for splash screen, so please choose PNG files.';
                        continue;
                    } else if ($imageFileType != "png") {
                        $errors[$key] = $values['title'] . ': Sorry, only PNG files are allowed.';
                        continue;
                    }
                }

                $imagetoBeCreatedWidth = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo]['width'];
                $imagetoBeCreatedHeight = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo]['height'];
                $imagetoBeCreated = $this->_getAPPImageDetailsForUpload[$imageToBeCreatedTo];
                $this->uploadQuickImage($imageUploaded, $imagetoBeCreated, $imagetoBeCreatedWidth, $imagetoBeCreatedHeight, $imageFileType);
            }
        }
        return $errors;
    }

    public function getMatchingImageTabTwo($key) {
        $value = '';
        switch ($key) {
            case 'app_icon_2':
            case 'app_icon_3':
            case 'app_icon_4':
            case 'app_icon_5':
                $value = 'hi_res_icon';
                break;
        }
        return $value;
    }

    public function getMatchingImageTabThree($key) {
        $value = '';
        switch ($key) {
            case 'slideshow_slide_image_1_1':
                $value = 'slideshow_slide_image_1_2';
                break;
            case 'slideshow_slide_image_2_1':
                $value = 'slideshow_slide_image_2_2';
                break;
            case 'slideshow_slide_image_3_1':
                $value = 'slideshow_slide_image_3_2';
                break;
        }
        return $value;
    }

    public function uploadQuickImage($fromDestination, $values, $imagetoBeCreatedWidth, $imagetoBeCreatedHeight, $imageFileType) {

        $tempfromLocation = APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . '.' . $imageFileType;

        $image = Engine_Image::factory();
        $image->open($fromDestination);

        $width = $image->width;
        $height = $image->height;

        $newwidth = $values['width'];
        $newHeight = $values['height'];
        if ($width != $newwidth || $height != $newHeight) {
            $image->resize($newwidth, $newHeight)
                    ->write($tempfromLocation)
                    ->destroy();
        }
        if (!is_file($tempfromLocation)) {
            echo 'error::There are no source (' . $tempfromLocation . ') file available.';
            die;
        }

        @chmod($tempfromLocation, 0777);
    }

    public function getFormFields($currentTab) {
        $getAPPBuilderParentPath = APPLICATION_PATH . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderBaseURL;

        $getAPPBuilderSettingsFilePath = $getAPPBuilderParentPath . DIRECTORY_SEPARATOR
                . $this->_getAPPBuilderSettingsFileName;

        if (@file_exists($getAPPBuilderSettingsFilePath))
            include $getAPPBuilderSettingsFilePath;

        $this->_tabTwoError = 0;
        $this->_tabOneError = 0;
        $tabOne = array(
            'package_name',
            'firebase_google_services',
            'title',
            'short_description',
            'description',
            'default_language',
            'category',
            'content_rating',
            'website_contact_details',
            'email_contact_details',
            'policy_url',
            'api_consumer_key',
            'api_consumer_secret',
            'enabledModules',
        );

        if (isset($appBuilderParams['publish_app']) && !empty($appBuilderParams['publish_app'])) {
            if (isset($appBuilderParams['provide_google_play_account_details']) && !empty($appBuilderParams['provide_google_play_account_details'])) {
                $requireFieldsPro = array(
                    'google_play_login_email',
                    'google_play_login_password',
                );
                $tabOne = array_merge($requireFieldsPro, $tabOne);
            } else {
                $requireFieldsPro = array(
                    'gmail_permission_done',
                );
                $tabOne = array_merge($requireFieldsPro, $tabOne);
            }
        }

        if (isset($appBuilderParams['slide_show_type']) && !empty($appBuilderParams['slide_show_type'])) {
            $this->_requiredFormImages = array_diff($this->_requiredFormImages, array('slideshow_slide_plain_image_1_1', 'slideshow_slide_plain_image_1_2', 'slideshow_slide_plain_image_1_3', 'slideshow_slide_plain_image_1_4', 'slideshow_slide_plain_image_1_5', 'slideshow_slide_plain_image_1_6', 'slideshow_slide_plain_image_1_7'));
        } else {
            $this->_requiredFormImages = array_diff($this->_requiredFormImages, array('slideshow_slide_image_1_1'));
        }

        $tabTwo = array(
            'slideshow_slide_1_title',
            'slideshow_slide_1_description',
            'app_header_color_primary',
            'app_header_color_dark',
            'app_header_text_color',
            'app_header_color_accent',
            'app_button_color',
            'font'
        );
        
        
        //If slid show type is one 
            if (!empty($appBuilderParams['slide_show_type'])) {
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_1']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_2']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_3']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_4']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_5']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_6']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_plain_image_1_7']);
            }
            elseif(isset($appBuilderParams['slide_show_type'])){
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_1']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_2']);
                unset($this->_getAPPImageDetailsForUpload['slideshow_slide_image_1_3']);
            }


        if ($currentTab >= 1) {
            foreach ($tabOne as $param) {
                if ($param == 'firebase_google_services') {
                    if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . '/' . 'google-services.json')) {
                        if (!isset($this->_tabOneError) || empty($this->_tabOneError))
                            $this->_tabOneError = 0;
                    } else {
                        $this->_tabOneError = 1;
                        $this->_subTabError[] = $this->getExactTabError($param);
                    }
                } else if (!isset($appBuilderParams[$param]) || empty($appBuilderParams[$param])) {
                    $this->_tabOneError = 1;
                    $this->_subTabError[] = $this->getExactTabError($param);
                }
            }
        }

        if ($currentTab >= 2) {
            // Set description for uploaded images.
            foreach ($this->_getAPPImageDetailsForUpload as $key => $values) {
                $imageType = '.png';
                if (in_array($key, $this->_dynamicImages) && isset($appBuilderParams['welcome_image_type']) && empty($appBuilderParams['welcome_image_type']))
                    $imageType = '.gif';

                if (@file_exists(APPLICATION_PATH . DIRECTORY_SEPARATOR . $this->_getAPPBuilderBaseURL . DIRECTORY_SEPARATOR . $values['directoryName'] . '/' . $values['fileName'] . $imageType)) {
                    if (!isset($this->_tabTwoError) || empty($this->_tabTwoError))
                        $this->_tabTwoError = 0;
                } else if (in_array($key, $this->_requiredFormImages)) {
                    if(($this->getExactTabError($key) == 'slideshow_four_plain_slide') || ($this->getExactTabError($key) == 'slideshow_five_plain_slide') || ($this->getExactTabError($key) == 'slideshow_six_plain_slide') || ($this->getExactTabError($key) == 'slideshow_seven_plain_slide') ){
                        $this->_tabTwoError = 0;
                        
                    }
                    else{
                        $this->_tabTwoError = 1;
                        $this->_subTabError[] = $this->getExactTabError($key);
                    }
                }
            }
            foreach ($tabTwo as $param) {
                if (!isset($appBuilderParams[$param])) {
                    $this->_tabTwoError = 1;
                    break;
                }
            }
        }
        $this->view->tabOneErrorDisplay = $this->_tabOneError;
        $this->view->tabTwoErrorDisplay = $this->_tabTwoError;
        $this->view->subTabError = $this->_subTabError;
    }

    public function getExactTabError($param) {
        foreach ($this->_formFields as $tab => $keys) {
            if (in_array($param, $keys)) {
                return $tab;
            }
        }
        return 0;
    }

    public function packageurlvalidationAction() {
        $package_url = $this->_getParam('package_name');
        $response = Engine_Api::_()->getApi('core', 'siteandroidapp')->getPackageNameFile(0, $package_url);
        echo $response;
        exit();
    }

    public function getImageError($enabledTab, $subTab = 0, $key, $slideshowType) {
        if (($enabledTab != 2))
            return 0;

        if (($enabledTab != 2 || $subTab != 2) && (in_array($key, array('app_icon_2', 'app_icon_3', 'app_icon_4', 'app_icon_5', 'notification_icon', 'notification_icon_large', 'hi_res_icon', 'feature_graphics', 'splash_portrait_1', 'splash_portrait_2', 'splash_portrait_3', 'splash_portrait_4'))))
            return 0;

        if (isset($slideshowType) && !empty($slideshowType)) {
            if ((($enabledTab != 2) || ($subTab != 3)) && (in_array($key, array('slideshow_slide_image_1_1', 'slideshow_slide_image_1_2'))))
                return 0;

            if (in_array($key, array('slideshow_slide_image_2_1', 'slideshow_slide_image_2_2', 'slideshow_slide_image_3_1', 'slideshow_slide_image_3_2', 'comet_chat_icon')))
                return 0;
            if (in_array($key, array('slideshow_slide_plain_image_1_1', 'slideshow_slide_plain_image_1_2', 'slideshow_slide_plain_image_1_3', 'slideshow_slide_plain_image_1_4', 'slideshow_slide_plain_image_1_5', 'slideshow_slide_plain_image_1_6', 'slideshow_slide_plain_image_1_7', 'comet_chat_icon')))
                return 0;
        }
        else {
            if ((($enabledTab != 2) || ($subTab != 3)) && (in_array($key, array('slideshow_slide_plain_image_1_1'))))
                return 0;

            if (in_array($key, array('slideshow_slide_plain_image_1_2', 'slideshow_slide_plain_image_1_3', 'slideshow_slide_plain_image_1_4', 'slideshow_slide_plain_image_1_5', 'slideshow_slide_plain_image_1_6', 'slideshow_slide_plain_image_1_7', 'comet_chat_icon')))
                return 0;

            if (in_array($key, array('slideshow_slide_image_1_1', 'slideshow_slide_image_1_2', 'slideshow_slide_image_2_1', 'slideshow_slide_image_2_2', 'slideshow_slide_image_3_1', 'slideshow_slide_image_3_2', 'comet_chat_icon')))
                return 0;
        }

        return 1;
    }

    protected function validateMessengerSubscription() {
        $apiURL = 'http://channelize.io/rest/V1/api/hasMobileApps';
        $website = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));

        $apiKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('primemessenger.apikey', '');

        if (empty($apiKey))
            return false;

        $tempAdminMenuPost = array(
            'key' => base64_encode($apiKey)
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $apiURL);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $tempAdminMenuPost);
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $getCurlResponse = ob_get_contents();
        ob_end_clean();

        if (strstr($getCurlResponse, 'error::'))
            return false;

        return $getCurlResponse;
    }
    
    public function getPrimemessengerContent($apiUrl =null, $apiKey=null)
    {
       if(empty($apiUrl))
           return ;
        $website = $apiUrl;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $website);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    
        ob_start();
        curl_exec($ch);
        curl_close($ch);
        $content = ob_get_contents();
        ob_end_clean();
        return $content;
    }

}
