<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteandroidapp
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2015-10-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteandroidapp_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */

        if (!empty($method) && $method == 'Siteandroidapp_Form_Admin_Settings') {
            
        }
        return true;
    }

    public function indexAction() {
        $urlMismatch = $this->_checkAPIUrl();
        $this->view->urlMisMatchError = 0;

        if (empty($urlMismatch))
            $this->view->urlMisMatchError = 1;

        if (isset($_POST['browse_as_guest'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.browse.guest', $_POST['browse_as_guest']);
        }

        if (isset($_POST['siteandroidapp_sound_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.sound.enable', $_POST['siteandroidapp_sound_enable']);
        }


        if (isset($_POST['android_member_view'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('android.member.view', $_POST['android_member_view']);
        }

        if (isset($_POST['siteandroidapp_version_upgrade'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.version.upgrade', $_POST['siteandroidapp_version_upgrade']);
        }

        if (isset($_POST['android_popup_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('android.popup.enable', $_POST['android_popup_enable']);
        }

        if (isset($_POST['siteandroidapp_version_description'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.version.description', $_POST['siteandroidapp_version_description']);
        }
        if (isset($_POST['siteandroidapp_force_upgrade'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.force.upgrade', $_POST['siteandroidapp_force_upgrade']);
        }

        if (isset($_POST['siteandroid_autodetect_enable'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroid.autodetect.enable', $_POST['siteandroid_autodetect_enable']);
        }

        if (isset($_POST['siteandroid_change_location'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroid.change.location', $_POST['siteandroid_change_location']);
        }

        if (isset($_POST['siteandroidapp_video_quality'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.video.quality', $_POST['siteandroidapp_video_quality']);
        }

        if (isset($_POST['app_tour'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.app.tour', $_POST['app_tour']);
        }

        if (isset($_POST['siteandroidapp_video_quality'])) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroidapp.video.quality', $_POST['siteandroidapp_video_quality']);
        }

        if (isset($_POST['android_enable_location'])) {
            $defaultValue = !empty($_POST['android_enable_location']) ? true : false;
            $db = Engine_Db_Table::getDefaultAdapter();
            $select = new Zend_Db_Select($db);
            $isLanguageRowExist = $select->from('engine4_siteandroidapp_menus')
                    ->where('name = ?', "seaocore_location")
                    ->limit(1)
                    ->query()
                    ->fetchColumn();
            if (!empty($isLanguageRowExist))
                $db->query("UPDATE `engine4_siteandroidapp_menus` SET `status` = '" . $defaultValue . "' WHERE `engine4_siteandroidapp_menus`.`name` = 'seaocore_location' LIMIT 1 ;");
        }

        if (isset($_POST['siteapi_test_device_id_android']) && ($_POST['siteapi_test_device_id_android'] != Engine_Api::_()->getApi('settings', 'core')->getSetting('siteapi.test.device.id.android', false))) {
            $this->clearLogs();
        }
        if (empty($_POST['siteapi_app_mode_android'])) {
            $this->clearLogs();
        }

        include_once APPLICATION_PATH . '/application/modules/Siteandroidapp/controllers/license/license1.php';
    }

    public function faqAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_faq');
    }

    public function readmeAction() {
        
    }

    /*
     * Delete the old exist android app from app dashboard.
     */

    public function deleteExistingAppAction() {
        $this->_helper->layout->setLayout('admin-simple');

        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getApi('core', 'siteandroidapp')->validatePreviousMobileAPP();

            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted Successfully!'))
            ));
        }
    }

    /*
     * Error Page Layout Function.
     */

    public function errorPageAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_error_page');
        $this->view->form = $form = new Siteandroidapp_Form_Admin_Error();
        $formValues = Engine_Api::_()->getApi('settings', 'core')->getSetting("siteandroidapp_error_params");
        $values = @unserialize($formValues);
        if (!empty($values))
            $form->populate($values);

        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            unset($values['submit']);

            if (isset($_FILES['siteandroidapp_error_image']["tmp_name"]) && !empty($_FILES['siteandroidapp_error_image']["tmp_name"])) {
                $target_file = @basename($_FILES['siteandroidapp_error_image']["name"]);
                $imageFileType = @pathinfo($target_file, PATHINFO_EXTENSION);
                $fileName = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'admin/public/' . 'siteandroidapp_error_image.' . $imageFileType;
                $isFileUpload = move_uploaded_file($_FILES['siteandroidapp_error_image']["tmp_name"], $fileName);
                @chmod($fileName, 0777);

                if ($isFileUpload) {
                    $values['siteandroidapp_error_image'] = $fileName;
                }
            }

            $value = @serialize($values);
            Engine_Api::_()->getApi('settings', 'core')->setSetting("siteandroidapp_error_params", $value);
            return $this->_helper->redirector->gotoRoute(array('action' => 'error-page'));
        }
    }

    /*
     * Location  Layout Function.
     */

    public function mapLocationAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteandroidapp_admin_main', array(), 'siteandroidapp_admin_map_location');
        $this->view->form = $form = new Siteandroidapp_Form_Admin_Maplocation();

        $formValues = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteandroid.maplocation', 'sitemember');
        $values = @unserialize($formValues);
        if (!empty($values))
            $form->populate($values);

        if ($this->getRequest()->isPost()) {
            unset($values['submit']);
            $enableModule['siteandroid_maplocation'] = $_POST['siteandroid_maplocation'];
            $enableModule = @serialize($enableModule);
            Engine_Api::_()->getApi('settings', 'core')->setSetting("siteandroid.maplocation", $enableModule);

            if (isset($_POST['siteandroid_autodetect_enable'])) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroid.autodetect.enable', $_POST['siteandroid_autodetect_enable']);
            }

            if (isset($_POST['siteandroid_change_location'])) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('siteandroid.change.location', $_POST['siteandroid_change_location']);
            }

            if (isset($_POST['android_enable_location'])) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('android.enable.location', $_POST['android_enable_location']);
            }

            if (isset($_POST['android_enable_location'])) {
                $defaultValue = !empty($_POST['android_enable_location']) ? true : false;
                $db = Engine_Db_Table::getDefaultAdapter();
                $select = new Zend_Db_Select($db);
                $isLanguageRowExist = $select->from('engine4_siteandroidapp_menus')
                        ->where('name = ?', "seaocore_location")
                        ->limit(1)
                        ->query()
                        ->fetchColumn();
                if (!empty($isLanguageRowExist))
                    $db->query("UPDATE `engine4_siteandroidapp_menus` SET `status` = '" . $defaultValue . "' WHERE `engine4_siteandroidapp_menus`.`name` = 'seaocore_location' LIMIT 1 ;");
            }

            $form->addNotice('Your changes have been saved.');
            return $this->_helper->redirector->gotoRoute(array('action' => 'map-location'));
        }
    }

    public function clearLogs() {
        $filepath = APPLICATION_PATH_TMP . DS . 'log' . DS . 'Seao-Android.log';
        if (($fh = fopen($filepath, 'w'))) {
            ftruncate($fh, 0);
            fclose($fh);
        }
        return true;
    }

    private function _checkAPIUrl() {
        $getHost = $_SERVER['HTTP_HOST'];
        $getHost = str_replace('www.', '', $getHost);
        $getHost = str_replace(".", "-", $getHost);
        $parentDirectoryPath = 'public/android-' . $getHost . '-app-builder';
        $coreDirectoryPath = APPLICATION_PATH . '/' . $parentDirectoryPath;

        if (!is_dir($coreDirectoryPath))
            return 1;

        include $coreDirectoryPath . '/settings.php';

        if (empty($appBuilderParams))
            return 1;

        $getHost = (isset($appBuilderParams['siteapi_validate_ssl']) && !empty($appBuilderParams['siteapi_validate_ssl'])) ? 'https://' . $_SERVER['HTTP_HOST'] : 'http://' . $_SERVER['HTTP_HOST'];
        $siteHost = $this->view->url(array(), 'home', false);
        $currentUrl = $getHost . $siteHost . 'api/rest/';

        if (empty(strcmp($currentUrl, $appBuilderParams['api_calling_url'])))
            return 1;

        return 0;
    }

}
