<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteautoaction
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Global.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteautoaction_Form_Admin_Settings_Global extends Engine_Form {

    public function init() {
        $this
            ->setTitle('Global Settings')
            ->setDescription('These are the common settings that will affect all the auto actions created on your site.');

//        $this->addElement('MultiCheckbox', 'siteautoaction_apply', array(
//            'label' => 'User Type',
//            'description' => 'Select user types for which you want to perform auto actions.',
//            'multiOptions' => array(
//                'new' => 'New Signups',
//                'existing' => 'Existing Users',
//            ),
//            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteautoaction.apply'),
//            'required' => true,
//        ));

        $multiOptions = Engine_Api::_()->siteautoaction()
            ->getResourceTypes(Engine_Api::_()->getApi('search', 'core')->getAvailableTypes());
        $indexCompleted = array_search('ITEM_TYPE_FORUM_POST', $multiOptions);
        unset($multiOptions[$indexCompleted]);
        $indexCompleted = array_search('ITEM_TYPE_FORUM_TOPIC', $multiOptions);
        unset($multiOptions[$indexCompleted]);
        if (!empty($multiOptions)) {
            $this->addElement('MultiCheckbox', 'siteautoaction_resource', array(
                'label' => 'Skip Auto Action',
                'description' => 'Select the resource types for which you want to skip auto actions to be created, otherwise auto actions can be created for all resource types by default.',
                'multiOptions' => $multiOptions,
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteautoaction.resource'),
                // 'required' => true,
            ));
        }

        // $this->addElement('Radio', 'siteautoaction_join', array(
        //     'label' => 'Enable Automatic Membership',
        //     'description' => 'Enabling this setting will create the memberships for created auto-action without taking into account the membership direction and verification settings in the modules.',
        //     'multiOptions' => array(
        //             1 => 'Enable, automatic membership despite the direction and verification settings in modules.',
        //             2 => 'Disable join option.'
        //         ),
        //     'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteautoaction.join',1),
        //     // 'required' => true,
        // ));

        // Add submit button
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }
}
