<?php

class Siteautologin_Form_Admin_Widget extends Engine_Form
{
  public function init()
  {
    $this->setTitle('SEAO - Auto Logging With Test User')
      ->setDescription('This widget displays the test users at placment as chosen from Global Settings of this plugin on the page on which this widget is placed.');

    $this->addElement('Hidden', 'title', array(
      'order' => 999,
    ));
    $this->addElement('Text', "header_title", array(
      'description' => 'Enter the text for the heading of test user slider box.',
      'allowEmpty' => false,
      'required' => true,
      'value' => "Site Tour with Test Users",
    ));
    $this->getElement('header_title')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));
    $this->addElement('Text', "header_description", array(
      'description' => 'Enter the text for the description of test user slider box.',
      'allowEmpty' => false,
      'required' => true,
      'value' => 'Choose a test user to login and take a site tour.',
    ));

    $this->getElement('header_description')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));
    $this->addElement('Select', "placement", array(
      'description' => 'Choose the placement of the test user slider box.',
      'allowEmpty' => false,
      'required' => true,
      'multiOptions' => array(
        'default' => 'At Place possitions',
        'fixed_left' => 'In Left Side of Screen',
        'fixed_right' => 'In Right Side of Screen',
      ),
      'value' => 'default',
    ));
    $this->getElement('placement')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));
    $this->addElement('Select', "style", array(
      'description' => 'Choose the view type for displaying test users in the box.',
      'allowEmpty' => false,
      'required' => true,
      'multiOptions' => array(
        'list' => 'List View',
        'grid' => 'Grid View',
        'grid round' => 'Grid View (Round icon)',
      ),
      'value' => 'grid',
    ));
    $this->getElement('style')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));

    $images = Engine_Api::_()->siteautologin()->getImages(array('application/modules/Siteautologin/externals/images/user_panel_icon.png' => 'Default'));

    $view = Zend_Registry::get('Zend_View');
    $this->addElement('Select', 'icon', array(
      'description' => 'Choose an icon to be uploaded for opening and closing the test user slider box. [Note: You can add a new icon from the "File & Media Manager" section from here: <a href="' . $view->baseUrl('/admin/files') . '" target="_blank">File & Media Manager</a>.]',
      'multiOptions' => $images,
    ));
    $this->getElement('icon')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));
    $this->addElement('Select', 'thumb_icon', array(
      'description' => 'Choose an size of User Photos',
      'multiOptions' => array(
        'icon' => 'Icon',
        'profile' => 'Profile',
      ),
      'escape' => false,
    ));
    $this->getElement('thumb_icon')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));

    $this->addElement('Text', "box_width", array(
      'description' => 'Enter the width of box.',
      'allowEmpty' => false,
      'required' => true,
      'value' => "195",
      'escape' => false,
    ));
    $this->getElement('box_width')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));


    $this->addElement('Text', "limit", array(
      'description' => 'Enter the maximum number of test users to be shown in the test user slider box.',
      'allowEmpty' => false,
      'required' => true,
      'value' => 6,
    ));
    $this->getElement('limit')->getDecorator('Description')->setOptions(array('placement' =>
      'PREPEND', 'escape' => false));
  }

}
