<?php

class Siteautologin_Model_DbTable_Users extends Engine_Db_Table
{

  protected $_rowClass = "Siteautologin_Model_User";

  public function hasUserAdded($userId, $params = array())
  {
    $params['user_id'] = $userId;
    return $this->fetchRow($this->getSelect($params));
  }

  public function getPaginator($params = array())
  {
    $paginator = Zend_Paginator::factory($this->getSelect($params));
    if( !empty($params['page']) ) {
      $paginator->setCurrentPageNumber($params['page']);
    }
    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  public function getSelect($params = array())
  {

    $select = $this->select()->from($this->info('name'));
    if( isset($params['enabled']) ) {
      $select->where('enabled =?', $params['enabled']);
    }
    if( isset($params['user_id']) ) {
      $select->where('user_id =?', $params['user_id']);
    }
    $select->order('order');
    return $select;
  }

}
