<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package	Sitebackup
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license	http://www.socialengineaddons.com/license/
 * @version	$Id: Diskspace.php 2010-10-25 9:40:21Z SocialEngineAddOns $
 * @author 	SocialEngineAddOns
 */
class Sitebackup_Form_Admin_Diskspace extends Engine_Form
{
  public function init()
  {
    //HERE WE SETTING THE TITLE AND DESCRIPTION OF DATABASE BACKUP
    $this
      ->setTitle('Minimum Storage Space')
      ->setDescription("Enter the minimum storage space required to be available on \"Remote Server\". Backup process will not start if available storage space is below this. [Note: We will recommend minimum 0.5GB. Usually, this much storage space is sufficient for database backup.]");

    $this->addElement('Text', 'sitebackup_diskspace', array(
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebackup.diskspace', 0.5),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
    ));
  }

}
