<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Api_Core extends Core_Api_Abstract
{

  protected $_privacy = array();  // $_privacy['guid']['user_id']['privacy_type']=$privacy;

  /**
   * Privacy settings base on level and package
   *
   * @param object $sitebusiness
   * @param string $privacy_type
   * @return int $is_manage_admin
   */

  public function isManageAdmin($sitebusiness, $privacy_type)
  {
    if( empty($sitebusiness) || empty($privacy_type) )
      return 0;
    $business_id = $sitebusiness->business_id;
    //business is declined then not edit business
    if( !empty($sitebusiness->declined) && ($privacy_type == "edit") ) {
      return 0;
    }

    if( $privacy_type == "view" && !$this->canViewBusiness($sitebusiness) ) {
      return 0;
    }

    if( $this->hasPackageEnable() ) {

      $packageInclude = array("tellafriend" => "tfriend", "print" => "print", "overview" => "overview", "map" => "map", "insights" => "insight", /* "layout" => "layout", */ "contact_details" => "contact", "profile" => "profile", "sendupdate" => "sendupdate", "twitter" => "twitter");
      $packageOwnerModules = array("sitebusinessoffer" => "offer", "sitebusinessform" => "form", "sitebusinessinvite" => "invite", "sitebusinessbadge" => "badge", "sitebusinesslikebox" => "likebox", "sitebusinessmember" => "smecreate");
      $subModules = array("sitebusinessdocument" => "sdcreate", "sitebusinessnote" => "sncreate", "sitebusinesspoll" => "splcreate", "sitebusinessevent" => "secreate", "sitebusinessvideo" => "svcreate", "sitebusinessalbum" => "spcreate", "sitebusinessmusic" => "smcreate", "sitecrowdfunding" => "sprcreate", "sitemusic" => "samcreate");

      // $packageSubModule = $this->getEnableSubModules();
      //non sub modules
      $search_Key = array_search($privacy_type, $packageInclude);
      if( !empty($search_Key) ) {
        return $this->allowPackageContent($sitebusiness->package_id, $search_Key);
      }

      //owner base submodules
      $packageOwnerSubModule = @array_search($privacy_type, $packageOwnerModules);
      if( !empty($packageOwnerSubModule) ) {
        return $this->allowPackageContent($sitebusiness->package_id, "modules", $packageOwnerSubModule);
      }

      //owner base and also depeanded on viewer
      $subModule = @array_search($privacy_type, $subModules);
      if( !empty($subModule) ) {
        if( !$this->allowPackageContent($sitebusiness->package_id, "modules", $subModule) )
          return 0;
      }
    }else {

      $levelInclude = array("tellafriend" => "tfriend", "print" => "print", "overview" => "overview", "map" => "map", "insights" => "insight", /* "layout" => "layout", */ "contact_details" => "contact", "profile" => "profile", "sendupdate" => "sendupdate", "twitter" => "twitter");
      $levelOwnerModules = array("sitebusinessoffer" => "offer", "sitebusinessform" => "form", "sitebusinessinvite" => "invite", "sitebusinessbadge" => "badge", "sitebusinesslikebox" => "likebox", "sitebusinessmember" => "smecreate");
      $levelBusinessBaseSubModule = array("sitebusinessdocument" => "sdcreate", "sitebusinessnote" => "sncreate", "sitebusinesspoll" => "splcreate", "sitebusinessevent" => "secreate", "sitebusinessvideo" => "svcreate", "sitebusinessalbum" => "spcreate", "sitebusinessmusic" => "smcreate");
      //non sub modules
      $search_Key = array_search($privacy_type, $levelInclude);
      if( !empty($search_Key) ) {
        $business_owner = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);
        $can_edit = $this->getManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type);
        if( $can_edit == -1 ) {
          $can_edit = Engine_Api::_()->authorization()->getPermission($business_owner->level_id, 'sitebusiness_business', $privacy_type); //Engine_Api::_()->authorization()->isAllowed($sitebusiness, $business_owner, $privacy_type);
          $this->setManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type, $can_edit);
        }
        if( empty($can_edit) ) {
          return 0;
        } else {
          return 1;
        }
      }

      //owner base submodules
      $levelsubModule = @array_search($privacy_type, $levelOwnerModules);
      if( !empty($levelsubModule) ) {
        $business_owner = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);
        $can_edit = $this->getManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type);
        if( $can_edit == -1 ) {
          $can_edit = Engine_Api::_()->authorization()->getPermission($business_owner->level_id, 'sitebusiness_business', $privacy_type);
          $this->setManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type, $can_edit);
        }
        if( empty($can_edit) ) {
          return 0;
        } else {
          return 1;
        }
      }

      //owner base and also depeanded on viewer
      $levelsubModule = @array_search($privacy_type, $levelBusinessBaseSubModule);
      if( !empty($levelsubModule) ) {
        $business_owner = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);
        $can_edit = $this->getManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type);
        if( $can_edit == -1 ) {
          $can_edit = Engine_Api::_()->authorization()->getPermission($business_owner->level_id, 'sitebusiness_business', $privacy_type);
          $this->setManageAdminPrivacyCache('sitebusiness_business', "level_" . $business_owner->level_id, $privacy_type, $can_edit);
        }
        if( empty($can_edit) ) {
          return 0;
        }
      }
    }
    $existManageAdmin = 0;
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $manageAdminEnable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1);
    if( !empty($viewer_id) && !empty($manageAdminEnable) ) {
      $manageadminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
      $manageadminTableName = $manageadminTable->info('name');
      $select = $manageadminTable->select()
        ->from($manageadminTableName, 'manageadmin_id')
        ->where('user_id = ?', $viewer_id)
        ->where('business_id = ?', $business_id)
        ->limit(1);
      $row = $manageadminTable->fetchAll($select)->toArray();
      if( !empty($row[0]['manageadmin_id']) ) {
        $existManageAdmin = 1;
      } else {
        $existManageAdmin = 0;
      }
    }

    $is_manage_admin = 1;
    if( $existManageAdmin == 0 || $viewer_id == $sitebusiness->owner_id ) {
      if( empty($viewer_id) ) {
        $viewer = null;
        $viewer_id = 0;
      }
      $viewer_guid = 'user' . "_" . $viewer_id;
      $can_edit = $this->getManageAdminPrivacyCache($sitebusiness->getGuid(), $viewer_guid, $privacy_type);
      if( $can_edit == -1 ) {
        $can_edit = Engine_Api::_()->authorization()->isAllowed($sitebusiness, $viewer, $privacy_type);
        $this->setManageAdminPrivacyCache($sitebusiness->getGuid(), $viewer_guid, $privacy_type, $can_edit);
      }
      if( empty($can_edit) ) {
        $is_manage_admin = 0;
      }
    } elseif( $existManageAdmin == 1 && $viewer_id != $sitebusiness->owner_id ) {
      $business_owner = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);
      $can_edit = $this->getManageAdminPrivacyCache($sitebusiness->getGuid(), $business_owner->getGuid(), $privacy_type);
      if( $can_edit == -1 ) {
        $can_edit = Engine_Api::_()->authorization()->isAllowed($sitebusiness, $business_owner, $privacy_type);
        $this->setManageAdminPrivacyCache($sitebusiness->getGuid(), $business_owner->getGuid(), $privacy_type, $can_edit);
      }
      if( empty($can_edit) ) {
        $is_manage_admin = 0;
      }
    }

    if( $privacy_type == "view" && $is_manage_admin ) {
      $is_manage_admin = $sitebusiness->isViewableByNetwork();
    }

    return $is_manage_admin;
  }

  public function setManageAdminPrivacyCache($index, $member_index, $privacy_type, $privacy)
  {
    return $this->_privacy[$index][$member_index][$privacy_type] = $privacy;
  }

  public function getManageAdminPrivacyCache($index, $member_index, $privacy_type)
  {
    //  print_r($this->_privacy);
    if( isset($this->_privacy[$index][$member_index][$privacy_type]) ) {
      return $this->_privacy[$index][$member_index][$privacy_type];
    } else {
      return -1;
    }
  }

  /**
   * viewer is business owner or business admin
   *
   * @param object $sitebusiness
   * @return bool $isBusinessOwnerFlage
   */
  public function isBusinessOwner($sitebusiness, $user = null)
  {
    if( empty($user) )
      $user = Engine_Api::_()->user()->getViewer();

    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $isBusinessOwnerFlage = false;
    if( empty($viewer_id) )
      return $isBusinessOwnerFlage;
    if( $sitebusiness->owner_id == $viewer_id )
      return true;

    $manageadminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
    $manageadminTableName = $manageadminTable->info('name');
    $select = $manageadminTable->select()
      ->from($manageadminTableName, 'manageadmin_id')
      ->where('user_id = ?', $viewer_id)
      ->where('business_id = ?', $sitebusiness->business_id);
    $row = $manageadminTable->fetchRow($select);
    if( !empty($row) )
      $isBusinessOwnerFlage = true;

    return $isBusinessOwnerFlage;
  }

  /**
   * allow to business owner
   *
   * @param object $sitebusiness
   * @param string $privacy_type
   * @return bool $canDo
   */
  public function isBusinessOwnerAllow($sitebusiness, $privacy_type)
  {
    if( empty($sitebusiness) )
      return;
    $business_owner = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);
    return (bool) $canDo = Engine_Api::_()->authorization()->getPermission($business_owner->level_id, 'sitebusiness_business', $privacy_type);
  }

  public function setDisabledType()
  {
    $modArray = unserialize(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mod.settings', 0));
    $modArrayType = unserialize(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mod.types', 0));
    if( !empty($modArray) ) {
      foreach( $modArray as $modName ) {
        $newModArray[] = strrev($modName);
      }
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.mod.settings', serialize($newModArray));
    }
    if( !empty($modArrayType) ) {
      foreach( $modArrayType as $modNameType ) {
        $newModArrayType[] = strrev($modNameType);
      }
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.mod.types', serialize($newModArrayType));
    }
  }

  /**
   * Get business id
   *
   * @param string $business_url
   * @return int $businessID
   */
  public function getBusinessId($business_url, $businessId = null)
  {
    $businessID = 0;
    if( !empty($business_url) ) {
      $sitebusiness_table = Engine_Api::_()->getItemTable('sitebusiness_business');
      $select = $sitebusiness_table->select()
        ->from($sitebusiness_table->info('name'), 'business_id')
        ->where('business_url = ?', $business_url);

      if( !empty($businessId) ) {
        $select->where('business_id != ?', $businessId);
      }

      $businessID = $select->limit(1)
        ->query()
        ->fetchColumn();
    }

    return $businessID;
  }

  /**
   * Get business url
   *
   * @param int $business_id
   * @return string $businessUrl
   */
  public function getBusinessUrl($business_id)
  {

    $businessUrl = 0;
    if( !empty($business_id) ) {
      $sitebusiness_table = Engine_Api::_()->getItemTable('sitebusiness_business');
      $businessUrl = $sitebusiness_table->select()
        ->from($sitebusiness_table->info('name'), 'business_url')
        ->where('business_id = ?', $business_id)
        ->limit(1)
        ->query()
        ->fetchColumn();
    }
    return $businessUrl;
  }

  /**
   * Get business list
   *
   * @param array $params
   * @param array $customParams
   * @return array $paginator;
   */
  public function getSitebusinessesPaginator($params = array(), $customParams = null)
  {

    $paginator = Zend_Paginator::factory($this->getSitebusinessesSelect($params, $customParams));
    if( !empty($params['business']) ) {
      $paginator->setCurrentPageNumber($params['business']);
    }

    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  /**
   * Get business select query
   *
   * @param array $params
   * @param array $customParams
   * @return string $select;
   */
  public function getSitebusinessesSelect($params = array(), $customParams = null)
  {

    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    $table = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName = $table->info('name');

    $moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if( !empty($moduleEnabled) ) {
      $membertable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
      $membertableName = $membertable->info('name');
    }

    $tmTable = Engine_Api::_()->getDbtable('TagMaps', 'core');
    $tmName = $tmTable->info('name');

    $searchTable = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'search')->info('name');

    $locationTable = Engine_Api::_()->getDbtable('locations', 'sitebusiness');
    $locationName = $locationTable->info('name');
    $select = $table->select()->setIntegrityCheck(false);

    if( isset($params['browse_business']) && !empty($params['browse_business']) ) {
      $columnsArray = array('business_id', 'title', 'business_url', 'body', 'owner_id', 'category_id', 'photo_id', 'price', 'location', 'creation_date', 'modified_date', 'featured', 'sponsored', 'view_count', 'comment_count', 'like_count', 'closed', 'email', 'website', 'phone', 'package_id', 'follow_count');

      if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') ) {
        $columnsArray = array_merge(array('member_count'), $columnsArray);
        $columnsArray = array_merge(array('member_title'), $columnsArray);
        $columnsArray = array_merge(array('member_approval'), $columnsArray);
      }

      if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge') )
        $columnsArray[] = 'badge_id';

      if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer') )
        $columnsArray[] = 'offer';

      if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview') ) {
        $columnsArray[] = 'review_count';
        $columnsArray[] = 'rating';
      }

      $select = $select->from($rName, $columnsArray);
    } else {
      $select = $select->from($rName);
    }

    if( isset($params['type']) && !empty($params['type']) && $params['type'] != 'manage' ) {
      if( $params['type'] == 'browse' || $params['type'] == 'home' ) {
        $select = $select
          ->where($rName . '.approved = ?', '1')
          ->where($rName . '.declined = ?', '0')
          ->where($rName . '.draft = ?', '1');

        if( !empty($moduleEnabled) && isset($params['type_location']) && $params['type_location'] != 'browseLocation' && $params['type_location'] != 'browseBusiness' && $params['type_location'] == 'profilebrowseBusiness' ) {
          $select = $select->join($membertableName, "$membertableName.business_id = $rName.business_id", array('user_id AS business_owner_id'));
          if( !empty($values['adminbusinesses']) ) {
            $select = $select->where($membertableName . '.user_id = ?', $params['user_id']);
          }
          if( isset($params['onlymember']) && !empty($params['onlymember']) ) {
            $select = $select->where($rName . '.business_id IN (?)', (array) $params['onlymember']);
          }
          $select = $select->where($membertableName . '.active = ?', 1);
        }

        $stusShow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.status.show', 1);
        if( $stusShow == 0 ) {
          $select = $select
            ->where($rName . '.closed = ?', '0');
        }
        if( $this->hasPackageEnable() )
          $select->where($rName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
      } elseif( $params['type'] == 'browse_home_zero' ) {
        $select = $select
          ->where($rName . '.closed = ?', '0')
          ->where($rName . '.approved = ?', '1')
          ->where($rName . '.declined = ?', '0')
          ->where($rName . '.draft = ?', '1');
        if( $this->hasPackageEnable() )
          $select->where($rName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
      }
      $select->where($rName . ".search = ?", 1);
    }
    if( isset($customParams) ) {

      $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
      $coreversion = $coremodule->version;
      if( Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.7') == 1 ) {

        //PROCESS OPTIONS
        $tmp = array();
        foreach( $customParams as $k => $v ) {
          if( null == $v || '' == $v || (is_array($v) && count(array_filter($v)) == 0) ) {
            continue;
          } else if( false !== strpos($k, '_field_') ) {
            list($null, $field) = explode('_field_', $k);
            $tmp['field_' . $field] = $v;
          } else if( false !== strpos($k, '_alias_') ) {
            list($null, $alias) = explode('_alias_', $k);
            $tmp[$alias] = $v;
          } else {
            $tmp[$k] = $v;
          }
        }
        $customParams = $tmp;
      }

      $select = $select
        ->setIntegrityCheck(false)
        ->joinLeft($searchTable, "$searchTable.item_id = $rName.business_id", null);

      $searchParts = Engine_Api::_()->fields()->getSearchQuery('sitebusiness_business', $customParams);
      foreach( $searchParts as $k => $v ) {
        //$v = str_replace("%2C%20",", ",$v);
        $select->where("`{$searchTable}`.{$k}", $v);
      }
    }

    if( isset($params['sitebusiness_price']) && !empty($params['sitebusiness_price']) ) {

      if( (!empty($params['sitebusiness_price']['min']) && !empty($params['sitebusiness_price']['max']) ) ) {

        if( $params['sitebusiness_price']['max'] < $params['sitebusiness_price']['min'] ) {
          $min = $params['sitebusiness_price']['max'];
          $max = $params['sitebusiness_price']['min'];
        } else {
          $min = $params['sitebusiness_price']['min'];
          $max = $params['sitebusiness_price']['max'];
        }

        $select = $select->where($rName . '.price >= ?', $this->getPriceWithCurrency($min, 1, 1))->where($rName . '.price <= ?', $this->getPriceWithCurrency($max, 1, 1));
      }

      if( (empty($params['sitebusiness_price']['min']) && !empty($params['sitebusiness_price']['max']) ) ) {
        $select = $select->where($rName . '.price <= ?', $this->getPriceWithCurrency($params['sitebusiness_price']['max'], 1, 1));
      }

      if( (!empty($params['sitebusiness_price']['min']) && empty($param['sitebusiness_price']['max']) ) ) {
        $select = $select->where($rName . '.price >= ?', $this->getPriceWithCurrency($params['sitebusiness_price']['min']));
      }
    }

    if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer') && isset($params['offer_type']) && !empty($params['offer_type']) ) {
      $offerTable = Engine_Api::_()->getDbtable('offers', 'sitebusinessoffer');
      $offerTableName = $offerTable->info('name');
      $today = date("Y-m-d H:i:s");
      $select->setIntegrityCheck(false)
        ->join($offerTableName, "$offerTableName.business_id = $rName.business_id", array(''))
        ->where("$offerTableName.end_settings = 0 OR ($offerTableName.end_settings = 1 AND $offerTableName.end_time >= '$today')");

      if( $params['offer_type'] == 'hot' ) {
        $select->where("$offerTableName.hotoffer = 1");
      } elseif( $params['offer_type'] == 'featured' ) {
        $select->where("$offerTableName.sticky = 1");
      }
    }

//     if (isset($params['sitebusiness_postalcode']) && empty($params['sitebusiness_postalcode']) && isset($params['locationmiles']) && empty($params['locationmiles'])) {
    //check for stret , city etc in location search.
    if( isset($params['sitebusiness_street']) && !empty($params['sitebusiness_street']) ) {
      $select->join($locationName, "$rName.business_id = $locationName.business_id   ", null);
      $select->where($locationName . '.address   LIKE ? ', '%' . $params['sitebusiness_street'] . '%');
    } if( isset($params['sitebusiness_city']) && !empty($params['sitebusiness_city']) ) {
      $select->join($locationName, "$rName.business_id = $locationName.business_id   ", null);
      $select->where($locationName . '.city = ?', $params['sitebusiness_city']);
    } if( isset($params['sitebusiness_state']) && !empty($params['sitebusiness_state']) ) {
      $select->join($locationName, "$rName.business_id = $locationName.business_id   ", null);
      $select->where($locationName . '.state = ?', $params['sitebusiness_state']);
    } if( isset($params['sitebusiness_country']) && !empty($params['sitebusiness_country']) ) {
      $select->join($locationName, "$rName.business_id = $locationName.business_id   ", null);
      $select->where($locationName . '.country = ?', $params['sitebusiness_country']);
    }
// 		} else {
// 			$select->join($locationName, "$rName.business_id = $locationName.business_id   ", null);
// 			$select->where($locationName . '.zipcode = ?', $params['sitebusiness_postalcode']);
// 		}

    if( !isset($params['sitebusiness_location']) && isset($params['locationSearch']) && !empty($params['locationSearch']) ) {
      $params['sitebusiness_location'] = $params['locationSearch'];

      if( isset($params['locationmilesSearch']) ) {
        $params['locationmiles'] = $params['locationmilesSearch'];
      }
    }

    if( (isset($params['sitebusiness_location']) && !empty($params['sitebusiness_location'])) || (!empty($params['formatted_address'])) ) {
      $enable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.proximitysearch', 1);
      if( isset($params['locationmiles']) && (!empty($params['locationmiles']) && !empty($enable)) ) {
        $longitude = 0;
        $latitude = 0;


        //check for zip code in location search.
        if( empty($params['Latitude']) && empty($params['Longitude']) ) {
          $selectLocQuery = $locationTable->select()->where('location = ?', $params['sitebusiness_location']);
          $locationValue = $locationTable->fetchRow($selectLocQuery);

          if( empty($locationValue) ) {
            $locationResults = Engine_Api::_()->getApi('geoLocation', 'seaocore')->getLatLong(array('location' => $params['sitebusiness_location'], 'module' => 'Directory / Businesses'));
            if( !empty($locationResults['latitude']) && !empty($locationResults['longitude']) ) {
              $latitude = $locationResults['latitude'];
              $longitude = $locationResults['longitude'];
            }
          } else {
            $latitude = (float) $locationValue->latitude;
            $longitude = (float) $locationValue->longitude;
          }
        } else {
          $latitude = (float) $params['Latitude'];
          $longitude = (float) $params['Longitude'];
        }

        $radius = $params['locationmiles']; //in miles

        $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.proximity.search.kilometer', 0);
        if( !empty($flage) ) {
          $radius = $radius * (0.621371192);
        }

        //We have follow this code from event plugin.
        //$latitudeRadians = deg2rad($latitude);
        $latitudeSin = "sin(radians($latitude))";
        $latitudeCos = "cos(radians($latitude))";

        $select->join($locationName, "$rName.business_id = $locationName.business_id   ", array("(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172) AS distance"));
        $sqlstring = "(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172 <= " . "'" . $radius . "'";
        $sqlstring .= ")";
        $select->where($sqlstring);
        $select->order("distance");
      } else {
// 				if ($params['sitebusiness_postalcode'] == 'postalCode') {
// 					$select->join($locationName, "$rName.business_id = $locationName.business_id", null);
// 					$select->where("`{$locationName}`.formatted_address LIKE ? ", "%" . $params['formatted_address'] . "%");
// 				}
// 				else {
        $select->join($locationName, "$rName.business_id = $locationName.business_id", null);
        $select->where("`{$locationName}`.formatted_address LIKE ? or `{$locationName}`.location LIKE ? or `{$locationName}`.city LIKE ? or `{$locationName}`.state LIKE ?", "%" . urldecode($params['sitebusiness_location']) . "%");
        //}
      }
    } elseif( (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessgeolocation') && isset($params['has_currentlocation']) && !empty($params['has_currentlocation']) && !empty($params['latitude']) && !empty($params['longitude']) ) {
      $radius = Engine_Api::_()->getApi('settings', 'core')->getSetting('sgl.geolocation.range', 100); // in miles
      $latitude = $params['latitude'];
      $longitude = $params['longitude'];
      $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.proximity.search.kilometer', 0);
      if( !empty($flage) ) {
        $radius = $radius * (0.621371192);
      }
      // $latitudeRadians = deg2rad($latitude);
      $latitudeSin = "sin(radians($latitude))";
      $latitudeCos = "cos(radians($latitude))";
      $select->join($locationName, "$rName.business_id = $locationName.business_id   ", array("(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172) AS distance"));
      $sqlstring = "(degrees(acos($latitudeSin * sin(radians($locationName.latitude)) + $latitudeCos * cos(radians($locationName.latitude)) * cos(radians($longitude - $locationName.longitude)))) * 69.172 <= " . "'" . $radius . "'";
      $sqlstring .= ")";
      $select->where($sqlstring);
      $select->order("distance");
    }

    //Start Network work
    if( !empty($params['type']) ) {
      if( $params['type'] == 'browse' || $params['type'] == 'home' || $params['type'] == 'browse_home_zero' ) {

        $select = $table->getNetworkBaseSql($select, array('browse_network' => (isset($params['show']) && $params['show'] == "3")));
      }
    }
    //End Network work

    $moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if( isset($params['type_location']) && $params['type_location'] != 'profilebrowseBusiness' ) {
      if( !empty($params['user_id']) && is_numeric($params['user_id']) ) {
        $select->where($rName . '.owner_id = ?', $params['user_id']);
      }
    }

    if( !empty($params['user']) && $params['user'] instanceof User_Model_User ) {
      $select->where($rName . '.owner_id = ?', $params['user']->getIdentity());
    }

    if( (isset($params['show']) && $params['show'] == "4" ) ) {
      $likeTableName = Engine_Api::_()->getDbtable('likes', 'core')->info('name');
      $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $select->setIntegrityCheck(false)
        ->join($likeTableName, "$likeTableName.resource_id = $rName.business_id")
        ->where($likeTableName . '.poster_type = ?', 'user')
        ->where($likeTableName . '.poster_id = ?', $viewer_id)
        ->where($likeTableName . '.resource_type = ?', 'sitebusiness_business');
    }

    if( (isset($params['show']) && $params['show'] == "5" ) ) {
      $select->where($rName . '.featured = ?', 1);
    }

    if( !empty($params['users']) ) {
      $str = (string) ( is_array($params['users']) ? "'" . join("', '", $params['users']) . "'" : $params['users'] );
      $select->where($rName . '.owner_id in (?)', new Zend_Db_Expr($str));
    }

    if( empty($params['users']) && isset($params['show']) && $params['show'] == '2' ) {
      $select->where($rName . '.owner_id = ?', '0');
    }
    if( !empty($params['tag']) ) {
      $select
        ->setIntegrityCheck(false)
        ->joinLeft($tmName, "$tmName.resource_id = $rName.business_id")
        ->where($tmName . '.resource_type = ?', 'sitebusiness_business')
        ->where($tmName . '.tag_id = ?', $params['tag']);
    }

// 		if ($params['widget'] == 'locationsearch') {
// 			$select->where($rName . ".location != ?", '');
// 		}


    if( isset($params['adminbusinesses']) ) {
      $str = (string) ( is_array($params['adminbusinesses']) ? "'" . join("', '", $params['adminbusinesses']) . "'" : $params['adminbusinesses'] );
      $select->where($rName . '.business_id in (?)', new Zend_Db_Expr($str));
    }

    if( isset($params['adminjoinedbusinesses']) ) {
      $str = (string) ( is_array($params['adminjoinedbusinesses']) ? "'" . join("', '", $params['adminjoinedbusinesses']) . "'" : $params['adminjoinedbusinesses'] );
      $select->where($rName . '.business_id in (?)', new Zend_Db_Expr($str));
    }

    if( isset($params['notIncludeSelfBusinesses']) && !empty($params['notIncludeSelfBusinesses']) ) {
      $select->where($rName . '.owner_id != ?', $params['notIncludeSelfBusinesses']);
    }

    if( !empty($params['category']) ) {
      $select->where($rName . '.category_id = ?', $params['category']);
    }

    if( !empty($params['category_id']) ) {
      $select->where($rName . '.category_id = ?', $params['category_id']);
    }

    if( (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge') ) {
      if( !empty($params['badge_id']) ) {
        $select->where($rName . '.badge_id = ?', $params['badge_id']);
      }
    }

    if( !empty($params['profile_type']) ) {
      $select->where($rName . '.profile_type = ?', $params['profile_type']);
    }

    if( !empty($params['subcategory']) ) {
      $select->where($rName . '.subcategory_id = ?', $params['subcategory']);
    }

    if( !empty($params['subcategory_id']) ) {
      $select->where($rName . '.subcategory_id = ?', $params['subcategory_id']);
    }

    if( !empty($params['subsubcategory']) ) {
      $select->where($rName . '.subsubcategory_id = ?', $params['subsubcategory']);
    }

    if( !empty($params['subsubcategory_id']) ) {
      $select->where($rName . '.subsubcategory_id = ?', $params['subsubcategory_id']);
    }

    if( isset($params['closed']) && $params['closed'] != "" ) {
      $select->where($rName . '.closed = ?', $params['closed']);
    }

    //Could we use the search indexer for this?
    if( !empty($params['search']) ) {

      $tagName = Engine_Api::_()->getDbtable('Tags', 'core')->info('name');
      $select
        ->setIntegrityCheck(false)
        ->joinLeft($tmName, "$tmName.resource_id = $rName.business_id and " . $tmName . ".resource_type = 'sitebusiness_business'", null)
        ->joinLeft($tagName, "$tagName.tag_id = $tmName.tag_id", array($tagName . ".text"));
      //$params['search'] = str_replace("%20"," ",$params['search']);
      $select->where($rName . ".title LIKE ? OR " . $rName . ".body LIKE ? OR " . $tagName . ".text LIKE ? ", '%' . $params['search'] . '%');
    }

    if( !empty($params['start_date']) ) {
      $select->where($rName . ".creation_date > ?", date('Y-m-d', $params['start_date']));
    }

    if( !empty($params['end_date']) ) {
      $select->where($rName . ".creation_date < ?", date('Y-m-d', $params['end_date']));
    }

    if( !empty($params['has_photo']) ) {
      $select->where($rName . ".photo_id > ?", 0);
    }

    if( !empty($params['has_review']) ) {
      $select->where($rName . ".review_count > ?", 0);
    }

    if( (isset($_GET['alphabeticsearch']) && $_GET['alphabeticsearch'] != 'all' && $_GET['alphabeticsearch'] != '@' ) ) {
      $select->where($rName . ".title LIKE ?", $_GET['alphabeticsearch'] . '%');
    } elseif( isset($_GET['alphabeticsearch']) && ($_GET['alphabeticsearch'] == 'all' && $_GET['alphabeticsearch'] != '@') ) {
//      $select->group($rName . '.business_id');
//      return $select;
    } elseif( isset($_GET['alphabeticsearch']) && ($_GET['alphabeticsearch'] == '@' && $_GET['alphabeticsearch'] != 'all') ) {
      $select->where($rName . ".title REGEXP '^[0-9]'");
    }
    $select->group($rName . '.business_id');

    if( !empty($params['type']) && empty($params['orderby']) ) {
      if( $params['type'] == 'browse' || $params['type'] == 'manage' ) {
        $order = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.browseorder', 1);
        switch( $order ) {
          case "1":
            $select->order($rName . '.creation_date DESC');
            break;
          case "2":
            $select->order($rName . '.view_count DESC');
            break;
          case "3":
            $select->order($rName . '.title');
            break;
          case "4":
            $select->order($rName . '.sponsored' . ' DESC');
            break;
          case "5":
            $select->order($rName . '.featured' . ' DESC');
            break;
          case "6":
            $select->order($rName . '.sponsored' . ' DESC');
            $select->order($rName . '.featured' . ' DESC');
            break;
          case "7":
            $select->order($rName . '.featured' . ' DESC');
            $select->order($rName . '.sponsored' . ' DESC');
            break;
        }
      }
    } else {
      if( !empty($params['orderby']) && $params['orderby'] == "title" ) {
        $select->order($rName . '.' . $params['orderby']);
      } elseif( isset($params['orderby']) && !empty($params['orderby']) )
        $select->order($rName . '.' . $params['orderby'] . ' DESC');
    }
    $select->order($rName . '.creation_date DESC'); //echo $select;die;
    return $select;
  }

  public function getPackageAuthInfo($modulename)
  {
    $sitebusinessModSetting = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mod.settings', 0);
    $sitebusinessModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.mod.types', 0);
    $modSecondArray = $modFirstArray = array();
    if( !empty($sitebusinessModSetting) ) {
      $modFirstArray = unserialize($sitebusinessModSetting);
    }
    if( !empty($sitebusinessModType) ) {
      $modSecondArray = unserialize($sitebusinessModType);
    }
    $modArray = array_merge($modFirstArray, $modSecondArray);
    return in_array(strrev($modulename), $modArray);
  }

  /**
   * Get Business View Link
   *
   * @param int $business_id
   * @param int $owner_id
   * @param string $slug
   * @return link
   */
  public function getHref($business_id, $owner_id, $slug = null)
  {

    $business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id);
    $params = array_merge(array('business_url' => $business_url));
    $urlO = Zend_Controller_Front::getInstance()->getRouter()
      ->assemble($params, 'sitebusiness_entry_view', true);

    //SITEBUSINESSURL WORK START
    $sitebusinessUrlEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessurl');
    if( !empty($sitebusinessUrlEnabled) ) {
      $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlS', "businessitem");
      $banneUrlArray = Engine_Api::_()->sitebusiness()->getBannedBusinessUrls();
      $business_likes = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.likelimit.forurlblock', "5");
      $change_url = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1);

      $sitebusinessObject = Engine_Api::_()->getItem('sitebusiness_business', Engine_Api::_()->sitebusiness()->getBusinessId($business_url));
      $replaceStr = str_replace("/" . $routeStartS . "/", "/", $urlO);
      if( (!empty($change_url)) && ($sitebusinessObject->like_count >= $business_likes) && !in_array($business_url, $banneUrlArray) && !empty($sitebusinessObject) ) {
        $urlO = $replaceStr;
      }
    }
    return $urlO;
  }

  public function sitebusiness_auth($admin_tab)
  {
    include_once APPLICATION_PATH . '/application/modules/Sitebusiness/controllers/license/license2.php';
    return $checkAuth;
  }

//

  /**
   * GET LINK OF PHOTO VIEW BUSINESS
   *
   * @param object $image
   * @param array $params
   * @return link
   */
  public function getHreflink($image, $params = array())
  {
    $params = array_merge(array(
      'route' => 'sitebusiness_imagephoto_specific',
      'reset' => true,
      'controller' => 'photo',
      'action' => 'view',
      'photo_id' => $image->getIdentity(),
      'album_id' => $image->collection_id,
      ), $params);
    $route = $params['route'];
    $reset = $params['reset'];
    unset($params['route']);
    unset($params['reset']);
    return Zend_Controller_Front::getInstance()->getRouter()
        ->assemble($params, $route, $reset);
  }

  /**
   * Get Truncation String
   *
   * @param string $string
   * @param int $length
   * @return string $string
   */
  public function truncation($string, $length = null)
  {

    if( empty($length) ) {
      $length = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.title.truncation', 16);
    }

    $string = strip_tags($string);
    return $string = Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }

  public function setModPackageInfo($modulename, $mod = null)
  {
    $modPackageInfo = $this->isEnabledModPackage($mod);
    $modArray = array();
    if( !empty($modPackageInfo) ) {
      $modArray = unserialize($modPackageInfo);
      if( !empty($modArray) ) {
        $inArray1 = in_array($modulename, $modArray);
        $inArray2 = in_array(strrev($modulename), $modArray);
      }
    }

    if( !empty($inArray1) && empty($inArray2) ) {
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.mod.settings', 'a:0:{}');
      Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.mod.types', 'a:0:{}');
      Engine_Api::_()->getApi('settings', 'core')->removeSetting('sitebusiness.edit.package');
      $modArray = array();
    }
    if( !empty($inArray2) && empty($inArray1) ) {
      return;
    }

    $modArray[] = strrev($modulename);
    $arrayName = 0;
    $mod ? $arrayName = 'sitebusiness.mod.types' : $arrayName = 'sitebusiness.mod.settings';
    Engine_Api::_()->getApi('settings', 'core')->setSetting($arrayName, serialize($modArray));
    return;
  }

  /**
   * Check location is enable
   *
   * @param array $params
   * @return int $check
   */
  public function enableLocation($params = array())
  {
    $sitebusiness_recent_info = Zend_Registry::isRegistered('sitebusiness_recent_info') ? Zend_Registry::get('sitebusiness_recent_info') : null;
    if( !empty($sitebusiness_recent_info) ) {
      $check = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.location', 1);

      if( !empty($check) ) {
        $check = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.locationfield', 1);
      }
    } else {
      return false;
    }

    return $check;
  }

  /**
   * THIS FUNCTION SHOW PEOPLE LIKES OR FRIEND LIKES.
   *
   * @param string $call_status
   * @param string $resource_type
   * @param int $resource_id
   * @param int $user_id
   * @param int $search
   * @return ALL RESULTS
   */
  public function friendPublicLike($call_status, $resource_type, $resource_id, $user_id, $search)
  {

    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $likeTableName = $likeTable->info('name');
    $membershipTable = Engine_Api::_()->getDbtable('membership', 'user');
    $membershipTableName = $membershipTable->info('name');
    $userTable = Engine_Api::_()->getItemTable('user');
    $userTableName = $userTable->info('name');

    $sub_status_select = $userTable->select()
      ->setIntegrityCheck(false)
      ->from($likeTableName, array('poster_id'))
      ->where($likeTableName . '.resource_type = ?', $resource_type)
      ->where($likeTableName . '.resource_id = ?', $resource_id)
      ->where($likeTableName . '.poster_id != ?', 0)
      ->where($userTableName . '.displayname LIKE ?', '%' . $search . '%')
      ->order('	like_id DESC');
    if( $call_status == 'friend' ) {

      $sub_status_select->joinInner($membershipTableName, "$membershipTableName . user_id = $likeTableName . poster_id", NULL)
        ->joinInner($userTableName, "$userTableName . user_id = $membershipTableName . user_id")
        ->where($membershipTableName . '.resource_id = ?', $user_id)
        ->where($membershipTableName . '.active = ?', 1)
        ->where($likeTableName . '.poster_id != ?', $user_id);
    } else if( $call_status == 'public' ) {

      $sub_status_select->joinInner($userTableName, "$userTableName . user_id = $likeTableName . poster_id");
    }
    return Zend_Paginator::factory($sub_status_select);
  }

  /**
   * number of business like
   *
   * @param string $RESOURCE_TYPE
   * @param int $RESOURCE_ID
   * @param int $LIMIT
   */
  public function businessLike($RESOURCE_TYPE, $RESOURCE_ID, $LIMIT)
  {

    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $likeTableName = $likeTable->info('name');
    $select = $likeTable->select()
      ->from($likeTableName, array('poster_id'))
      ->where('resource_type = ?', $RESOURCE_TYPE)
      ->where('resource_id = ?', $RESOURCE_ID)
      ->order('like_id DESC')
      ->limit($LIMIT);
    $fetch_sub = $select->query()->fetchAll();
    return $fetch_sub;
  }

  /**
   * Function for showing 'Liked Link'.This function use in the like button.
   *
   * @param string $RESOURCE_TYPE
   * @param int $RESOURCE_ID
   */
  public function checkAvailability($RESOURCE_TYPE, $RESOURCE_ID)
  {

    $viewer = Engine_Api::_()->user()->getViewer();
    $sub_status_table = Engine_Api::_()->getItemTable('core_like');
    $sub_status_name = $sub_status_table->info('name');
    $sub_status_select = $sub_status_table->select()
      ->from($sub_status_name, array('like_id'))
      ->where('resource_type = ?', $RESOURCE_TYPE)
      ->where('resource_id = ?', $RESOURCE_ID)
      ->where('poster_type =?', $viewer->getType())
      ->where('poster_id =?', $viewer->getIdentity())
      ->limit(1);
    return $sub_status_select->query()->fetchAll();
  }

  /**
   * Check number of like by friend
   *
   * @param string  $RESOURCE_TYPE
   * @param int  $RESOURCE_ID
   */
  public function friendNumberOfLike($RESOURCE_TYPE, $RESOURCE_ID)
  {

    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $likeTableName = $likeTable->info('name');
    $membershipTable = Engine_Api::_()->getDbtable('membership', 'user');
    $membershipTableName = $membershipTable->info('name');
    $select = $likeTable->select()
      ->from($likeTableName, array('COUNT(' . $likeTableName . '.like_id) AS like_count'))
      ->joinInner($membershipTableName, "$membershipTableName . user_id = $likeTableName . poster_id", NULL)
      //->joinInner($userName, "$userName.user_id = $likeTableName.poster_id", NULL)
      ->where($membershipTableName . '.resource_id = ?', $user_id)
      ->where($membershipTableName . '.active = ?', 1)
      ->where($likeTableName . '.resource_type = ?', $RESOURCE_TYPE)
      ->where($likeTableName . '.resource_id = ?', $RESOURCE_ID)
      ->where($likeTableName . '.poster_id != ?', $user_id)
      ->where($likeTableName . '.poster_id != ?', 0)
      ->group($likeTableName . '.resource_id');
    $fetch_count = $select->query()->fetchAll();
    if( !empty($fetch_count) ) {
      return $fetch_count[0]['like_count'];
    } else {
      return 0;
    }
  }

  /**
   * Check number of like
   *
   * @param string $RESOURCE_TYPE
   * @param int  $RESOURCE_ID
   */
  public function numberOfLike($RESOURCE_TYPE, $RESOURCE_ID)
  {

    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $likeTableName = $likeTable->info('name');
    $select = $likeTable->select()
      ->from($likeTableName, array('COUNT(' . $likeTableName . '.like_id) AS like_count'))
      ->where('resource_type = ?', $RESOURCE_TYPE)
      ->where('resource_id = ?', $RESOURCE_ID)
      ->where('poster_id != ?', 0)
      ->group('resource_id');
    $fetch_count = $select->query()->fetchAll();
    if( !empty($fetch_count) ) {
      return $fetch_count[0]['like_count'];
    } else {
      return 0;
    }
  }

  public function getEnabledSubModules()
  {

    $coreTable = Engine_Api::_()->getDbtable('modules', 'core');
    ///////////////////START FOR INRAGRATION WORK WITH OTHER PLUGIN./////////
    $sitebusinessintegrationEnabled = $coreTable->isModuleEnabled('sitebusinessintegration');
    if( !empty($sitebusinessintegrationEnabled) ) {
      $mixSettingsResults = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems(null, $isDashboard = true);
    }
    ///////////////////END FOR INRAGRATION WORK WITH OTHER PLUGIN./////////


    if( $coreTable->isModuleEnabled('sitebusinessalbum') ||
      $coreTable->isModuleEnabled('sitebusinessvideo') ||
      $coreTable->isModuleEnabled('sitebusinesspoll') ||
      $coreTable->isModuleEnabled('sitebusinessnote') ||
      $coreTable->isModuleEnabled('sitebusinessevent') ||
      $coreTable->isModuleEnabled('sitebusinessdocument') ||
      $coreTable->isModuleEnabled('sitebusinessreviews') ||
      $coreTable->isModuleEnabled('sitebusinessdiscussion') ||
      $coreTable->isModuleEnabled('sitebusinessoffer') ||
      $coreTable->isModuleEnabled('sitebusinessform') ||
      $coreTable->isModuleEnabled('sitebusinessinvite') ||
      $coreTable->isModuleEnabled('sitebusinessmember') ||
      $coreTable->isModuleEnabled('sitebusinessmusic') ||
      (Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->getDbtable('modules', 'siteevent')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) ||
      (Engine_Api::_()->hasModuleBootstrap('sitevideo') && Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) || (Engine_Api::_()->hasModuleBootstrap('sitemusic') && Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ||
      (Engine_Api::_()->hasModuleBootstrap('document') && Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness'))) || (Engine_Api::_()->hasModuleBootstrap('sitecrowdfundingintegration') && Engine_Api::_()->getDbtable('modules', 'sitecrowdfunding')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ||
      !empty($mixSettingsResults) ) {
      return $business_redirect = 1;
    } else {
      return $business_redirect = 0;
    }
  }

  //Package Related Functions

  /**
   * Get List of enabled submodule for package
   *
   */
  public function getEnableSubModules($tempPackages = null)
  {

    $enableSubModules = array();

    $includeModules = array("sitebusinessdocument" => 'Documents', "sitebusinessoffer" => 'Offers', "sitebusinessform" => "Form", "sitebusinessdiscussion" => "Discussions", "sitebusinessnote" => "Notes", "sitebusinessalbum" => "Photos", "sitebusinessvideo" => "Videos", "sitebusinessevent" => "Events", "sitebusinesspoll" => "Polls", "sitebusinessinvite" => "Invite & Promote", "sitebusinessbadge" => "Badges", "sitebusinesslikebox" => "External Badge", "sitebusinessmusic" => "Music", "sitebusinessmember" => "Member", "siteevent" => "Events", "sitevideo" => "Videos", "document" => "Documents", "sitecrowdfunding" => "Crowdfunding", "sitemusic" => "Advanced Music");

    $enableAllModules = Engine_Api::_()->getDbtable('modules', 'core')->getEnabledModuleNames();
    $enableModules = array_intersect(array_keys($includeModules), $enableAllModules);


    foreach( $enableModules as $module ) {
      if( $this->isPluginActivate($module) ) {
        if( $module == 'siteevent' ) {
          if( (Engine_Api::_()->hasModuleBootstrap('siteevent') && Engine_Api::_()->getDbtable('modules', 'siteevent')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ) {
            $enableSubModules['sitebusinessevent'] = $includeModules['sitebusinessevent'];
          }
        } elseif( $module == 'sitevideo' ) {
          if( (Engine_Api::_()->hasModuleBootstrap('sitevideo') && Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ) {
            $enableSubModules['sitebusinessvideo'] = $includeModules['sitebusinessvideo'];
          }
        } elseif( $module == 'document' ) {
          if( (Engine_Api::_()->hasModuleBootstrap('document') && Engine_Api::_()->getDbtable('modules', 'document')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ) {
            $enableSubModules['sitebusinessdocument'] = $includeModules['sitebusinessdocument'];
          }
        } elseif( $module == 'sitecrowdfunding' ) {
          if( (Engine_Api::_()->hasModuleBootstrap('sitecrowdfundingintegration') && Engine_Api::_()->getDbtable('modules', 'sitecrowdfunding')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ) {
            $enableSubModules['sitecrowdfunding'] = $includeModules['sitecrowdfunding'];
          }
        } elseif( $module == 'sitemusic' ) {
          if( (Engine_Api::_()->hasModuleBootstrap('sitemusic') && Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules(array('enabled' => 1, 'item_type' => 'sitebusiness_business', 'item_module' => 'sitebusiness')) ) ) {
            $enableSubModules['sitemusic'] = $includeModules['sitemusic'];
          }
        } else {
          $enableSubModules[$module] = $includeModules[$module];
        }
      }
    }

    //START FOR INRAGRATION WORK WITH OTHER PLUGIN.
    $sitebusinessintegrationEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration');
    if( !empty($sitebusinessintegrationEnabled) ) {
      $mixResults = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems(null, $isDashboard = true);

      $mixSettings = array();
      $title = '';
      foreach( $mixResults as $modName ) {
        if( $modName['resource_type'] == 'list_listing' ) {
          $title = "Listings";
        } elseif( $modName['resource_type'] == 'sitereview_listing' ) {
          if( $tempPackages == 'adminPackages' ) {
            $title = "Reviews" . ' - ' . $modName['item_title'];
          } else {
            $title = $modName['item_title'];
          }
        } elseif( $modName['resource_type'] == 'sitepage_page' ) {
          $title = "Pages";
        } elseif( $modName['resource_type'] == 'sitegroup_group' ) {
          $title = "Groups";
        } elseif( $modName['resource_type'] == 'document' ) {
          $title = "Documents";
        } elseif( $modName['resource_type'] == 'folder' ) {
          $title = "Folder";
        } elseif( $modName['resource_type'] == 'quiz' ) {
          $title = "Quiz";
        } elseif( $modName['resource_type'] == 'sitefaq_faq' ) {
          $title = "Faqs";
        } elseif( $modName['resource_type'] == 'sitetutorial_tutorial' ) {
          $title = "Tutorials";
        } elseif( $modName['resource_type'] == 'sitestoreproduct_product' ) {
          $title = "Store Products";
        }
        $mixSettings[$modName['resource_type'] . '_' . $modName['listingtype_id']] = $title;
      }

      $enableSubModules = array_merge($enableSubModules, $mixSettings);
    }
    //END FOR INRAGRATION WORK WITH OTHER PLUGIN.

    asort($enableSubModules);
    // SEAO CUSTOM WORK FOR SEPARATING ADD AND LINK LISTING SETTINGS
    $enableSubModulesKeys = array_keys($enableSubModules);
    foreach( $enableSubModules as $resource_type => $item_title ) {
      if( strpos($resource_type, 'sitereview_listing_link') !== false ) {
        $tempString = str_replace('link', '', $resource_type);
        if( !in_array($tempString, $enableSubModulesKeys) ) {
          $enableSubModules[$tempString] = $item_title;
        }
        unset($enableSubModules[$resource_type]);
      }
    }
    // SEAO CUSTOM WORK FOR SEPARATING ADD AND LINK LISTING SETTINGS
    return $enableSubModules;
  }

  /**
   * Check package is enable or not for site
   * @return bool
   */
  public function hasPackageEnable()
  {
    return (bool) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1);
  }

  /**
   * Allow contect for perticuler package
   * @params $type : which check
   * $params $package_id : Id of business
   * $params $params : array some extra
   * */
  public function allowPackageContent($package_id, $type = null, $subModuleName = null)
  {

    if( !$this->hasPackageEnable() )
      return;
    $flage = false;
    if( Engine_Api::_()->core()->hasSubject('sitebusiness_business') ) {
      $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

      if( !empty($sitebusiness->pending) && !$this->isBusinessOwner($sitebusiness) ) {
        return $flage;
      }
    }
    $package = Engine_Api::_()->getItem('sitebusiness_package', $package_id);

    if( empty($package) )
      return $flage;

    switch( $type ) {
      case "modules":

        $includeArray = $this->getEnableSubModules();

        $modulesArray = unserialize($package->modules);
        if( empty($modulesArray) )
          $modulesArray = array();

        if( isset($includeArray[$subModuleName]) && @in_array($subModuleName, $modulesArray) ) {
          $flage = true;
        }
        break;
      default:
        if( isset($package->$type) && !empty($package->$type) )
          $flage = true;
        break;
    }
    return $flage;
  }

  /**
   * Get Business Profile Fileds level base on package
   * @params int $business_id : Id of business
   * @return bool
   * */
  public function getPackageProfileLevel($business_id = null)
  {
    if( !$this->hasPackageEnable() )
      return;
    $package = null;
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if( !empty($business) ) {
      $package = $business->getPackage();
    }
    if( !empty($package) )
      return $package->profile;
    else
      return 0;
  }

  /**
   * Get Business Profile Fileds If package set some fields
   * @params int $business_id : Id of business
   * @return array : profile fields
   * */
  public function getProfileFields($business_id = null)
  {
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if( !empty($business) ) {
      $package = $business->getPackage();
      return unserialize($package->profilefields);
    }
  }

  /**
   * Get Business Profile Fileds If package selected fields Id
   * @params int $business_id : Id of business
   * @return array : profile fields
   * */
  public function getSelectedProfilePackage($business_id = null)
  {
    $profileType = array();
    $profileType[""] = "";
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if( !empty($business) ) {
      $package = $business->getPackage();
      $profile = unserialize($package->profilefields);

      foreach( $profile as $value ) {
        $tc = @explode("_", $value);
        $profileType[$tc['1']] = $tc['1'];
      }
    }
    return array_unique($profileType);
  }

  /**
   * Get Business Profile Fileds  level base on level
   * @params int $level_id : level id of business owner
   * @return array : profile fields
   * */
  public function getLevelProfileFields($level_id)
  {
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
    $profileFields = $permissionsTable->getAllowed('sitebusiness_business', $level_id, array("profilefields"));
    return unserialize($profileFields['profilefields']);
  }

  /**
   * Get Business Profile Fileds If owner level selected fields Id
   * @params int $level_id : Level Id of business owner
   * @return array : profile fields
   * */
  public function getSelectedProfileLevel($level_id)
  {

    $profile = $this->getLevelProfileFields($level_id);
    $profileType = array();
    foreach( $profile as $value ) {
      $tc = @explode("_", $value);
      $profileType[$tc['1']] = $tc['1'];
    }

    return array_unique($profileType);
  }

  /**
   * Send emails for perticuler business
   * @params $type : which mail send
   * $params $businessId : Id of business
   * */
  public function sendMail($type, $businessId)
  {

    if( empty($type) || empty($businessId) ) {
      return;
    }
    $business = Engine_Api::_()->getItem('sitebusiness_business', $businessId);
    $mail_template = null;
    if( !empty($business) ) {

      $owner = Engine_Api::_()->user()->getUser($business->owner_id);
      switch( $type ) {
        case "APPROVAL_PENDING":
          $mail_template = 'sitebusiness_business_approval_pending';
          break;
        case "EXPIRED":
          if( !$this->hasPackageEnable() )
            return;
          if( $business->getPackage()->isFree() )
            $mail_template = 'sitebusiness_business_expired';
          else
            $mail_template = 'sitebusiness_business_renew';
          break;
        case "OVERDUE":
          $mail_template = 'sitebusiness_business_overdue';
          break;
        case "CANCELLED":
          $mail_template = 'sitebusiness_business_cancelled';
          break;
        case "ACTIVE":
          $mail_template = 'sitebusiness_business_active';
          break;
        case "PENDING":
          $mail_template = 'sitebusiness_business_pending';
          break;
        case "REFUNDED":
          $mail_template = 'sitebusiness_business_refunded';
          break;
        case "APPROVED":
          $mail_template = 'sitebusiness_business_approved';
          break;
        case "DISAPPROVED":
          $mail_template = 'sitebusiness_business_disapproved';
          break;
        case "DECLINED":
          $mail_template = 'sitebusiness_business_declined';
          break;
        case "RECURRENCE":
          $mail_template = 'sitebusiness_business_recurrence';
          break;
      }
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($owner, $mail_template, array(
        'site_title' => Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title', 1),
        'business_title' => ucfirst($business->getTitle()),
        'business_description' => ucfirst($business->body),
        'business_title_with_link' => '<a href="' . 'http://' . $_SERVER['HTTP_HOST'] .
        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business->business_url), 'sitebusiness_entry_view', true) . '"  >' . ucfirst($business->getTitle()) . ' </a>',
        'object_link' => 'http://' . $_SERVER['HTTP_HOST'] .
        Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business->business_url), 'sitebusiness_entry_view', true),
      ));
    }
  }

  /**
   * Check here that show payment link or not
   * $params $businessId : Id of business
   * @return bool $showLink
   * */
  public function canShowPaymentLink($business_id)
  {
    if( !$this->hasPackageEnable() )
      return;

    $showLink = true;
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    if( !empty($business->declined) ) {
      return (bool) false;
    }
    if( !empty($business) ) {
      if( !$this->isBusinessOwner($business) ) {
        return (bool) false;
      }
      $package = $business->getPackage();
      if( $package->isFree() ) {
        return (bool) false;
      }

      if( empty($business->expiration_date) || $business->expiration_date === "0000-00-00 00:00:00" ) {
        return (bool) true;
      }

      if( $business->status != "initial" && $business->status != "overdue" ) {
        return (bool) false;
      }

      if( ($package->isOneTime()) && !$package->hasDuration() && !empty($business->approved) ) {
        return false;
      }
    } else {
      $showLink = false;
    }
    return (bool) $showLink;
  }

  /**
   * Check here that show renew link or not
   * $params $businessId : Id of business
   * @return bool $showLink
   * */
  public function canShowRenewLink($business_id)
  {
    if( !$this->hasPackageEnable() )
      return;
    $showLink = false;
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    if( !empty($business->declined) ) {
      return (bool) false;
    }
    if( !empty($business) ) {
      if( !$this->isBusinessOwner($business) ) {
        return (bool) false;
      }
      $package = $business->getPackage();

      if( !$package->isOneTime() || $package->isFree() || (!empty($package->level_id) && !in_array($business->getOwner()->level_id, explode(",", $package->level_id))) ) {
        return (bool) false;
      }
      if( $package->renew ) {
        if( !empty($business->expiration_date) && $business->status != "initial" && $business->status != "overdue" ) {
          $diff_days = round((strtotime($business->expiration_date) - strtotime(date('Y-m-d H:i:s'))) / 86400);
          if( $diff_days <= $package->renew_before || $business->expiration_date <= date('Y-m-d H:i:s') ) {
            return (bool) true;
          }
        }
      }
    }
    return (bool) $showLink;
  }

  /**
   * Check here that show renew link  or not for admin
   * $params $businessId : Id of business
   * @return bool $showLink
   * */
  public function canAdminShowRenewLink($business_id)
  {
    if( !$this->hasPackageEnable() )
      return false;

    $showLink = false;
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    if( !empty($business) ) {
      if( !empty($business->approved) && $business->expiration_date !== "2250-01-01 00:00:00" )
        $showLink = true;
    }
    return (bool) $showLink;
  }

  /**
   * DISAPROVED AFTER EXPIRY BUSINESS THIS IS USE ONLY FOR ENABLE PACKAGE MENAGEMENT
   * @params array $params
   * */
  public function updateExpiredBusinesses($params = array())
  {

//PACKAGE MANAGMENT NOT ENABLE
    if( !$this->hasPackageEnable() )
      return;

    $table = Engine_Api::_()->getDbtable('business', 'sitebusiness');

    $rName = $table->info('name');
//LIST FOR BUSINESSES WHICH ARE EXPIRIED NOW AND SEND MAIL
    $select = $table->select()
      ->from($rName, array('business_id'))
      ->where('status <>  ?', 'expired')
      ->where('approved = ?', '1')
      ->where('expiration_date <= ?', date('Y-m-d H:i:s'));
    //START BUSINESS-EVENT CODE

    $sitebusinesseventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent');
    $siteeventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent');
    $sitevideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');
    $documentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document');
    $documentintegrationEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('documentintegration');
    $sitecrowdfundingEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding');
    $sitemusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic');
    foreach( $table->fetchAll($select) as $business ) {
      $this->sendMail("EXPIRED", $business->business_id);
    }

//UPDATE THE STATUS
    $table->update(array(
      'approved' => 0,
      'status' => 'expired'
      ), array(
      'status <>?' => 'expired',
      'expiration_date <=?' => date('Y-m-d H:i:s'),
    ));
    Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusiness.task.updateexpiredbusinesses', time());

    $select = $table->select()
      ->from($rName, array('business_id'))
      ->where('status =  ?', 'expired');
    foreach( $table->fetchAll($select) as $business ) {
      if( $sitebusinesseventEnabled ) {
        //FETCH Notes CORROSPONDING TO THAT Business ID
        $sitebusinesseventtable = Engine_Api::_()->getItemTable('sitebusinessevent_event');
        $select = $sitebusinesseventtable->select()
          ->from($sitebusinesseventtable->info('name'), 'event_id')
          ->where('business_id = ?', $business->business_id);
        $rows = $sitebusinesseventtable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $event_ids ) {
            $event_id = $event_ids['event_id'];
            if( !empty($event_id) ) {
              $sitebusinesseventtable->update(array(
                'search' => '0'
                ), array(
                'event_id =?' => $event_id
              ));
            }
          }
        }
      }

      if( $siteeventEnabled ) {
        //FETCH Notes CORROSPONDING TO THAT Business ID
        $siteeventtable = Engine_Api::_()->getItemTable('siteevent_event');
        $select = $siteeventtable->select()
          ->from($siteeventtable->info('name'), 'event_id')
          ->where('parent_type = ?', 'sitebusiness_business')
          ->where('parent_id = ?', $business->business_id);
        $rows = $siteeventtable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $event_ids ) {
            $event_id = $event_ids['event_id'];
            if( !empty($event_id) ) {
              $siteeventtable->update(array(
                'search' => '0'
                ), array(
                'event_id =?' => $event_id
              ));
            }
          }
        }
      }

      if( $sitevideoEnabled ) {
        //FETCH Notes CORROSPONDING TO THAT Business ID
        $sitevideotable = Engine_Api::_()->getItemTable('sitevideo_video');
        $select = $sitevideotable->select()
          ->from($sitevideotable->info('name'), 'video_id')
          ->where('parent_type = ?', 'sitebusiness_business')
          ->where('parent_id = ?', $business->business_id);
        $rows = $sitevideotable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $video_ids ) {
            $video_id = $video_ids['video_id'];
            if( !empty($video_id) ) {
              $sitevideotable->update(array(
                'search' => '0'
                ), array(
                'video_id =?' => $video_id
              ));
            }
          }
        }
      }

      if( $documentEnabled && $documentintegrationEnabled ) {
        $documenttable = Engine_Api::_()->getItemTable('document');
        $select = $documenttable->select()
          ->from($documenttable->info('name'), 'document_id')
          ->where('parent_type = ?', 'sitebusiness_business')
          ->where('parent_id = ?', $business->business_id);
        $rows = $documenttable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $document_ids ) {
            $document_id = $document_ids['document_id'];
            if( !empty($document_id) ) {
              $documenttable->update(array(
                'search' => '0'
                ), array(
                'document_id =?' => $document_id
              ));
            }
          }
        }
      }

      if( $sitecrowdfundingEnabled ) {
        //FETCH Notes CORROSPONDING TO THAT Page ID
        $projecttable = Engine_Api::_()->getItemTable('sitecrowdfunding_project');
        $select = $projecttable->select()
          ->from($projecttable->info('name'), 'project_id')
          ->where('parent_type = ?', 'sitebusiness_business')
          ->where('parent_id = ?', $business->business_id);
        $rows = $projecttable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $project_ids ) {
            $project_id = $project_ids['project_id'];
            if( !empty($project_id) ) {
              $projecttable->update(array(
                'search' => '0'
                ), array(
                'project_id =?' => $project_id
              ));
            }
          }
        }
      }
      if( $sitemusicEnabled ) {
        //FETCH Notes CORROSPONDING TO THAT Page ID
        $sitemusictable = Engine_Api::_()->getItemTable('sitemusic_pl');
        $select = $sitemusictable->select()
          ->from($sitemusictable->info('name'), 'playlist_id')
          ->where('parent_type = ?', 'sitebusiness_business')
          ->where('parent_id = ?', $business->business_id);
        $rows = $sitemusictable->fetchAll($select)->toArray();
        if( !empty($rows) ) {
          foreach( $rows as $key => $album_ids ) {
            $album_id = $album_ids['playlist_id'];
            if( !empty($album_id) ) {
              $sitemusictable->update(array(
                'search' => '0'
                ), array(
                'playlist_id =?' => $album_id
              ));
            }
          }
        }
      }
      $table->update(array(
        'search' => 0
        ), array(
        'status =?' => 'expired',
      ));
    }
  }

  /**
   * Get expiry date for business
   * $params object $business
   * @return date
   * */
  public function getExpiryDate($business)
  {
    if( empty($business->expiration_date) || $business->expiration_date === "0000-00-00 00:00:00" )
      return "-";
    $translate = Zend_Registry::get('Zend_Translate');
    if( $business->expiration_date === "2250-01-01 00:00:00" )
      return $translate->translate('Never Expires');
    else {
      if( strtotime($business->expiration_date) < time() )
        return "Expired";

      return date("M d,Y g:i A", strtotime($business->expiration_date));
    }
  }

  /**
   * Get status of business
   * $params object $business
   * @return string
   * */
  public function getBusinessStatus($business)
  {
    $translate = Zend_Registry::get('Zend_Translate');
    if( !empty($business->declined) ) {
      return "<span style='color: red;'>" . $translate->translate("Declined") . "</span>";
    }

    if( !empty($business->pending) ) {
      return $translate->translate("Approval Pending");
    }
    if( !empty($business->approved) ) {
      return $translate->translate("Approved");
    }


    if( empty($business->approved) ) {
      return $translate->translate("Dis-Approved");
    }

    return "Approved";
  }

  /**
   * On installation time enable submodule for default package
   * $params string $modulename
   * */
  public function oninstallPackageEnableSubMOdules($modulename)
  {
    if( !Engine_Api::_()->sitebusiness()->hasPackageEnable() )
      return;
    $package = Engine_Api::_()->getItemtable('sitebusiness_package')->fetchRow(array('defaultpackage = ?' => 1));
    if( !empty($package) ) {
      $values = array();
      $values = unserialize($package->modules);
      $values[] = $modulename;
      $db = Zend_Db_Table_Abstract::getDefaultAdapter();
      $db->beginTransaction();
      try {
        $package->modules = serialize($values);
        $package->save();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
    }
  }

//Count the no of likes on a business
  public function getBusinessLikes($values = array())
  {
    if( empty($values['business_id']) )
      return;

    $business_id = $values['business_id'];
    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $like_name = $likeTable->info('name');

    $like_select = $likeTable->select()
      ->from($like_name)
      ->where('resource_type = ?', 'sitebusiness_business')
      ->where('resource_id = ?', $business_id);

    if( !empty($values['startTime']) && !empty($values['endTime']) ) {
      $like_select->where($like_name . '.creation_date >= ?', gmdate('Y-m-d H:i:s', $values['startTime']))
        ->where($like_name . '.creation_date < ?', gmdate('Y-m-d H:i:s', $values['endTime']));
    }
    return count($like_select->query()->fetchAll());
  }

//Calculate the no of likes on a business date or month wise
  public function getReportLikes($values = array())
  {
    if( empty($values['business_id']) )
      return;

    $business_id = $values['business_id'];
    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $like_name = $likeTable->info('name');

    $like_select = $likeTable->select()
      ->from($like_name, array('COUNT(like_id) as business_likes', 'creation_date'))
      ->where('resource_type = ?', 'sitebusiness_business')
      ->where('resource_id = ?', $business_id)
      ->group('resource_id');

    if( !empty($values['startTime']) && !empty($values['endTime']) ) {
      $like_select->where($like_name . '.creation_date >= ?', gmdate('Y-m-d', $values['startTime']))
        ->where($like_name . '.creation_date < ?', gmdate('Y-m-d', $values['endTime']));
    }

    if( !empty($values['user_report']) ) {
      if( !empty($values['time_summary']) ) {
        if( $values['time_summary'] == 'Monthly' ) {
          $startTime = date('Y-m', mktime(0, 0, 0, $values['month_start'], date('d'), $values['year_start']));
          $endTime = date('Y-m', mktime(0, 0, 0, $values['month_end'], date('d'), $values['year_end']));
        } else {
          if( !empty($values['start_daily_time']) ) {
            $start = $values['start_daily_time'];
          }
          if( !empty($values['start_daily_time']) ) {
            $end = $values['end_daily_time'];
          }
          $startTime = date('Y-m-d', $start);
          $endTime = date('Y-m-d', $end);
        }
      }
      if( !empty($values['time_summary']) ) {

        switch( $values['time_summary'] ) {

          case 'Monthly':
            $like_select
              ->where("DATE_FORMAT(" . $like_name . " .creation_date, '%Y-%m') >= ?", $startTime)
              ->where("DATE_FORMAT(" . $like_name . " .creation_date, '%Y-%m') <= ?", $endTime);
            if( !isset($values['total_stats']) && empty($values['total_stats']) ) {
              $like_select->group("DATE_FORMAT(" . $like_name . " .creation_date, '%m')");
            }
            break;

          case 'Daily':
            $like_select
              ->where("DATE_FORMAT(" . $like_name . " .creation_date, '%Y-%m-%d') >= ?", $startTime)
              ->where("DATE_FORMAT(" . $like_name . " .creation_date, '%Y-%m-%d') <= ?", $endTime);
            if( !isset($values['total_stats']) && empty($values['total_stats']) ) {
              $like_select->group("DATE_FORMAT(" . $like_name . " .creation_date, '%Y-%m-%d')");
            }
            break;
        }
      }
    }
    $like_array = $likeTable->fetchAll($like_select)->toarray();
    return $like_array;
  }

//Calculate the no of comments on a business date or month wise
  public function getReportComments($values = array())
  {
    if( empty($values['business_id']) )
      return;

    $business_id = $values['business_id'];
    $commentTable = Engine_Api::_()->getItemTable('core_comment');
    $comment_name = $commentTable->info('name');

    $comment_select = $commentTable->select()
      ->from($comment_name, array('COUNT(comment_id) as business_comments', 'creation_date'))
      ->where('resource_type = ?', 'sitebusiness_business')
      ->where('resource_id = ?', $business_id)
      ->group('resource_id');

    if( !empty($values['startTime']) && !empty($values['endTime']) ) {
      $comment_select->where($comment_name . '.creation_date >= ?', gmdate('Y-m-d', $values['startTime']))
        ->where($comment_name . '.creation_date < ?', gmdate('Y-m-d', $values['endTime']));
    }

    if( !empty($values['user_report']) ) {
      if( !empty($values['time_summary']) ) {
        if( $values['time_summary'] == 'Monthly' ) {
          $startTime = date('Y-m', mktime(0, 0, 0, $values['month_start'], date('d'), $values['year_start']));
          $endTime = date('Y-m', mktime(0, 0, 0, $values['month_end'], date('d'), $values['year_end']));
        } else {
          if( !empty($values['start_daily_time']) ) {
            $start = $values['start_daily_time'];
          }
          if( !empty($values['start_daily_time']) ) {
            $end = $values['end_daily_time'];
          }
          $startTime = date('Y-m-d', $start);
          $endTime = date('Y-m-d', $end);
        }
      }
      if( !empty($values['time_summary']) ) {

        switch( $values['time_summary'] ) {

          case 'Monthly':
            $comment_select
              ->where("DATE_FORMAT(" . $comment_name . " .creation_date, '%Y-%m') >= ?", $startTime)
              ->where("DATE_FORMAT(" . $comment_name . " .creation_date, '%Y-%m') <= ?", $endTime);
            if( !isset($values['total_stats']) && empty($values['total_stats']) ) {
              $comment_select->group("DATE_FORMAT(" . $comment_name . " .creation_date, '%m')");
            }
            break;

          case 'Daily':
            $comment_select
              ->where("DATE_FORMAT(" . $comment_name . " .creation_date, '%Y-%m-%d') >= ?", $startTime)
              ->where("DATE_FORMAT(" . $comment_name . " .creation_date, '%Y-%m-%d') <= ?", $endTime);
            if( !isset($values['total_stats']) && empty($values['total_stats']) ) {
              $comment_select->group("DATE_FORMAT(" . $comment_name . " .creation_date, '%Y-%m-%d')");
            }
            break;
        }
      }
    }
    $comment_array = $commentTable->fetchAll($comment_select)->toarray();
    return $comment_array;
  }

//Count the no of comments on a business
  public function getBusinessComments($values = array())
  {
    if( empty($values['business_id']) )
      return;

    $business_id = $values['business_id'];
    $commentTable = Engine_Api::_()->getItemTable('core_comment');
    $comment_name = $commentTable->info('name');

    $comment_select = $commentTable->select()
      ->from($comment_name)
      ->where('resource_type = ?', 'sitebusiness_business')
      ->where('resource_id = ?', $business_id);

    if( !empty($values['startTime']) && !empty($values['endTime']) ) {
      $comment_select->where($comment_name . '.creation_date >= ?', gmdate('Y-m-d H:i:s', $values['startTime']))
        ->where($comment_name . '.creation_date < ?', gmdate('Y-m-d H:i:s', $values['endTime']));
    }
    return count($comment_select->query()->fetchAll());
  }

  // This function checks that whether comments have to be displayed in insights or not
  public function displayCommentInsights()
  {
    $userlayout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
    if( !empty($userlayout) ) {
      $ContentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
    } else {
      $ContentTable = Engine_Api::_()->getDbtable('content', 'core');
    }
    $select = $ContentTable->select()->where('name= ?', 'sitebusiness.info-sitebusiness')->limit(1);
    $infoWidget = $ContentTable->fetchRow($select);
    if( !empty($infoWidget) ) {
      return true;
    } else {
      return false;
    }
  }

  public function hasBusinessLike($RESOURCE_ID, $viewer_id)
  {
    if( empty($RESOURCE_ID) || empty($viewer_id) )
      return false;

    $sub_status_table = Engine_Api::_()->getItemTable('core_like');

    $sub_status_select = $sub_status_table->select()
      ->where('resource_type = ?', 'sitebusiness_business')
      ->where('resource_id = ?', $RESOURCE_ID)
      ->where('poster_id = ?', $viewer_id);
    $fetch_sub = $sub_status_table->fetchRow($sub_status_select);
    if( !empty($fetch_sub) )
      return true;
    else
      return false;
  }

  /**
   * check photo show in light box or not
   * */
  public function canShowPhotoLightBox()
  {
    global $sitebusinessalbum_isLightboxActive;
    if( empty($sitebusinessalbum_isLightboxActive) ) {
      return;
    } else {
      return SEA_SITEBUSINESSALBUM_LIGHTBOX;
    }
  }

  /**
   * check in case draft, not approved viewer can view business
   * */
  public function canViewBusiness($sitebusiness)
  {
    $can_view = true;
    if( empty($sitebusiness->draft) || (empty($sitebusiness->aprrove_date)) || (empty($sitebusiness->approved) && empty($sitebusiness->pending) ) || !empty($sitebusiness->declined) || ($this->hasPackageEnable() && $sitebusiness->expiration_date !== "2250-01-01 00:00:00" && strtotime($sitebusiness->expiration_date) < time()) ) {
      $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
      if( empty($isManageAdmin) ) {
        $can_view = false;
      }
    }
    return $can_view;
  }

  public function attachBusinessActivity($sitebusiness)
  {
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($sitebusiness->getOwner(), $sitebusiness, 'sitebusiness_new');

      if( $action != null ) {
        Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action, true);
        Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitebusiness);
      }

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
  }

  public function onBusinessDelete($business_id)
  {

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    if( empty($business_id) || empty($viewer_id) ) {
      return;
    }

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    Engine_Api::_()->getDbtable('locations', 'sitebusiness')->delete(array('business_id =?' => $business_id));

    //FETCH PHOTO AND OTHER BELONGINGS
    $table = Engine_Api::_()->getItemTable('sitebusiness_photo');
    $select = $table->select()->where('business_id = ?', $business_id);
    $rows = $table->fetchAll($select);
    if( !empty($rows) ) {
      foreach( $rows as $sitebusinessphoto ) {
        //DELETE PHOTO AND OTHER BELONGINGS
        $sitebusinessphoto->delete();
      }
    }

    $table = Engine_Api::_()->getItemTable('sitebusiness_album');
    $select = $table->select()->where('business_id = ?', $business_id);
    $rows = $table->fetchAll($select);
    if( !empty($rows) ) {
      foreach( $rows as $sitebusinessalbum ) {
        //DELETE ALBUM AND OTHER BELONGINGS
        $sitebusinessalbum->delete();
      }
    }

    //END BUSINESS-ALBUM CODE
    //START BUSINESS-BADGE CODE
    $sitebusinessbadgeEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge');
    if( $sitebusinessbadgeEnabled ) {
      //DELETE BADGE REQUESTS CORROSPONDING TO THAT BUSINESS ID
      Engine_Api::_()->getItemTable('sitebusinessbadge_badgerequest')->delete(array('business_id = ?' => $business_id));
    }
    //END BUSINESS-BADGE CODE
    //START BUSINESS-DISCUSSION CODE
    $sitebusinessDiscussionEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion');
    if( $sitebusinessDiscussionEnabled ) {

      $table = Engine_Api::_()->getItemTable('sitebusiness_topic');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);
      if( !empty($rows) ) {
        foreach( $rows as $topic ) {
          $topic->delete();
        }
      }

      $table = Engine_Api::_()->getItemTable('sitebusiness_post');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);
      if( !empty($rows) ) {
        foreach( $rows as $post ) {
          $post->delete();
        }
      }

      Engine_Api::_()->getDbtable('topicwatches', 'sitebusiness')->delete(array('business_id =?' => $business_id));
    }
    //END BUSINESS-DISCUSSION CODE
    //START BUSINESS-DOCUMENT CODE
    $sitebusinessdocumentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument');
    if( $sitebusinessdocumentEnabled ) {

      //FETCH DOCUMENTS CORROSPONDING TO THAT SITEBUSINESS ID
      $table = Engine_Api::_()->getItemTable('sitebusinessdocument_document');
      $select = $table->select()
        ->from($table->info('name'), 'document_id')
        ->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $document_ids ) {
          $document_id = $document_ids['document_id'];
          if( !empty($document_id) ) {
            Engine_Api::_()->sitebusinessdocument()->deleteContent($document_id);
          }
        }
      }
    }
    //END BUSINESS-DOCUMENT CODE
    //START BUSINESS-EVENT CODE
    $sitebusinesseventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent');
    if( $sitebusinesseventEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Business ID
      $table = Engine_Api::_()->getItemTable('sitebusinessevent_event');
      $select = $table->select()
        ->from($table->info('name'), 'event_id')
        ->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $event_ids ) {
          $event_id = $event_ids['event_id'];
          if( !empty($event_id) ) {
            //DELETE EVENT, ALBUM AND EVENT IMAGES
            Engine_Api::_()->sitebusinessevent()->deleteContent($event_id);
          }
        }
      }
    }
    //END BUSINESS-EVENT CODE
    //START ADVANCED-EVENT CODE
    $siteeventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent');
    if( $siteeventEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Business ID
      $table = Engine_Api::_()->getItemTable('siteevent_event');
      $select = $table->select()
        ->from($table->info('name'), 'event_id')
        ->where('parent_type = ?', 'sitebusiness_business')
        ->where('parent_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $event_ids ) {
          $resource = Engine_Api::_()->getItem('siteevent_event', $event_ids['event_id']);
          if( $resource )
            $resource->delete();
        }
      }
    }

    $sitevideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');
    if( $sitevideoEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Business ID
      $table = Engine_Api::_()->getItemTable('sitevideo_video');
      $select = $table->select()
        ->from($table->info('name'), 'video_id')
        ->where('parent_type = ?', 'sitebusiness_business')
        ->where('parent_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $video_ids ) {
          $resource = Engine_Api::_()->getItem('sitevideo_video', $video_ids['video_id']);
          if( $resource )
            $resource->delete();
        }
      }
    }

    $documentEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document');
    $documentintegrationEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('documentintegration');
    if( $documentEnabled && $documentintegrationEnabled) {
      $table = Engine_Api::_()->getItemTable('document');
      $select = $table->select()
        ->from($table->info('name'), 'document_id')
        ->where('parent_type = ?', 'sitebusiness_business')
        ->where('parent_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $document_ids ) {
          $resource = Engine_Api::_()->getItem('document', $document_ids['document_id']);
          if( $resource )
            $resource->delete();
        }
      }
    }

    $sitecrowdfundingEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding');
    if( $sitecrowdfundingEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Page ID
      $table = Engine_Api::_()->getItemTable('sitecrowdfunding_project');
      $select = $table->select()
        ->from($table->info('name'), 'project_id')
        ->where('parent_id = ?', $business_id)
        ->where('parent_type = ?', 'sitebusiness_business');
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $project_ids ) {
          $resource = Engine_Api::_()->getItem('sitecrowdfunding_project', $project_ids['project_id']);
          if( $resource && $resource->isbacked() ) {
            $resource->parent_type = 'user';
            $resource->save();
          } else if( $resource )
            $resource->delete();
        }
      }
    }

    $sitemusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic');
    if( $sitemusicEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Page ID
      $table = Engine_Api::_()->getItemTable('sitemusic_pl');
      $select = $table->select()
        ->from($table->info('name'), 'playlist_id')
        ->where('parent_id = ?', $business_id)
        ->where('parent_type = ?', 'sitebusiness_business');
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $album_ids ) {
          $resource = Engine_Api::_()->getItem('sitemusic_pl', $album_ids['playlist_id']);
          if( $resource && $resource->isbacked() ) {
            $resource->parent_type = 'user';
            $resource->save();
          } else if( $resource )
            $resource->delete();
        }
      }
    }

    //END ADVANCED-EVENT CODE
    //START BUSINESS-FORM CODE
    $sitebusinessFormEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform');
    if( $sitebusinessFormEnabled ) {
      $mapstable = Engine_Api::_()->fields()->getTable('sitebusinessform', 'maps');
      $optiontable = Engine_Api::_()->fields()->getTable('sitebusinessform', 'options');

      $businessquetion_table = Engine_Api::_()->getDbtable('businessquetions', 'sitebusinessform');
      $sitebusinessform_table = Engine_Api::_()->getDbtable('sitebusinessforms', 'sitebusinessform');
      $select = $businessquetion_table->select()->where('business_id =?', $business_id);
      $optionid = $businessquetion_table->fetchRow($select);
      $option_id = $optionid->option_id;
      if( !empty($option_id) ) {
        $matatable = Engine_Api::_()->fields()->getTable('sitebusinessform', 'meta');
        $select_options = $matatable->select()->where('option_id =?', $option_id);
        $select_options_result = $select_options->from($matatable->info('name'), array('field_id'));
        $result = $matatable->fetchAll($select_options_result)->toArray();
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
          foreach( $result as $key => $id ) {
            $field_id = $id['field_id'];
            $matatable->delete(array('field_id =?' => $field_id));
            $optiontable->delete(array('field_id =?' => $field_id));
          }
          $optiontable->delete(array('option_id =?' => $option_id));
          $businessquetion_table->delete(array('option_id =?' => $option_id));
          $mapstable->delete(array('option_id =?' => $option_id));
          $sitebusinessform_table->delete(array('business_id =?' => $business_id));
          $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }
      }
    }
    //END BUSINESS-FORM CODE
    //START BUSINESS-NOTE CODE
    $sitebusinessnoteEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote');
    if( $sitebusinessnoteEnabled ) {
      //FETCH Notes CORROSPONDING TO THAT Business ID
      $table = Engine_Api::_()->getItemTable('sitebusinessnote_note');
      $select = $table->select()
        ->from($table->info('name'), 'note_id')
        ->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select)->toArray();
      if( !empty($rows) ) {
        foreach( $rows as $key => $note_ids ) {
          $note_id = $note_ids['note_id'];
          if( !empty($note_id) ) {

            //DELETE NOTE, ALBUM AND NOTE IMAGES
            Engine_Api::_()->sitebusinessnote()->deleteContent($note_id);
          }
        }
      }
    }
    //END BUSINESS-NOTE CODE
    //START BUSINESS-OFFER CODE
    $sitebusinessofferEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer');
    if( $sitebusinessofferEnabled ) {
      //FETCH Offers CORROSPONDING TO THAT Business ID
      $table = Engine_Api::_()->getItemTable('sitebusinessoffer_offer');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);
      if( !empty($rows) ) {
        foreach( $rows as $sitebusinessoffer ) {
          Engine_Api::_()->sitebusinessoffer()->deleteContent($sitebusinessoffer->offer_id);
        }
      }
    }
    //END BUSINESS-OFFER CODE
    //START BUSINESS-POLL CODE
    $sitebusinesspollEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll');
    if( $sitebusinesspollEnabled ) {
      //FETCH POLLS CORROSPONDING TO THAT GROUP ID
      $table = Engine_Api::_()->getItemTable('sitebusinesspoll_poll');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);
      if( !empty($rows) ) {
        foreach( $rows as $sitebusinesspoll ) {
          //DELETE POLL AND OTHER BELONGINGS
          $sitebusinesspoll->delete();
        }
      }
    }
    //END BUSINESS-POLL CODE
    //START BUSINESS-REVIEW CODE
    $sitebusinessreviewEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');
    if( $sitebusinessreviewEnabled ) {

      //FETCH REVIEWS
      $table = Engine_Api::_()->getItemTable('sitebusinessreview_review');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);

      if( !empty($rows) ) {
        foreach( $rows as $review ) {
          Engine_Api::_()->sitebusinessreview()->deleteContent($review->review_id);
        }
      }
    }
    //END BUSINESS-REVIEW CODE
    //START BUSINESS-WISHLIST CODE
    $sitebusinesswishlistEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesswishlist');
    if( $sitebusinesswishlistEnabled ) {
      Engine_Api::_()->getDbtable('business', 'sitebusinesswishlist')->delete(array('business_id =?' => $business_id));
    }
    //END BUSINESS-WISHLIST CODE
    //START BUSINESS-VIDEO CODE
    $sitebusinessvideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo');
    if( $sitebusinessvideoEnabled ) {
      //FETCH VIDEOS CORROSPONDING TO THAT SITEBUSINESS ID


      $table = Engine_Api::_()->getItemTable('sitebusinessvideo_video');
      $select = $table->select()->where('business_id = ?', $business_id);
      $rows = $table->fetchAll($select);
      if( !empty($rows) ) {
        foreach( $rows as $video ) {
          //DELETE VIDEO AND OTHER BELONGINGS
          Engine_Api::_()->getDbtable('ratings', 'sitebusinessvideo')->delete(array('video_id = ?' => $video->video_id));
          $video->delete();
        }
      }
    }
    //END BUSINESS-VIDEO CODE
    //START BUSINESS-MUSIC CODE
    $sitebusinessmusicEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic');
    if( $sitebusinessmusicEnabled ) {
      //FETCH PLAYLIST CORROSPONDING TO THAT BUSINESS ID
      $playlistTable = Engine_Api::_()->getDbtable('playlists', 'sitebusinessmusic');
      $playlistSelect = $playlistTable->select()->where('business_id = ?', $business_id);
      foreach( $playlistTable->fetchAll($playlistSelect) as $playlist ) {
        foreach( $playlist->getSongs() as $song ) {
          $song->deleteUnused();
        }
        $playlist->delete();
      }
    }
    //END BUSINESS-MUSIC CODE
    //START BUSINESS-MEMBER CODE
    $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    if( $sitebusinessmemberEnabled ) {
      $membershipTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
      $membershipTable->delete(array('resource_id =?' => $business_id, 'business_id =?' => $business_id));
    }
    //END BUSINESS-MUSIC CODE
    //FINALLY START BUSINESS CODE

    $searchTable = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'search');
    $valuesTable = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'values');

    $businessestatisticsTable = Engine_Api::_()->getDbtable('businessstatistics', 'sitebusiness');

    $writesTable = Engine_Api::_()->getDbtable('writes', 'sitebusiness');
    $listsTable = Engine_Api::_()->getDbtable('lists', 'sitebusiness');

    //$viewedsTable = Engine_Api::_()->getDbtable('vieweds', 'sitebusiness');
    $manageadminsTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');

    $locationsTable = Engine_Api::_()->getDbtable('locations', 'sitebusiness');

    $authAllowTable = Engine_Api::_()->getDbtable('allow', 'authorization');
    $claimTable = Engine_Api::_()->getDbtable('claims', 'sitebusiness');
    $sitebusinessitemofthedaysTable = Engine_Api::_()->getDbtable('itemofthedays', 'sitebusiness');

    $layoutcontentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
    $layoutcontentbusinessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
    //GETTING THE CONTENTBUSINESS ID FROM CONTENTBUSINESSES TABLE SO THAT WE CAN REMOVE THE CONTENT FROM CONTENT TABLE ALSO.
    $LayoutContentBusinessName = $layoutcontentbusinessTable->info('name');

    $select = $layoutcontentbusinessTable->select()->from($LayoutContentBusinessName, 'contentbusiness_id')->where('business_id = ?', $business_id);
    $LayoutContentBusinessid = $layoutcontentbusinessTable->fetchRow($select);
    if( !empty($LayoutContentBusinessid) ) {
      $LayoutContentBusinessid = $LayoutContentBusinessid->toarray();
    }

    $searchTable->delete(array('item_id =?' => $business_id));
    $valuesTable->delete(array('item_id =?' => $business_id));
    $writesTable->delete(array('business_id =?' => $business_id));
    $listsTable->delete(array('business_id =?' => $business_id));
    $businessestatisticsTable->delete(array('business_id =?' => $business_id));

    // $viewedsTable->delete(array('business_id =?' => $business_id));
    $manageadminsTable->delete(array('business_id =?' => $business_id));
    $locationsTable->delete(array('business_id =?' => $business_id));

    $sitebusinessitemofthedaysTable->delete(array('resource_id =?' => $business_id, 'resource_type' => 'sitebusiness_business'));

    $authAllowTable->delete(array('resource_id =?' => $business_id, 'resource_type =?' => 'sitebusiness_business'));
    $claimTable->delete(array('business_id =?' => $business_id));

    //DELETE FIELD ENTRIES IF EXISTS
    $fieldvalueTable = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'values');
    $fieldvalueTable->delete(array(
      'item_id = ?' => $business_id,
    ));

    $fieldsearchTable = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'search');
    $fieldsearchTable->delete(array(
      'item_id = ?' => $business_id,
    ));

    if( !empty($LayoutContentBusinessid) ) {
      $layoutcontentTable->delete(array('contentbusiness_id =?' => $LayoutContentBusinessid['contentbusiness_id']));
    }

    $layoutcontentbusinessTable->delete(array('business_id =?' => $business_id));
    $sitebusiness->cancel();
    $sitebusiness->delete();

    //END BUSINESS CODE
  }

  public function isEnabledModPackage($mod)
  {
    if( !empty($mod) ) {
      $arrayName = 'sitebusiness.mod.types';
    } else {
      $arrayName = 'sitebusiness.mod.settings';
    }
    return Engine_Api::_()->getApi('settings', 'core')->getSetting($arrayName, null);
  }

  public function isModulesActivated()
  {
    $businessModArray = array(
      'sitebusinessalbum' => 'Directory / Businesses - Albums Extension',
      'sitebusinessbadge' => 'Directory / Businesses - Badges Extension',
      'sitebusinessdocument' => 'Directory / Businesses - Documents Extension',
      'sitebusinessevent' => 'Directory / Businesses - Events Extension',
      'sitebusinessform' => 'Directory / Businesses - Form Extension',
      'sitebusinessinvite' => 'Directory / Businesses - Inviter Extension',
      'sitebusinessnote' => 'Directory / Businesses - Notes Extension',
      'sitebusinessoffer' => 'Directory / Businesses - Offers Extension',
      'sitebusinesspoll' => 'Directory / Businesses - Polls Extension',
      'sitebusinessreview' => 'Directory / Businesses - Reviews and Ratings Extension',
      'sitebusinessvideo' => 'Directory / Businesses - Videos Extension',
      'sitebusinessmusic' => 'Directory / Businesses - Music Extension',
      'sitebusinessmember' => 'Directory / Businesses - Business Members Extension',
      'sitebusinesslikebox' => 'Directory / Businesses - Like Box',
      'communityad' => 'Advertisements / Community Ads Plugin',
      'sitebusinessintegration' => 'Directory / Businesses - Multiple Listings and Products Showcase Extension',
      'siteevent' => 'Advanced Events',
      'sitevideo' => 'Advanced Videos',
      'document' => 'Documents',
      'sitecrowdfunding' => 'Crowdfunding / Donation',
      'sitemusic' => 'Advanced Music'
    );
    $notActivatedModArray = array();
    foreach( $businessModArray as $modNameKey => $modNameValue ) {
      $isModuleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($modNameKey);
      if( $modNameKey == 'communityad' ) {
        $isModuleActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting('communityad.navi.auth', null);
      } else {
        $isModuleActivate = Engine_Api::_()->getApi('settings', 'core')->getSetting($modNameKey . '.isActivate', null);
      }
      //Condition: If Plugin enabled but not activated.
      if( !empty($isModuleEnabled) && empty($isModuleActivate) ) {
        $notActivatedModArray[$modNameKey] = $modNameValue;
      }
    }
    return $notActivatedModArray;
  }

  public function isEnabled()
  {
    $hostType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.viewbusiness.sett', 0);
    $hostName = convert_uudecode($hostType);
    if( $hostName == 'localhost' || strpos($hostName, '192.168.') != false || strpos($hostName, '127.0.') != false ) {
      return;
    }

    return 1;
  }

  public function isPluginActivate($modName)
  {
    return (bool) Engine_Api::_()->getApi('settings', 'core')->getSetting($modName . '.isActivate', 0);
  }

  /**
   *  CHECK Payment PLUGIN ENABLE / DISABLE
   * */
  public function enablePaymentPlugin()
  {
    return Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('payment');
  }

  /**
   *  Check Viewer able to edit style
   * */
  public function allowStyle()
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    if( !empty($viewer_id) ) {
      return (bool) Engine_Api::_()->getDbtable('permissions', 'authorization')->getAllowed('sitebusiness_business', $viewer->level_id, 'style');
    } else {
      return (bool) 0;
    }
  }

  /**
   * get viewer like businesses
   */
  public function getMyLikeBusinesses($params = array())
  {
//    $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
//    $likeName = $likeTable->info('name');
//    $select = $likeTable->select()
//            ->where($likeName . '.poster_id = ?', $params['poster_id'])
//            ->where($likeName . '.poster_type = ?', $params['poster_type'])
//            ->where($likeName . '.resource_type = ?', $params['resource_type'])
//            ->order($likeName . '.creation_date DESC');
//    return $likeTable->fetchAll($select);
  }

  /**
   * Gets member like businesses
   *
   * $member User_Model_User
   */
  public function getMemberLikeBusinessesOfIds($member)
  {
    $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
    $likeName = $likeTable->info('name');
    return $select = $likeTable->select()
      ->from($likeName, "resource_id")
      ->where($likeName . '.poster_id = ?', $member->getIdentity())
      ->where($likeName . '.poster_type = ?', $member->getType())
      ->where($likeName . '.resource_type = ?', 'sitebusiness_business')
      ->order($likeName . '.creation_date DESC')
      ->query()
      ->fetchAll(Zend_Db::FETCH_COLUMN);
    ;
  }

  /**
   * Gets feed for which viewer like
   *
   * @$user User_Model_User
   * @param array $params
   */
  public function getFeedActionLikedBusinesses(User_Model_User $user, array $params = array())
  {
//    $ids = array();
//    if (!(bool) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.likebusiness', 0))
//      return $ids;
//    $getMyLikes = $this->getMyLikeBusinesses(array("poster_type" => $user->getType(), "poster_id" => $user->getIdentity(), "resource_type" => "sitebusiness_business"));
//    $count = count($getMyLikes);
//
//    if (!empty($count)) {
//      $resource_ids = array();
//      foreach ($getMyLikes as $likeItems) {
//        $resource_ids[] = $likeItems->resource_id;
//      }
//
//      if (!empty($resource_ids)) {
//        //Proc args
//        extract($params); //action_id, limit, min_id, max_id
//        $actionDbTable = Engine_Api::_()->getDbtable('actions', 'activity');
//        $typesAdmin = array("sitebusiness_post_self", "sitebusinessalbum_admin_photo_new", "sitebusinessvideo_admin_new", "sitebusinessevent_admin_new", "sitebusinessnote_admin_new", "sitebusinesspoll_admin_new", "sitebusinessdocument_admin_new", "sitebusinessoffer_admin_new", "sitebusiness_admin_topic_create", "sitebusinessmusic_admin_new", "sitebusiness_profile_photo_update");
//        $select = $actionDbTable->select()
//                ->where("type in (?)", new Zend_Db_Expr("'" . join("', '", $typesAdmin) . "'"))
//                ->where("subject_type = ? ", "sitebusiness_business")
//                ->where("subject_id IN(?)", new Zend_Db_Expr(join(',', $resource_ids)))
//                ->order('action_id DESC')
//                ->limit($limit);
//
//        if (null !== $action_id) {
//          $select->where('action_id = ?', $action_id);
//        } else {
//          if (null !== $min_id) {
//            $select->where('action_id >= ?', $min_id);
//          } else if (null !== $max_id) {
//            $select->where('action_id <= ?', $max_id);
//          }
//        }
//        $results = $actionDbTable->fetchAll($select);
//        foreach ($results as $actionData)
//          $ids[] = $actionData->action_id;
//      }
//    }
//    return $ids;
  }

  /**
   * Gets feed type business title and photo is enable
   *
   * @return bool
   */
  public function isFeedTypeBusinessEnable()
  {
    return (bool) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.type', 0);
  }

  /**
   * Set default widget in core businesses table
   *
   * @param object $table
   * @param string $tablename
   * @param int $business_id
   * @param string $type
   * @param string $widgetname
   * @param int $middle_id
   * @param int $order
   * @param string $title
   * @param int $titlecount
   */
  function setDefaultDataWidget($table, $tablename, $business_id, $type, $widgetname, $middle_id, $order, $title = null, $titlecount = null, $advanced_activity_params = null)
  {

    $selectWidgetId = $table->select()
      ->where('business_id =?', $business_id)
      ->where('type = ?', $type)
      ->where('name = ?', $widgetname)
      ->where('parent_content_id = ?', $middle_id)
      ->limit(1);
    $fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
    if( empty($fetchWidgetContentId) ) {
      $contentWidget = $table->createRow();
      $contentWidget->business_id = $business_id;
      $contentWidget->type = $type;
      $contentWidget->name = $widgetname;
      $contentWidget->parent_content_id = $middle_id;
      $contentWidget->order = $order;
      if( empty($advanced_activity_params) && $title && $titlecount ) {
        $contentWidget->params = "{\"title\":\"$title\",\"titleCount\":$titlecount}";
      } else {
        $contentWidget->params = "$advanced_activity_params";
      }
      $contentWidget->save();
    }
  }

  /**
   * Return business paginator
   *
   * @param int $total_items
   * @param int $items_per_business
   * @param int $p
   * @return paginator
   */
  public function makeBusiness($total_items, $items_per_business, $p)
  {
    if( !$items_per_business )
      $items_per_business = 1;
    $maxbusiness = ceil($total_items / $items_per_business);
    if( $maxbusiness <= 0 )
      $maxbusiness = 1;
    $p = ( ($p > $maxbusiness) ? $maxbusiness : ( ($p < 1) ? 1 : $p ) );
    $start = ($p - 1) * $items_per_business;
    return array($start, $p, $maxbusiness);
  }

  /**
   * Return count
   *
   * @param string $tablename
   * @param string $modulename
   * @param int $business_id
   * @param int $title_count
   * @return paginator
   */
  public function getTotalCount($business_id, $modulename, $tablename)
  {

    if( $modulename == 'siteevent' || $modulename == 'sitevideo' || $modulename == 'document' || $modulename == 'sitecrowdfunding' || $modulename == 'sitemusic' ) {
      $table = Engine_Api::_()->getDbtable($tablename, $modulename);
      $count = 0;
      $select = $table->select();
      $currentDate = date('Y-m-d H:i:s');
      $select->from($table->info('name'), array('count(*) as count'))
        ->where("parent_type = ?", 'sitebusiness_business')
        ->where("parent_id =?", $business_id);
      if( $modulename == 'sitecrowdfunding' ) {
        $select->where("approved =?", 1)
          ->where("state <> ?", 'draft')
          ->where("is_gateway_configured = ?", 1)
          ->where("start_date <= '$currentDate'");
      }
      $count = $select->query()->fetchColumn();
    } else {
      $table = Engine_Api::_()->getDbtable($tablename, $modulename);
      $count = 0;
      $select = $table
        ->select()
        ->from($table->info('name'), array('count(*) as count'))
        ->where("business_id = ?", $business_id);

      if( $tablename == 'albums' && !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1) ) {
        $select->where($table->info('name') . '.default_value' . '= ?', 0);
        $select->where($table->info('name') . ".type is Null");
      }

      $count = $select->query()->fetchColumn();
    }
    return $count;
  }

  /**
   * Return tabid
   *
   * @param string $widgetname
   * @param int $business_id
   * @param int $layout
   * @return tabid
   */
  public function GetTabIdinfo($widgetname, $businessid, $layout)
  {

    global $sitebusiness_GetTabIdType;
    $tab_id = '';
    if( !Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') ) {
      if( !$layout ) {
        if( Engine_Api::_()->sitemobile()->checkMode('mobile-mode') ) {
          $tablecontent = Engine_Api::_()->getDbtable('content', 'sitemobile');
          $select = $tablecontent->select()
            ->from($tablecontent->info('name'), 'content_id')
            ->where('name = ?', $widgetname)
            ->limit(1);
          $tab_id = $select->query()->fetchColumn();
        } elseif( Engine_Api::_()->sitemobile()->checkMode('tablet-mode') ) {
          $tablecontent = Engine_Api::_()->getDbtable('tabletcontent', 'sitemobile');
          $select = $tablecontent->select()
            ->from($tablecontent->info('name'), 'content_id')
            ->where('name = ?', $widgetname)
            ->limit(1);
          $tab_id = $select->query()->fetchColumn();
        }
      } else {
        $table = Engine_Api::_()->getDbtable('mobileContentbusinesses', 'sitebusiness');
        $select = $table->select()
          ->from($table->info('name'), 'mobilecontentbusiness_id')
          ->where('name = ?', 'sitebusiness_index_view')
          ->where('business_id = ?', $businessid)
          ->limit(1);
        $mobilecontentbusiness_id = $select->query()->fetchColumn();
        if( $mobilecontentbusiness_id ) {

          $tablecontent = Engine_Api::_()->getDbtable('mobileContent', 'sitebusiness');
          $select = $tablecontent->select()
            ->from($tablecontent->info('name'), 'mobilecontent_id')
            ->where('name = ?', $widgetname)
            ->where('mobilecontentbusiness_id = ?', $mobilecontentbusiness_id)
            ->limit(1);
          $tab_id = $select->query()->fetchColumn();
        } else {
          $business_id = $this->getMobileWidgetizedBusiness()->page_id;
          if( !empty($business_id) ) {
            $tablecontent = Engine_Api::_()->getDbtable('mobileadmincontent', 'sitebusiness');
            $select = $tablecontent->select()
              ->from($tablecontent->info('name'), 'mobileadmincontent_id')
              ->where('name = ?', $widgetname)
              ->where('business_id = ?', $business_id)
              ->limit(1);
            $tab_id = $select->query()->fetchColumn();
          }
        }
      }
      return $tab_id;
    }

    if( !$layout ) {
      $tablecontent = Engine_Api::_()->getDbtable('content', 'core');
      $select = $tablecontent->select()
        ->from($tablecontent->info('name'), 'content_id')
        ->where('name = ?', $widgetname)
        ->where('page_id = ?', $this->getWidgetizedBusiness()->page_id)
        ->limit(1);
      $tab_id = $select->query()->fetchColumn();
    } else {

      $table = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
      $select = $table->select()
        ->from($table->info('name'), 'contentbusiness_id')
        ->where('name = ?', 'sitebusiness_index_view')
        ->where('business_id = ?', $businessid)
        ->limit(1);
      $contentbusiness_id = $select->query()->fetchColumn();
      if( $contentbusiness_id ) {

        $tablecontent = Engine_Api::_()->getDbtable('content', 'sitebusiness');
        $select = $tablecontent->select()
          ->from($tablecontent->info('name'), 'content_id')
          ->where('name = ?', $widgetname)
          ->where('contentbusiness_id = ?', $contentbusiness_id)
          ->limit(1);
        $tab_id = $select->query()->fetchColumn();
      } else {
        $business_id = $this->getWidgetizedBusiness()->page_id;
        if( !empty($business_id) ) {
          $tablecontent = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
          $select = $tablecontent->select()
            ->from($tablecontent->info('name'), 'admincontent_id')
            ->where('name = ?', $widgetname)
            ->where('business_id = ?', $business_id)
            ->limit(1);
          $tab_id = $select->query()->fetchColumn();
        }
      }
    }

    return $sitebusiness_GetTabIdType ? $tab_id : $sitebusiness_GetTabIdType;
  }

  /**
   * Gets widgetized business
   *
   * @return Zend_Db_Table_Select
   */
  public function getWidgetizedBusiness()
  {

    //GET CORE BUSINESS TABLE
    $tableNameBusiness = Engine_Api::_()->getDbtable('pages', 'core');
    $select = $tableNameBusiness->select()
      ->from($tableNameBusiness->info('name'), array('page_id', 'description', 'keywords'))
      ->where('name =?', 'sitebusiness_index_view')
      ->limit(1);

    return $tableNameBusiness->fetchRow($select);
  }

  /**
   * Return parse string
   *
   * @param string $content
   * @return parse string
   */
  public function parseString($content)
  {
    return str_replace("'", "\'", trim($content));
  }

  /**
   * Return option of showing the widget of third type layout
   *
   * @param int $business_id
   * @param int $layout
   * @return third type layout show or not
   */
  public function getwidget($layout, $business_id)
  {
    if( !$layout ) {
      $business_id = $this->getWidgetizedBusiness()->page_id;
      if( !empty($business_id) ) {
        $table = Engine_Api::_()->getDbtable('content', 'core');
        $selectContent = $table->select()
          ->from($table->info('name'), 'page_id')
          ->where("name IN ('core.container-tabs', 'sitebusiness.widgetlinks-sitebusiness')")
          ->where('page_id =?', $business_id)
          ->limit(1);
        $contentinfo = $selectContent->query()->fetchAll();
        if( empty($contentinfo) ) {
          $contentinformation = 0;
        } else {
          $contentinformation = 1;
        }
      }
    } else {
      $table = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
      $select = $table->select()
        ->from($table->info('name'), 'contentbusiness_id')
        ->where('name = ?', 'sitebusiness_index_view')
        ->where('business_id = ?', $business_id)
        ->limit(1);
      $row = $table->fetchRow($select);
      if( $row !== null ) {
        $business_id = $row->contentbusiness_id;
        $table = Engine_Api::_()->getDbtable('content', 'sitebusiness');
        $selectContent = $table->select()
          ->from($table->info('name'), 'contentbusiness_id')
          ->where("name IN ('core.container-tabs', 'sitebusiness.widgetlinks-sitebusiness')")
          ->where('contentbusiness_id =?', $business_id);
        $contentinfo = $selectContent->query()->fetchAll();
        if( !empty($contentinfo) ) {
          $contentinformation = 1;
        } else {
          $contentinformation = 0;
        }
      } else {
        $business_id = $this->getWidgetizedBusiness()->page_id;
        $table = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
        $selectContent = $table->select()
          ->from($table->info('name'), 'business_id')
          ->where("name IN ('core.container-tabs', 'sitebusiness.widgetlinks-sitebusiness')")
          ->where('business_id =?', $business_id);
        $contentinfo = $selectContent->query()->fetchAll();
        if( !empty($contentinfo) ) {
          $contentinformation = 1;
        } else {
          $contentinformation = 0;
        }
      }
    }
    return $contentinformation;
  }

  /**
   * Return option of showing the top title for widgets
   *
   * @param int $business_id
   * @param int $layout
   * @return top title show or not
   */
  public function showtoptitle($layout, $business_id)
  {
    if( !$layout ) {
      $business_id = $this->getWidgetizedBusiness()->page_id;
      if( !empty($business_id) ) {
        $table = Engine_Api::_()->getDbtable('content', 'core');
        $tablename = $table->info('name');
        $selectContent = $table->select()
          ->from($table->info('name'), 'page_id')
          ->where('name =?', 'core.container-tabs')
          ->where('page_id =?', $business_id)
          ->limit(1);
        $contentinfo = $selectContent->query()->fetchAll();
        if( empty($contentinfo) ) {
          $contentinformation = 1;
        } else {
          $contentinformation = 0;
        }
      }
    } else {
      $table = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
      $select = $table->select()
        ->from($table->info('name'), 'contentbusiness_id')
        ->where('name = ?', 'sitebusiness_index_view')
        ->where('business_id =?', $business_id)
        ->limit(1);
      $row = $table->fetchRow($select);
      if( $row !== null ) {
        $business_id = $row->contentbusiness_id;
        $table = Engine_Api::_()->getDbtable('content', 'sitebusiness');
        $selectContent = $table->select()
          ->from($table->info('name'), 'contentbusiness_id')
          ->where('name =?', 'core.container-tabs')
          ->where('contentbusiness_id =?', $business_id)
          ->limit(1);
        $contentinfo = $selectContent->query()->fetchAll();
        if( empty($contentinfo) ) {
          $contentinformation = 1;
        } else {
          $contentinformation = 0;
        }
      } else {
        $business_id = $this->getWidgetizedBusiness()->page_id;
        $table = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
        $selectContent = $table->select()
            ->from($table->info('name'), 'business_id')
            ->where('name =?', 'core.container-tabs')
            ->where('business_id =?', $business_id)->limit(1);
        ;
        $contentinfo = $selectContent->query()->fetchAll();
        if( empty($contentinfo) ) {
          $contentinformation = 1;
        } else {
          $contentinformation = 0;
        }
      }

      return $contentinformation;
    }
  }

  /**
   * Return true or false for ad show on paid businesses
   *
   * @param object $sitebusiness
   * @return true or false
   */
  public function showAdWithPackage($sitebusiness)
  {
    if( !Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad') || !Engine_Api::_()->getApi('settings', 'core')->getSetting('communityad.isActivate', 1) ) {
      return 0;
    }
    $params = array();
    $params['lim'] = 1;
    $fetch_community_ads = Engine_Api::_()->communityad()->getAdvertisement($params);
    if( empty($fetch_community_ads) )
      return 0;

    $package = $sitebusiness->getPackage();

    if( isset($package->ads) ) {
      return (bool) $package->ads;
    } else {
      if( Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.communityads', 1) ) {
        return (bool) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.adwithpackage', 1);
      } else {
        return 0;
      }
    }
  }

  public function getModulelabel($title)
  {

    $menuitemsTable = Engine_Api::_()->getDbtable('menuItems', 'core');
    $selectMenuitemsTable = $menuitemsTable->select()->where('name =?', "core_admin_main_plugins_$title");
    $resultMenuitems = $menuitemsTable->fetchRow($selectMenuitemsTable);
    return $resultMenuitems;
  }

  public function getBannedUrls()
  {
    $merge_array = array();
    $pageUrlFinalArray = array();
    $groupUrlFinalArray = array();
    $storeUrlFinalArray = array();
    $staticpageUrlFinalArray = array();
    $bannedPageurlsTable = Engine_Api::_()->getDbtable('BannedPageurls', 'seaocore');
    $urlArray = $bannedPageurlsTable->select()->from($bannedPageurlsTable, 'word')
        ->query()->fetchAll(Zend_Db::FETCH_COLUMN);

    $enableSitepage = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');

    if( $enableSitepage ) {
      $pageTable = Engine_Api::_()->getDbtable('pages', 'sitepage');
      $pageUrlArray = $pageTable->select()->from($pageTable, 'page_url')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      foreach( $pageUrlArray as $url ) {
        $pageUrlFinalArray[] = strtolower($url);
      }
      $merge_array = array_merge($urlArray, $pageUrlFinalArray);
    } else {
      $merge_array = $urlArray;
    }

    $enableSitegroup = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    if( $enableSitegroup ) {
      $groupTable = Engine_Api::_()->getDbtable('groups', 'sitegroup');
      $groupUrlArray = $groupTable->select()->from($groupTable, 'group_url')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      foreach( $groupUrlArray as $url ) {
        $groupUrlFinalArray[] = strtolower($url);
      }
      $merge_array = array_merge($merge_array, $groupUrlFinalArray);
    }

    $enableSitestore = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestore');
    if( $enableSitestore ) {
      $storeTable = Engine_Api::_()->getDbtable('stores', 'sitestore');
      $storeUrlArray = $storeTable->select()->from($storeTable, 'store_url')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      foreach( $storeUrlArray as $url ) {
        $storeUrlFinalArray[] = strtolower($url);
      }
      $merge_array = array_merge($merge_array, $storeUrlFinalArray);
    }

    $enableSitestaticpage = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestaticpage');
    if( $enableSitestaticpage ) {
      $staticpageTable = Engine_Api::_()->getDbtable('pages', 'sitestaticpage');
      $staticpageUrlArray = $staticpageTable->select()->from($staticpageTable, 'page_url')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
      foreach( $staticpageUrlArray as $url ) {
        $staticpageUrlFinalArray[] = strtolower($url);
      }
      $merge_array = array_merge($merge_array, $staticpageUrlFinalArray);
    }

    return $merge_array;
  }

  /**
   * Return tabid
   *
   * @param string $widgetname
   * @param int $business_id
   * @param int $layout
   * @return tabid
   */
  public function getTabIdInfoIntegration($widgetname, $businessid, $layout, $resource_type = null)
  {

    global $sitebusiness_GetTabIdType;
    $tab_id = '';
    if( !$layout ) {
      $tablecontent = Engine_Api::_()->getDbtable('content', 'core');
      $select = $tablecontent->select()
        ->from($tablecontent->info('name'), 'content_id')
        ->where('name = ?', $widgetname);

      if( !empty($resource_type) ) {
        $select->where('params LIKE ?', '%' . $resource_type . '%');
      }

      $select->order('order ASC')->limit(1);
      $tab_id = $select->query()->fetchColumn();
    } else {
      $table = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
      $select = $table->select()
        ->from($table->info('name'), 'contentbusiness_id')
        ->where('name = ?', 'sitebusiness_index_view')
        ->where('business_id = ?', $businessid)
        ->limit(1);
      $contentbusiness_id = $select->query()->fetchColumn();
      if( $contentbusiness_id ) {
        $tablecontent = Engine_Api::_()->getDbtable('content', 'sitebusiness');
        $select = $tablecontent->select()
          ->from($tablecontent->info('name'), 'content_id')
          ->where('name = ?', $widgetname)
          ->where('contentbusiness_id = ?', $contentbusiness_id);

        if( !empty($resource_type) ) {
          $select->where('params LIKE ?', '%' . $resource_type . '%');
        }

        $select->order('order ASC')->limit(1);
        $tab_id = $select->query()->fetchColumn();
      } else {
        $business_id = $this->getWidgetizedBusiness()->page_id;
        $tablecontent = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
        $select = $tablecontent->select()
          ->from($tablecontent->info('name'), 'admincontent_id')
          ->where('name = ?', $widgetname)
          ->where('business_id = ?', $business_id);

        if( !empty($resource_type) ) {
          $select->where('params LIKE ?', '%' . $resource_type . '%');
        }

        $select->order('order ASC')->limit(1);
        $tab_id = $select->query()->fetchColumn();
      }
    }

    return $sitebusiness_GetTabIdType ? $tab_id : $sitebusiness_GetTabIdType;
  }

  public function getBannedBusinessUrls()
  {

    $merge_array = array();
    // GET THE ARRAY OF BANNED BUSINESSURLS
    if( !defined('SITEBUSINESS_BANNED_URLS') ) {
      $bannedPageurlsTable = Engine_Api::_()->getDbtable('BannedPageurls', 'seaocore');
      $urlArray = $bannedPageurlsTable->select()->from($bannedPageurlsTable, 'word')
          ->query()->fetchAll(Zend_Db::FETCH_COLUMN);

      $enableSitepage = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');

      if( $enableSitepage ) {
        $pageTable = Engine_Api::_()->getDbtable('pages', 'sitepage');
        $pageUrlArray = $pageTable->select()->from($pageTable, 'page_url')
            ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
        $merge_array = array_merge($urlArray, $pageUrlArray);
      } else {
        $merge_array = $urlArray;
      }

      $enableSitegroup = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
      if( $enableSitegroup ) {
        $groupTable = Engine_Api::_()->getDbtable('groups', 'sitegroup');
        $groupUrlArray = $groupTable->select()->from($groupTable, 'group_url')
            ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
        $merge_array = array_merge($merge_array, $groupUrlArray);
      }

      $enableSitestore = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestore');
      if( $enableSitestore ) {
        $storeTable = Engine_Api::_()->getDbtable('stores', 'sitestore');
        $storeUrlArray = $storeTable->select()->from($storeTable, 'store_url')
            ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
        $merge_array = array_merge($merge_array, $storeUrlArray);
      }

      $enableSitestaticpage = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestaticpage');
      if( $enableSitestaticpage ) {
        $staticpageTable = Engine_Api::_()->getDbtable('pages', 'sitestaticpage');
        $staticpageUrlArray = $staticpageTable->select()->from($staticpageTable, 'page_url')
            ->query()->fetchAll(Zend_Db::FETCH_COLUMN);
        $merge_array = array_merge($merge_array, $staticpageUrlArray);
      }

      define('SITEBUSINESS_BANNED_URLS', serialize($merge_array));
    }
    return $banneUrlArray = unserialize(SITEBUSINESS_BANNED_URLS);
  }

  public function isLessThan417AlbumModule()
  {
    $businessalbumModule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitebusinessalbum');
    $businessalbumModuleVersion = $businessalbumModule->version;
    if( empty(Engine_Api::_()->seaocore()->checkVersion($businessalbumModuleVersion, '4.1.7')) ) {
      return true;
    } else {
      return false;
    }
  }

  //ACTION FOR LIKES
  public function autoLike($resource_id, $resource_type)
  {

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GETTING THE VALUE OF RESOURCE ID AND RESOURCE TYPE
// 		$resource_id = $this->_getParam('resource_id');
// 		$resource_type = $this->_getParam('resource_type');

    if( empty($viewer_id) ) {
      return;
    }

    $likeTable = Engine_Api::_()->getItemTable('core_like');
    $likeTableName = $likeTable->info('name');
    $sub_status_select = $likeTable->select()
      ->from($likeTableName, new Zend_Db_Expr('COUNT(*)'))
      ->where('resource_type = ?', $resource_type)
      ->where('resource_id = ?', $resource_id)
      ->where('poster_type =?', $viewer->getType())
      ->where('poster_id =?', $viewer_id)
      ->limit(1);
    $like_id = (integer) $sub_status_select->query()->fetchColumn();

    //GET THE VALUE OF LIKE ID
    //$like_id = $this->_getParam('like_id');
    //$status = $this->_getParam('smoothbox', 1);
    //$this->view->status = true;
    //GET LIKES.
    $likeTable = Engine_Api::_()->getDbTable('likes', 'core');
    $resource = Engine_Api::_()->getItem($resource_type, $resource_id);

    //CHECK FOR LIKE ID
    if( empty($like_id) ) {

      //CHECKING IF USER HAS MAKING DUPLICATE ENTRY OF LIKING AN APPLICATION.
      $like_id_temp = Engine_Api::_()->sitebusiness()->checkAvailability($resource_type, $resource_id);
      if( empty($like_id_temp[0]['like_id']) ) {

        if( !empty($resource) ) {
          $like_id = $likeTable->addLike($resource, $viewer);
          if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelike') )
            Engine_Api::_()->sitelike()->setLikeFeed($viewer, $resource);
        }

        $notify_table = Engine_Api::_()->getDbtable('notifications', 'activity');
        $db = $likeTable->getAdapter();
        $db->beginTransaction();
        try {

          //CREATE THE NEW ROW IN TABLE
          if( !empty($getOwnerId) && $getOwnerId != $viewer_id ) {

            $notifyData = $notify_table->createRow();
            $notifyData->user_id = $getOwnerId;
            $notifyData->subject_type = $viewer->getType();
            $notifyData->subject_id = $viewer_id;
            $notifyData->object_type = $object_type;
            $notifyData->object_id = $resource_id;
            $notifyData->type = 'liked';
            $notifyData->params = $resource->getShortType();
            $notifyData->date = date('Y-m-d h:i:s', time());
            $notifyData->save();
          }

          //PASS THE LIKE ID.
          $this->view->like_id = $like_id;
          $this->view->error_mess = 0;
          $db->commit();
        } catch( Exception $e ) {

          $db->rollBack();
          throw $e;
        }
        $like_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Liked.');
      } else {
        $this->view->like_id = $like_id_temp[0]['like_id'];
        $this->view->error_mess = 1;
      }
    }
// 		else {
// 			if (!empty($resource)) {
// 				$likeTable->removeLike($resource, $viewer);
// 				  if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelike'))
//           Engine_Api::_()->sitelike()->removeLikeFeed($viewer, $resource);
// 			}
// 			$this->view->error_mess = 0;
//
// 			$like_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Unliked.');
//     }
//     if (empty($status)) {
//       $this->_forward('success', 'utility', 'core', array(
//               'smoothboxClose' => true,
//               'parentRefresh' => true,
//               'messages' => array($like_msg)
//           )
//       );
//     }
  }

  /**
   * Return categoryid
   *
   * @param string $content_id
   * @param string $widgetname
   * @return categoryid
   */
  public function getSitebusinessCategoryid($content_id = null, $widgetname)
  {

    $contentTable = Engine_Api::_()->getDbtable('content', 'core');
    $business_id = $contentTable
      ->select()
      ->from($contentTable->info('name'), array('page_id'))
      ->where('content_id =?', $content_id)
      ->query()
      ->fetchColumn();
    //GET CONTENT TABLE
    $contentTable = Engine_Api::_()->getDbtable('content', 'core');
    $params = $contentTable
      ->select()
      ->from($contentTable->info('name'), array('params'))
      ->where('page_id =?', $business_id)
      ->where('name =?', $widgetname)
      ->query()
      ->fetchColumn();
    if( $params )
      $params = Zend_Json::decode($params);
    if( $params && isset($params['category_id']) && !empty($params['category_id']) ) {
      return $params['category_id'];
    } else {
      return 0;
    }
  }

  //SEND NOTIFICATION TO BUSINESS ADMIN WHEN OWN BUSINESS LIKE AND COMMENT.
  public function itemCommentLike($subject, $notificationType, $baseOnContentOwner = null)
  {

//         $item_title = $subject->getShortType();
//         $item_title_url = $subject->getHref();
//         $item_title_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $item_title_url;
//         $item_title_link = "<a href='$item_title_baseurl'>" . $item_title . " </a>";
    //FETCH DATA
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');

    if( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') ) {

      $object_type = $subject->getType();
      $object_id = $subject->getIdentity();
// 					if ($notificationType == 'sitebusiness_contentcomment') {
// 						if ($baseOnContentOwner) {
// 								$subject_type = $viewer->getType();
// 								$subject_id = $viewer->getIdentity();
// 						} else {
// 								$subject_type = $viewer->getType();
// 								$subject_id = $viewer->getIdentity();
// 						}
// 					} else {
      $subject_type = $viewer->getType();
      $subject_id = $viewer->getIdentity();
      //}

      if( $notificationType == 'sitebusiness_contentlike' ) {
        $notification = '%"notificationlike":"1"%';
        $notificationFriend = '%"notificationlike":"2"%';
      } else {
        $notification = '%"notificationcomment":"1"%';
        $notificationFriend = '%"notificationcomment":"2"%';
      }

      $db = Zend_Db_Table_Abstract::getDefaultAdapter();

      $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();

      if( $friendId ) {
        $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $notificationType . "' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1) AND (engine4_sitebusiness_membership.action_notification LIKE '" . $notification . "' or (engine4_sitebusiness_membership.action_notification LIKE '" . $notificationFriend . "' and (engine4_sitebusiness_membership .user_id IN (" . join(",", $friendId) . "))))");
      } else {
        $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $notificationType . "' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1) AND (engine4_sitebusiness_membership.action_notification LIKE '" . $notification . "')");
      }
    } else {
      if( isset($subject->business_id) ) {
        $manageAdminsIds = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdmin($subject->business_id, $viewer_id);

        foreach( $manageAdminsIds as $value ) {
          $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
          $action_notification = unserialize($value['action_notification']);
          if( !empty($value['notification']) && (in_array('like', $action_notification) || in_array('comment', $action_notification)) ) {

            $row = $notifyApi->createRow();
            $row->user_id = $user_subject->getIdentity();

// 						if ($notificationType == 'sitebusiness_contentcomment') {
// 								if ($baseOnContentOwner) {
// 										$row->subject_type = $subject->parent_type;
// 										$row->subject_id = $subjectParent->getIdentity();
// 								} else {
// 										$row->subject_type = $viewer->getType();
// 										$row->subject_id = $viewer->getIdentity();
// 								}
// 						} else {
            $row->subject_type = $viewer->getType();
            $row->subject_id = $viewer->getIdentity();
            //}
            $row->type = "$notificationType";
            $row->object_type = $subject->getType();
            $row->object_id = $subject->getIdentity();
            //$row->params = '{"eventname":"' . $item_title_link . '"}';
            $row->date = date('Y-m-d H:i:s');
            $row->save();
          }
        }
      }
    }
  }

  public function sendNotificationToFollowers($object, $actionObject, $notificationType, $count = null)
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $business_id = $object->business_id;
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    //ITEM TITLE AND TILTE WITH LINK.
    $item_title = isset($object->title) ? $object->title : $object->getTitle();
    $item_title_url = $object->getHref();
    $item_title_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $item_title_url;
    $item_title_link = "<a href='$item_title_baseurl'>" . $item_title . "</a>";
    $followersIds = Engine_Api::_()->getDbTable('follows', 'seaocore')->getFollowers('sitebusiness_business', $business_id, $viewer->getIdentity());
    $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
    $notidicationSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.type', 0);
    foreach( $followersIds as $value ) {

      if( !empty($notidicationSettings) ) {
        $notificationsTable->delete(array('type =?' => "$notificationType", 'object_type = ?' => $object->getType(), 'object_id = ?' => $object->getIdentity(), 'subject_id = ?' => $sitebusiness->getIdentity(), 'subject_type = ?' => $sitebusiness->getType(), 'user_id =?' => $value['poster_id']));
      } else {
        $notificationsTable->delete(array('type =?' => "$notificationType", 'object_type = ?' => $object->getType(), 'object_id = ?' => $object->getIdentity(), 'subject_id = ?' => $viewer->getIdentity(), 'subject_type = ?' => $viewer->getType(), 'user_id =?' => $value['poster_id']));
      }

      $user_subject = Engine_Api::_()->user()->getUser($value['poster_id']);
      $row = $notificationsTable->createRow();
      $row->user_id = $user_subject->getIdentity();
      if( !empty($notidicationSettings) ) {
        $row->subject_type = $sitebusiness->getType();
        $row->subject_id = $sitebusiness->getIdentity();
      } else {
        $row->subject_type = $viewer->getType();
        $row->subject_id = $viewer->getIdentity();
      }

      $row->type = "$notificationType";
      $row->object_type = $object->getType();
      $row->object_id = $object->getIdentity();

      if( $notificationType == 'sitebusinessalbum_create' ) {
        $row->params = array('count' => $count); 
      } else {
        $row->params = array('eventname' => $item_title_link); 
      }
      $row->date = date('Y-m-d H:i:s');
      $row->save();
    }
  }

  public function allowInThisBusiness($sitebusiness, $packagePrivacyName, $levelPrivacyName)
  {
    if( $this->hasPackageEnable() ) {
      if( !$this->allowPackageContent($sitebusiness->package_id, "modules", $packagePrivacyName) ) {
        return false;
      }
    } else {
      $isBusinessOwnerAllow = $this->isBusinessOwnerAllow($sitebusiness, $levelPrivacyName);
      if( empty($isBusinessOwnerAllow) ) {
        return false;
      }
    }
    return true;
  }

  public function sendNotificationEmail($object, $actionObject, $notificationType = null, $emailType = null, $params = null, $count = null)
  {

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');

    $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
    $notificationSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.type', 0);

    $manageAdminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $business_id = $object->business_id;

    $subject = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $owner = $subject->getOwner();

    //previous notification is delete.
    $notificationsTable->delete(array('type =?' => "$notificationType", 'object_type = ?' => "sitebusiness_business", 'object_id = ?' => $business_id, 'subject_id = ?' => $viewer_id));

    //GET BUSINESS TITLE AND BUSINESS TITLE WITH LINK.
    $businesstitle = $subject->title;
    //$business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($subject->business_id);
    //$business_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);
    //$business_title_link = '<a href="' . $business_baseurl . '"  >' . $businesstitle . ' </a>';
    //ITEM TITLE AND TILTE WITH LINK.
    if( $notificationType == 'sitebusinessdocument_create' ) {
      $item_title = $object->sitebusinessdocument_title;
    } else {
      $item_title = $object->title;
    }
    $item_title_url = $object->getHref();
    $item_title_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $item_title_url;
    $item_title_link = "<a href='$item_title_baseurl' style='text-decoration:none;' >" . $item_title . " </a>";

    //POSTER TITLE AND PHOTO WITH LINK
    $poster_title = $viewer->getTitle();
    $poster_url = $viewer->getHref();
    $poster_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $poster_url;
    $poster_title_link = "<a href='$poster_baseurl' style='font-weight:bold;text-decoration:none;' >" . $poster_title . " </a>";
    if( $viewer->photo_id ) {
      $photo = 'http://' . $_SERVER['HTTP_HOST'] . $viewer->getPhotoUrl('thumb.icon');
    } else {
      $photo = 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/application/modules/Sitebusiness/externals/images/nophoto_user_thumb_icon.png';
    }
    $image = "<img src='$photo' />";
    $posterphoto_link = "<tr><td colspan='2' style='height:20px;'></td></tr><tr></tr><tr><td valign='top' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;padding-right:15px;text-align:left'><a href='$poster_baseurl'  >" . $image . " </a></td><td valign='top' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;width:100%;text-align:left'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;width:100%'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif'><span style='color:#333333;'>";

    //MEASSGE WITH LINK.
    if( isset($actionObject) ) {
      $post_baseUrl = 'http://' . $_SERVER['HTTP_HOST'] . $actionObject->getHref();
    }
    $created = $post = ' ';
    if( $notificationType == 'sitebusinessalbum_create' ) {
      $post = $poster_title . ' created a new album in business: ' . $businesstitle;
      $created = ' created the album ';
    } elseif( $notificationType == 'sitebusinessdocument_create' ) {
      $post = $poster_title . ' created a new document in business: ' . $businesstitle;
      $created = ' created the document ';
    } elseif( $notificationType == 'sitebusinessevent_create' ) {
      $post = $poster_title . ' created a new event in business: ' . $businesstitle;
      $created = ' created the event ';
    } elseif( $notificationType == 'sitebusinessmusic_create' ) {
      $post = $poster_title . ' created a new playlist in business: ' . $businesstitle;
      $created = ' created the music ';
    } elseif( $notificationType == 'sitebusinessnote_create' ) {
      $post = $poster_title . ' created a new note in business: ' . $businesstitle;
      $created = ' created the note ';
    } elseif( $notificationType == 'sitebusinessoffer_create' ) {
      $post = $poster_title . ' created a new offer in business: ' . $businesstitle;
      $created = ' created the offer ';
    } elseif( $notificationType == 'sitebusinesspoll_create' ) {
      $post = $poster_title . ' created a new poll in business: ' . $businesstitle;
      $created = ' created the poll ';
    } elseif( $notificationType == 'sitebusinessvideo_create' ) {
      $post = $poster_title . ' posted a new video in business: ' . $businesstitle;
      $created = ' created the video ';
    } elseif( $notificationType == 'sitebusinessdiscussion_create' ) {
      $post = $poster_title . ' created a new discussion in business: ' . $businesstitle;
      $created = ' created the discussion ';
    }
    if( !empty($post_baseUrl) ) {
      if( $params == 'Activity Comment' || $params == 'Activity Reply' ) {
        $post_link = "<a href='$post_baseUrl'  >" . 'post' . "</a>";
        $post_linkformail = "<table cellspacing='0' cellpadding='0' border='0' style='border-collapse:collapse;' width='90%'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;padding:20px;background-color:#fff;border-left:none;border-right:none;border-top:none;border-bottom:none;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;' width='100%'><tr><td colspan='2' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;border-bottom:1px solid #dddddd;padding-bottom:5px;'><a style='font-weight:bold;margin-bottom:10px;text-decoration:none;' href='$post_baseUrl'>" . 'post' . "</a></td></tr><tr><td valign='top' style='padding:10px 15px 10px 10px;'><a href='$poster_baseurl'  >" . $image . " </a></td><td valign='top' style='padding-top:10px;font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;width:100%;text-align:left;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;width:100%;'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;text-decoration:none;text-decoration:none;'>" . $poster_title_link . 'post' . $item_title_link . '.' . "</td></tr></table></td></tr></table></td></tr></table>";
      } else {
        $post_link = "<a href='$post_baseUrl'  >" . $post . "</a>";
        $post_linkformail = "<table cellspacing='0' cellpadding='0' border='0' style='border-collapse:collapse;' width='90%'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;padding:20px;background-color:#fff;border-left:none;border-right:none;border-top:none;border-bottom:none;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;' width='100%'><tr><td colspan='2' style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;border-bottom:1px solid #dddddd;padding-bottom:5px;'><a style='font-weight:bold;margin-bottom:10px;text-decoration:none;' href='$post_baseUrl'>" . $post . "</a></td></tr><tr><td valign='top' style='padding:10px 15px 10px 10px;'><a href='$poster_baseurl'  >" . $image . " </a></td><td valign='top' style='padding-top:10px;font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;width:100%;text-align:left;'><table cellspacing='0' cellpadding='0' style='border-collapse:collapse;width:100%;'><tr><td style='font-size:11px;font-family:LucidaGrande,tahoma,verdana,arial,sans-serif;text-decoration:none;'>" . $poster_title_link . $created . $item_title_link . '.' . "</td></tr></table></td></tr></table></td></tr></table>";
      }
    }

    //FETCH DATA
    if( empty($sitebusinessmemberEnabled) ) {
      $manageAdminsIds = $manageAdminTable->getManageAdmin($business_id, $viewer_id);
      foreach( $manageAdminsIds as $value ) {
        $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
        $action_notification = unserialize($value['action_notification']);
        if( !empty($value['notification']) && in_array('created', $action_notification) ) {
          $row = $notificationsTable->createRow();
          $row->user_id = $user_subject->getIdentity();
          if( $notificationSettings == 1 ) {
            $row->subject_type = $subject->getType();
            $row->subject_id = $subject->getIdentity();
          } else {
            $row->subject_type = $viewer->getType();
            $row->subject_id = $viewer->getIdentity();
          }
          $row->type = "$notificationType";
          $row->object_type = $object->getType();
          $row->object_id = $object->getIdentity();
          $row->date = date('Y-m-d H:i:s');

          if( $notificationType == 'sitebusinessalbum_create' ) {
            $row->params = array('count' => $count); 
          } else {
            $row->params = array('eventname' => $item_title_link); 
          }
          $row->save();
        }

        //EMAIL SEND TO ALL MANAGEADMINS.
        $action_email = json_decode($value['action_email']);
        if( !empty($value['email']) && in_array('created', $action_email) ) {
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "$emailType", array(
            'business_title' => $businesstitle,
            'item_title' => $item_title,
            'body_content' => $post_linkformail,
          ));
        }
      }
    }

    //START SEND EMAIL TO ALL MEMBER WHO HAVE JOINED THE BUSINESS INCLUDE MANAGE ADMINS.
    if( !empty($sitebusinessmemberEnabled) ) {
      $membersIds = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id, $viewer_id, $viewer_id, 0, 1);
      foreach( $membersIds as $value ) {
        $action_email = json_decode($value['action_email']);
        $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
        if( $params != 'Activity Comment' && $params != 'Activity Reply' ) {
          if( !empty($value['email_notification']) && $action_email->emailcreated == 1 ) {
            Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "$emailType", array(
              'business_title' => $businesstitle,
              'item_title' => $item_title,
              'body_content' => $post_linkformail,
            ));
          } elseif( !empty($value['email_notification']) && $action_email->emailcreated == 2 ) {
            $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
            if( in_array($value['user_id'], $friendId) ) {
              Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, "$emailType", array(
                'business_title' => $businesstitle,
                'item_title' => $item_title,
                'body_content' => $post_linkformail,
              ));
            }
          }
        }
      }
    }
    //END SEND EMAIL TO ALL MEMBER WHO HAVE JOINED THE BUSINESS INCLUDE MANAGE ADMINS.

    if( $params != 'Activity Comment' && $params != 'Businessevent Invite' && $params != 'Activity Reply' ) {
      $object_type = $subject->getType();
      $object_id = $subject->getIdentity();
      $subject_type = $viewer->getType();
      $subject_id = $viewer->getIdentity();
    } elseif( $params == 'Businessevent Invite' ) {
      $object_type = $object->getType();
      $object_id = $object->getIdentity();
      //      $subject_type = $viewer->getType();
      //      $subject_id = $viewer->getIdentity();
      if( $notificationSettings == 1 ) {
        $subject_type = $subject->getType();
        $subject_id = $subject->getIdentity();
      } else {
        $subject_type = $viewer->getType();
        $subject_id = $viewer->getIdentity();
      }
    }

    if( $params != 'Activity Comment' && $params != 'Activity Reply' ) {
      $notificationcreated = '%"notificationcreated":"1"%';
      $notificationsinglecodecreated = '%"notificationcreated":1%';
      $notificationfriendcreated = '%"notificationcreated":"2"%';
      $notificationfriendsinglecodecreated = '%"notificationcreated":2%';
      if( $count ) {
        $countparams = '{"count":"' . $count . '"}';
      } else {
        $countparams = null;
      }
      if( !empty($sitebusinessmemberEnabled) ) {
        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
        if( !empty($friendId) ) {
          $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $notificationType . "' as `type`, '" . $countparams . "' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1) AND (engine4_sitebusiness_membership.action_notification LIKE '" . $notificationcreated . "' or engine4_sitebusiness_membership.action_notification LIKE '" . $notificationsinglecodecreated . "' or (engine4_sitebusiness_membership.action_notification LIKE '" . $notificationfriendcreated . "' or engine4_sitebusiness_membership.action_notification LIKE '" . $notificationfriendsinglecodecreated . "' and (engine4_sitebusiness_membership .user_id IN (" . join(",", $friendId) . "))))");
        } else {
          $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $notificationType . "' as `type`, '" . $countparams . "' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1) AND (engine4_sitebusiness_membership.action_notification LIKE '" . $notificationcreated . "' OR engine4_sitebusiness_membership.action_notification LIKE '" . $notificationsinglecodecreated . "')");
        }
      }
    }
  }

  /**
   * Check If The Attachment Types in Activity Feed Should be Enabled or Not
   */
  public function enableComposer($composerType = null)
  {
    return Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($composerType) && method_exists(Engine_Api::_()->getApi('core', $composerType), 'enableComposer') ? Engine_Api::_()->getApi('core', $composerType)->enableComposer() : false;
  }

  /**
   * Gets widgetized business
   *
   * @return Zend_Db_Table_Select
   */
  public function getMobileWidgetizedBusiness()
  {

    if( !Engine_Api::_()->hasModuleBootstrap('sitemobile') )
      return false;

    //GET CORE BUSINESS TABLE
    $tableNameBusiness = Engine_Api::_()->getDbtable('pages', 'sitemobile');
    $select = $tableNameBusiness->select()
      ->from($tableNameBusiness->info('name'), array('page_id', 'description', 'keywords'))
      ->where('name =?', 'sitebusiness_index_view')
      ->limit(1);

    return $tableNameBusiness->fetchRow($select);
  }

  public function showTabsWithoutContent()
  {
    return Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.show.tabs.without.content', 0);
  }

  public function checkEnableForMobile($moduleName)
  {
    if( !Engine_Api::_()->hasModuleBootstrap('sitemobile') )
      return false;

    //GET CORE BUSINESS TABLE
    $modulesSitemobile = Engine_Api::_()->getDbtable('modules', 'sitemobile');
    $enable_mobile = $modulesSitemobile->select()
      ->from($modulesSitemobile->info('name'), array('enable_mobile'))
      ->where('name =?', $moduleName)
      ->where('enable_mobile= ?', 1)
      ->query()
      ->fetchColumn();

    return $enable_mobile;
  }

  /**
   * Set default widget in core businesses table
   *
   * @param object $table
   * @param string $tablename
   * @param int $business_id
   * @param string $type
   * @param string $widgetname
   * @param int $middle_id
   * @param int $order
   * @param string $title
   * @param int $titlecount
   */
  function setDefaultDataContentWidget($table, $tablename, $business_id, $type, $widgetname, $middle_id, $order, $title = null, $titlecount = null, $advanced_activity_params = null)
  {

    $selectWidgetId = $table->select()
      ->where('page_id =?', $business_id)
      ->where('type = ?', $type)
      ->where('name = ?', $widgetname)
      ->where('parent_content_id = ?', $middle_id)
      ->limit(1);
    $fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
    if( empty($fetchWidgetContentId) ) {
      $contentWidget = $table->createRow();
      $contentWidget->page_id = $business_id;
      $contentWidget->type = $type;
      $contentWidget->name = $widgetname;
      $contentWidget->parent_content_id = $middle_id;
      $contentWidget->order = $order;
      if( empty($advanced_activity_params) && $title && $titlecount ) {
        $contentWidget->params = "{\"title\":\"$title\",\"titleCount\":$titlecount}";
      } else {
        $contentWidget->params = "$advanced_activity_params";
      }
      $contentWidget->save();
    }
  }

  public function sendInviteEmail($object, $actionObject = null, $params = array(), $memberIdsArray = array())
  {

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
    $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');

    $manageAdminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $business_id = $params['parent_id'];

    $subject = Engine_Api::_()->getItem($params['parent_type'], $business_id);
    $owner = $subject->getOwner();

    //GET BUSINESS TITLE AND BUSINESS TITLE WITH LINK.
    $businesstitle = $subject->title;
    $business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($subject->business_id);
    $business_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);
    $business_title_link = '<a href="' . $business_baseurl . '"  >' . $businesstitle . ' </a>';

    //ITEM TITLE AND TILTE WITH LINK.
    $item_title = $object->title;
    $item_title_url = $object->getHref();
    $item_title_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $item_title_url;
    $item_title_link = "<a href='$item_title_baseurl'  >" . $item_title . " </a>";


    //POSTER TITLE AND PHOTO WITH LINK
    $poster_title = $viewer->getTitle();
    $poster_url = $viewer->getHref();
    $poster_baseurl = 'http://' . $_SERVER['HTTP_HOST'] . $poster_url;
    $poster_title_link = "<a href='$poster_baseurl'  >" . $poster_title . " </a>";
    if( $viewer->photo_id ) {
      $photo = 'http://' . $_SERVER['HTTP_HOST'] . $viewer->getPhotoUrl('thumb.icon');
    } else {
      $photo = 'http://' . $_SERVER['HTTP_HOST'] . $view->baseUrl() . '/application/modules/Sitebusiness/externals/images/nophoto_sitebusiness_thumb_icon.png';
    }
    $image = "<img src='$photo' />";
    $posterphoto_link = "<a href='$poster_baseurl'  >" . $image . " </a>";

    //MEASSGE WITH LINK.
    if( !empty($actionObject) && isset($actionObject) ) {
      $post_baseUrl = 'http://' . $_SERVER['HTTP_HOST'] . $actionObject->getHref();
      $post = $poster_title . ' Posted in ' . $businesstitle;
      $post_link = "<a href='$post_baseUrl'  >" . $post . " </a>";
    }

    //FETCH DATA
    if( $params['tempValue'] == 'InviteMembers' ) {
      foreach( $memberIdsArray as $value ) {
        $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
        if( !empty($value['email']) ) {
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, $params['emailType'], array(
            'business_title' => $businesstitle,
            'item_title_with_link' => $item_title_link,
            'item_title' => $item_title,
            'viewertitle_link' => $poster_title_link,
            'viewerphoto_link' => $posterphoto_link,
          ));
        }
      }
    } elseif( $params['tempValue'] == 'Businessevent Invite' ) {
      $businessMembers = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinMembers($business_id);
      foreach( $businessMembers as $value ) {
        if( $value['user_id'] == $object->owner_id )
          continue;
        $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
        if( !empty($value['email']) ) {
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, $params['emailType'], array(
            'business_title' => $businesstitle,
            'item_title_with_link' => $item_title_link,
            'item_title' => $item_title,
            'viewertitle_link' => $poster_title_link,
            'viewerphoto_link' => $posterphoto_link,
          ));
        }
      }
    } else {
      $manageAdminsIds = $manageAdminTable->getManageAdmin($business_id, $viewer_id);
      foreach( $manageAdminsIds as $value ) {
        $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
        if( !empty($value['email']) ) {
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, $params['emailType'], array(
            'business_title' => $businesstitle,
            'item_title_with_link' => $item_title_link,
            'item_title' => $item_title,
            'viewertitle_link' => $poster_title_link,
            'viewerphoto_link' => $posterphoto_link,
          ));
        }
      }
    }

    $object_type = $object->getType();
    $object_id = $object->getIdentity();
    $subject_type = $viewer->getType();
    $subject_id = $viewer->getIdentity();

    if( !empty($sitebusinessmemberEnabled) ) {
      $db = Zend_Db_Table_Abstract::getDefaultAdapter();
      if( $params['tempValue'] == 'InviteMembers' ) {
        $friendId = $memberIdsArray;
      } else {
        $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
      }
      if( !empty($friendId) ) {
        $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $params['notificationType'] . "' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1 or (engine4_sitebusiness_membership.notification = 2 and (engine4_sitebusiness_membership .user_id IN (" . join(",", $friendId) . "))))");
      } else {
        $db->query("INSERT IGNORE INTO `engine4_activity_notifications` (`user_id`, `subject_type`, `subject_id`, `object_type`, `object_id`, `type`,`params`, `date`) SELECT `engine4_sitebusiness_membership`.`user_id` as `user_id` ,	'" . $subject_type . "' as `subject_type`, " . $subject_id . " as `subject_id`, '" . $object_type . "' as `object_type`, " . $object_id . " as `object_id`, '" . $params['notificationType'] . "' as `type`, 'null' as `params`, '" . date('Y-m-d H:i:s') . "' as ` date `  FROM `engine4_sitebusiness_membership` WHERE (engine4_sitebusiness_membership.business_id = " . $subject->business_id . ") AND (engine4_sitebusiness_membership.user_id <> " . $viewer->getIdentity() . ") AND (engine4_sitebusiness_membership.notification = 1)");
      }
    }
  }

  public function getsecondLevelMaps($option_id)
  {
    // Get second level fields
    $mapData = Engine_Api::_()->getApi('core', 'fields')->getFieldsMaps('sitebusiness_business');
    $secondLevelMaps = array();
    $secondLevelFields = array();

    $secondLevelMaps = $mapData->getRowsMatching('option_id', $option_id);
    if( !empty($secondLevelMaps) ) {
      foreach( $secondLevelMaps as $map ) {
        $secondLevelFields[$map->child_id] = $map->getChild();
      }
    }
    return $secondLevelMaps;
  }

  /**
   * Gte Profiletype Label
   *
   * @param int $option_id
   * @return string $profie
   */
  public function getProfileTypeName($option_id)
  {

    $table_options = Engine_Api::_()->fields()->getTable('sitebusiness_business', 'options');
    $profie = $table_options->select()
      ->from($table_options->info('name'), 'label')
      ->where('option_id = ?', $option_id)
      ->query()
      ->fetchColumn();
    return $profie;
  }

  public function updateMemberCount($sitebusiness)
  {

    if( !$sitebusiness )
      return;

    $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');

    if( !$sitebusinessmemberEnabled )
      return;

    $tableSitebusinessMembership = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
    $tableSitebusinessMembershipName = $tableSitebusinessMembership->info('name');
    $count = $tableSitebusinessMembership->select()
      ->from($tableSitebusinessMembershipName, array('count(*) as count'))
      ->where('resource_id =?', $sitebusiness->getIdentity())
      ->where('active =?', 1)
      ->where('resource_approved =?', 1)
      ->where('user_approved =?', 1)
      ->query()
      ->fetchColumn();

    $sitebusiness->member_count = $count;
    $sitebusiness->save();
  }

  /**
   * Check here that show payment link or not
   * $params $business_id : Id of business
   * @return bool $showLink
   * */
  public function canShowCancelLink($business_id)
  {

    if( !Engine_Api::_()->sitebusiness()->hasPackageEnable() )
      return;

    $showLink = false;
    $business = Engine_Api::_()->getItem('sitebusiness_business', $business_id);


    if( !empty($business) ) {
      $package = $business->getPackage();

      if( !$package->isFree() && $business->status == "active" && !$package->isOneTime() && !empty($business->approved) ) {
        return (bool) true;
      }
    }

    return (bool) $showLink;
  }

  public function checkVersion($databaseVersion, $checkDependancyVersion)
  {
    $f = $databaseVersion;
    $s = $checkDependancyVersion;
    if( strcasecmp($f, $s) == 0 )
      return -1;

    $fArr = explode(".", $f);
    $sArr = explode('.', $s);
    if( count($fArr) <= count($sArr) )
      $count = count($fArr);
    else
      $count = count($sArr);

    for( $i = 0; $i < $count; $i++ ) {
      $fValue = $fArr[$i];
      $sValue = $sArr[$i];
      if( is_numeric($fValue) && is_numeric($sValue) ) {
        if( $fValue > $sValue )
          return 1;
        elseif( $fValue < $sValue )
          return 0;
        else {
          if( ($i + 1) == $count ) {
            return -1;
          } else
            continue;
        }
      }
      elseif( is_string($fValue) && is_numeric($sValue) ) {
        $fsArr = explode("p", $fValue);

        if( $fsArr[0] > $sValue )
          return 1;
        elseif( $fsArr[0] < $sValue )
          return 0;
        else {
          return 1;
        }
      } elseif( is_numeric($fValue) && is_string($sValue) ) {
        $ssArr = explode("p", $sValue);

        if( $fValue > $ssArr[0] )
          return 1;
        elseif( $fValue < $ssArr[0] )
          return 0;
        else {
          return 0;
        }
      } elseif( is_string($fValue) && is_string($sValue) ) {
        $fsArr = explode("p", $fValue);
        $ssArr = explode("p", $sValue);
        if( $fsArr[0] > $ssArr[0] )
          return 1;
        elseif( $fsArr[0] < $ssArr[0] )
          return 0;
        else {
          if( $fsArr[1] > $ssArr[1] )
            return 1;
          elseif( $fsArr[1] < $ssArr[1] )
            return 0;
          else {
            return -1;
          }
        }
      }
    }
  }

  //Function to return Currency Conversion rate
  public function getPriceWithCurrency($price, $priceOnly = 0, $search = 0)
  {

    if( empty($price) ) {
      return $price;
    }
    if( Engine_Api::_()->hasModuleBootstrap('sitemulticurrency') && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemulticurrency') && Engine_Api::_()->getDbtable('modules', 'sitemulticurrency')->isModuleEnable('sitebusiness') ) {

      $priceStr = Engine_Api::_()->sitemulticurrency()->convertCurrencyRate($price, $priceOnly, $search);
    } else {
      $defaultParams = array();
      $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      if( empty($viewer_id) ) {
        $defaultParams['locale'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'auto');
      }
      $currency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
      $defaultParams['precision'] = 2;
      $price = (float) $price;
      $priceStr = Zend_Registry::get('Zend_View')->locale()->toCurrency($price, $currency, $defaultParams);
    }

    return $priceStr;
  }

}
