<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesses
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layoutcore.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Api_LayoutCore extends Core_Api_Abstract {

    /**
     * Sets the without tab widgets information in core content table
     *
     * @param int $business_id
     */
    public function setWithoutTabContent($business_id, $sitebusiness_layout_cover_photo) {

        //GET CONTENT TABLE
        $contentTable = Engine_Api::_()->getDbtable('content', 'core');

        //GET CONTENT TABLE NAME
        $contentTableName = $contentTable->info('name');

        //INSERTING MAIN CONTAINER
        $mainContainer = $contentTable->createRow();
        $mainContainer->page_id = $business_id;
        $mainContainer->type = 'container';
        $mainContainer->name = 'main';
        $mainContainer->order = 2;
        $mainContainer->save();
        $container_id = $mainContainer->content_id;

        //INSERTING MAIN-MIDDLE CONTAINER
        $mainMiddleContainer = $contentTable->createRow();
        $mainMiddleContainer->page_id = $business_id;
        $mainMiddleContainer->type = 'container';
        $mainMiddleContainer->name = 'middle';
        $mainMiddleContainer->parent_content_id = $container_id;
        $mainMiddleContainer->order = 6;
        $mainMiddleContainer->save();
        $middle_id = $mainMiddleContainer->content_id;

        //INSERTING MAIN-LEFT CONTAINER
        $mainLeftContainer = $contentTable->createRow();
        $mainLeftContainer->page_id = $business_id;
        $mainLeftContainer->type = 'container';
        $mainLeftContainer->name = 'right';
        $mainLeftContainer->parent_content_id = $container_id;
        $mainLeftContainer->order = 4;
        $mainLeftContainer->save();
        $left_id = $mainLeftContainer->content_id;

        //INSERTING TITLE WIDGET
        if (empty($sitebusiness_layout_cover_photo)) {

            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');

            //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
                Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmember.businesscover-photo-sitebusinessmembers', $middle_id, 2, '', 'true');
            }

            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.title-sitebusiness', $middle_id, 3, '', 'true');

            //INSERTING LIKE WIDGET
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.like-button', $middle_id, 4, '', 'true');

            //INSERTING FACEBOOK LIKE WIDGET
            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebookse')) {
                Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'Facebookse.facebookse-sitebusinessprofilelike', $middle_id, 5, '', 'true');
            }

            //INSERTING MAIN PHOTO WIDGET
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.mainphoto-sitebusiness', $left_id, 10, '', 'true');
        } else {
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-profile-breadcrumb', $middle_id, 1, '', 'true');
            //INSERTING BUSINESS PROFILE BUSINESS COVER PHOTO WIDGET
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-cover-information-sitebusiness', $middle_id, 1, '', 'true');
        }

        //INSERTING CONTACT DETAIL WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.contactdetails-sitebusiness', $middle_id, 5, '', 'true');

        //INSERTING INFORAMTION WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.info-sitebusiness', $middle_id, 7, 'Info', 'true');

        //INSERTING ACTIVITY FEED WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity')) {
          $advanced_activity_params =  '{"title":"Updates","advancedactivity_tabs":["aaffeed"],"nomobile":"0","name":"advancedactivity.home-feeds"}';
          Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'advancedactivity.home-feeds', $middle_id, 6, 'Updates', 'true',$advanced_activity_params);
        } else {
          Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'activity.feed', $middle_id, 6, 'Updates', 'true');
        }

        //INSERTING OVERVIEW WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.overview-sitebusiness', $middle_id, 8, 'Overview', 'true');

        //INSERTING LOCATION WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.location-sitebusiness', $middle_id, 9, 'Map', 'true');

        //INSERTING LINKS WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'core.profile-links', $middle_id, 125, 'Links', 'true');

        //INSERTING MAIN PHOTO WIDGET
        // Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.mainphoto-sitebusiness', $left_id, 10,'','true');
        //INSERTING WIDGET LINK WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.widgetlinks-sitebusiness', $left_id, 11, '', 'true');

        //INSERTING OPTIONS WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.options-sitebusiness', $left_id, 12, '', 'true');

        //INSERTING WRITE SOMETHING ABOUT WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.write-business', $left_id, 13, '', 'true');

        //INSERTING INFORMATION WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.information-sitebusiness', $left_id, 10, 'Information', 'true');

        //INSERTING LIKE WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'seaocore.people-like', $left_id, 15, '', 'true');

        //INSERTING RATING WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessreview.ratings-sitebusinessreviews', $left_id, 16, 'Ratings', 'true');
        }

        //INSERTING BADGE WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessbadge')) {
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessbadge.badge-sitebusinessbadge', $left_id, 17, 'Badge', 'true');
        }

        $social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitebusiness.socialshare-sitebusiness"}';

        //INSERTING SOCIAL SHARE WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.socialshare-sitebusiness', $left_id, 19, 'Social Share', 'true', $social_share_default_code);

//    //INSERTING FOUR SQUARE WIDGET
//    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.foursquare-sitebusiness', $left_id, 20, '','true');
        //INSERTING INSIGHTS WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.insights-sitebusiness', $left_id, 22, 'Insights', 'true');

        //INSERTING FEATURED OWNER WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.featuredowner-sitebusiness', $left_id, 23, 'Owners', 'true');

        //INSERTING ALBUM WIDGET
        $sitebusinessAlbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
        if ($sitebusinessAlbumEnabled) {
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.albums-sitebusiness', $left_id, 24, 'Albums', 'true');
            $this->setDefaultInfoWithoutTab('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');
        }

        //INSERTING LINKED BUSINESSS WIDGET
        Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.favourite-business', $left_id, 26, 'Linked Businesses', 'true');

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
            Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.profile-player', $left_id, 25, '', 'true');
        }

        //INSERTING VIDEO WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo')) {
            $this->setDefaultInfoWithoutTab('sitebusinessvideo.profile-sitebusinessvideos', $business_id, 'Videos', 'true', '111');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo')) {
            $this->setDefaultInfoWithoutTab('sitevideo.contenttype-videos', $business_id, 'Videos', 'true', '111');
        }

        //INSERTING NOTE WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) {
            $this->setDefaultInfoWithoutTab('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');
        }

        //INSERTING REVIEW WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
            $this->setDefaultInfoWithoutTab('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
        }

        //INSERTING FORM WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform')) {
            $this->setDefaultInfoWithoutTab('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'false', '114');
        }

        //INSERTING DOCUMENT WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument')) {
            $this->setDefaultInfoWithoutTab('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
            $this->setDefaultInfoWithoutTab('document.contenttype-documents', $business_id, 'Documents', 'true', '115');
        }

        //INSERTING OFFER WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer')) {
            $this->setDefaultInfoWithoutTab('sitebusinessoffer.profile-sitebusinessoffers', $business_id, 'Offers', 'true', '116');
        }

        //INSERTING EVENT WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent')) {
            $this->setDefaultInfoWithoutTab('sitebusinessevent.profile-sitebusinessevents', $business_id, 'Events', 'true', '117');
        }

        //INSERTING EVENT WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent')) {
            $this->setDefaultInfoWithoutTab('siteevent.contenttype-events', $business_id, 'Events', 'true', '117');
        }

        //INSERTING POLL WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll')) {
            $this->setDefaultInfoWithoutTab('sitebusinesspoll.profile-sitebusinesspolls', $business_id, 'Polls', 'true', '118');
        }

        //INSERTING DISCUSSION WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
            $this->setDefaultInfoWithoutTab('sitebusiness.discussion-sitebusiness', $business_id, 'Discussions', 'true', '119');
        }

        //INSERTING MUSIC WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
            $this->setDefaultInfoWithoutTab('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');
        }
        //INSERTING TWITTER WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter')) {
            $this->setDefaultInfoWithoutTab('sitebusinesstwitter.feeds-sitebusinesstwitter', $business_id, 'Twitter', 'true', '121');
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
            $this->setDefaultInfoWithoutTab('sitebusinessmember.profile-sitebusinessmembers', $business_id, 'Member', 'true', '122');
            $this->setDefaultInfoWithoutTab('sitebusinessmember.profile-sitebusinessmembers-announcements', $business_id, 'Announcements', 'true', '123');
        }
        //INSERTING MEMBER WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration')) {
            $this->setDefaultInfoWithoutTab('sitebusinessintegration.profile-items', $business_id, '', '', 999);
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding')) {
            $this->setDefaultInfoWithoutTab('sitecrowdfunding.contenttype-projects', $business_id, 'Projects', 'true', '125');
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic')) {
            $this->setDefaultInfoWithoutTab('sitemusic.contenttype-music', $business_id, 'Music', 'true', '125');
        }
    }

    /**
     * Sets the tab widgets information in core content table
     *
     * @param int $business_id
     */
    public function setTabbedLayoutContent($business_id) {

        //NOW INSERTING DEFUALT INFO OF OTHER SUB PLUGINS WHICH ARE DEPENDENTS ON THIS SITEBUSINESS PLUGIN ARE ENABLED.
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum')) {
            $this->setContentDefaultInfo('sitebusiness.photos-sitebusiness', $business_id, 'Photos', 'true', '110');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessvideo')) {
            $this->setContentDefaultInfo('sitebusinessvideo.profile-sitebusinessvideos', $business_id, 'Videos', 'true', '111');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo')) {
            $this->setContentDefaultInfo('sitevideo.contenttype-videos', $business_id, 'Videos', 'true', '111');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessnote')) {
            $this->setContentDefaultInfo('sitebusinessnote.profile-sitebusinessnotes', $business_id, 'Notes', 'true', '112');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
            $this->setContentDefaultInfo('sitebusinessreview.profile-sitebusinessreviews', $business_id, 'Reviews', 'true', '113');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessform')) {
            $this->setContentDefaultInfo('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'false', '114');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdocument')) {
            $this->setContentDefaultInfo('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('document')) {
            $this->setContentDefaultInfo('document.contenttype-documents', $business_id, 'Documents', 'true', '115');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessoffer')) {
            $this->setContentDefaultInfo('sitebusinessoffer.profile-sitebusinessoffers', $business_id, 'Offers', 'true', '116');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessevent')) {
            $this->setContentDefaultInfo('sitebusinessevent.profile-sitebusinessevents', $business_id, 'Events', 'true', '117');
        }

        //INSERTING EVENT WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent')) {
            $this->setContentDefaultInfo('siteevent.contenttype-events', $business_id, 'Events', 'true', '117');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesspoll')) {
            $this->setContentDefaultInfo('sitebusinesspoll.profile-sitebusinesspolls', $business_id, 'Polls', 'true', '118');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessdiscussion')) {
            $this->setContentDefaultInfo('sitebusiness.discussion-sitebusiness', $business_id, 'Discussions', 'true', '119');
        }

        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmusic')) {
            $this->setContentDefaultInfo('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');
        }
        //INSERTING TWITTER WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinesstwitter')) {
            $this->setContentDefaultInfo('sitebusinesstwitter.feeds-sitebusinesstwitter', $business_id, 'Twitter', 'true', '121');
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
            $this->setContentDefaultInfo('sitebusinessmember.profile-sitebusinessmembers', $business_id, 'Member', 'true', '122');
            $this->setContentDefaultInfo('sitebusinessmember.profile-sitebusinessmembers-announcements', $business_id, 'Announcements', 'true', '123');
        }
        //INSERTING MEMBER WIDGET
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessintegration')) {
            $this->setContentDefaultInfo('sitebusinessintegration.profile-items', $business_id, '', '', 999);
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecrowdfunding')) {
            $this->setContentDefaultInfo('sitecrowdfunding.contenttype-projects', $business_id, 'Projects', 'true', '125');
        }
        if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemusic')) {
            $this->setContentDefaultInfo('sitemusic.contenttype-music', $business_id, 'Music', 'true', '126');
        }
}

    /**
     * Sets the tab widgets information in admin content and also content table for user layout
     *
     * @param int $business_id
     */
    public function setContentDefaultLayout($business_id) {

        //GET ADMIN CONTENT TABLE
        $admincontentTable = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');

        //GET CONTENT TABLE
        $contentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');

        //FETCH
        $corebusinessesinfo = Engine_Api::_()->sitebusiness()->getWidgetizedBusiness();

        //SELECT ADMIN CONTENT
        $admincontentselected = $admincontentTable->select()->where('business_id =?', $corebusinessesinfo->page_id)->where('type =?', 'container');

        //FETCH
        $admintableinfo = $admincontentTable->fetchAll($admincontentselected);

        //DEFINE OLD CONTAINER
        $oldContener = array();

        //CREATING A ROW
        foreach ($admintableinfo as $value) {
            $mainContainer = $contentTable->createRow();
            $mainContainer->contentbusiness_id = $business_id;
            $mainContainer->type = 'container';
            $mainContainer->name = $value->name;
            $mainContainer->order = $value->order;
            $mainContainer->params = $value->params;
            if (isset($oldContener[$value->parent_content_id]))
                $mainContainer->parent_content_id = $oldContener[$value->parent_content_id];
            $mainContainer->save();
            $container_id = $mainContainer->content_id;
            $oldContener[$value->admincontent_id] = $container_id;
        }

        //SELECT ADMIN CONTENT
        $admincontentselected = $admincontentTable->select()->where('business_id =?', $corebusinessesinfo->page_id)->where('type =?', 'widget')->where('name =?', 'core.container-tabs');

        //FETCH
        $admintableinfo = $admincontentTable->fetchAll($admincontentselected);

        //CREATING A ROW
        foreach ($admintableinfo as $values) {
            $mainWidgets = $contentTable->createRow();
            $mainWidgets->contentbusiness_id = $business_id;
            $mainWidgets->type = 'widget';
            $mainWidgets->name = $values->name;
            $mainWidgets->order = $values->order;
            $mainWidgets->params = $values->params;
            if (isset($oldContener[$values->parent_content_id]))
                $mainWidgets->parent_content_id = $oldContener[$values->parent_content_id];
            $mainWidgets->save();
            $container_id = $mainWidgets->content_id;
            $oldContener[$values->admincontent_id] = $container_id;
        }

        //SELECT ADMIN CONTENT
        $admincontentselected = $admincontentTable->select()->where('business_id =?', $corebusinessesinfo->page_id)->where('type =?', 'widget')->where('name <>?', 'core.container-tabs');

        //FETCH
        $admintableinfo = $admincontentTable->fetchAll($admincontentselected);

        //CREATING A ROW
        foreach ($admintableinfo as $values) {
            $mainWidgets = $contentTable->createRow();
            $mainWidgets->contentbusiness_id = $business_id;
            $mainWidgets->type = 'widget';
            $mainWidgets->name = $values->name;
            $mainWidgets->order = $values->order;
            $mainWidgets->params = $values->params;
            if (isset($oldContener[$values->parent_content_id]))
                $mainWidgets->parent_content_id = $oldContener[$values->parent_content_id];
            $mainWidgets->save();
        }
    }

    /**
     * Set profile business default widget in core content table with tab
     *
     * @param string $name
     * @param int $business_id
     * @param string $title
     * @param int $titleCount
     * @param int $order
     */
    public function setContentDefaultInfo($name = null, $business_id, $title = null, $titleCount = null, $order = null, $params = null) {
        $db = Engine_Db_Table::getDefaultAdapter();
        if (!empty($name)) {
            $contentTable = Engine_Api::_()->getDbtable('content', 'core');
            $contentTableName = $contentTable->info('name');
            $select = $contentTable->select();
            $select_content = $select
                    ->from($contentTableName)
                    ->where('page_id = ?', $business_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', $name)
                    ->limit(1);
            $content = $select_content->query()->fetchAll();
            if (empty($content)) {
                $select = $contentTable->select();
                $select_container = $select
                        ->from($contentTableName, array('content_id'))
                        ->where('page_id = ?', $business_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container = $select_container->query()->fetchAll();
                if (!empty($container)) {
                    $container_id = $container[0]['content_id'];
                    $select = $contentTable->select();
                    $select_middle = $select
                            ->from($contentTableName)
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $middle = $select_middle->query()->fetchAll();
                    if (!empty($middle)) {
                        $middle_id = $middle[0]['content_id'];
                        $select = $contentTable->select();
                        $select_tab = $select
                                ->from($contentTableName)
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'core.container-tabs')
                                ->where('page_id = ?', $business_id)
                                ->limit(1);
                        $tab = $select_tab->query()->fetchAll();
                        $tab_id = '';
                        if (!empty($tab)) {
                            $tab_id = $tab[0]['content_id'];
                        } else {
                            $contentWidget = $contentTable->createRow();
                            $contentWidget->page_id = $business_id;
                            $contentWidget->type = 'widget';
                            $contentWidget->name = 'core.container-tabs';
                            $contentWidget->parent_content_id = $middle_id;
                            $contentWidget->order = $order;
                            $showmaxtab = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showmore', 8);
                            $contentWidget->params = "{\"max\":\"$showmaxtab\"}";
                            $tab_id = $contentWidget->save();
                        }

                        if ($name != 'sitebusinessintegration.profile-items') {
                            $contentWidget = $contentTable->createRow();
                            $contentWidget->page_id = $business_id;
                            $contentWidget->type = 'widget';
                            $contentWidget->name = $name;
                            $contentWidget->parent_content_id = ($tab_id ? $tab_id : $middle_id);
                            $contentWidget->order = $order;

                            if ($params) {
                                $contentWidget->params = $params;
                            } else {
                                $contentWidget->params = '{"title":"' . $title . '" , "titleCount":' . $titleCount . '}';
                            }

                            $contentWidget->save();
                        } else {

                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'sitereview');
                            $check_list = $select->query()->fetchObject();
                            if (!empty($check_list)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {
                                    $item_title = $value['item_title'];
                                    $resource_type = $value['resource_type'] . '_' . $value['listingtype_id'];

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $tab_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $tab_id,
                                            'order' => 999,
                                            'params' => '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }

                            $this->setbusinessesintwidgetTab('document', '{"title":"Documents","resource_type":"document_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('sitegroup', '{"title":"Groups","resource_type":"sitegroup_group_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('sitepage', '{"title":"Pages","resource_type":"sitepage_page_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('sitestoreproduct', '{"title":"Products","resource_type":"sitestoreproduct_product_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('sitefaq', '{"title":"FAQs","resource_type":"sitefaq_faq_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('sitetutorial', '{"title":"Tutorials","resource_type":"sitetutorial_tutorial_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('list', '{"title":"Listings","resource_type":"list_listing_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('quiz', '{"title":"Quiz","resource_type":"quiz_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);

                            $this->setbusinessesintwidgetTab('folder', '{"title":"Folder","resource_type":"folder_0","nomobile":"0","name":"sitebusinessesintegration.profile-items"}', $tab_id, $business_id);
                        }
                    }
                }
            }
        }
    }

    /**
     * Set profile business default widget in core content table without tab
     *
     * @param string $name
     * @param int $business_id
     * @param string $title
     * @param int $titleCount
     * @param int $order
     */
    public function setDefaultInfoWithoutTab($name = null, $business_id, $title = null, $titleCount = null, $order = null) {
        $db = Engine_Db_Table::getDefaultAdapter();
        if (!empty($name)) {
            $contentTable = Engine_Api::_()->getDbtable('content', 'core');
            $contentTableName = $contentTable->info('name');
            $select = $contentTable->select();
            $select_content = $select
                    ->from($contentTableName)
                    ->where('page_id = ?', $business_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', $name)
                    ->limit(1);
            $content = $select_content->query()->fetchAll();
            if (empty($content)) {
                $select = $contentTable->select();
                $select_container = $select
                        ->from($contentTableName, array('content_id'))
                        ->where('page_id = ?', $business_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container = $select_container->query()->fetchAll();
                if (!empty($container)) {
                    $container_id = $container[0]['content_id'];
                    $select = $contentTable->select();
                    $select_middle = $select
                            ->from($contentTableName)
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $middle = $select_middle->query()->fetchAll();
                    if (!empty($middle)) {
                        $middle_id = $middle[0]['content_id'];

                        if ($name != 'sitebusinessintegration.profile-items') {
                            $contentWidget = $contentTable->createRow();
                            $contentWidget->page_id = $business_id;
                            $contentWidget->type = 'widget';
                            $contentWidget->name = $name;
                            $contentWidget->parent_content_id = ($middle_id);
                            $contentWidget->order = $order;
                            $contentWidget->params = '{"title":"' . $title . '" , "titleCount":' . $titleCount . '}';
                            $contentWidget->save();
                        } else {
                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'sitereview');
                            $check_list = $select->query()->fetchObject();
                            if (!empty($check_list)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {
                                    $item_title = $value['item_title'];
                                    $resource_type = $value['resource_type'] . '_' . $value['listingtype_id'];

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $middle_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $middle_id,
                                            'order' => 999,
                                            'params' => '{"title":"' . $item_title . '","resource_type":"' . $resource_type . '","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }

                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'sitegroup');
                            $check_sitegroup = $select->query()->fetchObject();
                            if (!empty($check_sitegroup)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $middle_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"Group","resource_type":"sitegroup_group_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $middle_id,
                                            'order' => 999,
                                            'params' => '{"title":"Groups","resource_type":"sitegroup_group_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }
                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'document');
                            $check_sitedocument = $select->query()->fetchObject();
                            if (!empty($check_sitedocument)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $middle_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"Documents","resource_type":"document_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $middle_id,
                                            'order' => 999,
                                            'params' => '{"title":"Documents","resource_type":"document_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }
                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'sitepage');
                            $check_sitepage = $select->query()->fetchObject();
                            if (!empty($check_sitepage)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $middle_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"Pages","resource_type":"sitepage_page_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $middle_id,
                                            'order' => 999,
                                            'params' => '{"title":"Pages","resource_type":"sitepage_page_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }
                            $select = new Zend_Db_Select($db);
                            $select
                                    ->from('engine4_core_modules')
                                    ->where('name = ?', 'list');
                            $check_list = $select->query()->fetchObject();
                            if (!empty($check_list)) {
                                $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

                                foreach ($results as $value) {

                                    // Check if it's already been placed
                                    $select = new Zend_Db_Select($db);
                                    $select
                                            ->from('engine4_core_content')
                                            ->where('parent_content_id = ?', $middle_id)
                                            ->where('type = ?', 'widget')
                                            ->where('name = ?', 'sitebusinessintegration.profile-items')
                                            ->where('params = ?', '{"title":"Listings","resource_type":"list_listing_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}');
                                    $info = $select->query()->fetch();
                                    if (empty($info)) {

                                        // tab on profile
                                        $db->insert('engine4_core_content', array(
                                            'page_id' => $business_id,
                                            'type' => 'widget',
                                            'name' => 'sitebusinessintegration.profile-items',
                                            'parent_content_id' => $middle_id,
                                            'order' => 999,
                                            'params' => '{"title":"Listings","resource_type":"list_listing_0","nomobile":"0","name":"sitebusinessintegration.profile-items"}',
                                        ));
                                    }
                                    //}
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public function setbusinessesintwidgetTab($module_name, $params, $tab_id, $business_id) {

        $db = Engine_Db_Table::getDefaultAdapter();

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', $module_name);
        $module_enable = $select->query()->fetchObject();

        if (!empty($module_enable)) {

            $results = Engine_Api::_()->getDbtable('mixsettings', 'sitebusinessintegration')->getIntegrationItems();

            foreach ($results as $value) {

                // Check if it's already been placed
                $select = new Zend_Db_Select($db);
                $select
                        ->from('engine4_core_content')
                        ->where('parent_content_id = ?', $tab_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'sitebusinessintegration.profile-items')
                        ->where('params = ?', $params);
                $info = $select->query()->fetch();
                if (empty($info)) {
                    // tab on profile
                    $db->insert('engine4_core_content', array(
                        'page_id' => $business_id,
                        'type' => 'widget',
                        'name' => 'sitebusinessintegration.profile-items',
                        'parent_content_id' => $tab_id,
                        'order' => 999,
                        'params' => $params,
                    ));
                }
            }
        }
    }

}

?>
