<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ActivityFeed.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Form_Admin_Settings_ActivityFeed extends Engine_Form {

  public function init() {
    $this
            ->setAttribs(array(
                'id' => 'activity_feed_form',
            ))
            ->setTitle('Activity Feed Settings')
            ->setDescription('Below are the options to customize the Activity Feeds related to Businesses. Once you configure all the settings below, click on "Save Changes" to save them.');
    $subCoreBusinessApi = Engine_Api::_()->getApi('subCore', 'sitebusiness');
    $socialengineaddonFeedIsAdded = $subCoreBusinessApi->isCoreActivtyFeedWidget('user_index_home', 'activity.feed');
    $advancedactivityHomeFeedsIsAdded = $subCoreBusinessApi->isCoreActivtyFeedWidget('user_index_home', 'advancedactivity.home-feeds');
    $translate = Zend_Registry::get('Zend_Translate');
    $description = "Select the type of activity feeds that should be published for directory items / businesses. By default, the photo and name of Business Admin is shown in activity feeds of directory items / businesses. Using this setting, you can instead choose to show the Business's Photo and Title.";
    if ($socialengineaddonFeedIsAdded || $advancedactivityHomeFeedsIsAdded) {
      $description .= "If you choose the 2nd option to show the Business's Photo and Title, then users will also receive on their home page the updates from Businesses that they have Liked.";
    }
    $options1 = 'Business\'s Photo and Title';
    if ($socialengineaddonFeedIsAdded) {
      $options1.=" (Choosing this will send to users on their homebusiness, the updates from Businesses that they Like. If you have the \"Advanced Activity Feeds / Wall Plugin\" (http://www.socialengineaddons.com/socialengine-advanced-activity-feeds-wall-plugin) installed on your site, then Business Photo and Title will also come for comments made by Business Admins on activity feeds of their Business and comments on the content of their Business (photo, video, document, etc.))";
    } elseif ($advancedactivityHomeFeedsIsAdded) {
      $options1.=" (Choosing this will send to users on their homebusiness, the updates from Businesses that they Like. Business Photo and Title will also come for comments made by Business Admins on activity feeds of their Business and comments on the content of their Business (photo, video, document, etc.))";
    } else {
      $options1.=" (If you have the \"Advanced Activity Feeds / Wall Plugin\" (http://www.socialengineaddons.com/socialengine-advanced-activity-feeds-wall-plugin) installed on your site, then Business Photo and Title will also come for comments made by Business Admins on activity feeds of their Business and comments on the content of their Business (photo, video, document, etc.))";
    }
    $this->getView()->escape($options1);
    $this->addElement('Radio', 'sitebusiness_feed_type', array(
        'label' => 'Directory Items / Businesses Activity Feed Type',
        'description' => $description,
        'multiOptions' => array(
            '0' => 'Business Admin\'s Photo and Name',
            '1' => $options1,
        ),
        'onclick' => 'showEditingOptions("sitebusinessfeed_likebusiness_dummy-wrapper",this.value)',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.type', 0),
    ));

    if (!$socialengineaddonFeedIsAdded && !$advancedactivityHomeFeedsIsAdded) {
      $this->addElement('Dummy', 'sitebusinessfeed_likebusiness_dummy', array(
          'decorators' => array(array('ViewScript', array(
                      'viewScript' => 'admin-settings/activity-feed/_feedLikebusiness.tpl',
                      'class' => 'form element'
              )))
      ));
    }
      $this->addElement('Radio', 'sitebusiness_feed_onlyliked', array(
        'label' => 'Show Directory Items / Businesses Activity Feeds On Member Home Business',
        'description' => 'Select the type of Activity Feeds corresponding to Directory Items / Businesses which you want to display to users on Member Home Business.',
        'multiOptions' => array(
            '0' => 'Show Feeds of all Directory Items / Businesses (This will be dependent on the Content Privacy of user.)',
            '1' => 'Show Feeds only of Liked Directory Items / Businesses',
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.feed.onlyliked', 1),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>