<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Favourites.php.tpl 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitebusiness_Model_DbTable_Favourites extends Engine_Db_Table {

  protected $_rowClass = "Sitebusiness_Model_Favourite";

  //THIS IS FOR ADD fAVOURITE  LINK IS NOT SHOW
  public function isShow($businessId) {

   $favouriteTableName = $this->info('name');
   $select = $this->select()
										->from($favouriteTableName, array('favourite_id'))
										->where('business_id = ?', $businessId)
										->limit(1);
    $findResults = $select->query()->fetchALL();
    if ( !empty($findResults) ) {
      return 1;
    }
    else {
      return 0;
    }
  }

  //THIS FOR DELETE fAVOURITE  LINK IS NOT SHOW
  public function isnotShow($businessId)
  {
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $favouriteTableName = $this->info('name');
    $select = $this->select()
										->from($favouriteTableName, array('favourite_id'))
										->where('business_id_for = ?', $businessId)
                    ->where('	owner_id = ?', $viewer_id)
										->limit(1);
    $findResults = $select->query()->fetchALL();

    if ((count($findResults) >= 1)) {
      return 1;
    }
    else {
			return 0;
    }
  }

  // DELETE LINK.
  public function deleteLink($business_id, $viewer_id) {

    $favouritesName = $this->info('name');
    $businesstable = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $businessTableName = $businesstable->info('name');
    $select = $this->select();
    $select = $select
            ->setIntegrityCheck(false)
            ->from($favouritesName, null)
            ->join($businessTableName, $favouritesName . '.business_id = ' . $businessTableName . '.business_id', array('business_id', 'title'))
            ->where($favouritesName . '.business_id_for = ?', $business_id)
            ->where($favouritesName . '.owner_id = ?', $viewer_id);
    return $this->fetchALL($select);
  }

	/**
   * Return linked businesses result
   *
   * @param int $sitebusiness_id
	 * @param int $LIMIT
   */
  public function linkedBusinesses($sitebusiness_id, $LIMIT,$params = array(), $flag = null) {

		$businessestable = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $businessesName = $businessestable->info('name');
    $favouritesName = $this->info('name');
    $select = $businessestable->select()
						->setIntegrityCheck(false);
						
		if (empty($flag)) {
			$select->from($businessestable, array('business_id', 'title','photo_id'))
			      ->join($favouritesName, $favouritesName . '.business_id_for = ' . $businessesName . '.business_id')
			      ->where($favouritesName . '.business_id =?', $sitebusiness_id);
		}
		
		//START WORK FOR PARENT BUSINESS AND SUB BUSINESS.
		if ($flag == 'subbusiness') {
			$select->from($businessestable, array('business_id', 'title','photo_id', 'owner_id'))
			->where($businessesName . '.	parent_id =?', $sitebusiness_id)
			->where($businessesName . '.	subbusiness =?', '1');
		}
		
	  if ($flag == 'parentbusiness') {
			$select->from($businessestable, array('business_id', 'title','photo_id', 'owner_id'))
			->where($businessesName . '.	business_id =?', $sitebusiness_id)
			->where($businessesName . '.	parent_id =?', '0')
			->where($businessesName . '.	subbusiness =?', '0');
		}
		//END WORK FOR PARENT BUSINESS AND SUB BUSINESS.
		
		$select->limit($LIMIT);
		if ( isset($params['category_id']) && !empty($params['category_id']) ) {
			$select = $select->where($businessesName . '.	category_id =?', $params['category_id']);
		}
		if ( isset($params['featured']) && ($params['featured'] == '1') ) {
			$select = $select->where($businessesName . '.	featured =?', '0');
		}
		elseif ( isset($params['featured']) && ($params['featured'] == '2') ) {
			$select = $select->where($businessesName . '.	featured =?', '1');
		}

		if ( isset($params['sponsored']) && ($params['sponsored'] == '1') ) {
			$select = $select->where($businessesName . '.	sponsored =?', '0');
		}
		elseif ( isset($params['sponsored']) && ($params['sponsored'] == '2') ) {
			$select = $select->where($businessesName . '.	sponsored =?', '1');
		}

    if(!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      return Zend_Paginator::factory($select);
    }

    return $userListings = $businessestable->fetchAll($select);
	}
}
?>