<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Plugin_Sitemobile {

  protected $_pagesTable;
  protected $_contentTable;

  
  public function onIntegrated() {

    $this->_pagesTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_pagesTable;
    $this->_contentTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_contentTable;
    //Business Plugin Main
    $this->addSitebusinessCreateBusiness();
    $this->addSitebusinessHomeBusiness();
    $this->addSitebusinessBrowseBusiness();
    $this->addSitebusinessProfileBusiness();
    $this->addSitebusinessManageBusiness();
    $this->addSitebusinessManageAdminBusiness();
    $this->addSitebusinessManageLikeBusiness();
    $this->addSitebusinessManageJoinedBusiness();
    $this->addSitebusinessBusinesses();
    include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/mobileLayoutCreation.php";
  }

  //Business plugin main businesses
  public function addSitebusinessProfileBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();
    $select = new Zend_Db_Select($db);

    // Check if it's already been placed
    $select
            ->from($this->_pagesTable)
            ->where('name = ?', 'sitebusiness_index_view')
            ->limit(1);

    $info = $select->query()->fetch();

    if (empty($info)) {
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_index_view',
          'displayname' => 'Directory / Businesses - Business Profile',
          'title' => 'Business Profile',
          'description' => 'This is a business profile page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId($this->_pagesTable);

      // containers
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'container',
          'name' => 'main',
          'parent_content_id' => null,
          'order' => 2,
          'params' => '',
      ));
      $container_id = $db->lastInsertId($this->_contentTable);

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'container',
          'name' => 'middle',
          'parent_content_id' => $container_id,
          'order' => 2,
          'params' => '',
      ));
      $middle_id = $db->lastInsertId($this->_contentTable);

			$db->insert($this->_contentTable, array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusiness.closebusiness-sitebusiness',
					'parent_content_id' => $middle_id,
					'order' => 1,
			));

			$db->insert($this->_contentTable, array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusiness.sitemobile-businesscover-photo-information',
					'parent_content_id' => $middle_id,
					'order' => 2,
					'params' => '{"title":"","titleCount":true,"showContent":["mainPhoto","title","sponsored","featured","category","subcategory","subsubcategory","likeButton","followButton","description","phone","email","website","location","tags","price"],"strachPhoto":"0"}',
			));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitemobile.container-tabs-columns',
          'parent_content_id' => $middle_id,
          'order' => 5,
          'params' => '{"max":6}',
      ));
      $tab_id = $db->lastInsertId($this->_contentTable);

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advfeed',
          'parent_content_id' => $tab_id,
          'order' => 100,
          'params' => '{"title":"Updates"}',
      ));
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.sitemobile-info-sitebusiness',
          'parent_content_id' => $tab_id,
          'order' => 200,
          'params' => '{"title":"Info"}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.sitemobile-overview-sitebusiness',
          'parent_content_id' => $tab_id,
          'order' => 300,
          'params' => '{"title":"Overview","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.sitemobile-location-sitebusiness',
          'parent_content_id' => $tab_id,
          'order' => 400,
          'params' => '{"title":"Map","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'seaocore.sitemobile-people-like',
          'parent_content_id' => $tab_id,
          'order' => 3000,
          'params' => '{"title":"Member Likes","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'seaocore.sitemobile-followers',
          'parent_content_id' => $tab_id,
          'order' => 3100,
          'params' => '{"title":"Followers","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.featuredowner-sitebusiness',
          'parent_content_id' => $tab_id,
          'order' => 3200,
          'params' => '{"title":"Business Admins","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.favourite-business',
          'parent_content_id' => $tab_id,
          'order' => 3300,
          'params' => '{"title":"Linked Businesses","titleCount":true}',
      ));

      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.subbusiness-sitebusiness',
          'parent_content_id' => $tab_id,
          'order' => 3400,
          'params' => '{"title":"Sub Businesses of a Business","titleCount":true}',
      ));

      //tab on profile
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitemobile.profile-links',
          'parent_content_id' => $tab_id,
          'order' => 3500,
          'params' => '{"title":"Links","titleCount":true}',
      ));
    }
  }

  public function addSitebusinessCreateBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_create');
    if (!$business_id) {

      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_index_create',
          'displayname' => 'Directory / Businesses - Create Business',
          'title' => 'Create new Business',
          'description' => 'This is business create page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 2,
      ));
    }
  }

  public function addSitebusinessHomeBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_home');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_index_home',
          'displayname' => 'Directory / Businesses - Businesses Home',
          'title' => 'Businesses Home',
          'description' => 'This is business home page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));
      //Insert search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
      ));   

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusiness.categories-sitebusiness',
          'page_id' => $business_id,
          'params' => '{"title":"Categories","nomobile":"0","name":"sitebusiness.categories-sitebusiness"}',
          'parent_content_id' => $main_middle_id,
          'order' => 3,
      ));
            $db->insert($this->_contentTable, array(
                'page_id' => $business_id,
                'type' => 'widget',
                'name' => 'sitemobile.container-tabs-columns',
                'parent_content_id' => $main_middle_id,
                'order' => 5,
                'params' => '{"max":6}',
                'module' => 'sitemobile'
            ));
            $tab_id = $db->lastInsertId($this->_contentTable);
            
            if($this->_contentTable == 'engine4_sitemobileapp_content' || $this->_contentTable == 'engine4_sitemobileapp_tablet_content')   {  
              $viewType = "gridview";
              $layout_views = '["2"]';
              $content_display = '["featured","sponsored","date","owner","likeCount","followCount","memberCount","reviewCount","commentCount","viewCount","location"]';
            }else{
              $viewType = "listview";
              $layout_views = '["1","2"]';
              $content_display = '["ratings","date","owner","likeCount","followCount","memberCount","reviewCount","commentCount","viewCount","location","price"]';
            }
            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitebusiness.sitemobile-popular-businesses',
                'page_id' => $business_id,
                'parent_content_id' => $tab_id,
                'order' => 1,
                'module' => 'sitebusiness',
                'params' => '{"title":"Recently Posted","titleCount":true,"columnHeight":"260","category_id":"0","content_display":'.$content_display.',"name":"sitebusiness.sitemobile-popular-businesses","popularity":"Recently Posted","itemCount":"5","truncation":"16", "layouts_views":'.$layout_views.',"viewType":"'.$viewType.'"}',
            ));
            
            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitebusiness.sitemobile-popular-businesses',
                'page_id' => $business_id,
                'parent_content_id' => $tab_id,
                'order' => 2,
                'module' => 'sitebusiness',
                'params' => '{"title":"Most Viewed","titleCount":true,"columnHeight":"260","category_id":"0","content_display":'.$content_display.',"name":"sitebusiness.sitemobile-popular-businesses","popularity":"Most Viewed","itemCount":"5","truncation":"16", "layouts_views":'.$layout_views.',"viewType":"'.$viewType.'"}',                
            ));
            
            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitebusiness.sitemobile-popular-businesses',
                'page_id' => $business_id,
                'parent_content_id' => $tab_id,
                'order' => 3,
                'module' => 'sitebusiness',
                'params' => '{"title":"Featured","titleCount":true,"columnHeight":"260","category_id":"0","content_display":'.$content_display.',"name":"sitebusiness.sitemobile-popular-businesses","popularity":"Featured","itemCount":"5","truncation":"16","layouts_views":'.$layout_views.',"viewType":"'.$viewType.'"}',
                 ));
            
            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitebusiness.sitemobile-popular-businesses',
                'page_id' => $business_id,
                'parent_content_id' => $tab_id,
                'order' => 4,
                'module' => 'sitebusiness',
                'params' => '{"title":"Sponsored","titleCount":true,"columnHeight":"260","category_id":"0","content_display":'.$content_display.',"name":"sitebusiness.sitemobile-popular-businesses","popularity":"Sponsored",
                "itemCount":"5","truncation":"16","layouts_views":'.$layout_views.',"viewType":"'.$viewType.'"}',
                 ));
            
            $sitebusinessmemberEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember');
            if ($sitebusinessmemberEnabled) {
            // Insert content
            $db->insert($this->_contentTable, array(
                'type' => 'widget',
                'name' => 'sitebusiness.sitemobile-popular-businesses',
                'page_id' => $business_id,
                'parent_content_id' => $tab_id,
                'order' => 5,
                'module' => 'sitebusiness',
                'params' => '{"title":"Most Joined","titleCount":true,"columnHeight":"260","category_id":"0","content_display":'.$content_display.',"name":"sitebusiness.sitemobile-popular-businesses","popularity":"Most Joined",
                "itemCount":"5","truncation":"16","layouts_views":'.$layout_views.',"viewType":"'.$viewType.'"}',
                ));
            }
    }
  }

  public function addSitebusinessBrowseBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_index');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_index_index',
          'displayname' => 'Directory / Businesses - Browse Businesses',
          'title' => 'Browse Businesses',
          'description' => 'This is business browse page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));
      //Insert search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
      ));
      //WE WILL NOT ADD THE ALPHABETICAL WIDGET TAB ON APP AND TABLET APP.
     if($this->_pagesTable == 'engine4_sitemobile_pages' || $this->_pagesTable == 'engine4_sitemobile_tablet_pages')  {
        // Insert Alphabetic Filtering
        $db->insert($this->_contentTable, array(
            'type' => 'widget',
            'name' => 'sitebusiness.alphabeticsearch-sitebusiness',
            'page_id' => $business_id,
            'parent_content_id' => $main_middle_id,
            'order' => 2,
        ));
     }
 
       
          if($this->_contentTable == 'engine4_sitemobileapp_content' || $this->_contentTable == 'engine4_sitemobileapp_tablet_content') {
            //App Parameters for business listing
            $params = '{"title":"","titleCount":true,"layouts_views":["2"],"view_selected":"grid","layouts_oder":"2","columnHeight":"260","category_id":"0","content_display":["featured","sponsored","date","owner","likeCount","followCount","memberCount","reviewCount","location"],"name":"sitebusiness.sitemobile-businesses-sitebusiness"}';        
          }else{
            //Mobile Browser Parameters for business listing
            $params = '{"title":"","titleCount":true,"layouts_views":["1","2"],"view_selected":"list","layouts_oder":"2","columnHeight":"260","category_id":"0","content_display":["ratings","likeCount","followCount","memberCount","reviewCount","location","price"],"name":"sitebusiness.sitemobile-businesses-sitebusiness"}';   
          }
          
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusiness.sitemobile-businesses-sitebusiness',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => $params,
          'order' => 3,
      ));
    }
  }

  public function addSitebusinessManageBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    // profile business
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_manage');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_index_manage',
          'displayname' => 'Directory / Businesses - Manage Businesses',
          'title' => 'My Businesses',
          'description' => 'This page lists a user\'s Businesses\'s.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));
      //Insert search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
      ));
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 3,
      ));
    }

    return $this;
  }

  //Businesses i admin
  public function addSitebusinessManageAdminBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    // profile business
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_manageadmin_my-businesses');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_manageadmin_my-businesses',
          'displayname' => 'Directory / Businesses - Manage Business (Businesses I Admin)',
          'title' => 'Businesses I Admin',
          'description' => 'This page lists a user\'s Businesses\'s of which user\'s is admin.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 3,
      ));
    }

    return $this;
  }

  //Businesses i like
  public function addSitebusinessManageLikeBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    // profile business
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_like_mylikes');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_like_mylikes',
          'displayname' => 'Directory / Businesses - Manage Business (Businesses I Like)',
          'title' => 'Businesses I Like',
          'description' => 'This page lists a user\'s Businesses\'s which user\'s likes.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 3,
      ));
    }

    return $this;
  }

  //Businesses i joined
  public function addSitebusinessManageJoinedBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    // profile business
    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_like_my-joined');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusiness_like_my-joined',
          'displayname' => 'Directory / Businesses - Manage Business (Businesses I\'ve Joined)',
          'title' => "Businesses I've Joined",
          'description' => 'This page lists a user\'s Businesses\'s which user\'s have joined.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert menu
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 3,
      ));
    }

    return $this;
  }

  public function addSitebusinessBusinesses() {
    //$this->setDefaultWidgetForSitebusiness('content', 'pages');//::- NOT ADD Widget on USER Profile Page at installation
    //$this->setDefaultWidgetForSitebusiness('tabletcontent', 'tabletpages');//::- NOT ADD Widget on USER Profile Page at installation
  }

  public function setDefaultWidgetForSitebusiness($content, $businesses) {
    // install content areas

    $db = Engine_Db_Table::getDefaultAdapter();
    $select = new Zend_Db_Select($db);

    // profile business
    $select
            ->from($this->_pagesTable)
            ->where('name = ?', 'user_profile_index')
            ->limit(1);
    $business_id = $select->query()->fetchObject()->page_id;


    // sitemobile.blog-profile-blogs
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from($this->_contentTable)
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusiness.profile-sitebusiness')
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {

      // container_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container_id = $select->query()->fetchObject()->content_id;

      // middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('parent_content_id = ?', $container_id)
              ->where('type = ?', 'container')
              ->where('name = ?', 'middle')
              ->limit(1);
      $middle_id = $select->query()->fetchObject()->content_id;

      // tab_id (tab container) may not always be there
      $select
              ->reset('where')
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitemobile.container-tabs-columns')
              ->where('page_id = ?', $business_id)
              ->limit(1);
      $tab_id = $select->query()->fetchObject();
      if ($tab_id && @$tab_id->content_id) {
        $tab_id = $tab_id->content_id;
      } else {
        $tab_id = null;
      }

      // tab on profile
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.profile-sitebusiness',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 11,
          'params' => '{"title":"Businesses","titleCount":true}',
          'module' => 'sitebusiness'
      ));
    }
  }

}
