<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminViewsitebusinessController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_AdminViewsitebusinessController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGE BUSINESSES
  public function indexAction() {

    if ((Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.task.updateexpiredbusinesses') + 900) <= time()) {
      Engine_Api::_()->sitebusiness()->updateExpiredBusinesses();
    }

    //TAB CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusiness_admin_main', array(), 'sitebusiness_admin_main_viewsitebusiness');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Sitebusiness_Form_Admin_Manage_Filter();

    //GET BUSINESS ID
    $business = $this->_getParam('page', 1);

    //MAKE QUERY
    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');

    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tableBusinessName = $tableBusiness->info('name');
    
    $values = array();
      $select = $tableBusiness->select()
              ->setIntegrityCheck(false)
              ->from($tableBusinessName)
              ->joinLeft($tableUser, "$tableBusinessName.owner_id = $tableUser.user_id", 'username');
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    foreach ($values as $key => $value) {

      if (null == $value) {
        unset($values[$key]);
      }
    }

    //SEARCHING
    $this->view->owner = '';
    $this->view->title = '';
    $this->view->sponsored = '';
    $this->view->approved = '';
    $this->view->featured = '';
    $this->view->status = '';
    $this->view->businessbrowse = '';
    $this->view->category_id = '';
    $this->view->subcategory_id = '';
    $this->view->subsubcategory_id = '';
    $this->view->package_id = '';

    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $packageTable = Engine_Api::_()->getDbtable('packages', 'sitebusiness');

      $packageselect = $packageTable->select()->from($packageTable->info("name"), array("package_id", "title"))->order("package_id DESC");
      $this->view->packageList = $packageTable->fetchAll($packageselect);
    }


    $values = array_merge(array(
        'order' => 'business_id',
        'order_direction' => 'DESC',
            ), $values);


    if (!empty($_POST['owner'])) {
      $user_name = $_POST['owner'];
    } elseif (!empty($_GET['owner'])) {
      $user_name = $_GET['owner'];
    } else {
      $user_name = '';
    }


    if (!empty($_POST['title'])) {
      $business_name = $_POST['title'];
    } elseif (!empty($_GET['title'])) {
      $business_name = $_GET['title'];
    } elseif ($this->_getParam('title', '')) {
      $business_name = $this->_getParam('title', '');
    } else {
      $business_name = '';
    }

    //SEARCHING
    $this->view->owner = $values['owner'] = $user_name;
    $this->view->title = $values['title'] = $business_name;

    if (!empty($business_name)) {
      $select->where($tableBusinessName . '.title  LIKE ?', '%' . $business_name . '%');
    }

    if (!empty($user_name)) {
      $select->where($tableUser . '.displayname  LIKE ?', '%' . $user_name . '%');
    }

    if (isset($_POST['search'])) {

      if (!empty($_POST['sponsored'])) {
        $this->view->sponsored = $_POST['sponsored'];
        $_POST['sponsored']--;

        $select->where($tableBusinessName . '.sponsored = ? ', $_POST['sponsored']);
      }
      if (!empty($_POST['business_status'])) {

        $this->view->business_status = $_POST['business_status'];
        switch ($this->view->business_status) {
          case 1:
            $select->where($tableBusinessName . '.aprrove_date  IS NULL');
            break;
          case 2:
            $select->where($tableBusinessName . '.approved = ? ', 1);
            break;
          case 3:
            $select->where($tableBusinessName . '.aprrove_date  IS NOT NULL');
            $select->where($tableBusinessName . '.approved = ? ', 0);
            break;
          case 4:
            $select->where($tableBusinessName . '.declined  = ? ', 1);
            break;
        }
      }
      if (!empty($_POST['featured'])) {
        $this->view->featured = $_POST['featured'];
        $_POST['featured']--;
        $select->where($tableBusinessName . '.featured = ? ', $_POST['featured']);
      }
      if (!empty($_POST['status'])) {
        $this->view->status = $_POST['status'];
        $_POST['status']--;
        $select->where($tableBusinessName . '.closed = ? ', $_POST['status']);
      }

      if (!empty($_POST['package_id'])) {
        $this->view->package_id = $_POST['package_id'];
        $select->where($tableBusinessName . '.package_id = ? ', $_POST['package_id']);
      }
      if (!empty($_POST['businessbrowse'])) {
        $this->view->businessbrowse = $_POST['businessbrowse'];
        $_POST['businessbrowse']--;
        if ($_POST['businessbrowse'] == 0) {
          $select->order($tableBusinessName . '.view_count DESC');
        } elseif ($_POST['businessbrowse'] == 1) {
          $select->order($tableBusinessName . '.creation_date DESC');
        } elseif ($_POST['businessbrowse'] == 2) {
          $select->order($tableBusinessName . '.comment_count DESC');
        } elseif ($_POST['businessbrowse'] == 3) {
          $select->order($tableBusinessName . '.like_count DESC');
        }
      }

      if (!empty($_POST['category_id']) && empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'])) {
        $this->view->category_id = $_POST['category_id'];
        $select->where($tableBusinessName . '.category_id = ? ', $_POST['category_id']);
      } elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'])) {
        $this->view->category_id = $_POST['category_id'];
        $subcategory_id = $this->view->subcategory_id = $_POST['subcategory_id'];
        $table = Engine_Api::_()->getDbtable('categories', 'sitebusiness');
        $categoriesName = $table->info('name');
        $selectcategory = $table->select()->from($categoriesName, 'category_name')
                ->where("(category_id = $subcategory_id)");
        $row = $table->fetchRow($selectcategory);
        if (!empty($row->category_name)) {
          $this->view->subcategory_name = $row->category_name;
        }

        $select->where($tableBusinessName . '.category_id = ? ', $_POST['category_id'])
                ->where($tableBusinessName . '.subcategory_id = ? ', $_POST['subcategory_id']);
      } elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && !empty($_POST['subsubcategory_id'])) {

        $this->view->category_id = $_POST['category_id'];
        $subcategory_id = $this->view->subcategory_id = $_POST['subcategory_id'];
        $subsubcategory_id = $this->view->subsubcategory_id = $_POST['subsubcategory_id'];

        $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subcategory_id);
        if (!empty($row->category_name)) {
          $this->view->subcategory_name = $row->category_name;
        }
        $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subsubcategory_id);
        if (!empty($row->category_name)) {
          $this->view->subsubcategory_name = $row->category_name;
        }
        $select->where($tableBusinessName . '.category_id = ? ', $_POST['category_id'])
                ->where($tableBusinessName . '.subcategory_id = ? ', $_POST['subcategory_id'])
                ->where($tableBusinessName . '.subsubcategory_id = ? ', $_POST['subsubcategory_id']);
        ;
      }
    }

    $this->view->formValues = array_filter($values);
    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'business_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(50);
    $this->view->paginator = $paginator->setCurrentPageNumber($business);
  }

  //VIEW BUSINESS DETAIL
  public function detailAction() {

    $id = $this->_getParam('id');

    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tableBusinessName = $tableBusiness->info('name');

    $select = $tableBusiness->select()
            ->setIntegrityCheck(false)
            ->from($tableBusinessName)
            ->where($tableBusinessName . '.business_id = ?', $id)
            ->limit(1);
    $this->view->sitebusinessDetail = $detail = $tableBusiness->fetchRow($select);

    $this->view->manageAdminEnabled = $manageAdminEnabled = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manageadmin', 1);
    if (!empty($manageAdminEnabled)) {
      $manageadminTable = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness');
      $manageadminTableName = $manageadminTable->info('name');
      $select = $manageadminTable->select()
              ->from($manageadminTableName, array('COUNT(*) AS count'))
              ->where('business_id = ?', $id);
      $rows = $tableBusiness->fetchAll($select)->toArray();
      $this->view->admin_total = $rows[0]['count'];
    }

    $this->view->category_id = $category_id = $detail['category_id'];
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($category_id);
    if (!empty($row->category_name)) {
      $this->view->category_name = $row->category_name;
    }
    $this->view->subcategory_id = $subcategory_id = $detail['subcategory_id'];
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subcategory_id);
    if (!empty($row->category_name)) {
      $this->view->subcategory_name = $row->category_name;
    }
    $this->view->subsubcategory_id = $subsubcategory_id = $detail['subsubcategory_id'];
    $row = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategory($subsubcategory_id);
    if (!empty($row->category_name)) {
      $this->view->subsubcategory_name = $row->category_name;
    }
    //SITEBUSINESS-REVIEW PLUGIN IS INSTALLED OR NOT
    $this->view->isEnabledSitebusinessreview = (int) Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview');
  }

  //ACTION FOR MULTI-DELETE OF BUSINESSES
  public function multiDeleteAction() {

    if ($this->getRequest()->isPost()) {

      $values = $this->getRequest()->getPost();

      foreach ($values as $key => $value) {

        if ($key == 'delete_' . $value) {

          //DELETE SITEBUSINESSES FROM DATABASE
          $business_id = (int) $value;

          //START SUB BUSINESS WORK
          $getSubBusinessids = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getsubBusinessids($business_id);
          foreach ($getSubBusinessids as $getSubBusinessid) {
            Engine_Api::_()->sitebusiness()->onBusinessDelete($getSubBusinessid['business_id']);
          }
          //END SUB BUSINESS WORK

          Engine_Api::_()->sitebusiness()->onBusinessDelete($business_id);
        }
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }

  //ACTION FOR BUSINESS EDIT
  public function editAction() {

    //TAB CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitebusiness_admin_main', array(), 'sitebusiness_admin_main_viewsitebusiness');

    //GET BUSINESS ID AND BUSINESS OBJECT
    $business_id = $this->_getParam('id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //FORM GENERATION
    $this->view->form = $form = new Sitebusiness_Form_Admin_Manage_Edit();

    if (!empty($sitebusiness->declined)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $status_businessOption = array();
    $approved = $sitebusiness->approved;
    if (empty($sitebusiness->aprrove_date) && empty($approved)) {
      $status_businessOption["0"] = "Approval Pending";
      $status_businessOption["1"] = "Approved Business";
      $status_businessOption["2"] = "Declined Business";
    } else {
      $status_businessOption["1"] = "Approved";
      $status_businessOption["0"] = "Dis-Approved";
    }
    $form->getElement("status_business")->setMultiOptions($status_businessOption);

    if (!$this->getRequest()->isPost()) {

      $form->getElement("closed")->setValue($sitebusiness->closed);
      $form->getElement("status_business")->setValue($sitebusiness->approved);
      $form->getElement("featured")->setValue($sitebusiness->featured);
      $form->getElement("sponsored")->setValue($sitebusiness->sponsored);
      $title = "<a href='" . $this->view->url(array('business_url' => $sitebusiness->business_url), 'sitebusiness_entry_view') . "'  target='_blank'>" . $sitebusiness->title . "</a>";
      $form->title_dummy->setDescription($title);
      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        $form->package_title->setDescription("<a href='" . $this->view->url(array('route' => 'admin_default', 'module' => 'sitebusiness', 'controller' => 'package', 'action' => 'packge-detail', 'id' => $sitebusiness->package_id), 'admin_default') . "'  class ='smoothbox'>" . ucfirst($sitebusiness->getPackage()->title) . "</a>");

        $package = $sitebusiness->getPackage();
        if ($package->isFree()) {

          $form->getElement("status")->setMultiOptions(array("free" => "NA (Free)"));
          $form->getElement("status")->setValue("free");
          $form->getElement("status")->setAttribs(array('disable' => true));
        } else {
          $form->getElement("status")->setValue($sitebusiness->status);
        }
      }
    } elseif ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        //PROCESS
        $values = $form->getValues();
        if ($values['status_business'] == 2) {
          $values['declined'] = 1;
        } else {
          $approved = $values['status_business'];
        }
        $sitebusiness->setFromArray($values);
        if (!empty($sitebusiness->declined)) {
          Engine_Api::_()->sitebusiness()->sendMail("DECLINED", $sitebusiness->business_id);
        }
        $sitebusiness->save();
        $db->commit();
        if ($approved != $sitebusiness->approved) {

          return $this->_helper->redirector->gotoRoute(array('module' => 'sitebusiness', 'controller' => 'admin', 'action' => 'approved', "id" => $business_id), "default", true);
        }
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }
  }
  
  //ACTION FOR EDIT CREATION DATE OF THE BUSINESSS.
  public function editCreationDateAction() {
  
  		//SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');
    
    //GET BUSINESS ID AND BUSINESS OBJECT
    $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		$businessExpiryDate = strtotime($sitebusiness->expiration_date);
 
    //FORM GENERATION
    $form = $this->view->form = new Sitebusiness_Form_Admin_editCreationDate();
    
    $creation_date = $sitebusiness->creation_date;
		$form->populate($sitebusiness->toArray());
 
    $form->populate(array(
			'starttime' => $creation_date,
			'endtime' => $sitebusiness->expiration_date,
    ));

    //CHECK POST
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      //GET FORM VALUES
      $values = $form->getValues();
      
      $modifiedCreationDate = strtotime($values['starttime']);
      if ($sitebusiness->expiration_date != '2250-01-01 00:00:00') {
				if ($businessExpiryDate < $modifiedCreationDate) {
					$itemError = Zend_Registry::get('Zend_Translate')->_("Creation Date * This should be less than expiration date.");
					$form->creation_date->setValue($sitebusiness->creation_date);
					$form->addError($itemError);
					return;
				}
 			}

			//BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
      
        $table = Engine_Api::_()->getDbtable('business', 'sitebusiness');
        $table->update(array('creation_date'=>  $values['starttime']), array('business_id =?' => $business_id));
        $db->commit();
        
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
              'smoothboxClose' => 10,
              'parentRefresh' => 10,
              'messages' => array(Zend_Registry::get('Zend_Translate')->_('The Creation Date of the Business has been edited successfully.'))
      ));
    }
  }
}

?>