<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_MobiController extends Core_Controller_Action_Standard {

  protected $_navigation;

  //SET THE VALUE FOR ALL ACTION DEFAULT
  public function init() {

		//BUSINESS VIEW AUTHORIZATION
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

    $ajaxContext = $this->_helper->getHelper('AjaxContext');
    $ajaxContext
        ->addActionContext('rate', 'json')
        ->addActionContext('validation', 'html')
        ->initContext();

		//GET BUSINESS URL AND BUSINESS ID
    $business_url = $this->_getParam('business_url', $this->_getParam('business_url', null));
    $business_id = $this->_getParam('business_id', $this->_getParam('business_id', null));

    if ($business_url) {
      $id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url);
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $id);
      if ($sitebusiness) {
        Engine_Api::_()->core()->setSubject($sitebusiness);
      }
    } elseif ($business_id) {
      $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
      if ($sitebusiness) {
        Engine_Api::_()->core()->setSubject($sitebusiness);
      }
    }
 
		//FOR UPDATE EXPIRATION
    if ((Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.task.updateexpiredbusinesses') + 900) <= time()) {
      Engine_Api::_()->sitebusiness()->updateExpiredBusinesses();
    }
  }

  //ACTION FOR SHOWING THE BUSINESS LIST
  public function indexAction() {

		//BUSINESS VIEW AUTHORIZATION
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if (empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0'))) {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
          ->setNoRender()
          ->setEnabled();
    }
  }

  //ACTION FOR SHOWING THE HOME BUSINESS
  public function homeAction() {

		//BUSINESS VIEW AUTHORIZATION
    if (!$this->_helper->requireAuth()->setAuthParams('sitebusiness_business', null, 'view')->isValid())
      return;

    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if (empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0'))) {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
          ->setNoRender()
          ->setEnabled();
    }
  }

	//ACTION FOR VIEW PROFILE BUSINESS
  public function viewAction() {

		//RETURN IF SUBJECT IS NOT SET
    if (!$this->_helper->requireSubject('sitebusiness_business')->isValid())
      return;

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

		//GET BUSINESS SUBJECT AND THEN CHECK VALIDATION
    $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    if (empty($sitebusiness)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    $business_id = $sitebusiness->business_id;

    $levelHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.level.createhost', 0);

    $package = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.lsettings', 0);

    $memory_size = ini_get('memory_limit');
    $memory_Size_int_array = explode("M", $memory_size);
    $memory_Size_int = $memory_Size_int_array[0];
    if ($memory_Size_int <= 32)
      ini_set('memory_limit', '64M');
    $maxView = 19;

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    if (!Engine_Api::_()->sitebusiness()->canViewBusiness($sitebusiness)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

		$current_date = date('Y-m-d H:i:s');
    $this->view->headScript()->appendFile($this->view->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/scripts/core.js')  
                             ->appendFile($this->view->layout()->staticBaseUrl.'application/modules/Sitebusiness/externals/scripts/hideTabs.js');
//     $sitebusinesstable = Engine_Api::_()->getDbtable('vieweds', 'sitebusiness');
// 
// 		//FUNCTION CALLING AND PASS BUSINESS ID AND VIEWER ID
// 		$sitebusinessresult = Engine_Api::_()->getDbtable('businessstatistics', 'sitebusiness')->getVieweds($viewer_id, $business_id);
// 
//     $count = count($sitebusinessresult);
//     if (empty($count)) {
//       $row = $sitebusinesstable->createRow();
//       $row->business_id = $business_id;
//       $row->viewer_id = $viewer_id;
//       $row->save();
//     } else {
//       $sitebusinesstable->update(array('date' => $current_date), array('business_id = ?' => $business_id, 'viewer_id' => $viewer_id));
//     }

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitebusiness->getOwner();
   
    $sub_status_table = Engine_Api::_()->getDbTable('businessstatistics', 'sitebusiness');
   
		//INCREMENT BUSINESS VIEWS DATE-WISE
    $values = array('business_id' => $sitebusiness->business_id);

    $statObject = $sub_status_table->businessReportInsights($values);
    $raw_views = $sub_status_table->fetchRow($statObject);
    $raw_views_count = $raw_views['views'];
    if (!$owner->isSelf($viewer) || ($sitebusiness->view_count == 1 && empty($raw_views_count))) {
      $sub_status_table->businessViewCount($business_id);
    }

    if (!$owner->isSelf($viewer)) {
      $sitebusiness->view_count++;
    }

    $sitebusiness->save();

		//CHECK TO SEE IF PROFILE STYLES IS ALLOWED
    $style_perm = 1;

    if ($style_perm) {

      //GET STYLE
      $table = Engine_Api::_()->getDbtable('styles', 'core');
      $select = $table->select()
              ->where('type = ?', $sitebusiness->getType())
              ->where('id = ?', $sitebusiness->getIdentity())
              ->limit();

      $row = $table->fetchRow($select);
      if (null !== $row && !empty($row->style)) {
        $this->view->headStyle()->appendStyle($row->style);
      }
    }

    if (null !== ($tab = $this->_getParam('tab'))) {
      $friend_tab_function = <<<EOF
                                        var content_id = "$tab";
                                        this.onload = function()
                                        {
      																		if(window.tabContainerSwitch) 
      																		{
                                              tabContainerSwitch($('main_tabs').getElement('.tab_' + content_id));
																					}
                                        }
EOF;
      $this->view->headScript()->appendScript($friend_tab_function);
    }    
    
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
  
		// Start: Suggestion work.
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    // Here we are delete this poll suggestion if viewer have.
    if (!empty($is_moduleEnabled)) {
      Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer->getIdentity(), 'sitebusiness_business', $business_id, 'business_suggestion');
    }
    // End: Suggestion work.
    
		if (empty(Engine_Api::_()->seaocore()->checkVersion($coreversion, '4.1.0'))) {

			$this->_helper->content->render();
		} else {
			$this->_helper->content->setNoRender()->setEnabled();
		}
  }
}
?>