<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.isActivate', 0);
if (empty($isActive)) {
  return;
}
$routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.manifestUrlP', "businessitems");
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$ads_Array = $categories_prepared = array();
$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}
$detactLocationElement = array(
    'Select',
    'detactLocation',
    array(
        'label' => 'Do you want to display members based on user’s current location?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => '0'
    )
);
$showProfileField = array(
	'Radio',
	'showProfileField',
	array(
		'label' => 'Do you want to show custom field?',
		'multiOptions' => array(
				1 => 'Yes',
				0 => 'No'
		),
		'value' => 0,
	),
);
$customFieldHeading = array(
    'Radio',
    'custom_field_heading',
    array(
        'label' => 'Do you want to show "Heading" of custom field?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => '0'
    )
);

$customFieldTitle = array(
    'Radio',
    'custom_field_title',
    array(
        'label' => 'Do you want to show “Title" of custom field?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => '0'
    )
);

$customParamsCount = array(
		'Text',
		'customFieldCount',
		array(
				'label' => $view->translate('Custom Profile Fields'),
				'description' => $view->translate('(number of profile fields to show.)'),
				'value' => 2,
		)
);

$featuredSponsoredElement = array(
    'Select',
    'fea_spo',
    array(
        'label' => 'Show Businesses',
        'multiOptions' => array(
            '' => '',
            'featured' => 'Featured Only',
            'sponsored' => 'Sponsored Only',
            'fea_spo' => 'Both Featured and Sponsored',
        ),
        'value' => 'sponsored',
    )
);

$showViewMoreContent = array(
    'Select',
    'show_content',
    array(
        'label' => 'What do you want for view more content?',
        'description' => '',
        'multiOptions' => array(
            '1' => 'Pagination',
            '2' => 'Show View More Link at Bottom',
            '3' => 'Auto Load Businesses on Scrolling Down'),
        'value' => 2,
    )
);

if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {

  $popularity_options = array(
      'view_count' => 'Most Viewed',
      'like_count' => 'Most Liked',
      'comment_count' => 'Most Commented',
      'review_count' => 'Most Reviewed',
      'rating' => 'Most Rated',
      'business_id' => 'Most Recent',
      'modified_date' => 'Recently Updated',
  );
} else {
  $popularity_options = array(
      'view_count' => 'Most Viewed',
      'like_count' => 'Most Liked',
      'comment_count' => 'Most Commented',
      'business_id' => 'Most Recent',
      'modified_date' => 'Recently Updated',
  );
}

$category_businesses_multioptions = array(
    'view_count' => 'Views',
    'like_count' => 'Likes',
    'comment_count' => 'Comments',
);
$pinboardShowsOptions = array(
    "viewCount" => "Views",
    "likeCount" => "Likes",
    "commentCount" => "Comments",
    'followCount' => 'Followers',
    "price" => 'Price',
    "location" => "Location"
);

if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
  $pinboardShowsOptions['reviewsRatings'] = "Reviews & Ratings";
}

$pinboardPopularityOptions = array(
    'view_count' => 'Most Viewed',
    'like_count' => 'Most Liked',
    'comment_count' => 'Most Commented',
    'follow_count' => 'Most Following',
    'business_id' => 'Most Recent',
    'modified_date' => 'Recently Updated',
);

$showContent_timeline = array("mainPhoto" => "Business Profile Photo", "title" => "Business Title", "followButton" => "Follow Button", "likeButton" => "Like Button", "likeCount" => "Total Likes", "followCount" => "Total Followers");
$showContent_option = array("mainPhoto", "title", "followButton", "likeButton", "followCount", "likeCount");

$layouts_tabs = array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5');
$layouts_tabs_options = array("1" => "Recent", "2" => "Most Popular", "3" => "Random", "4" => "Featured", "5" => "Sponsored");
$joined_order = array();
$linkDescription = 'Displays various links like  "Businesses I Admin", "Businesses I\'ve Claimed" and "Businesses I Like" on your site. This widget should be placed on Directory / Businesses - Manage Businesses page.';       
$linksOptions = array("businessAdmin" => "Businesses I Admin", "businessClaimed" => "Businesses I\'ve Claimed", 'businessLiked' => 'Businesses I Like');
$linksValues = array("businessAdmin","businessClaimed","businessLiked");

if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
  $showContent_timeline['memberCount'] = 'Total Members';
  $showContent_timeline['addButton'] = 'Add People Button';
  $showContent_timeline['joinButton'] = 'Join Business Button';

  $showContent_option[] = 'addButton';
  $showContent_option[] = 'joinButton';
  $showContent_option[] = 'memberCount';

  $pinboardShowsOptions['memberCount'] = 'Members';
  $pinboardPopularityOptions['member_count'] = "Most Joined Businesses";
  $layouts_tabs['5'] = "6";
  $layouts_tabs_options["6"] = "Most Joined Businesses";
  $joined_order = array(
      'Text',
      'joined_order',
      array(
          'label' => 'Most Joined Businesses Tab (order)',
      ),
  );
  $linksOptions = array_merge($linksOptions, array('businessesJoined' => 'Businesses I\'ve Joined'));
  $linksValues[] =  "businessesJoined";  
  $linkDescription = 'Displays various links like  "Businesses I Admin", "Businesses I\'ve Claimed", "Businesses I Like" and "Businesses I\'ve Joined" on your site. This widget should be placed on Directory / Businesses - Manage Businesses page.';  
}


$statisticsElement = array("likeCount" => "Likes", "followCount" => "Followers", "viewCount" => "Views", "commentCount" => "Comments");
$statisticsElementValue = array("viewCount", "likeCount", "followCount", "commentCount");


$statisticsBrowseElement = $statisticsElement;
$statisticsBrowseElementValue = $statisticsElementValue;
  
if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
  $statisticsElement['reviewCount'] = "Reviews";
  $statisticsElementValue[] = "reviewCount";
}
if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
  $statisticsElement['memberCount'] = "Members";
  $statisticsElementValue[] = "memberCount";
  
  $statisticsMemmberElement['memberApproval'] = "Join immediately / Must be approved";
  $statisticsMemmberElementstatisticsElementValue[] = "memberApproval";
  
  $statisticsBrowseElement = array_merge($statisticsElement, $statisticsMemmberElement);
  $statisticsBrowseElementValue = array_merge($statisticsElementValue, $statisticsMemmberElementstatisticsElementValue);
}

if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
  $category_businesses_multioptions['member_count'] = 'Members';
}
if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
  $category_businesses_multioptions['review_count'] = 'Reviews';
}
if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.proximity.search.kilometer', 0)) {
  $locationDescription = "Choose the kilometers within which businesses will be displayed. (This setting will only work, if you have chosen 'Yes' in the above setting.)";
  $locationLableS = "Kilometer";
  $locationLable = "Kilometers";
} else {
  $locationDescription = "Choose the miles within which businesses will be displayed. (This setting will only work, if you have chosen 'Yes' in the above setting.)";
  $locationLableS = "Mile";
  $locationLable = "Miles";
}

$defaultLocationDistanceElement = array(
    'Select',
    'defaultLocationDistance',
    array(
        'label' => $locationDescription,
        'multiOptions' => array(
            '0' => '',
            '1' => '1 ' . $locationLableS,
            '2' => '2 ' . $locationLable,
            '5' => '5 ' . $locationLable,
            '10' => '10 ' . $locationLable,
            '20' => '20 ' . $locationLable,
            '50' => '50 ' . $locationLable,
            '100' => '100 ' . $locationLable,
            '250' => '250 ' . $locationLable,
            '500' => '500 ' . $locationLable,
            '750' => '750 ' . $locationLable,
            '1000' => '1000 ' . $locationLable,
        ),
        'value' => '1000'
    )
);



$final_array = array(
    array(
        'title' => 'Business Archives',
        'description' => 'Displays the month-wise archives for the businesses posted on your site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.archives-sitebusiness',
        'defaultParams' => array(
            'title' => 'Archives',
            'titleCount' => true,
        )
    ),
    array(
        'title' => 'Navigation Tabs',
        'description' => 'Displays the Navigation tabs businesses having links of Businesses Home, Browse Businesses, etc. This widget should be placed at the top of Businesses Home and Browse Businesses businesses.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.browsenevigation-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Categories, Sub-categories and 3<sup>rd</sup> Level-categories (sidebar)',
        'description' => 'Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of businesses in an expandable form. Clicking on them will redirect the viewer to the list of businesses created in that category.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.categories-sitebusiness',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Categories, Sub-categories and 3<sup>rd</sup> Level-categories',
        'description' => 'Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of businesses in an expandable form. Clicking on them will redirect the viewer to the list of businesses created in that category.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.categories',
        'defaultParams' => array(
            'title' => 'Categories',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 businesses in them? (Note: Selecting "Yes" will display all the categories WITHOUT  the count of the businesses created in them if "Browse by Networks" are enabled  from the Global Settings of Directory / Businesses Plugin and display all the categories with count if selected "No" for Browse by Networks. While selecting "No" here will display categories with count of the businesses.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Radio',
                    'show2ndlevelCategory',
                    array(
                        'label' => 'Do you want to show sub-categories in this widget?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'show3rdlevelCategory',
                    array(
                        'label' => 'Do you want to show 3rd level category to the viewer? (This setting will depend on above setting.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Profile Businesses',
        'description' => 'Displays members\' businesses on their profile.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.profile-sitebusiness',
        'defaultParams' => array(
            'title' => 'Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'businessAdmin',
                    array(
                        'label' => 'Which all Businesses related to the user do you want to display in this tab widget on their profile?',
                        'multiOptions' => array(
                            1 => 'Businesses Owned by the user. (Business Owner)',
                            2 => 'Businesses Administered by the user. (Business Admin)'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
             array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),    
            )
        ),
    ),
    array(
        'title' => 'Featured Businesses Slideshow',
        'description' => 'Displays the Featured Businesses in the form of an attractive Slideshow with interactive controls.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.slideshow-sitebusiness',
        'defaultParams' => array(
            'title' => 'Featured Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Sponsored Businesses Slideshow',
        'description' => 'Displays the Sponsored Businesses in the form of an attractive Slideshow with interactive controls.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.sponsored-slideshow-sitebusiness',
        'defaultParams' => array(
            'title' => 'Sponsored Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Post a New Business',
        'description' => 'Displays the link to Post a New Business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.newbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        )
    ),
    array(
        'title' => 'Most Commented Businesses',
        'description' => 'Displays the list of Businesses having maximum number of comments.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostcommented-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Commented Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Most Followed Businesses',
        'description' => 'Displays a list of businesses having maximum number of followers. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostfollowers-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Followed Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Most Liked Businesses',
        'description' => 'Displays list of businesses having maximum number of likes.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostlikes-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Liked Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Popular Business Tags',
        'description' => 'Shows popular tags with frequency.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.tagcloud-sitebusiness',
        'adminForm' => array(
            'elements' => array(
                array(
                    'hidden',
                    'title',
                    array(
                        'label' => '',
                        'order' => 1001
                    )
                ),
                array(
                    'hidden',
                    'nomobile',
                    array(
                        'label' => '',
                        'order' => 1002
                    )
                ),
//          array(
//            'hidden',
//            'execute',
//            array(
//              'label' => ''
//            )
//          ),
//          array(
//            'hidden',
//            'cancel',
//            array(
//              'label' => ''
//            )
//          ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Recent Businesses',
        'description' => 'Displays list of recently created Businesses.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.recentlyposted-sitebusiness',
        'defaultParams' => array(
            'title' => 'Recent',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Popular Businesses',
        'description' => 'Displays list of popular businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostviewed-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Popular',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Browse Businesses: Pinboard View',
        'description' => 'Displays a list of all the businesses on site in attractive Pinboard View. You can also choose to display businesses based on user’s current location by using the Edit Settings of this widget. It is recommended to place this widget on "Browse Businesses\'s Pinboard View" business. ',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.pinboard-browse',
        'autoEdit' => true,
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'postedby',
                    array(
                        'label' => 'Show posted by option. (Selecting "Yes" here will display the member\'s name who has created the business.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Radio',
                    'showfeaturedLable',
                    array(
                        'label' => 'Do you want “Featured Label” for the Businesses to be displayed in block?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showsponsoredLable',
                    array(
                        'label' => 'Do you want “Sponsored Label”  for the Businesses to be displayed in block?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'showoptions',
                    array(
                        'label' => 'Choose the options that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $pinboardShowsOptions,
                    //'value' =>array("viewCount","likeCount","commentCount","reviewCount"),
                    ),
                ),
                array(
                    'Select',
                    'detactLocation',
                    array(
                        'label' => 'Do you want to display businesses based on user’s current location?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0'
                    )
                ),
                array(
                    'Select',
                    'defaultlocationmiles',
                    array(
                        'label' => $locationDescription,
                        'multiOptions' => array(
                            '0' => '',
                            '1' => '1 ' . $locationLableS,
                            '2' => '2 ' . $locationLable,
                            '5' => '5 ' . $locationLable,
                            '10' => '10 ' . $locationLable,
                            '20' => '20 ' . $locationLable,
                            '50' => '50 ' . $locationLable,
                            '100' => '100 ' . $locationLable,
                            '250' => '250 ' . $locationLable,
                            '500' => '500 ' . $locationLable,
                            '750' => '750 ' . $locationLable,
                            '1000' => '1000 ' . $locationLable,
                        ),
                        'value' => '1000'
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Text',
                    'itemWidth',
                    array(
                        'label' => 'One Item Width',
                        'description' => 'Enter the width for each pinboard item.',
                        'value' => 237,
                    )
                ),
                array(
                    'Radio',
                    'withoutStretch',
                    array(
                        'label' => 'Do you want to display the images without stretching them to the width of each pinboard item?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of Businesses to show)',
                        'value' => 12,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'show_buttons',
                    array(
                        'label' => 'Choose the action links that you want to be available for the Businesses displayed in this block.',
                        'multiOptions' => array("comment" => "Comment", "like" => "Like / Unlike", 'share' => 'Share', 'facebook' => 'Facebook', 'twitter' => 'Twitter', 'pinit' => 'Pin it', 'tellAFriend' => 'Tell a Friend', 'print' => 'Print')
                    //'value' =>array("viewCount","likeCount","commentCount","reviewCount"),
                    ),
                ),
                array(
                    'Text',
                    'truncationDescription',
                    array(
                        'label' => "Enter the truncation limit for the Business Description. (If you want to hide the description, then enter '0'.)",
                        'value' => 100,
                    )
                ),
                array(
                    'Select',
                    'commentSection',
                    array(
                        'label' => 'Do you want to display comments?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1'
                    )
                ),
                array(
                    'Select',
                    'defaultLoadingImage',
                    array(
                        'label' => 'Do you want to show a Loading image when this widget renders on a business?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0'
                    )
                ),
// 						array(
// 							'Radio',
// 							'getdirection',
// 							array(
// 									'label' => 'Show get direction link.',
// 									'multiOptions' => array(
// 											1 => 'Yes',
// 											0 => 'No'
// 									),
// 									'value' => 1,
// 							),
// 						),
            ),
        )
    ),
//     array(
//         'title' => 'Business Profile  Cover Photo and Information',
//         'description' => 'Displays the business cover photo with business profile photo, title and various action links that can be performed on the business from their Profile business (Like, Follow, etc.). You can choose various options from the Edit Settings of this widget. This widget should be placed on the Business Profile business.',
//         'category' => 'Business Profile',
//         'type' => 'widget',
//         'name' => 'sitebusiness.business-cover-information-sitebusiness',
//         'defaultParams' => array(
//             'title' => 'Information',
//             'titleCount' => true,
//             'showContent' => $showContent_option
//         ),
//         'adminForm' => array(
//             'elements' => array(
//                 array(
//                     'MultiCheckbox',
//                     'showContent',
//                     array(
//                         'label' => 'Select the information options that you want to be available in this block.',
//                         'multiOptions' => $showContent_timeline,
//                     ),
//                 ), 
//                 array(
//                     'Text',
//                     'columnHeight',
//                     array(
//                         'label' => 'Enter the cover photo height (in px). (Minimum 150 px required.)',
//                         'value' => '300',
//                     )
//                 ),             
//             ),
//         ),
//     ),
    array(
        'title' => 'Browse Businesses’ Locations',
        'description' => 'Displays a list of all the businesses having location entered corresponding to them on the site. This widget should be placed on Browse Businesses’ Locations business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.browselocation-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
// 						array(
// 							'Radio',
// 							'getdirection',
// 							array(
// 									'label' => 'Show get direction link.',
// 									'multiOptions' => array(
// 											1 => 'Yes',
// 											0 => 'No'
// 									),
// 									'value' => 1,
// 							),
// 						),
            ),
        )
    ),
    array(
        'title' => 'Browse Businesses',
        'description' => 'Displays a list of all the businesses on site. This widget should be placed on the Browse Businesses business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.businesses-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'layouts_views' => array("0" => "1", "1" => "2", "2" => "3"),
            'layouts_oder' => 1,
            'columnWidth' => 100,
            'statistics' => $statisticsBrowseElementValue,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'layouts_views',
                    array(
                        'label' => 'Choose the view types that you want to be available for businesses on the businesses home and browse businesses.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View")
                    ),
                ),
                array(
                    'Radio',
                    'layouts_oder',
                    array(
                        'label' => 'Select a default view type for Directory Items / Businesses.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View")
                    )
                ),
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column Width For Grid View.',
                        'value' => '100',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column Height For Grid View.',
                        'value' => '350',
                    )
                ),
                array(
                    'Text',
                    'turncation',
                    array(
                        'label' => 'Title Truncation Limit For Grid View.',
                        'value' => '40',
                    )
                ),
                array(
                    'Radio',
                    'showlikebutton',
                    array(
                        'label' => 'Do you want to show “Like Button” when users mouse over on Businesses in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showfeaturedLable',
                    array(
                        'label' => 'Do you want “Featured Label” for the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showsponsoredLable',
                    array(
                        'label' => 'Do you want “Sponsored Label”  for the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showlocation',
                    array(
                        'label' => 'Do you want “Location” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showgetdirection',
                    array(
                        'label' => 'Do you want “Get Direction” link for the businesses having location to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showprice',
                    array(
                        'label' => 'Do you want “Price” of the Businesses to be displayed?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showpostedBy',
                    array(
                        'label' => 'Do you want “Posted By” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showdate',
                    array(
                        'label' => 'Do you want “Creation Date” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showContactDetails',
                    array(
                        'label' => 'Do you want “Contact Details” of the Businesses to be displayed in list and map view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Listings in this block.',
                        'multiOptions' => $statisticsBrowseElement,
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                $showProfileField,
								$customFieldHeading,
								$customFieldTitle,
                $showViewMoreContent,
								$customParamsCount,
                $detactLocationElement,
                $defaultLocationDistanceElement,
            ),
        )
    ),
    array(
        'title' => 'Search Businesses form',
        'description' => 'Displays the form for searching Businesses on the basis of various filters.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.search-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'viewType',
                    array(
                        'label' => 'Show Search Form',
                        'multiOptions' => array(
                            'horizontal' => 'Horizontal',
                            'vertical' => 'Vertical',
                        ),
                        'value' => 'vertical'
                    )
                ),
                array(
                    'Radio',
                    'locationDetection',
                    array(
                        'label' => "Allow browser to detect user's current location.",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Random Businesses',
        'description' => 'Displays list of Businesses randomly.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.random-sitebusiness',
        'defaultParams' => array(
            'title' => 'Random',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Sponsored Businesses Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the sponsored Businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.sponsored-sitebusiness',
        'defaultParams' => array(
            'title' => 'Sponsored Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 4,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Sponsored Carousel Speed',
                        'description' => '(What maximum Carousel Speed should be applied to the sponsored widget?)',
                        'value' => 300,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Text',
                    'truncation',
                    array(
                        'label' => 'Title Truncation Limit',
                        'description' => '(What maximum limit should be applied to the number of characters in the titles of items in the Sponsored widgets? (Enter a number between 1 and 999. Titles having more characters than this limit will be truncated. Complete titles will be shown on mouseover.))',
                        'value' => 18,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'AJAX based Businesses Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the businesses on the site. You can choose to show sponsored / featured in this widget from the settings of this widget. You can place this widget multiple times on a business with different criterion chosen for each placement.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.ajax-carousel-sitebusiness',
        'defaultParams' => array(
            'title' => 'Businesses Carousel',
            'titleCount' => true,
            'statistics' => $statisticsElementValue,
        ),
        'adminForm' => array(
            'elements' => array(
                $featuredSponsoredElement,
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Listings in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
                array(
                    'Radio',
                    'viewType',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'blockHeight',
                    array(
                        'label' => 'Enter the height of each slideshow item.',
                        'value' => 240,
                    )
                ),
                array(
                    'Text',
                    'blockWidth',
                    array(
                        'label' => 'Enter the width of each slideshow item.',
                        'value' => 150,
                    )
                ),
                array(
                    'Select',
                    'popularity',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => $popularity_options,
                        'value' => 'listing_id',
                    )
                ),
                array(
                    'Radio',
                    'featuredIcon',
                    array(
                        'label' => 'Do you want to show the featured icon / label. (You can choose the marker from the \'Global Settings\' section in the Admin Panel.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Radio',
                    'sponsoredIcon',
                    array(
                        'label' => 'Do you want to show the sponsored icon / label. (You can choose the marker from the \'Global Settings\' section in the Admin Panel.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 4,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Sponsored Carousel Speed',
                        'description' => '(What maximum Carousel Speed should be applied to the sponsored widget?)',
                        'value' => 300,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Text',
                    'truncation',
                    array(
                        'label' => 'Title Truncation Limit',
                        'description' => '(What maximum limit should be applied to the number of characters in the titles of items in the Sponsored widgets? (Enter a number between 1 and 999. Titles having more characters than this limit will be truncated. Complete titles will be shown on mouseover.))',
                        'value' => 50,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business of the Day',
        'description' => 'Displays the Business of the Day as selected by the Admin from the widget settings section of this plugin.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.item-sitebusiness',
        'defaultParams' => array(
            'title' => 'Business of the Day',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Recently Viewed Businesses',
        'description' => 'Displays list of recently viewed Businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.recentview-sitebusiness',
        'defaultParams' => array(
            'title' => 'Recently Viewed',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Recently Viewed By Friends',
        'description' => 'Displays list of Businesses recently viewed by friends.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.recentfriend-sitebusiness',
        'defaultParams' => array(
            'title' => 'Recently Viewed By Friends',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Message for Zero Businesses',
        'description' => 'This widget should be placed in the top of the middle column of the Businesses Home business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.zerobusiness-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
    array(
        'title' => 'Close Business Message',
        'description' => 'If a Business is closed, then show this message.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.closebusiness-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Popular Locations',
        'description' => 'Displays list of popular locations of Businesses.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.popularlocations-sitebusiness',
        'defaultParams' => array(
            'title' => 'Popular Locations',
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of locations to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Overview',
        'description' => 'Displays rich overview on Business\'s profile, created by its admin using the editor from Business Dashboard. This should be placed in the Tabbed Blocks area of Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.overview-sitebusiness',
        'defaultParams' => array(
            'title' => 'Overview',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Breadcrumb',
        'description' => 'Displays breadcrumb of the business based on the categories. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.business-profile-breadcrumb',
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
    array(
        'title' => 'Sub Businesses of a Business',
        'description' => 'Displays the sub businesses created in the Business which is being viewed currently. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.subbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => 'Sub Businesses of a Business',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of sub-businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Parent Business of a Sub Business',
        'description' => 'Displays the parent business in which the currently viewed sub businesses is created. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.parentbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => 'Parent Business of a Sub Business',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of parent-businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            ),
        ),
    ),
//    array(
//        'title' => "Business Profile 'Save to foursquare' Button",
//        'description' => "This Button will enable business visitors to add the Business\'s place or tip to their foursquare To-Do List. There is also Member Level and Package setting for this button.",
//        'category' => 'Business Profile',
//        'type' => 'widget',
//        'name' => 'sitebusiness.foursquare-sitebusiness',
//        'defaultParams' => array(
//            'title' => '',
//            'titleCount' => true,
//        ),
//    ),
    array(
        'title' => 'Business Profile Social Share Buttons',
        'description' => "Contains Social Sharing buttons and enables users to easily share Businesses on their favorite Social Networks. This widget should be placed on the Business View Business. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.socialshare-sitebusiness',
        'defaultParams' => array(
            'title' => 'Social Share',
            'titleCount' => true,
        ),
        'requirements' => array(
            'subject' => 'sitebusiness_business',
        ),
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'nomobile',
                    array(
                        'label' => '',
                        'order' => 1003
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Title',
        'description' => 'Displays the Title of the Business. This widget should be placed on the Business Profile, in the middle column at the top.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.title-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Info',
        'description' => 'This widget forms the Info tab on the Business Profile and displays the information of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.info-sitebusiness',
        'defaultParams' => array(
            'title' => 'Info',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Information Business',
        'description' => 'Displays the owner, category, tags, views and other information about a Business. This widget should be placed on the Business Profile in the left column.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.information-sitebusiness',
        'defaultParams' => array(
            'title' => 'Information',
            'titleCount' => true,
            'showContent' => array("ownerPhoto", "ownerName", "modifiedDate", "viewCount", "likeCount", "commentCount", "tags", "location", "price", "memberCount", "followerCount", "categoryName")
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'showContent',
                    array(
                        'label' => 'Select the information options that you want to be available in this block.',
                        'multiOptions' => array("ownerPhoto" => "Business Owner's Photo", "ownerName" => "Owner's Name", "modifiedDate" => "Modified Date", "viewCount" => "Views", "likeCount" => "Likes", "commentCount" => "Comments", "tags" => "Tags", "location" => "Location", "price" => "Price", "memberCount" => 'Member', "followerCount" => 'Follower', "categoryName" => "Category"),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Photo',
        'description' => 'Displays the main cover photo of a Business. This widget must be placed on the Business Profile at the top of left column.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.mainphoto-sitebusiness',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Map',
        'description' => 'This widget forms the Map tab on the Business Profile. It displays the map showing the Business position as well as the location details of the business. It should be placed in the Tabbed Blocks area of the Business Profile. This feature will be available to Businesses based on their Package and Member Level of their owners.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.location-sitebusiness',
        'defaultParams' => array(
            'title' => 'Map',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Options',
        'description' => 'Displays the various action link options to users viewing a Business. This widget should be placed on the Business Profile in the left column, below the Business profile photo.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.options-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Owner Business Tags',
        'description' => 'Displays all the tags chosen by the Business owner for his Businesses. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.tags-sitebusiness',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Owner Businesses',
        'description' => 'Displays list of other businesses owned by the business owner.This widget should be placed on Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.userbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'popularity',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => array(
                            'view_count' => 'Views',
                            'like_count' => 'Likes',
                        ),
                        'value' => 'view_count',
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile About Business',
        'description' => 'Displays the About Us information for businesses. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.write-business',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Content Profile: Follow Button',
        'description' => 'This is the Follow Button to be placed on the Content Profile page. It enables users to Follow the content being currently viewed.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'seaocore.seaocore-follow',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Content Profile: Like Button for Content',
        'description' => 'This is the Like Button to be placed on the Content Profile page. It enables users to Like the content being currently viewed. The best place to put this widget is right above the Tabbed Blocks on the Content Profile page.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'seaocore.like-button',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Business Profile You May Also Like',
        'description' => 'Displays list of businesses that might be liked by user based on the business being currently viewed.This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.suggestedbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => 'You May Also Like',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Content Profile: Content Likes',
        'description' => 'Displays the users who have liked the content being currently viewed. This widget should be placed on the  Content Profile page.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'seaocore.people-like',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of users to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Business Insights',
        'description' => 'Displays the insights of a Business to its Business Admins. These insights include metrics like views, likes, comments and active users of the Business. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.insights-sitebusiness',
        'defaultParams' => array(
            'title' => 'Insights',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Alternate Thumb Photo',
        'description' => 'Displays the thumb photo of a Business. This works as an alternate profile photo when you have set the layout of Business Profile to be tabbed, from the Business Layout Settings, and have integrated with the "Advertisements / Community Ads Plugin" by SocialEngineAddOns. In that case, the left column of the Business Profile having the main profile photo gets hidden to accomodate Ads. This widget must be placed on the Business Profile at the top of middle column.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.thumbphoto-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showTitle',
                    array(
                        'label' => 'Show Business Profile Title.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No',
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Apps Links',
        'description' => "Displays the Apps related links like Documents, Form, Photos, Poll, etc on Business Profile, depending on the Businesses related apps installed on your site. This widget should be placed on the Business Profile in the left column.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.widgetlinks-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
    ),
    array(
        'title' => 'Business Profile Linked Businesses',
        'description' => 'Displays list of businesses linked to a business. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.favourite-business',
        'defaultParams' => array(
            'title' => 'Linked Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Featured Business Admins',
        'description' => "Displays the Featured Admins of a business. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.featuredowner-sitebusiness',
        'defaultParams' => array(
            'title' => "Business admins",
            'titleCount' => "",
        ),
    ),
array(
        'title' => 'Horizontal Search Businesses Form',
        'description' => "This widget searches over Business Titles, Locations and Categories. This widget should be placed in full-width / extended column. Multiple settings are available in the edit settings section of this widget.",
        'category' => 'Pages',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitebusiness.horizontal-searchbox-sitebusiness',
        'defaultParams' => array(
            'title' => "Search",
            'titleCount' => "",
            'loaded_by_ajax' => 0
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'locationDetection',
                    array(
                        'label' => "Allow browser to detect user's current location.",
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'formElements',
                    array(
                        'label' => 'Choose the options that you want to be displayed in this block.(Note:Proximity Search will not display if location field will be disabled.)',
                        'multiOptions' => array("textElement" => "Auto-suggest for Keywords", "categoryElement" => "Category Filtering", "locationElement" => "Location field", "locationmilesSearch" => "Proximity Search"),
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'categoriesLevel',
                    array(
                        'label' => 'Select the category level belonging to which categories will be displayed in the category drop-down of this widget.',
                        'multiOptions' => array("category" => "Category", "subcategory" => "Sub-category", "subsubcategory" => "3rd level category"),
                    ),
                ),
                array(
                    'Radio',
                    'showAllCategories',
                    array(
                        'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 businesses in them?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'textWidth',
                    array(
                        'label' => 'Width for AutoSuggest',
                        'value' => 275,
                    )
                ),
                array(
                    'Text',
                    'locationWidth',
                    array(
                        'label' => 'Width for Location field',
                        'value' => 250,
                    )
                ),
                array(
                    'Text',
                    'locationmilesWidth',
                    array(
                        'label' => 'Width for Proximity Search field',
                        'value' => 125,
                    )
                ),
                array(
                    'Text',
                    'categoryWidth',
                    array(
                        'label' => 'Width for Category Filtering',
                        'value' => 150,
                    )
                ),
               array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),
            ),
        ),
    ),        
    array(
        'title' => 'AJAX Search for Businesses',
        'description' => "This widget searches over Business Titles via AJAX. The search interface is similar to Facebook search.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.searchbox-sitebusiness',
        'defaultParams' => array(
            'title' => "Search",
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Alphabetic Filtering of Businesses',
        'description' => "This widget enables users to alphabetically filter the directory items / businesses on your site by clicking on the desired alphabet. The widget shows all the alphabets for filtering.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.alphabeticsearch-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
    ),
    array(
        'title' => 'Categorically Popular Businesses',
        'description' => 'This attractive widget categorically displays the most popular businesses on your site. It displays 5 Businesses for each category. From the edit popup of this widget, you can choose the number of categories to show, criteria for popularity and the duration for consideration of popularity.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.category-businesses-sitebusiness',
        'defaultParams' => array(
            'title' => 'Popular Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Category Count',
                        'description' => 'No. of Categories to show. Enter 0 for showing all categories.',
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'businessCount',
                    array(
                        'label' => 'Businesses Count per Category',
                        'description' => 'No. of Businesses to be shown in each Category.',
                        'value' => 5,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'popularity',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => $category_businesses_multioptions,
                        'value' => 'view_count',
// 											'onchange'=>'javascript:if($("popularity").value=="view_count"){ $("interval-wrapper").style.display = "none";}else{$("interval-wrapper").style.display = "block"; }',
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Popularity Duration (This duration will be applicable to all Popularity Criteria except Views.)',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
                array(
                    'Select',
                    'columnCount',
                    array(
                        'label' => 'Select categories to be displayed in a row.',
                        'multiOptions' => array('1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5'),
                        'value' => '2',
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Contact Details',
        'description' => "Displays the Contact Details of a business. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.contactdetails-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'contacts' => array("0" => "1", "1" => "2", "2" => "3"),
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'contacts',
                    array(
                        'label' => 'Select the contact details you want to display',
                        'multiOptions' => array("1" => "Phone", "2" => "Email", "3" => "Website"),
                    ),
                ),
                array(
                    'Radio',
                    'emailme',
                    array(
                        'label' => 'Do you want users to send emails to Businesses via a customized pop up when they click on "Email Me" link?',
                        'multiOptions' => array(
                            1 => 'Yes, open customized pop up',
                            0 => 'No, open browser`s default pop up'
                        ),
                        'value' => '0'
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Render Layout',
        'description' => "Displays the layout of the business when site header and footer are not rendered.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.onrender-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
    ),
    array(
        'title' => 'Popular / Recent / Random / Location Based Businesses: Pinboard View',
        'description' => 'Displays businesses based on popularity criteria, location and other settings that you want to choose for this widget in attractive Pinboard View. You can place this widget multiple times with different popularity criterion chosen for each placement. You can also choose to display businesses based on user’s current location by using the Edit Settings of this widget.',
        'category' => 'Businesses',
        'type' => 'widget',
        'autoEdit' => true,
        'name' => 'sitebusiness.pinboard-businesses',
        'defaultParams' => array(
            'title' => 'Recent',
            'statistics' => array("likeCount", "commentCount"),
            'show_buttons' => array("comment", "like", 'share', 'facebook', 'twitter', 'pinit')
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'fea_spo',
                    array(
                        'label' => 'Show Businesses',
                        'multiOptions' => array(
                            '' => '',
                            'featured' => 'Featured Only',
                            'sponsored' => 'Sponsored Only',
                            'fea_spo' => 'Both Featured and Sponsored',
                        ),
                        'value' => '',
                    )
                ),
                array(
                    'Select',
                    'detactLocation',
                    array(
                        'label' => 'Do you want to display businesses based on user’s current location? (Note:- For this you must be enabled the auto-loading.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0'
                    )
                ),
                array(
                    'Select',
                    'locationmiles',
                    array(
                        'label' => $locationDescription,
                        'multiOptions' => array(
                            '0' => '',
                            '1' => '1 ' . $locationLableS,
                            '2' => '2 ' . $locationLable,
                            '5' => '5 ' . $locationLable,
                            '10' => '10 ' . $locationLable,
                            '20' => '20 ' . $locationLable,
                            '50' => '50 ' . $locationLable,
                            '100' => '100 ' . $locationLable,
                            '250' => '250 ' . $locationLable,
                            '500' => '500 ' . $locationLable,
                            '750' => '750 ' . $locationLable,
                            '1000' => '1000 ' . $locationLable,
                        ),
                        'value' => '1000'
                    )
                ),
                array(
                    'Select',
                    'popularity',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => $pinboardPopularityOptions,
                        'value' => 'business_id',
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Popularity Duration (This duration will be applicable to these Popularity Criteria:  Most Liked, Most Commented, Most Rated and Most Recent.)',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
                array(
                    'Radio',
                    'postedby',
                    array(
                        'label' => 'Show posted by option. (Selecting "Yes" here will display the member\'s name who has created the business.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1',
                    )
                ),
                array(
                    'MultiCheckbox',
                    'showoptions',
                    array(
                        'label' => 'Choose the options that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $pinboardShowsOptions,
                    //'value' =>array("viewCount","likeCount","commentCount","reviewCount"),
                    ),
                ),
                array(
                    'Select',
                    'autoload',
                    array(
                        'label' => 'Do you want to enable auto-loading of old pinboard items when users scroll down to the bottom of this business?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '1'
                    )
                ),
                array(
                    'Text',
                    'itemWidth',
                    array(
                        'label' => 'One Item Width',
                        'description' => 'Enter the width for each pinboard item.',
                        'value' => 237,
                    )
                ),
                array(
                    'Radio',
                    'withoutStretch',
                    array(
                        'label' => 'Do you want to display the images without stretching them to the width of each pinboard item?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0',
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of Businesses to show)',
                        'value' => 12,
                    )
                ),
                array(
                    'Text',
                    'noOfTimes',
                    array(
                        'label' => 'Auto-Loading Count',
                        'description' => 'Enter the number of times that auto-loading of old pinboard items should occur on scrolling down. (Select 0 if you do not want such a restriction and want auto-loading to occur always. Because of auto-loading on-scroll, users are not able to click on links in footer; this setting has been created to avoid this.)',
                        'value' => 0,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'show_buttons',
                    array(
                        'label' => 'Choose the action links that you want to be available for the Businesses displayed in this block.',
                        'multiOptions' => array("comment" => "Comment", "like" => "Like / Unlike", 'share' => 'Share', 'facebook' => 'Facebook', 'twitter' => 'Twitter', 'pinit' => 'Pin it', 'tellAFriend' => 'Tell a Friend', 'print' => 'Print')
                    //'value' =>array("viewCount","likeCount","commentCount","reviewCount"),
                    ),
                ),
                array(
                    'Text',
                    'truncationDescription',
                    array(
                        'label' => "Enter the truncation limit for the Business Description. (If you want to hide the description, then enter '0'.)",
                        'value' => 100,
                    )
                ),
            ),
        ),
    ),
//    
//        array(
//        'title' => 'Business Home: Pinboard View',
//        'description' => 'Displays businesses in Pinboard View on the Businesses Home business. Multiple settings are available to customize this widget.',
//        'category' => 'Businesses',
//        'type' => 'widget',
//        'autoEdit' => true,
//        'name' => 'sitebusiness.pinboard-businesses-sitebusiness',
//        'defaultParams' => array(
//            'title' => 'Recent',
//            'statistics' => array("likeCount", "reviewCount"),
//            'show_buttons' => array("comment", "like", 'share', 'facebook', 'twitter', 'pinit')
//        ),
//        'adminForm' => array(
//            'elements' => array(
//                //$listingTypeCategoryElement,
//               // $ratingTypeElement,
//                $featuredSponsoredElement,
//                array(
//                    'Select',
//                    'popularity',
//                    array(
//                        'label' => 'Popularity Criteria',
//                        'multiOptions' => $popularity_options,
//                        'value' => 'business_id',
//                    )
//                ),
//                array(
//                    'Select',
//                    'interval',
//                    array(
//                        'label' => 'Popularity Duration (This duration will be applicable to these Popularity Criteria:  Most Liked, Most Commented, Most Rated and Most Recent.)',
//                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall',
//                        'value' => 'overall',
//                    )
//                ),
//                //$categoryElement,
//                //$hiddenCatElement,
//                //$hiddenSubCatElement,
//                //$hiddenSubSubCatElement,
//                //$statisticsElement,
//                array(
//                    'Radio',
//                    'postedby',
//                    array(
//                        'label' => 'Show posted by option. (Selecting "Yes" here will display the member\'s name who has created the listing.)',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No')
//                        ),
//                        'value' => '1',
//                    )
//                ),
//                array(
//                    'Select',
//                    'autoload',
//                    array(
//                        'label' => 'Do you want to enable auto-loading of old pinboard items when users scroll down to the bottom of this business?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No')
//                        ),
//                        'value' => '1'
//                    )
//                ),
//                array(
//                    'Text',
//                    'itemWidth',
//                    array(
//                        'label' => 'One Item Width',
//                        'description' => 'Enter the width for each pinboard item.',
//                        'value' => 237,
//                    )
//                ),
//                array(
//                    'Radio',
//                    'withoutStretch',
//                    array(
//                        'label' => 'Do you want to display the images without stretching them to the width of each pinboard item?',
//                        'multiOptions' => array(
//                            1 => 'Yes',
//                            0 => 'No')
//                        ),
//                        'value' => '0',
//                    )
//                ),
//                array(
//                    'Text',
//                    'itemCount',
//                    array(
//                        'label' => 'Count',
//                        'description' => '(number of Listings to show)',
//                        'value' => 3,
//                    )
//                ),
//                array(
//                    'Text',
//                    'noOfTimes',
//                    array(
//                        'label' => 'Auto-Loading Count',
//                        'description' => 'Enter the number of times that auto-loading of old pinboard items should occur on scrolling down. (Select 0 if you do not want such a restriction and want auto-loading to occur always. Because of auto-loading on-scroll, users are not able to click on links in footer; this setting has been created to avoid this.)',
//                        'value' => 0,
//                    )
//                ),
//                array(
//                    'MultiCheckbox',
//                    'show_buttons',
//                    array(
//                        'label' => 'Choose the action links that you want to be available for the Listings displayed in this block. (This setting will only work, if you have chosen Pinboard View from the above setting.)',
//                        'multiOptions' => array("comment" => "Comment", "like" => "Like / Unlike", 'share' => 'Share', 'facebook' => 'Facebook', 'twitter' => 'Twitter', 'pinit' => 'Pin it', 'tellAFriend' => 'Tell a Friend', 'print' => 'Print')
//                    //'value' =>array("viewCount","likeCount","commentCount","reviewCount"),
//                    ),
//                ),
//                array(
//                    'Text',
//                    'truncationDescription',
//                    array(
//                        'label' => "Enter the trucation limit for the Listing Description. (If you want to hide the description, then enter '0'.)"),
//                        'value' => 100,
//                    )
//                ),
//            ),
//        ),
//    ),
    array(
        'title' => 'Search Businesses Location Form',
        'description' => 'Displays the form for searching Businesses corresponding to location on the basis of various filters.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.location-search',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'advancedsearchLink',
                    array(
                        'label' => 'Show Advanced Search option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'street',
                    array(
                        'label' => 'Show street option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'city',
                    array(
                        'label' => 'Show city option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'state',
                    array(
                        'label' => 'Show state option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'country',
                    array(
                        'label' => 'Show country option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => 'Ajax Based Recently Posted, Popular, Random, Featured and Sponsored Businesses',
        'description' => "Displays the recently posted, popular, random, featured and sponsored businesses in a block in separate ajax based tabs respectively.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.recently-popular-random-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
            'layouts_views' => array("0" => "1", "1" => "2", "2" => "3"),
            'layouts_oder' => 1,
            'layouts_tabs' => $layouts_tabs,
            'recent_order' => 1,
            'popular_order' => 2,
            'random_order' => 3,
            'featured_order' => 4,
            'sponosred_order' => 5,
            'list_limit' => 10,
            'grid_limit' => 15,
            'columnWidth' => '188',
            'columnHeight' => '350',
            'statistics' => $statisticsElementValue,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'titleLink',
                    array(
                        'label' => 'Enter Title Link',
                        'description' => 'If you want to show the "Explore All" link and redirect it to "Browse Business" then please use this code <a href="/'.$routeStartP.'/index">Explore All</a> Otherwise simply leave this field empty, if you do not want to show any link.',
                        'value' => '',
                    )
                ),
                array(
                    'Radio',
                    'titleLinkPosition',
                    array(
                        'label' => 'Enter Title Link Position',
                        'description' => 'Please select the position of the title link. Setting will work only if above setting "Enter Title Link" is not empty.',
                        'multiOptions' => array(
                            'top' => 'Top',
                            'bottom' => 'Bottom',
                        ),
                        'value' => 'bottom',
                    )
                ),
//                array(
//                    'Text',
//                    'photoHeight',
//                    array(
//                        'label' => 'Enter the height of image.',
//                    )
//                ),
                array(
                    'Text',
                    'photoWidth',
                    array(
                        'label' => 'Enter the width of image.',
                    )
                ),
                array(
                    'MultiCheckbox',
                    'layouts_views',
                    array(
                        'label' => 'Choose the view types that you want to be available for businesses on the businesses home and browse businesses.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View"),
                    ),
                ),
                array(
                    'Radio',
                    'layouts_oder',
                    array(
                        'label' => 'Select a default view type for Directory Items / Businesses.',
                        'multiOptions' => array("1" => "List View", "2" => "Grid View", "3" => "Map View"),
                    )
                ),
                array(
                    'Select',
                    'detactLocation',
                    array(
                        'label' => 'Do you want to display businesses based on user’s current location? (Note:- For this you must be enabled the auto-loading.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => '0'
                    )
                ),
                array(
                    'Select',
                    'defaultLocationDistance',
                    array(
                        'label' => $locationDescription,
                        'multiOptions' => array(
                            '0' => '',
                            '1' => '1 ' . $locationLableS,
                            '2' => '2 ' . $locationLable,
                            '5' => '5 ' . $locationLable,
                            '10' => '10 ' . $locationLable,
                            '20' => '20 ' . $locationLable,
                            '50' => '50 ' . $locationLable,
                            '100' => '100 ' . $locationLable,
                            '250' => '250 ' . $locationLable,
                            '500' => '500 ' . $locationLable,
                            '750' => '750 ' . $locationLable,
                            '1000' => '1000 ' . $locationLable,
                        ),
                        'value' => '1000'
                    )
                ),
                array(
                    'Text',
                    'list_limit',
                    array(
                        'label' => 'List View (Limit)',
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                array(
                    'Text',
                    'grid_limit',
                    array(
                        'label' => 'Grid View (Limit)',
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                array(
                    'Text',
                    'columnWidth',
                    array(
                        'label' => 'Column Width For Grid View.',
                        'value' => '188',
                    )
                ),
                array(
                    'Text',
                    'columnHeight',
                    array(
                        'label' => 'Column Height For Grid View.',
                        'value' => '350',
                    )
                ),
                array(
                    'Text',
                    'listview_turncation',
                    array(
                        'label' => 'Title Truncation Limit For List View.',
                        'value' => '40',
                    )
                ),
                array(
                    'Text',
                    'turncation',
                    array(
                        'label' => 'Title Truncation Limit For Grid View.',
                        'value' => '40',
                    )
                ),
                array(
                    'Radio',
                    'showlikebutton',
                    array(
                        'label' => 'Do you want to show “Like Button” when users mouse over on Businesses in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showfeaturedLable',
                    array(
                        'label' => 'Do you want “Featured Label” for the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showsponsoredLable',
                    array(
                        'label' => 'Do you want “Sponsored Label”  for the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showlocation',
                    array(
                        'label' => 'Do you want “Location” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showgetdirection',
                    array(
                        'label' => 'Do you want “Get Direction” link for the businesses having location to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showprice',
                    array(
                        'label' => 'Do you want “Price” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showpostedBy',
                    array(
                        'label' => 'Do you want “Posted By” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'Radio',
                    'showdate',
                    array(
                        'label' => 'Do you want “Creation Date” of the Businesses to be displayed in grid view?',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    ),
                ),
                array(
                    'MultiCheckbox',
                    'layouts_tabs',
                    array(
                        'label' => 'Choose the ajax tabs that you want to be there in the Main Businesses Home Widget.',
                        'multiOptions' => $layouts_tabs_options,
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'MultiCheckbox',
                    'statistics',
                    array(
                        'label' => 'Choose the statistics that you want to be displayed for the Businesses in this block.',
                        'multiOptions' => $statisticsElement,
                    ),
                ),
                array(
                    'Text',
                    'recent_order',
                    array(
                        'label' => 'Recent Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'popular_order',
                    array(
                        'label' => 'Most Popular Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'random_order',
                    array(
                        'label' => 'Random Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'featured_order',
                    array(
                        'label' => 'Featured Tab (order)',
                    ),
                ),
                array(
                    'Text',
                    'sponosred_order',
                    array(
                        'label' => 'Sponosred Tab (order)',
                    ),
                ),
                $joined_order,
                  array(
                    'Radio',
                    'loaded_by_ajax',
                    array(
                        'label' => 'Widget Content Loading',
                        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content.)',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 0,
                    )
                ),  
            ),
        ),
    ),
    
    array(
          'title' => "My Businesses: Businesses' links",
          'description' => $linkDescription,
          'category' => 'Businesses',
          'type' => 'widget',
          'name' => 'sitebusiness.links-sitebusiness',
          'defaultParams' => array(
              'title' => '',
              'titleCount' => false,
              'showLinks' => $linksValues
          ),
      'adminForm' => array(
          'elements' => array(
            array(
                'MultiCheckbox',
                'showLinks',
                array(
                    'label' => 'Choose the action links that you want to be available for the Businesses displayed in this block.',
                    'multiOptions' => $linksOptions,
                  //  'value' => $linksValues
                ),
            ),
          ),
        ),
    ),
    
    array(
         'title' => 'My Businesses: User’s Businesses',
        'description' => 'Displays a list of all the businesses joined, owned, admin, etc. of a user on your site. This widget should be placed on Directory / Businesses - Manage Businesses page.',
          'category' => 'Businesses',
          'type' => 'widget',
          'name' => 'sitebusiness.manage-sitebusiness',
          'defaultParams' => array(
              'title' => '',
              'titleCount' => false,
          ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'businessAdminJoined',
                    array(
                        'label' => 'Which all Businesses related to the user do you want to display in this widget?',
                        'multiOptions' => array(
                              1 => 'Both Businesses Administered and Joined by user',
                              2 => 'Only Businesses Administered by user'
                        ),
                        'value' => '1'
                    )
                ),
                array(
                    'Radio',
                    'showOwnerInfo',
                    array(
                        'label' => 'Do you want to show the member information (You are owner / admin / member) for the business. If enabled this information will be shown to you on Directory / Businesses - Manage Businesses page.',
                        'multiOptions' => array(
                              1 => 'Yes',
                              0 => 'No'
                        ),
                        'value' => '0'
                    )
                ),
            ),
        ),
    ),    
    array(
          'title' => 'My Businesses: Search Businesses Form',
          'description' => 'Displays the form for searching Businesses on the basis of various fields and filters. Settings for this form can be configured from the Search Form Settings section. This widget should be placed on Directory / Businesses - Manage Businesses page.',
          'category' => 'Businesses',
          'type' => 'widget',
          'name' => 'sitebusiness.manage-search-sitebusiness',
          'defaultParams' => array(
              'title' => '',
              'titleCount' => false,
          ),
    ),      
    array(
        'title' => 'Search Businesses Form (Pinboard Results)',
        'description' => 'Displays the form for searching Businesses based on location and various filters. (Note: This widget supports both Pinboard and normal layouts for search results.)',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.horizontal-search',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'browseredirect',
                    array(
                        'label' => 'Choose the layout of browse business where you want to display the search results. (If you are placing this widget on a business having Pinboard layout, then choose Pinboard layout below.)',
                        'multiOptions' => array(
                            'pinboard' => 'Pinboard Layout',
                            'default' => 'Normal Layout'
                        ),
                        'value' => '1'
                    )
                ),
                array(
                    'Radio',
                    'advancedsearchLink',
                    array(
                        'label' => 'Show Advanced Search option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'street',
                    array(
                        'label' => 'Show street option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'city',
                    array(
                        'label' => 'Show city option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'state',
                    array(
                        'label' => 'Show state option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
                array(
                    'Radio',
                    'country',
                    array(
                        'label' => 'Show country option.',
                        'multiOptions' => array(
                            1 => 'Yes',
                            0 => 'No'
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
);

if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
  $ads_Array = array(
      array(
          'title' => 'Business Ads Widget',
          'description' => 'Displays community ads in various widgets and view businesses of this plugin.',
          'category' => 'Businesses',
          'type' => 'widget',
          'name' => 'sitebusiness.business-ads',
          'defaultParams' => array(
              'title' => '',
              'titleCount' => true,
          ),
  ));
}


if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
  $joined_array = array(
      array(
          'title' => 'Joined / Owned Businesses',
          'description' => 'Displays businesses administered and joined by members on their profiles. This widget should be placed on the Member Profile business.',
          'category' => 'Businesses',
          'type' => 'widget',
          'name' => 'sitebusiness.profile-joined-sitebusiness',
          'defaultParams' => array(
              'title' => 'Businesses',
              'titleCount' => true,
          ),
          'adminForm' => array(
              'elements' => array(
                  array(
                      'Radio',
                      'businessAdminJoined',
                      array(
                          'label' => 'Which all Businesses related to the user do you want to display in this tab widget on their profile?',
                          'multiOptions' => array(
                              1 => 'Both Businesses Administered and Joined by user',
                              2 => 'Only Businesses Joined by user'
                          ),
                          'value' => 1,
                      )
                  ),
                  array(
                      'Text',
                      'textShow',
                      array(
                          'label' => 'Enter the verb to be displayed for the business admin approved members. (If you do not want to display any verb, then simply leave this field blank.)',
                          'value' => 'Verified',
                      ),
                  ),
                  array(
                      'Radio',
                      'showMemberText',
                      array(
                          'label' => 'Show Member Text?',
                          'multiOptions' => array(
                              1 => 'Yes',
                              0 => 'No'
                          ),
                          'value' => 1,
                      )
                  ),
                  array(
                      'Select',
                      'category_id',
                      array(
                          'label' => 'Category',
                          'multiOptions' => $categories_prepared,
                      )
                  ),
              )
          ),
      )
  );
}

$fbbusiness_sitebusiness_Array = array(
    array(
        'title' => 'Business Profile: Facebook Like Box',
        'description' => 'This widget contains the Facebook Like Box which enables Business Admins to gain Likes for their Facebook Page from this website. The edit popup contains the settings to customize the Facebook Like Box. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.fblikebox-sitebusiness',
        'defaultParams' => array(
            'title' => ''
        ),
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    "Text",
                    "title",
                    array(
                        'label' => 'Title',
                        'value' => '',
                    )
                ),
                array(
                    "Text",
                    "fb_width",
                    array(
                        'label' => 'Width',
                        'description' => 'Width of the Facebook Like Box in pixels.',
                        'value' => '220',
                    )
                ),
                array(
                    "Text",
                    "fb_height",
                    array(
                        'label' => 'Height',
                        'description' => 'Height of the Facebook Like Box in pixels (optional).',
                        'value' => '588',
                    )
                ),
                array(
                    "Select",
                    "widget_color_scheme",
                    array(
                        'label' => 'Color Scheme',
                        'description' => 'Color scheme of the Facebook Like Box in pixels.',
                        'multiOptions' => array('light' => 'light', 'dark' => 'dark')
                    )
                ),
                array(
                    "MultiCheckbox",
                    "widget_show_faces",
                    array(
                        //'label' => 'Show Profile Photos in this plugin.',
                        'description' => 'Show Faces',
                        'multiOptions' => array('1' => 'Show profile photos of users who like the linked Facebook Page in the Facebook Like Box.')
                    )
                ),
                array(
                    "Text",
                    "widget_border_color",
                    array(
                        'label' => 'Border Color',
                        'description' => 'Border color of the Facebook Like Box'
                    )
                ),
                array(
                    "MultiCheckbox",
                    "show_stream",
                    array(
                        'description' => 'Stream',
                        'multiOptions' => array('1' => 'Show the Facebook Page profile stream for the public feeds in the Facebook Like Box.'),
                    )
                ),
                array(
                    "MultiCheckbox",
                    "show_header",
                    array(
                        'description' => 'Header',
                        'multiOptions' => array('1' => "Show the 'Find us on Facebook' bar at top. Only shown when either stream or profile photos are present."),
                    )
                ),
            )
        )
        ));

// if (!empty($recentPopularWidgt)) {
//   $final_array = array_merge($final_array, $recentPopularWidgt);
// }
if (!empty($joined_array)) {
  $final_array = array_merge($final_array, $joined_array);
}
if (!empty($ads_Array)) {
  $final_array = array_merge($final_array, $ads_Array);
}
if (!empty($fbbusiness_sitebusiness_Array)) {
  $final_array = array_merge($final_array, $fbbusiness_sitebusiness_Array);
}
return $final_array;
?>
