<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

$categories_prepared = array();
$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
$ads_Array = array();
$social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
<a class="addthis_button_preferred_1"></a>
<a class="addthis_button_preferred_2"></a>
<a class="addthis_button_preferred_3"></a>
<a class="addthis_button_preferred_4"></a>
<a class="addthis_button_preferred_5"></a>
<a class="addthis_button_compact"></a>
<a class="addthis_counter addthis_bubble_style"></a>
</div>
<script type="text/javascript">
var addthis_config = {
          services_compact: "facebook, twitter, linkedin, google, digg, more",
          services_exclude: "print, email"
}
</script>
<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';
$final_array = array(
    array(
        'title' => $view->translate('Business Profile Overview'),
        'description' => $view->translate('Displays rich overview on Business\'s profile, created by you using the editor from Business Dashboard. This should be placed in the Tabbed Blocks area of Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.overview-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('Overview'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Sub Businesses of a Business',
        'description' => 'Displays the sub businesses created in the Business which is being viewed currently. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.subbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => 'Sub Businesses of a Business',
            'titleCount' => true,
        ),
    ),
    
    array(
        'title' => 'Popular Businesses',
        'description' => 'Displays list of popular businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostviewed-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Popular',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 10,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),     
    
    array(
        'title' => 'AJAX Search for Businesses',
        'description' => "This widget searches over Business Titles via AJAX. The search interface is similar to Facebook search.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.searchbox-sitebusiness',
        'defaultParams' => array(
            'title' => "Search",
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
            ),
        ),
    ),        
    array(
        'title' => 'Parent Business of a Sub Business',
        'description' => 'Displays the parent business in which the currently viewed sub businesses is created. This widget should be placed on the Business Profile business.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.parentbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => 'Parent Business of a Sub Business',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Breadcrumb'),
        'description' => $view->translate('Displays breadcrumb of the business based on the categories. This widget should be placed on the Business Profile business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.business-profile-breadcrumb',
        'adminForm' => array(
            'elements' => array(
            ),
        ),
    ),
//    array(
//        'title' => $view->translate("Business Profile 'Save to foursquare' Button"),
//        'description' => $view->translate("This Button will enable Business visitors to add the Business's place or tip to their foursquare To-Do List. Note that this feature will be available to you based on your Business's Package and your Member Level."),
//        'category' => $view->translate('Business Profile'),
//        'type' => 'widget',
//        'name' => 'sitebusiness.foursquare-sitebusiness',
//        'defaultParams' => array(
//            'title' => '',
//            'titleCount' => true,
//        ),
//    ),
		array(
			'title' => $view->translate('Business Profile Social Share Buttons'),
			'description' => $view->translate("Contains Social Sharing buttons and enables users to easily share Businesses on their favorite Social Networks. You can personalize the code for social sharing buttons by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>"),
			'category' => $view->translate('Business Profile'),
			'type' => 'widget',
			'name' => 'sitebusiness.socialshare-sitebusiness',
			'defaultParams' => array(
					'title' => $view->translate('Social Share'),
					'titleCount' => true,
			),
			'requirements' => array(
				'subject' => 'sitebusiness_business',
			),
      'autoEdit' => true,
			'adminForm' => array(
				'elements' => array(
					array(
							'Textarea',
							'code',
							array(
									'description' => $view->translate("Social Sharing Buttons Code: You can personalize the code for social sharing buttons by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>"),
									'value' => $social_share_default_code,
									'decorators' => array('ViewHelper', array('Description', array('placement' => 'PREPEND','escape' => false)))
							),
					),
					array(
							'Hidden',
							'nomobile',
							array(
									'label' => '',
							)
					),
				),
			),
		),
    array(
        'title' => $view->translate('Business Profile Title'),
        'description' => $view->translate('Displays the Title of the Business. This widget should be placed on the Business Profile, in the middle column at the top.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.title-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Info'),
        'description' => $view->translate('This widget forms the Info tab on the Business Profile and displays the information of the Business. It should be placed in the Tabbed Blocks area of the Business Profile. You may enter content for this section from the Edit Info and Profile Info sections of the Business Dashboard.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.info-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('Info'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Information Business'),
        'description' => $view->translate('Displays the owner, category, tags, views and other information about a Business. This widget should be placed on the Business Profile in the left column.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.information-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('Information'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Photo'),
        'description' => $view->translate('Displays the main cover photo of a Business. This widget must be placed on the Business Profile at the top of left column.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.mainphoto-sitebusiness',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Map'),
        'description' => $view->translate('This widget forms the Map tab on the Business Profile. It displays the map showing the Business position as well as the location details of the business. It should be placed in the Tabbed Blocks area of the Business Profile. Location details can be entered from the Location section of the Dashboard. Note that this feature will be available to you based on your Business\'s Package and your Member Level.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.location-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('Map'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Options'),
        'description' => $view->translate('Displays the various action link options to users viewing your Business. This widget should be placed on the Business Profile in the left column, below the Business profile photo.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.options-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Owner Business Tags'),
        'description' => $view->translate('Displays all the tags chosen by the owner of your Business for his Businesses. This widget should be placed on the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.tags-sitebusiness',
        'defaultParams' => array(
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Owner Businesses'),
        'description' => $view->translate('Displays other Businesses owned by the owner of your Business. This widget should be placed on the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.userbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile About Business'),
        'description' => $view->translate('Displays the About Us information for your Business. You can enter information for this widget simply by clicking on the widget.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.write-business',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),
    array(
			'title' => $view->translate('Content Profile: Follow Button'),
			'description' => $view->translate('This is the Follow Button to be placed on the Content Profile page. It enables users to Follow the content being currently viewed.'),
			'category' => $view->translate('Business Profile'),
			'type' => 'widget',
			'name' => 'seaocore.seaocore-follow',
			'defaultParams' => array(
					'title' => '',
			),
    ),
    array(
        'title' => $view->translate('Content Profile: Like Button for Content'),
        'description' => $view->translate('This is the Like Button to be placed on the Content Profile page. It enables users to Like the content being currently viewed. The best place to put this widget is right above the Tabbed Blocks on the Content Profile page.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'seaocore.like-button',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => $view->translate('Business Profile You May Also Like'),
        'description' => $view->translate('Displays the other Businesses that a user may like, based on your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.suggestedbusiness-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('You May Also Like'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Most Liked Businesses',
        'description' => 'Displays list of businesses having maximum number of likes.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusiness.mostlikes-sitebusiness',
        'defaultParams' => array(
            'title' => 'Most Liked Businesses',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'interval',
                    array(
                        'label' => 'Time Period',
                        'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
                        'value' => 'overall',
                    )
                ),
            ),
        ),
    ),        
    array(
        'title' => $view->translate('Content Profile: Content Likes'),
        'description' => $view->translate('Displays the users who have liked the content being currently viewed. This widget should be placed on the  Content Profile page.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'seaocore.people-like',
    ),
    array(
        'title' => $view->translate('Business Profile Business Insights'),
        'description' => $view->translate('Displays the insights of your Business to your Business Admins only. These insights include metrics like views, likes, comments and active users of the Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.insights-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate('Insights'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Apps Links'),
        'description' => $view->translate("Displays the Apps related links for your Business. This widget should be placed in the left column."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.widgetlinks-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
    ),
		array(
				'title' => $this->view->translate('Business Profile Linked Businesses'),
				'description' => $this->view->translate('Displays Linked Businesses of your Business.'),
				'category' => $this->view->translate('Business Profile'),
				'type' => 'widget',
				'name' => 'sitebusiness.favourite-business',
				'defaultParams' => array(
								'title' => $this->view->translate('Linked Businesses'),
								'titleCount' => true,
				),
                                'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of businesses to show)',
                        'value' => 3,
                        'validators' => array(
                            array('Int', true),
                            array('GreaterThan', true, array(0)),
                        ),
                    )
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Featured Business Admins'),
        'description' => $view->translate("Displays the Featured Admins of your Business."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.featuredowner-sitebusiness',
        'defaultParams' => array(
            'title' => $view->translate("Business admins"),
            'titleCount' => "",
        ),
    ), 
    array(
        'title' => $view->translate('Business Profile Alternate Thumb Photo'),
        'description' => $view->translate('Displays the thumb photo of a Business. This works as an alternate profile photo when you have set the layout of Business Profile to be tabbed, from the Business Layout Settings, and have integrated with the "Advertisements / Community Ads Plugin" by SocialEngineAddOns. In that case, the left column of the Business Profile having the main profile photo gets hidden to accomodate Ads. This widget must be placed on the Business Profile at the top of middle column.'),
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusiness.thumbphoto-sitebusiness',
        'defaultParams' => array(
            'title' => "",
            'titleCount' => "",
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'showTitle',
                    array(
                        'label' => $view->translate('Show Business Profile Title.'),
                        'multiOptions' => array(
                            1 => $view->translate('Yes'),
                            0 => $view->translate('No'),
                        ),
                        'value' => 1,
                    )
                ),
            ),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Contact Details'),
        'description' => $view->translate("Displays the Contact Details of your Business."),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusiness.contactdetails-sitebusiness',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
            'contacts' => array("0" => "1", "1" => "2", "2" => "3"),
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'MultiCheckbox',
                    'contacts',
                    array(
                        'label' => $view->translate('Select the contact details you want to display'),
                        'multiOptions' => array("1" => "Phone", "2" => "Email", "3" => "Website"),
                    ),
                ),
                array(
									'Radio',
									'emailme',
									array(
											'label' => $view->translate('Do you want users to send emails to Businesses via a customized pop up when they click on "Email Me" link?'),
											'multiOptions' => array(
													1 => $view->translate('Yes, open customized pop up'),
													0 => $view->translate('No, open browser`s default pop up')
											),
											'value' => '0'
									)
                ),
            ),
        ),
    ), 
);
if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad')) {
  $ads_Array = array(
      array(
          'title' => $view->translate('Business Profile Alternate Cover Thumb Photo'),
          'description' => $view->translate('Displays the thumb photo of your Business. This widget must be placed on the Business Profile at the top of middle column. This photo shows up only in special cases.'),
          'category' => $view->translate('Business Profile'),
          'type' => 'widget',
          'name' => 'sitebusiness.thumbphoto-sitebusiness',
          'defaultParams' => '',
      ),
  );
}
if (!empty($ads_Array)) {
  $final_array = array_merge($final_array, $ads_Array);
}

$fbbusiness_sitebusiness_Array = array(
      array(
          'title' => $view->translate('Facebook Like Box'),
          'description' => $view->translate('This widget contains the Facebook Like Box which enables Business Admins to gain Likes for their Facebook Page from this website. The edit popup contains the settings to customize the Facebook Like Box. This widget should be placed on the Business Profile.'),
          'category' => $view->translate('Business Profile'),
          'type' => 'widget',
          'name' => 'sitebusiness.fblikebox-sitebusiness',
                    
          'defaultParams' => array(
              'title' => ''
             
          ),
           'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(   
              
                
                array(
                    "Text",
                    "title",
                    array(
                        'label' => $view->translate('Title'),
                        'value' => '',
                    )
                ),
                
                 array(
                    "Text",
                    "fb_width",
                    array(
                        'label' => $view->translate('Width'),
                        'description' => $view->translate('Width of the Facebook Like Box in pixels.'),
                        'value' => '220',
                    )
                ),
              array(
                    "Text",
                    "fb_height",
                    array(
                        'label' => $view->translate('Height'),
                        'description' => $view->translate('Height of the Facebook Like Box in pixels (optional).'),
                        'value' => '588',
                    )
                ),
                array(
                    "Select",
                    "widget_color_scheme",
                    array(
                        'label' => $view->translate('Color Scheme'),
                        'description' => $view->translate('Color scheme of the Facebook Like Box in pixels.'),
                       'multiOptions' => array('light' => 'light', 'dark' => 'dark')
                    )
                ),
                array(
                    "MultiCheckbox",
                    "widget_show_faces",
                    array(
                        //'label' => 'Show Profile Photos in this plugin.',
                        'description' => $view->translate('Show Faces'),
                        'multiOptions' => array('1' => $view->translate('Show profile photos of users who like the linked Facebook Page in the Facebook Like Box.'))
                         
                    )
                ),
                
                array(
                    "Text",
                    "widget_border_color",
                    array(
                        'label' => $view->translate('Border Color'),
                        'description' => $view->translate('The border color of the plugin')
                       
                         
                    )
                ),
                array(
                    "MultiCheckbox",
                    "show_stream",
                    array(
                        
                        'description' => $view->translate('Stream'),
                        'multiOptions' => array('1' => $view->translate('Show the Facebook Page profile stream for the public feeds in the Facebook Like Box.')),
                       
                        
                    )
                ),
                array(
                    "MultiCheckbox",
                    "show_header",
                    array(
                        
                        'description' => $view->translate('Header'),
                        'multiOptions' => array('1' => $view->translate("Show the 'Find us on Facebook' bar at top. Only shown when either stream or profile photos are present.")),
                       
                       
                    )
                ),
            )
        )
          
   ));
   
   if (!empty($fbbusiness_sitebusiness_Array)) {
  $final_array = array_merge($final_array, $fbbusiness_sitebusiness_Array);
}
return $final_array;
?>
