<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_InfoSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //DONT RENDER IF NOT AUTHORIZED
    $sitebusiness_info = Zend_Registry::isRegistered('sitebusiness_info') ? Zend_Registry::get('sitebusiness_info') : null;
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    $this->view->isManageAdmin = Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness);
    
		//SEND DATA TO TPL
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
    $this->view->widgets = $widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $sitebusiness->business_id);
    $this->view->content_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusiness.info-sitebusiness', $sitebusiness->business_id, $layout);
    $this->view->module_tabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $this->view->identity_temp = $this->view->identity;
    $this->view->showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $sitebusiness->business_id);
    $tableCategories = Engine_Api::_()->getDbTable('categories', 'sitebusiness');
    $this->view->category_name = $this->view->subcategory_name == $this->view->subsubcategory_name = '';
    if($sitebusiness->category_id) {
        $categoriesNmae = $tableCategories->getCategory($sitebusiness->category_id);
        if (!empty($categoriesNmae->category_name)) {
          $this->view->category_name = $categoriesNmae->category_name;
        }
        
        if($sitebusiness->subcategory_id) {
            $subcategory_name = $tableCategories->getCategory($sitebusiness->subcategory_id);
            if (!empty($subcategory_name->category_name)) {
              $this->view->subcategory_name = $subcategory_name->category_name;
            }
            
            //GET SUB-SUB-CATEGORY
            if($sitebusiness->subsubcategory_id) {
                $subsubcategory_name = $tableCategories->getCategory($sitebusiness->subsubcategory_id);
                if (!empty($subsubcategory_name->category_name)) {
                  $this->view->subsubcategory_name = $subsubcategory_name->category_name;
                }
            }
        }
    }
    
    //GET TAGS
    $this->view->sitebusinessTags = $sitebusiness->tags()->getTagMaps();

		//CUSTOM FIELD WORK
    $this->view->sitebusiness_description = Zend_Registry::isRegistered('sitebusiness_descriptions') ? Zend_Registry::get('sitebusiness_descriptions') : null;
    $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitebusiness/View/Helper', 'Sitebusiness_View_Helper');
    $this->view->fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($sitebusiness);
    if (empty($sitebusiness_info)) {
      return $this->setNoRender();
    }
  }
}

?>