<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_ManageSitebusinessController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        $this->view->autoContentLoad = $isappajax = $this->_getParam('isappajax', 0);

        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $this->view->businessAdminJoined = $this->_getParam("businessAdminJoined", 1);
        $this->view->showOwnerInfo = $this->_getParam("showOwnerInfo", 0);
        $this->view->can_edit = Engine_Api::_()->authorization()->isAllowed('sitebusiness_business', $viewer, "edit");
        $this->view->enablePrice = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.price.field', 1);
        $this->view->enableLocation = $checkLocation = Engine_Api::_()->sitebusiness()->enableLocation();
        $this->view->can_delete = Engine_Api::_()->authorization()->isAllowed('sitebusiness_business', $viewer, "delete");
        $this->view->can_create = Engine_Api::_()->authorization()->isAllowed('sitebusiness_business', $viewer, "create");
        Engine_Api::_()->getDbtable('businessstatistics', 'sitebusiness')->setViews();

        //GET VIEWER CLAIMS
        $claim_id = Engine_Api::_()->getDbtable('claims', 'sitebusiness')->getViewerClaims($viewer_id);

        //CLAIM IS ENABLED OR NOT
        $canClaim = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'claim');

        $this->view->showClaimLink = 0;
        if (!empty($claim_id) && !empty($canClaim)) {
            $this->view->showClaimLink = 1;
        }

        //FORM GENERATION
        $this->view->form = $form = new Sitebusiness_Form_Managesearch(array(
            'type' => 'sitebusiness_business'
        ));

        $form->removeElement('show');

        if (!empty($_POST)) {
            $form->populate($_POST);
            $this->view->search = $_POST['search'];
        }

        if (!empty($_POST))
            $form->populate($_POST);
        $values = $form->getValues();

        //CHECK TO SEE IF REQUEST IS FOR SPECIFIC USER'S BUSINESSES
       // if ($this->view->businessAdminJoined == 2) {
            //$values['user_id'] = $viewer->getIdentity();
       // } else {
            //CHECK THAT WE HAVE TO SHOW MANAGE ADMIN LINK OR NOTE
            $adminbusinesses = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdminBusinesses($viewer_id);

            //GET STUFF
            $manageadmin_ids = array();
            foreach ($adminbusinesses as $adminbusiness) {
                $manageadmin_ids[] = $adminbusiness->business_id;
            }
            $manageadmin_values = array();
            $manageadmin_values['adminbusinesses'] = $manageadmin_ids;
            $manageadmin_values['orderby'] = 'creation_date';

            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember') && $this->view->businessAdminJoined ==1) {
                $onlymember = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinBusinesses($viewer->getIdentity(), 'onlymember');

                $onlymemberids = array();
                foreach ($onlymember as $onlymembers) {
                    $onlymemberids[] = $onlymembers->business_id;
                }
                $values['adminjoinedbusinesses'] = array_merge($onlymemberids, $manageadmin_values['adminbusinesses']);
            } else {
                $values['adminjoinedbusinesses'] = $manageadmin_values['adminbusinesses'];
            }
        //}
        $values['type'] = 'manage';
        $values['type_location'] = 'manage';

        //GET PAGINATOR
        $this->view->paginator = $paginator = Engine_Api::_()->sitebusiness()->getSitebusinessesPaginator($values, null);
        $items_count = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.business', 10);

        $paginator->setItemCountPerPage($items_count);
        $this->view->paginator = $paginator->setCurrentPageNumber($values['business']);

        $this->view->business = $values['business'] ? $values['business'] : 1;
        $this->view->totalBusinesses = ceil(($paginator->getTotalItemCount()) / $items_count);

        $this->view->quota = 0;
        if ($viewer->level_id != 1) {
            $this->view->quota = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitebusiness_business', 'max');
        }
        $this->view->current_count = $paginator->getTotalItemCount();
        $this->view->category_id = $values['category_id'];
        $this->view->subcategory_id = $values['subcategory_id'];
        $this->view->subsubcategory_id = $values['subsubcategory_id'];
    }

}

?>