<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_SitemobileBusinesscoverPhotoInformationController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {
    $this->_mobileAppFile = true;
    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $this->view->strachPhoto = $this->_getParam('strachPhoto', 0);
    $this->view->showContent = $this->_getParam('showContent', array("mainPhoto", "title", "category", "subcategory", "subsubcategory",  "likeButton", "followButton", "joinButton", "addButton", "description", "phone", "email", "website", "location", "tags", "price", "badge"));

    if(empty($this->view->showContent)) {
      $this->view->showContent = array();
    }

    //GET VIEWER INFORMATION
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    $this->view->can_edit = $can_edit = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    $this->view->allowBusiness = Engine_Api::_()->sitebusiness()->allowInThisBusiness($sitebusiness, "sitebusinessmember", 'smecreate');
    $this->view->cover_params = array('top' => 0, 'left' => 0);

    if(Engine_Api::_()->hasModuleBootstrap('sitebusinessbadge') && isset($sitebusiness->badge_id))  {
			$this->view->sitebusinessbadges_value = Engine_Api::_()->getApi('settings', 'core')->sitebusinessbadge_badgeprofile_widgets;
			$this->view->sitebusinessbadge = Engine_Api::_()->getItem('sitebusinessbadge_badge', $sitebusiness->badge_id);
    }

    if (Engine_Api::_()->hasModuleBootstrap('sitebusinessalbum') && $sitebusiness->business_cover) {
      $this->view->photo = $photo = Engine_Api::_()->getItem('sitebusiness_photo', $sitebusiness->business_cover);
      $tableAlbum = Engine_Api::_()->getDbtable('albums', 'sitebusiness');
      $album = $tableAlbum->getSpecialAlbum($sitebusiness, 'cover');
      if ($album->cover_params)
        $this->view->cover_params = $album->cover_params;
    }
    $this->view->sitebusinessTags = $sitebusiness->tags()->getTagMaps();
    $this->view->resource_id = $resource_id = $sitebusiness->getIdentity();
    $this->view->resource_type = $resource_type = $sitebusiness->getType();
    $this->view->follow_count = Engine_Api::_()->getDbtable('follows', 'seaocore')->numberOfFollow($resource_type, $resource_id);
    $this->view->subcategory_name = '';
    $this->view->subsubcategory_name = '';
    $categoriesTable = Engine_Api::_()->getDbTable('categories', 'sitebusiness');
    $this->view->category_name = $categoriesTable->getCategory($sitebusiness->category_id)->category_name;
    if(isset($categoriesTable->getCategory($sitebusiness->subcategory_id)->category_name))
    $this->view->subcategory_name = $categoriesTable->getCategory($sitebusiness->subcategory_id)->category_name;
    if(isset($categoriesTable->getCategory($sitebusiness->subsubcategory_id)->category_name))
    $this->view->subsubcategory_name = $categoriesTable->getCategory($sitebusiness->subsubcategory_id)->category_name;
    
    //PARAMS
    $this->view->can_share = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.share', 1);
    
    if(isset($viewer->level_id))
    $this->showMessageOwner = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'messages', 'auth');
    
  }

}