<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */ 
class Sitebusiness_Widget_SitemobileDiscussionSitebusinessController extends Engine_Content_Widget_Abstract {

  protected $_childCount;
  
  //ACTION FOR FETCHING THE DISCUSSIONS FOR THE BUSINESSES
  public function indexAction() { 	

    if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
      return $this->setNoRender();
    }
    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }
    
    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    
    //GET BUSINESS ID
    $this->view->business_id = $sitebusiness->business_id;


    //START PACKAGE LEVEL CHECK
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessdiscussion")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'sdicreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //END PACKAGE LEVEL CHECK
    //TOTAL TOPICS
    $topicCount = Engine_Api::_()->sitebusiness()->getTotalCount($this->view->business_id, 'sitebusiness', 'topics');  
    
    $topicComment = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdicreate');
    
    
    if (empty($topicComment) && empty($topicCount) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }
    

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    $this->view->canPost =  Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sdicreate');
    //END MANAGE-ADMIN CHECK
    
		//GET PAGINATORS
		$this->view->paginator = $paginator = Engine_Api::_()->getDbtable('topics', 'sitebusiness')->getBusinessTopics($sitebusiness->business_id);
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('business', 1));
	  $this->_childCount = $paginator->getTotalItemCount();

  }

  public function getChildCount() {
    return $this->_childCount;
  }

}