<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_SitemobilePhotosSitebusinessController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR GETTING THE ALBUMS AND PHOTOS
  public function indexAction() {

    //HERE WE CHECKING THE SITEBUSINESS ALBUM IS ENABLED OR NOT
    $sitebusinessalbumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessalbum');
    if (!$sitebusinessalbumEnabled) {
      return $this->setNoRender();
    }

    //GET HOW MANY ALBUMS DO YOU WANT SHOW ON PER BUSINESS
    $this->view->itemCount = $albums_per_business = $this->_getParam('itemCount', 10);

    //GET HOW MANY PHOTOS DO YOU WANT SHOW ON PER BUSINESS
    $this->view->itemCount_photo = $this->_getParam('itemCount_photo', 100);

    //ALBUMS ORDER
    $this->view->albums_order = $this->_getParam('albumsorder', 1);

    //GET VIEWER ID
    $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //DON'T RENDER IF SUNJECT IS NOT THERE
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SITEBUSINESS SUBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $business_id = $sitebusiness->business_id;

    //START PACKAGE WORK
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessalbum")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'spcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //END PACKAGE WORK

    //TOTAL ALBUMS
    $albumCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusiness', 'albums');     
    $photoCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $canEdit = 0;
    } else {
      $this->view->can_edit = $canEdit = 1;
    }
    
    if (empty($photoCreate) && empty($albumCount) && empty($canEdit) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }

    //GET REQUEST
    $zendRequest = Zend_Controller_Front::getInstance()->getRequest();

		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'spcreate');
		if ($isManageAdmin || $canEdit) {
			$this->view->allowed_upload_photo = 1;
		} else {
			$this->view->allowed_upload_photo = 0;
		}

    //ALBUMS PER BUSINESS
		$this->view->albums_per_business = $albums_per_business = $zendRequest->getParam('itemCount', 10);

		if(empty($albums_per_business)) {
			$this->view->albums_per_business = $albums_per_business = 10;
		}

		//ALBUMS ORDER
		$this->view->albums_order = $albums_order = $zendRequest->getParam('albumsorder', 1);

		//GET CURRENT BUSINESS NUMBER OF ALBUM
		$currentAlbumBusinessNumbers = $business = $this->_getParam('business', 1);

		//SEND CURRENT BUSINESS NUMBER OF ALBUM TO THE TPL
		$this->view->currentAlbumBusinessNumbers = $currentAlbumBusinessNumbers;

		//SET ALBUMS PARAMS
		$paramsAlbum = array();
		$paramsAlbum['business_id'] = $business_id;

		//GET ALBUM COUNT
		$this->view->album_count = $album_count = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbumsCount($paramsAlbum);
		
		//SET ALBUMS PARAMS
		if(empty($albums_order)) {
			$paramsAlbum['orderby'] = 'album_id ASC';
		} else {
			$paramsAlbum['orderby'] = 'album_id DESC';
		}
		$paramsAlbum['getSpecialField'] = 0;

		$fecthAlbums = Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbums($paramsAlbum);

		$album = $this->view->album = $paginator = $this->view->paginator = $fecthAlbums;
		$this->view->paginator = $paginator->setItemCountPerPage($albums_per_business);
		$this->view->paginator->setCurrentPageNumber($this->_getParam('business', 1));

		//SET PHOTOS PARAMS
		$paramsPhoto = array();
		$paramsPhoto['business_id'] = $business_id;
		$paramsPhoto['user_id'] = $sitebusiness->owner_id;
		$paramsPhoto['album_id'] = $this->view->default_album_id = Engine_Api::_()->getItemTable('sitebusiness_album')->getDefaultAlbum($business_id)->album_id;
		
		//FETCHING ALL PHOTOS
		$this->view->total_images = $total_photo = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto);

		//SEND PHOTOS PER BUSINESS TO THE TPL
		$this->view->photos_per_business = $photos_per_business = $zendRequest->getParam('itemCount_photo', 100);

		if(empty($photos_per_business)) {
			$this->view->photos_per_business = $photos_per_business = 100;
		}

		$this->view->paginators = $paginators = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotos($paramsPhoto);
		$this->view->paginators = $paginators->setItemCountPerPage($photos_per_business);
		$this->view->paginators->setCurrentPageNumber($this->_getParam('businesses', 1));
		//SET PHOTOS PARAMS
		$paramsPhoto = array();
		$paramsPhoto['business_id'] = $sitebusiness->business_id;

    //SET COUNT TO THE TITLE
    $this->_childCount = $this->view->locale()->toNumber(Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto));

  }

  public function getChildCount() {
    return $this->_childCount;
  }

}