<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusiness_Widget_SponsoredSitebusinessController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $params = array();

    $this->view->limit = $params['limit'] = $this->_getParam('itemCount', 4);
    $this->view->category_id = $params['category_id'] = $this->_getParam('category_id', 0);
    $this->view->interval = $this->_getParam('interval', 300);
    $this->view->titletruncation = $this->_getParam('truncation', 18); 
    
    //GET SPONSERED BUSINESSS
    $totalSitebusiness = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings('Total Sponsored Sitebusiness',$params, null, null, array('business_id'));
    $sitebusiness_sponcerd = Zend_Registry::isRegistered('sitebusiness_sponcerd') ? Zend_Registry::get('sitebusiness_sponcerd') : null;

    //NO RENDER IF SPONSERED BUSINESSS ARE ZERO
    $this->view->totalCount = $totalSitebusiness->count();
    if ( !($this->view->totalCount > 0) ) {
      return $this->setNoRender();
    }

    //SEND BUSINESS DATA TO TPL
    $columnsArray = array('business_id', 'title', 'business_url', 'owner_id', 'category_id', 'photo_id', 'featured', 'sponsored', 'view_count', 'comment_count', 'like_count', 'follow_count');
    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessmember')) {
        $columnsArray[] = 'member_count';
    }
    $columnsArray[] = 'member_title';

    if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusinessreview')) {
        $columnsArray[] = 'review_count';
        $columnsArray[] = 'rating';
    }    
    $this->view->sitebusinesses = $sitebusinesses = Engine_Api::_()->getDbTable('business', 'sitebusiness')->getListings('Sponsored Sitebusiness',$params, null, null, $columnsArray);

    $this->view->count = $sitebusinesses->count();
    if ( empty($sitebusiness_sponcerd) ) {
      return $this->setNoRender();
    }
  }

}
?>