<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "businessalbums";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.manifestUrl', "business-albums");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitebusinessalbum',
        'version' => '5.4.1',
        'path' => 'application/modules/Sitebusinessalbum',
        'title' => 'Directory / Businesses - Photo Albums Extension',
        'description' => 'Directory / Businesses - Photo Albums Extension',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'callback' =>
        array(
            'path' => 'application/modules/Sitebusinessalbum/settings/install.php',
            'class' => 'Sitebusinessalbum_Installer',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitebusinessalbum',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitebusinessalbum.csv',
        ),
    ),
    'sitemobile_compatible' => true,
    // Compose -------------------------------------------------------------------
    'composer' => array(
        'sitebusinessphoto' => array(
            'script' => array('_composeSitebusinessPhoto.tpl', 'sitebusinessalbum'),
            'plugin' => 'Sitebusinessalbum_Plugin_Composer',
            'auth' => array('sitebusiness_business', 'spcreate'),
        ),
    ),
    'routes' => array(
        'sitebusinessalbumadmin_delete' => array(
            'route' => $routeStart.'/admin/delete/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessalbum',
                'controller' => 'admin-manage',
                'action' => 'delete'
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),

        'sitebusinessalbum_featuredalbum' => array(
            'route' => $routeStart.'/admin/featured/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessalbum',
                'controller' => 'admin-manage',
                'action' => 'featured'
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),

        'sitebusinessalbum_extended' => array(
            'route' => $routeStart.'/:controller/:action/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'photo',
                'action' => 'index'
            ),
        ),

         'sitebusinessalbum_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'album',
                'action' => 'browse',
            ),
        ),

        'sitebusinessalbum_home' => array(
           'route' => $routeStart.'/home/*',
            'defaults' => array(
                'module' => 'sitebusiness',
                'controller' => 'album',
                'action' => 'home',
            ),
        ),
    ),

);
?>