<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Widget_AlbumContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {
  
    //GET VIEWER
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();

    //GET VIEWER ID
    $viewer_id = $viewer->getIdentity();
    $photosorder = $this->_getParam('photosorder', 1);

    $request = Zend_Controller_Front::getInstance()->getRequest();

    $engineApiSitebusiness = Engine_Api::_()->sitebusiness();
    //GET ALBUM ID
    $this->view->album_id = $album_id = $request->getParam('album_id');

    //GET ALBUM ITEM
    $this->view->album = $album = Engine_Api::_()->getItem('sitebusiness_album', $album_id);

    //SEND TAB ID TO THE TPL
    $this->view->tab_selected_id = $request->getParam('tab');

    $getPackageEditPhoto = $engineApiSitebusiness->getPackageAuthInfo('sitebusinessalbum');

    //GET SITEBUSINESS ID
    $business_id = $request->getParam('business_id');

    //GET SITESITEBUSINESS ITEM
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = $engineApiSitebusiness->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = $engineApiSitebusiness->isManageAdmin($sitebusiness, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = $engineApiSitebusiness->isManageAdmin($sitebusiness, 'spcreate');
    if (empty($isManageAdmin)) {
      $this->view->canCreatePhoto = $canCreatePhoto = 0;
    } else {
      $this->view->canCreatePhoto = $canCreatePhoto = 1;
    }
    $this->view->is_ajax = $is_ajax = $this->_getParam('isajax', '');
    if( $is_ajax ) {
      $this->getElement()->removeDecorator('Title');
      $this->getElement()->removeDecorator('Container');
    }
    $isManageAdmin = $engineApiSitebusiness->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = 0;
    } else {
      $this->view->can_edit = 1;
    }
    if (empty($viewer->level_id)) {
      $this->view->level_id = $level_id = 0;
    }
    else {
      $this->view->level_id = $level_id = $viewer->level_id;
    }
    $this->view->allowView = false;
    if (!empty($viewer_id) && $level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitebusiness, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness, 'registered', 'view') === 1 ? true : false;
    } 

    //END MANAGE-ADMIN CHECK
    //CHECK THAT USER CAN UPLOAD PHOTO OR NOT
    $this->view->upload_photo = 0;

    if ($canCreatePhoto == 1 && ($engineApiSitebusiness->isBusinessOwner($sitebusiness) || $album->default_value == 1)) {
      $this->view->upload_photo = 1;
    }

    //GET CURRENT SITEBUSINESS NUMBER
    $currentBusinessNumbers = $request->getParam('businesses', 1);

    //SEND CURRENT SITEBUSINESS NUMBER TO THE TPL
    $this->view->currentBusinessNumbers = $currentBusinessNumbers;

    //SEND PHOTOS PER SITEBUSINESS TO THE TPL
    $this->view->photos_per_business = $photos_per_business = 10;

    //SET SITEBUSINESS PHOTO PARAMS
    $paramsPhoto = array();
    $paramsPhoto['business_id'] = $business_id;
    $paramsPhoto['album_id'] = $album_id;
    $paramsPhoto['order'] = 'order ASC';
    $paramsPhoto['viewBusiness'] = 1;
    //FETCHING ALL PHOTOS
    $total_photo = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotosCount($paramsPhoto);
    if (!empty($total_photo)) {
      if (Engine_Api::_()->core()->hasSubject()) {
        Engine_Api::_()->core()->clearSubject();
      }
      Engine_Api::_()->core()->setSubject($album);
    }

    //SET DEFAULT ALBUM VALUE
    $this->view->default_value = $album->default_value;

    //SET ALBUMS PARAMS
    $paramsAlbum = array();
    $paramsAlbum['business_id'] = $business_id;
    $paramsAlbum['viewBusiness'] = 1;
    
    //GET ALBUM COUNT
    $this->view->album_count =  Engine_Api::_()->getDbtable('albums', 'sitebusiness')->getAlbumsCount($paramsAlbum);
    
    //MAKING PAGINATION 
    $business_vars = $engineApiSitebusiness->makeBusiness($total_photo, $photos_per_business, $currentBusinessNumbers);
    $business_array = array();
    for ($x = 0; $x <= $business_vars[2] - 1; $x++) {
      if ($x + 1 == $business_vars[1]) {
        $link = "1";
      } else {
        $link = "0";
      }
      $business_array[$x] = array('business' => $x + 1, 'link' => $link);
    }
    $this->view->businessarray = $business_array;
    $this->view->maxbusiness = $business_vars[2];
    $this->view->pstart = 1;

    //GET TOTAL IMAGES
    $this->view->total_images = empty($getPackageEditPhoto) ? null : $total_photo;

    //SET SITEBUSINESS PHOTO PARAMS
    $paramsPhoto['start'] = $photos_per_business;
    $paramsPhoto['end'] = $business_vars[0];
    $paramsPhoto['viewBusiness'] = 1;
    $paramsPhoto['photosorder'] = $photosorder;
    $paramsPhoto['widgetName'] = 'Album Content';
    if (!Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
      $paramsPhoto['albumviewBusiness'] = 1;
    }
    //GETTING THE PHOTOS ACCORDING TO LIMIT
    $this->view->photos = Engine_Api::_()->getDbtable('photos', 'sitebusiness')->getPhotos($paramsPhoto);

    //INCREMENT VIEWS
    if ($album && !$album->getOwner()->isSelf(Engine_Api::_()->user()->getViewer())) {
      $album->view_count++;
    }

    //SAVE
    $album->save();

    //START: "SUGGEST TO FRIENDS" LINK WORK
    $business_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
		if( !empty($is_suggestion_enabled) ) {
			$is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
			$isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
			//HERE WE ARE DELETE THIS ALBUM SUGGESTION IF VIEWER HAVE
			if (!empty($is_moduleEnabled)) {
				Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_album', $request->getParam('album_id'), 'business_album_suggestion');
			}

			$SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
			$versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
			if( $versionStatus >= 0 ){ 
				$modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessalbum', $request->getParam('album_id'), 1,null);
				if (!empty($modContentObj)) {
					$contentCreatePopup = @COUNT($modContentObj);
				}
			}

			if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
				if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
					$business_flag = 1;
				}
			}
			if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
				$this->view->albumSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'album_sugg_link');
			}
		}
    //END: "SUGGEST TO FRIENDS" LINK WORK    
  }

}
?>