<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Widget_FeaturedAlbumsSlideshowController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
  
    $category_id = $this->_getParam('category_id',0);
    // List of featured album
    $table = Engine_Api::_()->getItemTable('sitebusiness_album');


    $tableName = $table->info('name');
    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $tableBusinessName = $tableBusiness->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tableBusinessName, "$tableBusinessName.business_id = $tableName.business_id", array('title AS business_title', 'photo_id as business_photo_id'))
                    ->where($tableName.".featured = ?", 1);
    $select = $select
              ->where($tableBusinessName . '.closed = ?', '0')
              ->where($tableBusinessName . '.approved = ?', '1')
              ->where($tableBusinessName . '.declined = ?', '0')
              ->where($tableBusinessName . '.draft = ?', '1');
              
    if(!empty($category_id)) {
      $select->where($tableBusinessName . '.	category_id =?', $category_id);
    }
    
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($tableBusinessName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }  

    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    } 
    
    $limit = $this->_getParam('itemCountPerBusiness', 10);
    $select->limit($limit);
    $this->view->show_slideshow_object = $this->view->featuredAlbums = $featuredAlbums = $table->fetchAll($select);
    // Count Featured Albums
    $this->view->num_of_slideshow = count($featuredAlbums);
    // Number of the result.
    if (empty($this->view->num_of_slideshow)) {
      return $this->setNoRender();
    }
  }

}
?>