<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessalbum_Widget_ListAlbumsTabsViewController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $this->view->is_ajax = $is_ajax = $this->_getParam('isajax', '');
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    $this->view->category_id = $category_id = $this->_getParam('category_id',0);
    if (empty($is_ajax)) {
      $this->view->tabs = $tabs = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitebusinessalbum', 'type' => 'albums', 'enabled' => 1));
      $count_tabs = count($tabs);
      if (empty($count_tabs)) {
        return $this->setNoRender();
      }
      $activeTabName = $tabs[0]['name'];
    }
    $this->view->marginPhoto = $this->_getParam('margin_photo', 12);
    $table = Engine_Api::_()->getItemTable('sitebusiness_album');
    $tableName = $table->info('name');
    $tableBusiness = Engine_Api::_()->getDbtable('business', 'sitebusiness'); 
    $tableBusinessName = $tableBusiness->info('name');
    $select = $table->select()
										->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tableBusinessName, "$tableBusinessName.business_id = $tableName.business_id", array('title AS business_title', 'photo_id as business_photo_id'))
            ->where($tableName . '.search = ?', '1');
 
    $select = $select
              ->where($tableBusinessName . '.closed = ?', '0')
              ->where($tableBusinessName . '.approved = ?', '1')
              ->where($tableBusinessName . '.declined = ?', '0')
              ->where($tableBusinessName . '.draft = ?', '1');

    if(!empty($category_id)) {
      $select->where($tableBusinessName . '.	category_id =?', $category_id);
    }
    
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($tableBusinessName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    } 
    
    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessalbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    }     
            
    $paramTabName = $this->_getParam('tabName', '');

    if (!empty($paramTabName))
      $activeTabName = $paramTabName;

    $activeTab = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitebusinessalbum', 'type' => 'albums', 'enabled' => 1, 'name' => $activeTabName));
    $this->view->activTab = $activTab = $activeTab['0'];

    switch ($activTab->name) {
      case 'recent_businessalbums':
        break;
      case 'liked_businessalbums':
        $select->order($tableName .'.like_count DESC');
        break;
      case 'viewed_businessalbums':
        $select->order($tableName .'.view_count DESC');
        break;
      case 'commented_businessalbums':
        $select->order($tableName .'.comment_count DESC');
        break;
      case 'featured_businessalbums':
        $select->where($tableName .'.featured = ?', 1);
        $select->order('Rand()');
        break;
      case 'random_businessalbums':
        $select->order('Rand()');
        break;
    }
 
    if ($activTab->name != 'featured_businessalbums' && $activTab->name != 'random_businessalbums') {
      $select->order('creation_date DESC');
    }

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $paginator->setItemCountPerPage($activTab->limit);
    $paginator->setCurrentPageNumber($this->_getParam('business', 1));
    $this->view->count = $paginator->getTotalItemCount();
    $this->view->canCreate = Engine_Api::_()->authorization()->isAllowed('album', null, 'create');
  }

}

?>
