<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminBadgerequestController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessbadge_AdminBadgerequestController extends Core_Controller_Action_Admin {

    //ACTION FOR MANAGING THE BADGE REQUESTES
    public function manageAction() {

        //GET NAVIGATION
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitebusinessbadge_admin_main', array(), 'sitebusinessbadge_admin_main_badgerequest');

        //GENERATE FORM
        $this->view->formFilter = $formFilter = new Sitebusinessbadge_Form_Admin_Filter();

        //FETCH REQUESTS
        $badgerequestTable = Engine_Api::_()->getDbtable('badgerequests', 'sitebusinessbadge');
        $badgerequestTableName = $badgerequestTable->info('name');

        $userTableName = Engine_Api::_()->getDbtable('users', 'user')->info('name');

        $businesstableName = Engine_Api::_()->getDbtable('business', 'sitebusiness')->info('name');

        $business = $this->_getParam('page', 1);
        $select = $badgerequestTable->select()
                ->setIntegrityCheck(false)
                ->from($badgerequestTableName)
                ->join($businesstableName, $businesstableName . '.business_id = ' . $badgerequestTableName . '.business_id', array('business_id', 'title'))
                ->join($userTableName, $userTableName . '.user_id = ' . $businesstableName . '.owner_id', array('user_id', 'email', 'displayname'))
                ->group($badgerequestTableName . '.badgerequest_id');
        $values = array();

        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        foreach ($values as $key => $value) {
            if (null === $value) {
                unset($values[$key]);
            }
        }

        $values = array_merge(array(
            'order' => 'badgerequest_id',
            'order_direction' => 'DESC',
                ), $values);

        $this->view->assign($values);
        $select->order((!empty($values['order']) ? $values['order'] : "badgerequest_id" ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
        $this->view->paginator = array();
        include APPLICATION_PATH . '/application/modules/Sitebusinessbadge/controllers/license/license2.php';
    }

    //ACTION FOR TAKING ACTION ON BADGE REQUSET FOR SITE-ADMIN
    public function changeStatusAction() {

        //GET BADGE REQUEST
        $badgerequest_id = $this->_getParam('badgerequest_id');
        $badgerequest = Engine_Api::_()->getItem('sitebusinessbadge_badgerequest', $badgerequest_id);

        //GET BUSINESS ITEM
        $this->view->sitebusiness_id = $businessid = $badgerequest->business_id;
        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $badgerequest->business_id);
        $this->view->sitebusiness_title = $sitebusiness->title;

        //GET BADGE DETAIL
        $this->view->badge = $badge = Engine_Api::_()->getItem('sitebusinessbadge_badge', $badgerequest->badge_id);
        $badge_path = Engine_Api::_()->storage()->get($badge->badge_main_id, '')->getPhotoUrl();
        $this->view->badge_image = $badge_image = '<img src="' . $badge_path . '" class="photo" width="50" />';

        //GET USER ITEM
        $this->view->member = $member = Engine_Api::_()->getItem('user', $sitebusiness->owner_id);

        $this->view->badgerequest = $badgerequest;
        $host = $_SERVER['HTTP_HOST'];
        $comments_mail = '';

        if ($this->getRequest()->isPost()) {
            $status = $_POST['status'];
            $comments = $_POST['admin_comment'];
            if (!empty($comments)) {
                $comments_mail.= Zend_Registry::get('Zend_Translate')->_("Comments by the administrator:") . '<br />' . $comments;
            }

            $modified_date = new Zend_Db_Expr('NOW()');
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            //UPDATE THE BADGE REQUEST STATUS
            $badgerequestTable = Engine_Api::_()->getDbtable('badgerequests', 'sitebusinessbadge');
            $badgerequestTable->update(array('status' => $status, 'admin_comment' => $comments, 'modified_date' => $modified_date), array('badgerequest_id = ?' => $badgerequest_id));

            $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title', 'Advertisement');

            $businesstitle = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $sitebusiness->business_url), 'sitebusiness_entry_view') . ">$sitebusiness->title</a>";

            $businessobjectlink = $host . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $sitebusiness->business_url), 'sitebusiness_entry_view');

            $badge_path = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . $badge_path;
            $badge_image = '<img src="' . $badge_path . '" class="photo" width="50" />';

            try {

                if ($status != 2) {
                    if ($status == 1) { //SEND EMAIL TO BUSINESS OWNER IF BADGE REQUEST HAS BEEN APPROVED BY SITE-ADMIN
                        Engine_Api::_()->getDbtable('business', 'sitebusiness')->update(array('badge_id' => $badgerequest->badge_id), array('business_id = ?' => $businessid));

                        $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($member->email, 'SITEBUSINESS_BADGEREQUEST_APPROVED_EMAIL', array(
                            'business_title' => $sitebusiness->title,
                            'badge_image' => $badge_image,
                            'site_title' => $site_title,
                            'business_title_with_link' => $businesstitle,
                            'admin_comment' => $comments_mail,
                            'business_view_url' => $businessobjectlink,
                            'email' => $email,
                            'queue' => true
                        ));
                    } elseif ($status == 4) { //SEND EMAIL TO BUSINESS OWNER IF BADGE REQUEST IN HOLDING STATUS BY SITE-ADMIN
                        $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
                        Engine_Api::_()->getApi('mail', 'core')->sendSystem($member->email, 'SITEBUSINESS_BADGEREQUEST_HOLDING_EMAIL', array(
                            'business_title' => $sitebusiness->title,
                            'badge_image' => $badge_image,
                            'site_title' => $site_title,
                            'business_title_with_link' => $businesstitle,
                            'admin_comment' => $comments_mail,
                            'business_view_url' => $businessobjectlink,
                            'email' => $email,
                            'queue' => true
                        ));
                    }
                } else { //SEND EMAIL TO BUSINESS OWNER IF BADGE REQUEST HAS BEEN DECLINED BY SITE-ADMIN
                    $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
                    Engine_Api::_()->getApi('mail', 'core')->sendSystem($member->email, 'SITEBUSINESS_BADGEREQUEST_DECLINED_EMAIL', array(
                        'business_title' => $sitebusiness->title,
                        'badge_image' => $badge_image,
                        'site_title' => $site_title,
                        'business_title_with_link' => $businesstitle,
                        'admin_comment' => $comments_mail,
                        'business_view_url' => $businessobjectlink,
                        'email' => $email,
                        'queue' => true
                    ));
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 300,
                'parentRefresh' => 300,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Status updated successfully.'))
            ));
        }
    }

    //ACTION FOR DELETING THE BADGE REQUEST
    public function deleteAction() {

        $this->_helper->layout->setLayout('admin-simple');
        $this->view->badgeRequestId = $badgeRequestId = $this->_getParam('badgerequest_id');

        if ($this->getRequest()->isPost()) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            try {
                $badgeRequest = Engine_Api::_()->getItem('sitebusinessbadge_badgerequest', $badgeRequestId);

                //DELETE THE BADGE REQUEST
                $badgeRequest->delete();
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
            ));
        }
        $this->renderScript('admin-badgerequest/delete.tpl');
    }

    //ACTION FOR MULTI-DELETE BADGE REQUESTS
    public function multiDeleteAction() {
        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            foreach ($values as $key => $value) {
                if ($key == 'delete_' . $value) {
                    $badgeRequest = Engine_Api::_()->getItem('sitebusinessbadge_badgerequest', (int) $value);

                    //DELETE THE BADGE REQUEST
                    $badgeRequest->delete();
                }
            }
        }
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'));
    }

}

?>