<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK


//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitebusiness.is.active')
	->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if(!empty($sitebusiness_settings)) {
	$sitebusiness_is_active = $sitebusiness_settings[0]['value'];
}
else {
	$sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitebusiness')
	->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if(!empty($check_sitebusiness)  && !empty($sitebusiness_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_business = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitebusiness_index_view')
										 ->limit(1);
  $business = $select_business->query()->fetchAll();
	if(!empty($business)) {
		$business_id = $business[0]['page_id'];
		
	  //INSERT THE BADGE WIDGET IN CORE CONTENT TABLE
		$select = new Zend_Db_Select($db);
    $select_content = $select
                 ->from('engine4_core_content')
                 ->where('page_id = ?', $business_id)
                 ->where('type = ?', 'widget')
                 ->where('name = ?', 'sitebusinessbadge.badge-sitebusinessbadge')
                 ->limit(1);
    $content = $select_content->query()->fetchAll();
    if(empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
                   ->from('engine4_core_content', 'content_id')
                   ->where('page_id = ?', $business_id)
                   ->where('type = ?', 'container')
                   ->limit(1);
      $container = $select_container->query()->fetchAll();
      if(!empty($container)) {
	      $container_id = $container[0]['content_id'];
	      $select = new Zend_Db_Select($db);
	      $select_left = $select
	                   ->from('engine4_core_content')
	                   ->where('parent_content_id = ?', $container_id)
	                   ->where('type = ?', 'container')
                     ->where('page_id = ?', $business_id)
	                   ->where('name in (?)', array('left', 'right'))
	                   ->limit(1);
	      $left = $select_left->query()->fetchAll();
	      if(!empty($left)) {
	        $left_id = $left[0]['content_id'];
	        $db->insert('engine4_core_content', array(
		        'page_id' => $business_id,
		        'type' => 'widget',
		        'name' => 'sitebusinessbadge.badge-sitebusinessbadge',
		        'parent_content_id' => $left_id,
		        'order' => 16,
		        'params' => '{"title":"Badge","titleCount":""}',
		       ));
	       }
      }
    }			
		
	  //INSERT THE BADGE WIDGET IN CORE CONTENT TABLE
		$select = new Zend_Db_Select($db);
    $select_content = $select
                 ->from('engine4_sitebusiness_admincontent')
                 ->where('business_id = ?', $business_id)
                 ->where('type = ?', 'widget')
                 ->where('name = ?', 'sitebusinessbadge.badge-sitebusinessbadge')
                 ->limit(1);
    $content = $select_content->query()->fetchAll();
    if(empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
                   ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
                   ->where('business_id = ?', $business_id)
                   ->where('type = ?', 'container')
                   ->limit(1);
      $container = $select_container->query()->fetchAll();
      if(!empty($container)) {
	      $container_id = $container[0]['admincontent_id'];
	      $select = new Zend_Db_Select($db);
	      $select_left = $select
	                   ->from('engine4_sitebusiness_admincontent')
	                   ->where('parent_content_id = ?', $container_id)
	                   ->where('type = ?', 'container')
                     ->where('business_id = ?', $business_id)
	                   ->where('name in (?)', array('left', 'right'))
	                   ->limit(1);
	      $left = $select_left->query()->fetchAll();
	      if(!empty($left)) {
	        $left_id = $left[0]['admincontent_id'];
	        $db->insert('engine4_sitebusiness_admincontent', array(
		        'business_id' => $business_id,
		        'type' => 'widget',
		        'name' => 'sitebusinessbadge.badge-sitebusinessbadge',
		        'parent_content_id' => $left_id,
		        'order' => 16,
		        'params' => '{"title":"Badge","titleCount":""}',
		       ));
	       }
      }
    }			
				
    //INSERTING THE FORM WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
		
    foreach ($contentbusiness_ids as $contentbusiness_id) {
			if(!empty($contentbusiness_id)) {
				$select = new Zend_Db_Select($db);
		    $select_content = $select
		                 ->from('engine4_sitebusiness_content')
		                 ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
		                 ->where('type = ?', 'widget')
		                 ->where('name = ?', 'sitebusinessbadge.badge-sitebusinessbadge')
		                 ->limit(1);
		    $content = $select_content->query()->fetchAll();
		    if(empty($content)) {
		      $select = new Zend_Db_Select($db);
		      $select_container = $select
		                   ->from('engine4_sitebusiness_content', 'content_id')
		                   ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
		                   ->where('type = ?', 'container')
		                   ->limit(1);
		      $container = $select_container->query()->fetchAll();
		      if(!empty($container)) {
			      $container_id = $container[0]['content_id'];
			      $select = new Zend_Db_Select($db);
			      $select_left = $select
			                   ->from('engine4_sitebusiness_content')
			                   ->where('parent_content_id = ?', $container_id)
			                   ->where('type = ?', 'container')
													->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
													->where('name in (?)', array('left', 'right'))
			                   ->limit(1);
			      $left = $select_left->query()->fetchAll();
			      if(!empty($left)) {
			        $left_id = $left[0]['content_id'];
			        $db->insert('engine4_sitebusiness_content', array(
				        'contentbusiness_id' => $contentbusiness_id['contentbusiness_id'],
				        'type' => 'widget',
				        'name' => 'sitebusinessbadge.badge-sitebusinessbadge',
				        'parent_content_id' => $left_id,
				        'order' => 16,
				        'params' => '{"title":"Badge","titleCount":""}',
				      ));
			      }
		      }
		    }
			}
    }		
	}
	
	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessbadge_index_showbadges')
          ->limit(1);
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessbadge_index_showbadges',
        'displayname' => 'Business badges',
        'title' => 'Business Badges List',
        'description' => 'This is the business badges.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
    //INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

    //INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

    //INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

    //INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

    //INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

    //INSERT BADGE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessbadge.sitebusiness-badge', $middle_id, 2);

     //INSERT MOST RECENT BUSINESS BADGE WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessbadge.popular-sitebusinessbadge', $right_id, 3, "Most Popular Badges", "true");


    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'communityad')
            ->where('enabled 	 = ?', 1)
            ->limit(1);
    $infomation = $select->query()->fetch();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.communityads')
            ->where('value 	 = ?', 1)
            ->limit(1);
    $rowinfo = $select->query()->fetch();
    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 6, "", "true");
    }
  }
}

?>