<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_Api_Core extends Core_Api_Abstract {

	public function getDocumentFileName($filename_id) {
		//FILENAME FROM STORAGE TABLE
    $tableStorage = Engine_Api::_()->getDbtable('files', 'storage');
    $tableStorageName = $tableStorage->info('name');
    $tableDocumentName = Engine_Api::_()->getDbtable('documents', 'sitebusinessdocument')->info('name');

    $select = $tableStorage->select()
                    ->setIntegrityCheck(false)
                    ->from($tableDocumentName)
                    ->join($tableStorageName, "$tableStorageName.file_id = $filename_id", array('name'))
                    ->where($tableStorageName . '.parent_type = ?', 'sitebusinessdocument');
    return $select->query()->fetchAll();
	}

  public function setDocumentPackages() {
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.basetime');
    $filePath = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.filepath');
    $currentbase_time = time();
    $word_name = strrev('lruc');
    $get_file_content = null;
    $file_path = APPLICATION_PATH . '/application/modules/' . $filePath;

    if (($currentbase_time - $base_result_time > 4579200) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $modGetType = strstr($get_file_content, $word_name);
      }

      if (empty($modGetType)) {
        Engine_Api::_()->sitebusiness()->setDisabledType();
        Engine_Api::_()->getItemtable('sitebusiness_package')->setEnabledPackages();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessdocument.set.type', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessdocument.api.info', 1);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitebusinessdocument.isvar', 1);
      }
    }
  }

  /**
   * Send email to document and business owner if document has been deleted from scirbd
   * @param array $document : document item
   * @param string $sitebusiness_title : business title
   */
  public function emailDocumentDelete($document, $sitebusiness_title, $sitebusiness_owner_id) {

    if (empty($document) || empty($sitebusiness_owner_id)) {
      return;
    }

    if (empty($sitebusiness_title)) {
      $sitebusiness_title = "Business Title";
    }

    $document_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $document->owner_id, 'document_id' => $document->document_id, 'slug' => $document->getSlug()), 'sitebusinessdocument_detail_view') . ">$document->sitebusinessdocument_title</a>";

    $edit_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'business_id' => $document->business_id), 'sitebusinessdocument_edit');

    $delete_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'business_id' => $document->business_id), 'sitebusinessdocument_delete');

    $business_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => Engine_Api::_()->sitebusiness()->getBusinessUrl($document->business_id)), 'sitebusiness_entry_view') . ">$sitebusiness_title</a>";

    $userTable = Engine_Api::_()->getItemTable('user');
    $document_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $document_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($document_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($document_owner_email_id, 'notify_docowner_sitebusinessdocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'business_title_with_link' => $business_title_with_link,
          'delete_document_link' => $delete_document_link,
          'edit_document_link' => $edit_document_link,
          'queue' => true
      ));
    }

    $userTable = Engine_Api::_()->getItemTable('user');
    $sitebusiness_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $sitebusiness_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($sitebusiness_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($sitebusiness_owner_email_id, 'notify_sitebusinessowner_sitebusinessdocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'business_title_with_link' => $business_title_with_link,
          'delete_document_link' => $delete_document_link,
          'queue' => true
      ));
    }
  }

  /**
   * Delete document from server
   * @param int $document_id : document id
   */
  public function deleteServerDocument($document_id) {

    $document = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

    $storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($document->storage_path) && !empty($document->storage_path)) {
      unlink($document->storage_path);
    }

    if (!empty($document->filename_id)) {
      $storage = Engine_Api::_()->getItem('storage_file', $document->filename_id);
      $fileName = $storage->name;
      $storage->delete();

      $document->storage_path = $fileName;
      $document->filename_id = 0;
      $document->save();
    }
  }

  /**
   * Delete the sitebusinessdocument and ratings
   * 
   * @param int $document_id
   */
  public function deleteContent($document_id) {

		//GET THE SITEBUSINESSNOTE ITEM
    $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', $document_id);

		if(empty($sitebusinessdocument)) {
			return;
		}

		include_once APPLICATION_PATH . '/application/modules/Sitebusinessdocument/Api/Scribdsitebusiness.php';

		$this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_api_key;
		$this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_secret_key;
		$this->scribdsitebusiness = new Scribdsitebusiness($this->scribd_api_key, $this->scribd_secret);

		//DELETE DOCUMENT FROM SCRIBD
		if (!empty($sitebusinessdocument->doc_id)) {
			$this->scribdsitebusiness->my_user_id = $sitebusinessdocument->owner_id;
			$this->scribdsitebusiness->delete($sitebusinessdocument->doc_id);
		}

		//DELETE ENTRY FROM engine4_document_fields_search TABLE CORRESPONDIG TO item_id
		$searchTable = Engine_Api::_()->getItem('sitebusinessdocument_search', $document_id);
		if (!empty($searchTable)) {
			$searchTable->delete();
		}

		Engine_Api::_()->getDbtable('ratings', 'sitebusinessdocument')->delete(array('document_id = ?' => $document_id));

		//DELETE DOCUMENT FROM LOCAL SERVER
		$storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($sitebusinessdocument->storage_path) && !empty($sitebusinessdocument->storage_path)) {
      unlink($sitebusinessdocument->storage_path);
    }

		//DELETE DOCUMENT AND OTHER BELONGINGS
		$sitebusinessdocument->delete();
	}

}
?>