<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK
//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

$db->query('
  INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
  ("sitebusinessdocument_admin_main_categories", "sitebusinessdocument", "Categories", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings","action":"categories"}\', "sitebusinessdocument_admin_main", "", 3);
');

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitebusiness.is.active')
	->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if(!empty($sitebusiness_settings)) {
	$sitebusiness_is_active = $sitebusiness_settings[0]['value'];
}
else {
	$sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitebusiness')
	->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if(!empty($check_sitebusiness)  && !empty($sitebusiness_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_business = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitebusiness_index_view')
										 ->limit(1);
  $business = $select_business->query()->fetchAll();
	if(!empty($business)) {
		$business_id = $business[0]['page_id'];
		
		//INSERTING THE DOCUMENT WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
	 
		//INSERTING THE DOCUMENT WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusinessdocument.profile-sitebusinessdocuments', $business_id, 'Documents', 'true', '115');
		
    //INSERTING THE DOCUMENT WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
			if(!empty($contentbusiness_id)) {
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusinessdocument.profile-sitebusinessdocuments', $contentbusiness_id['contentbusiness_id'], 'Documents', 'true', '115');
			}
		}
	}
	
	$contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');
 
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitebusiness.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
    ;
    $rowinfo = $select->query()->fetch();

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessdocument_index_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessdocument_index_browse',
        'displayname' => 'Browse Business documents',
        'title' => 'Business Documents List',
        'description' => 'This is the business documents.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

//INSERT DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.sitebusiness-document', $middle_id, 2);

    //INSERT SEARCH BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.search-sitebusinessdocument', $right_id, 3, "", "true");

    //INSERT FEATURED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homefeaturelist-sitebusinessdocuments', $right_id, 4, "Featured Documents", "true");

    //INSERT SPONSORED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.sitebusiness-sponsoreddocument', $right_id, 5, "Sponsored Documents", "true");

    //INSERT MOST COMMENTED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homecomment-sitebusinessdocuments', $right_id, 6, "Most Commented Documents", "true");

    //INSERT MOST VIEWED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homepopular-sitebusinessdocuments', $right_id, 7, "Most Viewed Documents", "true");

    //INSERT MOST LIKED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homelike-sitebusinessdocuments', $right_id, 8, "Most Liked Documents", "true");

    //INSERT TOP RATED BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homerate-sitebusinessdocuments', $right_id, 9, "Top Rated Documents", "true");

    //INSERT RECENT BUSINESS DOCUMENT WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessdocument.homerecent-sitebusinessdocuments', $right_id, 10, "Recent Business Documents", "true");

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 11, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessdocument_index_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessdocument_index_view',
        'displayname' => 'Business Document View Page',
        'title' => 'View Business Document',
        'description' => 'This is the view business for a business document.',
        'custom' => 1,
        'provides' => 'subject=sitebusinessdocument',
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.document-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    //BUSINESS DOCUMENT OWNER PHOTO WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.document-owner-photo-documents',
        'parent_content_id' => $right_id,
        'order' => 2,
        'params' => '',
      ));

			//BUSINESS DOCUMENT OPTIONS WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.options-documents',
        'parent_content_id' => $right_id,
        'order' => 3,
        'params' => '',
      ));

      //RECENT BUSINESS DOCUMENT
      $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessdocument.viewrecent-sitebusinessdocuments',
        'parent_content_id' => $right_id,
        'order' => 4,
        'params' => '',
      ));

			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitebusinessdocument.socialshare-sitebusinessdocuments"}';

			//SOCIAL SHARE BUTTONS WIDGET
			$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.socialshare-sitebusinessdocuments',
				'parent_content_id' => $right_id,
				'order' => 4,
				'params' => $social_share_default_code,
			));

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 5, "", "true");
    }

  }

  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'mobi')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_pages')
						->where('name = ?', 'sitebusinessdocument_mobi_view')
						->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
					'name' => 'sitebusinessdocument_mobi_view',
					'displayname' => 'Mobile Business Document Profile',
					'title' => 'Mobile Business Document Profile',
					'description' => 'This is the mobile verison of a Business document profile business.',
					'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'main',
					'parent_content_id' => null,
					'order' => 1,
					'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'right',
					'parent_content_id' => $container_id,
					'order' => 1,
					'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $container_id,
					'order' => 3,
					'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessdocument.document-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));
		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitebusinessdocument_admin_main_widgets", "sitebusinessdocument", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"widgets"}\', "sitebusinessdocument_admin_main", "", 0, 3, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_general_tab", "sitebusinessdocument", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"widgets", "action": "index"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_document_tab", "sitebusinessdocument", "Tabbed Documents Widget", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings", "action": "widget"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessdocument_admin_submain_dayitems", "sitebusinessdocument", "Document of the Day", "", \'{"route":"admin_default","module":"sitebusinessdocument","controller":"settings", "action": "manage-day-items"}\', "sitebusinessdocument_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitebusinessdocument_index_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitebusinessdocument_index_home',
				'displayname' => 'Business Documents Home',
				'title' => 'Business Documents Home',
				'description' => 'This is business document home business.',
				'custom' => 1
		));
		$business_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusiness.browsenevigation-sitebusiness',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
	
		//INSERT TOP RATED BUSINESS DOCUMENT WIDGET
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homerate-sitebusinessdocuments',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homerecent-sitebusinessdocuments',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Recent Business Documents","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homepopular-sitebusinessdocuments',
				'parent_content_id' => $right_id,
				'order' => 20,
				'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
		));

		// Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.featured-documents-slideshow',
				'parent_content_id' => $middle_id,
				'order' => 15,
				'params' => '{"title":"Featured Documents","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.list-documents-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Documents","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.sitebusinessdocumentlist-link',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.search-sitebusinessdocument',
				'parent_content_id' => $right_id,
				'order' => 18,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.document-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 12,
				'params' => '{"title":"Document of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homefeaturelist-sitebusinessdocuments',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Documents","itemCountPerBusiness":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homecomment-sitebusinessdocuments',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessdocument.homelike-sitebusinessdocuments',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
		));
	}

	$select = new Zend_Db_Select($db);
	$select
				->from('engine4_core_content')
				->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
				
	$is_exit = $select->query()->fetchObject();
	if(!empty($is_exit)) {
		$db->update('engine4_core_content', array(
			'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
			'params' => '{"title":"Highlighted Documents","titleCount":true}',
					), array(
			'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
		));
	}
	
	$select = new Zend_Db_Select($db);
	$select
				->from('engine4_sitebusiness_admincontent')
				->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
				
	$is_exit_content = $select->query()->fetchObject();
	if(!empty($is_exit_content)) {
		$db->update('engine4_core_content', array(
			'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
			'params' => '{"title":"Highlighted Documents","titleCount":true}',
					), array(
			'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
		));
	}

	$select = new Zend_Db_Select($db);
	$select
				->from('engine4_sitebusiness_content')
				->where('name = ?', 'sitebusinessdocument.featurelist-sitebusinessdocuments');
				
	$is_exit_sitebusinesscontent = $select->query()->fetchObject();
	if(!empty($is_exit_sitebusinesscontent)) {
		$db->update('engine4_core_content', array(
			'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
			'params' => '{"title":"Highlighted Documents","titleCount":true}',
					), array(
			'name = ?' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
		));
	}
}
?>