<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Documents',
        'description' => 'This widget forms the Documents tab on the Business Profile and displays the documents of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.profile-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Documents',
        ),
    ),
    array(
        'title' => 'Business Profile Recent Documents',
        'description' => 'Displays list of Business’s recent documents. This widget should be placed on Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.recent-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Recent Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Popular Documents',
        'description' => 'Displays list of business’s most viewed documents. This widget should be placed on Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.popular-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Commented Documents',
        'description' => 'Displays list of business’s most commented documents. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.comment-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Liked Documents',
        'description' => 'Displays list of business’s most liked documents. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.like-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Top Rated Documents',
        'description' => 'Displays list of business’s top rated documents. This widget should be placed on Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.rate-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Featured Documents',
        'description' => 'Displays list of business’s featured documents. This widget should be placed on Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Recent Documents',
        'description' => 'Displays the recent documents of the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homerecent-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Recent Documents'
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
	array(
		'title' => 'Business Document Social Share Buttons Buttons',
		'description' => "Contains Social Sharing buttons and enables users to easily share Business Documents on their favorite Social Networks. This widget should be placed on the Business Document View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
		'category' => 'Businesses',
		'type' => 'widget',
		'name' => 'sitebusinessdocument.socialshare-sitebusinessdocuments',
		'defaultParams' => array(
				'title' => 'Social Share',
				'titleCount' => true,
		),
    'requirements' => array(
      'subject' => 'sitebusinessdocument',
    ),
		'adminForm' => array(
			'elements' => array(
				array(
						'Hidden',
						'nomobile',
						array(
								'label' => '',
                                'order' => 1001
						)
				),
			),
		),
	),
    array(
        'title' => 'Recent Documents from Business',
        'description' => 'Displays recent Business Documents corresponding to the Business of which the document is being viewed. You can choose the number of entries to be shown. This widget should be placed on Business Document View Page.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.viewrecent-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => ''
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
			'title' => 'Search Business Documents form',
			'description' => 'Displays the form for searching Business Documents on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessdocument.search-sitebusinessdocument',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5', "5" => "6"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Documents form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Document Title", "5" => "Business Category", "6" => "Document Category"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Business Documents',
        'description' => 'Displays the list of Documents from Businesses created on your community. This widget should be placed in the widgetized Business Documents business. Results from the Search Business Documents form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.sitebusiness-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    
    array(
        'title' => 'Sponsored Documents',
        'description' => 'Displays the Documents from Paid Businesses. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.sitebusiness-sponsoreddocument',
        'defaultParams' => array(
            'title' => 'Sponsored Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
 
    array(
        'title' => 'Featured Documents',
        'description' => "Displays Featured Business Documents. You can mark Business Documents as Featured from the “Manage Business Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homefeaturelist-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
//     array(
//         'title' => 'Highlighted Documents',
//         'description' => "Displays Highlighted Business Documents. You can mark Business Documents as Highlighted from the “Manage Business Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
//         'category' => 'Businesses',
//         'type' => 'widget',
//         'name' => 'sitebusinessdocument.homehighlightlist-sitebusinessdocuments',
//         'defaultParams' => array(
//             'title' => 'Highlighted Documents',
//             'titleCount' => true,
//         ),
//         'adminForm' => array(
// 					'elements' => array(
// 						array(
// 								'Text',
// 								'itemCount',
// 								array(
// 										'label' => 'Count',
// 										'description' => '(number of documents to show)',
// 										'value' => 3,
// 										'validators' => array(
// 											array('Int', true),
// 											array('GreaterThan', true, array(0)),
// 										),
// 								),
// 						),
// 					),
//         ),
//     ),

    array(
        'title' => 'Most Commented Documents',
        'description' => "Displays the Most Commented Business Documents. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homecomment-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
    
     array(
        'title' => 'Most Popular Documents',
        'description' => "Displays the Most Viewed Business Documents. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homepopular-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
 
    array(
        'title' => 'Most Liked Documents',
        'description' => "Displays the Most Liked Business Documents. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homelike-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

    array(
        'title' => 'Top Rated Documents',
        'description' => "Displays the Top Rated Business Documents. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.homerate-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

	array(
			'title' => 'Business Document View',
			'description' => "This widget should be placed on the Business Document View Page.",
      'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessdocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

  array(
			'title' => 'Business Document View Options',
			'description' => 'Displays various action link options to users viewing a Business Document. This Widget should be placed on the Business Document View Page in the right column, below the Business Document\'s Owner Photo.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessdocument.options-documents',
			'requirements' => array(
				'subject' => 'sitebusinessdocument_document',
			),
	),

  array(
			'title' => 'Business Document\'s Owner Photo',
			'description' => 'Displays business owner\'s photo with business owner\'s name to users viewing Business Document. This widget should be placed on Business Document View Page.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessdocument.document-owner-photo-documents',
			'requirements' => array(
				'subject' => 'sitebusinessdocument_document',
			),
	),

  array(
        'title' => 'Document of the Day',
        'description' => 'Displays the Document of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Documents Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.document-of-the-day',
        'defaultParams' => array(
            'title' => 'Document of the Day'
        ),
    ),

     array(
        'title' => 'Business’s Featured Documents Slideshow',
        'description' => 'Displays featured documents in an attractive slideshow. You can set the count of the number of documents to show in this widget. If the total number of documents featured are more than that count, then the documents to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.featured-documents-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'itemCountPerBusiness' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Business’s Featured Documents Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured documents on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.featured-documents-carousel',
        'defaultParams' => array(
            'title' => 'Featured Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Documents in a Row',
                        'description' => '(number of documents to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Documents',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Documents in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Documents Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.list-documents-tabs-view',
        'defaultParams' => array(
            'title' => 'Documents',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),
 
    array(
        'title' => 'Browse Documents',
        'description' => 'Displays the link to view Business’s Documents Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.sitebusinessdocumentlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Business Profile Highlighted Documents',
        'description' => "Displays list of business's highlighted documents. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => 'Highlighted Business Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

     array(
    'title' => 'Top Creators : Business Documents',
    'description' => 'Displays the Businesses which have the most number of Business Documents added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessdocument.topcreators-sitebusinessdocument',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessdocument',
    ),
  ),

)
?>