<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Documents'),
        'description' => $view->translate('Forms the Documents tab of your Business and shows the documents of your Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.profile-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Recent Documents'),
        'description' => $view->translate('Displays recent documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.recent-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Popular Documents'),
        'description' => $view->translate('Displays popular documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.popular-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Popular Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Commented Documents'),
        'description' => $view->translate('Displays most commented documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.comment-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Liked Documents'),
        'description' => $view->translate('Displays most liked documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.like-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Top Rated Documents'),
        'description' => $view->translate('Displays top rated documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.rate-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Top Rated Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Featured Documents'),
        'description' => $view->translate('Displays featured documents of your Business.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.featurelist-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Featured Documents'),
            'titleCount' => true,
        ),
    ),
    array(
			'title' => $view->translate('Business Profile Highlighted Documents'),
			'description' => $view->translate("Displays list of business's highlighted documents. This widget should be placed on the Business Profile."),
			'category' => $view->translate('Business Profile'),
			'type' => 'widget',
			'name' => 'sitebusinessdocument.highlightlist-sitebusinessdocuments',
			'defaultParams' => array(
					'title' => $view->translate('Highlighted Business Documents'),
					'titleCount' => true,
			),
			'adminForm' => array(
				'elements' => array(
					array(
							'Text',
							'itemCount',
							array(
									'label' => $view->translate('Count'),
									'description' => $view->translate('(number of documents to show)'),
									'value' => 3,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
							),
					),
				),
			),
    ),
)
?>