<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Documents'),
        'description' => $view->translate('This widget forms the Documents tab on the Business Profile and displays the documents of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.sitemobile-profile-sitebusinessdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),

     array(
        'title' => $view->translate('Business Documents'),
        'description' => $view->translate('Displays the list of Documents from Businesses created on your community. This widget should be placed in the widgetized Business Documents business. Results from the Search Business Documents form are also shown here.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinessdocument.sitebusiness-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of documents to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
	array(
			'title' => $view->translate('Business Document View'),
			'description' => $view->translate("This widget should be placed on the Business Document View Business."),
      'category' => $view->translate('Businesses'),
			'type' => 'widget',
			'name' => 'sitebusinessdocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>