<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessdocument_Widget_DocumentContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

    //SET SCRIBD API AND SCECRET KEY
    $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_api_key;
    $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_secret_key;
    $this->scribdsitebusiness = new Scribdsitebusiness($this->scribd_api_key, $this->scribd_secret);

      //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET USER LEVEL
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = Engine_Api::_()->user()->getViewer()->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET DOCUMNET MODEL
    $this->view->sitebusinessdocument = $sitebusinessdocument = Engine_Api::_()->getItem('sitebusinessdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    if (empty($sitebusinessdocument)) {
      return $this->setNoRender();
    }

    $this->view->business_id = $sitebusinessdocument->business_id;

    //SET BUSINESS SUBJECT
    $sitebusiness_subject = null;
    //if (!Engine_Api::_()->core()->hasSubject()) {
      $business_id = $sitebusinessdocument->business_id;
      if (null !== $business_id) {
        $business_subject = $sitebusiness_subject = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
//         if ($sitebusiness_subject && $sitebusiness_subject->getIdentity()) {
//           Engine_Api::_()->core()->setSubject($sitebusiness_subject);
//         }
      }
    //}
    $this->view->sitebusiness_subject = $sitebusiness_subject;
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness_subject->package_id, "modules", "sitebusinessdocument")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness_subject, 'sdcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
  
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitebusiness_subject, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness_subject, 'registered', 'view') === 1 ? true : false;
    } 

    //END MANAGE-ADMIN CHECK
    //DESTROY THE PREVIOUS SUBJECT
   // Engine_Api::_()->core()->clearSubject();

    if (($can_edit != 1 && $viewer_id != $sitebusinessdocument->owner_id) && ($sitebusinessdocument->draft == 1 || $sitebusinessdocument->status != 1 || $sitebusinessdocument->approved != 1 || $sitebusinessdocument->search != 1)) {
      return $this->setNoRender();
    }

    //CHECK THAT VIEWER CAN RATE THE DOCUMENT OR NOT
    $this->view->can_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.rating', 1);

    //GET OWNER INFORMATION
    $this->view->owner = $owner = $sitebusinessdocument->getOwner();

    //GET CURRENT URL
    $front = Zend_Controller_Front::getInstance();
		if(!empty($this->view->https)) {
			$curr_url = 'https://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
		else {
			$curr_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
    $this->view->curr_url = urlencode((string) $curr_url);

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitebusinessdocument->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitebusinessdocument->views++;
    }

    //SET SCRIBD USER ID
    $this->scribdsitebusiness->my_user_id = $sitebusinessdocument->owner_id;
    Engine_Api::_()->sitebusinessdocument()->setDocumentPackages();

    $stat = null;
    if (!empty($sitebusinessdocument->doc_id)) {
      try {
        $stat = trim($this->scribdsitebusiness->getConversionStatus($sitebusinessdocument->doc_id));
      } catch (Exception $e) {
        $message = $e->getMessage();
        $this->view->excep_error = 1;
        $this->view->excep_message = $message;
      }
    }

    //CHECK VIEWER CAN DOWNLOAD AND EMAIL THIS DOCUMENT OR NOT
    if (!empty($viewer_id)) {
      $download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.download.allow', 1);
      $download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.download.format', 'pdf');
      $this->view->email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.email.allow', 1);
    } else {
      $download_allow = 0;
      $download_format = 0;
      $this->view->email_allow = 0;
    }

    if (!empty($viewer_id)) {
      if ($download_allow && $stat == 'DONE' && $sitebusinessdocument->download_allow) {
        try {
          $link = $this->scribdsitebusiness->getDownloadUrl($sitebusinessdocument->doc_id, $download_format);
        } catch (Exception $e) {
          $message = $e->getMessage();
          $this->view->excep_error = 1;
          $this->view->excep_message = $message;
        }
        $this->view->link = trim($link['download_link']);
        $sitebusinessdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.include.full.text', 1);
        if ($sitebusinessdocument_include_full_text == 1) {
          $doc_full_text = $sitebusinessdocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    } else { //WE SHOW FULL TEXT IN CASE OF NONLOGGEDIN USER IF DOCUMENT IS AVAILABLE FOR DOWNLOADING  AND ADMIN HAD ALLOWED FOR FULL TEXT IN GLOBAL SETTINGS
      if ($stat == 'DONE') {
        $sitebusinessdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.include.full.text', 1);
        $sitebusinessdocument_visitor_fulltext = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.visitor.fulltext', 1);
        if ($sitebusinessdocument_include_full_text == 1 && $sitebusinessdocument_visitor_fulltext == 1 && $sitebusinessdocument->download_allow) {
          $doc_full_text = $sitebusinessdocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    }

    //IF STAT IS DONE THAN UPDATE DOCUMENT STATUS AND OTHER INFORMATION
    if ($stat == 'DONE') {
      try {
        //GETTING DOCUMENT'S FULL TEXT
        $texturl = $this->scribdsitebusiness->getDownloadUrl($sitebusinessdocument->doc_id, 'txt');
        if ($sitebusinessdocument->status != 1) {
          $texturl = trim($texturl['download_link']);
          $file_contents = file_get_contents($texturl);
          if (empty($file_contents)) {
            $site_url = $texturl;
            $ch = curl_init();
            $timeout = 0; //SET ZERO FOR NO TIMEOUT
            curl_setopt($ch, CURLOPT_URL, $site_url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

            ob_start();
            curl_exec($ch);
            curl_close($ch);
            $file_contents = ob_get_contents();
            ob_end_clean();
          }
          $full_text = $file_contents;
          $sitebusinessdocument->fulltext = $full_text;
          $sitebusinessdocument->save();
        }
      } catch (Exception $e) {
        if ($sitebusinessdocument->status != 3 && $e->getCode() == 619) {
          $sitebusinessdocument->status = 3;

          //SEND EMAIL TO DOCUMENT OWNER IF BUSINESS DOCUMENT HAS BEEN DELETED FROM SCRIBD
          Engine_Api::_()->sitebusinessdocument()->emailDocumentDelete($sitebusinessdocument, $sitebusiness_subject->title, $sitebusiness_subject->owner_id);
        }
      }
      
      if($sitebusinessdocument->status != 3 && $sitebusinessdocument->status != 2) {
          $setting = $this->scribdsitebusiness->getSettings($sitebusinessdocument->doc_id);
          $thumbnail_url = trim($setting['thumbnail_url']);     
          $sitebusinessdocument->thumbnail = $thumbnail_url;
          $sitebusinessdocument->status = 1;
          $sitebusinessdocument->save();

          //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
          if ($sitebusinessdocument->draft == 0 && $sitebusinessdocument->approved == 1 && $sitebusinessdocument->status == 1 && $sitebusinessdocument->search == 1 && $sitebusinessdocument->activity_feed == 0) {
            $api = Engine_Api::_()->getDbtable('actions', 'activity');
            $creator = Engine_Api::_()->getItem('user', $sitebusinessdocument->owner_id);
            $activityFeedType = null;
            if (Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness_subject) && Engine_Api::_()->sitebusiness()->isFeedTypeBusinessEnable())
              $activityFeedType = 'sitebusinessdocument_admin_new';
            elseif ($sitebusiness_subject->all_post || Engine_Api::_()->sitebusiness()->isBusinessOwner($sitebusiness_subject))
              $activityFeedType = 'sitebusinessdocument_new';

            if ($activityFeedType) {
              $action = $api->addActivity($creator, $sitebusiness_subject, $activityFeedType);
              Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action);
            }
            //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
            if ($action != null) {
              $api->attachActivity($action, $sitebusinessdocument);
              $sitebusinessdocument->activity_feed = 1;
              $sitebusinessdocument->save();
            }
            
            //BUSINESS DOCUMENT CREATE NOTIFICATION AND EMAIL WORK
							if (Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitebusiness')->version >= '4.2.9p3') {
								Engine_Api::_()->sitebusiness()->sendNotificationEmail($sitebusinessdocument, $action, 'sitebusinessdocument_create', 'SITEBUSINESSDOCUMENT_CREATENOTIFICATION_EMAIL', 'Businessevent Invite');
								
								$isBusinessAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->isBusinessAdmins($viewer->getIdentity(), $business_id);
								if (!empty($isBusinessAdmins)) {
									//NOTIFICATION FOR ALL FOLLWERS.
									Engine_Api::_()->sitebusiness()->sendNotificationToFollowers($sitebusinessdocument, $action, 'sitebusinessdocument_create');
								}
							}
            
          }      
      }
     
    } elseif ($stat == 'ERROR') {
      if ($sitebusinessdocument->status != 2) {
        $sitebusinessdocument->status = 2;
        $sitebusinessdocument->save();
      }
    } else {
      $sitebusinessdocument->save();
    }

    //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
    $sitebusinessdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessdocument.save.local.server', 1);
    if ($sitebusinessdocument_save_local_server == 0 && ($sitebusinessdocument->status == 1 || $sitebusinessdocument->status == 2)) {
      Engine_Api::_()->sitebusinessdocument()->deleteServerDocument($sitebusinessdocument->document_id);
    }

    //SETTING PARAMETERS FOR SECURE DOCUMENT
    if ($viewer->getIdentity() == 0) {
      $uid = mt_rand(1000, 100000);
    } else {
      $uid = $viewer->getIdentity();
    }
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitebusinessdocument_secret_key;
    $sessionId = session_id();
    $signature = md5($scribd_secret . 'document_id' . $sitebusinessdocument->doc_id . 'session_id' . $sessionId . 'user_identifier' . $uid);
    $this->view->uid = $uid;
    $this->view->sessionId = $sessionId;
    $this->view->signature = $signature;
    $this->view->download_allow = $download_allow;

    //RATING WORK
    $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'sitebusinessdocument')->countRating($sitebusinessdocument->getIdentity());
    $this->view->sitebusinessdocument_rated = Engine_Api::_()->getDbTable('ratings', 'sitebusinessdocument')->previousRated($sitebusinessdocument->getIdentity(), $viewer->getIdentity());

    //CUSTOM FIELD WORK
    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
    $this->view->fieldStructure = $fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($sitebusinessdocument);

    // Start: Show "Suggest to Frind" link.
    $business_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'business_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessdocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        if ($business_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($business_subject->closed) && !empty($business_subject->approved) && empty($business_subject->declined) && !empty($business_subject->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'document_sugg_link');
      }
    }
    // End: "Suggest to Friend" link work
  }

}
?>