<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetsController.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_WidgetController extends Core_Controller_Action_Standard {

  //ACTION FOR RSVP
  public function profileRsvpAction() {

    //MAKE FORM
    $this->view->form = new Sitebusinessevent_Form_Rsvp();

    //GET THE SITEBUSINESSEVENT SUBJECT
    $sitebusinessevent = Engine_Api::_()->core()->getSubject();

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $business_id = $sitebusinessevent->business_id;
      if (!empty($business_id)) {
        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
        if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      }
    } else {
      $business_id = $sitebusinessevent->business_id;
      if (!empty($business_id)) {
        $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      }
      if (empty($isBusinessOwnerAllow)) {
        return $this->_forward('requireauth', 'error', 'core');
      }
    }
    // PACKAGE BASE PRIYACY END
    
    // GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();

    // IF VIEWER IS NOT MEMBER OF EVENT, RETURN
    if (!$sitebusinessevent->membership()->isMember($viewer, true)) {
      return;
    }

    //GETTING ROWS
    $row = $sitebusinessevent->membership()->getRow($viewer);
    if ($row) {
      $this->view->rsvp = $row->rsvp;
    } else {
      return $this->_helper->viewRenderer->setNoRender(true);
    }

    // IF NOT POST OR FORM NOT VALID, RETURN
    if ($this->getRequest()->isPost()) {
      $option_id = $this->getRequest()->getParam('option_id');
      //SAVE RSVP
      $row->rsvp = $option_id;
      $row->save();
    }
  }

  //ACTION FOR PROFILE INFO
  public function profileInfoAction() {
  	
    // DON'T RENDER THIS IF NOT AUTHORIZED
    if (!$this->_helper->requireAuth()->setAuthParams(null, null, 'view')->isValid())
      return $this->_helper->viewRenderer->setNoRender(true);
  }

  //ACTION FOR EVENT NOTIFICATION
  public function requestSitebusinesseventAction() {
  	
    $this->view->notification = $notification = $this->_getParam('notification');
  }

}

?>