<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Events',
        'description' => 'This widget forms the Events tab on the Business Profile and displays the events of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-sitebusinessevents',
        'defaultParams' => array(
            'title' => 'Events',
        ),
    ),
    array(
        'title' => 'Business Event Profile Photo',
        'description' => "Displays a Business event's photo on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-photo',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Business Event Profile Options',
        'description' => "Displays a Business event's options on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-options',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Business Event Profile Details',
        'description' => "Displays a Business event's details on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-info',
        'defaultParams' => array(
            'title' => 'Business Events Details',
        ),
    ),
    array(
        'title' => 'Business Event Profile Rsvp',
        'description' => "Displays a Business event's rsvp on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-rsvp',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
    'title' => 'Business Event Profile Photos',
    'description' => 'Displays a Business event\'s photos on it\'s profile.',
    'category' => 'Business Event Profile',
    'type' => 'widget',
    'name' => 'sitebusinessevent.profile-photos',
    'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Photos',
      'titleCount' => true,
    ),
    'requirements' => array(
      'subject' => 'sitebusinessevent_event',
    ),
  ),
    array(
        'title' => 'Business Event Profile Guest Member',
        'description' => "Displays a Business event's guest members on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-members',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Business Event Profile Title',
        'description' => "Displays a Business event's title on it's profile.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-status',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => 'Business Profile Upcoming Events',
        'description' => "Displays list of business’s upcoming events. This widget should be placed on Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-events',
        'defaultParams' => array(
            'title' => 'Upcoming Events',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of events to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Event Profile Breadcrumb',
        'description' => "Displays a 'Breadcrumb' on Business event's profile. This breadcrumb contains links to the Business this event belongs to and all the events of that Business.",
        'category' => 'Business Event Profile',
        'type' => 'widget',
        'name' => 'sitebusinessevent.profile-breadcrumbevent',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
        'title' => "Upcoming Events",        
        'description' => "Displays list of upcoming events of businesses on the site.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.upcoming-sitebusinessevent',
        'defaultParams' => array(
            'title' => 'Upcoming Events',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of events to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),

    array(
			'title' => 'Search Business Events form',
			'description' => 'Displays the form for searching Business Events on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessevent.search-sitebusinessevent',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5', "5" => '6'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Events form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Event Title", "5" => "Business Category", "6" => "Event Category"),
									),
							),
					),
			)
    ),

    array(
        'title' => 'Business Events',
        'description' => 'Displays the list of Events from Businesses created on your community. This widget should be placed in the widgetized Business Events business. Results from the Search Business Events form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.sitebusiness-event',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of events to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Events',
        'description' => 'Displays the Events from Paid Businesses. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.sitebusiness-sponsoredevent',
        'defaultParams' => array(
            'title' => 'Sponsored Events',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of events to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
                array(
									'Radio',
									'showevent',
									array(
											'label' => 'Show Events',
											'multiOptions' => array('upcoming' => 'Upcoming', 'overall' => 'Overall'),
											'value' => 'overall',
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Featured Events',
        'description' => "Displays Featured Business Events. You can mark Business Events as Featured from the “Manage Business Events” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.homefeaturelist-sitebusinessevents',
        'defaultParams' => array(
            'title' => 'Featured Events',
            'titleCount' => true,
            'showevent' => array('upcoming' => 'Upcoming', 'overall' => 'Overall'),
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of events to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					  ),
            array(
									'Radio',
									'showevent',
									array(
											'label' => 'Show Events',
											'multiOptions' => array('upcoming' => 'Upcoming', 'overall' => 'Overall'),
											'value' => 'overall',
									)
							),
					),
        ),
    ),

    array(
        'title' => 'Business’s Featured Events Slideshow',
        'description' => 'Displays featured events in an attractive slideshow. You can set the count of the number of events to show in this widget. If the total number of events featured are more than that count, then the events to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.featured-events-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Upcoming Events',
            'itemCountPerBusiness' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Business’s Featured Events Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured events on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.featured-events-carousel',
        'defaultParams' => array(
            'title' => 'Featured Upcoming Events',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					      ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Events in a Row',
                        'description' => '(number of events to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Event of the Day',
        'description' => 'Displays the Event of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Events Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.event-of-the-day',
        'defaultParams' => array(
            'title' => 'Event of the Day'
        ),
    ),

    array(
        'title' => 'Browse Events',
        'description' => 'Displays the link to view Business’s Events Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.sitebusinesseventlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Most Viewed Events',
        'description' => "Displays the Most Viewed Business Events. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.homeview-sitebusinessevents',
        'defaultParams' => array(
            'title' => 'Most Viewed Events',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of events to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					  ),
					),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Events',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Events in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Events Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.list-events-tabs-view',
        'defaultParams' => array(
            'title' => 'Events',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              ),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					    ),
            ),
        ),
    ),

    array(
    'title' => 'Top Creators : Business Events',
    'description' => 'Displays the Businesses which have the most number of Business Events added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessevent.topcreators-sitebusinessevent',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
					      ),
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessevent',
    ),
  ),
  
  
  
      array(
        'title' => 'By Locations',
        'description' => 'Displays a list of all the business events having location entered corresponding to them on the site. This widget should be placed on Browse Business Events’ Locations business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessevent.bylocation-event',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
//         'adminForm' => array(
// 					'elements' => array(
// 						array(
// 								'Radio',
// 								'order_by',
// 								array(
// 										'description' => 'Which all events do you want to display in this widget?',
// 										'multiOptions' => array(
// 												'2' => 'Only Upcoming Events',
// 												'1' => 'Only Past Events',
// 												'0' => 'Both Upcoming and Past Events',
// 										),
// 										'value' => 2,
// 								)
// 						),
// 					),
//         )
    ),
    array(
			'title' => 'Search Business Events Location Form',
			'description' => 'Displays the form for searching Business Events corresponding to location on the basis of various filters.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessevent.location-search',
			'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
			),
    ),
)
?>