<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if ( !empty($sitebusiness_settings) ) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    }
    else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if ( !empty($check_sitebusiness) && !empty($sitebusiness_is_active) ) {
      $PRODUCT_TYPE = 'sitebusinessevent';
      $PLUGIN_TITLE = 'Sitebusinessevent';
      $PLUGIN_VERSION = '5.5.0';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessevent Plugin';
      $PRODUCT_TITLE = 'Directory / Businesses - Events Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.6';
      $SocialEngineAddOns_version = '4.10.3p6';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if ( empty($is_file) ) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      }
      else {
        include $file_path;
      }


      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessevent.basetime', $businessTime ),
			('sitebusinessevent.isvar', 0 ),
			('sitebusinessevent.filepath', 'Sitebusinessevent/controllers/license/license2.php');");      
      parent::onPreInstall();
    }
    elseif ( !empty($check_sitebusiness) && empty($sitebusiness_is_active) ) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if ( strstr($url_string, "manage/install") ) {
        $calling_from = 'install';
      }
      else if ( strstr($url_string, "manage/query") ) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ( $explode_base_url as $url_key ) {
        if ( $url_key != 'install' ) {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Events Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    }
    else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-events' target='_blank'>Directory / Businesses - Events Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onInstall() {
  
    $db = $this->getDb();
    
    $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a business event {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitebusinessevent_create";');
    
    $seao_locationid = $db->query("SHOW COLUMNS FROM engine4_sitebusinessevent_events LIKE 'seao_locationid'")->fetch();
		if (empty($seao_locationid)) {
			$db->query("ALTER TABLE `engine4_sitebusinessevent_events` ADD `seao_locationid` INT( 11 ) NOT NULL ");
		}
		
		//START THE WORK FOR MAKE WIDGETIZE BUSINESS OF Locatio or map.
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_pages')
						->where('name = ?', 'sitebusinessevent_index_by-locations')
						->limit(1);
		$info = $select->query()->fetch();

		if ( empty($info) ) {
			$db->insert('engine4_core_pages', array(
					'name' => 'sitebusinessevent_index_by-locations',
					'displayname' => 'Browse Business Events’ Locations',
					'title' => 'Browse Business Events’ Locations',
					'description' => 'Browse Business Events’ Locations',
					'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');
			
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'top',
					'parent_content_id' => null,
					'order' => 1,
					'params' => '',
			));
			$top_id = $db->lastInsertId('engine4_core_content');
			
			//CONTAINERS
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'main',
					'parent_content_id' => Null,
					'order' => 2,
					'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');
			
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $top_id,
					'params' => '',
			));
			$top_middle_id = $db->lastInsertId('engine4_core_content');
			
			//INSERT MAIN - MIDDLE CONTAINER
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $container_id,
					'order' => 2,
					'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusiness.browsenevigation-sitebusiness',
					'parent_content_id' => $top_middle_id,
					'order' => 1,
					'params' => '',
			));
			
			//INSERT WIDGET OF LOCATION SEARCH AND CORE CONTENT
			$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessevent.location-search',
				'parent_content_id' => $middle_id,
				'order' => 2,
				'params' => '',
				));

			$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessevent.bylocation-event',
				'parent_content_id' => $middle_id,
				'order' => 3,
				'params' => '{"title":"","titleCount":true,"order_by":"2","nomobile":"0"}',
			));
		}
		//END THE WORK FOR MAKE WIDGETIZE BUSINESS OF LOCATIO OR MAP.
	
		//START THE WORK FOR MAKE WIDGETIZE BUSINESS OF Locatio or map.
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_pages')
						->where('name = ?', 'sitebusinessevent_index_mobileby-locations')
						->limit(1);
		$info = $select->query()->fetch();

		if ( empty($info) ) {
			$db->insert('engine4_core_pages', array(
					'name' => 'sitebusinessevent_index_mobileby-locations',
					'displayname' => 'Mobile Business Browse Events’ Locations',
					'title' => 'Mobile Business Browse Events’ Locations',
					'description' => 'Mobile Business Browse Events’ Locations',
					'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');
			
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'top',
					'parent_content_id' => null,
					'order' => 1,
					'params' => '',
			));
			$top_id = $db->lastInsertId('engine4_core_content');
			
			//CONTAINERS
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'main',
					'parent_content_id' => Null,
					'order' => 2,
					'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');
			
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $top_id,
					'params' => '',
			));
			$top_middle_id = $db->lastInsertId('engine4_core_content');
			
			//INSERT MAIN - MIDDLE CONTAINER
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'container',
					'name' => 'middle',
					'parent_content_id' => $container_id,
					'order' => 2,
					'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusiness.browsenevigation-sitebusiness',
					'parent_content_id' => $top_middle_id,
					'order' => 1,
					'params' => '',
			));
			
			//INSERT WIDGET OF LOCATION SEARCH AND CORE CONTENT
			$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessevent.location-search',
				'parent_content_id' => $middle_id,
				'order' => 2,
				'params' => '',
				));

			$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessevent.bylocation-event',
				'parent_content_id' => $middle_id,
				'order' => 3,
				'params' => '{"title":"","titleCount":true,"order_by":"2","nomobile":"0"}',
			));
	  }
	  //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF LOCATIO OR MAP.

    // START WORK FOR SINK LOCATION WITH NEW LOCATION TABLE.
    $table_exist = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessevent_events\'')->fetch();
    if (!empty($table_exist)) {
			$select = new Zend_Db_Select($db);
			$select
					->from('engine4_sitebusinessevent_events', array('event_id', 'seao_locationid', 'location'))
					->where('location <> ?', '')
					->where('seao_locationid <> ?', 0);
			$result = $select->query()->fetchAll();

			foreach ($result as $results) {

				$select = new Zend_Db_Select($db);
				$select
						->from('engine4_seaocore_locations')
						->where('location_id = ?', $results['seao_locationid']);
				$resultlocations = $select->query()->fetchAll();
				
				foreach($resultlocations as $resultlocation) {
					$resultlocation['location'] = str_replace("'", "\'", $resultlocation['location']);
					$resultlocation['formatted_address'] = str_replace("'", "\'", $resultlocation['formatted_address']);
					$resultlocation['country'] = str_replace("'", "\'", $resultlocation['country']);
					$resultlocation['state'] = str_replace("'", "\'", $resultlocation['state']);
					$resultlocation['city'] = str_replace("'", "\'", $resultlocation['city']);
					$resultlocation['address'] = str_replace("'", "\'", $resultlocation['address']);
					$db->query("INSERT IGNORE INTO `engine4_seaocore_locationitems` (`resource_type`, `resource_id`, `location`, `latitude`, `longitude`, `formatted_address`, `country`, `state`, `zipcode`, `city`, `address`, `zoom`) VALUES ('sitebusinessevent_event', '" . $results['event_id']. "', '" . $resultlocation['location']. "', '" . $resultlocation['latitude']. "', '" . $resultlocation['longitude']. "', '" . $resultlocation['formatted_address']. "', '" . $resultlocation['country']. "', '" . $resultlocation['state']. "', '" . $resultlocation['zipcode']. "', '" . $resultlocation['city']. "', '" . $resultlocation['address']. "', '" . $resultlocation['zoom']. "')");

					$select = new Zend_Db_Select($db);
					$select
						->from('engine4_seaocore_locationitems', array('locationitem_id'))
						->where('resource_type = ?', 'sitebusinessevent_event')
						->where('resource_id = ?', $results['event_id']); 
					$info = $select->query()->fetch();
					
					$db->query("UPDATE `engine4_sitebusinessevent_events` SET `seao_locationid` = '" .$info['locationitem_id']. "' WHERE `engine4_sitebusinessevent_events`.`event_id` = '" .$results['event_id']. "';");
				}
			}
		}
		// END WORK FOR SINK LOCATION WITH NEW LOCATION TABLE.
  
  
		//START THE WORK FOR MAKE WIDGETIZE BUSINESS OF EVENTS LISTING
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessevent')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'communityad')
							->where('enabled 	 = ?', 1)
							->limit(1);
				;
			$infomation = $select->query()->fetch();
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_settings')
							->where('name = ?', 'sitebusiness.communityads')
							->where('value 	 = ?', 1)
							->limit(1);
			$rowinfo = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessevent_index_browse')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessevent_index_browse',
						'displayname' => 'Browse Business Events',
						'title' => 'Business Events',
						'description' => 'This is the business events.',
						'custom' => 1,
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.search-sitebusinessevent',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.sitebusiness-event',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"","titleCount":""}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.sitebusiness-sponsoredevent',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Sponsored Events","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.upcoming-sitebusinessevent',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Upcoming Events","titleCount":"true"}',
				));

				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 6,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
    }
    
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessevent')
						->where('version < ?', '4.2.1');
		$is_enabled = $select->query()->fetchObject();
    if($is_enabled) {
			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessevent_admin_main_event_tab", "sitebusinessevent", "Tabbed Events Widget", "", \'{"route":"admin_default","module":"sitebusinessevent","controller":"settings", "action": "widget"}\', "sitebusinessevent_admin_main", "", 1, 0, 3)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessevent_admin_main_dayitems", "sitebusinessevent", "Event of the Day", "", \'{"route":"admin_default","module":"sitebusinessevent","controller":"settings", "action": "manage-day-items"}\', "sitebusinessevent_admin_main", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessevent_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessevent_index_home',
						'displayname' => 'Business Events Home',
						'title' => 'Business Events Home',
						'description' => 'This is business event home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
			
				//INSERT MOST VIEWED BUSINESS EVENT WIDGET
        // Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.homeview-sitebusinessevents',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Most Viewed Events","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.featured-events-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 16,
						'params' => '{"title":"Featured Upcoming Events","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.list-events-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 18,
						'params' => '{"title":"Events","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.sitebusinesseventlist-link',
						'parent_content_id' => $right_id,
						'order' => 20,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.search-sitebusinessevent',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.event-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Event of the Day"}',
				));

        $db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessevent.upcoming-sitebusinessevent',
					'parent_content_id' => $left_id,
					'order' => 15,
					'params' => '{"title":"Upcoming Events","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessevent.homefeaturelist-sitebusinessevents',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Events","itemCountPerBusiness":3}',
				));
			}
      $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessevent_events LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessevent_events` ADD `featured` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `photo_id`");
			}
      $showColumn = $db->query("SHOW COLUMNS FROM engine4_seaocore_tabs LIKE 'show'")->fetch();
			if (empty($showColumn)) {
				$db->query("ALTER TABLE `engine4_seaocore_tabs` ADD `show` TINYINT( 1 ) NOT NULL DEFAULT '1' AFTER `limit`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Events'), array('displayname = ?' => 'Business Events')); 
    }

    //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF EVNETS LISTING
    $select = new Zend_Db_Select($db);
    $select
          ->from('engine4_core_settings')
          ->where('name = ?', 'sitebusiness.feed.type');
  $info = $select->query()->fetch();
    $enable = 1;
    if (!empty($info))
      $enable = $info['value'];
    $db->query('INSERT IGNORE INTO   `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitebusinessevent_admin_new", "sitebusinessevent", "{item:$object} created a new event:", '.$enable.', 6, 2, 1, 1, 1, 1)');
     $this->_addEventProfileContentPhotoAndDiscussions();

		$categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessevent_events LIKE 'category_id'")->fetch();
		if (empty($categoryIdColumn)) {
			$db->query("ALTER TABLE `engine4_sitebusinessevent_events` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
		}
		
		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
				include APPLICATION_PATH . "/application/modules/Sitebusinessevent/controllers/license/mobileLayoutCreation.php";
		}
    
    $eventTable = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessevent_events\'')->fetch();
    if(!empty($eventTable)) {
        
        $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessevent_events LIKE 'featured'")->fetch();
        if(!empty($featuredColumn)) {
            $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessevent_events` WHERE Key_name = 'featured'")->fetch();   
            if(empty($featuredIndex)) {
              $db->query("ALTER TABLE `engine4_sitebusinessevent_events` ADD INDEX ( `featured` )");
            }
        }
 
        $categoryColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessevent_events LIKE 'category_id'")->fetch();
        if(!empty($categoryColumn)) {
            $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessevent_events` WHERE Key_name = 'category_id'")->fetch();     
            if(empty($categoryIdIndex)) {
              $db->query("ALTER TABLE `engine4_sitebusinessevent_events` ADD INDEX ( `category_id` )");
            }      
        }
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }

  protected function _addEventProfileContentPhotoAndDiscussions() {
//
// install content areas
//
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);

// profile page
    $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'sitebusinessevent_index_view')
            ->limit(1);
    if(!empty($select->query()->fetchObject())){
    	$business_id = $select->query()->fetchObject()->page_id;
    }

    if (empty($business_id))
      return;
// classified.profile-classifieds
// Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_content')
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinessevent.profile-photos')
    ;
    $info = $select->query()->fetch();
    if (empty($info)) {

// container_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_content')
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container_id = $select->query()->fetchObject()->content_id;

// middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_content')
              ->where('parent_content_id = ?', $container_id)
              ->where('type = ?', 'container')
              ->where('name = ?', 'middle')
              ->limit(1);
      $middle_id = $select->query()->fetchObject()->content_id;

// tab_id (tab container) may not always be there
      $select
              ->reset('where')
              ->where('type = ?', 'widget')
              ->where('name = ?', 'core.container-tabs')
              ->where('page_id = ?', $business_id)
              ->limit(1);
      $tab_id = $select->query()->fetchObject();
      if ($tab_id && @$tab_id->content_id) {
        $tab_id = $tab_id->content_id;
      } else {
        $tab_id = null;
      }

// tab on profile
      $db->insert('engine4_core_content', array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusinessevent.profile-photos',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 5,
          'params' => '{"title":"Photos","titleCount":true}',
      ));
      $db->insert('engine4_core_content', array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusiness.profile-discussions',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 9,
          'params' => '{"title":"Discussions","titleCount":true}',
      ));
    }
  }

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessevent','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessevent')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessevent/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }
  
  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessevent_event", "sitebusinessevent", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business event {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessevent_photo", "sitebusinessevent", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business event photo {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
}
