<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "businessevents";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessevent.manifestUrl', "business-events");
}
return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitebusinessevent',
        'version' => '5.5.0',
        'path' => 'application/modules/Sitebusinessevent',
        'title' => 'Directory / Businesses - Events Extension',
        'description' => 'Directory / Businesses - Events Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'callback' =>
        array(
            'path' => 'application/modules/Sitebusinessevent/settings/install.php',
            'class' => 'Sitebusinessevent_Installer',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitebusinessevent',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitebusinessevent.csv',
        ),
    ),
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitebusinessevent_Plugin_Core',
        ),
        array(
            'event' => 'addActivity',
            'resource' => 'Sitebusinessevent_Plugin_Core',
        ),
        array(
            'event' => 'onSitebusinesseventEventCreateAfter',
            'resource' => 'Sitebusinessevent_Plugin_Core',
        ),
        array(
            'event' => 'onSitebusinesseventEventUpdateAfter',
            'resource' => 'Sitebusinessevent_Plugin_Core',
        )
    ),
    // ITEMS --------------------------------------------------------------------
    'items' => array(
        'sitebusinessevent_event',
        'sitebusinessevent_photo',
        'sitebusinessevent_album',
        'sitebusinessevent_category'
    ),
    'sitemobile_compatible' => true,
    // ROUTES --------------------------------------------------------------------
    'routes' => array(
        'sitebusinessevent_detail_view' => array(
            'route' => $routeStart . '/:user_id/:event_id/:slug/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'event_id' => '\d+'
            )
        ),
        'sitebusinessevent_create' => array(
            'route' => $routeStart . '/create/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'business_id' => '\d+'
            )
        ),
        'sitebusinessevent_delete' => array(
            'route' => $routeStart . '/admin-manage/delete/:event_id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'admin-manage',
                'action' => 'delete'
            ),
            'reqs' => array(
                'event_id' => '\d+'
            )
        ),
        'sitebusinessevent_specific' => array(
            'route' => $routeStart . '/:action/:event_id/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'edit'
            ),
            'reqs' => array(
                'event_id' => '\d+',
                'action' => '(edit|invite|delete|join|leave|request|edit-location|edit-address|invite-members)',
            ),
        ),
        'sitebusinessevent_extended' => array(
            'route' => $routeStart . '/:action/:event_id/:business_id/:user_id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'edit'
            ),
            'reqs' => array(
                'event_id' => '\d+',
                'action' => '(reject|remove|approve|cancel|accept)',
            ),
        ),
        'sitebusinessevent_photo_extended' => array(
            'route' => $routeStart . '/photos/:action/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'photo',
                'action' => 'list'
            ),
            'reqs' => array(
                'action' => '(upload|list|view|edit-photo|photo-edit|remove|upload-sitemobile-photo)',
            ),
        ),
        'sitebusinessevent_browse' => array(
            'route' => $routeStart . '/browse/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),
        'sitebusinessevent_featured' => array(
            'route' => $routeStart . '/featured/:event_id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'featured'
            ),
            'reqs' => array(
                'event_id' => '\d+'
            )
        ),
        'sitebusinessevent_featuredevent' => array(
            'route' => $routeStart . '/admin/featuredevent/:id/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'admin-manage',
                'action' => 'featuredevent',
            ),
            'reqs' => array(
                'id' => '\d+'
            )
        ),
        'sitebusinessevent_home' => array(
            'route' => $routeStart . '/home/*',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'home',
            ),
        ),
        'sitebusinessevent_bylocation' => array(
            'route' => $routeStart . '/by-locations',
            'defaults' => array(
                'module' => 'sitebusinessevent',
                'controller' => 'index',
                'action' => 'by-locations',
            ),
        ),
    ),
);
?>