<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Widget_ProfileMembersController extends Seaocore_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING THE TABS OF THE UPDATES FEED AND JOINED MEMBER OF THE EVENT
  public function indexAction() {
  	
    // JUST REMOVE THE TITLE DECORATOR
    //$this->getElement()->removeDecorator('Title');

    //DON'T RENDER IF THERE IS NO SUBJECT
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    // GET SITEBUSINESS EVENT SUBJECT
    $this->view->sitebusinessevent_subject = $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject();
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent_subject->business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END     
     
    //START MANAGE-ADMIN CHECK    
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //GET PARAMS
    $this->view->business = $business = $this->_getParam('business', 1);
    $this->view->search = $search = $this->_getParam('search');
    $this->view->waiting = $waiting = $this->_getParam('waiting');

    //GET MEMBERS
    $members = null;
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity() && $sitebusinessevent_subject->isOwner($viewer)) {
      $this->view->waitingMembers = Zend_Paginator::factory($sitebusinessevent_subject->membership()->getMembersSelect(false));
      if ($waiting) {
        $this->view->members = $members = $this->view->waitingMembers;
      }
    }

    if (!$members) {
      $select = $sitebusinessevent_subject->membership()->getMembersObjectSelect();
      if ($search) {
        $select->where('displayname LIKE ?', '%' . $search . '%');
      }
      $this->view->members = $members = Zend_Paginator::factory($select);
    }

    $paginator = $members;
    $members->setCurrentPageNumber($business);

    //DO NOT RENDER IF NOTHING TO SHOW
    if ($paginator->getTotalItemCount() <= 0 && '' == $search) {
      return $this->setNoRender();
    }

    //ADD COUNT TO TITLE IF CONFIGURED
    if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  //RETURN THE COUNT OF THE EVENT
  public function getChildCount() {
    return $this->_childCount;
  }

}

?>