<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Widget_ProfileRsvpController extends Seaocore_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE EVENT RSVP ON EVENT VIEW BUSINESS
  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GETTING LOGGED IN USER INFO
    $this->view->viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

    //GET SUBJECT OF SITEBUSINESSEVENT
    $sitebusinessevent_subject = Engine_Api::_()->core()->getSubject('sitebusinessevent_event');

    //GET ITEM OF SITEBUSINESS
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $sitebusinessevent_subject->business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessevent")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
        
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

    //GETTING ROWS
    $row = $sitebusinessevent_subject->membership()->getRow(Engine_Api::_()->user()->getViewer());
    if (!$row) {
      return $this->setNoRender();
    }
    $this->view->rsvp = $row->rsvp;
  }

}

?>