 <?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessevent_Widget_ProfileSitebusinesseventsController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING THE EVENTS ON BUSINESS PROFILE BUSINESS
  public function indexAction() {

    // SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }
    
    // GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    
    //GET SUBJECT
    $this->view->sitebusiness_subject = $sitebusiness_subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $business_id = $sitebusiness_subject->business_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness_subject->package_id, "modules", "sitebusinessevent")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness_subject, 'secreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //TOTAL EVENT
    $this->view->eventCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessevent', 'events');     
    $eventCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'secreate');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
    
    if (empty($eventCreate) && empty($this->view->eventCount) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    } 
    //END MANAGE-ADMIN CHECK
    
    //GET VIEWER INFORMATION
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    $get_event = Engine_Api::_()->getItemTable('sitebusinessevent_event')->getEventUserType();
    if (empty($get_event)) {
      return $this->setNoRender();
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = true;
    }    

    //GET LAYOUT
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);

    //GET THE THIRD TYPE LAYOUT
    $this->view->widgets = $widgets = Engine_Api::_()->sitebusiness()->getwidget($layout, $business_id);

    //GET THE CURRENT TAB ID
    $this->view->content_id = Engine_Api::_()->sitebusiness()->GetTabIdinfo('sitebusinessevent.profile-sitebusinessevents', $business_id, $layout);
    $sitebusinessevent_profileBusinessType = Zend_Registry::isRegistered('sitebusinessevent_profileBusinessType') ? Zend_Registry::get('sitebusinessevent_profileBusinessType') : null;
    if (empty($sitebusinessevent_profileBusinessType)) {
      return $this->setNoRender();
    }

    //WHICH LINK HAS BEEN CLICKED
    $this->view->clicked = $clicked = $this->_getParam('clicked_event', 'upcomingevent');

    //REQUEST TYPE IS AJAX OR NOT
    $this->view->isajax = $isajax = $this->_getParam('isajax', null);

    //GET THE TAB ID
    $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $this->view->getIsEvent = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinessevent');

    //SHOWING THE TOP TITLE IN CASE OF NON TABBED LAYOUT
    $this->view->showtoptitle = $showtoptitle = Engine_Api::_()->sitebusiness()->showtoptitle($layout, $business_id);

    //SHOWING THE EVENTS
    if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {
      //GET THE TAB ID
      $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);
      $this->view->show_content = true;

      //GET SEARCHING PARAMETERS
      $this->view->business = $business = $this->_getParam('business', 1);
      $this->view->search = $search = $this->_getParam('search');
      $this->view->selectbox = $selectbox = $this->_getParam('selectbox');
      $this->view->checkbox = $checkbox = $this->_getParam('checkbox');

      //MAKING THE SEACHING PARAMATER ARRAY
      $values = array();
      if (!empty($search)) {
        $values['search'] = $search;
      }

      if ($clicked == 'upcomingevent') {
        if ($selectbox == 'allmyevent' || $selectbox == 'eventilead') {
          if (empty($values['orderby'])) {
            $values['orderby'] = 'starttime';
            $selectbox = 'starttime';
          } else {
            $values['orderby'] = $selectbox;
          }
        }
        $values['orderby'] = $selectbox;
        $values['clicked'] = $clicked;
        $params['selectedbox'] = '';
      } else if ($clicked == 'pastevent') {
        $values['clicked'] = $clicked;
        $values['orderby'] = 'endtime';
        $params['selectedbox'] = '';
      } else if ($clicked == 'myevent') {
        $values['selectedbox'] = 'allmyevent';
        if ($selectbox == 'allmyevent') {
          $values['selectedbox'] = $selectbox;
        } elseif ($selectbox == 'eventilead') {
          $values['selectedbox'] = $selectbox;
          $values['user_id'] = $viewer_id;
        }
      }

      if (empty($selectbox)) {
        $values['orderby'] = 'starttime';
      }

      //START MANAGE-ADMIN CHECK
      $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'secreate');
      if (empty($isManageAdmin) && empty($can_edit)) {
        $this->view->can_create = 0;
      } else {
        $this->view->can_create = 1;
      }
      //END MANAGE-ADMIN CHECK

      $values['business_id'] = $business_id;
      if ($can_edit) {
        $values['show_event'] = 0;
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getSitebusinesseventsPaginator($values);
      } else {
        $values['show_event'] = 1;
        $values['event_owner_id'] = $viewer_id;
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getSitebusinesseventsPaginator($values);
      }

      //EVENTS PER BUSINESS
      $paginator->setItemCountPerPage(10);
      $this->view->paginator->setCurrentPageNumber($business);

      //ADD COUNT TO TITLE IF CONFIGURED
      if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
        $this->_childCount = $paginator->getTotalItemCount();
      }

      // MAKE PAGINATOR
      $currentBusinessNumber = $this->_getParam('business', 1);
      $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getSitebusinesseventsPaginator($values);

      $this->view->myeventmessage = 0;
      $this->view->pastmessage = 0;
      $this->view->upcomingmessage = 0;
      
      if ($paginator->getTotalItemCount() == 0) {
        if ($clicked == 'myevent' && empty($search)) {
          $this->view->selectbox = '';
          $this->view->myeventmessage = 1;
        } elseif ($clicked == 'pastevent' && empty($search)) {
          $this->view->selectbox = '';
          $this->view->pastmessage = 1;
        } elseif ($clicked == 'upcomingevent' && empty($search)) {
          $this->view->selectbox = '';
          $this->view->upcomingmessage = 1;
        }
      }
      $paginator->setItemCountPerPage(10)->setCurrentPageNumber($currentBusinessNumber);
    } else {
      $this->view->show_content = false;
      $title_count = $this->_getParam('titleCount', false);
      $this->view->identity_temp = $this->view->identity;

      $values = array();
      $values['orderby'] = 'starttime';
      $values['business_id'] = $business_id;
      $values['show_count'] = 1;
      if ($can_edit) {
        $values['show_event'] = 0;
        $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getSitebusinesseventsPaginator($values);
      } else {
        $values['show_event'] = 1;
        $values['event_owner_id'] = $viewer_id;
        $paginator = Engine_Api::_()->getDbTable('events', 'sitebusinessevent')->getSitebusinesseventsPaginator($values);
      }
    }
    $this->_childCount = $paginator->getTotalItemCount();
  }

  public function getChildCount() {
  	
    return $this->_childCount;
  }

}

?>