<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitebusinessevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK
//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();	

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
	$select
  ->from('engine4_core_settings')
  ->where('name = ?', 'sitebusiness.is.active')
	->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if(!empty($sitebusiness_settings)) {
	$sitebusiness_is_active = $sitebusiness_settings[0]['value'];
}
else {
	$sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
	$select
	  ->from('engine4_core_modules')
  ->where('name = ?', 'sitebusiness')
	->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if(!empty($check_sitebusiness)  && !empty($sitebusiness_is_active)) {
	$select = new Zend_Db_Select($db);
	$select_business = $select
										 ->from('engine4_core_pages', 'page_id')
										 ->where('name = ?', 'sitebusiness_index_view')
										 ->limit(1);
  $business = $select_business->query()->fetchAll();
	if(!empty($business)) {
		$business_id = $business[0]['page_id'];
		
		//INSERTING THE FORM WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO.
		Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'true', '114');			
	 
		//INSERTING THE FORM WIDGET IN CORE_CONTENT TABLE ALSO.
		Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusinessform.sitebusiness-viewform', $business_id, 'Form', 'true', '114');
		
    //INSERTING THE FORM WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);								
		$contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
			if(!empty($contentbusiness_id)) {
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusinessform.sitebusiness-viewform', $contentbusiness_id['contentbusiness_id'], 'Form', 'true', '114');
			}
		}
	}	
	
	$select = new Zend_Db_Select($db);
	$select 
					->from('engine4_core_menuitems')
					->where('name = ?', 'sitebusinessform_admin_main_fields');
	$queary_info = $select->query()->fetchAll();
	if (empty($queary_info)) {
		$db->insert('engine4_core_menuitems', array(
				'name' => 'sitebusinessform_admin_main_fields',
				'module' => 'sitebusinessform',
				'label' => 'Form Questions',
				'plugin' => '',
				'params' => '{"route":"admin_default","module":"sitebusinessform","controller":"fields","action":"index"}',
				'menu' => 'sitebusinessform_admin_main',
				'submenu' => '',
				'order' => 3,
		));
	}
}  
	  
$select = new Zend_Db_Select($db);
$content = $select->from('engine4_sitebusinessform_businessquetions')->query()->fetchAll();		
if(empty($content)) {
	$select = new Zend_Db_Select($db);
	$sitebusiness_result = $select->from('engine4_sitebusiness_businesses')->query()->fetchAll();
	if(!empty($sitebusiness_result)) {
		foreach ($sitebusiness_result as $key => $value) {
			$business_id = $value['business_id'];
			$values = $value ['title'];
			$db->insert('engine4_sitebusinessform_fields_options', array(
										'field_id' => 1,
										'label' => $values,
			));
		$option_id =  $db->lastInsertId('engine4_sitebusinessform_fields_options');
		$select = new Zend_Db_Select($db);
		$select_content = $select
														->from('engine4_sitebusinessform_businessquetions')
														->where('business_id = ?', $business_id)
														->where('option_id = ?', $option_id)
														->limit(1);
		$content = $select_content->query()->fetchAll();
		if( empty($content) ) {
				$db->insert('engine4_sitebusinessform_businessquetions', array(
					'business_id' => $business_id,
					'option_id' => $option_id,
				));
			}

		$db->insert('engine4_sitebusinessform_sitebusinessforms', array(
										'business_id' => $business_id,
										));
		}
	}
}
//CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
$type_array = $db->query('SHOW COLUMNS FROM engine4_authorization_permissions LIKE \'type\'')->fetch();
if(!empty($type_array)) {
	$varchar = $type_array['Type'];
	$length_varchar = explode('(', $varchar);
	$length = explode(')', $length_varchar[1]);
	$length_type = $length[0];
	if($length_type < 32) 	{
		$run_query  = $db->query('ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL');
	}	
}

?>