<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessintegration_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */
        if (!empty($method) && $method == 'Sitebusinessintegration_Form_Admin_Global') {

        }
        return true;
    }
    
  public function indexAction() {
  
		$apiSettings = Engine_Api::_()->getApi('settings', 'core');
		$groupSettings = $apiSettings->getSetting('sitebusiness.group.integration', 0);
		$documentSettings = $apiSettings->getSetting('sitebusiness.document.integration', 0);
		$storeproductSettings = $apiSettings->getSetting('sitebusiness.storeproduct.integration', 0);
		
		//START GROUP / COMMUNITIES PLUGIN INTEGRATION.
		if(isset($_POST['sitebusiness_group_integration']) && $_POST['sitebusiness_group_integration'] != $groupSettings) {
			$this->pluginIntegration('sitebusiness_group_integration', 'Groups', 'sitegroup_group_0', 'sitegroup', 'group_id');
		}
		//END GROUP / COMMUNITIES PLUGIN INTEGRATION.

	  //START DOCUMENT PLUGIN INTEGRATION.
	  if(isset($_POST['sitebusiness_document_integration']) && $_POST['sitebusiness_document_integration'] != $documentSettings) {
			$this->pluginIntegration('sitebusiness_document_integration', 'Documents', 'document_0', 'document', 'document_id');
	  }
	  //START DOCUMENT PLUGIN INTEGRATION.
          
          //START PAGES PLUGIN INTEGRATION.
          if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage')) {
            $this->pluginIntegration('sitebusiness_page_integration', 'Pages', 'sitepage_page_0', 'sitepage', 'page_id');
          }
        //END PAGES PLUGIN INTEGRATION.
	  
	  //START STORE PRODUCTS PLUGIN WORK
	  if(isset($_POST['sitebusiness_storeproduct_integration']) && $_POST['sitebusiness_storeproduct_integration'] != $storeproductSettings) {
			$this->pluginIntegration('sitebusiness_storeproduct_integration', 'Products', 'sitestoreproduct_product_0', 'sitestoreproduct', 'product_id');
	  }
    
    $pluginName = 'sitebusinessintegration';
    if (!empty($_POST[$pluginName . '_lsettings']))
      $_POST[$pluginName . '_lsettings'] = @trim($_POST[$pluginName . '_lsettings']);
    
		//END STORE PRODUCTS PLUGIN WORK	
    $reload_count = 0;
    $business_reload = 1;
    include_once APPLICATION_PATH . '/application/modules/Sitebusinessintegration/controllers/license/license1.php';
  }

  public function faqAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitebusinessintegration_admin_main', array(), 'sitebusinessintegration_admin_main_faq');
  }

  public function setDefaultData($businessTable, $businessTableName, $coreContentTable, $coreContentTableName, $businessId, $content_id, $forBusiness=null, $module, $params, $business_id = null, $resourceType = null) {
    $db = Engine_Db_Table::getDefaultAdapter();

    $select = $businessTable->select()
            ->from($businessTableName, array($businessId))
            ->where('name = ?', 'sitebusiness_index_view');

    if (!empty($forBusiness)) {
      $select->where("$businessId = ?", $forBusiness);
    } /*else if(!empty($forBusiness) && !empty($business_id)) {
       $select->where("$business_id = ?", $forBusiness);
    }*/

    $getBusinessId = $select->query()->fetchColumn();

    // @Make an condition
    if (!empty($getBusinessId)) {
      $getContainerId = $coreContentTable->select()
              ->from($coreContentTableName, array($content_id))
              ->where('type = ?', 'container')
              ->where("$business_id = ?", $getBusinessId)
              ->where('name = ?', 'main')
              ->query()
              ->fetchColumn();
      if (!empty($getContainerId)) {
        $getMiddleContentId = $coreContentTable->select()
                ->from($coreContentTableName, array($content_id))
                ->where('type = ?', 'container')
                ->where("parent_content_id = ?", $getContainerId)
                ->where('name = ?', 'middle')
                ->query()
                ->fetchColumn();

        if (!empty($getMiddleContentId)) {
          $getCoreContainerContentId = $coreContentTable->select()
                  ->from($coreContentTableName, array($content_id))
                  ->where('type = ?', 'widget')
                  ->where("$business_id = ?", $getBusinessId)
                  ->where('name = ?', 'core.container-tabs')
                  ->query()
                  ->fetchColumn();
          $select = new Zend_Db_Select($db);
          $select
                  ->from('engine4_core_modules')
                  ->where('name = ?', $module);
          $check_list = $select->query()->fetchObject();

          if (!empty($check_list)) {
            if (!empty($getCoreContainerContentId)) {
              $contentBusinessId = $coreContentTable->select()
                      ->from($coreContentTableName, array($content_id))
                      ->where('parent_content_id = ?', $getCoreContainerContentId)
                      ->where('name = ?', 'sitebusinessintegration.profile-items')
                      ->where('type = ?', 'widget')
                      ->where('params LIKE ?', '%' . $params . '%')
                      ->query()
                      ->fetchColumn();

              if (empty($contentBusinessId)) {
                //INSERT MAIN-MIDDLE CONTAINER
                $insertMainItem = $coreContentTable->createRow();
                $insertMainItem->$business_id = $getBusinessId;
                $insertMainItem->type = 'widget';
                $insertMainItem->name = 'sitebusinessintegration.profile-items';
                $insertMainItem->parent_content_id = $getCoreContainerContentId;
                $insertMainItem->order = 999;
                $insertMainItem->params = $params;
                $insertMainItem->save();
              }
            } else {
              $contentBusinessId = $coreContentTable->select()
                      ->from($coreContentTableName, array($content_id))
                      ->where('parent_content_id = ?', $getMiddleContentId)
                      ->where('name = ?', 'sitebusinessintegration.profile-items')
                      ->where('type = ?', 'widget')
                      ->where('params LIKE ?', '%' . $params . '%')
                      ->query()
                      ->fetchColumn();

              if (empty($contentBusinessId)) {
                //INSERT MAIN-MIDDLE CONTAINER
                $insertMainItem = $coreContentTable->createRow();
                $insertMainItem->$business_id = $getBusinessId;
                $insertMainItem->type = 'widget';
                $insertMainItem->name = 'sitebusinessintegration.profile-items';
                $insertMainItem->parent_content_id = $getMiddleContentId;
                $insertMainItem->order = 999;
                $insertMainItem->params = $params;
                $insertMainItem->save();
              }
            }
          }
        }
      }
    }
  }

  public function readmeAction() {
    
  }
  
  public function pluginIntegration($globalFormValue, $titleName, $resourceType, $moduleName, $resource_id) {

		$coreTable = Engine_Api::_()->getDbtable('pages', 'core');
		$coreTableName = $coreTable->info('name');
		$coreContentTable = Engine_Api::_()->getDbtable('content', 'core');
		$coreContentTableName = $coreContentTable->info('name');
		$adminContentTable = Engine_Api::_()->getDbtable('admincontent', 'sitebusiness');
		$adminContentTableName = $adminContentTable->info('name');
		$contentBusinessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
		$contentBusinessTableName = $contentBusinessTable->info('name');
		$contentSitebusinessTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
		$contentSitebusinessTableName = $contentSitebusinessTable->info('name');
		$db = Engine_Db_Table::getDefaultAdapter();
  
  
		if (isset($_POST["$globalFormValue"]) && $_POST["$globalFormValue"] == '0') {
			$db->query("UPDATE `engine4_sitebusinessintegration_mixsettings` SET `enabled` = '0' WHERE `engine4_sitebusinessintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
		} else {

			$this->setDefaultData($coreTable, $coreTableName, $coreContentTable, $coreContentTableName, 'page_id', 'content_id', null, "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitebusinessintegration.profile-items"}', 'page_id');

			$this->setDefaultData($coreTable, $coreTableName, $adminContentTable, $adminContentTableName, 'page_id', 'admincontent_id', null, "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitebusinessintegration.profile-items"}', 'business_id');

			$totalBusinesses = $contentBusinessTable->select()
											->from($contentBusinessTableName, array('count(*) as count'))
											->where('name =?', 'sitebusiness_index_view')->query()->fetchColumn();

			$limit = 1000;
			$reload_count = round($totalBusinesses / $limit);
			$business_reload = $this->_getParam('business_reload', 1);
			$offset = ($business_reload - 1) * $limit;

			//business profile business
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitebusiness_contentbusinesses', array('business_id'))
							->where('name = ?', 'sitebusiness_index_view')
							->limit($limit, $offset);
			$results = $select->query()->fetchAll();

			foreach ($results as $result) {
				$this->setDefaultData($contentBusinessTable, $contentBusinessTableName, $contentSitebusinessTable, $contentSitebusinessTableName, 'contentbusiness_id', 'content_id', $result['business_id'], "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitebusinessintegration.profile-items"}', 'contentbusiness_id');
			}
			
      if(Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled($moduleName)) {
				$db->query("INSERT IGNORE INTO `engine4_sitebusinessintegration_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `enabled`) VALUES ('$moduleName', '$resourceType', '$resource_id', '$titleName', 1);");
			}
			
			$db->query("UPDATE `engine4_sitebusinessintegration_mixsettings` SET `enabled` = '1' WHERE `engine4_sitebusinessintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
		}
  }
}