<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesslikebox
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-10-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesslikebox_Api_Core extends Core_Api_Abstract {

	  /**
   * Check for package is enable or not and business admin check.
   *
   * @param object $sitebusiness
   * @param string $module
   * @param string $hasPackageEnable
   * @return bool $canDo
   */
  public function allowModule( $sitebusiness , $module , $hasPackageEnable ) {

    // CHECK FOR PACKAGE IS ENABLE OR NOT.
    if ( $hasPackageEnable ) {
      return (bool) Engine_Api::_()->sitebusiness()->allowPackageContent( $sitebusiness->package_id , 'modules' , $module ) ;
    }
    else {
      $levelModules = array ( "offer" => "sitebusinessoffer" , "form" => "sitebusinessform" , "invite" => "sitebusinessinvite" , "sdcreate" => "sitebusinessdocument" , "sncreate" => "sitebusinessnote" , "splcreate" => "sitebusinesspoll" , "secreate" => "sitebusinessevent" , "svcreate" => "sitebusinessvideo" , "spcreate" => "sitebusinessalbum" , "comment" => "sitebusinessdiscussion" , "smcreate" => "sitebusinessmusic") ;
      $search_Key = array_search( $module , $levelModules ) ;
      return (bool) Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow( $sitebusiness , $search_Key ) ;
    }
  }

	  /**
   * Get the widget name and find the order of profile widget show on the business profile business.
   *
   * @return Array $widgetSettingsArray
   */
  public function getWidgteParams() {

		//GET THE BUSINESS LAYOUT.
    $layout = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitebusiness.layoutcreate' ) ;

		//GET THE BUSINESS LAYOUT TYPE.
    $layoutType = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'sitebusiness.layout.setting' ) ;

    $widgetArray = array ( 'activity.feed' , 'advancedactivity.home-feeds', 'seaocore.feed' , 'sitebusiness.info-sitebusiness' , 'sitebusiness.location-sitebusiness' , 'sitebusiness.discussion-sitebusiness' , 'sitebusiness.photos-sitebusiness' , 'sitebusinessevent.profile-sitebusinessevents' , 'sitebusinesspoll.profile-sitebusinesspolls' , 'sitebusinessnote.profile-sitebusinessnotes' , 'sitebusinessoffer.profile-sitebusinessoffers' , 'sitebusinessvideo.profile-sitebusinessvideos' , 'sitebusinessmusic.profile-sitebusinessmusic' , 'sitebusinessdocument.profile-sitebusinessdocuments' , 'sitebusinessreview.profile-sitebusinessreviews' ) ;

    $widgetSettingsArray = array () ;
   if ( empty( $layout ) ) {
      if ( !empty( $layoutType ) ) {
        $businessesTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $business_id = $businessesTable->select()
                ->from( $businessesTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $business_id ) ) {
          $contentTable = Engine_Api::_()->getDbtable( 'content' , 'core' ) ;
          $allWidget = $contentTable->select()
                  ->from( $contentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $business_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        }
      }
      else {
        $businessesTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $business_id = $businessesTable->select()
                ->from( $businessesTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $business_id ) ) {
          $contentTable = Engine_Api::_()->getDbtable( 'content' , 'core' ) ;
          $allWidget = $contentTable->select()
                  ->from( $contentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $business_id ) ;
          $allWidget = $allWidget->query()->fetchAll() ;

          foreach ( $allWidget as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        }
      }
    }
    else {
      if ( !empty( $layoutType ) ) {
        $contentbusinessesTable = Engine_Api::_()->getDbtable( 'contentbusinesses' , 'sitebusiness' ) ;
        $contentbusiness_id = $contentbusinessesTable->select()
                ->from( $contentbusinessesTable->info( 'name' ) , array ( 'business_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $contentbusiness_id ) ) {
          $sitebusinesscontentTable = Engine_Api::_()->getDbtable( 'content' , 'sitebusiness' ) ;
          $allWidget = $sitebusinesscontentTable->select()
                  ->from( $sitebusinesscontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "contentbusiness_id = ?" , $contentbusiness_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;
        } else {
        $businessesTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $business_id = $businessesTable->select()
                ->from( $businessesTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;
          $sitebusinesscontentTable = Engine_Api::_()->getDbtable( 'admincontent' , 'sitebusiness' ) ;
          $allWidget = $sitebusinesscontentTable->select()
                  ->from( $sitebusinesscontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "business_id = ?" , $business_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ;    
        }
      }
      else {
        $contentbusinessesTable = Engine_Api::_()->getDbtable( 'contentbusinesses' , 'sitebusiness' ) ;
        $business_id = $contentbusinessesTable->select()
                ->from( $contentbusinessesTable->info( 'name' ) , array ( 'business_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;

        if ( !empty( $business_id ) ) {
          $sitebusinesscontentTable = Engine_Api::_()->getDbtable( 'content' , 'sitebusiness' ) ;
          $allWidget = $sitebusinesscontentTable->select()
                  ->from( $sitebusinesscontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "contentbusiness_id = ?" , $business_id ) ;
          $allWidget = $allWidget->query()->fetchAll() ;

          if($allWidget) {
            foreach ( $allWidget as $key => $values ) {
              if ( !in_array( $values['name'] , $widgetArray ) ) {
                continue ;
              }
              $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
              $getTitle = $values['name'] ;
              if ( !empty( $getTitleArray['title'] ) ) {
                $getTitle = $getTitleArray['title'] ;
              }
              $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
              $widgetSettingsArray[$values['order']] = $tempArray ;
            }
            ksort( $widgetSettingsArray ) ;
            return $widgetSettingsArray ;
          } else {
                      $businessesTable = Engine_Api::_()->getDbtable( 'pages' , 'core' ) ;
        $business_id = $businessesTable->select()
                ->from( $businessesTable->info( 'name' ) , array ( 'page_id' ) )
                ->where( "name = ?" , 'sitebusiness_index_view' )
                ->query()->fetchColumn() ;
          $sitebusinesscontentTable = Engine_Api::_()->getDbtable( 'admincontent' , 'sitebusiness' ) ;
          $allWidget = $sitebusinesscontentTable->select()
                  ->from( $sitebusinesscontentTable->info( 'name' ) , array ( 'order' , 'params' , 'name' ) )
                  ->where( "type = ?" , 'widget' )
                  ->where( "page_id = ?" , $business_id ) ;
          $contentTable = $allWidget->query()->fetchAll() ;

          foreach ( $contentTable as $key => $values ) {
            if ( !in_array( $values['name'] , $widgetArray ) ) {
              continue ;
            }
            $getTitleArray = !empty($values['params']) ? Zend_Json::decode( $values['params'] ) :  array();
            $getTitle = $values['name'] ;
            if ( !empty( $getTitleArray['title'] ) ) {
              $getTitle = $getTitleArray['title'] ;
            }
            $tempArray = array ( 'name' => $values['name'] , 'title' => $getTitle ) ;
            $widgetSettingsArray[$values['order']] = $tempArray ;
          }
          ksort( $widgetSettingsArray ) ;
          return $widgetSettingsArray ; 
          }
        }
      }
    }
	}
}
?>