<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitebusinessmember_Form_Admin_Global extends Engine_Form {

  // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
  public $_SHOWELEMENTSBEFOREACTIVATE = array(
      'environment_mode', 'include_in_package', 'submit_lsetting', 'sitebusinessmember_group_settings', 'sitebusinessmember_settings', 'sitebusinessmember_settingsforlayout'
  );
    
  public function init() {
    $this->setTitle('Global Settings')
        ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'sitebusinessmember_lsettings', array(
			'label' => 'Enter License key',
			'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
			'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.lsettings'),
    ));

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    
    $global_settings_file = APPLICATION_PATH . '/application/settings/general.php';
    if (file_exists($global_settings_file)) {
      $generalConfig = include $global_settings_file;
    } else {
      $generalConfig = array();
    }

//     	$this->addElement('Checkbox', 'sitebusinessmember_group_settings', array(
// 				'description' => 'Use as Groups (Setting to make this system work as Groups)',
// 				'label' => 'Do you want use this system as SocialEngineAddOns Demo Groups? (Note: If you select this option, then you will be able to configure additional settings to use this system as Groups on your site. This is a one time setting and to revert this later, you will have to manually configure from Layout Editor, Global Settings, Manage Packages, etc.)',
// 				'value' => 0,
// 				'onclick' => 'showGroupSettings(this.value)'
// 		));
//     
//     $LayoutSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.layoutcreate', 0);
//     
//     $Group_setting_array = array("packagedisable" => "Enable Packages and disable Member Level Settings.", "reportinsight" => "Enable Insights and Reports.");
//     $this->addElement( 'MultiCheckbox' , 'sitebusinessmember_settings' , array (
// 			'multiOptions' => $Group_setting_array,
// 		)) ;
// 
// 		
// 		
// 		
// 		$Group_settingforLayout = array("layoutsetasdemo" => "Retain the layout of Businesses Home (Now Groups Home) like what it is now and do not make it like SocialEngineAddOns Demo Groups Home.", 'layoutbrowsebusiness' => "Retain the layout of Browse Businesses (Now Browse Groups) like what it is now and do not make it like SocialEngineAddOns Demo Browse Groups.", 'layoutpinboard' => 'Retain the layout of Pinboard (Now Pinboard of Groups) like what it is now and do not make it like SocialEngineAddOns Demo Pinboard.', 'layoutprofilebusiness' => 'Retain the layout of Business Profile (Now Group Profile) like what it is now and do not make it like SocialEngineAddOns Demo Group Profile.');
// 
// 		$this->addElement( 'MultiCheckbox' , 'sitebusinessmember_settingsforlayout' , array (
// 		   'label' => 'Content Layout',
// 			'multiOptions' => $Group_settingforLayout,
// 		)) ;

		
    $this->addElement('Text', 'language_phrases_business', array(
        'label' => 'Singular Business Title',
        'description' => 'Please enter the Singular Title for business. This text will come in places like feeds generated, widgets etc.',
        'allowEmpty' => FALSE,
        'validators' => array(
            array('NotEmpty', true),
        ),
        'value'=> Engine_Api::_()->getApi('settings', 'core')->getSetting( "language.phrases.business", "business"),

    ));
    
    $this->addElement('Text', 'language_phrases_businesses', array(
        'label' => 'Plural Business Title',
        'description' => 'Please enter the Plural Title for businesses. This text will come in places like Main Navigation Menu, Business Navigation Menu, widgets etc.',
        'allowEmpty' => FALSE,
        'validators' => array(
            array('NotEmpty', true),
        ),
      'value'=> Engine_Api::_()->getApi('settings', 'core')->getSetting( "language.phrases.businesses", "businesses"),
    ));
    
//     $this->addElement( 'Radio' , 'sitebusinessmember_enabled_group_layout' , array (
//             'label' => 'Group Cover Photo Layout',
//             'description' => "Do you want to enable Group Cover Photo Layout for the profiles of directory items / businesses on your site?",
//             'multiOptions' => array (
//                     1 => 'Yes' ,
//                     0 => 'No'
//             ) ,
//             'value' => $coreSettings->getSetting('sitebusinessmember.enabled.group.layout', 1),
//     ));
    
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
            $this->addElement('Checkbox', 'include_in_package', array(
                    'label' => ' Enable members module for the default package that was created upon installation of the "Directory / Businesses Plugin". If enabled, Members App will also be enabled for the Businesses created so far under the default package.',
                    'description' => 'Enable Members Module for Default Package',
                    'value' => 1,
            ));
    }
    
    if ( ( !empty($generalConfig['environment_mode']) ) && ($generalConfig['environment_mode'] != 'development') ) {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few businesses of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
//          'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));
    
    $this->addElement('Text', 'sitebusinessmember_manifestUrl', array(
			'label' => 'Business Members URL alternate text for "business-members"',
			'allowEmpty' => false,
			'required' => true,
			'description' => 'Please enter the text below which you want to display in place of "businessmembers" in the URLs of this plugin.',
			'value' => $coreSettings->getSetting('sitebusinessmember.manifestUrl', "business-members"),
    ));
    
		$this->addElement( 'Radio' , 'businessmember_title' , array (
      'label' => 'Member Roles',
      'description' => "Do you want business members to be able to select their member roles in the directory items / businesses?",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.title' , 1),
    )) ;
    
    $this->addElement( 'Radio' , 'businessmember_member_title' , array (
      'label' => 'Enable Member Title',
      'description' => "Do you want business admins to be able to enter member titles by which members will be called in their directory items / businesses?",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.member.title' , 1),
    )) ;
    
    $this->addElement('Radio', 'sitebusinessmember_member_show_menu', array(
			'label' => 'Members Link',
			'description' => 'Do you want to show the Members link on Businesses Navigation Menu? (You might want to show this if Members from Businesses are an important component on your website. This link will lead to a widgetized business listing all Business Members, with a search form for Business Members and multiple widgets.',
			'multiOptions' => array(
					1 => 'Yes',
					0 => 'No'
			),
			'value' => $coreSettings->getSetting('sitebusinessmember.member.show.menu', 1),
    ));

    $this->addElement( 'Radio' , 'businessmember_date' , array (
      'label' => 'Affiliation / Joining Date',
      'description' => "Do you want business members to be able to select their affiliation / joining date in the directory items / businesses?",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.date' , 1),
    )) ;
    
    $this->addElement( 'Radio' , 'businessmember_announcement' , array (
      'label' => 'Announcements',
      'description' => 'Do you want announcements to be enabled for directory items / businesses? (If enabled, then business admins will be able to post announcements for their businesses from ‘Manage Announcements’ section of their Business Dashboard.)',
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.announcement' , 1),
			'onclick' => 'showAnnouncements(this.value)'
    )) ;
    
    $this->addElement('Radio', 'sitebusinessmember_tinymceditor', array(
        'label' => 'Tinymce Editor',
        'description' => 'Do you want to allow tinymce editor for the announcements.',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => $coreSettings->getSetting('sitebusinessmember.tinymceditor', 1),
    ));

    $this->addElement( 'Radio' , 'businessmember_automatically_addmember' , array (
      'label' => 'Automatically Add People',
      'description' => "Do you want people to be automatically added to a business when business admins or other members of that business add them? (Note: This setting will not work for the businesses which need admin approval when people try to join that business.)",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.automatically.addmember' , 1),
    )) ;

    $this->addElement( 'Radio' , 'businessmember_automatically_like' , array (
      'label' => 'Automatic Like',
      'description' => "Do you want members to automatically Like a business they Join?",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.automatically.like' , 0),
    )) ;
    
    $this->addElement( 'Radio' , 'businessmember_automatically_join' , array (
      'label' => 'Automatic Join',
      'description' => "Do you want members to automatically Join a business they Like?",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.automatically.join' , 0),
    )) ;

    $this->addElement( 'Radio' , 'businessmember_invite_option' , array (
      'label' => 'Enable “Member Invite Others” Option',
      'description' => "Do you want to enable “Member Invite Others” option in the businesses using which business admins will be able to choose who should be able to invite other people to their businesses? (If you select ‘No’, then you can choose who would be able to invite other people to the businesses on your site.)",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.invite.option' , 1),
      'onclick' => 'showInviteOption(this.value)',
    ));

		$this->addElement('Radio', 'businessmember_invite_automatically', array(
			'label' => 'Member Invite Others',
			'description' => 'Do you want business members to invite other people to the businesses they join?',
			'multiOptions' => array(
			'0' => 'Yes, members can invite other people.',
			'1' => 'No, only business admins can invite other people',
			),
			'value' => $coreSettings->getSetting( 'businessmember.invite.automatically' , 1),
		));
    
    $this->addElement( 'Radio' , 'businessmember_member_approval_option' , array (
      'label' => 'Enable “Approve Members” Option',
      'description' => "Do you want to enable “Approve Members” option in the businesses using which business admins will be able to choose that when people try to join businesses, should they be allowed to join immediately, or should they be forced to wait for approval? (If you select ‘No’, then you can choose to allow members to join immediately or wait for approval.)",
      'multiOptions' => array (
        1 => 'Yes' ,
        0 => 'No'
      ) ,
      'value' => $coreSettings->getSetting( 'businessmember.member.approval.option' , 1),
      'onclick' => 'showApprovalOption(this.value)'
    ));
    
    $this->addElement('Radio', 'businessmember_member_approval_automatically', array(
			'label' => 'Approve Members',
			'description' => 'When people try to join the businesses on your site, should they be allowed to join immediately, or should they be forced to wait for approval?',
			'multiOptions' => array(
				'1' => 'New members can join immediately.',
				'0' => 'New members must be approved.',
			),
			'value' => $coreSettings->getSetting( 'businessmember.member.approval.automatically' , 1),
		));

		$this->addElement( 'Radio' , 'businessmember_businessasgroup' , array (
			'label' => 'Enable "Invite All Business members" Option',
			'description' => "Do you want to let business event owners invite all business members to their business events? (If enabled, then ‘Invite All Business members’ option will be available while creating a business event.)",
			'multiOptions' => array (
				1 => 'Yes' ,
				0 => 'No'
			) ,
			'value' => $coreSettings->getSetting( 'businessmember.businessasgroup' , 0),
		));

    $this->addElement('Button', 'submit', array(
			'label' => 'Save Changes',
			'type' => 'submit',
			'ignore' => true
    ));
  }
}