<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: MemberController.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitebusinessmember_MemberController extends Seaocore_Controller_Action_Standard {

  protected $_TEMPDATEVALUE = 75633;
  //ACTION FOR MEMBER JOIN THE BUSINESS.
  public function joinAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

    //SOMMTHBOX
    $this->_helper->layout->setLayout('default-simple');

    //MAKE FORM
    if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
			$this->view->form = $form = new Sitebusinessmember_Form_Join();
    } else {
      $this->view->form = $form = new Sitebusinessmember_Form_SitemobileJoin();
    }
    
    //IF THE MODE IS APP MODE THEN
    if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
      $this->view->sitemapPageHeaderTitle = "Join Business";
      $form->setTitle('');
    }

		$viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();
		
		$business_id = $this->_getParam('business_id');
		$sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		$owner = $sitebusiness->getOwner();
		
	  	$notificationSettings = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->notificationSettings(array('user_id' => $sitebusiness->owner_id, 'business_id' => $business_id, 'columnName' => array('action_notification')));
	  	if($notificationSettings)
	  	$action_notification = Zend_Json_Decoder::decode($notificationSettings);

    $businessMemberJoinType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.join.type', null);    
    $hasMembers = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id, $business_id);
    $businessMemberJoinType = $businessMemberJoinType + $this->_TEMPDATEVALUE;
    $businessMemberJoinType = @md5($businessMemberJoinType);     
		
    //IF MEMBER IS ALREADY PART OF THE BUSINESS
    if(!empty($hasMembers)) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have already sent a membership request.')),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }

    //PROCESS FORM
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )	{

      $businessMemberUnitType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.unit.type', null);
      
			//SET THE REQUEST AS HANDLED FOR NOTIFACTION.
			$friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
			if($action_notification && $action_notification['notificationjoin'] == 1) {
				Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $sitebusiness, 'sitebusiness_join');
			} elseif($action_notification && in_array($sitebusiness->owner_id, $friendId) && $action_notification['notificationjoin'] == 2) {
				Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $sitebusiness, 'sitebusiness_join');
			}
			
			//ADD ACTIVITY
			$action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitebusiness, 'sitebusiness_join');
				if ( $action ) {
					Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity( $action , $sitebusiness ) ;
				}
			Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action,true);
      if( $businessMemberJoinType == $businessMemberUnitType ) {
        //GET VALUE FROM THE FORM.
        $values = $this->getRequest()->getPost();

        $membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
        $row = $membersTable->createRow();
        $row->resource_id = $business_id;
        $row->business_id = $business_id;
        $row->user_id = $viewer_id;

        //FOR CATEGORY WORK.
				if (isset($values['role_id'])) {
					$roleName = array();
					foreach($values['role_id'] as $role_id) {
						$roleName[] = Engine_Api::_()->getDbtable('roles', 'sitebusinessmember')->getRoleName($role_id);
					}
					$roleTitle = json_encode($roleName);
					$roleIDs = json_encode($values['role_id']);
					if ($roleTitle && $roleIDs) {
            $row->title = $roleTitle;
            $row->role_id = $roleIDs;
          }
				}

        //FOR DATE WORK.
        if (!empty($values['year']) || !empty($values['month']) || !empty($values['day'])) {
          $member_date = $values['year'] . '-' . (int) $values['month'] . '-' . (int) $values['day'];
          $row->date = $member_date;
        }

        //IF MEMBER IS ALREADY FEATURED THEN AUTOMATICALLY FEATURED WHEN MEMBER JOIN ANY BUSINESS.
        $sitebusinessmember = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id);
        if(!empty($sitebusinessmember->featured) && $sitebusinessmember->featured == 1) {
          $row->featured = 1;
        }

        $row->save();

        //MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
        Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
        $sitebusiness->save();

        //AUTOMATICALLY LIKE THE BUSINESS WHEN MEMBER JOIN THE BUSINESS.
        $autoLike = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'businessmember.automatically.like' , 0);
        if(!empty($autoLike)) {
          Engine_Api::_()->sitebusiness()->autoLike($business_id, 'sitebusiness_business');
        }
        
        //START DISCUSSION WORK WHEN MEMBER JOIN THE BUSINESS THEN ALL DISCUSSION IS WATCHABLE FOR JOINED MEMBERS.
        if(Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitebusinessdiscussion')) {
					$results = Engine_Api::_()->getDbTable('topics', 'sitebusiness')->getBusinessTopics($business_id);
					if(!empty($results)) {
						foreach($results as $result) {
						
						$topic_id = $result->topic_id;
						
						$db = Engine_Db_Table::getDefaultAdapter();
						
						$db->query("INSERT IGNORE INTO `engine4_sitebusiness_topicwatches` (`resource_id`, `topic_id`, `user_id`, `watch`, `business_id`) VALUES ('$business_id', '$topic_id', '$viewer_id', '1', '$business_id');");
						}
					}
        }
        //END DISCUSSION WORK WHEN MEMBER JOIN THE BUSINESS THEN ALL DISCUSSION IS WATCHABLE FOR JOINED MEMBERS.
        
      }

      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('You are now a member of this business.')),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }
  }

  //ACTION FOR LEAVE THE BUSINESS.
  public function leaveAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid()) return;

		$viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();

		//GET BUSINESS ID.
		$business_id = $this->_getParam('business_id');
		$sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		
    //MAKE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Member();
    $form->setTitle('Leave Business');
    $form->setDescription('Are you sure you want to leave this business?');
    $form->submit->setLabel('Leave Business');

    //IF THE MODE IS APP MODE THEN
    if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
      $this->view->sitemapPageHeaderTitle = "Leave Business";
      $form->setTitle('');
    }
    //PROCESS FORM
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )	{

      if (!empty($business_id)) {

        //DELETE THE RESULT FORM THE TABLE.
        Engine_Api::_()->getDbtable('membership', 'sitebusiness')->delete(array('resource_id =?' => $business_id, 'user_id = ?' => $viewer_id));

        //DELETE ACTIVITY FEED OF JOIN BUSINESS ACCORDING TO USER ID.
        $action_id = Engine_Api::_()->getDbtable('actions', 'activity')->fetchRow(array('type = ?'  => 'sitebusiness_join', 'subject_id = ?' => $viewer_id, 'object_id = ?' => $business_id));
        $action = Engine_Api::_()->getItem('activity_action', $action_id->action_id);
        if (!empty($action)) {
					$action->delete();
        }

				//REMOVE THE NOTIFICATION.
				$notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($sitebusiness->getOwner(), $sitebusiness, 'sitebusiness_join');
				if($notification) {
					$notification->delete();
				}
			
				//MEMBER COUNT DECREASE IN THE BUSINESS TABLE WHEN MEMBER LEAVE THE BUSINESS.
				$sitebusiness->member_count--;
				$sitebusiness->save();
      }

      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have successfully left this business.')),
        'layout' => 'default-simple',
        
        'parentRefresh' => true,
      ));
    }
  }

  //ACTION FOR REQUEST BUSINESS.
  public function requestAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

    //SOMMTHBOX
    $this->_helper->layout->setLayout('default-simple');
    
    //MAKE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Member();
    $form->setTitle('Request Business Membership');
    $form->setDescription('Would you like to request membership in this business?');
    $form->submit->setLabel('Send Request');
    
		//GET THE VIEWER ID.
		$viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET THE BUSINESS ID.
		$business_id = $this->_getParam('business_id');
		$sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		
		$businesstitle = $sitebusiness->title;
		$business_url = Engine_Api::_()->sitebusiness()->getBusinessUrl($business_id);
		
		$business_baseurl = ((!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"])) ? "https://":"http://") . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('business_url' => $business_url), 'sitebusiness_entry_view', true);		
		$business_title_link = '<a href="' . $business_baseurl . '"  >' . $businesstitle . ' </a>';
			
    $hasMembers = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id, $business_id);
    $businessJoinType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.join.type', null);

    //IF MEMBER IS ALREADY PART OF THE BUSINESS
    if(!empty($hasMembers)) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have already sent a membership request.')),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }

    //PROCESS FORM
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {

			$sitebusinessmember = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id);
      $businessPhraseNum = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmember.phrase.num', null);

      //GET MANAGE ADMIN AND SEND NOTIFICATIONS TO ALL MANAGE ADMINS.
			$manageadmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdmin($business_id);
      if( $businessJoinType == $businessPhraseNum ) {			
        foreach($manageadmins as $manageadmin) {

          $user_subject = Engine_Api::_()->user()->getUser($manageadmin['user_id']);

          Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user_subject, $viewer, $sitebusiness, 'sitebusinessmember_approve');

          //Email to all business admins.
          Engine_Api::_()->getApi('mail', 'core')->sendSystem($user_subject->email, 'SITEBUSINESSMEMBER_REQUEST_EMAIL', array(
              'business_title' => $businesstitle,
              'business_title_with_link' => $business_title_link,
              'object_link' => $business_baseurl,
              //'email' => $email,
              'queue' => true
          ));
        }

        $values = $this->getRequest()->getPost();

        $membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');

        $row = $membersTable->createRow();
        $row->resource_id = $business_id;
        $row->business_id = $business_id;
        $row->user_id = $viewer_id;
        $row->active = 0;
        $row->resource_approved = 0;
        $row->user_approved = 0;

        if (!empty($sitebusinessmember->featured) && $sitebusinessmember->featured == 1) {
          $row->featured = 1;
        }

        $row->save();
      }
			return $this->_forwardCustom('success', 'utility', 'core', array(
				'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your business membership request has been sent successfully.')),
				'layout' => 'default-simple',
				'parentRefresh' => true,
			));
    }
  }

  //ACTION FOR CANCEL MEMBER REQUEST.
  public function cancelAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

		//GET BUSINESS ID.
		$business_id = $this->_getParam('business_id');
		$sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
		
		//GET VIEWER ID.
		$viewer = Engine_Api::_()->user()->getViewer();

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Member();
    $form->setTitle('Cancel Business Membership Request');
    $form->setDescription('Would you like to cancel your request for membership in this business?');
    $form->submit->setLabel('Cancel Request');

    //PROCESS FORM
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {

			//REMOVE THE NOTIFICATION.
			$notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($sitebusiness->getOwner(), $sitebusiness, 'sitebusinessmember_approve');
			if( $notification ) {
				$notification->delete();
			}

			if (!empty($business_id)) {
				//DELETE THE RESULT FORM THE TABLE.
				Engine_Api::_()->getDbtable('membership', 'sitebusiness')->delete(array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
			}

      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('Business membership request cancelled.')),
        'layout' => 'default-simple',
        
        'parentRefresh' => true,
      ));
    }
  }

  //RESPOND REQUEST.
  public function respondAction() {
  
    // CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

    $viewer = Engine_Api::_()->user()->getViewer();

    //GET THE SITEBUSINESS ID FROM THE URL
    $business_id = $this->_getParam('business_id');
    $param = $this->_getParam('param');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    $this->view->form = $form = new Sitebusinessmember_Form_Respond();
    if ($param != 'Invite') {
			$form->setTitle('Respond to Membership Request');
			//$form->setDescription('Respond to Membership Request.');
    } else {
			$form->setTitle('Respond to Membership Invitation');
			//$form->setDescription('Respond to Membership Invitation.');
    }

      // Process form
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Method');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Data');
      return;
    }
  
  		//GET VALUE FROM THE FORM.
		$values = $this->getRequest()->getPost(); 

		if (isset($values['accept'])) {
		
// 			$notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($viewer, $sitebusiness, 'sitebusinessmember_invite');
// 			if( $notification ) {
// 				$notification->mitigated = true;
// 				$notification->save();
// 			}
			
      if (!empty($sitebusiness->member_approval)) {
				//ADD ACTIVITY.
				$action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitebusiness, 'sitebusiness_join');
				if ( $action ) {
					Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity( $action , $sitebusiness ) ;
				}
				Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action,true);
				Engine_Api::_()->getDbtable('membership', 'sitebusiness')->update(array('active'=>  '1', 'user_approved' => '1'), array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
				
				//MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
				Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
				$sitebusiness->save();
			} 
			else {
				Engine_Api::_()->getDbtable('membership', 'sitebusiness')->update(array('active'=>  '0', 'user_approved' => '0', 'resource_approved' => '0'), array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
			
				//GET MANAGE ADMIN AND SEND NOTIFICATIONS TO ALL MANAGE ADMINS.
				$manageadmins = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->getManageAdmin($business_id);
				foreach($manageadmins as $manageadmin) {

					$user_subject = Engine_Api::_()->user()->getUser($manageadmin['user_id']);
                                        $row = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->getRow($sitebusiness, $viewer);
					Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user_subject, $viewer, $sitebusiness, 'sitebusinessmember_approve', array('member_id' => $row->member_id));
				}
			}
		} 
		else {
			if (!empty($business_id)) {
				//DELETE THE RESULT FORM THE TABLE.
				Engine_Api::_()->getDbtable('membership', 'sitebusiness')->delete(array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
			}
		}
    $notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($viewer, $sitebusiness, 'sitebusinessmember_invite');
 			if( $notification ) {
 				$notification->mitigated = true;
                                $notification->read = true;
 				$notification->save();
 			}            
    $this->view->status = true;
    $this->view->error = false;
    if (isset($values['accept']) && !empty($automaticallyJoin) && !empty($sitebusiness->member_approval)) {
			$message = Zend_Registry::get('Zend_Translate')->_('You have accepted the invite to the business %s.');
    }  elseif (isset($values['accept']) && empty($automaticallyJoin) && empty($sitebusiness->member_approval)) {
			$message = Zend_Registry::get('Zend_Translate')->_('You have accepted the invitation to join the business %s.');
    }  elseif (isset($values['accept']) && empty($automaticallyJoin) && !empty($sitebusiness->member_approval)) {
			$message = Zend_Registry::get('Zend_Translate')->_('You have accepted the invitation to join the business %s.');
    } 
    else {
			$message = Zend_Registry::get('Zend_Translate')->_('You have ignored the invite to the business %s.');
    }
    
    $message = sprintf($message, $sitebusiness->__toString());
    $this->view->message = $message;

    if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array($message),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }
  }
  
  //ACTION FOR ACCEPT BUSINESS MEMBER REQUEST.
  public function acceptAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

    $viewer = Engine_Api::_()->user()->getViewer();

    //GET THE SITEBUSINESS ID FROM THE URL
    $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    
    //MAKE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Member();
    $form->setTitle('Accept Business Invitation');
    $form->setDescription('Would you like to accept business invitation for this business?');
    $form->submit->setLabel('Accept Business Invitation');

    //PROCESS FORM
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Method');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Data');
      return;
    }

		//SET THE REQUEST AS HANDLED
		$notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($viewer, $sitebusiness, 'sitebusinessmember_invite');
		if( $notification ) {
			$notification->mitigated = true;
			$notification->save();
		}

		//GET VALUE FROM THE FORM.
		$values = $this->getRequest()->getPost();
		
		//ADD ACTIVITY
		$action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitebusiness, 'sitebusiness_join');
		if ( $action ) {
       Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity( $action , $sitebusiness ) ;
    }
		Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action,true);
		Engine_Api::_()->getDbtable('membership', 'sitebusiness')->update(array('active'=>  '1', 'user_approved' => '1'), array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
		
		//MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
		Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
		$sitebusiness->save();
		
    $this->view->status = true;
    $this->view->error = false;

    $message = Zend_Registry::get('Zend_Translate')->_('You have accepted the invite to the business %s');
    $message = sprintf($message, $sitebusiness->__toString());
    $this->view->message = $message;

    if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array($message),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }
  }

  //ACTION FOR REJECT BUSINESS MEMBER REQUEST.
  public function rejectAction() {

    //CHECK AUTH
    if( !$this->_helper->requireUser()->isValid() ) return;

    //PROCESS
    $viewer = Engine_Api::_()->user()->getViewer();
    
    //GET THE SITEBUSINESS ID FROM THE URL
    $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //MAKE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Member();
    $form->setTitle('Reject Business Invitation');
    $form->setDescription('Would you like to reject the invitation for this business?');
    $form->submit->setLabel('Reject Business Invitation');
    
    //PROCESS FORM
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Method');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->view->status = false;
      $this->view->error = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('Invalid Data');
      return;
    }

		if (!empty($business_id)) {
		
			//DELETE THE RESULT FORM THE TABLE.
			Engine_Api::_()->getDbtable('membership', 'sitebusiness')->delete(array('resource_id =?' => $business_id, 'user_id =?' => $viewer->getIdentity()));
		}
		
    $this->view->status = true;
    $this->view->error = false;
    $message = Zend_Registry::get('Zend_Translate')->_('You have ignored the invite to the business %s');
    $message = sprintf($message, $sitebusiness->__toString());
    $this->view->message = $message;

    if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array($message),
        'layout' => 'default-simple',
        
        'parentRefresh' => true,
      ));
    }
  }
  
  //ACTION FOR THE INVITE MEMBER.
  public function inviteMembersAction() {

    if( !$this->_helper->requireUser()->isValid() ) return;

    //GET BUSINESS ID.
    $this->view->business_id = $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    
    $viewer = Engine_Api::_()->user()->getViewer();
    
		$isBusinessAdmin = Engine_Api::_()->getDbtable('manageadmins', 'sitebusiness')->isBusinessAdmins($viewer->getIdentity(), $sitebusiness->getIdentity());
		
    $automaticallyJoin = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.automatically.addmember', 1);

    //PREPARE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_InviteMembers();
    
    //IF THE MODE IS APP MODE THEN
    if (Engine_Api::_()->seaocore()->isSitemobileApp()) {
      $memberSettings = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.automatically.addmember' , 1);
      if (!empty($memberSettings)) {
        $text = "Add People";
      }else{
        $text = "Invite People";
      }
      $this->view->sitemapPageHeaderTitle = $text;
      $form->setTitle('');
    }
    
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $values = $form->getValues();
    
    if(empty($values['user_ids']) && empty($values['toValues'])) {
        $form->addError('Please complete this field - It is requried.');
        return;
    }
    
    if(empty($values['toValues'])) {
        $form->addError('This is an invalid user name. Please select a valid user name from the autosuggest.');
        return;
    }

    $members_ids = explode(",", $values['toValues']);

    $membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
    
		if (!empty($members_ids)) {
		
			foreach($members_ids as $members_id) {

				$row = $membersTable->createRow();
				$row->resource_id = $business_id;
				$row->business_id = $business_id;
				$row->user_id = $members_id;
				$row->resource_approved = 1;
				
				if (!empty($automaticallyJoin) && !empty($sitebusiness->member_approval)) {
				
					$row->active = 1;
					$row->user_approved = 1;
					$row->save();		
					//MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
					Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
					$sitebusiness->save();
				} elseif (!empty($automaticallyJoin) && empty($sitebusiness->member_approval) && !empty($isBusinessAdmin)) {
					$row->active = 1;
					$row->user_approved = 1;
					$row->save();		
					//MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
					Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
					$sitebusiness->save();
				}
				else {
					$row->active = 0;
					//$row->resource_approved = 0;
					$row->user_approved = 0;
				}
				
				$row->save();
				
				if (empty($automaticallyJoin)) {
					$user_subject = Engine_Api::_()->user()->getUser($members_id);
					Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user_subject, $viewer, $sitebusiness, 'sitebusinessmember_invite');
				} 
				else {
				  $user_subject = Engine_Api::_()->user()->getUser($members_id);
					//SET THE REQUEST AS HANDLED FOR NOTIFACTION.
					Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user_subject, $viewer, $sitebusiness, 'sitebusiness_addmember');

					//ADD ACTIVITY
					$action=Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($user_subject, $sitebusiness, 'sitebusiness_join');
					if ( $action ) {
						Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity( $action , $sitebusiness ) ;
					}
	        Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action,true);
				}
			}
		}
		
    return $this->_forwardCustom('success', 'utility', 'core', array(
      'messages' => array(Zend_Registry::get('Zend_Translate')->_('The selected members have been successfully added to this business.')),
      'layout' => 'default-simple',
      
      'parentRefresh' => true,
    ));
  }
  
  //ACTION FOR THE INVITE MEMBER.
  public function inviteAction() {

    if( !$this->_helper->requireUser()->isValid() ) return;

    //GET BUSINESS ID.
    $business_id = $this->_getParam('business_id');
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    
    $automaticallyJoin = Engine_Api::_()->getApi('settings', 'core')->getSetting( 'businessmember.automatically.addmember', 1);
    
    //PREPARE DATA
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->friends = $friends = $viewer->membership()->getMembers();

    $hasMembers_viewer = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer->getIdentity(), $sitebusiness->getIdentity());

    //PREPARE FORM
    $this->view->form = $form = new Sitebusinessmember_Form_Invite();

    $count = 0;
    foreach( $friends as $friend ) {
    
			$friend_id = $friend->getIdentity();

			$hasMembers = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($friend_id, $business_id);

			if(!empty($hasMembers)) {
				continue;
		  }
      //if( $sitebusiness->membership()->isMember($friend, null) ) continue;
      $multiOptions[$friend->getIdentity()] = $friend->getTitle();
      $count++;
    }
    sort($multiOptions);
    $form->users->addMultiOptions($multiOptions);
    $this->view->count = $count;

    // throw notice if count = 0
    if( $count == 0 ) {
      return $this->_forwardCustom('success', 'utility', 'core', array(
      'messages' => array(Zend_Registry::get('Zend_Translate')->_('You have currently no friends to invite.')),
      'layout' => 'default-simple',
      'parentRefresh' => true,
      ));
    }

    //NOT POSTING
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $usersIds = $form->getValue('users');
		foreach( $friends as $friend ) {
		
			if( !in_array($friend->getIdentity(), $usersIds) ) {
				continue;
			}

			//GET VALUE FROM THE FORM.
			$values = $this->getRequest()->getPost();
			$membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
			$row = $membersTable->createRow();
			$row->resource_id = $business_id;
			$row->business_id = $business_id;
			$row->user_id = $friend->getIdentity();
			$row->resource_approved = 1;
			
			if (!empty($automaticallyJoin) && !empty($sitebusiness->member_approval)) {
				$row->active = 1;
				$row->user_approved = 1;

				//MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
				Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
				$sitebusiness->save();
			} else {
				$row->active = 0;
				if(!empty($automaticallyJoin) && empty($sitebusiness->member_approval)) {
					$row->resource_approved = 0;
				}
				$row->user_approved = 0;
			}
			
			$row->save();
			
      if (empty($automaticallyJoin)) {
				Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($friend, $viewer, $sitebusiness, 'sitebusinessmember_invite');
			} elseif (!empty($automaticallyJoin) && empty($sitebusiness->member_approval)) {
				Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($friend, $viewer, $sitebusiness, 'sitebusinessmember_invite');
			}
		}
    if (!empty($automaticallyJoin) && !empty($sitebusiness->member_approval)) {
			$messages = Zend_Registry::get('Zend_Translate')->_('Members have been successfully added.');
    } else {
			$messages = Zend_Registry::get('Zend_Translate')->_('Members have been successfully invited.');
    }
    return $this->_forwardCustom('success', 'utility', 'core', array(
      'messages' => array(Zend_Registry::get('Zend_Translate')->_($messages)),
      'layout' => 'default-simple',
      'parentRefresh' => true,
    ));
  }
  
  //ACTION FOR JOINED MORE BUSINESSS BY MEMBERS.
  public function getMoreJoinedBusinessesAction() {
  
		$business_title = $this->_getParam('text', null); 
		$user_id = $this->_getParam('user_id', null);
    $data = array();

    $joinBusiness = Engine_Api::_()->getDbtable('membership', 'sitebusiness')->getJoinBusinesses($user_id, 'memberOfDay');

    $businessIds = array();

    foreach( $joinBusiness as $joinBusinesses ) {
      $businessIds[] = $joinBusinesses['business_id'];
    }

    $morebusinesses = Engine_Api::_()->sitebusinessmember()->getMoreBusiness($businessIds, $business_title);

    foreach ($morebusinesses as $morebusiness) {
			$business_photo = $this->view->itemPhoto($morebusiness, 'thumb.icon');
      $data[] = array(
				'id' => $morebusiness->business_id,
				'label' => $morebusiness->title,
				'photo' => $business_photo
      );
    }

    return $this->_helper->json($data);
  }
  
  //ACTION FOR JOINED MERE BUSINESSS.
  public function joinedMoreBusinessesAction() {
  
    $this->view->user_id = $user_id = $this->_getParam('user_id');
    
    //SET LAYOUT
    $this->_helper->layout->setLayout('default-simple');

    //FORM GENERATION
    $form = $this->view->form = new Sitebusinessmember_Form_JoinedMoreBusinesses();

    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
    //$form->getElement('title')->setLabel('Enter the name of the business which you want to join.');

    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

    //PROCESS FORM
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) )	{

			//GET VALUE FROM THE FORM.
			$values = $this->getRequest()->getPost();
			$business_id = $values['business_id'];
			$sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
			$owner = $sitebusiness->getOwner();

			//SET THE REQUEST AS HANDLED FOR NOTIFACTION.
			Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $sitebusiness, 'sitebusiness_join');
			
			//ADD ACTIVITY
			$action=Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitebusiness, 'sitebusiness_join');
		  if ( $action ) {
				Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity( $action , $sitebusiness ) ;
			}
	    Engine_Api::_()->getApi('subCore', 'sitebusiness')->deleteFeedStream($action,true);
			$membersTable = Engine_Api::_()->getDbtable('membership', 'sitebusiness');
			$row = $membersTable->createRow();
			$row->resource_id = $business_id;
			$row->business_id = $business_id;
			$row->user_id = $viewer_id;
			
			//IF MEMBER IS ALREADY FEATURED THEN AUTOMATICALLY FEATURED WHEN MEMBER JOIN THE ANY BUSINESS.
			$sitebusinessmember = Engine_Api::_()->getDbTable('membership', 'sitebusiness')->hasMembers($viewer_id);
			if(!empty($sitebusinessmember->featured) && $sitebusinessmember->featured == 1) {
				$row->featured = 1;
			}

			$row->save();

      //MEMBER COUNT INCREASE WHEN MEMBER JOIN THE BUSINESS.
			Engine_Api::_()->sitebusiness()->updateMemberCount($sitebusiness);
			$sitebusiness->save();

		  //AUTOMATICALLY LIKE THE BUSINESS WHEN MEMBER JOIN THE BUSINESS.
		  $autoLike = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'businessmember.automatically.like' , 0);
		  if(!empty($autoLike)) {
				Engine_Api::_()->sitebusiness()->autoLike($business_id, 'sitebusiness_business');
      }

      return $this->_forwardCustom('success', 'utility', 'core', array(
        'messages' => array(Zend_Registry::get('Zend_Translate')->_('You are now a member of this business.')),
        'layout' => 'default-simple',
        'parentRefresh' => true,
      ));
    }
  }

  public function requestMemberAction() {
    $this->view->notification = $notification = $this->_getParam('notification');
  }
}
