<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php
class Sitebusinessmember_Installer extends Engine_Package_Installer_Module
{
    public function onPreInstall()
    {
        $db = $this->getDb();

        //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
        $sitebusiness_settings = $select->query()->fetchAll();
        if (!empty($sitebusiness_settings)) {
            $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
        } else {
            $sitebusiness_is_active = 0;
        }

        //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
        $check_sitebusiness = $select->query()->fetchObject();
        if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
            $PRODUCT_TYPE                = 'sitebusinessmember';
            $PLUGIN_TITLE                = 'Sitebusinessmember';
            $PLUGIN_VERSION              = '5.4.1';
            $PLUGIN_CATEGORY             = 'plugin';
            $PRODUCT_DESCRIPTION         = 'Directory / Businesses - Business Members Extension';
            $PRODUCT_TITLE               = 'Directory / Businesses - Business Members Extension';
            $_PRODUCT_FINAL_FILE         = 0;
            $sitebusiness_plugin_version = '4.8.6p5';
            $SocialEngineAddOns_version  = '4.8.9p12';
            $file_path                   = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
            $is_file                     = file_exists($file_path);
            if (empty($is_file)) {
                include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
            } else {
                include $file_path;
            }
            parent::onPreInstall();
        } elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
            $baseUrl    = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
            $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
            if (strstr($url_string, "manage/install")) {
                $calling_from = 'install';
            } else if (strstr($url_string, "manage/query")) {
                $calling_from = 'queary';
            }
            $explode_base_url = explode("/", $baseUrl);
            foreach ($explode_base_url as $url_key) {
                if ($url_key != 'install') {
                    $core_final_url .= $url_key . '/';
                }
            }

            return $this->_error("<span style='color:red'>Note: You have installed the Directory / Businesses Plugin but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Business Members Extension.</span><a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'> Click here</a> to activate the Business Plugin.");
        } else {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
            return $this->_error("<span style='color:red'>Note: You have not installed the Directory / Businesses Plugin on your site yet. Please install it first before installing the Directory / Businesses - Business Members Extension.</span><a href='" . $base_url . "/manage'> Click here</a> to go Manage Packages.");
        }
    }

    private function checkVersion($databaseVersion, $checkDependancyVersion)
    {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0) {
            return -1;
        }

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr)) {
            $count = count($fArr);
        } else {
            $count = count($sArr);
        }

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue) {
                    return 1;
                } elseif ($fValue < $sValue) {
                    return 0;
                } else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else {
                        continue;
                    }

                }
            } elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue) {
                    return 1;
                } elseif ($fsArr[0] < $sValue) {
                    return 0;
                } else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0]) {
                    return 1;
                } elseif ($fValue < $ssArr[0]) {
                    return 0;
                } else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0]) {
                    return 1;
                } elseif ($fsArr[0] < $ssArr[0]) {
                    return 0;
                } else {
                    if ($fsArr[1] > $ssArr[1]) {
                        return 1;
                    } elseif ($fsArr[1] < $ssArr[1]) {
                        return 0;
                    } else {
                        return -1;
                    }
                }
            }
        }
    }

    public function onInstall()
    {
        $db = $this->getDb();

        $db->query("UPDATE  `engine4_activity_notificationtypes` SET  `handler` =  'sitebusinessmember.widget.request-member' WHERE  `engine4_activity_notificationtypes`.`type` =  'sitebusinessmember_invite' LIMIT 1 ;");

        $select                = new Zend_Db_Select($db);
        $businessmemberVersion = $select
            ->from('engine4_core_modules', 'version')
            ->where('name = ?', 'sitebusinessmember')
            ->query()
            ->fetchColumn();
        $version_check = $this->checkVersion($businessmemberVersion, '4.7.1p1');
        if ($version_check != 1) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_sitebusiness_membership', array('title', 'role_id', 'member_id'));
            $results = $select->query()->fetchAll();
            foreach ($results as $result) {
                $title   = Zend_Json::encode($result['title']);
                $role_id = Zend_Json::encode($result['role_id']);
                $db->update('engine4_sitebusiness_membership', array('title' => "[" . $title . "]", "role_id" => "[" . $role_id . "]"), array('member_id = ?' => $result['member_id']));
            }
        }

        $role_id = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_membership LIKE 'role_id'")->fetch();
        if (!empty($role_id)) {
            $db->query("ALTER TABLE `engine4_sitebusiness_membership` CHANGE `role_id` `role_id` VARCHAR( 255 ) NOT NULL");
        }

        //For add column in the 'engine4_sitebusiness_membership' table.
        $action_notification_field = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_membership LIKE 'action_email'")->fetch();
        if (empty($action_notification_field)) {
            $db->query("ALTER TABLE  `engine4_sitebusiness_membership` ADD `action_email` VARCHAR( 255 ) NULL");
        }

        //For add column in the 'engine4_sitebusiness_membership' table.
        $action_notification_field = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_membership LIKE 'action_notification'")->fetch();
        if (empty($action_notification_field)) {
            $db->query("ALTER TABLE  `engine4_sitebusiness_membership` ADD `action_notification` VARCHAR( 255 ) NULL");
        }

        $businessIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessmember_roles LIKE 'business_id'")->fetch();
        if (!empty($businessIdColumn)) {
            $businessIdIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessmember_roles` WHERE Key_name = 'business_id'")->fetch();
            if (empty($businessIdIndex)) {
                $db->query("ALTER TABLE `engine4_sitebusinessmember_roles` ADD INDEX ( `business_id` )");
            }
        }

        //DELETE IMPORTTAB FROM THE ADMIN MENU.
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_menuitems')
            ->where('name = ?', 'sitebusinessmember_admin_main_import');
        $importTab = $select->query()->fetchAll();
        if (!empty($importTab)) {
            $db->query("DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`name` = 'sitebusinessmember_admin_main_import';");
        }

        //START DELETE FOR BUSINESS JOIN FEED FROM STREAM TABLE.
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusinessmember')
            ->where('version <= ?', '4.5.0p3');
        $version_check = $select->query()->fetchObject();
        if (!empty($version_check)) {

            $select = new Zend_Db_Select($db);
            $select->from('engine4_activity_stream', "action_id")->where('type = ?', 'sitebusiness_join')->group('action_id');
            $str_action_ids = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);
            if (!empty($str_action_ids)) {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_activity_actions', "action_id")->where('type = ?', 'sitebusiness_join')->where('action_id IN(?)', $str_action_ids);
                $action_ids = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);
            }

            if (!empty($str_action_ids) && !empty($action_ids)) {
                $diff_action_ids = array_diff($str_action_ids, $action_ids);
            }

            if ($diff_action_ids) {
                $db->delete('engine4_activity_stream', array('action_id IN(?)' => $diff_action_ids));
            }
        }
        //END DELETE FOR BUSINESS JOIN FEED FROM STREAM TABLE.

        //For add column in the 'engine4_sitebusiness_businesses' table.
        $member_invite   = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_businesses LIKE 'member_invite'")->fetch();
        $member_approval = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_businesses LIKE 'member_approval'")->fetch();
        $memberCount     = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_businesses LIKE 'member_count'")->fetch();

        if (empty($member_invite)) {
            $db->query("ALTER TABLE `engine4_sitebusiness_businesses` ADD `member_invite` TINYINT( 1 ) NOT NULL DEFAULT '1'");
        }

        if (empty($member_approval)) {
            $db->query("ALTER TABLE `engine4_sitebusiness_businesses` ADD `member_approval` TINYINT( 1 ) NOT NULL DEFAULT '1'");
        }

        if (empty($memberCount)) {
            $db->query("ALTER TABLE `engine4_sitebusiness_businesses` ADD `member_count` smallint(6) unsigned NOT NULL");
        }

        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')
            ->where('name = ?', 'sitebusinessmember')
            ->where('enabled = ?', 1);
        $check_sitebusinessmember = $select->query()->fetchObject();
        if (empty($check_sitebusinessmember)) {

            //All entry in manage admin table move in the membership table install business member plugin.
            $select = new Zend_Db_Select($db);
            $select->from('engine4_sitebusiness_manageadmins', array('business_id', 'user_id'));
            $check_sitebusiness = $select->query()->fetchAll();
            if (!empty($check_sitebusiness)) {
                foreach ($check_sitebusiness as $result) {
                    $db->insert('engine4_sitebusiness_membership', array(
                        'resource_id' => $result['business_id'],
                        'user_id'     => $result['user_id'],
                        'business_id' => $result['business_id'],
                    ));
                }
            }

            //For member count for business table.
            $select = new Zend_Db_Select($db);
            $select->from('engine4_sitebusiness_manageadmins', array('business_id', 'user_id', 'COUNT(*) as count'))->group('business_id');
            $check_count = $select->query()->fetchAll();

            if (!empty($check_count)) {
                foreach ($check_count as $check_counts) {
                    $db->query("UPDATE `engine4_sitebusiness_businesses` SET `member_count` = '" . $check_counts['count'] . "' WHERE `engine4_sitebusiness_businesses`.`business_id` = '" . $check_counts['business_id'] . "';");
                }
            }

            //update all member level settings with new setting member. business plugin version condition.
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_authorization_levels', array('level_id'))
                ->where('title != ?', 'public');
            $check_sitebusiness = $select->query()->fetchAll();
            foreach ($check_sitebusiness as $modArray) {

                $select = new Zend_Db_Select($db);
                $select
                    ->from('engine4_authorization_permissions', array('params', 'name', 'level_id'))
                    ->where('type LIKE "%sitebusiness_business%"')
                    ->where('level_id = ?', $modArray['level_id'])
                    ->where('name != ?', 'auth_html')
                    ->where('name LIKE "%auth_%"');
                $result = $select->query()->fetchAll();

                foreach ($result as $results) {
                    $params   = !empty($results['params']) ? Zend_Json::decode($results['params']) : array();
                    $params[] = 'member';
                    $paramss  = Zend_Json::encode($params);
                    $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '$paramss' WHERE `engine4_authorization_permissions`.`type` = 'sitebusiness_business' AND `engine4_authorization_permissions`.`name` = '" . $results['name'] . "' AND `engine4_authorization_permissions`.`level_id` = '" . $results['level_id'] . "';");
                }
            }
            //END
        }

        //Start Memeber Profile business Widget
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'user_profile_index')
            ->limit(1);
        $business_id = $select->query()->fetchAll();

        if (!empty($business_id)) {
            $page_id        = $business_id[0]['page_id'];
            $selectWidgetId = new Zend_Db_Select($db);
            $selectWidgetId->from('engine4_core_content', array('content_id'))
                ->where('page_id =?', $page_id)
                ->where('type = ?', 'widget')
                ->where('name = ?', 'core.container-tabs')
                ->limit(1);
            $fetchWidgetContentId = $selectWidgetId->query()->fetchAll();
            if (!empty($fetchWidgetContentId)) {
                $tab_id = $fetchWidgetContentId[0]['content_id'];

                // Check if it's already been placed
                $select = new Zend_Db_Select($db);
                $select
                    ->from('engine4_core_content')
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'sitebusiness.profile-joined-sitebusiness');
                $info = $select->query()->fetch();

                if (empty($info)) {
                    $db->insert('engine4_core_content', array(
                        'page_id'           => $page_id,
                        'type'              => 'widget',
                        'name'              => 'sitebusiness.profile-joined-sitebusiness',
                        'parent_content_id' => $tab_id,
                        'order'             => 999,
                        'params'            => '{"title":"Joined Businesses","titleCount":""}',
                    ));
                }
            }
        }
        //End Memeber Profile business Widget

        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'sitebusinessmember_index_home')
            ->limit(1);
        $info = $select->query()->fetch();

        if (empty($info)) {
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitebusinessmember_index_home',
                'displayname' => 'Business Members Home',
                'title'       => 'Business Members Home',
                'description' => 'This is business member home business.',
                'custom'      => 1,
            ));
            $business_id = $db->lastInsertId('engine4_core_pages');

            // containers
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 2,
                'params'            => '',
            ));
            $container_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'right',
                'parent_content_id' => $container_id,
                'order'             => 5,
                'params'            => '',
            ));
            $right_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'left',
                'parent_content_id' => $container_id,
                'order'             => 4,
                'params'            => '',
            ));
            $left_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'top',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $top_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $top_id,
                'order'             => 6,
                'params'            => '',
            ));
            $top_middle_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $container_id,
                'order'             => 6,
                'params'            => '',
            ));
            $middle_id = $db->lastInsertId('engine4_core_content');

            // Top Middle
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusiness.browsenevigation-sitebusiness',
                'parent_content_id' => $top_middle_id,
                'order'             => 3,
                'params'            => '',
            ));

            // Left
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.home-recent-mostvaluable-sitebusinessmember',
                'parent_content_id' => $left_id,
                'order'             => 16,
                'params'            => '{"title":"Recent Members","select_option":"1","titleCount":"true"}',
            ));

            // Middele
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.featured-members-slideshow',
                'parent_content_id' => $left_id,
                'order'             => 14,
                'params'            => '{"title":"Featured Members","titleCount":"true"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.list-members-tabs-view',
                'parent_content_id' => $middle_id,
                'order'             => 17,
                'params'            => '{"title":"Members","margin_photo":"12","showViewMore":"1"}',
            ));

            // Right Side
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.home-recent-mostvaluable-sitebusinessmember',
                'parent_content_id' => $right_id,
                'order'             => 20,
                'params'            => '{"title":"Top Business Joiners","select_option":"2","titleCount":"true"}',
            ));

            // Right Side
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.search-sitebusinessmember',
                'parent_content_id' => $right_id,
                'order'             => 18,
                'params'            => '',
            ));

            // Right Side
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.sitebusinessmemberlist-link',
                'parent_content_id' => $right_id,
                'order'             => 19,
                'params'            => '',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.member-of-the-day',
                'parent_content_id' => $left_id,
                'order'             => 15,
                'params'            => '{"title":"Member of the Day"}',
            ));
        }

        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'communityad')
            ->where('enabled 	 = ?', 1)
            ->limit(1);
        $infomation = $select->query()->fetch();

        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.communityads')
            ->where('value 	 = ?', 1)
            ->limit(1);
        $rowinfo = $select->query()->fetch();

        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'sitebusinessmember_index_browse')
            ->limit(1);
        $info_browse = $select->query()->fetch();

        if (empty($info_browse)) {
            $db->insert('engine4_core_pages', array(
                'name'        => 'sitebusinessmember_index_browse',
                'displayname' => 'Browse Business Members',
                'title'       => 'Business Members',
                'description' => 'This is the business members.',
                'custom'      => 1,
            ));
            $business_id = $db->lastInsertId('engine4_core_pages');

            //CONTAINERS
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'main',
                'parent_content_id' => null,
                'order'             => 2,
                'params'            => '',
            ));
            $container_id = $db->lastInsertId('engine4_core_content');

            //INSERT MAIN - MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $container_id,
                'order'             => 6,
                'params'            => '',
            ));
            $middle_id = $db->lastInsertId('engine4_core_content');

            //INSERT MAIN - RIGHT CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'right',
                'parent_content_id' => $container_id,
                'order'             => 5,
                'params'            => '',
            ));
            $right_id = $db->lastInsertId('engine4_core_content');

            //INSERT TOP CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'top',
                'parent_content_id' => null,
                'order'             => 1,
                'params'            => '',
            ));
            $top_id = $db->lastInsertId('engine4_core_content');

            //INSERT TOP- MIDDLE CONTAINER
            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'container',
                'name'              => 'middle',
                'parent_content_id' => $top_id,
                'order'             => 6,
                'params'            => '',
            ));
            $top_middle_id = $db->lastInsertId('engine4_core_content');

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusiness.browsenevigation-sitebusiness',
                'parent_content_id' => $top_middle_id,
                'order'             => 1,
                'params'            => '{"title":"","titleCount":""}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.search-sitebusinessmember',
                'parent_content_id' => $right_id,
                'order'             => 3,
                'params'            => '{"title":"","titleCount":"true"}',
            ));

            $db->insert('engine4_core_content', array(
                'page_id'           => $business_id,
                'type'              => 'widget',
                'name'              => 'sitebusinessmember.sitebusiness-member',
                'parent_content_id' => $middle_id,
                'order'             => 2,
                'params'            => '{"title":"","titleCount":""}',
            ));

            if (!empty($infomation) && !empty($rowinfo)) {
                $db->insert('engine4_core_content', array(
                    'page_id'           => $business_id,
                    'type'              => 'widget',
                    'name'              => 'sitebusiness.business-ads',
                    'parent_content_id' => $right_id,
                    'order'             => 11,
                    'params'            => '{"title":"","titleCount":""}',
                ));
            }
        }

        //Member home business
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_pages')
            ->where('name = ?', 'user_index_home')
            ->limit(1);
        $business_id = $select->query()->fetchObject()->page_id;
        if (!empty($business_id)) {
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_core_content')
                ->where('page_id = ?', $business_id)
                ->where('type = ?', 'container')
                ->where('name = ?', 'main')
                ->limit(1);
            $container_id = $select->query()->fetchObject()->content_id;
            if (!empty($container_id)) {
                $select = new Zend_Db_Select($db);
                $select
                    ->from('engine4_core_content')
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
                    ->where('name = ?', 'right')
                    ->limit(1);
                $right_id = $select->query()->fetchObject()->content_id;
                if (!empty($right_id)) {
                    $select = new Zend_Db_Select($db);
                    $select
                        ->from('engine4_core_content')
                        ->where('parent_content_id = ?', $right_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'sitebusinessmember.mostjoined-sitebusiness');
                    $info = $select->query()->fetch();
                    if (empty($info)) {
                        $db->insert('engine4_core_content', array(
                            'page_id'           => $business_id,
                            'type'              => 'widget',
                            'name'              => 'sitebusinessmember.mostjoined-sitebusiness',
                            'parent_content_id' => $right_id,
                            'order'             => 1,
                            'params'            => '{"title":"Most Joined Businesses"}',
                        ));
                    }
                }
            }
        }

        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if ($is_sitemobile_object) {
            include APPLICATION_PATH . "/application/modules/Sitebusinessmember/controllers/license/mobileLayoutCreation.php";
        }

        //For add column in the 'engine4_sitebusiness_businesses' table.
        $email_field = $db->query("SHOW COLUMNS FROM engine4_sitebusiness_membership LIKE 'email'")->fetch();
        if (empty($email_field)) {
            $db->query("ALTER TABLE `engine4_sitebusiness_membership` ADD `email` TINYINT( 1 ) NOT NULL DEFAULT '1'");
        }

        $db->query("INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ('sitebusiness_gutter_notifications', 'sitebusinessmember', 'Notification Settings', 'Sitebusinessmember_Plugin_Menus::sitebusinessGutterNotificationSettings', '', 'sitebusiness_gutter', NULL, '1', '0', '999');");

        $db->query("INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ('sitebusiness_gutter_notifications', 'sitebusinessmember', 'Notification Settings', 'Sitebusinessmember_Plugin_Menus::sitebusinessGutterNotificationSettings', '', 'sitebusiness_gutter', NULL, '1', '0', '999');");

        //updated the member level setting of business if document integration is installed, added option of content member
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'documentintegration.isActivate')
            ->where('value = ?', 1);
        $documentintegration_isActivate_object = $select->query()->fetchObject();
        if ($documentintegration_isActivate_object) {
            $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitebusiness_business' AND `engine4_authorization_permissions`.`name` = 'auth_sdcreate';
		    ");
        }

        //updated the member level setting of business if video integration is installed, added option of content member
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitevideointegration.isActivate')
            ->where('value = ?', 1);
        $sitevideointegration_isActivate_object = $select->query()->fetchObject();
        if ($sitevideointegration_isActivate_object) {
            $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitebusiness_business' AND `engine4_authorization_permissions`.`name` = 'auth_svcreate';
		    ");
        }

        //updated the member level setting of business if crowdfunding is installed, added option of content member
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitecrowdfunding.isActivate')
            ->where('value = ?', 1);
        $sitecrowdfunding_isActivate_object = $select->query()->fetchObject();
        if ($sitecrowdfunding_isActivate_object) {
            $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitebusiness_business' AND `engine4_authorization_permissions`.`name` = 'auth_sprcreate';
		    ");
        }
        parent::onInstall();
    }

    public function onPostInstall()
    {
        $db     = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessmember','1')");
            $select = new Zend_Db_Select($db);
            $select
                ->from('engine4_sitemobile_modules')
                ->where('name = ?', 'sitebusinessmember')
                ->where('integrated = ?', 0);
            $is_sitemobile_object = $select->query()->fetchObject();
            if ($is_sitemobile_object) {
                $actionName     = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
                $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
                if ($controllerName == 'manage' && $actionName == 'install') {
                    $view       = new Zend_View();
                    $baseUrl    = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessmember/integrated/0/redirect/install');
                }
            }
        }

        //Work for the word changes in the business plugin .csv file.
        $actionName     = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
        $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
        if ($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
            $view       = new Zend_View();
            $baseUrl    = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
            $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
            if ($actionName == 'install') {
                $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
            } else {
                $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
            }
        }
    }
}