<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessmusic_Api_Core extends Core_Api_Abstract {

  /**
   * Return a truncate text
   *
   * @param text text 
   * @return truncate text
  * */
  public function truncation($string) {
    $length = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.truncation.limit', 13);
    $string = strip_tags($string);
    return Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }
  
  public function enableComposer() {
    $subject = '';
    if (Engine_Api::_()->core()->hasSubject()) {
      $subject = Engine_Api::_()->core()->getSubject();
    }
    if ($subject && in_array($subject->getType(), array('sitebusiness_business', 'sitebusinessevent_event'))):
 

      if (in_array($subject->getType(), array('sitebusinessevent_event'))):
        $subject = Engine_Api::_()->getItem('sitebusiness_business', $subject->business_id);
      endif;
      //PACKAGE BASE PRIYACY START
      if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitebusiness()->allowPackageContent($subject->package_id, "modules", "sitebusinessmusic")) {
          return false;
        }
      } else {
        $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($subject, 'smcreate');
        if (empty($isBusinessOwnerAllow)) {
          return false;
        }
      }
      if (!Engine_Api::_()->sitebusiness()->isManageAdmin($subject, 'edit') && !Engine_Api::_()->sitebusiness()->isManageAdmin($subject, 'smcreate')):
        return false;
      endif;
      return true;
    endif;
    return false;
  }
 
 
}

?>