<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http:// www.socialengineaddons.com/license/
 * @version    $Id: widgetSettings.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitebusiness')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

//CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitebusiness.is.active')
        ->limit(1);
$sitebusiness_settings = $select->query()->fetchAll();
if (!empty($sitebusiness_settings)) {
  $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
} else {
  $sitebusiness_is_active = 0;
}

//CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitebusiness')
        ->where('enabled = ?', 1);
$check_sitebusiness = $select->query()->fetchObject();
if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_business = $select->from('engine4_core_pages', 'page_id')->where('name = ?', 'sitebusiness_index_view')->limit(1);
  $business = $select_business->query()->fetchAll();
  if (!empty($business)) {
    $business_id = $business[0]['page_id'];

    //INSERTING THE MUSIC WIDGET IN SITEBUSINESS_ADMIN_CONTENT TABLE ALSO.
    Engine_Api::_()->getDbtable('admincontent', 'sitebusiness')->setAdminDefaultInfo('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');

    //INSERTING THE MUSIC WIDGET IN CORE_CONTENT TABLE ALSO.
    Engine_Api::_()->getApi('layoutcore', 'sitebusiness')->setContentDefaultInfo('sitebusinessmusic.profile-sitebusinessmusic', $business_id, 'Music', 'true', '120');

    //INSERTING THE MUSIC WIDGET IN SITEBUSINESS_CONTENT TABLE ALSO.
    $select = new Zend_Db_Select($db);
    $contentbusiness_ids = $select->from('engine4_sitebusiness_contentbusinesses', 'contentbusiness_id')->query()->fetchAll();
    foreach ($contentbusiness_ids as $contentbusiness_id) {
      if (!empty($contentbusiness_id)) {
        Engine_Api::_()->getDbtable('content', 'sitebusiness')->setDefaultInfo('sitebusinessmusic.profile-sitebusinessmusic', $contentbusiness_id['contentbusiness_id'], 'Music', 'true', '120');
        //INSERT THE BUSINESS PROFILE PLAYER WIDGET
        $select = new Zend_Db_Select($db);
        $select_content = $select
                ->from('engine4_sitebusiness_content')
                ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
                ->where('type = ?', 'widget')
                ->where('name = ?', 'sitebusinessmusic.profile-player')
                ->limit(1);
        $content = $select_content->query()->fetchAll();
        if (empty($content)) {
          $select = new Zend_Db_Select($db);
          $select_container = $select
                  ->from('engine4_sitebusiness_content', 'content_id')
                  ->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
                  ->where('type = ?', 'container')
                  ->limit(1);
          $container = $select_container->query()->fetchAll();
          if (!empty($container)) {
            $container_id = $container[0]['content_id'];
            $select = new Zend_Db_Select($db);
            $select_left = $select
                    ->from('engine4_sitebusiness_content')
                    ->where('parent_content_id = ?', $container_id)
                    ->where('type = ?', 'container')
										->where('contentbusiness_id = ?', $contentbusiness_id['contentbusiness_id'])
										->where('name in (?)', array('left', 'right'))
                    ->limit(1);
            $left = $select_left->query()->fetchAll();
            if (!empty($left)) {
              $left_id = $left[0]['content_id'];
              $db->insert('engine4_sitebusiness_content', array(
                  'contentbusiness_id' => $contentbusiness_id['contentbusiness_id'],
                  'type' => 'widget',
                  'name' => 'sitebusinessmusic.profile-player',
                  'parent_content_id' => $left_id,
                  'order' => 26,
                  'params' => '{"title":"","titleCount":""}',
              ));
            }
          }
        }
      }
    }
    //INSERT THE BUSINESS PROFILE PLAYER WIDGET
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_core_content')
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinessmusic.profile-player')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_core_content', 'content_id')
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['content_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_core_content')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('page_id = ?', $business_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['content_id'];
          $db->insert('engine4_core_content', array(
              'page_id' => $business_id,
              'type' => 'widget',
              'name' => 'sitebusinessmusic.profile-player',
              'parent_content_id' => $left_id,
              'order' => 26,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
    }  
    //INSERT THE BUSINESS PROFILE PLAYER WIDGET
    $select = new Zend_Db_Select($db);
    $select_content = $select
            ->from('engine4_sitebusiness_admincontent')
            ->where('business_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinessmusic.profile-player')
            ->limit(1);
    $content = $select_content->query()->fetchAll();
    if (empty($content)) {
      $select = new Zend_Db_Select($db);
      $select_container = $select
              ->from('engine4_sitebusiness_admincontent', 'admincontent_id')
              ->where('business_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container = $select_container->query()->fetchAll();
      if (!empty($container)) {
        $container_id = $container[0]['admincontent_id'];
        $select = new Zend_Db_Select($db);
        $select_left = $select
                ->from('engine4_sitebusiness_admincontent')
                ->where('parent_content_id = ?', $container_id)
                ->where('type = ?', 'container')
								->where('business_id = ?', $business_id)
								->where('name in (?)', array('left', 'right'))
                ->limit(1);
        $left = $select_left->query()->fetchAll();
        if (!empty($left)) {
          $left_id = $left[0]['admincontent_id'];
          $db->insert('engine4_sitebusiness_admincontent', array(
              'business_id' => $business_id,
              'type' => 'widget',
              'name' => 'sitebusinessmusic.profile-player',
              'parent_content_id' => $left_id,
              'order' => 26,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
    }      
  }
  
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessmusic_playlist_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessmusic_playlist_browse',
        'displayname' => 'Browse Business music',
        'title' => 'Business Music List',
        'description' => 'This is the business music.',
        'custom' => 1,
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $business_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $business_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $business_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $business_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $business_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.browsenevigation-sitebusiness', $top_middle_id, 1);

//INSERT MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.sitebusiness-music', $middle_id, 2);

    //INSERT SEARCH BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.search-sitebusinessmusic', $right_id, 3, "", "true");

    //INSERT MOST COMMENTED BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.homecomment-sitebusinessmusic', $right_id, 4, "Most Commented Playlists", "true");

    //INSERT SPONSORED BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.sitebusiness-sponsoredmusic', $right_id, 5, "Sponsored Playlists", "true");

    //INSERT MOST LIKED BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.homelike-sitebusinessmusic', $right_id, 6, "Most Liked Playlists", "true");

    //INSERT RECENT BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.homerecent-sitebusinessmusic', $right_id, 7, "Recent Business Playlists", "true");

   //INSERT POPULAR BUSINESS MUSIC WIDGET
    Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusinessmusic.homepopular-sitebusinessmusic', $right_id, 8, "Popular Business Playlists", "true");

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'communityad')
            ->where('enabled 	 = ?', 1)
            ->limit(1);
    ;
    $infomation = $select->query()->fetch();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.communityads')
            ->where('value 	 = ?', 1)
            ->limit(1);
    ;
    $rowinfo = $select->query()->fetch();
    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 10, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitebusinessmusic_playlist_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitebusinessmusic_playlist_view',
        'displayname' => 'Business Music View Page',
        'title' => 'View Business Music',
        'description' => 'This is the view business for a business music.',
        'custom' => 1,
        'provides' => 'subject=sitebusinessmusic',
    ));
    $business_id = $db->lastInsertId('engine4_core_pages');

   // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $business_id,
        'type' => 'widget',
        'name' => 'sitebusinessmusic.music-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));
    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitebusiness()->setDefaultDataContentWidget($contentTable, $contentTableName, $business_id, 'widget', 'sitebusiness.business-ads', $right_id, 1, "", "true");
    }
  }

  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitebusinessmusic_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessmusic_mobi_view',
						'displayname' => 'Mobile Business Music Profile',
						'title' => 'Mobile Business Music Profile',
						'description' => 'This is the mobile verison of a Business music profile business.',
						'custom' => 0,
			));
			$business_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $business_id,
					'type' => 'widget',
					'name' => 'sitebusinessmusic.music-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));
		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
	VALUES ("sitebusinessmusic_admin_widget_settings", "sitebusinessmusic", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"widgets"}\', "sitebusinessmusic_admin_main", "", 1, 0, 3)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_general_tab", "sitebusinessmusic", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"widgets", "action": "index"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_music_tab", "sitebusinessmusic", "Tabbed Musics Widget", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"settings", "action": "widget"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessmusic_admin_submain_dayitems", "sitebusinessmusic", "Music of the Day", "", \'{"route":"admin_default","module":"sitebusinessmusic","controller":"settings", "action": "manage-day-items"}\', "sitebusinessmusic_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitebusinessmusic_playlist_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitebusinessmusic_playlist_home',
				'displayname' => 'Business Music Home',
				'title' => 'Business Music Home',
				'description' => 'This is business music home business.',
				'custom' => 1
		));
		$business_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusiness.browsenevigation-sitebusiness',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.homerecent-sitebusinessmusic',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Recent Business Playlists","titleCount":"true"}',
		));

    $db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.homepopular-sitebusinessmusic',
				'parent_content_id' => $left_id,
				'order' => 15,
				'params' => '{"title":"Popular Business Playlists","titleCount":"true"}',
		));

	// Middele
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.featured-musics-carousel',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Featured Playlists","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitebusinessmusic.featured-musics-carousel"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.list-musics-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 18,
				'params' => '{"title":"Playlists","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.sitebusinessmusiclist-link',
				'parent_content_id' => $right_id,
				'order' => 20,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.search-sitebusinessmusic',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.music-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Playlist of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.homefeaturelist-sitebusinessmusics',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Playlists","itemCountPerBusiness":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.homecomment-sitebusinessmusic',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Playlists","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $business_id,
				'type' => 'widget',
				'name' => 'sitebusinessmusic.homelike-sitebusinessmusic',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Playlists","titleCount":"true"}',
		));
	}
}
?>