<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessmusic.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Music',
        'description' => 'This widget forms the Music tab on the Business Profile and displays the music of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.profile-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Music',
        ),
    ),
    array(
        'title' => 'Business Profile Most Popular Playlists',
        'description' => "Displays list of a Business's most played playlists. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.popular-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Popular Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Commented Playlists',
        'description' => "Displays list of Business's most commented playlists. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.comment-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Commented Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Recent Playlists',
        'description' => "Displays list of a Business's most recent playlists. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.recent-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Recent Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Liked Playlists',
        'description' => "Displays list of Business's most liked playlists. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.like-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Liked Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Recent Business Playlists',
        'description' => 'Displays list of recent playlists of businesses on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.homerecent-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Recent Business Playlists'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Popular Business Playlists',
        'description' => 'Displays the Most Popular Business Playlists. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.homepopular-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Popular Business Playlists'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Player',
        'description' => 'Displays a music player that plays the playlist the Business Admin has selected to play on their Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.profile-player',
    ),

    array(
			'title' => 'Search Business Music form',
			'description' => 'Displays the form for searching Business Music on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessmusic.search-sitebusinessmusic',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Music form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Music Title", "5" => "Business Category"),
									),
							),
					),
			)
    ),

    array(
        'title' => 'Business Music',
        'description' => 'Displays the list of Music from Businesses created on your community. This widget should be placed in the widgetized Business Music business. Results from the Search Business Music form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.sitebusiness-music',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Most Commented Business Playlists',
        'description' => "Displays the Most Commented Business Playlists. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.homecomment-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Commented Playlists',
            'titleCount' => true,array(
        'title' => 'Featured Playlists',
        'description' => "Displays Featured Business Playlists. You can mark Business Playlists as Featured from the “Manage Business Playlists” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessplaylist.homefeaturelist-sitebusinessplaylists',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of playlists to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Playlists',
        'description' => "Displays the Playlists from Paid Businesses. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.sitebusiness-sponsoredmusic',
        'defaultParams' => array(
            'title' => 'Sponsored Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
        'title' => 'Most Liked Business Playlists',
        'description' => "Displays the Most Liked Business Playlists. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.homelike-sitebusinessmusic',
        'defaultParams' => array(
            'title' => 'Most Liked Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),
  
    array(
			'title' => 'Business Music View',
			'description' => "This widget should be placed on the Business Music View Page.",
      'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessmusic.music-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
  array(
        'title' => 'Featured Playlists',
        'description' => "Displays Featured Business Playlists. You can mark Business Playlists as Featured from the “Manage Business Playlists” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.homefeaturelist-sitebusinessmusics',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of playlists to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    ),
    array(
        'title' => 'Business’s Featured Playlists Slideshow',
        'description' => 'Displays featured playlists in an attractive slideshow. You can set the count of the number of playlists to show in this widget. If the total number of playlists featured are more than that count, then the playlists to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.featured-musics-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'itemCountPerBusiness' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Business’s Featured Playlists Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured playlists on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.featured-musics-carousel',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Playlists in a Row',
                        'description' => '(number of playlists to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Business’s Ajax based Tabbed widget for Playlists',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented, Featured and Random Playlists in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Music Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.list-musics-tabs-view',
        'defaultParams' => array(
            'title' => 'Playlists',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),

    array(
        'title' => 'Browse Playlists',
        'description' => 'Displays the link to view Business’s Playlists Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.sitebusinessmusiclist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Business’s Playlist of the Day',
        'description' => 'Displays the Playlist of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Musics Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessmusic.music-of-the-day',
        'defaultParams' => array(
            'title' => 'Playlist of the Day'
        ),
    ),

    array(
    'title' => 'Top Creators : Business Music',
    'description' => 'Displays the Businesses which have the most number of Business Music added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessmusic.topcreators-sitebusinessmusic',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessmusic',
    ),
  ),
)
?>