<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessnote.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Notes',
        'description' => 'This widget forms the Notes tab on the Business Profile and displays the notes of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessnote.profile-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Notes',
        ),
    ),
    array(
        'title' => 'Business Profile Most Commented Notes',
        'description' => 'Displays list of a Business\'s most commented notes. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessnote.comment-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Most Commented Notes',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Recent Notes',
        'description' => 'Displays list of a Business\'s most recent notes. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessnote.recent-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Most Recent Notes',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Business Profile Most Liked Notes',
        'description' => 'Displays list of a Business\'s most liked notes. This widget should be placed on the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessnote.like-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Most Liked Notes',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Recent Notes',
        'description' => 'Displays list of recent notes on the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.homerecent-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Recent Notes'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
								array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
            ),
        ),
    ),
 
     array(
        'title' => 'Business Notes',
        'description' => 'Displays a list of all the business notes on site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.sitebusiness-note',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
			'title' => 'Business Note View',
			'description' => "Displays the list of Notes from Businesses created on your community. This widget should be placed in the widgetized Business Notes business. Results from the Search Business Notes form are also shown here.",
      'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessnote.note-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

    array(
        'title' => 'Most Commented Notes',
        'description' => 'Displays the Most Commented Business Notes. You can choose the number of entries to be shown',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.homecomment-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Most Commented Notes'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Most Liked Notes',
        'description' => 'Displays the Most Liked Business Notes. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.homelike-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Most Liked Notes'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Notes',
        'description' => "Displays the Notes from Paid Businesses. You can choose the number of entries to be shown",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.sitebusiness-sponsorednote',
        'defaultParams' => array(
            'title' => 'Sponsored Notes',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of notes to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
			'title' => 'Search Business Notes form',
			'description' => 'Displays the form for searching Business Notes on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessnote.search-sitebusinessnote',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5', "5" => "6"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Notes form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Note Keywords", "5" => "Business Category", "6" => "Note Category"),
									),
							),
					),
			)
    ),

    array(
    'title' => 'Related Notes',
    'description' => 'Displays a list of other business notes that are similar to the current business notes, based on tags.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessnote.show-same-tags',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Related Notes',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of notes to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessnote',
    ),
  ),
  array(
  'title' => 'Popular Note Tags',
  'description' => 'Shows popular tags with frequency.',
  'category' => 'Businesses',
  'type' => 'widget',
  'name' => 'sitebusinessnote.tagcloud-sitebusinessnote',
  'adminForm' => array(
       'elements' => array(
         array(
           'hidden',
           'title',
           array(
             'label' => '',
             'order' => 1001
           )
         ),
         array(
           'hidden',
           'nomobile',
           array(
             'label' => '',
             'order' => 1002
           )
         ),
         array(
           'hidden',
           'execute',
           array(
             'label' => '',
             'order' => 1003
           )
         ),
         array(
           'hidden',
           'cancel',
           array(
             'label' => '',
             'order' => 1004
           )
         ),
       )
     ),
    ),
   
    array(
        'title' => 'Business’s Featured Notes Slideshow',
        'description' => 'Displays featured notes in an attractive slideshow. You can set the count of the number of notes to show in this widget. If the total number of notes featured are more than that count, then the notes to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.featured-notes-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Notes',
            'itemCountPerBusiness' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

  array(
        'title' => 'Business’s Featured Notes Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured notes on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.featured-notes-carousel',
        'defaultParams' => array(
            'title' => 'Featured Notes',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Notes in a Row',
                        'description' => '(number of notes to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

  array(
        'title' => 'Business’s Ajax based Tabbed widget for Notes',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Notes in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Notes Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.list-notes-tabs-view',
        'defaultParams' => array(
            'title' => 'Notes',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              ),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							)
            ),
        ),
    ),

  array(
        'title' => 'Browse Notes',
        'description' => 'Displays the link to view Business’s Notes Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.sitebusinessnotelist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

  array(
        'title' => 'Business’s Note of the Day',
        'description' => 'Displays the Note of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Notes Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.note-of-the-day',
        'defaultParams' => array(
            'title' => 'Note of the Day'
        ),
    ),
  
    array(
        'title' => 'Featured Notes',
        'description' => "Displays Featured Business Notes. You can mark Business Notes as Featured from the “Manage Business Notes” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessnote.homefeaturelist-sitebusinessnotes',
        'defaultParams' => array(
            'title' => 'Featured Notes',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of notes to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

     array(
    'title' => 'Top Creators : Business Notes',
    'description' => 'Displays the Businesses which have the most number of Business Notes added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessnote.topcreators-sitebusinessnote',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessnote',
    ),
  ),
)
?>