<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessnote.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Notes'),
        'description' => $view->translate('Forms the Notes tab of your Business and shows notes of your Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.profile-sitebusinessnotes',
        'defaultParams' => array(
            'title' => $view->translate('Notes'),
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Commented Notes'),
        'description' => $view->translate('Displays your Business\'s most commented notes.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.comment-sitebusinessnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Notes'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Recent Notes'),
        'description' => $view->translate('Displays your Business\'s most recent notes.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.recent-sitebusinessnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Notes'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Profile Most Liked Notes'),
        'description' => $view->translate('Displays your Business\'s most liked notes.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.like-sitebusinessnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Notes'),
            'titleCount' => true,
        ),
    ),
)
?>