<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessnote_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    //GET DB
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if ( !empty($sitebusiness_settings) ) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    }
    else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();

    if ( !empty($check_sitebusiness) && !empty($sitebusiness_is_active) ) {
      $PRODUCT_TYPE = 'sitebusinessnote';
      $PLUGIN_TITLE = 'Sitebusinessnote';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessnote Plugin';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.5';      
      $SocialEngineAddOns_version = '4.10.3p6';
      $PRODUCT_TITLE = 'Directory / Businesses - Notes Extension';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if ( empty($is_file) ) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      }
      else {
        include $file_path;
      }


      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessnote.basetime', $businessTime ),
			('sitebusinessnote.isvar', 0 ),
			('sitebusinessnote.filepath', 'Sitebusinessnote/controllers/license/license2.php');");      
      parent::onPreInstall();
    }
    elseif ( !empty($check_sitebusiness) && empty($sitebusiness_is_active) ) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if ( strstr($url_string, "manage/install") ) {
        $calling_from = 'install';
      }
      else if ( strstr($url_string, "manage/query") ) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ( $explode_base_url as $url_key ) {
        if ( $url_key != 'install' ) {
          $core_final_url .= $url_key . '/';
        }
      }
      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Notes Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    }
    else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-notes' target='_blank'>Directory / Businesses - Notes Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onInstall() {

//    //START CODE FOR LIGHTBOX
//    //HERE WE CHECKING THAT SITEBUSINESSALBUM ENTRY EXIST IN THE CORE MODULE TABLE OR NOT
//    $select = new Zend_Db_Select($db);
//    $select
//            ->from('engine4_core_modules', array('version'))
//            ->where("name =?", "sitebusinessnote");
//    $sitebusinessnoteVersion = $select->query()->fetchAll();
//
//    //IF NOT EXIST THEN WE INSERTING THE LIGHTBOX SHOULD BE DISPLAY OR NOT
//    if (empty($sitebusinessnoteVersion)) {
//      $value = '';
//      $select = new Zend_Db_Select($db);
//      $value = $select
//              ->from('engine4_core_settings', array('value'))
//              ->where("name =?", "socialengineaddon.display.lightbox")
//              ->query()
//              ->fetchColumn();
//
//      //IF LIGHTBOX IS NOT DISPLAY THEN WE WILL INSERTING THE ACTIVITY FEED VALUE
//      if (empty($value)) {        
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("name Like ?", "%socialengineaddon.lightbox.option.display%");
//        $name = $select->query()->fetchAll();
//
//        $count = count($name);
//
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("value =?", "sitebusinessnote");
//        $name = $select->query()->fetchColumn();
//        if (empty($name)) {
//          $name = 'socialengineaddon.lightbox.option.display.' . ++$count;
//          $db->insert('engine4_core_settings', array(
//              'name' => $name,
//              'value' => 'sitebusinessnote'
//          ));
//        }      
//      }          
//    }
//    //END CODE FOR LIGHTBOX    
    
    //START THE WORK FOR MAKE WIDGETIZE BUSINESS OF NOTES LISTING AND NOTE VIEW BUSINESS
    $db = $this->getDb();

    $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a business note {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitebusinessnote_create";');
 
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusinessnote.is.active')
            ->limit(1);
    $sitebusinessnote_settings = $select->query()->fetchAll();

    // WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_menuitems')
		->where('name = ?', 'sitebusinessnote_admin_widget_settings')
		->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitebusinessnote_settings)) {
		$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitebusinessnote_admin_widget_settings", "sitebusinessnote", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"widgets"}\', "sitebusinessnote_admin_main", "", 0, 3, 1)');
		}

    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessnote')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitebusinessnote_index_notelist')
              ->limit(1);
      ;
      $info = $select->query()->fetch();

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitebusinessnote_index_browse')
              ->limit(1);
      ;
      $info_browse = $select->query()->fetch();
   
      if ( empty($info) && empty($info_browse) ) {
        $db->insert('engine4_core_pages', array(
            'name' => 'sitebusinessnote_index_browse',
            'displayname' => 'Browse Business Notes',
						'title' => 'Business Notes List',
						'description' => 'This is the business notes.',
						'custom' => 1,
        ));
        $business_id = $db->lastInsertId('engine4_core_pages');

        //CONTAINERS
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'main',
            'parent_content_id' => Null,
            'order' => 2,
            'params' => '',
        ));
        $container_id = $db->lastInsertId('engine4_core_content');

        //INSERT MAIN - MIDDLE CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $container_id,
            'order' => 6,
            'params' => '',
        ));
        $middle_id = $db->lastInsertId('engine4_core_content');


        //INSERT MAIN - RIGHT CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'right',
            'parent_content_id' => $container_id,
            'order' => 5,
            'params' => '',
        ));
        $right_id = $db->lastInsertId('engine4_core_content');


        //INSERT TOP CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'top',
            'parent_content_id' => Null,
            'order' => 1,
            'params' => '',
        ));
        $top_id = $db->lastInsertId('engine4_core_content');


        //INSERT TOP- MIDDLE CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $top_id,
            'order' => 6,
            'params' => '',
        ));
        $top_middle_id = $db->lastInsertId('engine4_core_content');


        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusiness.browsenevigation-sitebusiness',
            'parent_content_id' => $top_middle_id,
            'order' => 1,
            'params' => '{"title":"","titleCount":""}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.search-sitebusinessnote',
            'parent_content_id' => $right_id,
            'order' => 3,
            'params' => '{"title":"","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.sitebusiness-note',
            'parent_content_id' => $middle_id,
            'order' => 2,
            'params' => '{"title":"","titleCount":""}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.homecomment-sitebusinessnotes',
            'parent_content_id' => $right_id,
            'order' => 4,
            'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.sitebusiness-sponsorednote',
            'parent_content_id' => $right_id,
            'order' => 5,
            'params' => '{"title":"Sponsored Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.homelike-sitebusinessnotes',
            'parent_content_id' => $right_id,
            'order' => 6,
            'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.homerecent-sitebusinessnotes',
            'parent_content_id' => $right_id,
            'order' => 7,
            'params' => '{"title":"Recent Notes","titleCount":"true"}',
        ));

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'communityad')
                ->where('enabled 	 = ?', 1)
                ->limit(1);
        ;
        $infomation = $select->query()->fetch();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitebusiness.communityads')
                ->where('value 	 = ?', 1)
                ->limit(1);
        $rowinfo = $select->query()->fetch();
        if ( $infomation && $rowinfo ) {
          $db->insert('engine4_core_content', array(
              'page_id' => $business_id,
              'type' => 'widget',
              'name' => 'sitebusiness.business-ads',
              'parent_content_id' => $right_id,
              'order' => 10,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
       else {
        $db->update('engine4_core_pages', array('name' => 'sitebusinessnote_index_browse'), array('name = ?' => 'sitebusinessnote_index_notelist'));
      }

      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      // Check if it's already been placed
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitebusinessnote_index_view')
              ->limit(1);
      ;
      $info = $select->query()->fetch();

      if ( empty($info) ) {
        $db->insert('engine4_core_pages', array(
            'name' => 'sitebusinessnote_index_view',
            'displayname' => 'Business Note View Page',
						'title' => 'View Business Note',
						'description' => 'This is the view business for a business note.',
						'custom' => 1,
						'provides' => 'subject=sitebusinessnote',
        ));
        $business_id = $db->lastInsertId('engine4_core_pages');

        // containers
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'main',
            'parent_content_id' => null,
            'order' => 1,
            'params' => '',
        ));
        $container_id = $db->lastInsertId('engine4_core_content');

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'right',
            'parent_content_id' => $container_id,
            'order' => 1,
            'params' => '',
        ));
        $right_id = $db->lastInsertId('engine4_core_content');

        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $container_id,
            'order' => 3,
            'params' => '',
        ));
        $middle_id = $db->lastInsertId('engine4_core_content');

        // middle column content
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.note-content',
            'parent_content_id' => $middle_id,
            'order' => 1,
            'params' => '',
        ));

        // right column
        $db->insert('engine4_core_content', array(
            'page_id' => $business_id,
            'type' => 'widget',
            'name' => 'sitebusinessnote.show-same-tags',
            'parent_content_id' => $right_id,
            'order' => 1,
            'params' => '{"title":"Related Notes","titleCount":""}',
        ));

        $select = new Zend_Db_Select($db);
		    $select
						->from('engine4_core_modules')
						->where('name = ?', 'communityad')
						->where('enabled 	 = ?', 1)
						->limit(1);
			  ;
				$infomation = $select->query()->fetch();
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_settings')
								->where('name = ?', 'sitebusiness.communityads')
								->where('value 	 = ?', 1)
								->limit(1);
				$rowinfo = $select->query()->fetch();
				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 2,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}

			$select = new Zend_Db_Select($db);
			$select
			->from('engine4_core_modules')
			->where('name = ?', 'mobi')
			->where('enabled 	 = ?', 1)
			->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
				->from('engine4_core_pages')
				->where('name = ?', 'sitebusinessnote_mobi_view')
				->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
								'name' => 'sitebusinessnote_mobi_view',
								'displayname' => 'Mobile Business Note Profile',
								'title' => 'Mobile Business Note Profile',
								'description' => 'This is the mobile verison of a Business note profile business.',
								'custom' => 0,
					));
					$business_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'main',
								'parent_content_id' => null,
								'order' => 1,
								'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'right',
								'parent_content_id' => $container_id,
								'order' => 1,
								'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $business_id,
								'type' => 'container',
								'name' => 'middle',
								'parent_content_id' => $container_id,
								'order' => 3,
								'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessnote.note-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));

					// right column
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessnote.show-same-tags',
							'parent_content_id' => $right_id,
							'order' => 1,
							'params' => '{"title":"Related Notes"}',
					));
				}
			}
    }
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitebusinessnote')
					->where('version < ?', '4.2.1');
		$is_enabled_note = $select->query()->fetchObject();
		if($is_enabled_note) {
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_general_tab", "sitebusinessnote", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"widgets", "action": "index"}\', "sitebusinessnote_admin_submain", "", 1, 0, 1)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_note_tab", "sitebusinessnote", "Tabbed Notes Widget", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings", "action": "widget"}\', "sitebusinessnote_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessnote_admin_submain_dayitems", "sitebusinessnote", "Note of the Day", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings", "action": "manage-day-items"}\', "sitebusinessnote_admin_submain", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessnote_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessnote_index_home',
						'displayname' => 'Business Notes Home',
						'title' => 'Business Notes Home',
						'description' => 'This is business note home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.homerecent-sitebusinessnotes',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Recent Business Notes","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.featured-notes-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 15,
						'params' => '{"title":"Featured Notes","titleCount":"true"}',
				));
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.list-notes-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Notes","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.sitebusinessnotelist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.search-sitebusinessnote',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.note-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Note of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.homefeaturelist-sitebusinessnotes',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Notes","itemCountPerBusiness":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.homecomment-sitebusinessnotes',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessnote.homelike-sitebusinessnotes',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
				));
			}
      $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessnote_notes LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessnote_notes` ADD `featured` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `photo_id`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Notes'), array('displayname = ?' => 'Business Notes')); 
    }  
    //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF NOTES LISTING AND NOTE VIEW BUSINESS
      $select = new Zend_Db_Select($db);
      $select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitebusiness.feed.type');
      $info = $select->query()->fetch();
      $enable = 1;
      if (!empty($info)) 
      $enable = $info['value'];
      $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitebusinessnote_admin_new", "sitebusinessnote", "{item:$object} created a new note:", '.$enable.' , 6, 2, 1, 1, 1, 1)');
      
      
    $categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessnote_notes LIKE 'category_id'")->fetch();
    if (empty($categoryIdColumn)) {
      $db->query("ALTER TABLE `engine4_sitebusinessnote_notes` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
    }
    
    $categoryTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitebusinessnote_categories'")->fetch();
    if(empty($categoryTableExist)) {
      $db->query("
        CREATE TABLE IF NOT EXISTS `engine4_sitebusinessnote_categories` (
          `category_id` int(11) unsigned NOT NULL auto_increment,
          `title` varchar(64) NOT NULL,
          PRIMARY KEY  (`category_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci ;
      ");
      
      $db->query("
        INSERT IGNORE INTO `engine4_sitebusinessnote_categories` (`title`) VALUES
        ('Arts'),
        ('Business'),
        ('Conferences'),
        ('Festivals'),
        ('Food'),
        ('Fundraisers'),
        ('Galleries'),
        ('Health'),
        ('Just For Fun'),
        ('Kids'),
        ('Learning'),
        ('Literary'),
        ('Movies'),
        ('Museums'),
        ('Neighborhood'),
        ('Networking'),
        ('Nightlife'),
        ('On Campus'),
        ('Organizations'),
        ('Outdoors'),
        ('Pets'),
        ('Politics'),
        ('Sales'),
        ('Science'),
        ('Spirituality'),
        ('Sports'),
        ('Technology'),
        ('Theatre'),
        ('Other');
      ");
    }
    
    $select = new Zend_Db_Select($db);
    $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitebusinessnote')
                ->where('enabled = ?', 1);    
    $is_sitebusinessnote_object = $select->query()->fetchObject();
    if($is_sitebusinessnote_object) {      
        $db->query('
          INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
          ("sitebusinessnote_admin_main_categories", "sitebusinessnote", "Categories", "", \'{"route":"admin_default","module":"sitebusinessnote","controller":"settings","action":"categories"}\', "sitebusinessnote_admin_main", "", 3);
        ');
    }
    
		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
			include APPLICATION_PATH . "/application/modules/Sitebusinessnote/controllers/license/mobileLayoutCreation.php";
		}
    
    $noteTable = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessnote_notes\'')->fetch();
    if(!empty($noteTable)) {     
        
        $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessnote_notes LIKE 'featured'")->fetch();        
        if(!empty($featuredColumn)) {
            $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessnote_notes` WHERE Key_name = 'featured'")->fetch();   
            if(empty($featuredIndex)) {
              $db->query("ALTER TABLE `engine4_sitebusinessnote_notes` ADD INDEX ( `featured` )");
            }         
        }

        $categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessnote_notes LIKE 'category_id'")->fetch();        
            if(!empty($categoryIdColumn)) {
            $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessnote_notes` WHERE Key_name = 'category_id'")->fetch();     
            if(empty($categoryIdIndex)) {
              $db->query("ALTER TABLE `engine4_sitebusinessnote_notes` ADD INDEX ( `category_id` )");
            }     
        }
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }
 
  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessnote','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessnote')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessnote/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }

  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessnote_note", "sitebusinessnote", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business note {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessnote_photo", "sitebusinessnote", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business note photo {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  } 
  
}
?>
