<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessnote.isActivate', 0);
if ( empty($isActive) ) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Notes'),
        'description' => $view->translate('This widget forms the Notes tab on the Business Profile and displays the notes of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.sitemobile-profile-sitebusinessnotes',
        'defaultParams' => array(
            'title' => $view->translate('Notes'),
        ),
    ),
     array(
        'title' => $view->translate('Business Notes'),
        'description' => $view->translate('Displays a list of all the business notes on site.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinessnote.sitebusiness-note',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of notes to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
			'title' => $view->translate('Business Note View'),
			'description' => $view->translate("Displays the list of Notes from Businesses created on your community. This widget should be placed in the widgetized Business Notes business. Results from the Search Business Notes form are also shown here."),
      'category' => $view->translate('Businesses'),
			'type' => 'widget',
			'name' => 'sitebusinessnote.note-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>