<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessnote_Widget_NoteContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     //GET PLAYLIST ID AND OBJECT
    $note_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id', $this->_getParam('note_id', null));
  //GET LOGGED IN USER INFORMATION
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //GET NOTE ITEM
    $this->view->sitebusinessnote = $sitebusinessnote = Engine_Api::_()->getItem('sitebusinessnote_note', $note_id);
    if (empty($sitebusinessnote)) {
      return $this->setNoRender();
    }

    //BUSINESS ID
    $business_id = $sitebusinessnote->business_id;

    //GET BUSINESS ITEM
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //GETTING THE NOTE TAGS
    $this->view->noteTags = $sitebusinessnote->tags()->getTagMaps();

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'sncreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }
  
    //MAKE FEATURED OR NOT
    $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessnote.featured', 1);

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitebusiness, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitebusiness, 'registered', 'view') === 1 ? true : false;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE NOTE OR NOT
    if ($viewer_id != $sitebusinessnote->owner_id && $can_edit != 1 && ($sitebusinessnote->draft == 1 || $sitebusinessnote->search != 1)) {
      return $this->setNoRender();
    }

    //SHOW PHOTO
    $this->view->photoNotes = Engine_Api::_()->getDbTable('photos', 'sitebusinessnote')->getNotePhotos($sitebusinessnote->note_id);

    //INCREMENT IN NUMBER OF VIEWS
    if (!$sitebusinessnote->getOwner()->isSelf($viewer)) {
      $sitebusinessnote->view_count++;
    }
    $sitebusinessnote->save();

    //GETTING THE TOTAL NOTE IN THE ONE BUSINESS
    $this->view->count_note = Engine_Api::_()->getDbTable('notes', 'sitebusinessnote')->getTotalNote($business_id);
    $this->view->limit_sitebusinessnote = $total_sitebusinessnotes = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessnote.tag.widgets', 3);

    //START: "SUGGEST TO FRIEND" LINK WORK
    $business_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();

    if (!empty($is_suggestion_enabled)) {
      //HERE WE ARE DELETE THIS NOTE SUGGESTION IF VIEWER HAVE
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_note', Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id'), 'business_note_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessnote', Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
        if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->noteSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'note_sugg_link');
      }
      //END: "SUGGEST TO FRIEND" LINK WORK
    }
  }

}
?>