<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessnote_Widget_SitemobileProfileSitebusinessnotesController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING NOTES ON BUSINESS PROFILE BUSINESS
  public function indexAction() {
  	
    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GETTING LEVEL
    if (!empty($viewer_id)) {
      $level_id = $this->view->level_id = $viewer->level_id;
    } else {
      $level_id = $this->view->level_id = 0;
    }

    //GET SUBJECT AND BUSINESS ID AND BUSINESS OWNER ID
    $this->view->sitebusinessSubject = $sitebusinessSubject = Engine_Api::_()->core()->getSubject('sitebusiness_business');
    $business_id = $sitebusinessSubject->business_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusinessSubject->package_id, "modules", "sitebusinessnote")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusinessSubject, 'sncreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //TOTAL NOTE
    $noteCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessnote', 'notes'); 
    $noteCreate = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusinessSubject, 'sncreate');
            
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusinessSubject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $this->view->allowView = true;
    } 

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusinessSubject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
   
    if (empty($noteCreate) && empty($noteCount) && empty($can_edit) && !(Engine_Api::_()->sitebusiness()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

		//MAKING THE SEACHING PARAMATER ARRAY
		$values = array();
		
		//START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusinessSubject, 'sncreate');
		if (empty($isManageAdmin) && empty($can_edit)) {
			$this->view->can_create = 0;
		} else {
			$this->view->can_create = 1;
		}
		//END MANAGE-ADMIN CHECK
		
		//FETCH NOTES
		$values['business_id'] = $business_id;
    $values['orderby'] = 'creation_date';
		if ($can_edit == 1) {
			$values['show_businessnotes'] = 0;
			$this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitebusinessnote')->getSitebusinessnotesPaginator($values);
		} else {
			$values['show_businessnotes'] = 1;
			$values['note_owner_id'] = $viewer_id;
			$this->view->paginator = $paginator = Engine_Api::_()->getDbTable('notes', 'sitebusinessnote')->getSitebusinessnotesPaginator($values);
		}

		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('business', 1));
    $this->_childCount = $paginator->getTotalItemCount();
  }

  //RETURN THE COUNT OF THE NOTE
  public function getChildCount() {
    return $this->_childCount;
  }

}