<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessoffer_Widget_SitemobileProfileSitebusinessoffersController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DON'T RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $enable_type = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessoffer.offer.show.type', 1);
    if(empty($enable_type)) {
      return $this->setNoRender();
    }
    
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET SUBJECT
    $this->view->sitebusiness = $sitebusiness = $subject = Engine_Api::_()->core()->getSubject('sitebusiness_business');

    //GET BUSINESS ID
    $business_id = $subject->business_id;

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinessoffer")) {
        return $this->setNoRender();
      }
    } else {
      $businessOwnerBase = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'offer');
      if (empty($businessOwnerBase)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END     
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $can_edit = 1;
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    }

    $can_offer = 1;
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'offer');
    if (empty($isManageAdmin)) {
      $can_offer = 0;
    }
    //END MANAGE-ADMIN CHECK

    $can_create_offer = '';
    //OFFER CREATION AUTHENTICATION CHECK
    if ($can_edit == 1 && $can_offer == 1) {
      $this->view->can_create_offer = $can_create_offer =  1;
    }

    //TOTAL OFFER
    $offerCount = Engine_Api::_()->sitebusiness()->getTotalCount($business_id, 'sitebusinessoffer', 'offers');     
    if (empty($can_create_offer) && empty($offerCount)) {
      return $this->setNoRender();
    }       

		$this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitebusinessoffer_offer')->getSitebusinessoffersPaginator($business_id, 1,'',$can_create_offer,'buy');
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('business', 1));
    $this->_childCount = $paginator->getTotalItemCount();
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}