<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_Plugin_Menus {

  public function canViewPolls() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.poll.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('polls', 'sitebusinesspoll');
    $rName = $table->info('name');
    $table_businesses = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName_businesses = $table_businesses->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_businesses, array('photo_id', 'title as sitebusiness_title'))
                    ->join($rName, $rName . '.business_id = ' . $rName_businesses . '.business_id')
                    ->where($rName . '.search = ?', '1');

    $select = $select
                    ->where($rName_businesses . '.closed = ?', '0')
                    ->where($rName_businesses . '.approved = ?', '1')
                    ->where($rName_businesses . '.search = ?', '1')
                    ->where($rName_businesses . '.declined = ?', '0')
                    ->where($rName_businesses . '.draft = ?', '1');
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($rName_businesses . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }

  //SITEMOBILE BUSINESS POLL MENUS
  public function onMenuInitialize_SitebusinesspollShare($row) {
    $sitebusinesspoll = Engine_Api::_()->core()->getSubject('sitebusinesspoll_poll');
    if (empty($sitebusinesspoll)) {
      return false;
    }

    return array(
        'label' => 'Share',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => 'sitebusinesspoll_poll',
            'id' => $sitebusinesspoll->getIdentity(),
        )
    );
  }

  public function onMenuInitialize_SitebusinesspollReport($row) {
    $sitebusinesspoll = Engine_Api::_()->core()->getSubject('sitebusinesspoll_poll');
    if (empty($sitebusinesspoll)) {
      return false;
    }

    return array(
        'label' => 'Report',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $sitebusinesspoll->getGuid(),
        )
    );
  }

  public function onMenuInitialize_SitebusinesspollCreate($row) {
    $sitebusinesspoll = Engine_Api::_()->core()->getSubject('sitebusinesspoll_poll');
    if (empty($sitebusinesspoll)) {
      return false;
    }

    $business_id = $sitebusinesspoll->business_id;
    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }

    if (empty($can_create)) {
      return false;
    }
    return array(
        'label' => 'Create Poll',
        'route' => 'sitebusinesspoll_create',
        'class' => 'ui-btn-action',
        'params' => array(
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinesspollDelete($row) {
    $sitebusinesspoll = Engine_Api::_()->core()->getSubject('sitebusinesspoll_poll');
    if (empty($sitebusinesspoll)) {
      return false;
    }

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $owner_id = $sitebusinesspoll->owner_id;
    $business_id = $sitebusinesspoll->business_id;

    $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }

    if ($owner_id != $viewer_id && empty($can_edit)) {
      return false;
    }

    return array(
        'label' => 'Delete Poll',
        'route' => 'sitebusinesspoll_delete',
        'class' => 'ui-btn-danger',
        'params' => array(
            'poll_id' => $sitebusinesspoll->poll_id,
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

}
?>