<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_AdminController extends Core_Controller_Action_Admin {

  //ACTION FOR APPROVED AND DIS-APPROVED SITEBUSINESS-POLL
  public function approvedAction() {

    //GET THE BUSINESSPOLL MODEL
    $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $this->_getParam('poll_id'));

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      if ($sitebusinesspoll->approved == 0)
        $sitebusinesspoll->approved = 1;
      else 
        $sitebusinesspoll->approved = 0;

      $sitebusinesspoll->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitebusinesspoll/manage');
  }

  //ACTION FOR DELETE THE SITEBUSINESS-POLL
  public function deleteAction() {

    //RENDER LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET THE POLL ID
    $this->view->poll_id = $poll_id = $this->_getParam('poll_id');

    //GET THE BUSINESSPOLL MODEL
    $sitebusinesspoll = Engine_Api::_()->getItem('sitebusinesspoll_poll', $poll_id);

    if ($this->getRequest()->isPost()) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //FINALLY DELETE POLL MODEL
        $sitebusinesspoll->delete();
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    }
    $this->renderScript('admin/delete.tpl');
  }

}
?>