<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "businesspolls";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.manifestUrl', "business-polls");
}
return array(
    // Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'sitebusinesspoll',
        'version' => '5.4.1',
        'path' => 'application/modules/Sitebusinesspoll',
        'repository' => 'null',
        'title' => 'Directory / Businesses - Polls Extension',
        'description' => 'Directory / Businesses - Polls Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitebusinesspoll/settings/install.php',
            'class' => 'Sitebusinesspoll_Installer',
        ),
        'directories' => array(
            'application/modules/Sitebusinesspoll',
        ),
        'files' => array(
            'application/languages/en/sitebusinesspoll.csv',
        ),
    ),
    'sitemobile_compatible' => true,
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitebusinesspoll_Plugin_Core',
        ),
        array(
            'event' => 'onRenderLayoutMobileSMDefault',
            'resource' => 'Sitebusinesspoll_Plugin_Sitemobile',
        ),
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitebusinesspoll_poll',
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'sitebusinesspoll_create' => array(
            'route' => $routeStart.'/create/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'index',
                'action' => 'create'
            ),
            'reqs' => array(
                'business_id' => '\d+'
            )
        ),
        'sitebusinesspoll_approved' => array(
            'route' => $routeStart.'/approved/:poll_id',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'admin',
                'action' => 'approved'
            ),
            'reqs' => array(
                'poll_id' => '\d+'
            )
        ),
        'sitebusinesspoll_delete' => array(
            'route' => $routeStart.'/delete/:poll_id/:business_id/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'index',
                'action' => 'delete'
            ),
            'reqs' => array(
                'poll_id' => '\d+',
                'business_id' => '\d+'
            )
        ),
        'sitebusinesspolladmin_delete' => array(
            'route' => $routeStart.'/admin/delete/:poll_id/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'admin',
                'action' => 'delete'
            ),
            'reqs' => array(
                'poll_id' => '\d+'
            )
        ),
        'sitebusinesspoll_detail_view' => array(
            'route' => $routeStart.'/:user_id/:poll_id/:slug/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'poll_id' => '\d+'
            )
        ),
        'sitebusinesspoll_specific' => array(
            'route' => $routeStart.'/close/:poll_id/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'index',
                'action' => 'close',
            ),
            'reqs' => array(
                'poll_id' => '\d+'
            )
        ),
				'sitebusinesspoll_browse' => array(
            'route' => $routeStart.'/browse/*',
            'defaults' => array(
                'module' => 'sitebusinesspoll',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),
    )
)
?>