<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.isActivate', 0);
if (empty($isActive)) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Polls'),
        'description' => $view->translate('This widget forms the Polls tab on the Business Profile and displays the polls of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinesspoll.sitemobile-profile-sitebusinesspolls',
        'defaultParams' => array(
            'title' => $view->translate('Polls'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Polls'),
        'description' => $view->translate('Displays a list of all the businesses poll on site. This widget should be placed on the  Businesses poll business.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinesspoll.sitebusiness-poll',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of polls to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
			'title' => $view->translate('Business Poll View'),
			'description' => $view->translate("This widget should be placed on the Business Poll View Business."),
      'category' => $view->translate('Businesses'),
			'type' => 'widget',
			'name' => 'sitebusinesspoll.sitebusinesspoll-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>