<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinesspoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinesspoll_Widget_SitebusinesspollContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET THE TAB ID OF POLL ON BUSINESS PROFILE BUSINESS
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');
    //GET BUSINESSPOLL MODEL
    $this->view->sitebusinesspoll = $sitebusinesspoll = Engine_Api::_()->core()->getSubject('sitebusinesspoll_poll');
    if (empty($sitebusinesspoll)) {
      return $this->setNoRender();
    }

    //GET THE BUSINESS ID
    $this->view->business_id = $business_id = $sitebusinesspoll->business_id;

    //GET SITEBUSINESS OBJECT
    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitebusiness()->allowPackageContent($sitebusiness->package_id, "modules", "sitebusinesspoll")) {
        return $this->setNoRender();
      }
    } else {
      $isBusinessOwnerAllow = Engine_Api::_()->sitebusiness()->isBusinessOwnerAllow($sitebusiness, 'splcreate');
      if (empty($isBusinessOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'splcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //DIS-APPROVED POLL WILL BE VISIBLE ONLY TO POLL-OWNER, SITEBUSINESS-OWNER AND MANAGE-ADMIN
    if ($sitebusinesspoll->owner_id != $viewer_id && $can_edit != 1 && ( empty($sitebusinesspoll->approved) || empty($sitebusinesspoll->search))) {
      return $this->setNoRender();
    }

    //WHO CAN VOTE
    if (!empty($viewer_id) && $sitebusinesspoll->approved == 1 && $sitebusinesspoll->search == 1) {
      $this->view->can_vote = $can_vote = 1;
    } else {
      $this->view->can_vote = $can_vote = 0;
    }
    $getPackagepollview = Engine_Api::_()->sitebusiness()->getPackageAuthInfo('sitebusinesspoll');

    //GET OWNER INFORMATION
    Engine_Api::_()->sitebusinesspoll()->setPollPackages();
    $owner = $sitebusinesspoll->getOwner();

    //REPORT CODE
//     if (!empty($viewer_id)) {
//       $report = $sitebusinesspoll;
//       if (!empty($report)) {
//         Engine_Api::_()->core()->setSubject($report);
//       }
// //       if (!$this->_helper->requireSubject()->isValid())
// //         return;
//     }

    $this->view->sitebusinesspollOptions = empty($getPackagepollview) ? null : $sitebusinesspoll->getOptions();
    $this->view->hasVoted = $sitebusinesspoll->viewerVoted();
    $this->view->showPieChart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.showPieChart', false);
    $this->view->canVote = $can_vote;
    $this->view->canChangeVote = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinesspoll.canchangevote', false);

    //INCREMENT IN NUMBER OF VIEWS
    if (!$owner->isSelf($viewer)) {
      $sitebusinesspoll->views++;
    }

    $sitebusinesspoll->save();

    // START: "SUGGEST TO FRIENDS" LINK WORK.
    $business_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // HERE WE ARE DELETE THIS POLL SUGGESTION IF VIEWER HAVE.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_poll', Zend_Controller_Front::getInstance()->getRequest()->getParam('poll_id'), 'business_poll_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinesspoll', Zend_Controller_Front::getInstance()->getRequest()->getParam('poll_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
        if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->pollSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'poll_sugg_link');
      }
    }
    // END: "SUGGEST TO FRIENDS" LINE WORK.
  }

}
?>