<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessreview_Plugin_Menus {

  public function canViewReviews() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessreview.review.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('reviews', 'sitebusinessreview');
    $rName = $table->info('name');
    $table_businesses = Engine_Api::_()->getDbtable('business', 'sitebusiness');
    $rName_businesses = $table_businesses->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_businesses, array('photo_id', 'title as sitebusiness_title'))
                    ->join($rName, $rName . '.business_id = ' . $rName_businesses . '.business_id');
                    
    $select = $select
                    ->where($rName_businesses . '.closed = ?', '0')
                    ->where($rName_businesses . '.approved = ?', '1')
                    ->where($rName_businesses . '.search = ?', '1')
                    ->where($rName_businesses . '.declined = ?', '0')
                    ->where($rName_businesses . '.draft = ?', '1');
    if (Engine_Api::_()->sitebusiness()->hasPackageEnable()) {
      $select->where($rName_businesses . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }


  //SITEMOBILE BUSINESS REVIEW MENUS
  public function onMenuInitialize_SitebusinessreviewEdit($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitebusinessreview = $this->getSitebusinessReviewObject();
    if (empty($sitebusinessreview)) {
      return false;
    }
    //BUSINESS ID
    $business_id = $sitebusinessreview->business_id;

    $owner_id = $sitebusinessreview->owner_id;

    //CHECKS FOR EDIT
    if ($viewer_id != $owner_id) {
      return false;
    }

    return array(
        'label' => 'Edit Review',
        'route' => 'sitebusinessreview_edit',
        'class' => 'ui-btn-action',
        'params' => array(
            'review_id' => $sitebusinessreview->getIdentity(),
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinessreviewDelete($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    $sitebusinessreview = $this->getSitebusinessReviewObject();
    if (empty($sitebusinessreview)) {
      return false;
    }
    //BUSINESS ID
    $business_id = $sitebusinessreview->business_id;

    $owner_id = $sitebusinessreview->owner_id;
    $viewer->level_id;

    //CHECK FOR DELETE
    if ($viewer_id != $owner_id && $viewer->level_id != 1) {
      return false;
    }

    return array(
        'label' => 'Delete Review',
        'route' => 'sitebusinessreview_delete',
        'class' => 'ui-btn-danger smoothbox',
        'params' => array(
            'review_id' => $sitebusinessreview->getIdentity(),
            'business_id' => $business_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitebusinessreviewReport($row) {
    $subject = Engine_Api::_()->core()->getSubject();
    $viewer = Engine_Api::_()->user()->getViewer();
    $review_report = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessreview.report', 1);
    $viewer_id = $viewer->getIdentity();

    //CHECK FOR REPORT
    if ($review_report != 1 || empty($viewer_id)) {
      return false;
    }

    return array(
        'label' => 'Report',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $subject->getGuid(),
        // 'format' => 'smoothbox'
        )
    );
  }

  public function getSitebusinessReviewObject() {
    $subject = Engine_Api::_()->core()->getSubject();
    //GET REVIEW ID
    $review_id = $subject->getIdentity();
    //GET REVIEW ITEM
    $sitebusinessreview = Engine_Api::_()->getItem('sitebusinessreview_review', $review_id);
    //ASK
    if (empty($sitebusinessreview)) {
      return false;
    }
    return $sitebusinessreview;
  }
}
?>