<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusiness
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessreview_Plugin_Sitemobile {

  protected $_pagesTable;
  protected $_contentTable;

  public function onIntegrated() {

    $this->_pagesTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_pagesTable;
    $this->_contentTable = Engine_Api::_()->getApi('modules', 'sitemobile')->_contentTable;
    //Business Review
    $this->addSitebusinessReviewProfileContent();
    $this->addSitebusinessReviewCreateBusiness();
    $this->addSitebusinessReviewBrowseBusiness();
    $this->addSitebusinessReviewViewBusiness();
    include APPLICATION_PATH . "/application/modules/Sitebusinessreview/controllers/license/mobileLayoutCreation.php";
  }

  //business Review
  public function addSitebusinessReviewProfileContent() {


    // install content areas

    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusiness_index_view');

    // sitemobile.blog-profile-blogs
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
            ->from($this->_contentTable)
            ->where('page_id = ?', $business_id)
            ->where('type = ?', 'widget')
            ->where('name = ?', 'sitebusinessreview.sitemobile-profile-sitebusinessreviews')
    ;
    $info = $select->query()->fetch();

    if (empty($info)) {

      // container_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('page_id = ?', $business_id)
              ->where('type = ?', 'container')
              ->limit(1);
      $container_id = $select->query()->fetchObject()->content_id;

      // middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
              ->from($this->_contentTable)
              ->where('parent_content_id = ?', $container_id)
              ->where('type = ?', 'container')
              ->where('name = ?', 'middle')
              ->limit(1);
      $middle_id = $select->query()->fetchObject()->content_id;

      // tab_id (tab container) may not always be there
      $select
              ->reset('where')
              ->where('type = ?', 'widget')
              ->where('name = ?', 'sitemobile.container-tabs-columns')
              ->where('page_id = ?', $business_id)
              ->limit(1);
      $tab_id = $select->query()->fetchObject();
      if ($tab_id && @$tab_id->content_id) {
        $tab_id = $tab_id->content_id;
      } else {
        $tab_id = null;
      }

      // tab on profile
      $db->insert($this->_contentTable, array(
          'page_id' => $business_id,
          'type' => 'widget',
          'name' => 'sitebusinessreview.sitemobile-profile-sitebusinessreviews',
          'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
          'order' => 800,
          'params' => '{"title":"Reviews","titleCount":true}',
      ));
    }
  }

  public function addSitebusinessReviewBrowseBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessreview_index_browse');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessreview_index_browse',
          'displayname' => 'Directory / Businesses - Browse Reviews',
          'title' => 'Browse Reviews',
          'description' => 'This is browse reviews page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-navigation',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 1,
      ));
//      // Insert Advance search
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.sitemobile-advancedsearch',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => '{"search":"2","title":"","nomobile":"0","name":"sitemobile.sitemobile-advancedsearch"}',
          'order' => 2,
      ));
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinessreview.sitebusiness-review',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'params' => '{"itemCount":"10"}',
          'order' => 3,
      ));
    }
  }

  public function addSitebusinessReviewViewBusiness() {
    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessreview_index_view');
    // insert if it doesn't exist yet
    if (!$business_id) {
      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessreview_index_view',
          'displayname' => 'Directory / Businesses - Review View Page',
          'title' => 'Review View Page',
          'description' => 'This is review view page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
      ));
      $main_id = $db->lastInsertId();

      // Insert middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
          'order' => 2,
      ));
      $middle_id = $db->lastInsertId();

//      $db->insert($this->_contentTable, array(
//          'page_id' => $business_id,
//          'type' => 'widget',
//          'name' => 'sitemobile.sitemobile-headingtitle',
//          'parent_content_id' => $middle_id,
//          'order' => 1,
//          'params' => '{"title":"","nonloggedin":"1","loggedin":"1","nomobile":"0","notablet":"0","name":"sitemobile.sitemobile-headingtitle"}',
//          'module' => 'sitemobile'
//      ));
      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitebusinessreview.review-content',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 2,
      ));

      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'sitemobile.comments',
          'page_id' => $business_id,
          'parent_content_id' => $middle_id,
          'order' => 4,
      ));
    }
  }

  public function addSitebusinessReviewCreateBusiness() {

    $db = Engine_Db_Table::getDefaultAdapter();

    $business_id = Engine_Api::_()->getApi('modules', 'sitemobile')->getPageId('sitebusinessreview_index_create');
    if (!$business_id) {

      // Insert business
      $db->insert($this->_pagesTable, array(
          'name' => 'sitebusinessreview_index_create',
          'displayname' => 'Directory / Businesses - Create Review',
          'title' => 'Create new Review',
          'description' => 'This is review create page.',
          'custom' => 0,
      ));
      $business_id = $db->lastInsertId();

      // Insert main
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $business_id,
          'order' => 1,
      ));
      $main_id = $db->lastInsertId();

      // Insert main-middle
      $db->insert($this->_contentTable, array(
          'type' => 'container',
          'name' => 'middle',
          'page_id' => $business_id,
          'parent_content_id' => $main_id,
      ));
      $main_middle_id = $db->lastInsertId();

      // Insert content
      $db->insert($this->_contentTable, array(
          'type' => 'widget',
          'name' => 'core.content',
          'page_id' => $business_id,
          'parent_content_id' => $main_middle_id,
          'order' => 2,
      ));
    }
  }

}