<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessreview.isActivate', 0);
if(empty($isActive)){ return; }

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Reviews'),
        'description' => $view->translate('This widget forms the Reviews tab on the Business Profile and displays the reviews of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessreview.sitemobile-profile-sitebusinessreviews',
        'defaultParams' => array(
            'title' => $view->translate('Reviews'),
        ),
    ),
    array(
			'title' => $view->translate('Business Review View'),
			'description' => $view->translate("This widget should be placed on the Business Review View Business."),
      'category' => $view->translate('Businesses'),
			'type' => 'widget',
			'name' => 'sitebusinessreview.review-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	  ),
    array(
        'title' => $view->translate('Business Reviews'),
        'description' => $view->translate('Displays the list of Reviews from Businesses created on your community. This widget should be placed in the widgetized Business Reviews business. Results from the Search Business Reviews form are also shown here.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinessreview.sitebusiness-review',
        'defaultParams' => array(
            'title' => $view->translate('Reviews'),
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of reviews to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
)
?>