<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessreview
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessreview_Widget_PopularSitebusinessreviewsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SUBJECT AND SITEBUSINESS ID
		$business_url = Zend_Controller_Front::getInstance()->getRequest()->getParam('business_url', null);
		$business_id = Engine_Api::_()->sitebusiness()->getBusinessId($business_url);

    //GET OBJECT
    $sitebusiness_subject = Engine_Api::_()->getItem('sitebusiness_business',$business_id);

    // PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

    $sitebusinessreview_isReview = Zend_Registry::isRegistered('sitebusinessreview_isReview') ? Zend_Registry::get('sitebusinessreview_isReview') : null;
    if (empty($sitebusinessreview_isReview)) {
      return $this->setNoRender();
    }

		$params = array();
		$params['business_id'] = $business_id;
		$params['orderby'] = 'view_count DESC';
		$params['zero_count'] = 'view_count';
		$params['limit'] = $this->_getParam('itemCount', 3);

    $this->view->paginator = $paginator = Engine_Api::_()->getDbtable('reviews', 'sitebusinessreview')->reviewRatingData($params);

    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}
?>