<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessreview_Widget_ReviewContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {
//GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $this->view->level_id = $viewer->level_id;
    } else {
      $this->view->level_id = 0;
    }

    //GET REVIEW MODEL
    $this->view->sitebusinessreview = $sitebusinessreview = Engine_Api::_()->getItem('sitebusinessreview_review', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'));
    if (empty($sitebusinessreview)) {
      return $this->setNoRender();
    }

    $this->view->business_id = $business_id = $sitebusinessreview->business_id;

    $this->view->sitebusiness = $sitebusiness = Engine_Api::_()->getItem('sitebusiness_business', $business_id);

    $this->view->sitebusiness_slug = $sitebusiness->getSlug();
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitebusiness()->isManageAdmin($sitebusiness, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }
    //END MANAGE-ADMIN CHECK
    //GET OWNER INFORMATION
    $this->view->owner = $owner = $sitebusinessreview->getOwner();

    //INCREMENT IN NUMBER OF VIEWS
    if (!$owner->isSelf($viewer)) {
      $sitebusinessreview->view_count++;
      $sitebusinessreview->save();
    }

    //REPORT CODE
    $this->view->review_report = $review_report = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessreview.report', 1);
    if (!empty($viewer_id) && $review_report == 1) {
      $report = $this->view->report = $sitebusinessreview;
    }

    // Start: "Suggest to Friends" link work.
    $business_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitebusiness');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitebusiness')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // Here we are delete this review suggestion if viewer have.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitebusiness')->deleteSuggestion($viewer_id, 'business_review', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'), 'business_review_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitebusinessreview', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.package.enable', 1)) {
        if ($sitebusiness->expiration_date <= date("Y-m-d H:i:s")) {
          $business_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitebusiness->closed) && !empty($sitebusiness->approved) && empty($sitebusiness->declined) && !empty($sitebusiness->draft) && empty($business_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->reviewSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitebusiness', 'review_sugg_link');
      }
      // End: "Suggest to Friends" link work.
    }
  }

}
?>