<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessurl
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessurl_Form_Admin_Global extends Engine_Form {

  public function init() {
   
    $is_element = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessurl.is.enable', 0);
    $this->setTitle('Global Settings');
		$this->setDescription('These settings affect all members in your community.');
     if(!empty($is_element)) {
			$this->addElement('Radio', 'sitebusiness_showurl_column', array(
					'label' => 'Custom Business URL',
					'description' => 'Do you want to enable Business Admins to create their custom Business URL during Business creation? (If enabled, a URL field will be available to users at the time of creating a Business.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
          'onclick' => 'showediturl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.showurl.column', 1),
			));

			$this->addElement('Radio', 'sitebusiness_edit_url', array(
					'label' => 'Edit Custom Business URL',
					'description' => 'Do you want to enable Business Admins to edit their custom Business URL?',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.edit.url', 0),
			));

      $this->addElement('Radio', 'sitebusiness_change_url', array(
					'label' => 'Automatically Shorten Business URLs',
					'description' => 'Do you want the Business URLs to be shortened upon the number of Likes on them exceeding the Likes limit? (You can choose the Likes limit below. Selecting “Yes” will change the URLs of those Businesses from the form: “/businessitem/business_url” to: “/business_url”.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'onclick' => 'showurl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1),
			));
			
			$this->addElement('Text', 'sitebusiness_likelimit_forurlblock', array(
					'label' => 'Likes Limit for Active Short URL',
					'allowEmpty' => false,
					'maxlength' => '3',
					'required' => true,
					'description' => 'Please enter the minimum number of Likes after which Business URLs should be shortened. (Note: It is recommended to enter ‘5’ minimum number of Likes.)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.likelimit.forurlblock', 5),
			));   

      $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
      $this->addElement('Dummy', 'sitebusiness_manifestUrlP', array(
        'label' => 'Businesses URL alternate text for "businessitems"',
        'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Please %1$sedit%2$s the text which want to display in place of "businessitems" in the URLs of Directory/Businesses plugin.'),"<a href='" . $view->baseUrl() . "/admin/sitebusiness/settings#sitebusiness_manifestUrlP-label' target='_blank'>","</a>"),
      ));
      $this->getElement('sitebusiness_manifestUrlP')->getDecorator('Description')->setOptions(array('placement', 'APPEND', 'escape' => false));
      $this->addElement('Dummy', 'sitebusiness_manifestUrlS', array(
        'label' => 'Businesses URL alternate text for "businessitem"',
        'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Please %1$sedit%2$s the text which want to display in place of "businessitem" in the URLs of Directory/Businesses plugin.'),"<a href='" . $view->baseUrl() . "/admin/sitebusiness/settings#sitebusiness_manifestUrlS-label' target='_blank'>","</a>"),
      ));
				$this->getElement('sitebusiness_manifestUrlS')->getDecorator('Description')->setOptions(array('placement',
	'APPEND', 'escape' => false));
      $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
));
    }
    else {
			$this->addElement('Radio', 'sitebusiness_change_url', array(
					'label' => 'Automatically Shorten Business URLs',
					'description' => 'Do you want the Business URLs to be shortened upon the number of Likes on them exceeding the Likes limit? (You can choose the Likes limit below. Selecting “Yes” will change the URLs of those Businesses from the form: “/businessitem/business_url” to: “/business_url”.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'onclick' => 'showurl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.change.url', 1),
			));
			
			$this->addElement('Text', 'sitebusiness_likelimit_forurlblock', array(
					'label' => 'Likes Limit for Active Short URL',
					'allowEmpty' => false,
					'maxlength' => '3',
					'required' => true,
					'description' => 'Please enter the minimum number of Likes after which Business URLs should be shortened. (Note: It is recommended to enter ‘5’ minimum number of Likes.)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusiness.likelimit.forurlblock', 5),
			));
			
			$this->addElement('Button', 'submit', array(
        'label' => 'Proceed to activate Plugin',
        'type' => 'submit',
        'ignore' => true
    ));
    }
  }

}
?>