<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.isActivate', 0);
if (empty($isActive)) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitebusiness')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Business Profile Videos',
        'description' => 'This widget forms the Videos tab on the Business Profile and displays the videos of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.',
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.profile-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Videos',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Business Profile Most Commented Videos',
        'description' => "Displays list of a Business's most commented videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.comment-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Commented Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Business Profile Most Recent Videos',
        'description' => "Displays list of a Business's most recent videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.recent-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Recent Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Business Profile Top Rated Videos',
        'description' => "Displays list of a Business's top rated videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.rate-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Top Rated Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Business Profile Most Liked Videos',
        'description' => "Displays list of a Business's most liked videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.like-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Liked Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
    array(
        'title' => 'Business Profile Featured Videos',
        'description' => "Displays list of business's featured videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.featurelist-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Featured Business Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
        'title' => 'Business Profile Highlighted Videos',
        'description' => "Displays list of business's highlighted videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.highlightlist-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Highlighted Business Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
        'title' => 'Business Profile Most Viewed Videos',
        'description' => "Displays list of a Business's most viewed videos. This widget should be placed on the Business Profile.",
        'category' => 'Business Profile',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.view-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Viewed Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),
     array(
        'title' => 'Recent Videos',
        'description' => 'Displays the recent videos of the site.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homerecent-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Recent Videos'
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    ),

    array(
			'title' => 'Search Business Videos form',
			'description' => 'Displays the form for searching Business Videos on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessvideo.search-sitebusinessvideo',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Business Videos form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Business Title", "4" => "Video Keywords", "5" => "Business Category"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Business Videos',
        'description' => 'Displays the list of Videos from Businesses created on your community. This widget should be placed in the widgetized Business Videos business. Results from the Search Business Videos form are also shown here.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.sitebusiness-video',
        'defaultParams' => array(
            'title' => 'Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of videos to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    
    array(
        'title' => 'Sponsored Videos',
        'description' => 'Displays the Videos from Paid Businesses. You can choose the number of entries to be shown.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.sitebusiness-sponsoredvideo',
        'defaultParams' => array(
            'title' => 'Sponsored Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of videos to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
 
    array(
        'title' => 'Featured Videos',
        'description' => "Displays Featured Business Videos. You can mark Business Videos as Featured from the “Manage Business Videos” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homefeaturelist-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Featured Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
//     array(
//         'title' => 'Highlighted Videos',
//         'description' => "Displays Highlighted Business Videos. You can mark Business Videos as Highlighted from the “Manage Business Videos” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
//         'category' => 'Businesses',
//         'type' => 'widget',
//         'name' => 'sitebusinessvideo.homehighlightlist-sitebusinessvideos',
//         'defaultParams' => array(
//             'title' => 'Highlighted Videos',
//             'titleCount' => true,
//         ),
//         'adminForm' => array(
// 					'elements' => array(
// 						array(
// 								'Text',
// 								'itemCount',
// 								array(
// 										'label' => 'Count',
// 										'description' => '(number of videos to show)',
// 										'value' => 3,
// 										'validators' => array(
// 											array('Int', true),
// 											array('GreaterThan', true, array(0)),
// 										),
// 								),
// 						),
// 					),
//         ),
//     ),

    array(
        'title' => 'Most Commented Videos',
        'description' => "Displays the Most Commented Business Videos. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homecomment-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Commented Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
    
     array(
        'title' => 'Most Viewed Videos',
        'description' => "Displays the Most Viewed Business Videos. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homeview-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Viewed Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
 
    array(
        'title' => 'Most Liked Videos',
        'description' => "Displays the Most Liked Business Videos. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homelike-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Most Liked Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

    array(
        'title' => 'Top Rated Videos',
        'description' => "Displays the Top Rated Business Videos. You can choose the number of entries to be shown.",
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.homerate-sitebusinessvideos',
        'defaultParams' => array(
            'title' => 'Top Rated Videos',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

	array(
			'title' => 'Business Video View',
			'description' => "This widget should be placed on the Business Video View Page.",
      'category' => 'Businesses',
			'type' => 'widget',
			'name' => 'sitebusinessvideo.video-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

   array(
    'title' => 'People Also Liked',
    'description' => 'Displays a list of other Business Videos that the people who liked this Business Video also liked. You can choose the number of entries to be shown. This widget should be placed on Business Video View Page.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessvideo.show-also-liked',
    //'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'People Also Liked',
    ),
    'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessvideo',
    ),
  ),
  array(
    'title' => 'Other Videos From Business',
    'description' => 'Displays a list of other Business Videos corresponding to the Business of which the video is being viewed. You can choose the number of entries to be shown. This widget should be placed on Business Video View Page.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessvideo.show-same-poster',
    //'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Other Videos From Business',
    ),
    'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessvideo',
    ),
  ),
  array(
    'title' => 'Similar Videos',
    'description' => 'Displays Business Videos similar to the Business Video being viewed based on tags. You can choose the number of entries to be shown. This widget should be placed on Business Video View Page.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessvideo.show-same-tags',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Similar Videos',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of videos to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessvideo',
    ),
  ),

  array(
        'title' => 'Business’s Featured Videos Slideshow',
        'description' => 'Displays featured videos in an attractive slideshow. You can set the count of the number of videos to show in this widget. If the total number of videos featured are more than that count, then the videos to be displayed will be sequentially picked up.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.featured-videos-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Videos',
            'itemCountPerBusiness' => 10,
        ),
			'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

  array(
        'title' => 'Business’s Featured Videos Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured videos on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.featured-videos-carousel',
        'defaultParams' => array(
            'title' => 'Featured Videos',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Videos in a Row',
                        'description' => '(number of videos to show in one row. Video: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

  array(
        'title' => 'Business’s Ajax based Tabbed widget for Videos',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Videos in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Directory / Businesses - Videos Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.list-videos-tabs-view',
        'defaultParams' => array(
            'title' => 'Videos',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              ),
              array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							)
            ),
        ),
    ),

  array(
        'title' => 'Browse Videos',
        'description' => 'Displays the link to view Business’s Videos Browse business.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.sitebusinessvideolist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

  array(
        'title' => 'Business’s Video of the Day',
        'description' => 'Displays the Video of the Day as selected by the Admin from the widget settings section of Directory / Businesses - Videos Extension.',
        'category' => 'Businesses',
        'type' => 'widget',
        'name' => 'sitebusinessvideo.video-of-the-day',
        'defaultParams' => array(
            'title' => 'Video of the Day'
        ),
    ),

  array(
  'title' => 'Popular Video Tags',
  'description' => 'Shows popular tags with frequency.',
  'category' => 'Businesses',
  'type' => 'widget',
  'name' => 'sitebusinessvideo.tagcloud-sitebusinessvideo',
  'adminForm' => array(
       'elements' => array(
         array(
           'hidden',
           'title',
           array(
             'label' => '',
             'order' => 1001
           )
         ),
         array(
           'hidden',
           'nomobile',
           array(
             'label' => '',
             'order' => 1002
           )
         ),
         array(
           'hidden',
           'execute',
           array(
             'label' => '',
             'order' => 1003
           )
         ),
         array(
           'hidden',
           'cancel',
           array(
             'label' => '',
             'order' => 1004
           )
         ),
       )
     ),
    ),

    array(
    'title' => 'Top Creators : Business Videos',
    'description' => 'Displays the Businesses which have the most number of Business Videos added in them. Motivates Business Admins to add more content on your website.',
    'category' => 'Businesses',
    'type' => 'widget',
    'name' => 'sitebusinessvideo.topcreators-sitebusinessvideo',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitebusinessvideo',
    ),
  ),
)
?>