<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitebusinessvideo_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEBUSINESS PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.is.active')
            ->limit(1);
    $sitebusiness_settings = $select->query()->fetchAll();
    if (!empty($sitebusiness_settings)) {
      $sitebusiness_is_active = $sitebusiness_settings[0]['value'];
    } else {
      $sitebusiness_is_active = 0;
    }

    //CHECK THAT SITEBUSINESS PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitebusiness')
            ->where('enabled = ?', 1);
    $check_sitebusiness = $select->query()->fetchObject();
    if (!empty($check_sitebusiness) && !empty($sitebusiness_is_active)) {
      $PRODUCT_TYPE = 'sitebusinessvideo';
      $PLUGIN_TITLE = 'Sitebusinessvideo';
      $PLUGIN_VERSION = '5.6.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitebusinessvideo Plugin';
      $PRODUCT_TITLE = 'Directory / Businesses - Videos Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitebusiness_plugin_version = '4.8.6';
      $SocialEngineAddOns_version = '4.10.3p6';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitebusiness/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $this->_checkFfmpegPath();
      //CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
      $type_array = $db->query("SHOW COLUMNS FROM engine4_authorization_permissions LIKE 'type'")->fetch();
      if (!empty($type_array)) {
        $varchar = $type_array['Type'];
        $length_varchar = explode("(", $varchar);
        $length = explode(")", $length_varchar[1]);
        $length_type = $length[0];
        if ($length_type < 32) {
          $run_query = $db->query("ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
        }
      }


      $businessTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitebusinessvideo.basetime', $businessTime ),
			('sitebusinessvideo.isvar', 0 ),
			('sitebusinessvideo.filepath', 'Sitebusinessvideo/controllers/license/license2.php');");
      parent::onPreInstall();
    } elseif (!empty($check_sitebusiness) && empty($sitebusiness_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

     return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> but not activated it on your site yet. Please activate it first before installing the Directory / Businesses - Videos Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitebusiness/settings/readme'>Click here</a> to activate the Directory / Businesses Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
     return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-directory-businesses-plugin' target='_blank'>Directory / Businesses Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/businessextensions/socialengine-directory-businesses-videos' target='_blank'>Directory / Businesses - Videos Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  protected function _checkFfmpegPath() {

    $db = $this->getDb();
    $select = new Zend_Db_Select($db);

    //CHECK FFMPEG PATH FOR CORRECTNESS
    if (function_exists('exec') && function_exists('shell_exec')) {

      //API IS NOT AVAILABLE
      //$ffmpeg_path = Engine_Api::_()->getApi('settings', 'core')->video_ffmpeg_path;
      $ffmpeg_path = $db->select()
              ->from('engine4_core_settings', 'value')
              ->where('name = ?', 'sitebusinessvideo.ffmpeg.path')
              ->limit(1)
              ->query()
              ->fetchColumn(0);

      $output = null;
      $return = null;
      if (!empty($ffmpeg_path)) {
        exec($ffmpeg_path . ' -version', $output, $return);
      }

      //TRY TO AUTO-GUESS FFMPEG PATH IF IT IS NOT SET CORRECTLY
      $ffmpeg_path_original = $ffmpeg_path;
      if (empty($ffmpeg_path) || $return > 0 || stripos(join('', $output), 'ffmpeg') === false) {
        $ffmpeg_path = null;

        //WINDOWS
        if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
          // @todo
        }
        //NOT WINDOWS
        else {
          $output = null;
          $return = null;
          @exec('which ffmpeg', $output, $return);
          if (0 == $return) {
            $ffmpeg_path = array_shift($output);
            $output = null;
            $return = null;
            exec($ffmpeg_path . ' -version', $output, $return);
            if (0 == $return) {
              $ffmpeg_path = null;
            }
          }
        }
      }
      if ($ffmpeg_path != $ffmpeg_path_original) {
        $count = $db->update('engine4_core_settings', array(
            'value' => $ffmpeg_path,
                ), array(
            'name = ?' => 'sitebusinessvideo.ffmpeg.path',
                ));
        if ($count === 0) {
          try {
            $db->insert('engine4_core_settings', array(
                'value' => $ffmpeg_path,
                'name' => 'sitebusinessvideo.ffmpeg.path',
            ));
          } catch (Exception $e) {
            
          }
        }
      }
    }
  }

  function onInstall() {
		$db = $this->getDb();
		
		$db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a business video {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitebusinessvideo_create";');
		
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusinessvideo.is.active')
            ->limit(1);
    $sitebusinessvideo_settings = $select->query()->fetchAll();

		// WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_menuitems')
						->where('name = ?', 'sitebusinessvideo_admin_widget_settings')
						->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitebusinessvideo_settings)) {
						$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
						("sitebusinessvideo_admin_widget_settings", "sitebusinessvideo", "Widget Settings", "", \'{"route":"admin_default","module":"sitebusinessvideo","controller":"widgets"}\', "sitebusinessvideo_admin_main", "", 0, 3, 1)');
		}


      //START THE WORK FOR MAKE WIDGETIZE BUSINESS OF VIDEO LISTING AND VIDEO VIEW BUSINESS
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitebusinessvideo')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'communityad')
							->where('enabled 	 = ?', 1)
							->limit(1);
				;
			$infomation = $select->query()->fetch();
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_settings')
							->where('name = ?', 'sitebusiness.communityads')
							->where('value 	 = ?', 1)
							->limit(1);
			$rowinfo = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessvideo_index_videolist')
							->limit(1);
			;
			$info = $select->query()->fetch();

      $select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessvideo_index_browse')
							->limit(1);
			;
			$info_browse = $select->query()->fetch();

			if ( empty($info) && empty($info_browse) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessvideo_index_browse',
						'displayname' => 'Browse Business Videos',
						'title' => 'Business Videos',
						'description' => 'This is the business videos.',
						'custom' => 1,
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.search-sitebusinessvideo',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.sitebusiness-video',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homefeaturelist-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Featured Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.sitebusiness-sponsoredvideo',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Sponsored Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homecomment-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 6,
						'params' => '{"title":"Most Commented Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homeview-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 7,
						'params' => '{"title":"Most Viewed Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homelike-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 8,
						'params' => '{"title":"Most Liked Videos","titleCount":"true"}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homerate-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 9,
						'params' => '{"title":"Top Rated Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessvideo.homerecent-sitebusinessvideos',
							'parent_content_id' => $right_id,
							'order' => 10,
							'params' => '{"title":"Recent Videos","titleCount":"true"}',
					));

				if ( !empty($infomation)  && !empty($rowinfo) ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 11,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
      else {
        $db->update('engine4_core_pages', array('name' => 'sitebusinessvideo_index_browse'), array('name = ?' => 'sitebusinessvideo_index_videolist'));
      }

		 $db = $this->getDb();
   
			$select = new Zend_Db_Select($db);

			// Check if it's already been placed
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessvideo_index_view')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessvideo_index_view',
						'displayname' => 'Business Video View Page',
						'title' => 'View Business Video',
						'description' => 'This is the view business for a business video.',
						'custom' => 1,
						'provides' => 'subject=sitebusinessvideo',
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

				// middle column content
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.video-content',
						'parent_content_id' => $middle_id,
						'order' => 1,
						'params' => '',
				));

				// right column
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.show-same-tags',
						'parent_content_id' => $right_id,
						'order' => 1,
						'params' => '{"title":"Similar Videos"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.show-also-liked',
						'parent_content_id' => $right_id,
						'order' => 2,
						'params' => '{"title":"People Also Liked"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.show-same-poster',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"From the same Member"}',
				));

				if ( !empty($infomation)  && !empty($rowinfo) ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusiness.business-ads',
							'parent_content_id' => $right_id,
							'order' => 4,
							'params' => '{"title":"","titleCount":""}',
					));
				}

			}

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'mobi')
							->where('enabled 	 = ?', 1)
							->limit(1);
			;  
			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_pages')
								->where('name = ?', 'sitebusinessvideo_mobi_view')
								->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
							'name' => 'sitebusinessvideo_mobi_view',
							'displayname' => 'Mobile Business Video Profile',
							'title' => 'Mobile Business Video Profile',
							'description' => 'This is the mobile verison of a Business video profile business.',
							'custom' => 0,
					));
					$business_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'main',
							'parent_content_id' => null,
							'order' => 1,
							'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'right',
							'parent_content_id' => $container_id,
							'order' => 1,
							'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'container',
							'name' => 'middle',
							'parent_content_id' => $container_id,
							'order' => 3,
							'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessvideo.video-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));

					// right column
					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessvideo.show-same-tags',
							'parent_content_id' => $right_id,
							'order' => 1,
							'params' => '{"title":"Similar Videos"}',
					));

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessvideo.show-also-liked',
							'parent_content_id' => $right_id,
							'order' => 2,
							'params' => '{"title":"People Also Liked"}',
					));

					$db->insert('engine4_core_content', array(
							'page_id' => $business_id,
							'type' => 'widget',
							'name' => 'sitebusinessvideo.show-same-poster',
							'parent_content_id' => $right_id,
							'order' => 3,
							'params' => '{"title":"Other Videos From Business"}',
					));

				}
			}
    }
		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitebusinessvideo')
					->where('version < ?', '4.2.1');
		$is_enabled_video = $select->query()->fetchObject();
		
		if($is_enabled_video) {
			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessvideo_admin_submain_general_tab", "sitebusinessvideo", "General Settings", "", \'{"route":"admin_default","module":"sitebusinessvideo","controller":"widgets", "action": "index"}\', "sitebusinessvideo_admin_submain", "", 1, 0, 1)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessvideo_admin_submain_video_tab", "sitebusinessvideo", "Tabbed Videos Widget", "", \'{"route":"admin_default","module":"sitebusinessvideo","controller":"settings", "action": "widget"}\', "sitebusinessvideo_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitebusinessvideo_admin_submain_dayitems", "sitebusinessvideo", "Video of the Day", "", \'{"route":"admin_default","module":"sitebusinessvideo","controller":"settings", "action": "manage-day-items"}\', "sitebusinessvideo_admin_submain", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitebusinessvideo_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitebusinessvideo_index_home',
						'displayname' => 'Business Videos Home',
						'title' => 'Business Videos Home',
						'description' => 'This is business video home business.',
						'custom' => 1
				));
				$business_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusiness.browsenevigation-sitebusiness',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
			
				//INSERT TOP RATED BUSINESS VIDEO WIDGET
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homerate-sitebusinessvideos',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Top Rated Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homerecent-sitebusinessvideos',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Recent Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homeview-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 20,
						'params' => '{"title":"Most Viewed Videos","titleCount":"true"}',
				));

			// Middele
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.featured-videos-carousel',
						'parent_content_id' => $middle_id,
						'order' => 16,
						'params' => '{"title":"Featured Videos","vertical":"0", "noOfRow":"2","inOneRow":"3","interval":"250","name":"sitebusinessvideo.featured-videos-carousel"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.list-videos-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Videos","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.sitebusinessvideolist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.search-sitebusinessvideo',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.video-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 12,
						'params' => '{"title":"Video of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homefeaturelist-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Videos","itemCountPerBusiness":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homecomment-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Videos","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $business_id,
						'type' => 'widget',
						'name' => 'sitebusinessvideo.homelike-sitebusinessvideos',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Videos","titleCount":"true"}',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_core_content')
						->where('name = ?', 'sitebusinessvideo.featurelist-sitebusinessvideos');
						
			$is_exit = $select->query()->fetchObject();
			if(!empty($is_exit)) {
				$db->update('engine4_core_content', array(
					'name' => 'sitebusinessvideo.highlightlist-sitebusinessvideos',
					'params' => '{"title":"Highlighted Videos","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessvideo.featurelist-sitebusinessvideos',
				));
			}
			
			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitebusiness_admincontent')
						->where('name = ?', 'sitebusinessvideo.featurelist-sitebusinessvideos');
						
			$is_exit_content = $select->query()->fetchObject();
			if(!empty($is_exit_content)) {
				$db->update('engine4_sitebusiness_admincontent', array(
					'name' => 'sitebusinessvideo.highlightlist-sitebusinessvideos',
					'params' => '{"title":"Highlighted Videos","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessvideo.featurelist-sitebusinessvideos',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitebusiness_content')
						->where('name = ?', 'sitebusinessvideo.featurelist-sitebusinessvideos');
						
			$is_exit_sitebusinesscontent = $select->query()->fetchObject();
			if(!empty($is_exit_sitebusinesscontent)) {
				$db->update('engine4_sitebusiness_content', array(
					'name' => 'sitebusinessvideo.highlightlist-sitebusinessvideos',
					'params' => '{"title":"Highlighted Videos","titleCount":true}',
							), array(
					'name = ?' => 'sitebusinessvideo.featurelist-sitebusinessvideos',
				));
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'featured'")->fetch();
      $highlightedColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'highlighted'")->fetch();
			if (!empty($featuredColumn) && empty($highlightedColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessvideo_videos` CHANGE `featured` `highlighted` TINYINT( 1 ) NOT NULL");
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitebusinessvideo_videos` ADD `featured` TINYINT( 1 ) NOT NULL AFTER `highlighted`");
			}

      $db->update('engine4_core_pages', array('displayname' => 'Browse Business Videos'), array('displayname = ?' => 'Business Videos')); 
		}
	
    //END THE WORK FOR MAKE WIDGETIZE BUSINESS OF VIDEO LISTING AND VIDEO VIEW BUSINESS
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitebusiness.feed.type');
    $info = $select->query()->fetch();
    $enable = 1;
    if (!empty($info)) 
     $enable = $info['value'];
      $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitebusinessvideo_admin_new", "sitebusinessvideo", "{item:$object} posted a new video:",' . $enable . ', 6, 2, 1, 1, 1, 1)');
  
		$select = new Zend_Db_Select($db);
		$select
				->from('engine4_core_modules')
				->where('name = ?', 'sitemobile')
				->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
			include APPLICATION_PATH . "/application/modules/Sitebusinessvideo/controllers/license/mobileLayoutCreation.php";
		}
		

    $videoTable = $db->query('SHOW TABLES LIKE \'engine4_sitebusinessvideo_videos\'')->fetch();
    if(!empty($videoTable)) {
			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'featured'")->fetch();        
			if(!empty($featuredColumn)) {
					$featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessvideo_videos` WHERE Key_name = 'featured'")->fetch();   
					if(empty($featuredIndex)) {
						$db->query("ALTER TABLE `engine4_sitebusinessvideo_videos` ADD INDEX ( `featured` )");
					}
			}

			$highlightedColumn = $db->query("SHOW COLUMNS FROM engine4_sitebusinessvideo_videos LIKE 'highlighted'")->fetch();        
			if(!empty($highlightedColumn)) {
					$highlightedIndex = $db->query("SHOW INDEX FROM `engine4_sitebusinessvideo_videos` WHERE Key_name = 'highlighted'")->fetch();   
					if(empty($highlightedIndex)) {
						$db->query("ALTER TABLE `engine4_sitebusinessvideo_videos` ADD INDEX ( `highlighted` )");
					}
			}
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }
  
  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitebusinessvideo','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitebusinessvideo')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitebusinessvideo/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the business plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitebusiness/settings/language/redirect/query');
      }
    }
    
  }
  
  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitebusinessvideo_video", "sitebusinessvideo", \'{item:$subject} replied to a comment on {item:$owner}\'\'s business video {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }  
}

?>
