<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitebusinessvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitebusinessvideo.isActivate', 0);
if (empty($isActive)) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Business Profile Videos'),
        'description' => $view->translate('This widget forms the Videos tab on the Business Profile and displays the videos of the Business. It should be placed in the Tabbed Blocks area of the Business Profile.'),
        'category' => $view->translate('Business Profile'),
        'type' => 'widget',
        'name' => 'sitebusinessvideo.sitemobile-profile-sitebusinessvideos',
        'defaultParams' => array(
            'title' => $view->translate('Videos'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Business Videos'),
        'description' => $view->translate('Displays the list of Videos from Businesses created on your community. This widget should be placed in the widgetized Business Videos business. Results from the Search Business Videos form are also shown here.'),
        'category' => $view->translate('Businesses'),
        'type' => 'widget',
        'name' => 'sitebusinessvideo.sitebusiness-video',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of videos to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
		array(
				'title' => $view->translate('Business Video View'),
				'description' => $view->translate("This widget should be placed on the Business Video View Page."),
				'category' => $view->translate('Businesses'),
				'type' => 'widget',
				'name' => 'sitebusinessvideo.video-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
		),
)
?>