<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecitycontent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2015-01-25 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecitycontent_Api_Core extends Core_Api_Abstract {

    /**
     * Plugin which return the error, if admin is not using correct version for the plugins.
     *
     */
    public function isModulesSupport($modName = null) {

        if (empty($modName)) {
            $modArray = array(
                'seaocore' => '4.8.7p14',
                'sitemenu' => '4.8.7p1',
                'siteluminous' => '4.8.7p9',
                'siteadvsearch' => '4.8.6p13',
                'sitereview' => '4.8.6p13',
                'sitereviewlistingtype' => '4.8.6p13',
                'siteevent' => '4.8.6p8',
                'sitealbum' => '4.8.7p5',
                'sitemember' => '4.8.6p18',
                'sitepage' => '4.8.6p13',
                'sitepageevent' => '4.8.6p3',
                'sitebusiness' => '4.8.6p11',
                'sitebusinessevent' => '4.8.6p3',
                'sitegroup' => '4.8.6p11',
                'sitegroupevent' => '4.8.6p3',
                'sitestore' => '4.8.7',
                'sitetagcheckin' => '4.8.6p3',
                'sitemobile' => '4.8.6p10',
            );
        } else {
            $modArray[$modName['modName']] = $modName['version'];
        }

        $finalModules = array();
        foreach ($modArray as $key => $value) {
            $isModEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled($key);
            if (!empty($isModEnabled)) {
                $getModVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule($key);

                $running_version = $getModVersion->version;
                $product_version = $value;
                $shouldUpgrade = false;
                if (!empty($running_version) && !empty($product_version)) {
                    $temp_running_verion_2 = $temp_product_verion_2 = 0;
                    if (strstr($product_version, "p")) {
                        $temp_starting_product_version_array = @explode("p", $product_version);
                        $temp_product_verion_1 = $temp_starting_product_version_array[0];
                        $temp_product_verion_2 = $temp_starting_product_version_array[1];
                    } else {
                        $temp_product_verion_1 = $product_version;
                    }
                    $temp_product_verion_1 = @str_replace(".", "", $temp_product_verion_1);


                    if (strstr($running_version, "p")) {
                        $temp_starting_running_version_array = @explode("p", $running_version);
                        $temp_running_verion_1 = $temp_starting_running_version_array[0];
                        $temp_running_verion_2 = $temp_starting_running_version_array[1];
                    } else {
                        $temp_running_verion_1 = $running_version;
                    }
                    $temp_running_verion_1 = @str_replace(".", "", $temp_running_verion_1);


                    if (($temp_running_verion_1 < $temp_product_verion_1) || (($temp_running_verion_1 == $temp_product_verion_1) && ($temp_running_verion_2 < $temp_product_verion_2))) {
                        $shouldUpgrade = true;
                    }
                }

                if (!empty($shouldUpgrade)) {
                    $finalModules[] = $getModVersion->title;
                }
            }
        }

        return $finalModules;
    }

}
