<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecitycontent
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 6590 2015-01-25 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecitycontent_Form_Admin_Settings_Global extends Engine_Form {

      // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
    public $_SHOWELEMENTSBEFOREACTIVATE = array(
        "submit_lsetting", "environment_mode", "configurableModules"
    );
  
    public function init() {

        $this
                ->setTitle('Global Settings')
                ->setDescription('These settings affect all members in your community.');
        $this->setAttrib('onsubmit', 'return confirmChanges();');

        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', 'sitecitycontent_lsettings', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecitycontent.lsettings'),
        ));

        $modulesArray = array('siteevent', 'sitemember', 'sitealbum', 'sitebusiness', 'sitepage', 'sitegroup', 'sitereview', 'sitestore', 'sitestoreproduct');

        $activatedModulesArray = array();
        $activatedModulesArray['defaultSettings'] = "Default configuration settings";
        $activatedModulesArray['siteluminous'] = "Landing / Home Page";
        foreach ($modulesArray as $module) {
            $moduleDetails = Engine_Api::_()->getDbtable('modules', 'core')->getModule($module);
            if (!empty($moduleDetails) && !empty($moduleDetails->enabled)) {
                if ($module == 'sitereview') {
                    $listingTypeTable = Engine_Api::_()->getDbTable('listingtypes', 'sitereview');
                    $listingTypeTableName = $listingTypeTable->info('name');
                    $select = $listingTypeTable->select()->from($listingTypeTableName, array('listingtype_id', 'title_singular'));
                    $listingTypes = $listingTypeTable->fetchAll($select);
                    foreach ($listingTypes as $listingType) {
                        $activatedModulesArray[$module . "_listingtype_" . $listingType->listingtype_id] = $moduleDetails->title . " - " . $listingType->title_singular . " Listings";
                    }
                } else {
                    $activatedModulesArray[$module] = $moduleDetails->title;
                }
            }
        }
        
        $this->addElement('MultiCheckbox', 'configurableModules', array(
            'label' => 'Configure Modules / Pages',
            'description' => "Select the modules for configure them to location / city specific content package.[Note:After saving this setting, plugin pages and navigation will be display like our demo website]",
            'multiOptions' => $activatedModulesArray,
        ));
        $this->configurableModules->addDecorator('Description', array('placement' => 'PREPEND', 'class' => 'description', 'escape' => false));

        
        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }

        //Add submit button
        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
