<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Jury extends Engine_Form {

  protected $_field;

  public function init() {
    $this->setMethod('post');
    $this->setTitle('Add a Jury Member')
        ->setDescription('Select a jury member which can vote to the entries and winner will be declared according to jury member votes.');

    $label = new Zend_Form_Element_Text('title');
    $label->setLabel('Member')
        ->addValidator('NotEmpty')
        ->setRequired(true)
        ->setAttrib('class', 'text')
        ->setAttrib('style', 'width:300px;');


    // init to
    $this->addElement('Hidden', 'user_id', array( 'order' => 900,));

    $this->addElements(array(
        $label,
    ));

    // Buttons
    $this->addElement('Button', 'submit', array(
        'label' => 'Add Member',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
    ));

    // Element: cancel
    $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'link' => true,
        'prependText' => ' or ',
        'onclick' => 'javascript:parent.Smoothbox.close()',
        'decorators' => array(
          'ViewHelper',
        ),
    ));

    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
    $button_group = $this->getDisplayGroup('buttons');
  }
}
?>

<style type="text/css">
.sitecontest_categories-autosuggest li{
    cursor: pointer;
}
</style>