<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Settings_Entries extends Authorization_Form_Admin_Level_Abstract
{
	public function init() {

		parent::init();
    
    unset($this->level_id->options[5]);
    	// My stuff
	    $this
      	->setTitle('Member Level Settings for Entries')
      	->setDescription(" These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.");

		$this->addElement('Radio', 'delete', array(
        'label' => 'Allow Deletion of Entries?',
        'description' => 'Do you want to let members delete entries?',
        'multiOptions' => array(
          2 => 'Yes, allow members to delete all entries.',
          1 => 'Yes, allow them to delete their entries.',
          0 => 'No, do not allow them to delete entries.'
        ),
        'value' => ( $this->isModerator() ? 2 : 1 ),
    ));
    if( !$this->isModerator() ) {
        unset($this->delete->options[2]);
      }


		$this->addElement('Radio', 'comment', array(
        'label' => 'Allow Commenting on Entries?',
        'description' => 'Do you want to let members of this level comment on entries?',
        'multiOptions' => array(
          2 => 'Yes, allow members to comment on all entries, including private ones.',
          1 => 'Yes, allow them to comment on entries.',
          0 => 'No, do not allow them to comment on entries.'
        ),
          'value' => ( $this->isModerator() ? 2 : 1 ),
    ));
    if( !$this->isModerator() ) {
        unset($this->comment->options[2]);
      }

		$this->addElement('Radio', 'participation', array(
        'label' => 'Allow Participation in Contests?',
        'description' => 'Do you want to let members of this level participate in contests?',
        'multiOptions' => array(
          1 => 'Yes, allow them to participate in contests.',
          0 => 'No, do not allow them to participate in contests.'
        ),
        'value' => 1,
      ));

		$this->addElement('Radio', 'vote', array(
        'label' => 'Allow Voting on Entries?',
        'description' => 'Do you want to let members of this level vote on entry ?',
        'multiOptions' => array(
          1 => 'Yes, allow them to vote on entries. ',
          0 => 'No, do not allow them to vote on entries.'
        ),
        'value' => 1,
    ));
	}
}
?>