<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Widget_Contestsbrowse extends Engine_Form {

  public function init(){

    $this->addElement('MultiCheckbox', 'layouts_views', array(
      'label' => 'Choose the view types that you want to be available for contests on the contests home and browse contests.',
      'multiOptions' => array("1" => "List View", "2" => "Grid View")
    ));

   $this->addElement('Radio','layouts_oder',array(
      'label' => 'Select a default view type for Contest Items / Contests.',
      'multiOptions' => array("1" => "List View", "2" => "Grid View")
    ));
    $this->addElement('Text','columnWidth', array(
      'label' => 'Column Width For Grid View.',
      'value' => '212',
      'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(1),
      ),
    ));
    $this->addElement('Text','columnHeight',array(
      'label' => 'Column Height For Grid View.',
      'value' => '270',
      'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(1),
      ),
    ));
    $this->addElement('Text','turncation', array(
      'label' => 'Description Truncation Limit For Grid View.',
      'value' => '40',
      'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(1),
      ),
    ));
    $this->addElement('Text','list_turncation', array(
      'label' => 'Description Truncation Limit For List View.',
      'value' => '40',
      'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(1),
      ),
    ));
    $this->addElement( 'Radio', 'showpostedBy', array(
      'label' => 'Do you want image of owner of the Contests to be displayed ?',
      'multiOptions' => array(
          1 => 'Yes',
          0 => 'No'),
      'value' => 1, 
    ));

    $this->addElement('Select','status',array(
      'label' => 'What do you want for contest filter ?',
      'description' => '',
      'multiOptions' => array(
          '' => 'All',
          'active' => 'Active',
          'coming soon' => 'Coming Soon',
          'expired' => 'Ended'),
      'value' => 2,
    ));
    $this->addElement('MultiCheckbox', 'contacts', array(
      'label' => 'Choose share options ',
      'description' => 'it will be shown on contest',
      'multiOptions' => array(
          'facebook' => 'Facebook [Social Share Link]',
          'twitter' => 'Twitter [Social Share Link]',
          'linkedin' => 'LinkedIn [Social Share Link]',
          'googleplus' => 'Google+ [Social Share Link]'
      ),
    ));
    $this->addElement('MultiCheckbox', 'contest_item', array(
      'label' => 'Choose information ',
      'description' => 'it will be shown on contest',
      'multiOptions' => array(
          'like' => 'Like',
          'post' => 'Posted By',
          'date' => 'Creation Date',
          'description' => 'Description',
          'category' =>'Category',
          'views' =>'Views',
          'comment' => 'Comments',
          'follow' =>'Follow Count',
      ),
    ));

    $this->addElement('Select','show_content',array(
      'label' => 'What do you want for view more content?',
      'description' => '',
      'multiOptions' => array(
          '2' => 'Show View More Link at Bottom',
          '3' => 'Auto Load Pages on Scrolling Down'),
      'value' => 2,
    ));
    $this->addElement('Text','itemCount',array(
        'label' => 'Count',
        'description' => '(number of Contests to show)',
        'value' => 10,
        'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
        ),
      )
    );
  } 
}
?>