<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 class Sitecontest_Form_Admin_Widget_Sponsoredslideshow extends Engine_Form
 {
  public function init() {
    $this->setMethod('post');
    $this->setTitle('Sponsored Slideshow Carousel')->setDescription('Set your contest according to your user UI prefrence')->setAttrib('name', 'contests_create');

    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'description' => '',
      'value' => ''
    ));

    $this->addElement('Text','turncation', array(
        'label' => 'Title Truncation Limit .',
        'value' => '40',
        'validators' => array(
          array('Int', true),
          array('GreaterThan', true, array(0)),
      ),
    ));

    $this->addElement('Text','count', array(
        'label' => 'Count(number of contests to be shown in this widget, please enter more than 3.)',
        'value' => '5',
        'validators' => array(
          array('Int', true),
          array('GreaterThan', true, array(0)),
      ),
    ));

    $this->addElement('MultiCheckbox', 'contest_item', array(
      'label' => 'Choose ',
      'description' => 'it will be shown in carousel',
      'multiOptions' => array(
        'postedBy' => 'Posted By',
        'category' =>'Category',
        'owner' =>'Owner Image',
        'facebook' => 'Facebook [Social Share Link]',
        'twitter' => 'Twitter [Social Share Link]',
        'linkedin' => 'LinkedIn [Social Share Link]',
        'googleplus' => 'Google+ [Social Share Link]'
      ),
    ));

    $this->addElement('Select', 'show_contest', array(
      'label' => 'Show in carousel',
      'multiOptions' => array(
        "featured"=>"Featured Only",
        "sponsored"=>"Sponsored Only",
        "verified"=>"Verified Only",
        "hot"=>"Trending Only"),
    ));

    $this->addElement('Select', 'sort_contest', array(
      'label' => 'Popularity / Sorting Criteria',
      'multiOptions' => array(
        "most_liked"=>"Most Liked",
        "most_commented"=>"Most Commented",
        "created"=>"Recently created",
        "most_viewed"=>"Most Viewed"),
    ));
  }
}
?>