<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Widget_Tagsitecontest extends Engine_Form
{
  
  public function init() {

    $this->setMethod('post');
    $this->setTitle('Popular Contest Tags');
    $this->setDescription('Displays popular tags. You can choose to display tags based on their frequency / alphabets from the Edit Settings of this widget. This widget should be placed on the Advanced Contest - Contest ProfileAdvanced Contests - Browse ContestsAdvanced Contests - Contests Home pages.');

    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'description' => '',
      'value' => 'Contest Tags'
    ));

    $this->addElement('Radio', 'orderingType', array(
      'label' => 'Do you want to show popular contest tags in alphabetical order?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => 1,
    ));

    $this->addElement('Text', 'count', array(
        'label' => 'Count',
        'description' => '(number of tags to show. Enter 0 for displaying all tags.)',
        'validators' => array(
          array('Int', true),
          new Engine_Validate_AtLeast(0),
        ),
        'value' => '10'
    ));
  }
}
?>