<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Admin_Winnerdeclare extends Engine_Form
{ 

  protected $_quick;
  protected $_contestId;
  protected $_value;

  public function setvalue($flage) {
    $this->_value = $flage;
    return $this;
  }

  public function setquick($flage) {
    $this->_quick = $flage;
    return $this;
  }

  public function setcontestId($flage) {
    $this->_contestId = $flage;
    return $this;
  }

	public function init() {
		

    if(empty($this->_quick)) {

  		$this->setMethod('post');
    	$this->setTitle('Declare Winner')
    		->setAttrib('class', 'global_form_popup')
        ->setDescription('You can choose this entry to be the direct winner of the contest.');

      $entryTable = Engine_Api::_()->getDbtable('entries', 'sitecontest');
      $entryTableName = $entryTable->info('name');
      $select = $entryTable->select()->from($entryTableName, '*')
      ->where('contest_id=?', $this->_contestId)
      ->order('winner ASC');
      $entries = $entryTable->fetchAll($select);
      $ranks = array();
      foreach ($entries as $entry) {
        if(!empty($entry->winner)) {
          $ranks[] = $entry->winner;
        }
      }
      
      for($i = 1; $i <= $this->_value; $i++) {
        $shows[$i] = $i;
      }

      $this->addElement('Select', 'winner', array(
  	    'label' => 'Select what Rank you want to assign to this entry.',
  	    'multiOptions' =>  $shows ,
      ));
      foreach ($ranks as $rank) {
        unset($this->winner->options[$rank]);
      }
      $this->winner->getDecorator('Description')->setOption('placement', 'append');

      $this->addElement('Button', 'submit', array(
        'label' => 'Declare Winner',
        'type' => 'submit',
        'ignore' => true,
        'decorators' => array('ViewHelper')
      ));

      // Element: cancel
      $this->addElement('Cancel', 'cancel', array(
        'label' => 'cancel',
        'link' => true,
        'prependText' => ' or ',
        'onclick' => 'javascript:parent.Smoothbox.close()',
        'decorators' => array(
            'ViewHelper',
        ),
      ));

    } else {
      echo "<br><h2>This Contest is Active. You can declare the winner after the contest ends.</h2>";

    }

	}
}
?>

<style type="text/css">
  
  #global_content_simple h2 {text-align: center;
    margin: 0;
    font-family: arial;
    padding: 0 20px;
    font-weight: normal;
    font-size: 16px;
    line-height: 24px;
}
#winner-element{margin:10px 0 15px 0;}
</style>