<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Form_Compose extends Engine_Form
{
  
  public function init() {

    $this->setTitle('Compose Message');
    $this->setDescription('Create your new message with the form below. ')
        ->setAttrib('id', 'messages_compose')
        ->setAttrib('class', 'global_form_popup');

    // Init to Values
    $this->addElement('Hidden', 'toValues', array(
        'label' => 'Send To',
        'order' => 200,
        'validators' => array(
          'NotEmpty'
        ),
        'filters' => array(
          'HtmlEntities'
        ),
    ));

    // init title
    $this->addElement('Text', 'title', array(
      'label' => 'Subject',
      'order' => 6,
      'required' => true,
      'filters' => array(
          'StripTags',
          new Engine_Filter_Censor(),
          new Engine_Filter_HtmlSpecialChars(),
      ),
    ));

       
    // init body - plain text
    $this->addElement('Textarea', 'body', array(
      'label' => 'Message',
      'order' => 7,
      'required' => true,
      'allowEmpty' => false,
      'filters' => array(
          new Engine_Filter_HtmlSpecialChars(),
          new Engine_Filter_Censor(),
          new Engine_Filter_EnableLinks(),
      ),
    ));
        
    // init submit
    $this->addElement('Button', 'submit', array(
        'label' => 'Send Message',
        'order' => 8,
        'type' => 'submit',
        'ignore' => true
    ));
  }
}
?>