<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Model_DbTable_Otherinfo extends Engine_Db_Table {

  protected $_rowClass = "Sitecontest_Model_Otherinfo";

  public function getOtherinfo($contest_id) {

    $rName = $this->info('name');
    $select = $this->select()
            ->where($rName . '.contest_id = ?', $contest_id);

    $row = $this->fetchRow($select);

    if (empty($row))
        return;

    return $row;
  }

  public function getColumnValue($contest_id, $column_name) {

    return $this->select()
                ->from($this->info('name'), array("$column_name"))
                ->where('contest_id = ?', $contest_id)
                ->limit(1)
                ->query()
                ->fetchColumn();
  }
    
  public function getOtherinfoColumns($params){     
    $select = $this->select()
                  ->from($this->info('name'), $params['columns'])
                  ->where('contest_id = ?', $params['contest_id']);
    $row = $this->fetchRow($select);
    if (empty($row))
        return;
    return $row;
  }
}
?>