<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecontest_Model_DbTable_Votes extends Engine_Db_Table
{
  
  protected $_rowClass = "Sitecontest_Model_Vote";

  public function getVoteTable()
  {
    return $this;
  }
  
	public function addVote(Core_Model_Item_Abstract $resource, Core_Model_Item_Abstract $poster, $contest_id)
	{
	    $table = $this->getVoteTable();
	    if(empty(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.user.vote'))){
		    $select = $table->select()
		    		->where('contest_id = ?', $contest_id)
		    		->where('poster_id = ?', $poster->getIdentity())
		    		->limit(1);
		    $fetchRow = $table->fetchRow($select);
		    if( !empty($fetchRow) ){
		    	$entry = Engine_Api::_()->getItem('sitecontest_entry',$fetchRow->resource_id);
		    	$entry->vote_count--;
		    	$entry->save();
		    	$fetchRow->resource_id = $resource->getIdentity();
		    	$fetchRow->save();
		    	$row = $fetchRow;
		    } else {
          $row = $table->createRow();
          if( isset($row->resource_type) )
          {
            $row->resource_type = $resource->getType();
          }
          $row->resource_id = $resource->getIdentity();
          $row->poster_type = $poster->getType();
          $row->poster_id = $poster->getIdentity();
          $row->contest_id = $contest_id;
          $row->save();
        }
      } else {
        //CHECK IF THE USER HAVE ALREADY VOTED
        $select = $table->select()
            ->where('contest_id = ?', $contest_id)
            ->where('resource_id = ?', $resource->getIdentity())
            ->where('resource_type = ?', $resource->getType())
            ->where('poster_id = ?', $poster->getIdentity())
            ->limit(1);
        $fetchRow = $table->fetchRow($select);
        if( !empty($fetchRow) ) {
          $row = $fetchRow;
        } else {
          $row = $table->createRow();
          if( isset($row->resource_type) )
            {
              $row->resource_type = $resource->getType();
            }
          $row->resource_id = $resource->getIdentity();
            $row->poster_type = $poster->getType();
            $row->poster_id = $poster->getIdentity();
            $row->contest_id = $contest_id;
            $row->save();
        }
      }

      if( isset($resource->vote_count) )
      { 
        //IT WILL UPDATE THE VOTE COUNT EACH TIME VOTE ACTION IS CALLED, ONE USER CAN VOTE ONLY ONCE FOR A ENTRY
        Engine_Api::_()->sitecontest()->updateVoteCount($resource);
      }
      return $row;
  }

  public function getVoteCount(Core_Model_Item_Abstract $resource) {
    if( isset($resource->vote_count) )
    {
      return $resource->vote_count;
    }
    $select = new Zend_Db_Select($this->getVoteTable()->getAdapter());
    $select
      ->from($this->getVoteTable()->info('name'), new Zend_Db_Expr('COUNT(1) as count'));

    if( !$this->_custom )
    {
      $select->where('resource_type = ?', $resource->getType());
    }

    $select->where('resource_id = ?', $resource->getIdentity());
    $data = $select->query()->fetchAll();
    return (int) $data[0]['count'];
  }

}

?>