<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php 
class Sitecontest_Plugin_Core 
{
	
	public function onSitecontestContCreateAfter($event) {
    $view = $event->getPayload();
    $session = new Zend_Session_Namespace('create_contest');
    $session->createcontest = 1;
  }
     
  public function onRenderLayoutDefault($event, $mode = null) {
    $view = Zend_Registry::get('Zend_View');
    $view->headLink()->appendStylesheet($view->layout()->staticBaseUrl . 'externals/font-awesome/css/font-awesome.min.css');
    $viewer = Engine_Api::_()->user()->getViewer();
    $event->getPayload()->headLink()->appendStylesheet($event->getPayload()->layout()->staticBaseUrl . 'application/modules/Sitecontest/externals/styles/main.css');
    $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecontest.slugplural', "contestitems");
    $contestTable = Engine_Api::_()->getDbtable('contests', 'sitecontest');
    $contestTableName = $contestTable->info('name');
    $select = $contestTable->select()->from($contestTableName, '*')
            ->where('user_id=?', $viewer->getIdentity())
            ->order('contest_id DESC')
            ->limit(1);
    $contests = $contestTable->fetchAll($select);
        
    $isWelcomePopup = $view->settings('sitecontest.share.popup.enabled',1);
    $session = new Zend_Session_Namespace('create_contest');
    if (!empty($session->createcontest) && !empty($viewer->getIdentity()) && $isWelcomePopup) {
        unset($session->createcontest);
        foreach ($contests as $contest) { 
          $urlEditProfile = $view->baseUrl() .'/'. $routeStartP . '/profilepage/tell-a-friend/contest_id/'. $contest->getIdentity();
          $urlViewProfile = $view->baseUrl() .'/activity/index/share/type/'. $contest->getType() .'/id/'. $contest->getIdentity() .'/format/smoothbox' ;
          }
            // $userTitle = addslashes(ucwords($viewer->getTitle()));
        $editYourProfile = $view->translate('Tell A Friend');
        $viewYourProfile = $view->translate('Share Contest');
        $content = $view->translate('You have successfully created a contest').'.<br>'.$view->translate('Do you want to share now?');
            
        $script = <<<EOF
          en4.core.runonce.add(function(){
                     Smoothbox.open('<div class = "sitecontest_welcome_message_wrapper"><div class="sitecontest_welcome_popup_close_icon" onclick = "parent.Smoothbox.close()"></div> <div class ="sitecontest_welcome_message" > $content </div> <div class = "sitecontest_welcome_options " > <button onclick = "parent.Smoothbox.close(); Smoothbox.open(\'$urlEditProfile\')"> $editYourProfile</button> <button onclick = "parent.Smoothbox.close(); Smoothbox.open(\'$urlViewProfile\')"> $viewYourProfile </button></div></div>');
          });
EOF;
        $view->headScript()->appendScript($script);
    }      
  }
    
  public function onSitecontestContDeleteBefore($event) {
    $payload = $event->getPayload();
    $contest_id = $payload->getIdentity(); 
    $table = Engine_Api::_()->getItemTable('sitecontest_entry');
    $select = $table->select()->where('contest_id = ?', $contest_id);
    $rows = $table->fetchAll($select);
    if (!empty($rows)) {
      foreach ($rows as $contest) {
        $contest->delete();
      }
    } 
  }
  
  public function onUserDeleteBefore($event) {
    $payload = $event->getPayload();
    if ($payload instanceof User_Model_User) {
      $owner_id = $payload->getIdentity(); 
      //START ALBUM CODE
      $table = Engine_Api::_()->getItemTable('sitecontest_contest');
      $select = $table->select()->where('user_id = ?', $owner_id);
      $rows = $table->fetchAll($select);
      if (!empty($rows)) {
        foreach ($rows as $contest) {
          $contest->delete();
        }
      }
      $table = Engine_Api::_()->getItemTable('sitecontest_entry');
      $select = $table->select()->where('user_id = ?', $owner_id);
      $rows = $table->fetchAll($select);
      if (!empty($rows)) {
        foreach ($rows as $entry) {
          $entry->delete();
        }
      }
      $table = Engine_Api::_()->getItemTable('sitecontest_photo');
      $select = $table->select()->where('user_id = ?', $owner_id);
      $rows = $table->fetchAll($select);
      if (!empty($rows)) {
        foreach ($rows as $photo) {
          $photo->delete();
        }
      }
      $table = Engine_Api::_()->getItemTable('sitecontest_vote');
      $select = $table->select()->where('poster_id = ?', $owner_id);
      $rows = $table->fetchAll($select);
      if (!empty($rows)) {
        foreach ($rows as $vote) {
          $vote->delete();
        }
      } 
    }
  }
}

?>