<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_AdminCategoriesController extends Core_Controller_Action_Admin
{
	public function indexAction() { 
		//GET NAVIGATION
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
				->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_categories'); 
		//GET TASK
		if (isset($_POST['task'])) {
			$task = $_POST['task'];
		} elseif (isset($_GET['task'])) {
			$task = $_GET['task'];
		} else {
			$task = "main";
		}

		//GET CATEGORIES TABLE
		$tableCategory = Engine_Api::_()->getDbTable('categories', 'sitecontest');
		$tableCategoryName = $tableCategory->info('name');

		//GET CONTEST TABLE
		$tableSitecontest = Engine_Api::_()->getDbtable('contests', 'sitecontest');

		if ($task == "changeorder") {
			$divId = $_GET['divId'];
			$sitecontestOrder = explode(",", $_GET['sitecontestorder']);
			//RESORT CATEGORIES
			if ($divId == "categories") {
				for ($i = 0; $i < count($sitecontestOrder); $i++) {
					$category_id = substr($sitecontestOrder[$i], 4);
					$tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
				}
			} elseif (substr($divId, 0, 7) == "subcats") {
				for ($i = 0; $i < count($sitecontestOrder); $i++) {
					$category_id = substr($sitecontestOrder[$i], 4);
					$tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
				}
			} elseif (substr($divId, 0, 11) == "treesubcats") {
				for ($i = 0; $i < count($sitecontestOrder); $i++) {
					$category_id = substr($sitecontestOrder[$i], 4);
					$tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
				}
			}
		}

		$categories = array();
		$category_info = $tableCategory->getCategories(array('category_id', 'category_name','cat_order', 'file_id', 'banner_id'), null, 0, 0, 1);

		foreach ($category_info as $value) {
			$sub_cat_array = array();
			$subcategories = $tableCategory->getSubCategories($value->category_id);
			foreach ($subcategories as $subresults) {
				$subsubcategories = $tableCategory->getSubCategories($subresults->category_id);
				$treesubarrays[$subresults->category_id] = array();
				
				foreach ($subsubcategories as $subsubcategoriesvalues) {

					//GET TOTAL CONTEST COUNT
					$subsubcategory_sitecontest_count = $tableSitecontest->getContestsCount($subsubcategoriesvalues->category_id, 'subsubcategory_id');

					$treesubarrays[$subresults->category_id][] = $treesubarray = array(
						'tree_sub_cat_id' => $subsubcategoriesvalues->category_id,
						'tree_sub_cat_name' => $subsubcategoriesvalues->category_name,
						'count' => $subsubcategory_sitecontest_count,
						'file_id' => $subsubcategoriesvalues->file_id,
						'banner_id' => $subsubcategoriesvalues->banner_id,);
						
				} 
				//GET TOTAL CONTESTS COUNT
				$subcategory_sitecontest_count = $tableSitecontest->getContestsCount($subresults->category_id, 'subcategory_id');

				$sub_cat_array[] = $tmp_array = array(
					'sub_cat_id' => $subresults->category_id,
					'sub_cat_name' => $subresults->category_name,
					'tree_sub_cat' => $treesubarrays[$subresults->category_id],
					'count' => $subcategory_sitecontest_count,
					'file_id' => $subresults->file_id,
					'banner_id' => $subresults->banner_id,);
			}

			//GET TOTAL CONTESTS COUNT
			$category_sitecontest_count = $tableSitecontest->getContestsCount($value->category_id, 'category_id');

			$categories[] = $category_array = array(
				'category_id' => $value->category_id,
				'category_name' => $value->category_name,
				'count' => $category_sitecontest_count,
				'file_id' => $value->file_id,
				'banner_id' => $value->banner_id,
				'sub_categories' => $sub_cat_array);
		}

			   
		$this->view->categories = $categories;

		$request = Zend_Controller_Front::getInstance()->getRequest();
		$this->view->category_id = $category_id = $request->getParam('category_id', 0);
		$perform = $request->getParam('perform', 'add');
		$cat_dependency = 0;
		$subcat_dependency = 0;
		if ($category_id) {
			$category = Engine_Api::_()->getItem('sitecontest_category', $category_id);
			if ($category && empty($category->cat_dependency)) {
				$cat_dependency = $category->category_id;
			} elseif ($category && !empty($category->cat_dependency)) {
				$cat_dependency = $category->category_id;
				$subcat_dependency = $category->category_id;
			}
		}

		if ($perform == 'add') {
			$this->view->form = $form = new Sitecontest_Form_Admin_Categories_Add();

			//CHECK POST
			if (!$this->getRequest()->isPost()) {
				return;
			}

			//CHECK VALIDITY
			if (!$form->isValid($this->getRequest()->getPost())) {

				if (empty($_POST['category_name'])) {
					$form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
				}
				return;
			}

			//PROCESS
			$values = $form->getValues();

			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			try {

				$row_info = $tableCategory->fetchRow($tableCategory->select()->from($tableCategoryName, 'max(cat_order) AS cat_order'));
				$cat_order = $row_info['cat_order'] + 1;

				//GET CATEGORY TITLE
				$category_name = str_replace("'", "\'", trim($values['category_name']));
				$values['category_name'] = $category_name;
				$values['cat_order'] = $cat_order;
				$values['cat_dependency'] = $cat_dependency;
				$values['subcat_dependency'] = $subcat_dependency;
				$row = $tableCategory->createRow();
				$row->setFromArray($values);

				//UPLOAD ICON
				if (isset($_FILES['icon'])) {
					$photoFileIcon = $row->setPhoto($form->icon);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFileIcon->file_id)) {
						$row->file_id = $photoFileIcon->file_id;
					}
				}

				//UPLOAD CATEGORY PHOTO
				if (isset($_FILES['photo'])) {
					$photoFile = $row->setPhoto($form->photo, true);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFile->file_id)) {
						$row->photo_id = $photoFile->file_id;
					}
				}

				//UPLOAD BANNER
				if (isset($_FILES['banner'])) {
					$photoFileBanner = $row->setPhoto($form->banner);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFileBanner->file_id)) {
						$row->banner_id = $photoFileBanner->file_id;
					}
				}

				$category_id = $row->save();

				$db->commit();
			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}
			return $this->_helper->redirector->gotoRoute(array('module' => 'sitecontest', 'action' => 'index', 'controller' => 'categories', 'category_id' => $category_id, 'perform' => 'edit'), 'admin_default', true);
		} else {
			$this->view->form = $form = new Sitecontest_Form_Admin_Categories_Edit();
			$category = Engine_Api::_()->getItem('sitecontest_category', $category_id);
			$form->populate($category->toArray());

			//CHECK POST
			if (!$this->getRequest()->isPost()) {
				return;
			}

			//CHECK VALIDITY
			if (!$form->isValid($this->getRequest()->getPost())) {

				if (empty($_POST['category_name'])) {
					$form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
				}
				return;
			}
			$values = $form->getValues();
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			try {

				//GET CATEGORY TITLE
				$category_name = str_replace("'", "\'", trim($values['category_name']));

				$category->category_name = $category_name;

				$category->meta_title = $values['meta_title'];
				$category->meta_description = $values['meta_description'];
				$category->category_slug = $values['category_slug'];
				$cat_dependency = $category->cat_dependency;
				$subcat_dependency = $category->subcat_dependency;
				if ($category_id && empty($subcat_dependency) && !empty($cat_dependency)) {
					$cat_dependency = $cat_dependency;
					$subcat_dependency = 0;
				} elseif ($category_id && !empty($subcat_dependency) && !empty($cat_dependency)) {
					$cat_dependency = $cat_dependency;
					$subcat_dependency = $subcat_dependency;
				}

				$category->cat_dependency = $cat_dependency;
				$category->subcat_dependency = $subcat_dependency; 
				//UPLOAD ICON
				if (isset($_FILES['icon'])) {
					$previous_file_id = $category->file_id;
					$photoFileIcon = $category->setPhoto($form->icon);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFileIcon->file_id)) {

						//DELETE PREVIOUS CATEGORY ICON
						if ($previous_file_id) {
							$file = Engine_Api::_()->getItem('storage_file', $previous_file_id);
							$file->delete();
						}

						$category->file_id = $photoFileIcon->file_id;
						$category->save();
					}
				}

				//UPLOAD CATEGORY PHOTO
				if (isset($_FILES['photo'])) {
					$previous_photo_id = $category->photo_id;
					$photoFile = $category->setPhoto($form->photo, true);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFile->file_id)) {
						$category->photo_id = $photoFile->file_id;

						//DELETE PREVIOUS CATEGORY ICON
						if ($previous_photo_id) {
							$file = Engine_Api::_()->getItem('storage_file', $previous_photo_id);
							$file->delete();
						}
					}
				}

				//UPLOAD BANNER
				if (isset($_FILES['banner'])) {
					$previous_banner_id = $category->banner_id;
					$photoFileBanner = $category->setPhoto($form->banner);
					//UPDATE FILE ID IN CATEGORY TABLE
					if (!empty($photoFileBanner->file_id)) {

						//DELETE PREVIOUS CATEGORY BANNER
						if ($previous_banner_id) {
							$file = Engine_Api::_()->getItem('storage_file', $previous_banner_id);
							$file->delete();
						}

						$category->banner_id = $photoFileBanner->file_id;
						$category->save();
					}
				}

				$category->save();

				if (isset($values['removephoto']) && !empty($values['removephoto'])) {
					//DELETE CATEGORY ICON
					$file = Engine_Api::_()->getItem('storage_file', $category->photo_id);

					//UPDATE FILE ID IN CATEGORY TABLE
					$category->photo_id = 0;
					$category->save();
					$file->delete();
				}

				if (isset($values['removeicon']) && !empty($values['removeicon'])) {

					$previous_icon_id = $category->file_id;

					if ($previous_icon_id) {
						//UPDATE FILE ID IN CATEGORY TABLE
						$category->file_id = 0;
						$category->save();

						//DELETE CATEGORY ICON
						$file = Engine_Api::_()->getItem('storage_file', $previous_icon_id);
						$file->delete();
					}
				}

				if (isset($values['removebanner']) && !empty($values['removebanner'])) {

					$previous_banner_id = $category->banner_id;

					if ($previous_banner_id) {
						//UPDATE FILE ID IN CATEGORY TABLE
						$category->banner_id = 0;
						$category->save();

						//DELETE CATEGORY ICON
						$file = Engine_Api::_()->getItem('storage_file', $previous_banner_id);
						$file->delete();
					}
				}

				$db->commit();
				return $form->addNotice('Your changes have been saved.');
			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}
			return $this->_helper->redirector->gotoRoute(array('module' => 'sitecontest', 'action' => 'index', 'controller' => 'categories', 'category_id' => $category_id, 'perform' => 'edit'), 'admin_default', true);
		}
	}



	public function deleteCategoryAction() { 

		$this->_helper->layout->setLayout('admin-simple');
		$category_id = $this->_getParam('category_id');

		$this->view->category_id = $category_id;

		//GET CATEGORIES TABLE
		$tableCategory = Engine_Api::_()->getDbTable('categories', 'sitecontest');
		$tableCategoryName = $tableCategory->info('name');

		//GET contest TABLE
		$tableSitecontest = Engine_Api::_()->getDbtable('contests', 'sitecontest');

		if ($this->getRequest()->isPost()) { 
			//IF SUB-CATEGORY AND 3RD LEVEL CATEGORY IS MAPPED
			$previous_cat_profile_type = $tableCategory->getProfileType(null, $category_id);

			if ($previous_cat_profile_type) {

				//SELECT contestS WHICH HAVE THIS CATEGORY
				$contests = $tableSitecontest->getCategoryList($category_id, 'category_id');

				foreach ($contests as $contest) {

					//DELETE ALL MAPPING VALUES FROM FIELD TABLES
					Engine_Api::_()->fields()->getTable('sitecontest_cont', 'values')->delete(array('item_id = ?' => $contest->contest_id));
					Engine_Api::_()->fields()->getTable('sitecontest_cont', 'search')->delete(array('item_id = ?' => $contest->contest_id));

					//UPDATE THE PROFILE TYPE OF ALREADY CREATED contestS
					$tableSitecontest->update(array('profile_type' => 0), array('contest_id = ?' => $contest->contest_id));
				}
			}

			//SITEcontest TABLE SUB-CATEGORY/3RD LEVEL DELETE WORK
			$tableSitecontest->update(array('subcategory_id' => 0, 'subsubcategory_id' => 0), array('subcategory_id = ?' => $category_id));
			$tableSitecontest->update(array('subsubcategory_id' => 0), array('subsubcategory_id = ?' => $category_id));

			$tableCategory->delete(array('cat_dependency = ?' => $category_id, 'subcat_dependency = ?' => $category_id));
			$tableCategory->delete(array('category_id = ?' => $category_id));

			//}
			//GET URL
			$url = $this->_helper->url->url(array('action' => 'index', 'controller' => 'categories', 'perform' => 'add', 'category_id' => 0));
			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRedirect' => $url,
				'parentRedirectTime' => 1,
				'messages' => array(Zend_Registry::get('Zend_Translate')->_('Deleted successfully'))
			));
		}

		$this->renderScript('admin-categories/delete-category.tpl');
	}


	Public function mappingCategoryAction() {

		//SET LAYOUT
		$this->_helper->layout->setLayout('admin-simple');

		//GET CATEGORY ID AND OBJECT
		$this->view->catid = $catid = $this->_getParam('category_id');
		$category = Engine_Api::_()->getItem('sitecontest_category', $catid);

		//GET CATEGORY DEPENDANCY
		$this->view->subcat_dependency = $subcat_dependency = $this->_getParam('subcat_dependency');

		//CREATE FORM
		$this->view->form = $form = new Sitecontest_Form_Admin_Categories_Mapping();

		$this->view->close_smoothbox = 0;

		if (!$this->getRequest()->isPost()) {
			return;
		}

		if (!$form->isValid($this->getRequest()->getPost())) {
			return;
		}

		if ($this->getRequest()->isPost()) {

			//GET FORM VALUES
			$values = $form->getValues();

			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			try {

				//GET contest TABLE
				$tableSitecontest = Engine_Api::_()->getDbtable('contests', 'sitecontest');
				$tableSitecontestName = $tableSitecontest->info('name');

				//GET CATEGORY TABLE
				$tableCategory = Engine_Api::_()->getDbtable('categories', 'sitecontest');

				//ON CATEGORY DELETE
				$rows = $tableCategory->getSubCategories($catid);
				foreach ($rows as $row) {
					$subrows = $tableCategory->getSubCategories($row->category_id);
					foreach ($subrows as $subrow) {
						$subrow->delete();
					}
					$row->delete();
				}

				$previous_cat_profile_type = $tableCategory->getProfileType(null, $catid);
				$new_cat_profile_type = $tableCategory->getProfileType(null, $values['new_category_id']);

				/// contestS WHICH HAVE THIS CATEGORY
				if ($previous_cat_profile_type != $new_cat_profile_type && !empty($values['new_category_id'])) {
					$contests = $tableSitecontest->getCategoryList($catid, 'category_id');

					foreach ($contests as $contest) {

						//DELETE ALL MAPPING VALUES FROM FIELD TABLES
						Engine_Api::_()->fields()->getTable('sitecontest_cont', 'values')->delete(array('item_id = ?' => $contest->contest_id));
						Engine_Api::_()->fields()->getTable('sitecontest_cont', 'search')->delete(array('item_id = ?' => $contest->contest_id));
						//UPDATE THE PROFILE TYPE OF ALREADY CREATED contestS
						$tableSitecontest->update(array('profile_type' => $new_cat_profile_type), array('contest_id = ?' => $contest->contest_id));
					}
				}

				//contest TABLE CATEGORY DELETE WORK
				if (isset($values['new_category_id']) && !empty($values['new_category_id'])) {
					$tableSitecontest->update(array('category_id' => $values['new_category_id']), array('category_id = ?' => $catid));
				} else {

					$selectcontests = $tableSitecontest->select()
							->from($tableSitecontest->info('name'))
							->where('category_id = ?', $catid);
					foreach ($tableSitecontest->fetchAll($selectcontests) as $contest) {
						$contest->delete();
					}
				}

				$category->delete();

				$db->commit();
			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}
		}

		$url = $this->_helper->url->url(array('module' => 'sitecontest','action' => 'index', 'controller' => 'categories'));
		$this->_forward('success', 'utility', 'core', array(
			'smoothboxClose' => 1,
			'parentRedirect' => $url,
			'parentRedirectTime' => 1,
			'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
		));
	}
}
?>