<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_AdminContestManageController extends Core_Controller_Action_Admin {   
    
    public function indexAction() {

        //GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_contestmanage');
        //MAKE FORM
        $this->view->formFilter = $formFilter = new Sitecontest_Form_Admin_Filter();
        //GET PAGE NUMBER
        $page = $this->_getParam('page', 1);
        //GET USER TABLE NAME
        $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');
 
        //GET CATEGORY TABLE
        $this->view->tableCategory = $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitecontest');

        $getContestTable = Engine_Api::_()->getDbtable('contests', 'sitecontest');
        $pageTableName = $getContestTable->info('name');
        //MAKE QUERY
        $select = $getContestTable->select()
                        ->setIntegrityCheck(false)
                        ->from($pageTableName)
                        ->joinLeft($tableUserName, "$pageTableName.user_id = $tableUserName.user_id", 'displayname')
                        
                        ->group("$pageTableName.contest_id");
        $select->joinLeft($pageTableName, "$pageTableName.contest_id = $pageTableName.contest_id", array("title as contest"));
        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }

        foreach ($values as $key => $value) {

            if (null == $value) {
                unset($values[$key]);
            }
        }

        $this->view->owner = '';
        $this->view->title = '';
        $this->view->contest = '';
        $this->view->category_id = '';
        $this->view->subcategory_id = '';
        $this->view->subsubcategory_id = '';
        $this->view->featured = '';
        $this->view->sponsored = '';
        $this->view->hot = '';
        $this->view->verified = '';
        $this->view->approved = '';
        $this->view->media_type = '';
        $this->view->product_code = '';

        if (isset($_POST['search'])) {

            if (!empty($_POST['owner'])) {
                $this->view->owner = $_POST['owner'];
                $select->where($tableUserName . '.displayname  LIKE ?', '%' . trim($_POST['owner']) . '%');
            }

            if (!empty($_POST['created_on']) && !empty($_POST['created_on']['date'])) {
            $values['created_on'] = $_POST['created_on']['date'];
            } else {
            $values['created_on'] = '';
            }
            $this->view->created_on = $values['created_on'];

            if (isset($_POST['created_on']) && !empty($values['created_on'])) {
                $created_on = $this->view->created_on = $values['created_on'];
                $created_on = str_replace("/","-",$created_on);
                $select->where("$pageTableName.creation_date LIKE '%$created_on%'");
            }

            if (isset($_POST['media_type']) && !empty($_POST['media_type'])) {
                $this->view->media_type = $media_type = $_POST['media_type'];
                $select->where($pageTableName . '.media_type LIKE ? ', '%' . $media_type .'%');
            }

            if (isset($_POST['title']) && !empty($_POST['title'])) {
                $this->view->title = $_POST['title'];
                $select->where($pageTableName . '.title LIKE ?', '%' . trim($_POST['title']) . '%');
            }
            
            if (isset($_POST['sponsored']) && !empty($_POST['sponsored'])) {
                $this->view->sponsored = $_POST['sponsored'];
                $_POST['sponsored']--;

                $select->where($pageTableName . '.sponsored = ? ', $_POST['sponsored']);
            }

            if (isset($_POST['approved']) && !empty($_POST['approved'])) {
                $this->view->approved = $_POST['approved'];
                $_POST['approved']--;
                $select->where($pageTableName . '.approved = ? ', $_POST['approved']);
            }

            if (isset($_POST['featured']) && !empty($_POST['featured'])) {
                $this->view->featured = $_POST['featured'];
                $_POST['featured']--;
                $select->where($pageTableName . '.featured = ? ', $_POST['featured']);
            }

            if (isset($_POST['hot']) && !empty($_POST['hot'])) {
                $this->view->hot = $_POST['hot'];
                $_POST['hot']--;
                $select->where($pageTableName . '.hot = ? ', $_POST['hot']);
            }

            if (isset($_POST['verified']) && !empty($_POST['verified'])) {
                $this->view->verified = $_POST['verified'];
                $_POST['verified']--;
                $select->where($pageTableName . '.verified = ? ', $_POST['verified']);
            }
            
            if (!empty($_POST['category_id']) && empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'])) {
                $this->view->category_id = $_POST['category_id'];
                $select->where($pageTableName . '.category_id = ? ', $_POST['category_id']);
            } elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'])) {
                $this->view->category_id = $_POST['category_id'];
                $this->view->subcategory_id = $_POST['subcategory_id'];
                $this->view->subcategory_name = $tableCategory->getCategory($this->view->subcategory_id)->category_name;

                $select->where($pageTableName . '.category_id = ? ', $_POST['category_id'])
                                ->where($pageTableName . '.subcategory_id = ? ', $_POST['subcategory_id']);
            } elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && !empty($_POST['subsubcategory_id'])) {
                $this->view->category_id = $_POST['category_id'];
                $this->view->subcategory_id = $_POST['subcategory_id'];
                $this->view->subsubcategory_id = $_POST['subsubcategory_id'];
                $this->view->subcategory_name = $tableCategory->getCategory($this->view->subcategory_id)->category_name;
                $this->view->subsubcategory_name = $tableCategory->getCategory($this->view->subsubcategory_id)->category_name;

                $select->where($pageTableName . '.category_id = ? ', $_POST['category_id'])
                ->where($pageTableName . '.subcategory_id = ? ', $_POST['subcategory_id'])
                ->where($pageTableName . '.subsubcategory_id = ? ', $_POST['subsubcategory_id']);
            }
        }
        $values = array_merge(array(
                'order' => 'contest_id',
                'order_direction' => 'DESC',
                ), $values);

        $this->view->assign($values);

        $select->order((!empty($values['order']) ? $values['order'] : 'entry_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
        //MAKE PAGINATOR
        $this->view->paginator = Zend_Paginator::factory($select);
        $this->view->paginator->setItemCountPerPage(50);
        $this->view->paginator = $this->view->paginator->setCurrentPageNumber($page);
    }

     //ACTION FOR MULTI-DELETE CONTESTS
    public function multiDeleteAction() {

        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            foreach ($values as $key => $value) {
                if ($key == 'delete_' . $value) {
                    Engine_Api::_()->getItem('sitecontest_contest', (int) $value)->delete();
                }
            }
        }
        return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }

    //ACTION FOR DELETE THE CONTEST
    public function deleteAction() {

        $this->_helper->layout->setLayout('admin-simple');
        $contest_id = $this->_getParam('contest_id');
        $this->view->contest_id = $contest_id;

        if ($this->getRequest()->isPost()) {
            Engine_Api::_()->getItem('sitecontest_contest', $contest_id)->delete();
            $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('Deleted Succesfully.')
            ));
        }
        $this->renderScript('admin-contest-manage/delete.tpl');
    }

    public function detailAction() {

        //GET THE SITESTOREPRODUCT ITEM
        $this->view->sitecontestDetail = $contestItem = Engine_Api::_()->getItem('sitecontest_contest', (int) $this->_getParam('id'));

        $this->view->category_id = $category_id = $contestItem->category_id;
        $CategoriesObject = Engine_Api::_()->getDbTable('categories', 'sitecontest');
        
        $row = $CategoriesObject->getCategory($category_id);

        if (!empty($row->category_name)) {
            $this->view->category_name = $row->category_name;
        }
        $this->view->subcategory_id = $subcategory_id = $contestItem->subcategory_id;
        $row = $CategoriesObject->getCategory($subcategory_id);

        if (!empty($row->category_name)) {
            $this->view->subcategory_name = $row->category_name;
        }
        $this->view->subsubcategory_id = $subsubcategory_id = $contestItem->subsubcategory_id;
        $row = $CategoriesObject->getCategory($subsubcategory_id);
        
        if (!empty($row->category_name)) {
            $this->view->subsubcategory_name = $row->category_name;
        }
    }
}
?>