<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_AdminEntryManageController extends Core_Controller_Action_Admin
{
	public function indexAction() {

	//GET NAGIGATION
	$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
				->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_entrymanage');

	//MAKE FORM
	$this->view->formFilter = $formFilter = new Sitecontest_Form_Admin_Filter();
	
	//GET PAGE NUMBER
	$page = $this->_getParam('page', 1);
	//GET USER TABLE NAME
	$tableUserName = Engine_Api::_()->getItemTable('user')->info('name');


	//GET ENTRIES TABLE
	$tableProduct = Engine_Api::_()->getDbtable('entries', 'sitecontest');
	$entryTableName = $tableProduct->info('name');
	
	
	$getStoreTable = Engine_Api::_()->getDbtable('contests', 'sitecontest');
	$pageTableName = $getStoreTable->info('name');
	

	//MAKE QUERY
	$select = $tableProduct->select()
		->setIntegrityCheck(false)
		->from($entryTableName)
		->joinLeft($tableUserName, "$entryTableName.user_id = $tableUserName.user_id", 'username')
		->group("$entryTableName.entry_id");
	$select->joinLeft($pageTableName, "$entryTableName.contest_id = $pageTableName.contest_id", array("title as contest","end_datetime","media_type"));
	$values = array();

	if ($formFilter->isValid($this->_getAllParams())) {
	  $values = $formFilter->getValues();
	}
	foreach ($values as $key => $value) {

	  if (null == $value) {
		unset($values[$key]);
	  }
	}

	// searching
	$this->view->owner = '';
	$this->view->title = '';
	$this->view->contest = '';
	$this->view->media_type = '';
	$this->view->winner = '';
 

	if (isset($_POST['search'])) {

		if (!empty($_POST['owner'])) {
		$this->view->owner = $_POST['owner'];
		$select->where($tableUserName . '.displayname  LIKE ?', '%' . trim($_POST['owner']) . '%');
		}

		if (!empty($_POST['winner'])) {
		$this->view->winner = $_POST['winner'];
		$select->where($entryTableName . '.winner  LIKE ?', '%' . trim($_POST['winner']) . '%');
		}

		if (!empty($_POST['media_type'])) {
		$this->view->media_type = $media_type = $_POST['media_type'];
		$select->where($pageTableName . '.media_type LIKE ? ', '%' . $media_type .'%');
		}

		if (!empty($_POST['title'])) {
		$this->view->title = $_POST['title'];
		$select->where($entryTableName . '.title LIKE ?', '%' . trim($_POST['title']) . '%');
		}

		if (!empty($_POST['contest'])) {
		$this->view->contest = $_POST['contest'];
		$select->where($pageTableName . '.title LIKE ?', '%' . trim($_POST['contest']) . '%');
		}
	}

	$values = array_merge(array(
		'order' => 'entry_id',
		'order_direction' => 'DESC',
			), $values);

	$this->view->assign($values);

	$select->order((!empty($values['order']) ? $values['order'] : 'entry_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
	//MAKE PAGINATOR
	$this->view->paginator = Zend_Paginator::factory($select);
	$this->view->paginator->setItemCountPerPage(50);
	$this->view->paginator = $this->view->paginator->setCurrentPageNumber($page);
	}

	//ACTION FOR MULTI-DELETE PRODUCTS
	public function multiDeleteAction() {

		if ($this->getRequest()->isPost()) {
		  $values = $this->getRequest()->getPost();

		  foreach ($values as $key => $value) {
			if ($key == 'delete_' . $value) {
			  Engine_Api::_()->getItem('sitecontest_entry', (int) $value)->delete();
			}
		  }
		}
		return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
	}


  //ACTION FOR DELETE THE PRODUCT
	public function deleteAction() {

		$this->_helper->layout->setLayout('admin-simple');
		$this->view->entry_id = $entry_id = $this->_getParam('entry_id');

		if ($this->getRequest()->isPost()) {
			Engine_Api::_()->getItem('sitecontest_entry', $entry_id)->delete();
			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRefresh' => 10,
				'messages' => array('Deleted Succesfully.')
			));
		}
		 $this->renderScript('admin-entry-manage/delete.tpl');
	}


	public function detailAction() {
		//GET THE SITECONTEST ITEM
		$this->view->sitecontestDetail = Engine_Api::_()->getItem('sitecontest_entry', (int) $this->_getParam('id'));
	}


	public function winnerdeclareAction() {
		//SET LAYOUT
		$this->_helper->layout->setLayout('admin-simple');
		$this->view->entry_id = $entry_id = $this->_getParam('entry_id');

		$row = Engine_Api::_()->getItem('sitecontest_entry',$entry_id);
		$contest = Engine_Api::_()->getItem('sitecontest_contest',$row->contest_id);

		
		$contestId = $row->contest_id;
		$quick = 0;
		$current_date = date('Y-m-d H:i:s');
		if($current_date <= $contest->end_datetime) {
			$quick = 1;
		}
		$user = $contest->getOwner();
		$value = Engine_Api::_()->authorization()->getPermission($user->level_id, 'sitecontest_cont', "prize");

		//FORM GENERATION
		$form = $this->view->form = new Sitecontest_Form_Admin_Winnerdeclare(array('quick' => $quick,'contestId' => $contestId,'value' => $value));

		// Not post/invalid
		if( !$this->getRequest()->isPost() ) {
		  return;
		}

		if( !$form->isValid($this->getRequest()->getPost()) ) {
		  return;
		}

		$values = $form->getValues();
		//BEGIN TRANSACTION
		$db = Engine_Db_Table::getDefaultAdapter();
		$db->beginTransaction();
		try {
			
			

			if (!empty($row)) {
				//UPDATE THE PROFILE TYPE OF ALREADY CREATED contestS
				$row->winner = $values['winner'];
			}
			$row->save();

			//Genrate Activity feed of Contest Winner
			$viewer = Engine_Api::_()->getItem('user', $row->user_id);
			$action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $contest, 'sitecontest_winner',null,array('rank' => $values['winner']));
			if( $action ) {
			  Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $row);
			}

			//Mail
			$awardTable = Engine_Api::_()->getDbtable('awards', 'sitecontest');
            $awardTableName = $awardTable->info('name');
            $select = $awardTable->select()->from($awardTableName, '*')
            ->where('contest_id=?', $row->contest_id);
            $awards = $awardTable->fetchRow($select);

            if ($values['winner'] == 1) {
                $row->award = $awards->first_award_prize;
                Engine_Api::_()->sitecontest()->congratesEmail($row,$awards->first_award_message,'1');
            }elseif ($values['winner'] == 2) {
                $row->award = $awards->second_award_prize;
                Engine_Api::_()->sitecontest()->congratesEmail($row,$awards->second_award_message,'2');
            }elseif ($values['winner'] == 3) {
                $row->award = $awards->third_award_prize;
                Engine_Api::_()->sitecontest()->congratesEmail($row,$awards->third_award_message,'3');
            }elseif ($values['winner'] == 4) {
                $row->award = $awards->forth_award_prize;
                Engine_Api::_()->sitecontest()->congratesEmail($row,$awards->forth_award_message,'4');
            }else{
                $row->award = $awards->fifth_award_prize;
                Engine_Api::_()->sitecontest()->congratesEmail($row,$awards->fifth_award_message,'5');
            }

            //Cheaking only one time notification & mail will be sent
            if($contest->notification < 3) {

            	$allentries = Engine_Api::_()->getDbtable('entries','sitecontest');
	            $owner = $contest->getOwner('user');
	            //Mail to Contest Owner
	            Engine_Api::_()->sitecontest()->resultdeclareEmail($contest);

            	$followids = array();
				foreach ($allentries as $entry) {
					$followids[] = $entry->user_id;
					//Winner Declare Notification to ALl Entry Submitor
					$users = Engine_Api::_()->getItem('user',$entry->user_id);
					Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($users, $owner, $contest, 'sitecontest_Winner_declare');
				}

				//Winner Declare Notification to follower
				$followers = Engine_Api::_()->getDbtable('contests','sitecontest')->getFollowers($contest);
				foreach ($followers as $follower) {
						if(!in_array($follower->poster_id,$followids)) {
						$user = Engine_Api::_()->getItem('user',$follower->poster_id);
						Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $owner, $contest, 'sitecontest_Winner_declare');
						}
				}
				$contest->notification = 3;
				$contest->save();
            }


            //MAIL END

			$db->commit();
			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => true,
				'parentRefresh' => true,
				'class' => 'global_form_popup',
				'messages' => array(Zend_Registry::get('Zend_Translate')->_('The winner has been declared.'))));
		} catch (Exception $e) {
			$db->rollBack();
			throw $e;
		}
	}
}
?>