<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php

class Sitecontest_AdminGeneralController extends Core_Controller_Action_Admin {

    //ACTION FOR MAKING THE  FEATURED/UNFEATURED
    public function featuredAction() {

        $contest_id = $this->_getParam('contest_id');
        if (!empty($contest_id)) {
            $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
            $sitecontest->featured = !$sitecontest->featured;
            $sitecontest->save();
        }
        $this->_redirect('admin/sitecontest/contest-manage');
    }

    //ACTION FOR MAKING THE SPONSORED /UNSPONSORED
    public function sponsoredAction() {

        $contest_id = $this->_getParam('contest_id');
        if (!empty($contest_id)) {
            $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
            $sitecontest->sponsored = !$sitecontest->sponsored;
            $sitecontest->save();
        }
        $this->_redirect('admin/sitecontest/contest-manage');
    }

    //ACTION FOR MAKING THE  Hot
    public function hotAction() {

        $contest_id = $this->_getParam('contest_id');
        if (!empty($contest_id)) {
            $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
            $sitecontest->hot = !$sitecontest->hot;
            $sitecontest->save();
        }
        $this->_redirect('admin/sitecontest/contest-manage');
    }

    //ACTION FOR MAKING THE VERIFIED/UNVERIFIED
    public function verifiedAction() {

        $contest_id = $this->_getParam('contest_id');
        if (!empty($contest_id)) {
            $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
            $sitecontest->verified = !$sitecontest->verified;
            $sitecontest->save();
        }
        $this->_redirect('admin/sitecontest/contest-manage');
    }


    //ACTION FOR MAKING THE APPROVED /UNAPPROVED
    public function approvedAction() {

        $contest_id = $this->_getParam('contest_id');
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        // $email = array();
        try {
            $sitecontest = Engine_Api::_()->getItem('sitecontest_contest', $contest_id);
            $sitecontest->approved = !$sitecontest->approved;
            $owner = Engine_Api::_()->user()->getViewer();
            $viewer = Engine_Api::_()->getItem('user',$sitecontest->user_id);
            $notify = Engine_Api::_()->getDbtable('notifications', 'activity');
            if ($sitecontest->approved) {

                //Send notification of contest create to jury member
                $juries = Engine_Api::_()->getDbtable('juries', 'sitecontest')->fetchAll();
                $contestowner = $sitecontest->getOwner('user');
                foreach ($juries as $jury) {
                $user = Engine_Api::_()->getItem('user',$jury->user_id);
                $notify->addNotification($user, $contestowner, $sitecontest, 'sitecontest_create_contest');
                }
                
                //ON APPROVAL - ATTACH ACTIVITY FEED
                $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $sitecontest, 'sitecontest_new');
                if ($action != null) {
                  Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $sitecontest);
                }
                //Approved notification to user
                $notify->addNotification($viewer, $owner, $sitecontest, 'sitecontest_approve_contest');
            
                Engine_Api::_()->sitecontest()->aprovedEmailNotification($sitecontest, 'approved');
            } else {
                
                Engine_Api::_()->sitecontest()->aprovedEmailNotification($sitecontest, 'disapproved');
                //disApproved notification to user
                $notify->addNotification($viewer, $owner, $sitecontest, 'sitecontest_disapprove_contest');
            }
            $sitecontest->approved_date = date('Y-m-d H:i:s');
            $sitecontest->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        $this->_redirect('admin/sitecontest/contest-manage');
    }
    

    public function categoriesAction() {

        $element_value = $this->_getParam('element_value', 1);
        $element_type = $this->_getParam('element_type', 'category_id');

        $categoriesTable = Engine_Api::_()->getDbTable('categories', 'sitecontest');
        $select = $categoriesTable->select()
                ->from($categoriesTable->info('name'), array('category_id', 'category_name'))
                ->where("$element_type = ?", $element_value);

        if ($element_type == 'category_id') {
            $select->where('cat_dependency = ?', 0)->where('subcat_dependency = ?', 0);
        } elseif ($element_type == 'cat_dependency') {
            $select->where('subcat_dependency = ?', 0);
        } elseif ($element_type == 'subcat_dependency') {
            $select->where('cat_dependency = ?', $element_value);
        }

        $categoriesData = $categoriesTable->fetchAll($select);

        $categories = array();
        if (Count($categoriesData) > 0) {
            foreach ($categoriesData as $category) {
                $data = array();
                $data['category_name'] = $category->category_name;
                $data['category_id'] = $category->category_id;
                $categories[] = $data;
            }
        }

        $this->view->categories = $categories;
    }
}
?>