<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php

/**
 * 
 */
class Sitecontest_AdminLevelController extends Core_Controller_Action_Admin
{
	public function indexAction() {
		//GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_level');

        $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitecontest_admin_submain', array(), 'sitecontest_admin_submain_contest_tab');

		// Get level id
	    if( null !== ($id = $this->_getParam('id')) ) {
	      $level = Engine_Api::_()->getItem('authorization_level', $id);
	    } else {
	      $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
	    }

	    if( !$level instanceof Authorization_Model_Level ) {
	      throw new Engine_Exception('missing level');
	    }

	    $id = $level->level_id;
	    
		$this->view->form = $form = new Sitecontest_Form_Admin_Settings_Level(array(
	      'public' => ( in_array($level->type, array('public')) ),
	      'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
	    	));
		$form->level_id->setValue($id);

		  // Populate values
	    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
	    $form->populate($permissionsTable->getAllowed('sitecontest_cont', $id, array_keys($form->getValues())));
		// Check post
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    // Check validitiy
	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	      return;
	    }
	    // Process
	    $values = $form->getValues();
	    // Form elements with NonBoolean values
	    $nonBooleanSettings = $form->nonBooleanFields();
	    $db = $permissionsTable->getAdapter();
	    $db->beginTransaction();

	    try
	    {
		  // Set permissions
	      $permissionsTable->setAllowed('sitecontest_cont', $id, $values, '', $nonBooleanSettings);
	      // Commit
	      $db->commit();
	    } catch( Exception $e ) {
	      $db->rollBack();
	      throw $e;
	    }
	    $form->addNotice('Your changes have been saved.');
	}

	public function entriesAction() {

		//GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitecontest_admin_main', array(), 'sitecontest_admin_main_level');

        $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitecontest_admin_submain', array(), 'sitecontest_admin_submain_entry_tab');

		// Get level id
	    if( null !== ($id = $this->_getParam('id')) ) {
	      $level = Engine_Api::_()->getItem('authorization_level', $id);
	    } else {
	      $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
	    }

	    if( !$level instanceof Authorization_Model_Level ) {
	      throw new Engine_Exception('missing level');
	    }
	    $id = $level->level_id;
	    
		$this->view->form = $form = new Sitecontest_Form_Admin_Settings_Entries(array(
	      'public' => ( in_array($level->type, array('public')) ),
	      'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
	    	));
		$form->level_id->setValue($id);
		
		  // Populate values
	    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
	    $form->populate($permissionsTable->getAllowed('sitecontest_enty', $id, array_keys($form->getValues())));
		    // Check post
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    // Check validitiy
	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	      return;
	    }
	    // Process
	    $values = $form->getValues();
	    // Form elements with NonBoolean values
	    $nonBooleanSettings = $form->nonBooleanFields();

	    $db = $permissionsTable->getAdapter();
	    $db->beginTransaction();

	    try
	    {
	      // Set permissions
	      $permissionsTable->setAllowed('sitecontest_enty', $id, $values, '', $nonBooleanSettings);
	      // Commit
	      $db->commit();
	    } catch( Exception $e ) {
	      $db->rollBack();
	      throw $e;
	      die;
	    }
	    $form->addNotice('Your changes have been saved.');
	}	
}

?>