<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecontest
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    2019-08-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
return array(
  array(
    'title' => 'Contest Pinboard View',
    'description' => 'Displays contests attractive Pinboard View. ',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'autoEdit' => true,
    'name' => 'sitecontest.pinboard-sitecontest',
    'defaultParams' => array(
      'title' => 'Pinboard view',
      'statistics' => array("likeCount", "commentCount"),
      'show_buttons' => array("comment", "like", 'share', 'facebook', 'twitter', 'pinit'),
      'showpostedBy' => 1,
      'itemWidth' => 237,
      'contacts' => array('like','facebook','linkedin','googleplus'),
      'contest_item' => array('like','post','date','description','category','views','comment','follow'),
      'autoload' => 0,
      'itemCount' => 10,
      'noOfTimes' => 0,
      'turncation' => 40,
    ),
    'adminForm' => array(
      'elements' => array(
        array( 'Radio', 'showpostedBy', array(
            'label' => 'Do you want image of owner of the Contests to be displayed?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'),
            'value' => 1, 
          )
        ),
        array('Text','itemWidth',array(
            'label' => 'One Item Width',
            'description' => 'Enter the width for each pinboard item.',
            'value' => 237,
            'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array('MultiCheckbox', 'contacts', array(
          'label' => 'Choose share options ',
          'description' => 'it will be shown on contest',
          'multiOptions' => array(
            'facebook' => 'Facebook [Social Share Link]',
            'twitter' => 'Twitter [Social Share Link]',
            'linkedin' => 'LinkedIn [Social Share Link]',
            'googleplus' => 'Google+ [Social Share Link]'
          ),
        )),
        array('MultiCheckbox', 'contest_item', array(
          'label' => 'Choose information ',
          'description' => 'it will be shown on contest',
          'multiOptions' => array(
              'like' => 'Like',
              'post' => 'Posted By',
              'date' => 'Creation Date',
              'description' => 'Description',
              'category' =>'Category',
              'views' =>'Views',
              'comment' => 'Comments',
              'follow' =>'Follow Count',
          ),
        )),
        array(
          'Select',
          'autoload',
          array(
              'label' => 'Do you want to enable auto-loading of old pinboard items when users scroll down to the bottom of this page?',
              'multiOptions' => array(
                  1 => 'Yes',
                  0 => 'No'
              ),
              'value' => '1'
          )
        ),
        array(
          'Text',
          'itemCount',
          array(
              'label' => 'Count',
              'description' => '(number of contests to show)',
              'value' => 12,
              'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array(
          'Text',
          'noOfTimes',
          array(
              'label' => 'Auto-Loading Count',
              'description' => 'Enter the number of times that auto-loading of old pinboard items should occur on scrolling down. (Select 0 if you do not want such a restriction and want auto-loading to occur always. Because of auto-loading on-scroll, users are not able to click on links in footer; this setting has been created to avoid this.)',
              'value' => 0,
          )
        ),
        array(
          'Text','turncation', array(
            'label' => 'Description Truncation Limit For Pinboard View.',
            'value' => '40',
            'validators' => array(
              array('Int', true),
              new Engine_Validate_AtLeast(1),
            ),
          )
        ),
      ),
    ),
  ),
  array(
      'title' => 'Alphabetic Filtering of Contests',
      'description' => "This widget enables users to alphabetically filter the contests on your site by clicking on the desired alphabet. The widget shows all the alphabets for filtering.",
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.alphabeticsearch-sitecontest',
      'defaultParams' => array(
          'title' => "",
          'titleCount' => "",
      ),
  ),
  array(
    'title' => 'Categories / Sub-categories in Grid View',
    'description' => 'Displays Categories and Sub-categories in Grid view on Categories Home page and associated Category’s Home page respectively.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'autoEdit' => true,
    'name' => 'sitecontest.categories-grid-view',
    'defaultParams' => array(
        'title' => 'Categories',
        'showSubCategoriesCount' => 5,
        'showCount' => 0,
        'columnWidth' => 212,
        'columnHeight' => 270,
        'categoryCount' => 5,
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'showSubCategoriesCount',
            array(
                'label' => 'Show number of sub-categories / 3rd level categories to be shown on mouseover on a category / sub-category respectively.',
                'value' => '5',
                'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
                ),
                'maxlength' => 1
            )
        ),
        array(
            'Radio',
            'showCount',
            array(
                'label' => 'Show entry count along with the sub-category / 3rd level category name.',
                'multiOptions' => array(
                    1 => 'Yes',
                    0 => 'No'
                ),
                'value' => 0,
            )
        ),
        array(
            'Text',
            'columnWidth',
            array(
                'label' => 'Column Width For Grid View.',
                'value' => '234',
                'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
            )
        ),
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height For Grid View.',
                'value' => '216',
                'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
            )
        ),
        array(
            'Text',
            'categoryCount',
            array(
                'label' => 'Please enter no. of categories do you want to show.',
                'value' => '8',
                'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
            )
        ),
      )
    ),
  ),
  array(
    'title' => 'Contest Profile: Overview',
    'description' => 'The widget displays the overview of the contest on the Contest Profile Page.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.overview-sitecontest',
    'defaultParams' => array(
        'title' => 'Overview',
        'titleCount' => true,
    ),
  ),
  array(
      'title' => 'Browse Contests',
      'description' => 'Displays a list of all the contests on site. This widget should be placed on the Browse Contests page.',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.contests-sitecontest',
      'defaultParams' => array(
          'title' => '',
          'layouts_views' => array('1','2'),
          'layouts_oder' => 2,
          'columnWidth' => 212,
          'columnHeight' => 270,
          'turncation' => 40,
          'list_turncation' => 40,
          'showpostedBy' => 1,
          'contacts' => array('facebook','twitter','linkedin','googleplus'),
          'contest_item' => array('post','date','description','like','views','comment','follow'),
          'show_content' => 2,
          'itemCount' => 10,
      ),
      'adminForm' => 'Sitecontest_Form_Admin_Widget_Contestsbrowse'
  ),
  array(
    'title' => 'Contest of the Day',
    'description' => 'It display the Contest of the Day as selected by the Admin.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.item-sitecontest',
    'defaultParams' => array(
        'title' => 'Contest of the Day',
        'columnHeight' => 328,
        'truncation' => 40,
        'contest_item' =>array('post','category','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),
    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Text',
          'columnHeight',
            array(
              'label' => 'Column Height For Grid View.',
              'value' => '328',
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
            )
        ),
        array('Text','truncation', array(
            'label' => 'Title Truncation Limit .',
            'value' => '40',
            'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
        )),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'multiOptions' => array(
              'post' => 'Posted by',
              'category' =>'Category',
              'views' =>'Views',
              'comment' => 'Comments',
              'like' => 'Like',
              'follow' =>'Follow Count',
              'facebook' => 'Facebook [Social Share Link]',
              'twitter' => 'Twitter [Social Share Link]',
              'linkedin' => 'LinkedIn [Social Share Link]',
              'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),   
      ),
    ),
  ),
  array(
    'title' => 'Entry of the Day',
    'description' => 'It display the Entry of the Day as selected by the Admin.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.entryitem-sitecontest',
    'defaultParams' => array(
        'title' => 'Entry of the Day',
        'columnHeight' => 328,
        'contest_item' => array('post','category','views','comment','facebook','twitter','linkedin','googleplus'),
    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Text',
          'columnHeight',
          array(
            'label' => 'Column Height For Grid View.',
            'value' => '328',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'multiOptions' => array(
                'post' => 'Posted by',
                'category' =>'Category',
                'views' =>'Total Views',
                'comment' => 'Comments',
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Most Participated Contests',
    'description' => 'Displays a list of contests having maximum number of Participants. You can choose the number of contests to be shown.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.mostparticipated-sitecontest',
    'defaultParams' => array(
        'title' => 'Most Participated Contests',
        'itemCount' => 3,
        'columnHeight' => 328,
        'featured' => 0,
        'sponsored' => 0,
        'hot' => 0,
        'contest_item' => array('host','owner','date','category','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'itemCount',
            array(
                'label' => 'Count',
                'description' => '(number of contests to be shown)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            ),
        ),
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height For Grid View.',
                'value' => '328',
                'validators' => array(
                  array('Int', true),
                  array('GreaterThan', true, array(0)),
              ),
            )
        ),
        array(
            'Select',
            'featured',
            array(
                'label' => 'Featured',
                'multiOptions' => array(
                    0 => '',
                    2 => 'Yes',
                    1 => 'No',
                ),
            )
        ),
        array(
            'Select',
            'sponsored',
            array(
                'label' => 'Sponsored',
                'multiOptions' => array(
                    0 => '',
                    2 => 'Yes',
                    1 => 'No',
                ),
            )
        ),
        array(
            'Select',
            'hot',
            array(
                'label' => 'Trending',
                'multiOptions' => array(
                    0 => '',
                    2 => 'Yes',
                    1 => 'No',
                ),
            )
        ),
        array(
            'MultiCheckbox',
            'contest_item',
            array(
                'label' => 'Choose ',
                'description' => 'it will be shown in widget',
                'multiOptions' => array(
                    'owner' => 'Owner Image',
                    'host' => 'Posted By',
                    'date' => 'Creation Date',
                    'category' =>'Category',
                    'views' =>'Views',
                    'comment' => 'Comments',
                    'like' => 'Like',
                    'follow' =>'Follow Count',
                    'facebook' => 'Facebook [Social Share Link]',
                    'twitter' => 'Twitter [Social Share Link]',
                    'linkedin' => 'LinkedIn [Social Share Link]',
                    'googleplus' => 'Google+ [Social Share Link]'
                ),
            )
        ), 
      ),
    ),
  ),
  array(
    'title' => 'All Contest Winners',
    'description' => 'Displays a list of winner entries. You can choose the number of winner entries to be shown.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.winner-sitecontest',
    'defaultParams' => array(
        'title' => '',
        'columnHeight' => 270,
        'columnWidth' => 212,
        'contacts' => array('facebook', 'twitter', 'linkedin', 'googleplus'),
        'contest_item' => array('post', 'category', 'media'),
        'itemCount' => 10,
         
    ),
    'adminForm' => array(
      'elements' => array(
        array('Text','columnWidth', array(
                'label' => 'Column Width For Grid View.',
                'value' => '212',
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
        )),
        array('Text','columnHeight',array(
                'label' => 'Column Height For Grid View.',
                'value' => '270',
                'validators' => array(
                  array('Int', true),
                  array('GreaterThan', true, array(0)),
              ),
            )),
        array(
            'MultiCheckbox',
            'contacts',
            array(
                'label' => 'Select the contact details you want to display',
                'multiOptions' => array(
                    'facebook' => 'Facebook [Social Share Link]',
                    'twitter' => 'Twitter [Social Share Link]',
                    'linkedin' => 'LinkedIn [Social Share Link]',
                    'googleplus' => 'Google+ [Social Share Link]'),
            ),
        ),
        array(
            'MultiCheckbox',
            'contest_item',
            array(
                'label' => 'Choose ',
                'description' => 'it will be shown on contest',
                'multiOptions' => array(
                    'post' => 'Posted By',
                    'category' =>'Category',
                    'media' => 'Media Type'
                ),
            )
        ),
        array(
            'Text',
            'itemCount',
            array(
                'label' => 'Count',
                'description' => '(number of Winners Entries to show)',
                'value' => 10,
                'validators' => array(
                    array('Int', true),
                    new Engine_Validate_AtLeast(1),
              ),
            )
        ),
        array(
            'Radio',
            'view_more',
            array(
                'label' => 'View More',
                'description' => 'Do you want to show view more button? ',
                'value' => 10,
                'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
              ),
              'value' => 1,
            )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Search Contest Form',
    'description' => 'Displays the form for searching Contests on the basis of various filters.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.search-sitecontest',
    'defaultParams' => array(
        'title' => '',
        'showAllCategories' => 1,
    ),
    'adminForm' => array(
      'elements' => array( 
        array('Radio','showAllCategories', array(
            'label' => 'Do you want all the categories, sub-categories and 3rd level categories to be shown to the users even if they have 0 contests in them?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
          )
        ), 
      ),
    ),
  ),
  array(
    'title' => 'Categories, Sub-categories and 3<sup>rd</sup> Level-categories (sidebar)',
    'description' => 'Displays the Categories, Sub-categories and 3<sup>rd</sup> Level-categories of contests in an expandable form. Clicking on them will redirect the viewer to the list of contests created in that category.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.categories-sitecontest',
    'defaultParams' => array(
        'title' => 'Categories',
        'titleCount' => true,
    ),
    'autoEdit' => true,
    'adminForm' => array(
      'elements' => array(
        array(
            'Hidden',
            'nomobile',
            array(
                'label' => '',
                'order' => 1005
            )
        ),    
      )
    )
  ),
  array(
    'title' => 'Latest Entries',
    'description' => 'Displays a list of latest entries.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.latest-entries',
    'defaultParams' => array(
        'title' => 'Latest Entries',
        'itemCount' => 3,
        'columnHeight' => 328,
        'contest_item' => array('category','date','views','comment','facebook','twitter','linkedin','googleplus'),
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'itemCount',
            array(
                'label' => 'Count',
                'description' => '(number of entries to show)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            ),
        ),
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height For Grid View.',
                'value' => '328',
                'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
              ),
            )
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'description' => 'it will be shown in carousel',
            'multiOptions' => array(
                'date' => 'Date',
                'views' =>'Views',
                'category' => 'Category',
                'comment' => 'Comments',
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Join Contest',
    'description' => 'Displays a button " Join Contest" so that users of your website can join any contest. ',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.join-sitecontest',
    'defaultParams' => array(
      'title' => 'Join Contest',
    ),
  ),
  array(
    'title' => 'Media Type',
    'description' => 'Displays media type of a particular contest.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.mediatype-sitecontest',
    'defaultParams' => array(
        'title' => 'Media Type',
    ),
  ),
  array(
    'title' => 'Contest Details',
    'description' => 'Displays detail of a particular contest.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contestdetail-sitecontest',
    'defaultParams' => array(
      'title' => 'Contest Details',
      'showComments' => 1,
    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Radio',
          'showComments',
          array(
            'label' => 'Enable Comments',
            'description' => 'Do you want to enable comments in this widget? ',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
          )
        ),
      )
    )
  ),
  array(
    'title' => 'Entry Details',
    'description' => 'Displays the entry details.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.entrydetail-sitecontest',
    'defaultParams' => array(
      'title' => 'Entry Details',
    ),
  ),
  array(
    'title' => 'Entry',
    'description' => 'Displays the entry of participant.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.entry-sitecontest',
  ),
  array(
    'title' => 'Rules',
    'description' => 'Displays the contest rules. ',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contestrule-sitecontest',
    'defaultParams' => array(
     'title' => 'Rules',
    ),
  ),
  array(
    'title' => 'Contest Awards',
    'description' => 'Displays award of a particular contest.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contestaward-sitecontest',
    'defaultParams' => array(
      'title' => 'Contest Awards',
    ),
  ),
  array(
    'title' => 'Manage Contests & Entries',
    'description' => 'Displays a list of all your entries, contests. This widget should be placed on the Manage Contests & Entries Page.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.manage-entries-sitecontest',
    'defaultParams' => array(
        'title' => '',
        'turncation' => 40,
        'entry_turncation' => 40,
        'load_data' => 5,
        'contest_item' => array('like','post','date','description','views','comment','follow','category'),
        'entry_content' => array('post','date','description','views','comment','vote'),
    ),
    'adminForm' => array(
    'elements' => array(
      array('Text','turncation', array(
        'label' => 'Description Truncation Limit for contests.',
        'value' => '40',
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
      )),
      array('Text','entry_turncation', array(
        'label' => 'Description Truncation Limit for entries.',
        'value' => '40',
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
      )),
      array('Text','load_data', array(
        'label' => 'Count (Number of Entries to show)',
        'value' => '5',
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
      )),
      array(
        'MultiCheckbox',
        'contest_item',
        array(
          'label' => 'Choose ',
          'description' => 'it will be shown in My Contests',
          'multiOptions' => array(
              'description' => 'Description',
              'post' => 'Posted By',
              'date' => 'Creation Date',
              'category' =>'Category',
              'views' =>'Views',
              'comment' => 'Comments',
              'like' => 'Like',
              'follow' =>'Follow Count',
          ),
        )
      ),
      array(
        'MultiCheckbox',
        'entry_content',
          array(
            'label' => 'Choose ',
            'description' => 'it will be shown in My Entries',
            'multiOptions' => array(
                'post' => 'Posted By',
                'description' => 'Description',
                'date' => 'Date',
                'views' =>'Views',
                'comment' => 'Comments',
                'vote' => 'Vote Count',
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contest Entries',
    'description' => 'Displays a list of all the entries of contest on site. This widget should be placed on the Contest View Page.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.entries-sitecontest',
    'defaultParams' => array(
        'title' => 'Contest Entries',
        'layouts_views' => array('1','2'),
        'layouts_oder' => 1,
        'columnWidth' => 212,
        'columnHeight' => 270,
        'turncation' => 40,
        'list_turncation' => 40,
        'showpostedBy' => 1,
        'contacts' => array('facebook','twitter','linkedin','googleplus'),
        'contest_item' => array('post','date','description','vote','views','comment'),
        'show_content' => 2,
        'itemCount' => 10,
    ),
    'adminForm' => array(
      'elements' => array(
        array('MultiCheckbox', 'layouts_views', array(
          'label' => 'Choose the view types that you want to be available for Entry on the contests view .',
          'multiOptions' => array("1" => "List View", "2" => "Grid View")
        )),
        array('Radio','layouts_oder',array(
            'label' => 'Select a default view type for Entry Items.',
            'multiOptions' => array("1" => "List View", "2" => "Grid View")
        )),
        array('Text','columnWidth', array(
          'label' => 'Column Width For Grid View.',
          'value' => '212',
          'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
        )),
        array('Text','columnHeight',array(
          'label' => 'Column Height For Grid View.',
          'value' => '270',
          'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
        )),
        array('Text','turncation', array(
            'label' => 'Description Truncation Limit For Grid View.',
            'value' => '40',
            'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
        )),
        array('Text','list_turncation', array(
            'label' => 'Description Truncation Limit For List View.',
            'value' => '40',
            'validators' => array(
              array('Int', true),
              array('GreaterThan', true, array(0)),
          ),
        )),
        array(
          'Radio', 
          'showpostedBy', 
          array(
            'label' => 'Do you want image of owner of the Entry to be displayed in grid view?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'),
                'value' => 1, 
            )
        ),
        array(
          'MultiCheckbox',
          'contacts',
          array(
              'label' => 'Select the contact details you want to display',
              'multiOptions' => array(
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'),
          ),
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'description' => 'it will be shown on contest',
            'multiOptions' => array(
                'post' => 'Posted By',
                'date' => 'Creation Date',
                'description' => 'Description',
                'views' =>'Views',
                'comment' => 'Comments',
                'vote' => 'Vote Count'
            ),
          )
        ),
        array(
            'Select',
            'show_content',
            array(
            'label' => 'What do you want for view more content?',
            'description' => '',
            'multiOptions' => array(
                '2' => 'Show View More Link at Bottom',
                '3' => 'Auto Load Pages on Scrolling Down'),
            'value' => 2,
        )),
        array(
          'Text',
          'itemCount',
          array(
              'label' => 'Count',
              'description' => '(number of Entries to show)',
              'value' => 10,
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
            ),
          )
        ), 
      ),
    ),
  ),
  array(
      'title' => 'Popular Contest Tags',
      'description' => 'Shows popular tags with frequency.',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.tag-sitecontest',
      'defaultParams' => array(
          'title' => '',
          'orderingType' =>0,
          'count' => 10,
      ),
      'adminForm' =>'Sitecontest_Form_Admin_Widget_Tagsitecontest',
  ),
  array(
      'title' => 'Create New Contest',
      'description' => 'Displays a button "Create New Contest" to create new contests for your website. ',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'autoEdit' => true,
      'name' => 'sitecontest.newcontest-sitecontest',
  ),
  array(
      'title' => 'Delete Entry',
      'description' => 'Displays a button "Delete Enrty" to delete entry of contest. ',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'autoEdit' => true,
      'name' => 'sitecontest.entry-delete-sitecontest',
      'defaultParams' => array(
          'title' => '',
      ),
  ),
  array(
    'title' => 'Featured, Sponsored, Verified, Trending Contests',
    'description' => 'Displays a list of featured/ trending/ sponsored/ verified contests.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.list-featured-sitecontest',
    'defaultParams' => array(
      'itemCount' => 3,
      'contest_item' => array('owner','host','date','category','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),
      'columnHeight' => 328,
      'show_contest' => 'featured',
      'sort_contest' => 'created',
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'itemCount',
            array(
                'label' => 'Count',
                'description' => '(number of contests to show)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            ),
        ),
        array(
            'MultiCheckbox',
            'contest_item',
            array(
                'label' => 'Choose ',
                'description' => 'it will be shown in carousel',
                'multiOptions' => array(
                    'owner' => 'Owner Image',
                    'host' => 'Posted By',
                    'date' => 'Creation Date',
                    'category' =>'Category',
                    'views' =>'Views',
                    'comment' => 'Comments',
                    'like' => 'Like',
                    'follow' =>'Follow Count',
                    'facebook' => 'Facebook [Social Share Link]',
                    'twitter' => 'Twitter [Social Share Link]',
                    'linkedin' => 'LinkedIn [Social Share Link]',
                    'googleplus' => 'Google+ [Social Share Link]'
                ),
            )
        ),
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height',
                'value' => '328',
                'validators' => array(
                    array('Int', true),
                    array('GreaterThan', true, array(0)),
                ),
            )
        ),
        array(
            'Select',
            'show_contest',
            array(
              'label' => 'Show in widget',
              'multiOptions' => array(
                "featured"=>"Featured Only",
                "sponsored"=>"Sponsored Only",
                "verified"=>"Verified Only",
                "hot"=>"Trending Only"),
              'description' => 'Select which category will be shown in this widget.'
            ),
        ),
        array(
            'Select',
            'sort_contest',
            array(
              'label' => 'Popularity / Sorting Criteria',
              'multiOptions' => array(
                "most_liked"=>"Most Liked",
                "most_commented"=>"Most Commented",
                "created"=>"Recently created",
                "most_viewed"=>"Most Viewed"),
              'description' => 'Select which category will be shown in this widget.'
            ),
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contest Profile: Contest Options',
    'description' => 'Displays the various action link options to users viewing an Contest. This widget should be placed on the Contest View page below the contest profile cover photo.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.options-sitecontest',
  ),
  array(
    'title' => 'Other Contests from Contest Owner',
    'description' => 'Displays a list of contests of contest owner. ',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.owner-contest-sitecontest',
    'defaultParams' => array(
      'title' => 'Owner Other Contests',
      'count' => 3,
      'turncation' => 40,
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'count',
            array(
                'label' => 'Count',
                'description' => '(number of Contests to show)',
                'value' => 3,
            'validators' => array(
                    array('Int', true),
                    new Engine_Validate_AtLeast(1),
              ),
            ),
        ),
        array('Text','turncation', array(
          'label' => 'Title Truncation Limit .',
          'value' => '40',
          'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
          ),
        )),
      ),
    ),
  ),
  array(
      'title' => 'Owner Image',
      'description' => 'Displays the image of owner. ',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.owner-image-sitecontest',
       'defaultParams' => array(
        'title' => 'Entry Owner Image',
      ),
  ),
  array(
      'title' => 'Featured Contest Carousel',
      'description' => 'Displays contests based on the Popularity / Sorting Criteria and other settings configured by you in an attractive carousel with interactive controls. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.featured-slideshow-sitecontest',
      'autoEdit' => 'true',
      'defaultParams' => array(
        'category_id' => 0,
        'turncation' => 40,
        'contest_item' => array('host','owner','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),
        'count' => 2,
        'show_contest' =>'featured',
        'sort_contest' => 'created',
      ),
      'adminForm' =>'Sitecontest_Form_Admin_Widget_Slideshow',
  ),
  array(
      'title' => 'Sponsored Contest Carousel',
      'description' => ' Displays contests based on the Popularity / Sorting Criteria and other settings configured by you in an attractive carousel with interactive controls. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.sponsored-slideshow-sitecontest',
      'autoEdit' => 'true',
      'defaultParams' => array(
        'turncation' => 40,
        'count' => 5,
        'contest_item' => array('postedBy','category','owner','facebook','twitter','linkedin','googleplus'),
        'show_contest' => 'sponsored',
        'sort_contest' => 'created',
      ),
      'adminForm' =>'Sitecontest_Form_Admin_Widget_Sponsoredslideshow',
  ),
  array(
    'title' => 'Category Contest Carousel',
    'description' => 'Displays contests based on the Popularity / Sorting Criteria and other settings configured by you in an attractive slideshow with interactive controls. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.category-carousel-sitecontest',
    'autoEdit' => 'true',
    'defaultParams' => array(
      'itemcount' => 4,
      'columnWidth' => 212,
      'columnHeight' => 270,

    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Text',
          'itemcount',
          array(
            'label' => 'Category per slide',
            'value' => '4',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array('Text','columnWidth', array(
            'label' => 'Column Width',
            'value' => '212',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array('Text','columnHeight',array(
              'label' => 'Column Height',
              'value' => '270',
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
          )
        ),
      ),
    ),
  ),
  array(
      'title' => 'Category Banner',
      'description' => 'Displays the banner of selected category.',
      'category' => 'Professional Contests Plugin',
      'type' => 'widget',
      'name' => 'sitecontest.categories-banner-sitecontest',
      'requirements' => array(
        'no-subject',
      ),
  ),
  array(
    'title' => 'Recently Viewed Contests',
    'description' => 'Displays contests that have been recently viewed by you. ',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'autoEdit' => true,
    'name' => 'sitecontest.recently-viewed-sitecontest',
    'defaultParams' => array(
        'title' => 'Recently Viewed By Friends',
        'columnHeight' => 328,
        'count' => 3,
        'contest_item' =>array('post','category','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),

    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'columnHeight',
            array(
                'label' => 'Column Height For Grid View.',
                'value' => '328',
                'validators' => array(
                    array('Int', true),
                    new Engine_Validate_AtLeast(1),
                ),
            )
        ),
        array(
            'Text',
            'count',
            array(
                'label' => 'Count',
                'description' => '(number of Contests to show)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    new Engine_Validate_AtLeast(1),
                ),
            ),
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'description' => 'Select options to display',
            'multiOptions' => array(
                'post' => 'Posted by',
                'category' => 'Category',
                'comment' => 'Comments',
                'follow' =>'Followers',
                'views' =>'Views',
                'like' => 'Like',
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contests Home Widget',
    'description' => 'Contains multiple tabs showing Featured, Sponsored, Verified, Recently Created, Ended contests in a block separately.',
    'category' => 'Professional Contests Plugin',
    'name' => 'sitecontest.popular-contest-sitecontest',
    'type' => 'widget',
    'defaultParams' => array(
      'showpostedBy' => 1,
      'contest_item' => array('featured','sponsored','recentlyZZcreated','hot','verified'),
      'contacts' => array('facebook','twitter','linkedin','googleplus'),
      'contest_info' => array('like','post','description','category','views','comment','follow'),
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Radio', 
          'showpostedBy', 
          array(
            'label' => 'Do you want image of owner of the Contests to be displayed?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'),
                'value' => 1, 
            )
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
          'label' => 'Choose the sort type which would be available for contest sort for this widget.',
            'multiOptions' => array(
              "featured" =>"Featured",
              "sponsored" =>"Sponsored",
              "verified" =>"Verified",
              "mostZZviewed" => "Most Viewed",
              "mostZZfollowed" => "Most Followed",
              "mostZZjoined" => "Most Joined",
              "active" => "Active",
              "comingZZsoon" => "Coming Soon",
              "ended" => "Ended",
              "hot" => "Trending",
              "recentlyZZcreated" => "Recently Created",
              "mostZZliked" =>"Most Liked",
              "mostZZcommented" =>"Most Commented",
            )
          )
        ),
        array(
          'MultiCheckbox', 
          'contacts', 
          array(
          'label' => 'Choose share options ',
          'description' => 'it will be shown on contest',
          'multiOptions' => array(
              'facebook' => 'Facebook [Social Share Link]',
              'twitter' => 'Twitter [Social Share Link]',
              'linkedin' => 'LinkedIn [Social Share Link]',
              'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),
        array(
            'MultiCheckbox',
            'contest_info',
            array(
                'label' => 'Choose ',
                'description' => 'it will be shown on contest',
                'multiOptions' => array(
                    'like' => 'Like',
                    'post' => 'Posted By',
                    'description' => 'Description',
                    'category' =>'Category',
                    'views' =>'Views',
                    'comment' => 'Comments',
                    'follow' =>'Follow Count',
                ),
            )
        ),   
        array(
            'Text',
            'columnWidth',
             array(
                  'label' => 'Column Width For Grid View.',
                  'value' => '212',
                  'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
                ),
            )
         ),
        array('Text',
            'columnHeight',
            array(
              'label' => 'Column Height For Grid View.',
              'value' => '270',
              'validators' => array(
              array('Int', true),
              new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array(
          'MultiCheckbox',
          'layouts_views',
          array(
            'label' => 'Choose the view types that you want to be available for contests on frontend.',
            'multiOptions' => array("1" => "List View", "2" => "Grid View")
          )
        ),
        array(
          'Radio',
          'layouts_oder',
          array(
            'label' => 'Select a default view type for Contest Items / Contests.',
            'multiOptions' => array("1" => "List View", "2" => "Grid View")
          )
        ),
        array('Text','turncation', array(
          'label' => 'Description Truncation Limit For Grid View.',
          'value' => '40',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array('Text','list_turncation', array(
          'label' => 'Description Truncation Limit For List View.',
          'value' => '40',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array(
          'Select',
          'show_content',
          array(
            'label' => 'What do you want to view more contests?',
            'multiOptions' => array(
                '2' => 'Show View More Link at Bottom',
                '3' => 'Auto Load Pages on Scrolling Down'),
            'value' => '2',
          )
        ),
        array(
          'Text',
          'itemCount',
          array(
              'label' => 'Count',
              'description' => '(number of Contests to show)',
              'value' => 10,
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array(
            'Text',
            'featured_order',
            array(
                'label' => 'Featured Tab (order)',
                'value' => 1
            ),
        ),
        array(
            'Text',
            'sponsored_order',
            array(
                'label' => 'Sponsored Tab (order)',
                'value' => 2
            ),
        ),
        array(
            'Text',
            'verified_order',
            array(
                'label' => 'Verified Tab (order)',
                'value' => 3
            ),
        ),
        array(
            'Text',
            'most_viewed_order',
            array(
                'label' => 'Most Viewed Tab (order)',
                'value' => 4
            ),
        ),
        array(
            'Text',
            'most_followed_order',
            array(
                'label' => 'Most Followed Tab (order)',
                'value' => 5
            ),
        ),
        array(
            'Text',
            'most_joined_order',
            array(
                'label' => 'Most Joined Tab (order)',
                'value' => 6
            ),
        ),
        array(
            'Text',
            'active_order',
            array(
                'label' => 'Active Tab (order)',
                'value' => 7
            ),
        ),
        array(
            'Text',
            'coming_soon_order',
            array(
                'label' => 'Coming Soon Tab (order)',
                'value' => 8
            ),
        ),
        array(
            'Text',
            'ended_order',
            array(
                'label' => 'Ended Tab (order)',
                'value' => 9
            ),
        ),
        array(
            'Text',
            'hot_order',
            array(
                'label' => 'Trending Tab (order)',
                'value' => 10
            ),
        ),
        array(
            'Text',
            'recently_created_order',
            array(
                'label' => 'Recently Created Tab (order)',
                'value' => 11
            ),
        ),
        array(
            'Text',
            'most_liked_order',
            array(
                'label' => 'Most Liked Tab (order)',
                'value' => 12
            ),
        ),
         array(
            'Text',
            'most_commented_order',
            array(
                'label' => 'Most Commented Tab (order)',
                'value' => 13
            ),
        ),
      )
    ),  
  ),
  array(
    'title' => 'Category Based Contests',
    'description' => 'Displays a list of contest based on the category selected.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.category-contest-sitecontest',
    'defaultParams' => array(
        'layouts_views' => array('1','2'),
        'layouts_oder' => 2,
        'columnWidth' => 212,
        'columnHeight' => 270,
        'turncation' => 40,
        'list_turncation' => 40,
        'contacts' => array('facebook','twitter','linkedin','googleplus'),
        'contest_info' => array('post','date','description','like','views','comment','follow'),
        'show_content' => 2,
        'itemCount' => 10,
    ),
    'adminForm' => array(
      'elements' => array(

        array('MultiCheckbox', 'layouts_views', array(
          'label' => 'Choose the view types that you want to be available for contest .',
          'multiOptions' => array("1" => "List View", "2" => "Grid View")
        )),
        array('Radio','layouts_oder',array(
            'label' => 'Select a default view type for contest Items.',
            'multiOptions' => array("1" => "List View", "2" => "Grid View")
        )),
        array('Text','columnWidth', array(
          'label' => 'Column Width For Grid View.',
          'value' => '212',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array('Text','columnHeight',array(
          'label' => 'Column Height For Grid View.',
          'value' => '270',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array('Text','turncation', array(
          'label' => 'Description Truncation Limit For Grid View.',
          'value' => '40',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array('Text','list_turncation', array(
          'label' => 'Description Truncation Limit For List View.',
          'value' => '40',
          'validators' => array(
            array('Int', true),
            new Engine_Validate_AtLeast(1),
          ),
        )),
        array(
          'MultiCheckbox',
          'contacts',
          array(
            'label' => 'Select the items you want to display.',
            'multiOptions' => array(
              'facebook' => 'Facebook [Social Share Link]',
              'twitter' => 'Twitter [Social Share Link]',
              'linkedin' => 'LinkedIn [Social Share Link]',
              'googleplus' => 'Google+ [Social Share Link]'),
          ),
        ),
        array(
          'MultiCheckbox',
          'contest_info',
          array(
            'label' => 'Choose ',
            'description' => 'it will be shown on contest',
            'multiOptions' => array(
                'like' => 'Likes',
                'post' => 'Posted By',
                'date' => 'Creation Date',
                'description' => 'Description',
                'category' =>'Category',
                'views' =>'Views',
                'comment' => 'Comments',
                'follow' =>'Follow Count',
            ),
          )
        ),
        array(
          'Select',
          'show_content',
          array(
          'label' => 'What do you want for viewing more contests?',
          'description' => '',
          'multiOptions' => array(
              '2' => 'Show View More Link at Bottom',
              '3' => 'Auto Load Pages on Scrolling Down'),
          'value' => 2,
        )),
        array(
          'Text',
          'itemCount',
          array(
              'label' => 'Count',
              'description' => '(number of Contests to show)',
              'value' => 10,
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contest Profile: Contest Status',
    'description' => "Displays status of the contest. This widget should be placed on Contest Profile page.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contest-status',
    'defaultParams' => array(
        'title' => '',
    ),
  ),
  array(
    'title' => 'Contest Profile Breadcrumb',
    'description' => 'Displays breadcrumb of the Contest based on the categories. This widget should be placed on the Contest Profile page.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contest-profile-breadcrumb',
    'adminForm' => array(
        'elements' => array(
        ),
    ),
  ),
  array(
    'title' => 'Friends Participated',
    'description' => "Display all the friends who have participated in this contest.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.friendsparticipate-sitecontest',
    'defaultParams' => array(
        'title' => '',
    ),
  ),
  array(
    'title' => 'People who Liked your Contest',
    'description' => "Displays the people who liked your contests.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.peoplewhoacted-sitecontest',
    'defaultParams' => array(
        'title' => 'People who Acted on Contest',
        'count' => 3,
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'count',
            array(
                'label' => 'Count',
                'description' => '(number of users to show)',
                'value' => 3,
                'validators' => array(
                    array('Int', true),
                    new Engine_Validate_AtLeast(1),
              ),
            ),
        ),
      ),
    ),
  ),
  array(
    'title' => 'Jury Members',
    'description' => "Display all the Jury members.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.jurymember-sitecontest',
    'defaultParams' => array(
        'title' => 'Jury Members',
        'columnWidth' => 212,
        'columnHeight' => 270,
    ),
    'adminForm' => array(
      'elements' => array(
        array('Text','columnWidth', array(
              'label' => 'Column Width For Grid View.',
              'value' => '212',
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
            ),
          )
        ),
        array('Text','columnHeight',array(
            'label' => 'Column Height For Grid View.',
            'value' => '270',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Navigation Tabs',
    'description' => "This widget displays the navigation tabs for 'Professional Contests Plugin' having links of Contests Home, Browse Contests etc.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.navigation-sitecontest',
  ),
  array(
    'title' => 'Quick Information(Profile-fields)',
    'description' => "Displays the Quick Information of Profile-Type Fields.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.quickinfo-sitecontest',
    'defaultParams' => array(
        'title' => '',
    ),
    'adminForm' => array(
        'elements' => array(),
    ),
  ),
  array(
    'title' => 'Vote Button',
    'description' => "Display the Vote button on Entry View Page.",
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.vote-sitecontest',
    'defaultParams' => array(
    ),
    'adminForm' => array(
        'elements' => array(),
    ),
  ),
  array(
    'title' => 'Contest Profile: Winner',
    'description' => 'Displays winner of the particular contest.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contest-winner-sitecontest',
    'defaultParams' => array(
        'title' => 'Winner',
        'columnWidth' => 212,
        'columnHeight' => 270,
        'contacts' => array('like','facebook','twitter','linkedin','googleplus'),
        'contest_item' => array('post','category','media'),
    ),
    'adminForm' => array(
      'elements' => array(
        array('Text','columnWidth', array(
            'label' => 'Column Width For Grid View.',
            'value' => '212',
            'validators' => array(
              array('Int', true),
              new Engine_Validate_AtLeast(1),
          ),
        )),
        array('Text','columnHeight',array(
            'label' => 'Column Height For Grid View.',
            'value' => '270',
            'validators' => array(
              array('Int', true),
              new Engine_Validate_AtLeast(1),
          ),
        )),
        array(
          'MultiCheckbox',
          'contacts',
          array(
              'label' => 'Select the contact details you want to display',
              'multiOptions' => array(
                  'like' => 'Likes',
                  'facebook' => 'Facebook [Social Share Link]',
                  'twitter' => 'Twitter [Social Share Link]',
                  'linkedin' => 'LinkedIn [Social Share Link]',
                  'googleplus' => 'Google+ [Social Share Link]'),
          ),
        ),
        array(
            'MultiCheckbox',
            'contest_item',
            array(
                'label' => 'Choose ',
                'description' => 'it will be shown on contest',
                'multiOptions' => array(
                    'post' => 'Posted By',
                    'category' =>'Category',
                    'media' => 'Media Type'
                ),
            )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contest Full-Width Slider',
    'description' => 'It display a full width slider of contests.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contest-slideshow-sitecontest',
    'autoEdit' => 'true',
    'defaultParams' => array(
        'itemcount' => 3,
        'columnHeight' => 270,
        'turncation' => 40,
        'show_contest' => 'most_liked',
        'contest_item' => array('description','post','category','views','comment','like','follow','facebook','twitter','linkedin','googleplus'),
    ),
    'adminForm' => array(
      'elements' => array(
        array(
            'Text',
            'itemcount',
            array(
              'label' => 'Total Contests in slider',
              'value' => '4',
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
          )
        ),
        array('Text','columnHeight',array(
            'label' => 'Height of Slider.',
            'value' => '270',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
        )),
        array('Text','turncation', array(
            'label' => 'Description Truncation Limit',
            'value' => '40',
            'validators' => array(
                array('Int', true),
                new Engine_Validate_AtLeast(1),
            ),
        )),
        array(
            'Select',
            'show_contest',
             array(
              'label' => 'Show in slider',
              'multiOptions' => array(
                "most_joined"=>"Most Participated",
                "most_liked"=>"Most Liked",
                "most_commented"=>"Most Commented",
                "most_viewed"=>"Most Viewed"),
              'description' => 'Select which category will be shown in slider.'
            )
        ),
        array(
          'MultiCheckbox',
          'contest_item',
          array(
            'label' => 'Choose ',
            'description' => 'it will be shown in contest',
            'multiOptions' => array(
                'description' => 'Description',
                'views' =>'Views',
                'post' => 'Posted By',
                'category' => 'Category',
                'comment' => 'Comments',
                'follow' =>'Follow Count',
                'like' => 'Like',
                'facebook' => 'Facebook [Social Share Link]',
                'twitter' => 'Twitter [Social Share Link]',
                'linkedin' => 'LinkedIn [Social Share Link]',
                'googleplus' => 'Google+ [Social Share Link]'
            ),
          )
        ),
      ),
    ),
  ),
  array(
    'title' => 'Contest Profile Cover Photo',
    'description' => 'Displays the cover photo of a Contest. It is recommended to place this widget on the Contest Profile at the top.',
    'category' => 'Professional Contests Plugin',
    'type' => 'widget',
    'name' => 'sitecontest.contestcover-photo-sitecontest',
    'defaultParams' => array(
        'title' => '',
        'columnHeight' => 300,
        'showContent' => array("mainPhoto","title", "followButton", "likeButton", "joinButton", "addButton"),
        'statistics' => array("followCount", "likeCount")
    ),
    'adminForm' => array(
      'elements' => array(
      array(
          'Text',
          'columnHeight',
          array(
              'label' => 'Enter the cover photo height (in px). (Minimum 300 px required.)',
              'value' => '300',
              'validators' => array(
                  array('Int', true),
                  new Engine_Validate_AtLeast(1),
              ),
          )
      ),
      array(
        'MultiCheckbox',
        'showContent',
        array(
            'label' => 'Select the information options that you want to be available in this block.',
            'multiOptions' => array('mainPhoto'=>'Contest Profile Photo','title' => 'Contest Title' ,"followButton" => "Follow", "likeButton" => "Like", "joinButton" => "Join Contest","others" => "Others(edit,share,report,tell a friend,delete)"),
        ),
      ), 
      array(
        'MultiCheckbox',
        'statistics',
        array(
            'label' => 'Select the Count options that you want to be available in this block.',
            'multiOptions' => array("followCount" => "Follow Count", "likeCount" => "Like Count"),
        ),
      ), 
     ),
    ),
  )

) ?>