<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/

require_once realpath(dirname(__FILE__)) . '/seaocore_install.php';

class Sitecontest_Installer extends Sitecore_License_Installer
{
	protected $_deependencyVersion = array(
	    'seaocore' => '4.10.5p8',
	    'siteadvsearch' => '4.10.5p1',
	);

	protected $_installConfig = array(
    'sku' => 'sitecontest',
  	);
   
	
	public function onInstall() {

		$this->_addSitecontestBrowsePage();
		$this->_addSitecontestEntryViewPage();
		$this->_addSitecontestHomePage();
		$this->_addSitecontestViewPage();
		$this->_addSitecontestManagePage();
		$this->_addSitecontestCategoryPage();
		$this->_addSitecontestWinnerPage();
		$this->_addSitecontestJuryPage();
		$this->_addSitecontestCreatePage();
		$this->_addSitecontestEntryCreatePage();
		$this->_addSitecontestCategoryViewPage();
		$this->_addSitecontestTagPage();
		$this->_addSitecontestPinboardPage();

		$db = $this->getDb();
		$isseaocore = $db->select()
                ->from('engine4_core_modules')
                ->where('name = ?', 'seaocore')
                ->limit(1)
                ->query()
                ->fetchColumn();
		if (!empty($isseaocore)) {
            $db->query("INSERT IGNORE INTO `engine4_seaocore_searchformsetting` (`module`, `name`, `display`, `order`, `label`) VALUES ('sitecontest', 'search', 1, 10, 'Name'),('sitecontest', 'orderby', 1, 20, 'Browse By'),('sitecontest', 'category_id', 0, 30, 'Category'),('sitecontest', 'Media_type', 1, 40, 'Type'),('sitecontest', 'status', 1, 50, 'Status');");
        }

		parent::onInstall();

	}

	protected function _addSitecontestBrowsePage() {
		$db = $this->getDb();
		// profile page
		$pageId = $db->select()
		  ->from('engine4_core_pages', 'page_id')
		  ->where('name = ?', 'sitecontest_index_browse')
		  ->limit(1)
		  ->query()
		  ->fetchColumn();

		// insert if it doesn't exist yet
		if( !$pageId ) {
			// Insert page
		  $db->insert('engine4_core_pages', array(
			'name' => 'sitecontest_index_browse',
			'displayname' => 'Contest Browse Page',
			'title' => 'Contest Browse',
			'description' => 'This page lists contests.',
			'custom' => 0,
		  ));
		  $pageId = $db->lastInsertId();
		  
		  // Insert top
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'top',
			'page_id' => $pageId,
			'order' => 1,
		  ));
		  $topId = $db->lastInsertId();

		  // Insert top-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $topId,
		  ));
		  $topMiddleId = $db->lastInsertId();

		  // Insert main
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'main',
			'page_id' => $pageId,
			'order' => 2,
		  ));
		  $mainId = $db->lastInsertId();

		 

		  // Insert main-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 2,
		  ));
		  $mainMiddleId = $db->lastInsertId();

		  // Insert main-left
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'left',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 1,
		  ));
		  $mainLeftId = $db->lastInsertId();


		  // Insert content
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.navigation-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 1,
		  ));
		  // Insert search
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.search-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 1,
			'params' =>'{"showAllCategories":"1","nomobile":"0","name":"sitecontest.search-sitecontest"}',
		  ));

		  // Insert Alphabatic search
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.alphabeticsearch-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 2,
		  ));

		  // Insert content
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.contests-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 3,
			'params' =>'{"layouts_views":["1","2"],"layouts_oder":"2","columnWidth":"267","columnHeight":"300","turncation":"40","list_turncation":"100","showpostedBy":"1","contacts":["facebook","twitter","linkedin","googleplus"],"contest_item":["like","post","date","description","category","views","comment","follow"],"show_content":"2","itemCount":"9","nomobile":"0","name":"sitecontest.contests-sitecontest"}',
		  ));

		  // Featured viewed
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.list-featured-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainLeftId,
			'order' => 1,
			'params' =>'{"title":"Verified Contests","itemCount":"2","columnHeight":"328","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"show_contest":"verified","sort_contest":"most_liked","nomobile":"0","name":"sitecontest.list-featured-sitecontest"}',
		  ));

		  // Most Participate contest
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.mostparticipated-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainLeftId,
			'order' => 2,
			'params' =>'{"title":"Most Participated Contests","itemCount":"3","columnHeight":"328","featured":"0","sponsored":"0","hot":"0","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.mostparticipated-sitecontest"}',
		  ));

		}
	}

	protected function _addSitecontestEntryViewPage() {

		$db = $this->getDb();
		// profile page
		$pageId = $db->select()
		  ->from('engine4_core_pages', 'page_id')
		  ->where('name = ?', 'sitecontest_index_entryview')
		  ->limit(1)
		  ->query()
		  ->fetchColumn();

		// insert if it doesn't exist yet
		if( !$pageId ) {
			// Insert page
		  $db->insert('engine4_core_pages', array(
			'name' => 'sitecontest_index_entryview',
			'displayname' => 'Contest Entry View Page',
			'title' => 'Entry View',
			'description' => 'This page lists a particular entry.',
			'custom' => 0,
		  ));
		  $pageId = $db->lastInsertId();

		// Insert top
		$db->insert('engine4_core_content', array(
		  'type' => 'container',
		  'name' => 'top',
		  'page_id' => $pageId,
		  'order' => 1,
		));
		$topId = $db->lastInsertId();

		// Insert top-middle
		$db->insert('engine4_core_content', array(
		  'type' => 'container',
		  'name' => 'middle',
		  'page_id' => $pageId,
		  'parent_content_id' => $topId,
		));
		$topMiddleId = $db->lastInsertId();


		  // Insert main
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'main',
			'page_id' => $pageId,
			'order' => 2,
		  ));
		  $mainId = $db->lastInsertId();

		 

		  // Insert main-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 2,
		  ));
		  $mainMiddleId = $db->lastInsertId();

		  // Insert main-right
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'right',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 1,
		  ));
		  $mainRightId = $db->lastInsertId();

		  

		// Insert content
		$db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
		));

		  // Insert owner image
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
		  	'name' => 'sitecontest.owner-image-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainRightId,
			'order' => 1,
			'params' =>'{"title":"Entry Owner Image","nomobile":"0","name":"sitecontest.owner-image-sitecontest"}',
		  ));

		  // Insert vote button
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.vote-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainRightId,
			'order' => 2,
		  ));

		  // Insert delete button
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.entry-delete-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainRightId,
			'order' => 3,
		  ));

		  // Insert owner image
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.entry-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 1,
		  ));

		  // Insert entry detail
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.entrydetail-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 2,
		  ));
		}
	}
  protected function _addSitecontestHomePage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_index')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_index',
		'displayname' => 'Contest Home Page',
		'title' => 'Contest Home',
		'description' => 'This page is contest home page.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  // Insert main-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 3,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert main-right
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'right',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainRightId = $db->lastInsertId();

	  // Insert main-left
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'left',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainLeftId = $db->lastInsertId();

	  // Insert Navigation Bar
		$db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.navigation-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $topMiddleId,
		'order' => 1,
		));

		$db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contest-slideshow-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $topMiddleId,
		'order' => 2,
		'params' =>'{"itemcount":"3","columnHeight":"290","turncation":"40","show_contest":"most_viewed","contest_item":["description","post","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.contest-slideshow-sitecontest"}',
		));

		$db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.featured-slideshow-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $topMiddleId,
		'order' => 3,
		'params' =>'{"title":"Featured Contests","category_id":"0","turncation":"40","count":"4","show_contest":"featured","sort_contest":"most_viewed","contest_item":["category","owner","host","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.featured-slideshow-sitecontest"}',
		));


	  // Insert contest home widget
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.popular-contest-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' =>'{"showpostedBy":"1","contest_item":["featured","sponsored","hot","recentlyZZcreated","mostZZviewed"],"contacts":["facebook","twitter","linkedin","googleplus"],"contest_info":["like","post","description","category","views","comment","follow"],"columnWidth":"263","columnHeight":"273","layouts_views":["1","2"],"layouts_oder":"1","turncation":"40","list_turncation":"100","show_content":"2","itemCount":"5","featured_order":"3","sponsored_order":"4","verified_order":"6","most_viewed_order":"2","most_followed_order":"9","most_joined_order":"7","active_order":"11","coming_soon_order":"12","ended_order":"13","hot_order":"5","recently_created_order":"1","most_liked_order":"10","most_commented_order":"8","nomobile":"0","name":"sitecontest.popular-contest-sitecontest"}',
	  ));


	  // Insert contest of the day
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.item-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 1,
		'params' =>'{"title":"Contest of the day","columnHeight":"328","turncation":"40","contest_item":["post","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.item-sitecontest"}',
	  ));

	  // Insert trending contest 
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.list-featured-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 2,
		'params' =>'{"title":"Trending Contests","itemCount":"2","columnHeight":"300","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"show_contest":"hot","sort_contest":"most_liked","nomobile":"0","name":"sitecontest.list-featured-sitecontest"}',
	  ));

	   // Insert tag 
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.tag-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 3,
		'params' =>'{"title":"CONTEST TAGS","orderingType":"0","count":"10","nomobile":"0","name":"sitecontest.tag-sitecontest"}',
	  	));

	 
	  // Insert entry of the day
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.entryitem-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 1,
		'params' =>'{"title":"Entry of the day","columnHeight":"328","contest_item":["post","category","views","comment","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.entryitem-sitecontest"}',
	  ));


	  // Insert featured contest
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.newcontest-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 2,
	  )); 

	   // Insert trending contest 
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.list-featured-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 3,
		'params' =>'{"title":"Sponsored Contests","itemCount":"2","columnHeight":"300","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"show_contest":"sponsored","sort_contest":"most_commented","nomobile":"0","name":"sitecontest.list-featured-sitecontest"}',
	  ));

	}
  }
  protected function _addSitecontestViewPage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_contestview')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_contestview',
		'displayname' => 'Contest View Page',
		'title' => 'Contest View Page',
		'description' => 'This page view a particular contest.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  // Insert main-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 3,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert main-right
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'right',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainRightId = $db->lastInsertId();

	  // Insert main-left
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'left',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainLeftId = $db->lastInsertId();

	  // Insert content
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contest-profile-breadcrumb',
		'page_id' => $pageId,
		'parent_content_id' => $topMiddleId,
		'order' => 1,
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contestcover-photo-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $topMiddleId,
		'order' => 2,
		'params' => '{"columnHeight":"300","showContent":["mainPhoto","title","followButton","likeButton","joinButton","others"],"statistics":["followCount","likeCount"],"nomobile":"0","name":"sitecontest.contestcover-photo-sitecontest"}'
	  ));


	  // Insert tab container
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'core.container-tabs',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' =>'{"max":8}',
	  ));
	  $tabContainer = $db->lastInsertId();

	  // Insert contest entries
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.entries-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 1,
		'params' =>'{"title":"Contest Entries","layouts_views":["1","2"],"layouts_oder":"1","columnWidth":"100","columnHeight":"270","turncation":"40","list_turncation":"40","showpostedBy":"1","contacts":["facebook","twitter","linkedin","googleplus"],"contest_item":["post","date","description","views","comment","vote"],"show_content":"2","itemCount":"10","nomobile":"0","name":"sitecontest.entries-sitecontest"}',
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'activity.feed',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 2,
		'params' =>'{"title":"Updates","max_photo":"2","nomobile":"0","name":"activity.feed"}'
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contestdetail-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 3,
		'params' => '{"title":"Contest Details","showComments":"1","nomobile":"0","name":"sitecontest.contestdetail-sitecontest"}'
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contestrule-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 4,
		'params' => '{"title":"Rules","nomobile":"0","name":"sitecontest.contestrule-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contestaward-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 5,
		'params' => '{"title":"Contest Awards ","nomobile":"0","name":"sitecontest.contestaward-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contest-winner-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 6,
		'params' => '{"title":"Winner","columnWidth":"175","columnHeight":"250","contacts":["like","facebook","twitter","linkedin","googleplus"],"contest_item":["post","category"],"nomobile":"0","name":"sitecontest.contest-winner-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.overview-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $tabContainer,
		'order' => 7,
		'params' => '{"title":"Overview","nomobile":"0","name":"sitecontest.overview-sitecontest"}',
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.options-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 1,
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.quickinfo-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 2,
		'params' => '{"title":"Quick Information","nomobile":"0","name":"sitecontest.quickinfo-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.owner-contest-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 3,
		'params' => '{"title":"Other Contests from this Owner","count":"1","turncation":"40","nomobile":"0","name":"sitecontest.owner-contest-sitecontest"}',
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.tag-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 4,
		'params' => '{"title":"Contest Tags","orderingType":"0","count":"6","nomobile":"0","name":"sitecontest.tag-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.join-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 1,
	  ));  
	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.contest-status',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 2,
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.mediatype-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 3,
		'params' => '{"title":"Media Type","nomobile":"0","name":"sitecontest.mediatype-sitecontest"}'
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.friendsparticipate-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 4,
		'params' => '{"title":"Friends Participated","nomobile":"0","name":"sitecontest.friendsparticipate-sitecontest"}'
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.newcontest-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 5,
	  ));

	   $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.peoplewhoacted-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 6,
		'params' => '{"title":"People who Acted on Contest","nomobile":"0","name":"sitecontest.peoplewhoacted-sitecontest"}'
	  )); 

	}
  }
  protected function _addSitecontestManagePage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_manage')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_manage',
		'displayname' => 'My Contests & Entries Page',
		'title' => ' My Contests & Entries',
		'description' => 'This page lists contests as well as entries.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  // Insert main-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert main-right
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'right',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainRightId = $db->lastInsertId();


	  // Insert content
		$db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
		));

	  // Insert latest entries
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.latest-entries',
		'page_id' => $pageId,
		'parent_content_id' => $mainRightId,
		'order' => 1,
		'params' =>'{"title":"Latest Entries","itemCount":"3","columnHeight":"300","contest_item":["date","views","category","comment","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.latest-entries"}',
	  ));

	  // Insert manage contest & entries
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.manage-entries-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' =>'{"turncation":"100","entry_turncation":"10","load_data":"5","contest_item":["date","views","category","comment","description","post","like","follow"],"entry_content":["date","views","vote","comment","description","post"],"nomobile":"0","name":"sitecontest.latest-entries"}',
	  ));
	  
	}
  }
  protected function _addSitecontestCreatePage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_create')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_create',
		'displayname' => 'Contest Create Page',
		'title' => 'Contest Create Page',
		'description' => 'This page is the contest create page.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert main-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert content
		$db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
		));

	  // Insert manage contest
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'core.content',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
	  ));
	}
  }
  protected function _addSitecontestCategoryPage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_categories')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_categories',
		'displayname' => 'Contest Category Page',
		'title' => 'Categories',
		'description' => 'This is the categories home page.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert main-left
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'left',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainLeftId = $db->lastInsertId();
	  // Insert content
		$db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
		));

	  // Insert content
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.category-carousel-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' => '{"title":"Categories","itemcount":"3","columnWidth":"200","columnHeight":"200","nomobile":"0","name":"sitecontest.category-carousel-sitecontest"}',
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.popular-contest-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 2,
		'params' =>'{"showpostedBy":"1","contest_item":["featured","sponsored","hot","recentlyZZcreated","mostZZviewed"],"contacts":["facebook","twitter","linkedin","googleplus"],"contest_info":["like","post","description","category","views","comment","follow"],"columnWidth":"263","columnHeight":"273","layouts_views":["1","2"],"layouts_oder":"1","turncation":"40","list_turncation":"100","show_content":"2","itemCount":"5","featured_order":"3","sponsored_order":"4","verified_order":"6","most_viewed_order":"2","most_followed_order":"9","most_joined_order":"7","active_order":"11","coming_soon_order":"12","ended_order":"13","hot_order":"5","recently_created_order":"1","most_liked_order":"10","most_commented_order":"8","nomobile":"0","name":"sitecontest.popular-contest-sitecontest"}',
	  ));
	  // Insert content
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.list-featured-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 1,
		'params' => '{"title":"Trending Contests","itemCount":"2","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"columnHeight":"300","show_contest":"hot","sort_contest":"most_liked","nomobile":"0","name":"sitecontest.list-featured-sitecontest"}'
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.categories-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 2,
		'params' => '{"title":"All Categories ","nomobile":"0","name":"sitecontest.categories-sitecontest"}'
	  ));
	}
  }
  protected function _addSitecontestJuryPage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_jury')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_jury',
		'displayname' => 'Contest Jury Page',
		'title' => 'Jury Members',
		'description' => 'On this page, jury members are displayed.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert main-left
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'left',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainLeftId = $db->lastInsertId();

	  // Insert content
		$db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
		));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.recently-viewed-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 1,
		'params' =>'{"title":"Recently Viewed Contests","columnHeight":"300","count":"2","contest_item":["post","category","comment","like","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.recently-viewed-sitecontest"}',
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.jurymember-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' =>'{"title":"Jury Members","columnWidth":"190","columnHeight":"190","nomobile":"0","name":"sitecontest.jurymember-sitecontest"}',
	  ));
	}
  }
  protected function _addSitecontestWinnerPage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_winner')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_winner',
		'displayname' => 'Contest Winner Page',
		'title' => 'Contest Winners',
		'description' => 'This page displays winner of all contests.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  // Insert main-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();


	  // Insert main-left
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'left',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 1,
	  ));
	  $mainLeftId = $db->lastInsertId();

	  // Insert navigation
	  $db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.mostparticipated-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainLeftId,
		'order' => 1,
		'params' =>'{"title":"Most Participated Contests","itemCount":"2","columnHeight":"300","featured":"2","sponsored":"0","hot":"0","contest_item":["owner","host","date","category","views","comment","like","follow","facebook","twitter","linkedin","googleplus"],"nomobile":"0","name":"sitecontest.mostparticipated-sitecontest"}',
	  ));

	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'sitecontest.winner-sitecontest',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
		'params' =>'{"title":"Winners","columnWidth":"255","columnHeight":"270","contacts":["facebook","twitter","linkedin","googleplus"],"contest_item":["post","category","media"],"itemCount":"10","view_more":"1","nomobile":"0","name":"sitecontest.winner-sitecontest"}',
	  ));
	}
  }
  protected function _addSitecontestEntryCreatePage()
  {
	$db = $this->getDb();

	// profile page
	$pageId = $db->select()
	  ->from('engine4_core_pages', 'page_id')
	  ->where('name = ?', 'sitecontest_index_entry')
	  ->limit(1)
	  ->query()
	  ->fetchColumn();

	// insert if it doesn't exist yet
	if( !$pageId ) {
	  // Insert page
	  $db->insert('engine4_core_pages', array(
		'name' => 'sitecontest_index_entry',
		'displayname' => 'Contest Entry Create Page',
		'title' => 'Contest Entry Create Page',
		'description' => 'This page entry create page.',
		'custom' => 0,
	  ));
	  $pageId = $db->lastInsertId();

	  // Insert top
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'top',
		'page_id' => $pageId,
		'order' => 1,
	  ));
	  $topId = $db->lastInsertId();

	  // Insert main
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'main',
		'page_id' => $pageId,
		'order' => 2,
	  ));
	  $mainId = $db->lastInsertId();

	  // Insert top-middle
	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $topId,
	  ));
	  $topMiddleId = $db->lastInsertId();

	  $db->insert('engine4_core_content', array(
		'type' => 'container',
		'name' => 'middle',
		'page_id' => $pageId,
		'parent_content_id' => $mainId,
		'order' => 2,
	  ));
	  $mainMiddleId = $db->lastInsertId();

	  // Insert content
	  $db->insert('engine4_core_content', array(
		  'type' => 'widget',
		  'name' => 'sitecontest.navigation-sitecontest',
		  'page_id' => $pageId,
		  'parent_content_id' => $topMiddleId,
		  'order' => 1,
	  ));

	  // Insert content
	  $db->insert('engine4_core_content', array(
		'type' => 'widget',
		'name' => 'core.content',
		'page_id' => $pageId,
		'parent_content_id' => $mainMiddleId,
		'order' => 1,
	  ));
	  
	}
  }


  protected function _addSitecontestCategoryViewPage() {
		$db = $this->getDb();
		// profile page
		$pageId = $db->select()
		  ->from('engine4_core_pages', 'page_id')
		  ->where('name = ?', 'sitecontest_index_category')
		  ->limit(1)
		  ->query()
		  ->fetchColumn();

		// insert if it doesn't exist yet
		if( !$pageId ) {
			// Insert page
		  $db->insert('engine4_core_pages', array(
			'name' => 'sitecontest_index_category',
			'displayname' => 'Contest Category View Page',
			'title' => 'Category View Page',
			'description' => 'This page lists contests of selected category.',
			'custom' => 0,
		  ));
		  $pageId = $db->lastInsertId();
		  
		  // Insert top
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'top',
			'page_id' => $pageId,
			'order' => 1,
		  ));
		  $topId = $db->lastInsertId();

		  // Insert top-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $topId,
		  ));
		  $topMiddleId = $db->lastInsertId();

		  // Insert main
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'main',
			'page_id' => $pageId,
			'order' => 2,
		  ));
		  $mainId = $db->lastInsertId();

		  // Insert main-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 2,
		  ));
		  $mainMiddleId = $db->lastInsertId();

		  // Insert main-left
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'left',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 1,
		  ));
		  $mainLeftId = $db->lastInsertId();

		  // Insert content
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.navigation-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 1,
		  ));

		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.categories-banner-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 2,
		  ));

		  // Insert category contests
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.category-contest-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 1,
			'params' =>'{"layouts_views":["1","2"],"layouts_oder":"2","columnWidth":"266","columnHeight":"330","turncation":"15","list_turncation":"100","contacts":["facebook","twitter","linkedin","googleplus"],"contest_info":["like","post","date","description","category","views","comment","follow"],"show_content":"2","itemCount":"5","nomobile":"0","name":"sitecontest.category-contest-sitecontest"}',
		  ));

		  // Insert Alphabatic search
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.categories-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainLeftId,
			'order' => 1,
		  ));

		}
	}
	

	protected function _addSitecontestTagPage() {
		$db = $this->getDb();
		// profile page
		$pageId = $db->select()
		  ->from('engine4_core_pages', 'page_id')
		  ->where('name = ?', 'sitecontest_index_tagscloud')
		  ->limit(1)
		  ->query()
		  ->fetchColumn();

		// insert if it doesn't exist yet
		if( !$pageId ) {
			// Insert page
		  $db->insert('engine4_core_pages', array(
			'name' => 'sitecontest_index_tagscloud',
			'displayname' => 'Contest Tag Page',
			'title' => 'Contest Tag Page',
			'description' => 'This is the contests tags page.',
			'custom' => 0,
		  ));
		  $pageId = $db->lastInsertId();
		  
		  // Insert top
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'top',
			'page_id' => $pageId,
			'order' => 1,
		  ));
		  $topId = $db->lastInsertId();

		  // Insert top-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $topId,
		  ));
		  $topMiddleId = $db->lastInsertId();

		  // Insert main
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'main',
			'page_id' => $pageId,
			'order' => 2,
		  ));
		  $mainId = $db->lastInsertId();

		  // Insert main-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 1,
		  ));
		  $mainMiddleId = $db->lastInsertId();

		  // Insert navigation
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.navigation-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 1,
		  ));

		  // Insert tag 
		   $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.tag-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 1,
			'params' =>'{"title":"Contest Tags","orderingType":"1","count":"0","nomobile":"0","name":"sitecontest.tag-sitecontest"}',
		  	));
		}
	}

	protected function _addSitecontestPinboardPage() {
		$db = $this->getDb();
		// profile page
		$pageId = $db->select()
		  ->from('engine4_core_pages', 'page_id')
		  ->where('name = ?', 'sitecontest_index_pinboard')
		  ->limit(1)
		  ->query()
		  ->fetchColumn();

		// insert if it doesn't exist yet
		if( !$pageId ) {
			// Insert page
		  $db->insert('engine4_core_pages', array(
			'name' => 'sitecontest_index_pinboard',
			'displayname' => 'Contest Pinboard Page',
			'title' => 'Contest Pinboard Page',
			'description' => 'This is the contests pinboard page.',
			'custom' => 0,
		  ));
		  $pageId = $db->lastInsertId();
		  
		  // Insert top
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'top',
			'page_id' => $pageId,
			'order' => 1,
		  ));
		  $topId = $db->lastInsertId();

		  // Insert top-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $topId,
		  ));
		  $topMiddleId = $db->lastInsertId();

		  // Insert main
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'main',
			'page_id' => $pageId,
			'order' => 2,
		  ));
		  $mainId = $db->lastInsertId();

		  // Insert main-middle
		  $db->insert('engine4_core_content', array(
			'type' => 'container',
			'name' => 'middle',
			'page_id' => $pageId,
			'parent_content_id' => $mainId,
			'order' => 1,
		  ));
		  $mainMiddleId = $db->lastInsertId();

		  // Insert navigation
		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.navigation-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 1,
		  ));

		  $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.search-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $topMiddleId,
			'order' => 2,
			'params' =>'{"showAllCategories":"1","nomobile":"0","name":"sitecontest.search-sitecontest"}',
		  ));

		  // Insert tag 
		   $db->insert('engine4_core_content', array(
			'type' => 'widget',
			'name' => 'sitecontest.pinboard-sitecontest',
			'page_id' => $pageId,
			'parent_content_id' => $mainMiddleId,
			'order' => 1,
			'params' =>'{"title":"","showpostedBy":"1","itemWidth":"288","contacts":["facebook","twitter","linkedin","googleplus"],"contest_item":["like","post","date","description","category","views","comment","follow"],"autoload":"0","itemCount":"10","noOfTimes":"0","turncation":"40" ,"nomobile":"0","name":"sitecontest.pinboard-sitecontest"}',
		  	));
		}
	}

}

?>