<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitecontest
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
?>
<?php
class Sitecontest_Widget_EntrySitecontestController extends Engine_Content_Widget_Abstract
{
  public function indexAction()  {
      
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !Engine_Api::_()->core()->hasSubject() ) {
      return $this->setNoRender();
    }
    // Get subject and check auth
    $subject = Engine_Api::_()->core()->getSubject();
  
    if( !$subject->authorization()->isAllowed($viewer, 'view') ) {
      return $this->setNoRender();
    }
    $this->view->contest = $contest = Engine_Api::_()->getItem('sitecontest_contest',$subject->contest_id );
   
    if($contest->media_type == 'video') { 
      $table = Engine_Api::_()->getDbtable('videos','sitecontest');
      $video = $table->fetchRow($table->select()->where('entry_id = ?',$subject->getIdentity())); 

      $storage_file = Engine_Api::_()->getItem('storage_file', $video->file_id);
      if ($storage_file) {
        $this->view->video_location = $storage_file->map();
        $this->view->video_extension = $storage_file->extension;
      }
    } elseif ($contest->media_type == 'music') {
      //Song File Get
      $songs = Engine_Api::_()->getDbTable('songs','sitecontest');
      $song = $songs->fetchRow($songs->select()->where('entry_id = ?', $subject->entry_id)->limit(1));
      $this->view->storage_file = $storage_file = Engine_Api::_()->getItem('storage_file', $song->file_id);
      if ($storage_file) {
        $this->view->song_location = $storage_file->map();
        $this->view->song_extension = $storage_file->extension;
      }
    }
    $this->view->sitecontest = $subject;
    $contest = Engine_Api::_()->getItem('sitecontest_contest',$subject->contest_id);
  }
}
?>