<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Coupon.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitecoupon_Model_Coupon extends Core_Model_Item_Abstract {

  protected $_searchTriggers = false;
  
  /**
   * Get gateway coupon params
   *
   * @return object $params
   */
  public function getGatewayCouponParams($values = array()) {

		if (!empty($values)) {
			$code = $this->code;
			$newCode = $values['code'];
			$expirydate = $values['expirydate'];
			$minimum_order = $values['minimum_order'];
			$discount_type = $values['discount_type'];
			$discount_value = $values['discount_value'];
			$packageIds = $values['package_ids'];
			$package_type = $values['package_type'];
		}
		else {
			$code = $this->code;
			$expirydate = $this->expirydate;
			$minimum_order = $this->minimum_order;
			$discount_type = $this->discount_type;
			$discount_value = $this->discount_value;
			$packageIds = $this->package_ids;
			$package_type = $this->package_type;
		}

	  $params = array(
			'coupon_code' => $code,
			'date_expire' => $expirydate,
			'type' => 'product',
			'percentage_off' => NULL,
			'value_off' => NULl,
			'minimum_purchase' => $minimum_order,
			'product_id' => NULL,
			'select_all' => false,
    );
		
		if (!empty($values)) { 
			$params['new_code'] = $newCode;
		}
		
    if ($discount_type == 'percentage') {
      $params['percentage_off'] = (int)$discount_value;
      unset($params['value_off']);
    } 
    else {
      $params['value_off'] = (int)$discount_value;
      unset($params['percentage_off']);
    }

    if (empty($packageIds) && empty($package_type)) {
			$modules_enabled = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'modules.enabled');

			if (!empty($modules_enabled)) {
				$contentModuleEn = unserialize($modules_enabled) ;
			}

			$allproductId = array();
			foreach($contentModuleEn as $content) {
        $package_ids = $this->getPackageIds($content, $discount_value);

				if (!empty($package_ids)) {
					$allproductId = array_merge($allproductId, $this->getProductIds($content, $package_ids));
				}
			}
			$params['product_id'] = $allproductId;

			if (empty($params['product_id'])) {
				$params['select_all'] = true;
			}
     // $params['select_all'] = true;
    }
    elseif(empty($packageIds) && !empty($package_type)) {
			$package_ids = $this->getPackageIds($package_type, $discount_value);
			
			if (!empty($package_ids)) {
				$params['product_id'] = $this->getProductIds($package_type, $package_ids);
			}
    }
    else {
// 			$package_ids = explode(',', $packageIds);
// 			$packageTable = Engine_Api::_()->getItemTable($package_type);
// 			$packageTableName = $packageTable->info('name');
// 			$package_ids = $packageTable->select()
// 										->from($packageTableName, array('package_id'))
// 										->where($packageTableName . '.package_id IN (?)', (array) $package_ids)
// 										//->where($packageTableName . '.price > ?', 0)
// 										->where($packageTableName . '.price > ?', $discount_value)
// 										->where($packageTableName . '.enabled = ?', 1);
// 			$packageIdsresult = $package_ids->query()->fetchAll(Zend_Db::FETCH_COLUMN); 
// 
// 			$params['product_id'] = $this->getProductIds($package_type, $packageIdsresult); //*/array(4665948939,4666012866); 
			$params['product_id'] = $this->getProductIds($package_type, explode(',', $packageIds));
    }
    return $params;

//     $params = array(
// 			'coupon_code' => $this->code,
// 			'date_expire' => $this->expirydate,
// 			'type' => 'product',
// 			'percentage_off' => NULL,
// 			'value_off' => NULl,
// 			'minimum_purchase' => $this->minimum_order,
// 			'product_id' => NULL,
// 			'select_all' => false,
//     );
//     
//     if ($this->discount_type == 'percentage') {
//       $params['percentage_off'] = (int)$this->discount_value;
//     } else {
//       $params['value_off'] = (int)$this->discount_value;
//     }
// 
//     if (empty($this->package_ids) && empty($this->module_name)) {
// 			$modules_enabled = Engine_Api::_()->getApi( 'settings' , 'core' )->getSetting( 'modules.enabled' ) ;
// 			if (!empty($modules_enabled)) {
// 				$contentModuleEn = unserialize($modules_enabled) ;
// 			}
// 			$allproductId = array();
// 			foreach($contentModuleEn as $content) {
//         $package_ids = Engine_Api::_()->sitecoupon()->getPackageIds($content);
// 				if (!empty($package_ids)) {
// 					$allproductId = array_merge($allproductId, Engine_Api::_()->sitecoupon()->getProductIds($content, $package_ids));
// 				}
// 			}
// 			$params['product_id'] = $allproductId;
//      // $params['select_all'] = true;
//     } elseif(empty($this->package_name) && !empty($this->module_name)) {
// 				$package_ids = Engine_Api::_()->sitecoupon()->getPackageIds($this->module_name);
// 				if (!empty($package_ids)) {
// 					$params['product_id'] = Engine_Api::_()->sitecoupon()->getProductIds($this->module_name, $package_ids);
// 				}
//     } else {
// 			$params['product_id'] = Engine_Api::_()->sitecoupon()->getProductIds($this->module_name, explode(',', $this->package_name)); //*/array(4665948939,4666012866);    
//     }
  }
  
  /**
   * Get the package id according to selected package and for all packages.
   *
   * @param string $package_type
   * @return array
   */
  public function getPackageIds($package_type , $discount_value) {

    $packageTable = Engine_Api::_()->getItemTable($package_type);
    $packageTableName = $packageTable->info('name');
    $package_ids = $packageTable->select()
            ->from($packageTableName, array('package_id'))
            ->where($packageTableName . '.price > ?', 0)
            //->where($packageTableName . '.price < ?', $discount_value)
            ->where($packageTableName . '.enabled = ?', 1);
    return $package_ids->query()->fetchAll(Zend_Db::FETCH_COLUMN);
  }
  
  
  /**
   * Get the product id according to selected package id id and package types.
   *
   * @param int $package_ids
   * @param string $package_type
   * @return array $productIdsArray
   */
  public function getProductIds($package_type, $package_ids) {

    $productIdsArray = array();
    $gateway = Engine_Api::_()->sitecoupon()->enabled2Checkout();

    if (!empty($gateway)) {
      $gatewayPlugin = $gateway->getGateway();

      if (!method_exists($gatewayPlugin, 'getService'))
        return;

      $gatewayPluginService = $gateway->getService();

      if (method_exists($gatewayPluginService, 'createCoupon')) {
        foreach ($package_ids as $packageid) {  
          $response = $gatewayPluginService->detailVendorProduct(Engine_Api::_()->getItem($package_type, $packageid)->getProduct()->sku);
          $productIdsArray[] = $response['product_id'];
        }
      }
      return $productIdsArray;
    }
  }
  
  /**
   * Create photo
   *
   * @param array $photo
   * @return photo object
   */
  public function setPhoto($photo) {
  
    if ($photo instanceof Zend_Form_Element_File) {
      $file = $photo->getFileName();
    } else if (is_array($photo) && !empty($photo['tmp_name'])) {
      $file = $photo['tmp_name'];
    } else if (is_string($photo) && file_exists($photo)) {
      $file = $photo;
    } else {
      $error_msg1 = Zend_Registry::get('Zend_Translate')->_('invalid argument passed to setPhoto');
      throw new Event_Model_Exception($error_msg1);
    }

    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    $params = array(
			'parent_id' => $this->getIdentity(),
			'parent_type' => 'sitecoupon_coupons'
    );

    $storage = Engine_Api::_()->storage();

    // Add autorotation for uploded images. It will work only for SocialEngine-4.8.9 Or more then.
    $hasVersion = Engine_Api::_()->seaocore()->usingLessVersion('core', '4.8.9');
    if(!empty($hasVersion)) {
      //RESIZE IMAGE (NORMAL)
      $image = Engine_Image::factory();
      $image->open($file)
        ->resize(140, 160)
        ->write($path . '/in_' . $name)
        ->destroy();
    }else {
      //RESIZE IMAGE (NORMAL)
      $image = Engine_Image::factory();
      $image->open($file)
        ->autoRotate()
        ->resize(140, 160)
        ->write($path . '/in_' . $name)
        ->destroy();
    }

    //STORE
    $iIconNormal = $storage->create($path . '/in_' . $name, $params);

		//REMOVE TEMP FILES
    @unlink($path . '/in_' . $name);
    @unlink($path . '/is_' . $name);

    //UPDATE ROW
    $this->photo_id = $iIconNormal->file_id;
    $this->save();

    return $this;
  }
}
?>