<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Types.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_Model_DbTable_Types extends Engine_Db_Table {

  protected $_name = 'sitecoupon_types';
  
  /**
   * Get the package id according to selected package and for all packages.
   *
   * @param int $formUsages
   * @return array
   */
  public function getEnabledModules($usages = NULL) {

    $modules_enabled = Engine_Api::_()->getApi('settings', 'core')->getSetting('modules.enabled');
    
    if (!empty($modules_enabled)) {
      $contentModuleEn = unserialize($modules_enabled);
    }

    $couponTypeTableName = $this->info('name');

    $coreTable = Engine_Api::_()->getDbTable('modules', 'core');
    $coreTableName = $coreTable->info('name');

    $select = $this->select()
            ->setIntegrityCheck(false)
            ->from($couponTypeTableName)
            ->join($coreTableName, "$coreTableName.name = $couponTypeTableName.module_name", array($couponTypeTableName . '.title'))
            ->where($coreTableName . '.enabled = ?', 1);

    if (!empty($usages)) {
      $select->where($couponTypeTableName . '.package_type IN (?)', (array) $contentModuleEn);
    }

    return $select->query()->fetchAll();
  }
}
?>