<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminMessageController.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_AdminMessageController extends Core_Controller_Action_Admin {

  public function mailAction() {
  
    //CREATE NAVIGATION TABS
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
          ->getNavigation('sitecoupon_admin_main', array(), 'sitecoupon_admin_message_mail');

    $this->view->form = $form = new Sitecoupon_Form_Admin_Mail();
		$this->view->moduleEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitemailtemplates');
		
    //GET COUPON ID AND COUPON CODE.
    $this->view->couponId = $coupon_id = $this->_getParam('id');
    $code = $this->_getParam('code');

    if (!empty($coupon_id) && !empty($code)) {
      $form->coupon_code->setValue($code);
      $form->coupon_id->setValue($coupon_id);
    }

    if (!$this->getRequest()->isPost() ) {
      return;
    }

		if (!$form->isValid($this->getRequest()->getPost())) {
			return;
		}
		
    $values = $form->getValues();

    $couponTable = Engine_Api::_()->getItem('sitecoupon_coupons', $values['coupon_id']);

    $userTable = Engine_Api::_()->getItemTable('user');
    
    $select = new Zend_Db_Select($userTable->getAdapter());
    $select->from($userTable->info('name'), 'email')
            ->where('enabled = ?', true); // Do not email disabled members

    if ($values['coupon_mail'] == 1) {
      $user_idsValues = explode(",", $values['toValues']);

      $select->where('user_id IN (?)', new Zend_Db_Expr(trim($values['toValues'], ',')));
    } 
    elseif ($values['coupon_mail'] == 0) {
      if ($couponTable['restriction_type'] == 1 && !empty($couponTable['level_ids'])) {
        if (is_array($level_ids) && !empty($level_ids)) {
          $level = explode(",", $couponTable['level_ids']);
          $level_ids = $level;
          $select->where('level_id IN (?)', $level_ids);
        }
      }

      if ($couponTable['restriction_type'] == 2 && !empty($couponTable['user_ids'])) {
        $user_idsValues = explode(",", $couponTable['user_ids']);
        $select->where('user_id IN (?)', $couponTable['user_ids']);
      }
    }
    
    //GET SITE TITLE
    $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title', 1);

    //INITIALISE VARIABLES
    $contact_string = "";
    $template_header = "";
    $template_footer = "";

    //ATTACH BODY
    $contact_string .= $values['body'];
    
    $emails = array();
    if ($values['coupon_mail'] != '2' )  {
			$mailAddress = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0);
    } else {
			$mailAddress = explode(',', $values['recipients']);
    }

		foreach ($mailAddress as $email) {
			if (!empty($email)) {
				Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, 'SITECOUPON_EMAIL_NOTIFICATION', array(
					'subject' => $values['subject'],
					'template_header' => $template_header,
					'code' => $couponTable['code'],
					'message' => $contact_string,
					'object_link' => 'http://' . $_SERVER['HTTP_HOST'] .
					Zend_Controller_Front::getInstance()->getRouter()->assemble(array(), 'sitecoupon_browse', true),
					'template_footer' => $template_footer,
					'site_title' => $site_title,
					'queue' => false
				));
			}
		}

    // temporarily enable queueing if requested
    $temporary_queueing = Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing;
    if (isset($values['queueing']) && $values['queueing']) {
      Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing = 1;
    }

    $mailApi = Engine_Api::_()->getApi('mail', 'core');

    $mail = $mailApi->create();
    $mail
				->setFrom($values['from_address'], $values['from_name'])
				->setSubject($values['subject'])
				->setBodyHtml(nl2br($values['body']));

    if (!empty($values['body_text'])) {
      $mail->setBodyText($values['body_text']);
    } else {
      $mail->setBodyText(strip_tags($values['body']));
    }

		include APPLICATION_PATH . '/application/modules/Sitecoupon/controllers/license/license2.php';

    $mailComplete = $mailApi->create();
    $mailComplete
            ->addTo(Engine_Api::_()->user()->getViewer()->email)
            ->setFrom($values['from_address'], $values['from_name'])
            ->setSubject('Mailing Complete: ' . $values['subject'])
            ->setBodyHtml('Your email blast to your members has completed.  Please note that, while the emails have been
        sent to the recipients\' mail server, there may be a delay in them actually receiving the email due to
        spam filtering systems, incoming mail throttling features, and other systems beyond SocialEngine\'s control.');

    $mailApi->send($mailComplete);

    // emails have been queued (or sent); re-set queueing value to original if changed
    if (isset($values['queueing']) && $values['queueing']) {
      Engine_Api::_()->getApi('settings', 'core')->core_mail_queueing = $temporary_queueing;
    }

    $this->view->form = null;
    $this->view->status = true;
  }
}
