<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecoupon_IndexController extends Seaocore_Controller_Action_Standard {

  /**
   * @var User_Model_User
   */
  protected $_user;
  
  /**
   * @var Zend_Session_Namespace
   */
  protected $_session;
  
  public function init()
  {

    $this->_session = new Zend_Session_Namespace('Payment_Subscription');
    // Get user and session
    $this->_user = Engine_Api::_()->user()->getViewer();
    
    // Check viewer and user
    if(!$this->_user->getIdentity() ) { 
      if( !empty($this->_session->user_id) ) { 
        $this->_user = Engine_Api::_()->getItem('user', $this->_session->user_id);
      }
//       // If no user, redirect to home?
//       if( !$this->_user || !$this->_user->getIdentity() ) {
//         $this->_session->unsetAll();
//         return $this->_helper->redirector->gotoRoute(array(), 'default', true);
//       }
    }
  }
  
  //ACTION FOR COUPON CODE CHECK.
  public function indexAction() {


    if (Engine_Api::_()->getDbtable( "modules" , "core" )->isModuleEnabled("sitecredit")){

     $creditSession = new Zend_Session_Namespace('payment_subscription_credit');

      if (!empty($creditSession->paymentSubscriptionCreditDetail)) {
        $creditSession->paymentSubscriptionCreditDetail = null;
      }
    }

    //GET COUPON CODE.
    $code = $this->_getParam('code');

    //CHECK FOR WHICH MODULE NAME IS SET AND SET PARAMETERS ACCORDING TO THE MODULE NAME.
    $module_name = $this->_getParam('package_type');
    if ($module_name == 'sitepage') {
      $sessionName = 'Payment_Sitepage';
      $itemId = 'page_id';
      $itemType = 'sitepage_page';
    } elseif ($module_name == 'communityad') {
      $sessionName = 'Payment_Userads';
      $itemId = 'userad_id';
      $itemType = 'userads';
    } else if ($module_name == 'payment') {
      $sessionName = 'Payment_Subscription';
      $itemId = 'subscription_id';
      $itemType = 'payment_subscription';
    } else if ($module_name == 'sitebusiness') {
      $sessionName = 'Payment_Sitebusiness';
      $itemId = 'business_id';
      $itemType = 'sitebusiness_business';
    } else if ($module_name == 'sitegroup') {
      $sessionName = 'Payment_Sitegroup';
      $itemId = 'group_id';
      $itemType = 'sitegroup_group';
    } else if ($module_name == 'sitestore') {
      $sessionName = 'Payment_Sitestore';
      $itemId = 'store_id';
      $itemType = 'sitestore_store';
    }

    //HERE WE CREATE SESSION ACCORDING TO MODULE NAME.
    $session = new Zend_Session_Namespace($sessionName);
    $user_id = $session->user_id;

    //HERE WE CHANGE ID ACCRODING TO THE MODULE.
    $resourceId = $session->$itemId;

    //HERE WE GET OBJECT ACCRODING TO THE ITEM TYPE AND RESOURCE ID.
    $itemObject = Engine_Api::_()->getItem($itemType, $resourceId);
    $package = $itemObject->getPackage();

    //HERE WE GET THE TYPE OF THE TABLE LIKE PAGE, COMMUITY ADS TABLE AND PASS IN THE CORE.PHP FILE IN THE SITECOUPON.
    $packageType = $package->getType();
    if ($packageType == 'communityad_package') {
      $packageType = 'package';
    }
    $package_id = $itemObject->package_id;

    //HERE PACKAGE TYPE IS THE TYPE OF THE CORRESPONDING PACKAGE ID AND CURRENT MODULE TYPE USE. PASS THE VARIABLE PACKAGE_ID AND PACKAGE_TYPE AND CODE.
    $codeCheck = Engine_Api::_()->sitecoupon()->hasValidCode($code, $package_id, $packageType);

    //HERE CHECK CODE AND SEND RESPONSE.
    if (!$codeCheck) {
      $this->view->status = $data = false;
      //$this->view->body  = $body = "This Coupon is Invalid"; 
      return $this->_helper->json(array('status' => $data));
    } 
    else {
      $this->view->status = $data = true;
      $couponSession = new Zend_Session_Namespace('Sitecopoun_Valid');
      $couponSession->code = $code;
      
      if ($packageType == 'package') {
        $this->view->body = $body = $this->view->action('gettotal', 'index', 'sitecoupon', array('id' => $package->getIdentity(), 'type' => 'package', 'code' => $code, 'format' => 'html'));
      } 
      else {
        $this->view->body = $body = $this->view->action('gettotal', 'index', 'sitecoupon', array('id' => $package->getIdentity(), 'type' => $package->getType(), 'code' => $code, 'format' => 'html'));
      }
    }
    
    $this->_helper->contextSwitch->initContext();
    return $this->_helper->json(array('status' => $data, 'body' => $body));
  }

  //FUNCTION FOR TOTALVALUE OF PACKAGE AFTER COUPON DISCOUNT.
  public function gettotalAction() {

    $this->view->package = $package = Engine_Api::_()->getItem($this->_getParam('type'), $this->_getParam('id'));

    //COUPON VALUE ACCRORDING TO CODE.
    $result = Engine_Api::_()->getDbtable('coupons', 'sitecoupon')->getCode($this->_getParam('code'));

    //HERE WE CALCULATE THE DISCOUNT.
    $discount_value = 0;
    if ($result->discount_type == 'price') {
      $this->view->discount_value = $discount_value = $result->discount_value;
    } 
    else if ($result->discount_type == 'percentage') {
      $this->view->discount_value = $discount_value = ($package->price ) * ($result->discount_value / 100);
    }
    
    $totalValue = $package->price - $discount_value;
    if ($totalValue < 0) { 
			$totalValue = '0.00';
    }
     $this->view->totalValue = Engine_Api::_()->sitecoupon()->getPriceWithCurrency($totalValue); 
  }

  //FUNCTION FOR REDIRECT TO PAYMENT PAGE.
  public function processAction() {

    //GET THE MODULE NAME.
    $module_name = $this->_getParam('package_type');

    //SESSION SET OF COUPON VALID.
    $couponSession = new Zend_Session_Namespace('Sitecopoun_Valid');
    $code = $couponSession->code;

    //SET THE VARIABLE ACCRODING TO THE MODULE NAME.
    if ($module_name == 'payment') {
      $session_name = 'Payment_Subscription';
      $gateway_name = 'payment_gateway';
      $module_id = 'subscription_id';
      $itemType = 'payment_subscription';
    } else if ($module_name == 'sitepage') {
      $session_name = 'Payment_Sitepage';
      $gateway_name = 'sitepage_gateway';
      $module_id = 'page_id';
      $itemType = 'sitepage_page';
    } elseif ($module_name == 'communityad') {
      $session_name = 'Payment_Userads';
      $gateway_name = 'communityad_gateway';
      $module_id = 'userad_id';
      $itemType = 'userads';
    } elseif ($module_name == 'sitebusiness') {
      $session_name = 'Payment_Sitebusiness';
      $gateway_name = 'sitebusiness_gateway';
      $module_id = 'business_id';
      $itemType = 'sitebusiness_business';
    } elseif ($module_name == 'sitegroup') {
      $session_name = 'Payment_Sitegroup';
      $gateway_name = 'sitegroup_gateway';
      $module_id = 'group_id';
      $itemType = 'sitegroup_group';
    } elseif ($module_name == 'sitestore') {
      $session_name = 'Payment_Sitestore';
      $gateway_name = 'sitestore_gateway';
      $module_id = 'store_id';
      $itemType = 'sitestore_store';
    }

    //MAKE SESSION ACCRODING TO THE MODULE NAME.
    $session = new Zend_Session_Namespace($session_name);

    //SESSION OF USER AND GET THE USER ID AND OBJECT OF USER.
    //$this->_user = Engine_Api::_()->user()->getViewer();
    
    //CHECK VIEWER AND USER
    if (!$this->_user || !$this->_user->getIdentity()) {
      if (!empty($session->user_id)) {
        $this->_user = Engine_Api::_()->getItem('user', $session->user_id);
      }
      // If no user, redirect to home?
//       if( !$this->_user || !$this->_user->getIdentity() ) {
//         $this->_session->unsetAll();
//         return $this->_helper->redirector->gotoRoute(array(), 'default', true);
//       }
    }

    $user_id = $this->_user->user_id;
    $user = Engine_Api::_()->getItem('user', $user_id);

    //GET GATEWAY
    $gatewayId = $this->_getParam('gateway_id', $session->gateway_id);
    if (!$gatewayId ||
            !($gateway = Engine_Api::_()->getItem($gateway_name, $gatewayId)) ||
            !($gateway->enabled)) {
      return $this->_helper->redirector->gotoRoute(array('action' => 'gateway'));
    }
    
    $this->view->gateway = $gateway;

    //GET SUBSCRIPTION
    $subscriptionId = $this->_getParam($module_id, $session->$module_id);
    if (!$subscriptionId ||
            !($subscription = Engine_Api::_()->getItem($itemType, $subscriptionId))) {
      if ($module_name == 'payment') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'choose'));
      } elseif ($module_name == 'sitepage') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitepage_general', true);
      } elseif ($module_name == 'communityad') {
        return $this->_helper->redirector->gotoRoute(array(), 'communityad_campaigns', true);
      } elseif ($module_name == 'sitebusiness') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitebusiness_general', true);
      } elseif ($module_name == 'sitegroup') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitegroup_general', true);
      } elseif ($module_name == 'sitestore') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitestore_general', true);
      }
    }
    $this->view->subscription = $subscription;

    //GET PACKAGE
    $package = $subscription->getPackage();
    if (!$package || $package->isFree()) {
      if ($module_name == 'payment') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'choose'));
      } elseif ($module_name == 'sitepage') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitepage_general', true);
      } elseif ($module_name == 'communityad') {
        return $this->_helper->redirector->gotoRoute(array(), 'communityad_campaigns', true);
      } elseif ($module_name == 'sitebusiness') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitebusiness_general', true);
      } elseif ($module_name == 'sitegroup') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitegroup_general', true);
      } elseif ($module_name == 'sitestore') {
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitestore_general', true);
      }
    }
    $this->view->package = $package;

    //COUPON VALUE ACCRORDING TO CODE. CALLING FUNCTION.
    $result = Engine_Api::_()->getDbtable('coupons', 'sitecoupon')->getCode($code);

    $discount_value = 0;
    if ($result->discount_type == 'price') {
      $discount_value = $result->discount_value;
    } else if ($result->discount_type == 'percentage') {
      $discount_value = ($package->price ) * ($result->discount_value / 100);
    }
    $totalValue = $package->price - $discount_value;
    //$totalValue = Engine_Api::_()->sitecoupon()->getPriceWithCurrency($totalValue); 	
    $package->price = @round($totalValue, 2);


    
    // PROCESS
    // CREATE ORDER
    $ordersTable = Engine_Api::_()->getDbtable('orders', 'payment');
    if (!empty($session->order_id)) {
      $previousOrder = $ordersTable->find($session->order_id)->current();
      if ($previousOrder && $previousOrder->state == 'pending') {
        $previousOrder->state = 'incomplete';
        $previousOrder->save();
      }
    }
    $ordersTable->insert(array(
        'user_id' => $user->getIdentity(),
        'gateway_id' => $gateway->gateway_id,
        'state' => 'pending',
        'creation_date' => new Zend_Db_Expr('NOW()'),
        'source_type' => $itemType,
        'source_id' => $subscription->$module_id,
    ));
    $session->order_id = $order_id = $ordersTable->getAdapter()->lastInsertId();

    //HERE WE CAN INSERT THE VALUE IN THE COUPON USAGES TABLE(FOR MAKE A HISTORY).
    //if (!empty($order_id)) {
    $couponUsgaesTable = Engine_Api::_()->getDbtable('usages', 'sitecoupon');
    $couponUsgaesTable->insert(array(
        'coupon_id' => $result->coupon_id,
        'order_id' => $order_id,
        'code' => $code,
        'value' => $totalValue,
        'user_id' => $user_id,
        'resource_id' => $subscription->$module_id,
    ));
    //}

    if ($result->discount_type == 'percentage' && $result->discount_value == '100') {
			if ($module_name == 'sitebusiness' || $module_name == 'sitepage' || $module_name == 'sitegroup' || $module_name == 'sitestore') {
				$checkStatus = $this->_checkBusinessStatus($subscription, $module_name);
			} elseif ($module_name == 'communityad') {
				$checkStatus = $this->_checkBusinessStatus($subscription, $module_name);
			} elseif($module_name == 'payment') {
					$checkStatus = $this->_checkSubscriptionStatus($subscription, $module_name);
			}

			if ($checkStatus) {
				return;
			}
    }

    //END COUOPN USAGES.
    //UNSET CERTAIN KEYS
    unset($session->package_id);
    unset($session->$module_id);
    unset($session->gateway_id);

    //GET GATEWAY PLUGIN
    $this->view->gatewayPlugin = $gatewayPlugin = $gateway->getGateway();
    $plugin = $gateway->getPlugin();

    //PREPARE HOST INFO
    $schema = 'http://';
    if (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"])) {
      $schema = 'https://';
    }
    $host = $_SERVER['HTTP_HOST'];


    //PREPARE TRANSACTION
    $params = array();
    $params['language'] = $user->language;
    $localeParts = explode('_', $user->language);
    if (count($localeParts) > 1) {
      $params['region'] = $localeParts[1];
    }
    $params['vendor_order_id'] = $order_id;

    if ($module_name == 'sitestore') {
      $params['return_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitestore'), 'default')
              . '?order_id=' . $order_id
              . '&code=' . $code
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitestore'), 'default')
              . '?order_id=' . $order_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'sitestore'), 'default')
              . '?order_id=' . $order_id;
      // Process transaction
      $transaction = $plugin->createStoreTransaction($user, $subscription, $package, $params);
    } elseif ($module_name == 'sitegroup') {
      $params['return_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitegroup'), 'default')
              . '?order_id=' . $order_id
              . '&code=' . $code
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitegroup'), 'default')
              . '?order_id=' . $order_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'sitegroup'), 'default')
              . '?order_id=' . $order_id;
      // Process transaction
      $transaction = $plugin->createGroupTransaction($user, $subscription, $package, $params);
    } elseif ($module_name == 'sitebusiness') {
      $params['return_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitebusiness'), 'default')
              . '?order_id=' . $order_id
              . '&code=' . $code
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitebusiness'), 'default')
              . '?order_id=' . $order_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'sitebusiness'), 'default')
              . '?order_id=' . $order_id;
      // Process transaction
      $transaction = $plugin->createBusinessTransaction($user, $subscription, $package, $params);
    } elseif ($module_name == 'sitepage') {
      $params['return_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitepage'), 'default')
              . '?order_id=' . $order_id
              . '&code=' . $code
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'sitepage'), 'default')
              . '?order_id=' . $order_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'sitepage'), 'default')
              . '?order_id=' . $order_id;
      // Process transaction
      $transaction = $plugin->createPageTransaction($user, $subscription, $package, $params);
    } else if ($module_name == 'payment') {

      $params['return_url'] = $schema . $host
              .  $this->view->url(array('action' => 'return', 'controller' => 'subscription', 'module' => 'payment'), 'default')
              . '?order_id=' . $order_id
               . '&code=' . $code
              //. '?gateway_id=' . $this->_gateway->gateway_id
              //. '&subscription_id=' . $this->_subscription->subscription_id
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'subscription', 'module' => 'payment'), 'default')
              . '?order_id=' . $order_id
              //. '?gateway_id=' . $this->_gateway->gateway_id
              //. '&subscription_id=' . $this->_subscription->subscription_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'payment'), 'default')
              . '?order_id=' . $order_id;
      //. '?gateway_id=' . $this->_gateway->gateway_id
      //. '&subscription_id=' . $this->_subscription->subscription_id;
      // Process transaction
      $transaction = $plugin->createSubscriptionTransaction($user, $subscription, $package, $params);
    } elseif ($module_name == 'communityad') {
      $params['return_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'communityad'), 'default')
              . '?order_id=' . $order_id
              . '&code=' . $code
              . '&state=' . 'return';
      $params['cancel_url'] = $schema . $host
              . $this->view->url(array('action' => 'return', 'controller' => 'payment', 'module' => 'communityad'), 'default')
              . '?order_id=' . $order_id
              . '&state=' . 'cancel';
      $params['ipn_url'] = $schema . $host
              . $this->view->url(array('action' => 'index', 'controller' => 'ipn', 'module' => 'payment'), 'default')
              . '?order_id=' . $order_id;
      $transaction = $plugin->createUseradTransaction($user, $subscription, $package, $params);
    }

    //PULL TRANSACTION PARAMS
    $this->view->transactionUrl = $transactionUrl = $gatewayPlugin->getGatewayUrl();
    $this->view->transactionMethod = $transactionMethod = $gatewayPlugin->getGatewayMethod();
    $this->view->transactionData = $transactionData = $transaction->getData();

    //SEND COUPON CODE FOR DECREASE THE VALUE OF PACKAGE.
    $transactionData['coupon'] = $code;

    //HANDLE REDIRECTION
    if ($transactionMethod == 'GET') {
      $transactionUrl .= '?' . http_build_query($transactionData);
      return $this->_helper->redirector->gotoUrl($transactionUrl, array('prependBase' => false));
    }
    //POST WILL BE HANDLED BY THE VIEW SCRIPT
  }


  protected function _checkBusinessStatus(Zend_Db_Table_Row_Abstract $business = null, $module_name) {
    if (!$this->_user) {
      return false;
    }

		if ($module_name == 'sitepage') {
			$resource_type = 'sitepage_page';
			$resource_id = $business->page_id;
		} elseif ($module_name == 'sitebusiness') {
			$resource_type = 'sitebusiness_business';
			$resource_id = $business->business_id;
		} elseif ($module_name == 'sitegroup') {
			$resource_type = 'sitegroup_group';
			$resource_id = $business->group_id;
		} elseif ($module_name == 'sitestore') {
			$resource_type = 'sitestore_store';
			$resource_id = $business->store_id;
		} elseif ($module_name == 'communityad') {
		  $resource_type = 'userads';
			$resource_id = $business->userad_id;
		}
		
    if (null == $business) {
      $business = Engine_Api::_()->getItem($resource_type, $resource_id);
    }

    if ($business->getPackage()->isFree()) {
      $business->onPaymentSuccess();
      $this->_finishPayment('free', $module_name);
      return true;
    }

    return false;
  }

  protected function _finishPayment($state = 'active', $module_name) {
  
    //SESSION OF USER AND GET THE USER ID AND OBJECT OF USER.
   // $this->_user = Engine_Api::_()->user()->getViewer();
   
    if ($module_name == 'sitestore') {
			$returnmanage = $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitestore_general', true);
			$return = $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'controller' => 'payment', 'state' => $state), 'sitestore_extended', true);
		} elseif ($module_name == 'sitegroup') {
			$returnmanage = $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitegroup_general', true);
			$return = $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'controller' => 'payment', 'state' => $state), 'sitegroup_extended', true);
		} elseif ($module_name == 'sitebusiness') {
			$returnmanage = $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitebusiness_general', true);
			$return = $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'controller' => 'payment', 'state' => $state), 'sitebusiness_extended', true);
		} elseif ($module_name == 'sitepage') {
			$returnmanage = $this->_helper->redirector->gotoRoute(array('action' => 'manage'), 'sitepage_general', true);
			$return = $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'controller' => 'payment', 'state' => $state), 'sitepage_extended', true);
		} 

		elseif($module_name == 'communityad') {

        $this->_session = new Zend_Session_Namespace('Payment_Userads');
				$viewer = Engine_Api::_()->user()->getViewer();
				$user = $this->_user;

				// No user?
				if (!$this->_user) {
					return $this->_helper->redirector->gotoRoute(array(), 'default', true);
				}

				// Log the user in, if they aren't already
				if (($state == 'active' || $state == 'free') &&
						$this->_user &&
						!$this->_user->isSelf($viewer) &&
						!$viewer->getIdentity()) {
					Zend_Auth::getInstance()->getStorage()->write($this->_user->getIdentity());
					Engine_Api::_()->user()->setViewer();
				}

				// Clear session
				$errorMessage = $this->_session->errorMessage;
				$userIdentity = $this->_session->user_id;
				$userad_id = $this->_session->userad_id;
				$this->_session->unsetAll();
				$this->_session->user_id = $userIdentity;
				$this->_session->errorMessage = $errorMessage;

				// Redirect
				if ($state == 'free') {
					return $this->_helper->redirector->gotoRoute(array('ad_id' => $userad_id, "state" => 'saved'), 'communityad_userad', true);
				} else {
					return $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'state' => $state));
				}
		}
		
		if ($module_name != 'communityad') {
			if ($state == 'free') {
				return $returnmanage;
			} else {
				return $return;
			}
    }
  }



  protected function _checkSubscriptionStatus(Zend_Db_Table_Row_Abstract $subscription = null) {
    //$this->_user = Engine_Api::_()->user()->getViewer();
    if( !$this->_user ) {
      return false;
    }

    if( null === $subscription ) {
      $subscriptionsTable = Engine_Api::_()->getDbtable('subscriptions', 'payment');
      $subscription = $subscriptionsTable->fetchRow(array(
        'user_id = ?' => $this->_user->getIdentity(),
        'active = ?' => true,
      ));
    }

    if( !$subscription ) {
      return false;
    }

//     if( $subscription->status == 'active' ||
//         $subscription->status == 'trial' ) {
//       if( !$subscription->getPackage()->isFree() ) {
//         $this->_finishSubscriptionPayment('active');
//       } else { 
//         $subscription->onPaymentSuccess();
//         $this->_finishSubscriptionPayment('free');
//       }
//       return true;
//     } else if( $subscription->status == 'pending' ) {
//       $this->_finishSubscriptionPayment('pending');
//       return true;
//     }
    if( $subscription->getPackage()->isFree() ) {
    $subscription->onPaymentSuccess();
        $this->_finishSubscriptionPayment('free');
    }
    return false;
  }

  protected function _finishSubscriptionPayment($state = 'active') {
    //$this->_user = Engine_Api::_()->user()->getViewer();
    //$this->_session = new Zend_Session_Namespace('Payment_Subscription');
    $viewer = Engine_Api::_()->user()->getViewer();

    // No user?
    if( !$this->_user ) {
     return $this->_helper->_redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
    }

    // Log the user in, if they aren't already
    if( ($state == 'active' || $state == 'free') &&
        $this->_user &&
        !$this->_user->isSelf($viewer) &&
        !$viewer->getIdentity() ) {
      Zend_Auth::getInstance()->getStorage()->write($this->_user->getIdentity());
      Engine_Api::_()->user()->setViewer();
      $viewer = $this->_user;
    }

    // Handle email verification or pending approval
    if( $viewer->getIdentity() && !$viewer->enabled ) {
      Engine_Api::_()->user()->setViewer(null);
      Engine_Api::_()->user()->getAuth()->getStorage()->clear();

      $confirmSession = new Zend_Session_Namespace('Signup_Confirm');
      $confirmSession->approved = $viewer->approved;
      $confirmSession->verified = $viewer->verified;
      $confirmSession->enabled  = $viewer->enabled;
      return $this->_helper->_redirector->gotoRoute(array('action' => 'confirm'), 'user_signup', true);
    }
    
    // Clear session
    $errorMessage = $this->_session->errorMessage;
    $userIdentity = $this->_session->user_id;
    //$this->_session->unsetAll();
    $this->_session->user_id = $userIdentity;
    $this->_session->errorMessage = $errorMessage;

    // Redirect
    if( $state == 'free' ) {
      return $this->_helper->_redirector->gotoRoute(array('action' => 'home'), 'user_general', true);
    } else {
      return $this->_helper->redirector->gotoRoute(array('action' => 'finish', 'state' => $state));
    }
  }


  public function browseAction() {

    //USER VALDIATION
//     $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
//     if (empty($viewer_id)) {
//       return $this->_forward('requireauth', 'error', 'core');
//     }
    //CHECK THE VERSION OF THE CORE MODULE
    $this->_helper->content->setNoRender()->setEnabled();
  }

  //ACTION FOR PRINT COUPONS.
  public function printAction() {
  
    $this->_helper->layout->setLayout('default-simple');

    //GET COUPON ID.
    $id = $this->_getParam('coupon_id', $this->_getParam('id', null));

    $this->view->coupon = $coupon = Engine_Api::_()->getItem('sitecoupon_coupons', $id);

    if (empty($coupon)) {
      return $this->_forward('notfound', 'error', 'core');
    }
  }

  //ACTION FOR PREVIEW NA RELAVANT COUPONS.
  public function previewcouponAction() {

    $this->_helper->layout->setLayout('default-simple');

    $contentTable = Engine_Api::_()->getDbtable('content', 'core');
		$content = $contentTable->select()
			->from($contentTable->info('name'), array('params'))
			->where('name =?', 'core.menu-logo')
			->query()
			->fetchColumn();

    $contentLogo  = !empty($content) ? Zend_Json::decode($content) : array();
		if(isset($contentLogo['logo'])) {
			$this->view->logo = $contentLogo['logo'];
		}
		
    $package_type = $this->_getParam('package_type', null);
    
    //SET THE VARIABLE ACCRODING TO THE MODULE NAME.
    if ($package_type == 'payment') {
      $package_type = 'payment_package';
    } else if ($package_type == 'sitepage') {
      $package_type = 'sitepage_package';
    } elseif ($package_type == 'communityad') {
      $package_type = 'package';
    } elseif ($package_type == 'sitebusiness') {
      $package_type = 'sitebusiness_package';
    } elseif ($package_type == 'sitegroup') {
      $package_type = 'sitegroup_package';
    } elseif ($package_type == 'sitestore') {
      $package_type = 'sitestore_package';
    }
    
    //GET COUPON ID AND PACKAGE TYPE.
    $this->view->coupon_id = $id = $this->_getParam('coupon_id', null);
    $this->view->coupon = Engine_Api::_()->getItem('sitecoupon_coupons', $id);

		$select = Engine_Api::_()->sitecoupon()->getAllCoupons('previewcoupon', $package_type);
		$select = $select->limit(20);

	  $this->view->result = $paginator = Zend_Paginator::factory($select);
    $paginator->setItemCountPerPage(20);
    //$this->view->paginator = $paginator->setCurrentPageNumber(Zend_Controller_Front::getInstance()->getRequest()->getParam('page'));
  }
  
}