<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoupon
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 6590 2012-06-24 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 
$formUsages = 1;
$contentModule = Engine_Api::_()->getDbtable('types', 'sitecoupon')->getEnabledModules($formUsages);
$contentModuleArray = array();

if( !empty($contentModule) ) {

  $contentModuleArray[1] = 'All Coupons';
	$contentModuleArray[0] = 'All Items';	
	foreach ($contentModule as $modules) {
		$contentModuleArray[$modules['package_type']] = $modules['title'];
	}
}

if( !empty($contentModule) ) {
	//$contentModuleArray[0] = 'Select All';
	foreach ($contentModule as $modules) {
		$contentModuleArrays[$modules['package_type']] = $modules['title'];
	}
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
  array(
    'title' => 'Special Offer',
    'description' => 'Displays a coupon as a special offer. You can choose the coupon to be shown in this widget from the settings of the widget. Other settings are also available.',
    'category' => 'Coupons',
    'autoEdit' => true,
    'type' => 'widget',
    'name' => 'sitecoupon.coupon-day',
    'adminForm' => 'Sitecoupon_Form_Admin_Item',
    'defaultParams' => array(
				'title' => $view->translate('Special Offer'),
		),
  ),
	array(
		'title' => $view->translate('Coupons (sidebar)'),
		'description' => $view->translate('Displays a list of the active coupons depending on the settings chosen for this widget that should be visible to the viewer. Clicking on a coupon entry displays that coupon\'s details in a small window along with instructions for using the coupon code. Multiple settings are available for this widget.'),
		'category' => $view->translate('Coupons'),
		'type' => 'widget',
		//'autoEdit' => true,
		'name' => 'sitecoupon.show-coupons',
		'defaultParams' => array(
				'title' => $view->translate('Coupons (sidebar)'),
				'titleCount' => true,
		),
		'adminForm' => array(
			'elements' => array(
			array(
				'Text',
				'itemCount',
					array(
						'label' => $view->translate('Count'),
						'description' => $view->translate('(number of coupons to show)'),
						'value' => 5,
						'validators' => array(
							array('Int', true),
							array('GreaterThan', true, array(0)),
						),
					),
				),
				array(
					'Radio',
					'print',
					array(
							'label' => $view->translate('Show print option.'),
							'multiOptions' => array(
									1 => 'Yes',
									0 => 'No'
							),
							'value' => 1,
					)
				),
				array(
					'Radio',
					'usagesshow',
					array(
							'label' => $view->translate('Show remaining usage count.'),
							'multiOptions' => array(
									1 => 'Yes',
									0 => 'No'
							),
							'value' => 1,
					)
				),
				array(
					'select',
					'package_type',
					array(
						'label' => $view->translate('Select the product type.'),
						'multiOptions' =>	$contentModuleArray,
					)
				),
				
				array(
					'Select',
					'interval',
					array(
							'label' => $view->translate('Display Criteria'),
							'multiOptions' => array('1' => 'Random', '2' => 'Created', '3' => 'Higher Percentage', '4' => 'Higher Price', '5' => 'Latest'),
							'value' => 'rand',
					)
				),
			),
		),
  ),
	array(
		'title' => $view->translate('Browse Coupons'),
		'description' => $view->translate('Displays a list of all the active coupons on your site that should be visible to the viewer. Viewer can filter the entries based on product types. Clicking on a coupon entry displays that coupon\'s details in a small window along with instructions for using the coupon code. Multiple settings are available for this widget. This widget should be placed on the Coupons Browse Page.'),
		'category' => $view->translate('Coupons'),
		'type' => 'widget',
		'name' => 'sitecoupon.all-coupon',
		'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
		),
		'adminForm' => array(
			'elements' => array(
				array(
					'Text',
					'itemCount',
					array(
						'description' => $view->translate('Count (number of coupons to show)'),
						'value' => 20,
						'validators' => array(
							array('Int', true),
							array('GreaterThan', true, array(0)),
						),
					),
				),
// 				array(
// 					'MultiCheckbox',
// 					'search_column',
// 					array(
// 							'label' => $view->translate('Choose the fields that you want to be show in the Search Drop Down.'),
// 							'multiOptions' => $contentModuleArrays,
// 					),
// 				),
				array(
					'Radio',
					'print',
					array(
							'label' => $view->translate('Show print option.'),
							'multiOptions' => array(
									1 => 'Yes',
									0 => 'No'
							),
							'value' => 1,
					)
				),
			  array(
					'Radio',
					'usagesshow',
					array(
							'label' => $view->translate('Show remaining usage count.'),
							'multiOptions' => array(
									1 => 'Yes',
									0 => 'No'
							),
							'value' => 1,
					)
				),
			),
		),
  ),
)
?>