<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecrowdfunding
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecrowdfunding_Form_Settings extends Engine_Form {

    public function init() {

        $this->setTitle("Edit Project Profile Settings")
                ->setDescription("You can configure below settings related to the your Project’s profile page, like you can enable setting to display main photo / video at top on the Project’s profile page.")
                ->setAttrib('name', 'owner_settings');
        $this->addElement('Radio', 'profile_cover', array(
            'label' => 'Main Photo / Video',
            'description' => "What do you want to show as main content, photo / video, on your Project’s profile page?<br>[Note: You can choose the main photo / video from the ‘Photos’ / ‘Videos’ section of the dashboard.]",
            'multiOptions' => array(
                '1' => 'Photo',
                '0' => 'Video',
            ),
            'value' => 1,
        ));
        $this->profile_cover->addDecorator('Description', array('placement' => 'PREPEND', 'class' => 'description', 'escape' => false));
        $this->addElement('Button', 'save', array(
            'label' => 'Save',
            'type' => 'submit',
        ));
    }

}
