<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecrowdfunding
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitecrowdfunding_Widget_MainProjectInformationController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //DONT RENDER IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject('sitecrowdfunding_project')) {
            return $this->setNoRender();
        }
        //GET PROJECT SUBJECT
        $this->view->project = $project = Engine_Api::_()->core()->getSubject('sitecrowdfunding_project');
        $this->view->projectOption = $this->_getParam('projectOption', array("title", "description", "owner", "location", "fundingRatio", "fundedAmount", "daysLeft", "backerCount", "backButton", "category", "dashboardButton", "shareOptions", "optionsButton"));
        $this->view->columnHeight = $this->_getParam('columnHeight', 400);
        $this->view->titleTruncation = $this->_getParam('titleTruncation', 20);
        $this->view->descriptionTruncation = $this->_getParam('descriptionTruncation', 50);
        $this->view->showPhoto = true;
        $tableOtherinfo = Engine_Api::_()->getDbTable('otherinfo', 'sitecrowdfunding');

        //0:Video,1:Photo
        $profile_cover = $tableOtherinfo->getColumnValue($project->getIdentity(), 'profile_cover');
        $sitevideoEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitevideo');
        $sitecrowdfundingMainProjectInfo = Zend_Registry::isRegistered('sitecrowdfundingMainProjectInfo') ? Zend_Registry::get('sitecrowdfundingMainProjectInfo') : null;
        if ($profile_cover == 0 && !empty($project->video_id) && $sitevideoEnabled && Engine_Api::_()->getDbtable('modules', 'sitevideo')->getIntegratedModules(array('enabled' => 1, 'item_type' => "sitecrowdfunding_project", 'item_module' => 'sitecrowdfunding'))) {
            $this->view->video = $video = Engine_Api::_()->getItem('sitevideo_video', $project->video_id);
            if ($video) {
                $this->view->showPhoto = false;
            }
        }
        if (empty($sitecrowdfundingMainProjectInfo))
            return $this->setNoRender();
        // Suggest to Friend link show work
        $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
        if (!empty($is_suggestion_enabled)) {
            $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitecrowdfunding', $project->project_id, null, null);
            if (!empty($modContentObj)) {
                $contentCreatePopup = @COUNT($modContentObj);
            }
            Engine_Api::_()->sitecrowdfunding()->deleteSuggestion(Engine_Api::_()->user()->getViewer()->getIdentity(), 'sitecrowdfunding', $project->project_id, 'sitecrowdfunding_project', 'sitecrowdfunding_suggestion');
            if (!empty($contentCreatePopup)) {
                $this->view->projectSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitecrowdfunding', 'link');
            }
        } else {
            $this->view->projectSuggLink = 0;
        }
    }

}
