<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitecoretheme
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Pagelayouts.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitedating_Api_Pagelayouts extends Core_Api_Abstract {  
    /**
     * Get Widgetized PageId
     * @param $params
     */
    public function getWidgetizedPageId($params = array()) {
        //GET CORE CONTENT TABLE
       $tableNamePages = Engine_Api::_()->getDbtable('pages', 'core');
       $page_id = $tableNamePages->select()
       ->from($tableNamePages->info('name'), 'page_id')
       ->where('name =?', $params['name'])
       ->query()
       ->fetchColumn();
       return $page_id;
    } 
    
    public function getBackupPageId($pageName) {
        //GET CORE CONTENT TABLE
       $tableNamePages = Engine_Api::_()->getDbtable('pages', 'core');
       $page_id = $tableNamePages->select()
       ->from($tableNamePages->info('name'), 'page_id')
       ->where('name =?', $pageName)
       ->query()
       ->fetchColumn();
       return $page_id;
    }

    public function configureSliderWidget() {
      $coreSettings = Engine_Api::_()->getApi('settings', 'core');
       $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/slider';
       if (is_dir($imagesPath)) {
         foreach (scandir($imagesPath) as $fileName) {
           $extension = ltrim(strrchr(basename($fileName), '.'), '.');
           if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
             continue;
          }
          $fileNumber = explode('.', $fileName)[0];
          $Filedata = array(
             'tmp_name' => $imagesPath . '/' . $fileName,
             'name' => $fileName,
          );
          $values = array('title' => "Image ".$fileNumber, 'enabled' => 1, 'order' => $fileNumber);
          $imagesTable = Engine_Api::_()->getDbtable('images', 'sitecoretheme');
          $db = Engine_Db_Table::getDefaultAdapter();
          $db->beginTransaction();
          try {
             $image = $imagesTable->createRow();
             $image->setFromArray($values);
             $image->save();
             $image->setPhoto($Filedata);
             $db->commit();
          } catch (Exception $e) {
             $db->rollBack();
             throw $e;
          }   
       }
    }
    //SAVE THE SETTINGS REATED TO THE IMAGE SLIDER
    $coreSettings->setSetting('sitecoretheme.landing.slider.form.type', 'user_search');
    $coreSettings->setSetting('sitecoretheme.landing.slider.bannerTitle', 'Glide In & Find The Love Of Your Life');
    $coreSettings->setSetting('sitecoretheme.landing.slider.description1', 'Allow yourself to meet people with the same tastes and desires!'); 
 }

 public function configureHighlightWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $highlightBlocks = array(
      '1' => array('title' => 'Global Members', 'description' => 'In this site, people from all over the world have joined. That means we have global users. You can look for your perfect match globally.'),
      '2' => array('title' => 'Mobilize members', 'description' => 'Every member is a potential outreach hub in his or her social universe. Mobilisation involves people to do things.'),
      '3' => array('title' => 'Connecting people', 'description' => 'Connecting more faces around the world makes your virtual ambience even more enjoyable and happy.'),
      '4' => array('title' => 'Opportunity to understand', 'description' => 'Take your time to understand the one you meet via this site. It is important to know the other person\'s perspectives for life and partner'),
      '5' => array('title' => 'A place to meet virtually', 'description' => 'In this life full of hustles, a platform is needed to give people a virtual company to enjoy.'),
      '6' => array('title' => 'Easy meetups', 'description' => 'Discover the one with common interests. Set up a date to know about each other even more'),
      '7' => array('title' => 'Share your thoughts', 'description' => 'Sharing your thoughts with others helps you connect with more individuals with a comparable point of view towards life.'),
      '8' => array('title' => 'Share your dating success stories', 'description' => 'Share your dating success stories with other members of community to increase their interests and trust towards online dating.'),
   );

    $highlightTable = Engine_Api::_()->getDbtable('highlights', 'sitecoretheme');
    $rows = $highlightTable->fetchAll();
    $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/highlight';
    foreach ($rows as $row) {
      $fileName = $row->highlights_id.'.png';
      $fileData = array(
        'tmp_name' => $imagesPath . '/' .$fileName ,
        'name' => $fileName,
     );

      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try { 
        $row->setFromArray($highlightBlocks[$row->highlights_id]);
        $row->save();
        $row->setPhoto($fileData);
        $db->commit();
     } catch (Exception $e) {
        $db->rollBack();
        throw $e;
     }
  }
          //SET MIDDLE SECTION PHOTO
  $coreSettings->setSetting('sitecoretheme.landing.highlights.image', 'application/modules/Sitedating/externals/images/highlights_middle.jpg');
}

public function configureStatsWidget() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
 $statCountArray = array('1' => '2800', '2' => '2754', '3' => '2699', '4' => '12597');
 $statTitleArray = array('1' => 'Registered Users', '2' => 'Success Stories', '3' => 'Datings', '4' => 'Posts');
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/stats';

 if (is_dir($imagesPath)) {
   foreach (scandir($imagesPath) as $fileName) {
     $extension = ltrim(strrchr(basename($fileName), '.'), '.');
     if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
       continue;
    }
    $fileNumber = explode('.', $fileName)[0];
    $Filedata = array(
       'tmp_name' => $imagesPath . '/' . $fileName,
       'name' => $fileName,
    ); 
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {  
       $file_id = $this->setPhoto($Filedata, null, 'sitecoretheme_stat');
       if($file_id) {
        $coreSettings->setSetting('sitecoretheme.landing.stats.icon'.$fileNumber, $file_id);
       }
       $coreSettings->setSetting('sitecoretheme.landing.stats.count'.$fileNumber, $statCountArray[$fileNumber]);
       $coreSettings->setSetting('sitecoretheme.landing.stats.title'.$fileNumber, $statTitleArray[$fileNumber]);
       $db->commit();
    } catch (Exception $e) {
       $db->rollBack();
       throw $e;
    }
 }
}
$coreSettings->setSetting('sitecoretheme.landing.stats.bgimage', 'application/modules/Sitedating/externals/images/stat_background.jpg');
}

public function configureTextBannerWidget() {
  $coreSettings = Engine_Api::_()->getApi('settings', 'core');
  $coreSettings->setSetting('sitecoretheme.landing.tbanner.text', 'Don’t Stay Alone!');
  $coreSettings->setSetting('sitecoretheme.landing.tbanner.ctatext', 'Join & Find Your Love');
  $coreSettings->setSetting('sitecoretheme.landing.tbanner.url', '#');
  $coreSettings->setSetting('sitecoretheme.landing.tbanner.newtab', 1);
}

public function configureCommonSettings() {
   $coreSettings = Engine_Api::_()->getApi('settings', 'core');
   //change the footer background image
   $coreSettings->setSetting('sitecoretheme.footer.backgroundimage', 'application/modules/Sitedating/externals/images/default_footer_bg.jpg');
   //ICON BELOW THE HEADING IN THE LANDING PAGE
   $coreSettings->setSetting('sitecoretheme.landing.heading.icon', 'f004');
   //BUTTONS STYLE
   $coreSettings->setSetting('sitecoretheme.button.design', '6');
   //HEADING STYPE
   $coreSettings->setSetting('sitecoretheme.layout.container.headding.style', '1');
   //CONTAINER STYLE
   $coreSettings->setSetting('sitecoretheme.layout.container.design', '2');

   //SAVE THE LAYOUT SETTING, THESE MAY BE DIFFRERET BASED ON THE TEMPLATE
   $fileName = 'sitecorethemeThemeGeneralConstants.css';
   $values['sitecoretheme_layout_theme_width'] =  '1200px';
   $values['sitecoretheme_layout_left_column_width'] = '250px';
   $values['sitecoretheme_layout_right_column_width'] = '250px';
   $values['sitecoretheme_layout_container_design'] = '2';
   $values['sitecoretheme_layout_container_headding_style'] = '1';
   $values['sitecoretheme_button_design'] = '6';
   $values['sitecoretheme_landing_heading_icon'] = 'f004';
   $values['sitecoretheme_layout_hide_left_column'] = 'none';
   $values['sitecoretheme_layout_hide_right_column'] = 'block';
   Engine_Api::_()->getApi('customization', 'sitecoretheme')->setConstants($values, $fileName);
}

public function configureContentBlocksWidget() {
 $params = '{"video_uri":"","cta_1_heading":null,"cta_1_label":"","cta_1_uri":"","cta_1_uri_target":"0","cta_2_heading":null,"cta_2_label":"","cta_2_uri":"","cta_2_uri_target":"0"}';
 $body1 = 'We met through this site. When I saw her profile, All she wrote on her profile was “I am ready and willing to co-create a conscious partnership full of play, adventure, and personal growth! Would you be willing to embark with me?” Instantly, I was intrigued and accepted her challenge by sending her a message. Within a few days of emailing on the site we started video chatting and I took her on a "virtual date". She then asked, "When are you going to take me on a real date?" Two and half months later, I flew to meet her in person take her on our first real date. She is everything I was looking for and more – a conscious, compassionate, kind, capable, and funny woman!';
 $body2 = 'My wife, Casey,  and I met through this site almost five years ago.  From our profiles, we already knew that we had important things in common, and none of the typical deal breakers. After dating for a few years, we decided to get married,  outdoors, of course, in the church of the open sky on Folly Beach,  South Carolina.  We celebrate our first anniversary next month. I don`t think we would have met without this site.<p> Thank you!</p>Mike';
 $body3 = '<p>Me (TURAN) and my dearest (ITEWKER) met on your site on September 2017, He lives in Los Angeles, like my son, and I live near Rome in Italy. After many months of talking finally we really met on 5th April 2018 and a real strong love story was confirmed between us.</p> <p>Now we are organizing to have a succesfull life together soon somewhere.</p> <p>We want to thank your site that gave us this destiny chance to really found a twin soul.</p> <p>I attach here a picture of us in Sedona (Arizona).</p><p>Greetings, </p><p>Rosanna and James </p>';
 $contentArray = array(
   '1' => array('title' => 'When Rom met Com…', 'subheading' => 'SAN DIEGO DAIRIES', 'body' => $body1, 'params' => $params),
   '2' => array('title' => 'Important Things in Common', 'subheading' => 'Beckenham Dairies', 'body' => $body2, 'params' => $params),
   '3' => array('title' => 'Long Distance Love - Was Never A Problem', 'subheading' => 'Rome and Los Angeles Love Story', 'body' => $body3, 'params' => $params),
);
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/blocks';
 if (is_dir($imagesPath)) {
   foreach (scandir($imagesPath) as $fileName) {
     $extension = ltrim(strrchr(basename($fileName), '.'), '.');
     if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
       continue;
    }
    $fileNumber = explode('.', $fileName)[0];
    $Filedata = array(
       'tmp_name' => $imagesPath . '/' . $fileName,
       'name' => $fileName,
    );
    $blocksTable = Engine_Api::_()->getDbtable('blocks', 'sitecoretheme');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
       $block = $blocksTable->createRow();
       $block->setFromArray($contentArray[$fileNumber]);
       $block->save();
       $block->setPhoto($Filedata);
       $db->commit();
    } catch (Exception $e) {
       $db->rollBack();
       throw $e;
    }
 }
}
}

public function configureCtaButtonsWidget() {
 $coreSettings = Engine_Api::_()->getApi('settings', 'core');
 $ctaTitleArray = array('1' => 'Create Your Profile', '2' => 'Find Matches', '3' => 'Start Dating');
 $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/ctabutton';
 $imagesPathHover = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/ctahover';
 if (is_dir($imagesPath)) {
   foreach (scandir($imagesPath) as $fileName) {
     $extension = ltrim(strrchr(basename($fileName), '.'), '.');
     if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
       continue;
    }
    $fileNumber = explode('.', $fileName)[0];
    $Filedata = array(
       'tmp_name' => $imagesPath . '/' . $fileName,
       'name' => $fileName,
    ); 
    $fileDataHover = array(
       'tmp_name' => $imagesPathHover . '/' . $fileName,
       'name' => $fileName,
    ); 
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {  
       $file_id = $this->setPhoto($Filedata, null, 'sitecoretheme_ctabutton');
       $fileIdHover = $this->setPhoto($fileDataHover, null, 'sitecoretheme_ctabutton');
       if($file_id) {
        $coreSettings->setSetting('sitecoretheme.landing.cta.icon'.$fileNumber, $file_id);
       }
       if($fileIdHover) {
        $coreSettings->setSetting('sitecoretheme.landing.cta.hover.icon'.$fileNumber, $fileIdHover);
       }
       $coreSettings->setSetting('sitecoretheme.landing.cta.title'.$fileNumber, $ctaTitleArray[$fileNumber]);
       $db->commit();
    } catch (Exception $e) {
       $db->rollBack();
       throw $e;
    }
 }
}
$coreSettings->setSetting('sitecoretheme.landing.cta.style', 'style3');
$coreSettings->setSetting('sitecoretheme.landing.cta.newtab', '0');
}

public function configureBannerImagesWidget() {
     $coreSettings = Engine_Api::_()->getApi('settings', 'core');
     $bannerTable = Engine_Api::_()->getItemTable('sitecoretheme_banner');
      $imagesPath = APPLICATION_PATH . '/application/modules/Sitedating/externals/images/banner';
      if (is_dir($imagesPath)) {
        foreach (scandir($imagesPath) as $fileName) {
          $extension = ltrim(strrchr(basename($fileName), '.'), '.');
          if (!in_array($extension, array('jpg', 'png', 'gif', 'jpeg'))) {
            continue;
         }
         $fileNumber = explode('.', $fileName)[0];
         $Filedata = array(
            'tmp_name' => $imagesPath . '/' . $fileName,
            'name' => $fileName,
         );
         $values = array('title' => "Banner_".$fileNumber, 'enabled' => 1, 'order' => $fileNumber);
         $db = Engine_Db_Table::getDefaultAdapter();
         $db->beginTransaction();
         try {
            $banner = $bannerTable->createRow();
            $banner->setFromArray($values);
            $banner->save();
            $banner->setPhoto($Filedata);
            $db->commit();
         } catch (Exception $e) {
            $db->rollBack();
            throw $e;
         }   
      }
   }
}

public function setPhoto($photo, $parent_id = null, $parent_type = null, $size = 64)
{
 if( $photo instanceof Zend_Form_Element_File ) {
   $file = $photo->getFileName();
} else if( is_array($photo) && !empty($photo['tmp_name']) ) {
   $file = $photo['tmp_name'];
} else if( is_string($photo) && file_exists($photo) ) {
   $file = $photo;
} else {
   throw new Engine_Exception('invalid argument passed to setPhoto');
}

$name = basename($file);
$path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

$thumb_file = $path . '/in_' . $name;
$image = Engine_Image::factory();

$image->open($file)
->resize($size, $size)
->write($thumb_file)
->destroy();
try {
   $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
     'parent_type' => $parent_type,
     'parent_id' => $parent_id
  ));
            // Remove temp file
   @unlink($thumb_file);
} catch( Exception $e ) {

}
$file_id = $thumbFileRow->file_id;
return $file_id;
}

public function getBackupOfHomePage() {

 $page_id = $this->getWidgetizedPageId(array('name' => 'core_index_index'));
 $tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
 $tableNameContentName = $tableNameContent->info('name');
 $db = Engine_Db_Table::getDefaultAdapter();

        //CHECK PAGE EXIST OR NOT
 $home_backup_page_id = $this->getBackupPageId('landing_page_backup');
 if(!empty($home_backup_page_id)) {
   return;
}

        //CREATE PAGE
if (empty($home_backup_page_id)) {
   $db->query("INSERT IGNORE INTO `engine4_core_pages` ( `name`, `displayname`, `url`, `title`, `description`, `keywords`, `custom`, `fragment`, `layout`, `levels`, `provides`, `view_count`, `search`) VALUES ('landing_page_backup', 'Landing Page - Backup of Landing Page on Installation of Vertical Theme', 'landing_page_backup', 'Backup of Landing Page on Installation of Vertical Theme Plugin', '', '', '0', '0', '', NULL, NULL, '0', '0');");
}

        //GET EXISTING PAGE ID
$home_backup_page_id = $this->getBackupPageId('landing_page_backup');

$db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $home_backup_page_id");
        //GET MAIN CONTAINER WORK

$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'main')
->where('type =?', 'container');

$mainRow = $tableNameContent->fetchRow($select);

if (!empty($mainRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'main',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $mainRow->order,
     'params' => $mainRow->params ? json_encode($mainRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $mainRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => $values['type'],
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //LEFT CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $mainRow->content_id)
  ->where('name =?', 'left')
  ->where('type =?', 'container');

  $leftRow = $tableNameContent->fetchRow($select);

  if (!empty($leftRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $leftRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'left')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END LEFT CONTAINER WIDGET
            //MIDDLE CONTAINER WIDGETS
 $select = $tableNameContent->select()
 ->from($tableNameContentName, '*')
 ->where('page_id =?', $page_id)
 ->where('parent_content_id =?', $mainRow->content_id)
 ->where('name =?', 'middle')
 ->where('type =?', 'container');

 $middleRow = $tableNameContent->fetchRow($select);

 if (!empty($middleRow)) {
  $results = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $middleRow->content_id)
  ->where('type =?', 'widget')
  ->query()
  ->fetchAll();

  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $home_backup_page_id)
  ->where('parent_content_id =?', $content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $row = $tableNameContent->fetchRow($select);

  foreach ($results as $values) {
    $db->insert('engine4_core_content', array(
      'type' => $values['type'],
      'name' => $values['name'],
      'page_id' => $home_backup_page_id,
      'parent_content_id' => $row->content_id,
      'order' => $values['order'],
      'params' => $values['params']
   ));
 }
}
            //END MIDDLE CONTAINER WIDGET
            //RIGHT CONTAINER WIDGETS
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('parent_content_id =?', $mainRow->content_id)
->where('name =?', 'right')
->where('type =?', 'container');

$rightRow = $tableNameContent->fetchRow($select);

if (!empty($rightRow)) {
  $results = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $rightRow->content_id)
  ->where('type =?', 'widget')
  ->query()
  ->fetchAll();

  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $home_backup_page_id)
  ->where('parent_content_id =?', $content_id)
  ->where('name =?', 'right')
  ->where('type =?', 'container');

  $row = $tableNameContent->fetchRow($select);

  foreach ($results as $values) {
    $db->insert('engine4_core_content', array(
      'type' => $values['type'],
      'name' => $values['name'],
      'page_id' => $home_backup_page_id,
      'parent_content_id' => $row->content_id,
      'order' => $values['order'],
      'params' => $values['params']
   ));
 }
}
            //END RIGHT CONTAINER WIDGET
}

        //TOP CONTAINER
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'top')
->where('type =?', 'container');

$topRow = $tableNameContent->fetchRow($select);

if (!empty($topRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $topRow->order,
                //'params' => json_encode($topRow->params)
     'params' => $topRow->params ? json_encode($topRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $topRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //MIDDLE CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $topRow->content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $topMiddleRow = $tableNameContent->fetchRow($select);

  if (!empty($topMiddleRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $topMiddleRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'middle')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END MIDDLE CONTAINER WIDGET
}


        //GET BOTTOM CONTAINER
$select = $tableNameContent->select()
->from($tableNameContentName, '*')
->where('page_id =?', $page_id)
->where('name =?', 'bottom')
->where('type =?', 'container');

$bottomRow = $tableNameContent->fetchRow($select);

if (!empty($bottomRow)) {

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'bottom',
     'page_id' => $home_backup_page_id,
     'parent_content_id' => null,
     'order' => $bottomRow->order,
     'params' => $bottomRow->params ? json_encode($bottomRow->params) : ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');

   $results = $tableNameContent->select()
   ->from($tableNameContentName, '*')
   ->where('page_id =?', $page_id)
   ->where('name in (?)', array('left', 'middle', 'right'))
   ->where('type =?', 'container')
   ->where('parent_content_id =?', $bottomRow->content_id)
   ->query()
   ->fetchAll();

   foreach ($results as $values) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => $values['name'],
       'page_id' => $home_backup_page_id,
       'parent_content_id' => $content_id,
       'order' => $values['order'],
       'params' => $values['params']
    ));
  }

            //MIDDLE CONTAINER WIDGETS
  $select = $tableNameContent->select()
  ->from($tableNameContentName, '*')
  ->where('page_id =?', $page_id)
  ->where('parent_content_id =?', $bottomRow->content_id)
  ->where('name =?', 'middle')
  ->where('type =?', 'container');

  $bottomMiddleRow = $tableNameContent->fetchRow($select);

  if (!empty($bottomMiddleRow)) {
     $results = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $page_id)
     ->where('parent_content_id =?', $bottomMiddleRow->content_id)
     ->where('type =?', 'widget')
     ->query()
     ->fetchAll();

     $select = $tableNameContent->select()
     ->from($tableNameContentName, '*')
     ->where('page_id =?', $home_backup_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'middle')
     ->where('type =?', 'container');

     $row = $tableNameContent->fetchRow($select);

     foreach ($results as $values) {
       $db->insert('engine4_core_content', array(
         'type' => $values['type'],
         'name' => $values['name'],
         'page_id' => $home_backup_page_id,
         'parent_content_id' => $row->content_id,
         'order' => $values['order'],
         'params' => $values['params']
      ));
    }
 }
            //END MIDDLE CONTAINER WIDGET
}
}

public function setDefaultLayout($obj) {
 $this->getBackupOfHomePage();
 $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
 $db = Engine_Db_Table::getDefaultAdapter();
 $page_id = $db->select()
 ->from('engine4_core_pages', 'page_id')
 ->where('name = ?', 'core_index_index')
 ->limit(1)
 ->query()
 ->fetchColumn();
 if (!empty($page_id) && !empty($obj) && !empty($obj['sitecoretheme_landing_page_layout'])) {
   $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $page_id");

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $page_id,
     'order' => 1,
  ));
   $top_id = $db->lastInsertId();

   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'middle',
     'parent_content_id' => $top_id,
     'page_id' => $page_id,
     'order' => 2,
  ));
   $top_middle_id = $db->lastInsertId();

  $db->insert('engine4_core_content', array(
    'type' => 'widget',
    'name' => 'sitecoretheme.landing-page-header',
    'page_id' => $page_id,
    'parent_content_id' => $top_middle_id,
    'params' => '{"title":"","name":"sitecoretheme.landing-page-header"}',
    'order' => 3,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.images',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":""}',
     'order' => 4,
  )); 
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'main',
     'page_id' => $page_id,
     'order' => 5,
  ));
   $main_id = $db->lastInsertId();

            // Insert main-middle
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'middle',
     'page_id' => $page_id,
     'parent_content_id' => $main_id,
     'order' => 6,
  ));
   $main_middle_id = $db->lastInsertId();

            // Insert main-middle
   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.highlights-block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"Aided For","titleCount":true,"description":"Your tribe is your vibe. A solid tribe is a motivation for folks to do things out of tradition. An online tribe cements people to do a lot together but virtually.","nomobile":"0"}',
     'order' => 7,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.stats-block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"","titleCount":true}',
     'order' => 8,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.content-blocks',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"viewType":"5","title":"Match made in Heaven","description":"","itemType":"album","sortBy":"creation_date","readMoreText":"Read More","limit":"9","nomobile":"0","name":"sitecoretheme.content-blocks"}',
     'order' => 8,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.text-banner',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"", "nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.heading',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.heading","title":"Success Stories","description":"Many people found the love of their lives using this site which can make you trust online dating. Read the dating success stories which couples has shared with us.","nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"1","photosPositions":"left","backendBorder":"1","title":"","nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"2","photosPositions":"right","backendBorder":"1","title":"","nomobile":"0"}',
     'order' => 9,
  ));

   $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.block',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"name":"sitecoretheme.block","block_id":"3","photosPositions":"left","backendBorder":"1","title":"","nomobile":"0"}',
     'order' => 9,
  ));  

   if (Engine_Api::_()->hasModuleBootstrap('sitealbum')) {
     $db->insert('engine4_core_content', array(
       'type' => 'widget',
       'name' => 'sitealbum.list-popular-albums',
       'page_id' => $page_id,
       'parent_content_id' => $top_middle_id,
       'params' => '{"title":"Popular Albums","itemCountPerPage":"6","description":" Albums are the standalone subsistence which keep your memories collaborated at one place to share memories collectively.","category_id":"0","subcategory_id":null,"hidden_category_id":"0","hidden_subcategory_id":"0","featured":"1","popularType":"comment","interval":"overall","photoHeight":"280","photoWidth":"396","albumInfo":["ownerName","viewCount","likeCount","commentCount","albumTitle","totalPhotos"],"infoOnHover":"1","titleLink":"","truncationLocation":"35","albumTitleTruncation":"100","detactLocation":"0","defaultLocationDistance":"1000","nomobile":"0","name":"sitealbum.list-popular-albums"}',
       'order' => 11,
    ));
  }

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.static-buttons',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"How to find your love with us!","name":"sitecoretheme.static-buttons"}',
     'order' => 12,
  ));

  if (Engine_Api::_()->hasModuleBootstrap('siteevent')) {
     $db->insert('engine4_core_content', array(
       'type' => 'widget',
       'name' => 'siteevent.list-popular-events',
       'page_id' => $page_id,
       'parent_content_id' => $top_middle_id,
       'params' => '{"title":"Popular Events","titleCount":true,"showOptions":["category","rating","review"],"description":"Event is an occurrence of people gathering together where some or all of the attendees are not physically in the same location but are connected in a common environment.","eventType":"0","fea_spo":"","category_id":"0","subcategory_id":null,"hidden_category_id":"","hidden_subcategory_id":"","hidden_subsubcategory_id":"","showMorelink":"1","blockHeight":"350","blockWidth":"387","itemCount":"3","popularity":"event_id","showEventType":"upcoming","truncationLocation":"50","truncation":"50","ratingType":"rating_avg","detactLocation":"0","defaultLocationDistance":"1000","nomobile":"0","name":"siteevent.list-popular-events"}',
       'order' => 13,
    ));
  }

  if (Engine_Api::_()->hasModuleBootstrap('sitereview')) {
     $db->insert('engine4_core_content', array(
       'type' => 'widget',
       'name' => 'sitereview.list-featured-listing',
       'page_id' => $page_id,
       'parent_content_id' => $top_middle_id,
       'params' => '{"title":"Popular articles","titleCount":true,"showOptions":["category","rating","review","wishlist"],"description":"Articles are the frequent, chronological publication of personal thoughts , News and Web links.","listingtype_id":"18","ratingType":"rating_avg","fea_spo":"fea_spo","category_id":"0","hidden_category_id":"0","hidden_subcategory_id":"0","hidden_subsubcategory_id":"0","detactLocation":"0","defaultLocationDistance":"1000","blockHeight":"440","blockWidth":"350","itemCount":"3","popularity":"creation_date","featuredIcon":"1","sponsoredIcon":"1","newIcon":"1","truncation":"50","desc_truncation":"250","showMorelink":"0","nomobile":"0","name":"sitereview.list-featured-listing"}',
       'order' => 14,
    ));
  }

  $db->insert('engine4_core_content', array(
     'type' => 'widget',
     'name' => 'sitecoretheme.app-promotion',
     'page_id' => $page_id,
     'parent_content_id' => $top_middle_id,
     'params' => '{"title":"", "nomobile":"0"}',
     'order' => 15,
  ));


  if (Engine_Api::_()->hasModuleBootstrap('sitemember')) {
     $db->insert('engine4_core_content', array(
       'type' => 'widget',
       'name' => 'sitemember.list-featured',
       'page_id' => $page_id,
       'parent_content_id' => $top_middle_id,
       'params' => '{"title":"Popular Members","titleCount":true,"description":"Members are the heart of any community. Members of a network makes a community more stronger.","fea_spo":"featured","itemCount":"4","nomobile":"0","name":"sitemember.list-featured"}',
       'order' => 16,
    ));
  }
} 
$member_home_page_id = $this->getWidgetizedPageId(array('name' => 'user_index_home'));
$tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
$tableNameContentName = $tableNameContent->info('name');
$top_content_id = $tableNameContent->select()
->from($tableNameContentName, 'content_id')
->where('page_id =?', $member_home_page_id)
->where('name =?', 'top')
->query()
->fetchColumn();
if (empty($top_content_id)) {
   $db->insert('engine4_core_content', array(
     'type' => 'container',
     'name' => 'top',
     'page_id' => $member_home_page_id,
     'parent_content_id' => null,
     'order' => 1,
     'params' => ''
  ));
   $content_id = $db->lastInsertId('engine4_core_content');
   $middle_content_id = $tableNameContent->select()
   ->from($tableNameContentName, 'content_id')
   ->where('page_id =?', $member_home_page_id)
   ->where('parent_content_id =?', $content_id)
   ->where('name =?', 'middle')
   ->query()
   ->fetchColumn();

   if (empty($middle_content_id)) {
     $db->insert('engine4_core_content', array(
       'type' => 'container',
       'name' => 'middle',
       'page_id' => $member_home_page_id,
       'parent_content_id' => $content_id,
       'order' => 2,
       'params' => ''
    ));

     $content_id = $db->lastInsertId('engine4_core_content');

     $middle_banner_id = $tableNameContent->select()
     ->from($tableNameContentName, 'content_id')
     ->where('page_id =?', $member_home_page_id)
     ->where('parent_content_id =?', $content_id)
     ->where('name =?', 'sitecoretheme.banner-images')
     ->query()
     ->fetchColumn();
     if (!$middle_banner_id) {
       $db->insert('engine4_core_content', array(
         'type' => 'widget',
         'name' => 'sitecoretheme.banner-images',
         'page_id' => $member_home_page_id,
         'parent_content_id' => $content_id,
         'order' => 1,
         'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"300","speed":"5000","order":"2","verticalHtmlTitle":"Find Your Love","verticalHtmlDescription":"","title":"","nomobile":"0","name":"sitecoretheme.banner-images"}'
      ));
    }
 }
 $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1 ;");
} else {
   $middle_content_id = $tableNameContent->select()
   ->from($tableNameContentName, 'content_id')
   ->where('page_id =?', $member_home_page_id)
   ->where('parent_content_id =?', $top_content_id)
   ->where('name =?', 'middle')
   ->query()
   ->fetchColumn();

   if (!empty($middle_content_id)) {

     $middle_banner_id = $tableNameContent->select()
     ->from($tableNameContentName, 'content_id')
     ->where('page_id =?', $member_home_page_id)
     ->where('parent_content_id =?', $middle_content_id)
     ->where('name =?', 'sitecoretheme.banner-images')
     ->query()
     ->fetchColumn();

     if (!$middle_banner_id) {
       $db->insert('engine4_core_content', array(
         'type' => 'widget',
         'name' => 'sitecoretheme.banner-images',
         'page_id' => $member_home_page_id,
         'parent_content_id' => $middle_content_id,
         'order' => 1,
         'params' => '{"showBanners":"1","selectedBanners":"","width":"","height":"300","speed":"5000","order":"2","verticalHtmlTitle":"Find Your Love","verticalHtmlDescription":"","title":"","nomobile":"0","name":"sitecoretheme.banner-images"}'
      ));
    }
    $db->query("UPDATE `engine4_core_content` SET  `order` =  '2' WHERE  `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'main' LIMIT 1;");

    if (Engine_Api::_()->hasModuleBootstrap('spectacular')) {
       $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'spectacular.banner-images' LIMIT 1;");
    }

    if (Engine_Api::_()->hasModuleBootstrap('captivate')) {
       $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`page_id` = $member_home_page_id AND `engine4_core_content`.`name` = 'captivate.banner-images' LIMIT 1;");
    }
 }
}
}

  public function updateThemeName() {

    $db = Engine_Db_Table::getDefaultAdapter();
    $db->query("UPDATE `engine4_core_modules` SET  `label` =  'Responsive Dating Theme' WHERE `engine4_core_modules`.`name` = 'sitecoretheme';");
    $db->query("UPDATE `engine4_core_menuitems` SET `title` =  'SEAO - Responsive Dating Theme' WHERE `engine4_core_menuitems`.`name` = 'sitecoretheme_admin_settings';");
    $db->query("UPDATE `engine4_core_menuitems` SET `title` =  'Responsive Dating Theme' WHERE `engine4_core_menuitems`.`name` = 'sitecoretheme_admin_main_theme';");
    $db->query("UPDATE `engine4_core_menus` SET  `title` =  'Responsive Dating Theme' WHERE `engine4_core_menus`.`name` = 'sitecoretheme_footer';");
    $db->query("UPDATE `engine4_core_themes` SET  `title` =  'Responsive Dating Theme' WHERE `engine4_core_themes`.`name` = 'sitecoretheme';");
  }
}
