<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_Form_Admin_Global extends Engine_Form {

    public function init() {

        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this
                ->setTitle('Global Settings')
                ->setDescription('These settings affect all members in your community.');

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        if (!$coreSettings->siteemailverification_auto_verified) {
          $countExistingUser = Engine_Api::_()->siteemailverification()->countExistingUser();
          //VALUE FOR CAPTCHA
            $this->addElement('Radio', 'siteemailverification_existing_users', array(
                'label' => 'Email Verification for Existing Users',
                'description' => 'Do you want to enable email verification for the existing users? In case you enable this setting, the existing ('. $countExistingUser.') users will need to verify their email addresses again.',
                'multiOptions' => array(
                  1 => 'Yes',
                  0 => 'No',
                ),
                'value' => $coreSettings->getSetting('siteemailverification.existing.users', 0),
                'onchange' => 'showexistingverification(this.value);'
            ));

            //VALUE FOR CAPTCHA
            $this->addElement('Text', 'siteemailverification_suspended_duration', array(
                'label' => 'Email Verification Time Period (Existing Users)',
                'description' => 'Enter the time duration within which all the existing users need to verify their email addresses otherwise their accounts will be suspended.',
                'value' => $coreSettings->getSetting('siteemailverification.suspended.duration', 30),
            ));
        }

        //COLOR VALUE FOR Tip Text
        $this->addElement('Text', 'siteemailverification_tip_text_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowText.tpl',
                        'class' => 'form element'
                    )))
        ));

        //COLOR VALUE FOR Tip Backgroung
        $this->addElement('Text', 'siteemailverification_tip_background_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowBackground.tpl',
                        'class' => 'form element'
                    )))
        ));

        //COLOR VALUE FOR Tip Backgroung
        $this->addElement('Text', 'siteemailverification_tip_button_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowButton.tpl',
                        'class' => 'form element'
                    )))
        ));

        //COLOR VALUE FOR Tip Backgroung
        $this->addElement('Text', 'siteemailverification_tip_button_text_color', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowButtonText.tpl',
                        'class' => 'form element'
                    )))
        ));
        
        //VALUE FOR CAPTCHA
        $this->addElement('Textarea', 'siteemailverification_tip_verification_text', array(
            'label' => 'Text for Email Verification Tip',
            'description' => 'Enter the text for email verification tip.',
            'value' => $coreSettings->getSetting('siteemailverification.tip.verification.text', "Please verify your email address by clicking on the button in order to enjoy uninterrupted continuation with us."),
        ));

        //VALUE FOR CAPTCHA
        $this->addElement('Textarea', 'siteemailverification_tip_resend_text', array(
            'label' => 'Text for Resend Email Verification Tip',
            'description' => 'Enter the text for resend email verification tip. [Note: You can edit the text below except the “resend_link”]',
            'value' => $coreSettings->getSetting('siteemailverification.tip.resend.text', "Please [resend_link:click here] if you haven't got verification email."),
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}

?>
