<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Level.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_Form_Admin_Level extends Authorization_Form_Admin_Level_Abstract
{
  public function init()
  {
    parent::init();

    // My stuff
    $this
      ->setTitle('Member Level Settings')
      ->setDescription("These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.");
    $this->level_id->removeMultiOption(1);

    if( !$this->isPublic() ) {
      // Element: allow_verify
      $this->addElement('Radio', 'allow_verify', array(
        'label' => 'Verify New Signups',
        'description' => 'Do you want to enable email verification for the new signups?',
        'multiOptions' => array(
          1 => 'Yes, allow email verification',
          0 => 'No, do not allow email verification',
        ),
        'value' => ( $this->isModerator() ? 0 : 1 ),
        'onchange' => 'showverificationsettings(this.value);'
      ));

      $this->addElement('Text', 'suspended_time', array(
        'label' => 'Email Verification Time Period (New Signups)',
        'description' => 'Enter the time duration within which all the new signup users need to verify their email addresses otherwise their accounts will be suspended.',
        'value' => 30,
      ));

      $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Enter the duration after which you want to show the tip again in case user has closed it.<br/>[Note: This setting will be same for both new sign ups and existing users.]"));

      // Element: duration
      $this->addElement('Text', 'duration', array(
        'label' => 'Duration for Cookie',
        'description' => $description,
        'value' => 2,
      ));
      
      $this->duration->getDecorator('Description')->setOption('escape', false);

      $descriptionofsuspending = sprintf(Zend_Registry::get('Zend_Translate')->_("Enter the duration for sending a reminder email after user signup, to get the email addresses verified otherwise their accounts will get suspended.<br/>[Note: This setting will be same for both new sign ups and existing users.]"));
      // Element: suspended duration
      $this->addElement('Text', 'suspending_time', array(
        'label' => 'Duration for Reminder Email',
        'description' => $descriptionofsuspending,
        'value' => 4,
      ));
      $this->suspending_time->getDecorator('Description')->setOption('escape', false);
    } else {
      $description = "<div class='tip'><span>" . Zend_Registry::get('Zend_Translate')->_("Users in this member level are non-members/visitors, so they do not need email verification.") . "</span></div>";
      $this->addElement('Dummy', 'public', array(
        'description' => $description,
      ));
      $this->public->addDecorator('Description', array('placement' =>
        Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));
    }
  }
}