<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Suspended.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_Plugin_Task_Suspended extends Core_Plugin_Task_Abstract
{
  public function execute()
  {
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $rusersName = $userTable->info('name');
    $emailuserTable = Engine_Api::_()->getDbtable('users', 'siteemailverification');
    $remailusersName = $emailuserTable->info('name');

    // Get the users whos are not verified
    $usertable_result = $userTable->select()
    ->setIntegrityCheck(false)
      ->from($userTable, array('user_id', 'level_id', 'email', 'creation_date'))
      ->join($remailusersName, "$remailusersName.user_id = $rusersName.user_id AND $remailusersName.verified_email = 0")
      ->where($rusersName.'.enabled = ?', 1);

    $allow_verify_existuser = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_existing_users;
    if ( empty( $allow_verify_existuser )) {
      $coreSetting = Engine_Api::_()->getApi('settings', 'core');
      $last_user = $coreSetting->getSetting('siteemailverification.last.user');
      $userTable->where( 'user_id > ?', $last_user );
    }
    
    $value = $usertable_result->query()->fetchAll();
    if (!$value) {
      return;
    } else {
      $data = array();

      // Get the plugin installation time 
      $pluiginCreation = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_creation_time;
      foreach ($value as $id => $users) {
        // send mail to only new users for suspending
        $suspendedDuration = Engine_Api::_()->authorization()->getPermission($users['level_id'], 'mailverification', 'suspending_time');
        $allow_verify = Engine_Api::_()->authorization()->getPermission($users['level_id'], 'mailverification', 'allow_verify');
        $allow_verify_existuser = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_existing_users;

        $duration = $suspendedDuration*86400;
        // check for new signups
        if ($users['creation_date'] > $pluiginCreation) {
          // check setting is enable for new signups
          if ($allow_verify) {
            $suspendDuration = Engine_Api::_()->authorization()->getPermission($users['level_id'], 'mailverification', 'suspended_time');
            $time = $users['creation_date'];
          }
        } else {
          // check setting is enabled for existing users
          if ($allow_verify_existuser) {
            $suspendDuration = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_suspended_duration;
            
            $time = $pluiginCreation;
          }
        }

        $lastDate = strtotime($time) + ($suspendDuration * 86400);
        $time = strtotime($time)+$duration;
        $dateToCheck = date('Y-m-d H:i:s', $lastDate);
        $dateToday = date('Y-m-d H:i:s', time());
            
        if (date('Y-m-d H:i:s', $time) <= $dateToday  && $dateToCheck > $dateToday) {
          if ($allow_verify || $allow_verify_existuser) {
            $verifyTable = Engine_Api::_()->getDbtable('verifications', 'siteemailverification');

            $verification_code = $verifyTable->createCode($users['user_id']);
            $date1 = date_create($dateToCheck);
            $date2 = date_create($dateToday);
            $diff = date_diff($date1, $date2);
            
            $data['remaining_time'] = $diff->days;
            $data['code'] = $verification_code;
            $data['user_id'] = $users['user_id'];
            $data['email'] = $users['email'];
            Engine_Api::_()->siteemailverification()->suspendedUsersEmail($data);
          }
        }
      } 
    }
  }
}
