<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLevelController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_AdminLevelController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    // Get Navigation
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteemailverification_admin_main', array(), 'siteemailverification_admin_main_level');

    // Get level id
    if( null !== ($id = $this->_getParam('id')) ) {
      $level = Engine_Api::_()->getItem('authorization_level', $id);
    } else {
      $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
    }

    if( !$level instanceof Authorization_Model_Level ) {
      throw new Engine_Exception('missing level');
    }
    
    $this->view->emailVerify = Engine_Api::_()->getApi('settings', 'core')->user_signup_verifyemail;

    // Get the value of allow verify email or not
    $id = $level->level_id;
    

    // Make form
    $this->view->form = $form = new Siteemailverification_Form_Admin_Level(array(
      'public' => ( in_array($level->type, array('public')) ),
      'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
    ));
    $form->level_id->setValue($id);

    // Populate values
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
    $form->populate($permissionsTable->getAllowed('mailverification', $id, array_keys($form->getValues())));

    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

      // Process
      $values = $form->getValues();

      // Form elements with NonBoolean values
      $nonBooleanSettings = $form->nonBooleanFields();

      $db = $permissionsTable->getAdapter();
      $db->beginTransaction();

      try
      {
        // Set permissions
        $permissionsTable->setAllowed('mailverification', $id, $values, '', $nonBooleanSettings);

        // Commit
        $db->commit();
      }

      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }
      $form->addNotice('Your changes have been saved.');
    }
    $this->view->allow_verify = Engine_Api::_()->authorization()->getPermission($id, 'mailverification', 'allow_verify');
  }

}