<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_AdminManageController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteemailverification_admin_main', array(), 'siteemailverification_admin_main_manage');

    // Get the params
    $order = $this->_getParam('order');
    $id = $this->_getParam('id');

    // Make Form
    $this->view->formFilter = $formFilter = new Siteemailverification_Form_Admin_Manage_Filter();
    $this->view->emailVerify = Engine_Api::_()->getApi('settings', 'core')->user_signup_verifyemail;

    //Get last user id
    $last_user = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_last_user;

    //Get setting for existing user
    $verify_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteemailverification.existing.users', 0);
    $auto_verify = Engine_Api::_()->getApi('settings', 'core')->siteemailverification_auto_verified;
    
    $page = $this->_getParam('page', 1);

    $table = Engine_Api::_()->getDbtable('users', 'user');
    $tableName = $table->info('name');
    $emailtable = Engine_Api::_()->getDbtable('users', 'siteemailverification');
    $emailtableName = $emailtable->info('name');

    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($table)
            ->join($emailtableName, "$emailtableName.user_id = $tableName.user_id", array('verified_email'));
    // $select = $table->select();

    // Process form
    $values = array();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    }
    foreach( $values as $key => $value ) {
      if( null === $value ) {
        unset($values[$key]);
      }
    }
    if (!isset($values['verified'])) {
      $values['verified'] = 0;
    }

    if (!$verify_allow && !$auto_verify) {
      $select->where("$tableName.user_id > ?", $last_user);
    }
    // Set up select info
    $select->order(( !empty($id) ? $id : 'user_id' ) . ' ' . ( !empty($order) ? $order : 'DESC' ));

    if( !empty($values['username']) ) {
      $select->where($tableName.'.displayname LIKE ?', '%' . $values['username'] . '%');
    }
    if( isset($values['verified']) && $values['verified'] != -1 ) {
      $select->where($emailtableName.'.verified_email = ?', $values['verified'] );
    }
    if( isset($values['enabled']) && $values['enabled'] != -1 ) {
      $select->where($tableName.'.enabled = ?', $values['enabled'] );
    }
    if( isset($values['suspended']) && $values['suspended'] != -1 ) {
      $select->where($tableName.'.enabled = ?', $values['suspended'] );
    }
    // Filter out junk
    $valuesCopy = array_filter($values);

    // Reset verified bit
    if( isset($values['verified']) && $values['verified'] == 0 ) {
      $valuesCopy['verified'] = 0;
    }

    // Reset enabled bit
    if( isset($values['enabled']) && $values['enabled'] == 0 ) {
      $valuesCopy['enabled'] = 0;
    }
    // Reset enabled bit
    if( isset($values['suspended']) && $values['suspended'] == 0 ) {
      $valuesCopy['suspended'] = 0;
    }

    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
    $this->view->formValues = $valuesCopy;
    $this->view->order = $order;
  }

  public function resendEmailAction() 
  {
    $user_id = $this->_getParam('id');
    $response = array(
      'status' => false,
      'message' =>'',
    );
    $user = Engine_Api::_()->getItem('user', $user_id);

    // Check user is exists or not
    if( !$user || !$user->getIdentity() ) {
      return $this->_helper->redirector->gotoRoute(array(), 'default', true);
    }

    if ($user) {
      // Generate the code for verification
      $verifyTable = Engine_Api::_()->getDbtable('verifications', 'siteemailverification');

      $verification_code = $verifyTable->createCode($user->getIdentity(), true);

      $params = array('email'=> $user->email, 'code' => $verification_code, 'user_id' => $user->getIdentity());
      Engine_Api::_()->siteemailverification()->emailVerification($params);
      $response['status'] = true;
      $response['message'] = $this->view->translate('Email Sent Successfully!!!.');
    }
  
    return $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => true,
      'parentRefresh' => true,
      'format'=> 'smoothbox',
      'messages' => array($response['message'])
    ));
  }

  public function deleteselectedAction()
  {
    $this->view->ids = $ids = $this->_getParam('ids');
    $count = explode(",", $ids);
    $this->view->count = count($count);
    if( $this->getRequest()->isPost() ) {
      $ids_array = explode(",", $ids);
      foreach( $ids_array as $id ) {
        $user = Engine_Api::_()->getItem('user', $id);
        $verifyTable = Engine_Api::_()->getDbtable('verifications', 'siteemailverification');
        $select = $verifyTable->select()
                ->where('user_id = ?', $id);
        $verifyData = $verifyTable->fetchRow($select);
        $verified = Engine_Api::_()->getItem('siteemailverification_verification', $verifyData->verify_id);

        $db = Engine_Api::_()->getDbtable('verifications', 'siteemailverification')->getAdapter();
        $db1 = Engine_Api::_()->getDbtable('users', 'user')->getAdapter(); 
        $db1->beginTransaction();

        try {
          $db->beginTransaction();
          try {
            $verified->delete();
            $db->commit();
          } catch( Exception $e ) {
            $db->rollBack();
            throw $e;
          }
          $user->delete();
          $db1->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function approvedAction() 
  {
    $user_id = $this->_getParam('user_id', null);
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      // Verified the users directly by amdin
      $user = Engine_Api::_()->getItem('siteemailverification_user', $user_id);
      $user->verified_email = 1;
      $user->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/siteemailverification/manage');
  }
}