<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: INdexController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteemailverification_IndexController extends Core_Controller_Action_Standard
{
  public function emailVerificationAction() 
  {
    $email = $this->_getParam('email');
    $user_id = $this->_getParam('user_id');
    $response = array(
      'status' => false,
    );
    $user = Engine_Api::_()->getItem('user', $user_id);
    if( !$user || !$user->getIdentity() ) {
      return $this->_helper->redirector->gotoRoute(array(), 'default', true);
    }

    if ($user && $email) {

      $verifyTable = Engine_Api::_()->getDbtable('verifications', 'siteemailverification');

      $verification_code = $verifyTable->createCode($user->getIdentity(), true);
    //   $select = $verifyTable->select()
    //           ->where('user_id = ?', $user_id);
    //   $verifyData = $verifyTable->fetchRow($select);
    //   if ($verifyData && $verifyData->user_id) {
    //   	$verifyTable->update(array(
    //         'code' => $verification_code,
				//     'email_count' => ++$verifyData->email_count,
				//     'creation_date' => date('Y-m-d H:i:s'),
    //       ), array(
    //       'user_id = ?' => $user->getIdentity(),
    //     ));
    //   } else {
		  //   $verifyTable->insert(array(
		  //     'user_id' => $user->getIdentity(), 
		  //     'code' => $verification_code,
		  //     'email_count' => 1,
		  //     'creation_date' => date('Y-m-d H:i:s'),
		  //   ));
		  // }
      $params = array('email'=> $email, 'code' => $verification_code, 'user_id' => $user->getIdentity());
      Engine_Api::_()->siteemailverification()->emailVerification($params);
      $response['status'] = true;
    }
    return $this->_helper->json($response);
  }

  public function verifyEmailAction()
  {
    $verify = $this->_getParam('verify');
    $token = $this->_getParam('token');
    $settings = Engine_Api::_()->getApi('settings', 'core');

    // No code or token
    if( !$verify || !$token ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('The email or verification code was not valid.');
      return;
    }

    // Get verify user
    $userId = Engine_Api::_()->siteemailverification()->getUserIdFromToken($token);
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $user = $userTable->fetchRow($userTable->select()->where('user_id = ?', $userId));

    if( !$user || !$user->getIdentity() ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('The email does not match an existing user.');
      return;
    }
    $emailuserTable = Engine_Api::_()->getDbtable('users', 'siteemailverification');
    $emailuser = $emailuserTable->fetchRow($emailuserTable->select()->where('user_id = ?', $userId));
    // If the user is already verified, just redirect
    if( $emailuser->verified_email ) {
      $this->view->status = true;
      return;
    }

    // Get verify row
    $verifyTable = Engine_Api::_()->getDbtable('verifications', 'siteemailverification');
    $verifyRow = $verifyTable->fetchRow($verifyTable->select()->where('user_id = ?', $user->getIdentity()));

    if( !$verifyRow || $verifyRow->code != $verify ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('There is no verification info for that user.');
      return;
    }
    
    // Process
    $db = $verifyTable->getAdapter();
    $db->beginTransaction();

    try {

      //$verifyRow->delete();
      $emailuser->verified_email = 1;
      $emailuser->save();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
  }
}
