<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteemailverification
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Siteemailverification_Installer extends Engine_Package_Installer_Module
{
  public function onPreinstall() {
    parent::onPreinstall();
    $this->placeWidgets();
  }

  function onInstall() {
    parent::onInstall();

    $db = $this->getDb();
    //Get last user id after installation
    $select = new Zend_Db_Select($db);
    $select
        ->from('engine4_users')
        ->order('user_id DESC')
        ->limit(1);
    $user = $select->query()->fetch();
    $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
      ('siteemailverification.last.user', ".$user['user_id']. ");");

    $db->query("UPDATE `engine4_siteemailverification_users` INNER JOIN `engine4_users` ON `engine4_siteemailverification_users`.`user_id` =`engine4_users`.`user_id` AND `engine4_users`.`level_id` = 1 SET `verified_email` =  1;");
  }

  public function placeWidgets() {
    $db = $this->getDb();

    // PLACE SCHEMA MARKUP WIDGET
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_pages')
      ->where('name = ?', 'footer')
      ->limit(1);
    $info = $select->query()->fetch();

    if (empty($info)) 
      return false;

    $page_id = $info['page_id'];
    $select = new Zend_Db_Select($db);
    $select->from('engine4_core_content')
      ->where('name = ?', 'siteemailverification.verify-email')
      ->where('page_id = ?', $page_id)
      ->where('type = ?', 'widget')
      ->limit(1);
    $info = $select->query()->fetch();

    if (!empty($info)) 
      return false;

    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_content')
      ->where('name = ?', 'main')
      ->where('page_id = ?', $page_id)
      ->where('type = ?', 'container')
      ->limit(1);
    $info = $select->query()->fetch();

    if ($info) {
      $container_id = $info['content_id'];
      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'siteemailverification.verify-email',
        'page_id' => $page_id,
        'parent_content_id' => $container_id,
        'order' => 10,
      ));
    }
  }
}
?>
