<?php

class Siteerror_Api_Core extends Core_Api_Abstract
{

  public function setPhoto($photo, $isSmall = false)
  {

    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
      $fileName = $file;
    } else if( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
      $fileName = $photo['name'];
    } else if( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
      $fileName = $photo;
    } else {
      return;
    }

    if( !$file ) {
      return;
    }
    if( !$fileName ) {
      $fileName = basename($file);
    }

    $extension = ltrim(strrchr(basename($fileName), '.'), '.');
    $base = rtrim(substr(basename($fileName), 0, strrpos(basename($fileName), '.')), '.');
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    // Save
    $filesTable = Engine_Api::_()->getDbtable('files', 'storage');

    $size = $isSmall ? 500 : 500;
    // Resize image (main)
    $bigBannerPath = $path . DIRECTORY_SEPARATOR . $base . '_b-i.' . $extension;
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize($size, $size)
      ->write($bigBannerPath)
      ->destroy();

    // Store
    $bigBanner = $filesTable->createSystemFile($bigBannerPath);
    // Remove temp files
    @unlink($bigBannerPath);
    return $bigBanner->getIdentity();
  }

  public function getPhotoUrl($fileId)
  {
    if (empty($fileId)){
      return;
    }
    $file = Engine_Api::_()->getDbtable('files', 'storage')->getFile($fileId);
    return $file ? $file->getHref() : '';
  }

  public function getSocialUrl($name)
  {
    $menuItemsTable = Engine_Api::_()->getDbtable('menuItems', 'core');
    $menuItemsSelect = $menuItemsTable->select()
      ->where('name = ?', $name);
    if( !empty($this->_enabledModuleNames) ) {
      $menuItemsSelect->where('module IN(?)',  $this->_enabledModuleNames);
    }
    $menuItem = $menuItemsTable->fetchRow($menuItemsSelect);

    if( !$menuItem ) {
      return '';
    }
    // Make safe
    $menuItemData = $menuItem->toArray();
    if( isset($menuItemData['params']) && is_array($menuItemData['params']) ) {
      $menuItemData = array_merge($menuItemData, $menuItemData['params']);
    }
    return $menuItemData['uri'];
  }

}
