  <?php

class Siteerror_AdminMaintenanceModeController extends Core_Controller_Action_Admin
{

  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    ->getNavigation('siteerror_admin_main', array(), 'siteerror_admin_main_maintenancemode');

    $this->view->form = $form = new Siteerror_Form_Admin_MaintenanceMode();
    // If not post or form not valid, return
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    $values = $form->getValues();
    if( !empty($values['background_photo']) && empty($values['remove_photo']) ) {
      $values['background_photo'] = Engine_Api::_()->siteerror()->setPhoto($form->background_photo);
    }

    if( empty($values['background_photo']) ) {
      unset($values['background_photo']);
    }
    if( !empty($values['remove_photo']) ) {
      $values['background_photo'] = 0;
    }

    if( isset($values['remove_photo']) ) {
      unset($values['remove_photo']);
    }

    if( !empty($values['front_photo']) && empty($values['remove_front_photo']) ) {
      $values['front_photo'] = Engine_Api::_()->siteerror()->setPhoto($form->front_photo, true);
    }
    if( empty($values['front_photo']) ) {
      unset($values['front_photo']);
    }
    if( !empty($values['remove_front_photo']) ) {
      $values['front_photo'] = 0;
    }

    if( isset($values['remove_front_photo']) ) {
      unset($values['remove_front_photo']);
    }
    foreach( $values as $key => $value ) {
      $key = 'siteerror_maintenance_' . $key;
      if( Engine_Api::_()->getApi('settings', 'core')->hasSetting($key) ) {
        Engine_Api::_()->getApi('settings', 'core')->removeSetting($key);
      }
      if( !is_null($value) ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, '');
      }
    }
    $this->writeMaintenanceModeFile();
    $this->view->form = $form = new Siteerror_Form_Admin_MaintenanceMode();
    $form->addNotice('Your changes have been saved.');
  }

  private function writeMaintenanceModeFile()
  {
    $api = Engine_Api::_()->getApi('settings', 'core');
    $data['heading'] = $api->getSetting('siteerror.maintenance.heading', "Maintenance Mode");
    $data['subheading'] = $api->getsetting('siteerror.maintenance.subheading', "This site is under construction, may be you see it soon.");
    $data['body'] = $api->getsetting('siteerror.maintenance.body', "We apologize for the inconvenience, we're doing our best to get things back to working order for you.");
    $fileId = $api->getSetting('siteerror.maintenance.background.photo', 0);
    $data['overlay'] = $api->getsetting('siteerror.maintenance.overlay','siteerrorOverlayOff');
    $data['backgroundImageUrl'] = Engine_Api::_()->siteerror()->getPhotoUrl($fileId);
    $fileId = $api->getSetting('siteerror.maintenance.front.photo', 0);
    $data['fromImageUrl'] = Engine_Api::_()->siteerror()->getPhotoUrl($fileId);
    $fileId = $api->getSetting('siteerror.site.logo', 0);
    $data['siteLogoUrl'] = Engine_Api::_()->siteerror()->getPhotoUrl($fileId);
    $data['showSocialLinks'] = $api->getSetting('siteerror.maintenance.socialsites.enable', 1);
    $template = $api->getSetting('siteerror.maintenance.template', 'template1');
    $content = $this->view->partial('maintenance-mode/' . $template . '.tpl', 'siteerror', $data);
    $filename = APPLICATION_PATH_PUB . DS . 'siteerror-maintenance.html';
    file_put_contents($filename, $content);
    chmod($filename, 0777);
  }

}
