<?php

class Siteerror_AdminSettingsController extends Core_Controller_Action_Admin
{

  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    ->getNavigation('siteerror_admin_main', array(), 'siteerror_admin_main_settings');

    $this->view->form = $form = new Siteerror_Form_Admin_Global();
    // If not post or form not valid, return
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    $values = $form->getValues();
    if( !empty($values['site_logo']) && empty($values['remove_photo']) ) {
      $values['site_logo'] = Engine_Api::_()->siteerror()->setPhoto($form->site_logo);
    }

    if( empty($values['site_logo']) ) {
      unset($values['site_logo']);
    }
    if( !empty($values['remove_photo']) ) {
      $values['site_logo'] = 0;
    }

    if( isset($values['remove_photo']) ) {
      unset($values['remove_photo']);
    }

    foreach( $values as $key => $value ) {
      $key = 'siteerror_' . $key;
      if( Engine_Api::_()->getApi('settings', 'core')->hasSetting($key) ) {
        Engine_Api::_()->getApi('settings', 'core')->removeSetting($key);
      }
      if( !is_null($value) ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, '');
      }
    }
    $this->view->form = $form = new Siteerror_Form_Admin_Global();
    $form->addNotice('Your changes have been saved.');
    if(Engine_Api::_()->getApi('settings', 'core')->getSetting('siteerror.maintenance.enable')) {
      $form->addNotice('Note: If you are doing any changes in Global Settings, then you need to click on "Save Settings" under Maintenance Mode Page tab for those changes to reflect on your custom Maintenance Mode Page.');
    }
  }

  public function manageContentPagesAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteerror_admin_main', array(), 'siteerror_admin_main_managepages');
    $pageTable = Engine_Api::_()->getDbtable('pages', 'core');
    $pageSelect = $pageTable->select()->where('name LIKE ?', 'siteerror_%');
    $this->view->layoutPages = $pages = $pageTable->fetchAll($pageSelect);
  }
  public function faqAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteerror_admin_main', array(), 'siteerror_admin_main_faq');
    $this->view->action = 'faq';
    $this->view->faq_type = $this->_getParam('faq_type', 'general');
  }
}