<?php

class Siteerror_IndexController extends Core_Controller_Action_Standard
{

  public function indexAction()
  {
    
  }

  public function searchAction()
  {

    //GET SEARCHABLE TEXT FROM GLOBAL SEARCH BOX
    $text = $this->_getParam('text', null);
    $pos = strpos($text, '#');
    if( !empty($text) ) {
      $values = array();
      $values['text'] = $text;
      $values['pagination'] = '';
      $values['resource_type'] = '';
      $values['limit'] = $this->_getParam('limit');

      $items = $this->getCoreSearchData($values);
    }
    $data = array();
    $dataSearchable = array();
    $i = 0;


    if( !empty($text) ) {
      foreach( $items as $item ) {
        $type = $item->type;
        if( !Engine_Api::_()->hasItemType($type) ) {
          continue;
        }
        $item = $this->view->item($type, $item->id);
        if( empty($item) ) {
          continue;
        }
        if( $item->getPhotoUrl() != '' ) {
          $content_photo = $this->view->itemPhoto($item, 'thumb.icon');
        } else {
          $content_photo = "<img src='" . $this->view->layout()->staticBaseUrl . "application/modules/Siteerror/externals/images/nophoto_icon.png' alt='' />";
        }

        $i++;

        $resourceTitle = $item->getShortType();
        if( $type == 'user' ) {
          $resourceTitle = 'member';
        }
        $iType = $this->view->translate(ucfirst($resourceTitle));
        if( is_array($iType) && isset($iType[0]) ) {
          $iType = $iType[0];
        }
        $dataSearchable[] = array(
          'label' => $item->getTitle(),
          'type' => $iType,
          'photo' => $content_photo,
          'item_url' => $item->getHref(),
          'count' => $i
        );
      }
      $data = $dataSearchable;
      if( empty($dataSearchable) ) {
        $data[] = array(
          'label' => sprintf($this->view->translate('No result found for "%s".'), $text),
          'type' => 'no_resuld_found',
          'item_url' => '',
          'search_text' => $text,
        );
      } else {
        $data[] = array(
          'label' => sprintf($this->view->translate('See more for "%s".'), $text),
          'type' => 'view_more',
          'item_url' => $this->view->url(array('controller' => 'search'), 'default', true) . '?query='.$text,
          'search_text' => $text,
        );
      }
    }
    return $this->_helper->json($data);
  }

  public function getCoreSearchData($params = array())
  {

    $items = array();
    $text = trim($params['text']);
    if( empty($text) ) {
      return $items;
    }
    $SearchTable = Engine_Api::_()->getDbtable('search', 'core');
    $searchTableName = $SearchTable->info('name');
    $select = $SearchTable->select()
      ->setIntegrityCheck(false)
      ->from($SearchTable->info('name'), array('type', 'id', 'description', 'keywords'));
    $select->where("(`title` LIKE  ? OR `description` LIKE  ? OR `keywords` LIKE  ? OR `hidden` LIKE  ?)", "%$text%");
    $select->group('id');

    $select = $select->limit($params['limit']);
    return $items = $SearchTable->fetchAll($select);
  }

}