<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Cache.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Form_Admin_Cache extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Cache Management');

    // disable form if not in production mode
    $attribs = array();
    if (APPLICATION_ENV != 'production') {
      $attribs = array('disabled' => 'disabled', 'readonly' => 'readonly');
      $this->addError('Note: Caching is disabled when your site is in development mode. Your site must be in production mode to modify the settings below.');
    }


    $this->addElement('Radio', 'se_siteestore_cache', array(
        'label' => 'Enable Cache',
        'description' => 'Do you want to enable caching? (Enabling caching will increase the CPU usage of your database server (resulting in an increase of page load times.)',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'attribs' => $attribs,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('se.siteestore.cache', 1),
    ));


    $this->addElement('MultiCheckbox', 'clear_catch', array(
        'label' => 'Flush cache',
        'multiOptions' => array(1 => 'Flush cache storage of this Store.'),
        'attribs' => $attribs
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true,
        'attribs' => $attribs,
    ));
  }

}

?>
