<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Faqcreate.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Form_Admin_Faqcreate extends Engine_Form {

  public function init() {

    // Conditions: When click on 'edit' from the faq-manage-page for showing prefields for selected ID.
    $faqId = Zend_Controller_Front::getInstance()->getRequest()->getParam('faq_id', null);
    $questionValue = '';
    $answerValue = '';
    $faq_default = 0;
    $faq_type = 0;
    if (!empty($faqId)) {
      $faqObj = Engine_Api::_()->getItem('siteestore_faq', $faqId);
      $questionValue = $faqObj->question;
      $answerValue = $faqObj->answer;
      $faq_default = $faqObj->faq_default;
      $faq_type = $faqObj->type;
    }

    $this->setTitle('Genral FAQ')
            ->setDescription('Create an genral faq for "Help & Learn More" page.');

    if (empty($faq_default)) {
      $this->addElement('Textarea', 'faq_question', array(
          'label' => 'Enter Question',
          'description' => "Please enter the 'Question' ?",
          'required' => true,
          'value' => $questionValue
      ));

      $this->addElement('Textarea', 'faq_answer', array(
          'label' => 'Enter Answer',
          'description' => "Please enter the 'Answer' for the 'Question' ?",
          'required' => true,
          'value' => $answerValue
      ));

      $this->addElement('Button', 'submit', array(
          'label' => 'Post FAQ',
          'type' => 'submit',
          'ignore' => true
      ));
    } else {
      $language_variable = '_siteestore_help_generalfaq_';
      $faq_qus = $language_variable . $faq_default;
      $faq_ans = $faq_default + 1;
      $message = 'For QUS: ' . $faq_qus . ' and for ANS: ' . $language_variable . $faq_ans;
      $this->addElement('Dummy', 'dummy_msg', array(
          'label' => $message
      ));
    }
  }

}

?>