<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Plugin_Menus {

  public function isValidUser() {
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if (!empty($viewer_id)) {
      return true;
    }
    return false;
  }
  
  public function isStoreView() {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    
    if( !empty($viewer_id) && ($viewer->level_id != 1) ) {
      $status = Engine_Api::_()->getDbTable('users', 'siteestore')->getUser(array('se_user_id' => $viewer_id));
      if( !empty($status) && empty($status[0]['enable']) ) {
        return false;
      }
    }
    return true;
  }

  public function onMenuInitialize_SiteestoreIndexMain($row) {
    $isApiConnValid = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    return $isApiConnValid;
  }

  public function onMenuInitialize_MagentoCheckout($row) {
    $isApiConnValid = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    return $isApiConnValid;
  }

  public function onMenuInitialize_SiteestoreGutterShare($row) {
    $viewer = Engine_Api::_()->user()->getViewer();

    if ((!$viewer->getIdentity())) {
      return false;
    }

    $subject = Engine_Api::_()->core()->getSubject();

    if (!($subject instanceof Siteestore_Model_Product)) {
      return false;
    }

    // Modify params
    $params = $row->params;
    $params['params']['type'] = $subject->getType();
    $params['params']['id'] = $subject->getIdentity();
    $params['params']['format'] = 'smoothbox';
    return $params;
  }
  
  public function onMenuInitialize_SiteestoreMainWishlist($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $params = $row->params;
    if( empty($viewer_id) ) {
      return array(
          'route' => 'user_login'
      );
    }
    return $params;
  }

  Public function onMenuInitialize_SiteestoreGutterSugestFriend($row) {
    $isSuggestion = Engine_Api::_()->getDbTable('modules', 'core')->isModuleEnabled('suggestion');
    if (empty($isSuggestion)) {
      return;
    }

    $isPopupEnabled = Engine_Api::_()->suggestion()->getModSettings('siteestore', 'enabled');
    if( empty($isPopupEnabled) ) {
      return;
    }
    
    $sugg_check = Engine_Api::_()->suggestion()->getModSettings('siteestore', 'link');
    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if (!empty($sugg_check) && !empty($user_id)) {
      $viewer = Engine_Api::_()->user()->getViewer();
      $subject = Engine_Api::_()->core()->getSubject();

      $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('siteestore', $subject->getIdentity(), 1,null);

      if (!empty($modContentObj)) {
        $contentCreatePopup = @COUNT($modContentObj);
      }

      if (!empty($contentCreatePopup)) {
        return array(
            'label' => $row->label,
            'class' => 'buttonlink smoothbox icon_suggestion',
            'route' => 'default',
            'params' => array(
                'module' => 'suggestion',
                'controller' => 'index',
                'action' => 'switch-popup',
                'modName' => 'siteestore',
                'modContentId' => $subject->getIdentity(),
                'modError' => 1,
                'format' => 'smoothbox',
            ),
        );
      }
    }
  }
}
