<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminHelpsController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_AdminHelpsController extends Core_Controller_Action_Admin {

  public function helpAndLearnmoreAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_admin_manage_help');

    $page = $this->_getParam('page', 1);
    $sortingColumnName = $this->_getParam('idSorting', 0);
    $pagesettingsTable = Engine_Api::_()->getItemTable('siteestore_infopage');
    $pagesettingsSelect = $pagesettingsTable->select()->where('package != 1');
    $this->view->paginator = Zend_Paginator::factory($pagesettingsSelect);

    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator->setCurrentPageNumber($page);
    if ($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value) {
          $contentObject = Engine_Api::_()->getItem('siteestore_infopage', $value);
          if (!empty($contentObject->delete)) {
            $contentObject->delete();
          }
        }
      }
    }
  }

  // Function: When approved or disapproved page (Help & Learn more page).
  public function statusAction() {
    $status = $this->_getParam('status');
    $infoId = $this->_getParam('id');
    if (empty($status)) {
      $this->view->title = $this->view->translate("Disable Page?");
      $this->view->discription = $this->view->translate("Are you sure that you want to disable this 'Help & Learn More' page? After being disabled this will not be shown in 'Help & Learn More' options.");
      $this->view->bouttonLink = $this->view->translate("Disable");
    } else {
      $this->view->title = $this->view->translate("Enable Page?");
      $this->view->discription = $this->view->translate("Are you sure that you want to enable this 'Help & Learn More' page? After being enabled this will be shown in 'Help & Learn More' options.");
      $this->view->bouttonLink = $this->view->translate("Enable");
    }
    // Check post
    if ($this->getRequest()->isPost()) {
      $pagesettingsTable = Engine_Api::_()->getDbTable('infopages', 'siteestore');
      $pagesettingsTable->update(array('status' => $status), array('infopage_id =?' => $infoId));

      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('Successfully done.')
      ));
    }
  }

  public function helpPageCreateAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_admin_manage_help');

    $this->view->page_id = $page_id = $this->_getParam('page_id', 0);
    // Condition: For check if selected page is faq page then show the manage page for the faq page.
    if (!empty($page_id)) {
      $this->view->faqCheck = $faqCheck = Engine_Api::_()->getItem('siteestore_infopage', $page_id)->faq;
    } else {
      $this->view->faqCheck = $faqCheck = 0;
    }
    // Condition: Only page allow which are not faq.
    if (empty($faqCheck)) {

      $this->view->form = $form = Siteestore_Form_Admin_Helppagecreate();


      $textFlag = $this->_getParam('textFlag', 0);
      if (empty($textFlag)) {
        $form->removeElement('text_description');
        $textLinkFlag = $this->view->url(array('module' => 'siteestore', 'controller' => 'helps', 'action' => 'help-page-create', 'textFlag' => 1, 'page_id' => $page_id), 'admin_default', true);
        $textDescription = $this->view->translate("If your site supports multiple laguage then <a href='%s'> click here </a> for the compatible Text input box.", $textLinkFlag);
      } else {
        $form->removeElement('description');
        $textLinkFlag = $this->view->url(array('module' => 'siteestore', 'controller' => 'helps', 'action' => 'help-page-create', 'textFlag' => 0, 'page_id' => $page_id), 'admin_default', true);
        $textDescription = $this->view->translate("If your site supports only one laguage then <a href='%s'> click here </a> for the compatible Text input box.", $textLinkFlag);
      }

      $form->text_flag->setDescription($textDescription);

      $form->text_flag->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false));



      if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
        $values = $form->getValues();
        if (!empty($values['text_description'])) {
          $values['description'] = $values['text_description'];
          unset($values['text_description']);
        }
        $contentTable = Engine_Api::_()->getDbTable('infopages', 'siteestore');
        if (empty($values['is_opration'])) {
          $widgetDisplay = $contentTable->createRow();
          $widgetDisplay->title = $values['title'];
          $widgetDisplay->description = $values['description'];
          $widgetDisplay->status = 1;
          $widgetDisplay->delete = 1;
          $widgetDisplay->faq = 0;
          $widgetDisplay->save();
        } else {
          $contentTable->update(array('title' => $values['title'], 'description' => $values['description']), array('infopage_id =?' => $values['is_opration']));
        }
        $this->_helper->redirector->gotoRoute(array('module' => 'siteestore', 'controller' => 'helps', 'action' => 'help-and-learnmore'), 'admin_default', true);
      }
    } else { // Condition: Faq page come here.
      // Show the navigation bar.
      $page = $this->_getParam('page', 1); // Page id: Controll pagination.
      $this->view->page_title = Engine_Api::_()->getItem('siteestore_infopage', $page_id)->title;
      $socialengineTable = Engine_Api::_()->getItemTable('siteestore_faq');
      $socialengineSelect = $socialengineTable->select()
                      ->where('status =?', 1)->where('type =?', $faqCheck)->order('faq_id DESC');

      $this->view->paginator = Zend_Paginator::factory($socialengineSelect);

      $this->view->paginator->setItemCountPerPage(10);
      $this->view->paginator->setCurrentPageNumber($page);
      if ($this->getRequest()->isPost()) {
        $values = $this->getRequest()->getPost();
        foreach ($values as $key => $value) {
          if ($key == 'delete_' . $value) {
            Engine_Api::_()->getItem('siteestore_faq', $value)->delete();
          }
        }
      }
    }
  }

  public function helpPageDeleteAction() {
    $pagesetting_id = $this->_getParam('page_id');
    $this->view->pagesetting_id = $pagesetting_id;
    // Check post
    if ($this->getRequest()->isPost()) {
      $pagesettingTable = Engine_Api::_()->getItem('siteestore_infopage', $pagesetting_id);
      if (!empty($pagesettingTable)) {
        $pagesettingTable->delete();
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('Deleted Successsfully.')
      ));
    }
  }

  public function defaultHelpMsgAction() {
    $pagesetting_id = $this->_getParam('page_id');
    if (!empty($pagesetting_id)) {
      $this->view->item = $item = Engine_Api::_()->getItem('siteestore_infopage', $pagesetting_id);
    }
  }

  public function faqcreateAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_admin_manage_help');
    $this->view->page_id = $page_id = $this->_getParam('page_id');
    $faq_type = Engine_Api::_()->getItem('siteestore_infopage', $page_id)->faq;
    $faq_id = $this->_getParam('faq_id');
    $this->view->form = $form = new Siteestore_Form_Admin_Faqcreate();

    $user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $this->getRequest()->getPost();
      $siteestoreFaqTable = Engine_Api::_()->getItemTable('siteestore_faq');
      if (empty($faq_id)) {
        $siteestoreFaqInsert = $siteestoreFaqTable->createRow();
        $siteestoreFaqInsert->question = $values['faq_question'];
        $siteestoreFaqInsert->answer = $values['faq_answer'];
        $siteestoreFaqInsert->type = $faq_type;
        $siteestoreFaqInsert->poster_id = $user_id;
        $siteestoreFaqInsert->status = 1;
        $siteestoreFaqInsert->save();
      } else {
        $siteestoreFaqTable->update(array('question' => $values['faq_question'], 'answer' => $values['faq_answer']), array('faq_id =?' => $faq_id));
      }
      $this->_helper->redirector->gotoRoute(array('module' => 'siteestore', 'controller' => 'helps', 'action' => 'help-page-create', 'page_id' => $page_id), 'admin_default', true);
    }
  }

  public function faqDeleteAction() {
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('faq_id');
    $this->view->faq_id = $id;
    if ($this->getRequest()->getPost()) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        $featured = Engine_Api::_()->getItem('siteestore_faq', $id);
        $featured->delete();
        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => true,
          'parentRefresh' => true,
          'messages' => array('FAQ has been deleted')
      ));
    }
  }

  public function faqDefaultMsgAction() {
    $faq_id = $this->_getParam('faq_id');
    if (!empty($faq_id)) {
      $this->view->item = $item = Engine_Api::_()->getItem('siteestore_faq', $faq_id);
    }
  }

}