<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_AdminSettingsController extends Core_Controller_Action_Admin {

  public function indexAction() {    
    $onactive_disabled = array('siteestore_manifestUrl', 'siteestore_confkey', 'submit');
    $afteractive_disabled = array('environment_mode', 'submit_lsetting');
    $this->view->isModsSupport = Engine_Api::_()->siteestore()->isModulesSupport();

    include APPLICATION_PATH . '/application/modules/Siteestore/controllers/license/license1.php';
  }

  public function faqAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_admin_menu', array(), 'siteestore_settings_faq');
  }

  public function readmeAction() {
    
  }

  //ACTION FOR SPECIAL PRODUCT AUTO SUGGEST.
  public function getitemAction() {

    $text = $this->_getParam('text', null);
    $limit = $this->_getParam('limit', 40);

    $data = array();

    $table = Engine_Api::_()->getItemTable('siteestore_product');
    $name = $table->info('name');
    $select = $table->select()
            ->where($name . '.title  LIKE ? ', '%' . $text . '%')
            ->where($name . '.status = ?', '1');

    $select->limit(10);

    $productObj = $table->fetchAll($select);

    foreach ($productObj as $product) {

      $image = $this->view->itemPhoto($product, 'thumb.icon');
      $data[] = array(
          'id' => $product->product_id,
          'label' => $product->title,
          'photo' => $image
      );
    }

    return $this->_helper->json($data);
  }

}
