<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_IndexController extends Core_Controller_Action_Standard {

  public function addToCartAction() {
    $session = new Zend_Session_Namespace();
    $getArray = empty($session->cartProduct) ? array() : $session->cartProduct;
    $product_id = $this->_getParam('product_id');


    if (!in_array($product_id, $getArray)) {
      $getArray[$product_id] = $product_id;
      $session->cartProduct = $getArray;
    }
    $this->view->status = 1;
  }

  // Main action which calling from ajax for "My Store Account" tab.
  public function indexAction() {
    $baseUrl = $this->_getParam('baseUrl');
    $this->view->callingFromWidgets = $block = $this->_getParam('block');
    $postValues = @unserialize($this->_getParam('postValues'));
    $actionName = null;
    if( !empty($_GET['actionName']) ) {
      $actionName = $_GET['actionName'];
    }
    if( !empty($_GET['includeJs']) ) {
      $this->view->includeJs = $_GET['includeJs'];
    }
    $data['baseUrl'] = $baseUrl;
    $data['block'] = $block;
    $data['actionName'] = $actionName;
    $data['postValues'] = $postValues;

    if (isset($_POST['payment-checkout'])) {
      $data['payment-checkout'] = true;
    }

    $this->view->magentoBaseUrl = Engine_Api::_()->siteestore()->magentoBaseUrl();
    $this->view->hostType = Engine_Api::_()->siteestore()->getSEProtocol();
    $this->view->getMageProtocol = Engine_Api::_()->siteestore()->getMageProtocol();
    $this->view->getSEBaseUrl = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $this->view->data = $contentBlock = Engine_Api::_()->getApi('Curl', 'siteestore')->getCurlResponse($data);

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $session = new Zend_Session_Namespace();

    if (strstr($actionName, 'account') && !empty($viewer_id) && empty($session->isMagentoUserLogin)) {
      return $this->_forward('verify-password', 'index', 'siteestore');
    }

    // If key exist in returned array then we will redirect it to that location.
    if (is_array($contentBlock) && array_key_exists('location', $contentBlock) && !empty($contentBlock['location'])) {
      $this->view->location = $contentBlock['location'];
    }

    $this->_helper->layout->setLayout('default-simple');
  }

  // Call on "My Magento Account" link.
  public function accountAction() {

    if (!$this->_helper->requireUser()->isValid())
      return;
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_main', array(), 'siteestore_main_account');

    $getPageBlock = array('cart_sidebar' => 'cart_sidebar', 'catalog.compare.sidebar' => 'catalog.compare.sidebar', 'sale.reorder.sidebar' => 'sale.reorder.sidebar');
    $getBlockRequest = Engine_Api::_()->getApi('Curl', 'siteestore')->getCurlResponse(array('multiBlockResponce' => $getPageBlock));
    
    $mage_user_account = Zend_Registry::isRegistered('mage_user_account') ? Zend_Registry::get('mage_user_account') : null;
    if (empty($mage_user_account)) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    // Set Registry for widgets.
    $renderBlockArray = array();
    foreach ($getPageBlock as $blockName) {
      // Need to come from database.
      $blockValues = $getBlockRequest[$blockName];
      
      if(!empty($blockValues) && ($blockValues != $blockName)) {
        $renderBlockArray[] = $blockName;
        Zend_Registry::set($blockName, $blockValues);
      }
    }

    $this->view->renderBlockArray = $renderBlockArray;

    $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $this->view->baseUrl = $BaseUrl = Engine_Api::_()->siteestore()->getGlobalUrls();

    $protocol = Engine_Api::_()->siteestore()->getSEProtocol();
    $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
    $this->view->getSocialEngineBase = $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shopmanifestU');
    $this->view->socialEngineURL = $protocol . $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . DIRECTORY_SEPARATOR . $getMagentoFlag . DIRECTORY_SEPARATOR;

    // If there are form submit then send the post.
    $this->view->postValue = !empty($_POST) ? $_POST : array();

    $front = Zend_Controller_Front::getInstance();
    $this->view->requestUri = $curr_url = $front->getRequest()->getRequestUri();
    $curr_url = $curr_url . "/";

    $currl_url = str_replace($socilEngineBaseDir['path'] . "/" . $BaseUrl . "/account/", "", $curr_url);
    $catchName = $currl_url = rtrim($currl_url, "/");
    if (!empty($catchName)) {
      $this->view->catchName = $catchName;
    }


    $magentoMenusArray = array(
        array("id" => 1, "title" => "Account Dashboard", "url" => "customer/account", "headFlag" => "customer/account"),
        array("id" => 3, "title" => "Address Book", "url" => "customer/address", "headFlag" => "customer/address"),
        array("id" => 4, "title" => "My Orders", "url" => "sales/order/history/", "headFlag" => "order"),
        // array("id" => 5, "title" => "Billing Agreements", "url" => "sales/billing_agreement/", "headFlag" => "billing"),
        array("id" => 11, "title" => "Recurring Profiles", "url" => "sales/recurring_profile", "headFlag" => "recurring"),
        array("id" => 6, "title" => "My Product Reviews", "url" => "review/customer/", "headFlag" => "review"),
        array("id" => 7, "title" => "My Tags", "url" => "tag/customer/", "headFlag" => "tag"),
        array("id" => 8, "title" => "My Wishlist", "url" => "wishlist/", "headFlag" => "wishlist"),
        array("id" => 10, "title" => "Newsletter Subscriptions", "url" => "newsletter/manage/", "headFlag" => "newsletter"),
        array("id" => 9, "title" => "My Downloadable Products", "url" => "downloadable/customer/products/", "headFlag" => "downloadable")
    );

    $this->view->magentoMenusArray = $magentoMenusArray;
  }

  // Function which handle the layout pages.
  public function shoppingAction() {
    // Restrict the user, which are not permitted by siteadmin.
    $viewer = Engine_Api::_()->user()->getViewer();
    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $siteinfo = $view->layout()->siteinfo;
    $getViewerStatus = Engine_Api::_()->getDbtable('users', 'siteestore')->getUser(array('se_user_id' => $viewer->getIdentity()));
    $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id) && ($viewer->level_id != 1) && (!empty($getViewerStatus) && empty($getViewerStatus[0]['enable']))) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $requestURI = $_SERVER['REQUEST_URI'];
    Zend_Registry::set('is_registry_set', true);
    if (strstr($requestURI, 'checkout')) {
      $this->_forward('verify-password', 'index', 'siteestore');
      if (!$this->_helper->requireUser()->isValid())
        return;
      $this->_forward('cart', 'index', 'siteestore', array());
    } else {
      // Findout the "Browse Page Id" and "View Page Id".
      $seCatch = Zend_Registry::get('Zend_Cache');
      $pageTable = Engine_Api::_()->getDbtable('pages', 'core');
      $pageSelect = $pageTable->select()->where('name = ?', "siteestore_index_shopping");
      $pageViewSelect = $pageTable->select()->where('name = ?', "siteestore_index_view");
      $pageHomeSelect = $pageTable->select()->where('name = ?', "siteestore_index_home");
      $seSiteestoreCaching = Engine_Api::_()->getApi('settings', 'core')->getSetting('se.siteestore.cache', 1);
      $pageObject = $pageTable->fetchRow($pageSelect);
      $pageViewObject = $pageTable->fetchRow($pageViewSelect);
      $pageHomeObject = $pageTable->fetchRow($pageHomeSelect);
      $displayedPageId = $browsePageId = $pageObject->page_id;
      $viewPageId = $pageViewObject->page_id;
      $homePageId = $pageHomeObject->page_id;


      // Getting all magento widgets array, which placed on "Browse Page" and "View Page".
      $cacheBlockValues = $cacheBlockArray = $getPageBlock = array();
      $browsepageWidgets = Engine_Api::_()->siteestore()->getPageBlock($browsePageId);
      $viewpageWidgets = Engine_Api::_()->siteestore()->getPageBlock($viewPageId);
      $homepageWidgets = Engine_Api::_()->siteestore()->getPageBlock($homePageId);
      $mageStoreConnection = Engine_Api::_()->getApi('settings', 'core')->getSetting('mage.store.connection');
      $pagesAddedBlocks = array_merge((array) $browsepageWidgets, (array) $viewpageWidgets);
      $getPageBlock = array_merge((array) $homepageWidgets, (array) $pagesAddedBlocks);

      // Get cURL responced according to the widgets, which placed on "Browse Page" and "View Page".
      $getBlockRequest = Engine_Api::_()->getApi('Curl', 'siteestore')->getCurlResponse(array('multiBlockResponce' => $getPageBlock));
      if( !empty($getBlockRequest['included_files']) ) {
        if( !empty($getBlockRequest['included_files']['js']) ) {
          foreach( $getBlockRequest['included_files']['js'] as $jsFiles ) {
            $this->view->headScript()->appendFile($jsFiles);
          }
        }
        
        if( !empty($getBlockRequest['included_files']['css']) ) {
          foreach( $getBlockRequest['included_files']['css'] as $cssFiles ) {
            $this->view->headLink()->prependStylesheet($cssFiles);
          }
        }
      }

      if (in_array('content', $getPageBlock)) {
        $cache_product_id = 0;
        if( !empty($getBlockRequest['view_page_info']) && !empty($getBlockRequest['view_page_info']['product_id']) ) {
          $cache_product_id = $getBlockRequest['view_page_info']['product_id'];
        }
        
        // if( !empty($getBlockRequest['']) )
        $cacheBlockArray['content'] = Engine_Api::_()->getApi('Curl', 'siteestore')->getCacheName('content', $cache_product_id);
      }
      if (in_array('catalog.leftnav', $getPageBlock)) {
        $cacheBlockArray['catalog.leftnav'] = Engine_Api::_()->getApi('Curl', 'siteestore')->getCacheName('leftnav');
      }

      // If site in Production mode.
      if (($seCatch instanceof Zend_Cache_Core) && !empty($seSiteestoreCaching)) {
        foreach ($cacheBlockArray as $key => $name) {
          $cacheBlock = $seCatch->load($name);
          if (!empty($cacheBlock)) {
            unset($getPageBlock[$key]); // Dont send this block to cURL.
            $cacheBlockValues[$key] = @base64_decode($cacheBlock); // Store cache value at our side.
          }
        }
      }
      
      if (empty($getBlockRequest) || empty($mageStoreConnection)) {
        return $this->_forward('notfound', 'error', 'core');
      }

      // If there are no cURL request found then show the error page to the user.
      if (empty($getBlockRequest) || empty($mageStoreConnection)) {
        return $this->_forward('notfound', 'error', 'core');
      }


      if ( !empty($getBlockRequest['catch_page']) && ($getBlockRequest['catch_page'] == 'home') ) {
        $getSEProtocol = Engine_Api::_()->siteestore()->getSEProtocol();
        $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
        $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shop');
        $hostURL = $getSEProtocol . $socilEngineBaseDir['host'] . $socilEngineBaseDir['path'] . '/' . $getMagentoFlag . '/index/';
        if( !strstr($getBlockRequest['content'], $hostURL) ) {
          $getBlockRequest['content'] = str_replace('href="/', 'href="' . $hostURL, $getBlockRequest['content']);
        }
        
        $siteinfo['title'] = $siteinfo['title'] . ' - Products';
        $displayedPageId = $homePageId;
      }else{
        if( !empty($getBlockRequest['mageSiteinfo']) ) {
          foreach($getBlockRequest['mageSiteinfo'] as $mageSiteinfo) {
            $labelArray[] = $mageSiteinfo['label'];
          }
          
          $titleName = @end($labelArray);
          if( empty($getBlockRequest['view_page_info']) ) {
            $siteinfo['title'] = $siteinfo['title'] . ' - ' . $titleName;
          }else {
            $countPro = @COUNT($labelArray);
            unset($labelArray[$countPro - 1]);
            $getTitleCat = @implode(" - ", $labelArray);
            $siteinfo['title'] = !empty($getTitleCat)? $siteinfo['title'] . ' - ' . @implode(" - ", $labelArray): $siteinfo['title'];
          }
        }
 
        if( !empty($getBlockRequest['view_page_info']) ) {
          
          $siteinfo['description'] = $getBlockRequest['view_page_info']['short_description'];
          if( !empty($getBlockRequest['view_page_info']['categorys']) ) {
            $siteinfo['keywords'] = @implode(",", $getBlockRequest['view_page_info']['categorys']);
          }
        }
      }


      // If viewed pages is view page then insert the information in database accordingly.
      
      if (!empty($getBlockRequest['view_page_info'])) {
        $displayedPageId = $viewPageId;
        $magentoLinkTable = Engine_Api::_()->getDbTable('products', 'siteestore');
        Zend_Registry::set("siteestore_view_page", $getBlockRequest['view_page_info']['product_id']);
        $magentoLinkTable->setProducts($getBlockRequest['view_page_info']);

        $linkTableArray = Engine_Api::_()->getItem('siteestore_product', $getBlockRequest['view_page_info']['product_id']);

        Engine_Api::_()->core()->setSubject($linkTableArray);

        $incrementCount = $linkTableArray->view_counts + 1; // $linkTableArray[0]['view_counts'] + 1;
        $magentoLinkTable->update(array('view_counts' => $incrementCount), array('product_id =?' => $linkTableArray->product_id));
      }

      // Set variable if viewed page is category page.
      if (!empty($getBlockRequest['category_page'])) {
        Zend_Registry::set("category_page", true);
      }


      if (($seCatch instanceof Zend_Cache_Core) && !empty($seSiteestoreCaching)) {
        // Set the cache.
        if (array_key_exists('catch_page', $getBlockRequest) && !empty($getBlockRequest['catch_page'])) {
          foreach ($cacheBlockArray as $key => $name) {
            if (!empty($getBlockRequest[$key])) {
              $cacheValue = @base64_encode($getBlockRequest[$key]);
              $seCatch->save($cacheValue, $name);
            }
          }
        }

        // If caching are available then add this in main block array
        if (!empty($cacheBlockValues)) {
          $getBlockRequest = array_merge($getBlockRequest, $cacheBlockValues);
          $blockNameArray = array_keys($cacheBlockValues);
          $getPageBlock = array_merge($getPageBlock, $blockNameArray);
        }
      }

      // Set Registry for widgets.
      foreach ($getPageBlock as $blockName) {
        // Need to come from database.
        $blockValues = $getBlockRequest[$blockName];
        if( $blockName != $blockValues ) {
          Zend_Registry::set($blockName, $blockValues);
        }
      }

      $view->layout()->siteinfo = $siteinfo;
      $this->_helper->content
              ->setContentName($displayedPageId)
              ->setNoRender()
              ->setEnabled();
    }
  }

  public function cartAction() {
    // Restrict the user, which are not permitted by siteadmin.
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    Zend_Registry::set('is_registry_set', true);
    if (strstr($_SERVER['REQUEST_URI'], 'checkout/onepage')) {
      if (!$this->_helper->requireUser()->isValid())
        return;
    }

    $getViewerStatus = Engine_Api::_()->getDbtable('users', 'siteestore')->getUser(array('se_user_id' => $viewer->getIdentity()));
    $siteestoreApiPath = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore.api.path', '');
    if (!empty($viewer_id) && ($viewer->level_id != 1) && !empty($getViewerStatus) && empty($getViewerStatus[0]['enable'])) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    $pageTable = Engine_Api::_()->getDbtable('pages', 'core');
    $pageSelect = $pageTable->select()->where('name = ?', "siteestore_index_checkout");
    $pageViewSelect = $pageTable->select()->where('name = ?', "siteestore_index_view");
    $pageObject = $pageTable->fetchRow($pageSelect);
    $pageViewObject = $pageTable->fetchRow($pageViewSelect);
    $viewPageId = $pageViewObject->page_id;
    $checkoutPageId = $renderPageId = $pageObject->page_id;

    $checkoutPageBlock = Engine_Api::_()->siteestore()->getPageBlock($pageObject->page_id);
    $magRequestStr = Engine_Api::_()->getApi('settings', 'core')->getSetting('mage.request.path', '');
    $viewpageWidgets = Engine_Api::_()->siteestore()->getPageBlock($viewPageId);
    $getPageBlock = array_merge((array) $checkoutPageBlock, (array) $viewpageWidgets);
    $getRequestPath = $this->getRequestPath($siteestoreApiPath, $magRequestStr);

    $getBlockRequest = Engine_Api::_()->getApi('Curl', 'siteestore')->getCurlResponse(array('actionName' => 'cart', 'multiBlockResponce' => $getPageBlock));
    if (empty($getRequestPath)) {
      Engine_Api::_()->getApi('settings', 'core')->setSetting('siteestore.access.info', 0);
    }
    Zend_Registry::set("mage_request_path", $getRequestPath);

    $session = new Zend_Session_Namespace();
    if (!empty($viewer_id) && empty($session->isMagentoUserLogin)) {
      $this->_setParam("isCart", true);
      return $this->_forward('verify-password', 'index', 'siteestore');
    }

    // If there are no cURL request found then show the error page to the user.
    if (empty($getBlockRequest)) {
      return $this->_forward('notfound', 'error', 'core');
    }

    // If viewed pages is view page then insert the information in database accordingly.
    if (!empty($getBlockRequest['view_page_info'])) {
      $renderPageId = $viewPageId;
      $magentoLinkTable = Engine_Api::_()->getDbTable('products', 'siteestore');
      Zend_Registry::set("siteestore_view_page", $getBlockRequest['view_page_info']['product_id']);
      $magentoLinkTable->setProducts($getBlockRequest['view_page_info']);

      $linkTableArray = Engine_Api::_()->getItem('siteestore_product', $getBlockRequest['view_page_info']['product_id']);

      Engine_Api::_()->core()->setSubject($linkTableArray);

      $incrementCount = $linkTableArray->view_counts + 1;
      $magentoLinkTable->update(array('view_counts' => $incrementCount), array('product_id =?' => $linkTableArray->product_id));
    }

    // Set Registry for widgets.
    foreach ($getPageBlock as $blockName) {
      $blockValues = $getBlockRequest[$blockName];
      Zend_Registry::set($blockName, $blockValues);
    }

    $this->_helper->content
            ->setContentName($renderPageId)
            ->setNoRender()
            ->setEnabled();
  }

  public function purchasedProductsAction() {
    $user_id = $this->_getParam('id');
    $orderItems = Engine_Api::_()->getDbTable('orders', 'siteestore')->getProductQtys(array('owner_id' => $user_id));

    if (empty($orderItems))
      return;

    $products = array();
    foreach ($orderItems as $product_id) {
      $getProduct = Engine_Api::_()->getItem('siteestore_product', $product_id['product_id']);

      if (empty($getProduct))
        continue;

      $data['product'] = $getProduct;
      $data['qty'] = $product_id['quantity_count'];
      $products[] = $data;
    }
    $this->view->products = $products;
  }

  // CALLING FROM THE "VIEW ALL PRODUCTS" FROM THE ACTIVITY FEED.
  public function orderProductsAction() {
    $order_id = $this->_getParam('id');
    $order_id = (int) Engine_Api::_()->siteestore()->getDecode($order_id);

    $orderItems = Engine_Api::_()->getDbTable('orders', 'siteestore')->getOrder(array('order_id' => $order_id));

    if (empty($orderItems))
      return;

    $products = array();

    foreach ($orderItems as $product_id) {
      $getProduct = Engine_Api::_()->getItem('siteestore_product', $product_id['product_id']);

      if (empty($getProduct))
        continue;

      $products['products'] = $getProduct;
      $products['qty'] = $product_id['quantity'];
      $data[] = $products;
    }
    $this->view->products = $data;
  }

  public function getRequestPath($apiPath, $requestPath) {
    if (empty($apiPath) || empty($requestPath)) {
      return;
    }

    if (strstr($requestPath, $apiPath)) {
      return $apiPath;
    }

    return;
  }
  
  // If user are going to login from the 3rd party integration like Facebook, Twiter etc.
  public function createPasswordAction() {
    $user = $viewer = Engine_Api::_()->user()->getViewer();
    $user_id = $viewer_id = $viewer->getIdentity();
    
    $existUser = Engine_Api::_()->getDbtable("users", "siteestore")->existUser(array("se_user_id" => $viewer_id));
    if( !empty($existUser['user_id']) ) {
      Engine_Api::_()->getItem("siteestore_user", $existUser['user_id'])->delete();
    }

    // Make form
    $this->view->form = $form = new Siteestore_Form_Createpass();

    // Check request
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    // Check data
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Process
    $values = $form->getValues();
    // Check same password
    if( $values['password'] !== $values['password_confirm'] ) {
      $form->addError('The passwords you entered did not match.');
      return;
    }
    
    // Db
    $db = $user->getTable()->getAdapter();
    $db->beginTransaction();

    try
    {
      // This gets handled by the post-update hook
      $user->password = $values['password'];
      $user->save();
      
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_setParam("viewer_password", $values['password']);
    return $this->_forward('verify-password', 'index', 'siteestore');
  }

  public function verifyPasswordAction() {
    // Cart MenuItems
    $isCart = $this->_getParam("isCart", null);
    $viewerPassword = $this->_getParam("viewer_password", null);
    if (!empty($isCart)) {
      $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_main', array(), 'siteestore_main_myproduct');
    }
    
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    
    if( !empty($viewer_id) && empty($viewer->password) ) {
      return $this->_forward( 'create-password', 'index', 'siteestore');
    }

    // Make form
    $this->view->form = $form = new Siteestore_Form_Login();
    if (!empty($viewerPassword) || ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()))) {
      $values = $form->getValues();
      // Find out the "First Name" & "Last Name" of the login user from the fields table.
      $aliasValues = Engine_Api::_()->fields()->getFieldsValuesByAlias($viewer);
      if (!empty($aliasValues)) {
        $firstName = !empty($aliasValues['first_name']) ? $aliasValues['first_name'] : null;
        $lastName = !empty($aliasValues['last_name']) ? $aliasValues['last_name'] : null;
      }
      $email = $viewer->email;
      $password = !empty($viewerPassword)? $viewerPassword: $values['password'];
      $websiteId = Engine_Api::_()->siteestore()->getWebsite('id');

      $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login(array("username" => $email, "password" => $password));
      if (empty($isCustomerExist)) {

        /*
          User not abel to login in Magento. Here we have two case:
          Case 1: May be user details ( Email or Password ) has been changed in SocialEngine.
          Case 2: May be User doing first time login and don't have account in magento.
         */

        // Check in "siteestore_users" table, If "Magento Customer Id" and "SocialEngine User Id" exist in table then we are assume "Case 1" and follow respective steps else assume "Case 2" and follow respective steps.
        $existUser = Engine_Api::_()->getDbtable("users", "siteestore")->existUser(array("se_user_id" => $viewer->getIdentity()));
        $argument = array("username" => $email, "password" => $password);

        // Follow Case 2.
        if (empty($existUser)) {
          // May be User doing first time loggin and don't have account in magento. So we create user as customer in magento through XML-RPC.
          $createUser = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->magento_test_api_connection('socialengineint_seint.create', array(array('firstname' => $firstName, 'lastname' => $lastName, 'email' => $email, 'password' => $password, 'store_id' => 1, 'website_id' => $websiteId, 'group_id', 1)));

          if (!empty($createUser)) {
            Engine_Api::_()->getDbtable("users", "siteestore")->setUser(array("mage_user_id" => $createUser['entity_id'], "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "website" => $websiteId, "enable" => true));
            $isCustomerExist = Engine_Api::_()->getApi('Curl', 'siteestore')->login($argument);
          }
        } else { // Follow Case 1.
          $form->addError("Please enter the correct password.");
        }
        Engine_Api::_()->getApi('Curl', 'siteestore')->setCookies($isCustomerExist);
      } else {
        $isUserExist = Engine_Api::_()->getDbtable("users", "siteestore")->getUser(array('se_user_id' => $viewer->getIdentity()));
        if (empty($isUserExist)) {
          Engine_Api::_()->getDbtable("users", "siteestore")->setUser(array("mage_user_id" => $isCustomerExist, "se_user_id" => $viewer->getIdentity(), "name" => $firstName . ' ' . $lastName, "website" => $websiteId, "enable" => true));
        }
        Engine_Api::_()->getApi('Curl', 'siteestore')->setCookies($isCustomerExist);
      }

      // Redirect by session
      $session = new Zend_Session_Namespace();
      if (!empty($_SERVER['REQUEST_URI'])) {
        $protocol = Engine_Api::_()->siteestore()->getSEProtocol();
        $socilEngineBaseDir = Engine_Api::_()->siteestore()->getSEBaseUrl();
        $getMagentoFlag = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteestore_manifestUrl', 'shop');
        $requestUri = str_replace('/siteestore/', '/' . $getMagentoFlag . '/account/', $_SERVER['REQUEST_URI']);
        $requestURL = explode('?', $requestUri);
        $requestUri = !empty($requestURL[0]) ? $requestURL[0] : $requestUri;
        $url = $protocol . $socilEngineBaseDir['host'] . DIRECTORY_SEPARATOR . ltrim($requestUri, '/');
        return $this->_helper->redirector->gotoUrl($url);
      } else if (isset($session->uri)) {
        $uri = $session->uri;
        $opts = $session->options;
        $session->unsetAll();
        return $this->_redirect($uri, $opts);
      } else if (isset($session->route)) {
        $session->unsetAll();
        return $this->_helper->redirector->gotoRoute($session->params, $session->route, $session->reset);
      }

      // Just redirect to home
      return $this->_helper->redirector->gotoRoute(array(), 'magento_main', true);
    }
  }

  public function helpAndLearnmoreAction() {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('siteestore_main', array(), 'siteestore_main_help');
    $this->view->display_faq = $display_faq = $this->_getParam('display_faq');
    $this->view->page_id = $page_id = $this->_getParam('page_id', 0);

    if (empty($page_id)) {
      $helpInfoTable = Engine_Api::_()->getItemtable('siteestore_infopage');
      $helpInfoTableName = $helpInfoTable->info('name');
      $select = $helpInfoTable->select()->from($helpInfoTableName)->where('status =?', 1);
      $fetchHelpTable = $select->query()->fetchAll();
      if (!empty($fetchHelpTable)) {
        $this->view->pageObject = $fetchHelpTable;
        $default_faq = $fetchHelpTable[0]['faq'];
        $default_contact = $fetchHelpTable[0]['contect_team'];
        $this->view->page_default = $fetchHelpTable[0]['page_default'];
      }
    } else {
      $helpInfoTable = Engine_Api::_()->getItemtable('siteestore_infopage');
      $helpInfoTableName = $helpInfoTable->info('name');
      $select = $helpInfoTable->select()->from($helpInfoTableName, array('infopage_id', 'title', 'package', 'faq', 'contect_team'))->where('status =?', 1);
      $fetchHelpTable = $select->query()->fetchAll();
      if (!empty($fetchHelpTable)) {
        $this->view->pageObject = $fetchHelpTable;
        $page_info = Engine_Api::_()->getItem('siteestore_infopage', $page_id);
        if (empty($page_info)) {
          return $this->_forward('notfound', 'error', 'core');
        }
        $display_faq = $default_faq = $page_info->faq;
        $default_contact = $page_info->contect_team;
        $this->view->page_default = $page_info->page_default;
        if (empty($default_faq) && empty($default_contact)) {
          $this->view->content_data = $page_info->description;
          $this->view->content_title = $page_info->title;
        }
      }
    }

    if (empty($display_faq)) {
      $this->view->display_faq = $display_faq = $default_faq;
    }

    if (!empty($display_faq)) {
      $pageIdSelect = $helpInfoTable->select()->from($helpInfoTableName, array('*'))
                      ->where('faq =?', $display_faq)->where('status =?', 1)->limit(1);
      $result = $pageIdSelect->query()->fetchAll();
      $this->view->faqpage_id = $result[0]['infopage_id'];
      $communityadFaqTable = Engine_Api::_()->getItemTable('siteestore_faq');
      $communityadFaqName = $communityadFaqTable->info('name');

      // fetch General or Design or Targeting FAQ according to the selected tab
      $communityadFaqSelect = $communityadFaqTable->select()->from($communityadFaqName, array('question', 'answer', 'type', 'faq_default'))
              ->where('status =?', 1)
              ->where('type =?', $display_faq)
              ->order('faq_id DESC');
      $this->view->viewFaq = $communityadFaqSelect->query()->fetchAll();
    }
  }

}
