<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SyncController.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_SyncController extends Core_Controller_Action_Standard {

  // Create User in SocialEngine, when customer login or signup in configured magento site.
  public function createAction() {
    if (!empty($_GET["info"])) {
      $customerInfo = $_GET["info"];
    } else {
      exit();
    }

    $customerInfo = base64_decode($customerInfo);
    $customerInfo = unserialize($customerInfo);
    if (empty($customerInfo) || empty($customerInfo['email'])) {
      exit();
    }

    $userTable = Engine_Api::_()->getItemTable('user');
    $tableName = $userTable->info('name');

    // Create user in SocialEngine.
    $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $customerInfo['email']);
    $user = $selectTable->query()->fetch();
    if (empty($user)) {
      $signupData = Engine_Api::_()->siteestore()->doSignup($customerInfo);
      Engine_Api::_()->siteestore()->crateUser($customerInfo); // Create user in siteestore_users Table.
    }


    $db = Zend_Db_Table_Abstract::getDefaultAdapter();
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    // Find out the first_name meta fileds values and set the First Name into the Profile Type.
    if (!empty($customerInfo['firstname']) && !empty($viewer_id)) {
      $metaFnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'first_name' LIMIT 0 , 30")->fetchAll();
      if (!empty($viewer_id)) {
        foreach ($metaFnameQuery as $fetchRow) {
          $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $viewer_id . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
          if (empty($query)) {
            $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $viewer_id . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['firstname'] . "')");
          }
        }
      }
    }


    // Find out the last_name meta fileds values and set the Last Name into the Profile Type.
    if (!empty($customerInfo['lastname']) && !empty($viewer_id)) {
      $metaLnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'last_name' LIMIT 0 , 30")->fetchAll();
      if (!empty($viewer_id)) {
        foreach ($metaLnameQuery as $fetchRow) {
          $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $viewer_id . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
          if (empty($query)) {
            $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $viewer_id . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['lastname'] . "')");
          }
        }
      }
    }
  }

  // Update customer information into the SocialEngine, when customer update his information from the configured magento site.
  public function updateAction() {
    if (!empty($_GET["info"])) {
      $customerInfo = $_GET["info"];
    } else {
      exit();
    }

    $customerInfo = base64_decode($customerInfo);
    $customerInfo = unserialize($customerInfo);
    if (empty($customerInfo)) {
      exit();
    }
    
    $getMAgentoId = Engine_Api::_()->getDbTable('users', 'siteestore')->getUser(array('mage_user_id' => $customerInfo['id']));
    $getMAgentoId = end($getMAgentoId);
    $socialEngineUserId = $getMAgentoId['se_user_id'];
    $siteestoreUserId = $getMAgentoId['user_id'];
    $db = Zend_Db_Table_Abstract::getDefaultAdapter();
    // Update Email, Password, Salt and Displayname
  if( !empty($customerInfo['salt']) && !empty($customerInfo['password']) && !empty($customerInfo['confirmation']) && ($customerInfo['password'] === $customerInfo['confirmation']) ) {
    $staticSalt = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.secret', 'staticSalt');
    $password = md5($staticSalt . $customerInfo["password"] . $customerInfo["salt"]);
    $query = "UPDATE `engine4_users` SET `email` = '".$customerInfo['email']."', `password` = '".$password."', `salt` = '".$customerInfo['salt']."', `displayname` = '".$customerInfo['firstname']." ".$customerInfo['lastname']."' WHERE `engine4_users`.`user_id` =$socialEngineUserId LIMIT 1 ;";
  }else {
    $query = "UPDATE `engine4_users` SET `email` = '".$customerInfo['email']."', `displayname` = '".$customerInfo['firstname']." ".$customerInfo['lastname']."' WHERE `engine4_users`.`user_id` =$socialEngineUserId LIMIT 1 ;";
  }
  
  $db->query($query);
  
  $db->query("UPDATE `engine4_siteestore_users` SET `name` = '".$customerInfo['firstname']." ".$customerInfo['lastname']."' WHERE `engine4_siteestore_users`.`user_id` =$siteestoreUserId LIMIT 1 ;");
    
  
  
  
    if (!empty($customerInfo['firstname'])) {
      $metaFnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'first_name' LIMIT 0 , 30")->fetchAll();
      if (!empty($socialEngineUserId)) {
        foreach ($metaFnameQuery as $fetchRow) {
          $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $socialEngineUserId . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
          if (empty($query)) {
            $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $socialEngineUserId . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['firstname'] . "')");
          }else {
            $db->query("UPDATE `engine4_user_fields_values` SET `value` = '".$customerInfo['firstname']."' WHERE `engine4_user_fields_values`.`item_id` =$socialEngineUserId AND `engine4_user_fields_values`.`field_id`= ".$fetchRow['field_id']." LIMIT 1 ;");
          }
        }
      }
    }
    
    
    // Find out the last_name meta fileds values and set the Last Name into the Profile Type.
    if (!empty($customerInfo['lastname'])) {
      $metaLnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'last_name' LIMIT 0 , 30")->fetchAll();
      if (!empty($socialEngineUserId)) {
        foreach ($metaLnameQuery as $fetchRow) {
          $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $socialEngineUserId . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
          if (empty($query)) {
            $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $socialEngineUserId . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['lastname'] . "')");
          }else {
            $db->query("UPDATE `engine4_user_fields_values` SET `value` = '".$customerInfo['lastname']."' WHERE `engine4_user_fields_values`.`item_id` =$socialEngineUserId AND `engine4_user_fields_values`.`field_id`= ".$fetchRow['field_id']." LIMIT 1 ;");
          }
        }
      }
    }
  }
}