<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: widgetSettings.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
$db = Zend_Db_Table_Abstract::getDefaultAdapter();

$db->query('
INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES

("siteestore_magento_settings", "siteestore", "Magento Integration", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings", "action":"api"}\', "siteestore_admin_menu", NULL, 1, 0, 2),
("siteestore_admin_products", "siteestore", "Manage Products", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings", "action":"manage-products"}\', "siteestore_admin_menu", NULL, 1, 0, 3),
("siteestore_magento_users", "siteestore", "Manage Members", NULL, \'{"route":"admin_default","module":"siteestore","controller":"users"}\', "siteestore_admin_menu", NULL, 1, 0, 4),
("siteestore_mage_settings_admin", "siteestore", "Administer Store", NULL, \'{"uri":"http://localhost/semagento/magento/admin","icon":"", "target":"_blank"}\', "siteestore_admin_menu", NULL, 1, 0, 5),
("siteestore_mage_settings_api", "siteestore", "Integration Settings", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings","action":"api"}\', "siteestore_admin_mage_settings", NULL, 1, 0, 1),
("siteestore_mage_settings_store", "siteestore", "Store Integration", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings","action":"store"}\', "siteestore_admin_mage_settings", NULL, 1, 0, 2),
("siteestore_mage_settings_mapping", "siteestore", "Language Mapping", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings","action":"mapping"}\', "siteestore_admin_mage_settings", NULL, 1, 0, 3),
("siteestore_mage_settings_cache", "siteestore", "Cache Management", NULL, \'{"route":"admin_default","module":"siteestore","controller":"magentosettings","action":"cache"}\', "siteestore_admin_mage_settings", NULL, 1, 0, 6),
("siteestore_main_shop", "siteestore", "Products", NULL, \'{"route":"magento_main","icon":""}\', "siteestore_main", NULL, 1, 0, 1),
("siteestore_main_myproduct", "siteestore", "My Cart", NULL, \'{"route":"magento_cart"}\', "siteestore_main", NULL, 1, 0, 4),
("siteestore_gutter_share", "siteestore", "Share", "Siteestore_Plugin_Menus", \'{"route":"default","module":"activity","controller":"index","action":"share","class":"buttonlink smoothbox seaocore_icon_share"}\', "siteestore_gutter", NULL, 1, 0, 2),
("siteestore_gutter_sugest_friend", "siteestore", "Suggest to Friends", "Siteestore_Plugin_Menus", \'{"route":"default"}\', "siteestore_gutter", NULL, 1, 0, 1),
("siteestore_main_wishlist", "siteestore", "My Wishlist", "", \'{"route":"magento_wishlist","icon":""}\', "siteestore_main", NULL, 1, 0, 3),
("siteestore_main_checkout", "siteestore", "Checkout", NULL, \'{"route":"magento_checkout","icon":""}\', "siteestore_main", NULL, 1, 0, 5);
');

$db->query('
INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES
("siteestore_add_wishlist", "siteestore", \'{item:$subject} has added {item:$object} to wishlist:\', 1, 5, 1, 3, 1, 1),
("siteestore_new", "siteestore", \'{item:$subject} purchased {var:$count} product(s):\', 1, 5, 1, 3, 1, 1);  
');


//home page
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'core_index_index')
        ->limit(1);
$page_id = $select->query()->fetchObject()->page_id;

// @Make an condition
if (!empty($page_id)) {

  // container_id (will always be there)
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_content')
          ->where('page_id = ?', $page_id)
          ->where('type = ?', 'container')
          ->where('name = ?', 'main')
          ->limit(1);
  $container_id = $select->query()->fetchObject()->content_id;
  if (!empty($container_id)) {
    // $right_id (will always be there)
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_content')
            ->where('parent_content_id = ?', $container_id)
            ->where('type = ?', 'container')
            ->where('name = ?', 'right')
            ->limit(1);
    $right_id = $select->query()->fetchObject()->content_id;

    if (!empty($right_id)) {
      // Check if it's already been placed
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_content')
              ->where('parent_content_id = ?', $right_id)
              ->where('type = ?', 'widget')
              ->where('name = ?', 'Siteestore.list-recently-purchased');
      $info = $select->query()->fetch();
      if (empty($info)) {
        // tab on profile
        $db->insert('engine4_core_content', array(
            'page_id' => $page_id,
            'type' => 'widget',
            'name' => 'Siteestore.list-recently-purchased',
            'parent_content_id' => $right_id,
            'order' => 2,
        ));
      }
    }
  }
}


//home page
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'user_index_home')
        ->limit(1);
$page_id = $select->query()->fetchObject()->page_id;

// @Make an condition
if (!empty($page_id)) {

  // container_id (will always be there)
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_content')
          ->where('page_id = ?', $page_id)
          ->where('type = ?', 'container')
          ->where('name = ?', 'main')
          ->limit(1);
  $container_id = $select->query()->fetchObject()->content_id;
  if (!empty($container_id)) {
    // $right_id (will always be there)
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_content')
            ->where('parent_content_id = ?', $container_id)
            ->where('type = ?', 'container')
            ->where('name = ?', 'left')
            ->limit(1);
    $left_id = $select->query()->fetchObject()->content_id;

    if (!empty($left_id)) {
      // Check if it's already been placed
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_content')
              ->where('parent_content_id = ?', $left_id)
              ->where('type = ?', 'widget')
              ->where('name = ?', 'Siteestore.top-buyer');
      $info = $select->query()->fetch();
      if (empty($info)) {
        // tab on profile
        $db->insert('engine4_core_content', array(
            'page_id' => $page_id,
            'type' => 'widget',
            'name' => 'Siteestore.top-buyer',
            'parent_content_id' => $left_id,
            'order' => 999,
        ));
      }
    }
  }
}



// MAGENTO HOME PAGE.
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'siteestore_index_home')
        ->limit(1);
$page = $select->query()->fetch();
if (empty($page)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'siteestore_index_home',
      'displayname' => 'Store Home Page - Magento',
      'title' => '',
      'description' => '',
      'custom' => 1,
  ));
  $page_id = $db->lastInsertId('engine4_core_pages');

  // TOP CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'top',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $top_container_id = $db->lastInsertId('engine4_core_content');

  // TOP MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $top_container_id,
      'order' => 6,
      'params' => '',
  ));
  $top_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 2,
      'params' => '',
  ));
  $main_container_id = $db->lastInsertId('engine4_core_content');

  // MAIN MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $main_container_id,
      'order' => 6,
      'params' => '',
  ));
  $main_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN RIGHT
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'right',
      'parent_content_id' => $main_container_id,
      'order' => 5,
      'params' => '',
  ));
  $main_right_id = $db->lastInsertId('engine4_core_content');

  // INSERT WIDGETS IN TOP CONTAINER.
  if (!empty($top_middle_id)) {
    // Navigation
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.main-menu',
        'parent_content_id' => $top_middle_id,
        'order' => 3,
        'params' => '{"title":""}',
    ));

    // Magento: Category Widget.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 4,
        'params' => '{"title":"","block_name":"catalog.topnav","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN MIDDLE.
  if (!empty($main_middle_id)) {
    // MAGENTO - MAIN WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_middle_id,
        'order' => 7,
        'params' => '{"title":"","block_name":"content","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN RIGHT.
  if (!empty($main_right_id)) {
    // SEARCH WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.products-search',
        'parent_content_id' => $main_right_id,
        'order' => 9,
        'params' => '',
    ));

    // SPECIAL PRODUCTS.
//    $db->insert('engine4_core_content', array(
//        'page_id' => $page_id,
//        'type' => 'widget',
//        'name' => 'Siteestore.products-search',
//        'parent_content_id' => $main_right_id,
//        'order' => 9,
//        'params' => '',
//    ));
    // SEARCH WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_right_id,
        'order' => 11,
        'params' => '{"title":"","tempTitle":"Best Selling Products","titleType":"0","popularType":"maxpurchased","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));

    // MAGENTO - COMPARE PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 12,
        'params' => '{"title":"","block_name":"catalog.compare.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - CART
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 13,
        'params' => '{"title":"","block_name":"cart_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - WISHLIST
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 14,
        'params' => '{"title":"","block_name":"wishlist_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY VIEWED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 15,
        'params' => '{"title":"","block_name":"right.reports.product.viewed","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY COMPARED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 16,
        'params' => '{"title":"","block_name":"right.reports.product.compared","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - LAST ORDERED PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 17,
        'params' => '{"title":"","block_name":"sale.reorder.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // POPULAR PRODUCTS - LIKED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_right_id,
        'order' => 18,
        'params' => '{"title":"","tempTitle":"Most Liked Products","titleType":"0","popularType":"like","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));

    // POPULAR PRODUCTS - VIEWED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_right_id,
        'order' => 19,
        'params' => '{"title":"","tempTitle":"Most Viewed Products","titleType":"0","popularType":"view","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));
  }
}













// MAGENTO BROWSE PAGE.
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'siteestore_index_shopping')
        ->limit(1);
$page = $select->query()->fetch();
if (empty($page)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'siteestore_index_shopping',
      'displayname' => 'Store Browse Page - Magento',
      'title' => '',
      'description' => '',
      'custom' => 1,
  ));
  $page_id = $db->lastInsertId('engine4_core_pages');

  // TOP CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'top',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $top_container_id = $db->lastInsertId('engine4_core_content');

  // TOP MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $top_container_id,
      'order' => 6,
      'params' => '',
  ));
  $top_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 2,
      'params' => '',
  ));
  $main_container_id = $db->lastInsertId('engine4_core_content');

  // MAIN MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $main_container_id,
      'order' => 6,
      'params' => '',
  ));
  $main_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN RIGHT
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'right',
      'parent_content_id' => $main_container_id,
      'order' => 5,
      'params' => '',
  ));
  $main_right_id = $db->lastInsertId('engine4_core_content');

  // MAIN LEFT
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'left',
      'parent_content_id' => $main_container_id,
      'order' => 4,
      'params' => '',
  ));
  $main_left_id = $db->lastInsertId('engine4_core_content');

  // INSERT WIDGETS IN TOP CONTAINER.
  if (!empty($top_middle_id)) {
    // Navigation
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.main-menu',
        'parent_content_id' => $top_middle_id,
        'order' => 3,
        'params' => '{"title":""}',
    ));

    // Magento: Category Widget.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 4,
        'params' => '{"title":"","block_name":"catalog.topnav","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // Magento: BREADCRUMBS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 5,
        'params' => '{"title":"","block_name":"breadcrumbs","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  if (!empty($main_left_id)) {
    // MAGENTO - SUB CATEGORY
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_left_id,
        'order' => 8,
        'params' => '{"title":"","block_name":"catalog.leftnav","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - POPULAR PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_left_id,
        'order' => 9,
        'params' => '{"title":"","block_name":"tags_popular","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - NEWSLATER
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_left_id,
        'order' => 10,
        'params' => '{"title":"","block_name":"left.newsletter","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // POPULAR PRODUCTS - BEST SELLING PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_left_id,
        'order' => 11,
        'params' => '{"title":"","tempTitle":"Best Selling Products","titleType":"0","popularType":"maxpurchased","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));

    // POPULAR PRODUCTS - VIEWS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_left_id,
        'order' => 12,
        'params' => '{"title":"","tempTitle":"Most Viewed Products","titleType":"0","popularType":"view","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));
  }

  // INSERT WIDGETS IN MAIN MIDDLE.
  if (!empty($main_middle_id)) {
    // MAGENTO - MAIN WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_middle_id,
        'order' => 14,
        'params' => '{"title":"","block_name":"content","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN RIGHT.
  if (!empty($main_right_id)) {
    // SEARCH WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.products-search',
        'parent_content_id' => $main_right_id,
        'order' => 16,
        'params' => '',
    ));

    // SPECIAL PRODUCTS.
//    $db->insert('engine4_core_content', array(
//        'page_id' => $page_id,
//        'type' => 'widget',
//        'name' => 'Siteestore.products-search',
//        'parent_content_id' => $main_right_id,
//        'order' => 9,
//        'params' => '',
//    ));
    // SEARCH WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-recently-purchased',
        'parent_content_id' => $main_right_id,
        'order' => 18,
        'params' => '',
    ));

    // MAGENTO - COMPARE PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 19,
        'params' => '{"title":"","block_name":"catalog.compare.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - CART
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 20,
        'params' => '{"title":"","block_name":"cart_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - WISHLIST
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 21,
        'params' => '{"title":"","block_name":"wishlist_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY VIEWED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 22,
        'params' => '{"title":"","block_name":"right.reports.product.viewed","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY COMPARED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 23,
        'params' => '{"title":"","block_name":"right.reports.product.compared","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - LAST ORDERED PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 24,
        'params' => '{"title":"","block_name":"sale.reorder.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // POPULAR PRODUCTS - LIKED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'parent_content_id' => $main_right_id,
        'order' => 25,
        'params' => '{"title":"","tempTitle":"Most Liked Products","titleType":"0","popularType":"like","itemCountPerPage":"3","nomobile":"0","name":"Siteestore.list-popular-products"}',
    ));
  }
}







// MAGENTO VIEW PAGE.
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'siteestore_index_view')
        ->limit(1);
$page = $select->query()->fetch();
if (empty($page)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'siteestore_index_view',
      'displayname' => 'Store Product View Page - Magento',
      'title' => '',
      'description' => '',
      'custom' => 1,
  ));
  $page_id = $db->lastInsertId('engine4_core_pages');

  // TOP CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'top',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $top_container_id = $db->lastInsertId('engine4_core_content');

  // TOP MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $top_container_id,
      'order' => 6,
      'params' => '',
  ));
  $top_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 2,
      'params' => '',
  ));
  $main_container_id = $db->lastInsertId('engine4_core_content');

  // MAIN MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $main_container_id,
      'order' => 6,
      'params' => '',
  ));
  $main_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN RIGHT
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'right',
      'parent_content_id' => $main_container_id,
      'order' => 5,
      'params' => '',
  ));
  $main_right_id = $db->lastInsertId('engine4_core_content');

  // INSERT WIDGETS IN TOP CONTAINER.
  if (!empty($top_middle_id)) {
    // Navigation
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.main-menu',
        'parent_content_id' => $top_middle_id,
        'order' => 3,
        'params' => '{"title":""}',
    ));

    // Magento: Category Widget.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 4,
        'params' => '{"title":"","block_name":"catalog.topnav","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // Magento: BREADCRUMBS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 5,
        'params' => '{"title":"","block_name":"breadcrumbs","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN MIDDLE.
  if (!empty($main_middle_id)) {
    // MAGENTO - MAIN WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_middle_id,
        'order' => 8,
        'params' => '{"title":"","block_name":"content","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN RIGHT.
  if (!empty($main_right_id)) {
    // SEARCH WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.products-search',
        'parent_content_id' => $main_right_id,
        'order' => 10,
        'params' => '',
    ));
    
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'facebookse');
    $isFacebooksePlugin = $select->query()->fetchObject();
    if (!empty($isFacebooksePlugin)) {
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'Facebookse.facebookse-commonlike',
          'parent_content_id' => $main_right_id,
          'order' => 11,
          'params' => '',
      ));
    }


    // GUTTER MENUS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.gutter-menu',
        'parent_content_id' => $main_right_id,
        'order' => 12,
        'params' => '',
    ));

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitelike');
    $isLikePlugin = $select->query()->fetchObject();
    if (!empty($isLikePlugin)) {
      // RELATED PRODUCTS
      $db->insert('engine4_core_content', array(
          'page_id' => $page_id,
          'type' => 'widget',
          'name' => 'sitelike.common-friend-like',
          'parent_content_id' => $main_right_id,
          'order' => 13,
          'params' => '',
      ));
    }


    // RELATED PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 14,
        'params' => '{"title":"","block_name":"catalog.product.related","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - COMPARE PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 15,
        'params' => '{"title":"","block_name":"catalog.compare.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - CART
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 16,
        'params' => '{"title":"","block_name":"cart_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - WISHLIST
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 17,
        'params' => '{"title":"","block_name":"wishlist_sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY VIEWED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 18,
        'params' => '{"title":"","block_name":"right.reports.product.viewed","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - RECENTLY COMPARED
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 19,
        'params' => '{"title":"","block_name":"right.reports.product.compared","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // MAGENTO - LAST ORDERED PRODUCTS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_right_id,
        'order' => 20,
        'params' => '{"title":"","block_name":"sale.reorder.sidebar","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }
}



// MAGENTO CHECKOUT PAGE.
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_pages')
        ->where('name = ?', 'siteestore_index_checkout')
        ->limit(1);
$page = $select->query()->fetch();
if (empty($page)) {
  $db->insert('engine4_core_pages', array(
      'name' => 'siteestore_index_checkout',
      'displayname' => 'Store Checkout Page - Magento',
      'title' => '',
      'description' => '',
      'custom' => 1,
  ));
  $page_id = $db->lastInsertId('engine4_core_pages');

  // TOP CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'top',
      'parent_content_id' => null,
      'order' => 1,
      'params' => '',
  ));
  $top_container_id = $db->lastInsertId('engine4_core_content');

  // TOP MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $top_container_id,
      'order' => 6,
      'params' => '',
  ));
  $top_middle_id = $db->lastInsertId('engine4_core_content');

  // MAIN CONTAINERS
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'main',
      'parent_content_id' => null,
      'order' => 2,
      'params' => '',
  ));
  $main_container_id = $db->lastInsertId('engine4_core_content');

  // MAIN MIDDILE
  $db->insert('engine4_core_content', array(
      'page_id' => $page_id,
      'type' => 'container',
      'name' => 'middle',
      'parent_content_id' => $main_container_id,
      'order' => 6,
      'params' => '',
  ));
  $main_middle_id = $db->lastInsertId('engine4_core_content');

  // INSERT WIDGETS IN TOP CONTAINER.
  if (!empty($top_middle_id)) {
    // Navigation
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.main-menu',
        'parent_content_id' => $top_middle_id,
        'order' => 3,
        'params' => '{"title":""}',
    ));

    // Magento: Category Widget.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 4,
        'params' => '{"title":"","block_name":"catalog.topnav","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));

    // Magento: BREADCRUMBS
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $top_middle_id,
        'order' => 5,
        'params' => '{"title":"","block_name":"breadcrumbs","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }

  // INSERT WIDGETS IN MAIN MIDDLE.
  if (!empty($main_middle_id)) {
    // MAGENTO - MAIN WIDGET.
    $db->insert('engine4_core_content', array(
        'page_id' => $page_id,
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'parent_content_id' => $main_middle_id,
        'order' => 8,
        'params' => '{"title":"","block_name":"content","shop_block_name":"","getWidAjaxEnabled":"1","nomobile":"0","name":"Siteestore.blocks"}',
    ));
  }
}