<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

$blockElements = array(
    'Select',
    'block_name',
    array(
        'RegisterInArrayValidator' => false,
        'decorators' => array(array('ViewScript', array(
                    'viewScript' => 'application/modules/Siteestore/views/scripts/_contentBlock.tpl',
                    'class' => 'form element'))),
    )
);


$hiddenCatElement = array(
    'Text',
    'shop_block_name',
    array(
        'label' => 'Enter the ‘Block Title’ of your custom Magento Block',
    )
);

$className = array(
    'Hidden',
    'hidden_class_name',
    array(
        'value' => 'my-cart',
        'order' => 1001
    )
);

$isAjaxable = array(
    'Radio',
    'getWidAjaxEnabled',
    array(
        'label' => 'Widget Content Loading',
        'description' => 'Do you want the content of this widget to be loaded via AJAX, after the loading of main webpage content? (Enabling this can improve webpage loading speed. Disabling this would load content of this widget along with the page content. Note: This setting will only work, if this widget is placed on pages  other than Ecommerce / Social Store’s pages on your site.)',
        'multiOptions' => array(
            '1' => 'Yes',
            '0' => 'No',
        ),
        'value' => 1,
    )
);



return array(
    array(
        'title' => $view->translate('Magento Blocks (selected content)'),
        'description' => $view->translate('A Magento block is a modular unit of content that can be positioned almost anywhere on the page, just like widgets in SocialEngine. Blocks can be used to display static information such as text, images, and embedded video, as well as dynamic information from your Magento site. This widget displays content of a selected Magento Block, which you can choose from the settings of this widget. You can place this widget multiple times on a page with different Magento Blocks chosen for each placement.<br />
It is recommended to place this widget in the pages of E-commerce / Store on your site. If you place this widget outside the pages of E-commerce / Store, then it should not be placed more than 1 or 2 times on a page.          
'),
        'category' => $view->translate('E-commerce / Store'),
        'type' => 'widget',
        'name' => 'Siteestore.blocks',
        'autoEdit' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'title',array('order' => 1003)
                ),
                $blockElements,
                $hiddenCatElement,
                $isAjaxable
            )
        )
    ),
    array(
        'title' => $view->translate('Navigation Tabs'),
        'description' => $view->translate('Displays the Navigation tabs for ‘Ecommerce / Social Store’ having links of Products, Users’ Store Account, etc. This widget should be placed at the top of ‘Store Home Page - Magento’, ‘Store Checkout Page - Magento’ and ‘Store Browse Page - Magento’.'),
        'category' => $view->translate('E-commerce / Store'),
        'type' => 'widget',
        'name' => 'Siteestore.main-menu'
    ),
    array(
        'title' => $view->translate('Product View Page Options'),
        'description' => $view->translate('Displays the various action links that can be performed on the Products from their View pages (Like, Share, etc.). This widget should be placed on the Store Product View Page - Magento. You can manage the Action Links available in this widget from the Menu Editor section by choosing Store Product View Page Options Menu.'),
        'category' => $view->translate('E-commerce / Store'),
        'type' => 'widget',
        'name' => 'Siteestore.gutter-menu',
    ),
    array(
        'title' => $view->translate('Search Products form'),
        'description' => $view->translate('Displays the form for searching products on the basis of various fields and filters. This widget should be placed in the right column of ‘Store Browse Page - Magento’.'),
        'category' => $view->translate('E-commerce / Store'),
        'type' => 'widget',
        'name' => 'Siteestore.products-search',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'title',array('order' => 1004)
                ),
                array(
                    'Text',
                    'tempTitle',
                    array(
                        'label' => 'Title',
                        'value' => 'Search'
                    )
                ),
                array(
                    'Radio',
                    'titleType',
                    array(
                        'label' => 'How do you want to display the title of this widget? (It is recommended to select the option "Inside Widget", if this widget is placed on an E-commerce / Social Store page of your site.)',
                        'multiOptions' => array(
                            0 => 'Inside Widget',
                            1 => 'Outside Widget'
                        ),
                        'value' => 0
                    )
                ),
            )
        ),
    ),
    array(
        'title' => 'Special Product',
        'description' => 'Displays a product as a special product. You can choose the product to be shown in this widget from the settings of the widget.',
        'category' => $view->translate('E-commerce / Store'),
        'autoEdit' => true,
        'type' => 'widget',
        'name' => 'Siteestore.special-product',
        'adminForm' => 'Siteestore_Form_Admin_Item',
    ),
    array(
        'title' => 'Popular Products',
        'description' => 'Displays most popular Products. There is a setting for the parameter for popularity such as Views, Likes and Purchases from site. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
        'category' => 'E-commerce / Store',
        'type' => 'widget',
        'name' => 'Siteestore.list-popular-products',
        'isPaginated' => true,
        'autoEdit' => true,
        'requirements' => array(
            'no-subject',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'title',
                    array('order' => 1005)
                ),
                array(
                    'Text',
                    'tempTitle',
                    array(
                        'label' => 'Title',
                        'value' => 'Most Viewed Products'
                    )
                ),
                array(
                    'Radio',
                    'titleType',
                    array(
                        'label' => 'How do you want to display the title of this widget? (It is recommended to select the option "Inside Widget", if this widget is placed on an E-commerce / Social Store page of your site.)',
                        'multiOptions' => array(
                            0 => 'Inside Widget',
                            1 => 'Outside Widget'
                        ),
                        'value' => 0
                    )
                ),
                array(
                    'Radio',
                    'popularType',
                    array(
                        'label' => 'Popularity Criteria',
                        'multiOptions' => array(
                            'view' => 'Views',
                            'like' => 'Likes',
                            'maxpurchased' => 'Purchases from site'
                        ),
                        'value' => 'view',
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(number of items to show)',
                        'value' => 3
                    )
                )
            )
        ),
    ),
    array(
        'title' => 'Recently Ordered Products',
        'description' => 'Displays recently ordered products from this site. This widget should be placed in right / left column.',
        'category' => 'E-commerce / Store',
        'type' => 'widget',
        'name' => 'Siteestore.list-recently-purchased',
        'isPaginated' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'title',
                    array('order' => 1006)
                ),
                array(
                    'Text',
                    'tempTitle',
                    array(
                        'label' => 'Title',
                        'value' => 'Recently Ordered Products'
                    )
                ),
                array(
                    'Radio',
                    'titleType',
                    array(
                        'label' => 'How do you want to display the title of this widget? (It is recommended to select the option "Inside Widget", if this widget is placed on an E-commerce / Social Store page of your site.)',
                        'multiOptions' => array(
                            0 => 'Inside Widget',
                            1 => 'Outside Widget'
                        ),
                        'value' => 0
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(number of items to show)',
                        'value' => 3
                    )
                )
            )
        ),
    ),
    array(
        'title' => 'Top Buyers',
        'description' => 'Shows the users who have purchased the maximum number of products from your site. You can choose the number of entries to show.',
        'category' => 'E-commerce / Store',
        'type' => 'widget',
        'name' => 'Siteestore.top-buyer',
        'isPaginated' => true,
        'adminForm' => array(
            'elements' => array(
                array(
                    'Hidden',
                    'title',
                    array('order' => 1007)
                ),
                array(
                    'Text',
                    'tempTitle',
                    array(
                        'label' => 'Title',
                        'value' => 'Top Buyers'
                    )
                ),
                array(
                    'Radio',
                    'titleType',
                    array(
                        'label' => 'How do you want to display the title of this widget? (It is recommended to select the option "Inside Widget", if this widget is placed on an E-commerce / Social Store page of your site.)',
                        'multiOptions' => array(
                            0 => 'Inside Widget',
                            1 => 'Outside Widget'
                        ),
                        'value' => 0
                    )
                ),
                array(
                    'Text',
                    'itemCountPerPage',
                    array(
                        'label' => 'Count',
                        'description' => '(number of items to show)',
                        'value' => 3
                    )
                )
            )
        ),
    ),
    array(
        'title' => 'All Products',
        'description' => 'Displays a list of all the products of your Magento Store in grid view. (To display all the latest product of your Magento Store, it is recommended to synchronize products on your site with your Magento Store. To do so, go to the Manage Products section of this plugin.)',
        'category' => 'E-commerce / Store',
        'type' => 'widget',
        'name' => 'Siteestore.home-page-products',
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_product',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of Products to show)',
                        'value' => 12,
                    )
                ),
            ),
        ),
    ),
);
?>