<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteestore
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2012-10-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Siteestore_Widget_HomePageProductsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $this->view->margin_product = $this->_getParam('margin_product', 2);   
    $this->view->itemCount = $itemCount = $this->_getParam('itemCount', 12);
    $this->view->is_ajax = $this->_getParam('is_ajax', false);
    $getUserStatus = Engine_Api::_()->siteestore()->getUserStatus();
    $isApiConnValid = Engine_Api::_()->getApi('Xmlrpc', 'siteestore')->isApiConnValid();
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    
    if (empty($getUserStatus) || empty($isApiConnValid)) {
      return $this->setNoRender();
    }
    
    $page = Zend_Controller_Front::getInstance()->getRequest()->getParam('page', 1);
    $this->view->paginator = $paginator = Engine_Api::_()->getItemTable('siteestore_product')->getProductsPaginator(array('status' => true));    
    $paginatorCount = $paginator->getTotalItemCount();
    $this->view->paginator->setItemCountPerPage($itemCount);
    $this->view->paginator->setCurrentPageNumber($page);

    if(empty($paginatorCount) && !empty($viewer_id) && !empty($viewer->level_id) && ($viewer->level_id != 1))  {
       return $this->setNoRender();
    }
  }
}

?>