<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteevent
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: GetContent.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteevent_View_Helper_GetEventContent extends Zend_View_Helper_Abstract {

    /**
     * Assembles action string
     * 
     * @return string
     */
    public function getEventContent($action, $content) {

        $settings = Engine_Api::_()->getApi('settings', 'core');
        $rsvpSetting = $settings->getSetting('siteevent.rsvp.membership.combined', 0);
        $eventTypes = array(
            'siteevent_join' => array('will be attending', 'is going to'),
            'siteevent_leave' => array('will not be attending', 'ignored'),
            'siteevent_maybe_join' => array('maybe attending the', 'interested in the'),
            'siteevent_mid_join' => array('is attending', 'is going to'),
            'siteevent_mid_leave' => array('is not attending', 'ignored'),
            'siteevent_mid_maybe' => array('maybe attending', 'interested in'),
        );
        $type = $action->type;
        if (!$rsvpSetting || !isset($eventTypes[$type])) {
            return $content;
        }
       
        return str_replace($eventTypes[$type][0], $eventTypes[$type][1], $content);
    }

}
