<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventadmincontact
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminMailsController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventadmincontact_AdminMailsController extends Core_Controller_Action_Admin {

    //ACTION FOR SENDING THE EMAIL
    public function indexAction() {

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteeventadmincontact_admin_main', array(), 'Siteeventadmincontact_admin_main_mails');

        //GET NAVIGATION
        $this->view->navigationEvent = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main', array(), 'siteevent_admin_main_admincontact');

        //GET FORM
        $this->view->form = $form = new Siteeventadmincontact_Form_Admin_Mail_Mail();

        //CHECK METHOD
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            //GET VALUES
            $values = $form->getValues();

						if (isset($values['starttime']) && !empty($values['starttime']) || (isset($values['endtime']) && !empty($values['endtime']))) {
							$starttimeExplode = explode(' ', $values['starttime']);
              $endtimeExplode = explode(' ', $values['endtime']);
							if($endtimeExplode[0] < $starttimeExplode[0] ) {
								$form->addError("End Date should be greater than the Start Date.");
								return;
							}
						}

            //GET VIEW OBJECT
            $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

            //INITIALISE VARIABLES
            $contact_string = "";
            $template_header = "";
            $template_footer = "";
            $site_title = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.general.site.title');
            $validator = new Zend_Validate_EmailAddress();
            $validator->getHostnameValidator()->setValidateTld(false);

            //ATTACH BODY
            $contact_string .= $values['body'];

            //GET SET EMAIL ADDRESS OF THE ADMIN
            $emailAdmin = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;

            //SET MESSAGESENT TO 0
            $this->view->messageSent = 0;

            //CHECK WHETHER THE TEST EMAIL HAS TO BE SENT
            if (!empty($values['event_contactemail_demo'])) {

                $contactAdminEmail = $values['event_contactemail_admin'];
                if ($validator->isValid($contactAdminEmail)) {
                    Engine_Api::_()->getApi('mail', 'core')->sendSystem($values['event_contactemail_admin'], 'SITEEVENTADMINCONTACT_CONTACTS_EMAIL_NOTIFICATION', array(
                    'subject' => $values['subject'],
                    'template_header' => $template_header,
                    'message' => $contact_string,
                    'template_footer' => $template_footer,
                    'site_title' => $site_title,
                    'email' => $emailAdmin,
                    'queue' => true));
                    $this->view->messageSent = 1;
                    $this->view->successMessge = $this->view->translate("Your test email has been sent successfully.");
                }

            } else {

                $listitemsTable = Engine_Api::_()->getItemTable('siteevent_list_item');
                $listitemsTableName = $listitemsTable->info('name');
                $eventTable = Engine_Api::_()->getDbtable('events', 'siteevent');
                $eventTableName = $eventTable->info('name');
                $listsTable = Engine_Api::_()->getItemTable('siteevent_list');
                $listsTableName = $listsTable->info('name');
                $results = $eventTable->checkEvent();
                $siteEventOccuretable = Engine_Api::_()->getDbTable('occurrences', 'siteevent');
                $siteeventOccurTableName = $siteEventOccuretable->info('name');
                if (!empty($results)) {
                    $selectChildId = $eventTable->select()->setIntegrityCheck(false)
                            ->from($eventTableName, array('owner_id'))
                            ->join($listsTableName, $eventTableName . '.event_id = ' . $listsTableName . '.owner_id', array())
                            ->join($listitemsTableName, $listsTableName . '.list_id = ' . $listitemsTableName . '.list_id', array('child_id'))
                            ->group($listitemsTableName . '.child_id')
                            ->order('child_id ASC');

                    $selectOwnerId = $eventTable->select()->setIntegrityCheck(false)
                            ->from($eventTableName, array('owner_id', 'host_id'))
                            ->group('owner_id');

                    $categories_ids = $values['categories'];
                    if (is_array($categories_ids) && !empty($categories_ids) && !empty($values['categories'][0])) {
                        $selectChildId->where('category_id IN (?)', $categories_ids);
                        $selectOwnerId->where('category_id IN (?)', $categories_ids);
                    }

                    $membershipTable = Engine_Api::_()->getDbTable('membership', 'network');
                    $membershipTableName = $membershipTable->info('name');

                    $networks_privacy = implode(',', $values['networks_privacy']);
                    if (!empty($networks_privacy)) {
                        $selectChildId->join($membershipTableName, $listitemsTableName . '.child_id = ' . $membershipTableName . '.user_id', array());
                        $selectChildId->where('resource_id in(?)', $networks_privacy);
                        $selectOwnerId->join($membershipTableName, $eventTableName . '.owner_id = ' . $membershipTableName . '.user_id', array());
                        $selectOwnerId->where('resource_id in(?)', $networks_privacy);
                    }

                    $status_ids = $values['status'];
                    if (is_array($status_ids) && (in_array("Draft", $status_ids) && in_array("Published", $status_ids) )) {
                        $selectChildId->where($eventTableName . '.draft = ?', '0')->orWhere($eventTableName . '.draft = ?', '1');
                        $selectOwnerId->where($eventTableName . '.draft = ?', '0')->orWhere($eventTableName . '.draft = ?', '1');
                    } elseif (is_array($status_ids) && in_array("Draft", $status_ids)) {
                        $selectChildId->where($eventTableName . '.draft = ?', '0');
                        $selectOwnerId->where($eventTableName . '.draft = ?', '0');
                    } elseif (is_array($status_ids) && in_array("Published", $status_ids)) {
                        $selectChildId->where($eventTableName . '.draft = ?', '1');
                        $selectOwnerId->where($eventTableName . '.draft = ?', '0');
                    }

                    if (is_array($status_ids) && (in_array("Open", $status_ids) && in_array("Cancel", $status_ids) )) {
                        $selectChildId->where($eventTableName . '.closed = ?', '0')->orWhere($eventTableName . '.closed = ?', '1');
                        $selectOwnerId->where($eventTableName . '.closed = ?', '0')->orWhere($eventTableName . '.closed = ?', '1');
                    } elseif (is_array($status_ids) && in_array("Open", $status_ids)) {
                        $selectChildId->where($eventTableName . '.closed = ?', '0');
                        $selectOwnerId->where($eventTableName . '.closed = ?', '0');
                    } elseif (is_array($status_ids) && in_array("Cancel", $status_ids)) {
                        $selectChildId->where($eventTableName . '.closed = ?', '1');
                        $selectOwnerId->where($eventTableName . '.closed = ?', '1');
                    }

                    if (is_array($status_ids) && in_array("Featured", $status_ids)) {
                        $selectChildId->where($eventTableName . '.Featured = ?', '1');
                        $selectOwnerId->where($eventTableName . '.Featured = ?', '1');
                    }

                    if (is_array($status_ids) && in_array("Sponsored", $status_ids)) {
                        $selectChildId->where($eventTableName . '.Sponsored = ?', '1');
                        $selectOwnerId->where($eventTableName . '.Sponsored = ?', '1');
                    }

                    if (is_array($status_ids) && (in_array("Approved", $status_ids) && in_array("DisApproved", $status_ids) )) {
                        $selectChildId->where($eventTableName . '.approved = ?', '0')->orWhere($eventTableName . '.approved = ?', '1');
                        $selectOwnerId->where($eventTableName . '.approved = ?', '0')->orWhere($eventTableName . '.approved = ?', '1');
                    } elseif (is_array($status_ids) && in_array("Approved", $status_ids)) {
                        $selectChildId->where($eventTableName . '.approved = ?', '1');
                        $selectOwnerId->where($eventTableName . '.approved = ?', '1');
                    } elseif (is_array($status_ids) && in_array("DisApproved", $status_ids)) {
                        $selectChildId->where($eventTableName . '.approved = ?', '0');
                        $selectOwnerId->where($eventTableName . '.approved = ?', '0');
                    }


                    if (isset($values['starttime']) && !empty($values['starttime']) || (isset($values['endtime']) && !empty($values['endtime']))) {
                        if (($values['starttime'] != '0000-00-00 01:00:00' && $values['endtime'] != '0000-00-00 01:00:00') && ($values['starttime'] != $values['endtime'])) {
                            $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                            $selectChildId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                            $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                            $selectOwnerId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                        } elseif (isset($values['starttime']) && isset($values['endtime']) && ($values['starttime'] != '0000-00-00 01:00:00') && ($values['starttime'] == $values['endtime'])) {
                            $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                            $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                        } elseif ($values['starttime'] != '0000-00-00 01:00:00') {
                            $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                            $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                        } elseif ($values['endtime'] != '0000-00-00 01:00:00') {
                            $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectChildId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                            $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                            $selectOwnerId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                        }
                    }


                    $childIds = $selectChildId->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0);
                    $ownerIds = $selectOwnerId->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0);
                    $hostIds = array();

                    if ($values['siteevent_emailhost_setting']) {
                        $selectOwnerId->where("$eventTableName.host_type = ?", 'user');
                        $hostIds = $selectOwnerId->query()->fetchAll(Zend_Db::FETCH_COLUMN, 1);
                    }

                    $eventOwnerIds = array_unique(array_merge($childIds, array_merge($hostIds, $ownerIds)));
                    foreach ($eventOwnerIds as $id) {
                        if (is_numeric($id)) {
                            $email = Engine_Api::_()->getItem('user', $id)->email;
                            if (!$validator->isValid($email)) {
                                continue;
                            }

                            if (!empty($email)) {
                                Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, 'SITEEVENTADMINCONTACT_CONTACTS_EMAIL_NOTIFICATION', array(
                                    'subject' => $values['subject'],
                                    'template_header' => $template_header,
                                    'message' => $contact_string,
                                    'template_footer' => $template_footer,
                                    'site_title' => $site_title,
                                    'email' => $emailAdmin,
                                    'queue' => true
                                ));
                            }
                        }
                    }

                    //GET ADMIN INFO
                    $fromAddress = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.mail.from', 'admin@' . $_SERVER['HTTP_HOST']);
                    $fromName = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.mail.name', 'Site Admin');

                    //GET MAIL CORE TABLE
                    $mailApi = Engine_Api::_()->getApi('mail', 'core');
                    $mailComplete = $mailApi->create();
                    $mailComplete
                            ->addTo(Engine_Api::_()->user()->getViewer()->email)
                            ->setFrom($fromAddress, $fromName)
                            ->setSubject('Mailing Complete: ' . $values['subject'])
                            ->setBodyHtml('Your email blast to your members has completed.  Please note that, while the emails have been
              sent to the recipients\' mail server, there may be a delay in them actually receiving the email due to
              spam filtering systems, incoming mail throttling features, and other systems beyond SocialEngine\'s control.')
                    ;
                    $mailApi->send($mailComplete);
                    $this->view->messageSent = 1;
                    $this->view->successMessge = $this->view->translate("Your emails have been queued for sending.");
                } else {
                    $this->view->messageSent = 1;
                    $this->view->successMessge = $this->view->translate("Your email can not be sent because no Events have been created yet.");
                }
            }
            foreach ($values as $key => $value) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
            }
// 			//START LANGUAGE WORK
// 			Engine_Api::_()->getApi('language', 'siteevent')->languageChanges();
// 			//END LANGUAGE WORK
        }
    }

    //ACTION FOR FAQ
    public function faqAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteeventadmincontact_admin_main', array(), 'siteeventadmincontact_admin_main_faq');
    }

    //ACTION FOR README
    public function readmeAction() {
        
    }

    //ACTION FOR UPLOADING THE IMAGES
    public function uploadPhotoAction() {

        //GET THE DIRECTORY WHERE WE ARE UPLOADING THE PHOTOS
        $adminContactFile = APPLICATION_PATH . '/public/eventadmincontact';

        if (!is_dir($adminContactFile) && mkdir($adminContactFile, 0777, true)) {
            chmod($adminContactFile, 0777);
        }

        //GET THE PATH
        $path = realpath($adminContactFile);
        $fileName = Engine_Api::_()->seaocore()->tinymceEditorPhotoUploadedFileName();
        //PREPARE
        if (empty($_FILES[$fileName])) {
            $this->view->error = 'File failed to upload. Check your server settings (such as php.ini max_upload_filesize).';
            return;
        }

        //GET PHOTO INFORMATION
        $info = $_FILES[$fileName];

        //SET TARGET FILE
        $targetFile = $path . '/' . $info['name'];

        //TRY TO MOVE UPLOADED FILE
        if (!move_uploaded_file($info['tmp_name'], $targetFile)) {
            $this->view->error = Zend_Registry::get('Zend_Translate')->_("Unable to move file to upload directory.");
            return;
        }

        //SEND THE STATUS TO THE TPl
        $this->view->status = true;

        //SEND THE PHOTO URL TO THE TPl
        $this->view->photo_url = 'http://' . $_SERVER['HTTP_HOST'] . '/' . Zend_Controller_Front::getInstance()->getBaseUrl() . '/public/eventadmincontact/' . $info['name'];
    }

}
