<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventadmincontact
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: IndexController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventadmincontact_IndexController extends Core_Controller_Action_Standard {

    //ACION FOR SENDING THE MESSAGE
    public function indexAction() {

        //GET VIEWER
        $viewer = Engine_Api::_()->user()->getViewer();

        //GET VIEWER ID
        $viewer_id = $viewer->getIdentity();

        //GET USER LEVEL
        if (!empty($viewer_id)) {
            $level_id = Engine_Api::_()->user()->getViewer()->level_id;
        } else {
            $level_id = 0;
        }

        //IF SUPERADMIN,ADMIN IS NOT THERE THEN RETURN THE PRIVATE EVENT
        if (empty($level_id)) {
            return $this->_forward('requireauth', 'error', 'core');
        }

        //IF SUPERADMIN,ADMIN IS NOT THERE THEN RETURN THE PRIVATE EVENT
        if ($level_id != 1 && $level_id != 2) {
            return $this->_forward('requireauth', 'error', 'core');
        }
        $this->view->results = $results = Engine_Api::_()->getDbtable('events', 'siteevent')->checkEvent();
        if (!empty($results)) {
            //MAKE FORM
            $this->view->form = $form = new Siteeventadmincontact_Form_Compose();
        }

        //ASSIGN THE COMPOSING STUFF
        $composePartials = array();
        foreach (Zend_Registry::get('Engine_Manifest') as $data) {
            if (empty($data['composer']))
                continue;
            foreach ($data['composer'] as $type => $config) {
                $composePartials[] = $config['script'];
            }
        }
        $this->view->composePartials = $composePartials;

        //GET PACKAGE ID
        $networks_privacy = $this->_getParam('networks_privacy');

        //MAKE PACKAGE ID ARRAY
        $networks_privacy_array = explode(",", trim($networks_privacy, ","));

        //GET CATEGORIES ID
        $categories_id = $this->_getParam('categories_id');

        //GET CATEGORIES ID ARRAY
        $categories_id_array = explode(",", trim($categories_id, ","));

        //GET CATEGORIES ID
        $status = $this->_getParam('status');
        $host_message = $this->_getParam('host_message');
        //GET CATEGORIES ID ARRAY
        $status_id_array = explode(",", trim($status, ","));

        //GET CATEGORIES ID
        $values = array();
        $values['starttime'] = $starttime = $this->_getParam('starttime');
        $values['endtime'] = $endtime = $this->_getParam('endtime');

        //GET EVENT TABLE NAME
        $eventTableName = Engine_Api::_()->getDbtable('events', 'siteevent')->info('name');

        //PROCESS
        $db = Engine_Api::_()->getDbtable('messages', 'messages')->getAdapter();
        $db->beginTransaction();

        try {
            //RY ATTACHMENT GETTING STUFF
            $attachment = null;
            $attachmentData = $this->getRequest()->getParam('attachment');
            if (!empty($attachmentData) && !empty($attachmentData['type'])) {
                $type = $attachmentData['type'];
                $config = null;
                foreach (Zend_Registry::get('Engine_Manifest') as $data) {
                    if (!empty($data['composer'][$type])) {
                        $config = $data['composer'][$type];
                    }
                }
                if ($config) {
                    $plugin = Engine_Api::_()->loadClass($config['plugin']);
                    $method = 'onAttach' . ucfirst($type);
                    $attachment = $plugin->$method($attachmentData);
                    $parent = $attachment->getParent();
                    if ($parent->getType() === 'user') {
                        $attachment->search = 0;
                        $attachment->save();
                    } else {
                        $parent->search = 0;
                        $parent->save();
                    }
                }
            }

            //CHECK METHOD / DATA
            if (!$this->getRequest()->isPost()) {
                return;
            }

            //CHECK METHOD / DATA
            if (!$form->isValid($this->getRequest()->getPost())) {
                return;
            }

						if (isset($values['starttime']) && !empty($values['starttime']) || (isset($values['endtime']) && !empty($values['endtime']))) {
							$starttimeExplode = explode(' ', $values['starttime']);
              $endtimeExplode = explode(' ', $values['endtime']);
							if($endtimeExplode[0] < $starttimeExplode[0] ) {
								$form->addError("End Date should be greater than the Start Date.");
								return;
							}
						}

            $listitemsTable = Engine_Api::_()->getItemTable('siteevent_list_item');
            $listitemsTableName = $listitemsTable->info('name');
            $eventTable = Engine_Api::_()->getDbtable('events', 'siteevent');
            $eventTableName = $eventTable->info('name');
            $listsTable = Engine_Api::_()->getItemTable('siteevent_list');
            $listsTableName = $listsTable->info('name');
            $results = $eventTable->checkEvent();
            $siteEventOccuretable = Engine_Api::_()->getDbTable('occurrences', 'siteevent');
            $siteeventOccurTableName = $siteEventOccuretable->info('name');
            //GET FORM VALUES
            $values = array_merge($values, $form->getValues());

            $selectChildId = $eventTable->select()->setIntegrityCheck(false)
                    ->from($eventTableName, array())
                    ->join($listsTableName, $eventTableName . '.event_id = ' . $listsTableName . '.owner_id', array())
                    ->join($listitemsTableName, $listsTableName . '.list_id = ' . $listitemsTableName . '.list_id', array('child_id'))
                    ->where($listitemsTableName . '.child_id <> (?)', $viewer_id)
                    ->group($listitemsTableName . '.child_id')
                    ->order('child_id ASC');

            $selectOwnerId = $eventTable->select()->setIntegrityCheck(false)
                    ->from($eventTableName, array('owner_id', 'host_id'))
                    ->where($eventTableName . '.owner_id <> (?)', $viewer_id)
                    ->group('owner_id');

            if (is_array($categories_id_array) && !empty($categories_id_array) && !empty($categories_id_array[0])) {
                $selectChildId->where('category_id IN (?)', $categories_id_array);
                $selectOwnerId->where('category_id IN (?)', $categories_id_array);
            }

            $membershipTable = Engine_Api::_()->getDbTable('membership', 'network');
            $membershipTableName = $membershipTable->info('name');

            if (is_array($networks_privacy_array) && !empty($networks_privacy_array) && !empty($networks_privacy_array[0])) {
                $selectChildId->join($membershipTableName, $listitemsTableName . '.child_id = ' . $membershipTableName . '.user_id', array());
                $selectChildId->where('resource_id in(?)', $networks_privacy_array);
                $selectOwnerId->join($membershipTableName, $eventTableName . '.owner_id = ' . $membershipTableName . '.user_id', array());
                $selectOwnerId->where('resource_id in(?)', $networks_privacy_array);
            }
            $status_ids = $status_id_array;
            // $status_ids = $values['status'];
            if (is_array($status_ids) && (in_array("Draft", $status_ids) && in_array("Published", $status_ids) )) {
                $selectChildId->where($eventTableName . '.draft = ?', '0')->orWhere($eventTableName . '.draft = ?', '1');
                $selectOwnerId->where($eventTableName . '.draft = ?', '0')->orWhere($eventTableName . '.draft = ?', '1');
            } elseif (is_array($status_ids) && in_array("Draft", $status_ids)) {
                $selectChildId->where($eventTableName . '.draft = ?', '0');
                $selectOwnerId->where($eventTableName . '.draft = ?', '0');
            } elseif (is_array($status_ids) && in_array("Published", $status_ids)) {
                $selectChildId->where($eventTableName . '.draft = ?', '1');
                $selectOwnerId->where($eventTableName . '.draft = ?', '0');
            }

            if (is_array($status_ids) && (in_array("Open", $status_ids) && in_array("Cancel", $status_ids) )) {
                $selectChildId->where($eventTableName . '.closed = ?', '0')->orWhere($eventTableName . '.closed = ?', '1');
                $selectOwnerId->where($eventTableName . '.closed = ?', '0')->orWhere($eventTableName . '.closed = ?', '1');
            } elseif (is_array($status_ids) && in_array("Open", $status_ids)) {
                $selectChildId->where($eventTableName . '.closed = ?', '0');
                $selectOwnerId->where($eventTableName . '.closed = ?', '0');
            } elseif (is_array($status_ids) && in_array("Cancel", $status_ids)) {
                $selectChildId->where($eventTableName . '.closed = ?', '1');
                $selectOwnerId->where($eventTableName . '.closed = ?', '1');
            }

            if (is_array($status_ids) && in_array("Featured", $status_ids)) {
                $selectChildId->where($eventTableName . '.Featured = ?', '1');
                $selectOwnerId->where($eventTableName . '.Featured = ?', '1');
            }

            if (is_array($status_ids) && in_array("Sponsored", $status_ids)) {
                $selectChildId->where($eventTableName . '.Sponsored = ?', '1');
                $selectOwnerId->where($eventTableName . '.Sponsored = ?', '1');
            }

            if (is_array($status_ids) && (in_array("Approved", $status_ids) && in_array("DisApproved", $status_ids) )) {
                $selectChildId->where($eventTableName . '.approved = ?', '0')->orWhere($eventTableName . '.approved = ?', '1');
                $selectOwnerId->where($eventTableName . '.approved = ?', '0')->orWhere($eventTableName . '.approved = ?', '1');
            } elseif (is_array($status_ids) && in_array("Approved", $status_ids)) {
                $selectChildId->where($eventTableName . '.approved = ?', '1');
                $selectOwnerId->where($eventTableName . '.approved = ?', '1');
            } elseif (is_array($status_ids) && in_array("DisApproved", $status_ids)) {
                $selectChildId->where($eventTableName . '.approved = ?', '0');
                $selectOwnerId->where($eventTableName . '.approved = ?', '0');
            }

            if (isset($values['starttime']) && !empty($values['starttime']) || (isset($values['endtime']) && !empty($values['endtime']))) {
                if (($values['starttime'] != '0000-00-00 01:00:00' && $values['endtime'] != '0000-00-00 01:00:00') && ($values['starttime'] != $values['endtime'])) {
                    $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                    $selectChildId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                    $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                    $selectOwnerId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                } elseif (isset($values['starttime']) && isset($values['endtime']) && ($values['starttime'] != '0000-00-00 01:00:00') && ($values['starttime'] == $values['endtime'])) {
                    $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                    $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                } elseif ($values['starttime'] != '0000-00-00 01:00:00') {
                    $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectChildId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                    $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectOwnerId->where("$siteeventOccurTableName.starttime >= FROM_UNIXTIME(?)", strtotime($values['starttime']));
                } elseif ($values['endtime'] != '0000-00-00 01:00:00') {
                    $selectChildId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectChildId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                    $selectOwnerId->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array());
                    $selectOwnerId->where("$siteeventOccurTableName.endtime <= FROM_UNIXTIME(?)", strtotime($values['endtime']));
                }
            }

            $childIds = $selectChildId->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0);
            $ownerIds = $selectOwnerId->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0);

            $hostIds = array();

            if ($host_message) {
                $selectOwnerId->where("$eventTableName.host_type = ?", 'user');
                $hostIds = $selectOwnerId
                                ->where($eventTableName . '.host_id <> (?)', $viewer_id)->query()->fetchAll(Zend_Db::FETCH_COLUMN, 1);
            }
            $eventOwnerIds = array_unique(array_merge($childIds, array_merge($hostIds, $ownerIds)));

//       //GET USER IDS
//       $user_ids = $select->query()->fetchAll();
            if (!empty($eventOwnerIds)) {

                //GET USER
                $recipientsUsers = Engine_Api::_()->getItemMulti('user', $eventOwnerIds);

                //CREATE CONVERSATION
                $conversation = Engine_Api::_()->getItemTable('messages_conversation')->send(
                        $viewer, $eventOwnerIds, $values['title'], $values['body'], $attachment
                );

                //SEND NOTIFICATIONS
                foreach ($recipientsUsers as $user) {
                    if ($user->getIdentity() == $viewer->getIdentity()) {
                        continue;
                    }
                    Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification(
                            $user, $viewer, $conversation, 'message_new'
                    );
                }
            }

            // INCREMENT MESSAGE COUNTER
            Engine_Api::_()->getDbtable('statistics', 'core')->increment('messages.creations');

            //COMMIT
            $db->commit();

            return $this->_forward('success', 'utility', 'core', array(
                        'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your message has been sent successfully.')),
                        'smoothboxClose' => true,
                        'parentRefreshTime' => '60',
                        'parentRefresh' => 'true',
                        'format' => 'smoothbox'
            ));
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }

}
