<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFieldsController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventdocument_AdminFieldsController extends Fields_Controller_AdminAbstract {

    protected $_fieldType = 'siteeventdocument_document';
    protected $_requireProfileType = false;

    //ACTION FOR MANAGE CUSTOM FIELDS
    public function indexAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main_document', array(), 'siteeventdocument_admin_main_fields');

        //GET NAVIGATION
        $this->view->navigationEvent = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main', array(), 'siteevent_admin_main_document');

        parent::indexAction();
    }

    //ACTION FOR CREATING NEW FIELD
    public function fieldCreateAction() {

        include APPLICATION_PATH . '/application/modules/Siteeventdocument/controllers/license/license2.php';

        //GET FORM
        $form = $this->view->form;

        if ($form) {
            $form->setTitle('Add Event document Question');

            $form->removeElement('show');
            $form->addElement('hidden', 'show', array('value' => 0));

            $display = $form->getElement('display');
            $display->setLabel('Show on document page?');
            $display->setOptions(array('multiOptions' => array(
                    1 => 'Show on document page',
                    0 => 'Hide on document page'
            )));

            $form->addElement('hidden', 'search', array(
                'label' => 'Show on the search options?',
                'multiOptions' => array(
                    1 => 'Hide on the search options',
                    0 => 'Show on the search options'
                ),
                'value' => 1,
            ));
        }
    }

    //ACTION FOR EDIT THE FIELD
    public function fieldEditAction() {

        parent::fieldEditAction();

        //GET FORM
        $form = $this->view->form;

        if ($form) {
            $form->setTitle('Edit Event document Question');

            $form->removeElement('show');
            $form->addElement('hidden', 'show', array('value' => 0));

            $display = $form->getElement('display');
            $display->setLabel('Show on document page?');
            $display->setOptions(array('multiOptions' => array(
                    1 => 'Show on document page',
                    0 => 'Hide on document page'
            )));

            $form->addElement('hidden', 'search', array(
                'label' => 'Show on the search options?',
                'multiOptions' => array(
                    1 => 'Hide on the search options',
                    0 => 'Show on the search options'
                ),
                'value' => 1,
            ));
        }
    }

}