<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Siteeventdocument/Api/Scribdsiteevent.php';

class Siteeventdocument_AdminSettingsController extends Core_Controller_Action_Admin {

    //ACTION FOR GLOBAL SETTINGS
    public function indexAction() {

        if (isset($_POST['siteeventdocument_api_key']) && !empty($_POST['siteeventdocument_api_key'])) {
            $_POST['siteeventdocument_api_key'] = trim($_POST['siteeventdocument_api_key']);
        }

        if (isset($_POST['siteeventdocument_secret_key']) && !empty($_POST['siteeventdocument_secret_key'])) {
            $_POST['siteeventdocument_secret_key'] = trim($_POST['siteeventdocument_secret_key']);
        }

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main_document', array(), 'siteeventdocument_admin_main_settings');

        //GET NAVIGATION
        $this->view->navigationEvent = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteevent_admin_main', array(), 'siteevent_admin_main_document');

        // generate the form
        $this->view->form = $form = new Siteeventdocument_Form_Admin_Settings_Global();

        $values = $this->getRequest()->getPost();
        $scribd_check = 0;
        if (!empty($values)) {
            $api_key = $values['siteeventdocument_api_key'];
            $secreat_key = $values['siteeventdocument_secret_key'];
            $scribd_check = $this->checkscribd($api_key, $secreat_key);
            if (empty($scribd_check)) {
                if (!empty($values['siteeventdocument_default_visibility']) && ($values['siteeventdocument_default_visibility'] == 'public') && !empty($values['siteeventdocument_secure_allow'])) {
                    $error = $this->view->translate('_SITEEVENTDOCUMENT_VISIBILITY_SECURE_IPAPER_MESSAGE');
                    $error = Zend_Registry::get('Zend_Translate')->_($error);

                    $form->getDecorator('errors')->setOption('escape', false);
                    $form->addError($error);
                    return;
                }

                include APPLICATION_PATH . '/application/modules/Siteeventdocument/controllers/license/license2.php';
                $this->_helper->redirector->gotoRoute(array('route' => 'admin-default'));
            } else {
                $scribd_error = $scribd_check;
                $scribd_error = Zend_Registry::get('Zend_Translate')->_($scribd_error);
                $form->addError($scribd_error);
                return;
            }
        }
    }

    //FUNCTION FOR CHECK SCRIBD DETAIL
    public function checkscribd($api_key, $secreat_key) {
        $this->scribdsiteevent = new Scribdsiteevent($api_key, $secreat_key);
        try {
            $result = $this->scribdsiteevent->getList();
        } catch (Exception $e) {
            $is_error = 1;
            $code = $e->getCode();
            if ($code == 401) {
                $message = $e->getMessage();

                $error = $message . $this->view->translate(': Api key is not correct');
                return $error;
            }
        }
    }

    //ACTION FOR FAQ
    public function faqAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('siteeventdocument_admin_main', array(), 'siteeventdocument_admin_main_faq');

        $this->view->show = $this->_getParam('show');
    }
}