<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventdocument_Installer extends Engine_Package_Installer_Module {

    function onPreInstall() {
        $getErrorMsg = $this->getVersion(); 
        if (!empty($getErrorMsg)) {
          return $this->_error($getErrorMsg);
        } 
        
        $db = $this->getDb();

        //CHECK THAT SITEEVENT PLUGIN IS ACTIVATED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteevent.isActivate')
                ->limit(1);
        $siteevent_settings = $select->query()->fetchAll();
        if (!empty($siteevent_settings)) {
            $siteevent_is_active = 1;
        } else {
            $siteevent_is_active = 0;
        }

        //CHECK THAT SITEEVENT PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'siteevent')
                ->where('enabled = ?', 1);
        $check_siteevent = $select->query()->fetchObject();
        if (!empty($check_siteevent) && !empty($siteevent_is_active)) {
            $PRODUCT_TYPE = 'siteeventdocument';
            $PLUGIN_TITLE = 'Siteeventdocument';
            $PLUGIN_VERSION = '5.5.0';
            $PLUGIN_CATEGORY = 'plugin';
            $PRODUCT_DESCRIPTION = 'Advanced Events - Documents Extension';
            $_PRODUCT_FINAL_FILE = 0;
            $SocialEngineAddOns_version = '4.8.0p1';
            $PRODUCT_TITLE = 'Advanced Events - Documents Extension';
            $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
            $is_file = @file_exists($file_path);

            if (empty($is_file)) {
                include APPLICATION_PATH . "/application/modules/Siteevent/controllers/license/license3.php";
            } else {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
                $is_Mod = $select->query()->fetchObject();
                if (empty($is_Mod)) {
                    include_once $file_path;
                }
            }
            parent::onPreinstall();
        } elseif (!empty($check_siteevent) && empty($siteevent_is_active)) {
            $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
            $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
            if (strstr($url_string, "manage/install")) {
                $calling_from = 'install';
            } else if (strstr($url_string, "manage/query")) {
                $calling_from = 'queary';
            }
            $explode_base_url = explode("/", $baseUrl);
            foreach ($explode_base_url as $url_key) {
                if ($url_key != 'install') {
                    $core_final_url .= $url_key . '/';
                }
            }

            return $this->_error("<span style='color:red'>Note: You have installed the 'Advanced Events Plugin' but not activated it on your site yet. Please activate it first before installing the 'Advanced Events - Documents Extension'.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/siteevent/settings/readme'>Click here</a> to activate the Advanced Events Plugin.");
        } else {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
            return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-advanced-events-plugin' target='_blank'>Advanced Events Plugin</a> on your site yet. Please install it first before installing the 'Advanced Events - Documents Extension'.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteeventdocument.code.share');
        $siteeventdocument_code_share = $select->query()->fetchObject();
        if (empty($siteeventdocument_code_share)) {
            $social_share_default_code = '<div class="addthis_toolbox addthis_default_style ">
			<a class="addthis_button_preferred_1"></a>
			<a class="addthis_button_preferred_2"></a>
			<a class="addthis_button_preferred_3"></a>
			<a class="addthis_button_preferred_4"></a>
			<a class="addthis_button_preferred_5"></a>
			<a class="addthis_button_compact"></a>
			<a class="addthis_counter addthis_bubble_style"></a>
			</div>
			<script type="text/javascript">
			var addthis_config = {
								services_compact: "facebook, twitter, linkedin, google, digg, more",
								services_exclude: "print, email"
			}
			</script>
			<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js"></script>';

            $db->insert('engine4_core_settings', array(
                'name' => 'siteeventdocument.code.share',
                'value' => $social_share_default_code,
            ));
        }

        parent::onPreInstall();
    }

    function onInstall() {
        $db = $this->getDb();
        
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')
               ->where('name = ?', 'siteeventdocument')
               ->where('version <= ?', '4.8.8p5');
        $is_enabled = $select->query()->fetchObject();
        if (!empty($is_enabled)) {
            $db->query("UPDATE `engine4_siteeventdocument_documents` SET `thumbnail` = REPLACE(thumbnail, 'http:', 'https:') WHERE `thumbnail` Like 'http:%'");
        }             

        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='siteeventdocument';");

        $select = new Zend_Db_Select($db);
        $advancedactivity = $select->from('engine4_core_modules', 'name')
                ->where('name = ?', 'advancedactivity')
                ->query()
                ->fetchcolumn();

        $is_enabled = $select->query()->fetchObject();
        if (!empty($is_enabled)) {
					$db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_grouped`, `is_object_thumb`) VALUES ("siteeventdocument_new_parent", "siteeventdocument", \'{itemParent:$object} created a new document in the event {item:$object}:\', "1", "2", "2", "1", "1", "1", "0", "2");');
				} else {
					$db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("siteeventdocument_new", "siteeventdocument", \'{item:$subject} added a new document to the event {item:$object:$title}: {body:$body}\', "1", "3", "2", "1", "1", "1");');
				}
        //CHECK THAT SITEEVENT PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'siteevent')
                ->where('enabled = ?', 1);
        $check_siteevent = $select->query()->fetchObject();
        if (!empty($check_siteevent)) {

            //CODE FOR INCREASE THE SIZE OF engine4_authorization_permissions's FIELD type
            $type_array = $db->query("SHOW COLUMNS FROM engine4_authorization_permissions LIKE 'type'")->fetch();
            if (!empty($type_array)) {
                $varchar = $type_array['Type'];
                $length_varchar = explode("(", $varchar);
                $length = explode(")", $length_varchar[1]);
                $length_type = $length[0];
                if ($length_type < 32) {
                    $run_query = $db->query("ALTER TABLE `engine4_authorization_permissions` CHANGE `type` `type` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
                }
            }

            //START: PUT DOCUMENT TAB AUTOMATICALLY AT SITEEVENT PROFILE PAGE
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);

            $select
                    ->from('engine4_core_pages')
                    ->where('name = ?', 'siteevent_index_view')
                    ->limit(1);
            $page_id = $select->query()->fetchObject()->page_id;
            if (!empty($page_id)) {

                $select = new Zend_Db_Select($db);
                $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'siteeventdocument.profile-siteeventdocuments')
                        ->limit(1);
                if(!empty($select_content->query()->fetchObject())){
                    $content_id = $select_content->query()->fetchObject()->content_id;
                }
                if (empty($content_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_container = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'container')
                            ->limit(1);
                    $container_id = $select_container->query()->fetchObject()->content_id;
                    if (!empty($container_id)) {
                        $select = new Zend_Db_Select($db);
                        $select_middle = $select
                                ->from('engine4_core_content')
                                ->where('parent_content_id = ?', $container_id)
                                ->where('type = ?', 'container')
                                ->where('name = ?', 'middle')
                                ->limit(1);
                        $middle_id = $select_middle->query()->fetchObject()->content_id;
                        if (!empty($middle_id)) {
                            $select = new Zend_Db_Select($db);
                            $select_tab = $select
                                    ->from('engine4_core_content')
                                    ->where('type = ?', 'widget')
                                    ->where('name = ?', 'core.container-tabs')
                                    ->where('page_id = ?', $page_id)
                                    ->limit(1);
                            $tab_id = $select_tab->query()->fetchObject()->content_id;

                            $db->insert('engine4_core_content', array(
                                'page_id' => $page_id,
                                'type' => 'widget',
                                'name' => 'siteeventdocument.profile-siteeventdocuments',
                                'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                                'order' => 999,
                                'params' => '{"title":"Documents","titleCount":true}',
                            ));
                        }
                    }
                }
            }
            //END: PUT DOCUMENT TAB AUTOMATICALLY AT SITEEVENT PROFILE PAGE
            //START DOCUMENT VIEW PAGE WORK
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_core_pages')
                    ->where('name = ?', 'siteeventdocument_index_view')
                    ->limit(1);

            $info = $select->query()->fetch();

            if (empty($info)) {
                //CREATE PAGE IF NOT EXIST
                $db->insert('engine4_core_pages', array(
                    'name' => 'siteeventdocument_index_view',
                    'displayname' => 'Advanced Events - Document View Page',
                    'title' => 'Advanced Events - Document View Page',
                    'description' => 'This is the event document view page.',
                    'custom' => 0,
                    'layout' => 'default',
                ));
                $page_id = $db->lastInsertId('engine4_core_pages');

                //MAIN CONTAINER
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'container',
                    'name' => 'main',
                    'parent_content_id' => null,
                    'order' => 2,
                    'params' => '',
                ));
                $main_container_id = $db->lastInsertId('engine4_core_content');

                //RIGHT CONTAINER
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'container',
                    'name' => 'right',
                    'parent_content_id' => $main_container_id,
                    'order' => 5,
                    'params' => '',
                ));
                $right_container_id = $db->lastInsertId('engine4_core_content');

                //MAIN MIDDLE CONTAINER
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'container',
                    'name' => 'middle',
                    'parent_content_id' => $main_container_id,
                    'order' => 6,
                    'params' => '',
                ));
                $main_middle_container_id = $db->lastInsertId('engine4_core_content');

                //DOCUMENT VIEWER WINDOW WIDGET
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'siteeventdocument.content-siteeventdocuments',
                    'parent_content_id' => $main_middle_container_id,
                    'order' => 3,
                    'params' => '{"title":"","titleCount":true,"statistics":["viewCount","likeCount","commentCount"],"documentViewerHeight":"600","documentViewerWidth":"830","nomobile":"","name":"siteeventdocument.content-siteeventdocuments"}',
                ));

                //DOCUMENT OWNER PHOTO WIDGET
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'siteeventdocument.owner-photo-siteeventdocuments',
                    'parent_content_id' => $right_container_id,
                    'order' => 5,
                    'params' => '',
                ));

                //DOCUMENT OPTIONS WIDGET
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'siteeventdocument.options-siteeventdocuments',
                    'parent_content_id' => $right_container_id,
                    'order' => 6,
                    'params' => '',
                ));

                //DOCUMENT OPTIONS WIDGET
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'siteeventdocument.documents-siteeventdocuments',
                    'parent_content_id' => $right_container_id,
                    'order' => 7,
                    'params' => '{"title":"%s\'s Documents","popularity":"document_id","statistics":["viewCount","likeCount","commentCount"],"truncationTitle":"18","itemCount":"5","nomobile":"0","name":"siteeventdocument.documents-siteeventdocuments"}',
                ));

                //SOCIAL SHARE BUTTONS WIDGET
                $db->insert('engine4_core_content', array(
                    'page_id' => $page_id,
                    'type' => 'widget',
                    'name' => 'siteeventdocument.socialshare-siteeventdocuments',
                    'parent_content_id' => $right_container_id,
                    'order' => 9,
                    'params' => '{"title":"Social Share"}',
                ));
            }
            //END DOCUMENT VIEW PAGE WORK            

            parent::onInstall();
        }
    }

    function onEnable() {

        $db = $this->getDb();

        $db->update('engine4_core_menuitems', array('enabled' => 1), array('name = ?' => 'siteevent_admin_main_document'));

        parent::onEnable();
    }

    function onDisable() {

        $db = $this->getDb();

        $db->update('engine4_core_menuitems', array('enabled' => 0), array('name = ?' => 'siteevent_admin_main_document'));

        parent::onDisable();
    }

  public function onPostInstall() {

     //SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL
        $moduleName = 'siteeventdocument';
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES
('$moduleName','1')");
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_sitemobile_modules')
                    ->where('name = ?', $moduleName)
                    ->where('integrated = ?', 0);
            $is_sitemobile_object = $select->query()->fetchObject();
            if ($is_sitemobile_object) {
                $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
                $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
                if ($controllerName == 'manage' && $actionName == 'install') {
                    $view = new Zend_View();
                    $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/' . $moduleName . '/integrated/0/redirect/install');
                }
            }
        }
        //END - SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL

		//WORK FOR THE WORD CHANGES IN THE ADVANCED EVENT PLUGIN .CSV FILE.
		$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
		$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
		if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
			$view = new Zend_View();
			$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
			$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
			if ($actionName == 'install') {
				$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/install');
			} else {
				$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/query');
			}
		}
    
  }
  
  private function getVersion() {

        $db = $this->getDb();

        $errorMsg = '';
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitemobile' => '4.8.0p1',
        );

        $finalModules = array();
        foreach ($modArray as $key => $value) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')
                    ->where('name = ?', "$key")
                    ->where('enabled = ?', 1);
            $isModEnabled = $select->query()->fetchObject();
            if (!empty($isModEnabled)) {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules', array('title', 'version'))
                        ->where('name = ?', "$key")
                        ->where('enabled = ?', 1);
                $getModVersion = $select->query()->fetchObject();

                $isModSupport = $this->checkVersion($getModVersion->version, $value);
                if (empty($isModSupport)) {
                    $finalModules[] = $getModVersion->title;
                }
            }
        }

        foreach ($finalModules as $modArray) {
            $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Mobile / Tablet Plugin".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }
    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }    
}
