<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Siteeventdocument/Api/Scribdsiteevent.php';

class Siteeventdocument_Widget_ContentSiteeventdocumentsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        //DON'T RENDER IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject('siteeventdocument_document')) {
            return $this->setNoRender();
        }

        //GET LOGGED IN USER INFORMATION
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

        $this->view->documentViewerHeight = $this->_getParam('documentViewerHeight', 600);
        $this->view->documentViewerWidth = $this->_getParam('documentViewerWidth', 730);
        $this->view->statistics = $this->_getParam('statistics', array("likeCount", "commentCount", "viewCount"));
        $siteeventdocumentEventsContents = Zend_Registry::isRegistered('siteeventdocumentEventsContents') ? Zend_Registry::get('siteeventdocumentEventsContents') : null;

        //GET USER LEVEL
        if (!empty($viewer_id)) {
            $level_id = Engine_Api::_()->user()->getViewer()->level_id;
        } else {
            $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }

        //GET DOCUMNET MODEL
        $this->view->siteeventdocument = $siteeventdocument = Engine_Api::_()->core()->getSubject();

        $this->view->tab_selected_id = Engine_Api::_()->siteeventdocument()->getTabId();

        //GET SITEEVENT OBJECT
        $this->view->siteevent = $siteevent = Engine_Api::_()->getItem('siteevent_event', $siteeventdocument->event_id);

        //WHO CAN COMMENT THIS DOCUMENT
        $this->view->can_comment = 1;
        if ($level_id != 1) {
            $this->view->can_comment = $siteevent->authorization()->isAllowed(null, 'comment');
        }

        //CHECK THAT VIEWER CAN RATE THE DOCUMENT OR NOT
        $this->view->can_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.rating', 1);

        //CHECK THAT VIEWER CAN SHARE THE DOCUMENT OR NOT
        $this->view->can_share = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.share', 1);

        //GET OWNER INFORMATION
        $this->view->owner = $owner = $siteeventdocument->getOwner();

        //GET CURRENT URL
        $front = Zend_Controller_Front::getInstance();
        if (!empty($this->view->https)) {
            $curr_url = 'https://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
        } else {
            $curr_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
        }
        $this->view->curr_url = urlencode((string) $curr_url);

        //INCREMENT DOCUMENT VIEWS IF VIEWER IS NOT OWNER
        if (!$owner->isSelf($viewer)) {
            $siteeventdocument->view_count++;
        }

        if (empty($siteeventdocumentEventsContents))
            return $this->setNoRender();

        //SET SCRIBD API AND SCECRET KEY
        $scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->siteeventdocument_api_key;
        $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->siteeventdocument_secret_key;
        $scribdsiteevent = new Scribdsiteevent($scribd_api_key, $scribd_secret);
        $scribdsiteevent->my_user_id = $siteeventdocument->owner_id;

        $stat = null;
        if (!empty($siteeventdocument->doc_id)) {
            try {
                $stat = trim($scribdsiteevent->getConversionStatus($siteeventdocument->doc_id));
            } catch (Exception $e) {
                $message = $e->getMessage();
                $this->view->excep_error = 1;
                $this->view->excep_message = $message;
            }
        }

        //GET EMAIL, DOWNLOAD AND FORMAT SETTINGS

        $this->view->download_allow = $download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.download.allow', 1);
        $download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.download.format', 'pdf');

        if (!empty($viewer_id)) {
            if ($download_allow && $stat == 'DONE' && $siteeventdocument->download_allow) {
                try {
                    $link = $scribdsiteevent->getDownloadUrl($siteeventdocument->doc_id, $download_format);
                } catch (Exception $e) {
                    $message = $e->getMessage();
                    $this->view->excep_error = 1;
                    $this->view->excep_message = $message;
                }
                $this->view->link = trim($link['download_link']);
                $siteeventdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.include.full.text', 1);
                if ($siteeventdocument_include_full_text == 1) {
                    $doc_full_text = $siteeventdocument->fulltext;
                    $this->view->doc_full_text = $doc_full_text;
                }
            }
        } else { //We show full text in case of nonlogged in user if document is available for downloading and Admin had allowd for full text in global settings
            if ($stat == 'DONE') {
                $siteeventdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.include.full.text', 1);
                $siteeventdocument_visitor_fulltext = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.visitor.fulltext', 1);
                if ($siteeventdocument_include_full_text == 1 && $siteeventdocument_visitor_fulltext == 1 && $siteeventdocument->download_allow) {
                    $doc_full_text = $siteeventdocument->fulltext;
                    $this->view->doc_full_text = $doc_full_text;
                }
            }
        }

        //IF STAT IS DONE THAN UPDATE DOCUMENT STATUS AND OTHER INFORMATION
        if ($stat == 'DONE') {
            try {
                //GETTING DOCUMENT'S FULL TEXT
                $texturl = $scribdsiteevent->getDownloadUrl($siteeventdocument->doc_id, 'txt');
                if ($siteeventdocument->status != 1) {
                    $texturl = trim($texturl['download_link']);
                    $file_contents = file_get_contents($texturl);
                    if (empty($file_contents)) {
                        $site_url = $texturl;
                        $ch = curl_init();
                        $timeout = 0; //set to zero for no timeout
                        curl_setopt($ch, CURLOPT_URL, $site_url);
                        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

                        ob_start();
                        curl_exec($ch);
                        curl_close($ch);
                        $file_contents = ob_get_contents();
                        ob_end_clean();
                    }
                    $full_text = $file_contents;
                    $siteeventdocument->fulltext = $full_text;
                    $siteeventdocument->save();
                }
            } catch (Exception $e) {
                if ($siteeventdocument->status != 3 && $e->getCode() == 619) {
                    $siteeventdocument->status = 3;
                    $siteeventdocument->save();

                    //SEND EMAIL TO DOCUMENT OWNER IF Event document HAS BEEN DELETED FROM SCRIBD
                    Engine_Api::_()->siteeventdocument()->emailDocumentDelete($siteeventdocument, $siteevent->title, $siteevent->owner_id);
                }
            }
            
            if($siteeventdocument->status != 3 && $siteeventdocument->status != 2) {
                
                $setting = $scribdsiteevent->getSettings($siteeventdocument->doc_id);
                $thumbnail_url = trim($setting['thumbnail_url']);                   
                $siteeventdocument->thumbnail = $thumbnail_url;
                $siteeventdocument->status = 1;
                $siteeventdocument->save();
                //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
                if ($siteeventdocument->draft == 0 && $siteeventdocument->approved == 1 && $siteeventdocument->status == 1 && $siteeventdocument->activity_feed == 0) {
                    $api = Engine_Api::_()->getDbtable('actions', 'activity');
                    $creator = Engine_Api::_()->getItem('user', $siteeventdocument->owner_id);
                    $action = $api->addActivity($creator, $siteevent, Engine_Api::_()->siteevent()->getActivtyFeedType($siteevent, 'siteeventdocument_new', $creator));

                    //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
                    if ($action != null) {
                        $api->attachActivity($action, $siteeventdocument);
                        $siteeventdocument->activity_feed = 1;
                        $siteeventdocument->save();

                        //START NOTIFICATION AND EMAIL WORK
                        Engine_Api::_()->siteevent()->sendNotificationEmail($siteevent, $action, 'siteeventdocument_new', 'SITEEVENTDOCUMENT_CREATENOTIFICATION_EMAIL', null, null, 'created', $siteeventdocument);
                        $isChildIdLeader = Engine_Api::_()->getDbtable('listItems', 'siteevent')->checkLeader($siteevent);
                        if (!empty($isChildIdLeader)) {
                            Engine_Api::_()->siteevent()->sendNotificationToFollowers($siteevent, 'siteeventdocument_new');
                        }
                        //END NOTIFICATION AND EMAIL WORK
                    }
                }            
            }
        } elseif ($stat == 'ERROR') {
            if ($siteeventdocument->status != 2) {
                $siteeventdocument->status = 2;
                $siteeventdocument->save();
            }
        } else {
            $siteeventdocument->save();
        }

        //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
        $siteeventdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.save.local.server', 1);
        if ($siteeventdocument_save_local_server == 0 && ($siteeventdocument->status == 1 || $siteeventdocument->status == 2)) {
            Engine_Api::_()->siteeventdocument()->deleteServerDocument($siteeventdocument->document_id);
        }

        //SETTING PARAMETERS FOR SECURE DOCUMENT
        if ($viewer->getIdentity() == 0) {
            $uid = mt_rand(1000, 100000);
        } else {
            $uid = $viewer->getIdentity();
        }
        $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->siteeventdocument_secret_key;
        $sessionId = session_id();
        $signature = md5($scribd_secret . 'document_id' . $siteeventdocument->doc_id . 'session_id' . $sessionId . 'user_identifier' . $uid);
        $this->view->uid = $uid;
        $this->view->sessionId = $sessionId;
        $this->view->signature = $signature;
        $this->view->download_allow = $download_allow;

        //RATING WORK
        $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'siteeventdocument')->countRating($siteeventdocument->getIdentity());
        $this->view->siteeventdocument_rated = Engine_Api::_()->getDbTable('ratings', 'siteeventdocument')->previousRated($siteeventdocument->getIdentity(), $viewer_id);

        //CUSTOM FIELD WORK
        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
        $this->view->fieldStructure = $fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($siteeventdocument);
    }

}
