<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventdocument_Widget_DocumentsSiteeventdocumentsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        //GET VIEWER
        $viewer = Engine_Api::_()->user()->getViewer();

        //FETCH DOCUMENTS
        $params = array();
        $params['orderby'] = $this->_getParam('popularity', 'document_id');
        $params['itemCount'] = $this->_getParam('itemCount', 3);

        //GET SUBJECT
        $subject = Engine_Api::_()->core()->getSubject();
        if ($subject->getType() == 'siteevent_event') {
            $params['event_id'] = $subject->event_id;
        } elseif ($subject->getType() == 'siteeventdocument_document') {
            $params['event_id'] = $subject->event_id;
            $params['document_id'] = $subject->document_id;
        } else {
            return $this->setNoRender();
        }

        $this->view->truncationTitle = $this->_getParam('truncationTitle', 18);
        $siteeventdocumentEventsContents = Zend_Registry::isRegistered('siteeventdocumentEventsContents') ? Zend_Registry::get('siteeventdocumentEventsContents') : null;
        $this->view->statistics = $this->_getParam('statistics', array("likeCount", "commentCount"));
        $this->view->siteeventdocuments = Engine_Api::_()->getDbtable('documents', 'siteeventdocument')->widgetDocumentsData($params);

        if (empty($siteeventdocumentEventsContents))
            return $this->setNoRender();

        if (Count($this->view->siteeventdocuments) <= 0) {
            return $this->setNoRender();
        }

        $element = $this->getElement();
        $element->setTitle(sprintf($element->getTitle(), $this->view->htmlLink($subject->getHref(), $subject->getTitle())));
    }

}