<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventsiteeventdocument
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.tpl 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Siteeventdocument/Api/Scribdsiteevent.php';

class Siteeventdocument_Widget_ProfileSiteeventdocumentsController extends Seaocore_Content_Widget_Abstract {

    protected $_childCount;

    public function indexAction() {

        //DONT RENDER THIS IF NOT AUTHORIZED
        if (!Engine_Api::_()->core()->hasSubject()) {
            return $this->setNoRender();
        }

        //GET VIEWER INFORMATION
        $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
        if (!empty($viewer_id)) {
            $this->view->level_id = $level_id = $viewer->level_id;
        } else {
            $this->view->level_id = $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;
        }

        //GET SUBJECT AND SITEEVENT ID
        $this->view->siteevent = $siteevent = Engine_Api::_()->core()->getSubject('siteevent_event');
        $siteeventdocumentProfileEvents = Zend_Registry::isRegistered('siteeventdocumentProfileEvents') ? Zend_Registry::get('siteeventdocumentProfileEvents') : null;

        //SET NO RENDER IF VIEWER CAN NOT VIEW THE DOCUMENTS
        $can_view = $siteevent->authorization()->isAllowed($viewer, 'view');
        if ($this->view->level_id != 1 && empty($can_view)) {
            return $this->setNoRender();
        }

        if (empty($siteeventdocumentProfileEvents))
            return $this->setNoRender();

        //GET SEARCHING PARAMETERS
        $this->view->page = $page = $this->_getParam('page', 1);
        $this->view->search = $search = $this->_getParam('search');
        $this->view->selectbox = $selectbox = $this->_getParam('selectbox');
        $this->view->checkbox = $checkbox = $this->_getParam('checkbox');
        $this->view->isAjax = $this->_getParam('isAjax', 0);
        $this->view->truncationTitle = $this->_getParam('truncationTitle', 55);
        $this->view->statistics = $this->_getParam('statistics', array("likeCount", "commentCount", "viewCount"));
        $this->view->params = $this->_getAllParams();

        $values = array();
        if (!empty($search)) {
            $values['search'] = $search;
        }
        if (!empty($selectbox) && $selectbox == 'featured') {
            $values['featured'] = 1;
            $values['orderby'] = 'document_id';
        } elseif (!empty($selectbox)) {
            $values['orderby'] = $selectbox;
        } else {
            $values['orderby'] = 'document_id';
        }
        if (!empty($checkbox) && $checkbox == 1) {
            $values['owner_id'] = $viewer_id;
        }

        //CHECK WHO CAN CREATE DOCUMENTS
        $this->view->can_create = Engine_Api::_()->authorization()->isAllowed($siteevent, $viewer, 'document');

        //BLOCK FOR UPDATING CONVERSION STATUS OF THE DOCUMENT
        $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->siteeventdocument_api_key;
        $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->siteeventdocument_secret_key;
        $this->scribdsiteevent = new Scribdsiteevent($this->scribd_api_key, $this->scribd_secret);

        //DOCUMENT TABLE
        $documentTable = Engine_Api::_()->getDbtable('documents', 'siteeventdocument');

        //DOCUMENTS FOR SCRIBD CONVERSION
        $doc_forUpdate = $documentTable->updateDocs($siteevent->event_id);

        foreach ($doc_forUpdate as $value) {

            if (empty($value->doc_id)) {
                continue;
            }

            $this->scribdsiteevent->my_user_id = $value->owner_id;

            try {
                $stat = trim($this->scribdsiteevent->getConversionStatus($value->doc_id));
            } catch (Exception $e) {
                $message = $e->getMessage();
            }

            if ($stat == 'DONE') {
                try {
                    //GETTING DOCUMENT'S FULL TEXT
                    $texturl = $this->scribdsiteevent->getDownloadUrl($value->doc_id, 'txt');
                    //for some reason, the URL comes back with leading and trailing spaces
                    $texturl = trim($texturl['download_link']);

                    $file_contents = file_get_contents($texturl);
                    if (empty($file_contents)) {
                        $site_url = $texturl;
                        $ch = curl_init();
                        $timeout = 0; //set to zero for no timeout
                        curl_setopt($ch, CURLOPT_URL, $site_url);
                        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

                        ob_start();
                        curl_exec($ch);
                        curl_close($ch);
                        $file_contents = ob_get_contents();
                        ob_end_clean();
                    }
                    $full_text = $file_contents;
                    $value->fulltext = $full_text;
                    $value->save();

                } catch (Exception $e) {
                    if ($e->getCode() == 619) {
                        $value->status = 3;
                        $value->save();

                        //SEND EMAIL TO DOCUMENT OWNER IF Event document HAS BEEN DELETED FROM SCRIBD
                        Engine_Api::_()->siteeventdocument()->emailDocumentDelete($value, $siteevent->title, $siteevent->owner_id);
                    }
                }

                if($value->status != 3 && $value->status != 2) { 
                    $setting = $this->scribdsiteevent->getSettings($value->doc_id);
                    $thumbnail_url = trim($setting['thumbnail_url']);                    
                    $value->thumbnail = $thumbnail_url;
                    $value->status = 1;
                    $value->save();
                    
                    //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
                    $siteeventdocument = Engine_Api::_()->getItem('siteeventdocument_document', $value->document_id);
                    if ($siteeventdocument->draft == 0 && $siteeventdocument->approved == 1 && $siteeventdocument->status == 1 && $siteeventdocument->activity_feed == 0) {
                        $api = Engine_Api::_()->getDbtable('actions', 'activity');
                        $creator = Engine_Api::_()->getItem('user', $siteeventdocument->owner_id);
                        $action = $api->addActivity($creator, $siteevent, Engine_Api::_()->siteevent()->getActivtyFeedType($siteevent, 'siteeventdocument_new', $creator));

                        //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
                        if ($action != null) {
                            $api->attachActivity($action, $siteeventdocument);
                            $siteeventdocument->activity_feed = 1;
                            $siteeventdocument->save();

                            //START NOTIFICATION AND EMAIL WORK
                            Engine_Api::_()->siteevent()->sendNotificationEmail($siteevent, $action, 'siteeventdocument_new', 'SITEEVENTDOCUMENT_CREATENOTIFICATION_EMAIL', null, null, 'created', $siteeventdocument);
                            $isChildIdLeader = Engine_Api::_()->getDbtable('listItems', 'siteevent')->checkLeader($siteevent);
                            if (!empty($isChildIdLeader)) {
                                Engine_Api::_()->siteevent()->sendNotificationToFollowers($siteevent, 'siteeventdocument_new');
                            }
                            //END NOTIFICATION AND EMAIL WORK
                        }
                    }
                }
            } elseif ($stat == 'ERROR') {
                $value->status = 2;
                $value->save();
            }

            //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
            $siteeventdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.save.local.server', 1);
            if ($siteeventdocument_save_local_server == 0 && ($value->status == 1 || $value->status == 2)) {
                Engine_Api::_()->siteeventdocument()->deleteServerDocument($value->document_id);
            }
        }

        //FETCH DOCUMENTS
        $values['event_id'] = $siteevent->event_id;
        if ($viewer_id == $siteevent->owner_id || $level_id == 1) {
            $values['show_document'] = 0;
            $this->view->paginator = $paginator = $documentTable->getSiteeventdocumentsPaginator($values);
        } else {
            $values['show_document'] = 1;
            $values['document_owner_id'] = $viewer_id;
            $this->view->paginator = $paginator = $documentTable->getSiteeventdocumentsPaginator($values);
        }

        //10 DOCUMENTS PER PAGE
        $paginator->setItemCountPerPage(10);
        $this->view->paginator->setCurrentPageNumber($page);

        //ADD NUMBER OF DOCUMENTS IN TAB
        if ($paginator->getTotalItemCount() > 0) {
            $this->_childCount = $paginator->getTotalItemCount();
        }

        if ($this->view->isAjax) {
            $this->getElement()->removeDecorator('Title');
        }

        if ($this->_getParam('loaded_by_ajax', false)) {
            $this->view->loaded_by_ajax = true;
            if ($this->_getParam('is_ajax_load', false)) {
                $this->view->is_ajax_load = true;
                $this->view->loaded_by_ajax = false;
                if (!$this->_getParam('onloadAdd', false))
                    $this->getElement()->removeDecorator('Title');
                $this->getElement()->removeDecorator('Container');
            } else {
                return;
            }
        }

        $this->view->showContent = true;

        //MAKE FEATURED/UN-FEATURED IS ALLOWED OR NOT
        $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.featured', 1);

        //CHECK THAT RATING IS VIEABLE OR NOT
        $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventdocument.rating', 1);
    }

    public function getChildCount() {
        return $this->_childCount;
    }

}
