<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventemail
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Email.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventemail_Form_Admin_Email extends Engine_Form {

    public function init() {
        // create an object for view
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

        $this->loadDefaultDecorators();

        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemailtemplates') || !Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemailtemplates.isActivate', 0)) {
            $description = sprintf(Zend_Registry::get('Zend_Translate')->_('This page contains settings for automatic reminder emails for events. You can also send sample emails to yourself to see the content. <br/><div class="tip"><span>To send attractive emails to your users via rich, branded, professional and impact-ful emails by using our "%1$sEmail Templates Plugin%2$s". To see details, please  "%3$svisit here%4$s".</span></div>'), "<a href='http://www.socialengineaddons.com/socialengine-email-templates-plugin' target='_blank'>", "</a>", "<a href='http://www.socialengineaddons.com/socialengine-email-templates-plugin' target='_blank'>", "</a>");
        } else {
            $description = sprintf(Zend_Registry::get('Zend_Translate')->_("This page contains settings for automatic reminder emails for events. You can also send sample emails to yourself to see the content."));
        }

        $this
                ->setTitle('Automatic Reminder Email Settings');

        $this
                ->setDescription($description);

        $this->getDecorator('Description')->setOption('escape', false);
        $this->addElement('Radio', 'siteeventemail_reminder', array(
            'label' => 'Automatic Event Reminders',
            'description' => "Do you want the site to send automatic email reminders to guests for events that they are attending or maybe attending? (The content of this email template can be customized from the Mail Templates section in Settings.)",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
        ));

        $this->addElement('Multiselect', 'siteeventemail_reminder_options', array(
            'label' => 'Duration of Upcoming Reminder Email',
            'description' => 'Select the duration before which a reminder email will be sent to the guests of an event.',
            'multiOptions' => array(
                '86400' => '1 Day',
                '172800' => '2 Days',
                '259200' => '3 Days',
                '604800' => '1 Week',
                '1209600' => '2 Weeks',
                '2592000' => '1 Month'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.reminder.options', array('0' => 86400))
        ));

        $this->addElement('Radio', 'siteeventemail_finish_event', array(
            'label' => 'Automatic Email After Event Ended',
            'description' => "Do you want the site to send automatic email after an event is ended? (The content of this email template can be customized from the Mail Templates section in Settings.)",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.finish.event', 0),
        ));

        $this->addElement('Select', 'siteeventemail_finish_event_options', array(
            'label' => 'Duration of Event Ended Email',
            'description' => 'Select the duration for the email to be sent after an event is ended. This email is sent to all the guests who have attended the event.',
            'multiOptions' => array(
                '3600' => '1 Hour',
                '86400' => '1 Day',
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.finish.event.options', 3600),
        ));

        $this->addElement('Checkbox', 'siteeventemail_demo', array(
            'label' => 'Send me test emails for event to check the above settings.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.demo', 1),
        ));

        $this->addElement('Text', 'siteeventemail_admin', array(
            'label' => 'Email ID for Testing',
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('EmailAddress', true),
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.admin', Engine_API::_()->seaocore()->getSuperAdminEmailAddress()),
        ));
        $this->siteeventemail_admin->getValidator('NotEmpty')->setMessage('Please enter a valid email address.', 'isEmpty');
        $this->siteeventemail_admin->getValidator('EmailAddress')->getHostnameValidator()->setValidateTld(false);

        // Add submit button
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}