<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventemail
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ReminderMail.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventemail_Plugin_Task_ReminderMail extends Core_Plugin_Task_Abstract {

    public function execute() {
        $siteeventemail_reminder_options = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.reminder.options', array('0' => 86400));
        $sqlTimeStr = '';

        foreach ($siteeventemail_reminder_options as $value) {
            $start_date = date('Y-m-d', (time() + $value)) . " 00:00:00";
            $end_date = date('Y-m-d', (time() + $value)) . " 23:59:59";
            $sqlTimeStr = ".starttime BETWEEN " . "'" . $start_date . "'" . " AND " . "'" . $end_date . "'" . "";
            $this->sendEmail($sqlTimeStr, $value);
        }
    }

    public function sendEmail($sqlTimeStr, $values) {

        $siteeventemailPostSystemType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemailpost.system.type', null);

        $siteeventEmailGetShowViewType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteeventemail.getshow.viewtype', null);
        $siteEventOccuretable = Engine_Api::_()->getDbTable('occurrences', 'siteevent');
        $siteeventOccurTableName = $siteEventOccuretable->info('name');
        $eventTable = Engine_Api::_()->getDbtable('events', 'siteevent');
        $eventTableName = $eventTable->info('name');
        $siteeventMembershipTable = Engine_Api::_()->getDbTable('membership', 'siteevent');
        $siteeventMembershipTableName = $siteeventMembershipTable->info('name');
        $siteeventOtherinfoTable = Engine_Api::_()->getDbtable('otherinfo', 'siteevent');
        $siteeventOtherinfoTableName = $siteeventOtherinfoTable->info('name');
        $select = $eventTable->select()->setIntegrityCheck(false)
                ->from($eventTableName, array('event_id', 'closed'))
                ->join($siteeventOccurTableName, $eventTableName . '.event_id = ' . $siteeventOccurTableName . '.event_id', array('starttime', 'endtime'))
                ->join($siteeventMembershipTableName, $siteeventOccurTableName . '.occurrence_id = ' . $siteeventMembershipTableName . '.occurrence_id', array('user_id', 'occurrence_id', 'rsvp'))
                ->join($siteeventOtherinfoTableName, $siteeventOtherinfoTableName . '.event_id = ' . $eventTableName . '.event_id')
                ->where("$siteeventMembershipTableName.rsvp= 2 OR $siteeventMembershipTableName.rsvp= 1")
                ->where("$siteeventMembershipTableName.active= 1")
                ->where("$siteeventMembershipTableName.resource_approved	= 1")
                ->where("$siteeventMembershipTableName.user_approved	= 1")
                ->where($siteeventOccurTableName . "$sqlTimeStr")
                ->where($eventTableName . '.approved = ?', '1')
                ->where($eventTableName . '.draft = ?', '0')
                ->where($eventTableName . ".search = ?", 1)
                ->where($eventTableName . '.closed = ?', '0')
                ->group($eventTableName . '.event_id')
                ->group($siteeventMembershipTableName . '.user_id');

        $events = $select->query()->fetchAll();

        $eventEmailHostType = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $tempEventEmailTypeInfo = @base64_encode($eventEmailHostType);
        $siteeventemailReminderEvents = Zend_Registry::isRegistered('siteeventemailReminderEvents') ? Zend_Registry::get('siteeventemailReminderEvents') : null;
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        if (empty($siteeventemailReminderEvents))
            return;

        $validator = new Zend_Validate_EmailAddress();
        $validator->getHostnameValidator()->setValidateTld(false);
        if ((!empty($siteeventEmailGetShowViewType) || empty($siteeventemailPostSystemType) || ($siteeventemailPostSystemType == $tempEventEmailTypeInfo))) {
            foreach ($events as $key => $value) {
                $siteevent = Engine_Api::_()->getItem('siteevent_event', $value['event_id']);
                $user = Engine_Api::_()->getItem('user', $value['user_id']);

                if ($siteevent->closed)
                    continue;

                $email = $user->email;
                if (!$validator->isValid($email)) {
                    continue;
                }

                Zend_Registry::set('occurrence_id', $value['occurrence_id']);
                $occurrence_id = $value['occurrence_id'];
                $translate = Zend_Registry::get('Zend_Translate');

                $body = '';
                //GETTING THE event PHOTO.
//                $file = $siteevent->getPhotoUrl('thumb.normal');
//                if (empty($file)) {
//                    $eventphoto_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . 'application/modules/Siteevent/externals/images/nophoto_event_thumb_normal.png';
//                } else {
//                    $eventphoto_path = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . Zend_Registry::get('Zend_View')->layout()->staticBaseUrl . $file;
//                }

                $moduletype = 'siteevent';
                //GETTING THE USER PHOTO.
                $file = $siteevent->getPhotoUrl('thumb.normal');
                if (empty($file)) {
                    $photo = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl() . '/application/modules/' . ucfirst($moduletype) . '/externals/images/nophoto_event_thumb_icon.png';
                } else {
                    if (strpos($file, 'http') === FALSE)
                        $photo = ( _ENGINE_SSL ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $file;
                    else
                        $photo = $file;
                }

                $eventUrl = ( _ENGINE_SSL ? 'https://' : 'http://' )
                        . $_SERVER['HTTP_HOST']
                        . $siteevent->getHref();
                $eventTitle = $siteevent->getTitle();
                $eventUrl_link = '';
                $eventUrl_link .= $view->translate("Here's a little reminder of an upcoming event %s:", $eventTitle);
                $eventUrl_link .= '<br > <table width="100%"><tr valign="top"><td style="padding-top:5px;"><div style="float:left;margin-right:15px;"><a href = ' . $eventUrl . ' target="_blank">' . '<img src="' . $photo . '" align="left" style="width: 100px; border: 1px solid rgb(221, 221, 221); padding: 0px;"/>' . '</a></div><div style="overflow:hidden;">';
                $eventdateinfo = Engine_Api::_()->getDbTable('occurrences', 'siteevent')->getEventDate($siteevent->event_id, $occurrence_id);
                $optionText = '';
                $startDateObject = new Zend_Date(strtotime($eventdateinfo['starttime']));
                $endDateObject = new Zend_Date(strtotime($eventdateinfo['endtime']));
                $tz = $user->timezone;
                $startDateObject->setTimezone($tz);
                $endDateObject->setTimezone($tz);

                if ($startDateObject->toString('y-MM-dd') == $endDateObject->toString('y-MM-dd')) {
                    $optionText = $view->locale()->toDateTime($startDateObject, array('format' => 'MMM', 'timezone' => $user->timezone));
                    $optionText = $view->locale()->toDateTime($startDateObject, array('format' => 'MMM', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toDateTime($startDateObject, array('format' => 'd', 'timezone' => $user->timezone)) . ', ' . $view->locale()->toDateTime($startDateObject, array('format' => 'yyyy', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toTime($startDateObject, array('timezone' => $user->timezone)) . ' - ' . $view->locale()->toTime($endDateObject, array('timezone' => $user->timezone));
                } else {
                    $optionText = $view->locale()->toDateTime($startDateObject, array('format' => 'MMM', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toDateTime($startDateObject, array('format' => 'd', 'timezone' => $user->timezone)) . ', ' . $view->locale()->toDateTime($startDateObject, array('format' => 'yyyy', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toTime($startDateObject, array('timezone' => $user->timezone)) . ' - ' . $view->locale()->toDateTime($endDateObject, array('format' => 'MMM', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toDateTime($endDateObject, array('format' => 'd', 'timezone' => $user->timezone)) . ', ' . $view->locale()->toDateTime($endDateObject, array('format' => 'yyyy', 'timezone' => $user->timezone)) . ' ' . $view->locale()->toTime($endDateObject, array('timezone' => $user->timezone));
                }

                $hostname = '';

                $event_details = '';
                $host = $siteevent->getHost();
                if ($host)
                    $hostname = '<a href="' . 'http://' . $_SERVER['HTTP_HOST'] . $host->getHref() . '">' . $host->getTitle() . '</a>';
                if ($hostname)
                    $event_details .= $translate->_('Host:') . '<b> ' . $hostname . '</b><br >';
                $event_details .= $translate->_('Date & Time:') . '<b> ' . $optionText . '</b><br />' . $translate->_('Venue:') . '<b> ' . $siteevent->venue_name . '</b><br />' . $translate->_('Location:') . '<b> ' . $siteevent->location . '</b>';

                $body .= $eventUrl_link . $event_details . '</td></tr><tr><td><br />';

                $body .= $translate->_("Hope to see you soon :)") . '<br /><br />';

                if (!Engine_Api::_()->siteevent()->isTicketBasedEvent()) {
                    if ($value['rsvp'] == 1) {
                        $availabilityStatus = $translate->_('Maybe');
                    } elseif ($value['rsvp'] == 2) {
                        $availabilityStatus = $translate->_('Yes');
                    }

                    $body .= $view->translate('Your availability status: %1$s', $availabilityStatus) . '<br /><br />';

                    $changeAvailability = '<a href=" ' . $eventUrl . '?changeRsvp=2' . '">' . $translate->_("Yes") . '</a>&nbsp;&nbsp;';
                    $changeAvailability .= '&middot; <a href=" ' . $eventUrl . '?changeRsvp=3' . '">' . $translate->_("No") . '</a>&nbsp;&nbsp;';
                    $changeAvailability .= '&middot; <a href=" ' . $eventUrl . '?changeRsvp=1' . '">' . $translate->_("Maybe") . '</a>&nbsp;';
                    $body .= $view->translate('Change Availability To: %1$s', $changeAvailability) . '<br /><br />';
                }
                
                
                $tab_id = Engine_Api::_()->siteevent()->getTabId('siteevent.profile-members');
                $guestUrl = $tab_id ? $eventUrl . '/tab/' . $tab_id : $eventUrl;
                
                if (!Engine_Api::_()->siteevent()->isTicketBasedEvent()) {

                $body .= '<span style="border:1px solid #5c98b8;background-color:#79b4d4;margin-right:10px;display:inline-block;"><table cellspacing="0" cellpadding="0" style="border-collapse:collapse"><tbody><tr><td style="font-size:11px;font-family:tahoma,verdana,arial,sans-serif;padding:2px 6px 4px;border-top:1px solid #8a9cc2"><a href="' . $guestUrl . '" style="text-decoration:none;font-weight:bold;color:#fff;font-size:11px" target="_blank"> ' . $translate->_("View Guest List") . '</a></td></tr></tbody></table></span>';
                
                }

                $body .= '<span style="border:1px solid #5c98b8;background-color:#79b4d4;display:inline-block;"><table cellspacing="0" cellpadding="0" style="border-collapse:collapse"><tbody><tr><td style="font-size:11px;font-family:tahoma,verdana,arial,sans-serif;padding:2px 6px 4px;border-top:1px solid #8a9cc2"><a href="' . $eventUrl . '" style="text-decoration:none;font-weight:bold;color:#fff;font-size:11px" target="_blank"> ' . $translate->_("Go to Event") . '</a></td></tr></tbody></table></span>';
                if ($values == '86400') {
                    $number_of_days = 'one';
                } elseif ($values == '172800') {
                    $number_of_days = 'two';
                } elseif ($values == '259200') {
                    $number_of_days = 'three';
                } elseif ($values == '604800') {
                    $number_of_days = 1;
                } elseif ($values == '1209600') {
                    $number_of_days = 2;
                } elseif ($values == '2592000') {
                    $number_of_days = 1;
                }
                Engine_Api::_()->getApi('mail', 'core')->sendSystem($email, "siteevent_reminder_$values", array(
                    'body' => $body,
                    'event_title' => $eventTitle,
                    'date_time' => $optionText,
                    'number_of_days' => $number_of_days,
                    'email' => Engine_Api::_()->getApi('settings', 'core')->core_mail_from,
                    'queue' => false));
            }
        }
    }

}
