<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventemail
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventemail_Installer extends Engine_Package_Installer_Module {

    function onPreInstall() {
        $db = $this->getDb();

        //CHECK THAT SITEEVENT PLUGIN IS ACTIVATED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteevent.isActivate')
                ->limit(1);
        $siteevent_settings = $select->query()->fetchAll();
        if (!empty($siteevent_settings)) {
            $siteevent_is_active = 1;
        } else {
            $siteevent_is_active = 0;
        }

        //CHECK THAT SITEEVENT PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'siteevent')
                ->where('enabled = ?', 1);
        $check_siteevent = $select->query()->fetchObject();
        if (!empty($check_siteevent) && !empty($siteevent_is_active)) {
            $PRODUCT_TYPE = 'siteeventemail';
            $PLUGIN_TITLE = 'Siteeventemail';
            $PLUGIN_VERSION = '4.8.5p2';
            $PLUGIN_CATEGORY = 'plugin';
            $PRODUCT_DESCRIPTION = 'Advanced Events - Event Reminders Extension';
            $PRODUCT_TITLE = 'Advanced Events - Event Reminders Extension';
            $_PRODUCT_FINAL_FILE = 0;
            $SocialEngineAddOns_version = '4.8.10p4';
            $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
            $is_file = file_exists($file_path);
            if (empty($is_file)) {
                include APPLICATION_PATH . "/application/modules/Siteevent/controllers/license/license3.php";
            } else {
                include $file_path;
            }

            parent::onPreInstall();
        } elseif (!empty($check_siteevent) && empty($siteevent_is_active)) {
            $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
            $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
            if (strstr($url_string, "manage/install")) {
                $calling_from = 'install';
            } else if (strstr($url_string, "manage/query")) {
                $calling_from = 'queary';
            }
            $explode_base_url = explode("/", $baseUrl);
            foreach ($explode_base_url as $url_key) {
                if ($url_key != 'install') {
                    $core_final_url .= $url_key . '/';
                }
            }

            return $this->_error("<span style='color:red'>Note: You have installed the 'Advanced Events Plugin' but not activated it on your site yet. Please activate it first before installing the 'Advanced Events - Event Reminders Extension'.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/siteevent/settings/readme'>Click here</a> to activate the Advanced Events Plugin.");
        } else {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
            return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-advanced-events-plugin' target='_blank'>Advanced Events Plugin</a> on your site yet. Please install it first before installing the 'Advanced Events - Event Reminders Extension'.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
        }
    }

    function onInstall() {

        //GET DB
        $db = $this->getDb();

        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='siteeventemail';");
        
        $db->query("INSERT IGNORE INTO `engine4_core_mailtemplates` ( `type`, `module`, `vars`) VALUES ('siteevent_finish_rate_member', 'siteeventemail', '[host],[email],[event_title],[date_time],[venue_name],[event_with_link],[event_home_with_link]');");
        
        //CODE FOR INCREASE THE SIZE OF engine4_core_menuitems's FIELD type
        $type_array = $db->query("SHOW COLUMNS FROM engine4_core_menuitems LIKE 'label'")->fetch();
        if (!empty($type_array)) {
            $varchar = $type_array['Type'];
            $length_varchar = explode("(", $varchar);
            $length = explode(")", $length_varchar[1]);
            $length_type = $length[0];
            if ($length_type < 64) {
                $run_query = $db->query("ALTER TABLE `engine4_core_menuitems` CHANGE `label` `label` VARCHAR( 64 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
            }
        }

        //CODE FOR INCREASE THE SIZE OF engine4_core_menuitems's FIELD type
        $type_array = $db->query("SHOW COLUMNS FROM engine4_core_menuitems LIKE 'menu'")->fetch();
        if (!empty($type_array)) {
            $varchar = $type_array['Type'];
            $length_varchar = explode("(", $varchar);
            $length = explode(")", $length_varchar[1]);
            $length_type = $length[0];
            if ($length_type < 64) {
                $run_query = $db->query("ALTER TABLE `engine4_core_menuitems` CHANGE `menu` `menu` VARCHAR( 64 ) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL");
            }
        }
        parent::onInstall();
    }

    function onEnable() {

        $db = $this->getDb();

        $db->update('engine4_core_menuitems', array('enabled' => 1), array('name = ?' => 'siteevent_admin_main_email'));

        parent::onEnable();
    }

    function onDisable() {

        $db = $this->getDb();

        $db->update('engine4_core_menuitems', array('enabled' => 0), array('name = ?' => 'siteevent_admin_main_email'));

        parent::onDisable();
    }

    public function onPostInstall() {

			//WORK FOR THE WORD CHANGES IN THE ADVANCED EVENT PLUGIN .CSV FILE.
			$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
			$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
			if ($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
					$view = new Zend_View();
					$baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					if ($actionName == 'install') {
							$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/install');
					} else {
							$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/query');
					}
			}
    }

}