<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteeventrepeat
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteeventrepeat_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {
        $getErrorMsg = $this->getVersion(); 
        if (!empty($getErrorMsg)) {
          return $this->_error($getErrorMsg);
        } 
        
        $db = $this->getDb();

        //CHECK THAT SITEEVENT PLUGIN IS ACTIVATED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'siteevent.isActivate')
                ->limit(1);
        $siteevent_settings = $select->query()->fetchAll();
        if (!empty($siteevent_settings)) {
            $siteevent_is_active = 1;
        } else {
            $siteevent_is_active = 0;
        }


        //CHECK THAT SITEEVENT PLUGIN IS INSTALLED OR NOT
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'siteevent')
                ->where('enabled = ?', 1);
        $check_siteevent = $select->query()->fetchObject();
        if (!empty($check_siteevent) && !empty($siteevent_is_active)) {
            $PRODUCT_TYPE = 'siteeventrepeat';
            $PLUGIN_TITLE = 'Siteeventrepeat';
            $PLUGIN_VERSION = '5.5.0';
            $PLUGIN_CATEGORY = 'plugin';
            $PRODUCT_DESCRIPTION = 'Advanced Events - Recurring / Repeating Events Extension';
            $_PRODUCT_FINAL_FILE = 0;
            $SocialEngineAddOns_version = '4.8.0p1';
            $PRODUCT_TITLE = 'Advanced Events - Recurring / Repeating Events Extension';
            $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
            $is_file = @file_exists($file_path);

            if (empty($is_file)) {
                include APPLICATION_PATH . "/application/modules/Siteevent/controllers/license/license3.php";
            } else {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
                $is_Mod = $select->query()->fetchObject();
                if (empty($is_Mod)) {
                    include_once $file_path;
                }
            }
            parent::onPreinstall();
        } elseif (!empty($check_siteevent) && empty($siteevent_is_active)) {
            $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
            $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
            if (strstr($url_string, "manage/install")) {
                $calling_from = 'install';
            } else if (strstr($url_string, "manage/query")) {
                $calling_from = 'queary';
            }
            $explode_base_url = explode("/", $baseUrl);
            foreach ($explode_base_url as $url_key) {
                if ($url_key != 'install') {
                    $core_final_url .= $url_key . '/';
                }
            }

            return $this->_error("<span style='color:red'>Note: You have installed the 'Advanced Events Plugin' but not activated it on your site yet. Please activate it first before installing the 'Advanced Events - Recurring / Repeating Events Extension'.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/siteevent/settings/readme'>Click here</a> to activate the Advanced Events Plugin.");
        } else {
            $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
            return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-advanced-events-plugin' target='_blank'>Advanced Events Plugin</a> on your site yet. Please install it first before installing the 'Advanced Events - Recurring / Repeating Events Extension'.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
        }
    }

    function onInstall() {
        $db = $this->getDb();

        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='siteeventrepeat';");

        //START: PUT OCCURRENCE TAB AUTOMATICALLY AT SITEEVENT PROFILE PAGE
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);

        $select
                ->from('engine4_core_pages')
                ->where('name = ?', 'siteevent_index_view')
                ->limit(1);
        $page_id = $select->query()->fetchObject()->page_id;
        if (!empty($page_id)) {

            $select = new Zend_Db_Select($db);
            $select_content = $select
                    ->from('engine4_core_content')
                    ->where('page_id = ?', $page_id)
                    ->where('type = ?', 'widget')
                    ->where('name = ?', 'siteeventrepeat.occurrences')
                    ->limit(1);
            if(!empty($select_content->query()->fetchObject())){
                $content_id = $select_content->query()->fetchObject()->content_id;
            }
            if (empty($content_id)) {
                $select = new Zend_Db_Select($db);
                $select_container = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'container')
                        ->limit(1);
                $container_id = $select_container->query()->fetchObject()->content_id;
                if (!empty($container_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_middle = $select
                            ->from('engine4_core_content')
                            ->where('parent_content_id = ?', $container_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'middle')
                            ->limit(1);
                    $middle_id = $select_middle->query()->fetchObject()->content_id;
                    if (!empty($middle_id)) {
                        $select = new Zend_Db_Select($db);
                        $select_tab = $select
                                ->from('engine4_core_content')
                                ->where('type = ?', 'widget')
                                ->where('name = ?', 'core.container-tabs')
                                ->where('page_id = ?', $page_id)
                                ->limit(1);
                        $tab_id = $select_tab->query()->fetchObject()->content_id;

                        $db->insert('engine4_core_content', array(
                            'page_id' => $page_id,
                            'type' => 'widget',
                            'name' => 'siteeventrepeat.occurrences',
                            'parent_content_id' => ($tab_id ? $tab_id : $middle_id),
                            'order' => 999,
                            'params' => '{"title":"Occurrences","titleCount":true,"loaded_by_ajax":"1","guest_pictures":"1","guestCountActive":"13","guestCountDeactive":"18","guest_count_link":"1","rsvp_dropdown":"1","date_filter":"1","profile_links":["join","leave","accept-ignore","invite","review"],"autoloading":"1","itemCount":"10","nomobile":"0","name":"siteeventrepeat.occurrences"}',
                        ));
                    }
                }
            }
        }

        parent::onInstall();
    }

    public function onPostInstall() {

       //SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL
        $moduleName = 'siteeventrepeat';
        $db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES
('$moduleName','1')");
            $select = new Zend_Db_Select($db);
            $select
                    ->from('engine4_sitemobile_modules')
                    ->where('name = ?', $moduleName)
                    ->where('integrated = ?', 0);
            $is_sitemobile_object = $select->query()->fetchObject();
            if ($is_sitemobile_object) {
                $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
                $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
                if ($controllerName == 'manage' && $actionName == 'install') {
                    $view = new Zend_View();
                    $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
                    $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
                    $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/' . $moduleName . '/integrated/0/redirect/install');
                }
            }
        }
        //END - SITEMOBILE CODE TO CALL MY.SQL ON POST INSTALL
       
			//WORK FOR THE WORD CHANGES IN THE ADVANCED EVENT PLUGIN .CSV FILE.
			$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
			$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
			if ($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
					$view = new Zend_View();
					$baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					if ($actionName == 'install') {
							$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/install');
					} else {
							$redirector->gotoUrl($baseUrl . 'admin/siteevent/settings/language/redirect/query');
					}
			}
    }
    
    private function getVersion() {

        $db = $this->getDb();

        $errorMsg = '';
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitemobile' => '4.8.0p1',
            'siteevent' => '4.8.8p1',
        );

        $finalModules = array();
        foreach ($modArray as $key => $value) {
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')
                    ->where('name = ?', "$key")
                    ->where('enabled = ?', 1);
            $isModEnabled = $select->query()->fetchObject();
            if (!empty($isModEnabled)) {
                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_modules', array('title', 'version'))
                        ->where('name = ?', "$key")
                        ->where('enabled = ?', 1);
                $getModVersion = $select->query()->fetchObject();

                $isModSupport = $this->checkVersion($getModVersion->version, $value);
                if (empty($isModSupport)) {
                    $finalModules[] = $getModVersion->title;
                }
            }
        }

        foreach ($finalModules as $modArray) {
            $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Mobile / Tablet Plugin".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }

    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }    
}
