<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefaq
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
require_once realpath(dirname(__FILE__)) . '/sitemodule_install.php';

class Sitefaq_Installer extends SiteModule_Installer
{
  public function onInstall()
  {
		$db = $this->getDb();

		//START MAKE CHANGES IN engine4_communityad_faqs TABLE
		$table_exist = $db->query("SHOW TABLES LIKE 'engine4_communityad_faqs'")->fetch();
		if (!empty($table_exist)) {

			$column_exist = $db->query("SHOW COLUMNS FROM engine4_communityad_faqs LIKE 'import'")->fetch();
			if (empty($column_exist)) {
				$db->query("ALTER TABLE `engine4_communityad_faqs` ADD `import` TINYINT( 1 ) NOT NULL DEFAULT '0'");
			}
		}
    
    $isTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitefaq_categories'")->fetch();
    if (!empty($isTableExist)) {
      $isIndexed = $db->query("SHOW INDEX FROM `engine4_sitefaq_categories` WHERE Key_name = 'cat_dependency'")->fetch();
      if (empty($isIndexed)) {
        $db->query("ALTER TABLE `engine4_sitefaq_categories` ADD INDEX ( `cat_dependency` );");
      }
      
      $isIndexed = $db->query("SHOW INDEX FROM `engine4_sitefaq_categories` WHERE Key_name = 'subcat_dependency'")->fetch();
      if (empty($isIndexed)) {
        $db->query("ALTER TABLE `engine4_sitefaq_categories` ADD INDEX ( `subcat_dependency` );");
      }  
    }
    
    $categoriesTable = $db->query('SHOW TABLES LIKE \'engine4_sitefaq_categories\'')->fetch();
		if (!empty($categoriesTable)) {
 
			$catDependencyIndex = $db->query("SHOW INDEX FROM `engine4_sitefaq_categories` WHERE Key_name = 'cat_dependency'")->fetch();     
      if(empty($catDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_sitefaq_categories` ADD INDEX ( `cat_dependency` )");
      }    
      
			$subcatDependencyIndex = $db->query("SHOW INDEX FROM `engine4_sitefaq_categories` WHERE Key_name = 'subcat_dependency'")->fetch();     
      if(empty($subcatDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_sitefaq_categories` ADD INDEX ( `subcat_dependency` )");
      }       
    }

    $faqTable = $db->query('SHOW TABLES LIKE \'engine4_sitefaq_faqs\'')->fetch();
    if(!empty($faqTable)) {
        $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitefaq_faqs` WHERE Key_name = 'featured'")->fetch();   
        if(empty($featuredIndex)) {
          $db->query("ALTER TABLE `engine4_sitefaq_faqs` ADD INDEX ( `featured` )");
        }   

        $searchIndex = $db->query("SHOW INDEX FROM `engine4_sitefaq_faqs` WHERE Key_name = 'search'")->fetch();
        if(empty($searchIndex)) {
            $db->query("ALTER TABLE `engine4_sitefaq_faqs` ADD INDEX (`search`, `draft` , `approved`)");
        }
    }      
    
    parent::onInstall();
  }
}
