<?php

class Sitefbchat_Installer extends Engine_Package_Installer_Module
{

  public function onInstall()
  {
    $this->_addFbMessenger();
    parent::onInstall();
  }

  protected function _addFbMessenger()
  {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);

    // Get page id
    $pageId = $select
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'footer')
      ->limit(1)
      ->query()
      ->fetchColumn(0);

    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $hasWidget = $select
      ->from('engine4_core_content', new Zend_Db_Expr('TRUE'))
      ->where('page_id = ?', $pageId)
      ->where('type = ?', 'widget')
      ->where('name = ?', 'sitefbchat.fb-messenger')
      ->query()
      ->fetchColumn()
    ;

    // Add it
    if( !$hasWidget ) {
      $select = new Zend_Db_Select($db);
      $content_id = $select
        ->from('engine4_core_content', 'content_id')
        ->where('page_id = ?', $pageId)
        ->where('name = ?', 'main')
        ->limit(1)
        ->query()
        ->fetchColumn(0);

      if( $content_id ) {
        $db->insert('engine4_core_content', array(
          'page_id' => $pageId,
          'type' => 'widget',
          'name' => 'sitefbchat.fb-messenger',
          'parent_content_id' => $content_id,
          'order' => 999
        ));
      }
    }
  }

}