<?php

class Sitefbchat_Widget_FbMessengerController extends Engine_Content_Widget_Abstract
{

  function indexAction()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $enable = $coreSettings->getSetting('sitefbchat.enable.messenger', '1');
    if( $enable == 0 ) {
      return $this->setNoRender();
    }

    $this->view->pageId = $coreSettings->getSetting('sitefbchat.page_id', '');

    if( !$this->view->pageId ) {
      return $this->setNoRender();
    }

    $viewer = Engine_Api::_()->user()->getViewer();
    $visibility = $coreSettings->getSetting('sitefbchat.visibility', 'all');
    if( $visibility != 'all' ) {
      if( $visibility == 'logged-in' && (!$viewer || !$viewer->getIdentity() ) ) {
        return $this->setNoRender();
      } else if( $visibility == 'logged-out' && ($viewer && $viewer->getIdentity()) ) {
        return $this->setNoRender();
      }
    }

    $allowedDevices = $coreSettings->getSetting('sitefbchat.allowed.devices', '0');
    if( $allowedDevices ) {
      Engine_Loader::loadClass('Sitefbchat_MobileDetector');
      $mobileDetector = new Sitefbchat_MobileDetector();
      if( $allowedDevices == 1 && $mobileDetector->isMobile() ) {
        return $this->setNoRender();
      } else if( $allowedDevices == 2 && !$mobileDetector->isMobile() ) {
        return $this->setNoRender();
      }
    }
    $enableduration = $coreSettings->getSetting('sitefbchat.enable.timing', '0');
    $starttime = $coreSettings->getSetting('sitefbchat.starttime', '');
    $endtime = $coreSettings->getSetting('sitefbchat.endtime', '');
    if( $enableduration && $starttime && $endtime ) {
      if( !(time() > strtotime(date('H:i:s', strtotime($starttime))) && time() < strtotime(date('H:i:s', strtotime($endtime)))) ) {
        return $this->setNoRender();
      }
    }
  }

}
