<?php
/**
* SocialEngine
*
* @category   Application_Extensions
* @package    Sitefbclone
* @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
* @license    http://www.socialengineaddons.com/license/
* @version    $Id: Pagelayouts.php 2015-06-04 00:00:00Z SocialEngineAddOns $
* @author     SocialEngineAddOns
*/

class Sitefbclone_Api_Core extends Core_Api_Abstract {

    /**
    * Does the user have new updates, returns the number or 0
    *
    * @param User_Model_User $user
    * @param $params
    * @return int The number of new updates the user has
    */
    public function getNewUpdatesCount(User_Model_User $user, $params = array()) {
        $notificationTable = Engine_Api::_()->getDbtable('notifications', 'seaocore');
        $notificationTableName = $notificationTable->info('name');

        $notificationsTable = Engine_Api::_()->getDbtable('notifications', 'activity');
        $notificationsTableName = $notificationsTable->info('name');

        $select = $notificationTable->select()
        ->from($notificationTableName, "COUNT($notificationTableName.notification_id) as count")
        ->where("$notificationsTableName.user_id = ?", $user->getIdentity())
        ->where("$notificationTableName.show = ?", 0)
        ->where("$notificationsTableName.read = ?", 0);

        if (isset($params['isNotification']) && !empty($params['isNotification']))
            $select->where("$notificationsTableName.type != 'friend_request'")
        ->where("$notificationsTableName.type != 'message_new'")
        ->where("$notificationsTableName.type != 'friend_follow_request'");
        elseif (isset($params['type']) && !empty($params['type'])) {
            $notificationType = $params['type'];
            $select->where("$notificationsTableName.type = 'friend_follow_request' OR $notificationsTableName.type = '" . $notificationType . "'");
        }
        $newUpdates = $select->query()->fetchAll();
        $newUpdatesCount = $newUpdates[0]['count'];
        return empty($newUpdatesCount) ? false : $newUpdatesCount;
    }

    public function displayPhoto($id, $type = 'thumb.profile') {
        if (empty($id)) {
            return null;
        }
        $file = Engine_Api::_()->getItemTable('storage_file')->getFile($id, $type);
        if (!$file) {
            return null;
        }

        //Get url of the image
        $src = $file->map();
        return $src;
    } 

    public function getOldVersionImages($array){
        // Get available files
        $imgOptions = array();
        $imgOptions = $array;
        $imageExtensions = array('gif', 'jpg', 'jpeg', 'png');

        $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
        foreach ($it as $file) {
            if ($file->isDot() || !$file->isFile())
                continue;
            $basename = basename($file->getFilename());
            if (!($pos = strrpos($basename, '.')))
                continue;
            $ext = strtolower(ltrim(substr($basename, $pos), '.'));
            if (!in_array($ext, $imageExtensions))
                continue;
            $imgOptions['public/admin/' . $basename] = $basename;
        }
        return $imgOptions;
    }

    public function getNewVersionImages($array){
        $params = array();
        $params['extension'] = array('gif', 'jpg', 'jpeg', 'png');
        $filesTable = Engine_Api::_()->getDbTable('files','core');
        $select = $filesTable->getFiles($params);
        $fileData = $filesTable->fetchAll($select);
        $imgOptions = array();
        if(!empty($array)) 
            $imgOptions = $array;
        else
            $imgOptions = array('0' => $default);
        foreach ($fileData as $key => $value) {
            $imgOptions[$value->storage_path] =  $value->name;
        }
        return $imgOptions;
    }

    public function getImages($array = array('0' => 'No Image')){
        $coreVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core')->version;
        $checkVersion = Engine_Api::_()->seaocore()->checkVersion($coreVersion, '5.0.0');
        // changes in calling of function on the basis of core version
        if($checkVersion) {
            return $this->getNewVersionImages($array);
        } else {
            return $this->getOldVersionImages($array);
        }
    }
}
