<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Pagelayouts.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_Form_Admin_Settings_Styling extends Engine_Form {

  public function init() {

    $description = "Here, you can manage the color schemes of your website. <br /><div class='tip'><span>Once you switch color schemes or make any changes to the new color schemes you added, please change the mode of your website from Production to Development. This has to be done everytime, and you can switch to production instantly or as soon you are done configuring the color scheme of your website.</span></div>";
    
    // Decorators
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);
    $this->setTitle('Manage Color Schemes')
    ->setDescription($description);

    $settings = Engine_Api::_()->getApi('settings', 'core');
    $api = Engine_Api::_()->sitefbclone();
    $contrast_mode = $api->getContantValueXML('contrast_mode') ? $api->getContantValueXML('contrast_mode') : 'dark_mode';
    $this->addElement('Radio', 'contrast_mode', array(
      'label' => 'Contrast Mode?',
      'description' => 'Choose the Contrast mode for the accessibility widget on your website. You can choose Dark Mode or Light Mode as per the default theme on your website.',
      'multiOptions' => array(
        'light_mode' => 'Light Mode',
        'dark_mode' => 'Dark Mode'
    ),
      'value'=>$contrast_mode
  ));

    $customThemes = Engine_Api::_()->getDbTable('customthemes', 'sitefbclone')->getCustomThemes(array('all' => 1));
    foreach($customThemes as $customTheme) {
      if(in_array($customTheme['theme_id'], array(1,2,3))) {
        $themeOptions[$customTheme['theme_id']] = '<img src="./application/modules/Sitefbclone/externals/images/color-scheme/'.$customTheme['theme_id'].'.png" alt="" />';
    } else {
        $themeOptions[$customTheme['theme_id']] = '<img src="./application/modules/Sitefbclone/externals/images/color-scheme/custom.png" alt="" /> <span class="custom_theme_name">'. $customTheme->name.'</span>';
    }
}

$this->addElement('Radio', 'theme_color', array(
  'label' => 'Color Schemes',
  'multiOptions' => $themeOptions,
  'onclick' => 'changeThemeColor(this.value, "")',
  'escape' => false,
  'value' => $api->getContantValueXML('theme_color'),
));

$this->addElement('dummy', 'custom_themes', array(
  'decorators' => array(array('ViewScript', array(
    'viewScript' => 'application/modules/Sitefbclone/views/scripts/custom_themes.tpl',
    'class' => 'form element',
)))
));

$theme_color = $api->getContantValueXML('theme_color');
if($theme_color == '5') {
  $sitefbclone_header_background_color = $settings->getSetting('sitefbclone.header.background.color');
  $sitefbclone_mainmenu_background_color = $settings->getSetting('sitefbclone.mainmenu.background.color');
  $sitefbclone_mainmenu_links_color = $settings->getSetting('sitefbclone.mainmenu.link.color');
  $sitefbclone_mainmenu_links_hover_color = $settings->getSetting('sitefbclone.mainmenu.link.hover.color');
  $sitefbclone_mainmenu_links_hover_background_color = $settings->getSetting('sitefbclone.mainmenu.links.hover.background.color');
  $sitefbclone_minimenu_links_color = $settings->getSetting('sitefbclone.minimenu.link.color');
  $sitefbclone_minimenu_link_active_color = $settings->getSetting('sitefbclone.minimenu.link.active.color');
  $sitefbclone_footer_background_color = $settings->getSetting('sitefbclone.footer.background.color');
  $sitefbclone_footer_font_color = $settings->getSetting('sitefbclone.footer.font.color');
  $sitefbclone_footer_links_color = $settings->getSetting('sitefbclone.footer.links.color');
  $sitefbclone_footer_border_color = $settings->getSetting('sitefbclone.footer.border.color');
  $sitefbclone_theme_color = $settings->getSetting('sitefbclone.theme.color');
  $sitefbclone_body_background_color = $settings->getSetting('sitefbclone.body.background.color');
  $sitefbclone_menu_tip_color = $settings->getSetting('sitefbclone.menu.tip.color');
  $sitefbclone_font_color = $settings->getSetting('sitefbclone.font.color');
  $sitefbclone_font_color_light = $settings->getSetting('sitefbclone.font.color.light');
  $sitefbclone_links_color = $settings->getSetting('sitefbclone.links.color');
  $sitefbclone_links_hover_color = $settings->getSetting('sitefbclone.links.hover.color');
  $sitefbclone_headline_color = $settings->getSetting('sitefbclone.headline.color');
  $sitefbclone_border_color = $settings->getSetting('sitefbclone.border.color');
  $sitefbclone_box_background_color = $settings->getSetting('sitefbclone.box.background.color');
  $sitefbclone_form_label_color = $settings->getSetting('sitefbclone.form.label.color');
  $sitefbclone_input_background_color = $settings->getSetting('sitefbclone.input.background.color');
  $sitefbclone_input_font_color = $settings->getSetting('sitefbclone.input.font.color');
  $sitefbclone_input_border_color = $settings->getSetting('sitefbclone.input.border.colors');
  $sitefbclone_button_background_color = $settings->getSetting('sitefbclone.button.background.color');
  $sitefbclone_button_background_color_hover = $settings->getSetting('sitefbclone.button.background.color.hover');
  $sitefbclone_button_font_color = $settings->getSetting('sitefbclone.button.font.color');
  $sitefbclone_button_border_color = $settings->getSetting('sitefbclone.button.border.color');
  $sitefbclone_comments_background_color = $settings->getSetting('sitefbclone.comments.background.color');
} else {

  $sitefbclone_header_background_color = $api->getContantValueXML('sitefbclone_header_background_color');
  $sitefbclone_mainmenu_background_color = $api->getContantValueXML('sitefbclone_mainmenu_background_color');
  $sitefbclone_mainmenu_links_color = $api->getContantValueXML('sitefbclone_mainmenu_links_color');
  $sitefbclone_mainmenu_links_hover_color = $api->getContantValueXML('sitefbclone_mainmenu_links_hover_color');
  $sitefbclone_minimenu_links_color = $api->getContantValueXML('sitefbclone_minimenu_links_color');
  $sitefbclone_minimenu_link_active_color = $api->getContantValueXML('sitefbclone_minimenu_link_active_color');
  $sitefbclone_mainmenu_links_hover_background_color = $api->getContantValueXML('sitefbclone_mainmenu_links_hover_background_color');
  $sitefbclone_footer_background_color = $api->getContantValueXML('sitefbclone_footer_background_color');
  $sitefbclone_footer_font_color = $api->getContantValueXML('sitefbclone_footer_font_color');
  $sitefbclone_footer_links_color = $api->getContantValueXML('sitefbclone_footer_links_color');
  $sitefbclone_footer_border_color = $api->getContantValueXML('sitefbclone_footer_border_color');
  $sitefbclone_theme_color = $api->getContantValueXML('sitefbclone_theme_color');
  $sitefbclone_body_background_color = $api->getContantValueXML('sitefbclone_body_background_color');
  $sitefbclone_menu_tip_color = $api->getContantValueXML('sitefbclone_menu_tip_color');
  $sitefbclone_font_color = $api->getContantValueXML('sitefbclone_font_color');
  $sitefbclone_font_color_light = $api->getContantValueXML('sitefbclone_font_color_light');
  $sitefbclone_links_color = $api->getContantValueXML('sitefbclone_links_color');
  $sitefbclone_links_hover_color = $api->getContantValueXML('sitefbclone_links_hover_color');
  $sitefbclone_headline_color = $api->getContantValueXML('sitefbclone_headline_color');
  $sitefbclone_border_color = $api->getContantValueXML('sitefbclone_border_color');
  $sitefbclone_box_background_color = $api->getContantValueXML('sitefbclone_box_background_color');
  $sitefbclone_form_label_color = $api->getContantValueXML('sitefbclone_form_label_color');
  $sitefbclone_input_background_color = $api->getContantValueXML('sitefbclone_input_background_color');
  $sitefbclone_input_font_color = $api->getContantValueXML('sitefbclone_input_font_color');
  $sitefbclone_input_border_color = $api->getContantValueXML('sitefbclone_input_border_color');
  $sitefbclone_button_background_color = $api->getContantValueXML('sitefbclone_button_background_color');
  $sitefbclone_button_background_color_hover = $api->getContantValueXML('sitefbclone_button_background_color_hover');
  $sitefbclone_button_font_color = $api->getContantValueXML('sitefbclone_button_font_color');
  $sitefbclone_button_border_color = $api->getContantValueXML('sitefbclone_button_border_color');
  $sitefbclone_comments_background_color = $api->getContantValueXML('sitefbclone_comments_background_color');
}

$this->addElement('Dummy', 'header_settings', array(
    'label' => 'Header Styling Settings',
));
$this->addElement('Text', "sitefbclone_header_background_color", array(
    'label' => 'Header Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_header_background_color,
));

$this->addElement('Text', "sitefbclone_mainmenu_background_color", array(
    'label' => 'Main Menu Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_mainmenu_background_color,
));

$this->addElement('Text', "sitefbclone_mainmenu_links_color", array(
    'label' => 'Main Menu Link Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_mainmenu_links_color,
));

$this->addElement('Text', "sitefbclone_mainmenu_links_hover_color", array(
    'label' => 'Main Menu Link Hover Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_mainmenu_links_hover_color,
));
$this->addElement('Text', "sitefbclone_mainmenu_links_hover_background_color", array(
    'label' => 'Main Menu Link Hover Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_mainmenu_links_hover_background_color,
));
$this->addElement('Text', "sitefbclone_menu_tip_color", array(
    'label' => 'Vertical Main Menu Mouseover Tip Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_menu_tip_color,
));

$this->addElement('Text', "sitefbclone_minimenu_links_color", array(
    'label' => 'Mini Menu Link Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_minimenu_links_color,
));

$this->addElement('Text', "sitefbclone_minimenu_link_active_color", array(
    'label' => 'Mini Menu Link Active Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_minimenu_link_active_color,
));

$this->addDisplayGroup(array('sitefbclone_header_background_color', 'sitefbclone_mainmenu_background_color', 'sitefbclone_mainmenu_links_color', 'sitefbclone_mainmenu_links_hover_color', 'sitefbclone_mainmenu_links_hover_background_color', 'sitefbclone_menu_tip_color', 'sitefbclone_minimenu_links_color', 'sitefbclone_minimenu_link_active_color'), 'header_settings_group', array('disableLoadDefaultDecorators' => true));
$header_settings_group = $this->getDisplayGroup('header_settings_group');
$header_settings_group->setDecorators(array('FormElements', 'Fieldset', array('HtmlTag', array('tag' => 'div', 'id' => 'header_settings_group'))));

$this->addElement('Dummy', 'footer_settings', array(
    'label' => 'Footer Styling Settings',
));
$this->addElement('Text', "sitefbclone_footer_background_color", array(
    'label' => 'Footer Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_footer_background_color,
));

$this->addElement('Text', "sitefbclone_footer_font_color", array(
    'label' => 'Footer Font Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_footer_font_color,
));

$this->addElement('Text', "sitefbclone_footer_links_color", array(
    'label' => 'Footer Link Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_footer_links_color,
));

$this->addElement('Text', "sitefbclone_footer_border_color", array(
    'label' => 'Footer Border Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_footer_border_color,
));
$this->addDisplayGroup(array('sitefbclone_footer_background_color', 'sitefbclone_footer_font_color', 'sitefbclone_footer_links_color', 'sitefbclone_footer_border_color'), 'footer_settings_group', array('disableLoadDefaultDecorators' => true));
$footer_settings_group = $this->getDisplayGroup('footer_settings_group');
$footer_settings_group->setDecorators(array('FormElements', 'Fieldset', array('HtmlTag', array('tag' => 'div', 'id' => 'footer_settings_group'))));

$this->addElement('Dummy', 'body_settings', array(
    'label' => 'Body Styling Settings',
));
$this->addElement('Text', "sitefbclone_theme_color", array(
    'label' => 'Theme Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_theme_color,
));

$this->addElement('Text', "sitefbclone_body_background_color", array(
    'label' => 'Body Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_body_background_color,
));

$this->addElement('Text', "sitefbclone_font_color", array(
    'label' => 'Font Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_font_color,
));

$this->addElement('Text', "sitefbclone_font_color_light", array(
    'label' => 'Font Light Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_font_color_light,
));

$this->addElement('Text', "sitefbclone_links_color", array(
  'label' => 'Link Color',
  'allowEmpty' => false,
  'required' => true,
  'class' => 'SEcolor',
  'value' => $sitefbclone_links_color,
));

$this->addElement('Text', "sitefbclone_links_hover_color", array(
    'label' => 'Link Hover Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_links_hover_color,
));

$this->addElement('Text', "sitefbclone_headline_color", array(
    'label' => 'Headline Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_headline_color,
));

$this->addElement('Text', "sitefbclone_border_color", array(
    'label' => 'Border Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_border_color,
));
$this->addElement('Text', "sitefbclone_box_background_color", array(
    'label' => 'Box Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_box_background_color,
));

$this->addElement('Text', "sitefbclone_form_label_color", array(
    'label' => 'Form Label Font Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_form_label_color,
));

$this->addElement('Text', "sitefbclone_input_background_color", array(
    'label' => 'Input Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_input_background_color,
));

$this->addElement('Text', "sitefbclone_input_font_color", array(
    'label' => 'Input Font Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_input_font_color,
));

$this->addElement('Text', "sitefbclone_input_border_color", array(
    'label' => 'Input Border Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_input_border_color,
));

$this->addElement('Text', "sitefbclone_button_background_color", array(
    'label' => 'Button Background Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_button_background_color,
));
$this->addElement('Text', "sitefbclone_button_background_color_hover", array(
    'label' => 'Button Background Hovor Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_button_background_color_hover,
));

$this->addElement('Text', "sitefbclone_button_font_color", array(
    'label' => 'Button Font Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_button_font_color,
));
$this->addElement('Text', "sitefbclone_button_border_color", array(
    'label' => 'Button Border Color',
    'allowEmpty' => false,
    'required' => true,
    'class' => 'SEcolor',
    'value' => $sitefbclone_button_border_color,
));
$this->addElement('Text', "sitefbclone_comments_background_color", array(
  'label' => 'Comments Background Color',
  'allowEmpty' => false,
  'required' => true,
  'class' => 'SEcolor',
  'value' => $sitefbclone_comments_background_color,
));

$this->addDisplayGroup(array('sitefbclone_theme_color','sitefbclone_body_background_color', 'sitefbclone_font_color', 'sitefbclone_font_color_light', 'sitefbclone_links_color', 'sitefbclone_links_hover_color','sitefbclone_headline_color', 'sitefbclone_border_color', 'sitefbclone_box_background_color', 'sitefbclone_form_label_color', 'sitefbclone_input_background_color', 'sitefbclone_input_font_color', 'sitefbclone_input_border_color', 'sitefbclone_button_background_color', 'sitefbclone_button_background_color_hover', 'sitefbclone_button_font_color', 'sitefbclone_button_border_color', 'sitefbclone_dashboard_list_background_color_hover', 'sitefbclone_dashboard_list_border_color', 'sitefbclone_dashboard_font_color', 'sitefbclone_dashboard_link_color', 'sitefbclone_comments_background_color'), 'body_settings_group', array('disableLoadDefaultDecorators' => true));
$body_settings_group = $this->getDisplayGroup('body_settings_group');
$body_settings_group->setDecorators(array('FormElements', 'Fieldset', array('HtmlTag', array('tag' => 'div', 'id' => 'body_settings_group'))));

$this->addElement('Button', 'save', array(
    'label' => 'Save Changes',
    'type' => 'submit',
    'ignore' => true,
    'decorators' => array('ViewHelper')
));
}
}
