<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLayoutController.php 2018-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_AdminLayoutController extends Core_Controller_Action_Admin
{

	public function indexAction()
	{
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_main_customization');
		$this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_theme_custom', array(), 'sitefbclone_admin_layout_index');

		//MAKE FORM
		$this->view->form = $form = new Sitefbclone_Form_Admin_Settings_Layout();


		if( !$this->getRequest()->isPost() )
			return;

		if( !$form->isValid($this->getRequest()->getPost()) ) {
			return;
		}


		$values = $form->getValues();

		$fileName = 'sitefbcloneThemeGeneralConstants.css';
		$valuesWithPx = $values;
		$valuesWithPx['sitefbclone_layout_theme_width'] = $valuesWithPx['sitefbclone_layout_theme_width'].'px';
		$valuesWithPx['sitefbclone_layout_left_column_width'] = $valuesWithPx['sitefbclone_layout_left_column_width'].'px';
		$valuesWithPx['sitefbclone_layout_right_column_width'] = $valuesWithPx['sitefbclone_layout_right_column_width'].'px';
		$successfullySaved = Engine_Api::_()->getApi('customization', 'sitefbclone')->setConstants($valuesWithPx, $fileName);

		foreach( $values as $key => $value ) {
			Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
		}

		if( !empty($successfullySaved) ) {
			Core_Model_DbTable_Themes::clearScaffoldCache();

			$form->addNotice('Changes successfully saved. If changes not reflect to frontend then please change the mode to Development.');
		}
	}

}
