<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitefbclone
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFieldsController.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitefbclone_AdminSettingsController extends Core_Controller_Action_Admin {

	public function indexAction() {
		
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_main_settings');

		$this->view->form = $form = new Sitefbclone_Form_Admin_Settings_Global(array('BackGroundColor' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitefbclone_color','#f0f2f5')));

		$tableSimages = Engine_Api::_()->getDbtable('simages', 'sitefbclone');
		$select = $tableSimages->select()->where('saved = ?', 1);
		$select->order('order ASC');
	   	$this->view->list = $simages = Zend_Paginator::factory($select);
		
		if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams())) {
			
			$values = $form->getValues();
			
			foreach ($values as $key => $value) {
				if($key == 'sitefbclone_slider' && $value == '2'){
				if(empty(count($simages))){
						 return $form->addError('Please add images from slider images section.');
					}
				}
				Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
			}
			$form->addNotice('Your changes have been saved.');
		}
	}

	public function footerMenuAction() {
		$this->_redirect('admin/menus/index?name=sitefbclone_footer');
	}

	public function orderAction() {
        if (!empty($_POST)) {
            foreach ($_POST as $key => $value) {
                if (strstr($key, "content_")) {
                    $keyArray = explode("content_", $key);

                    if (!empty($keyArray))
                        $image_id = end($keyArray);

                    if (!empty($image_id)) {
                        $obj = Engine_Api::_()->getItem('sitefbclone_simage', $image_id);
                        $obj->order = $value;
                        $obj->save();
                    }
                }
            }
        }
    }

    //ACTION FOR MAKE SLIDESHOW ENABLE/DIS-ABLE
    public function enabledAction() {
        //GET SLIDESHOW ID
        $id = $this->_getParam('id');
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
            //GET SLIDESHOW OBJECT
          $table = Engine_Api::_()->getDbtable('simages', 'sitefbclone');
          $simage = $table->fetchRow($table->select()->where('simage_id = ?', $id));
          if ($simage->enabled == 0) {
              $simage->enabled = 1;
          } else {
              $simage->enabled = 0;
          }
          $simage->save();
          $db->commit();
        } catch (Exception $e) {
          $db->rollBack();
          throw $e;
        }
        $this->_redirect('admin/sitefbclone/settings/slider-images');
    }

	public function configurePagesAction() {
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
		->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_configure_pages');

		
		$this->view->form = $form = new Sitefbclone_Form_Admin_Settings_Configure();

		if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
			$values = $form->getValues();
			
			foreach( $values as $key => $value ) {
				Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
			}
			$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
			$URL = $view->baseUrl() . '/admin/content';

			if ($values['sitefbclone_landing_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setDefaultLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'landing_page_backup', 'name' => 'core_index_index'));
			}

			if ($values['sitefbclone_header_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setHeaderLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'header_backup', 'name' => 'header'));
			}

			if ($values['sitefbclone_footer_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setFooterLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'footer_backup', 'name' => 'footer'));
			}

			if ($values['sitefbclone_login_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setSignInPageLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'user_auth_login_backup', 'name' => 'user_auth_login'));
			}

			if ($values['sitefbclone_login_required_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setSignInRequiredPageLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'core_error_requireuser_backup', 'name' => 'core_error_requireuser'));
			}
			
			if ($values['sitefbclone_signup_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setSignUpPageLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'user_signup_index_backup', 'name' => 'user_signup_index'));
			}

			if ($values['sitefbclone_forgot_password_page_layout']) {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->setForgotPasswordPageLayout($values);
			} else {
				Engine_Api::_()->getApi('pagelayouts', 'sitefbclone')->restorePageBackup(array('pageUrl' => 'user_auth_forgot_backup', 'name' => 'user_auth_forgot'));
			}
			$form->addNotice('Your changes have been saved. Please check your pages layout from <a href="' . $URL . '" target="_blank">here</a>.');
		}
	}

	public function faqAction()
	{
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
		->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_settings_faq');
		$this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
	}

	public function imageUploadAction()
	{
		if( !$this->_helper->requireUser()->checkRequire() )
		{
			$this->view->status = false;
			$this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
			return;
		}

		if( !$this->getRequest()->isPost() )
		{
			$this->view->status = false;
			$this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
			return;
		}

		$values = $this->getRequest()->getPost();

		if (empty($_FILES['file'])) {
			$this->view->status = false;
			$this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
			return;
		}

		$db = Engine_Api::_()->getDbTable('simages','sitefbclone')->getAdapter();
		$db->beginTransaction();

		try {
			$viewer = Engine_Api::_()->user()->getViewer();

			$simagesTable = Engine_Api::_()->getDbTable('simages','sitefbclone');
			$photo = $simagesTable->createRow();
			$photo->title = $_FILES['file']['name'];
			$photo->enabled = 0;
			$photo->order = 0;
			$photo->saved = 0;
			$photo->save();


			$photo->setPhoto($_FILES['file']);

			$this->view->status = true;
			$this->view->name = $_FILES['file']['name'];
			$this->view->photo_id = $photo->simage_id;

			$db->commit();

			$this->sendJson([
				'id' => $photo->simage_id,
				'fileName' => $_FILES['file']['name']
			]);
		}

		catch( Exception $e )
		{
			$db->rollBack();
			$this->view->status = false;
			$this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.');
    		return;
		}
	}

	public function uploadAction()
	{
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_main_settings_slider-images');

    	//MAKE FORM
		$this->view->form = $form = new Sitefbclone_Form_Admin_Settings_Landingpage_SlideImage();

    	// Check method/data
		if( !$this->getRequest()->isPost() ) {
			return;
		}
		if( !$form->isValid($this->getRequest()->getPost()) ) {
			return;
		}

		$values = $form->getValues();

		if(empty($values['file'][0]) ) {
			$form->file->setErrors(array("File 'photo' is not uploaded. Please select photo"));
			return;
		}
		$simagesTable = Engine_Api::_()->getDbTable('simages','sitefbclone');
		$simages = $simagesTable->fetchAll($simagesTable->select()->where('saved = ?', 0));
		foreach ($simages as $key => $simage) {
			if(!in_array($simage->getIdentity(), $values['file'])){
				$simage->delete();
			} else {
				$simage->enabled = 1;
				$simage->saved = 1;
				$simage->save();
			}
		}

		$this->_redirect('admin/sitefbclone/settings/slider-images');
	}

	public function sliderImagesAction()
	{
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_settings_slider');

		$tableSimages = Engine_Api::_()->getDbtable('simages', 'sitefbclone');
		$select = $tableSimages->select()->where('saved = ?', 1);
		$select->order('order ASC');
    
		$this->view->list = Zend_Paginator::factory($select);
		$items_per_page = 10;
		$this->view->list->setItemCountPerPage($items_per_page);
		$this->view->list = $this->view->list->setCurrentPageNumber($this->_getParam('page'));

	}

	public function customCssAction()
	{
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_main', array(), 'sitefbclone_admin_main_customization');
		$this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitefbclone_admin_theme_custom', array(), 'sitefbclone_admin_settings_custom_css');
		$filePath = APPLICATION_PATH . '/application/themes/sitefbclone/customization.css';
		$isFileExist = @file_exists($filePath);

		$this->view->message = '';
		$this->view->sucess = false;

		if( empty($isFileExist) ) {
			$fh = @fopen($filePath, 'w') or die('Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/sitefbclone/, then try again.');
			@fclose($fh);
		} elseif( !is_writable($filePath) ) {
			@chmod($filePath, 0777);
			if( !is_writable($filePath) ) {
				$this->view->message = 'Unable to write customization CSS file; please give the CHMOD 777 recursive permission to the directory /application/themes/sitefbclone/, then try again.';
				return;
			}
		}

		$this->view->fileContent = file_get_contents($filePath);

		// Check method/data
		if( !$this->getRequest()->isPost() ) {
			return;
		}

		if( !isset($_POST['sitefbclone_custom_css']) ) {
			return;
		}

		if( @file_put_contents($filePath, $_POST['sitefbclone_custom_css']) ) {
			@chmod($filePath, 0777);
			$this->view->message = 'Your changes have been saved.';
			$this->view->sucess = true;
		}
		$this->view->fileContent = $_POST['sitefbclone_custom_css'];
	} 

	public function editImageAction() {
		$simage_id = $this->_getParam('simage_id');
		$simage = Engine_Api::_()->getItem('sitefbclone_simage', $simage_id);
		$this->_helper->layout->setLayout('default-simple');
		$title = $simage->title;
		$form = $this->view->form = new Sitefbclone_Form_Admin_Settings_Landingpage_Edit();
		$form->title->setValue($title);
		if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

			$simage->title = $_POST['title'];
			$simage->save();
			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRefresh' => 10,
				'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved successfully.'))
			));
		}
	}

	//ACTION FOR DELETE SLIDESHOW
	public function deleteImageAction() {
        //LAYOUT
		$this->_helper->layout->setLayout('admin-simple');

        //GET SLIDESHOW ID
		$this->view->id = $id = $this->_getParam('id');

		if ($this->getRequest()->isPost()) {
			$table = Engine_Api::_()->getDbtable('simages', 'sitefbclone');

			$result = $table->fetchRow($table->select()->where('simage_id = ?', $id));
			$result->delete();
			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRefresh' => 10,
				'messages' => array('')
			));
		}
		$this->renderScript('admin-settings/delete-image.tpl');
	}

  	//ACTION FOR DELETE SLIDESHOW AND THEIR BELONGINGS
	public function multiImageDeleteAction() {
		if ($this->getRequest()->isPost()) {

			$values = $this->getRequest()->getPost();
			$table = Engine_Api::_()->getDbtable('simages', 'sitefbclone');
          	//IF ADMIN CLICK ON DELETE SELECTED BUTTON
			foreach ($values as $key => $value) {
				if ($key == 'delete_' . $value) {
					$id = (int) $value;
					$result = $table->fetchRow($table->select()->where('simage_id = ?', $id));
					$result->delete();
				}
			}
		}
		$this->_redirect('admin/sitefbclone/settings/slider-images');
	}
}
