<?php
$menusTable =  Engine_Api::_()->getDbtable('menus', 'sitefbclone');
$menuCategories = $menusTable->getAllMenus( array('enabled' => 1,'link' => 1));
$homeFeedElements[] = array();

if(Engine_Api::_()->hasModuleBootstrap('primemessenger') && Engine_Api::_()->primemessenger()->isPrimeMessengerActive()){
  $homeFeedElements[] = array(
    'Radio',
    'showPrimeMessenger',
    array(
      'label' => "Do you want to show prime messenger option?",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 1,
    )
  );
}
$menuCategoriesArray[] = 'All';
foreach ($menuCategories as $menu){
  $menuCategoriesArray[$menu->getIdentity()] = $menu->getTitle();
}
$view = Zend_Registry::get('Zend_View');
if(count($menuCategoriesArray) > 1) {
  $exploreLinksCategoryElement = array(
    'Select',
    'parent',
    array(
      'label' => 'Select Menu',
      'multiOptions' => $menuCategoriesArray,
    ),
    'value' => '',
  );
} else {
  
  $exploreLinksCategoryElement = array(
    'dummy',
    'tip',
    array(
      'description' => '<div style="background-color: #E7E8B3;
      padding: 5px;">Some of the default explore links are already created for your site. You can edit / add more from <a href="'.$view->baseUrl('/admin/sitefbclone/menus').'"  target = "_blank" >here</a> as per your requirement.</div>',
      'decorators' => array('ViewHelper', array('Description', array('placement' => 'PREPEND', 'escape' => false))),
    ),
    'class' => 'tip',
  );
}

return array(
  array(
    'title' => 'New Facebook Clone Theme - Footer Menu',
    'description' => 'Shows the site-wide footer menu. You can edit its contents in your menu editor.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.menu-footer',
    'adminForm' => array(
        'elements' => array(
            array(
                'Radio',
                'showCopyRight',
                array(
                    'label' => 'Do you want to show the copyright note in the footer of your site?',
                    'multiOptions' => array(
                        1 => 'Yes',
                        0 => 'No'
                    ),
                    'value' => 1
                )
            )
        )
    ),
    'requirements' => array(
      'header-footer',
    ),
  ),
  array(
    'title' => 'New Facebook Clone Theme - Add / Remove Shortcut Buttons',
    'description' => 'This widget is used to add/ remove shortcuts.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.add-to-shortcuts',
  ),
  array(
    'title' => 'New Facebook Clone Theme - Full width slider',
    'description' => 'You can configure its settings via the Global Settings in admin panel. Click on <a href="'.$view->baseUrl('/admin/sitefbclone/settings').'"  target = "_blank" > Global Settings</a> to modify the other content for this widget.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.landing-page-tagline',
    'adminForm' => array(
          'elements' => array(
              array(
                  'Radio',
                  'showRecentLogins',
                  array(
                      'label' => "Do you want to show Recent Logins on the logout page?",
                      'multiOptions' => array(
                          1 => 'Yes',
                          0 => 'No'
                      ),
                      'value' => 1,
                  )
              ),
          ),
      ),
  ),
  array(
    'title' => 'New Facebook Clone Theme - Recent Logins',
    'description' => 'Displays Recent Login Users.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.list-logins',
    'adminForm' => array(
      'elements' => array(
        array(
          'Text',
          'max',
          array(
            'description' => "How many recently logged in users you want to display to make login easy? It will be browser specific.",
            'value' => 4
          )
        )
      )),
    'requirements' => array(
      'viewer',
    ),
  ),
  array(
    'title' => 'New Facebook Clone Theme - Sign In and Sign Up',
    'description' => 'Displays signin signup widget.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.form-banner',
    'defaultParams' => array(
      'title' => '',
    ),
  ),
  array(
    'title' => 'New Facebook Clone Theme - Non-Login Header',
    'description' => 'Displays the header options on your site landing page. You can edit its content in your menu editor. Click on <a href="'.$view->baseUrl('/admin/sitefbclone/header').'"  target = "_blank" >edit</a> to modify the other content for this widget.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.non-login-header',
  ),
  array(
    'title' => 'New Facebook Clone Theme - Languages',
    'description' => 'This widget is used to display the languages available on site.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.language',
    'adminForm' => array(
      'elements' => array(
        array(
          'Text',
          'showLanguages',
          array(
            'description' => "Enter the number of languages which you want to showcase. The left over languages will be shown under the more option.",
            'value' => 3
          )
        )
      )),
  ),
  array(
    'title' => 'New Facebook Clone Theme - Explore Links',
    'description' => 'This widget is used for showcasing all the explore links in order to make exploring easy for you. You can add / manage these links from <a href="'.$view->baseUrl('/admin/sitefbclone/menus').'"  target = "_blank" >Manage Explore Links</a> tab in the admin panel.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.explore-links',
    'adminForm' => array(
      'elements' => array(
        $exploreLinksCategoryElement,
        array(
          'Integer',
          'viewmore_limit',
          array(
            'label' => "View More Limit",
            'description' => "(Enter the number after which you want to show view more option for explore sub-menus)",
            'value' => 2
          )
        ),
      )),
  ),
  array(
    'title' => 'New Facebook Clone Theme - User Photo',
    'description' => 'Displays the logged-in member\'s photo.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.home-photo',
    'requirements' => array(
      'viewer',
    ),
    'adminForm' => array(
      'elements' => $homeFeedElements,
    ),
  ),
  array(
    'title' => 'New Facebook Clone Theme - User Cover Photo',
    'description' => ' This should be placed on Member Profile Page which displays the cover photo, profile photo.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.fb-cover-profile',
  ),
  array(
    'title' => 'New Facebook Clone Theme - Login Header',
    'description' => 'Displays the header options on your site landing page. You can edit its content in your menu editor. Click on <a href="'.$view->baseUrl('/admin/sitefbclone/header').'"  target = "_blank" > edit </a> to modify the other content for this widget.',
    'category' => 'SEAO - New Facebook Clone Theme',
    'type' => 'widget',
    'name' => 'sitefbclone.login-header',
  ),
  array(
        'title' => 'New Facebook Clone Theme - User Shortcuts',
        'description' => 'This widget is used to display all the shortcuts added by user.',
        'category' => 'SEAO - New Facebook Clone Theme',
        'type' => 'widget',
        'name' => 'sitefbclone.user-shortcuts',
    ),
  array(
      'title' => 'New Facebook Clone Theme - Sticky / Fix Page Columns Widget',
      'description' => 'This widget is used to sticky /fix the content of column on scroll.',
      'category' => 'SEAO - New Facebook Clone Theme',
      'name' => 'sitefbclone.sitefixcolumn',
      'adminForm' => array(
        'elements' => array(
          array('Hidden', 'title', array(
              'order' => 99
            )
          ),
          array('Hidden', 'nomobile', array(
              'order' => 90
            )
          ),
          array('Text', 'startOffset', array(
              'label' => 'Margin from Top',
              'description' => 'Enter the margin you want to keep from top. [Note: If your website has fixed header then you can set the margin accordingly from here.]',
              'value' => 5,
              'validators' => array(
                array('Int')
              )
            )
          ),
        )
      )
  ),
);