<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Sitefbclone
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitefbclone_Widget_NonLoginHeaderController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        // Do not show if logged in
        if (Engine_Api::_()->user()->getViewer()->getIdentity()) {
            $this->setNoRender();
            return;
        }
        $request = Zend_Controller_Front::getInstance()->getRequest();
        if(($request->getControllerName() == 'signup' && $request->getActionName() == 'index') || ($request->getActionName() == 'login') || ($request->getModuleName() == 'core' && $request->getControllerName() == 'index' && $request->getActionName() == 'index')){
            $this->setNoRender();
            return;
        }

        //Core settings
        $this->view->coreSettings = $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        $this->view->logo = $coreSettings->getSetting('sitefbclone.landing.logo.image');

        $this->view->loggedInWidgets = $coreSettings->getSetting('sitefbclone.header.loggedin.widgets', $deafultHeaderOptions);

        // Display form
        $form = $this->view->form = new User_Form_Login(array(
            'mode' => 'column',
        ));
        $form->setTitle(null)->setDescription(null);
    }

}
