<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Category.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitegdpr_Form_Admin_Consent_Category extends Engine_Form
{

  public function init()
  {
    $this->setTitle("Add Consent");
    $this->setAttrib('id', 'form-upload');

    $this->addElement('Select', 'required', array(
      'label' => "Consent Type",
      'multiOptions' => array(
        '0' => 'Optional',
        '1' => 'Required',
      ),
    ));

    // Init name
    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'maxlength' => '64',
      'allowEmpty' => false,
      'required' => true,
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
        new Engine_Filter_StringLength(array('max' => '64')),
      ),
    ));

    $this->addElement('Textarea', 'description', array(
      'label' => 'Description',
    ));

    $pages = Engine_Api::_()->getDbtable('consentsPages', 'sitegdpr')->fetchAll();
    foreach( $pages as $page ) {
      $pagesOption[$page->consentspage_id] = $page->page_name;
    }

    $this->addElement('MultiCheckbox', 'show_on_pages', array(
      'label' => "Display on Pages",
      'multiOptions' => $pagesOption,
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Submit',
      'type' => 'submit',
      'ignore' => true,
    ));
  }

}

?>

