<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Category.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitegdpr_Form_Admin_Cookies_Category extends Engine_Form
{

  public function init()
  {
    $this->setTitle("Add Cookie Category");
    $this->setAttrib('id', 'form-upload');

    // Init name
    $this->addElement('Text', 'title', array(
      'label' => 'Title',
      'maxlength' => '64',
      'allowEmpty' => false,
      'required' => true,
    ));

    $this->addElement('radio', 'is_thirdparty_cookie', array(
      'label' => "Cookie Origin",
      'multiOptions' => array(
        '0' => 'This site',
        '1' => 'Third Party Site',
      ),
      'value' => 0,
      'onclick' => 'showDomainField()'
    ));

    $this->addElement('Text', 'cookie_domain', array(
      'label' => 'Third Party Site URL',
      'maxlength' => '512',
    ));

    $this->addElement('Select', 'required', array(
      'label' => "Cookie Type",
      'multiOptions' => array(
        '0' => 'Optional',
        '1' => 'Required',
      ),
      'value' => 0,
      'onclick' => 'showoptoutField()'
    ));

    $faqUrl = $this->getView()->url(array('action' => 'faq', 'controller' => 'general', 'module' => 'sitegdpr', 'faq' => 'faq_5' ), 'admin_default');
    $links = array($faqUrl);
    $label = vsprintf('Opt-out Link (<a href="%1$s" target="_blank">know more</a> )',$links);

    $this->addElement('Text', 'optout_link', array(
      'label' => $label,
      'maxlength' => '512',
    ));
    $this->optout_link->getDecorator('label')->setOption('escape', false);

    $this->addElement('Text', 'cookies', array(
      'label' => 'Cookies (comma seperated)',
      'maxlength' => '512',
    ));

    $this->addElement('Textarea', 'cookies_purpose', array(
      'label' => 'Purpose of the Cookies',
      'maxlength' => '1024',
      'allowEmpty' => false,
      'required' => true,
    ));


    $this->addElement('Button', 'submit', array(
      'label' => 'Submit',
      'type' => 'submit',
      'ignore' => true,
    ));
  }

}

?>

<script type="text/javascript">
  var form = document.getElementById("form-upload");
  window.addEvent('domready', function () {
    showDomainField();
    showoptoutField()
  });

  function showDomainField() {
    if (form.elements["is_thirdparty_cookie"].value == 1) {
      $('cookie_domain-wrapper').style.display = 'block';
    } else {
      $('cookie_domain-wrapper').style.display = 'none';
    }
  }
  
  function showoptoutField() {
    if (form.elements["required"].value == 1) {
      $('optout_link-wrapper').style.display = 'block';
    } else {
      $('optout_link-wrapper').style.display = 'none';
    }
  }
</script>
