<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: UserConsents.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegdpr_Model_DbTable_UserPreferences extends Engine_Db_Table
{

  protected $_name = 'sitegdpr_user_preferences';
  protected $_rowClass = 'Sitegdpr_Model_UserPreference';

  public function alreadyExists($userId)
  {
    $tableName = $this->info('name');
    $select = $this->select();
    $data = $select->from($tableName, 'userpreference_id')
      ->where('user_id = ?', $userId)
      ->query()
      ->fetchColumn();

    if( $data ) {
      return $data;
    }

    return false;
  }

  public function getPreferences($userId)
  {
    $tableName = $this->info('name');
    $select = $this->select();
    $data = $select->from($tableName, 'consents')
      ->where('user_id = ?', $userId)
      ->query()
      ->fetchColumn();

    if( $data ) {
      return $data;
    }

    return false;
  }

// fetch perticular user data
  public function getUserRequests($userId)
  {
    $tableName = $this->info('name');
    $select = $this->select();
    $data = $select->from($tableName, 'consents')
      ->where('user_id = ?', $userId)
      ->query()
      ->fetchColumn();

    if( $data ) {
      return $data;
    }

    return false;
  }

}
