<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegdpr
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2018-05-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */


class Sitegdpr_Installer extends Engine_Package_Installer_Module
{

  public function onInstall()
  {
    $this->addBannerWidget();
    parent::onInstall();
  }

  private function addBannerWidget()
  {
    $db = $this->getDb();

    $theme_id = $db->select()
      ->from('engine4_core_themes', 'theme_id')
      ->where('active = ?', 1)
      ->where('name = ?', 'facelight')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !empty($theme_id) ) {
      $this->addBannerWidgetHeader();
    } else {
      $this->addBannerWidgetFooter();
    }
  }

  private function addBannerWidgetHeader()
  {
    $db = $this->getDb();

    $page_id = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'header')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !empty($page_id) ) {

      $widget_id = $db->select()
        ->from('engine4_core_content', 'content_id')
        ->where('name = ?', 'sitegdpr.cookies-banner')
        ->where('page_id = ?', $page_id)
        ->limit(1)
        ->query()
        ->fetchColumn();

      if( !empty($widget_id) ) {
        return;
      }

      $tableNameContentName = "engine4_core_content";
      $parent_content_id = $db->select()
        ->from($tableNameContentName, 'content_id')
        ->where('page_id =?', $page_id)
        ->where('name =?', 'main')
        ->query()
        ->fetchColumn();

      if( empty($parent_content_id) ) {

        $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $page_id,
          'order' => 1,
        ));
        $parent_content_id = $db->lastInsertId();
      }

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitegdpr.cookies-banner',
        'page_id' => $page_id,
        'parent_content_id' => $parent_content_id,
        'order' => 99,
      ));
    }
  }

  private function addBannerWidgetFooter()
  {
    $db = $this->getDb();

    $page_id = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'footer')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !empty($page_id) ) {

      $widget_id = $db->select()
        ->from('engine4_core_content', 'content_id')
        ->where('name = ?', 'sitegdpr.cookies-banner')
        ->where('page_id = ?', $page_id)
        ->limit(1)
        ->query()
        ->fetchColumn();

      if( !empty($widget_id) ) {
        return;
      }

      $tableNameContentName = "engine4_core_content";
      $parent_content_id = $db->select()
        ->from($tableNameContentName, 'content_id')
        ->where('page_id =?', $page_id)
        ->where('name =?', 'main')
        ->query()
        ->fetchColumn();

      if( empty($parent_content_id) ) {

        $db->insert('engine4_core_content', array(
          'type' => 'container',
          'name' => 'main',
          'page_id' => $page_id,
          'order' => 1,
        ));
        $parent_content_id = $db->lastInsertId();
      }

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitegdpr.cookies-banner',
        'page_id' => $page_id,
        'parent_content_id' => $parent_content_id,
        'order' => 99,
      ));
    }
  }

}
