<?php

class Sitegifplayer_Form_Admin_Gifphoto_AddGiphyImageUrl extends Engine_Form
{
  public function init()
  {

    $this->setTitle('Import Single GIF Image')
        ->setDescription('You can import single GIF image from GIPHY via its URL.');

    $this->addElement('Text', 'url', array(
      'label' => 'GIF Image URL',
      'allowEmpty' => false,
      'required' => true,
      'description' => 'Enter the GIF image URL available at GIPHY. [Note: Make sure the URL ends with ‘.gif’]',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->url->getDecorator("Description")->setOption("placement", "append");

    $this->addElement('Text', 'title', array(
      'label' => 'Add Search Keywords',
      'autocomplete' => 'off',
      'allowEmpty' => false,
      'required' => true,
      'description' => 'Enter the keywords for the imported GIF image and separate them with commas. These keywords will be used by your site members to search this GIF image on your website.',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->title->getDecorator("Description")->setOption("placement", "append");




    $this->addElement('Button', 'submit', array(
      'label' => 'Import',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));
    $this->addElement('Cancel', 'cancel', array(
      'label' => 'Cancel',
      'link' => true,
      'prependText' => ' or ',
      'onclick' => 'javascript:parent.Smoothbox.close()',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }

}
