<?php

class Sitegifplayer_Form_Admin_Gifphoto_AddGiphyImages extends Engine_Form
{
  public function init()
  {
    $this->setTitle('Import Multiple GIF Images')
        ->setDescription('By filling below fields you can import multiple GIF images from GIPHY.');

    $this->addElement('Text', 'searchKeyword', array(
      'label' => 'GIPHY Search Keyword',
      'allowEmpty' => false,
      'required' => true,
      'description' => 'Enter the keyword or category name to find the associated GIF images from GIPHY which will be imported to your website.',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->searchKeyword->getDecorator("Description")->setOption("placement", "append");


    $this->addElement('Text', 'title', array(
      'label' => 'Add Search Keywords',
      'autocomplete' => 'off',
      'allowEmpty' => false,
      'required' => true,
      'description' => 'Enter the keywords for the imported GIF images and separate them with commas. These keywords will be used by your site members to search GIF images on your website.',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->title->getDecorator("Description")->setOption("placement", "append");

    $this->addElement('Text', 'limit', array(
      'label' => 'Count of Images',
      'autocomplete' => 'off',
      'allowEmpty' => false,
      'required' => true,
      'value' => 10,
      'description' => 'Enter the count of GIF images to be imported from GIPHY.',
      'filters' => array(
        'StripTags',
        'Int',
        new Engine_Filter_Censor(),
      ),
    ));
    $this->title->getDecorator("Description")->setOption("placement", "append");
    $this->addElement('Button', 'submit', array(
      'label' => 'Import',
      'type' => 'submit',
      'ignore' => true,
      'decorators' => array('ViewHelper')
    ));
    $this->addElement('Cancel', 'cancel', array(
      'label' => 'Cancel',
      'link' => true,
      'prependText' => ' or ',
      'onclick' => 'javascript:parent.Smoothbox.close()',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
    $this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
  }

}
