<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegifplayer
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Form_Admin_Global extends Engine_Form
{

  public function init()
  {
    $this->setTitle('General Settings')
      ->setDescription('These settings affect all users in your community.');

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');

    //SETTINGS FOR ENABLED AND DISABLED "Play Button" 
    $this->addElement('Radio', 'sitegifplayer_allow_action', array(
      'label' => 'Action for GIF Player',
      'description' => 'On what action GIF Player should start',
      'multiOptions' => array(
        1 => 'On mouse hover',
        0 => 'On click over gif image'
      ),
      'value' => $coreSettings->getSetting('sitegifplayer.allow.action', 1)
    ));

    $this->addElement('Text', 'sitegifplayer_duration', array(
      'label' => 'Duration',
      'description' => 'Please enter the minimum time duration for which gif should play once (in sec).',
      'validators' => array(
        array('NotEmpty', true),
        array('Int', true),
        new Engine_Validate_AtLeast(1),
      ),
      'value' => $coreSettings->getSetting('sitegifplayer.duration', 60),
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
