<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereaction
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Sticker.php 6590 2012-26-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegifplayer_Plugin_Composer_GifPhoto extends Core_Plugin_Composer
{
  public function onAttachGifPhoto($data)
  {
    if( empty($data['gif_guid']) && empty($data['gif_code']) ) {
      return;
    }
    if( !empty($data['gif_guid']) ) {
      $photo = Engine_Api::_()->getItemByGuid($data['gif_guid']);
    } elseif( !empty($data['gif_code']) ) {
      $photoTable = Engine_Api::_()->getDbtable('photos', 'sitegifplayer');
      $photo = $photoTable->getByCode($data['gif_code']);
      if( empty($photo) ) {
        $url = sprintf(Sitegifplayer_Api_Core::GIPHY_MEDIA_URL, $data['gif_code']);
        $photo = $photoTable->addPhoto($url, array(
          'code' => $data['gif_code'],
          'title' => $data['title'],
          'enabled' => 0
          ), true);
      }
    }
    if( !$photo ) {
      return;
    }
    $photo->used_count++;
    $photo->save();
    return $photo;
  }

}
