<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupalbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupalbum_Widget_FeaturedAlbumsSlideshowController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
  
    $category_id = $this->_getParam('category_id',0);
    // List of featured album
    $table = Engine_Api::_()->getItemTable('sitegroup_album');


    $tableName = $table->info('name');
    $tableGroup = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $tableGroupName = $tableGroup->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tableGroupName, "$tableGroupName.group_id = $tableName.group_id", array('title AS group_title', 'photo_id as group_photo_id'))
                    ->where($tableName.".featured = ?", 1);
    $select = $select
              ->where($tableGroupName . '.closed = ?', '0')
              ->where($tableGroupName . '.approved = ?', '1')
              ->where($tableGroupName . '.declined = ?', '0')
              ->where($tableGroupName . '.draft = ?', '1');
              
    if(!empty($category_id)) {
      $select->where($tableGroupName . '.	category_id =?', $category_id);
    }
    
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($tableGroupName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }  

    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupalbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    } 
    
    $limit = $this->_getParam('itemCountPerGroup', 10);
    $select->limit($limit);
    $this->view->show_slideshow_object = $this->view->featuredAlbums = $featuredAlbums = $table->fetchAll($select);
    // Count Featured Albums
    $this->view->num_of_slideshow = count($featuredAlbums);
    // Number of the result.
    if (empty($this->view->num_of_slideshow)) {
      return $this->setNoRender();
    }
  }

}
?>