<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupbadge
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupbadge.isActivate', 0);
if (empty($isActive)) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitegroup')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(

	array(
			'title' => $view->translate('Group Profile Badge'),
			'description' => $view->translate('Displays the badge, which has been assigned to a Group, on it\'s profile.'),
			'category' => $view->translate('Group Profile'),
			'type' => 'widget',
			'name' => 'sitegroupbadge.sitemobile-badge-sitegroupbadge',
			'defaultParams' => array(
					'title' => $view->translate('Badge'),
					'titleCount' => true,
			),
	),
	array(
			'title' => $view->translate('Group Badges'),
			'description' => $view->translate('Displays a list of all the groups badge on site. This widget should be placed on the Groups badge group.'),
			'category' => $view->translate('Groups'),
			'type' => 'widget',
			'name' => 'sitegroupbadge.sitegroup-badge',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
			'adminForm' => array(
					'elements' => array(
							array(
									'Text',
									'itemCount',
									array(
											'label' => $view->translate('Count'),
											'description' => $view->translate('(number of badges to show)'),
											'value' => 10,
											'validators' => array(
												array('Int', true),
												array('GreaterThan', true, array(0)),
											),
									),
							),
              array(
									'Select',
									'category_id',
									array(
											'label' => $view->translate('Category'),
											'multiOptions' => $categories_prepared,
									)
						  ),
					),
			),
	),
)
?>