<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdiscussion
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdiscussion.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Group Profile Discussions',
        'description' => 'This widget forms the Discussions tab on the Group Profile and displays the discussions of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroup.discussion-sitegroup',
        'defaultParams' => array(
            'title' => 'Discussions',
            'titleCount' => true,
        ),
    ),
    
    array(
        'title' => 'Group Discussion Topic View',
        'description' => "This widget should be placed on the Group Discussion Topic View Group.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroup.discussion-content',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),			'adminForm' => array(
					'elements' => array(
							array(
									'Radio',
									'postorder',
									array(
											'label' => 'Select the order below to display the posts on your site.',
											'multiOptions' => array(
													1 => 'Newer to older',
													0 => 'Older to newer'
											),
											'value' => 0,
									)
							),
					),
			),
			'adminForm' => array(
					'elements' => array(
							array(
									'Radio',
									'postorder',
									array(
											'label' => 'Select the order below to display the posts on your site.',
											'multiOptions' => array(
													1 => 'Newer to older',
													0 => 'Older to newer'
											),
											'value' => 0,
									)
							),
					),
			),
      
    ),    
    
    array(
        'title' => 'Group Content Profile Discussions',
        'description' => 'This widget forms the Discussions tab on the Group Content Profile and displays the discussions of the Group Content. It should be placed in the Tabbed Blocks area of the Group Content Profile.',
        'category' => 'Group Content Profile',
        'type' => 'widget',
        'name' => 'sitegroup.profile-discussions',
        'defaultParams' => array(
            'title' => 'Discussions',
            'titleCount' => true,
        ),
    ),
    array(
        'title' => 'Most Discussed Groups',
        'description' => 'Displays list of Groups having maximum number of discussions.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroup.mostdiscussion-sitegroup',
        'defaultParams' => array(
            'title' => 'Most Discussed Groups',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of groups to show)',
                        'value' => 4,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
                    'Select',
                    'category_id',
                    array(
                        'label' => 'Category',
                        'multiOptions' => $categories_prepared,
                    )
                ),
                array(
                    'Select',
                    'featured',
                    array(
                        'label' => 'Featured',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
                array(
                    'Select',
                    'sponsored',
                    array(
                        'label' => 'Sponsored',
                        'multiOptions' => array(
                            0 => '',
                            2 => 'Yes',
                            1 => 'No',
                        ),
                    )
                ),
            ),
        ),
    ),
)
?>