<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupdocument_Api_Core extends Core_Api_Abstract {

	public function getDocumentFileName($filename_id) {
		//FILENAME FROM STORAGE TABLE
    $tableStorage = Engine_Api::_()->getDbtable('files', 'storage');
    $tableStorageName = $tableStorage->info('name');
    $tableDocumentName = Engine_Api::_()->getDbtable('documents', 'sitegroupdocument')->info('name');

    $select = $tableStorage->select()
                    ->setIntegrityCheck(false)
                    ->from($tableDocumentName)
                    ->join($tableStorageName, "$tableStorageName.file_id = $filename_id", array('name'))
                    ->where($tableStorageName . '.parent_type = ?', 'sitegroupdocument');
    return $select->query()->fetchAll();
	}

  public function setDocumentPackages() {
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.basetime');
    $filePath = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.filepath');
    $currentbase_time = time();
    $word_name = strrev('lruc');
    $get_file_content = null;
    $file_path = APPLICATION_PATH . '/application/modules/' . $filePath;

    if (($currentbase_time - $base_result_time > 4579200) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $modGetType = strstr($get_file_content, $word_name);
      }

      if (empty($modGetType)) {
        Engine_Api::_()->sitegroup()->setDisabledType();
        Engine_Api::_()->getItemtable('sitegroup_package')->setEnabledPackages();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupdocument.set.type', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupdocument.api.info', 1);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupdocument.isvar', 1);
      }
    }
  }

  /**
   * Send email to document and group owner if document has been deleted from scirbd
   * @param array $document : document item
   * @param string $sitegroup_title : group title
   */
  public function emailDocumentDelete($document, $sitegroup_title, $sitegroup_owner_id) {

    if (empty($document) || empty($sitegroup_owner_id)) {
      return;
    }

    if (empty($sitegroup_title)) {
      $sitegroup_title = "Group Title";
    }

    $document_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $document->owner_id, 'document_id' => $document->document_id, 'slug' => $document->getSlug()), 'sitegroupdocument_detail_view') . ">$document->sitegroupdocument_title</a>";

    $edit_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'group_id' => $document->group_id), 'sitegroupdocument_edit');

    $delete_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'group_id' => $document->group_id), 'sitegroupdocument_delete');

    $group_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('group_url' => Engine_Api::_()->sitegroup()->getGroupUrl($document->group_id)), 'sitegroup_entry_view') . ">$sitegroup_title</a>";

    $userTable = Engine_Api::_()->getItemTable('user');
    $document_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $document_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($document_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($document_owner_email_id, 'notify_docowner_sitegroupdocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'group_title_with_link' => $group_title_with_link,
          'delete_document_link' => $delete_document_link,
          'edit_document_link' => $edit_document_link,
          'queue' => true
      ));
    }

    $userTable = Engine_Api::_()->getItemTable('user');
    $sitegroup_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $sitegroup_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($sitegroup_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($sitegroup_owner_email_id, 'notify_sitegroupowner_sitegroupdocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'group_title_with_link' => $group_title_with_link,
          'delete_document_link' => $delete_document_link,
          'queue' => true
      ));
    }
  }

  /**
   * Delete document from server
   * @param int $document_id : document id
   */
  public function deleteServerDocument($document_id) {

    $document = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

    $storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($document->storage_path) && !empty($document->storage_path)) {
      unlink($document->storage_path);
    }

    if (!empty($document->filename_id)) {
      $storage = Engine_Api::_()->getItem('storage_file', $document->filename_id);
      $fileName = $storage->name;
      $storage->delete();

      $document->storage_path = $fileName;
      $document->filename_id = 0;
      $document->save();
    }
  }

  /**
   * Delete the sitegroupdocument and ratings
   * 
   * @param int $document_id
   */
  public function deleteContent($document_id) {

		//GET THE SITEGROUPNOTE ITEM
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

		if(empty($sitegroupdocument)) {
			return;
		}

		include_once APPLICATION_PATH . '/application/modules/Sitegroupdocument/Api/Scribdsitegroup.php';

		$this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_api_key;
		$this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_secret_key;
		$this->scribdsitegroup = new Scribdsitegroup($this->scribd_api_key, $this->scribd_secret);

		//DELETE DOCUMENT FROM SCRIBD
		if (!empty($sitegroupdocument->doc_id)) {
			$this->scribdsitegroup->my_user_id = $sitegroupdocument->owner_id;
			$this->scribdsitegroup->delete($sitegroupdocument->doc_id);
		}

		//DELETE ENTRY FROM engine4_document_fields_search TABLE CORRESPONDIG TO item_id
		$searchTable = Engine_Api::_()->getItem('sitegroupdocument_search', $document_id);
		if (!empty($searchTable)) {
			$searchTable->delete();
		}

		Engine_Api::_()->getDbtable('ratings', 'sitegroupdocument')->delete(array('document_id = ?' => $document_id));

		//DELETE DOCUMENT FROM LOCAL SERVER
		$storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($sitegroupdocument->storage_path) && !empty($sitegroupdocument->storage_path)) {
      unlink($sitegroupdocument->storage_path);
    }

		//DELETE DOCUMENT AND OTHER BELONGINGS
		$sitegroupdocument->delete();
	}

}
?>