<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Widget.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupdocument_Form_Admin_Widget extends Engine_Form {

  public function init() {
    $this
            ->setTitle('Widget Settings')
            ->setDescription('Configure the general settings for the various widgets available with this plugin.');

    $this->addElement('Text', 'sitegroupdocument_comment_widgets', array(
        'label' => 'Group Profile Most Commented Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the group profile most commented documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.comment.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupdocument_like_widgets', array(
        'label' => 'Group Profile Most Liked Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the group profile most liked documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.like.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupdocument_featurelist_widgets', array(
        'label' => 'Group Profile Featured Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the group profile featured documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.featurelist.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupdocument_popular_widgets', array(
        'label' => 'Group Profile Popular Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the group profile popular documents widget (value cannot be empty or zero) ? [Note: Popularity here is based on the number of views.]',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.popular.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupdocument_rate_widgets', array(
        'label' => 'Group Profile Top Rated Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the top group profile top rated documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.rate.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Text', 'sitegroupdocument_recent_widgets', array(
        'label' => 'Group Profile Recent Documents',
        'maxlength' => '3',
        'description' => 'How many documents should be shown in the group profile recent documents widget (value cannot be empty or zero) ?',
        'required' => true,
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.recent.widgets', 3),
        'validators' => array(
            array('Int', true),
            array('GreaterThan', true, array(0)),
        ),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>