<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroup
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupdocument_Plugin_Menus {

  public function canViewDocuments() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.document.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('documents', 'sitegroupdocument');
    $rName = $table->info('name');
    $table_groups = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $rName_groups = $table_groups->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_groups, array(''))
                    ->join($rName, $rName . '.group_id = ' . $rName_groups . '.group_id')
                    ->where($rName .'.approved = ?', 1)
										->where($rName .'.draft = ?', 0)
										->where($rName .'.status = ?', 1)
										->where($rName .'.search = ?', 1);
    $select = $select
                    ->where($rName_groups . '.closed = ?', '0')
                    ->where($rName_groups . '.approved = ?', '1')
                    ->where($rName_groups . '.search = ?', '1')
                    ->where($rName_groups . '.declined = ?', '0')
                    ->where($rName_groups . '.draft = ?', '1');
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($rName_groups . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }

   //ADD GROUP DOCUMENT LISTING LINK
  public function onMenuInitialize_SitegroupdocumentGutterGroup() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEGROUPDOCUMENT SUBJECT
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);   

    if ($sitegroupdocument->getType() !== 'sitegroupdocument_document') {
      return false;
    }

   $group_url = $sitegroup->getHref(array('tab' => $tab_selected_id));

    //RETURN BACK TO GROUP LINK
    return array(
        'class' => 'buttonlink  icon_sitegroupdocument_back',
        'uri' =>  $group_url
        
    );
  }

	//ADD GROUP DOCUMENT PUBLISH LINK
  public function onMenuInitialize_SitegroupdocumentGutterPublish() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEGROUPDOCUMENT SUBJECT
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitegroupdocument->getType() !== 'sitegroupdocument_document' || empty($viewer_id) || empty($sitegroupdocument->draft)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) || ($viewer_id != $sitegroupdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitegroupdocument_publish',
        'route' => 'sitegroupdocument_publish',
        'params' => array(
            'document_id' => $sitegroupdocument->getIdentity(),
						'tab' => $tab_selected_id
        ),
    );
  }

	//ADD GROUP DOCUMENT EDIT LINK
  public function onMenuInitialize_SitegroupdocumentGutterEdit($row) {

		 //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
   
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEPAG SUBJECT
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitegroupdocument->getType() !== 'sitegroupdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitegroupdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitegroupdocument_edit',
        'route' => 'sitegroupdocument_edit',
        'params' => array(
						'document_id' => $sitegroupdocument->getIdentity(),
						'group_id' => $sitegroupdocument->group_id,
						'tab' => $tab_selected_id
        ),
    );
  }


//ADD GROUP DOCUMENT SUGGESTION LINK	
  public function onMenuInitialize_SitegroupdocumentGutterSuggest($row) {

		$sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $group_subject = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);      

		// Start: Show "Suggest to Frind" link.
    $group_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'group_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegroupdocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if ($group_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($group_subject->closed) && !empty($group_subject->approved) && empty($group_subject->declined) && !empty($group_subject->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'document_sugg_link');
      }
    }
    else {
     return false;   
  
    }
 
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    if( empty($documentSuggLink) && !empty($sitegroupdocument->draft) && empty($sitegroupdocument->approved) && empty($sitegroupdocument->status) )  {
      return false;
    }
 
    // End: "Suggest to Friend" link work

   return array(
				'class' => 'buttonlink icon_group_friend_suggestion smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'suggestion',
						'controller' => 'index',
						'action' => 'switch-popup',
						'modContentId' => $sitegroupdocument->document_id,
						'modName' => 'group_document',
						'format' => 'smoothbox',
				),
    );
  }


//ADD DOCUMENT DELETE LINK
  public function onMenuInitialize_SitegroupdocumentGutterDelete() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITEGROUP SUBJECT
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitegroupdocument->getType() !== 'sitegroupdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitegroupdocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink  icon_sitegroupdocument_delete',
        'route' => 'sitegroupdocument_delete',
        'params' => array(
								'document_id' => $sitegroupdocument->getIdentity(),
								'group_id' => $sitegroupdocument->group_id,
								'tab' => $tab_selected_id
        ),
    );
  }


  //ADD DOCUMENT OF THE DAY LINK
  public function onMenuInitialize_SitegroupdocumentGutterDocumentofday() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITEGROUP SUBJECT
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);   

    $allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $allowView = $auth->isAllowed($sitegroup, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitegroup, 'registered', 'view') === 1 ? true : false;
    } 

    if(empty($allowView)) {
      return false;
   }

    return array(
				'class' => 'buttonlink item_icon_sitegroupdocument_detail smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'sitegroupdocument',
						'controller' => 'index',
						'action' => 'add-document-of-day',
						'document_id' => $sitegroupdocument->document_id,
						'format' => 'smoothbox',
				),
    );
  }


  //ADD GROUP DOCUMENT ADD LINK
  public function onMenuInitialize_SitegroupdocumentGutterAdd() {
   
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();      
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);  
		$sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupdocument->group_id);  
 
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'sdcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitegroupdocument->getType() !== 'sitegroupdocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_create)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitegroupdocument_new',
        'route' => 'sitegroupdocument_create',
        'params' => array(
								'group_id' => $sitegroupdocument->group_id,
								'tab' => $tab_selected_id
        ),
    );
  }


	//ADD DOCUMENT SHARE LINK
  public function onMenuInitialize_SitegroupdocumentGutterShare() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

		//SHARING IS ALLOWED OR NOT
    $can_share = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.share', 1);

		//CAN SHARE OR NOT
    if (empty($sitegroupdocument) || empty($viewer_id) || $sitegroupdocument->draft == 1 || empty($sitegroupdocument->approved) || $sitegroupdocument->status != 1 || empty($can_share)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_share',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => 'sitegroupdocument_document',
            'id' => $sitegroupdocument->getIdentity(),
            'format' => 'smoothbox',
        ),
    );
  }

	//ADD DOCUMENT DOWNLOAD LINK
  public function onMenuInitialize_SitegroupdocumentGutterDownload($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitegroupdocument) || empty($viewer_id)) {
      return false;
    }

		//DOWNLOAD IS ALLOWED OR NOT FOR THIS LEVEL
		$view_download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.download.allow', 1);
		if(empty($view_download_allow) || empty($sitegroupdocument->download_allow)) {
			return false;
		}

		//GET SCRIBD DETAIL
    $scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_api_key;
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_secret_key;
    $scribd = new Scribdsitegroup($scribd_api_key, $scribd_secret);

    //SET SCRIBD USER ID
    $scribd->my_user_id = $sitegroupdocument->owner_id;

		//DOCUMENT FORMAT FOR THIS LEVEL
		$download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.download.format', 'pdf');
		$link = '';
		try {
			$link = $scribd->getDownloadUrl($sitegroupdocument->doc_id, $download_format);
			$link = trim($link['download_link']);
		} catch (Exception $e) {
			$this->view->excep_message = $message = $e->getMessage();
			$this->view->excep_error = 1;
		}

		if(empty($link)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitegroupdocument_download',
				'uri' => $link,
				'target' => '_blank'
    );
  }

	//ADD DOCUMENT EMAIL LINK
  public function onMenuInitialize_SitegroupdocumentGutterEmail($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitegroupdocument) || empty($viewer_id) || $sitegroupdocument->status != 1) {
      return false;
    }

		//EMAIL IS ALLOWED OR NOT
		$view_email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.email.allow', 1);
		if(empty($view_email_allow) || empty($sitegroupdocument->email_allow)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitegroupdocuments_email',
        'route' => 'default',
        'params' => array(
            'module' => 'sitegroupdocument',
            'controller' => 'index',
            'action' => 'email',
            'id' => $sitegroupdocument->getIdentity(),
        ),
    );
  }


	//ADD DOCUMENT REPORT LINK
  public function onMenuInitialize_SitegroupdocumentGutterReport() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $document_id);

		//CAN REPORT OR NOT
    if (empty($viewer_id) || empty($sitegroupdocument)) {
      return false;
    }

		//REPORTING IS ALLOWED OR NOT
    $report = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.report', 1);
    if (empty($report)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_report',
        'route' => 'default',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $sitegroupdocument->getGuid(),
            'format' => 'smoothbox',
        ),
    );
  }

}
?>