<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Documents'),
        'description' => $view->translate('Forms the Documents tab of your Group and shows the documents of your Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.profile-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Recent Documents'),
        'description' => $view->translate('Displays recent documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.recent-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Popular Documents'),
        'description' => $view->translate('Displays popular documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.popular-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Popular Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Commented Documents'),
        'description' => $view->translate('Displays most commented documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.comment-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Liked Documents'),
        'description' => $view->translate('Displays most liked documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.like-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Top Rated Documents'),
        'description' => $view->translate('Displays top rated documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.rate-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Top Rated Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Featured Documents'),
        'description' => $view->translate('Displays featured documents of your Group.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupdocument.featurelist-sitegroupdocuments',
        'defaultParams' => array(
            'title' => $view->translate('Featured Documents'),
            'titleCount' => true,
        ),
    ),
    array(
			'title' => $view->translate('Group Profile Highlighted Documents'),
			'description' => $view->translate("Displays list of group's highlighted documents. This widget should be placed on the Group Profile."),
			'category' => $view->translate('Group Profile'),
			'type' => 'widget',
			'name' => 'sitegroupdocument.highlightlist-sitegroupdocuments',
			'defaultParams' => array(
					'title' => $view->translate('Highlighted Group Documents'),
					'titleCount' => true,
			),
			'adminForm' => array(
				'elements' => array(
					array(
							'Text',
							'itemCount',
							array(
									'label' => $view->translate('Count'),
									'description' => $view->translate('(number of documents to show)'),
									'value' => 3,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
							),
					),
				),
			),
    ),
)
?>