<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupdocument_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.is.active')
            ->limit(1);
    $sitegroup_settings = $select->query()->fetchAll();
    if (!empty($sitegroup_settings)) {
      $sitegroup_is_active = $sitegroup_settings[0]['value'];
    } else {
      $sitegroup_is_active = 0;
    }

    //CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitegroup')
            ->where('enabled = ?', 1);
    $check_sitegroup = $select->query()->fetchObject();
    if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
      $PRODUCT_TYPE = 'sitegroupdocument';
      $PLUGIN_TITLE = 'Sitegroupdocument';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitegroupdocument Plugin';
      $PRODUCT_TITLE = 'Groups - Documents Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitegroup_plugin_version = '4.8.6';  
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitegroup/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $groupTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitegroupdocument.basetime', $groupTime ),
			('sitegroupdocument.isvar', 0 ),
			('sitegroupdocument.filepath', 'Sitegroupdocument/controllers/license/license2.php');");    
      parent::onPreInstall();
    } elseif (!empty($check_sitegroup) && empty($sitegroup_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> but not activated it on your site yet. Please activate it first before installing the Groups / Communities - Documents Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitegroup/settings/readme'>Click here</a> to activate the Groups Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/groupextensions/socialengine-groups-communities-documents' target='_blank'>Groups / Communities - Documents Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }
  
  function onInstall() {
		$db = $this->getDb();
        
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')
               ->where('name = ?', 'sitegroupdocument')
               ->where('version <= ?', '4.8.9p2');
        $is_enabled = $select->query()->fetchObject();
        if (!empty($is_enabled)) {
            $db->query("UPDATE `engine4_sitegroupdocument_documents` SET `thumbnail` = REPLACE(thumbnail, 'http:', 'https:') WHERE `thumbnail` Like 'http:%'");
        }         
		
    $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a group document {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitegroupdocument_create";');
    
    //WORK FOR CORE CONTENT GROUPS
		$select = new Zend_Db_Select($db);

    $select->from('engine4_core_content',array('params'))
            ->where('name = ?', 'sitegroupdocument.socialshare-sitegroupdocuments');
		$result = $select->query()->fetchObject();
    if(!empty($result->params)) {
			$params = Zend_Json::decode($result->params);
			if(isset($params['code'])) {
				$code = $params['code'];
				$db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
				('sitegroupdocument.code.share','".$code. "');");
			}
    }

    $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupdocument_documents'")->fetch();
    if (!empty($table_exist)) {

      $columnExist = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'sitegroupdocument_slug'")->fetch();
      if(!empty($columnExist)) {
        $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` DROP `sitegroupdocument_slug`");
      }
    }




    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroupdocument.is.active')
            ->limit(1);
    $sitegroupdocument_settings = $select->query()->fetchAll();



  // WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_menuitems')
		->where('name = ?', 'sitegroupdocument_admin_main_widgets')
		->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitegroupdocument_settings)) {
		$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitegroupdocument_admin_main_widgets", "sitegroupdocument", "Widget Settings", "", \'{"route":"admin_default","module":"sitegroupdocument","controller":"settings","action":"widget"}\', "sitegroupdocument_admin_main", "", 0, 3, 1)');
		}

      //START THE WORK FOR MAKE WIDGETIZE GROUP OF DOCUMENTS LISTING AND DOCUMENT VIEW GROUP
    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitegroupdocument')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'communityad')
							->where('enabled 	 = ?', 1)
							->limit(1);
				;
			$infomation = $select->query()->fetch();
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_settings')
							->where('name = ?', 'sitegroup.communityads')
							->where('value 	 = ?', 1)
							->limit(1);
			$rowinfo = $select->query()->fetch();

			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitegroupdocument_index_browse')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupdocument_index_browse',
						'displayname' => 'Browse Group Documents',
						'title' => 'Group Documents',
						'description' => 'This is the group documents.',
						'custom' => 1,
				));
				$group_id = $db->lastInsertId('engine4_core_pages');

				//CONTAINERS
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => Null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				//INSERT MAIN - MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');


				//INSERT MAIN - RIGHT CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => Null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');


				//INSERT TOP- MIDDLE CONTAINER
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');


				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroup.browsenevigation-sitegroup',
						'parent_content_id' => $top_middle_id,
						'order' => 1,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.search-sitegroupdocument',
						'parent_content_id' => $right_id,
						'order' => 3,
						'params' => '{"title":"","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.sitegroup-document',
						'parent_content_id' => $middle_id,
						'order' => 2,
						'params' => '{"title":"","titleCount":""}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homefeaturelist-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 4,
						'params' => '{"title":"Featured Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.sitegroup-sponsoreddocument',
						'parent_content_id' => $right_id,
						'order' => 5,
						'params' => '{"title":"Sponsored Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homecomment-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 6,
						'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homepopular-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 7,
						'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homelike-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 8,
						'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homerate-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 9,
						'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroupdocument.homerecent-sitegroupdocuments',
							'parent_content_id' => $right_id,
							'order' => 10,
							'params' => '{"title":"Recent Group Documents","titleCount":"true"}',
					));

				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroup.group-ads',
							'parent_content_id' => $right_id,
							'order' => 11,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}

			$db = $this->getDb();
			$select = new Zend_Db_Select($db);

			// Check if it's already been placed
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitegroupdocument_index_view')
							->limit(1);
			;
			$info = $select->query()->fetch();

			if ( empty($info) ) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupdocument_index_view',
						'displayname' => 'Group Document View Page',
						'title' => 'View Group Document',
						'description' => 'This is the view group for a group document.',
						'custom' => 1,
						'provides' => 'subject=sitegroupdocument',
				));
				$group_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

				// middle column content
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.document-content',
						'parent_content_id' => $middle_id,
						'order' => 1,
						'params' => '',
				));

        //GROUP DOCUMENT OWNER PHOTO WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupdocument.document-owner-photo-documents',
        'parent_content_id' => $right_id,
        'order' => 2,
        'params' => '',
      ));

			//GROUP DOCUMENT OPTIONS WIDGET
      $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupdocument.options-documents',
        'parent_content_id' => $right_id,
        'order' => 3,
        'params' => '',
      ));

      //RECENT GROUP DOCUMENT
      $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupdocument.viewrecent-sitegroupdocuments',
        'parent_content_id' => $right_id,
        'order' => 4,
        'params' => '',
      ));



				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroup.group-ads',
							'parent_content_id' => $right_id,
							'order' => 5,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}
	
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_modules')
							->where('name = ?', 'mobi')
							->where('enabled 	 = ?', 1)
							->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_pages')
								->where('name = ?', 'sitegroupdocument_mobi_view')
								->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
							'name' => 'sitegroupdocument_mobi_view',
							'displayname' => 'Mobile Group Document Profile',
							'title' => 'Mobile Group Document Profile',
							'description' => 'This is the mobile verison of a Group document profile group.',
							'custom' => 0,
					));
					$group_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'container',
							'name' => 'main',
							'parent_content_id' => null,
							'order' => 1,
							'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'container',
							'name' => 'right',
							'parent_content_id' => $container_id,
							'order' => 1,
							'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'container',
							'name' => 'middle',
							'parent_content_id' => $container_id,
							'order' => 3,
							'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroupdocument.document-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));
				}
			}
    }

    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitegroupdocument')
					->where('version < ?', '4.2.1');
		$is_enabled_document = $select->query()->fetchObject();
      
		if($is_enabled_document) {

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupdocument_admin_submain_document_tab", "sitegroupdocument", "Tabbed Documents Widget", "", \'{"route":"admin_default","module":"sitegroupdocument","controller":"settings", "action": "widget"}\', "sitegroupdocument_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupdocument_admin_submain_dayitems", "sitegroupdocument", "Document of the Day", "", \'{"route":"admin_default","module":"sitegroupdocument","controller":"settings", "action": "manage-day-items"}\', "sitegroupdocument_admin_submain", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitegroupdocument_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupdocument_index_home',
						'displayname' => 'Group Documents Home',
						'title' => 'Group Documents Home',
						'description' => 'This is group document home group.',
						'custom' => 1
				));
				$group_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroup.browsenevigation-sitegroup',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
			
				//INSERT TOP RATED GROUP DOCUMENT WIDGET
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homerate-sitegroupdocuments',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Top Rated Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homerecent-sitegroupdocuments',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Recent Group Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homepopular-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 20,
						'params' => '{"title":"Most Popular Documents","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.featured-documents-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 15,
						'params' => '{"title":"Featured Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.list-documents-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Documents","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.sitegroupdocumentlist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.search-sitegroupdocument',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.document-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 12,
						'params' => '{"title":"Document of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homefeaturelist-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Documents","itemCountPerGroup":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homecomment-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Documents","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupdocument.homelike-sitegroupdocuments',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Documents","titleCount":"true"}',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_core_content')
						->where('name = ?', 'sitegroupdocument.featurelist-sitegroupdocuments');
						
			$is_exit = $select->query()->fetchObject();
			if(!empty($is_exit)) {
				$db->update('engine4_core_content', array(
					'name' => 'sitegroupdocument.highlightlist-sitegroupdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitegroupdocument.featurelist-sitegroupdocuments',
				));
			}
			
			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitegroup_admincontent')
						->where('name = ?', 'sitegroupdocument.featurelist-sitegroupdocuments');
						
			$is_exit_content = $select->query()->fetchObject();
			if(!empty($is_exit_content)) {
				$db->update('engine4_sitegroup_admincontent', array(
					'name' => 'sitegroupdocument.highlightlist-sitegroupdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitegroupdocument.featurelist-sitegroupdocuments',
				));
			}

			$select = new Zend_Db_Select($db);
			$select
						->from('engine4_sitegroup_content')
						->where('name = ?', 'sitegroupdocument.featurelist-sitegroupdocuments');
						
			$is_exit_sitegroupcontent = $select->query()->fetchObject();
			if(!empty($is_exit_sitegroupcontent)) {
				$db->update('engine4_sitegroup_content', array(
					'name' => 'sitegroupdocument.highlightlist-sitegroupdocuments',
					'params' => '{"title":"Highlighted Documents","titleCount":true}',
							), array(
					'name = ?' => 'sitegroupdocument.featurelist-sitegroupdocuments',
				));
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'featured'")->fetch();
      $highlightedColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'highlighted'")->fetch();
			if (!empty($featuredColumn) && empty($highlightedColumn)) {
				$db->query("ALTER TABLE `engine4_sitegroupdocument_documents` CHANGE `featured` `highlighted` TINYINT( 1 ) NOT NULL");
			}

			$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD `featured` TINYINT( 1 ) NOT NULL AFTER `highlighted`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Group Documents'), array('displayname = ?' => 'Group Documents')); 
		}

		//START SOCIAL SHARE WIDGET WORK
		//CHECK PLUGIN VERSION
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitegroupdocument')
					->where('version < ?', '4.2.1');
		$is_enabled_module = $select->query()->fetchObject();

		if(!empty($is_enabled_module)) {

			$social_share_default_code = '{"title":"Social Share","titleCount":true,"code":"<div class=\"addthis_toolbox addthis_default_style \">\r\n<a class=\"addthis_button_preferred_1\"><\/a>\r\n<a class=\"addthis_button_preferred_2\"><\/a>\r\n<a class=\"addthis_button_preferred_3\"><\/a>\r\n<a class=\"addthis_button_preferred_4\"><\/a>\r\n<a class=\"addthis_button_preferred_5\"><\/a>\r\n<a class=\"addthis_button_compact\"><\/a>\r\n<a class=\"addthis_counter addthis_bubble_style\"><\/a>\r\n<\/div>\r\n<script type=\"text\/javascript\">\r\nvar addthis_config = {\r\n          services_compact: \"facebook, twitter, linkedin, google, digg, more\",\r\n          services_exclude: \"print, email\"\r\n}\r\n<\/script>\r\n<script type=\"text\/javascript\" src=\"http:\/\/s7.addthis.com\/js\/250\/addthis_widget.js\"><\/script>","nomobile":"","name":"sitegroupdocument.socialshare-sitegroupdocuments"}';

	  	$db->update('engine4_core_content', array('params' => $social_share_default_code,), array('name =?' => 'sitegroupdocument.socialshare-sitegroupdocuments'));
		}
		//END SOCIAL SHARE WIDGET WORK
		$select = new Zend_Db_Select($db);
    $select
          ->from('engine4_core_settings')
          ->where('name = ?', 'sitegroup.feed.type');
  $info = $select->query()->fetch();
    $enable = 1;
    if (!empty($info))
      $enable = $info['value'];
    $db->query('INSERT IGNORE INTO   `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitegroupdocument_admin_new", "sitegroupdocument", "{item:$object} created a new document:", '.$enable.', 6, 2, 1, 1, 0, 1)');
        
        $categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupdocument_documents LIKE 'category_id'")->fetch();
    if (empty($categoryIdColumn)) {
      $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
    }
    
    $categoryTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupdocument_categories'")->fetch();
    if(empty($categoryTableExist)) {
      $db->query("
        CREATE TABLE IF NOT EXISTS `engine4_sitegroupdocument_categories` (
          `category_id` int(11) unsigned NOT NULL auto_increment,
          `title` varchar(64) NOT NULL,
          PRIMARY KEY  (`category_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci ;
      ");
      
      $db->query("
        INSERT IGNORE INTO `engine4_sitegroupdocument_categories` (`title`) VALUES
        ('Arts'),
        ('Group'),
        ('Conferences'),
        ('Festivals'),
        ('Food'),
        ('Fundraisers'),
        ('Galleries'),
        ('Health'),
        ('Just For Fun'),
        ('Kids'),
        ('Learning'),
        ('Literary'),
        ('Movies'),
        ('Museums'),
        ('Neighborhood'),
        ('Networking'),
        ('Nightlife'),
        ('On Campus'),
        ('Organizations'),
        ('Outdoors'),
        ('Pets'),
        ('Politics'),
        ('Sales'),
        ('Science'),
        ('Spirituality'),
        ('Sports'),
        ('Technology'),
        ('Theatre'),
        ('Other');
      ");
    }    
    
    $select = new Zend_Db_Select($db);
    $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitegroupdocument')
                ->where('enabled = ?', 1);    
    $is_sitegroupdocument_object = $select->query()->fetchObject();
    if($is_sitegroupdocument_object) {        
    $db->query('
      INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
      ("sitegroupdocument_admin_main_categories", "sitegroupdocument", "Categories", "", \'{"route":"admin_default","module":"sitegroupdocument","controller":"settings","action":"categories"}\', "sitegroupdocument_admin_main", "", 3);
    ');
    }

		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
				include APPLICATION_PATH . "/application/modules/Sitegroupdocument/controllers/license/mobileLayoutCreation.php";
		}
    
    $documentTable = $db->query('SHOW TABLES LIKE \'engine4_sitegroupdocument_documents\'')->fetch();
    if(!empty($documentTable)) {
        $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupdocument_documents` WHERE Key_name = 'featured'")->fetch();   
        if(empty($featuredIndex)) {
          $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD INDEX ( `featured` )");
        }   
 
        $highlightedIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupdocument_documents` WHERE Key_name = 'highlighted'")->fetch();     
        if(empty($highlightedIndex)) {
          $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD INDEX ( `highlighted` )");
        }         
 
        $categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupdocument_documents` WHERE Key_name = 'category_id'")->fetch();     
        if(empty($categoryIdIndex)) {
          $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD INDEX ( `category_id` )");
        }      

        $searchIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupdocument_documents` WHERE Key_name = 'search'")->fetch();
        if(!empty($searchIndex)) {
            $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` DROP INDEX search");
            $db->query("ALTER TABLE `engine4_sitegroupdocument_documents` ADD INDEX (`draft`, `search`, `status`, `approved`)");
        }
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitegroupdocument','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitegroupdocument')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitegroupdocument/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the group plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/query');
      }
    }
    
  }
  
  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitegroupdocument_document", "sitegroupdocument", \'{item:$subject} replied to a comment on {item:$owner}\'\'s group document {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }   

}
?>
