<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupdocument_Widget_DocumentContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

    //SET SCRIBD API AND SCECRET KEY
    $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_api_key;
    $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_secret_key;
    $this->scribdsitegroup = new Scribdsitegroup($this->scribd_api_key, $this->scribd_secret);

      //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET USER LEVEL
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = Engine_Api::_()->user()->getViewer()->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET DOCUMNET MODEL
    $this->view->sitegroupdocument = $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    if (empty($sitegroupdocument)) {
      return $this->setNoRender();
    }

    $this->view->group_id = $sitegroupdocument->group_id;

    //SET GROUP SUBJECT
    $sitegroup_subject = null;
    //if (!Engine_Api::_()->core()->hasSubject()) {
      $group_id = $sitegroupdocument->group_id;
      if (null !== $group_id) {
        $group_subject = $sitegroup_subject = Engine_Api::_()->getItem('sitegroup_group', $group_id);
//         if ($sitegroup_subject && $sitegroup_subject->getIdentity()) {
//           Engine_Api::_()->core()->setSubject($sitegroup_subject);
//         }
      }
    //}
    $this->view->sitegroup_subject = $sitegroup_subject;
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup_subject->package_id, "modules", "sitegroupdocument")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup_subject, 'sdcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
  
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitegroup_subject, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitegroup_subject, 'registered', 'view') === 1 ? true : false;
    } 

    //END MANAGE-ADMIN CHECK
    //DESTROY THE PREVIOUS SUBJECT
    //Engine_Api::_()->core()->clearSubject();

    if (($can_edit != 1 && $viewer_id != $sitegroupdocument->owner_id) && ($sitegroupdocument->draft == 1 || $sitegroupdocument->status != 1 || $sitegroupdocument->approved != 1 || $sitegroupdocument->search != 1)) {
      return $this->setNoRender();
    }

    //CHECK THAT VIEWER CAN RATE THE DOCUMENT OR NOT
    $this->view->can_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.rating', 1);

    //GET OWNER INFORMATION
    $this->view->owner = $owner = $sitegroupdocument->getOwner();

    //GET CURRENT URL
    $front = Zend_Controller_Front::getInstance();
		if(!empty($this->view->https)) {
			$curr_url = 'https://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
		else {
			$curr_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
    $this->view->curr_url = urlencode((string) $curr_url);

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitegroupdocument->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitegroupdocument->views++;
    }

    //SET SCRIBD USER ID
    $this->scribdsitegroup->my_user_id = $sitegroupdocument->owner_id;
    Engine_Api::_()->sitegroupdocument()->setDocumentPackages();

    $stat = null;
    if (!empty($sitegroupdocument->doc_id)) {
      try {
        $stat = trim($this->scribdsitegroup->getConversionStatus($sitegroupdocument->doc_id));
      } catch (Exception $e) {
        $message = $e->getMessage();
        $this->view->excep_error = 1;
        $this->view->excep_message = $message;
      }
    }

    //CHECK VIEWER CAN DOWNLOAD AND EMAIL THIS DOCUMENT OR NOT
    if (!empty($viewer_id)) {
      $download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.download.allow', 1);
      $download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.download.format', 'pdf');
      $this->view->email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.email.allow', 1);
    } else {
      $download_allow = 0;
      $download_format = 0;
      $this->view->email_allow = 0;
    }

    if (!empty($viewer_id)) {
      if ($download_allow && $stat == 'DONE' && $sitegroupdocument->download_allow) {
        try {
          $link = $this->scribdsitegroup->getDownloadUrl($sitegroupdocument->doc_id, $download_format);
        } catch (Exception $e) {
          $message = $e->getMessage();
          $this->view->excep_error = 1;
          $this->view->excep_message = $message;
        }
        $this->view->link = trim($link['download_link']);
        $sitegroupdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.include.full.text', 1);
        if ($sitegroupdocument_include_full_text == 1) {
          $doc_full_text = $sitegroupdocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    } else { //WE SHOW FULL TEXT IN CASE OF NONLOGGEDIN USER IF DOCUMENT IS AVAILABLE FOR DOWNLOADING  AND ADMIN HAD ALLOWED FOR FULL TEXT IN GLOBAL SETTINGS
      if ($stat == 'DONE') {
        $sitegroupdocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.include.full.text', 1);
        $sitegroupdocument_visitor_fulltext = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.visitor.fulltext', 1);
        if ($sitegroupdocument_include_full_text == 1 && $sitegroupdocument_visitor_fulltext == 1 && $sitegroupdocument->download_allow) {
          $doc_full_text = $sitegroupdocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    }

    //IF STAT IS DONE THAN UPDATE DOCUMENT STATUS AND OTHER INFORMATION
    if ($stat == 'DONE') {
      try {
        //GETTING DOCUMENT'S FULL TEXT
        $texturl = $this->scribdsitegroup->getDownloadUrl($sitegroupdocument->doc_id, 'txt');
        if ($sitegroupdocument->status != 1) {
          $texturl = trim($texturl['download_link']);
          $file_contents = file_get_contents($texturl);
          if (empty($file_contents)) {
            $site_url = $texturl;
            $ch = curl_init();
            $timeout = 0; //SET ZERO FOR NO TIMEOUT
            curl_setopt($ch, CURLOPT_URL, $site_url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

            ob_start();
            curl_exec($ch);
            curl_close($ch);
            $file_contents = ob_get_contents();
            ob_end_clean();
          }
          $full_text = $file_contents;
          $sitegroupdocument->fulltext = $full_text;
          $sitegroupdocument->save();
        }
      } catch (Exception $e) {
        if ($sitegroupdocument->status != 3 && $e->getCode() == 619) {
          $sitegroupdocument->status = 3;

          //SEND EMAIL TO DOCUMENT OWNER IF GROUP DOCUMENT HAS BEEN DELETED FROM SCRIBD
          Engine_Api::_()->sitegroupdocument()->emailDocumentDelete($sitegroupdocument, $sitegroup_subject->title, $sitegroup_subject->owner_id);
        }
      }
      
      if($sitegroupdocument->status != 3 && $sitegroupdocument->status != 2) {
          $setting = $this->scribdsitegroup->getSettings($sitegroupdocument->doc_id);
          $thumbnail_url = trim($setting['thumbnail_url']);          
          $sitegroupdocument->thumbnail = $thumbnail_url;
          $sitegroupdocument->status = 1;

          //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
          if ($sitegroupdocument->draft == 0 && $sitegroupdocument->approved == 1 && $sitegroupdocument->status == 1 && $sitegroupdocument->search == 1 && $sitegroupdocument->activity_feed == 0) {
            $api = Engine_Api::_()->getDbtable('actions', 'activity');
            $creator = Engine_Api::_()->getItem('user', $sitegroupdocument->owner_id);
            $activityFeedType = null;
            if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup_subject) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
              $activityFeedType = 'sitegroupdocument_admin_new';
            elseif ($sitegroup_subject->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup_subject))
              $activityFeedType = 'sitegroupdocument_new';

            if ($activityFeedType) {
              $action = $api->addActivity($creator, $sitegroup_subject, $activityFeedType);
              Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
            }
            //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
            if ($action != null) {
              $api->attachActivity($action, $sitegroupdocument);
              $sitegroupdocument->activity_feed = 1;
              $sitegroupdocument->save();
            }
            
            //GROUP DOCUMENT CREATE NOTIFICATION AND EMAIL WORK
            if(Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version >= '4.2.9p3') {

								Engine_Api::_()->sitegroup()->sendNotificationEmail($sitegroupdocument, $action, 'sitegroupdocument_create', 'SITEGROUPDOCUMENT_CREATENOTIFICATION_EMAIL', 'Groupevent Invite');
								
								$isGroupAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitegroup')->isGroupAdmins($viewer->getIdentity(), $group_id);
								if (!empty($isGroupAdmins)) {
									//NOTIFICATION FOR ALL FOLLWERS.
									Engine_Api::_()->sitegroup()->sendNotificationToFollowers($sitegroupdocument, $action, 'sitegroupdocument_create');
								}
							
                }
            }      
      }
      $sitegroupdocument->save();
    } elseif ($stat == 'ERROR') {
      if ($sitegroupdocument->status != 2) {
        $sitegroupdocument->status = 2;
        $sitegroupdocument->save();
      }
    } else {
      $sitegroupdocument->save();
    }

    //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
    $sitegroupdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.save.local.server', 1);
    if ($sitegroupdocument_save_local_server == 0 && ($sitegroupdocument->status == 1 || $sitegroupdocument->status == 2)) {
      Engine_Api::_()->sitegroupdocument()->deleteServerDocument($sitegroupdocument->document_id);
    }

    //SETTING PARAMETERS FOR SECURE DOCUMENT
    if ($viewer->getIdentity() == 0) {
      $uid = mt_rand(1000, 100000);
    } else {
      $uid = $viewer->getIdentity();
    }
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_secret_key;
    $sessionId = session_id();
    $signature = md5($scribd_secret . 'document_id' . $sitegroupdocument->doc_id . 'session_id' . $sessionId . 'user_identifier' . $uid);
    $this->view->uid = $uid;
    $this->view->sessionId = $sessionId;
    $this->view->signature = $signature;
    $this->view->download_allow = $download_allow;

    //RATING WORK
    $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'sitegroupdocument')->countRating($sitegroupdocument->getIdentity());
    $this->view->sitegroupdocument_rated = Engine_Api::_()->getDbTable('ratings', 'sitegroupdocument')->previousRated($sitegroupdocument->getIdentity(), $viewer->getIdentity());

    //CUSTOM FIELD WORK
    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
    $this->view->fieldStructure = $fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($sitegroupdocument);

    // Start: Show "Suggest to Frind" link.
    $group_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'group_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegroupdocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if ($group_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($group_subject->closed) && !empty($group_subject->approved) && empty($group_subject->declined) && !empty($group_subject->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'document_sugg_link');
      }
    }
    // End: "Suggest to Friend" link work
  }

}
?>