<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupdocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Sitegroupdocument/Api/Scribdsitegroup.php';

class Sitegroupdocument_Widget_SitemobileProfileSitegroupdocumentsController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = $viewer->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET SUBJECT AND SITEGROUP ID
    $this->view->sitegroup_subject = $sitegroup_subject = Engine_Api::_()->core()->getSubject('sitegroup_group');

    $this->view->group_id = $group_id = $sitegroup_subject->group_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup_subject->package_id, "modules", "sitegroupdocument")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup_subject, 'sdcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //TOTAL DOCUMENT
    $documentCount = Engine_Api::_()->sitegroup()->getTotalCount($group_id, 'sitegroupdocument', 'documents');
    $documentCreate = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'sdcreate');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    if (empty($documentCreate) && empty($documentCount) && empty($can_edit) && !(Engine_Api::_()->sitegroup()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }

    $sitegroupdocument_feedtype = Zend_Registry::isRegistered('sitegroupdocument_feedtype') ? Zend_Registry::get('sitegroupdocument_feedtype') : null;
    if (empty($sitegroupdocument_feedtype)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

    //GET DOCUMENT TABLE
    $documentTable = Engine_Api::_()->getDbtable('documents', 'sitegroupdocument');
      
		$values = array();
		$values['orderby'] = 'creation_date';
	
		//START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'sdcreate');
		if (empty($isManageAdmin) && empty($can_edit)) {
			$this->view->can_create = 0;
		} else {
			$this->view->can_create = 1;
		}
		//END MANAGE-ADMIN CHECK

		//BLOCK FOR UPDATING CONVERSION STATUS OF THE DOCUMENT
		$this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_api_key;
		$this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitegroupdocument_secret_key;
		$this->scribdsitegroup = new Scribdsitegroup($this->scribd_api_key, $this->scribd_secret);

		//FETCH DOCUMENTS
		$params = array();
		$params['group_id'] = $group_id;
		$params['profile_group_widget'] = 1;
		$doc_forUpdate = $documentTable->widgetDocumentsData($params);
		$stat="";
		foreach ($doc_forUpdate as $value) {

			if (empty($value->doc_id)) {
				continue;
			}

			$this->scribdsitegroup->my_user_id = $value->owner_id;

			try {
				$stat = trim($this->scribdsitegroup->getConversionStatus($value->doc_id));
			} catch (Exception $e) {
				$message = $e->getMessage();
			}

			if ($stat == 'DONE') {
				try {
					//GETTING DOCUMENT'S FULL TEXT
					$texturl = $this->scribdsitegroup->getDownloadUrl($value->doc_id, 'txt');
					//for some reason, the URL comes back with leading and trailing spaces
					$texturl = trim($texturl['download_link']);

					$file_contents = file_get_contents($texturl);
					if (empty($file_contents)) {
						$site_url = $texturl;
						$ch = curl_init();
						$timeout = 0; // set to zero for no timeout
						curl_setopt($ch, CURLOPT_URL, $site_url);
						curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

						ob_start();
						curl_exec($ch);
						curl_close($ch);
						$file_contents = ob_get_contents();
						ob_end_clean();
					}
					$full_text = $file_contents;
                    $value->fulltext = $full_text;
                    $value->save();

				} catch (Exception $e) {
					if ($e->getCode() == 619) {
						$value->status = 3;
						$value->save();

						//SEND EMAIL TO DOCUMENT OWNER IF GROUP DOCUMENT HAS BEEN DELETED FROM SCRIBD
						Engine_Api::_()->sitegroupdocument()->emailDocumentDelete($value, $sitegroup_subject->title, $sitegroup_subject->owner_id);
					}
				}
                
                if($value->status != 3 && $value->status != 2) {

					$setting = $this->scribdsitegroup->getSettings($value->doc_id);
					$thumbnail_url = trim($setting['thumbnail_url']);
					$value->thumbnail = $thumbnail_url;
					$value->status = 1;
					$value->save();                    
                    
                    //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
                    $sitegroupdocument = Engine_Api::_()->getItem('sitegroupdocument_document', $value->document_id);
                    if ($sitegroupdocument->draft == 0 && $sitegroupdocument->approved == 1 && $sitegroupdocument->status == 1 && $sitegroupdocument->search == 1 && $sitegroupdocument->activity_feed == 0) {
                        $api = Engine_Api::_()->getDbtable('actions', 'activity');
                        $creator = Engine_Api::_()->getItem('user', $sitegroupdocument->owner_id);
                        // $action = $api->addActivity($creator, $sitegroup_subject, 'sitegroupdocument_new');
                        $activityFeedType = null;
                        if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup_subject,$creator) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
                            $activityFeedType = 'sitegroupdocument_admin_new';
                        elseif ($sitegroup_subject->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup_subject,$creator))
                            $activityFeedType = 'sitegroupdocument_new';

                        if ($activityFeedType) {
                            $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($creator, $sitegroup_subject, $activityFeedType);
                            Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
                        }
                        //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
                        if ($action != null) {
                            $api->attachActivity($action, $sitegroupdocument);
                            $sitegroupdocument->activity_feed = 1;
                            $sitegroupdocument->save();
                        }
                    }
                }
			} elseif ($stat == 'ERROR') {
				$value->status = 2;
				$value->save();
			}

			//DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
			$sitegroupdocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.save.local.server', 1);
			if ($sitegroupdocument_save_local_server == 0 && ($value->status == 1 || $value->status == 2)) {
				Engine_Api::_()->sitegroupdocument()->deleteServerDocument($value->document_id);
			}
		}

		//CHECK THAT RATING IS VIEABLE OR NOT
		$this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupdocument.rating', 1);
    $values['group_id'] = $group_id;
		if ($can_edit == 1) {
			$values['show_document'] = 0;
			$this->view->paginator = $paginator = $documentTable->getSitegroupdocumentsPaginator($values);
		} else {
			$values['show_document'] = 1;
			$values['document_owner_id'] = $viewer_id;
			$this->view->paginator = $paginator = $documentTable->getSitegroupdocumentsPaginator($values);
		}

		//10 DOCUMENTS PER GROUP
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('group', 1));
		$this->_childCount = $paginator->getTotalItemCount();
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}