<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroup
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: MobiController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_MobiController extends Core_Controller_Action_Standard {

  public function init() {
  	
    //GET GROUP ID
    $group_id = $this->_getParam('group_id');

    //PACKAGE BASE PRIYACY START
    if (!empty($group_id)) {
      $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupevent")) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      } else {
        $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'secreate');
        if (empty($isGroupOwnerAllow)) {
          return $this->_forward('requireauth', 'error', 'core');
        }
      }
    }
    //PACKAGE BASE PRIYACY END
    else {
      if ($this->_getParam('event_id') != null) {
        $sitegroupevent = Engine_Api::_()->getItem('sitegroupevent_event', $this->_getParam('event_id'));
        $group_id = $sitegroupevent->group_id;
      }
    }
    
    //GET EVENT ID
    $event_id = $this->_getParam('event_id');
    if ($event_id) {
      $sitegroupevent = Engine_Api::_()->getItem('sitegroupevent_event', $event_id);
      if ($sitegroupevent) {
        Engine_Api::_()->core()->setSubject($sitegroupevent);
      }
    }
  }

  //ACTION FOR VIEW THE EVENT
  public function viewAction() {
    
    //IF SITEGROUPEVENT SUBJECT IS NOT THEN RETURN
    if (!$this->_helper->requireSubject('sitegroupevent_event')->isValid())
      return;

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();

    //GET EVENT ITEM
    $sitegroupevent = Engine_Api::_()->getItem('sitegroupevent_event', $this->getRequest()->getParam('event_id'));

    //GET SITEGROUP ITEM
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupevent->group_id);

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->_forward('requireauth', 'error', 'core');
    }
    //END MANAGE-ADMIN CHECK

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE EVENT OR NOT
    if ($viewer_id != $sitegroupevent->user_id && $can_edit != 1 && $sitegroupevent->search != 1) {
      return $this->_forward('requireauth', 'error', 'core');
    }

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitegroupevent->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitegroupevent->view_count++;
    }

    //SAVE VALUES
    $sitegroupevent->save();

    //CHECK THE VERSION OF THE CORE MODULE
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
    if ($coreversion < '4.1.0') {
      $this->_helper->content->render();
    } else {
      $this->_helper->content
              ->setNoRender()
              ->setEnabled()
      ;
    }
  }
  
}

?>