<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 6590 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupevent.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Events'),
        'description' => $view->translate('This widget forms the Events tab on the Group Profile and displays the events of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupevent.sitemobile-profile-sitegroupevents',
        'defaultParams' => array(
            'title' => $view->translate('Events'),
        ),
    ),
    array(
			'title' => $view->translate('Group Event Profile Details'),
			'description' => $view->translate("Displays a Group event's details on it's profile."),
			'category' => $view->translate('Group Event Profile'),
			'type' => 'widget',
			'name' => 'sitegroupevent.sitemobile-profile-info',
			'defaultParams' => array(
					'title' => $view->translate(''),
			),
			'adminForm' => array(
				'elements' => array(
					array(
						'Radio',
						'sitegroupeventInfoCollapsible',
						array(
								'label' => $view->translate('Do you want users to be able to expand and collapse group event information shown in this block?'),
								//'description' => $view->translate('Do you want to show the event detail collapsible?'),
								'multiOptions' => array(
										1 => $view->translate('Yes'),
										0 => $view->translate('No')
								),
								'value' => 0,
						)
					),
					array(
						'Radio',
						'sitegroupeventInfoCollapsibleDefault',
						array(
								'label' => $view->translate('Do you want group event details to be expanded or collapsed by default? (This setting will only work, if you have selected ‘No’ in the above setting)'),
								//'description' => $view->translate('Do you want to show the event detail collapsible?'),
								'multiOptions' => array(
										1 => $view->translate('Yes'),
										0 => $view->translate('No')
								),
								'value' => 1,
						)
					),
				),
			),
    ),
    array(
        'title' => $view->translate('Group Event Profile Rsvp'),
        'description' => $view->translate("Displays a Group event's rsvp on it's profile."),
        'category' => $view->translate('Group Event Profile'),
        'type' => 'widget',
        'name' => 'sitegroupevent.profile-rsvp',
        'defaultParams' => array(
            'title' => '',
        ),
    ),
    array(
    'title' => 'Group Event Profile Photos',
    'description' => 'Displays a Group event\'s photos on it\'s profile.',
    'category' => $view->translate('Group Event Profile'),
    'type' => 'widget',
    'name' => 'sitegroupevent.profile-photos',
    'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Photos',
      'titleCount' => true,
    ),
    'requirements' => array(
      'subject' => 'sitegroupevent_event',
    ),
  ),
	array(
		'title' => $view->translate('Group Event Profile Guest Member'),
		'description' => $view->translate("Displays a Group event's guest members on it's profile."),
		'category' => $view->translate('Group Event Profile'),
		'type' => 'widget',
		'name' => 'sitegroupevent.profile-members',
		'defaultParams' => array(
				'title' => 'Guests',
				'titleCount' => true
		),
	),
	array(
		'title' => $view->translate('Group Event Breadcrumb'),
		'description' => $view->translate("Displays breadcrumb on Group event's various groups. "),
		'category' => $view->translate('Group Event Breadcrumb'),
		'type' => 'widget',
		'name' => 'sitegroupevent.sitemobile-breadcrumb',
		'defaultParams' => array(
				'title' => '',
		),
	),
  array(
		'title' => $view->translate('Group Events'),
		'description' => $view->translate('Displays the list of Events from Groups created on your community. This widget should be placed in the widgetized Group Events group. Results from the Search Group Events form are also shown here.'),
		'category' => $view->translate('Groups'),
		'type' => 'widget',
		'name' => 'sitegroupevent.sitegroup-event',
		'defaultParams' => array(
				'title' => '',
				'titleCount' => true,
		),
		'adminForm' => array(
				'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => $view->translate('Count'),
										'description' => $view->translate('(number of events to show)'),
										'value' => 10,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
				),
		),
  ),
)
?>