<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupevent
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_Widget_ProfileEventsController extends Engine_Content_Widget_Abstract {

  //ACTION FOR SHOWING THE UPCOMING EVENTS ON GROUP PROFILE GROUP 
  public function indexAction() {

    //DON'T RENDER IF THERE IS NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SUBJECT AND SITEGROUP ID
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->core()->getSubject('sitegroup_group');
    $sitegroupevent_profileEvent = Zend_Registry::isRegistered('sitegroupevent_profileEvent') ? Zend_Registry::get('sitegroupevent_profileEvent') : null;
    $group_id = $sitegroup->group_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupevent")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'secreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //NO RENDER
    if (empty($sitegroupevent_profileEvent)) {
      return $this->setNoRender();
    }

    //GET TAB ID
    $this->view->tab_id = Engine_Api::_()->sitegroup()->GetTabIdinfo('sitegroupevent.profile-sitegroupevents', $group_id, Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.layoutcreate', 0));

    //SEARCH PARAMETER
    $params = array();
    $params['group_id'] = $group_id;
    $params['limit'] = $this->_getParam('itemCount', 3);

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('events', 'sitegroupevent')->widgetEventsData($params);

    //SET NO RENDER
    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}

?>