<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupevent
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupevent_Widget_ProfileMembersController extends Seaocore_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING THE TABS OF THE UPDATES FEED AND JOINED MEMBER OF THE EVENT
  public function indexAction() {
  	
    // JUST REMOVE THE TITLE DECORATOR
    //$this->getElement()->removeDecorator('Title');

    //DON'T RENDER IF THERE IS NO SUBJECT
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    // GET SITEGROUP EVENT SUBJECT
    $this->view->sitegroupevent_subject = $sitegroupevent_subject = Engine_Api::_()->core()->getSubject();
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupevent_subject->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupevent")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'secreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END     
     
    //START MANAGE-ADMIN CHECK    
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    
    //GET PARAMS
    $this->view->group = $group = $this->_getParam('group', 1);
    $this->view->search = $search = $this->_getParam('search');
    $this->view->waiting = $waiting = $this->_getParam('waiting');

    //GET MEMBERS
    $members = null;
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity() && $sitegroupevent_subject->isOwner($viewer)) {
      $this->view->waitingMembers = Zend_Paginator::factory($sitegroupevent_subject->membership()->getMembersSelect(false));
      if ($waiting) {
        $this->view->members = $members = $this->view->waitingMembers;
      }
    }

    if (!$members) {
      $select = $sitegroupevent_subject->membership()->getMembersObjectSelect();
      if ($search) {
        $select->where('displayname LIKE ?', '%' . $search . '%');
      }
      $this->view->members = $members = Zend_Paginator::factory($select);
    }

    $paginator = $members;
    $members->setCurrentPageNumber($group);

    //DO NOT RENDER IF NOTHING TO SHOW
    if ($paginator->getTotalItemCount() <= 0 && '' == $search) {
      return $this->setNoRender();
    }

    //ADD COUNT TO TITLE IF CONFIGURED
    if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  //RETURN THE COUNT OF THE EVENT
  public function getChildCount() {
    return $this->_childCount;
  }

}

?>