<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupform
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupform_Form_Admin_Global extends Engine_Form {
  // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
  public $_SHOWELEMENTSBEFOREACTIVATE = array(
      'submit_lsetting', 'environment_mode', 'include_in_package'
  );
  
  public function init() {

    $this
            ->setTitle('Global Settings')
            ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'sitegroupform_lsettings', array(
        'label' => 'Enter License key',
        'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.lsettings'),
    ));

    $global_settings_file = APPLICATION_PATH . '/application/settings/general.php';
    if (file_exists($global_settings_file)) {
      $generalConfig = include $global_settings_file;
    } else {
      $generalConfig = array();
    }

    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $this->addElement('Checkbox', 'include_in_package', array(
          'label' => ' Enable form module for the default package that was created upon installation of the "Groups / Communities Plugin". If enabled, Form App will also be enabled for the Groups created so far under the default package.)',
          'description' => 'Enable Form Module for Default Package',
          'value' => 1,
      ));
    }
    
    if ( ( !empty($generalConfig['environment_mode']) ) && ($generalConfig['environment_mode'] != 'development') )  {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few groups of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
//          'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));

    $this->addElement('Radio', 'sitegroupform_formtabseeting', array(
        'label' => 'Non-logged-in Visitors',
        'description' => 'Do you want the Form tab in Groups to be available to non-logged-in visitors? (If yes, then non-logged-in visitors will be able to see the Form tab on the Group and fill the form created by the Group Admin.)',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.formtabseeting', 1),
    ));

    $this->addElement('Radio', 'sitegroupform_captcha', array(
        'label' => 'CAPTCHA',
        'description' => 'Do you want CAPTCHA in forms of Form App in Groups for non-logged-in visitors?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.captcha', 1),
    ));
	
	
		$this->addElement('Radio', 'sitegroupform_add_question', array(
				'label' => 'Allow Adding Custom Fields / Questions',
				'description' => 'Do you want to allow Group owners to add custom fields / questions for their Group Forms?',
				'multiOptions' => array(
						1 => 'Yes',
						0 => 'No'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.add.question', 1),
		));
	
	  $this->addElement('Radio', 'sitegroupform_edit_name', array(
				'label' => 'Allow Editing Form Tab’s Name',
				'description' => 'Do you want to allow Group owners to edit the name of their Group’s Form tab?',
				'multiOptions' => array(
						1 => 'Yes',
						0 => 'No'
				),
				'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.edit.name', 1),
		));
	
	 $this->addElement('Text', 'sitegroupform_manifestUrl', array(
        'label' => 'Groups Form URL alternate text for "group-form"',
        'allowEmpty' => false,
        'required' => true,
        'description' => 'Please enter the text below which you want to display in place of "groupform" in the URLs of this plugin.',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupform.manifestUrl', "group-form"),
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}
?>