<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupform
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupform_AdminManageController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGING FORMS
  public function indexAction() {

    //CREATE NAVIGATION TABS
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroupform_admin_main', array(), 'sitegroupform_admin_main_manage');

    //HIDDEN SEARCH FORM CONTAIN ORDER AND ORDER DIRECTION  
    $this->view->formFilter = $formFilter = new Sitegroupform_Form_Admin_Manage_Filter();
    $group = $this->_getParam('page', 1);
    $table = Engine_Api::_()->getDbtable('sitegroupforms', 'sitegroupform');
    $table_name = $table->info('name');
    $sitegroup_table = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $table_name1 = $sitegroup_table->info('name');
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($table_name)
            ->joinInner($table_name1, "$table_name.group_id = $table_name1.group_id", array('title as sitegroup_title', 'group_id as sitegroup_id'));

    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    //FILTERING PARAMETERES
    $this->view->group_title = '';
    $this->view->form_title = '';
    $this->view->groupform_status = '';

    $values = array_merge(array(
        'order' => 'group_id',
        'order_direction' => 'DESC',
            ), $values);


    if (!empty($_POST['group_title'])) {
      $group_name = $_POST['group_title'];
    } elseif (!empty($_GET['group_title'])) {
      $group_name = $_GET['group_title'];
    } elseif ($this->_getParam('group_title', '')) {
      $group_name = $this->_getParam('group_title', '');
    } else {
      $group_name = '';
    }

    if (!empty($_POST['form_title'])) {
      $form_name = $_POST['form_title'];
    } elseif (!empty($_GET['form_title'])) {
      $form_name = $_GET['form_title'];
    } elseif ($this->_getParam('form_title', '')) {
      $form_name = $this->_getParam('form_title', '');
    } else {
      $form_name = '';
    }

    //SEARCHING
    $this->view->group_title = $values['group_title'] = $group_name;
    $this->view->form_title = $values['form_title'] = $form_name;

    if (!empty($group_name)) {
      $select->where($table_name1 . '.title  LIKE ?', '%' . $group_name . '%');
    }

    if (!empty($form_name)) {
      $select->where($table_name . '.title  LIKE ?', '%' . $form_name . '%');
    }

    if (isset($_POST['search'])) {
      if (!empty($_POST['groupform_status'])) {

        $this->view->groupform_status = $_POST['groupform_status'];
        switch ($this->view->groupform_status) {
          case 1:
            $select->where($table_name . '.status = ? ', 1);
            break;
          case 2:
            $select->where($table_name . '.status = ? ', 0);
            break;
        }
      }
    }

    $this->view->assign($values);
    $select->order((!empty($values['order']) ? $values['order'] : 'group_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));
    include APPLICATION_PATH . '/application/modules/Sitegroupform/controllers/license/license2.php';
  }

  //ACTION FOR DISABLING THE FORM
  public function disableFormAction() {

    //CHECK USER VALIDATION
    if (!$this->_helper->requireUser()->isValid())
      return;

    //GET GROUP ID
    $group_id = $this->_getParam('id');

    //GET FORM DATA
    $formTable = Engine_Api::_()->getDbtable('sitegroupforms', 'sitegroupform');
    $formSelect = $formTable->select()->where('group_id = ?', $group_id);
    $formSelectData = $formTable->fetchRow($formSelect);

    //GET FORM ID AND OBJECT
    $this->view->form_id = $sitegroupform_id = $formSelectData->sitegroupform_id;
    $sitegroupform = Engine_Api::_()->getItem('sitegroupform', $sitegroupform_id);

    //SEND STATUS TO TPL
    $this->view->status = $sitegroupform->status;

    //SMOOTHBOX
    if (null === $this->_helper->ajaxContext->getCurrentContext()) {
      $this->_helper->layout->setLayout('default-simple');
    } else {//NO LAYOUT
      $this->_helper->layout->disableLayout(true);
    }

    if (!$this->getRequest()->isPost())
      return;
    $db = Engine_Api::_()->getDbtable('sitegroupforms', 'sitegroupform')->getAdapter();
    $db->beginTransaction();
    try {
      if ($sitegroupform->status == 0) {
        $sitegroupform->status = 1;
      } else {
        $sitegroupform->status = 0;
      }

      $sitegroupform->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollback();
      throw $e;
    }
    $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
    ));
  }

}

?>