<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupform
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupform_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    $db = $this->getDb();

    //CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.is.active')
            ->limit(1);
    $sitegroup_settings = $select->query()->fetchAll();
    if (!empty($sitegroup_settings)) {
      $sitegroup_is_active = $sitegroup_settings[0]['value'];
    } else {
      $sitegroup_is_active = 0;
    }

    //CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitegroup')
            ->where('enabled = ?', 1);
    $check_sitegroup = $select->query()->fetchObject();
    if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
      $PRODUCT_TYPE = 'sitegroupform';
      $PLUGIN_TITLE = 'Sitegroupform';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitegroupform Plugin';
      $PRODUCT_TITLE = 'Groups - Form Extension';
      $_PRODUCT_FINAL_FILE = 0;
      $sitegroup_plugin_version = '4.8.5';  
      $SocialEngineAddOns_version = '4.8.9p12';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitegroup/controllers/license/license4.php";
      } else {
        include $file_path;
      }

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_modules')
              ->where('name = ?', 'sitegroupform');
      $check_sitegroupform = $select->query()->fetchObject();
      if (empty($check_sitegroupform) && !empty($sitegroup_is_active)) {
        $db->query('DROP TABLE IF EXISTS `engine4_sitegroupform_fields_options`;');
        $db->query('
					CREATE TABLE `engine4_sitegroupform_fields_options` (
						`option_id` int(11) NOT NULL auto_increment,
						`field_id` int(11) NOT NULL,
						`label` varchar(255) NOT NULL,
						`order` smallint(6) NOT NULL default "999",
						PRIMARY KEY  (`option_id`),
						KEY `field_id` (`field_id`)
					) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci');

        $db->query('DROP TABLE IF EXISTS `engine4_sitegroupform_sitegroupforms`;');
        $db->query('
							CREATE TABLE IF NOT EXISTS `engine4_sitegroupform_sitegroupforms` (
								`sitegroupform_id` int(11) NOT NULL AUTO_INCREMENT,
								`group_id` int(11) NOT NULL,
								`title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT "Leave your Feedback",
								`description` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
								`status` int(2) NOT NULL DEFAULT "1",
								`groupformactive` int(2) NOT NULL DEFAULT "1",
								`activeyourname` int(2) NOT NULL DEFAULT "1",
								`activeemail` int(2) NOT NULL DEFAULT "1",
								`activeemailself` int(2) NOT NULL DEFAULT "1",
								`activemessage` int(2) NOT NULL DEFAULT "1",
								PRIMARY KEY (`sitegroupform_id`),
                KEY `group_id` (`group_id`)
							) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
												');

        $db->query('DROP TABLE IF EXISTS `engine4_sitegroupform_groupquetions`;');
        $db->query('
						CREATE TABLE IF NOT EXISTS `engine4_sitegroupform_groupquetions` (
						`groupquetion_id` int(11) NOT NULL AUTO_INCREMENT,
						`option_id` int(11) NOT NULL,
						`group_id` int(11) NOT NULL,
						PRIMARY KEY (`groupquetion_id`),
            KEY `group_id` (`group_id`)
					) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1');
      }

      $groupTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitegroupform.basetime', $groupTime ),
			('sitegroupform.isvar', 0 ),
			('sitegroupform.filepath', 'Sitegroupform/controllers/license/license2.php');");



      $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupform_sitegroupforms'")->fetch();
      if (!empty($table_exist)) {
        //ADD THE INDEX FROM THE "engine4_sitegroupform_sitegroupforms" TABLE
        $groupIdColumnIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupform_sitegroupforms` WHERE Key_name = 'group_id'")->fetch();

        if( empty($groupIdColumnIndex)) {
          $db->query("ALTER TABLE `engine4_sitegroupform_sitegroupforms` ADD INDEX ( `group_id` );");
        }
      }

      $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupform_groupquetions'")->fetch();
      if (!empty($table_exist)) {
        //ADD THE INDEX FROM THE "engine4_sitegroupform_groupquetions" TABLE
        $groupIdQuestionColumnIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupform_groupquetions` WHERE Key_name = 'group_id'")->fetch();

        if( empty($groupIdQuestionColumnIndex)) {
          $db->query("ALTER TABLE `engine4_sitegroupform_groupquetions` ADD INDEX ( `group_id` );");
        }
      }
      parent::onPreInstall();
    } elseif (!empty($check_sitegroup) && empty($sitegroup_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }

      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> but not activated it on your site yet. Please activate it first before installing the Groups / Communities - Form Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitegroup/settings/readme'>Click here</a> to activate the Groups Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/groupextensions/socialengine-groups-communities-form' target='_blank'>Groups / Communities - Form Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onEnable() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroupform.isActivate')
            ->limit(1);

    $sitegroupform_settings = $select->query()->fetchAll();
    if (!empty($sitegroupform_settings)) {
      $select = new Zend_Db_Select($db);
      $select_content = $select
                      ->from('engine4_sitegroupform_groupquetions');
      $content = $select_content->query()->fetchAll();
      if (!empty($content)) {
				$count_result = count($content);
				$group_id = '';
				$group_id.= $content[0]['group_id'];
				$i = 1;
				while ($i < $count_result) {
					$group_id.= ',' . $content[$i]['group_id'];
					$i++;
				}
				$select = new Zend_Db_Select($db);
				$select_sitegroup = $select
												->from('engine4_sitegroup_groups')
												->where('engine4_sitegroup_groups' . '.group_id NOT IN (' . $group_id . ')');
				$sitegroup_result = $select_sitegroup->query()->fetchAll();
				if (!empty($sitegroup_result)) {
					foreach ($sitegroup_result as $key => $value) {
						$group_id = $value['group_id'];
						$values = $value ['title'];
						$db->insert('engine4_sitegroupform_fields_options', array(
								'field_id' => 1,
								'label' => $values,
						));
						$option_id = $db->lastInsertId('engine4_sitegroupform_fields_options');
						$select = new Zend_Db_Select($db);
						$select_content = $select
														->from('engine4_sitegroupform_groupquetions')
														->where('group_id = ?', $group_id)
														->where('option_id = ?', $option_id)
														->limit(1);
						$content = $select_content->query()->fetchAll();
						if (empty($content)) {
							$db->insert('engine4_sitegroupform_groupquetions', array(
									'group_id' => $group_id,
									'option_id' => $option_id,
							));
						}

						$db->insert('engine4_sitegroupform_sitegroupforms', array(
								'group_id' => $group_id,
						));
					}
				}
      }
    }
    
    	$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
				include APPLICATION_PATH . "/application/modules/Sitegroupform/controllers/license/mobileLayoutCreation.php";
		}
		
    parent::onEnable();
  }
  
  function onInstall() {

    $db = $this->getDb();
    $column_tab_exist = $db->query('SHOW COLUMNS FROM engine4_sitegroupform_sitegroupforms LIKE \'offer_tab_name\'')->fetch();
		if (empty($column_tab_exist)) {
			$db->query('ALTER TABLE `engine4_sitegroupform_sitegroupforms` ADD `offer_tab_name` VARCHAR( 32 ) NOT NULL AFTER `activemessage`');
		}
		
		$select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitegroupform')
						->where('enabled = ?', 1);
		$is_enabled = $select->query()->fetchObject();
		
		if(!empty($is_enabled)) {
			$select = new Zend_Db_Select($db);
			$select 
							->from('engine4_core_menuitems')
							->where('name = ?', 'sitegroupform_admin_main_fields');
			$queary_info = $select->query()->fetchAll();
			if (empty($queary_info)) {
				$db->insert('engine4_core_menuitems', array(
						'name' => 'sitegroupform_admin_main_fields',
						'module' => 'sitegroupform',
						'label' => 'Form Questions',
						'plugin' => '',
						'params' => '{"route":"admin_default","module":"sitegroupform","controller":"fields","action":"index"}',
						'menu' => 'sitegroupform_admin_main',
						'submenu' => '',
						'order' => 3,
				));
			}
		}
		parent::onInstall();
  }
  
  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitegroupform','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitegroupform')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitegroupform/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the group plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/query');
      }
    }
    
  }
}
?>