<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupintegration_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        /*
         * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
         * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
         * REMEMBER:
         *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
         *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
         */
        if (!empty($method) && $method == 'Sitegroupintegration_Form_Admin_Global') {

        }
        return true;
    }
    
  public function indexAction() {
  
		$apiSettings = Engine_Api::_()->getApi('settings', 'core');
		$businessSettings = $apiSettings->getSetting('sitegroup.business.integration', 0);
		$documentSettings = $apiSettings->getSetting('sitegroup.document.integration', 0);
		$storeproductSettings = $apiSettings->getSetting('sitegroup.storeproduct.integration', 0);
		
  		if(isset($_POST['sitegroup_business_integration']) && $_POST['sitegroup_business_integration'] != $groupSettings) {
			$this->pluginIntegration('sitegroup_business_integration', 'Businesses', 'sitebusiness_business_0', 'sitebusiness', 'business_id');
		}
    
    $pluginName = 'sitegroupintegration';
    if (!empty($_POST[$pluginName . '_lsettings']))
      $_POST[$pluginName . '_lsettings'] = @trim($_POST[$pluginName . '_lsettings']);

	  //START DOCUMENT PLUGIN INTEGRATION.
	  if(isset($_POST['sitegroup_document_integration']) && $_POST['sitegroup_document_integration'] != $documentSettings) {
			$this->pluginIntegration('sitegroup_document_integration', 'Documents', 'document_0', 'document', 'document_id');
	  }
	  //START DOCUMENT PLUGIN INTEGRATION.
	  
	  //START STORE PRODUCTS PLUGIN WORK
	  if(isset($_POST['sitegroup_storeproduct_integration']) && $_POST['sitegroup_storeproduct_integration'] != $storeproductSettings) {
			$this->pluginIntegration('sitegroup_storeproduct_integration', 'Products', 'sitestoreproduct_product_0', 'sitestoreproduct', 'product_id');
	  }
          //END STORE PRODUCTS PLUGIN WORK
          
          //START PAGES PLUGIN INTEGRATION.
          if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage')) {
            $this->pluginIntegration('sitegroup_page_integration', 'Pages', 'sitepage_page_0', 'sitepage', 'page_id');
          }
        //END PAGES PLUGIN INTEGRATION.
        $reload_count = 0;
    $group_reload = 1;
    include_once APPLICATION_PATH . '/application/modules/Sitegroupintegration/controllers/license/license1.php';
  }

  public function faqAction() {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitegroupintegration_admin_main', array(), 'sitegroupintegration_admin_main_faq');
  }

  public function setDefaultData($groupTable, $groupTableName, $coreContentTable, $coreContentTableName, $groupId, $content_id, $forGroup=null, $module, $params, $group_id = null, $resourceType = null) {
    $db = Engine_Db_Table::getDefaultAdapter();

    $select = $groupTable->select()
            ->from($groupTableName, array($groupId))
            ->where('name = ?', 'sitegroup_index_view');

    if (!empty($forGroup)) {
      $select->where("$groupId = ?", $forGroup);
    } /*else if(!empty($forGroup) && !empty($group_id)) {
       $select->where("$group_id = ?", $forGroup);
    }*/

    $getGroupId = $select->query()->fetchColumn();

    // @Make an condition
    if (!empty($getGroupId)) {
      $getContainerId = $coreContentTable->select()
              ->from($coreContentTableName, array($content_id))
              ->where('type = ?', 'container')
              ->where("$group_id = ?", $getGroupId)
              ->where('name = ?', 'main')
              ->query()
              ->fetchColumn();
      if (!empty($getContainerId)) {
        $getMiddleContentId = $coreContentTable->select()
                ->from($coreContentTableName, array($content_id))
                ->where('type = ?', 'container')
                ->where("parent_content_id = ?", $getContainerId)
                ->where('name = ?', 'middle')
                ->query()
                ->fetchColumn();

        if (!empty($getMiddleContentId)) {
          $getCoreContainerContentId = $coreContentTable->select()
                  ->from($coreContentTableName, array($content_id))
                  ->where('type = ?', 'widget')
                  ->where("$group_id = ?", $getGroupId)
                  ->where('name = ?', 'core.container-tabs')
                  ->query()
                  ->fetchColumn();
          $select = new Zend_Db_Select($db);
          $select
                  ->from('engine4_core_modules')
                  ->where('name = ?', $module);
          $check_list = $select->query()->fetchObject();

          if (!empty($check_list)) {
            if (!empty($getCoreContainerContentId)) {
              $contentGroupId = $coreContentTable->select()
                      ->from($coreContentTableName, array($content_id))
                      ->where('parent_content_id = ?', $getCoreContainerContentId)
                      ->where('name = ?', 'sitegroupintegration.profile-items')
                      ->where('type = ?', 'widget')
                      ->where('params LIKE ?', '%' . $params . '%')
                      ->query()
                      ->fetchColumn();

              if (empty($contentGroupId)) {
                //INSERT MAIN-MIDDLE CONTAINER
                $insertMainItem = $coreContentTable->createRow();
                $insertMainItem->$group_id = $getGroupId;
                $insertMainItem->type = 'widget';
                $insertMainItem->name = 'sitegroupintegration.profile-items';
                $insertMainItem->parent_content_id = $getCoreContainerContentId;
                $insertMainItem->order = 999;
                $insertMainItem->params = $params;
                $insertMainItem->save();
              }
            } else {
              $contentGroupId = $coreContentTable->select()
                      ->from($coreContentTableName, array($content_id))
                      ->where('parent_content_id = ?', $getMiddleContentId)
                      ->where('name = ?', 'sitegroupintegration.profile-items')
                      ->where('type = ?', 'widget')
                      ->where('params LIKE ?', '%' . $params . '%')
                      ->query()
                      ->fetchColumn();

              if (empty($contentGroupId)) {
                //INSERT MAIN-MIDDLE CONTAINER
                $insertMainItem = $coreContentTable->createRow();
                $insertMainItem->$group_id = $getGroupId;
                $insertMainItem->type = 'widget';
                $insertMainItem->name = 'sitegroupintegration.profile-items';
                $insertMainItem->parent_content_id = $getMiddleContentId;
                $insertMainItem->order = 999;
                $insertMainItem->params = $params;
                $insertMainItem->save();
              }
            }
          }
        }
      }
    }
  }

  public function readmeAction() {
    
  }
  
  public function pluginIntegration($globalFormValue, $titleName, $resourceType, $moduleName, $resource_id) {

		$coreTable = Engine_Api::_()->getDbtable('pages', 'core');
		$coreTableName = $coreTable->info('name');
		$coreContentTable = Engine_Api::_()->getDbtable('content', 'core');
		$coreContentTableName = $coreContentTable->info('name');
		$adminContentTable = Engine_Api::_()->getDbtable('admincontent', 'sitegroup');
		$adminContentTableName = $adminContentTable->info('name');
		$contentGroupTable = Engine_Api::_()->getDbtable('contentgroups', 'sitegroup');
		$contentGroupTableName = $contentGroupTable->info('name');
		$contentSitegroupTable = Engine_Api::_()->getDbtable('content', 'sitegroup');
		$contentSitegroupTableName = $contentSitegroupTable->info('name');
		$db = Engine_Db_Table::getDefaultAdapter();
  
  
		if (isset($_POST["$globalFormValue"]) && $_POST["$globalFormValue"] == '0') {
			$db->query("UPDATE `engine4_sitegroupintegration_mixsettings` SET `enabled` = '0' WHERE `engine4_sitegroupintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
		} else {

			$this->setDefaultData($coreTable, $coreTableName, $coreContentTable, $coreContentTableName, 'page_id', 'content_id', null, "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitegroupintegration.profile-items"}', 'page_id');

			$this->setDefaultData($coreTable, $coreTableName, $adminContentTable, $adminContentTableName, 'page_id', 'admincontent_id', null, "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitegroupintegration.profile-items"}', 'group_id');

			$totalGroups = $contentGroupTable->select()
											->from($contentGroupTableName, array('count(*) as count'))
											->where('name =?', 'sitegroup_index_view')->query()->fetchColumn();

			$limit = 1000;
			$reload_count = round($totalGroups / $limit);
			$group_reload = $this->_getParam('group_reload', 1);
			$offset = ($group_reload - 1) * $limit;

			//group profile group
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitegroup_contentgroups', array('group_id'))
							->where('name = ?', 'sitegroup_index_view')
							->limit($limit, $offset);
			$results = $select->query()->fetchAll();

			foreach ($results as $result) {
				$this->setDefaultData($contentGroupTable, $contentGroupTableName, $contentSitegroupTable, $contentSitegroupTableName, 'contentgroup_id', 'content_id', $result['group_id'], "$moduleName", '{"title":"'.$titleName.'","resource_type":"'.$resourceType.'","nomobile":"0","name":"sitegroupintegration.profile-items"}', 'contentgroup_id');
			}
			
      if(Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled($moduleName)) {
				$db->query("INSERT IGNORE INTO `engine4_sitegroupintegration_mixsettings` (`module`, `resource_type`, `resource_id`, `item_title`, `enabled`) VALUES ('$moduleName', '$resourceType', '$resource_id', '$titleName', 1);");
			}
			
			$db->query("UPDATE `engine4_sitegroupintegration_mixsettings` SET `enabled` = '1' WHERE `engine4_sitegroupintegration_mixsettings`.`resource_type` = '$resourceType' LIMIT 1 ;");
		}
  }
}