<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupinvite
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStart = "groupinvites";
$module=null;$controller=null;$action=null;$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
  $routeStart = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupinvite.manifestUrl', "group-invites");
}
return array(
    // Package -------------------------------------------------------------------
    'package' => array(
        'type' => 'module',
        'name' => 'sitegroupinvite',
        'version' => '5.6.1',
        'path' => 'application/modules/Sitegroupinvite',
        'repository' => 'null',
        'title' => 'Groups / Communities - Inviter Extension',
        'description' => 'Groups / Communities - Inviter Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'date' => 'Thrusday, 05 May 2011 18:33:08 +0000',
        'copyright' => 'Copyright 2010-2011 BigStep Technologies Pvt. Ltd.',
        'actions' => array(
            'install',
            'upgrade',
            'refresh',
            'enable',
            'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitegroupinvite/settings/install.php',
            'class' => 'Sitegroupinvite_Installer',
        ),
        'directories' => array(
            'application/modules/Sitegroupinvite',
        ),
        'files' => array(
            'application/languages/en/sitegroupinvite.csv',
        ),
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'sitegroupinvite_invite' => array(
            'route' => $routeStart.'/invitefriends/:user_id/:sitegroup_id/',
            'defaults' => array(
                'module' => 'sitegroupinvite',
                'controller' => 'index',
                'action' => 'friendsgroupinvite'
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'sitegroup_id' => '\d+'
            )
        ),
        'sitegroupinvite_invitefriends' => array(
            'route' => $routeStart.'/inviteusers/:user_id/:sitegroup_id/',
            'defaults' => array(
                'module' => 'sitegroupinvite',
                'controller' => 'index',
                'action' => 'inviteusers'
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'sitegroup_id' => '\d+'
            )
        ),
        'sitegroupinvite_app_config' => array(
            'route' => 'admin/sitegroupinvite/global/appconfigs',
            'defaults' => array(
                'module' => 'sitegroupinvite',
                'controller' => 'admin-global',
                'action' => 'appconfigs'
            )
        ),
        'sitegroupinvite_global_global' => array(
            'route' => 'admin/sitegroupinvite/global/global',
            'defaults' => array(
                'module' => 'sitegroupinvite',
                'controller' => 'admin-global',
                'action' => 'global'
            )
        )
    )
);
?>