<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouplikebox
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-10-10 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouplikebox_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    //GET DB
    $db = $this->getDb();

    //CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.is.active')
            ->limit(1);
    $sitegroup_settings = $select->query()->fetchAll();
    if (!empty($sitegroup_settings)) {
      $sitegroup_is_active = $sitegroup_settings[0]['value'];
    } else {
      $sitegroup_is_active = 0;
    }

    //CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitegroup')
            ->where('enabled = ?', 1);
    $check_sitegroup = $select->query()->fetchObject();

    if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
      $PRODUCT_TYPE = 'sitegrouplikebox';
      $PLUGIN_TITLE = 'Sitegrouplikebox';
      $PLUGIN_VERSION = '5.9.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitegrouplikebox Plugin';
      $_PRODUCT_FINAL_FILE = 0;
      $sitegroup_plugin_version = '4.8.6'; 
      $SocialEngineAddOns_version = '4.8.9p12';
      $PRODUCT_TITLE = 'Groups / Communities - Embeddable Badges, Like Box Extension';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if (empty($is_file)) {
        include APPLICATION_PATH . "/application/modules/Sitegroup/controllers/license/license4.php";
      } else {
        include $file_path;
      }
      parent::onPreInstall();
    } elseif (!empty($check_sitegroup) && empty($sitegroup_is_active)) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if (strstr($url_string, "manage/install")) {
        $calling_from = 'install';
      } else if (strstr($url_string, "manage/query")) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ($explode_base_url as $url_key) {
        if ($url_key != 'install') {
          $core_final_url .= $url_key . '/';
        }
      }
      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> but not activated it on your site yet. Please activate it first before installing the Groups / Communities - Embeddable Badges, Like Box Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitegroup/settings/readme'>Click here</a> to activate the Groups / Communities Plugin.");
    } else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/groupextensions/socialengine-groups-communities-embeddable-badges-like-box' target='_blank'>Groups / Communities - Embeddable Badges, Like Box Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }
  public function onPostInstall() {
			//Work for the word changes in the group plugin .csv file.
			$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
			$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
			if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
				$view = new Zend_View();
				$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
				$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
				if ($actionName == 'install') {
					$redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/install');
				} else {
					$redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/query');
				}
			}
  }
}
?>
