<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmember
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2013-03-18 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php
class Sitegroupmember_Installer extends Engine_Package_Installer_Module {

	function onInstall() {
   // $db = $this->getDb();
    $db = $this->getDb(); 
    $db->query("UPDATE  `engine4_activity_notificationtypes` SET  `handler` =  'sitegroupmember.widget.request-member' WHERE  `engine4_activity_notificationtypes`.`type` =  'sitegroupmember_invite' LIMIT 1 ;");

    //updated the member level setting of group if document integration is installed, added option of content member
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'documentintegration.isActivate')
            ->where('value = ?', 1);
    $documentintegration_isActivate_object = $select->query()->fetchObject();
    if($documentintegration_isActivate_object) {
        $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitegroup_group' AND `engine4_authorization_permissions`.`name` = 'auth_sdcreate';
        ");
    }  

    //updated the member level setting of group if video integration is installed, added option of content member
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitevideointegration.isActivate')
            ->where('value = ?', 1);
    $sitevideointegration_isActivate_object = $select->query()->fetchObject();
    if($sitevideointegration_isActivate_object) {
        $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitegroup_group' AND `engine4_authorization_permissions`.`name` = 'auth_svcreate';
        ");
    } 

    //updated the member level setting of business if crowdfunding is installed, added option of content member
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitecrowdfunding.isActivate')
            ->where('value = ?', 1);
    $sitecrowdfunding_isActivate_object = $select->query()->fetchObject();
    if($sitecrowdfunding_isActivate_object) {
        $db->query("UPDATE `engine4_authorization_permissions` SET `params` = '[\"registered\",\"owner_network\",\"owner_member_member\",\"owner_member\",\"member\",\"like_member\",\"owner\"]' WHERE `engine4_authorization_permissions`.`level_id` NOT IN(5) AND `engine4_authorization_permissions`.`type` = 'sitegroup_group' AND `engine4_authorization_permissions`.`name` = 'auth_sprcreate';
        ");
    }
		parent::onInstall() ;
	}

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitegroupmember','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitegroupmember')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitegroupmember/integrated/0/redirect/install');
				} 
      }
    }
  }

  public function onEnable() {

        $db = $this->getDb();
        $db->query("UPDATE `engine4_core_menuitems` SET  `enabled` =  '1' WHERE  `engine4_core_menuitems`.`name` ='sitegroup_admin_main_member';");
        parent::onEnable();
  }
    
    public function onDisable() {

        $db = $this->getDb();
        $db->query("UPDATE `engine4_core_menuitems` SET  `enabled` =  '0' WHERE  `engine4_core_menuitems`.`name` ='sitegroup_admin_main_member';");
        parent::onDisable();
    }

}
