<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupmusic_Api_Core extends Core_Api_Abstract {

  /**
   * Return a truncate text
   *
   * @param text text 
   * @return truncate text
  * */
  public function truncation($string) {
    $length = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.truncation.limit', 13);
    $string = strip_tags($string);
    return Engine_String::strlen($string) > $length ? Engine_String::substr($string, 0, ($length - 3)) . '...' : $string;
  }
  
  public function enableComposer() {
    $subject = '';
    if (Engine_Api::_()->core()->hasSubject()) {
      $subject = Engine_Api::_()->core()->getSubject();
    }
    if ($subject && in_array($subject->getType(), array('sitegroup_group', 'sitegroupevent_event'))):
 

      if (in_array($subject->getType(), array('sitegroupevent_event'))):
        $subject = Engine_Api::_()->getItem('sitegroup_group', $subject->group_id);
      endif;
      //PACKAGE BASE PRIYACY START
      if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
        if (!Engine_Api::_()->sitegroup()->allowPackageContent($subject->package_id, "modules", "sitegroupmusic")) {
          return false;
        }
      } else {
        $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($subject, 'smcreate');
        if (empty($isGroupOwnerAllow)) {
          return false;
        }
      }
      if (!Engine_Api::_()->sitegroup()->isManageAdmin($subject, 'edit') && !Engine_Api::_()->sitegroup()->isManageAdmin($subject, 'smcreate')):
        return false;
      endif;
      return true;
    endif;
    return false;
  }
 
 
}

?>