<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitegroup')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Group Profile Music',
        'description' => 'This widget forms the Music tab on the Group Profile and displays the music of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.profile-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Music',
        ),
    ),
    array(
        'title' => 'Group Profile Most Popular Playlists',
        'description' => "Displays list of a Group's most played playlists. This widget should be placed on the Group Profile.",
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.popular-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Popular Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Most Commented Playlists',
        'description' => "Displays list of Group's most commented playlists. This widget should be placed on the Group Profile.",
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.comment-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Commented Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Most Recent Playlists',
        'description' => "Displays list of a Group's most recent playlists. This widget should be placed on the Group Profile.",
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.recent-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Recent Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Most Liked Playlists',
        'description' => "Displays list of Group's most liked playlists. This widget should be placed on the Group Profile.",
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.like-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Liked Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlist to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Recent Group Playlists',
        'description' => 'Displays list of recent playlists of groups on the site.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.homerecent-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Recent Group Playlists'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
            ),
        ),
    ),
    array(
        'title' => 'Popular Group Playlists',
        'description' => 'Displays the Most Popular Group Playlists. You can choose the number of entries to be shown.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.homepopular-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Popular Group Playlists'
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),
    array(
        'title' => 'Group Profile Player',
        'description' => 'Displays a music player that plays the playlist the Group Admin has selected to play on their Group Profile.',
        'category' => 'Group Profile',
        'type' => 'widget',
        'name' => 'sitegroupmusic.profile-player',
    ),

    array(
			'title' => 'Search Group Music form',
			'description' => 'Displays the form for searching Group Music on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupmusic.search-sitegroupmusic',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5'),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Group Music form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Group Title", "4" => "Music Title", "5" => "Group Category"),
									),
							),
					),
			)
    ),

    array(
        'title' => 'Group Music',
        'description' => 'Displays the list of Music from Groups created on your community. This widget should be placed in the widgetized Group Music group. Results from the Search Group Music form are also shown here.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.sitegroup-music',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Most Commented Group Playlists',
        'description' => "Displays the Most Commented Group Playlists. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.homecomment-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Commented Playlists',
            'titleCount' => true,array(
        'title' => 'Featured Playlists',
        'description' => "Displays Featured Group Playlists. You can mark Group Playlists as Featured from the “Manage Group Playlists” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupplaylist.homefeaturelist-sitegroupplaylists',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of playlists to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Sponsored Playlists',
        'description' => "Displays the Playlists from Paid Groups. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.sitegroup-sponsoredmusic',
        'defaultParams' => array(
            'title' => 'Sponsored Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),

    array(
        'title' => 'Most Liked Group Playlists',
        'description' => "Displays the Most Liked Group Playlists. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.homelike-sitegroupmusic',
        'defaultParams' => array(
            'title' => 'Most Liked Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of playlists to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),
  
    array(
			'title' => 'Group Music View',
			'description' => "This widget should be placed on the Group Music View Page.",
      'category' => 'Groups',
			'type' => 'widget',
			'name' => 'sitegroupmusic.music-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
  array(
        'title' => 'Featured Playlists',
        'description' => "Displays Featured Group Playlists. You can mark Group Playlists as Featured from the “Manage Group Playlists” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.homefeaturelist-sitegroupmusics',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of playlists to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    ),
    array(
        'title' => 'Group’s Featured Playlists Slideshow',
        'description' => 'Displays featured playlists in an attractive slideshow. You can set the count of the number of playlists to show in this widget. If the total number of playlists featured are more than that count, then the playlists to be displayed will be sequentially picked up.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.featured-musics-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Playlists',
            'itemCountPerGroup' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Group’s Featured Playlists Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured playlists on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.featured-musics-carousel',
        'defaultParams' => array(
            'title' => 'Featured Playlists',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Playlists in a Row',
                        'description' => '(number of playlists to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
            ),
        ),
    ),

    array(
        'title' => 'Group’s Ajax based Tabbed widget for Playlists',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented, Featured and Random Playlists in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Groups - Music Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.list-musics-tabs-view',
        'defaultParams' => array(
            'title' => 'Playlists',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),

    array(
        'title' => 'Browse Playlists',
        'description' => 'Displays the link to view Group’s Playlists Browse group.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.sitegroupmusiclist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Group’s Playlist of the Day',
        'description' => 'Displays the Playlist of the Day as selected by the Admin from the widget settings section of Groups - Musics Extension.',
        'category' => 'Groups',
        'type' => 'widget',
        'name' => 'sitegroupmusic.music-of-the-day',
        'defaultParams' => array(
            'title' => 'Playlist of the Day'
        ),
    ),

    array(
    'title' => 'Top Creators : Group Music',
    'description' => 'Displays the Groups which have the most number of Group Music added in them. Motivates Group Admins to add more content on your website.',
    'category' => 'Groups',
    'type' => 'widget',
    'name' => 'sitegroupmusic.topcreators-sitegroupmusic',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						),
					),
        ),
    'requirements' => array(
      'subject' => 'sitegroupmusic',
    ),
  ),
)
?>