<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupmusic
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupmusic_Widget_SitemobileProfileSitegroupmusicController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  //ACTION FOR SHOWING MUSIC ON GROUP PROFILE GROUP
  public function indexAction() {

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //Getting Level
    if (!empty($viewer_id)) {
      $level_id = $this->view->level_id = $viewer->level_id;
    } else {
      $level_id = $this->view->level_id = 0;
    }

    //GET SUBJECT AND GROUP ID AND GROUP OWNER ID
    $this->view->sitegroupSubject = $sitegroupSubject = Engine_Api::_()->core()->getSubject('sitegroup_group');
		$profile_music = Zend_Registry::isRegistered('sitegroupmusic_profile') ? Zend_Registry::get('sitegroupmusic_profile') : null;
    $this->view->group_id = $group_id = $sitegroupSubject->group_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroupSubject->package_id, "modules", "sitegroupmusic")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroupSubject, 'smcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    
    //TOTAL MUSIC
    $musicCount = Engine_Api::_()->sitegroup()->getTotalCount($group_id, 'sitegroupmusic', 'playlists');   
    $musicCreate = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'smcreate');
       
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

		if( empty($profile_music) ) {
			return $this->setNoRender();
		}

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    if (empty($musicCreate) && empty($musicCount) && empty($can_edit) && !(Engine_Api::_()->sitegroup()->showTabsWithoutContent())) {
      return $this->setNoRender();
    } 
    //END MANAGE-ADMIN CHECK
    

      //GET SEARCHING PARAMETERS
      $this->view->group = $group = $this->_getParam('group', 1);

      //MAKING THE SEACHING PARAMATER ARRAY
      $values = array();

        $values['orderby'] = 'creation_date';
      

      //START MANAGE-ADMIN CHECK
      $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroupSubject, 'smcreate');
      if (empty($isManageAdmin) && empty($can_edit)) {
        $this->view->can_create = 0;
      } else {
        $this->view->can_create = 1;
      }
      //END MANAGE-ADMIN CHECK
     
      $this->view->allowView = false;
			if (!empty($viewer_id) && $viewer->level_id == 1) {
				$this->view->allowView = true;
			} 

    //MAKE FEATURED OR NOT
    $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupmusic.featured', 1);

      //FETCH MUSIC
      $values['group_id'] = $group_id;

      if ($can_edit == 1) {
        $values['show_groupmusics'] = 0;
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('playlists', 'sitegroupmusic')->getPlaylistPaginator($values);
      } else {
        $values['show_groupmusics'] = 1;
        $values['music_owner_id'] = $viewer_id;
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('playlists', 'sitegroupmusic')->getPlaylistPaginator($values);
      }

      $paginator->setItemCountPerPage(10)->setCurrentPageNumber($group);
      //ADD COUNT TO TITLE IF CONFIGURED
      if ($paginator->getTotalItemCount() > 0) {
        $this->_childCount = $paginator->getTotalItemCount();
      }
  }

  //RETURN THE COUNT OF THE MUSIC
  public function getChildCount() {
    return $this->_childCount;
  }

}

?>