<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_AdminManageController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGE NOTES
  public function indexAction() {

    //CREATE NAVIGATION TABS
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitegroupnote_admin_main', array(), 'sitegroupnote_admin_main_manage');

    //HIDDEN SEARCH FORM CONTAIN ORDER AND ORDER DIRECTION  
    $this->view->formFilter = $formFilter = new Sitegroupnote_Form_Admin_Manage_Filter();
    $group = $this->_getParam('page', 1);

    //GET NOTES
    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');
    $tablesitegroup = Engine_Api::_()->getItemTable('sitegroup_group')->info('name');
    $table = Engine_Api::_()->getDbtable('notes', 'sitegroupnote');
    $rName = $table->info('name');
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($rName, array('note_id', 'group_id', 'owner_id', 'title', 'creation_date', 'view_count', 'comment_count', 'total_photos', 'like_count', 'creation_date', 'featured'))
            ->joinLeft($tableUser, "$rName.owner_id = $tableUser.user_id", 'username')
            ->joinLeft($tablesitegroup, "$rName.group_id = $tablesitegroup.group_id", 'title AS sitegroup_title');
    $values = array();
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array('order' => 'note_id', 'order_direction' => 'DESC'), $values);

    $this->view->assign($values);
    $select->order((!empty($values['order']) ? $values['order'] : 'note_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    $this->view->paginator = array();
    include_once APPLICATION_PATH . '/application/modules/Sitegroupnote/controllers/license/license2.php';
  }

  //ACTION FOR MULTI DELETE NOTES
  public function multiDeleteAction() {

    if ($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();

      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value) {
          $note_id = (int) $value;  
          Engine_Api::_()->sitegroupnote()->deleteContent($note_id);
        }
      }
      
      $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }  
  }

  //ACTION FOR DELETE THE NOTE
  public function deleteAction() {

    //LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET THE NOTE ID WHICH WE WANT TO DELETE
    $this->view->note_id = $note_id = $this->_getParam('id');

    //IF NOT POST OR FORM NOT VALID, RETURN
    if ($this->getRequest()->isPost()) {
      //PROCESS
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
 
        //DELETE NOTE ALBUM AND NOTE IMAGES
        Engine_Api::_()->sitegroupnote()->deleteContent($note_id);

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }

      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    }

    //RENDER THE DELETE TPL FILE
    $this->renderScript('admin-manage/delete.tpl');
  }
  
  //ACTION FOR MAKE NOTE FEATURED AND REMOVE FEATURED NOTE 
  public function featurednoteAction() {

    //GET OFFER ID
    $noteId = $this->_getParam('id');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $noteId);
      if ($sitegroupnote->featured == 0) {
        $sitegroupnote->featured = 1;
      } else {
        $sitegroupnote->featured = 0;
     }
      $sitegroupnote->save();
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitegroupnote/manage');
  }

}

?>