<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetSettings.php 6590 2010-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
 
//START LANGUAGE WORK
Engine_Api::_()->getApi('language', 'sitegroup')->languageChanges();
//END LANGUAGE WORK

//GET DB
$db = Zend_Db_Table_Abstract::getDefaultAdapter();
    
$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `order`) VALUES
("sitegroupnote_admin_main_categories", "sitegroupnote", "Categories", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings","action":"categories"}\', "sitegroupnote_admin_main", "", 3);');

//CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitegroup.is.active')
        ->limit(1);
$sitegroup_settings = $select->query()->fetchAll();
if (!empty($sitegroup_settings)) {
  $sitegroup_is_active = $sitegroup_settings[0]['value'];
} else {
  $sitegroup_is_active = 0;
}

//CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
$select = new Zend_Db_Select($db);
$select
        ->from('engine4_core_modules')
        ->where('name = ?', 'sitegroup')
        ->where('enabled = ?', 1);
$check_sitegroup = $select->query()->fetchObject();
if (!empty($check_sitegroup) && !empty($sitegroup_is_active)) {
  $select = new Zend_Db_Select($db);
  $select_group = $select
          ->from('engine4_core_pages', 'page_id')
          ->where('name = ?', 'sitegroup_index_view')
          ->limit(1);
  $group = $select_group->query()->fetchAll();
  if (!empty($group)) {
    $group_id = $group[0]['page_id'];

    //INSERTING THE NOTE WIDGET IN SITEGROUP_ADMIN_CONTENT TABLE ALSO
    Engine_Api::_()->getDbtable('admincontent', 'sitegroup')->setAdminDefaultInfo('sitegroupnote.profile-sitegroupnotes', $group_id, 'Notes', 'true', '112');

    //INSERTING THE NOTE WIDGET IN CORE_CONTENT TABLE ALSO
    Engine_Api::_()->getApi('layoutcore', 'sitegroup')->setContentDefaultInfo('sitegroupnote.profile-sitegroupnotes', $group_id, 'Notes', 'true', '112');

    //INSERTING THE NOTE WIDGET IN SITEGROUP_CONTENT TABLE ALSO
    $select = new Zend_Db_Select($db);
    $contentgroup_ids = $select->from('engine4_sitegroup_contentgroups', 'contentgroup_id')->query()->fetchAll();
    foreach ($contentgroup_ids as $contentgroup_id) {
      if (!empty($contentgroup_id)) {
        Engine_Api::_()->getDbtable('content', 'sitegroup')->setDefaultInfo('sitegroupnote.profile-sitegroupnotes', $contentgroup_id['contentgroup_id'], 'Notes', 'true', '112');
      }
    }
  }
  
  $select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_modules')
					->where('name = ?', 'communityad')
					->where('enabled 	 = ?', 1)
					->limit(1);
	;
	$infomation = $select->query()->fetch();
	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_settings')
					->where('name = ?', 'sitegroup.communityads')
					->where('value 	 = ?', 1)
					->limit(1);
	;
	$rowinfo = $select->query()->fetch();
  $contentTable = Engine_Api::_()->getDbtable('content', 'core');
  $contentTableName = $contentTable->info('name');

  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupnote_index_browse')
          ->limit(1);
  ;
  $info = $select->query()->fetch();
  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupnote_index_browse',
        'displayname' => 'Browse Group Notes',
        'title' => 'Group Notes List',
        'description' => 'This is the group notes.',
        'custom' => 1,
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');
//INSERT MAIN CONTAINER
    $mainContainer = $contentTable->createRow();
    $mainContainer->page_id = $group_id;
    $mainContainer->type = 'container';
    $mainContainer->name = 'main';
    $mainContainer->order = 2;
    $mainContainer->save();
    $container_id = $mainContainer->content_id;

//INSERT MAIN - MIDDLE CONTAINER
    $mainMiddleContainer = $contentTable->createRow();
    $mainMiddleContainer->page_id = $group_id;
    $mainMiddleContainer->type = 'container';
    $mainMiddleContainer->name = 'middle';
    $mainMiddleContainer->parent_content_id = $container_id;
    $mainMiddleContainer->order = 6;
    $mainMiddleContainer->save();
    $middle_id = $mainMiddleContainer->content_id;

//INSERT MAIN - RIGHT CONTAINER
    $mainRightContainer = $contentTable->createRow();
    $mainRightContainer->page_id = $group_id;
    $mainRightContainer->type = 'container';
    $mainRightContainer->name = 'right';
    $mainRightContainer->parent_content_id = $container_id;
    $mainRightContainer->order = 5;
    $mainRightContainer->save();
    $right_id = $mainRightContainer->content_id;

//INSERT TOP CONTAINER
    $topContainer = $contentTable->createRow();
    $topContainer->page_id = $group_id;
    $topContainer->type = 'container';
    $topContainer->name = 'top';
    $topContainer->order = 1;
    $topContainer->save();
    $top_id = $topContainer->content_id;

//INSERT TOP- MIDDLE CONTAINER
    $topMiddleContainer = $contentTable->createRow();
    $topMiddleContainer->page_id = $group_id;
    $topMiddleContainer->type = 'container';
    $topMiddleContainer->name = 'middle';
    $topMiddleContainer->parent_content_id = $top_id;
    $topMiddleContainer->order = 6;
    $topMiddleContainer->save();
    $top_middle_id = $topMiddleContainer->content_id;

    //INSERT NAVIGATION WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.browsenevigation-sitegroup', $top_middle_id, 1);

//INSERT NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.sitegroup-note', $middle_id, 2);

    //INSERT SEARCH GROUP NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.search-sitegroupnote', $right_id, 3, "", "true");

    //INSERT MOST COMMENTED GROUP NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.homecomment-sitegroupnotes', $right_id, 4, "Most Commented Notes", "true");

    //INSERT SPONSORED GROUP NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.sitegroup-sponsorednote', $right_id, 5, "Sponsored Notes", "true");

    //INSERT MOST LIKED GROUP NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.homelike-sitegroupnotes', $right_id, 6, "Most Liked Notes", "true");

    //INSERT RECENT GROUP NOTE WIDGET
    Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroupnote.homerecent-sitegroupnotes', $right_id, 7, "Recent Notes", "true");

    if ( $infomation && $rowinfo ) {
      Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 10, "", "true");
    }
  }
$select = new Zend_Db_Select($db);

  // Check if it's already been placed
  $select = new Zend_Db_Select($db);
  $select
          ->from('engine4_core_pages')
          ->where('name = ?', 'sitegroupnote_index_view')
          ->limit(1);
  ;
  $info = $select->query()->fetch();

  if ( empty($info) ) {
    $db->insert('engine4_core_pages', array(
        'name' => 'sitegroupnote_index_view',
        'displayname' => 'Group Note View Page',
        'title' => 'View Group Note',
        'description' => 'This is the view group for a group note.',
        'custom' => 1,
        'provides' => 'subject=sitegroupnote',
    ));
    $group_id = $db->lastInsertId('engine4_core_pages');

    // containers
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'main',
        'parent_content_id' => null,
        'order' => 1,
        'params' => '',
    ));
    $container_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'right',
        'parent_content_id' => $container_id,
        'order' => 1,
        'params' => '',
    ));
    $right_id = $db->lastInsertId('engine4_core_content');

    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'container',
        'name' => 'middle',
        'parent_content_id' => $container_id,
        'order' => 3,
        'params' => '',
    ));
    $middle_id = $db->lastInsertId('engine4_core_content');

    // middle column content
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupnote.note-content',
        'parent_content_id' => $middle_id,
        'order' => 1,
        'params' => '',
    ));

    // right column
    $db->insert('engine4_core_content', array(
        'page_id' => $group_id,
        'type' => 'widget',
        'name' => 'sitegroupnote.show-same-tags',
        'parent_content_id' => $right_id,
        'order' => 1,
        'params' => '{"title":"Related Notes"}',
    ));

		if ( $infomation && $rowinfo ) {
			Engine_Api::_()->sitegroup()->setDefaultDataContentWidget($contentTable, $contentTableName, $group_id, 'widget', 'sitegroup.group-ads', $right_id, 10, "", "true");
    }
  }
 
  $select = new Zend_Db_Select($db);
	$select
	->from('engine4_core_modules')
	->where('name = ?', 'mobi')
	->where('enabled 	 = ?', 1)
	->limit(1);
	;  

	$infomation = $select->query()->fetch();
	if(!empty($infomation)) {
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitegroupnote_mobi_view')
		->limit(1);
		;
		$info = $select->query()->fetch();
		if (empty($info)) {
			$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupnote_mobi_view',
						'displayname' => 'Mobile Group Note Profile',
						'title' => 'Mobile Group Note Profile',
						'description' => 'This is the mobile verison of a Group note profile group.',
						'custom' => 0,
			));
			$group_id = $db->lastInsertId('engine4_core_pages');

			// containers
			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
			));
			$container_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 1,
						'params' => '',
			));
			$right_id = $db->lastInsertId('engine4_core_content');

			$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 3,
						'params' => '',
			));
			$middle_id = $db->lastInsertId('engine4_core_content');

			// middle column content
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupnote.note-content',
					'parent_content_id' => $middle_id,
					'order' => 1,
					'params' => '',
			));

			// right column
			$db->insert('engine4_core_content', array(
					'page_id' => $group_id,
					'type' => 'widget',
					'name' => 'sitegroupnote.show-same-tags',
					'parent_content_id' => $right_id,
					'order' => 1,
					'params' => '{"title":"Related Notes"}',
			));
		}
	}

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`)
	VALUES ("sitegroupnote_admin_widget_settings", "sitegroupnote", "Widget Settings", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"widgets"}\', "sitegroupnote_admin_main", "", 1, 0, 3)');

  $db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupnote_admin_submain_general_tab", "sitegroupnote", "General Settings", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"widgets", "action": "index"}\', "sitegroupnote_admin_submain", "", 1, 0, 1)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupnote_admin_submain_note_tab", "sitegroupnote", "Tabbed Notes Widget", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings", "action": "widget"}\', "sitegroupnote_admin_submain", "", 1, 0, 2)');

	$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupnote_admin_submain_dayitems", "sitegroupnote", "Note of the Day", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings", "action": "manage-day-items"}\', "sitegroupnote_admin_submain", "", 1, 0, 4)');


	$select = new Zend_Db_Select($db);
	$select
					->from('engine4_core_pages')
					->where('name = ?', 'sitegroupnote_index_home')
					->limit(1);
	$info = $select->query()->fetch();
	if (empty($info)) {
		$db->insert('engine4_core_pages', array(
				'name' => 'sitegroupnote_index_home',
				'displayname' => 'Group Notes Home',
				'title' => 'Group Notes Home',
				'description' => 'This is group note home group.',
				'custom' => 1
		));
		$group_id = $db->lastInsertId('engine4_core_pages');

		// containers
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'main',
				'parent_content_id' => null,
				'order' => 2,
				'params' => '',
		));
		$container_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'right',
				'parent_content_id' => $container_id,
				'order' => 5,
				'params' => '',
		));
		$right_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'left',
				'parent_content_id' => $container_id,
				'order' => 4,
				'params' => '',
		));
		$left_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'top',
				'parent_content_id' => null,
				'order' => 1,
				'params' => '',
		));
		$top_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $top_id,
				'order' => 6,
				'params' => '',
		));
		$top_middle_id = $db->lastInsertId('engine4_core_content');

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'container',
				'name' => 'middle',
				'parent_content_id' => $container_id,
				'order' => 6,
				'params' => '',
		));
		$middle_id = $db->lastInsertId('engine4_core_content');

	// Top Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroup.browsenevigation-sitegroup',
				'parent_content_id' => $top_middle_id,
				'order' => 3,
				'params' => '',
		));

		// Left
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.homerecent-sitegroupnotes',
				'parent_content_id' => $left_id,
				'order' => 14,
				'params' => '{"title":"Recent Group Notes","titleCount":"true"}',
		));

		// Middle
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.featured-notes-slideshow',
				'parent_content_id' => $middle_id,
				'order' => 15,
				'params' => '{"title":"Featured Notes","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.list-notes-tabs-view',
				'parent_content_id' => $middle_id,
				'order' => 17,
				'params' => '{"title":"Notes","margin_photo":"12"}',
		));
		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.sitegroupnotelist-link',
				'parent_content_id' => $right_id,
				'order' => 19,
				'params' => '',
		));

		// Right Side
		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.search-sitegroupnote',
				'parent_content_id' => $right_id,
				'order' => 18,
				'params' => '',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.note-of-the-day',
				'parent_content_id' => $left_id,
				'order' => 13,
				'params' => '{"title":"Note of the Day"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.homefeaturelist-sitegroupnotes',
				'parent_content_id' => $right_id,
				'order' => 21,
				'params' => '{"title":"Featured Notes","itemCountPerGroup":3}',
		));


		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.homecomment-sitegroupnotes',
				'parent_content_id' => $right_id,
				'order' => 22,
				'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
		));

		$db->insert('engine4_core_content', array(
				'page_id' => $group_id,
				'type' => 'widget',
				'name' => 'sitegroupnote.homelike-sitegroupnotes',
				'parent_content_id' => $right_id,
				'order' => 23,
				'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
		));
	}
}
?>