<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.isActivate', 0);
if (empty($isActive)) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Notes'),
        'description' => $view->translate('Forms the Notes tab of your Group and shows notes of your Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupnote.profile-sitegroupnotes',
        'defaultParams' => array(
            'title' => $view->translate('Notes'),
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Commented Notes'),
        'description' => $view->translate('Displays your Group\'s most commented notes.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupnote.comment-sitegroupnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Notes'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Recent Notes'),
        'description' => $view->translate('Displays your Group\'s most recent notes.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupnote.recent-sitegroupnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Notes'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Profile Most Liked Notes'),
        'description' => $view->translate('Displays your Group\'s most liked notes.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupnote.like-sitegroupnotes',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Notes'),
            'titleCount' => true,
        ),
    ),
)
?>