<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_Installer extends Engine_Package_Installer_Module {

  function onPreInstall() {
    //GET DB
    $db = $this->getDb();

    //CHECK THAT SITEGROUP PLUGIN IS ACTIVATED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroup.is.active')
            ->limit(1);
    $sitegroup_settings = $select->query()->fetchAll();
    if ( !empty($sitegroup_settings) ) {
      $sitegroup_is_active = $sitegroup_settings[0]['value'];
    }
    else {
      $sitegroup_is_active = 0;
    }

    //CHECK THAT SITEGROUP PLUGIN IS INSTALLED OR NOT
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitegroup')
            ->where('enabled = ?', 1);
    $check_sitegroup = $select->query()->fetchObject();

    if ( !empty($check_sitegroup) && !empty($sitegroup_is_active) ) {
      $PRODUCT_TYPE = 'sitegroupnote';
      $PLUGIN_TITLE = 'Sitegroupnote';
      $PLUGIN_VERSION = '5.4.1p1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Sitegroupnote Plugin';
      $_PRODUCT_FINAL_FILE = 0;
      $sitegroup_plugin_version = '4.8.5'; 
      $SocialEngineAddOns_version = '4.10.3p6';
      $PRODUCT_TITLE = 'Groups / Communities - Notes Extension';
      $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);
      if ( empty($is_file) ) {
        include APPLICATION_PATH . "/application/modules/Sitegroup/controllers/license/license4.php";
      }
      else {
        include $file_path;
      }


      $groupTime = time();
      $db->query("INSERT IGNORE INTO `engine4_core_settings` (`name`, `value`) VALUES
			('sitegroupnote.basetime', $groupTime ),
			('sitegroupnote.isvar', 0 ),
			('sitegroupnote.filepath', 'Sitegroupnote/controllers/license/license2.php');");      
      parent::onPreInstall();
    }
    elseif ( !empty($check_sitegroup) && empty($sitegroup_is_active) ) {
      $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
      $url_string = Zend_Controller_Front::getInstance()->getRequest()->getRequestUri();
      if ( strstr($url_string, "manage/install") ) {
        $calling_from = 'install';
      }
      else if ( strstr($url_string, "manage/query") ) {
        $calling_from = 'queary';
      }
      $explode_base_url = explode("/", $baseUrl);
      foreach ( $explode_base_url as $url_key ) {
        if ( $url_key != 'install' ) {
          $core_final_url .= $url_key . '/';
        }
      }
      return $this->_error("<span style='color:red'>Note: You have installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> but not activated it on your site yet. Please activate it first before installing the Groups / Communities - Notes Extension.</span><br/> <a href='" . 'http://' . $core_final_url . "admin/sitegroup/settings/readme'>Click here</a> to activate the Groups Plugin.");
    }
    else {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();
      return $this->_error("<span style='color:red'>Note: You have not installed the <a href='http://www.socialengineaddons.com/socialengine-groups-communities-plugin' target='_blank'>Groups / Communities Plugin</a> on your site yet. Please install it first before installing the <a href='http://www.socialengineaddons.com/groupextensions/socialengine-groups-communities-notes' target='_blank'>Groups / Communities - Notes Extension</a>.</span><br/> <a href='" . $base_url . "/manage'>Click here</a> to go Manage Packages.");
    }
  }

  function onInstall() {

//    //START CODE FOR LIGHTBOX
//    //HERE WE CHECKING THAT SITEGROUPALBUM ENTRY EXIST IN THE CORE MODULE TABLE OR NOT
//    $select = new Zend_Db_Select($db);
//    $select
//            ->from('engine4_core_modules', array('version'))
//            ->where("name =?", "sitegroupnote");
//    $sitegroupnoteVersion = $select->query()->fetchAll();
//
//    //IF NOT EXIST THEN WE INSERTING THE LIGHTBOX SHOULD BE DISPLAY OR NOT
//    if (empty($sitegroupnoteVersion)) {
//      $value = '';
//      $select = new Zend_Db_Select($db);
//      $value = $select
//              ->from('engine4_core_settings', array('value'))
//              ->where("name =?", "socialengineaddon.display.lightbox")
//              ->query()
//              ->fetchColumn();
//
//      //IF LIGHTBOX IS NOT DISPLAY THEN WE WILL INSERTING THE ACTIVITY FEED VALUE
//      if (empty($value)) {        
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("name Like ?", "%socialengineaddon.lightbox.option.display%");
//        $name = $select->query()->fetchAll();
//
//        $count = count($name);
//
//        $select = new Zend_Db_Select($db);
//        $select
//                ->from('engine4_core_settings', array('name'))
//                ->where("value =?", "sitegroupnote");
//        $name = $select->query()->fetchColumn();
//        if (empty($name)) {
//          $name = 'socialengineaddon.lightbox.option.display.' . ++$count;
//          $db->insert('engine4_core_settings', array(
//              'name' => $name,
//              'value' => 'sitegroupnote'
//          ));
//        }      
//      }          
//    }
//    //END CODE FOR LIGHTBOX    
    
    //START THE WORK FOR MAKE WIDGETIZE GROUP OF NOTES LISTING AND NOTE VIEW GROUP
    $db = $this->getDb();

    $db->query('UPDATE  `engine4_activity_notificationtypes` SET  `body` =  \'{item:$subject} has created a group note {item:$object}.\' WHERE  `engine4_activity_notificationtypes`.`type` =  "sitegroupnote_create";');
     
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_settings')
            ->where('name = ?', 'sitegroupnote.is.active')
            ->limit(1);
    $sitegroupnote_settings = $select->query()->fetchAll();

    // WIDGET SETTING WORK
		$select = new Zend_Db_Select($db);
		$select
		->from('engine4_core_menuitems')
		->where('name = ?', 'sitegroupnote_admin_widget_settings')
		->limit(1);
		$info = $select->query()->fetch();
		if (empty($info) && !empty($sitegroupnote_settings)) {
		$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `custom`, `order`, `enabled`) VALUES
		("sitegroupnote_admin_widget_settings", "sitegroupnote", "Widget Settings", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings","action":"widget"}\', "sitegroupnote_admin_main", "", 0, 3, 1)');
		}

    $select = new Zend_Db_Select($db);
		$select
						->from('engine4_core_modules')
						->where('name = ?', 'sitegroupnote')
						->where('version < ?', '4.2.0');
		$is_enabled = $select->query()->fetchObject();
    if(!empty($is_enabled)) {
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitegroupnote_index_notelist')
              ->limit(1);
      ;
      $info = $select->query()->fetch();

      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitegroupnote_index_browse')
              ->limit(1);
      ;
      $info_browse = $select->query()->fetch();
   
      if ( empty($info) && empty($info_browse) ) {
        $db->insert('engine4_core_pages', array(
            'name' => 'sitegroupnote_index_browse',
            'displayname' => 'Browse Group Notes',
						'title' => 'Group Notes List',
						'description' => 'This is the group notes.',
						'custom' => 1,
        ));
        $group_id = $db->lastInsertId('engine4_core_pages');

        //CONTAINERS
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'main',
            'parent_content_id' => Null,
            'order' => 2,
            'params' => '',
        ));
        $container_id = $db->lastInsertId('engine4_core_content');

        //INSERT MAIN - MIDDLE CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $container_id,
            'order' => 6,
            'params' => '',
        ));
        $middle_id = $db->lastInsertId('engine4_core_content');


        //INSERT MAIN - RIGHT CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'right',
            'parent_content_id' => $container_id,
            'order' => 5,
            'params' => '',
        ));
        $right_id = $db->lastInsertId('engine4_core_content');


        //INSERT TOP CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'top',
            'parent_content_id' => Null,
            'order' => 1,
            'params' => '',
        ));
        $top_id = $db->lastInsertId('engine4_core_content');


        //INSERT TOP- MIDDLE CONTAINER
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $top_id,
            'order' => 6,
            'params' => '',
        ));
        $top_middle_id = $db->lastInsertId('engine4_core_content');


        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroup.browsenevigation-sitegroup',
            'parent_content_id' => $top_middle_id,
            'order' => 1,
            'params' => '{"title":"","titleCount":""}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.search-sitegroupnote',
            'parent_content_id' => $right_id,
            'order' => 3,
            'params' => '{"title":"","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.sitegroup-note',
            'parent_content_id' => $middle_id,
            'order' => 2,
            'params' => '{"title":"","titleCount":""}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.homecomment-sitegroupnotes',
            'parent_content_id' => $right_id,
            'order' => 4,
            'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.sitegroup-sponsorednote',
            'parent_content_id' => $right_id,
            'order' => 5,
            'params' => '{"title":"Sponsored Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.homelike-sitegroupnotes',
            'parent_content_id' => $right_id,
            'order' => 6,
            'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
        ));

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.homerecent-sitegroupnotes',
            'parent_content_id' => $right_id,
            'order' => 7,
            'params' => '{"title":"Recent Notes","titleCount":"true"}',
        ));

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'communityad')
                ->where('enabled 	 = ?', 1)
                ->limit(1);
        ;
        $infomation = $select->query()->fetch();
        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_settings')
                ->where('name = ?', 'sitegroup.communityads')
                ->where('value 	 = ?', 1)
                ->limit(1);
        $rowinfo = $select->query()->fetch();
        if ( $infomation && $rowinfo ) {
          $db->insert('engine4_core_content', array(
              'page_id' => $group_id,
              'type' => 'widget',
              'name' => 'sitegroup.group-ads',
              'parent_content_id' => $right_id,
              'order' => 10,
              'params' => '{"title":"","titleCount":""}',
          ));
        }
      }
       else {
        $db->update('engine4_core_pages', array('name' => 'sitegroupnote_index_browse'), array('name = ?' => 'sitegroupnote_index_notelist'));
      }

      $db = $this->getDb();
      $select = new Zend_Db_Select($db);

      // Check if it's already been placed
      $select = new Zend_Db_Select($db);
      $select
              ->from('engine4_core_pages')
              ->where('name = ?', 'sitegroupnote_index_view')
              ->limit(1);
      ;
      $info = $select->query()->fetch();

      if ( empty($info) ) {
        $db->insert('engine4_core_pages', array(
            'name' => 'sitegroupnote_index_view',
            'displayname' => 'Group Note View Page',
						'title' => 'View Group Note',
						'description' => 'This is the view group for a group note.',
						'custom' => 1,
						'provides' => 'subject=sitegroupnote',
        ));
        $group_id = $db->lastInsertId('engine4_core_pages');

        // containers
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'main',
            'parent_content_id' => null,
            'order' => 1,
            'params' => '',
        ));
        $container_id = $db->lastInsertId('engine4_core_content');

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'right',
            'parent_content_id' => $container_id,
            'order' => 1,
            'params' => '',
        ));
        $right_id = $db->lastInsertId('engine4_core_content');

        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'container',
            'name' => 'middle',
            'parent_content_id' => $container_id,
            'order' => 3,
            'params' => '',
        ));
        $middle_id = $db->lastInsertId('engine4_core_content');

        // middle column content
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.note-content',
            'parent_content_id' => $middle_id,
            'order' => 1,
            'params' => '',
        ));

        // right column
        $db->insert('engine4_core_content', array(
            'page_id' => $group_id,
            'type' => 'widget',
            'name' => 'sitegroupnote.show-same-tags',
            'parent_content_id' => $right_id,
            'order' => 1,
            'params' => '{"title":"Related Notes","titleCount":""}',
        ));

        $select = new Zend_Db_Select($db);
		    $select
						->from('engine4_core_modules')
						->where('name = ?', 'communityad')
						->where('enabled 	 = ?', 1)
						->limit(1);
			  ;
				$infomation = $select->query()->fetch();
				$select = new Zend_Db_Select($db);
				$select
								->from('engine4_core_settings')
								->where('name = ?', 'sitegroup.communityads')
								->where('value 	 = ?', 1)
								->limit(1);
				$rowinfo = $select->query()->fetch();
				if ( $infomation && $rowinfo ) {
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroup.group-ads',
							'parent_content_id' => $right_id,
							'order' => 2,
							'params' => '{"title":"","titleCount":""}',
					));
				}
			}

			$select = new Zend_Db_Select($db);
			$select
			->from('engine4_core_modules')
			->where('name = ?', 'mobi')
			->where('enabled 	 = ?', 1)
			->limit(1);
			;  

			$infomation = $select->query()->fetch();
			if(!empty($infomation)) {
				$select = new Zend_Db_Select($db);
				$select
				->from('engine4_core_pages')
				->where('name = ?', 'sitegroupnote_mobi_view')
				->limit(1);
				;
				$info = $select->query()->fetch();
				if (empty($info)) {
					$db->insert('engine4_core_pages', array(
								'name' => 'sitegroupnote_mobi_view',
								'displayname' => 'Mobile Group Note Profile',
								'title' => 'Mobile Group Note Profile',
								'description' => 'This is the mobile verison of a Group note profile group.',
								'custom' => 0,
					));
					$group_id = $db->lastInsertId('engine4_core_pages');

					// containers
					$db->insert('engine4_core_content', array(
								'page_id' => $group_id,
								'type' => 'container',
								'name' => 'main',
								'parent_content_id' => null,
								'order' => 1,
								'params' => '',
					));
					$container_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $group_id,
								'type' => 'container',
								'name' => 'right',
								'parent_content_id' => $container_id,
								'order' => 1,
								'params' => '',
					));
					$right_id = $db->lastInsertId('engine4_core_content');

					$db->insert('engine4_core_content', array(
								'page_id' => $group_id,
								'type' => 'container',
								'name' => 'middle',
								'parent_content_id' => $container_id,
								'order' => 3,
								'params' => '',
					));
					$middle_id = $db->lastInsertId('engine4_core_content');

					// middle column content
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroupnote.note-content',
							'parent_content_id' => $middle_id,
							'order' => 1,
							'params' => '',
					));

					// right column
					$db->insert('engine4_core_content', array(
							'page_id' => $group_id,
							'type' => 'widget',
							'name' => 'sitegroupnote.show-same-tags',
							'parent_content_id' => $right_id,
							'order' => 1,
							'params' => '{"title":"Related Notes"}',
					));
				}
			}
    }
    $select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitegroupnote')
					->where('version < ?', '4.2.1');
		$is_enabled_note = $select->query()->fetchObject();
		if($is_enabled_note) {

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupnote_admin_submain_note_tab", "sitegroupnote", "Tabbed Notes Widget", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings", "action": "widget"}\', "sitegroupnote_admin_submain", "", 1, 0, 2)');

			$db->query('INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ("sitegroupnote_admin_submain_dayitems", "sitegroupnote", "Note of the Day", "", \'{"route":"admin_default","module":"sitegroupnote","controller":"settings", "action": "manage-day-items"}\', "sitegroupnote_admin_submain", "", 1, 0, 4)');


			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_core_pages')
							->where('name = ?', 'sitegroupnote_index_home')
							->limit(1);
			$info = $select->query()->fetch();
			if (empty($info)) {
				$db->insert('engine4_core_pages', array(
						'name' => 'sitegroupnote_index_home',
						'displayname' => 'Group Notes Home',
						'title' => 'Group Notes Home',
						'description' => 'This is group note home group.',
						'custom' => 1
				));
				$group_id = $db->lastInsertId('engine4_core_pages');

				// containers
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'main',
						'parent_content_id' => null,
						'order' => 2,
						'params' => '',
				));
				$container_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'right',
						'parent_content_id' => $container_id,
						'order' => 5,
						'params' => '',
				));
				$right_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'left',
						'parent_content_id' => $container_id,
						'order' => 4,
						'params' => '',
				));
				$left_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'top',
						'parent_content_id' => null,
						'order' => 1,
						'params' => '',
				));
				$top_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $top_id,
						'order' => 6,
						'params' => '',
				));
				$top_middle_id = $db->lastInsertId('engine4_core_content');

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'container',
						'name' => 'middle',
						'parent_content_id' => $container_id,
						'order' => 6,
						'params' => '',
				));
				$middle_id = $db->lastInsertId('engine4_core_content');

			// Top Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroup.browsenevigation-sitegroup',
						'parent_content_id' => $top_middle_id,
						'order' => 3,
						'params' => '',
				));

				// Left
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.homerecent-sitegroupnotes',
						'parent_content_id' => $left_id,
						'order' => 14,
						'params' => '{"title":"Recent Group Notes","titleCount":"true"}',
				));

				// Middle
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.featured-notes-slideshow',
						'parent_content_id' => $middle_id,
						'order' => 15,
						'params' => '{"title":"Featured Notes","titleCount":"true"}',
				));
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.list-notes-tabs-view',
						'parent_content_id' => $middle_id,
						'order' => 17,
						'params' => '{"title":"Notes","margin_photo":"12"}',
				));
				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.sitegroupnotelist-link',
						'parent_content_id' => $right_id,
						'order' => 19,
						'params' => '',
				));

				// Right Side
				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.search-sitegroupnote',
						'parent_content_id' => $right_id,
						'order' => 18,
						'params' => '',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.note-of-the-day',
						'parent_content_id' => $left_id,
						'order' => 13,
						'params' => '{"title":"Note of the Day"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.homefeaturelist-sitegroupnotes',
						'parent_content_id' => $right_id,
						'order' => 21,
						'params' => '{"title":"Featured Notes","itemCountPerGroup":3}',
				));


				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.homecomment-sitegroupnotes',
						'parent_content_id' => $right_id,
						'order' => 22,
						'params' => '{"title":"Most Commented Notes","titleCount":"true"}',
				));

				$db->insert('engine4_core_content', array(
						'page_id' => $group_id,
						'type' => 'widget',
						'name' => 'sitegroupnote.homelike-sitegroupnotes',
						'parent_content_id' => $right_id,
						'order' => 23,
						'params' => '{"title":"Most Liked Notes","titleCount":"true"}',
				));
			}
      $featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupnote_notes LIKE 'featured'")->fetch();
			if (empty($featuredColumn)) {
				$db->query("ALTER TABLE `engine4_sitegroupnote_notes` ADD `featured` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `photo_id`");
			}
      $db->update('engine4_core_pages', array('displayname' => 'Browse Group Notes'), array('displayname = ?' => 'Group Notes')); 
    }  
    //END THE WORK FOR MAKE WIDGETIZE GROUP OF NOTES LISTING AND NOTE VIEW GROUP
      $select = new Zend_Db_Select($db);
      $select
        ->from('engine4_core_settings')
        ->where('name = ?', 'sitegroup.feed.type');
      $info = $select->query()->fetch();
      $enable = 1;
      if (!empty($info)) 
      $enable = $info['value'];
      $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`, `is_object_thumb`) VALUES("sitegroupnote_admin_new", "sitegroupnote", "{item:$object} created a new note:", '.$enable.' , 6, 2, 1, 1, 1, 1)');
      
            
      
    $categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupnote_notes LIKE 'category_id'")->fetch();
    if (empty($categoryIdColumn)) {
      $db->query("ALTER TABLE `engine4_sitegroupnote_notes` ADD `category_id` INT( 11 )  NOT NULL DEFAULT '0';");
    }
    
    $categoryTableExist = $db->query("SHOW TABLES LIKE 'engine4_sitegroupnote_categories'")->fetch();
    if(empty($categoryTableExist)) {
      $db->query("
        CREATE TABLE IF NOT EXISTS `engine4_sitegroupnote_categories` (
          `category_id` int(11) unsigned NOT NULL auto_increment,
          `title` varchar(64) NOT NULL,
          PRIMARY KEY  (`category_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE utf8_unicode_ci ;
      ");
      
      $db->query("
        INSERT IGNORE INTO `engine4_sitegroupnote_categories` (`title`) VALUES
        ('Arts'),
        ('Group'),
        ('Conferences'),
        ('Festivals'),
        ('Food'),
        ('Fundraisers'),
        ('Galleries'),
        ('Health'),
        ('Just For Fun'),
        ('Kids'),
        ('Learning'),
        ('Literary'),
        ('Movies'),
        ('Museums'),
        ('Neighborhood'),
        ('Networking'),
        ('Nightlife'),
        ('On Campus'),
        ('Organizations'),
        ('Outdoors'),
        ('Pets'),
        ('Politics'),
        ('Sales'),
        ('Science'),
        ('Spirituality'),
        ('Sports'),
        ('Technology'),
        ('Theatre'),
        ('Other');
      ");
    }
    
		$select = new Zend_Db_Select($db);
		$select
					->from('engine4_core_modules')
					->where('name = ?', 'sitemobile')
					->where('enabled = ?', 1);
		$is_sitemobile_object = $select->query()->fetchObject();
		if($is_sitemobile_object)  {
			include APPLICATION_PATH . "/application/modules/Sitegroupnote/controllers/license/mobileLayoutCreation.php";
		}

        
    $noteTable = $db->query('SHOW TABLES LIKE \'engine4_sitegroupnote_notes\'')->fetch();
    if(!empty($noteTable)) {     
			
		$featuredColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupnote_notes LIKE 'featured'")->fetch();        
		if(!empty($featuredColumn)) {
				$featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupnote_notes` WHERE Key_name = 'featured'")->fetch();   
				if(empty($featuredIndex)) {
					$db->query("ALTER TABLE `engine4_sitegroupnote_notes` ADD INDEX ( `featured` )");
				}         
		}

		$categoryIdColumn = $db->query("SHOW COLUMNS FROM engine4_sitegroupnote_notes LIKE 'category_id'")->fetch();        
				if(!empty($categoryIdColumn)) {
				$categoryIdIndex = $db->query("SHOW INDEX FROM `engine4_sitegroupnote_notes` WHERE Key_name = 'category_id'")->fetch();     
				if(empty($categoryIdIndex)) {
					$db->query("ALTER TABLE `engine4_sitegroupnote_notes` ADD INDEX ( `category_id` )");
				}     
			}
    }
    $this->setActivityFeeds();
    parent::onInstall();
  }

  public function onPostInstall() {

    $db = $this->getDb();
		$select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if(!empty($is_sitemobile_object)) {
			$db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitegroupnote','1')");
			$select = new Zend_Db_Select($db);
			$select
							->from('engine4_sitemobile_modules')
							->where('name = ?', 'sitegroupnote')
							->where('integrated = ?', 0);
			$is_sitemobile_object = $select->query()->fetchObject();
      if($is_sitemobile_object)  {
				$actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
				$controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
				if($controllerName == 'manage' && $actionName == 'install') {
          $view = new Zend_View();
					$baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
					$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
					$redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitegroupnote/integrated/0/redirect/install');
				} 
      }
    } 
    
    //Work for the word changes in the group plugin .csv file.
    $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
    $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
    if($controllerName == 'manage' && ($actionName == 'install' || $actionName == 'query')) {
      $view = new Zend_View();
      $baseUrl = ( !empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://':'http://') .  $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
      $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
      if ($actionName == 'install') {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/install');
      } else {
        $redirector->gotoUrl($baseUrl . 'admin/sitegroup/settings/language/redirect/query');
      }
    }
    
  }
  
  public function setActivityFeeds() {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'nestedcomment')
            ->where('enabled = ?', 1);
    $is_nestedcomment_object = $select->query()->fetchObject();
    if ($is_nestedcomment_object) {
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitegroupnote_note", "sitegroupnote", \'{item:$subject} replied to a comment on {item:$owner}\'\'s group note {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
        $db->query('INSERT IGNORE INTO `engine4_activity_actiontypes` (`type`, `module`, `body`, `enabled`, `displayable`, `attachable`, `commentable`, `shareable`, `is_generated`) VALUES ("nestedcomment_sitegroupnote_photo", "sitegroupnote", \'{item:$subject} replied to a comment on {item:$owner}\'\'s group note photo {item:$object:$title}: {body:$body}\', 1, 1, 1, 1, 1, 1)');
    }
  }
}

?>