<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.isActivate', 0);
if ( empty($isActive) ) {
  return;
}
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Notes'),
        'description' => $view->translate('This widget forms the Notes tab on the Group Profile and displays the notes of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupnote.sitemobile-profile-sitegroupnotes',
        'defaultParams' => array(
            'title' => $view->translate('Notes'),
        ),
    ),
     array(
        'title' => $view->translate('Group Notes'),
        'description' => $view->translate('Displays a list of all the group notes on site.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegroupnote.sitegroup-note',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of notes to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
			'title' => $view->translate('Group Note View'),
			'description' => $view->translate("Displays the list of Notes from Groups created on your community. This widget should be placed in the widgetized Group Notes group. Results from the Search Group Notes form are also shown here."),
      'category' => $view->translate('Groups'),
			'type' => 'widget',
			'name' => 'sitegroupnote.note-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>