<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupnote
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupnote_Widget_NoteContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     //GET PLAYLIST ID AND OBJECT
    $note_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id', $this->_getParam('note_id', null));
  //GET LOGGED IN USER INFORMATION
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //SEND TAB ID TO TPL FILE
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //GET NOTE ITEM
    $this->view->sitegroupnote = $sitegroupnote = Engine_Api::_()->getItem('sitegroupnote_note', $note_id);
    if (empty($sitegroupnote)) {
      return $this->setNoRender();
    }

    //GROUP ID
    $group_id = $sitegroupnote->group_id;

    //GET GROUP ITEM
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    //GETTING THE NOTE TAGS
    $this->view->noteTags = $sitegroupnote->tags()->getTagMaps();

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'sncreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }
  
    //MAKE FEATURED OR NOT
    $this->view->canMakeFeatured = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.featured', 1);

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitegroup, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitegroup, 'registered', 'view') === 1 ? true : false;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK
    //CHECKING THE USER HAVE THE PERMISSION TO VIEW THE NOTE OR NOT
    if ($viewer_id != $sitegroupnote->owner_id && $can_edit != 1 && ($sitegroupnote->draft == 1 || $sitegroupnote->search != 1)) {
      return $this->setNoRender();
    }

    //SHOW PHOTO
    $this->view->photoNotes = Engine_Api::_()->getDbTable('photos', 'sitegroupnote')->getNotePhotos($sitegroupnote->note_id);

    //INCREMENT IN NUMBER OF VIEWS
    if (!$sitegroupnote->getOwner()->isSelf($viewer)) {
      $sitegroupnote->view_count++;
    }
    $sitegroupnote->save();

    //GETTING THE TOTAL NOTE IN THE ONE GROUP
    $this->view->count_note = Engine_Api::_()->getDbTable('notes', 'sitegroupnote')->getTotalNote($group_id);
    $this->view->limit_sitegroupnote = $total_sitegroupnotes = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupnote.tag.widgets', 3);

    //START: "SUGGEST TO FRIEND" LINK WORK
    $group_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();

    if (!empty($is_suggestion_enabled)) {
      //HERE WE ARE DELETE THIS NOTE SUGGESTION IF VIEWER HAVE
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_note', Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id'), 'group_note_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegroupnote', Zend_Controller_Front::getInstance()->getRequest()->getParam('note_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.package.enable', 1)) {
        if ($sitegroup->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitegroup->closed) && !empty($sitegroup->approved) && empty($sitegroup->declined) && !empty($sitegroup->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->noteSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'note_sugg_link');
      }
      //END: "SUGGEST TO FRIEND" LINK WORK
    }
  }

}
?>