<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupoffer_Api_Core extends Core_Api_Abstract {

  public function setOfferPackages() {
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.basetime');
    $filePath = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.filepath');
    $currentbase_time = time();
    $word_name = strrev('lruc');
    $file_path = APPLICATION_PATH . '/application/modules/' . $filePath;

    if (($currentbase_time - $base_result_time > 3801600) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $modGetType = strstr($get_file_content, $word_name);
      }

      if (empty($modGetType)) {
        Engine_Api::_()->sitegroup()->setDisabledType();
        Engine_Api::_()->getItemtable('sitegroup_package')->setEnabledPackages();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupoffer.set.type', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupoffer.offer.type', 1);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupoffer.isvar', 1);
      }
    }
  }

  /**
   * Delete the sitegroupoffer album and photos
   * 
   * @param int $offer_id
   */
  public function deleteContent($offer_id) {

		//GET THE SITEGROUPNOTE ITEM
    $sitegroupoffer = Engine_Api::_()->getItem('sitegroupoffer_offer', $offer_id);

		if(empty($sitegroupoffer)) {
			return;
		}

    $tablePhoto = Engine_Api::_()->getItemTable('sitegroupoffer_photo');
    $select = $tablePhoto->select()->where('offer_id = ?', $offer_id);
    $rows = $tablePhoto->fetchAll($select);
    if (!empty($rows)) {
      foreach ($rows as $photo) {
        $photo->delete();
      }
    }

    $tableAlbum = Engine_Api::_()->getItemTable('sitegroupoffer_album');
    $select = $tableAlbum->select()->where('offer_id = ?', $offer_id);
    $rows = $tableAlbum->fetchAll($select);
		if (!empty($rows)) {
	    foreach ($rows as $album) {
	      $album->delete();
	    }
		}

		$sitegroupoffer->delete();
	}
	
	public function tabofferDuration($sqlTimeStr = NULL, $totalOffers,$category_id) {

    //OFFER TABLE NAME
    $offerTable = Engine_Api::_()->getDbtable('offers', 'sitegroupoffer');
    $offerTableName = Engine_Api::_()->getDbtable('offers', 'sitegroupoffer')->info('name');

    //GROUP TABLE
    $groupTable = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $groupTableName = $groupTable->info('name');

    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $currentTime = date("Y-m-d H:i:s");
    if (!empty($viewer_id)) {
      // Convert times
      $oldTz = date_default_timezone_get();
      date_default_timezone_set($viewer->timezone);
      $currentTime = date("Y-m-d H:i:s");
      date_default_timezone_set($oldTz);
    }
    //QUERY MAKING
    $select = $offerTable->select()
                    ->setIntegrityCheck(false)
                    ->from($groupTableName, array('photo_id', 'title as sitegroup_title'))
                    ->join($offerTableName, $offerTableName . '.group_id = ' . $groupTableName . '.group_id');
    if ( empty($sqlTimeStr) ) {
      $select = $select
                      ->where("($offerTableName.end_settings = 1 AND $offerTableName.end_time >= '$currentTime' OR $offerTableName.end_settings = 0)");
    }
    else {
      $select = $select->where($offerTableName . "$sqlTimeStr  or " . $offerTableName . '.end_time < 1');
      $select = $select
                      ->where("($offerTableName.end_settings = 1 AND $offerTableName.end_time >= '$currentTime' OR $offerTableName.end_settings = 0)");
    }

    $select = $select
                    ->where($groupTableName . '.closed = ?', '0')
                    ->where($groupTableName . '.approved = ?', '1')
                    ->where($groupTableName . '.search = ?', '1')
                    ->where($groupTableName . '.declined = ?', '0')
                    ->where($groupTableName . '.draft = ?', '1');

    if (!empty($category_id)) {
			$select = $select->where($groupTableName . '.	category_id =?', $category_id);
		}
		
    if ( Engine_Api::_()->sitegroup()->hasPackageEnable() ) {
      $select->where($groupTableName . '.expiration_date  > ?', $currentTime);
    }

    //Start Network work
    $select = $groupTable->getNetworkBaseSql($select, array('not_groupBy' => 1, 'extension_group' => $offerTableName . ".offer_id"));
    //End Network work

    $select = $select->limit($totalOffers);

    return Zend_Paginator::factory($select);
  }

}
?>