<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupoffer.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Offers'),
        'description' => $view->translate('This widget forms the Offers tab on the Group Profile and displays the offers of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitemobile-profile-sitegroupoffers',
        'defaultParams' => array(
            'title' => $view->translate('Offers'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Offers'),
        'description' => $view->translate('Displays the list of Offers from Groups created on your community. This widget should be placed in the widgetized Group Offers group. Results from the Search Group Offers form are also shown here.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegroupoffer.sitegroup-offer',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of offers to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
		array(
				'title' => $view->translate('Group Offer View'),
				'description' => $view->translate("This widget should be placed on the Group Offer View Page."),
				'category' => $view->translate('Groups'),
				'type' => 'widget',
				'name' => 'sitegroupoffer.offer-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
		),
	)

?>