<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupoffer_Widget_ListOffersTabsViewController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $this->view->is_ajax = $is_ajax = $this->_getParam('isajax', '');
        $this->view->showViewMore = $this->_getParam('showViewMore', 1);
        $this->view->category_id = $category_id = $this->_getParam('category_id', 0);
        $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
        $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
        if (empty($is_ajax)) {
            $this->view->tabs = $tabs = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitegroupoffer', 'type' => 'offers', 'enabled' => 1));
            $count_tabs = count($tabs);
            if (empty($count_tabs)) {
                return $this->setNoRender();
            }
            $activeTabName = $tabs[0]['name'];
        }

        //GET CURRENT TIME
        if (!empty($viewer_id)) {
            $oldTz = date_default_timezone_get();
            date_default_timezone_set($viewer->timezone);
        }
        $currentTime = date("Y-m-d H:i:s");
        $this->view->marginPhoto = $this->_getParam('margin_photo', 12);
        $table = Engine_Api::_()->getItemTable('sitegroupoffer_offer');
        $tableName = $table->info('name');
        $tableGroup = Engine_Api::_()->getDbtable('groups', 'sitegroup');
        $tableGroupName = $tableGroup->info('name');
        $select = $table->select()
                ->setIntegrityCheck(false)
                ->from($tableName)
                ->joinLeft($tableGroupName, "$tableGroupName.group_id = $tableName.group_id", array('title AS group_title', 'photo_id as group_photo_id', 'offer'))
                ->where("($tableName.end_settings = 1 AND $tableName.end_time >= '$currentTime' OR $tableName.end_settings = 0)");

        $select = $select
                ->where($tableGroupName . '.closed = ?', '0')
                ->where($tableGroupName . '.approved = ?', '1')
                ->where($tableGroupName . '.declined = ?', '0')
                ->where($tableGroupName . '.draft = ?', '1');

        if (!empty($category_id)) {
            $select = $select->where($tableGroupName . '.	category_id =?', $category_id);
        }
        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
            $select->where($tableGroupName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
        }

        $paramTabName = $this->_getParam('tabName', '');

        if (!empty($paramTabName))
            $activeTabName = $paramTabName;

        $activeTab = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitegroupoffer', 'type' => 'offers', 'enabled' => 1, 'name' => $activeTabName));
        $this->view->activTab = $activTab = $activeTab['0'];
        switch ($activTab->name) {
            case 'recent_groupoffers':
                break;
            case 'liked_groupoffers':
                $select->order($tableName . '.like_count DESC');
                break;
            case 'viewed_groupoffers':
                $select->order($tableName . '.view_count DESC');
                break;
            case 'commented_groupoffers':
                $select->order($tableName . '.comment_count DESC');
                break;
            case 'featured_groupoffers':
                $select->where($tableName . '.sticky = ?', 1);
                break;
            case 'hot_groupoffers':
                $select->where($tableName . '.hotoffer = ?', 1);
                $select->order('Rand()');
                break;
            case 'popular_groupoffers':
                $select->where($tableName . '.claimed != ?', 0);
                break;
            case 'random_groupoffers':
                $select->order('Rand()');
                break;
        }

        if ($activTab->name != 'featured_groupoffers' && $activTab->name != 'random_groupoffers') {
            $select->order('creation_date DESC');
        }

        if (!empty($viewer_id)) {
            date_default_timezone_set($oldTz);
        }

        $this->view->paginator = $paginator = Zend_Paginator::factory($select);
        $paginator->setItemCountPerPage($activTab->limit);
        $paginator->setCurrentPageNumber($this->_getParam('group', 1));
        $this->view->count = $paginator->getTotalItemCount();
        $view = $this->view;
        $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
    }

}

?>
