<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupoffer
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupoffer_Widget_SitemobileProfileSitegroupoffersController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //DON'T RENDER IF SUBJECT IS NOT SET
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET SUBJECT
    $this->view->sitegroup = $sitegroup = $subject = Engine_Api::_()->core()->getSubject('sitegroup_group');

    //GET GROUP ID
    $group_id = $subject->group_id;

    // PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupoffer")) {
        return $this->setNoRender();
      }
    } else {
      $groupOwnerBase = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'offer');
      if (empty($groupOwnerBase)) {
        return $this->setNoRender();
      }
    }
    // PACKAGE BASE PRIYACY END     
    
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $can_edit = 1;
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    }

    $can_offer = 1;
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'offer');
    if (empty($isManageAdmin)) {
      $can_offer = 0;
    }
    //END MANAGE-ADMIN CHECK

    $can_create_offer = '';
    //OFFER CREATION AUTHENTICATION CHECK
    if ($can_edit == 1 && $can_offer == 1) {
      $this->view->can_create_offer = $can_create_offer =  1;
    }

    //TOTAL OFFER
    $offerCount = Engine_Api::_()->sitegroup()->getTotalCount($group_id, 'sitegroupoffer', 'offers');     
    if (empty($can_create_offer) && empty($offerCount)) {
      return $this->setNoRender();
    }       

		$this->view->paginator = $paginator = Engine_Api::_()->getItemTable('sitegroupoffer_offer')->getSitegroupoffersPaginator($group_id, 1,'',$can_create_offer);
		$this->view->paginator->setItemCountPerPage(10)->setCurrentPageNumber($this->_getParam('group', 1));
    $this->_childCount = $paginator->getTotalItemCount();
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}