<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroup
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegrouppoll_Plugin_Menus {

  public function canViewPolls() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.poll.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('polls', 'sitegrouppoll');
    $rName = $table->info('name');
    $table_groups = Engine_Api::_()->getDbtable('groups', 'sitegroup');
    $rName_groups = $table_groups->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_groups, array('photo_id', 'title as sitegroup_title'))
                    ->join($rName, $rName . '.group_id = ' . $rName_groups . '.group_id')
                    ->where($rName . '.search = ?', '1');

    $select = $select
                    ->where($rName_groups . '.closed = ?', '0')
                    ->where($rName_groups . '.approved = ?', '1')
                    ->where($rName_groups . '.search = ?', '1')
                    ->where($rName_groups . '.declined = ?', '0')
                    ->where($rName_groups . '.draft = ?', '1');
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      $select->where($rName_groups . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }

  //SITEMOBILE GROUP POLL MENUS
  public function onMenuInitialize_SitegrouppollShare($row) {
    $sitegrouppoll = Engine_Api::_()->core()->getSubject('sitegrouppoll_poll');
    if (empty($sitegrouppoll)) {
      return false;
    }

    return array(
        'label' => 'Share',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => 'sitegrouppoll_poll',
            'id' => $sitegrouppoll->getIdentity(),
        )
    );
  }

  public function onMenuInitialize_SitegrouppollReport($row) {
    $sitegrouppoll = Engine_Api::_()->core()->getSubject('sitegrouppoll_poll');
    if (empty($sitegrouppoll)) {
      return false;
    }

    return array(
        'label' => 'Report',
        'route' => 'default',
        'class' => 'ui-btn-action smoothbox',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $sitegrouppoll->getGuid(),
        )
    );
  }

  public function onMenuInitialize_SitegrouppollCreate($row) {
    $sitegrouppoll = Engine_Api::_()->core()->getSubject('sitegrouppoll_poll');
    if (empty($sitegrouppoll)) {
      return false;
    }

    $group_id = $sitegrouppoll->group_id;
    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'splcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }

    if (empty($can_create)) {
      return false;
    }
    return array(
        'label' => 'Create Poll',
        'route' => 'sitegrouppoll_create',
        'class' => 'ui-btn-action',
        'params' => array(
            'group_id' => $group_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

  public function onMenuInitialize_SitegrouppollDelete($row) {
    $sitegrouppoll = Engine_Api::_()->core()->getSubject('sitegrouppoll_poll');
    if (empty($sitegrouppoll)) {
      return false;
    }

    //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $owner_id = $sitegrouppoll->owner_id;
    $group_id = $sitegrouppoll->group_id;

    $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }

    if ($owner_id != $viewer_id && empty($can_edit)) {
      return false;
    }

    return array(
        'label' => 'Delete Poll',
        'route' => 'sitegrouppoll_delete',
        'class' => 'ui-btn-danger',
        'params' => array(
            'poll_id' => $sitegrouppoll->poll_id,
            'group_id' => $group_id,
            'tab' => Zend_Controller_Front::getInstance()->getRequest()->getParam('tab')
        )
    );
  }

}
?>