<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegrouppoll
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegrouppoll.isActivate', 0);
if (empty($isActive)) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Polls'),
        'description' => $view->translate('This widget forms the Polls tab on the Group Profile and displays the polls of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegrouppoll.sitemobile-profile-sitegrouppolls',
        'defaultParams' => array(
            'title' => $view->translate('Polls'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Polls'),
        'description' => $view->translate('Displays a list of all the groups poll on site. This widget should be placed on the  Groups poll group.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegrouppoll.sitegroup-poll',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of polls to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
			'title' => $view->translate('Group Poll View'),
			'description' => $view->translate("This widget should be placed on the Group Poll View Group."),
      'category' => $view->translate('Groups'),
			'type' => 'widget',
			'name' => 'sitegrouppoll.sitegrouppoll-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),
)
?>