<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Reviewcats.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupreview_Model_DbTable_Reviewcats extends Engine_Db_Table {

  protected $_rowClass = 'Sitegroupreview_Model_Reviewcat';

	/**
   * Return review parameters data according to group category
   *
   * @param Int group_id
	 * @param Int viewer_id
   * @return Zend_Db_Table_Select
   */
	public function reviewParams($category_id) {
    $select = $this->select()
                    ->from($this->info('name'), array('reviewcat_id', 'reviewcat_name'))
                    ->where('category_id = ?', $category_id);
    return $this->fetchAll($select);
	}

	/**
   * Return review parameters and category data
   *
   * @return Zend_Db_Table_Select
   */
	public function reviewCatParams() {

    $tableGroupCats = Engine_Api::_()->getDbtable('categories', 'sitegroup');
    $tableGroupCatsName = $tableGroupCats->info('name');

		$tableReviewCatsName = $this->info('name');

    $select = $tableGroupCats->select()
                    ->setIntegrityCheck(false)
                    ->from($tableGroupCatsName)
                    ->joinLeft($this->info('name'), "$tableGroupCatsName.category_id = $tableReviewCatsName.category_id", array('reviewcat_name', 'reviewcat_id'))
                    ->where($tableGroupCatsName . ".cat_dependency = ?", 0);
    return $tableGroupCats->fetchAll($select);

	}

}
?>