<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupreview.isActivate', 0);
if(empty($isActive)){ return; }

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Reviews'),
        'description' => $view->translate('This widget forms the Reviews tab on the Group Profile and displays the reviews of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupreview.sitemobile-profile-sitegroupreviews',
        'defaultParams' => array(
            'title' => $view->translate('Reviews'),
        ),
    ),
    array(
			'title' => $view->translate('Group Review View'),
			'description' => $view->translate("This widget should be placed on the Group Review View Group."),
      'category' => $view->translate('Groups'),
			'type' => 'widget',
			'name' => 'sitegroupreview.review-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	  ),
    array(
        'title' => $view->translate('Group Reviews'),
        'description' => $view->translate('Displays the list of Reviews from Groups created on your community. This widget should be placed in the widgetized Group Reviews group. Results from the Search Group Reviews form are also shown here.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegroupreview.sitegroup-review',
        'defaultParams' => array(
            'title' => $view->translate('Reviews'),
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of reviews to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
)
?>