<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2010-12-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupreview_Widget_CommentSitegroupreviewsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET SUBJECT AND SITEGROUP ID
		$group_url = Zend_Controller_Front::getInstance()->getRequest()->getParam('group_url', null);
		$group_id = Engine_Api::_()->sitegroup()->getGroupId($group_url);

    //GET OBJECT
    $sitegroup_subject = Engine_Api::_()->getItem('sitegroup_group',$group_id);


    // PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK

    $sitegroupreview_isComment = Zend_Registry::isRegistered('sitegroupreview_isComment') ? Zend_Registry::get('sitegroupreview_isComment') : null;
    if (empty($sitegroupreview_isComment)) {
      return $this->setNoRender();
    }

		$params = array();
		$params['group_id'] = $group_id;
		$params['orderby'] = 'comment_count DESC';
		$params['zero_count'] = 'comment_count';
		$params['limit'] = $this->_getParam('itemCount', 3);

    $this->view->paginator = $paginator = Engine_Api::_()->getDbtable('reviews', 'sitegroupreview')->reviewRatingData($params);

    if (Count($paginator) <= 0) {
      return $this->setNoRender();
    }
  }

}
?>