<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupreview
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupreview_Widget_ReviewContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {
//GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();
    if (!empty($viewer_id)) {
      $this->view->level_id = $viewer->level_id;
    } else {
      $this->view->level_id = 0;
    }

    //GET REVIEW MODEL
    $this->view->sitegroupreview = $sitegroupreview = Engine_Api::_()->getItem('sitegroupreview_review', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'));
    if (empty($sitegroupreview)) {
      return $this->setNoRender();
    }

    $this->view->group_id = $group_id = $sitegroupreview->group_id;

    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);

    $this->view->sitegroup_slug = $sitegroup->getSlug();
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }
    //END MANAGE-ADMIN CHECK
    //GET OWNER INFORMATION
    $this->view->owner = $owner = $sitegroupreview->getOwner();

    //INCREMENT IN NUMBER OF VIEWS
    if (!$owner->isSelf($viewer)) {
      $sitegroupreview->view_count++;
      $sitegroupreview->save();
    }

    //REPORT CODE
    $this->view->review_report = $review_report = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupreview.report', 1);
    if (!empty($viewer_id) && $review_report == 1) {
      $report = $this->view->report = $sitegroupreview;
    }

    // Start: "Suggest to Friends" link work.
    $group_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // Here we are delete this review suggestion if viewer have.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_review', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'), 'group_review_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegroupreview', Zend_Controller_Front::getInstance()->getRequest()->getParam('review_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.package.enable', 1)) {
        if ($sitegroup->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitegroup->closed) && !empty($sitegroup->approved) && empty($sitegroup->declined) && !empty($sitegroup->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->reviewSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'review_sugg_link');
      }
      // End: "Suggest to Friends" link work.
    }
  }

}
?>