<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupurl
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupurl_Form_Admin_Global extends Engine_Form {

  public function init() {
   
    $is_element = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupurl.is.enable', 0);
    $this->setTitle('Global Settings');
		$this->setDescription('These settings affect all members in your community.');
     if(!empty($is_element)) {
			$this->addElement('Radio', 'sitegroup_showurl_column', array(
					'label' => 'Custom Group URL',
					'description' => 'Do you want to enable Group Admins to create their custom Group URL during Group creation? (If enabled, a URL field will be available to users at the time of creating a Group.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
          'onclick' => 'showediturl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.showurl.column', 1),
			));

			$this->addElement('Radio', 'sitegroup_edit_url', array(
					'label' => 'Edit Custom Group URL',
					'description' => 'Do you want to enable Group Admins to edit their custom Group URL?',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.edit.url', 0),
			));

      $this->addElement('Radio', 'sitegroup_change_url', array(
					'label' => 'Automatically Shorten Group URLs',
					'description' => 'Do you want the Group URLs to be shortened upon the number of Likes on them exceeding the Likes limit? (You can choose the Likes limit below. Selecting “Yes” will change the URLs of those Groups from the form: “/group/group_url” to: “/group_url”.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'onclick' => 'showurl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.change.url', 1),
			));
			
			$this->addElement('Text', 'sitegroup_likelimit_forurlblock', array(
					'label' => 'Likes Limit for Active Short URL',
					'allowEmpty' => false,
					'maxlength' => '3',
					'required' => true,
					'description' => 'Please enter the minimum number of Likes after which Group URLs should be shortened. (Note: It is recommended to enter ‘5’ minimum number of Likes.)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.likelimit.forurlblock', 5),
			));   

      $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
      $this->addElement('Dummy', 'sitegroup_manifestUrlP', array(
        'label' => 'Groups URL alternate text for "groups"',
        'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Please %1$sedit%2$s the text which want to display in place of "groups" in the URLs of Groups plugin.'),"<a href='" . $view->baseUrl() . "/admin/sitegroup/settings#sitegroup_manifestUrlP-label' target='_blank'>","</a>"),
      ));
      $this->getElement('sitegroup_manifestUrlP')->getDecorator('Description')->setOptions(array('placement', 'APPEND', 'escape' => false));
      $this->addElement('Dummy', 'sitegroup_manifestUrlS', array(
        'label' => 'Groups URL alternate text for "group"',
        'description' => sprintf(Zend_Registry::get('Zend_Translate')->_('Please %1$sedit%2$s the text which want to display in place of "group" in the URLs of Groups plugin.'),"<a href='" . $view->baseUrl() . "/admin/sitegroup/settings#sitegroup_manifestUrlS-label' target='_blank'>","</a>"),
      ));
				$this->getElement('sitegroup_manifestUrlS')->getDecorator('Description')->setOptions(array('placement',
	'APPEND', 'escape' => false));
      $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
));
    }
    else {
			$this->addElement('Radio', 'sitegroup_change_url', array(
					'label' => 'Automatically Shorten Group URLs',
					'description' => 'Do you want the Group URLs to be shortened upon the number of Likes on them exceeding the Likes limit? (You can choose the Likes limit below. Selecting “Yes” will change the URLs of those Groups from the form: “/group/group_url” to: “/group_url”.)',
					'multiOptions' => array(
							1 => 'Yes',
							0 => 'No'
					),
					'onclick' => 'showurl(this.value)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.change.url', 1),
			));
			
			$this->addElement('Text', 'sitegroup_likelimit_forurlblock', array(
					'label' => 'Likes Limit for Active Short URL',
					'allowEmpty' => false,
					'maxlength' => '3',
					'required' => true,
					'description' => 'Please enter the minimum number of Likes after which Group URLs should be shortened. (Note: It is recommended to enter ‘5’ minimum number of Likes.)',
					'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.likelimit.forurlblock', 5),
			));
			
			$this->addElement('Button', 'submit', array(
        'label' => 'Proceed to activate Plugin',
        'type' => 'submit',
        'ignore' => true
    ));
    }
  }

}
?>