<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    ReviewController.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupvideo_IndexController extends Siteapi_Controller_Action_Standard {

    public function init() {

        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupvideo')) {
            $this->respondWithError('unauthorized');
        }

        //CHECK SUBJECT IS EXIST OR NOT IF NOT EXIST THEN SET ACCORDING TO THE PAGE ID AND PHOTO ID
        if (!Engine_Api::_()->core()->hasSubject()) {
            if (0 !== ($video_id = (int) $this->_getParam('video_id')) &&
                    null !== ($video = Engine_Api::_()->getItem('sitegroupvideo_video', $video_id))) {
                Engine_Api::_()->core()->setSubject($video);
            } else if (0 !== ($group_id = (int) $this->_getParam('group_id')) &&
                    null !== ($sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id))) {
                Engine_Api::_()->core()->setSubject($sitegroup);
            }
        }

        //GET PAGE ID
        $group_id = $this->_getParam('group_id');

        //PACKAGE BASE PRIYACY START    
        if (!empty($group_id)) {
            $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
            if (!empty($sitegroup)) {
                if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
                    if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupvideo")) {
                        $this->respondWithError('unauthorized');
                    }
                } else {
                    $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'svcreate');
                    if (empty($isGroupOwnerAllow)) {
                        $this->respondWithError('unauthorized');
                    }
                }
            }
        }
        // PACKAGE BASE PRIYACY END
        else {
            if (Engine_Api::_()->core()->hasSubject() != null) {
                $video = Engine_Api::_()->core()->getSubject();
                $group_id = $video->group_id;
            }
        }
    }

    public function indexAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        // get sitegroup and album
        if (Engine_Api::_()->core()->getSubject()->getType() == 'sitegroup_group') {
            $sitegroup = Engine_Api::_()->core()->getSubject('sitegroup_group');
        } else {
            $sitegroup = Engine_Api::_()->core()->getSubject()->getParent();
        }

        $group_id = $sitegroup->group_id;
        $params = array();
        $params['group_id'] = $group_id;
        if ($this->_getParam('group'))
            $params['group'] = $this->_getParam('group');
        else
            $params['group'] = 1;

        if ($this->_getParam('limit'))
            $params['limit'] = $this->_getParam('limit');
        else
            $params['limit'] = 10;

        if ($this->_getParam('search'))
            $params['search'] = $this->_getParam('search');

        if ($this->_getParam('myvideos'))
            $params['user_id'] = $viewer_id;

        if ($this->_getParam('orderby'))
            $params['orderby'] = $this->_getParam('orderby');

        $groupsobj = $paginator = Engine_Api::_()->getDbtable('videos', 'sitegroupvideo')->getSitegroupvideosPaginator($params);
        $response['totalItemcount'] = $paginator->getTotalItemCount();
        // Set the 'side menus' for 'My Groups' 
        $tempResponse = array();
        if ($groupsobj->getTotalItemCount() > 0) {
            foreach ($groupsobj as $groupObj) {
                $value = $groupObj->toArray();
                $ownerImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($groupObj, true);
                $videoImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($groupObj, false);
                $value['video_url'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->getVideoURL($groupObj);
                
                $tempMenu = array();

                if ($groupObj->authorization()->isAllowed($viewer, 'view')) {
                    $tempMenu[] = array(
                        'label' => $this->translate('View Video'),
                        'name' => 'view',
                        'url' => 'advancedgroups/video/view/' . $group_id . '/' . $groupObj->getIdentity(),
                        'urlParams' => array(
                        )
                    );
                }

                if ($groupObj->authorization()->isAllowed($viewer, 'edit')) {
                    $tempMenu[] = array(
                        'label' => $this->translate('Edit Video'),
                        'name' => 'edit',
                        'url' => 'advancedgroups/video/edit/' . $group_id . '/' . $groupObj->getIdentity(),
                        'urlParams' => array(
                        )
                    );

                    $tempMenu[] = array(
                        'label' => $this->translate('Delete Video'),
                        'name' => 'delete',
                        'url' => 'advancedgroups/video/delete/' . $group_id . '/' . $groupObj->getIdentity(),
                        'urlParams' => array(
                        )
                    );
                }


                $tempMenu[] = array(
                    'label' => $this->translate('Highlight Video'),
                    'name' => 'highlight',
                    'url' => 'advancedgroups/video/highlight/' . $group_id . '/' . $groupObj->getIdentity(),
                    'urlParams' => array(
                    )
                );

                $tempMenu[] = array(
                    'label' => $this->translate('Make Featured'),
                    'name' => 'featured',
                    'url' => 'advancedgroups/video/featured/' . $group_id . '/' . $groupObj->getIdentity(),
                    'urlParams' => array(
                    )
                );

                $tempMenu[] = array(
                    'label' => $this->translate('Comment on Video'),
                    'name' => 'comment',
                    'url' => 'advancedgroups/video/comment/' . $group_id . '/' . $groupObj->getIdentity(),
                    'urlParams' => array(
                    )
                );

                $value["menu"] = $tempMenu;

                $value["owner_title"] = $groupObj->getOwner()->getTitle();

                $value["allow_to_view"] = 1;

                $isAllowedEdit = Engine_Api::_()->sitegroup()->isManageAdmin($groupObj, 'edit');
                if (isset($params['is_edit']) && !empty($params['is_edit']))
                    $value["edit"] = empty($isAllowedEdit) ? 0 : 1;

                $isAllowedDelete = $groupObj->authorization()->isAllowed($viewer, 'delete');

                if (isset($params['is_delete']) && !empty($params['is_delete']))
                    $value["delete"] = empty($isAllowedDelete) ? 0 : 1;

                $value = array_merge($value, $ownerImages);
                $value = array_merge($value, $videoImages);

                $tempResponse[] = $value;
            }

            if (!empty($tempResponse))
                $response['response'] = $tempResponse;
        }
        $this->respondWithSuccess($response, true);
    }

//    public function viewAction() {
//        $viewer = Engine_Api::_()->user()->getViewer();
//        $viewer_id = $viewer->getIdentity();
//
//        // get sitegroup and album
//        if (Engine_Api::_()->core()->getSubject()->getType() == 'sitegroup_group') {
//            $sitegroup = Engine_Api::_()->core()->getSubject('sitegroup_group');
//        } else {
//            $sitegroup = Engine_Api::_()->core()->getSubject()->getParent();
//        }
//
//        $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
//
//        if (!$video)
//            $this->respondWithError('no_record');
//
//        $response['video'] = $video->toArray();
//
//
//        // package level checks
//        if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
//            if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupvideo")) {
//                $this->respondWithError('unauthorized');
//            }
//        } else {
//            $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'svcreate');
//            if (empty($isGroupOwnerAllow)) {
//                $this->respondWithError('unauthorized');
//            }
//        }
//
//        //START MANAGE-ADMIN CHECK
//        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
//        if (empty($isManageAdmin)) {
//            $this->respondWithError('unauthorized');
//        }
//
//        if ($viewer_id == $video->owner_id)
//            $gutterMenus = $this->_gutterMenus();
//
//        $response = array();
//        $response['data'] = $video->toArray();
//        $rating_count = Engine_Api::_()->getDbtable('ratings', 'sitegroupvideo')->ratingCount($video->getIdentity());
//        $response['data']['rating_count'] = $rating_count;
//        $response['gutterMenus'] = $gutterMenus;
//        $this->respondWithSuccess($response, true);
//    }
//    public function _gutterMenus() {
//        $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
//        $viewer = Engine_Api::_()->user()->getViewer();
//        $viewer_id = $viewer->getIdentity();
//
//        $tempMenu[] = array(
//            'label' => $this->translate('View Video'),
//            'name' => 'view',
//            'url' => 'advancedgroups/view/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//        $tempMenu[] = array(
//            'label' => $this->translate('Edit Video'),
//            'name' => 'edit',
//            'url' => 'advancedgroups/edit/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//
//        $tempMenu[] = array(
//            'label' => $this->translate('Highlight Video'),
//            'name' => 'highlight',
//            'url' => 'advancedgroups/highlight/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//        $tempMenu[] = array(
//            'label' => $this->translate('Make Featured'),
//            'name' => 'featured',
//            'url' => 'advancedgroups/featured/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//        $tempMenu[] = array(
//            'label' => $this->translate('Comment on Video'),
//            'name' => 'comment',
//            'url' => 'advancedgroups/comment/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//        $tempMenu[] = array(
//            'label' => $this->translate('Delete Video'),
//            'name' => 'delete',
//            'url' => 'advancedgroups/delete/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//        $tempMenu[] = array(
//            'label' => $this->translate("Like Video"),
//            'name' => 'like',
//            'url' => 'advancedgroups/like/' . $group_id . '/' . $groupObj->getIdentity(),
//            'urlParams' => array(
//            )
//        );
//
//        if (Engine_Api::_()->getDbtable('ratings', 'sitegroupvideo')->checkRated($video->getIdentity(), $viewer_id)) {
//            $tempMenu[] = array(
//                'label' => $this->translate("Rate This Video"),
//                'name' => 'rating',
//                'url' => 'advancedgroups/like/' . $group_id . '/' . $groupObj->getIdentity(),
//                'urlParams' => array(
//                    'rating'
//                )
//            );
//        }
//        return $tempMenu;
//    }

    public function searchFormAction() {
        $viewer = Engine_Api::_()->user()->getViewer();

        // if (!Engine_Api::_()->authorization()->isAllowed('sitegroupvideo_video', $viewer, 'view'))
        //     $this->respondWithError('unauthorized');

        $response = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->getVideoBrowseSearchForm();

        $responseData['form'] = $response;

        // this is not working for some reason 
        // first task to do tomorrow
        $this->respondWithSuccess($responseData, true);
    }

}
