<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    ReviewController.php 2015-09-17 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitegroupvideo_VideoController extends Siteapi_Controller_Action_Standard {

    public function init() {

        if (!Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupvideo')) {
            $this->respondWithError('unauthorized');
        }

        //CHECK SUBJECT IS EXIST OR NOT IF NOT EXIST THEN SET ACCORDING TO THE PAGE ID AND PHOTO ID
        if (!Engine_Api::_()->core()->hasSubject()) {
            if (0 !== ($video_id = (int) $this->_getParam('video_id')) &&
                    null !== ($video = Engine_Api::_()->getItem('sitegroupvideo_video', $video_id))) {
                Engine_Api::_()->core()->setSubject($video);
            } else if (0 !== ($group_id = (int) $this->_getParam('group_id')) &&
                    null !== ($sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id))) {
                Engine_Api::_()->core()->setSubject($sitegroup);
            }
        }

        //GET PAGE ID
        $group_id = $this->_getParam('group_id');

        // PACKAGE BASE PRIYACY START    
        if (!empty($group_id)) {
            $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $group_id);
            if (!empty($sitegroup)) {
                if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
                    if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupvideo")) {
                        $this->respondWithError('unauthorized');
                    }
                } else {
                    $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'svcreate');
                    if (empty($isGroupOwnerAllow)) {
                        $this->respondWithError('unauthorized');
                    }
                }
            }
        }
        // PACKAGE BASE PRIYACY END
        else {
            if (Engine_Api::_()->core()->hasSubject() != null) {
                $video = Engine_Api::_()->core()->getSubject();
                $group_id = $video->group_id;
            }
        }
    }

    public function viewAction() {

        $this->validateRequestMethod();

        // Gets logged in user info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        $value['response'] = $video->toArray();
        
        // User Rating work
        $ratingTable = Engine_Api::_()->getDbtable('ratings','sitegroupvideo');
        $checkRated = $ratingTable->checkRated($video->video_id , $viewer_id);
        $averagerating = $ratingTable->rateVideo($video->video_id);
        
        $value['response']['owner_title'] = $video->getOwner()->getTitle();
        $value['response']['rating'] = $averagerating;
        $ownerImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($video, true);
        $videoImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($video, false);

        $value['response'] = array_merge($value['response'], $ownerImages);
        $value['response'] = array_merge($value['response'], $videoImages);
        
        $value['response']['video_url'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->getVideoURL($video);

        $tempMenu = array();
        if ($video->authorization()->isAllowed($viewer, 'edit')) {

            $tempMenu[] = array(
                'label' => $this->translate('Edit Video'),
                'name' => 'edit',
                'url' => 'sitegroup/video/edit/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
                'urlParams' => array(
                )
            );

            $tempMenu[] = array(
                'label' => $this->translate('Delete Video'),
                'name' => 'delete',
                'url' => 'advancedgroups/video/delete/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
                'urlParams' => array(
                )
            );
        }
        
        if(!$checkRated)
        {
            $tempMenu[] = array(
                'label' => $this->translate('Rating'),
                'description' => $this->translate("give rating in stars"),
                'name' => 'rating',
                'url' => 'advancedgroups/video/rating/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
                'urlParams' => array()
            );
        }


        $tempMenu[] = array(
            'label' => $this->translate('Highlight Video'),
            'name' => 'highlight',
            'url' => 'advancedgroups/video/highlight/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
            'urlParams' => array(
            )
        );

        $tempMenu[] = array(
            'label' => $this->translate('Make Featured'),
            'name' => 'featured',
            'url' => 'advancedgroups/video/featured/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
            'urlParams' => array(
            )
        );

        $tempMenu[] = array(
            'label' => $this->translate('Comment on Video'),
            'name' => 'comment',
            'url' => 'advancedgroups/video/comment/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
            'urlParams' => array(
            )
        );

        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        if (!$likeTable->isLike($subject, $viewer)) {
            $tempMenu[] = array(
                'label' => $this->translate('Like on Video'),
                'name' => 'like',
                'url' => 'advancedgroups/video/like/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
                'urlParams' => array(
                )
            );
        } else {
            $tempMenu[] = array(
                'label' => $this->translate('unlike on Video'),
                'name' => 'unlike',
                'url' => 'advancedgroups/video/unlike/' . $sitegroup->getIdentity() . '/' . $video->getIdentity(),
                'urlParams' => array(
                )
            );
        }

        $tempMenu[] = array(
            'name' => 'share',
            'label' => $this->translate('Share This Video'),
            'url' => 'activity/share',
            'urlParams' => array(
                "type" => $subject->getType(),
                "id" => $subject->getIdentity()
            )
        );

        $value['guttermenu'] = $tempMenu;

        $this->respondWithSuccess($value, true);
    }

    /*
     * Create a Directory group video
     */

    public function createAction() {

        // Gets logged in user info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }

        if (Engine_Api::_()->core()->hasSubject('sitegroup_group')) {
            $sitegroup = Engine_Api::_()->core()->getSubject('sitegroup_group');
        }

        if (!$sitegroup)
            $this->respondWithError("no_record");

        // Manage admin work Start

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
        if (empty($isManageAdmin))
            $this->respondWithError('unauthorized');

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');

        if (empty($isManageAdmin))
            $can_edit = 0;
        else
            $can_edit = 1;

        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'svcreate');
        if (empty($isManageAdmin) && empty($can_edit))
            $this->respondWithError('unauthorized');

        // Manage admin work end

        if ($this->getRequest()->isGet()) {
            $form_fields = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->getCreateVideoForm();
            $this->respondWithSuccess($form_fields);
        } elseif ($this->getRequest()->isPost()) {
            $values = $this->_getAllParams();

            // Start form validation
            $validators = Engine_Api::_()->getApi('Siteapi_FormValidators', 'sitegroupvideo')->createformvalidators();
            $values['validators'] = $validators;

            $validationMessage = $this->isValid($values);

//            var_dump($validationMessage);
//            die;
            // Response validation error
            if (!empty($validationMessage) && @is_array($validationMessage)) {
                $this->respondWithValidationError('validation_fail', $validationMessage);
            }

            $getPackagevideoCreate = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegroupvideo');
            $sitegroupModHostName = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
            $isModType = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.set.type', 0);
            if (empty($isModType)) {
                Engine_Api::_()->getApi('settings', 'core')->setSetting('sitegroupvideo.utility.type', convert_uuencode($sitegroupModHostName));
            }

            $values['owner_id'] = $viewer->getIdentity();

            // Video creation process
            $videoTable = Engine_Api::_()->getDbtable('videos', 'sitegroupvideo');

            $db = $videoTable->getAdapter();
            $db->beginTransaction();
            try {

                if ($values['type'] == 3) {
                    $sitegroupvideo = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->uploadVideo();
                } else {
                    $sitegroupvideo = $videoTable->createRow();
                }

                $sitegroupvideo->setFromArray($values);
                $sitegroupvideo->group_id = $sitegroup->group_id;
                $sitegroupvideo->save();

                // Thumbnail creation
                $thumbnail = $this->handleThumbnail($sitegroupvideo->type, $sitegroupvideo->code);
                $ext = ltrim(strrchr($thumbnail, '.'), '.');
                $thumbnail_parsed = @parse_url($thumbnail);

                if (@GetImageSize($thumbnail)) {
                    $valid_thumb = true;
                } else {
                    $valid_thumb = false;
                }

                if ($valid_thumb && $thumbnail && $ext && $thumbnail_parsed && in_array($ext, array('jpg', 'jpeg', 'gif', 'png'))) {
                    $tmp_file = APPLICATION_PATH . '/temporary/link_' . md5($thumbnail) . '.' . $ext;
                    $thumb_file = APPLICATION_PATH . '/temporary/link_thumb_' . md5($thumbnail) . '.' . $ext;
                    $src_fh = fopen($thumbnail, 'r');
                    $tmp_fh = fopen($tmp_file, 'w');
                    stream_copy_to_stream($src_fh, $tmp_fh, 1024 * 1024 * 2);
                    $image = Engine_Image::factory();
                    $image->open($tmp_file)
                            ->resize(120, 240)
                            ->write($thumb_file)
                            ->destroy();

                    try {
                        $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
                            'parent_type' => $sitegroupvideo->getType(),
                            'parent_id' => $sitegroupvideo->getIdentity()
                        ));

                        // Remove temp files
                        @unlink($thumb_file);
                        @unlink($tmp_file);
                    } catch (Exception $e) {
                        
                    }
                    $information = $this->handleInformation($sitegroupvideo->type, $sitegroupvideo->code);
                    $sitegroupvideo->duration = $information['duration'];
                    $sitegroupvideo->photo_id = $thumbFileRow->file_id;
                    $sitegroupvideo->status = 1;
                    $sitegroupvideo->featured = 0;
                    $sitegroupvideo->save();

                    // Insert new action item
                    $insert_action = true;
                }



                if ($values['ignore'] == true) {
                    $sitegroupvideo->status = 1;
                    $sitegroupvideo->save();
                    $insert_action = true;
                }

                // Comment privacy
                $auth = Engine_Api::_()->authorization()->context;
                $roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network', 'everyone');
                $auth_comment = "everyone";
                $commentMax = array_search($auth_comment, $roles);
                foreach ($roles as $i => $role) {
                    $auth->setAllowed($sitegroupvideo, $role, 'comment', ($i <= $commentMax));
                }

                // Tag work
                if (!empty($values['tags'])) {
                    $tags = preg_split('/[,]+/', $values['tags']);
                    $sitegroupvideo->tags()->addTagMaps($viewer, $tags);
                }


                // Adding activity feed 
                if ($insert_action && $sitegroupvideo->search == 1) {
                    $owner = $sitegroupvideo->getOwner();
                    $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
                    $activityFeedType = null;
                    if (Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup) && Engine_Api::_()->sitegroup()->isFeedTypeGroupEnable())
                        $activityFeedType = 'sitegroupvideo_admin_new';
                    elseif ($sitegroup->all_post || Engine_Api::_()->sitegroup()->isGroupOwner($sitegroup))
                        $activityFeedType = 'sitegroupvideo_new';

                    if ($activityFeedType) {
                        $action = $actionTable->addActivity($owner, $sitegroup, $activityFeedType);
                        Engine_Api::_()->getApi('subCore', 'sitegroup')->deleteFeedStream($action);
                    }


                    if ($action != null) {
                        $actionTable->attachActivity($action, $sitegroupvideo);
                    }

                    // Sending activity feed to facebook.
                    $enable_Facebooksefeed = $enable_fboldversion = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('facebooksefeed');
                    if (!empty($enable_Facebooksefeed)) {

                        $video_array = array();
                        $video_array['type'] = 'sitegroupvideo_new';
                        $video_array['object'] = $sitegroupvideo;

                        Engine_Api::_()->facebooksefeed()->sendFacebookFeed($video_array);
                    }

                    //PAGE VIDEO CREATE NOTIFICATION AND EMAIL WORK
//                    $sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
//                    if (!empty($action)) {
//                        if ($sitegroupVersion >= '4.3.0p1') {
//                            Engine_Api::_()->sitegroup()->sendNotificationEmail($sitegroupvideo, $action, 'sitegroupvideo_create', 'SITEPAGEVIDEO_CREATENOTIFICATION_EMAIL', 'Groupevent Invite');
//                            $isGroupAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitegroup')->isGroupAdmins($viewer->getIdentity(), $group_id);
//                            if (!empty($isGroupAdmins)) {
//                                //NOTIFICATION FOR ALL FOLLWERS.
//                                Engine_Api::_()->sitegroup()->sendNotificationToFollowers($sitegroupvideo, $action, 'sitegroupvideo_create');
//                            }
//                        }
//                    }
                }



                $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
                foreach ($actionTable->getActionsByObject($sitegroupvideo) as $action) {
                    $actionTable->resetActivityBindings($action);
                }

                $db->commit();
                $this->successResponseNoContent('no_content');
            } catch (Exception $ex) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    /*
     * Edit Directory Group video
     */

    public function editAction() {
        // Gets logged in user info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        // Manage admin work start
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            $can_edit = 0;
        } else {
            $can_edit = 1;
        }
        // End manage admin work
        // Superadmin, video owner and group owner can edit video
        if ($viewer_id != $sitegroupvideo->owner_id && $can_edit != 1) {
            $this->respondWithError('unauthorized');
        }

        if ($this->getRequest()->isGet()) {
            $form_fields = Engine_Api::_()->getApi('Siteapi_Core', 'sitegroupvideo')->getEditForm($subject);
            $this->respondWithSuccess($form_fields);
        } elseif ($this->getRequest()->isPost()) {
            Engine_Api::_()->sitegroupvideo()->setVideoPackages();

            $values = $this->_getAllParams();

            // Start form validation
            $validators = Engine_Api::_()->getApi('Siteapi_FormValidators', 'sitegroupvideo')->createformvalidators();
            $values['validators'] = $validators;
            $validationMessage = $this->isValid($values);

            // Response validation error
            if (!empty($validationMessage) && @is_array($validationMessage)) {
                $this->respondWithValidationError('validation_fail', $validationMessage);
            }


            // Process
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            
            try {

                $subject->setFromArray($values);

                // Add tags
                $tags = preg_split('/[,]+/', $values['tags']);
                $subject->tags()->setTagMaps($viewer, $tags);
                $subject->save();

                $db->commit();
                $this->successResponseNoContent('no_content');
            } catch (Exception $ex) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    /*
     *    Lists the likes and comments on the Directory group video
     */

    public function listcommentsAction() {

        // Gets logged in user info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        $canComment = $subject->authorization()->isAllowed($viewer, 'comment');

        $groupApi = Engine_Api::_()->sitegroup();
        $groupApi->isManageAdmin($groupSubject, 'edit');
        $viewAllLikes = $this->_getParam('viewAllLikes', false);
        $likes = $subject->likes()->getLikePaginator();

        // Likes work
        $likesData = array();
        if (!empty($likes)) {
            foreach ($likes as $like) {
                $likesData[$like->like_id] = $like->toArray();
                $poster = $like->getPoster();
                $posterImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($poster, true);
                $likesData[$like->like_id]['owner_images'] = $posterImages;
                $likesData[$like->like_id]['owner_title'] = $poster->getTitle();
            }
        }


        // Comments work
        if (null !== ( $group = $this->_getParam('group'))) {
            $commentSelect = $subject->comments()->getCommentSelect('ASC');
            $commentSelect->order('comment_id ASC');
            $comments = Zend_Paginator::factory($commentSelect);
            $comments->setCurrentGroupNumber($group);
            $comments->setItemCountPerGroup(10);
        }
        // If not has a group, show the
        else {
            $commentSelect = $subject->comments()->getCommentSelect('DESC');
            $commentSelect->order('comment_id DESC');

            $comments = Zend_Paginator::factory($commentSelect);
            $comments->setCurrentGroupNumber(1);
            $comments->setItemCountPerGroup(4);
        }
        $commentsData = array();
        if (!empty($comments)) {
            foreach ($comments as $comment) {
                $poster = $comment->getPoster();
                $posterImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($poster, true);
                $likes = $comment->likes();
                $commentsData[$comment->comment_id] = $comment->toArray();
                $commentsData[$comment->comment_id]['owner_images'] = $posterImages;
                $commentsData[$comment->comment_id]['owner_title'] = $poster->getTitle();
            }
        }

        $response['comments'] = $commentsData;
        $response['likes'] = $likesData;

        $this->respondWithSuccess($response, true);
    }
    
    /*
     * Give rating to a Directory group video
     */
    public function ratingAction()
    {
        
        $this->validateRequestMethod("PUT");
        // Get viewer info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");
        
        $rating = intval($this->_getParam('rating'));
        if(empty($rating) || $rating<=0 || $rating>5)
            $this->respondWithValidationError('parameter_missing', 'rating is missing or is invalid');
        
        $ratingTable = Engine_Api::_()->getDbtable('ratings','sitegroupvideo');
        $checkrated = $ratingTable->checkRated($video->video_id , $viewer_id);
        
        if($checkrated)
            $this->respondWithValidationError('already_rated', "You have already rated this video");
        
        // Process
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
                
                $ratingTable->setRating($video->video_id , $viewer_id , $rating);
                $db->commit();
                $this->successResponseNoContent('no_content');
                
            } catch (Exception $ex) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        
    }

    /*
     * Delete's the video
     *
     */

    public function deleteAction() {

        $this->validateRequestMethod("DELETE");

        // Check user validation
        if (!$this->_helper->requireUser()->isValid())
            return;

        // Get viewer info
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        // Start mamage admin check
        $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
        if (empty($isManageAdmin)) {
            $can_edit = 0;
        } else {
            $can_edit = 1;
        }

        // Video owner and group owner can delete the video
        if ($viewer_id != $video->owner_id && $can_edit != 1) {
            $this->respondWithError('unauthorized');
        }

        $db = $video->getTable()->getAdapter();
        $db->beginTransaction();

        try {

            Engine_Api::_()->getDbtable('ratings', 'sitegroupvideo')->delete(array('video_id =?' => $this->getRequest()->getParam('video_id')));
            $video->delete();

            $db->commit();
            $this->successResponseNoContent('no_content');
        } catch (Exception $e) {
            $db->rollBack();
            $this->respondWithError('internal_server_error', $e->getMessage());
        }
    }

    /*
     * Returns comment form and posts comment on a video
     *
     *
     */

    public function commentAction() {
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");


        if ($this->getRequest()->isGet()) {
            $commentform = Engine_Api::_()->getApi('Siteapi_Core', 'Sitegroupvideo')->getcommentForm($video->getType(), $video->video_id);
            $this->respondWithSuccess($commentform, true);
        }

        if ($this->getRequest()->isPost()) {
            $values = array();
            $values = $this->_getAllParams();

            // Start form validation
            $validators = Engine_Api::_()->getApi('Siteapi_FormValidators', 'sitegroupvideo')->getcommentValidation();
            $values['validators'] = $validators;
            $validationMessage = $this->isValid($values);

            // Response validation error
            if (!empty($validationMessage) && @is_array($validationMessage)) {
                $this->respondWithValidationError('validation_fail', $validationMessage);
            }

            $body = $values['body'];
            $values['type'] = $subject->getType();
            $values['id'] = $subject->video_id;
            $values['identity'] = $subject->video_id;
            $db = $subject->comments()->getCommentTable()->getAdapter();
            $db->beginTransaction();
            try {
                $activityApi = Engine_Api::_()->getDbtable('actions', 'activity');
                $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
                $subjectOwner = $subject->getOwner('user');
                $subject->comments()->addComment($viewer, $body);

                // Activity
                $action = $activityApi->addActivity($viewer, $subject, 'comment_' . $subject->getType(), '', array(
                    'owner' => $subjectOwner->getGuid(),
                    'body' => $body
                ));

                if (!empty($action)) {
                    $activityApi->attachActivity($action, $subject);
                }


                // add notification
//                $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
//                $notifyApi->addNotification($notifyUser, $viewer, $subject, 'commented_commented', array(
//                    'label' => $subject->getShortType()
//                ));
                // Add a notification for all users that commented or like except the viewer and poster
                // @todo we should probably limit this
//                $commentedUserNotifications = array();
//                foreach ($subject->comments()->getAllCommentsUsers() as $notifyUser) {
//                    if ($notifyUser->getIdentity() == $viewer->getIdentity() || $notifyUser->getIdentity() == $subjectOwner->getIdentity())
//                        continue;
//
//                    // Don't send a notification if the user both commented and liked this
//                    $commentedUserNotifications[] = $notifyUser->getIdentity();
//                    $notifyApi->addNotification($notifyUser, $viewer, $subject, 'commented_commented', array(
//                        'label' => $subject->getShortType()
//                    ));
//                }
                // Add a notification for all users that liked
                // @todo we should probably limit this
//                foreach ($subject->likes()->getAllLikesUsers() as $notifyUser) {
//                    // Skip viewer and owner
//                    if ($notifyUser->getIdentity() == $viewer->getIdentity() || $notifyUser->getIdentity() == $subjectOwner->getIdentity())
//                        continue;
//
//                    // Don't send a notification if the user both commented and liked this
//                    if (in_array($notifyUser->getIdentity(), $commentedUserNotifications))
//                        continue;
//
//                    $notifyApi->addNotification($notifyUser, $viewer, $subject, 'liked_commented', array(
//                        'label' => $subject->getShortType()
//                    ));
//
//
//                    //end check for group admin and group owner
//                }
                // Send notification to Group admins
                $sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
                if ($sitegroupVersion >= '4.2.9p3') {
                    Engine_Api::_()->sitegroup()->itemCommentLike($subject, 'sitegroup_contentcomment', $baseOnContentOwner);
                }

                // Increment comment count
                Engine_Api::_()->getDbtable('statistics', 'core')->increment('core.comments');

                $db->commit();
                $this->successResponseNoContent('no_content', true);
            } catch (Exception $e) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $e->getMessage());
            }
        }
    }

    /*
     * Deletes a comment
     *
     *
     */

    public function removecommentAction() {

        // Validate request method
        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }


        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        // Comment id
        $comment_id = $this->_getParam('comment_id');

        // Comment
        $comment = $subject->comments()->getComment($comment_id);
        if (!$comment) {
            $this->respondWithError('no_record');
        }

        // Process
        $db = $subject->comments()->getCommentTable()->getAdapter();
        $db->beginTransaction();

        try {
            $subject->comments()->removeComment($comment_id);
            $db->commit();
            $this->successResponseNoContent('no_content', true);
        } catch (Exception $e) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    /*
     * Allows to like a Video
     *
     */

    public function likeAction() {
        // Validate request methods
        $this->validateRequestMethod();

        $viewer = Engine_Api::_()->user()->getViewer();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }

        if (!$this->_helper->requireAuth()->setAuthParams(null, null, 'comment')->isValid()) {
            $this->respondWithError('unauthorized');
        }

        $commentedItem = $subject;
        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        if ($likeTable->isLike($subject, $viewer))
            $this->successResponseNoContent('no_content', true);

        // Process
        $db = $commentedItem->likes()->getAdapter();
        $db->beginTransaction();
        try {
            $commentedItem->likes()->addLike($viewer);
            // Add notification
            $owner = $commentedItem->getOwner();
            $this->view->owner = $owner->getGuid();
            if ($owner->getType() == 'user' && $owner->getIdentity() != $viewer->getIdentity()) {
                $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
                $notifyApi->addNotification($owner, $viewer, $commentedItem, 'liked', array(
                    'label' => $commentedItem->getShortType()
                ));
            }

            $sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
            if ($sitegroupVersion >= '4.2.9p3') {
                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupmember'))
                    Engine_Api::_()->sitegroupmember()->joinLeave($subject, 'Join');
                Engine_Api::_()->sitegroup()->itemCommentLike($subject, 'sitegroup_contentlike', '');
            }
            $db->commit();
            $this->successResponseNoContent('no_content', true);
        } catch (Exception $ex) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    /*
     *   Allows to ulike a video
     *
     */

    public function unlikeAction() {
        $this->validateRequestMethod();

        $viewer = Engine_Api::_()->user()->getViewer();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");


        if (!$this->_helper->requireUser()->isValid()) {
            $this->respondWithError('unauthorized');
        }
        if (!$this->_helper->requireAuth()->setAuthParams(null, null, 'comment')->isValid()) {
            $this->respondWithError('unauthorized');
        }

        // Check for already unliked
        $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
        if (!$likeTable->isLike($subject, $viewer))
            $this->successResponseNoContent('no_content', true);

        $commentedItem = $subject;
        // Process
        $db = $commentedItem->likes()->getAdapter();
        $db->beginTransaction();
        try {

            $commentedItem->likes()->removeLike($viewer);

            // Remove notification
            if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitelike')) {
                Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('type = ?' => 'liked', 'subject_id = ?' => $viewer->getIdentity(), 'subject_type = ?' => $viewer->getType(), 'object_type = ?' => $subject->getType(), 'object_id = ?' => $subject->getIdentity()));
            }

            $sitegroupVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('sitegroup')->version;
            if ($sitegroupVersion >= '4.2.9p3') {
                if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroupmember'))
                    Engine_Api::_()->sitegroupmember()->joinLeave($subject, 'Join');
            }

            $db->commit();
            $this->successResponseNoContent('no_content', true);
        } catch (Exception $ex) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    /*
     * Make a video as featured
     */

    public function featuredAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        $subject->featured = !$subject->featured;
        $subject->save();
        $this->successResponseNoContent('no_content', true);
    }

    /*
     *   Highlight a video
     */

    public function highlightAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject('sitegroupvideo_video')) {
            $subject = $video = Engine_Api::_()->core()->getSubject('sitegroupvideo_video');
            $sitegroup = $video->getParent();
        }

        if (!$video || !$sitegroup)
            $this->respondWithError("no_record");

        $subject->highlighted = !$subject->highlighted;
        $subject->save();
        $this->successResponseNoContent('no_content', true);
    }

    //ACTION FOR HANDLES THUMBNAIL
    private function handleThumbnail($type, $code = null) {
        switch ($type) {
            //youtube
            case "1":
                //https://i.ytimg.com/vi/Y75eFjjgAEc/default.jpg
                return "https://i.ytimg.com/vi/$code/default.jpg";
            //vimeo
            case "2":
                //thumbnail_medium
                $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
                $thumbnail = $data->video->thumbnail_medium;
                return $thumbnail;
        }
    }

    //ACTION FOR HANDLE INFORMATION
    private function handleInformation($type, $code) {
        switch ($type) {
            //youtube
            case "1":
                $key = Engine_Api::_()->getApi('settings', 'core')->getSetting('video.youtube.apikey');
                $data = file_get_contents('https://www.googleapis.com/youtube/v3/videos?part=snippet,contentDetails&id=' . $code . '&key=' . $key);
                if (empty($data)) {
                    return;
                }
                $data = Zend_Json::decode($data);
                $information = array();
                $youtube_video = $data['items'][0];
                $information['title'] = $youtube_video['snippet']['title'];
                $information['description'] = $youtube_video['snippet']['description'];
                $information['duration'] = Engine_Date::convertISO8601IntoSeconds($youtube_video['contentDetails']['duration']);
                return $information;
            //vimeo
            case "2":
                //thumbnail_medium
                $data = simplexml_load_file("http://vimeo.com/api/v2/video/" . $code . ".xml");
                $thumbnail = $data->video->thumbnail_medium;
                $information = array();
                $information['title'] = $data->video->title;
                $information['description'] = $data->video->description;
                $information['duration'] = $data->video->duration;
                //http://img.youtube.com/vi/Y75eFjjgAEc/default.jpg
                return $information;
        }
    }

}
