<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.isActivate', 0);
if (empty($isActive)) {
  return;
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Group Profile Videos'),
        'description' => $view->translate('This widget forms the Videos tab on the Group Profile and displays the videos of the Group. It should be placed in the Tabbed Blocks area of the Group Profile.'),
        'category' => $view->translate('Group Profile'),
        'type' => 'widget',
        'name' => 'sitegroupvideo.sitemobile-profile-sitegroupvideos',
        'defaultParams' => array(
            'title' => $view->translate('Videos'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Group Videos'),
        'description' => $view->translate('Displays the list of Videos from Groups created on your community. This widget should be placed in the widgetized Group Videos group. Results from the Search Group Videos form are also shown here.'),
        'category' => $view->translate('Groups'),
        'type' => 'widget',
        'name' => 'sitegroupvideo.sitegroup-video',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => $view->translate('Count'),
                        'description' => $view->translate('(number of videos to show)'),
                        'value' => 10,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
		array(
				'title' => $view->translate('Group Video View'),
				'description' => $view->translate("This widget should be placed on the Group Video View Page."),
				'category' => $view->translate('Groups'),
				'type' => 'widget',
				'name' => 'sitegroupvideo.video-content',
				'defaultParams' => array(
						'title' => '',
						'titleCount' => true,
				),
		),
)
?>