<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitegroupvideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitegroupvideo_Widget_VideoContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

     $this->_mobileAppFile = true;
     //GET VIDEO ID AND OBJECT
    $video_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id', $this->_getParam('video_id', null));
    $sitegroupvideo = Engine_Api::_()->getItem('sitegroupvideo_video', $video_id);

    if (empty($sitegroupvideo)) {
      return $this->setNoRender();
    }

    //GET TAB ID
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    $getPackagevideoView = Engine_Api::_()->sitegroup()->getPackageAuthInfo('sitegroupvideo');

    //GET VIEWER INFO
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //IF THIS IS SENDING A MESSAGE ID, THE USER IS BEING DIRECTED FROM A CONVERSATION
    //CHECK IF MEMBER IS PART OF THE CONVERSATION
    $message_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('message');
    $message_view = false;
    if ($message_id) {
      $conversation = Engine_Api::_()->getItem('messages_conversation', $message_id);
      if ($conversation->hasRecipient(Engine_Api::_()->user()->getViewer()))
        $message_view = true;
    }
    $this->view->message_view = $message_view;

    //SET SITEGROUP SUBJECT
    $this->view->sitegroup = $sitegroup = Engine_Api::_()->getItem('sitegroup_group', $sitegroupvideo->group_id);

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitegroup()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitegroup()->allowPackageContent($sitegroup->package_id, "modules", "sitegroupvideo")) {
        return $this->setNoRender();
      }
    } else {
      $isGroupOwnerAllow = Engine_Api::_()->sitegroup()->isGroupOwnerAllow($sitegroup, 'svcreate');
      if (empty($isGroupOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'svcreate');
    if (empty($isManageAdmin)) {
      $this->view->can_create = 0;
    } else {
      $this->view->can_create = 1;
    }
    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

     //MAKE HIGHLIGHTED OR NOT
    $this->view->canMakeHighlighted = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.featured', 1);

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitegroup, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitegroup, 'registered', 'view') === 1 ? true : false;
    } 

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitegroup()->isManageAdmin($sitegroup, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = $this->view->can_edit = 0;
    } else {
      $can_edit = $this->view->can_edit = 1;
    }

    if ($viewer_id != $sitegroupvideo->owner_id && $can_edit != 1 && ($sitegroupvideo->status != 1 || $sitegroupvideo->search != 1) || empty($getPackagevideoView)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    //GET VIDEO TAGS
    $this->view->videoTags = $sitegroupvideo->tags()->getTagMaps();

    //CHECK IF EMBEDDING IS ALLOWED
    $can_embed = true;
    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.embeds', 1)) {
      $can_embed = false;
    } else if (isset($sitegroupvideo->allow_embed) && !$sitegroupvideo->allow_embed) {
      $can_embed = false;
    }
    $this->view->can_embed = $can_embed;

    $this->view->videoEmbedded = $embedded = "";

      //INCREMENT IN NUMBER OF VIEWS
      $owner = $sitegroupvideo->getOwner();
      if (!$owner->isSelf($viewer)) {
        $sitegroupvideo->view_count++;
      }

      $sitegroupvideo->save();
      if ($sitegroupvideo->type != 3) {
				$this->view->videoEmbedded = $embedded = $sitegroupvideo->getRichContent(true);
      }

    //SET GROUP-VIDEO SUBJECT
    if (Engine_Api::_()->core()->hasSubject()) {
      Engine_Api::_()->core()->clearSubject();
    }
    Engine_Api::_()->core()->setSubject($sitegroupvideo);

    //VIDEO FROM MY COMPUTER WORK
    if ($sitegroupvideo->type == 3 && $sitegroupvideo->status != 0) {
      $sitegroupvideo->save();

      if (!empty($sitegroupvideo->file_id)) {
        $storage_file = Engine_Api::_()->getItem('storage_file', $sitegroupvideo->file_id);
        if ($storage_file) {
          $this->view->video_location = $storage_file->map();
          $this->view->video_extension = $storage_file->extension;
        }
      }
    }

    $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'sitegroupvideo')->ratingCount($sitegroupvideo->getIdentity());
    $this->view->video = empty($getPackagevideoView) ? null : $sitegroupvideo;
    $this->view->rated = Engine_Api::_()->getDbTable('ratings', 'sitegroupvideo')->checkRated($sitegroupvideo->getIdentity(), $viewer->getIdentity());

    //TAG WORK
    $this->view->limit_sitegroupvideo = $total_sitegroupvideos = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroupvideo.tag.limit', 3);
    
    //VIDEO TABLE
    $videoTable = Engine_Api::_()->getDbtable('videos', 'sitegroupvideo');

    //TOTAL VIDEO COUNT FOR THIS GROUP
    $this->view->count_video = $videoTable->getGroupVideoCount($sitegroupvideo->group_id);

    // Start: "Suggest to Friends" link work.
    $group_flag = 0;
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitegroup');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitegroup')->isSupport();
    if (!empty($is_suggestion_enabled)) {
      // Here we are delete this video suggestion if viewer have.
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitegroup')->deleteSuggestion($viewer_id, 'group_video', Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id'), 'group_video_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitegroupvideo', Zend_Controller_Front::getInstance()->getRequest()->getParam('video_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitegroup.package.enable', 1)) {
        if ($sitegroup->expiration_date <= date("Y-m-d H:i:s")) {
          $group_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($sitegroup->closed) && !empty($sitegroup->approved) && empty($sitegroup->declined) && !empty($sitegroup->draft) && empty($group_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->videoSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitegroup', 'video_sugg_link');
      }
      // End: "Suggest to Friends" link work.
    }
  }

}
?>