<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Videos_Settings extends Engine_Form {

    protected $_field;
    // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
    public $_SHOWELEMENTSBEFOREACTIVATE = array(
        "submit_lsetting", "environment_mode", "sitehomepagevideo_landing_page_layout"
    );

    public function init() {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->setTitle('General Setting')
                ->setDescription('Below, you can configure the settings for this plugin.');

        $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Global Settings")))
                ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("These settings affect all members in your community.")));

        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', 'sitehomepagevideo_lsettings', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => $coreSettings->getSetting('sitehomepagevideo.lsettings'),
        ));


        $this->addElement('Radio', 'sitehomepagevideo_landing_page_layout', array(
            'label' => 'Change Landing Page Layout',
            'description' => 'Do you want to place "Home Page Background Videos & Photos" widget on the landing page of your website? If selected "Yes" a background videos & photos will get displayed at the top of the landing page of your website. [Note: You will see the default video getting displayed after enabling this setting, which you can easily replace with your videos & photos from "Manage Background Slideshows" section in this plugin.]',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => $coreSettings->getSetting('sitehomepagevideo.landing.page.layout', 0),
        ));

        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }

        //Add submit button
        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));

        $this->addElement('Text', 'sitehomepagevideo_video_ffmpeg_path', array(
            'label' => 'Path to FFMPEG',
            'description' => 'Please enter the full path to your FFMPEG installation. (Environment variables are not present.) [Note: Used for converting uploaded videos into the format which is compatible to your website.] You can leave it blank, if FFMPEG is not installed/upgraded on your server.',
            'value' => $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', '')),
        ));
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $baseURL = $view->baseUrl();
        $sitehomepagevideoLendingBlockValue = $coreSettings->getSetting('sitehomepagevideo.lending.block', null);
        if (empty($sitehomepagevideoLendingBlockValue) || is_array($sitehomepagevideoLendingBlockValue)) {
            $sitehomepagevideoLendingBlockValue = '<div style="width:1200px;margin:0 auto;display:table;">
            <span style="font-size:48px;color:#292929;float:left;width:100%;text-align:center;margin:80px 0 0 0;position:absolute;top:0;left:0;right:0;">How It Works !</span>
			   <div style="transition: opacity 0.8s ease, top 800ms ease;float: left; margin: 150px 0; opacity: 1; padding: 56px 0; text-align: center; width: 33.3%;">
                    <a href="events/">
					  <span style="background-position: center 50%; background-repeat: no-repeat; margin: 0 auto; width: 200px; height: 200px; background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/create-event.png);"></span>
                        <span style="color: #fff; float: left; font-family: sans-serif; font-size: 27px; margin-top: 20px; text-align: center; width: 100%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Create Events</span>
                        <span style="color: #fff; display:inline-block; font-family: sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Create your event, define the tickets and ready for action!</span>
                    </a>
				</div>
			 <div style="transition: opacity 0.8s ease, top 800ms ease;float: left; margin: 150px 0; opacity: 1; padding: 56px 0; text-align: center; width: 33.3%;">
               <a href="events/">
				  <span style="background-position: center 50%; background-repeat: no-repeat; margin: 0 auto; width: 200px; height: 200px; background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/sell-tickets.png);"></span>
                        <span style="color: #fff; float: left; font-family: sans-serif; font-size: 27px; margin-top: 20px; text-align: center; width: 100%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Sell Tickets</span>
                        <span style="color: #fff; display:inline-block; font-family: sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Sell your event tickets Online.</span>
				 </a>
			</div>
            <div style="transition: opacity 0.8s ease, top 800ms ease;float: left; margin: 150px 0; opacity: 1; padding: 56px 0; text-align: center; width: 33.3%;">
              <a href="events/">
				 <span style="background-position: center 50%; background-repeat: no-repeat; margin: 0 auto; width: 200px; height: 200px; background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/invitepeople.png);"></span>
                        <span style="color: #fff; float: left; font-family: sans-serif; font-size: 27px; margin-top: 20px; text-align: center; width: 100%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Share Events</span>
                        <span style="color: #fff; display:inline-block; font-family: sans-serif; font-size: 15px; margin-top: 10px; padding: 0 11%; text-align: center; width: 71%; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4);">Promote and Invite people to your events.</span>
			  </a>
			</div>
           <a href="#" style="text-indent:100px;height:20px;width:20px;position:absolute;top:12px;background-image:url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/close-icon.png);">Close</a>
            </div>';
        } else {
            $sitehomepagevideoLendingBlockValue = @base64_decode($sitehomepagevideoLendingBlockValue);
        }


        $sitehomepagevideoLendingBlockTaglineValue = $coreSettings->getSetting('sitehomepagevideo.lending.block', null);
        if (empty($sitehomepagevideoLendingBlockTaglineValue) || is_array($sitehomepagevideoLendingBlockTaglineValue)) {

            $sitehomepagevideoLendingBlockTaglineValue = '<ul>      
					  <li style="background-position: left center; background-repeat: no-repeat; color: #ffffff; font-size: 19px; line-height: 68px; padding: 0 0 0 56px; text-transform: capitalize; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/tag1.png);">Create a free account</li><li style="background-position: left center; background-repeat: no-repeat; color: #ffffff; font-size: 19px; line-height: 68px; padding: 0 0 0 56px; text-transform: capitalize; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/tag2.png);">Connect and share with the people</li><li style="background-position: left center; background-repeat: no-repeat; color: #ffffff; font-size: 19px; line-height: 68px; padding: 0 0 0 56px; text-transform: capitalize; text-shadow: 0 0 3px rgba(0, 0, 0, 0.4); background-image: url(' . $baseURL . '/application/modules/Sitehomepagevideo/externals/images/tag3.png);">Join your interest based groups</li></ul>';
        } else {
            $sitehomepagevideoLendingBlockTaglineValue = @base64_decode($sitehomepagevideoLendingBlockTaglineValue);
        }

        //WORK FOR MULTILANGUAGES START
        $localeMultiOptions = Engine_Api::_()->sitehomepagevideo()->getLanguageArray();
        $defaultLanguage = $coreSettings->getSetting('core.locale.locale', 'en');
        $total_allowed_languages = Count($localeMultiOptions);
        if (!empty($localeMultiOptions)) {
            foreach ($localeMultiOptions as $key => $label) {
                $lang_name = $label;
                if (isset($localeMultiOptions[$label])) {
                    $lang_name = $localeMultiOptions[$label];
                }

                if (!strstr($key, '_')) {
                    $key = $key . '_default';
                }
                $page_block_field = "sitehomepagevideo_lending_page_block_$key";
                $page_block_title_field = "sitehomepagevideo_lending_page_block_title_$key";
                $keyForSettings = str_replace('_', '.', $key);
                $sitehomepagevideoLendingBlockValueMulti = $coreSettings->getSetting('sitehomepagevideo.lending.block.languages.' . $keyForSettings, null);
                if (empty($sitehomepagevideoLendingBlockValueMulti)) {
                    $sitehomepagevideoLendingBlockValueMulti = $sitehomepagevideoLendingBlockValue;
                } else {
                    $sitehomepagevideoLendingBlockValueMulti = @base64_decode($sitehomepagevideoLendingBlockValueMulti);
                }

                $sitehomepagevideoLendingBlockTitleValueMulti = $coreSettings->getSetting('sitehomepagevideo.lending.block.title.languages.' . $keyForSettings);

                if (empty($sitehomepagevideoLendingBlockTitleValueMulti)) {
                    $sitehomepagevideoLendingBlockTitleValueMulti = 'Get Started';
                } else {
                    $sitehomepagevideoLendingBlockTitleValueMulti = @base64_decode($sitehomepagevideoLendingBlockTitleValueMulti);
                }
                $page_block_label = sprintf(Zend_Registry::get('Zend_Translate')->_("Action Button's Slide Down Content in %s"), $lang_name);
                $page_block_title_label = sprintf(Zend_Registry::get('Zend_Translate')->_("Get Started Action Button's Slide Down Content in %s"), $lang_name);

                if ($total_allowed_languages <= 1) {
                    $page_block_field = "sitehomepagevideo_lending_page_block";
                    $page_block_title_field = "sitehomepagevideo_lending_page_block_title";
                    $page_block_label = "Action Button's Slide Down Content";
                    $page_block_title_label = "Action Button Title";
                } elseif ($label == 'en' && $total_allowed_languages > 1) {
                    $page_block_field = "sitehomepagevideo_lending_page_block";
                    $page_block_title_field = "sitehomepagevideo_lending_page_block_title";
                }

                $this->addElement('Text', $page_block_title_field, array(
                    'label' => $page_block_title_label,
                    'description' => "Choose a title for the action button, like 'Get Started', etc, that is currently getting displayed on the videos & photos rotator on the landing page. Clicking on this will attractively slide down related content that you can configure below. [This can be used to show useful information regarding your website like 'How it Works', 'Get Going', 'Tours', 'Contact Us', etc.] (Note: For this button to be displayed, it must be enabled in the settings of the widget: 'Home Page Background Videos & Photos - Landing Page Videos & Photos'.)",
                    'value' => $sitehomepagevideoLendingBlockTitleValueMulti,
                    'filters' => array(
                        new Engine_Filter_Html(),
                        new Engine_Filter_Censor()),
                ));

                $editorOptions = Engine_Api::_()->seaocore()->tinymceEditorOptions();
                $editorOptions['height'] = '500px';

                $this->addElement('TinyMce', $page_block_field, array(
                    'label' => $page_block_label,
                    'description' => "Configure the content that gets shown in an attractive slide-down manner, when someone clicks on the Action Button. In this content, you can include important links of your website, or a quick overview of your website to enable users to get started.",
                    'attribs' => array('rows' => 24, 'cols' => 80, 'style' => 'width:200px; max-width:200px; height:240px;'),
                    'value' => $sitehomepagevideoLendingBlockValueMulti,
                    'filters' => array(
                        new Engine_Filter_Html(),
                        new Engine_Filter_Censor()),
                    'editorOptions' => $editorOptions,
                ));
                $page_block_field = "sitehomepagevideo_lending_page_block_tagline_$key";
                $page_block_label = sprintf(Zend_Registry::get('Zend_Translate')->_("Tagline & Icons in %s"), $lang_name);
                if ($total_allowed_languages <= 1) {
                    $page_block_field = "sitehomepagevideo_lending_page_block_tagline";

                    $page_block_label = "Sign In and Sign Up Form Icons and Taglines";
                } elseif ($label == 'en' && $total_allowed_languages > 1) {
                    $page_block_field = "sitehomepagevideo_lending_page_block_tagline";
                }
                $sitehomepagevideoLendingBlockTaglineValueMulti = $coreSettings->getSetting('sitehomepagevideo.lending.block.tagline.languages.' . $keyForSettings, null);
                if (empty($sitehomepagevideoLendingBlockTaglineValueMulti)) {
                    $sitehomepagevideoLendingBlockTaglineValueMulti = $sitehomepagevideoLendingBlockTaglineValue;
                } else {
                    $sitehomepagevideoLendingBlockTaglineValueMulti = @base64_decode($sitehomepagevideoLendingBlockTaglineValueMulti);
                }

                $this->addElement('TinyMce', $page_block_field, array(
                    'label' => $page_block_label,
                    'description' => "Configure the taglines and icons that gets displayed with Sign In and Sign Up form on the videos & photos rotator on landing page. [You can enable / disable this from 'Home Page Videos & Photos' widget settings]",
                    'attribs' => array('rows' => 24, 'cols' => 80, 'style' => 'width:200px; max-width:200px; height:240px;'),
                    'value' => $sitehomepagevideoLendingBlockTaglineValueMulti,
                    'filters' => array(
                        new Engine_Filter_Html(),
                        new Engine_Filter_Censor()),
                    'editorOptions' => $editorOptions,
                ));
            }
        }
        //WORK FOR MULTILANGUAGES END
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
