<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Videos_Upload extends Engine_Form {

    public function init() {

        $slideshow_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('slideshow_id', null);
        // Init form
        $this
                ->setTitle('Add New Video')
                ->setAttrib('id', 'form-upload')
                ->setAttrib('name', 'video_create')
                ->setAttrib('enctype', 'multipart/form-data')
                ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

        // Init name
        $this->addElement('Text', 'title', array(
            'label' => 'Video Title',
            'maxlength' => '100',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array(
                //new Engine_Filter_HtmlSpecialChars(),
                'StripTags',
                new Engine_Filter_Censor(),
                new Engine_Filter_StringLength(array('max' => '100')),
            )
        ));

        // Init video
        $this->addElement('Select', 'type', array(
            'label' => 'Video Source',
            'multiOptions' => array('0' => ' '),
            'onchange' => "updateTextFields()",
        ));

        //YouTube, Vimeo
        $video_options = Array();
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        //My Computer
        $ffmpeg_path = $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', ''));
        if (!empty($ffmpeg_path)) {
            if (Engine_Api::_()->hasModuleBootstrap('mobi') && Engine_Api::_()->mobi()->isMobile()) {
                $video_options[] = "My Device";
            } else {
                $video_options[] = "My Computer";
            }
        }

        $this->type->addMultiOptions($video_options);

        $this->addElement('File', 'Filedata', array(
            'label' => 'Upload a Video:',
            'accept' => "video/*",
            'onchange' => "showSaveButton();"
        ));


        $this->addElement('hidden', 'video_id', array('value' => '', 'order' => 998));
        $this->addElement('hidden', 'slideshow_id', array('value' => $slideshow_id, 'order' => 999));
        // Init submit
        $this->addElement('Button', 'upload', array(
            'label' => 'Save Video',
            'type' => 'submit',
        ));
    }

}
