<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Video.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Videos_Video extends Engine_Form {

    public function init() {

        $this->loadDefaultDecorators();

        $this->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("Please upload the converted video files like: video thumbnail image, .mp4 video file and .webm video file (You can get these files once you will extract the downloaded .tar file on your system). Here, you can also upload any other video's files in case you have thumbnail image, .mp4 file and .webm format file of that video. Max Video file size allowed: <strong style='font-weight:bold'>" . (int) ini_get("upload_max_filesize") . "MB</strong>")))->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'upload-manually')))->getDecorator('Description')->setOption('escape', false);

        // Init name
        $this->addElement('Text', 'title', array(
            'label' => 'Video Title',
            'maxlength' => '100',
            'allowEmpty' => false,
            'required' => true,
            'filters' => array(
                //new Engine_Filter_HtmlSpecialChars(),
                'StripTags',
                new Engine_Filter_Censor(),
                new Engine_Filter_StringLength(array('max' => '100')),
            )
        ));

        $this->addElement('File', 'photo', array(
            'label' => 'Upload Video Thumbnail Image',
            'required' => true,
            'allowEmpty' => false,
        ));
        $this->photo->addValidator('Extension', false, 'jpg,jpeg,png,gif');

        $this->addElement('File', 'videomp4', array(
            'label' => 'Upload .mp4 Video File',
            'required' => true,
            'allowEmpty' => false,
        ));
        $this->videomp4->addValidator('Extension', false, 'mp4');

        $this->addElement('File', 'videowebm', array(
            'label' => 'Upload .webm Video File',
            'required' => true,
            'allowEmpty' => false,
        ));
        $this->videowebm->addValidator('Extension', false, 'webm');

        // Init submit
        $this->addElement('Button', 'upload', array(
            'label' => 'Save Video',
            'type' => 'submit',
        ));
    }

}
