<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WidgetHeaderContent.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Form_Admin_Widget_WithoutHeaderContent extends Engine_Form {

    public function init() {

        $this
                ->setAttrib('id', 'form-upload');

        $this->addElement('Radio', 'columnHeightWidth', array(
            'label' => "Do you want to play videos slideshow in full height and width? [This setting only works for videos slideshows, and if this setting is enabled, all the other widgets placed on this page will not be rendered, so it is recommended that please remove those widgets. Also, below settings like: 'Do you want to play videos & photos slideshows according to screen's height ?' and  ‘Enter the height of Landing Page Videos & Photos' will not be applicable.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0
        ));

        $this->addElement('Radio', 'videoScreenHeight', array(
            'label' => "Do you want to play videos & photos slideshows according to screen's height ? [This setting only works for either videos slideshows or photos slideshows type (will not work for both videos & photos slideshows type), and and if this setting is enabled, below setting ‘Enter the height of Landing Page Videos & Photos' will not be applicable.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0
        ));

        $this->addElement('Radio', 'showStartViewing', array(
            'label' => "Do you want to enable 'Start Exploring' button on videos? [This setting is only applicable if you have enabled 'Do you want to play videos slideshows according to screen's height ?' setting.]",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1
        ));

        $this->addElement('Text', 'columnHeight', array(
            'label' => "Enter the height for Landing Page Videos & Photos.",
            'value' => '600'
        ));

        $this->addElement('Text', 'columnWidth', array(
            'label' => 'Enter width for the Landing Page Videos & Photos. (If left blank banners will have 100% width)',
            'value' => '',
        ));

        $listSlides = Engine_Api::_()->getItemTable('sitehomepagevideo_slideshow')->getSlides(array('enabled' => 1));
        $listArray = array();
        foreach ($listSlides->toArray() as $listSlide) {
            $listArray[$listSlide['slideshow_id']] = $listSlide['title'];
        }

        $this->addElement('Radio', 'selectedSlides', array(
            'multiOptions' => $listArray,
            'label' => 'Select the slideshow that you want to play on this page. [you can upload new videos & photos and manage existing ones from the "Manage Background Slideshows" tab available in admin of Home Page Background Videos & Photos Plugin.]',
            'value' => 1,
        ));

        $this->addElement('Radio', 'showNextLink', array(
            'label' => "Do you want to show Next and Previous button, in case you have uploaded more than one videos & photos?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
        ));


        $this->addElement('Text', 'sitehomepagevideoHtmlTitle', array(
            'label' => 'Enter the title that you want to display, layered above the background videos and photos.',
            'value' => 'BRING PEOPLE TOGETHER',
            'style' => 'width:350px;',
        ));

        $this->addElement('Text', 'sitehomepagevideoHtmlDescription', array(
            'label' => 'Enter the description that you want to display, layered above the background videos and photos.',
            'value' => 'Create an event. Sell tickets online.',
            'style' => 'width:350px;',
        ));

        $this->addElement('Radio', 'sitehomepagevideoTitleColor', array(
            'label' => 'Select the color for the last word of above entered title that displayed above the background videos & photos slideshows.',
            'multiOptions' => array(
                1 => 'White Color',
                0 => 'Theme Color'
            ),
            'value' => 1
        ));

        $this->addElement('Radio', 'playVideoSound', array(
            'label' => "Do you want to enable sound in videos?",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 0,
        ));

        $this->addElement('hidden', 'nomobile', array(
             'order' => 901,
            'label' => ''
        ));
    }

}
