<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminImageController.php 2011-10-22 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_AdminImageController extends Core_Controller_Action_Admin {

    public function init() {
        //GET SLIDESHOW ID
        $slideshow_id = (int) $this->_getParam('slideshow_id');

        if (!Engine_Api::_()->core()->hasSubject()) {
            if (0 !== ($slideshow_id) && null !== ($slideshow = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $slideshow_id))) {
                Engine_Api::_()->core()->setSubject($slideshow);
            }
        }
    }

    public function simpleUploadAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');

        //GET SLIDESHOW ID
        $this->view->slideshow_id = $slideshow_id = $this->_getParam('slideshow_id');

        //CREATE FORM
        $this->view->form = $form = new Sitehomepagevideo_Form_Admin_Image_Simpleupload();

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        if ($this->getRequest()->isPost()) {

            for ($i = 1; $i <= 10; $i++) {
                $elementName = "photo_$i";

                //UPLOAD PHOTO
                if (isset($_FILES[$elementName]) && is_uploaded_file($_FILES[$elementName]['tmp_name'])) {
                    $params = array(
                        'slideshow_id' => $slideshow_id,
                        'user_id' => 1,
                    );

                    //CREATE IMAGE
                    Engine_Api::_()->sitehomepagevideo()->createImage($params, $_FILES[$elementName]);
                }
            }
        }

        //REDIRECT
        $this->_redirect("admin/sitehomepagevideo/video/manage/slideshow_id/" . $slideshow_id);
    }

    //ACTION FOR UPLOAD SLIDE
    public function uploadAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');

        //GET SLIDESHOW SUBJECT AND SLIDESHOW ID
        $slideshow = Engine_Api::_()->core()->getSubject();
        $this->view->slideshow_id = $slideshow_id = $slideshow->slideshow_id;
        $settings = Engine_Api::_()->getApi('settings', 'core');

        $this->view->form = $form = new Sitehomepagevideo_Form_Admin_Image_Upload();
        $form->Filedata->setAttrib('data', array('slideshow_id' => $slideshow_id));

        if ((!$this->getRequest()->isPost())) {
            return;
        }

        if ((!$form->isValid($this->getRequest()->getPost()))) {
            return;
        }

        //GET SLIDESHOW ID

        //GET VIEWER INFORMATION
        if (!$this->_helper->requireUser()->checkRequire()) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
            return $form->addError($this->view->error);
        }

        $db = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo')->getAdapter();
        $db->beginTransaction();

        try {
            $params = array(
                'slideshow_id' => $slideshow_id,
                'user_id' => 1,
            );

            $this->view->status = true;
            $image_id = Engine_Api::_()->sitehomepagevideo()->createImage($params, $_FILES['Filedata'])->photo_id;

            $this->view->name = $_FILES['Filedata']['name'];
            $this->view->image_id = $image_id;
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_($e->getMessage());
            return $form->addError($this->view->error);
        }

        //REDIRECT
        if($this->view->status){
            $this->_redirect("admin/sitehomepagevideo/video/manage/slideshow_id/" . $slideshow_id);
        }
    }


    public function editImageAction() {
        $video_id = $this->_getParam('video_id');
        $video = Engine_Api::_()->getItem('sitehomepagevideo_video', $video_id);
        $this->_helper->layout->setLayout('default-simple');
        $form = $this->view->form = new Sitehomepagevideo_Form_Admin_Image_Edit();
        $title = $video->title;
        $form->title->setValue($title);
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

            $video->title = $_POST['title'];
            $video->save();
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Your changes have been saved successfully.'))
            ));
        }
    }

    //ACTION FOR DELETE SLIDESHOW
    public function removeAction() {
        //LAYOUT
        $this->_helper->layout->setLayout('admin-simple');
        //GET SLIDESHOW ID
        $slideshow_id = (int) $this->_getParam('slideshow_id');

        //GET SLIDESHOW ID
        $this->view->image_id = $image_id = $this->_getParam('image_id');

        if ($this->getRequest()->isPost()) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                $table = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');

                $result = $table->select()->from($table->info('name'), 'video_id')->where('slideshow_id =?', $slideshow_id)->where('photo_id =?', $image_id)->query()->fetchAll(Zend_Db::FETCH_COLUMN);

                foreach ($result as $r) {
                    Engine_Api::_()->getItem('sitehomepagevideo_video', $r)->delete();
                }

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }
    }

}

?>