<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_AdminSettingsController extends Core_Controller_Action_Admin {

    public function __call($method, $params) {
        if (!empty($method) && $method == 'Sitehomepagevideo_Form_Admin_Videos_Settings') {
            
        }
        return true;
    }

    public function indexAction() {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        // Check ffmpeg path for correctness
        if (function_exists('exec')) {
            $ffmpeg_path = $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', ''));

            $output = null;
            $return = null;
            if (!empty($ffmpeg_path)) {
                exec($ffmpeg_path . ' -version', $output, $return);
            }
            // Try to auto-guess ffmpeg path if it is not set correctly
            $ffmpeg_path_original = $ffmpeg_path;
            if (empty($ffmpeg_path) || $return > 0 || stripos(join('', $output), 'ffmpeg') === false) {
                $ffmpeg_path = null;
                // Windows
                if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
                    // @todo
                }
                // Not windows
                else {
                    $output = null;
                    $return = null;
                    @exec('which ffmpeg', $output, $return);
                    if (0 == $return) {
                        $ffmpeg_path = array_shift($output);
                        $output = null;
                        $return = null;
                        exec($ffmpeg_path . ' -version 2>&1', $output, $return);
                        if ($output == null) {
                            $ffmpeg_path = null;
                        }
                    }
                }
            }
            if ($ffmpeg_path && $ffmpeg_path != $ffmpeg_path_original) {
                $coreSettings->sitehomepagevideo_ffmpeg_path = $ffmpeg_path;
            }
        }

        $this->view->position = true;
        if ($ffmpeg_path) {
            $this->view->position = strpos(@shell_exec("$ffmpeg_path -version 2>&1"), '--enable-libvpx');
        }

        $tempLanguageDataArray = array();
        $tempLanguageTitleDataArray = array();

        $tempTaglineLanguageDataArray = array();
        if ($this->getRequest()->isPost()) {
            $localeMultiOptions = Engine_Api::_()->sitehomepagevideo()->getLanguageArray();
            $defaultLanguage = $coreSettings->getSetting('core.locale.locale', 'en');
            $total_allowed_languages = Count($localeMultiOptions);

            if (!empty($localeMultiOptions)) {
                foreach ($localeMultiOptions as $key => $label) {
                    $lang_name = $label;
                    if (isset($localeMultiOptions[$label])) {
                        $lang_name = $localeMultiOptions[$label];
                    }

                    if (!strstr($key, '_')) {
                        $key = $key . '_default';
                    }
                    $page_block_field = "sitehomepagevideo_lending_page_block_$key";
                    $page_block_title_field = "sitehomepagevideo_lending_page_block_title_$key";
                    if ($total_allowed_languages <= 1) {
                        $page_block_field = "sitehomepagevideo_lending_page_block";
                        $page_block_title_field = "sitehomepagevideo_lending_page_block_title";
                        $page_block_label = "Description";
                        $page_block_title_label = "Title";
                    } elseif ($label == 'en' && $total_allowed_languages > 1) {
                        $page_block_field = "sitehomepagevideo_lending_page_block";
                        $page_block_title_field = "sitehomepagevideo_lending_page_block_title";
                    }


                    $tempLanguageDataArray[$key] = @base64_encode($_POST[$page_block_field]);
                    $tempLanguageTitleDataArray[$key] = @base64_encode($_POST[$page_block_title_field]);


                    $page_block_tagline_field = "sitehomepagevideo_lending_page_block_tagline_$key";
                    if ($total_allowed_languages <= 1) {
                        $page_block_tagline_field = "sitehomepagevideo_lending_page_block_tagline";
                    } elseif ($label == 'en' && $total_allowed_languages > 1) {
                        $page_block_tagline_field = "sitehomepagevideo_lending_page_block_tagline";
                    }

                    if (!strstr($key, '_')) {
                        $key = $key . '_default';
                    }

                    $tempTaglineLanguageDataArray[$key] = @base64_encode($_POST[$page_block_tagline_field]);
                }

                $coreSettings->setSetting('sitehomepagevideo.lending.block.languages', $tempLanguageDataArray);
                $coreSettings->setSetting('sitehomepagevideo.lending.block.title.languages', $tempLanguageTitleDataArray);
                $coreSettings->setSetting('sitehomepagevideo.lending.block.tagline.languages', $tempTaglineLanguageDataArray);
            }
        }

        include APPLICATION_PATH . '/application/modules/Sitehomepagevideo/controllers/license/license1.php';
        if (isset($_POST) && !empty($_POST)) {
            //$form->addNotice('Your changes have been saved.');
            $this->_helper->redirector->gotoRoute(array('route' => 'admin-default'));
        }
    }

    public function faqAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_settings_faq');
        $this->view->faq_id = $faq_id = $this->_getParam('faq', 'faq_1');
    }

    public function readmeAction() {
        
    }

    public function encodeAndDefaultAction() {
        $tableNameVideos = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');
        $tableNameVideosName = $tableNameVideos->info('name');
        $videos = $tableNameVideos->select()
                ->from($tableNameVideosName, 'video_id')
                ->where('status =?', 0)
                ->orWhere('status =?', 2)
                ->query()
                ->fetchAll();
        foreach ($videos as $video) {
            Engine_Api::_()->sitehomepagevideo()->encodeVideo($video['video_id']);
        }

        $params = array(
            'owner_type' => 'user',
            'owner_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
        );

        $video_id = $tableNameVideos->select()
                ->from($tableNameVideosName, 'video_id')
                ->where('title in (?)', array('Landing Page Video'))
                ->limit(1)
                ->query()
                ->fetchColumn();

        if ($video_id) {
            Engine_Api::_()->getItem('sitehomepagevideo_video', $video_id)->delete();
        }

        $files = array('0' => array('duration' => 29, 'name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video.mp4', 'type' => 'application/octet-stream', 'tmp_name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video.mp4'));
        $filess = array('0' => array('name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video_Image.jpg', 'type' => 'image/jpeg', 'tmp_name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video_Image.jpg'));
        $titlevalues = array('0' => array('title' => 'Landing Page Video'));
        $idsArray = array();
        foreach ($files as $key => $value) {
            $video = Engine_Api::_()->sitehomepagevideo()->createVideo($params, $value, array('title' => $titlevalues[$key]['title'], 'default' => 1, 'file_webm' => array('duration' => 29, 'name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video_Webm.webm', 'type' => 'application/octet-stream', 'tmp_name' => 'application/modules/Sitehomepagevideo/externals/videos/Landing_Page_Video_Webm.webm')));
            $filess[$key]['video_id'] = $video->getIdentity();
            $filess[$key]['duration'] = $value['duration'];
        }

        foreach ($filess as $key => $value) {
            $video = Engine_Api::_()->getItem('sitehomepagevideo_video', $value['video_id']);
            $storage = Engine_Api::_()->getItemTable('storage_file');
            $storageObject = $storage->createFile($value, array(
                'parent_id' => $video->getIdentity(),
                'parent_type' => $video->getType(),
                'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
            ));
            $video->photo_id = $storageObject->file_id;
            $video->enabled = 1;
            $video->type = 3;
            $video->status = 1;
            $video->order = $video->getIdentity();
            $video->duration = $value['duration'];
            $video->slideshow_id = 1;
            $video->save();
        }

        $this->_redirect('install/manage');
    }

    public function encodeVideosAction() {
        $tableNameVideos = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');
        $tableNameVideosName = $tableNameVideos->info('name');
        $videos = $tableNameVideos->select()
                ->from($tableNameVideosName, 'video_id')
                ->where('status =?', 0)
                ->orWhere('status =?', 2)
                ->query()
                ->fetchAll();
        foreach ($videos as $video) {
            Engine_Api::_()->sitehomepagevideo()->encodeVideo($video['video_id']);
        }
    }

}
