<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSlideshowsController.php 2011-10-22 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_AdminSlideshowsController extends Core_Controller_Action_Admin {

    //ACTION FOR MANAGE SLIDESHOWS
    public function manageAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');

        //GET PAGE COUNT
        $page = $this->_getParam('page', 1);

        $tableSlideshow = Engine_Api::_()->getDbTable('slideshows', 'sitehomepagevideo');
        $tableSlideshowName = $tableSlideshow->info('name');

        $select = $tableSlideshow->select()
                ->from($tableSlideshowName);

        $values = array_merge(array(
            'order' => 'slideshow_id',
            'order_direction' => 'DESC',
        ));

        $this->view->assign($values);

        $select->order((!empty($values['order']) ? $values['order'] : 'slideshow_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

        //GET PAGINATOR
        $this->view->paginator = $paginator = Zend_Paginator::factory($select);
        $this->view->paginator->setItemCountPerPage(50);
        $this->view->paginator = $paginator->setCurrentPageNumber($page);
    }

    public function createAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');

        //FORM GENERATION
        $this->view->form = $form = new Sitehomepagevideo_Form_Admin_Slideshows_Create();
        //CHECK POST FORM
        if ((!$this->getRequest()->isPost())) {
            return;
        }
        if ((!$form->isValid($this->getRequest()->getPost()))) {
            return;
        }

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            $table = Engine_Api::_()->getDbtable('slideshows', 'sitehomepagevideo');
            $db = $table->getAdapter();
            $db->beginTransaction();

            try {
                $viewer = Engine_Api::_()->user()->getViewer();
                $row = $table->createRow();
                $params = array_merge(array(
                    'owner_type' => 'user',
                    'owner_id' => $viewer->getIdentity()
                        ), $values);
                $row->setFromArray($params);
                $row->save();

                $db->commit();

                $this->_redirect('admin/sitehomepagevideo/slideshows/manage');
            } catch (Exception $e) {
                $db->rollBack();
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.') . $e;
                return;
            }
        }
    }

    public function editAction() {
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');
        $slideshow_id = $this->_getParam('slideshow_id');
        $slideshow = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $slideshow_id);
        //FORM GENERATION
        $this->view->form = $form = new Sitehomepagevideo_Form_Admin_Slideshows_Edit();
        $form->populate($slideshow->toArray());
        //CHECK POST FORM
        if ((!$this->getRequest()->isPost())) {
            return;
        }
        if ((!$form->isValid($this->getRequest()->getPost()))) {
            return;
        }

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            $table = Engine_Api::_()->getDbtable('slideshows', 'sitehomepagevideo');
            $db = $table->getAdapter();
            $db->beginTransaction();

            try {
                $viewer = Engine_Api::_()->user()->getViewer();

                $params = array_merge(array(
                    'owner_type' => 'user',
                    'owner_id' => $viewer->getIdentity()
                        ), $values);
                $slideshow->setFromArray($params);
                $slideshow->save();

                $db->commit();

                $this->_redirect('admin/sitehomepagevideo/slideshows/manage');
            } catch (Exception $e) {
                $db->rollBack();
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.') . $e;
                return;
            }
        }
    }

    //ACTION FOR MAKE SLIDESHOW ENABLE/DIS-ABLE
    public function enabledAction() {
        //GET SLIDESHOW ID
        $slideshow_id = $this->_getParam('slideshow_id');
        $db = Engine_Db_Table::getDefaultAdapter();
        $db->beginTransaction();
        try {
            //GET SLIDESHOW OBJECT
            $slideshow = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $slideshow_id);
            if ($slideshow->enabled == 0) {
                $slideshow->enabled = 1;
            } else {
                $slideshow->enabled = 0;
            }
            $slideshow->save();
            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }
        $this->_redirect("admin/sitehomepagevideo/slideshows/manage");
    }

    //ACTION FOR DELETE SLIDESHOW
    public function deleteAction() {
        //LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET SLIDESHOW ID
        $this->view->slideshow_id = $slideshow_id = $this->_getParam('slideshow_id');

        if ($this->getRequest()->isPost()) {
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {
                $slideshow = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $slideshow_id);

                $table = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');

                $result = $table->select()->from($table->info('name'), 'video_id')->where('slideshow_id =?', $slideshow_id)->query()->fetchAll(Zend_Db::FETCH_COLUMN);

                foreach ($result as $r) {
                    Engine_Api::_()->getItem('sitehomepagevideo_video', $r)->delete();
                }

                $slideshow->delete();
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array('')
            ));
        }
        $this->renderScript('admin-slideshows/delete.tpl');
    }

    //ACTION FOR DELETE SLIDESHOW AND THEIR BELONGINGS
    public function multiDeleteAction() {
        if ($this->getRequest()->isPost()) {
            $values = $this->getRequest()->getPost();
            $table = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');

            //IF ADMIN CLICK ON DELETE SELECTED BUTTON
            if (!empty($values['delete'])) {
                foreach ($values as $key => $value) {
                    if ($key == 'delete_' . $value) {
                        $slideshow_id = (int) $value;

                        $result = $table->select()->from($table->info('name'), 'video_id')->where('slideshow_id =?', $slideshow_id)->query()->fetchAll(Zend_Db::FETCH_COLUMN);

                        foreach ($result as $r) {
                            Engine_Api::_()->getItem('sitehomepagevideo_video', $r)->delete();
                        }
                        $slideshow = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $slideshow_id);
                        $slideshow->delete();
                    }
                }
            }
        }
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage'));
    }

}
