<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminVideoController.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_AdminVideoController extends Core_Controller_Action_Admin {

    public function manageAction() {

        $slideshow_id = $this->view->slideshow_id = $this->_getParam('slideshow_id');
        $this->view->obj = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $this->view->slideshow_id);
        //GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $ffmpeg_path = $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', ''));
        $this->view->position = true;
        if ($ffmpeg_path) {
            $this->view->position = strpos(@shell_exec("$ffmpeg_path -version 2>&1"), '--enable-libvpx');
        }

        include APPLICATION_PATH . '/application/modules/Sitehomepagevideo/controllers/license/license2.php';

        $tableNameVideos = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo');
        $tableNameVideosName = $tableNameVideos->info('name');

        //GET VIDEO IDS OF STATUS 0 OR 2
        $this->view->video_id = $tableNameVideos->select()
                ->from($tableNameVideosName, 'video_id')
                ->where('status =?', 0)
                ->orWhere('status =?', 2)
                ->limit(1)
                ->query()
                ->fetchColumn();

        //NOT ENABLED VIDEOS COUNT
        $this->view->notEnabledVideosCount = $tableNameVideos->select()
                ->from($tableNameVideosName, 'count(*) as count')
                ->where('slideshow_id =?', $slideshow_id)
                ->where('enabled =?', 0)
                ->where('status =?', 1)
                ->limit(1)
                ->query()
                ->fetchColumn();
    }

    public function uploadAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');
        $this->view->slideshow_id = $this->_getParam('slideshow_id');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $ffmpeg_path = $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', ''));
        $this->view->position = true;
        if ($ffmpeg_path) {
            $this->view->position = strpos(@shell_exec("$ffmpeg_path -version 2>&1"), '--enable-libvpx');
        }

        // Upload video
        if (isset($_GET['ul']))
            return $this->_forward('upload-video', null, null, array('format' => 'json'));

        include APPLICATION_PATH . '/application/modules/Sitehomepagevideo/controllers/license/license2.php';

        $this->view->form = $form = new Sitehomepagevideo_Form_Admin_Videos_Upload();

        if (!$this->getRequest()->isPost()) {
            return;
        }
        $values = $this->getRequest()->getPost();
        $obj = Engine_Api::_()->getItem('sitehomepagevideo_video', $values['video_id']);

        $title = Engine_Api::_()->getItemTable('sitehomepagevideo_video')->getTitleMatch($values['title']);

        if ($title) {
            $values['title'] = $values['title'] . '-' . $values['video_id'];
        }

        if ($obj) {
            $obj->slideshow_id = $values['slideshow_id'];
            $obj->title = $values['title'];
            $obj->save();
        }


        $this->_redirect('admin/sitehomepagevideo/video/manage/slideshow_id/' . $values['slideshow_id']);
    }

    public function uploadTarAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');
        $this->view->slideshow_id = $this->_getParam('slideshow_id');
        $form = $this->view->form = new Sitehomepagevideo_Form_Admin_Videos_Video();
        $uploadtarform = $this->view->uploadtarform = new Sitehomepagevideo_Form_Admin_Videos_Uploadtar();
        $this->view->slideshow_id = $this->_getParam('slideshow_id');
        if ($this->getRequest()->isPost() && $uploadtarform->isValid($this->getRequest()->getPost())) {
            $values = $this->getRequest()->getPost();

            if (empty($_FILES['videotar'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
                return;
            }

            if (!isset($_FILES['videotar']) || !is_uploaded_file($_FILES['videotar']['tmp_name'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
                return;
            }

            $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
            if (in_array(pathinfo($_FILES['videotar']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
                return;
            }

            $tmpDir = $this->getTmpDir();
            @chmod($tmpDir, 0777);
            $name = $_FILES['videotar']['name'];
            @move_uploaded_file($_FILES['videotar']['tmp_name'], "$tmpDir/$name");
            try {
                $archive = new Archive_Tar("$tmpDir/$name");
                $rval = $archive->extract($tmpDir);
            } catch (Exception $ex) {
                
            }

            if ("$tmpDir/$name") {
                unlink("$tmpDir/$name");
            }

            $viewer = Engine_Api::_()->user()->getViewer();
            $values['owner_id'] = $viewer->getIdentity();

            $params = array(
                'owner_type' => 'user',
                'owner_id' => $viewer->getIdentity()
            );

            if ($handle = opendir($tmpDir)) {
                while (false !== ($entry = readdir($handle))) {
                    chmod("$tmpDir/$entry", 0777);
                    if ($entry != "." && $entry != "..") {
                        if (pathinfo($entry, PATHINFO_EXTENSION) == 'mp4') {
                            $files = array('0' => array('name' => $entry, 'type' => 'video/mp4', 'tmp_name' => "$tmpDir/$entry"));
                        } else if (pathinfo($entry, PATHINFO_EXTENSION) == 'webm') {
                            $webmfiles = array('name' => $entry, 'type' => 'video/webm', 'tmp_name' => "$tmpDir/$entry");
                        } else if (pathinfo($entry, PATHINFO_EXTENSION) == 'jpg') {
                            $filess = array('0' => array('name' => $entry, 'type' => 'image/jpeg', 'tmp_name' => "$tmpDir/$entry"));
                        }
                    }
                }
            }

            if (empty($files) || empty($webmfiles) || empty($filess)) {
                $uploadtarform->addError("Invalid Upload");
                return;
            }

            foreach ($files as $key => $value) {
                $video = Engine_Api::_()->sitehomepagevideo()->createVideo($params, $value, array('title' => $values['tartitle'], 'default' => 1, 'file_webm' => $webmfiles));
                $filess[$key]['video_id'] = $video->getIdentity();
            }
            foreach ($filess as $key => $value) {
                $video = Engine_Api::_()->getItem('sitehomepagevideo_video', $value['video_id']);
                $storage = Engine_Api::_()->getItemTable('storage_file');
                $storageObject = $storage->createFile($value, array(
                    'parent_id' => $video->getIdentity(),
                    'parent_type' => $video->getType(),
                    'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
                ));
                $video->photo_id = $storageObject->file_id;
                $video->enabled = 1;
                $video->type = 3;
                $video->status = 1;
                $video->order = $video->getIdentity();
                $video->slideshow_id = $this->view->slideshow_id;
                $video->save();
            }

            if ($handle = opendir($tmpDir)) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        unlink("$tmpDir/$entry");
                    }
                }
            }
            $this->_redirect('admin/sitehomepagevideo/video/manage/slideshow_id/' . $this->view->slideshow_id);
        }
    }

    public function uploadManuallyAction() {

        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_main_manage_slideshows');
        $this->view->slideshow_id = $this->_getParam('slideshow_id');
        $form = $this->view->form = new Sitehomepagevideo_Form_Admin_Videos_Video();
        $uploadtarform = $this->view->uploadtarform = new Sitehomepagevideo_Form_Admin_Videos_Uploadtar();

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {

            $values = $this->getRequest()->getPost();

            if (empty($_FILES['videomp4'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
                return;
            }

            if (!isset($_FILES['videomp4']) || !is_uploaded_file($_FILES['videomp4']['tmp_name'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
                return;
            }

            $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
            if (in_array(pathinfo($_FILES['videomp4']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
                return;
            }

            if (empty($_FILES['videowebm'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
                return;
            }

            if (!isset($_FILES['videowebm']) || !is_uploaded_file($_FILES['videowebm']['tmp_name'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
                return;
            }

            $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
            if (in_array(pathinfo($_FILES['videowebm']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
                return;
            }

            if (empty($_FILES['photo'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
                return;
            }

            if (!isset($_FILES['photo']) || !is_uploaded_file($_FILES['photo']['tmp_name'])) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
                return;
            }

            $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
            if (in_array(pathinfo($_FILES['photo']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                $this->view->status = false;
                $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
                return;
            }

            $viewer = Engine_Api::_()->user()->getViewer();
            $values['owner_id'] = $viewer->getIdentity();

            $params = array(
                'owner_type' => 'user',
                'owner_id' => $viewer->getIdentity()
            );
            $files = array('0' => array('name' => $_FILES['videomp4']['name'], 'type' => $_FILES['videomp4']['type'], 'tmp_name' => $_FILES['videomp4']['tmp_name']));
            $filess = array('0' => array('name' => $_FILES['photo']['name'], 'type' => $_FILES['photo']['type'], 'tmp_name' => $_FILES['photo']['tmp_name']));
            $titlevalues = array('0' => array('title' => $values['title']));
            $idsArray = array();
            foreach ($files as $key => $value) {
                $video = Engine_Api::_()->sitehomepagevideo()->createVideo($params, $value, array('title' => $values['title'], 'default' => 1, 'file_webm' => array('name' => $_FILES['videowebm']['name'], 'type' => $_FILES['videowebm']['type'], 'tmp_name' => $_FILES['videowebm']['tmp_name'])));
                $filess[$key]['video_id'] = $video->getIdentity();
            }

            foreach ($filess as $key => $value) {
                $video = Engine_Api::_()->getItem('sitehomepagevideo_video', $value['video_id']);
                $storage = Engine_Api::_()->getItemTable('storage_file');
                $storageObject = $storage->createFile($value, array(
                    'parent_id' => $video->getIdentity(),
                    'parent_type' => $video->getType(),
                    'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
                ));
                $video->photo_id = $storageObject->file_id;
                $video->enabled = 1;
                $video->type = 3;
                $video->status = 1;
                $video->order = $video->getIdentity();
                $video->slideshow_id = $this->view->slideshow_id;
                $video->save();
            }

            $this->_redirect('admin/sitehomepagevideo/video/manage/slideshow_id/' . $this->view->slideshow_id);
        }
    }

    public function uploadVideoAction() {

        if (!$this->_helper->requireUser()->checkRequire()) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
            return;
        }

        if (!$this->getRequest()->isPost()) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
            return;
        }

        $values = $this->getRequest()->getPost();

        if (empty($_FILES['Filedata'])) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('No file');
            return;
        }

        if (!isset($_FILES['Filedata']) || !is_uploaded_file($_FILES['Filedata']['tmp_name'])) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload') . print_r($_FILES, true);
            return;
        }

        $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
        if (in_array(pathinfo($_FILES['Filedata']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
            return;
        }

        $db = Engine_Api::_()->getDbtable('videos', 'sitehomepagevideo')->getAdapter();
        $db->beginTransaction();

        try {
            $viewer = Engine_Api::_()->user()->getViewer();
            $values['owner_id'] = $viewer->getIdentity();

            $params = array(
                'owner_type' => 'user',
                'owner_id' => $viewer->getIdentity()
            );
            $video = Engine_Api::_()->sitehomepagevideo()->createVideo($params, $_FILES['Filedata'], $values);

            $this->view->status = true;
            $this->view->name = $_FILES['Filedata']['name'];
            $this->view->code = $video->code;
            $this->view->video_id = $video->video_id;
            $this->view->slideshow_id = $this->_getParam('slideshow_id');
            // sets up title and owner_id now just incase members switch page as soon as upload is completed
            $video->title = $_FILES['Filedata']['name'];
            $video->enabled = 0;
            $video->slideshow_id = $this->view->slideshow_id;
            $video->save();

            $db->commit();
            return $video->video_id;
        } catch (Exception $e) {
            $db->rollBack();
            $this->view->status = false;
            $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.') . $e;
            return;
        }
    }

    //ACTION OF SETTING FOR CREATING VIDEO FROM MY COMPUTER
    public function utilityAction() {

        //GET NAGIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitehomepagevideo_admin_main', array(), 'sitehomepagevideo_admin_submain_utilities_tab');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->view->ffmpeg_path = $ffmpeg_path = $coreSettings->getSetting('sitehomepagevideo.video.ffmpeg.path', $coreSettings->getSetting('video.ffmpeg.path', ''));

        $command = "$ffmpeg_path -version 2>&1";
        $this->view->version = $version = @shell_exec($command);

        $command = "$ffmpeg_path -formats 2>&1";
        $this->view->format = $format = @shell_exec($command);
    }

    public function orderAction() {
        if (!empty($_POST)) {
            foreach ($_POST as $key => $value) {
                if (strstr($key, "content_")) {
                    $keyArray = explode("content_", $key);

                    if (!empty($keyArray))
                        $image_id = end($keyArray);

                    if (!empty($image_id)) {
                        $obj = Engine_Api::_()->getItem('sitehomepagevideo_video', $image_id);
                        $obj->order = $value;
                        $obj->save();
                    }
                }
            }
        }
    }

    public function deleteAction() {

        $this->_helper->layout->setLayout('admin-simple');

        $this->view->id = $id = $this->_getParam('id');
        $slideshow_id = $this->_getParam('slideshow_id');
        if ($this->getRequest()->isPost()) {
            $item = Engine_Api::_()->getItem('sitehomepagevideo_video', $id);

            $item->delete();
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array('Deleted Succesfully.')
            ));
        }
    }

    public function enabledAction() {
        $id = $this->_getParam('id');
        $slideshow_id = $this->_getParam('slideshow_id');
        if (!empty($id)) {
            $item = Engine_Api::_()->getItem('sitehomepagevideo_video', $id);
            $item->enabled = !$item->enabled;
            $item->save();
        }
        $this->_redirect('admin/sitehomepagevideo/video/manage/slideshow_id/' . $slideshow_id);
    }

    //ACTION FOR MULTI-DELETE OF PAGES
    public function multiDeleteAction() {
        $slideshow_id = $this->_getParam('slideshow_id');
        if ($this->getRequest()->isPost()) {

            $values = $this->getRequest()->getPost();

            foreach ($values as $key => $value) {

                if ($key == 'delete_' . $value) {

                    $item = Engine_Api::_()->getItem('sitehomepagevideo_video', $value);

                    $item->delete();
                }
            }
        }
        return $this->_helper->redirector->gotoRoute(array('action' => 'manage', 'slideshow_id' => $slideshow_id));
    }

    /**
     * Changes permissions on files and directories within $dir and dives recursively
     * into found subdirectories.
     */
    function chmod_r($dir, $dirPermissions, $filePermissions) {
        $dp = opendir($dir);
        while ($file = readdir($dp)) {
            if (($file == ".") || ($file == ".."))
                continue;

            $fullPath = $dir . "/" . $file;

            if (is_dir($fullPath)) {
                echo('DIR:' . $fullPath . "\n");
                chmod($fullPath, $dirPermissions);
                chmod_r($fullPath, $dirPermissions, $filePermissions);
            } else {
                echo('FILE:' . $fullPath . "\n");
                chmod($fullPath, $filePermissions);
            }
        }
        closedir($dp);
    }

    function destroy_dir($dir) {
        if (!is_dir($dir) || is_link($dir))
            return unlink($dir);
        foreach (scandir($dir) as $file) {
            if ($file == '.' || $file == '..')
                continue;
            if (!$this->destroy_dir($dir . DIRECTORY_SEPARATOR . $file)) {
                chmod($dir . DIRECTORY_SEPARATOR . $file, 0777);
                if (!$this->destroy_dir($dir . DIRECTORY_SEPARATOR . $file))
                    return false;
            };
        }
        return rmdir($dir);
    }

    private function getTmpDir() {
        set_time_limit(0);
        // Check the video temporary directory
        $tmpDir = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary' .
                DIRECTORY_SEPARATOR . 'ffmpegcoversion_video' . DIRECTORY_SEPARATOR . 'video';
        $this->destroy_dir($tmpDir);
        if (!is_dir($tmpDir) && !mkdir($tmpDir, 0777, true)) {
            throw new Sitehomepagevideo_Model_Exception('Video temporary directory did not exist and could not be created.');
        }

        if (!is_writable($tmpDir)) {
            throw new Sitehomepagevideo_Model_Exception('Video temporary directory is not writable.');
        }
        return $tmpDir;
    }

    public function editAction() {
        $video_id = $this->_getParam('video_id');
        $video = Engine_Api::_()->getItem('sitehomepagevideo_video', $video_id);
        $this->_helper->layout->setLayout('default-simple');
        $form = $this->view->form = new Sitehomepagevideo_Form_Admin_Videos_Editthumbnail();
        $title = $video->title;
        $form->title->setValue($title);
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            if ($_FILES['photo']['name']) {
                if ($video->photo_id) {
                    $item = Engine_Api::_()->getItem('storage_file', $video->photo_id);
                    $item->delete();
                }
                $filess = array('0' => array('name' => $_FILES['photo']['name'], 'type' => $_FILES['photo']['type'], 'tmp_name' => $_FILES['photo']['tmp_name']));
                foreach ($filess as $value) {
                    $storage = Engine_Api::_()->getItemTable('storage_file');
                    $storageObject = $storage->createFile($value, array(
                        'parent_id' => $video->getIdentity(),
                        'parent_type' => $video->getType(),
                        'user_id' => Engine_Api::_()->user()->getViewer()->getIdentity()
                    ));
                    $video->photo_id = $storageObject->file_id;
                }
            }
            if ($_POST['title'])
                $video->title = $_POST['title'];
            $video->save();
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRefresh' => 10,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_('Thumbnail has been updated successfully.'))
            ));
        }
    }

}
