<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitehomepagevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2015-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitehomepagevideo_Widget_VideosController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $this->getElement()->removeDecorator('Title');
        $this->view->showLogo = $this->_getParam('showLogo');
        $this->view->logo = $this->_getParam('logo');
        $this->view->sitehomepagevideoTitleColor = $this->_getParam('sitehomepagevideoTitleColor', 1);

        $this->view->isSitemenuExist = $isSitemenuExist = Engine_Api::_()->hasModuleBootstrap('sitemenu');
        $tempSitemenuLtype = $tempHostType = 3532;
        $this->view->sitehomepagevideoSignupLoginLink = $this->_getParam("sitehomepagevideoSignupLoginLink", 1);
        $this->view->sitehomepagevideoBrowseMenus = $this->_getParam("sitehomepagevideoBrowseMenus", 1);
        $this->view->sitehomepagevideoFirstImprotantLink = $this->_getParam("sitehomepagevideoFirstImprotantLink", 1);
        $this->view->sitehomepagevideoFirstTitle = $this->_getParam("sitehomepagevideoFirstTitle", 'Important Title & Link');
        $sitehomepagevideoGlobalType = $coreSettings->getSetting('sitehomepagevideo.global.type', 0);
        $hostType = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
        $sitehomepagevideoManageType = $coreSettings->getSetting('sitehomepagevideo.manage.type', 1);
        $this->view->sitehomepagevideoFirstUrl = $this->_getParam("sitehomepagevideoFirstUrl", '#');
        $this->view->sitehomepagevideoHtmlTitle = $this->_getParam("sitehomepagevideoHtmlTitle", 'BRING PEOPLE TOGETHER');
        $this->view->getVideoSrcPoint = false;
        $this->view->getDefaultVideoSrc = '';
        $this->view->sitehomepagevideoHtmlDescription = $this->_getParam("sitehomepagevideoHtmlDescription", 'Create an event. Sell tickets online.');
        $this->view->sitehomepagevideoSignupLoginButton = $this->_getParam("sitehomepagevideoSignupLoginButton", 0);
        $this->view->sitehomepagevideoSearchBox = $this->_getParam("sitehomepagevideoSearchBox", 4);

        $this->view->showTagLine = $this->_getParam("showTagLine", 1);
        $this->view->showLeftRightSignupButton = $this->_getParam("showLeftRightSignupButton", 0);
        $this->view->videoScreenHeight = $this->_getParam("videoScreenHeight", 1);
        $this->view->showLocationSearch = $this->_getParam('showLocationSearch', 0);
        $this->view->showLocationBasedContent = $this->_getParam('showLocationBasedContent', 0);
        $this->view->showNextLink = $this->_getParam('showNextLink', 1);
        $this->view->columnHeight = $this->_getParam('columnHeight', 600);
        $this->view->columnWidth = $this->_getParam('columnWidth', null);
        $this->view->showStartViewing = $this->_getParam('showStartViewing', 1);
        $this->view->showSignupFields = $showSignupFields = $this->_getParam('showSignupFields');
        $itemTable = Engine_Api::_()->getItemTable('sitehomepagevideo_video');


        if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode') && (Engine_API::_()->seaocore()->isMobile() || Engine_API::_()->seaocore()->isTabletDevice())) {
            $this->view->showStartViewing = 0;
            $this->view->sitehomepagevideoSearchBox = 0;
            $this->view->sitehomepagevideoSignupLoginButton = 1;
            $this->view->videoScreenHeight = 0;
        }

        $selectedSlides = $this->_getParam('selectedSlides');

        if (empty($selectedSlides)) {
            return $this->setNoRender();
        }

        $obj = Engine_Api::_()->getItem('sitehomepagevideo_slideshow', $selectedSlides);

        $this->view->slideshow_type = $obj->slideshow_type;

        $this->view->defaultDuration = $obj->delay;

        $this->view->list = $itemTable->getVideos(array('enabled' => 1, 'selectedSlides' => $selectedSlides));
        $sitehomepagevideoInfoType = $coreSettings->getSetting('sitehomepagevideo.info.type', 1);
        $sitehomepagevideoLtype = $coreSettings->getSetting('sitehomepagevideo.lsettings', 0);

        if (!count($this->view->list)) {
            return $this->setNoRender();
        }

        if (empty($sitehomepagevideoGlobalType)) {
            for ($check = 0; $check < strlen($hostType); $check++) {
                $tempHostType += @ord($hostType[$check]);
            }

            for ($check = 0; $check < strlen($sitehomepagevideoLtype); $check++) {
                $tempSitemenuLtype += @ord($sitehomepagevideoLtype[$check]);
            }
        }

        $this->view->max = $this->_getParam('max', 20);
        $this->view->sitehomepagevideoHowItWorks = $this->_getParam('sitehomepagevideoHowItWorks', 0);

        $islanguage = $this->view->translate()->getLocale();
        if (!strstr($islanguage, '_')) {
            $islanguage = $islanguage . '_default';
        }
        $keyForSettings = str_replace('_', '.', $islanguage);
        $sitehomepagevideoMainVideo = Zend_Registry::isRegistered('sitehomepagevideoMainVideo') ? Zend_Registry::get('sitehomepagevideoMainVideo') : null;
        $sitehomepagevideoLendingBlockValue = $coreSettings->getSetting('sitehomepagevideo.lending.block.languages.' . $keyForSettings, null);

        $sitehomepagevideoLendingBlockTitleValue = $coreSettings->getSetting('sitehomepagevideo.lending.block.title.languages.' . $keyForSettings, null);
        $sitehomepagevideoLendingBlockTaglineValue = $coreSettings->getSetting('sitehomepagevideo.lending.block.tagline.languages.' . $keyForSettings, null);
        if (empty($sitehomepagevideoLendingBlockValue)) {
            $sitehomepagevideoLendingBlockValue = $coreSettings->getSetting('sitehomepagevideo.lending.block', null);
        }
        if (empty($sitehomepagevideoLendingBlockTitleValue)) {
            $sitehomepagevideoLendingBlockTitleValue = $coreSettings->getSetting('sitehomepagevideo.lending.block.title', null);
        }

        if (empty($sitehomepagevideoLendingBlockTaglineValue)) {
            $sitehomepagevideoLendingBlockTaglineValue = $coreSettings->getSetting('sitehomepagevideo.lending.block.tagline.', null);
        }
        /*if (empty($sitehomepagevideoMainVideo)) {
            return $this->setNoRender();
        }*/

        if ((empty($sitehomepagevideoGlobalType)) && (($sitehomepagevideoManageType != $tempHostType) || ($sitehomepagevideoInfoType != $tempSitemenuLtype)))
            $this->view->getVideoSrcPoint = true;

        if (!empty($sitehomepagevideoLendingBlockValue))
            $this->view->sitehomepagevideoLendingBlockValue = @base64_decode($sitehomepagevideoLendingBlockValue);
        if (!empty($sitehomepagevideoLendingBlockTitleValue))
            $this->view->sitehomepagevideoLendingBlockTitleValue = @base64_decode($sitehomepagevideoLendingBlockTitleValue);
        if (!empty($sitehomepagevideoLendingBlockTaglineValue))
            $this->view->sitehomepagevideoLendingBlockTaglineValue = @base64_decode($sitehomepagevideoLendingBlockTaglineValue);

        $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = $request->getParams();
        $this->view->removePadding = false;
        $this->view->columnHeightWidth = $this->_getParam('columnHeightWidth', 0);
        if (!Zend_Registry::isRegistered('columnHeightWidth')) {
            Zend_Registry::set('columnHeightWidth', $this->view->columnHeightWidth);
        }
        
        if (!Zend_Registry::isRegistered('logo')) {
            Zend_Registry::set('logo', $this->view->logo);
        }

        //GET CONTENT ID
        $content_id = $this->view->identity;
        $content_page_id = Engine_Api::_()->sitehomepagevideo()->getContentPageId(array('content_id' => $content_id));
        $layoutValue = Engine_Api::_()->sitehomepagevideo()->getWidgetizedPageLayoutValue(array('page_id' => $content_page_id));
        if ($layoutValue == 'default-simple') {
            Zend_Layout::startMvc()->setViewBasePath(APPLICATION_PATH . "/application/modules/Sitehomepagevideo/layouts", 'Core_Layout_View');
            $this->view->removePadding = true;
        }
        $this->view->isPost = Zend_Controller_Front::getInstance()->getRequest()->isPost();

        $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
        $isSubscriptionEnabled = false;
        $this->view->show_signup_popup = true;
        if (empty($viewer_id)) {
            $tempClassArray = array(
                'Payment_Plugin_Signup_Subscription',
                'Sladvsubscription_Plugin_Signup_Subscription'
            );
            $db = Zend_Db_Table_Abstract::getDefaultAdapter();
            $subscriptionObj = $db->query('SELECT `class` FROM `engine4_user_signup` WHERE  `enable` = 1 ORDER BY `engine4_user_signup`.`order` ASC LIMIT 1')->fetch();
            if (!empty($subscriptionObj) && isset($subscriptionObj['class']) && !empty($subscriptionObj['class']) && in_array($subscriptionObj['class'], $tempClassArray)) {
                $isSubscriptionEnabled = true;
            }
        }

        if (!empty($isSubscriptionEnabled)) {
            $this->view->show_signup_popup = false;
        }
        $this->view->playVideoSound = $this->_getParam('playVideoSound', 0);

        $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
        $this->view->active = $active = $themeTable->select()
                ->from($themeTable->info('name'), 'active')
                ->where('name = ?', 'captivate')
                ->where('active = ?', 1)
                ->query()
                ->fetchColumn()
        ;
    }

}
