<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelazyload
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2018-12-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelazyload_AdminSettingsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
    ->getNavigation('sitelazyload_admin_main', array(), 'sitelazyload_admin_main_settings');

    $this->view->form  = $form = new Sitelazyload_Form_Admin_Global();
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues(); 
      if ($values['sitelazyload_mode'] == 'testmode') {
        $userTable = Engine_Api::_()->getDbtable('users','user');
        $userSelect = $userTable->select()->where('email = ?', $values['sitelazyload_email']);
        $data= $userTable->fetchRow($userSelect);
        if (empty($data)) {
          $form->addError('User does not exist');
          return;
        }
      }
      foreach ($values as $key => $value) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  } 

  public function faqAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitelazyload_admin_main', array(), 'sitelazyload_admin_main_faq');
  }
}