<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFooterTemplatesController.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_AdminFooterTemplatesController extends Core_Controller_Action_Admin {

  public function indexAction() {

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitelinkedin_admin_main', array(), 'sitelinkedin_admin_settings_footer');



    $this->view->form = $form = new Sitelinkedin_Form_Admin_Footertemplates();

    if (!$this->getRequest()->isPost())
      return;

    if (!$form->isValid($this->getRequest()->getPost()))
      return;

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $values = $form->getValues();

    foreach ($values as $key => $value) {
      if ($coreSettings->hasSetting($key, $value)) {
        $coreSettings->removeSetting($key);
      }
      if ($value == null) {
        continue;
      }
      $coreSettings->setSetting($key, $value);
    }

    $form->addNotice('Your changes have been saved.');
  }

}
