<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitelinkedin
 * @copyright  Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2019-08-28 15:11:20Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitelinkedin_Widget_ContentHomephotoController extends Seaocore_Content_Widget_Abstract {

  //protected $_childCount;
  public function indexAction() {
    // Don't render this if not logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!$viewer->getIdentity()) {
      return $this->setNoRender();
    }
    $this->view->coverUserPhoto = $this->getUserCoverPhoto();
  }

  public function getUserCoverPhoto() {
    $user = Engine_Api::_()->user()->getViewer();
    $coverPhoto = null;
    if (!$user->getIdentity()) {
      return $coverPhoto;
    }
    $albumType = Engine_Api::_()->hasModuleBootstrap('advalbum') ? 'advalbum_photo' : 'album_photo';
    if (Engine_Api::_()->hasModuleBootstrap('siteusercoverphoto')) {
      if (isset($user->user_cover) && $user->user_cover) {
        $coverPhoto = Engine_Api::_()->getItem($albumType, $user->user_cover);
      } elseif (!empty($coverId = Engine_Api::_()->getApi("settings", "core")->getSetting("siteusercoverphoto.cover.photo.preview.level.$user->level_id.id"))) {
        $coverPhoto = Engine_Api::_()->getItem('storage_file', $coverId);
      }
    } elseif (isset($user->coverphoto)) {
      if (Engine_Api::_()->authorization()->isAllowed('user', $user, 'coverphotoupload') && $user->coverphoto) {

        $coverPhoto = Engine_Api::_()->getItem('storage_file', $user->coverphoto);
      }
      $coverId = Engine_Api::_()->getApi("settings", "core")
        ->getSetting("usercoverphoto.preview.level.id." . $user->level_id);
      if (empty($coverPhoto) && $coverId) {
        $coverPhoto = Engine_Api::_()->getItem('storage_file', $coverId);
      }
    }
    return $coverPhoto;
  }

}
