<?php

class Sitelivestreaming_StreamingController extends Core_Controller_Action_Standard
{
	public function startAction()
    {

		if( !$this->_helper->requireUser()->isValid() ) return;

		if(!Engine_Api::_()->sitelivestreaming()->hasPackageEnable()) {
		    return $this->_forward('requireauth', 'error', 'core');
		}
		// check post request
		if( !$this->getRequest()->isPost() ) {
		    return;
		}

		$this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();
		$subject_type = "sitevideo_video";

		$this->view->subject_type = $subject_type;
		$title = $this->_getParam("title");
		$description = $this->_getParam("body");

		$streamTable = Engine_Api::_()->getDbtable('streams', 'sitelivestreaming');

		$db = $streamTable->getAdapter();
		$db->beginTransaction ();

		try {
			$videoDbTable = Engine_Api::_()->getDbtable('videos', 'sitevideo');
			$newVideo = $videoDbTable->createRow();
			$newVideo->status = 0;
			$newVideo->title = $title ? $title : "Live video";
			$newVideo->description = $description ? $description : "New broadcasted video.";
			$newVideo->search = 1;
			$newVideo->owner_type = "user";
			$newVideo->owner_id = $viewer_id;
			$newVideo->type = "upload";
			$newVideo->code = "mp4";
			$newVideo->synchronized = 1;
			$newVideo->save();

			$this->view->video = $newVideo;
			// CREATE AUTH STUFF HERE
			$auth = Engine_Api::_()->authorization()->context;
			$roles = array('owner', 'owner_member', 'owner_member_member', 'owner_network','friends', 'registered', 'everyone');

			if (isset($_POST['auth_view']))
				$videoAuth_view = $auth_view = $_POST['auth_view'];
			else
				$videoAuth_view = $auth_view = "everyone";

			if(strstr($auth_view, "networks")){
				$videoAuth_view = 'owner_network';
			}
			elseif (strstr($auth_view, "friends")) {
				$videoAuth_view = 'owner_member';
			}
			elseif (strstr($auth_view, "onlyme")) {
				$videoAuth_view = 'owner';
			}
			elseif (strstr($auth_view, "everyone")) {
				$videoAuth_view = 'everyone';
			}

			$viewMax = array_search($videoAuth_view, $roles);
			foreach ($roles as $i => $role) {
				$auth->setAllowed($newVideo, $role, 'view', ($i <= $viewMax));
				$auth->setAllowed($newVideo, $role, 'comment', ($i <= $viewMax));
			}

			$stream_name = uniqid(rand());
			$video_id = $newVideo->getIdentity(); 

			$token = (int)(((float)rand()/(float)getrandmax())*100000000);

			// Create New Stream
			$streamTable = Engine_Api::_()->getDbtable ("streams","sitelivestreaming" );

	        $start_time = new DateTime(date('Y-m-d H:i:s'), new DateTimeZone('UTC'));
			$start_time = $start_time->format('Y-m-d H:i:s');

			$allowedTime = min(Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('livestreamingvideo', $viewer, 'max_allowed_duration'), 90);
			$end_time = date('Y-m-d H:i:s', strtotime('+' . $allowedTime . ' minutes', strtotime($start_time)));

			$newStream = $streamTable->createRow();

			$newStream->name = $stream_name;
			$newStream->subject_type = $subject_type;
			$newStream->start_time = $start_time;
			$newStream->owner_id = $viewer_id;
			$newStream->end_time = $end_time;
			$newStream->title = $title ? $title : "Live video";
			$newStream->token = $token;
			$newStream->video_id = $video_id;
			$newStream->description = $description ? $description : "New broadcasted video.";
			$newStream->subject_id =  $video_id;

			// save tags
			if(!empty($_POST['toValues'])) {
				$newStream->tovalues = $_POST['toValues'];
			}
			$newStream->save();
			foreach ($roles as $i => $role) {
				$auth->setAllowed($newStream, $role, 'view', ($i <= $viewMax));
			}
			$userIds = array();
			$params =  array (
				'stream_name' => $stream_name ,
				'main_subject_type' => $subject_type,
				'main_subject_id' => $newStream->subject_id,
				'allowedTime' => min(Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('livestreamingvideo', $viewer, 'max_allowed_duration'), 90)
			);
			$members = array();
			if($auth_view == 'friends') {
				$members = Engine_Api::_()->sitelivestreaming()->getFriends($viewer);
			} elseif($auth_view == 'networks') {
				$network_id = Engine_Api::_()->sitelivestreaming()->getNetwork($viewer);
				$members = Engine_Api::_()->sitelivestreaming()->getMembersOfUserNetwork($network_id);        
	        } elseif($auth_view == 'everyone') {
				$members = Engine_Api::_()->sitelivestreaming()->getRegistedUsers();
	        }

			if (isset($members) && count($members) > 0 ) {

				$userIds = array_column($members->toArray(), 'user_id');

				// remove the viewer from user list
				if (($key = array_search($viewer->getIdentity(), $userIds)) !== false) {
					unset($userIds[$key]);
				}
				if (count($userIds) > 0) {
					//Push notification work starts
					if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('livestreamingvideo')) {
						if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteiosapp') || Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteandroidapp')) {
							$tempMessage['message']['object_params'] = array(
								'type' => 'video',
								'id' => $newVideo->getIdentity(),
								'sender_id' => $viewer->getIdentity()
							);
							$tempMessage['message']['object_params'] = array_merge($params,$tempMessage['message']['object_params']);
							$getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($viewer);
							$tempMessage['message']['feed_title'] =  sprintf($this->view->translate('%s has started live now'), $viewer->getTitle());
							$tempMessage['imgUrl'] = $getContentImages['image_icon'];
							$tempMessage['title'] = $viewer->getTitle();
							$tempMessage['ticker'] = $this->view->translate('new update');
						}

						// For Android
						if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteandroidapp')) {
							$plugin = Engine_Api::_()->loadClass('Siteandroidapp_Plugin_Pushnotification');
							$gcmUsers = Engine_Api::_()->getApi('Siteapi_Core', 'livestreamingvideo')->getUsers(array('user_ids'=> $userIds));

							if ($gcmUsers)
								$plugin->sendBroadcastNotification($gcmUsers,$tempMessage);
						}

						// For iOS
						if (Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteiosapp')) {
							$iosPlugin = Engine_Api::_()->loadClass('Siteiosapp_Plugin_Pushnotification');
							$apnUsers = Engine_Api::_()->getApi('Siteapi_Core', 'livestreamingvideo')->getUsers(array('user_ids'=> $userIds), 0);

							if($apnUsers)
								$iosPlugin->sendBroadcastIosNotification($apnUsers, $tempMessage);
						}
					}
					//Push notification work ends
				}

				$membersIdsChunk = array_chunk($userIds, 10000);
				$url  = $this->view->url(array('action' => 'join', 'stream_id' => $newStream->getIdentity()), 'sitelivestreaming_general', true);
				$link = "<a href='$url'>live video</a>";
				$params['link'] = $link;

				foreach ($membersIdsChunk as $membersId) {
					$dataArray = array('members' => $membersId, 'subject_type'=> $viewer->getType(), 'subject_id'=> $viewer->getIdentity(), 'object_type' => $newVideo->getType(),'object_id' => $newVideo->getIdentity(),'type' => 'sitelivestreaming_video' ,'params' => (object) $params, 'date' => date('Y-m-d H:i:s'));

					$finalData = array('data' => $dataArray);
					$data = json_encode($finalData);
					$agoraUrl = Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url');
					$apiURL = $agoraUrl.'send-notification';

					$curl = curl_init();
					curl_setopt_array($curl, array(
						CURLOPT_URL => $apiURL,
						CURLOPT_RETURNTRANSFER => true,
						CURLOPT_ENCODING => "",
						CURLOPT_MAXREDIRS => 10,
						CURLOPT_TIMEOUT => 0,
						CURLOPT_FOLLOWLOCATION => true,
						CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
						CURLOPT_CUSTOMREQUEST => "POST",
						CURLOPT_POSTFIELDS =>$data,
						CURLOPT_HTTPHEADER => array("Content-Type: application/json")
					));
					$response = curl_exec($curl);
					$statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
					curl_close($curl);
				}
			}

			$db->commit();

		} catch ( Exception $e ) {
			$db->rollBack();
			throw $e;
		}
		return $this->_helper->redirector->gotoRoute(array('action' => 'broadcast', 'stream_id' => $newStream->getIdentity()), 'sitelivestreaming_general', true);
	}

	public function stopAction()
	{
		$streamTable = Engine_Api::_()->getDbtable('streams' , 'sitelivestreaming');
		$db = $streamTable->getAdapter();
		$db->beginTransaction ();
		$check = array('flag' => 'failure');
		try {
			$viewer = Engine_Api::_()->user()->getViewer();
			$stream_id = $this->_getParam("stream_id");

			$stream = Engine_Api::_()->getItem('sitelivestreaming_stream', $stream_id);

			if(empty($stream->getIdentity()))
				return $this->_forward('notfound', 'error', 'core');

			$stream->end_time = date('Y-m-d H:i:s');
			$stream->status = 'normal';
			$stream->save();

			$db->commit();
			$check['flag'] = 'success';

			// Stop recording
			$agoraUrl = Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url');
			$agoraKey = Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.agora.app.id');
			$requestData = array('sid' => $_POST["sid"], 'resource' => $_POST["resourceId"], 'channel' => $stream->name, 'uid' => $stream->token);

			$apiURL = $agoraUrl.'stop';

			$curl = curl_init();
			curl_setopt_array($curl, array(
				CURLOPT_URL => $apiURL,
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => "",
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => "POST",
				CURLOPT_POSTFIELDS => json_encode($requestData),
				CURLOPT_HTTPHEADER => array("Content-Type: application/json")
					));
			$result = curl_exec($curl);
			curl_close($curl);

			if( !empty($result) ) {
				$result = Zend_Json::decode($result);
			}
			return $this->_helper->json($check);
		} catch(Exception $e) {
			$db->rollBack ();
		}
	}

	public function deleteAction() {
		$streamTable = Engine_Api::_()->getDbtable('streams' , 'sitelivestreaming');
		$db = $streamTable->getAdapter();
		$db->beginTransaction ();
		$check = array('flag' => 'failure');
		try {
			$stream_id = $this->_getParam("stream_id");

			$stream = Engine_Api::_()->getItem('sitelivestreaming_stream', $stream_id);

			if(!$stream->stream_id)
				return $this->_forward('notfound', 'error', 'core');

			// delete video first
			$subject = Engine_Api::_()->getItem($stream->subject_type , $stream->subject_id);
			if($subject)
				$subject->delete();

			$db->commit();
			$check['flag'] = 'success';
			return $this->_helper->json($check);
		} catch(Exception $e) {
			$db->rollBack ();
		}
	}

	public function shareAction() {
		$stream_id = $this->_getParam("stream_id", null);
		$endType = !empty($_POST["endType"]) ? $_POST["endType"] : "normal";
		$view_count = !empty($_POST["view_count"]) ? $_POST['view_count'] : 0;
		$check = array('flag' => 'failure');

		if(!$stream_id) {
			$check['reason'] = 'Stream ID is Missing';
			return $this->_helper->json($check);
		}

		$stream = Engine_Api::_()->getItem('sitelivestreaming_stream', $stream_id);
		if(!$stream->stream_id) {
			$check['reason'] = 'No Record Found';
			return $this->_helper->json($check);
		}

		//if no need to save video.........
		if($endType == 'normal'){
			$this->_normalEnd($stream);
			$check['flag'] = 'success';
			return $this->_helper->json($check);
		}

		try{

			$path = $this->getVideoPath($stream);
			$stream->end_time = date('Y-m-d H:i:s');
			$stream->status = $endType;
			$stream->save();
			$video = Engine_Api::_()->getItem($stream->subject_type , $stream->video_id);
			$video->view_count = $view_count;
			$video->save();

			$check['flag'] = 'success';
			return $this->_helper->json($check);
		}
		catch (Exception $e) {
			$check['reason'] = 'An Error occurred';
			return $this->_helper->json($check);
		}
	}

	protected  function _normalEnd($streamObject) {
		$streamObject->status = 'normal';
		$streamObject->end_time = date('Y-m-d H:i:s');
		$streamObject->save();
		$subject = Engine_Api::_()->getItem($streamObject->subject_type , $streamObject->subject_id);

		if($subject)
			$subject->delete();
	}

	public function getVideoPath($stream) {
		$curl = curl_init();
		$agorUrl = Engine_Api::_()->getApi('settings', 'core')->getSetting('livestreamingvideo.url');

		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_URL, $agorUrl.'get-streaming-file?channel='.$stream->name);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_FAILONERROR, true);

		$result = curl_exec($curl);
		if( !empty($result) ) {
			$result = Zend_Json::decode($result);
		}
		return $result;
	}
}
?>