<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Api.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Form_Admin_Api extends Engine_Form {

    public function init() {
        $this->setTitle('Magento Integration Settings');

        $this->addElement('Select', 'sitemagento_hostType', array(
            'label' => "Magento Site's Protocol",
            'description' => 'Select the Web Protocol of your Magento site.',
            'allowEmpty' => false,
            'multiOptions' => array('http' => 'HTTP', 'https' => 'HTTPS'),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemagento.hostType', 'http')
        ));

        $this->addElement('Text', 'sitemagento_api_host', array(
            'label' => 'Magento Site URL',
            'required' => true,
            'description' => 'Enter URL of your Magento Site you want to integrate with SocialEngine Community for ex. www.your-magento-site.com',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemagento.api.host', '')
        ));

        $this->addElement('Text', 'sitemagento_api_user', array(
            'label' => 'Magento Admin User Name',
            'description' => 'Enter the User Name of your Magento Site’s Admin.',
            'required' => true,
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemagento.api.user', '')
        ));

        $this->addElement('Password', 'sitemagento_api_pass', array(
            'label' => 'Magento Admin Password',
            'description' => 'Enter the Password of your Magento Site’s Admin.',
            'required' => false,
            'value' => ''
        ));
        // Add submit button
        $this->addElement('Button', 'save', array(
            'label' => 'Save Settings',
            'type' => 'submit',
            'ignore' => true,
            'decorators' => array('ViewHelper')
        ));
    }

}

?>
