<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Orderdetails.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Model_DbTable_Products extends Engine_Db_Table {

    protected $_name = 'sitemagento_products';
    protected $_rowClass = 'Sitemagento_Model_Product';

    public function setProduct($product) {
        $row = $this->getProductById($product['product_id']);
        if (!$row) {
            $row = $this->createRow();
        }
        $row->product_id = $product['product_id'];
        $row->title = $product['title'];
        $row->sku = $product['sku'];
        $row->price = $product['price'];
        $row->url = $product['url'];
        $row->image_url = Engine_Api::_()->sitemagento()->checkProductImage($product['image_url']);
        $row->category = $product['category'];
        $row->currency = $product['currency'];
        $row->type_id = $product['type_id'];
        $row->save();
        return true;
    }

    public function getProductById($productId) {
        return Engine_Api::_()->getItem('sitemagento_product', $productId);
    }

}
