<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Users.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_Model_DbTable_Users extends Engine_Db_Table {

  protected $_name = 'sitemagento_users';
  protected $_rowClass = 'Sitemagento_Model_User';

  /**
   * INSERT THE USER INFORMATION INTO THIS TABLE.
   *
   * @param $data: Array of the information, which required for filter data.
   * @return array
   */
  public function setUser($data) {
    $row = $this->createRow();
    $row->se_user_id = $data["se_user_id"];
    $row->mage_user_id = $data["mage_user_id"];
    $row->name = $data["name"];
    //$row->website = $data["website"];
    $row->enable = $data["enable"];
    $row->save();
    return;
  }

  /**
   * RETURN THE USER OBJECT FOR THE "MANAGE USER" PAGE.
   *
   * @param $data: Array of the information, which required for filter data.
   * @return array
   */
  public function getUser($data = array()) {
    $table = $this->info('name');
    $select = $this->select();

    if (!empty($data)) {
      foreach ($data as $key => $value) {
        $select->where($key . '=?', $value);
      }
    }

    $fetchArray = $select->query()->fetchAll();
    return $fetchArray;
  }


  /**
   * RETURN THE USER EXIST OR NOT.
   *
   * @param $data: Array of the information, which required for filter data.
   * @return array
   */
  public function existUser($data) {
    $table = $this->info('name');
    $select = $this->select();

    foreach ($data as $key => $value) {
      $select->where("$key = ?", $value);
    }
    $select->limit(1);

    $fetchArray = $select->query()->fetchAll();
    $fetchArray = !empty($fetchArray) ? $fetchArray[0] : array();
    return $fetchArray;
  }

  /**
   * CALLING WHEN USER WILL DELETE HIS ACCOUNT FROM THE SocilEngine EXISTING SITE. USER WILL DELETE FROM THE MAGENTOINT_USER TABLE ALSO.
   *
   * @param $seUserId: User id.
   * @return
   */
  public function deleteUser($seUserId) {
    $db = Zend_Db_Table_Abstract::getDefaultAdapter();
    $db->query("DELETE FROM `engine4_sitemagento_users` WHERE `engine4_sitemagento_users`.`se_user_id` = " . $seUserId['se_user_id']);
  }

}