<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WishlistRichContent.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_View_Helper_WishlistRichContent extends Zend_View_Helper_Abstract {

    public function wishlistRichContent($id) {
        $richStr = '';
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $wishlist = Engine_Api::_()->getItem('sitemagento_wishlist', $id);
        if (empty($wishlist)) {
            return;
        }
        $product = Engine_Api::_()->getItem('sitemagento_product', $wishlist->product_id);
        $RESOURCE_TYPE = 'sitemagento_product';
        $sub_title = str_replace("'", '"', $product->getTitle());
        $title = '<span class="mint_pp_title">' . $view->htmlLink($product->url, Engine_Api::_()->sitemagento()->truncateStr($product->getTitle(),23), array('title' => $sub_title, 'target' => '_blank', 'class' => 'sea_add_tooltip_link', 'rel' => $RESOURCE_TYPE . ' ' . $product->product_id)) . '</span>';
        if ($wishlist->type_id == 'bundle') {
            $price = "<span class='wish_pp_price'>".$wishlist->currency . number_format($wishlist-> min_price, 2, '.', ',') . ' - ' . " " . $wishlist->currency . number_format($wishlist->max_price, 2, '.', ',') . "</span>";
            } elseif ($wishlist->type_id == 'grouped') {
            $price = "<span class='wish_pp_price'>" . $view->translate('Starting at') . " " . $wishlist->currency . number_format($wishlist->price, 2, '.', ',') . "</span>";
        } else {
            $price = "<span class='wish_pp_price'>" . $wishlist->currency . number_format($wishlist->price, 2, '.', ',') . "</span>";
        }
        $photoURL = $product->image_url;
        $photoURL = !empty($photoURL) ? $photoURL : 'application/modules/Sitemagento/externals/images/default.png';
        $image = "<div class='feeds_image'><a href='" . $product->url . "' target='_blank' class = 'sea_add_tooltip_link' rel = '$RESOURCE_TYPE " . $product->product_id . "'>" . '<img class="mint_pp_img" src="' . $photoURL . '" /></a></div>';
        $product = '<div class="product_info">' . $image . '<div class="feeds_content">' . $title . '' . $price . '</div></div>';
        $richStr .= $product;
        $richStr = rtrim($richStr, ", ");
        return $richStr;
    }

}
