<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SyncController.php 2017-06-22 9:40:21Z SocialEngineAddOns
 * @author     SocialEngineAddOns
 */
class Sitemagento_SyncController extends Core_Controller_Action_Standard {

    // Create User in SocialEngine, when customer login or signup in configured magento site.
    public function createAction() {
        if (!empty($_GET["info"])) {
            $customerInfo = $_GET["info"];
        } else {
            exit();
        }

        $customerInfo = base64_decode($customerInfo);
        $customerInfo = unserialize($customerInfo);
        if (empty($customerInfo) || empty($customerInfo['email'])) {
            exit();
        }
        $sitemagentoCreateUser = Zend_Registry::isRegistered('sitemagentoCreateUser') ? Zend_Registry::get('sitemagentoCreateUser') : null;

        $userTable = Engine_Api::_()->getItemTable('user');
        $tableName = $userTable->info('name');
        if (empty($sitemagentoCreateUser))
            exit();
        // Create user in SocialEngine.
        $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $customerInfo['email']);
        $user = $selectTable->query()->fetch();
        if (empty($user)) {
            $signupData = Engine_Api::_()->sitemagento()->doSignup($customerInfo);
            Engine_Api::_()->sitemagento()->createUser($customerInfo); // Create user in sitemagento_users Table.
        }


        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        // Find out the first_name meta fileds values and set the First Name into the Profile Type.
        if (!empty($customerInfo['firstname']) && !empty($viewer_id)) {
            $metaFnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'first_name' LIMIT 0 , 30")->fetchAll();
            foreach ($metaFnameQuery as $fetchRow) {
                $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $viewer_id . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
                if (empty($query)) {
                    $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $viewer_id . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['firstname'] . "')");
                }
            }
        }


        // Find out the last_name meta fileds values and set the Last Name into the Profile Type.
        if (!empty($customerInfo['lastname']) && !empty($viewer_id)) {
            $metaLnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'last_name' LIMIT 0 , 30")->fetchAll();
            foreach ($metaLnameQuery as $fetchRow) {
                $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $viewer_id . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
                if (empty($query)) {
                    $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $viewer_id . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['lastname'] . "')");
                }
            }
        }
    }

    // Update customer information into the SocialEngine, when customer update his information from the configured magento site.
    public function updateAction() {
        if (!empty($_GET["info"])) {
            $customerInfo = $_GET["info"];
        } else {
            exit();
        }
        $sitemagentoUpdateUser = Zend_Registry::isRegistered('sitemagentoUpdateUser') ? Zend_Registry::get('sitemagentoUpdateUser') : null;

        $customerInfo = base64_decode($customerInfo);
        $customerInfo = unserialize($customerInfo);
        if (empty($customerInfo)) {
            exit();
        }
        if (empty($sitemagentoUpdateUser))
            exit();
        $getMAgentoId = Engine_Api::_()->getDbTable('users', 'sitemagento')->getUser(array('mage_user_id' => $customerInfo['id']));
        if (!empty($getMAgentoId)) {
            $getMAgentoId = end($getMAgentoId);
            $socialEngineUserId = $getMAgentoId['se_user_id'];
            $sitemagentoUserId = $getMAgentoId['user_id'];
        } else {
            $userTable = Engine_Api::_()->getItemTable('user');
            $tableName = $userTable->info('name');
            $selectTable = $userTable->select()->from($tableName, array('user_id'))->where("email =?", $customerInfo['email']);
            $user = $selectTable->query()->fetch();
            $socialEngineUserId = $user['user_id'];
            $sitemagentoUserId = $customerInfo['id'];
            Engine_Api::_()->getDbtable("users", "sitemagento")->setUser(array("mage_user_id" => $sitemagentoUserId, "se_user_id" => $socialEngineUserId, "name" => $customerInfo['firstname'] . " " . $customerInfo['lastname'], "enable" => true));
        }

        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        // Update Email, Password, Salt and Displayname
        if (!empty($customerInfo['salt']) && !empty($customerInfo['password']) && !empty($customerInfo['password_confirmation']) && ($customerInfo['password'] === $customerInfo['password_confirmation'])) {
            $staticSalt = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.secret', 'staticSalt');
            $password = md5($staticSalt . $customerInfo["password"] . $customerInfo["salt"]);
            $query = "UPDATE `engine4_users` SET `email` = '" . $customerInfo['email'] . "', `password` = '" . $password . "', `salt` = '" . $customerInfo['salt'] . "', `displayname` = '" . $customerInfo['firstname'] . " " . $customerInfo['lastname'] . "' WHERE `engine4_users`.`user_id` =$socialEngineUserId LIMIT 1 ;";
        } else {
            $query = "UPDATE `engine4_users` SET `email` = '" . $customerInfo['email'] . "', `displayname` = '" . $customerInfo['firstname'] . " " . $customerInfo['lastname'] . "' WHERE `engine4_users`.`user_id` =$socialEngineUserId LIMIT 1 ;";
        }
        $db->query($query);

        $db->query("UPDATE `engine4_sitemagento_users` SET `name` = '" . $customerInfo['firstname'] . " " . $customerInfo['lastname'] . "' WHERE `engine4_sitemagento_users`.`user_id` =$sitemagentoUserId LIMIT 1 ;");
        if (!empty($customerInfo['firstname'])) {
            $metaFnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'first_name' LIMIT 0 , 30")->fetchAll();
            if (!empty($socialEngineUserId)) {
                foreach ($metaFnameQuery as $fetchRow) {
                    $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $socialEngineUserId . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
                    if (empty($query)) {
                        $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $socialEngineUserId . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['firstname'] . "')");
                    } else {
                        $db->query("UPDATE `engine4_user_fields_values` SET `value` = '" . $customerInfo['firstname'] . "' WHERE `engine4_user_fields_values`.`item_id` =$socialEngineUserId AND `engine4_user_fields_values`.`field_id`= " . $fetchRow['field_id'] . " LIMIT 1 ;");
                    }
                }
            }
        }


        // Find out the last_name meta fileds values and set the Last Name into the Profile Type.
        if (!empty($customerInfo['lastname'])) {
            $metaLnameQuery = $db->query("SELECT * FROM `engine4_user_fields_meta` WHERE `type` LIKE 'last_name' LIMIT 0 , 30")->fetchAll();
            if (!empty($socialEngineUserId)) {
                foreach ($metaLnameQuery as $fetchRow) {
                    $query = $db->query("SELECT * FROM `engine4_user_fields_values` WHERE `item_id` = " . $socialEngineUserId . " AND `field_id` =" . $fetchRow['field_id'] . " LIMIT 1")->fetch();
                    if (empty($query)) {
                        $db->query("INSERT IGNORE INTO `engine4_user_fields_values`(`item_id`, `field_id`, `value`)VALUES(" . $socialEngineUserId . ", " . $fetchRow['field_id'] . ", '" . $customerInfo['lastname'] . "')");
                    } else {
                        $db->query("UPDATE `engine4_user_fields_values` SET `value` = '" . $customerInfo['lastname'] . "' WHERE `engine4_user_fields_values`.`item_id` =$socialEngineUserId AND `engine4_user_fields_values`.`field_id`= " . $fetchRow['field_id'] . " LIMIT 1 ;");
                    }
                }
            }
        }
    }

}
