<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Widget_CategoriesNavigationController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $this->view->viewDisplayHR = $this->_getParam('viewDisplayHR', 0);
        $this->view->category_id = $category_id = $this->_getParam('category_id', 1);
        $this->view->subcategory_id = $subcategory_id = $this->_getParam('subcategory_id');
        $this->view->subsubcategory_id = $subsubcategory_id = $this->_getParam('hidden_subsubcategory_id');
        if (!empty($subsubcategory_id)) {
            $category_id = $subcategory_id;
        } elseif (!empty($subcategory_id)) {
            $category_id = $subcategory_id;
        } elseif (empty($category_id)) {
            $category_id = 1;
        }
        if ($this->view->viewDisplay) {
            $element = $this->getElement();
            $this->view->widgetTitle = $element->getTitle();
            $element->setTitle('');
        }
        if (empty($category_id)) {
            $category_id = 1;
        }
        $params = array(
            'apiType' => 'getCategoriesWithUrl',
            'method' => 'GET',
            'parameters' => array(
                'rootCategoryId' => $category_id
            )
        );
        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($params);
        $categoriesArray = array();
        if ($response['is_error'] == false && !empty($response['response_output']) && isset($response['response_output']) && count($response['response_output']) > 0) {
            $categories = $response['response_output'];

            foreach ($categories as $category) {
                $categoriesArray[$category['entity_id']] = array(
                    'category' => array('name' => $category['name'],
                        'url' => $category['url']),
                    'subcategories' => $category['children_data']
                );
            }
        }
        $this->view->categoriesArray = $categoriesArray;
    }

}
