<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemagento
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2017-06-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemagento_Widget_FeaturedCatalogsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $param = array();
        $this->view->category_id = $category_id = $this->_getParam('category_id');
        $this->view->subcategory_id = $subcategory_id = $this->_getParam('subcategory_id');
        $this->view->subsubcategory_id = $subsubcategory_id = $this->_getParam('hidden_subsubcategory_id');
        $this->view->viewType = $param['viewType'] = $this->_getParam('viewType', 'listView');
        $this->view->viewTypeOptions = $param['viewTypeOptions'] = $this->_getParam('viewTypeOptions', array('gridView', 'listView'));
        $this->view->type = $type = $this->_getParam('type', 'new');
        $this->view->buttonTitle = $param['buttonTitle'] = $this->_getParam('buttonTitle', 'Go to Store');
        $this->view->count = $pageSize = $this->_getParam('count', 10);
        $this->view->host = $host = Engine_Api::_()->sitemagento()->getMagentoHostUrl();
        $this->view->catalogImagePath = $host . Engine_Api::_()->sitemagento()->getCatalogImageUrl();
        $this->view->buttonLink = $param['buttonLink'] = $this->_getParam('buttonLink', $host);
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation', 30);
        $this->view->productViewPage = $this->_getParam('productViewPage', 0);
        $element = $this->getElement();

        $widgetTitle = $this->view->heading = $element->getTitle();
        $sitemagentoFeaturedCatalog = Zend_Registry::isRegistered('sitemagentoFeaturedCatalog') ? Zend_Registry::get('sitemagentoFeaturedCatalog') : null;
        if (!empty($widgetTitle)) {
            $element->setTitle("");
        }
        if (empty($this->view->viewTypeOptions) || count($this->view->viewTypeOptions) == 1) {
            $this->view->viewTypeOptions = array($this->view->viewType);
        }
        $cid = 0;
        if (!empty($subsubcategory_id)) {
            $cid = $subsubcategory_id;
        } elseif (!empty($subcategory_id)) {
            $cid = $subcategory_id;
        } elseif (!empty($category_id)) {
            $cid = $category_id;
        }
        //Find the products from magento site
        switch ($type) {
            case 'new' :
                $searchCri = array(
                    'searchCriteria[sortOrders][0][field]' => 'created_at',
                    'searchCriteria[sortOrders][0][direction]' => 'DESC',
                    'searchCriteria[pageSize]' => $pageSize,
                    'searchCriteria[filterGroups][0][filters][0][field]' => 'type_id',
                    'searchCriteria[filterGroups][0][filters][0][value]' => 'virtual',
                    'searchCriteria[filterGroups][0][filters][0][conditionType]' => 'neq',
                    'searchCriteria[filterGroups][1][filters][0][field]' => 'visibility',
                    'searchCriteria[filterGroups][1][filters][0][value]' => 1,
                    'searchCriteria[filterGroups][1][filters][0][conditionType]' => 'neq',
                    'searchCriteria[filterGroups][2][filters][0][field]' => 'status',
                    'searchCriteria[filterGroups][2][filters][0][value]' => 1,
                    'searchCriteria[filterGroups][2][filters][0][conditionType]' => 'eq',
                );
                if (!empty($cid)) {
                    $searchCri = array_merge($searchCri, array(
                        'searchCriteria[filterGroups][3][filters][0][field]' => 'category_id',
                        'searchCriteria[filterGroups][3][filters][0][value]' => $cid,
                        'searchCriteria[filterGroups][3][filters][0][conditionType]' => 'eq'
                    ));
                }
                
                $packet = array(
                    'apiType' => 'getProducts',
                    'method' => 'GET',
                    'queryParameters' => $searchCri
                );
                break;
            case 'best_seller' :
                $packet = array(
                    'apiType' => 'getBestSellers',
                    'method' => 'GET',
                    'parameters' => array(
                        'pageSize' => $pageSize,
                        'categoryId' => $cid
                    )
                );
                break;
        }

        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        $products = array();
        if ($response['is_error'] == false && !empty($response['response_output'])) {
            $products = $response['response_output'];
            if ($type == 'new' && isset($response['response_output']['items']) && count($response['response_output']['items']) > 0) {
                $productsArray = $response['response_output']['items'];

                $prIds = array();
                $products = array();
                foreach ($productsArray as $product) {
                    $prIds[] = $product['id'];
                    $products[$product['id']] = $product;
                }

                $packet = array(
                    'apiType' => 'getProductsPrice',
                    'method' => 'POST',
                    'parameters' => array(
                        'productIds' => $prIds
                    )
                );
                $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
                if ($response['is_error'] == false && !empty($response['response_output'])) {
                    $prds = $response['response_output'];
                    foreach ($prds as $p) {
                        $products[$p['product_id']]['product_id'] = $p['product_id'];
                        $products[$p['product_id']]['url'] = $p['url'];
                        $products[$p['product_id']]['avg_rating'] = $p['avg_rating'];
                        $products[$p['product_id']]['price_1'] = $p['price'];
                        $products[$p['product_id']]['min_price'] = $p['min_price'];
                        $products[$p['product_id']]['max_price'] = $p['max_price'];
                        if (!isset($products[$p['product_id']]['price'])) {
                            $products[$p['product_id']]['price'] = 0.00;
                        }
                    }
                }
            }
        }

        if (empty($products) || count($products) == 0) {
            return $this->setNoRender();
        }

        //Get Currency
        $this->view->currencySymbol = '';
        $packet = array(
            'apiType' => 'getCurrency',
            'method' => 'GET',
        );

        $response = Engine_Api::_()->getApi('Request', 'sitemagento')->client_api_connect($packet);
        if ($response['is_error'] == false && !empty($response['response_output']['base_currency_symbol'])) {
            $this->view->currencySymbol = $response['response_output']['base_currency_symbol'];
        }
        if (empty($sitemagentoFeaturedCatalog))
            return $this->setNoRender();
        $this->view->products = $products;
    }

}
