<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemailtemplates
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2012-06-20 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemailtemplates_Api_Core extends Core_Api_Abstract {
 
 	public function tinymceEditorOptions($upload_url = false) {

    $plugins = "directionality,advlist,autolink,lists,link,image,charmap,print,preview,hr,anchor,"
        . "pagebreak,searchreplace,wordcount,visualblocks,visualchars,code,fullscreen,insertdatetime,"
        . "media,nonbreaking,save,table,contextmenu,directionality,emoticons,paste,textcolor";
    $uploadPlugin = '';
    if (!empty($upload_url)) {
      $plugins .= ',jbimages';
      $uploadPlugin = 'jbimages,';
    }
    $plugins .= ",imagetools,colorpicker,autosave";
    return array(
      'upload_url' => $upload_url,
      'menubar' => true,
      'forced_root_block' => false,
      'force_p_newlines' => false,
      'plugins' => $plugins,
      'toolbar1' => "ltr,rtl,undo,redo,removeformat,pastetext,|,code,link,media,image," . $uploadPlugin . "emoticons,|,bullist,numlist,|,print,preview,fullscreen",
      'toolbar2' => "fontselect,fontsizeselect,bold,italic,underline,strikethrough,forecolor,backcolor,|,alignleft,aligncenter,alignright,alignjustify,|,outdent,indent,blockquote",
      'image_advtab' => true,
    );
  }

  public function getSuperAdminEmailAddress() {
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $userTable->info('name');
    $email = $userTable->select()->from($userTableName, 'email')->where('level_id =?', 1)->order('user_id ASC')->query()->fetchColumn();
    $settings = Engine_Api::_()->getApi('settings', 'core');
    $core_mail_contact = $settings->getSetting('core.mail.contact');
    return $core_mail_contact ? $core_mail_contact : $email;
  }

  public function tinymceEditorPhotoUploadedFileName() {
    $fileNmame = 'userfile';
    return $fileNmame;
  }
}