<?php 
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemobile
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 6590 2013-06-03 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php

class Sitemobileiosapp_Form_Admin_Ios_Settings extends Engine_Form {

    public function init() {
        $settings = Engine_Api::_()->getApi('settings', 'core');
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $URL = $view->baseUrl() . "/admin/files";
        $click = '<a href="' . $URL . '" target="_blank">over here</a>';
        $customBlocks = sprintf("Upload an apple apn certificate file %s. The ideal extension of this file should be '.pem'.Once you upload a new certificate file at the link mentioned, then refresh this page to see its preview below after selection.", $click);
        $imageExtensions = array('pem');
        $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
        $apnPath = $settings->getSetting('sitemobile.ios.apple.server.apn.key', '');
        $tempApn = @explode("public/admin/",$apnPath);

        if(!empty($tempApn[1]))
        $apnVal = "public/admin/".$tempApn[1];
        else
        $apnVal = "";
        
        foreach ($it as $file) {
            if ($file->isDot() || !$file->isFile())
                continue;
            $basename = basename($file->getFilename());
            if (!($pos = strrpos($basename, '.')))
                continue;
            $ext = strtolower(ltrim(substr($basename, $pos), '.'));
            if (!in_array($ext, $imageExtensions))
                continue;
            $logoOptions['public/admin/' . $basename] = $basename;
        }
        $this
                ->setTitle('Ios App Settings')
                ->setDescription('Below, you can configure settings for your Ios app.');
if(empty($logoOptions))
    $logoOptions['new'] = "no pem file";
      $this->addElement('Select', 'apple_server_apn_key', array(
          'label' => 'Apple Apn Server Certificate',
          'description' => $customBlocks,
          'multiOptions' => $logoOptions,
          'value' => $apnVal,
      ));
      $this->getElement('apple_server_apn_key')->getDecorator('Description')->setOptions(array('placement' =>
          'PREPEND', 'escape' => false));

        $this->addElement('Password', 'password', array(
            'label' => 'Password',
            'required' => true,
            'allowEmpty' => false,
        ));

        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
