<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemobile
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2013-06-03 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Sitemobileapp/settings/install.php';

class Sitemobileiosapp_Installer extends Engine_Package_Installer_Module {

  function onPreinstall() {

    $db = $this->getDb();

    $select = new Zend_Db_Select($db);
    $sitemobile_settings = $select
            ->from('engine4_core_settings', 'value')
            ->where('name = ?', 'sitemobile.isActivate')
            ->limit(1)
            ->query()
            ->fetchColumn();
    $sitemobile_is_active = !empty($sitemobile_settings) ? $sitemobile_settings : 0;

    $select = new Zend_Db_Select($db);
    $issitemobileEnabled = $select
            ->from('engine4_core_modules', 'enabled')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1)
            ->query()
            ->fetchColumn();

    if (empty($issitemobileEnabled)) {
      $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

      return $this->_error("<span style='color:red'>Note: You have not installed the '<a href='http://www.socialengineaddons.com/socialengine-mobile-tablet-plugin' target='_blank'>Mobile / Tablet Plugin</a>' on your site yet. Please install it first before installing the 'Mobile Application'. <a href='" . $base_url . "/manage'>Click here</a> to go to Manage Packages.</span>");
    } else {
      if (empty($sitemobile_is_active)) {
        $core_final_url = '';
        $baseUrl = $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getBaseUrl();
        $explode_base_url = explode("/", $baseUrl);
        foreach ($explode_base_url as $url_key) {
          if ($url_key != 'install') {
            $core_final_url .= $url_key . '/';
          }
        }
        return $this->_error("<span style='color:red'>Note: You have installed the 'Mobile / Tablet Plugin' but not activated it on your site yet. Please activate it first before installing the 'Mobile Application'.</span> <a href='" . 'http://' . $core_final_url . "admin/sitemobile/settings/readme'>Click here</a> to activate the 'Mobile / Tablet Plugin'.");
      }

      $getErrorMsg = $this->_getVersion();
      if (!empty($getErrorMsg)) {
        return $this->_error($getErrorMsg);
      }

      $PRODUCT_TYPE = 'sitemobileiosapp';
      $PLUGIN_TITLE = 'Sitemobileiosapp';
      $PLUGIN_VERSION = '5.4.1';
      $PLUGIN_CATEGORY = 'plugin';
      $PRODUCT_DESCRIPTION = 'Mobile / Tablet IOS APP';
      $_PRODUCT_FINAL_FILE = 0;
      $SocialEngineAddOns_version = '4.8.6p1';
      $PRODUCT_TITLE = 'Mobile / Tablet IOS APP';

      $file_path = APPLICATION_PATH . "/application/modules/Sitemobileiosapp/controllers/license/ilicense.php";
      $is_file = file_exists($file_path);

      if (empty($is_file)) {
        include_once APPLICATION_PATH . "/application/modules/Sitemobile/controllers/license/license3.php";
      } else {
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
        $is_Mod = $select->query()->fetchObject();
        if (empty($is_Mod)) {
          include_once $file_path;
        }
      }
    }
    parent::onPreinstall();
  }

  public function onInstall() {   
    $db = $this->getDb();

    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitemobileiosapp';");
    
    $db->query("DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`name` = 'sitemobileapp_admin_main_ios' LIMIT 1");
    
    $db->query("INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`,`enabled`, `custom`, `order`) VALUES
( 'sitemobileapp_admin_main_ios', 'sitemobileiosapp', 'iOS Settings', '', '{\"route\":\"admin_default\",\"module\":\"sitemobileiosapp\",\"controller\":\"ios\"}', 'sitemobileapp_admin_main', '', 1, 0, 10)");

    $activitynotificationtypesTable = $db->query('SHOW TABLES LIKE \'engine4_activity_notificationtypes\'')->fetch();
    if (!empty($activitynotificationtypesTable)) {
      $enable_push = $db->query("SHOW COLUMNS FROM engine4_activity_notificationtypes LIKE 'enable_push'")->fetch();
      if (empty($enable_push)) {
        $db->query("ALTER TABLE `engine4_activity_notificationtypes` ADD `enable_push` TINYINT( 1 ) NOT NULL DEFAULT '0';");
      }

      $ios_pushtype = $db->query("SHOW COLUMNS FROM engine4_activity_notificationtypes LIKE 'ios_pushtype'")->fetch();
      if (empty($ios_pushtype)) {
        $db->query("ALTER TABLE `engine4_activity_notificationtypes` ADD `ios_pushtype` TINYINT( 4 ) NOT NULL DEFAULT '4';");
      }
    }
    
    // CALLING THE ONINSTALL QUERIES FROM THE SITESTOREAPP EXTENSION.
    Sitemobileapp_Installer::callFromAndroidIosAppInstaller();

    parent::onInstall();
  }
  
  public function onEnable() {
    $db = $this->getDb();
    $db->query('UPDATE `engine4_core_modules` SET `enabled` = "1" WHERE `engine4_core_modules`.`name` = "sitemobileapp" LIMIT 1');
    
    parent::onEnable();
  }

  public function onDisable() {
    $db = $this->getDb();

    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name =?', 'sitemobileandroidapp')
            ->limit(1);
    $moduleData = $select->query()->fetchAll();
    if (!empty($moduleData)) {
      if(empty($moduleData[0]['enabled']))
        $db->query('UPDATE `engine4_core_modules` SET `enabled` = "0" WHERE `engine4_core_modules`.`name` = "sitemobileapp" LIMIT 1');
    }else {
      $db->query('UPDATE `engine4_core_modules` SET `enabled` = "0" WHERE `engine4_core_modules`.`name` = "sitemobileapp" LIMIT 1');
    }
    parent::onDisable();
  }

  public function onPostInstall() {

    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_core_modules')
            ->where('name = ?', 'sitemobile')
            ->where('enabled = ?', 1);
    $is_sitemobile_object = $select->query()->fetchObject();
    if (!empty($is_sitemobile_object)) {
      $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitemobileapp','0')");
      $select_smapp = new Zend_Db_Select($db);
      $select_smapp
              ->from('engine4_sitemobile_modules')
              ->where('name = ?', 'sitemobileapp')
              ->where('integrated = ?', 0);
      $is_sitemobile_object_smapp = $select_smapp->query()->fetchObject();
      $sitemobile_app = 0;
      if ($is_sitemobile_object_smapp) {
        $sitemobile_app = 1;
      }
   
    $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`) VALUES ('sitemobileiosapp','0')");
    $select = new Zend_Db_Select($db);
    $select
            ->from('engine4_sitemobile_modules')
            ->where('name = ?', 'sitemobileiosapp')
            ->where('integrated = ?', 0);
    $is_sitemobile_object = $select->query()->fetchObject();
    if ($is_sitemobile_object) {
      $actionName = Zend_Controller_Front::getInstance()->getRequest()->getActionName();
      $controllerName = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
      if ($controllerName == 'manage' && $actionName == 'query') {
        $view = new Zend_View();
        $baseUrl = (!empty($_ENV["HTTPS"]) && 'on' == strtolower($_ENV["HTTPS"]) ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . str_replace('install/', '', $view->url(array(), 'default', true));
        $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
        $redirector->gotoUrl($baseUrl . 'admin/sitemobile/module/enable-mobile/enable_mobile/1/name/sitemobileiosapp/integratedForApp/0/integrated/1/sitemobileapp/'.$sitemobile_app.'redirect/install');
      }
      }
    }
  }
  
  private function _getVersion() {

    $db = $this->getDb();

    $errorMsg = '';
    $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

    $modArray = array(
        'sitemobile' => '4.8.5p1',
    );

    $finalModules = array();
    foreach ($modArray as $key => $value) {
      $select = new Zend_Db_Select($db);
      $select->from('engine4_core_modules')
              ->where('name = ?', "$key")
              ->where('enabled = ?', 1);
      $isModEnabled = $select->query()->fetchObject();
      if (!empty($isModEnabled)) {
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_modules', array('title', 'version'))
                ->where('name = ?', "$key")
                ->where('enabled = ?', 1);
        $getModVersion = $select->query()->fetchObject();

        $isModSupport = $this->checkVersion($getModVersion->version, $value);
        if (empty($isModSupport)) {
          $finalModules[$key] = $getModVersion->title;
        }
      }
    }

    foreach ($finalModules as $modArray) {
      $errorMsg .= '<div class="tip"><span style="background-color: #da5252;color:#FFFFFF;">Note: You do not have the latest version of the "' . $modArray . '". Please upgrade "' . $modArray . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "' . $modArray . '".<br/> Please <a class="" href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
    }

    return $errorMsg;
  }
    private function checkVersion($databaseVersion, $checkDependancyVersion) {
        $f = $databaseVersion;
        $s = $checkDependancyVersion;
        if (strcasecmp($f, $s) == 0)
            return -1;

        $fArr = explode(".", $f);
        $sArr = explode('.', $s);
        if (count($fArr) <= count($sArr))
            $count = count($fArr);
        else
            $count = count($sArr);

        for ($i = 0; $i < $count; $i++) {
            $fValue = $fArr[$i];
            $sValue = $sArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                if ($fValue > $sValue)
                    return 1;
                elseif ($fValue < $sValue)
                    return 0;
                else {
                    if (($i + 1) == $count) {
                        return -1;
                    } else
                        continue;
                }
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);

                if ($fsArr[0] > $sValue)
                    return 1;
                elseif ($fsArr[0] < $sValue)
                    return 0;
                else {
                    return 1;
                }
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);

                if ($fValue > $ssArr[0])
                    return 1;
                elseif ($fValue < $ssArr[0])
                    return 0;
                else {
                    return 0;
                }
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                if ($fsArr[0] > $ssArr[0])
                    return 1;
                elseif ($fsArr[0] < $ssArr[0])
                    return 0;
                else {
                    if ($fsArr[1] > $ssArr[1])
                        return 1;
                    elseif ($fsArr[1] < $ssArr[1])
                        return 0;
                    else {
                        return -1;
                    }
                }
            }
        }
    }
}