<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemulticurrency
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemulticurrency_Form_Admin_Settings_Global extends Engine_Form {

    public $_SHOWELEMENTSBEFOREACTIVATE = array(
        "submit_lsetting", "environment_mode"
    );

    public function init() {

        $this->setTitle('Global Settings')
                ->setDescription('These settings will affect all members in your community.')
                ->setName('review_global');
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $productType = 'sitemulticurrency';
        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', $productType . '_lsettings', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting($productType . '.lsettings'),
        ));
        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }
        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));
        $this->addElement('Radio', 'sitemulticurrency_enabled', array(
            'label' => 'Multicurrency Feature',
            'onclick' => 'showSettings(this.value)',
            'description' => "Do you want Multicurrency feature to be activated on your site? If enabled, site user will be able to select any of the supported currencies to view the price of products, event tickets, subscriptions, listing types and other integrated plugin features in the selected currency.",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => $coreSettings->getSetting('sitemulticurrency.enabled', 1),
        ));
        $this->addElement('Radio', 'sitemulticurrency_headermenu_enabled', array(
            'label' => 'Currencies Drop-down',
            'description' => "Do you want currencies drop-down in header of your website?",
            'onclick' => 'showCurrencyOption(this.value)',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => $coreSettings->getSetting('sitemulticurrency.headermenu.enabled', 1),
        ));
        $this->addElement('Radio', 'sitemulticurrency_currency_information', array(
            'label' => 'Currency Format',
            'description' => "Please choose a currency format to be shown
                                            on your website.",
            'multiOptions' => array(
                'currencySymbol' => 'Currency code with currency symbol',
                'countryFlag' => 'Country name with country flag'
            ),
            'value' => $coreSettings->getSetting('sitemulticurrency.currency.information', 'currencySymbol'),
        ));
        $this->addElement('Button', 'save', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
