<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemulticurrency
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 6590 2014-01-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
?>
<?php

class Sitemulticurrency_AdminManageController extends Core_Controller_Action_Admin {

    //ACTION FOR MANAGE CURRENCIES SAVE THE ALLOWED AND DEFAULT DISPLAY CURRENCIES
    public function indexAction() {
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitemulticurrency_admin_main', array(), 'sitemulticurrency_admin_main_manage');
        $this->view->form = $form = new Sitemulticurrency_Form_Admin_Manage_Manage();
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        //FORM VALDIATION
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            include APPLICATION_PATH . '/application/modules/Sitemulticurrency/controllers/license/license2.php';
            $this->view->form = $form = new Sitemulticurrency_Form_Admin_Manage_Manage();
            $form->addNotice($this->view->translate('Your changes have been saved successfully.'));
        }
    }

    //ACTION FOR MANAGE CURRENCY RATES 
    public function manageRatesAction() {

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitemulticurrency_admin_main', array(), 'sitemulticurrency_admin_main_rates');
        //MAKE FILTER FORM
        $this->view->formFilter = $formFilter = new Sitemulticurrency_Form_Admin_Filter();
        $page = $this->_getParam('page', 1);

        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $currencyTable = Engine_Api::_()->getDbtable('currencyrates', 'sitemulticurrency');
        $currencyTableName = $currencyTable->info('name');
        $this->view->baseCurrency = $baseCurrency = $coreSettings->getSetting('payment.currency', 'USD');

        //PROCESS FORM
        $values = array();
        if ($formFilter->isValid($this->_getAllParams())) {
            $values = $formFilter->getValues();
        }
        foreach ($values as $key => $value) {

            if (null == $value) {
                unset($values[$key]);
            }
        }
        //ALLOWED CURRENCIES FOR THE USER SIDE
        $alreadyAllowed = array();
        $alreadyAllowed = $coreSettings->getSetting('sitemulticurrency.allowed.currency', $baseCurrency);

        include APPLICATION_PATH . '/application/modules/Sitemulticurrency/controllers/license/license2.php';
 
        //CREATED SELECT FOR RATES TABLE
        $select = $currencyTable->select()
                ->from($currencyTableName);

        $result = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);
        $noOfRows = count($result);
        $this->view->baseCurrencyGlobalRate = 1; //API WE DOWNLOAD THE RATES FOR USD
        if($noOfRows) {
            $currencyRow = $currencyTable->fetchRow(array('code = ?' => $baseCurrency));
            $this->view->baseCurrencyGlobalRate = $currencyRow->global_rate;
        }
        

        //SEARCH BY CURRECNY NAME AND CODE
        if (isset($_POST['search'])) {

            $this->view->code = $searchParam['code'] = $this->_getParam('code');
            $this->view->name = $searchParam['name'] = $this->_getParam('name');

            if (!empty($searchParam['code']))
                $select->where($currencyTableName . '.code  LIKE ?', '%' . $searchParam['code'] . '%');
            if (!empty($searchParam['name']))
                $select->where($currencyTableName . '.currency_name  LIKE ?', '%' . $searchParam['name'] . '%');
        }

        //FETCH ONLY ALLOWED CURRENCIES RATE
        $select->where($currencyTableName . '.code IN(?)', $alreadyAllowed);

        $values = array_merge(array(
            'order' => 'code',
            'order_direction' => 'DESC',
                ), $values);

        $this->view->assign($values);
        $select->order((!empty($values['order']) ? $values['order'] : 'code' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

        $paginator = Zend_Paginator::factory($select);
        $totalItem = $paginator->getTotalItemCount();

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

        if (empty($noOfRows)) {
            $this->view->message = "Please Import The Rates";
        } else if (empty($totalItem) && (count($alreadyAllowed) > 1)) {
            $this->view->message = "No Currencies Found Related These Critria";
        } else {
            $this->view->message = "Please <a target='_blank' href='" . $view->url(array('module' => 'sitemulticurrency', 'controller' => 'manage', 'action' => 'index'), 'admin_default', true) . "'>allow</a> some currencies to view their rates.";
        }
        $paginator->setItemCountPerPage($paginator->getTotalItemCount());
        $this->view->paginator = $paginator->setCurrentPageNumber($page);
    }

    //ACTION TO SAVE CURRENCIES AFTER EDITING
    public function saveEditedAction() {
        $this->_helper->content->setNoRender()->setEnabled();
        $currencyTable = Engine_Api::_()->getDbtable('currencyrates', 'sitemulticurrency');
        $currencyTableName = $currencyTable->info('name');
        $from = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
        $values = $this->getRequest()->getPost();

        if (!$this->getRequest()->isPost())
            return;

        foreach ($values as $to => $newRate) {
            //RATE STORED IN DATABASE (GLOBAL RATE)
            $select = $currencyTable->select()
                    ->from($currencyTableName)
                    ->where($currencyTableName . '.code = ?', $to);
            $previousAppliedRate = $currencyTable->fetchRow($select)->applied_rate;

            //UPADTE ONLY THOSE CURRENCIES WHICH ARE CHANGED REALLY
            if (is_numeric($newRate) && $newRate > 0) {
                if ($newRate != $previousAppliedRate) {
                    $currencyTable->update(array('applied_rate' => trim($newRate), 'updation_date' => date('Y-m-d H:i:s')), array('code = ?' => $to));
                }
            }
        }

        $this->_redirect('admin/sitemulticurrency/manage/manage-rates');
    }

}
