<?php

class Sitemulticurrency_IndexController extends Core_Controller_Action_Standard {

    public function indexAction() {
        // Get available subscriptions
        $packagesTable = Engine_Api::_()->getDbtable('packages', 'payment');
        $package->_packages = $packagesTable->fetchAll();
        $multiOptions = array();
        foreach ($package->_packages as $package) {
            $multiOptions[$package->package_id] = $package->title
                    . ' (' . $this->getPackageDescription($package) . ')'
            ;
        }
        return $this->_helper->json($multiOptions);
    }

    public function getPackagePriceAction() {
        $sessionName = 'Payment_Subscription';
        $itemId = 'subscription_id';
        $itemType = 'payment_subscription';
        $session = new Zend_Session_Namespace($sessionName);
        $user_id = $session->user_id;

        //HERE WE CHANGE ID ACCRODING TO THE MODULE.
        $resourceId = $session->$itemId;
        //HERE WE GET OBJECT ACCRODING TO THE ITEM TYPE AND RESOURCE ID.
        $itemObject = Engine_Api::_()->getItem($itemType, $resourceId);
        $package = $itemObject->getPackage();
        $translate = Zend_Registry::get('Zend_Translate');
        $data = array();
        $str = '';
        if ($package) {
            if ($package->recurrence) {
                $str = $translate->translate('Please setup your subscription to continue:');
            } else {
                $str = $this->translate('Please pay a one-time fee to continue:');
            }
            $str .= $this->getPackageDescription($package);
        }
        $data['detail'] = $str;
        return $this->_helper->json($data);
    }

    public function getPackageDescription($package) {
        $translate = Zend_Registry::get('Zend_Translate');
        $currency = Engine_Api::_()->getApi('settings', 'core')->getSetting('payment.currency', 'USD');
        $view = Zend_Registry::get('Zend_View');


        $priceStr = Engine_Api::_()->sitemulticurrency()->convertCurrencyRate($package->price);

        // Plan is free
        if ($package->price == 0) {
            $str = $translate->translate('Free');
        }

        // Plan is recurring
        else if ($package->recurrence > 0 && $package->recurrence_type != 'forever') {

            // Make full string
            if ($package->recurrence == 1) { // (Week|Month|Year)ly
                $typeStr = $translate->translate($package->recurrence_type . 'ly');
                if ($package->recurrence_type == 'day') {
                    $typeStr = $translate->translate('daily');
                }
                $str = sprintf($translate->translate('%1$s %2$s'), $priceStr, $typeStr);
            } else { // per x (Week|Month|Year)s
                $typeStr = $translate->translate(array($package->recurrence_type, $package->recurrence_type . 's', $package->recurrence));
                $str = sprintf($translate->translate('%1$s per %2$s %3$s'), $priceStr, $package->recurrence, $typeStr); // @todo currency
            }
        }

        // Plan is one-time
        else {
            $str = sprintf($translate->translate('One-time fee of %1$s'), $priceStr);
        }

        // Add duration, if not forever
        if ($package->duration > 0 && $package->duration_type != 'forever') {
            $typeStr = $translate->translate(array($package->duration_type, $package->duration_type . 's', $package->duration));
            $str = sprintf($translate->translate('%1$s for %2$s %3$s'), $str, $package->duration, $typeStr);
        }

        return $str;
    }

    //ACTION TO LIST THE ALL ALLOWED CURRECNIES IN SITEMENU ICON CLICK
    public function currencyAction() {
        $this->view->allowed = Engine_Api::_()->getDbTable('currencyrates', 'sitemulticurrency')->getAllowedCurrencies();
    }

}
