<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Add.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Categories_Add extends Engine_Form
{

  public function init()
  {

    $category = null;
    $category_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('category_id', 0);
    $perform = Zend_Controller_Front::getInstance()->getRequest()->getParam('perform', 'add');
    $cat_dependency = 0;
    $subcat_dependency = 0;
    if( $category_id ) {
      $category = Engine_Api::_()->getItem('sitemusic_song_categories', $category_id);
      if( $category && empty($category->cat_dependency) ) {
        $cat_dependency = $category->category_id;
      } elseif( $category && !empty($category->cat_dependency) ) {
        $cat_dependency = $category->category_id;
        $subcat_dependency = $category->category_id;
      }
    }

    if( $perform == 'add' ) {
      if( empty($category_id) ) {
        $this
          ->setTitle('Add Category');
      } elseif( !empty($category_id) && empty($category->cat_dependency) ) {
        $this
          ->setTitle('Add Sub Category');
      }
    } elseif( $perform == 'edit' && !empty($category) ) {
      $category_name = $category->category_name;
      $this
        ->setTitle("Edit $category_name");
    }

    $this->addElement('Text', 'category_name', array(
      'label' => 'Name',
      'required' => true,
      'empty' => false,
      'value' => '',
    ));

    $this->addElement('Text', 'tagline', array(
      'label' => 'Tagline',
      'Description' => 'Please enter the content to be shown on banner image.',
      'allowEmpty' => true,
      'required' => false,
    ));

    $this->addElement('Textarea', 'meta_keywords', array(
      'label' => 'Meta Keywords',
      // 'required' => true,
      'value' => '',
    ));

    $this->addElement('File', 'icon', array(
      'label' => 'Icon',
      'Description' => 'Upload the icon. The recommended dimension for the icon is: 24 x 24 pixels.',
      'allowEmpty' => true,
      'required' => false,
    ));
    $this->icon->addValidator('Extension', false, 'jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG');

    $this->addElement('File', 'banner', array(
      'label' => 'Banner',
      'Description' => 'Upload the banner.',
      'allowEmpty' => true,
      'required' => false,
    ));
    $this->banner->addValidator('Extension', false, 'jpg,png,gif,jpeg,JPG,PNG,GIF,JPEG');

    $this->addElement('Button', 'submit', array(
      'label' => 'Add',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
