<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Global_Album extends Engine_Form
{

  public function init()
  {
    $this
      ->setTitle('Music Album Settings')
      ->setDescription('These settings will affect all the member levels of your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    $this->addElement('Radio', 'sitemusic_enable_albumfavourite', array(
      'label' => 'Favourite',
      'description' => 'Do you want to enable favourite feature for music albums?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.albumfavourite', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_albumshare', array(
      'label' => 'Share',
      'description' => 'Do you want to enable share option for music albums?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.albumshare', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_albumreport', array(
      'label' => 'Report',
      'description' => 'Do you want to enable report option?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.albumreport', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_albumrating', array(
      'label' => 'Rating',
      'description' => 'Do you want to enable rating feature for music albums?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'onclick' => 'showUpdateratingSetting(this.value)',
      'value' => $settings->getSetting('sitemusic.enable.albumrating', 1),
    ));

    $this->addElement('Radio', 'sitemusicalbumrating_update', array(
      'label' => 'Allow Updating of Rating?',
      'description' => "Do you want to let members to update their rating for music albums?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusicalbumrating.update', 1),
    ));

    $this->addElement('Radio', 'sitemusic_own_albumrating', array(
      'label' => 'Allow Owner to Rate their Music Album?',
      'description' => "Do you want to let members to rate their own music albums?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusic.own.albumrating', 1),
    ));

    $this->addElement('Radio', 'sitemusic_category_required', array(
      'label' => 'Music Album Category Required',
      'description' => 'Do you want to make a music album category field required?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.category.required', 0),
    ));

    // Get available files
    $coverPhotoOptions = Engine_Api::_()->sitemusic()->getImages(array('' => ''));

    $this->addElement('Select', 'sitemusic_albumcoverPhoto', array(
      'label' => 'Default Cover Photo',
      'description' => 'Select the default cover photo to be displayed on Music Album profile page. This photo will be visible to users as cover photo if they don’t upload any it themselves. (Note: You can upload the photo from: "Appearance" > "File & Media Manager".)',
      'multiOptions' => $coverPhotoOptions,
      'value' => $settings->getSetting('sitemusic.albumcoverPhoto'),
    ));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
