<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Artist.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Global_Artist extends Engine_Form
{

  public function init()
  {
    $url = $this->_attribs['url'];

    $this
      ->setTitle('Artist Settings')
      ->setDescription('These settings will affect all the member levels of your community.');

    $settings = Engine_Api::_()->getApi('settings', 'core');
    // Get The Value
    $values = $settings->sitemusic;

    $this->addElement('Radio', 'sitemusic_enable_artist', array(
      'label' => 'Allow Artists',
      'description' => 'Do you want to allow members to associate artists with songs being uploaded?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.artist', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_artistfavourite', array(
      'label' => 'Favourite',
      'description' => 'Do you want to enable favourite feature for artists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.artistfavourite', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_artistshare', array(
      'label' => 'Share',
      'description' => 'Do you want to enable share option for artists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.artistshare', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_artistreport', array(
      'label' => 'Report',
      'description' => 'Do you want to enable report option?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.artistreport', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_artistrating', array(
      'label' => 'Rating',
      'description' => 'Do you want to enable rating feature for artists?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'onclick' => 'showUpdateratingSetting(this.value)',
      'value' => $settings->getSetting('sitemusic.enable.artistrating', 1),
    ));

    $this->addElement('Radio', 'sitemusicartistrating_update', array(
      'label' => 'Allow Updating of Rating?',
      'description' => "Do you want to let members to update their rating for artists?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusicartistrating.update', 1),
    ));

    $this->addElement('Radio', 'sitemusic_artist_auto_approval', array(
      'label' => 'Automatically Approve Artists',
      'description' => 'Do you want to automatically approve artist added by your site members?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.user.artist', 1),
    ));

    // Get available files
    $coverPhotoOptions = Engine_Api::_()->sitemusic()->getImages(array('' => ''));

    $this->addElement('Select', 'sitemusic_artistcoverPhoto', array(
      'label' => 'Default Cover Photo',
      'description' => 'Select the default cover photo to be displayed on Artist profile page. This photo will be visible to users as cover photo if they don’t upload any it themselves. (Note: You can upload the photo from: "Appearance" > "File & Media Manager".)',
      'multiOptions' => $coverPhotoOptions,
      'value' => $settings->getSetting('sitemusic.artistcoverPhoto'),
    ));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
