<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Global_Song extends Engine_Form
{

  public function init()
  {
    $this
      ->setTitle('Song Settings')
      ->setDescription('These settings will affect all the member levels of your community.');


    $settings = Engine_Api::_()->getApi('settings', 'core');
    $this->addElement('Radio', 'sitemusic_enable_songfavourite', array(
      'label' => 'Favourite',
      'description' => 'Do you want to enable favourite feature for songs?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.songfavourite', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_songshare', array(
      'label' => 'Share',
      'description' => 'Do you want to enable share option for songs?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.songshare', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_songreport', array(
      'label' => 'Report',
      'description' => 'Do you want to enable report option?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.songreport', 1),
    ));

    $this->addElement('Radio', 'sitemusic_enable_songrating', array(
      'label' => 'Rating',
      'description' => 'Do you want to enable rating feature for songs?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'onclick' => 'showUpdateratingSetting(this.value)',
      'value' => $settings->getSetting('sitemusic.enable.songrating', 1),
    ));

    $this->addElement('Radio', 'sitemusicsongrating_update', array(
      'label' => 'Allow Updating of Rating?',
      'description' => "Do you want to let members to update their rating for songs?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusicsongrating.update', 1),
    ));

    $this->addElement('Radio', 'sitemusic_own_songrating', array(
      'label' => 'Allow Rate to own songs?',
      'description' => "Do you want to let members to rate their own songs?",
      'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
      'value' => $settings->getSetting('sitemusic.own.songrating', 1),
    ));

    $this->addElement('radio', 'sitemusic_url', array(
      'label' => 'Allow Song Upload via URL',
      'description' => 'Do you want to enable your site members to upload songs via external downloadable URL?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.url', 0),
    ));

    $this->addElement('Radio', 'sitemusic_enable_download', array(
      'label' => 'Songs Download',
      'description' => 'Do you want to enable download option for songs?',
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No',
      ),
      'value' => $settings->getSetting('sitemusic.enable.download', 1),
    ));

    // Get available files
    $coverPhotoOptions = Engine_Api::_()->sitemusic()->getImages(array('' => ''));

    $this->addElement('Select', 'sitemusic_songcoverPhoto', array(
      'label' => 'Default Cover Photo',
      'description' => 'Select the default cover photo to be displayed on Song profile page. This photo will be visible to users as cover photo if they don’t upload any it themselves. (Note: You can upload the photo from: "Appearance" > "File & Media Manager".)',
      'multiOptions' => $coverPhotoOptions,
      'value' => $settings->getSetting('sitemusic.songcoverPhoto'),
    ));

    // Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }

}
