<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: CategorieBannerContentSlideshow.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_AlbumCategorySlideshow extends Engine_Form
{

  public function init()
  {

    $this->addElement('Text', 'categoryHeight', array(
      'label' => "Enter the height of category image displaying in the slideshow.",
      'value' => 400
    ));

    $albumCategoryTable = Engine_Api::_()->getDbtable('albumcategories', 'sitemusic');
    $albumType = $albumCategoryTable->getCategoriesAssoc();
    if( !empty($albumType) ) {
      $this->addElement('MultiCheckbox', 'albumCategoryId', array(
        'label' => 'Choose the categories which you want to display in the slideshow.',
        'multiOptions' => $albumType,
      ));
    }
    $this->addElement('Radio', 'showExplore', array(
      'label' => "Do you want to show “Explore Now” button?",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 1,
    ));
    $this->addElement('Text', 'titleTruncation', array(
      'label' => "Truncation limit for category title.",
      'value' => 100,
    ));
    $this->addElement('Text', 'taglineTruncation', array(
      'label' => "Truncation limit for category tagline.",
      'value' => 200,
    ));
    $this->addElement('hidden', 'nomobile', array(
      'label' => '',
      'order' => 10001,
    ));
  }

}
