<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: CategorieBannerContentSlideshow.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_GenreSlideshow extends Engine_Form
{

  public function init()
  {
    $this->addElement('Text', 'categoryHeight', array(
      'label' => "Enter the height of genre image displaying in the slideshow.",
      'value' => 400
    ));

    $songCategoryTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
    $categories = $songCategoryTable->getCategoriesAssoc();

    $subCategories = $songCategoryTable->getSubCategoriesOnly();
    $genreType = $categories + $subCategories;
    if( count($genreType) > 0 ) {
      $this->addElement('MultiCheckbox', 'genreId', array(
        'label' => 'Choose the genres which you want to display in the slideshow.',
        'multiOptions' => $genreType,
      ));
    }
    $this->addElement('Radio', 'showExplore', array(
      'label' => "Do you want to show “Explore Now” button?",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => 1,
    ));

    $this->addElement('Text', 'titleTruncation', array(
      'label' => "Truncation limit for genre title.",
      'value' => 100,
    ));
    $this->addElement('Text', 'taglineTruncation', array(
      'label' => "Truncation limit for genre tagline.",
      'value' => 200,
    ));
    $this->addElement('hidden', 'nomobile', array(
      'label' => '',
      'order' => 10001,
    ));
  }

}


