<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: CategorieBannerContentSlideshow.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Admin_Widget_Tracks extends Engine_Form
{

  public function init()
  {
    $entities = Engine_Api::_()->getDbtable('entities', 'sitemusic')->getEntity();
    if( isset($entities['song']) ) {
      unset($entities['song']);
    }
    $this->addElement('Select', 'entity_type', array(
      'label' => 'choose the entity type',
      'description' => 'Select the music entity (album,artist and playlist) whose songs you want to display on the respective profile page.',
      'multiOptions' => $entities,
      'value' => 'album',
    ));

    $this->addElement('Text', 'titleTruncationLimit', array(
      'label' => 'Title Truncation Limit',
      'value' => '100',
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0))),
    ));

    $this->addElement('Radio', 'showViewMore', array(
      'label' => 'Show “View More”',
      'description' => '',
      'multiOptions' => array(
        '1' => 'Yes',
        '0' => 'No'),
      'value' => 1,
    ));

    $this->addElement('Text', 'limit', array(
      'label' => 'Count',
      'description' => '(number of items to show)',
      'value' => 5,
    ));
  }

}

?>
