<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Editinfo.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Form_Editinfo extends Engine_Form
{

  protected $_isArray = true;

  public function init()
  {
    $user = Engine_Api::_()->user()->getViewer();
    $songId = $this->_attribs['song_id'];
    $this->clearDecorators()
      ->addDecorator('FormElements');

    $this->addElement('Text', 'title', array(
      'label' => 'Song Title',
      'onkeypress' => "assignSongId($songId)",
      'filters' => array(
        new Engine_Filter_Censor(),
        new Engine_Filter_HtmlSpecialChars(),
      ),
      'decorators' => array(
        'ViewHelper',
        array('HtmlTag', array('tag' => 'div', 'class' => 'albums_editphotos_title_input')),
        array('Label', array('tag' => 'div', 'placement' => 'PREPEND', 'class' => 'albums_editphotos_title')),
      ),
    ));

    $songCategoryTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
    $genereType = $songCategoryTable->getCategoriesAssoc();
    if( !empty($genereType) ) {
      $subType = $songCategoryTable->getSubCategoriesAssoc($genereType);
    }
    $genreOption = array("0" => " ");
    if( !empty($subType) ) {
      $genreOption = $genreOption + $subType;
    }
    if( count($genereType) > 0 ) {
      $this->addElement('Select', 'genre_id', array(
        'label' => 'Genre',
        'multiOptions' => $genreOption,
        'decorators' => array(
          'ViewHelper',
          array('HtmlTag', array('tag' => 'div', 'class' => 'albums_editphotos_title_input')),
          array('Label', array('tag' => 'div', 'placement' => 'PREPEND', 'class' => 'albums_editphotos_title')),
        ),
      ));
    }
  if(Engine_Api::_()->sitemusic()->isArtistEnabled()) {
    $this->addElement('Text', 'item_title', array(
      'label' => 'Artist',
      'Placeholder' => 'Start typing the name of artist...',
      'filters' => array(
        new Engine_Filter_Censor(),
        new Engine_Filter_HtmlSpecialChars(),
      ),
      'decorators' => array(
        'ViewHelper',
        array('HtmlTag', array('tag' => 'div', 'class' => 'albums_editphotos_title_input')),
        array('Label', array('tag' => 'div', 'placement' => 'PREPEND', 'class' => 'albums_editphotos_title')),
      ),
    ));
  }

    $this->addElement('Hidden', 'artistName', array(
      'value' => '',
    ));

    $this->addElement('Text', 'tags', array(
      'label' => 'Tags (Keywords)',
      'autocomplete' => 'off',
      'description' => 'Separate tags with commas.',
      'filters' => array(
        'StripTags',
        new Engine_Filter_Censor(),
      ),
      'decorators' => array(
        'ViewHelper',
        array('HtmlTag', array('tag' => 'div', 'class' => 'albums_editphotos_title_input')),
        array('Label', array('tag' => 'div', 'placement' => 'PREPEND', 'class' => 'albums_editphotos_title')),
      ),
    ));

    $this->addElement('textarea', 'lyrics', array(
      'label' => 'Lyrics',
      'filters' => array(
        new Engine_Filter_Censor(),
        new Engine_Filter_HtmlSpecialChars(),
      ),
      'decorators' => array(
        'ViewHelper',
        array('HtmlTag', array('tag' => 'div', 'class' => 'albums_editphotos_title_input')),
        array('Label', array('tag' => 'div', 'placement' => 'PREPEND', 'class' => 'albums_editphotos_title')),
      ),
    ));
  }

}
