<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2021 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: LikeDateTimes.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Model_DbTable_LikeDatetimes extends Engine_Db_Table
{

  protected $_name = 'sitemusic_like_datetimes';

  public function setDateTime($likeId)
  {
    $db = $this->getAdapter();
    $db->beginTransaction();
    try {
      $likeResult = $this->fetchRow(array('like_id = ?' => $likeId));
      if(empty($likeResult)) {
        $likeDateTime = $this->createRow();
        $likeDateTime->like_id = $likeId;
        $likeDateTime->creation_date = date('Y-m-d H:i:s');
        $likeDateTime->save();
        $db->commit();
      }
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
  }

}
