<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Songartists.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Model_DbTable_Songartists extends Engine_Db_Table
{

  public function setSongArtist($params = array(), $playlist_id, $song_id)
  {
    if( !empty($params) ) {
      $query1 = $this->select()
        ->from($this)
        ->where('song_id = ?', $song_id)
        ->query()
        ->fetchAll();
      ;
      if( empty($query1) ) {

        $this->saveSongArtist($params, $playlist_id, $song_id);
      } else {

        foreach( $query1 as $q ) {
          $artistIds[] = $q['artist_id'];
        }
        $commonArtistIds = array_intersect($artistIds, $params);
        $diffArtistId = array_diff($artistIds, $commonArtistIds);
        if( !empty($diffArtistId) ) {
          foreach( $diffArtistId as $id ) {
            $this->delete(array('song_id = ?' => $song_id, 'artist_id = ?' => $id));
          }
        }
        $artist_ids = array_diff($params, $commonArtistIds);
        if( !empty($artist_ids) ) {
          $this->saveSongArtist($artist_ids, $playlist_id, $song_id);
        }
      }
    }
  }

  public function saveSongArtist($params = array(), $playlist_id, $song_id)
  {
    $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();

    foreach( $params as $artist_id ) {
      $songArtistMapTable = $this->createRow();
      $songArtistMapTable->artist_id = $artist_id;
      $songArtistMapTable->playlist_id = $playlist_id;
      $songArtistMapTable->song_id = $song_id;
      $songArtist = $songArtistMapTable->save();

      $artistId = $songArtist['artist_id'];
      $playlist = Engine_Api::_()->getItem('sitemusic_pl', $playlist_id);
      $artist = Engine_Api::_()->getItem('sitemusic_artist', $artistId);
      $followTable = Engine_Api::_()->getDbTable('follows', 'sitemusic');
      $followers = $followTable->getFollowers('sitemusic_artist', $artistId, $viewerId);
      if( $followers ) {
        foreach( $followers as $result ) {
          $id = $result['poster_id'];
          $user = Engine_Api::_()->getItem('user', $id);
          Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($user, $artist, $playlist, 'artist_song_new');
        }
      }
    }
  }

  public function getArtist($songId)
  {
    $saName = $this->info('name');
    $artistTable = Engine_Api::_()->getDbTable('artists', 'sitemusic');
    $aName = $artistTable->info('name');
    $select = $artistTable->select()->from($aName);
    $select->join($saName, "$aName.artist_id = $saName.artist_id", '');
    $select->where('song_id = ?', $songId);
    $artist = $select->query()->fetchAll();
    return $artist;
  }

  public function checkArtistMapping($artists, $songId, $playlistId)
  {
    //did to fix warning
    if(!is_array($artists)) {
      $artists = array();
    }
    $artistTable = Engine_Api::_()->getDbTable('artists', 'sitemusic');
    $artistId = array();
    $newArtistIds = array();
    $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    foreach( $artists as $artist ) {
      $select = $artistTable->select();
      $select->where('title LIKE ?', "%{$artist}%");
      $select->where('soundex_value = ?', soundex($artist));
      $artistExist = $select->query()->fetch();
      if( empty($artistExist['artist_id']) && !isset($artistExist['artist_id']) ) {
        // check auto approval setting enable or not
        $enableAutoApprove = Engine_Api::_()->sitemusic()->enableArtistAutoApproval();
        if( $enableAutoApprove ) {
          $approve = 1;
        } else {
          $approve = 0;
        }
        $artistRow = $artistTable->createRow();
        $artistRow->title = trim($artist);
        $artistRow->owner_id = $viewerId;
        $artistRow->owner_type = 'user';
        $artistRow->soundex_value = soundex($artist);
        $artistRow->approved = $approve;
        $newArtistId = $artistRow->save();
        $artistIdParam[] = $newArtistId;
        $newArtistIds[] = $newArtistId;
        unset($artistId);
      } else {
        unset($artistId);
        $aId = $artistExist['artist_id'];
        $artistIdParam[] = $aId;
      }
    }

    if( !empty($artistIdParam) && isset($artistIdParam) ) {
      $this->setSongArtist($artistIdParam, $playlistId, $songId);
    }
    return $newArtistIds;
  }

}
