<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminModulesController.php 6590 2015-1-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_AdminModulesController extends Core_Controller_Action_Admin
{

  protected $_enabledModuleNames;

  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sm_admin_main', array(), 'sm_admin_main_modules');
    $this->view->integrated = $integrated = Engine_Api::_()->getDbtable('modules', 'sitemusic')->getIntegratedModules();
  }

  public function addAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sm_admin_main', array(), 'sm_admin_main_modules');

    $this->view->form = $form = new Sitemusic_Form_Admin_Module_Add();
     $request = Zend_Controller_Front::getInstance()->getRequest();
     $this->view->module = $module = $request->getParam('resource_module', null);
     $this->view->resource_type = $request->getParam('resource_type', null);
    // Check method/data
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $values = $form->getValues();
      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        try{
        $integratedTable = Engine_Api::_()->getDbtable('modules', 'sitemusic');
        echo $values['resource_type'];
        echo "<br>";
        $resourceTypeTable = Engine_Api::_()->getItemTable($values['resource_type']);
        } catch(Exception $e ) {
          echo $e->getMessage();
          die;
        }
        $primaryId = current($resourceTypeTable->info("primary"));
        if( !empty($primaryId) ) {
          $values['resource_id'] = $primaryId;
        }
        $row = $integratedTable->createRow();
        $row->setFromArray($values);
        $row->save();

        foreach( $values as $key => $value ) {
          Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
        }

        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      $this->_redirect('admin/sitemusic/modules');
    }
  }

  public function editAction()
  {

    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sm_admin_main', array(), 'sm_admin_main_modules');

    $id = Zend_Controller_Front::getInstance()->getRequest()->getParam('id', null);
    $integratedTable = Engine_Api::_()->getDbTable('modules', 'sitemusic');
    $integratedTableResult = $integratedTable->fetchRow(array('module_id = ?' => $id));
    $integratedRowValues = $integratedTableResult->toArray();
    $resource_module = Zend_Controller_Front::getInstance()->getRequest()->getParam('resource_module', null);
    $this->view->form = $form = new Sitemusic_Form_Admin_Module_Edit();
    if( isset($integratedRowValues['resource_membertype']) && !empty($integratedRowValues['resource_membertype']) ) {
      $integratedRowValues['resource_membertype'] = unserialize($integratedRowValues['resource_membertype']);
    }
    $form->populate($integratedRowValues);

    if( $this->getRequest()->isPost() && !$form->isValid($this->getRequest()->getPost()) ) {
      if( $resource_module == 'sitereview' ) {
        $form->resource_module->setValue('sitereview');
        $form->resource_type->setValue('sitereview_listing');
      } else {
        $form->resource_module->setValue($resource_module);
        $form->resource_type->setValue($integratedRowValues->resource_type);
      }
      $form->resource_module->setAttrib('disable', true);
      $form->resource_type->setAttrib('disable', true);
      return;
    }

    $form->resource_module->setAttrib('disable', true);
    $form->resource_type->setAttrib('disable', true);

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $values = $form->getValues();
      $resource_type = $integratedTableResult->resource_type;
      $resource_module = $integratedTableResult->resource_module;
      $resource_id = $integratedTableResult->resource_id;
      $type = $resource_module . 'playlist_playlist';
      unset($values['resource_module']);
      unset($values['resource_type']);
      if( isset($values['resource_membertype']) && !empty($values['resource_membertype']) )
        $values['resource_membertype'] = serialize($values['resource_membertype']);


      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {
        $integratedTableResult->setFromArray($values);
        $integratedTableResult->save();

        foreach( $values as $key => $value ) {
          Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
        }

        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      $this->_redirect('admin/sitemusic/modules');
    }
  }

  public function deleteAction()
  {
    $this->_helper->layout->setLayout('admin-simple');
    $this->view->id = $id = $this->_getParam('id');
    $integratedTable = Engine_Api::_()->getDbtable('modules', 'sitemusic');
    $integratedTableSelect = $integratedTable->fetchRow(array('module_id = ?' => $id));
    $this->view->module = $integratedTableSelect->resource_module;
    if( $this->getRequest()->isPost() ) {
      $integratedTableSelect->delete();
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
      ));
    }
  }

  public function enabledDisabledAction()
  {
    $id = $this->_getParam('id');
    $coreModuleTable = Engine_Api::_()->getDbtable('modules', 'core');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    $table = Engine_Api::_()->getDbtable('modules', 'sitemusic');
    $select = $table->select()->where('module_id =?', $id);
    $content = $table->fetchRow($select);
    $enabled = $content->enabled;
    $integrated = $content->integrated;
    $projectParams = '{"title":"Music","itemCountPerPage":"10","margin_project":"2","projectOption":["title","owner","creationDate","view","like","comment","favourite","facebook","twitter","linkedin","googleplus"],"projectHeight":"265","projectWidth":"283","show_content":"2","nomobile":"0","name":"sitemusic.contenttype-music"}';
    if( $content->enabled == 0 && $content->integrated == 0 ) {
      $resource_type = $content->resource_type;
      $resource_module = $content->resource_module;
      $resource_id = $content->resource_id;
      $name = $resource_module . '_admin_main_managemusic';
      $db->query("UPDATE `engine4_core_menuitems` SET `enabled` = '1' WHERE `engine4_core_menuitems`.`name` = '$name';");

      if( $resource_module == 'sitepage' || $resource_module == 'sitebusiness' || $resource_module == 'sitegroup' ) {

        $type = $resource_module . 'playlist_playlist';
        $explodedArray = explode('_', $resource_id);
        $itemShortType = 'getWidgetized' . ucfirst($explodedArray[0]);
        if( Engine_Api::_()->$resource_module()->$itemShortType() ) {
          $page_id = Engine_Api::_()->$resource_module()->$itemShortType()->page_id;
        }
        Engine_Api::_()->getDbtable('admincontent', $resource_module)->setAdminDefaultInfo('sitemusic.contenttype-music', $page_id, 'Music', 'true', '117', $projectParams);
        if( Engine_Api::_()->hasModuleBootstrap('sitemobile') ) {
          $itemMobileShortType = 'getMobileWidgetized' . ucfirst($explodedArray[0]);

          $mobilepage_id = Engine_Api::_()->$resource_module()->$itemMobileShortType()->page_id;
          if( $mobilepage_id ) {
            Engine_Api::_()->getDbtable('mobileadmincontent', $resource_module)->setAdminDefaultInfo('sitemusic.contenttype-music', $mobilepage_id, 'Music', 'true', '117', $projectParams);

            Engine_Api::_()->getApi('mobilelayoutcore', $resource_module)->setContentDefaultInfo('sitemusic.contenttype-music', $mobilepage_id, 'Music', 'true', '117', $projectParams);
          }
        }


        Engine_Api::_()->getApi('layoutcore', $resource_module)->setContentDefaultInfo('sitemusic.contenttype-music', $page_id, 'Music', 'true', '117', $projectParams);

        if( $resource_module == 'sitepage' ) {

          //GET SITEPAGE CONTENT TABLE
          $sitepagecontentTable = Engine_Api::_()->getDbtable('content', 'sitepage');
          //GET SITEPAGE CONTENT PAGES TABLE
          $sitepagepageTable = Engine_Api::_()->getDbtable('contentpages', 'sitepage');
          $selectsitepagePage = $sitepagepageTable->select()
            ->from($sitepagepageTable->info('name'), array('contentpage_id'))
            ->where('name =?', 'sitepage_index_view');
          $contentpages_id = $selectsitepagePage->query()->fetchAll();
          foreach( $contentpages_id as $key => $value ) {
            $sitepagecontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['contentpage_id'], 'Music', 'true', '117', $projectParams);
          }

          if( Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$resource_module()->getMobileWidgetizedPage() ) {

            //GET SITEPAGE CONTENT TABLE
            $sitepagemobilecontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitepage');
            //GET SITEPAGE CONTENT PAGES TABLE
            $sitepagemobilecontentpagesTable = Engine_Api::_()->getDbtable('mobileContentpages', 'sitepage');
            $selectsitepagemobilePage = $sitepagemobilecontentpagesTable->select()
              ->from($sitepagemobilecontentpagesTable->info('name'), array('mobilecontentpage_id'))
              ->where('name =?', 'sitepage_index_view');
            $contentmobilepages_id = $selectsitepagemobilePage->query()->fetchAll();
            foreach( $contentmobilepages_id as $key => $value ) {
              $sitepagemobilecontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['mobilecontentpage_id'], 'Music', 'true', '117', $projectParams);
            }
          }

          $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'sitemusic.playlist.leader.owner.sitepage.page', '1');");
          if( Engine_Api::_()->sitepage()->hasPackageEnable() ) {
            Engine_Api::_()->sitepage()->oninstallPackageEnableSubMOdules('sitemusic');
          }
        } elseif( $resource_module == 'sitebusiness' ) {
          //GET SITEBUSINESS CONTENT TABLE
          $sitebusinesscontentTable = Engine_Api::_()->getDbtable('content', 'sitebusiness');
          //GET SITEBUSINESS CONTENT PAGES TABLE
          $sitebusinessbusinessTable = Engine_Api::_()->getDbtable('contentbusinesses', 'sitebusiness');
          $selectsitebusinessBusiness = $sitebusinessbusinessTable->select()
            ->from($sitebusinessbusinessTable->info('name'), array('contentbusiness_id'))
            ->where('name =?', 'sitebusiness_index_view');
          $contentbusinesses_id = $selectsitebusinessBusiness->query()->fetchAll();
          foreach( $contentbusinesses_id as $key => $value ) {
            $sitebusinesscontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['contentbusiness_id'], 'Music', 'true', '117', $projectParams);
          }

          if( Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$resource_module()->getMobileWidgetizedBusiness() ) {
            //GET SITEBUSINESS CONTENT TABLE
            $sitebusinesscontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitebusiness');
            //GET SITEBUSINESS CONTENT PAGES TABLE
            $sitebusinessbusinessTable = Engine_Api::_()->getDbtable('mobileContentbusinesses', 'sitebusiness');
            $selectsitebusinessBusiness = $sitebusinessbusinessTable->select()
              ->from($sitebusinessbusinessTable->info('name'), array('mobilecontentbusiness_id'))
              ->where('name =?', 'sitebusiness_index_view');
            $contentbusinesses_id = $selectsitebusinessBusiness->query()->fetchAll();
            foreach( $contentbusinesses_id as $key => $value ) {
              $sitebusinesscontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['mobilecontentbusiness_id'], 'Music', 'true', '117', $projectParams);
            }
          }


          $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'sitemusic.playlist.leader.owner.sitebusiness.business', '1');");
          if( Engine_Api::_()->sitebusiness()->hasPackageEnable() ) {
            Engine_Api::_()->sitebusiness()->oninstallPackageEnableSubMOdules('sitemusic');
          }
        } elseif( $resource_module == 'sitegroup' ) {
          //GET SITEGROUP CONTENT TABLE
          $sitegroupcontentTable = Engine_Api::_()->getDbtable('content', 'sitegroup');
          //GET SITEGROUP CONTENT PAGES TABLE
          $sitegroupgroupTable = Engine_Api::_()->getDbtable('contentgroups', 'sitegroup');
          $selectsitegroupGroup = $sitegroupgroupTable->select()
            ->from($sitegroupgroupTable->info('name'), array('contentgroup_id'))
            ->where('name =?', 'sitegroup_index_view');
          $contentgroups_id = $selectsitegroupGroup->query()->fetchAll();
          foreach( $contentgroups_id as $key => $value ) {
            $sitegroupcontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['contentgroup_id'], 'Music', 'true', '117', $projectParams);
          }
          $db->query("INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( 'sitemusic.playlist.leader.owner.sitegroup.group', '0');");
          if( Engine_Api::_()->sitegroup()->hasPackageEnable() ) {
            Engine_Api::_()->sitegroup()->oninstallPackageEnableSubMOdules('sitemusic');
          }

          if( Engine_Api::_()->hasModuleBootstrap('sitemobile') && Engine_Api::_()->$resource_module()->getMobileWidgetizedGroup() ) {
            //GET SITEGROUP CONTENT TABLE
            $sitegroupcontentTable = Engine_Api::_()->getDbtable('mobileContent', 'sitegroup');
            //GET SITEGROUP CONTENT PAGES TABLE
            $sitegroupgroupTable = Engine_Api::_()->getDbtable('mobileContentgroups', 'sitegroup');
            $selectsitegroupGroup = $sitegroupgroupTable->select()
              ->from($sitegroupgroupTable->info('name'), array('mobilecontentgroup_id'))
              ->where('name =?', 'sitegroup_index_view');
            $contentgroups_id = $selectsitegroupGroup->query()->fetchAll();
            foreach( $contentgroups_id as $key => $value ) {
              $sitegroupcontentTable->setDefaultInfo('sitemusic.contenttype-music', $value['mobilecontentgroup_id'], 'Music', 'true', '117', $projectParams);
            }
          }
        }

        $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions`
						SELECT level_id as `level_id`,
							"' . $resource_type . '" as `type`,
							"auth_samcreate" as `name`,
							5 as `value`,
							\'["registered","owner_network","owner_member_member","owner_member","owner","member","like_member"]\' as `params`
						FROM `engine4_authorization_levels` WHERE `type` NOT IN("public");
					');
        $db->query('
						INSERT IGNORE INTO `engine4_authorization_permissions`
						SELECT level_id as `level_id`,
							"' . $resource_type . '" as `type`,
							"samcreate" as `name`,
							1 as `value`,
							NULL as `params`
						FROM `engine4_authorization_levels`;
					');

        $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

        $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'view' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

        $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						2 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('moderator', 'admin');");

        $db->query("INSERT IGNORE INTO `engine4_authorization_permissions`
					SELECT
						level_id as `level_id`,
						'$type' as `type`,
						'comment' as `name`,
						1 as `value`,
						NULL as `params`
					FROM `engine4_authorization_levels` WHERE `type` IN('user');");

        $db->query("INSERT IGNORE INTO `engine4_authorization_permissions` (`level_id`, `type`, `name`, `value`, `params`) VALUES ('5', '$type', 'view', '1', NULL);");
      }
    }

    try {
      $content->enabled = !$content->enabled;
      $content->integrated = 1;
      $content->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitemusic/modules');
  }

}
