<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    AdminSettingsController.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_AdminSettingsController extends Core_Controller_Action_Admin
{

  public function init()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_settings');
  }

  public function indexAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main_globalsettings', array(), 'sm_admin_mainsetting_global');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'core', 'controller' => 'files'), 'file & media manager');
    $this->view->form = $form = new Sitemusic_Form_Admin_Global_Global(array('url' => $url));
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $this->setValues($form);
    }
  }

  public function albumSettingsAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main_globalsettings', array(), 'sm_admin_mainsetting_album');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'core', 'controller' => 'files'), 'file & media manager');
    $this->view->form = $form = new Sitemusic_Form_Admin_Global_Album(array('url' => $url));
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $this->setValues($form);
    }
  }

  public function songSettingsAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main_globalsettings', array(), 'sm_admin_mainsetting_song');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'core', 'controller' => 'files'), 'file & media manager');
    $this->view->form = $form = new Sitemusic_Form_Admin_Global_Song(array('url' => $url));
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $this->setValues($form);
    }
  }

  public function setValues($form)
  {
    $values = $form->getValues();
    $setting = Engine_Api::_()->getApi('settings', 'core');

    foreach( $values as $key => $value ) {
      $setting->setSetting($key, $value);
    }
    $form->addNotice('Your changes have been saved.');
  }

  public function playlistSettingsAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main_globalsettings', array(), 'sm_admin_mainsetting_playlist');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'core', 'controller' => 'files'), 'file & media manager');
    $this->view->form = $form = new Sitemusic_Form_Admin_Global_Playlist(array('url' => $url));
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues();
      $menuItemApi = Engine_Api::_()->getDbtable('menuItems', 'core');
      $entityTable = Engine_Api::_()->getDbtable('entities', 'sitemusic');
      if( !$values['sitemusic_enable_playlist'] ) {
        $menuItemApi->update(array('enabled' => 0), array('name = ?' => 'sitemusic_main_browse_playlist', 'module = ?' => 'sitemusic'));
        $menuItemApi->update(array('enabled' => 0), array('name = ?' => 'sitemusic_user_playlist', 'module = ?' => 'sitemusic'));
        $entityTable->update(array('enabled' => 0), array('name = ?' => 'playlist'));
      } else {
        $menuItemApi->update(array('enabled' => 1), array('name = ?' => 'sitemusic_main_browse_playlist', 'module = ?' => 'sitemusic'));
        $menuItemApi->update(array('enabled' => 1), array('name = ?' => 'sitemusic_user_playlist', 'module = ?' => 'sitemusic'));
        $entityTable->update(array('enabled' => 1), array('name = ?' => 'playlist'));
      }
      $setting = Engine_Api::_()->getApi('settings', 'core');

      foreach( $values as $key => $value ) {
        $setting->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function artistSettingsAction()
  {
    $this->view->subnavigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main_globalsettings', array(), 'sm_admin_mainsetting_artist');

    $url = $this->view->htmlLink(array('route' => 'admin_default', 'module' => 'core', 'controller' => 'files'), 'file & media manager');
    $this->view->form = $form = new Sitemusic_Form_Admin_Global_Artist(array('url' => $url));
    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues();
      $menuItemApi = Engine_Api::_()->getDbtable('menuItems', 'core');
      $entityTable = Engine_Api::_()->getDbtable('entities', 'sitemusic');
      if( !$values['sitemusic_enable_artist'] ) {
        $menuItemApi->update(array('enabled' => 0), array('name = ?' => 'sitemusic_main_browse_artist', 'module = ?' => 'sitemusic'));
        $menuItemApi->update(array('enabled' => 0), array('name = ?' => 'sitemusic_user_artist', 'module = ?' => 'sitemusic'));
        $entityTable->update(array('enabled' => 0), array('name = ?' => 'artist'));
      } else {
        $menuItemApi->update(array('enabled' => 1), array('name = ?' => 'sitemusic_user_artist', 'module = ?' => 'sitemusic'));
        $menuItemApi->update(array('enabled' => 1), array('name = ?' => 'sitemusic_main_browse_artist', 'module = ?' => 'sitemusic'));
        $entityTable->update(array('enabled' => 1), array('name = ?' => 'artist'));
      }

      $setting = Engine_Api::_()->getApi('settings', 'core');

      foreach( $values as $key => $value ) {
        $setting->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
  }

  public function artistAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_artistcategories');

    $isArtistEnable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic.enable.artist', 1);
    if( !$isArtistEnable ) {
      $this->view->artistNotEnable = true;
    }

    $this->view->artists = Engine_Api::_()->getItemTable('sitemusic_artist')->fetchAll();
  }

  public function addArtistAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');

    // Generate and assign form
    $form = $this->view->form = new Sitemusic_Form_Admin_Artistform();
    $form->setAction($this->view->url(array()));

    // Check post
    if( !$this->getRequest()->isPost() ) {
      $this->renderScript('admin-settings/form.tpl');
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->renderScript('admin-settings/form.tpl');
      return;
    }

    // Process
    $values = $form->getValues();

    $viewer = Engine_Api::_()->user()->getViewer();
    $table = Engine_Api::_()->getDbtable('artists', 'sitemusic');
    $db = $table->getAdapter();
    $db->beginTransaction();
    // Update row
    try {
      $artist = $table->createRow();
      $artist->owner_id = $viewer->getIdentity();
      $artist->owner_type = 'user';
      $artist->title = $values['label'];
      $artist->soundex_value = soundex($values['label']);
      $artist->description = $values['description'];
      $artist->approved = 1;
      if( !empty($values['profilephoto']) ) {
        $photo = Engine_Api::_()->getApi('core', 'sitemusic')->setPhoto($artist, $form->profilephoto);
        $artist->photo_id = $photo->photo_id;
      }
      if( !empty($values['coverphoto']) ) {
        $coverPhoto = $artist->setCoverPhoto($form->coverphoto);
        $artist->cover_photo_id = $coverPhoto->cover_photo_id;
      }
      $artist->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  //ACTION FOR DELETE THE GENERE
  public function deleteSubgenreAction()
  {

    $this->_helper->layout->setLayout('admin-simple');
    $categoryId = $this->_getParam('songcategory_id');
    $catDependency = $this->_getParam('cat_dependency');
    $category = Engine_Api::_()->getItem('sitemusic_songcategory', $categoryId);
    $this->view->category_id = $categoryId;

    $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Delete();

    //GET CATEGORIES TABLE
    $tableCategory = Engine_Api::_()->getDbTable('songcategories', 'sitemusic');
    $tableCategoryName = $tableCategory->info('name');

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    $db = $category->getTable()->getAdapter();
    $db->beginTransaction();

    try {

      $tableCategory->delete(array('cat_dependency = ?' => $categoryId));
      $tableCategory->delete(array('songcategory_id = ?' => $categoryId));
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted.');
    return $this->_forward('success', 'utility', 'core', array(
        'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitemusic', 'controller' => 'settings', 'action' => 'categories'), "admin_default", true),
        'messages' => Array($this->view->message)
    ));
  }

  public function categoriesAction()
  {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_genrecategories');

    //GET sub tab
    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_managecategory', array(), 'sm_admin_managecategory_genre');

    $orientation = $this->view->layout()->orientation;
    if( $orientation == 'right-to-left' ) {
      $this->view->directionality = 'rtl';
    } else {
      $this->view->directionality = 'ltr';
    }

    //GET CATEGORIES TABLE
    $tableCategory = Engine_Api::_()->getDbtable('Songcategories', 'sitemusic');
    $tableCategoryName = $tableCategory->info('name');


    //GET TASK
    if( isset($_POST['task']) ) {
      $task = $_POST['task'];
    } elseif( isset($_GET['task']) ) {
      $task = $_GET['task'];
    } else {
      $task = "main";
    }


    if( $task == "changeorder" ) {
      $divId = $_GET['divId'];
      $sitemusicOrder = explode(",", $_GET['sitemusicorder']);
      //RESORT CATEGORIES
      if( $divId == "categories" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $songcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('songcategory_id = ?' => $songcategory_id));
        }
      } elseif( substr($divId, 0, 7) == "subcats" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $songcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('songcategory_id = ?' => $songcategory_id));
        }
      } elseif( substr($divId, 0, 11) == "treesubcats" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $songcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('songcategory_id = ?' => $songcategory_id));
        }
      }
    }

    //GET STORAGE API
    $this->view->storage = Engine_Api::_()->storage();

    $categories = array();
    $categoryInfo = $tableCategory->getCategories(null, 0, 1, 0, 1, 0, 'cat_order', 0, array('songcategory_id', 'category_name', 'cat_order', 'photo_id'));
    foreach( $categoryInfo as $value ) {
      $sub_cat_array = array();
      $subCategories = $tableCategory->getSubCategories($value->songcategory_id, array('songcategory_id', 'category_name', 'cat_order', 'photo_id'));
      foreach( $subCategories as $subCategory ) {
        $sub_cat_array[] = $tmp_array = array(
          'sub_cat_id' => $subCategory->songcategory_id,
          'sub_cat_name' => $subCategory->category_name,
          'photo_id' => $subCategory->photo_id,
          'order' => $subCategory->cat_order);
      }

      $categories[] = $category_array = array('songcategory_id' => $value->songcategory_id,
        'category_name' => $value->category_name,
        'order' => $value->cat_order,
        'file_id' => $value->photo_id,
        'sub_categories' => $sub_cat_array);
    }
    $this->view->categories = $categories;

    //GET CATEGORIES TABLE
    $tableCategory = Engine_Api::_()->getDbTable('Songcategories', 'sitemusic');
    $tableCategoryName = $tableCategory->info('name');
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $this->view->songcategory_id = $songCategory_id = $request->getParam('songcategory_id', 0);
    $perform = $request->getParam('perform', 'add');
    $catDependency = 0;
    if( $songCategory_id ) {
      $category = Engine_Api::_()->getItem('sitemusic_songcategory', $songCategory_id);
      if( $category && empty($category->cat_dependency) ) {
        $catDependency = $category->songcategory_id;
      }
    }

    if( $perform == 'add' ) {
      $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Add();
      $form->setTitle('Add Genre');
      //CHECK POST
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      //CHECK VALIDITY
      if( !$form->isValid($this->getRequest()->getPost()) ) {

        if( empty($_POST['category_name']) ) {
          $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
        }
        return;
      }
      //PROCESS
      $values = $form->getValues();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        $rowInfo = $tableCategory->fetchRow($tableCategory->select()->from($tableCategoryName, 'max(cat_order) AS cat_order'));
        $catOrder = $rowInfo['cat_order'] + 1;

        //GET CATEGORY TITLE
        $categoryName = str_replace("'", "\'", trim($values['category_name']));
        $values['cat_order'] = $catOrder;
        $values['category_name'] = $categoryName;
        $values['cat_dependency'] = $catDependency;

        $metaInfo = array();
        if( !empty($values['tagline']) ) {
          $metaInfo['tagline'] = $values['tagline'];
        }

        if( !empty($values['meta_keywords']) ) {
          $metaInfo['meta_keywords'] = $values['meta_keywords'];
        }

        if( !empty($metaInfo) ) {
          $metaInfo = Zend_Json::encode($metaInfo);
          $values['params'] = $metaInfo;
        }
        $row = $tableCategory->createRow();
        $row->setFromArray($values);
        if( empty($row) )
          return;

        //UPLOAD BANNER
        if( isset($_FILES['banner']['name']) && !empty($_FILES['banner']['name']) ) {
          $categoryBanner = Engine_Api::_()->getApi('core', 'sitemusic')->setCoverPhoto($row, $form->banner);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryBanner->file_id) ) {
            $row->photo_id = $categoryBanner->file_id;
          }
        }
        //UPLOAD ICON
        if( isset($_FILES['icon']['name']) && !empty($_FILES['icon']['name']) ) {
          $categoryIcon = $row->setPhoto($form->icon);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryIcon->file_id) ) {
            $row->file_id = $categoryIcon->file_id;
          }
        }

        $songCategory_id = $row->save();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      return $this->_helper->redirector->gotoRoute(array('module' => 'sitemusic', 'action' => 'categories', 'controller' => 'settings', 'songcategory_id' => $songCategory_id, 'perform' => 'edit'), 'admin_default', true);
    } else {
      $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Edit();
      $form->setTitle('Add Genre');
      $category = Engine_Api::_()->getItem('sitemusic_songcategory', $songCategory_id);
      $metaInfo = $category->params;
      if( $metaInfo ) {
        $metaInfo = Zend_Json::decode($metaInfo);
        if( is_array($metaInfo) ) {
          $form->populate($metaInfo);
        }
      }
      $form->populate($category->toArray());

      //CHECK POST
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      //CHECK VALIDITY
      if( !$form->isValid($this->getRequest()->getPost()) ) {

        if( empty($_POST['category_name']) ) {
          $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
        }
        return;
      }
      $values = $form->getValues();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //GET CATEGORY TITLE
        $categoryName = str_replace("'", "\'", trim($values['category_name']));

        $category->category_name = $categoryName;

        $metaInfo = array();
        if( !empty($values['tagline']) ) {
          $metaInfo['tagline'] = $values['tagline'];
        }

        if( !empty($values['meta_keywords']) ) {
          $metaInfo['meta_keywords'] = $values['meta_keywords'];
        }

        if( !empty($metaInfo) ) {
          $metaInfo = Zend_Json::encode($metaInfo);
          $category->params = $metaInfo;
        }
        $catDependency = $category->cat_dependency;
        if( $songCategory_id && !empty($catDependency) ) {
          $catDependency = $catDependency;
        } elseif( $songCategory_id && !empty($catDependency) ) {
          $catDependency = $catDependency;
        }

        $category->cat_dependency = $catDependency;

        //UPLOAD BANNER
        if( isset($_FILES['banner']['name']) && !empty($_FILES['banner']['name']) ) {
          $previousFileId = $category->photo_id;
          $categoryBanner = $category->setPhoto($form->banner);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryBanner->file_id) ) {

            //DELETE PREVIOUS CATEGORY ICON
            if( $previousFileId ) {
              $file = Engine_Api::_()->getItem('storage_file', $previousFileId);
              $file->delete();
            }

            $category->photo_id = $categoryBanner->file_id;
            $category->save();
          }
        }

        //UPLOAD ICON
        if( isset($_FILES['icon']['name']) && !empty($_FILES['icon']['name']) ) {
          $previousFileId = $category->file_id;
          $categoryIcon = $category->setPhoto($form->icon);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryIcon->file_id) ) {

            //DELETE PREVIOUS CATEGORY ICON
            if( $previousFileId ) {
              $file = Engine_Api::_()->getItem('storage_file', $previousFileId);
              $file->delete();
            }

            $category->file_id = $categoryIcon->file_id;
            $category->save();
          }
        }

        $category->save();

        if( isset($values['removeicon']) && !empty($values['removeicon']) ) {

          $previousIconId = $category->photo_id;

          if( $previousIconId ) {
            //UPDATE FILE ID IN CATEGORY
            // TABLE
            $category->photo_id = 0;
            $category->save();

            //DELETE CATEGORY ICON
            $file = Engine_Api::_()->getItem('storage_file', $previousIconId);
            $file->delete();
          }
        }
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      $form->addNotice('Your changes have been saved.');
      return $this->_helper->redirector->gotoRoute(array('module' => 'sitemusic', 'action' => 'categories', 'controller' => 'settings', 'songcategory_id' => $songCategory_id, 'perform' => 'edit'), 'admin_default', true);
    }
  }

  public function deleteGenreAction()
  {
    $this->_helper->layout->setLayout('admin-simple');
    $viewer = Engine_Api::_()->user()->getViewer();
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $this->view->catid = $catId = $this->_getParam('songcategory_id');
    $this->view->songcategory_id = $songCategory_id = $request->getParam('songcategory_id', 0);
    $category = Engine_Api::_()->getItem('sitemusic_songcategory', $songCategory_id);
    $tableCategory = Engine_Api::_()->getDbTable('songcategories', 'sitemusic');
//  if( !$this->_helper->requireAuth()->setAuthParams($blog, null, 'delete')->isValid()) return;
    // In smoothbox

    $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Delete();

    if( !$category ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_("Entry doesn't exist or not authorized to delete");
      return;
    }

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    $db = $category->getTable()->getAdapter();
    $db->beginTransaction();

    try {
      $category->delete();

      $rows = $tableCategory->getSubCategories($catId);
      foreach( $rows as $row ) {
        $row->delete();
      }
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted.');
    return $this->_forward('success', 'utility', 'core', array(
        'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitemusic', 'controller' => 'settings', 'action' => 'categories'), "admin_default", true),
        'messages' => Array($this->view->message)
    ));
  }

  public function albumcategoriesAction()
  {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_genrecategories');

    //GET sub tab
    $this->view->sub_navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_managecategory', array(), 'sm_admin_managecategory_album');

    $orientation = $this->view->layout()->orientation;
    if( $orientation == 'right-to-left' ) {
      $this->view->directionality = 'rtl';
    } else {
      $this->view->directionality = 'ltr';
    }

    $local_language = $this->view->locale()->getLocale()->__toString();
    $local_language = explode('_', $local_language);
    $this->view->language = $local_language[0];

    //GET CATEGORIES TABLE
    $tableCategory = Engine_Api::_()->getDbtable('Albumcategories', 'sitemusic');
    $tableCategoryName = $tableCategory->info('name');

    //GET TASK
    if( isset($_POST['task']) ) {
      $task = $_POST['task'];
    } elseif( isset($_GET['task']) ) {
      $task = $_GET['task'];
    } else {
      $task = "main";
    }


    if( $task == "changeorder" ) {
      $divId = $_GET['divId'];
      $sitemusicOrder = explode(",", $_GET['sitemusicorder']);
      //RESORT CATEGORIES
      if( $divId == "categories" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $albumcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('albumcategory_id = ?' => $albumcategory_id));
        }
      } elseif( substr($divId, 0, 7) == "subcats" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $albumcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('albumcategory_id = ?' => $albumcategory_id));
        }
      } elseif( substr($divId, 0, 11) == "treesubcats" ) {
        for( $i = 0; $i < count($sitemusicOrder); $i++ ) {
          $albumcategory_id = substr($sitemusicOrder[$i], 4);
          $tableCategory->update(array('cat_order' => $i + 1), array('albumcategory_id = ?' => $albumcategory_id));
        }
      }
    }



    //GET STORAGE API
    $this->view->storage = Engine_Api::_()->storage();

    $categories = array();
    $categoryInfo = $tableCategory->getCategories(null, 0, 1, 0, 1, 0, 'cat_order', 0, array('albumcategory_id', 'category_name', 'cat_order', 'photo_id'));
    foreach( $categoryInfo as $value ) {

      $categories[] = $category_array = array('albumcategory_id' => $value->albumcategory_id,
        'category_name' => $value->category_name,
        'order' => $value->cat_order,
        'file_id' => $value->photo_id,
      );
    }
    $this->view->categories = $categories;

    //GET CATEGORIES TABLE
    $tableCategory = Engine_Api::_()->getDbTable('Albumcategories', 'sitemusic');
    $tableCategoryName = $tableCategory->info('name');
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $this->view->albumcategory_id = $albumCategory_id = $request->getParam('albumcategory_id', 0);
    $perform = $request->getParam('perform', 'add');

    if( $perform == 'add' ) {
      $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Add();

      //CHECK POST
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      //CHECK VALIDITY
      if( !$form->isValid($this->getRequest()->getPost()) ) {

        if( empty($_POST['category_name']) ) {
          $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
        }
        return;
      }
      //PROCESS
      $values = $form->getValues();
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        $rowInfo = $tableCategory->fetchRow($tableCategory->select()->from($tableCategoryName, 'max(cat_order) AS cat_order'));
        $catOrder = $rowInfo['cat_order'] + 1;

        //GET CATEGORY TITLE
        $categoryName = str_replace("'", "\'", trim($values['category_name']));
        $values['cat_order'] = $catOrder;
        $values['category_name'] = $categoryName;

        if( !empty($values['tagline']) ) {
          $metaInfo['tagline'] = $values['tagline'];
        }

        if( !empty($values['meta_keywords']) ) {
          $metaInfo['meta_keywords'] = $values['meta_keywords'];
        }

        if( !empty($metaInfo) ) {
          $metaInfo = Zend_Json::encode($metaInfo);
          $values['params'] = $metaInfo;
        }
        $row = $tableCategory->createRow();
        $row->setFromArray($values);
        if( empty($row) )
          return;

        //UPLOAD BANNER
        if( isset($_FILES['banner']['name']) && !empty($_FILES['banner']['name']) ) {
          $categoryBanner = Engine_Api::_()->getApi('core', 'sitemusic')->setCoverPhoto($row, $form->banner);
          //    $categoryBanner = $row->setPhoto($form->banner);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryBanner->file_id) ) {
            $row->photo_id = $categoryBanner->file_id;
          }
        }

        //UPLOAD ICON
        if( isset($_FILES['icon']['name']) && !empty($_FILES['icon']['name']) ) {
          $categoryIcon = $row->setPhoto($form->icon);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryIcon->file_id) ) {
            $row->file_id = $categoryIcon->file_id;
          }
        }

        $albumCategory_id = $row->save();
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      return $this->_helper->redirector->gotoRoute(array('module' => 'sitemusic', 'action' => 'albumcategories', 'controller' => 'settings', 'albumcategory_id' => $albumCategory_id, 'perform' => 'edit'), 'admin_default', true);
    } else {
      $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Edit();
      $category = Engine_Api::_()->getItem('sitemusic_albumcategory', $albumCategory_id);
      if( empty($category) )
        return;
      $metaInfo = $category->params;
      if( !empty($metaInfo) ) {
        $metaInfo = Zend_Json::decode($metaInfo);
      }

      if( $metaInfo ) {
        if( is_array($metaInfo) ) {
          $form->populate($metaInfo);
        }
      }
      $form->populate($category->toArray());

      //CHECK POST
      if( !$this->getRequest()->isPost() ) {
        return;
      }

      //CHECK VALIDITY
      if( !$form->isValid($this->getRequest()->getPost()) ) {

        if( empty($_POST['category_name']) ) {
          $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
        }
        return;
      }
      $values = $form->getValues();


      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

        //GET CATEGORY TITLE
        $categoryName = str_replace("'", "\'", trim($values['category_name']));
        $category->category_name = $categoryName;

        $metaInfo = array();
        if( !empty($values['tagline']) ) {
          $metaInfo['tagline'] = $values['tagline'];
        }

        if( !empty($values['meta_keywords']) ) {
          $metaInfo['meta_keywords'] = $values['meta_keywords'];
        }

        if( !empty($metaInfo) ) {
          $metaInfo = Zend_Json::encode($metaInfo);
          $category->params = $metaInfo;
        }

        //UPLOAD BANNER
        if( isset($_FILES['banner']['name']) && !empty($_FILES['banner']['name']) ) {
          $previousFileId = $category->photo_id;
          $categoryBanner = $category->setPhoto($form->banner);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryBanner->file_id) ) {

            //DELETE PREVIOUS CATEGORY ICON
            if( $previousFileId ) {
              $file = Engine_Api::_()->getItem('storage_file', $previousFileId);
              $file->delete();
            }

            $category->photo_id = $categoryBanner->file_id;
            $category->save();
          }
        }

        //UPLOAD ICON
        if( isset($_FILES['icon']['name']) && !empty($_FILES['icon']['name']) ) {
          $previousFileId = $category->file_id;
          $categoryIcon = $category->setPhoto($form->icon);
          //UPDATE FILE ID IN CATEGORY TABLE
          if( !empty($categoryIcon->file_id) ) {

            //DELETE PREVIOUS CATEGORY ICON
            if( $previousFileId ) {
              $file = Engine_Api::_()->getItem('storage_file', $previousFileId);
              $file->delete();
            }

            $category->file_id = $categoryIcon->file_id;
            $category->save();
          }
        }

        $category->save();

        if( isset($values['removeicon']) && !empty($values['removeicon']) ) {

          $previousIconId = $category->file_id;

          if( $previousIconId ) {
            //UPDATE FILE ID IN CATEGORY
            // TABLE
            $category->file_id = 0;
            $category->save();

            //DELETE CATEGORY ICON
            $file = Engine_Api::_()->getItem('storage_file', $previousIconId);
            $file->delete();
          }
        }
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      $form->addNotice('Your changes have been saved.');
      return $this->_helper->redirector->gotoRoute(array('module' => 'sitemusic', 'action' => 'albumcategories', 'controller' => 'settings', 'albumcategory_id' => $albumCategory_id, 'perform' => 'edit'), 'admin_default', true);
    }
  }

  public function deleteAlbumCategoryAction()
  {

    $this->_helper->layout->setLayout('admin-simple');
    $categoryId = $this->_getParam('albumcategory_id');
    $category = Engine_Api::_()->getItem('sitemusic_albumcategory', $categoryId);
    $this->view->category_id = $categoryId;

    $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Delete();

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }

    $db = $category->getTable()->getAdapter();
    $db->beginTransaction();

    try {

      $category->delete();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted.');
    return $this->_forward('success', 'utility', 'core', array(
        'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitemusic', 'controller' => 'settings', 'action' => 'albumcategories'), "admin_default", true),
        'messages' => Array($this->view->message)
    ));
  }

  public function labelcategoriesAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_labelcategories');
    $labelItem = Engine_Api::_()->getItemTable('sitemusic_label');
    $select = $labelItem->select();
    $select->order('label_order ASC');
    $this->view->labels = $labelItem->fetchAll($select);
  }

  public function addLabelcategoryAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');

    // Generate and assign form

    $form = $this->view->form = new Sitemusic_Form_Admin_Labelcategory();
    $form->setAction($this->view->url(array()));

    // Check post
    if( !$this->getRequest()->isPost() ) {
      $this->renderScript('admin-settings/label-form.tpl');
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      $this->renderScript('admin-settings/label-form.tpl');
      return;
    }
    // Process
    $values = $form->getValues();

    $viewer = Engine_Api::_()->user()->getViewer();
    $table = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $db = $table->getAdapter();
    $db->beginTransaction();
    // Update row
    try {
      $label = $table->createRow();
      $label->label_name = $values['label_name'];
//      if( is_numeric($values['label_order']) ) {
//        $label->label_order = $values['label_order'];
//      }

      if( isset($values['sitemusic_label_color']) ) {
        $params['label_color'] = $values['sitemusic_label_color'];
      }
      if( isset($values['sitemusic_label_text_color']) ) {
        $params['label_text_color'] = $values['sitemusic_label_text_color'];
      }

      if( isset($params) && !empty($params) ) {
        $encodeParams = json_encode($params, true);
        $label->params = $encodeParams;
      }
      $label->displayable = 1;
      $label->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  public function deleteLabelcategoryAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $categoryId = $this->_getParam('id');
    $this->view->label_id = $this->view->category_id = $categoryId;
    $artistTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $category = $artistTable->find($categoryId)->current();

    if( !$category ) {

    } else {
      $categoryId = $category->getIdentity();
    }

    $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Delete();

    if( !$category ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_("Entry doesn't exist or not authorized to delete");
      return;
    }

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }
    // Process
    $db = $artistTable->getAdapter();
    $db->beginTransaction();

    try {

      $category->delete();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted.');
    return $this->_forward('success', 'utility', 'core', array(
        'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitemusic', 'controller' => 'settings', 'action' => 'labelcategories'), "admin_default", true),
        'messages' => Array($this->view->message)
    ));
  }

  public function editLabelcategoryAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $categoryId = $this->_getParam('id');
    $artistTable = Engine_Api::_()->getDbtable('labels', 'sitemusic');
    $category = $artistTable->find($categoryId)->current();
    $label = Engine_Api::_()->getItem('sitemusic_label', $categoryId);
    if( !$category ) {
      return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    } else {
      $categoryId = $category->getIdentity();
    }

    $form = $this->view->form = new Sitemusic_Form_Admin_Labelcategory();
    $form->setTitle('Edit Label');
    $form->getElement('submit')->setLabel('Edit');
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !empty($category->params) ) {
      $params = json_decode($category->params, true);

      if( isset($params['label_color']) ) {
        $this->view->label_color = $params['label_color'];
      }
      if( isset($params['label_text_color']) ) {
        $this->view->label_text_color = $params['label_text_color'];
      }
    }

    $form->populate($category->toArray());

    if( !$this->getRequest()->isPost() ) {
      // Output
      $this->renderScript('admin-settings/label-form.tpl');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      // Output
      $this->renderScript('admin-settings/label-form.tpl');
      return;
    }
    $values = $form->getValues();
    // Process
    $db = $artistTable->getAdapter();
    $db->beginTransaction();
    try {
      $category->label_name = $values['label_name'];
//      if( is_numeric($values['label_order']) ) {
//        $category->label_order = $values['label_order'];
//      }
      if( isset($values['sitemusic_label_color']) ) {
        $params['label_color'] = $values['sitemusic_label_color'];
      }
      if( isset($values['sitemusic_label_text_color']) ) {
        $params['label_text_color'] = $values['sitemusic_label_text_color'];
      }
      if( isset($params) && !empty($params) ) {
        $encodeParams = json_encode($params, true);
        $category->params = $encodeParams;
      }
      $category->save();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  public function deleteArtistAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $artistId = $this->_getParam('id');
    $this->view->artist_id = $this->view->category_id = $artistId;
    $artistTable = Engine_Api::_()->getDbtable('artists', 'sitemusic');
    $artist = $artistTable->find($artistId)->current();
    $this->view->form = $form = new Sitemusic_Form_Admin_Categories_Delete();
    if( !$artist ) {
      $this->view->status = false;
      return;
    }
    $artistId = $artist->getIdentity();

    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }
    // Process
    $db = $artistTable->getAdapter();
    $db->beginTransaction();

    try {

      $artist->delete();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Your entry has been deleted.');
    return $this->_forward('success', 'utility', 'core', array(
        'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('module' => 'sitemusic', 'controller' => 'settings', 'action' => 'artist'), "admin_default", true),
        'messages' => Array($this->view->message)
    ));
  }

  public function editArtistAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $artistId = $this->_getParam('id');
    //  $this->view->artist_id = $this->view->category_id = $id;
    $artistTable = Engine_Api::_()->getDbtable('artists', 'sitemusic');
    $artistRow = $artistTable->find($artistId)->current();
    $artist = Engine_Api::_()->getItem('sitemusic_artist', $artistId);
    if( !$artistRow ) {
      return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    } else {
      $artistId = $artistRow->getIdentity();
    }

    $form = $this->view->form = new Sitemusic_Form_Admin_Artistform();
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
    $form->setField($artistRow);

    if( !$this->getRequest()->isPost() ) {
      // Output
      $this->renderScript('admin-settings/form.tpl');
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      // Output
      $this->renderScript('admin-settings/form.tpl');
      return;
    }

    // Process
    $values = $form->getValues();
    $viewer = Engine_Api::_()->user()->getViewer();
    $db = $artistTable->getAdapter();
    $db->beginTransaction();

    try {
      $artistRow->owner_id = $viewer->getIdentity();
      $artistRow->title = $values['label'];
      $artistRow->description = $values['description'];
      if( !empty($values['profilephoto']) ) {
        $photo = Engine_Api::_()->getApi('core', 'sitemusic')->setPhoto($artistRow, $form->profilephoto);
        $artistRow->photo_id = $photo->photo_id;
      }
      if( !empty($values['coverphoto']) ) {
        $coverPhoto = $artistRow->setCoverPhoto($form->coverphoto);
        $artistRow->cover_photo_id = $coverPhoto->cover_photo_id;
      }
      $artistRow->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
    ));
  }

  public function approvedArtistAction()
  {
    $id = $this->_getParam('id');
    $approve = $this->_getParam('approve');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $artistTable = Engine_Api::_()->getItem('sitemusic_artist', $id);
      $artistTable->approved = $approve;
      $artistTable->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitemusic/settings/artist');
  }

  public function displayableArtistAction()
  {
    $id = $this->_getParam('id');
    $displayable = $this->_getParam('displayable');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $artistTable = Engine_Api::_()->getItem('sitemusic_artist', $id);
      $artistTable->displayable = $displayable;
      $artistTable->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitemusic/settings/artist');
  }

  public function displayableLabelAction()
  {
    $id = $this->_getParam('id');
    $displayable = $this->_getParam('displayable');
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $labelTable = Engine_Api::_()->getItem('sitemusic_label', $id);
      $labelTable->displayable = $displayable;
      $labelTable->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $this->_redirect('admin/sitemusic/settings/labelcategories');
  }

  public function statsAction()
  {
    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sm_admin_main', array(), 'sm_admin_main_statistics');

    $playlist = Engine_Api::_()->getDbTable('playlists', 'sitemusic');
    $userPlaylist = Engine_Api::_()->getDbTable('userPlaylists', 'sitemusic');
    $playlistSong = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
    $artist = Engine_Api::_()->getDbTable('artists', 'sitemusic');


    $playlistSelect = $playlist->select();
    $playlistSelect->from($playlist->info('name'), 'count(*) as totalAlbum');

    //total album
    $this->view->totalAlbum = $playlistSelect->query()->fetchColumn();

    $userPlaylistSelect = $userPlaylist->select();
    $userPlaylistSelect->from($userPlaylist->info('name'), 'count(*) as totalPlaylist');
    //total playlist
    $this->view->totalPlaylist = $userPlaylistSelect->query()->fetchColumn();


    $playlistSongSelect = $playlistSong->select();
    $playlistSongSelect->from($playlistSong->info('name'), 'count(*) as totalSong');

    //total song
    $this->view->totalSong = $playlistSongSelect->query()->fetchColumn();

    $artistSelect = $artist->select();
    $artistSelect->from($artist->info('name'), 'count(*) as totalArtist');

    //total artist
    $this->view->totalArtist = $artistSelect->query()->fetchColumn();

    $playlistSelect->where('published = ?', 1);
    $this->view->totalPublishedAlbum = $playlistSelect->query()->fetchColumn();

    $playlistSelect->where('view_privacy = ?', 'everyone');
    $this->view->totalPublicAlbum = $playlistSelect->query()->fetchColumn();

    $playlistSelect = $playlist->select();
    $playlistSelect->from($playlist->info('name'), 'count(*) as totalUnPublishedAlbum');
    $playlistSelect->where('published = ?', 0);
    $this->view->totalUnPublishedAlbum = $playlistSelect->query()->fetchColumn();

    $playlistSelect = $playlist->select();
    $playlistSelect->from($playlist->info('name'), 'sum(download_count)');
    $this->view->albumDownloadCount = $playlistSelect->query()->fetchColumn();

    $playlistSongSelect = $playlistSong->select();
    $playlistSongSelect->from($playlistSong->info('name'), 'sum(download_count)');
    $this->view->SongDownloadCount = $songDownloadCount = $playlistSongSelect->query()->fetchColumn();
    if( empty($songDownloadCount) ) {
      $this->view->SongDownloadCount = 0;
    }
  }

  public function orderAction()
  {
    if( !empty($_POST) ) {
      foreach( $_POST as $key => $value ) {
        if( strstr($key, "content_") ) {
          $keyArray = explode("content_", $key);

          if( !empty($keyArray) )
            $labelId = end($keyArray);
          if( !empty($labelId) ) {
            $obj = Engine_Api::_()->getItem('sitemusic_label', $labelId);
            $obj->label_order = $value;
            $obj->save();
          }
        }
      }
    }
  }

  public function faqAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sm_admin_main', array(), 'sm_admin_main_faq');
    $this->view->action = 'faq';
    $this->view->faq_type = $this->_getParam('faq_type', 'general');
  }

  public function defaultImagesSetupAction()
  {
    $scTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
    $scTable->uploadDefaultImages();
    $acTable = Engine_Api::_()->getDbtable('albumcategories', 'sitemusic');
    $acTable->uploadDefaultImages();
    $setting = Engine_Api::_()->getApi('settings', 'core');
    $setting->setSetting('sitemusic_default_setup', 1);
    $this->_redirect('admin/sitemusic/settings');
  }

}
