<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: GeneralController.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_GeneralController extends Core_Controller_Action_Standard
{

  public function likeAction()
  {
//GET THE VIEWER.
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewerId = $viewer->getIdentity();

//GET THE VALUE OF RESOURCE ID AND RESOURCE TYPE AND LIKED ID.
    $this->view->resource_id = $resourceId = $this->_getParam('resource_id');
    $this->view->resource_type = $resourceType = $this->_getParam('resource_type');
    $like_id = $this->_getParam('like_id');
    $status = $this->_getParam('smoothbox', 1);
    $this->view->status = true;
    $resource = Engine_Api::_()->getItem($resourceType, $resourceId);
    if( empty($resource) ) {
      return;
    }

    $likeDatetimeTable = Engine_Api::_()->getDbTable('likeDatetimes', 'sitemusic');

    $owner = $resource->getOwner();
    $ownerId = $owner->getIdentity();
    $this->view->viewer_id = $loggedin_user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if( (empty($loggedin_user_id) ) ) {
      return;
    }
//CHECK THE LIKE ID.
    if( empty($like_id) ) {
      //CHECKING IF USER HAS MAKING DUPLICATE ENTRY OF LIKING AN APPLICATION.
      $like_id_temp = Engine_Api::_()->getApi('liked', 'sitemusic')->checkAvailability($resourceType, $resourceId);
      if( empty($like_id_temp[0]['like_id']) ) {
        if( $resource->getIdentity() ) {
          $like_id = Engine_Api::_()->getDbTable('likes', 'core')->addLike($resource, $viewer)->like_id;
        }
        if( $like_id ) {
          $likeDatetimeTable->setDateTime($like_id);
          $this->view->like_id = $like_id;
          $like_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Liked.');
        }

        if( $viewerId != $ownerId ) {
          $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $resource, 'like_' . $resourceType);
          if( $resourceType != 'sitemusic_artist' ) {
            Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $resource, 'like_' . $resourceType);
          }
          // make sure action exists before attaching to the activity
          if( $action ) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $resource);
          }
        }
      } else {
        $this->view->like_id = $like_id_temp[0]['like_id'];
        $this->view->error_mess = 1;
      }
    } else {
      if( !empty($resource) && isset($resource->like_count) ) {
        $resource->like_count--;
        $resource->save();
      }
      //START DELETE NOTIFICATION
      Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('type = ?' => 'like_' . $resourceType, 'subject_id = ?' => $viewer->getIdentity(), 'subject_type = ?' => $viewer->getType(), 'object_type = ?' => $resourceType, 'object_id = ?' => $resourceId));
      $contentTable = Engine_Api::_()->getDbTable('likes', 'core')->delete(array('like_id =?' => $like_id));
      $likeDatetimeTable->delete(array('like_id =?' => $like_id));
//END Disliked WORK.
      $liked_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Disliked.');
    }
    if( empty($status) ) {
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => true,
        'parentRefresh' => true,
        'messages' => array($liked_msg)
        )
      );
    }
  }

  public function favouriteAction()
  {

//GET THE VIEWER.
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewerId = $viewer->getIdentity();

//GET THE VALUE OF RESOURCE ID AND RESOURCE TYPE AND FAVOURITE ID.
    $this->view->resource_id = $resourceId = $this->_getParam('resource_id');
    $this->view->resource_type = $resourceType = $this->_getParam('resource_type');
    $favourite_id = $this->_getParam('favourite_id');
    $status = $this->_getParam('smoothbox', 1);
    $this->view->status = true;
    $resource = Engine_Api::_()->getItem($resourceType, $resourceId);
    $owner = $resource->getOwner();
    $ownerId = $owner->getIdentity();
//GET THE FAVOURITE BUTTON SETTINGS.
    $this->view->favourite_setting_button = Engine_Api::_()->getApi('settings', 'core')->getSetting('favourite.setting.button');

//GET THE CURRENT UESRID AND SETTINGS.
    $this->view->viewer_id = $loggedin_user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    if( (empty($loggedin_user_id) ) ) {
      return;
    }
//CHECK THE FAVOURITE ID.
    if( empty($favourite_id) ) {

//CHECKING IF USER HAS MAKING DUPLICATE ENTRY OF FAVOURITING AN APPLICATION.
      $favourite_id_temp = Engine_Api::_()->getApi('favourite', 'sitemusic')->hasFavourite($resourceType, $resourceId);
//CHECK THE THE ITEM IS FAVOURITED OR NOT.
      if( empty($favourite_id_temp[0]['favourite_id']) ) {

        $favouriteTable = Engine_Api::_()->getItemTable('sitemusic_favourite');
        $notify_table = Engine_Api::_()->getDbtable('notifications', 'activity');
        $db = $favouriteTable->getAdapter();
        $db->beginTransaction();
        try {
//            //ADD FAVOURITE
          $favourite_id = $favouriteTable->addFavourite($resource, $viewer)->favourite_id;
//PASS THE FAVOURITE ID VALUE.
          $this->view->favourite_id = $favourite_id;
          $db->commit();
        } catch( Exception $e ) {
          $db->rollBack();
          throw $e;
        }
        $favourite_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Favourited.');

        if( $viewerId != $ownerId ) {
          $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $resource, 'fav_' . $resourceType);
          if( $resourceType != 'sitemusic_artist' ) {
            Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $resource, 'fav_' . $resourceType);
          }
          // make sure action exists before attaching to the activity
          if( $action ) {
            Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $resource);
          }
        }
      } else {
        $this->view->favourite_id = $favourite_id_temp[0]['favourite_id'];
      }
    } else {

//START DELETE NOTIFICATION
      Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('type = ?' => 'fav_' . $resourceType, 'subject_id = ?' => $viewer->getIdentity(), 'subject_type = ?' => $viewer->getType(), 'object_type = ?' => $resourceType, 'object_id = ?' => $resourceId));
//END DELETE NOTIFICATION
////START UNFAVOURITE WORK.
//HERE 'PAGE OR LIST PLUGIN' CHECK WHEN UNFAVOURITE
      if( !empty($resource) && isset($resource->favourite_count) ) {
        $resource->favourite_count--;
        $resource->save();
      }
      $contentTable = Engine_Api::_()->getDbTable('favourites', 'sitemusic')->delete(array('favourite_id =?' => $favourite_id));
//END UNFAVOURITE WORK.
      $favourite_msg = Zend_Registry::get('Zend_Translate')->_('Successfully Unfavourited.');
    }
    if( empty($status) ) {
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => true,
        'parentRefresh' => true,
        'messages' => array($favourite_msg)
        )
      );
    }
//HERE THE CONTENT TYPE MEANS MODULE NAME
    $num_of_contenttype = Engine_Api::_()->getApi('favourite', 'sitemusic')->favouriteCount($resourceType, $resourceId);
    $favourites_number = $this->view->translate(array('%s favourite', '%s favourites', $num_of_contenttype), $this->view->locale()->toNumber($num_of_contenttype));
    $this->view->num_of_favourite = "<a href='javascript:void(0);' onclick='showSmoothBox(); return false;' >" . $favourites_number . "</a>";
  }

  public function shareAction()
  {
    $this->_helper->layout->setLayout('default-simple');
    $this->view->resource_id = $resourceId = $this->_getParam('resource_id');
    $this->view->resource_type = $resourceType = $this->_getParam('resource_type');
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();
    $this->view->subject = $subject = Engine_Api::_()->getItem($resourceType, $resourceId);
  }

  public function shareItemAction()
  {
    if( !$this->_helper->requireUser()->isValid() )
      return;

    $type = $this->_getParam('type');
    $id = $this->_getParam('id');
    $this->view->parent_action_id = $parent_action_id = $this->_getparam('action_id', null);
    $memories = $this->_getparam('onthisday', null);
    //echo $this->_helper->contextSwitch->getCurrentContext(); die;
    if( null != $this->_helper->contextSwitch->getCurrentContext() ) {
      $this->_helper->layout->setLayout('default-simple');
    }
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->attachment = $attachment = Engine_Api::_()->getItem($type, $id);
    $this->view->form = $form = new Activity_Form_Share();
    $form->body->setAttribs(array('rows' => 1));
    if( !$attachment ) {
      // tell smoothbox to close
      $this->view->status = true;
      $this->view->message = Zend_Registry::get('Zend_Translate')->_('You cannot share this item because it has been removed.');
      $this->view->smoothboxClose = true;
      return $this->render('deletedItem');
    }


    // hide facebook and twitter option if not logged in
    $Api_facebook = Engine_Api::_()->getApi('facebook_Facebookinvite', 'seaocore');
    $facebook_userfeed = $Api_facebook->getFBInstance();
    $fb_checkconnection = '';
    if( !empty($facebook_userfeed) )
      $fb_checkconnection = $Api_facebook->checkConnection(null, $facebook_userfeed);
    $facebook = Seaocore_Api_Facebook_Facebookinvite::getFBInstance();

    if( !$Api_facebook || !$fb_checkconnection ) {
      $form->removeElement('post_to_facebook');
    }

    try {
      $Api_twitter = Engine_Api::_()->getApi('twitter_Api', 'seaocore');
      $twitterOauth = $twitter = $Api_twitter->getApi();
      if( $twitter && $Api_twitter->isConnected() ) {
        // @todo truncation?
        // @todo attachment
        //$twitter = $twitterTable->getApi();
        //$twitter->setReturnFormat(CODEBIRD_RETURNFORMAT_ARRAY);
        $twitterData = (array) $twitterOauth->get(
            'statuses/home_timeline', array('count' => 1)
        );
        if( isset($twitterData['errors']) )
          $form->removeElement('post_to_twitter');

        //$logged_TwitterUserfeed = $twitter->statuses_homeTimeline(array('count' => 1));
      } else {

        $form->removeElement('post_to_twitter');
      }
    } catch( Exception $e ) {
      $form->removeElement('post_to_twitter');
      // Silence
    }



    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Process

    $db = Engine_Api::_()->getDbtable('actions', 'activity')->getAdapter();
    $db->beginTransaction();

    try {
      // Get body
      $body = $form->getValue('body');
// Set Params for Attachment

      if( method_exists($attachment, 'getMediaType') ) {
        $lable = $attachment->getMediaType();
      } else {
        $lable = $this->getMediaType($attachment);
      }

      if( empty($lable) )
        $lable = $attachment->getShortType();
      $suffix = "";
      if( $attachment->getType() == 'activity_action' ) {
        $suffix = "_no";
      }
      $params = array(
        'type' => '<a href="' . $attachment->getHref() . '" class="sea_add_tooltip_link' . $suffix . ' feed_' . $attachment->getType() . '_title"  rel="' . $attachment->getType() . ' ' . $attachment->getIdentity() . '" >' . $lable . '</a>',
      );
      // Add activity
      $api = Engine_Api::_()->getDbtable('actions', 'activity');
      // $action = $api->addActivity($viewer, $viewer, 'post_self', $body);
      $shareType = 'share';
      if( !empty($memories) ) {
        $shareType = 'share_memories';
      }
      $action = $api->addActivity($viewer, $attachment->getOwner(), $shareType, $body, $params);
      if( $action ) {
        $api->attachActivity($action, $attachment);
        if( !empty($parent_action_id) && Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('advancedactivity') ) {
          $shareTable = Engine_Api::_()->getDbtable('shares', 'advancedactivity');
          $shareTable->insert(array(
            'resource_type' => (string) $type,
            'resource_id' => (int) $id,
            'parent_action_id' => $parent_action_id,
            'action_id' => $action->action_id,
          ));
        }
      }
      $db->commit();
      // Notifications
      $notifyApi = Engine_Api::_()->getDbtable('notifications', 'activity');
      // Add notification for owner of activity (if user and not viewer)
      if( $action->subject_type == 'user' && $attachment->getOwner()->getIdentity() != $viewer->getIdentity() ) {
        $notifyApi->addNotification($attachment->getOwner(), $viewer, $action, 'shared', array(
          'label' => $lable,
        ));
      }

      // Preprocess attachment parameters
      $publishMessage = html_entity_decode($form->getValue('body'));
      $publishUrl = null;
      $publishName = null;
      $publishDesc = null;
      $publishPicUrl = null;
      // Add attachment
      if( $attachment ) {
        $publishUrl = $attachment->getHref();
        $publishName = $attachment->getTitle();
        $publishDesc = $attachment->getDescription();
        if( empty($publishName) ) {
          $publishName = ucwords($attachment->getShortType());
        }
        if( ($tmpPicUrl = $attachment->getPhotoUrl() ) ) {
          $publishPicUrl = $tmpPicUrl;
        }
        // prevents OAuthException: (#100) FBCDN image is not allowed in stream
        if( $publishPicUrl &&
          preg_match('/fbcdn.net$/i', parse_url($publishPicUrl, PHP_URL_HOST)) ) {
          $publishPicUrl = null;
        }
      } else {
        $publishUrl = $action->getHref();
      }
      // Check to ensure proto/host
      if( $publishUrl &&
        false === stripos($publishUrl, 'http://') &&
        false === stripos($publishUrl, 'https://') ) {
        $publishUrl = 'http://' . $_SERVER['HTTP_HOST'] . $publishUrl;
      }
      if( $publishPicUrl &&
        false === stripos($publishPicUrl, 'http://') &&
        false === stripos($publishPicUrl, 'https://') ) {
        $publishPicUrl = 'http://' . $_SERVER['HTTP_HOST'] . $publishPicUrl;
      }
      // Add site title
      if( $publishName ) {
        $publishName = Engine_Api::_()->getApi('settings', 'core')->core_general_site_title
          . ": " . $publishName;
      } else {
        $publishName = Engine_Api::_()->getApi('settings', 'core')->core_general_site_title;
      }


      // Publish to facebook, if checked & enabled
      if( $this->_getParam('post_to_facebook', false) &&
        'publish' == Engine_Api::_()->getApi('settings', 'core')->core_facebook_enable ) {
        try {
          $facebookApi = Seaocore_Api_Facebook_Facebookinvite::getFBInstance();
          $facebookTable = Engine_Api::_()->getDbtable('facebook', 'user');
          $fb_uid = $facebookTable->find($viewer->getIdentity())->current();

          if( $facebookApi && Seaocore_Api_Facebook_Facebookinvite::checkConnection(null, $facebookApi)
          ) {
            $fb_data = array(
              'message' => $publishMessage,
            );
            if( $publishUrl ) {
              $fb_data['link'] = $publishUrl;
            }
            if( $publishName ) {
              $fb_data['name'] = $publishName;
            }
            if( $publishDesc ) {
              $fb_data['description'] = strip_tags($publishDesc);
            }
            if( $publishPicUrl ) {
              $fb_data['picture'] = $publishPicUrl;
            }
            if( isset($fb_data['link']) && !empty($fb_data['link']) ) {
              $appkey = Engine_Api::_()->getApi('settings', 'core')->getSetting('bitly.apikey');
              $appsecret = Engine_Api::_()->getApi('settings', 'core')->getSetting('bitly.secretkey');
              if( !empty($appkey) && !empty($appsecret) ) {
                $shortURL = Engine_Api::_()->getApi('Bitly', 'seaocore')->get_bitly_short_url($fb_data['link'], $appkey, $appsecret, $format = 'txt');
                $fb_data['link'] = $shortURL;
              }
            }
            $res = $facebookApi->api('/me/feed', 'POST', $fb_data);
            if( $subject && isset($subject->fbpage_id) && !empty($subject->fbpage_id) ) {
              $manages_pages = $facebookApi->api('/me/accounts', 'GET');
              //NOW GETTING THE PAGE ACCESS TOKEN TO WITH THIS SITE PAGE IS INTEGRATED:

              foreach( $manages_pages['data'] as $page ) {
                if( $page['id'] == $subject->fbpage_id ) {
                  $fb_data['access_token'] = $page['access_token'];
                  $res = $facebookApi->api('/' . $subject->fbpage_id . '/feed', 'POST', $fb_data);
                  break;
                }
              }
            }
          }
        } catch( Exception $e ) {
          // Silence
        }
      } // end Facebook
      // Publish to twitter, if checked & enabled
      if( $this->_getParam('post_to_twitter', false) &&
        'publish' == Engine_Api::_()->getApi('settings', 'core')->core_twitter_enable ) {
        try {
          $twitterTable = Engine_Api::_()->getDbtable('twitter', 'user');
          if( $twitterTable->isConnected() ) {

            $twitterOauth = $twitter = $Api_twitter->getApi();
            $login = Engine_Api::_()->getApi('settings', 'core')->getSetting('bitly.apikey');
            $appkey = Engine_Api::_()->getApi('settings', 'core')->getSetting('bitly.secretkey');


            //TWITTER ONLY ACCEPT 140 CHARACTERS MAX..
            //IF BITLY IS CONFIGURED ON THE SITE..
            if( !empty($login) && !empty($appkey) ) {
              if( strlen(html_entity_decode($_POST['body'])) > 140 || $attachment ) {
                if( $attachment ) {
                  $shortURL = Engine_Api::_()->getApi('Bitly', 'seaocore')->get_bitly_short_url((_ENGINE_SSL ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . $attachment->getHref(), $login, $appkey, $format = 'txt');
                  $BitlayLength = strlen($shortURL);
                } else {
                  $BitlayLength = 0;
                  $shortURL = '';
                }
                $twitterFeed = substr(html_entity_decode($_POST['body']), 0, (140 - ($BitlayLength + 1))) . ' ' . $shortURL;
              } else
                $twitterFeed = html_entity_decode($_POST['body']);
            }
            else {
              $twitterFeed = substr(html_entity_decode($_POST['body']), 0, 137) . '...';
            }

            $lastfeedobject = $twitterOauth->post(
              'statuses/update', array('status' => $twitterFeed)
            );
            //$twitter->statuses->update($message);
          }
        } catch( Exception $e ) {
          // Silence
        }
      }


      // Publish to janrain
      if( //$this->_getParam('post_to_janrain', false) &&
        'publish' == Engine_Api::_()->getApi('settings', 'core')->core_janrain_enable ) {
        try {
          $session = new Zend_Session_Namespace('JanrainActivity');
          $session->unsetAll();

          $session->message = $publishMessage;
          $session->url = $publishUrl ? $publishUrl : 'http://' . $_SERVER['HTTP_HOST'] . _ENGINE_R_BASE;
          $session->name = $publishName;
          $session->desc = $publishDesc;
          $session->picture = $publishPicUrl;
        } catch( Exception $e ) {
          // Silence
        }
      }
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e; // This should be caught by error handler
    }

    if( !empty($memories) ) {
      setcookie("shared_this", 1, time() + 86400, "/");
    }

    // If we're here, we're done
    $this->view->status = true;
    $this->view->message = Zend_Registry::get('Zend_Translate')->_('Success!');
    // Redirect if in normal context
    //CHECK IF SITEMOBILE PLUGIN IS ENABLED AND SITE IS IN MOBILE MODE:
    $enable_sitemobilemodule = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemobile');
    $checkMobMode = false;
    if( $enable_sitemobilemodule )
      $checkMobMode = Engine_Api::_()->sitemobile()->checkMode('mobile-mode') || Engine_Api::_()->sitemobile()->checkMode('tablet-mode');
    if( !$checkMobMode ) {
      if( null === $this->_helper->contextSwitch->getCurrentContext() ) {
        $return_url = $form->getValue('return_url', false);
        if( !$return_url ) {
          $return_url = $this->view->url(array(), 'default', true);
        }
        return $this->_helper->redirector->gotoUrl($return_url, array('prependBase' => false));
      } else if( 'smoothbox' == $this->_helper->contextSwitch->getCurrentContext() && $this->_getParam('not_parent_refresh', 0) ) {
        $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          //  'parentRefresh' => 10,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Share successfully.'))
        ));
      } else if( 'smoothbox' == $this->_helper->contextSwitch->getCurrentContext() ) {
        $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
        ));
      }
    } else {
      return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'messages' => array(Zend_Registry::get('Zend_Translate')->_('Share successfully.'))
      ));
    }
  }

  public function followAction()
  {
    //CHECK USER VALIDATION
    if( !$this->_helper->requireUser()->isValid() )
      return;

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    $resourceId = $this->_getParam('resource_id');
    $resourceType = $this->_getParam('resource_type');
    $follow_id = $this->_getParam('follow_id');
    $status = $this->_getParam('smoothbox', 1);
    $this->view->status = true;
    //GET FOLLOW TABLE
    $followTable = Engine_Api::_()->getDbTable('follows', 'sitemusic');
    $follow_name = $followTable->info('name');

    //GET OBJECT
    $resource = Engine_Api::_()->getItem($resourceType, $resourceId);
    $owner = $resource->getOwner();
    $ownerId = $owner->getIdentity();

    if( empty($follow_id) ) {
      //CHECKING IF USER HAS MAKING DUPLICATE ENTRY OF LIKING AN APPLICATION.
      if( $resource->getType() == 'user' ) {
        $follow_id_temp = Engine_Api::_()->getApi('following', 'sitemusic')->isFollow($resource, $viewer);
      } else {
        $follow_id_temp = $resource->follows()->isFollow($viewer);
      }
      if( empty($follow_id_temp) ) {
        $follow_id = Engine_Api::_()->getApi('following', 'sitemusic')->addFollow($resource, $viewer);
        if( $resource ) {
          $object_type = $resource->getType();
          $object_id = $resource->getIdentity();
          $subject_type = $viewer->getType();
          $subject_id = $viewer->getIdentity();
          $notificationType = 'follow_' . $resourceType;
          $notificationcreated = '%"notificationfollow":"1"%';
          $notificationFriendCreated = '%"notificationfollow":"2"%';
          $db = Zend_Db_Table_Abstract::getDefaultAdapter();
          if( $resource->getType() != 'user' ) {
            if( $resource->getType() == 'sitemusic_pl' ) {
              Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($resource->getOwner(), $viewer, $resource, 'follow_album');
            }
          } else {
            Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($resource->getOwner(), $viewer, $resource, 'follow_album_owner');
          }
          $friendId = Engine_Api::_()->user()->getViewer()->membership()->getMembershipsOfIds();
        }
        if( $resource->getType() == 'user' ) {
          $userFollowCount = Engine_Api::_()->getDbtable('userFollowCounts', 'sitemusic');
          $userFollowCount->addFollowCount($follow_id);
        } else {
          $table = Engine_Api::_()->getItem($resourceType, $resourceId);
          $table->follow_count++;
          $table->save();
        }
      }
      if( $follow_id ) {
        $this->view->follow_id = $follow_id;
      } elseif( $follow_id_temp ) {
        $this->view->follow_id = $follow_id_temp;
      }

      $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($viewer, $resource, 'follow_' . $resourceType);
      // make sure action exists before attaching to the activity
      if( $action ) {
        Engine_Api::_()->getDbtable('actions', 'activity')->attachActivity($action, $resource);
      }

      $follow_msg = $this->view->translate('Successfully Followd.');
    } else {
      if( !empty($resource) ) {
        if( $resourceType == 'user' ) {
          Engine_Api::_()->getApi('following', 'sitemusic')->removeFollowForUser($resource, $viewer, $follow_id);
        } else {
          $followTable->removeFollow($resource, $viewer);
        }

        if( $viewer_id != $resource->getOwner()->getIdentity() ) {

          Engine_Api::_()->getDbtable('notifications', 'activity')->delete(array('object_type = ?' => "$resourceType", 'object_id = ?' => $resourceId, 'subject_id = ?' => $resourceId, 'subject_type = ?' => "$resourceType", 'user_id = ?' => $viewer_id));
          foreach( $manageAdminsIds as $value ) {
            $user_subject = Engine_Api::_()->user()->getUser($value['user_id']);
            //DELETE NOTIFICATION
            $notification = Engine_Api::_()->getDbtable('notifications', 'activity')->getNotificationByObjectAndType($user_subject, $resource, 'follow_' . $resourceType);
            if( $notification ) {
              $notification->delete();
            }
          }

          //DELETE ACTIVITY FEED
          $action_id = Engine_Api::_()->getDbtable('actions', 'activity')
            ->select()
            ->from('engine4_activity_actions', 'action_id')
            ->where('type = ?', "follow_$resourceType")
            ->where('subject_id = ?', $viewer_id)
            ->where('subject_type = ?', 'user')
            ->where('object_type = ?', $resourceType)
            ->where('object_id = ?', $resource->getIdentity())
            ->query()
            ->fetchColumn();

          if( !empty($action_id) ) {
            $activity = Engine_Api::_()->getItem('activity_action', $action_id);
            if( !empty($activity) ) {
              $activity->delete();
            }
          }
        }
        if( $resource->getType() == 'user' ) {
          Engine_Api::_()->getApi('following', 'sitemusic')->removeFollowCount($follow_id);
        }
      }
      $follow_msg = $this->view->translate('Successfully Unfollowd.');
    }

    if( empty($status) ) {
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => true,
        'parentRefresh' => true,
        'messages' => array($follow_msg))
      );
    }

    if( $resource->getType() == 'user' ) {
      $userFollowCount = Engine_Api::_()->getItem('sitemusic_user_follow_count', $follow_id);
      if( $userFollowCount ) {
        $follow_count = $userFollowCount->follow_count;
      }
    } else {
      //HERE THE CONTENT TYPE MEANS MODULE NAME
      $this->view->follow_count = $follow_count = Engine_Api::_()->getItem($resourceType, $resourceId)->follow_count;
    }
    $followers = $this->view->translate(array('%s follower', '%s followers', $follow_count), $this->view->locale()->toNumber($follow_count));
  }

  public function downloadAction()
  {
    $resourceType = $this->_getParam('resource_type');
    $resourceId = $this->_getParam('resource_id');

    $path = Engine_Api::_()->getApi('core', 'sitemusic')->createZip($resourceType, $resourceId);
    if( $path == false ) {
      return;
    }
    @set_time_limit(0);
    if( file_exists($path) && is_file($path) ) {
      // Kill zend's ob
      while( ob_get_level() > 0 ) {
        ob_end_clean();
      }
    }

    header("Content-Disposition: attachment; filename=" . urlencode(basename($path)), true);
    header("Content-Transfer-Encoding: Binary", true);
    header("Content-Type: application/x-tar", true);
    header("Content-Type: application/force-download", true);
    header("Content-Type: application/octet-stream", true);
    header("Content-Type: application/download", true);
    header("Content-Description: File Transfer", true);
    header("Content-Length: " . filesize($path), true);
    $fh = fopen($path, 'r');
    //$len = 0;
    while( !feof($fh) /* $size > $len */ ) {
      $str = fread($fh, 8192);
      //$len += strlen($str);
      echo $str;
    }
    unlink($path);
    exit();
  }

  public function logAction()
  {
    $id = $this->_getParam('id');
    $type = $this->_getParam('type');

    if( empty($id) ) {
      $this->view->status = false;
      return;
    }
    if( $type == 'song' ) {
      $playLog = Engine_Api::_()->getDbTable('playLog', 'sitemusic');
      $songArtistTable = $playLog->createRow();
      $songArtistTable->song_id = $id;
      $songArtistTable->user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
      $songArtist = $songArtistTable->save();


      // increment song play count
      $psItem = Engine_Api::_()->getItem('sitemusic_playlist_song', $id);
      if( empty($psItem) ) {
        $this->view->status = false;
        return;
      }
      $playCount = $psItem->play_count;
      $psItem->play_count = ++$playCount;
      $psItem->save();
      $this->view->status = true;
      return;
    }

    if( $type == 'musicalbum' ) {
      $pItem = Engine_Api::_()->getItem('sitemusic_pl', $id);
      if( empty($pItem) ) {
        return;
      }
      $playCount = $pItem->play_count;
      $pItem->play_count = ++$playCount;
      $pItem->save();
      $this->view->status = true;
      return;
    }

//    if( is_array($logInfo) ) {
//      $playLog = Engine_Api::_()->getDbTable('playLog', 'sitemusic');
//      $songArtistTable = $playLog->createRow();
//      $songArtistTable->song_id = $logInfo['songId'];
//      $songArtistTable->user_id = Engine_Api::_()->user()->getViewer()->getIdentity();
//      $songArtist = $songArtistTable->save();
//
//
//      // increment song play count
//      $psItem = Engine_Api::_()->getItem('sitemusic_playlist_song', $logInfo['songId']);
//      $playCount = $psItem->play_count;
//      $psItem->play_count = ++$playCount;
//      $psItem->save();
//    } else {
//      $pItem = Engine_Api::_()->getItem('sitemusic_playlist', $logInfo);
//      $playCount = $pItem->play_count;
//      $pItem->play_count = ++$playCount;
//      $pItem->save();
//    }
  }

  public function rateAction()
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $user_id = $viewer->getIdentity();
    $itemId = $this->_getParam('item_id');
    $resourceType = $this->_getParam('resourceType');
    $rating = $this->_getParam('rating');
    $table = Engine_Api::_()->getDbtable('ratings', 'sitemusic');
    $item = Engine_Api::_()->getItem($resourceType, $itemId);
    $owner = $item->getOwner();
    $ownerId = $owner->getIdentity();
    $select = $table->select();
    $select->where('resource_type = ?', $resourceType)
      ->where('resource_id = ?', $itemId)
      ->where('user_id = ?', $user_id)
      ->limit(1);
    $isExist = $select->query()->fetch();
    if( $isExist ) {
      $setting = Engine_Api::_()->getApi('settings', 'core');
      if( $resourceType == 'sitemusic_pl' ) {
        $updatePermission = $setting->getSetting('sitemusicalbumrating.update', 1);
      } elseif( $resourceType == 'sitemusic_playlist_song' ) {
        $updatePermission = $setting->getSetting('sitemusicsongrating.update', 1);
      } elseif( $resourceType == 'sitemusic_userpl' ) {
        $updatePermission = $setting->getSetting('sitemusicplaylistrating.update', 1);
      } elseif( $resourceType == 'sitemusic_artist' ) {
        $updatePermission = $setting->getSetting('sitemusicartistrating.update', 1);
      }
      if( $updatePermission ) {
        $table->update(array('rating' => $rating), array('resource_type = ?' => $resourceType, 'resource_id = ?' => $itemId, 'user_id = ?' => $user_id));
        $ratingCount = $item->rating_count;
        $avgRating = $item->rating;
        if( $ratingCount == 0 ) {
          $item->rating_count = ++$ratingCount;
          $item->rating = $rating;
          $item->save();
        } else {
          $item->rating_count = ++$ratingCount;
          $item->rating = ($avgRating * ($ratingCount - 1) + $rating) / $ratingCount;
          $item->save();
        }

        $ratingPer = (100 * $rating) / 5;
        Engine_Api::_()->getApi('rated', 'sitemusic')->setRatingScore($item->getIdentity(), $resourceType, $ratingCount, $ratingPer);
      } else {
        $this->view->status = false;
        $this->view->message = $this->view->translate('You have given ratings');
        return;
      }
      $this->view->status = true;
    } else {
      Engine_Api::_()->sitemusic()->setRating($itemId, $user_id, $rating, $resourceType);
      $ratingCount = $item->rating_count;
      $avgRating = $item->rating;
      if( $ratingCount == 0 ) {
        $item->rating_count = ++$ratingCount;
        $item->rating = $rating;
        $item->save();
      } else {
        $item->rating_count = ++$ratingCount;
        $item->rating = ($avgRating * ($ratingCount - 1) + $rating) / $ratingCount;
        $item->save();
      }
      $ratingPer = (100 * $rating) / 5;
      Engine_Api::_()->getApi('rated', 'sitemusic')->setRatingScore($item->getIdentity(), $resourceType, $ratingCount, $ratingPer);
      $this->view->status = true;
    }
    $total = Engine_Api::_()->sitemusic()->ratingCount($itemId, $resourceType);

    $data = array();
    $data[] = array(
      'status' => true,
      'total' => $total,
      'rating' => $rating,
    );

    if( $user_id != $ownerId ) {
      Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $item, 'rating_' . $resourceType);
    }
    $this->view->status = true;
    return $this->_helper->json($data);
  }

  public function uploadPhotoAction()
  {
    $img = $this->_getParam('img');
    $itemId = $this->_getParam('itemId');
    $type = $this->_getParam('type');

    // only members can upload sitemusic
    if( !$this->_helper->requireUser()->checkRequire() ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('You do not have permission to upload Music.');
      return;
    }

    // Check method
    if( !$this->getRequest()->isPost() ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('Invalid request method');
      return;
    }

    // Check the music temporary directory
    $tmpDir = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary' . DIRECTORY_SEPARATOR . 'music';
    if( !is_dir($tmpDir) ) {
      if( !mkdir($tmpDir, 0777, true) ) {
        $this->view->status = false;
        $this->view->error = $this->view->translate('Music temporary directory did not exist and could not be created.');
        return;
      }
    }

    if( !is_writable($tmpDir) ) {
      $this->view->status = false;
      $this->view->error = $this->view->translate('Music temporary directory is not writable.');
      return;
    }

    if( $type == 'artist' ) {
      $item = Engine_Api::_()->getItem('sitemusic_artist', $itemId);
    } else {
      $item = Engine_Api::_()->getItem('sitemusic_playlist_song', $itemId);
    }
    if( empty($item) ) {
      return;
    }
    $encodeImage = explode('base64,', $img);
    $image = base64_decode($encodeImage[1]);

    if( $image ) {
      $imgName = "item_$itemId.jpg";
      $imgPath = $tmpDir . $imgName;

      if( isset($image) ) {
        file_put_contents($imgPath, $image);
      }

      Engine_Api::_()->getApi('core', 'sitemusic')->setPhoto($item, $imgPath);
      @unlink($imgPath);
    }
  }

}
