<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Install.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Installer extends Engine_Package_Installer_Module
{

  public function onInstall()
  {
    $db = $this->getDb();
//    $select = new Zend_Db_Select($db);
//    $columns = array(
//      "owner_id" => "int(11) unsigned NOT NULL",
//      "parent_id" => "int(11) unsigned NOT NULL",
//      "parent_type" => "varchar(42) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL",
//      "cover_photo_id" => "int(11) unsigned NOT NULL default '0'",
//      "song_count" => "int(11) unsigned NOT NULL default '0'",
//      "download_count" => "int(11) unsigned NOT NULL default '0'",
//      "rating_count" => "int(11) unsigned NOT NULL default '0'",
//      "follow_count" => "int(11) unsigned NOT NULL default '0'",
//      "rating" => "int(11) unsigned NOT NULL default '0'",
//      "approved" => "tinyint(1) unsigned NOT NULL default '0'",
//      "category_id" => "int(11) unsigned NOT NULL default '0'",
//      "favourite_count" => "int(11) unsigned NOT NULL default '0'",
//      "download_privacy" => "VARCHAR(24) NOT NULL",
//      "published" => "tinyint(1) unsigned default '0'",
//    );
//    foreach( $columns as $key => $value ) {
//      try {
//        $rows = $db->query('SHOW COLUMNS FROM engine4_music_playlists LIKE \'' . $key . '\'')->fetch();
//        if( empty($rows) ) {
//          $db->query("ALTER TABLE `engine4_music_playlists` ADD $key $value");
//        }
//      } catch( Exception $e ) {
//        break;
//      }
//    }
//    $ps_columns = array(
//      "owner_id" => "int(11) unsigned NOT NULL",
//      "cover_photo_id" => "int(11) unsigned NOT NULL default '0'",
//      "photo_id" => "int(11) unsigned NOT NULL default '0'",
//      "creation_date" => "DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP",
//      "modified_date" => "datetime NOT NULL",
//      "comment_count" => "int(11) unsigned NOT NULL default '0'",
//      "like_count" => "int(11) unsigned NOT NULL default '0'",
//      "download_count" => "int(11) unsigned NOT NULL default '0'",
//      "favourite_count" => "int(11) unsigned NOT NULL default '0'",
//      "rating_count" => "int(11) unsigned NOT NULL default '0'",
//      "rating" => "int(11) unsigned NOT NULL default '0'",
//      "song_length" => "varchar(8) NOT NULL default '0:00'",
//      "genre_id" => "int(11) unsigned NOT NULL default '0'",
//      "approved" => "tinyint(1) unsigned NOT NULL default '0'",
//      "lyrics" => "text NOT NULL default ''",
//      "params" => "text",
//      "message" => "text",
//    );
//    foreach( $ps_columns as $key => $value ) {
//      try {
//        $ps_rows = $db->query('SHOW COLUMNS FROM engine4_music_playlist_songs LIKE \'' . $key . '\'')->fetch();
//        if( empty($ps_rows) ) {
//          $db->query("ALTER TABLE `engine4_music_playlist_songs` ADD $key $value");
//        }
//      } catch( Exception $e ) {
//        break;
//      }
//    }
//
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'music')
      ->where('enabled = ?', 1);
    $isMusicobject = $select->query()->fetchObject();

    if( !empty($isMusicobject) ) {
      $db->query("UPDATE `engine4_core_modules` SET `enabled` = '0' WHERE `engine4_core_modules`.`name` = 'music'");
    }

//    $column_exist = $db->query("SHOW COLUMNS FROM `engine4_core_likes` LIKE 'creation_date'")->fetch();
//    if( empty($column_exist) ) {
//      $db->query("ALTER TABLE  `engine4_core_likes` ADD  `creation_date` datetime NOT NULL");
//    }

//    $db->query("ALTER TABLE  `engine4_core_menuitems` MODIFY  `menu` varchar(64) collate latin1_general_ci NOT NULL");
//    $db->query("ALTER TABLE  `engine4_core_menus` MODIFY  `name` varchar(64) collate latin1_general_ci NOT NULL");

    // $db->query("ALTER TABLE  `engine4_authorization_permissions` MODIFY  `name` varchar(64) collate latin1_general_ci NOT NULL");
//    $db->query("ALTER TABLE  `engine4_activity_actions` MODIFY  `type` varchar(34) COLLATE utf8_unicode_ci NOT NULL");


    $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitemusic.isActivate", "1");');

    $this->_addMusicManageAlbumPage();
    $this->_addMusicManagePlaylistPage();
    $this->_addMusicManageSongPage();
    $this->_addMusicManageArtistPage();
    $this->_addMusicManageFavouritePage();
    $this->_addMusicManageLikedPage();
    $this->_addMusicManageRatedPage();
    $this->_addMusicManageFollowingPage();
    $this->_addMusicHomePage();
    $this->_addMusicEditSongPage();
    $this->_addMusicAlbumBrowsePage();
    $this->_addMusicSongBrowsePage();
    $this->_addMusicArtistBrowsePage();
    $this->_addMusicPlaylistBrowsePage();
    $this->_addMusicAlbumProfilePage();
    $this->_addMusicPlaylistProfilePage();
    $this->_addMusicSongProfilePage();
    $this->_addMusicArtistProfilePage();
    $this->_addMusicMusicAlbumCategoriesPage();
    $this->_addMusicGenrePage();
    $this->_addMusicAlbumHomePage();
    $this->_addMusicSongHomePage();
    $this->_addMusicPlayer();
    $this->_addMusicHistory();
    $this->_addUserProfileContent();
    $this->_addMusicUnapprovedSongPage();
    $this->createwidgetizePage('sitemusic_albums_create', 'Advanced Music - Music Album Create Page', 'Music Album Creation Page', 'This page is the music album creation page.');
    $this->createwidgetizePage('sitemusic_albums_edit', 'Advanced Music - Edit Music Album Page', 'Music Album Edit Page', 'This page is the music album edit page.');
    parent::onInstall();
    $this->setManageModules();
  }

  public function onPostInstall()
  {
    $db = $this->getDb();
    if( $this->_databaseOperationType == 'upgrade' ) {
      $updateTables = array(
        'engine4_authorization_allow' => 'resource_type',
        'engine4_authorization_permissions' => 'type',
        'engine4_activity_attachments' => 'type',
        'engine4_activity_notifications' => 'object_type',
        'engine4_activity_stream' => 'object_type',
        'engine4_core_likes' => 'resource_type',
        'engine4_nestedcomment_dislikes' => 'resource_type',
        'engine4_sitecredit_credits' => 'resource_type',
        'engine4_sitemusic_ratings' => 'resource_type',
        'engine4_activity_attachments' => 'type',
        'engine4_core_search' => 'type',
        'engine4_storage_files' => 'parent_type',
        'engine4_sitemusic_label_map' => 'resource_type',

      );
      foreach ($updateTables as $tableName => $columnName) {
        $tableExist = $db->query("SHOW TABLES LIKE '$tableName'")->fetch(); 
        if (!empty($tableExist)) { 
          $db->query("UPDATE `$tableName` SET `$columnName` = 'sitemusic_pl' WHERE `$tableName`.`$columnName` = 'sitemusic_playlist';");
          $db->query("UPDATE `$tableName` SET `$columnName` = 'sitemusic_userpl' WHERE `$tableName`.`$columnName` = 'sitemusic_user_playlist';");
        }
      }
    }
  }

  public function setManageModules()
  {

    $db = $this->getDb();
    $db->query("DROP TABLE IF EXISTS `engine4_sitemusic_modules`;");
    $db->query("
   CREATE TABLE IF NOT EXISTS `engine4_sitemusic_modules` (
  `module_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `resource_type` varchar(255) NOT NULL default '',
  `resource_id` varchar(255) NOT NULL default '',
  `resource_module` varchar(255) NOT NULL default '',
  `resource_title` varchar(255) NOT NULL default '',
  `resource_membertype` varchar(255) NOT NULL default '',
  `enabled` tinyint(1) NOT NULL default '1',
  `integrated` tinyint(1) NOT NULL default '1',
  PRIMARY KEY (`module_id`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;");


    //integrating sitemusic with sitepage
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'sitepage')
      ->where('enabled = ?', 1);
    $is_sitepage_object = $select->query()->fetchObject();
    if( $is_sitepage_object ) {

      $db->query("INSERT IGNORE INTO `engine4_sitemusic_modules` (`resource_type`, `resource_id`, `resource_module`, `enabled`, `integrated`, `resource_title`, `resource_membertype`) VALUES ('sitepage_page', 'page_id', 'sitepage', '0', '0', 'Page Music', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");
      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitepage_admin_main_managemusic", "sitemusic", "Manage Music", "", \'{"uri":"admin/sitemusic/manage/index/contentType/sitepage_page/contentModule/sitepage"}\', "sitepage_admin_main", "", 0, 0, 24);');
      $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitemusic.playlist.leader.owner.sitepage.page", "1");');
    }

    //integrating sitemusic with sitebusiness
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'sitebusiness')
      ->where('enabled = ?', 1);
    $is_sitebusiness_object = $select->query()->fetchObject();
    if( $is_sitebusiness_object ) {

      $db->query("INSERT IGNORE INTO `engine4_sitemusic_modules` (`resource_type`, `resource_id`, `resource_module`, `enabled`, `integrated`, `resource_title`, `resource_membertype`) VALUES ('sitebusiness_business', 'business_id', 'sitebusiness', '0', '0', 'Business Music', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");

      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitebusiness_admin_main_managemusic", "sitemusic", "Manage Music", "", \'{"uri":"admin/sitemusic/manage/index/contentType/sitebusiness_business/contentModule/sitebusiness"}\', "sitebusiness_admin_main", "", 0, 0, 24);');
      $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitemusic.playlist.leader.owner.sitebusiness.business", "1");');
    }

    //integrating sitemusic with sitegroup
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_modules')
      ->where('name = ?', 'sitegroup')
      ->where('enabled = ?', 1);
    $is_sitegroup_object = $select->query()->fetchObject();
    if( $is_sitegroup_object ) {

      $db->query("INSERT IGNORE INTO `engine4_sitemusic_modules` (`resource_type`, `resource_id`, `resource_module`, `enabled`, `integrated`, `resource_title`, `resource_membertype`) VALUES ('sitegroup_group', 'group_id', 'sitegroup', '0', '0', 'Group Music', 'a:3:{i:0;s:14:\"contentmembers\";i:1;s:18:\"contentlikemembers\";i:2;s:20:\"contentfollowmembers\";}')");

      $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES("sitegroup_admin_main_managemusic", "sitemusic", "Manage Music", "", \'{"uri":"admin/sitemusic/manage/index/contentType/sitegroup_group/contentModule/sitegroup"}\', "sitegroup_admin_main", "", 0, 0, 24);');
      $db->query('INSERT IGNORE INTO `engine4_core_settings` ( `name`, `value`) VALUES( "sitemusic.playlist.leader.owner.sitegroup.group", "1");');
    }
  }

  public function createwidgetizePage($pageName, $pageDisplayName, $title, $description)
  {

    $db = $this->getDb();

    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', $pageName)
      ->limit(1)
      ->query()
      ->fetchColumn();
    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => $pageName,
        'displayname' => $pageDisplayName, //'Advanced Music create/edit page',
        'title' => $title, //'Edit/create',
        'description' => $description, //'Advanced Music create/edit page'
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.content',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
      ));
    }
  }

  protected function _addMusicManageAlbumPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_album')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_album',
        'displayname' => 'Advanced Music - Manage Music Page',
        'title' => 'Album Manage Page',
        'description' => 'This page is the album manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert user-album
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-album',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-album","album_layout_views":["listZZZview"],"albumDefaultLayout":"listZZZview","showOptions":["albumFavourite","albumLike","albumRating","albumComment","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":["albumName","songLike","songRating","songDownload","genre","songFavourite","songPlay","songQueue","songShare","addToPlaylist"],"gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","titleTruncationLimit":"100","gridTitleTruncationLimit":"100","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicManagePlaylistPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_playlist')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_playlist',
        'displayname' => 'Advanced Music - Manage Playlist Page',
        'title' => 'Playlist Manage Page',
        'description' => 'This page is the playlist manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert user-playlist
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-playlist',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"My Playlist","name":"sitemusic.user-playlist","playlist_layout_views":["listZZZview"],"playlistDefaultLayout":"listZZZview","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistComment","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":["songLike","playlistQueue","songDownload","songFavourite","songRating","songPlay","songQueue","genre","playlistSongDelete","songShare","addToPlaylist","albumName"],"gridViewWidth":"167","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","titleTruncationLimit":"100","gridTitleTruncationLimit":"100","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicManageSongPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_song')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_song',
        'displayname' => 'Advanced Music - Manage Song Page',
        'title' => 'Song Manage Page',
        'description' => 'This page is the song manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // mymusic-favourite
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Most Favourite Songs","name":"sitemusic.song-general","label_category":"all","ajaxTabs":["MostZZZFavourite"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","song_layout_views":["thumbnailZZZview"],"songDefaultLayout":"thumbnailZZZview","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songComment","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"gridViewWidth":"180","gridViewHeight":"328","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"7","MostZZZRated":"8","MostZZZPlayed":"9","showViewMore":"0","limit":"5","nomobile":"0"}'
      ));

      // Insert user-song
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-song',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-song","titleTruncationLimit":"100","limit":"10","nomobile":"0","itemCountPerPage":"10"}'
      ));
    }
  }

  protected function _addMusicManageArtistPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_artist')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_artist',
        'displayname' => 'Advanced Music - Manage Artist Page',
        'title' => 'Artist Manage Page',
        'description' => 'This page is the artist manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert user-artist
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-artist',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","nomobile":"0","itemCountPerPage":"10","name":"sitemusic.user-artist"}'
      ));
    }
  }

  protected function _addMusicManageFavouritePage()
  {
    $db = $this->getDb();

    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_favourite')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_favourite',
        'displayname' => 'Advanced Music - Manage Favourites Page',
        'title' => 'User Favourite Manage Page',
        'description' => 'This page is the user favourite manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-favourite',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-favourite","ajaxTabs":["album","artist","playlist","song"],"album_layout_views":["listZZZview"],"playlist_layout_views":["listZZZview"],"song_layout_views":["listZZZview"],"albumDefaultLayout":"listZZZview","playlistDefaultLayout":"listZZZview","songDefaultLayout":"listZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","Album":"1","Playlist":"2","Song":"3","Artist":"4","limit":"10","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicManageFollowingPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_following')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_following',
        'displayname' => 'Advanced Music - Manage Following List Page',
        'title' => 'User Following Manage Page',
        'description' => "This page is the manage album,artist,album's owner follow.",
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert user-following
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-following',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-following","ajaxTabs":["album","user","artist"],"album_layout_views":["listZZZview"],"album_default_views":"listZZZview","gridViewWidth":"217","gridViewHeight":"190","cardViewWidth":"371","cardViewHeight":"402","Album":"1","Artist":"2","User":"3","limit":"10","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicManageLikedPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_liked')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_liked',
        'displayname' => 'Advanced Music - Manage Liked List Page',
        'title' => 'User Likes Manage Page',
        'description' => 'This page is the user likes manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert user-like
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-liked',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-liked","ajaxTabs":["album","artist","playlist","song"],"album_layout_views":["listZZZview"],"playlist_layout_views":["listZZZview"],"song_layout_views":["listZZZview"],"albumDefaultLayout":"listZZZview","playlistDefaultLayout":"listZZZview","songDefaultLayout":"listZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","Album":"1","Playlist":"2","Song":"3","Artist":"4","limit":"5","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","nomobile":"0"}'
      ));

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));
    }
  }

  protected function _addMusicManageRatedPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_rated')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_rated',
        'displayname' => 'Advanced Music - Manage Rating List Page',
        'title' => 'User Rating Manage Page',
        'description' => 'This page is the user rating manage page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert user rated
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.user-rated',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.user-rated","ajaxTabs":["album","artist","playlist","song"],"album_layout_views":["listZZZview"],"playlist_layout_views":["listZZZview"],"song_layout_views":["listZZZview"],"albumDefaultLayout":"listZZZview","playlistDefaultLayout":"listZZZview","songDefaultLayout":"listZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","Album":"1","Playlist":"2","Song":"3","Artist":"4","limit":"10","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicAlbumBrowsePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_albums_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_albums_index',
        'displayname' => 'Advanced Music - Browse Music Albums Page',
        'title' => 'Music Album Browse',
        'description' => 'This page lists album.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert search
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-search',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-browse',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Complete Collection of Music Albums","name":"sitemusic.album-browse","label_category":"all","album_layout_views":["listZZZview","gridZZZview","cardZZZview"],"albumDefaultLayout":"listZZZview","gridViewWidth":"224","gridViewHeight":"200","cardViewWidth":"371","cardViewHeight":"382","showOptions":["albumFavourite","albumLike","albumRating","albumComment","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":["albumName","songLike","songRating","songDownload","genre","songFavourite","songPlay","songQueue","songShare","addToPlaylist"],"default_sort":"creationDate","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"12","Show \u201cView More\u201d":null,"limit":"15","nomobile":"0"}',
      ));
    }
  }

  protected function _addMusicSongBrowsePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_songs_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_songs_index',
        'displayname' => 'Advanced Music - Browse Songs Page',
        'title' => 'Music Song Browse',
        'description' => 'This page lists song.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();



      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert search
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-search',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // insert song-browse widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-browse',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Complete Collection of Songs","name":"sitemusic.song-browse","label_category":"all","song_layout_views":["listZZZview","gridZZZview"],"songDefaultLayout":"listZZZview","gridViewWidth":"226","gridViewHeight":"200","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"listTitleTruncationLimit":"100","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"20","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}'
      ));

    }
  }

  protected function _addMusicArtistBrowsePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_artists_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_artists_index',
        'displayname' => 'Advanced Music - Browse Artist Page',
        'title' => 'Music Artist Browse',
        'description' => 'This page lists artist.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // insert pick of the day artist
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-artist',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Featured Artists","name":"sitemusic.item-artist","item_title":"","artist_id":"","itemIds":"2 10 12 1","titleTruncationLimit":"20","starttime":"0000-00-00","endtime":"0000-00-00","limit":"2","nomobile":"0"}'
      ));

      // insert artist-general for favourite
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Popular Artists","name":"sitemusic.artist-general","label_category":"all","artist_layout_views":["thumbnailZZZview"],"artistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","popularType":"like_count","thumbnailTitleTruncationLimit":"12","gridTitleTruncationLimit":"100","Trending":"1","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"6","MostZZZRated":"6","showViewMore":"0","limit":"5","nomobile":"0"}'
      ));

      // insert artist-general for trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Most Followed Artists","name":"sitemusic.artist-general","label_category":"all","artist_layout_views":["thumbnailZZZview"],"artistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"ajaxTabs":["MostZZZFollowed"],"trendingType":"like","trendingSort":"last_week","popularType":"like_count","thumbnailTitleTruncationLimit":"20","gridTitleTruncationLimit":"100","Trending":"1","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"6","MostZZZRated":"6","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));



      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert search
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-search',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert artist browse widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-browse',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.album-browse","label_category":"all","artist_layout_views":["gridZZZview"],"artistDefaultLayout":null,"gridViewWidth":"211","gridViewHeight":"180","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"default_sort":"creationDate","thumbnailTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","showViewMore":"1","limit":"36","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicPlaylistBrowsePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_playlists_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_playlists_index',
        'displayname' => 'Advanced Music - Browse Playlist Page',
        'title' => 'Music Playlist Browse',
        'description' => 'This page lists playlist.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // insert pick of the day playlist
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-playlist',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Featured Playlists","name":"sitemusic.item-playlist","item_title":"","userplaylist_id":"","itemIds":"2 2 2 3","titleTruncationLimit":"12","starttime":"2018-03-02 02:10:00","endtime":"2018-05-26 00:20:00","limit":"2","nomobile":"0"}'
      ));


      // trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.playlist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Trending Playlists","name":"sitemusic.playlist-general","label_category":"all","playlist_layout_views":["thumbnailZZZview"],"playlistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":"","ajaxTabs":["Trending"],"trendingType":"like","trendingSort":"last_month","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"12","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","Show \u201cView More\u201d":null,"limit":"5","nomobile":"0"}'
      ));

      // most favourite
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.playlist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Popular Playlists","name":"sitemusic.playlist-general","label_category":"all","playlist_layout_views":["thumbnailZZZview"],"playlistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":"","ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","Show \u201cView More\u201d":null,"limit":"5","nomobile":"0"}',
      ));

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert search
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-search',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert playlist browse widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.playlist-browse',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.playlist-browse","label_category":"all","playlist_layout_views":["listZZZview","cardZZZview","gridZZZview"],"playlistDefaultLayout":"listZZZview","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistComment","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":["songLike","playlistQueue","songDownload","songFavourite","songRating","songPlay","songQueue","genre","playlistSongDelete","songShare","addToPlaylist","albumName"],"gridViewWidth":"219","gridViewHeight":"200","cardViewWidth":"283","cardViewHeight":"282","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"20","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicEditSongPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_songs_editinfo')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_songs_editinfo',
        'displayname' => 'Advanced Music - Edit Song Page',
        'title' => 'Edit Song',
        'description' => 'This page is the edit song information page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();


      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.content',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
      ));
    }
  }

  protected function _addMusicAlbumProfilePage()
  {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_albums_view')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_albums_view',
        'displayname' => 'Advanced Music - Music Album Profile Page',
        'title' => 'Album Profile Page',
        'description' => 'This page is the Album Profile Page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // insert album-general for trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Trending Music Albums","name":"sitemusic.album-general","label_category":"all","album_category":"all","album_layout_views":["thumbnailZZZview"],"albumDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","cardViewWidth":"371","cardViewHeight":"402","showOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":"","ajaxTabs":["Trending"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"15","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));

      // Insert related album widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.related-album',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"You May Also Like","name":"sitemusic.related-album","thumbnailTitleTruncationLimit":"15","relatedType":"albumCategory","limit":"5","nomobile":"0"}',
      ));

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert Breadcrumb Menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-breadcrumb',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert cover photo
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-cover-photo',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"entity_type":"album","title":"","nomobile":"0","name":"sitemusic.item-cover-photo"}'
      ));

      // Insert entity info
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-info',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"Info","entity_type":"album","nomobile":"0","name":"sitemusic.entity-info"}',
      ));
      // Insert entity tracks
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-tracks',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Tracks","entity_type":"album","titleTruncationLimit":"100","limit":"3","nomobile":"0","name":"sitemusic.entity-tracks"}',
      ));

      // Insert comments
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.comments',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 6,
        'params' => '{"title":"Comments"}',
      ));
    }
  }

  protected function _addMusicSongProfilePage()
  {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_songs_view')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_songs_view',
        'displayname' => 'Advanced Music - Song Profile Page',
        'title' => 'Song Profile Page',
        'description' => 'This page is the Song Profile Page',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();


      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert Breadcrumb Menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-breadcrumb',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert cover photo
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-cover-photo',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"entity_type":"song","title":"","nomobile":"0","name":"sitemusic.item-cover-photo"}'
      ));

      // Insert entity info
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-info',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"Info","entity_type":"song","nomobile":"0","name":"sitemusic.entity-info"}',
      ));

      // Insert entity lyrics
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.lyrics',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Lyrics","entity_type":"Song"}',
      ));

      // Insert comments
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.comments',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 6,
        'params' => '{"title":"Comments"}',
      ));

      // Insert related song widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.related-song',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"You May Also Like","name":"sitemusic.related-song","thumbnailTitleTruncationLimit":"15","relatedType":"genre","limit":"5","nomobile":"0"}',
      ));

      // insert song-general for trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 3,
        'params' => '{"title":"Trending Songs","name":"sitemusic.song-general","label_category":"all","song_layout_views":["thumbnailZZZview"],"songDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"ajaxTabs":["Trending"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"15","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","MostZZZPlayed":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));
    }
  }

  protected function _addMusicPlaylistProfilePage()
  {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_playlists_view')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_playlists_view',
        'displayname' => 'Advanced Music - Playlist Profile Page',
        'title' => 'Playlist Profile Page',
        'description' => 'This page is the Playlist Profile Page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();


      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // most favourite
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.related-playlist',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"You May Also Like","name":"sitemusic.related-playlist","thumbnailTitleTruncationLimit":"15","limit":"5","nomobile":"0"}',
      ));

      // trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.playlist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 3,
        'params' => '{"title":"Most Popular Playlists","name":"sitemusic.playlist-general","label_category":"all","playlist_layout_views":["thumbnailZZZview"],"playlistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistComment","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":"","ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"15","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","Show \u201cView More\u201d":null,"limit":"5","nomobile":"0"}'
      ));


      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert Breadcrumb Menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-breadcrumb',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert cover photo
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-cover-photo',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"entity_type":"playlist","title":"","nomobile":"0","name":"sitemusic.item-cover-photo"}'
      ));

      // Insert entity info
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-info',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"Info","entity_type":"playlist","nomobile":"0","name":"sitemusic.entity-info"}',
      ));
      // Insert entity tracks
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-tracks',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Tracks","entity_type":"Playlist"}',
      ));

      // Insert comments
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.comments',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 6,
        'params' => '{"title":"Comments"}',
      ));
    }
  }

  protected function _addMusicArtistProfilePage()
  {
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);
    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_artists_view')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_artists_view',
        'displayname' => 'Advanced Music - Artist Profile Page',
        'title' => 'Artist Profile Page',
        'description' => 'This page is the Artist Profile Page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // insert artist-general for trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Trending Artists","name":"sitemusic.artist-general","label_category":"all","artist_layout_views":["thumbnailZZZview"],"artistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"ajaxTabs":["Trending"],"trendingType":"like","trendingSort":"last_month","popularType":"like_count","thumbnailTitleTruncationLimit":"15","gridTitleTruncationLimit":"100","Trending":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));

      // insert artist-general for popular
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Most Popular Artists","name":"sitemusic.artist-general","label_category":"all","artist_layout_views":["thumbnailZZZview"],"artistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","popularType":"like_count","thumbnailTitleTruncationLimit":"15","gridTitleTruncationLimit":"100","Trending":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));
      // Insert Breadcrumb Menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-breadcrumb',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert cover photo
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-cover-photo',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"max":"4","coverPhoto":null,"entity_type":"artist","title":"","nomobile":"0","name":"sitemusic.item-cover-photo"}'
      ));

      // Insert entity info
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-info',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"Info","entity_type":"artist","titleTruncationLimit":"100","limit":"5","nomobile":"0","name":"sitemusic.entity-tracks"}',
      ));
      // Insert entity tracks
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.entity-tracks',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Tracks","entity_type":"Artist"}',
      ));

      // Insert comments
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.comments',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 6,
        'params' => '{"title":"Comments"}',
      ));
    }
  }

  protected function _addMusicHomePage()
  {
    $db = $this->getDb();

    // Home page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_index_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      $containerCount = 0;
      $widgetCount = 0;

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_index_index',
        'displayname' => 'Advanced Music - Music Home Page',
        'title' => 'Music Home Page',
        'description' => 'This page is the advanced music home page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      //TOP CONTAINER
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => $containerCount++,
      ));
      $top_container_id = $db->lastInsertId();

      //MAIN CONTAINER
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => $containerCount++,
      ));
      $main_container_id = $db->lastInsertId();

      //INSERT TOP-MIDDLE
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $top_container_id,
        'order' => $containerCount++,
      ));
      $topMiddleId = $db->lastInsertId();

      //RIGHT CONTAINER
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $main_container_id,
        'order' => $containerCount++,
      ));
      $right_container_id = $db->lastInsertId();

      //MAIN-MIDDLE CONTAINER
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $main_container_id,
        'order' => $containerCount++,
      ));
      $mainMiddleId = $db->lastInsertId();

      $db->insert('engine4_core_content', array(
        'page_id' => $pageId,
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'parent_content_id' => $topMiddleId,
        'order' => 1,
        'params' => '',
      ));

      $db->insert('engine4_core_content', array(
        'page_id' => $pageId,
        'type' => 'widget',
        'name' => 'sitemusic.categorized-album',
        'parent_content_id' => $topMiddleId,
        'order' => 2,
        'params' => '',
      ));

      $db->insert('engine4_core_content', array(
        'page_id' => $pageId,
        'type' => 'widget',
        'name' => 'sitemusic.trending-carousel',
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Trending Music Albums","name":"sitemusic.trending-carousel","ajaxTabs":["album"],"gridTitleTruncationLimit":"100","albumcategory_id":"all","genre_id":"All","albumShowOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","songCount"],"carouselHeight":"200","songShowOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"playlistShowOptions":["playlistFavourite","playlistLike","playlistRating","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","songCount"],"artistShowOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"Album":"1","Playlist":"4","Song":"2","Artist":"3","autoPlay":"0","slideItemlimitM":"1","slideItemlimitT":"2","slideItemlimit":"3","seeAll":"1","limit":"10","trendingType":"like","trendingSort":"last_week","nomobile":"0"}',
      ));

      // insert artist-general for most followed
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"User\'s Favourite Music Albums","name":"sitemusic.album-general","label_category":"all","album_category":"all","album_layout_views":["listZZZview","gridZZZview","cardZZZview"],"albumDefaultLayout":"cardZZZview","gridViewWidth":"218","gridViewHeight":"180","cardViewWidth":"283","cardViewHeight":"382","showOptions":["albumFavourite","albumLike","albumRating","albumComment","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":["albumName","songLike","songRating","songDownload","genre","songFavourite","songPlay","songQueue","songShare","addToPlaylist"],"ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_month","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"12","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"7","MostZZZRated":"8","showViewMore":"0","limit":"6","nomobile":"0"}'
      ));

      // Insert most-popular-carousel
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.most-popular-carousel',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 3,
        'params' => '{"title":"Popular Songs","name":"sitemusic.most-popular-carousel","ajaxTabs":["song"],"gridTitleTruncationLimit":"30","albumcategory_id":"all","genre_id":"All","albumShowOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","songCount"],"carouselHeight":"200","songShowOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"playlistShowOptions":["playlistFavourite","playlistLike","playlistRating","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","songCount"],"artistShowOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"Album":"1","Playlist":"4","Song":"2","Artist":"3","autoPlay":"1","slideItemlimitM":"1","slideItemlimitT":"2","slideItemlimit":"3","seeAll":"1","limit":"10","popularType":"like_count","nomobile":"0"}',
      ));

      // insert artist-general for most followed
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 4,
        'params' => '{"title":"Most Played Songs","name":"sitemusic.song-general","label_category":"all","song_layout_views":["listZZZview","gridZZZview"],"songDefaultLayout":"listZZZview","gridViewWidth":"217","gridViewHeight":"180","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"ajaxTabs":["MostZZZPlayed"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"12","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZRated":"7","MostZZZPlayed":"8","showViewMore":"0","limit":"8","nomobile":"0"}'
      ));

      // Insert most-favourite-carousel
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.most-favourite-carousel',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 5,
        'params' => '{"title":"Top Favourite Artists","name":"sitemusic.most-favourite-carousel","ajaxTabs":["artist"],"gridTitleTruncationLimit":"30","albumcategory_id":"all","genre_id":"All","albumShowOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","songCount"],"carouselHeight":"200","songShowOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"playlistShowOptions":["playlistFavourite","playlistLike","playlistRating","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","songCount"],"artistShowOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"Album":"3","Playlist":"2","Song":"4","Artist":"1","autoPlay":"1","slideItemlimitM":"1","slideItemlimitT":"2","slideItemlimit":"4","seeAll":"1","limit":"10","nomobile":"0"}',
      ));






      // right side widget

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.side-recently-played',
        'page_id' => $pageId,
        'parent_content_id' => $right_container_id,
        'order' => 1,
        'params' => '{"title":"Recently Played","thumbnailTitleTruncationLimit":"20","nomobile":"0","itemCountPerPage":"5","name":"sitemusic.side-recently-played"}'
      ));

      // insert artist-general
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.artist-general',
        'page_id' => $pageId,
        'parent_content_id' => $right_container_id,
        'order' => 2,
        'params' => '{"title":"Popular Artists","name":"sitemusic.artist-general","label_category":"all","artist_layout_views":["thumbnailZZZview"],"artistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["artistFavourite","artistRating","songCount","artistFollow","artistLike","artistLabel","artistFavouriteCount","artistLikeCount"],"ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","popularType":"like_count","thumbnailTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","Trending":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"","showViewMore":"0","limit":"5","nomobile":"0"}'
      ));

      // insert playlist-general
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.playlist-general',
        'page_id' => $pageId,
        'parent_content_id' => $right_container_id,
        'order' => 3,
        'params' => '{"title":"Popular Playlists","name":"sitemusic.playlist-general","label_category":"all","playlist_layout_views":["thumbnailZZZview"],"playlistDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistComment","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":"","ajaxTabs":["MostZZZLiked"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZRated":"6","Show \u201cView More\u201d":null,"limit":"5","nomobile":"0"}'
      ));

    }
  }

  protected function _addMusicMusicAlbumCategoriesPage()
  {
    $db = $this->getDb();

    // Home page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_categories_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_categories_index',
        'displayname' => 'Advanced Music - Music Album Categories Home Page',
        'title' => 'Music Album Categories',
        'description' => 'This page is the Categories page of Advanced music.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();


      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert album-category-slideshow
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-category-slideshow',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"categoryHeight":"500","albumCategoryId":["1","2","3","4","5","6","7","8","9","10","11","12","14","15","13"],"showExplore":"1","showNavigation":"1","titleTruncation":"30","taglineTruncation":"100","nomobile":"","title":"","name":"sitemusic.album-category-slideshow"}'
      ));

      // Insert genre category
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.categories',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 4,
        'params' => '{"categoryType":"albumCategory","onZeroCategoryVisible":"1","limit":"20","title":"","nomobile":"0","name":"sitemusic.categories"}'
      ));

      // Insert categorized album
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.categorized-album',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 4,
        'params' => '{"label_category":"all","limit":"10","title":"","nomobile":"0","name":"sitemusic.categorized-album"}'
      ));

      // Insert categorized album
      // $db->insert('engine4_core_content', array(
      //   'type' => 'widget',
      //   'name' => 'sitemusic.categorized-album',
      //   'page_id' => $pageId,
      //   'parent_content_id' => $mainMiddleId,
      //   'order' => 5,
      //   'params' => '{"label_category":"all","limit":"10","title":"","nomobile":"0","name":"sitemusic.categorized-album"}'
      // ));
    }
  }

  protected function _addMusicGenrePage()
  {
    $db = $this->getDb();

    // Home page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_genres_index')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_genres_index',
        'displayname' => 'Advanced Music - Music Song Genre Home Page',
        'title' => 'Music Songs Genre',
        'description' => 'This page is the Categories page of Advanced music.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();


      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.genre-slideshow',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
        'params' => '{"categoryHeight":"500","genreId":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19"],"showExplore":"1","showNavigation":"1","titleTruncation":"15","taglineTruncation":"30","nomobile":"","title":"","name":"sitemusic.genre-slideshow"}'
      ));

      // Insert categorized album
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.categories',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"categoryType":"genre","onZeroCategoryVisible":"1","limit":"20","title":"","nomobile":"0","name":"sitemusic.categories"}'
      ));

      $db->insert('engine4_core_content', array(
        'page_id' => $pageId,
        'type' => 'widget',
        'name' => 'sitemusic.trending-carousel',
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
        'params' => '{"title":"Trending Songs","name":"sitemusic.trending-carousel","ajaxTabs":["song"],"gridTitleTruncationLimit":"20","albumcategory_id":"all","genre_id":"All","albumShowOptions":"","carouselHeight":"180","songShowOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"playlistShowOptions":"","artistShowOptions":"","Album":"1","Playlist":"2","Song":"3","Artist":"4","autoPlay":"1","slideItemlimitM":"1","slideItemlimitT":"2","slideItemlimit":"5","seeAll":"1","limit":"10","trendingType":"like","trendingSort":"last_week","nomobile":"0"}',
      ));

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.most-popular-carousel',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 3,
        'params' => '{"title":"Popular Songs","name":"sitemusic.most-popular-carousel","ajaxTabs":["song"],"gridTitleTruncationLimit":"20","albumcategory_id":"all","genre_id":"All","albumShowOptions":"","carouselHeight":"180","songShowOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"playlistShowOptions":"","artistShowOptions":"","Album":"1","Playlist":"2","Song":"3","Artist":"4","autoPlay":"1","slideItemlimitM":"1","slideItemlimitT":"2","slideItemlimit":"5","seeAll":"1","limit":"10","popularType":"like_count","nomobile":"0"}',
      ));
    }
  }

  protected function _addMusicAlbumHomePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_albums_home')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_albums_home',
        'displayname' => 'Advanced Music - Music Albums Home Page',
        'title' => 'Music Album Home',
        'description' => 'This page is album home page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.most-popular-carousel',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
        'params' => '{"title":"Popular Albums","name":"sitemusic.most-popular-carousel","ajaxTabs":["album"],"gridTitleTruncationLimit":"30","albumcategory_id":"all","genre_id":"All","albumShowOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","songCount"],"carouselHeight":"200","songShowOptions":"","playlistShowOptions":"","artistShowOptions":"","Album":"1","Playlist":"2","Song":"3","Artist":"4","autoPlay":"1","slideItemlimitM":"1","slideItemlimitT":"3","slideItemlimit":"5","seeAll":"0","limit":"15","popularType":"like_count","nomobile":"0"}',
      ));






      // insert album-general
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.album-general","label_category":"all","album_category":"all","album_layout_views":["listZZZview","gridZZZview","cardZZZview"],"albumDefaultLayout":"listZZZview","gridViewWidth":"219","gridViewHeight":"200","cardViewWidth":"283","cardViewHeight":"382","showOptions":["albumFavourite","albumLike","albumRating","albumComment","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":["albumName","songLike","songRating","songDownload","genre","songFavourite","songPlay","songQueue","songShare","addToPlaylist"],"ajaxTabs":["Trending","Latest","MostZZZLiked","MostZZZPopular","MostZZZFavourite","MostZZZFollowed","MostZZZRated"],"trendingType":"like","trendingSort":"last_month","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"20","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"20","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"7","MostZZZRated":"8","showViewMore":"1","limit":"10","nomobile":"0"}',
      ));

      // insert pick of the day album
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-album',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Album Of The Day"}'
      ));

      // insert album-general
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Most Rated Albums","name":"sitemusic.album-general","label_category":"all","album_category":"all","album_layout_views":["thumbnailZZZview"],"albumDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","cardViewWidth":"371","cardViewHeight":"402","showOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":"","ajaxTabs":["MostZZZRated"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"8","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));

      // insert album-general
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 3,
        'params' => '{"title":"Most Followed Albums","name":"sitemusic.album-general","label_category":"all","album_category":"all","album_layout_views":["thumbnailZZZview"],"albumDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","cardViewWidth":"371","cardViewHeight":"402","showOptions":["albumFavourite","albumLike","albumRating","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":"","ajaxTabs":["MostZZZFollowed"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","cardTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZFollowed":"","MostZZZRated":"8","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));
    }
  }

  protected function _addMusicSongHomePage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_songs_home')
      ->limit(1)
      ->query()
      ->fetchColumn();

    // insert if it doesn't exist yet
    if( !$pageId ) {
      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_songs_home',
        'displayname' => 'Advanced Music - Songs Home Page',
        'title' => 'Music Song Home',
        'description' => 'This page is song home page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert genre category
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.genre-categories',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 3,
      ));

      // insert song-browse widget
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-browse',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"","name":"sitemusic.song-browse","label_category":"all","song_layout_views":["listZZZview","gridZZZview"],"songDefaultLayout":"listZZZview","gridViewWidth":"217","gridViewHeight":"180","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"listTitleTruncationLimit":"100","gridTitleTruncationLimit":"20","thumbnailTitleTruncationLimit":"12","default_sort":"creationDate","showViewMore":"1","limit":"12","nomobile":"0"}'
      ));

      // insert pick of the day song
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.item-song',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Chartbusters","name":"sitemusic.item-song","item_title":"","song_id":"","itemIds":"3 2","titleTruncationLimit":"20","starttime":"2018-02-01 01:00:00","endtime":"2018-04-28 03:00:00","limit":"2","nomobile":"0"}'
      ));

      // insert song-general for latest
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Popular Songs","name":"sitemusic.song-general","label_category":"all","song_layout_views":["thumbnailZZZview"],"songDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"ajaxTabs":["MostZZZPopular"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","MostZZZPlayed":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));

      // insert song-general for trending
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 3,
        'params' => '{"title":"Most Played Songs","name":"sitemusic.song-general","label_category":"all","song_layout_views":["thumbnailZZZview"],"songDefaultLayout":"thumbnailZZZview","gridViewWidth":"180","gridViewHeight":"328","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"ajaxTabs":["MostZZZPlayed"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","listTitleTruncationLimit":"100","gridTitleTruncationLimit":"100","thumbnailTitleTruncationLimit":"20","Trending":"","Latest":"","MostZZZPopular":"","MostZZZLiked":"","MostZZZFavourite":"","MostZZZRated":"","MostZZZPlayed":"","showViewMore":"0","limit":"5","nomobile":"0"}',
      ));
    }
  }

  protected function _addMusicPlayer()
  {

    $db = $this->getDb();

    $footerPageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'footer')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !empty($footerPageId) ) {
      $parentContentId = $db->select()
          ->from('engine4_core_content', 'content_id')
          ->where('page_id = ?', $footerPageId)
          ->where('name = ?', 'main')
          ->where('type = ?', 'container')
          ->limit(1)->query()->fetchColumn();
    }
    if( !empty($parentContentId) ) {
      $contentId = $db->select()
          ->from('engine4_core_content', 'content_id')
        ->where('name = ?', 'sitemusic.music-player')
        ->where('page_id = ?', $footerPageId)
        ->limit(1)
        ->query()
        ->fetchColumn();
    }
    if( empty($contentId) ) {
      // insert music-player
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.music-player',
        'page_id' => $footerPageId,
        'parent_content_id' => $parentContentId,
        'order' => 1,
      ));
    }
  }

  protected function _addMusicHistory()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_manage_history')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_manage_history',
        'displayname' => 'Advanced Music - Songs History Page',
        'title' => 'Manage History Page',
        'description' => 'This page is the manage history page.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert Mymusic menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.mymusic-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 2,
      ));

      // Insert recently-played
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.recently-played',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 1,
        'params' => '{"title":"Recently Played","name":"sitemusic.recently-played","showOptions":["songLike","songShare","songComment","songDownload","songQueue","songFavourite","addToPlaylist","songPlay","albumName","playAll","clearAll"],"limit":"10","nomobile":"0"}'
      ));

      // most-favourite-album
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.album-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 1,
        'params' => '{"title":"Most Favourite Albums","name":"sitemusic.album-general","album_category":"all","ajaxTabs":["MostZZZFavourite"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","album_layout_views":["thumbnailZZZview"],"albumDefaultLayout":"thumbnailZZZview","showOptions":["albumFavourite","albumLike","albumRating","songRating","albumComment","genre","albumShare","songLike","songDownload","albumQueue","albumInfo","songFavourite","songComment","songPlay","songQueue","songShare","addToPlaylist","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","songCount","likeCount","albumCommentCount","albumLabel","albumName","albumCategory"],"gridViewWidth":"180","gridViewHeight":"328","cardViewWidth":"371","cardViewHeight":"402","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZDownloaded":"6","MostZZZFollowed":"7","MostZZZRated":"8","showViewMore":"0","limit":"5","nomobile":"0"}'
      ));

      // most-favourite-song
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.song-general',
        'page_id' => $pageId,
        'parent_content_id' => $mainRightId,
        'order' => 2,
        'params' => '{"title":"Most Favourite Songs","name":"sitemusic.song-general","label_category":"all","ajaxTabs":["MostZZZFavourite"],"trendingType":"like","trendingSort":"last_week","latestSort":"creation_date","popularType":"like_count","song_layout_views":["thumbnailZZZview"],"songDefaultLayout":"thumbnailZZZview","showOptions":["songRating","genre","songLikeCount","songCommentCount","songFavouriteCount","songLike","songShare","songComment","songDownload","songDownloadCount","songQueue","songInfo","songFavourite","addToPlaylist","songPlay","playCount","songLabel","albumName"],"gridViewWidth":"180","gridViewHeight":"328","Trending":"1","Latest":"2","MostZZZPopular":"3","MostZZZLiked":"4","MostZZZFavourite":"5","MostZZZFollowed":"7","MostZZZRated":"8","MostZZZPlayed":"9","showViewMore":"0","limit":"5","nomobile":"0"}'
      ));
    }
  }

  protected function _addMusicUnapprovedSongPage()
  {
    $db = $this->getDb();

    // profile page
    $pageId = $db->select()
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'sitemusic_albums_unapprove-songs')
      ->limit(1)
      ->query()
      ->fetchColumn();

    if( !$pageId ) {

      // Insert page
      $db->insert('engine4_core_pages', array(
        'name' => 'sitemusic_albums_unapprove-songs',
        'displayname' => 'Advanced Music - Unapprove Songs Page',
        'title' => 'Manage History Page',
        'description' => 'This page is the content unapproved songs.',
        'custom' => 0,
      ));
      $pageId = $db->lastInsertId();

      // Insert top
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'top',
        'page_id' => $pageId,
        'order' => 1,
      ));
      $topId = $db->lastInsertId();

      // Insert main
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'main',
        'page_id' => $pageId,
        'order' => 2,
      ));
      $mainId = $db->lastInsertId();

      // Insert top-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $topId,
      ));
      $topMiddleId = $db->lastInsertId();

      // Insert main-middle
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'middle',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 2,
      ));
      $mainMiddleId = $db->lastInsertId();

      // Insert main-right
      $db->insert('engine4_core_content', array(
        'type' => 'container',
        'name' => 'right',
        'page_id' => $pageId,
        'parent_content_id' => $mainId,
        'order' => 1,
      ));
      $mainRightId = $db->lastInsertId();

      // Insert menu
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'sitemusic.browse-menu',
        'page_id' => $pageId,
        'parent_content_id' => $topMiddleId,
        'order' => 1,
      ));

      // Insert content
      $db->insert('engine4_core_content', array(
        'type' => 'widget',
        'name' => 'core.content',
        'page_id' => $pageId,
        'parent_content_id' => $mainMiddleId,
        'order' => 2,
      ));

    }
  }

  protected function _addUserProfileContent()
  {
    //
    // install content areas
    //
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);

    // profile page
    $select
      ->from('engine4_core_pages', 'page_id')
      ->where('name = ?', 'user_profile_index')
      ->limit(1);
    $pageId = $select->query()->fetchColumn();

    if( !empty($pageId) ) {

      $tab_id = $db->select()
        ->from('engine4_core_content', array('content_id'))
        ->where('page_id =?', $pageId)
        ->where('type = ?', 'widget')
        ->where('name = ?', 'core.container-tabs')
        ->limit(1)
        ->query()
        ->fetchColumn();

      if( !empty($tab_id) ) {

        $content_id = $db->select()
          ->from('engine4_core_content', array('content_id'))
          ->where('page_id =?', $pageId)
          ->where('type = ?', 'widget')
          ->where('name = ?', 'sitemusic.user-album')
          ->limit(1)
          ->query()
          ->fetchColumn();

        if( empty($content_id) ) {
          $db->insert('engine4_core_content', array(
            'page_id' => $pageId,
            'type' => 'widget',
            'name' => 'sitemusic.user-album',
            'parent_content_id' => $tab_id,
            'order' => 999,
            'params' => '{"title":"Music Albums","titleCount":true,"name":"sitemusic.user-album","album_layout_views":["listZZZview"],"albumDefaultLayout":"listZZZview","showOptions":["albumFavourite","albumLike","albumRating","albumComment","albumShare","albumQueue","albumInfo","albumPlay","albumPlayCount","albumFavouriteCount","albumDownloadCount","albumCommentCount","albumLikeCount","albumLabel","albumCategory","songCount"],"showSongOptions":["albumName","songLike","songRating","songDownload","genre","songFavourite","songPlay","songQueue","songShare","addToPlaylist"],"gridViewWidth":"180","gridViewHeight":"","cardViewWidth":"371","titleTruncationLimit":"100","gridTitleTruncationLimit":"100","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}',
          ));
        }

        $content_id = $db->select()
          ->from('engine4_core_content', array('content_id'))
          ->where('page_id =?', $pageId)
          ->where('type = ?', 'widget')
          ->where('name = ?', 'sitemusic.user-playlist')
          ->limit(1)
          ->query()
          ->fetchColumn();

        if( empty($content_id) ) {
          $db->insert('engine4_core_content', array(
            'page_id' => $pageId,
            'type' => 'widget',
            'name' => 'sitemusic.user-playlist',
            'parent_content_id' => $tab_id,
            'order' => 999,
            'params' => '{"title":"My Playlist","titleCount":true,"name":"sitemusic.user-playlist","playlist_layout_views":["listZZZview"],"playlistDefaultLayout":"listZZZview","showOptions":["playlistFavourite","playlistLike","playlistRating","playlistComment","playlistShare","playlistPlay","playlistFavouriteCount","playlistLikeCount","playlistCommentCount","playlistLabel","playlistQueue","songCount"],"showSongOptions":["songLike","playlistQueue","songDownload","songFavourite","songRating","songPlay","songQueue","genre","playlistSongDelete","songShare","addToPlaylist","albumName"],"gridViewWidth":"167","gridViewHeight":"","cardViewWidth":"371","cardViewHeight":"402","titleTruncationLimit":"100","gridTitleTruncationLimit":"100","default_sort":"creationDate","showViewMore":"1","limit":"10","nomobile":"0"}',
          ));
        }
      }
    }
  }

}

?>
