<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStartP = "site-musics";
$routeStartS = "site-music";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if( !empty($request) ) {
  $module = $request->getModuleName(); // Return the current module name.
  $action = $request->getActionName();
  $controller = $request->getControllerName();
  $getURL = $request->getRequestUri();
}
if( empty($request) || !($module == "default" && ( strpos($getURL, '/install') !== false)) ) {
  $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic.manifestUrlP', "site-musics");
  $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitemusic.manifestUrlS', "site-music");
}
return array(
  // Package -------------------------------------------------------------------
  'package' => array(
    'type' => 'module',
    'name' => 'sitemusic',
    'version' => '5.9.1',
    'sku' => 'seao-sitemusic',
    'revision' => null,
    'path' => 'application/modules/Sitemusic',
    'repository' => null,
    'title' => 'Advanced Music Plugin',
    'description' => 'Advanced Music Plugin enables users to upload audios(songs) from their local computers, and downloadable url, create albums and playlist.',
    'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
    'actions' => array(
      'install',
      'upgrade',
      'refresh',
      'enable',
      'disable',
    ),
    'callback' => array(
      'path' => 'application/modules/Sitemusic/settings/install.php',
      'class' => 'Sitemusic_Installer',
    ),
    'dependencies' => array(
          array(
            'type' => 'module',
            'name' => 'seaocore',
            'minVersion' => '4.10.3p28',
          ),
     ),
    'directories' => array(
      0 => 'application/modules/Sitemusic',
      1 => 'application/libraries/id3',
    ),
    'files' => array(
      0 => 'application/languages/en/sitemusic.csv',
    ),
  ),
  // Compose -------------------------------------------------------------------
  'compose' => array(
    array('_composeSitemusic.tpl', 'sitemusic'),
  ),
  'composer' => array(
    'sitemusic' => array(
      'script' => array('_composeSitemusic.tpl', 'sitemusic'),
      'plugin' => 'Sitemusic_Plugin_Composer',
      'auth' => array('sitemusic_pl', 'create'),
    ),
  ),
  // Hooks ---------------------------------------------------------------------
  'hooks' => array(
    array(
      'event' => 'onStatistics',
      'resource' => 'Sitemusic_Plugin_Core'
    ),
    array(
      'event' => 'onUserDeleteBefore',
      'resource' => 'Sitemusic_Plugin_Core',
    ),
    array(
      'event' => 'onSitemusicPlDeleteBefore',
      'resource' => 'Sitemusic_Plugin_Core',
    ),
    array(
      'event' => 'onSitemusicUserplDeleteBefore',
      'resource' => 'Sitemusic_Plugin_Core',
    ),
    array(
      'event' => 'onSitemusicLabelDeleteBefore',
      'resource' => 'Sitemusic_Plugin_Core',
    ),
    array(
      'event' => 'onSitemusicPlCreateAfter',
      'resource' => 'Sitemusic_Plugin_Core',
    ),
//    array(
//      'event' => 'onSitemusicPlUpdateAfter',
//      'resource' => 'Sitemusic_Plugin_Core',
//    ),
  ),
  // Items ---------------------------------------------------------------------
  'items' => array(
    'sitemusic_pl',
    'sitemusic_playlist',
    'sitemusic_playlist_song',
    'sitemusic_artist',
    'sitemusic_songcategory',
    'sitemusic_albumcategory',
    'sitemusic_label',
    'sitemusic_songartist',
    'sitemusic_userpl',
    'sitemusic_user_playlist',
    'sitemusic_user_playlist_song',
    'sitemusic_user_follow_count',
    'sitemusic_favourite'
  ),
  // Routes --------------------------------------------------------------------
  'routes' => array(
    'sitemusic_general' => array(
      'route' => $routeStartP . '/:controller/:action/*',
      'defaults' => array(
        'module' => 'sitemusic',
        'controller' => 'index',
        'action' => 'index',
      ),
      'reqs' => array(
        'controller' => '\D+',
        'action' => '\D+',
      ),
    ),
    'sitemusic_item_view' => array(
      'route' => $routeStartS . '/:controller/:item_id/:slug/*',
      'defaults' => array(
        'module' => 'sitemusic',
        'controller' => 'albums',
        'action' => 'view',
        'slug' => '',
      ),
      'reqs' => array(
        'item_id' => '\d+',
      ),
    ),
    'sitemusic_item_specific' => array(
      'route' => $routeStartS . '/:controller/:action/:item_id/:slug/*',
      'defaults' => array(
        'module' => 'sitemusic',
        'controller' => 'albums',
        'action' => 'edit',
        'slug' => '',
      ),
      'reqs' => array(
        'item_id' => '\d+',
        'action' => '(edit|delete|sort|editinfo|add-song|append)',
      ),
    ),
  ),
  )
?>
