<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_EntityTracksController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $params = array();
    $params['entity_type'] = $this->view->entityType = $entityType = ucfirst($this->_getParam('entity_type', 'Album'));
    $values = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $params['item_id'] = $itemId = $values['item_id'];
    $this->view->showOptions = array('All');
    if( $entityType == 'Playlist' ) {
      $resourceType = 'sitemusic_userpl';
      $entityId = 'userplaylist_id';
    } elseif( $entityType == 'Artist' ) {
      $entityId = 'artist_id';
      $resourceType = 'sitemusic_artist';
    } elseif( $entityType == 'Album' ) {
      $entityId = 'playlist_id';
      $resourceType = 'sitemusic_pl';
    }
    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $item = Engine_Api::_()->getItem($resourceType, $itemId);
    if( !empty($item) ) {
      $this->view->songs = $songs = $item->getSongs();
      if(empty($songs)) {
        return $this->setNoRender();
      }
      $jsonSongInfo = Engine_Api::_()->getApi('core', 'sitemusic')->changeSongsToJsonString($songs);
      $this->view->jsonSongInfo = $jsonSongInfo;
      $this->view->paginator = $paginator = Zend_Paginator::factory($songs);
      $this->view->totalCount = $paginator->getTotalItemCount();
      $limit = $this->_getParam('limit', 10);
      $paginator->setItemCountPerPage($limit);
      if( isset($values['page']) ) {
        $params['page'] = $page = $values['page'];
      } else {
        $params['page'] = $page = 1;
      }
      $this->view->showViewMore = $this->_getParam('showViewMore', 1);
      $this->view->params = $params;
      if( $this->_getParam('randomNum') ) {
        $this->view->randomNumber = $this->_getParam('randomNum');
      } else {
        $this->view->randomNumber = $params['randomNum'] = rand();
      }
      $this->view->paginator = $paginator->setCurrentPageNumber($page);
    } else {
      return $this->setNoRender();
    }
  }

}
