<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_GenreCategoriesController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $songCategoryTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
    $genereType = $songCategoryTable->getCategoriesAssoc();

    $genreDisplayOption = $this->_getParam('genreDisplayOption');

    if( $genereType ) {
      $select = $songCategoryTable->select();

      if( $genreDisplayOption == 'firstLevel' ) {
        $select->where('cat_dependency = ?', 0);
      } else {
        $select->from($songCategoryTable->info('name'), 'cat_dependency');
        $select->where('cat_dependency != ?', 0);
        $categoryIdArray = array();
        $songCategoryIds = $select->query()->fetchAll();
        foreach( $songCategoryIds as $songCategoryId ) {
          $categoryIdArray[] = $songCategoryId['cat_dependency'];
        }
        if( isset($categoryIdArray) && !empty($categoryIdArray) ) {
          $select = $songCategoryTable->select()->where('songcategory_id NOT IN(?)', $categoryIdArray);
        } else {
          $select = $songCategoryTable->select();
          $select->where('cat_dependency = ?', 0);
        }
      }
    } else {
      return $this->setNoRender();
    }

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $limit = $this->_getParam('itemCountPerPage', 20);
    $this->view->paginator = $paginator->setItemCountPerPage($limit);
    if( count($this->view->paginator) <= 0 ) {
      return $this->setNoRender();
    }
  }

}
