<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideo
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_GenreSlideshowController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = array();
        $genreId = $this->_getParam('genreId', null);
        $this->view->showExporeButton = $this->_getParam('showExplore');
        $this->view->containerHeight = $this->_getParam('categoryHeight', 300);
        $this->view->titleTruncation = $this->_getParam('titleTruncation', 100);
        $this->view->taglineTruncation = $this->_getParam('taglineTruncation', 200);
        //SET NO RENDER & GET CATEGORY ITEM

        if (empty($genreId))
            return $this->setNoRender();
        $categoryTable = Engine_Api::_()->getDbtable('songcategories', 'sitemusic');
        $select = $categoryTable->select()->where('songcategory_id IN (?)',$genreId);
        $result = $categoryTable->fetchAll($select);

        $this->view->paginator = $paginator = Zend_Paginator::factory($result);
        $this->view->totalCount = $totalCount = $paginator->getTotalItemCount();
        $paginator->setItemCountPerPage($totalCount);

        // Do not render if nothing to show
        if (($totalCount <= 0)) {
            return $this->setNoRender();
        }
        //GET STORAGE API
        $this->view->storage = Engine_Api::_()->storage();

    }

}
