<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ItemCoverPhotoController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->enableFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableFavourite();
    $this->view->entityType = $entityType = $this->_getParam('entity_type', 'Album');
    $this->view->itemId = $itemId = $this->_getParam('item_id');
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $values = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $itemId = $values['item_id'];
    if( $entityType == 'playlist' ) {
      $resourceType = 'sitemusic_userpl';
      $entityId = 'userplaylist_id';
    } elseif( $entityType == 'song' ) {
      $entityId = 'song_id';
      $resourceType = 'sitemusic_playlist_song';
    } elseif( $entityType == 'artist' ) {
      $entityId = 'artist_id';
      $resourceType = 'sitemusic_artist';
    } else {
      $entityId = 'playlist_id';
      $resourceType = 'sitemusic_pl';
    }
  $setting = Engine_Api::_()->getApi('settings', 'core');
  $this->view->albumBackgroupImage = $setting->getSetting('sitemusic.albumcoverPhoto');
  $this->view->playlistBackgroupImage = $setting->getSetting('sitemusic.playlistcoverPhoto');
  $this->view->artistBackgroupImage = $setting->getSetting('sitemusic.artistcoverPhoto');
  $this->view->songBackgroupImage = $setting->getSetting('sitemusic.songcoverPhoto');

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    //   $this->view->backgroupImage = $this->_getParam('coverPhoto');
    $this->view->item = $item = Engine_Api::_()->getItem($resourceType, $itemId);
    $this->view->isUpload = $isUpload = Engine_Api::_()->authorization()->isAllowed($item, null, 'upload_song');
    if( empty($item) ) {
      return $this->setNoRender();
    }
    // own entity rating permission  or update permission
    if( $item->getType() == 'sitemusic_pl' ) {
      $this->view->ratingPermission = $setting->getSetting('sitemusic.own.albumrating', 1);
      $this->view->ratingUpdatePermission = $setting->getSetting('sitemusicalbumrating.update', 1);
    } elseif( $item->getType() == 'sitemusic_playlist_song' ) {
      $this->view->ratingPermission = $setting->getSetting('sitemusic.own.songrating', 1);
      $this->view->ratingUpdatePermission = $setting->getSetting('sitemusicsongrating.update', 1);
    } elseif( $item->getType() == 'sitemusic_userpl' ) {
      $this->view->ratingPermission = $setting->getSetting('sitemusic.own.playlistrating', 1);
      $this->view->ratingUpdatePermission = $setting->getSetting('sitemusicplaylistrating.update', 1);
    } elseif( $item->getType() == 'sitemusic_artist' ) {
      $this->view->ratingUpdatePermission = $setting->getSetting('sitemusicartistrating.update', 1);
    }
    $this->view->artistNavigation = array('like' => 'like', 'artistFavourite' => 'artistFavourite', 'artistShare' => "artistShare", "artistFollow" => "artistFollow");
    $this->view->songNavigation = array('like' => 'like', 'songPlay' => "songPlay", 'songFavourite' => 'songFavourite', 'songDownload' => "songDownload", 'songQueue' => "songQueue", 'songShare' => "songShare", "addToPlaylist" => "addToPlaylist", 'dashboard' => 'dashboard', 'delete' => 'delete');
    $this->view->playlistNavigation = array('like' => 'like', 'playlistPlay' => "playlistPlay", 'playlistQueue' => "playlistQueue", 'playlistFavourite' => 'playlistFavourite', 'playlistShare' => "playlistShare", 'delete' => 'delete');
    $this->view->navigation = array('like' => 'like', 'uploadSong' => "uploadSong", 'albumPlay' => "albumPlay", 'albumDownload' => "albumDownload", 'albumQueue' => "albumQueue", 'albumFavourite' => 'albumFavourite', 'albumShare' => "albumShare", 'albumFollow' => 'albumFollow', 'dashboard' => 'dashboard', 'delete' => 'delete');
    $this->view->max = $this->_getParam('max', 3);
  }

}
