<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2014-07-20 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ItemPlaylistController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $playlistIdsAsString = $this->_getParam('itemIds');

    if( is_string($playlistIdsAsString) ) {
      $playlistIds = explode(' ', $playlistIdsAsString);
    }
    if( !isset($playlistIds) && empty($playlistIds) ) {
      return $this->setNoRender();
    }
    $values['playlistIds'] = $playlistIds;

    $userplaylistTable = Engine_Api::_()->getDbTable('userPlaylists', 'sitemusic');
    $this->view->paginator = $paginator = $userplaylistTable->getPaginator($values);

    $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();

    if( !$enablePlaylist ) {
      return $this->setNoRender();
    }

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    //for display all stats
    $this->view->playlistShowOptions = array('All');

    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $startTime = $this->_getParam('starttime');
    $endTime = $this->_getParam('endtime');
    $currentTime = date('Y-m-d H:i:s');

    if( $startTime != 0 && $endTime != 0 ) {
      if( ($currentTime < $startTime) || ( $currentTime > $endTime) ) {
        return $this->setNoRender();
      }
    }

    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
