<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemember
 * @copyright  Copyright 2014-2015 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2014-07-20 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_ItemSongController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $songIdsAsString = $this->_getParam('itemIds');

    if( is_string($songIdsAsString) ) {
      $songIds = explode(' ', $songIdsAsString);
    }
    if( !isset($songIds) && empty($songIds) ) {
      return $this->setNoRender();
    }
    $values['type'] = 'sitemusic_playlist_song';
    $values['songIds'] = $songIds;

    $playlistSongTable = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
    $this->view->paginator = $paginator = $playlistSongTable->getPaginator($values);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    //for display all stats
    $this->view->songShowOptions = array('All');

    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $startTime = $this->_getParam('starttime');
    $endTime = $this->_getParam('endtime');
    $currentTime = date('Y-m-d H:i:s');

    if( $startTime!= 0 && $endTime!=0 ) {
      if( ($currentTime < $startTime) || ( $currentTime > $endTime) ) {
        return $this->setNoRender();
      }
    }

    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
