<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_PlaylistBrowseController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->canCreate = Engine_Api::_()->authorization()->isAllowed('sitemusic_pl', null, 'create');
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $this->view->formFilter = $formFilter = new Sitemusic_Form_Search();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    } else {
      $values = array();
    }
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $this->view->enablePlaylistRating = $enableRating = Engine_Api::_()->sitemusic()->enablePlaylistRating();
    $this->view->enablePlaylistShare = $enableShare = Engine_Api::_()->sitemusic()->enablePlaylistShare();
    $limit = $this->_getParam('limit', 5);
    $paramValue = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->value = $paramValue;
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();

    // Show
    if( isset($values['show']) ) {
      if( $paramValue['show'] == 2 && $viewer->getIdentity() ) {
        // Get an array of friend ids
        $values['users'] = $viewer->membership()->getMembershipsOfIds();
        $values['searchBit'] = 1;
      } elseif( $paramValue['show'] == 3 && $viewerId ) {
        $values['only_my'] = $viewerId;
      }
    }
    if( isset($paramValue['search']) ) {
      $values['title'] = $paramValue['search'];
    }
    if( isset($paramValue['alphabet']) ) {
      $values['alphabet'] = $paramValue['alphabet'];
      $values['title'] = null;
    }
    $this->view->formValues = array_filter($values);

    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $showViewOptions = $params['showOptions'] = $this->_getParam('showSongOptions');
    if( isset($showViewOptions) && !empty($showViewOptions) ) {
      $options = array_merge($showViewOptions, $showOptions);
    } else {
      $options = $showOptions;
    }
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_userpl';
    $this->view->playlistShowOptions = $options;
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $this->view->cardViewWidth = $this->_getParam('cardViewWidth', '371');
    $this->view->cardViewHeight = $this->_getParam('cardViewHeight', '402');
    $playlistLayoutViews = $params['playlist_layout_views'] = $this->_getParam('playlist_layout_views', array("list_view", "grid_view", "card_view"));
    foreach( $playlistLayoutViews as $key => $value )
      $playlistLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($playlistLayoutViews);
    $this->view->playlist_layout_views = $playlistLayoutViews;

    $this->view->playlistDefaultLayout = $playlistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('playlistDefaultLayout', 'list_view'));
    if( count($playlistLayoutViews) == 1 ) {
      $this->view->playlistDefaultLayout = $playlistDefaultLayout = $playlistLayoutViews[0];
    }
    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 25);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 25);
    $this->view->card_title_truncation = $this->_getParam('cardTitleTruncationLimit', 25);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $values['sort'] = $this->_getParam('default_sort', 'creationDate');
    $this->view->message = 'Nobody has created a music playlist yet.';
// Show
    if( @$values['show'] == 2 && $viewer->getIdentity() ) {
// Get an array of friend ids
      $values['users'] = $viewer->membership()->getMembershipsOfIds();
    } elseif( $values['show'] == 3 ) {
      $values['only_my'] = $viewer->getIdentity();
    }
    unset($values['show']);
    $userPlaylistTable = Engine_Api::_()->getDbTable('userPlaylists', 'sitemusic');
// Get paginator
    $this->view->paginator = $paginator = $userPlaylistTable->getPaginator($values);


    if( !isset($paramValue['page']) ) {
      $page = 1;
    } else {
      $page = $paramValue['page'];
    }
    $element = $this->getElement();
    $widgetTitle = $this->view->heading = $element->getTitle();
    if( !empty($widgetTitle) ) {
      $element->setTitle("");
    } else {
      $this->view->heading = "";
    }
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
  }

}
