<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_RecentlyPlayedController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $values = array();
    $params['limit'] = $limit = $this->_getParam('limit', 10);
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();

    // check entity enable or not
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableFavourite();
    $this->view->isRatingEnable = $enableRating = Engine_Api::_()->sitemusic()->enableRating();
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->isShareEnable = $enableShare = Engine_Api::_()->sitemusic()->enableShare();
    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 20);
    $playLog = Engine_Api::_()->getDbTable('playLog', 'sitemusic');
    $plName = $playLog->info('name');
    $playListSong = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
    $psName = $playListSong->info('name');
    $showOptions = $this->_getParam('showOptions', 'All');
    $this->view->songShowOptions = $showOptions;
    $request = new Zend_Controller_Request_Http();
    $clearAll = $request->getParam('clearAll', 0);
    if( $clearAll ) {
      $playLog->delete(array('user_id = ?' => $viewerId));
    }
    $select = $playListSong->select()->from($psName);
    $select->distinct(true);
    $select->join($plName, "$plName.song_id = $psName.song_id", '');
    $select->where('user_id = ?', $viewerId);
    $this->view->songs = $songs = $playListSong->fetchAll($select);
    $jsonSongInfo = Engine_Api::_()->getApi('core', 'sitemusic')->changeSongsToJsonString($songs);
    $this->view->jsonSongInfo = $jsonSongInfo;
    $this->view->randomNumber = $randomNum = rand();
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $allParam = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $paginator->setItemCountPerPage($limit);
    if( isset($allParam['page']) ) {
      $page = $allParam['page'];
    } else {
      $page = 1;
    }
    $values['page'] = $page;
    $this->view->params = $values;
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
  }

}
