<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_RelatedAlbumController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $limit = $this->_getParam('limit', 5);
    $relatedType = $this->_getParam('relatedType', 'owner');
    $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $album = Engine_Api::_()->getItem('sitemusic_pl', $params['item_id']);

    if( empty($album) ) {
      return $this->setNoRender();
    }

    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enableFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableFavourite();
    $this->view->isRatingEnable = $enableRating = Engine_Api::_()->sitemusic()->enableRating();
    $this->view->isShareEnable = $enableShare = Engine_Api::_()->sitemusic()->enableShare();

    $categoryId = $album->category_id;
    $ownerId = $album->getOwner()->getIdentity();
    $select = $album->select();
    $select->where('playlist_id != ?', $album->getIdentity());
    if( $relatedType == 'owner' ) {
      $select->where('owner_id = ?', $ownerId);
    } elseif( $relatedType == 'albumCategory' ) {
      if( $categoryId ) {
        $select->where('category_id = ?', $categoryId);
      } else {
        return $this->setNoRender();
      }
    }
    $this->view->albumShowOptions = array('All');
    $this->view->album_layout_views = $albumLayoutViews = array('thumbnail_view');
    $this->view->albumDefaultLayout = $albumDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('albumDefaultLayout', 'thumbnail_view'));
// Get paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $paginator->setItemCountPerPage($limit);

    if( count($this->view->paginator) <= 0 ) {
      return $this->setNoRender();
    }
  }

}
