<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_RelatedPlaylistController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $limit = $this->_getParam('limit', 5);
    $paramValue = $this->_getAllParams();

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $playlist = Engine_Api::_()->getItem('sitemusic_userpl', $params['item_id']);

    if( empty($playlist) ) {
      return $this->setNoRender();
    }

    $ownerId = $playlist->getOwner()->getIdentity();

    $select = $playlist->select();
    $select->where('owner_id = ?', $ownerId);
    $select->where('userplaylist_id != ?', $playlist->getIdentity());
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    if( !$enablePlaylist ) {
      return $this->setNoRender();
    }

    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $this->view->enablePlaylistRating = $enableRating = Engine_Api::_()->sitemusic()->enablePlaylistRating();
    $this->view->enablePlaylistShare = $enableShare = Engine_Api::_()->sitemusic()->enablePlaylistShare();

    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $this->view->playlistShowOptions = array('All');
    $this->view->playlist_layout_views = $playlistLayoutViews = array('thumbnail_view');
    $this->view->playlistDefaultLayout = $playlistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('playlistDefaultLayout', 'thumbnail_view'));

// Get paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);

    $paginator->setItemCountPerPage($limit);

    if( count($this->view->paginator) <= 0 ) {
      return $this->setNoRender();
    }
  }

}
