<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_SideRecentlyPlayedController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $params['limit'] = $limit = $this->_getParam('itemCountPerPage', 5);
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();

    // check entity enable or not
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();

    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $playLog = Engine_Api::_()->getDbTable('playLog', 'sitemusic');
    $plName = $playLog->info('name');
    $playListSong = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
    $psName = $playListSong->info('name');
    $songLayoutViews = array("thumbnail_view");
    $this->view->song_layout_views = $songLayoutViews;
    $this->view->songDefaultLayout = $songDefaultLayout = "thumbnail_view";
    $this->view->songShowOptions = array('All');
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 50);
    $select = $playListSong->select()->from($psName);
    $select->distinct(true);
    $select->join($plName, "$plName.song_id = $psName.song_id", '');
    $select->where('user_id = ?', $viewerId);
    $select->order('creation_date DESC');
    $songs = $playListSong->fetchAll($select);
    $jsonSongInfo = Engine_Api::_()->getApi('core', 'sitemusic')->changeSongsToJsonString($songs);
    $this->view->jsonSongInfo = $jsonSongInfo;
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);
    if( $paginator->getTotalItemCount() <= 0 ) {
      return $this->setNoRender();
    }
  }

}
