<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_SongBrowseController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $values = array();
    $limit = $this->_getParam('limit', 5);
    $paramValue = Zend_Controller_Front::getInstance()->getRequest()->getParams();
    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->value = $paramValue;
    if( !isset($paramValue['page']) ) {
      $page = 1;
    } else {
      $page = $paramValue['page'];
    }
    $values = $paramValue;

    if( isset($paramValue['search']) ) {
      $values['title'] = $paramValue['search'];
    }
    if( isset($paramValue['alphabet']) ) {
      $values['alphabet'] = $paramValue['alphabet'];
    }
    if( empty($values['genreId']) && !isset($values['genreId']) ) {
      if( isset($paramValue['genre_id']) ) {
        $values['genreId'] = $paramValue['genre_id'];
      }
      $values['type'] = 'song';
    }
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = Engine_Api::_()->user()->getViewer()->getIdentity();

    $this->view->enableStatsCountOnZero = $enablePlaylist = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enableSongFavourite = $enableFavourite = Engine_Api::_()->sitemusic()->enableSongFavourite();
    $this->view->enableSongRating = $enableRating = Engine_Api::_()->sitemusic()->enableSongRating();
    $this->view->enableSongShare = $enableShare = Engine_Api::_()->sitemusic()->enableSongShare();
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_playlist_song';
    $this->view->formValues = array_filter($values);
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $this->view->songShowOptions = $showOptions;
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '180');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $songLayoutViews = $params['song_layout_views'] = $this->_getParam('song_layout_views', array("list_view", "grid_view"));
    foreach( $songLayoutViews as $key => $value )
      $songLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($songLayoutViews);
    $this->view->song_layout_views = $songLayoutViews;
    $this->view->songDefaultLayout = $songDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('songDefaultLayout', 'list_view'));
    if( count($songLayoutViews) == 1 ) {
      $this->view->songDefaultLayout = $songDefaultLayout = $songLayoutViews[0];
    }
    $this->view->list_title_truncation = $this->_getParam('listTitleTruncationLimit', 25);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 25);
    $this->view->thumbnail_title_truncation = $this->_getParam('thumbnailTitleTruncationLimit', 20);
    $values['sort'] = $this->_getParam('default_sort', 'creationDate');

    if( isset($values['genreId']) && !empty($values['genreId']) ) {
      $this->view->message = 'There is no related song.';
    } else {
      $this->view->message = 'There is no song uploaded yet.';
    }
// Show
    if( isset($values['show']) ) {
      if( @$values['show'] == 2 && $viewer->getIdentity() ) {
// Get an array of friend ids
        $values['users'] = $viewer->membership()->getMembershipsOfIds();
      } elseif( $values['show'] == 3 ) {
        $values['only_my'] = $viewer->getIdentity();
      }
      unset($values['show']);
    }
    $element = $this->getElement();
    $widgetTitle = $this->view->heading = $element->getTitle();
    if( !empty($widgetTitle) ) {
      $element->setTitle("");
    } else {
      $this->view->heading = "";
    }
    $playlistSongTable = Engine_Api::_()->getDbTable('playlistSongs', 'sitemusic');
// Get paginator
    $this->view->paginator = $paginator = $playlistSongTable->getPaginator($values);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $paginator->setItemCountPerPage($limit);

    $this->view->paginator = $paginator->setCurrentPageNumber($page);
  }

}
