<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitemusic
 * @copyright  Copyright 2017-2022 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-03-27 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitemusic_Widget_UserPlaylistController extends Engine_Content_Widget_Abstract
{
  protected $_childCount;
  
  public function indexAction()
  {
    $this->view->viewer = $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewerId = $viewer->getIdentity();
    $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    if( !$enablePlaylist ) {
      return $this->setNoRender();
    }
    $this->view->enablePlaylist = $enablePlaylist = Engine_Api::_()->sitemusic()->isPlaylistEnabled();
    $this->view->enablePlaylistFavourite = $enablePlaylistFavourite = Engine_Api::_()->sitemusic()->enablePlaylistFavourite();
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_userpl';
    $showOptions = $params['showOptions'] = $this->_getParam('showOptions');
    $showViewOptions = $params['showOptions'] = $this->_getParam('showSongOptions');
    if( isset($showViewOptions) && !empty($showViewOptions) ) {
      $options = array_merge($showViewOptions, $showOptions);
    } else {
      $options = $showOptions;
    }
    $values['labelType'] = $this->_getParam('label_category');
    $values['type'] = 'sitemusic_userpl';
    $this->view->playlistShowOptions = $options;
    $playlistLayoutViews = $params['playlist_layout_views'] = $this->_getParam('playlist_layout_views', array("list_view", "grid_view", "card_view"));
    foreach( $playlistLayoutViews as $key => $value )
      $playlistLayoutViews[$key] = str_replace("ZZZ", "_", $value);
    sort($playlistLayoutViews);
    $this->view->playlist_layout_views = $playlistLayoutViews;

    $this->view->enableStatsCountOnZero = Engine_Api::_()->sitemusic()->enableStatsCountOnZero();
    $this->view->playlistDefaultLayout = $playlistDefaultLayout = str_replace("ZZZ", "_", $this->_getParam('playlistDefaultLayout', 'list_view'));
    if( count($playlistLayoutViews) == 1 ) {
      $this->view->playlistDefaultLayout = $playlistDefaultLayout = $playlistLayoutViews[0];
    }
    $this->view->gridViewWidth = $this->_getParam('gridViewWidth', '167');
    $this->view->gridViewHeight = $this->_getParam('gridViewHeight', '290');
    $this->view->cardViewWidth = $this->_getParam('cardViewWidth', '371');
    $this->view->cardViewHeight = $this->_getParam('cardViewHeight', '402');
    $this->view->title_truncation = $this->_getParam('titleTruncationLimit', 50);
    $this->view->grid_title_truncation = $this->_getParam('gridTitleTruncationLimit', 50);
    $values['sort'] = $this->_getParam('default_sort');
    $this->view->message = 'You have not created a music playlist yet.';
    $this->view->mymusic = 1;
    $param = Zend_Controller_Front::getInstance()->getRequest()->getParams();

    if( !isset($param['page']) ) {
      $page = 1;
    } else {
      $page = $param['page'];
    }

    if( !empty($param['search']) ) {
      $values['search'] = $param['search'];
    }
    if( !empty($param['sort']) ) {
      $values['sort'] = $param['sort'];
    }
    if( $this->_getParam('randomNum') ) {
      $this->view->randomNumber = $this->_getParam('randomNum');
    } else {
      $this->view->randomNumber = $param['randomNum'] = rand();
    }

    $this->view->params = $param;
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);

    $values['user'] = Engine_Api::_()->user()->getViewer()->getIdentity();
    $userPlaylistTable = Engine_Api::_()->getDbTable('userPlaylists', 'sitemusic');
// Get paginator
    $this->view->paginator = $paginator = $userPlaylistTable->getPaginator($values);
    $this->view->totalCount = $paginator->getTotalItemCount();
    $limit = $this->_getParam('limit', 5);
    $paginator->setItemCountPerPage($limit);
    $paginator->setCurrentPageNumber($page);

    // Add count to title if configured
    if( $this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0 ) {
      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  public function getChildCount()
  {
    return $this->_childCount;
  }

}
