<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: WebParser.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Api_WebParser extends Core_Api_Abstract
{

  public function parseUrl($url)
  {
    $endpoint = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.webparser.endpoint') ?: '';
    if(empty($endpoint)) {
      return false;
    }
    $url = $endpoint . '?url=' . urlencode($url);
    return $this->sendRequest($url);
  }

  public function sendRequest($url)
  {
    $curl = curl_init();
    $curlConfig = array(
      CURLOPT_URL => $url,
      // CURLOPT_PORT => 3010,
      CURLOPT_HTTPHEADER => array(
        'Content-Type: application/json'
      ),
      //  CURLOPT_RETURNTRANSFER => true, // return web page
      CURLOPT_FOLLOWLOCATION => true, // follow redirects
      CURLOPT_MAXREDIRS => 10, // stop after 10 redirects
      CURLOPT_ENCODING => "", // handle compressed
      CURLOPT_USERAGENT => "", // name of client
      CURLOPT_AUTOREFERER => true, // set referrer on redirect
      CURLOPT_CONNECTTIMEOUT => 120, // time-out on connect
      CURLOPT_TIMEOUT => 120, // time-out on response
      CURLOPT_SSL_VERIFYPEER => false
    );
    curl_setopt_array($curl, $curlConfig);
    ob_start();
    // Send the request & save response to $resp
    curl_exec($curl);
    // Close request to clear up some resources
    curl_close($curl);
    $content = ob_get_contents();
    ob_end_clean();

    $content = (array) json_decode($content, true);
    if( isset($content) && isset($content['error']) && $content['error'] ) {
      return false;
    }
    return $content;
  }

  public function getContent($url, $default=false)
  {
    return $this->parseUrl($url);
  }

}