<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Admin_Global extends Engine_Form {

    public $_SHOWELEMENTSBEFOREACTIVATE = array(
    "submit_lsetting", "environment_mode"
    );

    public function init() {

        $productType = 'sitenews';

        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        $this
                ->setTitle('Global Settings')
                ->setDescription('These settings affect all members in your community.');

        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', $productType . '_lsettings', array(
            'label' => 'Enter License key For News / RSS Importer and Aggregator Plugin',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting($productType . '.lsettings'),
        ));        

        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }

        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));   
        
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        
        $this->addElement('Text', 'sitenews_news_manifestUrlP', array(
            'label' => 'URL Alternate Text for "news"',
            'allowEmpty' => false,
            'required' => true,
            'description' => 'Please enter the text below which you want to display in place of "news" in the URLs of this plugin.',
            'value' => $coreSettings->getSetting('sitenews.news.manifestUrlP', "news"),
        ));

        $this->addElement('hidden', 'sitenews_news_manifestUrlS', array(
             'order' => 991,
            'label' => 'URL Alternate Text for "news"',
            'allowEmpty' => false,
            'required' => true,
            'description' => 'Please enter the text below which you want to display in place of "news" in the URLs of this plugin.',
            'value' => $coreSettings->getSetting('sitenews.news.manifestUrlS', "news"),
        ));

        $this->addElement('Radio', 'sitenews_category_enabled', array(
            'label' => 'Allow Category',
            'description' => 'Do you want the Category field to be enabled for News?',
            'multiOptions' => array('1' => 'Yes', '0' => 'No'),
            'value' => $coreSettings->getSetting('sitenews.category.enabled', 1)
        ));

        $this->addElement('Radio', 'sitenews_news_tags_enabled', array(
            'label' => 'Allow Tags',
            'description' => 'Do you want the Tags field to be enabled for News?',
            'multiOptions' => array('1' => 'Yes', '0' => 'No'),
            'value' => $coreSettings->getSetting('sitenews.news.tags.enabled', 1)
        ));

        $this->addElement('Radio', 'sitenews_news_description', array(
            'label' => 'Description',
            'description' => "Do you want the Description field to be enabled for News?",
            'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
            'value' => $coreSettings->getSetting('sitenews.news.description', 1),
        ));

        $this->addElement('Radio', 'sitenews_news_location', array(
            'label' => 'Location',
            'description' => "Do you want the Location field to be enabled for News?",
            'MultiOptions' => array('1' => 'Yes', '0' => 'No'),
            'value' => $coreSettings->getSetting('sitenews.news.location', 1),
            'onclick' => 'showProximitySearchSetting(this.value)',
        ));

        //VALUE FOR ENABLE /DISABLE PROXIMITY SEARCH IN Kilometer
        $this->addElement('Radio', 'sitenews_news_proximity_search_kilometer', array(
            'label' => 'Location & Proximity Search Metric',
            'description' => 'What metric do you want to be used for location & proximity Search Metric? (This will enable users to search for News within a certain distance from their current location or any particular location.)',
            'multiOptions' => array(
                0 => 'Miles',
                1 => 'Kilometers'
            ),
            'value' => $coreSettings->getSetting('sitenews.news.proximity.search.kilometer', 0),
        ));

        $this->addElement('Text', 'sitenews_news_sponsoredcolor', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowNewsSponsred.tpl',
                        'class' => 'form element'
                    )))
        ));

        $this->addElement('Text', 'sitenews_news_featuredcolor', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowNewsFeatured.tpl',
                        'class' => 'form element'
                    )))
        ));   

        $this->addElement('Text', 'sitenews_news_breakingcolor', array(
            'decorators' => array(array('ViewScript', array(
                        'viewScript' => '_formImagerainbowNewsBreaking.tpl',
                        'class' => 'form element'
                    )))
        ));               

        $this->addElement('Text', 'normal_news_height', array(
            'label' => 'Small Thumbnail Height of News (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('normal.news.height', 375),
        ));

        $this->normal_news_height->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Text', 'normal_news_width', array(
            'label' => 'Small Thumbnail Width of News (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('normal.news.width', 375),
        ));
        $this->normal_news_width->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Text', 'normallarge_news_height', array(
            'label' => 'Medium Thumbnail Height of News (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('normallarge.news.height', 720),
        ));
        $this->normallarge_news_height->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Text', 'normallarge_news_width', array(
            'label' => 'Medium Thumbnail Width of News (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('normallarge.news.width', 720),
        ));
        $this->normallarge_news_width->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Text', 'main_news_height', array(
            'label' => 'Large Thumbnail Height of News  (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('main.news.height', 1600),
        ));
        $this->main_news_height->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Text', 'main_news_width', array(
            'label' => 'Large Thumbnail Width of News (in pixels)',
            'description' => "Note: Changes will be reflected only for the newly added news.",
            'value' => $coreSettings->getSetting('main.news.width', 1600),
        ));
        $this->main_news_width->getDecorator('Description')->setOption('placement', 'append');

        $this->addElement('Radio', 'sitenews_news_network', array(
            'label' => 'Browse by Networks',
            'description' => "Do you want to show News according to viewer's network if he has selected any? (If set to no, all the News will be shown.)",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'onclick' => 'showDefaultNetwork(this.value)',
            'value' => $coreSettings->getSetting('sitenews.news.network', 0),
        ));

        $this->addElement('Radio', 'sitenews_news_default_show', array(
            'label' => 'Set Only My Networks as Default in Search',
            'description' => ' Do you want to set "Only My Network" option as default for Show field in the search form widget? (This widget appears on the Browse News to enable users to search and filter news.)',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'onclick' => 'showDefaultNetworkType(this.value)',
            'value' => $coreSettings->getSetting('sitenews.news.default.show', 0),
        ));

        $this->addElement('Radio', 'sitenews_news_networks_type', array(
            'label' => 'Network Selection for News',
            'description' => "You have chosen that viewers should only see News of their network(s). How should a News' network(s) be decided?",
            'multiOptions' => array(
                0 => "News Owner's network(s) [If selected, only members belonging to News owner's network(s) will see the News.]",
                1 => "Selected Networks [If selected, News owner will be able to choose the networks of which members will be able to see their News.]"
            ),
            'value' => $coreSettings->getSetting('sitenews.news.networks.type', 0),
        ));

        $this->addElement('Radio', 'sitenews_news_networkprofile_privacy', array(
            'label' => 'Display Profile News only to Network Users',
            'description' => "Do you want to show the News Profile page only to users of the same network. (If set to yes and \"Browse By Networks\" is enabled then users would not be able to view the profile page of those News which does not belong to their networks.)",
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.networkprofile.privacy', 0),
        ));

        $this->addElement('Radio', 'sitenews_news_privacybase', array(
            'label' => 'Displays All News in Widgets',
            'description' => "Do you want to show all the News to the users in the Widgets and Browse News of this plugin irrespective of privacy? [Note: If you select 'No', then only those News will be shown in the Widgets and Browse News which are viewable to the current logged-in users. But this may slightly affect the loading speed of your website. To avoid such loading delay to the best possible extent, we are also using caching based display.)",
            'multiOptions' => array(
                0 => 'Yes',
                1 => 'No'
            ),
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.privacybase', 0),
        ));

        $this->addElement('Text', 'sitenewsshow_navigation_tabs', array(
            'label' => 'Tabs in News Navigation bar',
            'allowEmpty' => false,
            'maxlength' => '3',
            'required' => true,
            'description' => 'How many tabs do you want to show on News main navigation bar by default? (Note: If number of tabs exceeds the limit entered by you then a "More" tab will appear, clicking on which will show the remaining hidden tabs. To choose the tab to be shown in this navigation menu, and their sequence, please visit: "Layout" > "Menu Editor")',
            'value' => $coreSettings->getSetting('sitenewsshow.navigation.tabs', 7),
            'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
            ),
        ));

        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
