<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Content.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Admin_Widget_Content extends Engine_Form {

    public function init() {
        $this
                ->setAttrib('id', 'form-upload')
                ->setTitle('Editing: My News');

        $topNavigationLink = array(
            'news' => 'News',
            'rss' => 'RSS',
            'createNews' => 'Add News',
            'createRss' => 'Add RSS',
        );
        if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.allow', 1)) {
            $topNavigationLink = array(
                'news' => 'News',
                'createNews' => 'Add News',
            );
        }

        $newsOption = array(
            'title' => 'News Title',
            'creationDate' => 'Creation Date',
            'provider' => 'Provider',
            'view' => 'Views',
            'location' => 'Location',
            'like' => 'Likes',
            'comment' => 'Comments',
            'favourite' => 'Favourite',
        );
        $newsNavigationLink = array(
            'news' => 'News');
        $newsOption = array_merge($newsOption, array(
            'facebook' => 'Facebook [Social Share Link]',
            'twitter' => 'Twitter [Social Share Link]',
            'linkedin' => 'LinkedIn [Social Share Link]',
            'googleplus' => 'Google+ [Social Share Link]'
        ));
        $newsNavigationLink = array_merge($newsNavigationLink, array('liked' => 'Liked',
            'favourite' => 'Favourites',
                )
        );
        $this->addElement('MultiCheckbox', 'topNavigationLink', array(
            'label' => "Choose the action links that you want to display for the News in this block.",
            'multiOptions' => $topNavigationLink,
        ));
        $this->addElement('MultiCheckbox', 'newsNavigationLink', array(
            'label' => "Choose the News navigation links that you want to display for the News on this page.",
            'multiOptions' => $newsNavigationLink,
        ));

        $this->addElement('MultiCheckbox', 'viewType', array(
            'label' => "Choose the view type for News.",
            'multiOptions' => array(
                'gridView' => 'Grid view',
                'listView' => 'List view',
            ),
        ));

        $this->addElement('Radio', 'searchButton', array(
            'label' => "Do you want to show “Search” button ?",
            'multiOptions' => array(
                '1' => 'Yes',
                '0' => 'No',
            ),
            'value' => 1,
        ));
        $this->addElement('Select', 'defaultViewType', array(
            'label' => "Select a default view type for News",
            'multiOptions' => array(
                'gridView' => 'Grid view',
                'listView' => 'List view',
            ),
            'value' => 'gridView',
        ));
        $this->addElement('Text', 'gridViewWidth', array(
            'label' => "Column width for Grid View",
            'value' => 250,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'gridViewHeight', array(
            'label' => "Column height for Grid View",
            'value' => 200,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'listViewWidth', array(
            'label' => "Column width for List View",
            'value' => 324,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'listViewHeight', array(
            'label' => "Column height for List View",
            'value' => 328,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('MultiCheckbox', 'newsOption', array(
            'label' => "Choose the options that you want to display for the News in this block. (These information would be same for all the tabs available on My News page)",
            'multiOptions' => $newsOption,
        ));
        $this->addElement('Radio', 'listDescription', array(
            'label' => "Do you want to show description in list view?",
            'multiOptions' => array(
                '1' => 'Yes',
                '0' => 'No',
            ),
            'value' => 1,
        ));

        $this->addElement('Select', 'show_content', array(
            'label' => "What do you want for view more content?",
            'multiOptions' => array(
                '2' => 'Show View More Link at Bottom',
                '3' => 'Auto Load Content on Scrolling Down'),
            'value' => 2,
        ));
        $this->addElement('Select', 'orderby', array(
            'label' => "Default ordering of News.",
            'multiOptions' => array(
                'random' => 'Random News',
                'creation_date' => 'Recent News'
            ),
            'value' => 'creation_date',
        ));
        $this->addElement('Text', 'titleTruncation', array(
            'label' => "Title truncation limit for List View",
            'value' => 22,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'titleTruncationGridNNewsView', array(
            'label' => "Title truncation limit for Grid View",
            'value' => 22,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'descriptionTruncation', array(
            'label' => "Description truncation limit",
            'value' => 100,
            'validators' => array(
                array('Int', true),
            ),
        ));
        $this->addElement('Text', 'itemCountPerPage', array(
            'label' => "Count",
            'description' => '(Number of items to show)',
            'value' => 12,
            'validators' => array(
                array('Int', true),
            ),
        ));
    }

}

?>
