<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Listrss.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Admin_Widget_Listrss extends Engine_Form {

    public function init() {

        $this->setMethod('post');
        $this->setTitle('Editing: List RSS')
             ->setDescription('Displays RSS on your website. You can place this widget anywhere on the site.');


        $this->addElement(
                'Text', 'itemCount', array(
            'label' => 'Count (RSS Feeds).',
            'value' => 12,
            'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
            ),
                )
        );

        $this->addElement(
                'radio', 'showViewMore', array(
            'label' => 'Do you want to show View more button?',
            'multiOptions' => array(
                'true' => 'Yes',
                'false' => 'No'
            ),
            'value' => 'Yes',
                )
        );

        $this->addElement(
                'Text', 'titleTruncation', array(
            'label' => 'Title Tuncation limit.',
            'value' => 22,
            'validators' => array(
                array('Int', true),
                array('GreaterThan', true, array(0)),
            ),
                )
        );

        $this->addElement(
                'radio', 'subscribeRss', array(
            'label' => 'Do you want to show subscribe option for the RSS Feeds in this block?',
            'multiOptions' => array(
                1 => 'Yes',
                0 => 'No'
            ),
            'value' => 1,
                )
        );
    }

}
