<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Locationsearch.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_Locationsearch extends Engine_Form {

    protected $_searchForm;
    protected $_hasMobileMode = false;
    protected $_widgetSettings;

    public function getWidgetSettings() {
        return $this->_widgetSettings;
    }

    public function setWidgetSettings($widgetSettings) {
        $this->_widgetSettings = $widgetSettings;
        return $this;
    }

    public function getHasMobileMode() {
        return $this->_hasMobileMode;
    }

    public function setHasMobileMode($flage) {
        $this->_hasMobileMode = $flage;
        return $this;
    }

    public function init() {

        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();

        // Add custom elements
        $this->setAttribs(array(
                    'id' => 'filter_form',
                    'class' => '',
                ))
                ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
                ->setMethod('POST');

        $this->_searchForm = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore');

        $this->getAdditionalOptionsElement();

        $this->loadDefaultDecorators();
        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

        if ($module == 'sitenews' && $controller == 'news' && $action != 'map') {
            $this->setAction($view->url(array('action' => 'map'), 'sitenews_news_general', true))->getDecorator('HtmlTag')->setOption('class', '');
        }
    }

    public function getAdditionalOptionsElement() {
        $translate = Zend_Registry::get('Zend_Translate');
        $front = Zend_Controller_Front::getInstance();
        $module = $front->getRequest()->getModuleName();
        $controller = $front->getRequest()->getControllerName();
        $action = $front->getRequest()->getActionName();

        //GET API
        $settings = Engine_Api::_()->getApi('settings', 'core');

        $subform = new Zend_Form_SubForm(array(
            'name' => 'extra',
            'order' => 19999999,
            'decorators' => array(
                'FormElements',
            )
        ));
        Engine_Form::enableForm($subform);
        $i = 99980;
        $order = 1;
        $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'search');
        if (!empty($row) && !empty($row->display)) {
            $this->addElement('Text', 'search', array(
                'label' => 'What',
                'autocomplete' => 'off',
                'description' => '(Enter keywords or News name)',
                'order' => $order,
            ));
            $this->search->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));

            if (isset($_GET['search'])) {
                $this->search->setValue($_GET['search']);
            } elseif (isset($_GET['titleAjax'])) {
                $this->search->setValue($_GET['titleAjax']);
            }
        }

        $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'location');
        if (!empty($row) && !empty($row->display) && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.location', 0)) {
            $this->addElement('Text', 'location', array(
                'label' => 'Where',
                'autocomplete' => 'off',
                'order' => ++$order,
                'onclick' => 'locationPage();',
                'placeholder' => $translate->translate("Enter a location"),
            ));
            $this->location->getDecorator('Description')->setOptions(array('placement' => 'APPEND'));

            // $myLocationDetails = Engine_Api::_()->seaocore()->getMyLocationDetailsCookie();
            
            // if (isset($myLocationDetails['location']) && !isset($_POST['location']) && $_POST['page']<=1) {
            //     $this->location->setValue($myLocationDetails['location']);
            // }
            
            // if (isset($_POST['location'])) {
            //     if (($_POST['location'])) {
            //         $myLocationDetails['location'] = $_POST['location'];
            //         $myLocationDetails['latitude'] = $_POST['Latitude'];
            //         $myLocationDetails['longitude'] = $_POST['Longitude'];
            //         $myLocationDetails['locationmiles'] = $_POST['locationmiles'];

            //     }

            //     Engine_Api::_()->seaocore()->setMyLocationDetailsCookie($myLocationDetails);
            // }

            // if (!isset($_POST['location']) && empty($this->_widgetSettings['locationDetection'])) {
            //     $this->location->setValue('');
            // }
            
            if(!empty($_POST['location'])){
                $this->location->setValue($_POST['location']);
            }

            $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'proximity');
            if (!empty($row) && !empty($row->display)) {
                $flage = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.proximity.search.kilometer', 1);
                if ($flage) {
                    $locationLable = "Within Kilometers";
                    $locationOption = array(
                        '0' => '',
                        '1' => '1 Kilometer',
                        '2' => '2 Kilometers',
                        '5' => '5 Kilometers',
                        '10' => '10 Kilometers',
                        '20' => '20 Kilometers',
                        '50' => '50 Kilometers',
                        '100' => '100 Kilometers',
                        '250' => '250 Kilometers',
                        '500' => '500 Kilometers',
                        '750' => '750 Kilometers',
                        '1000' => '1000 Kilometers',
                    );
                } else {
                    $locationLable = "Within Miles";
                    $locationOption = array(
                        '0' => '',
                        '1' => '1 Mile',
                        '2' => '2 Miles',
                        '5' => '5 Miles',
                        '10' => '10 Miles',
                        '20' => '20 Miles',
                        '50' => '50 Miles',
                        '100' => '100 Miles',
                        '250' => '250 Miles',
                        '500' => '500 Miles',
                        '750' => '750 Miles',
                        '1000' => '1000 Miles',
                    );
                }
                $this->addElement('Select', 'locationmiles', array(
                    'label' => $locationLable,
                    'multiOptions' => $locationOption,
                    'value' => '0',
                    'order' => ++$order,
                ));

                if (isset($myLocationDetails['locationmiles'])) {
                    $this->locationmiles->setValue($myLocationDetails['locationmiles']);
                }
            }
        }

        //Check for Location browse page.
        if ($module == 'list' && $controller == 'index' && $action != 'map') {
            $subform->addElement('Button', 'done', array(
                'label' => 'Search',
                'type' => 'submit',
                'ignore' => true,
            ));
            $this->addSubForm($subform, $subform->getName());
        } else {
            $subform->addElement('Button', 'done', array(
                'label' => 'Search',
                'type' => 'submit',
                'ignore' => true,
                'onclick' => 'return locationSearch();'
            ));
            $this->addSubForm($subform, $subform->getName());
        }

        // Element: cancel
        $this->addElement('Cancel', 'advances_search', array(
            'label' => 'Advanced search',
            'ignore' => true,
            'link' => true,
            'order' => ++$order,
            'onclick' => 'advancedSearchLists();',
            'decorators' => array('ViewHelper'),
        ));

        $this->addElement('hidden', 'advanced_search', array(
             'order' => $i++,
            'value' => 0
        ));

        $this->addDisplayGroup(array('advances_search', 'locationmiles', 'search', 'done', 'location'), 'grp3');

        $group2 = array();

        $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'location');
        if (!empty($row) && !empty($row->display) && Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.location', 0)) {
            $rowStreet = $this->_searchForm->getFieldsOptions('sitenews_news', 'street');
            if (!empty($rowStreet) && !empty($rowStreet->display)) {
                $this->addElement('Text', 'news_street', array(
                    'label' => 'Street',
                    'autocomplete' => 'off',
                    'order' => ++$order,
                ));
                $group2[] = 'news_street';
            }

            $rowCity = $this->_searchForm->getFieldsOptions('sitenews_news', 'city');
            if (!empty($rowCity) && !empty($rowCity->display)) {
                $this->addElement('Text', 'news_city', array(
                    'label' => 'City',
                    'placeholder' => '',
                    'autocomplete' => 'off',
                    'order' => ++$order,
                ));
                $group2[] = 'news_city';
            }

            $rowState = $this->_searchForm->getFieldsOptions('sitenews_news', 'state');
            if (!empty($rowState) && !empty($rowState->display)) {
                $this->addElement('Text', 'news_state', array(
                    'label' => 'State',
                    'autocomplete' => 'off',
                    'order' => ++$order,
                ));
                $group2[] = 'news_state';
            }

            $rowCountry = $this->_searchForm->getFieldsOptions('sitenews_news', 'country');
            if (!empty($rowCountry) && !empty($rowCountry->display)) {
                $this->addElement('Text', 'news_country', array(
                    'label' => 'Country',
                    'autocomplete' => 'off',
                    'order' => ++$order,
                ));
                $group2[] = 'news_country';
            }
        }

        if (!empty($group2)) {
            $this->addDisplayGroup($group2, 'grp2');
        }
        $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'state');
        if (!empty($row) && !empty($row->display)) {
            $multiOPtionsOrderBy = array(
                '' => '',
                'creation_date' => 'Recently Created',
                'view_count' => 'Most Popular',
                'like_count' => 'Most Liked',
                'comment_count' => 'Most Commented',
                'title' => "Alphabetical (A-Z)",
                'title_reverse' => 'Alphabetical (Z-A)'
            );
            //GET API
            $this->addElement('Select', 'orderby', array(
                'label' => 'Browse By',
                'order' => ++$order,
                'multiOptions' => $multiOPtionsOrderBy,
                'onchange' => 'searchSitenews();',
            ));
        }

        $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'view');
        if (!empty($row) && !empty($row->display)) {
            $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
            if (!empty($viewer_id)) {
                $show_multiOptions = array();
                $show_multiOptions["0"] = $translate->translate("Everyone's News");
                $show_multiOptions["1"] = $translate->translate("Only My Friend's News");
                $value_deault = 0;
                $enableNetwork = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.network', 0);
                if (empty($enableNetwork)) {
                    $networkMembershipTable = Engine_Api::_()->getDbtable('membership', 'network');
                    $viewerNetwork = $networkMembershipTable->fetchRow(array('user_id = ?' => $viewer_id));
                    if (!empty($viewerNetwork) || Engine_Api::_()->sitenews()->newsBaseNetworkEnable()) {
                        $show_multiOptions["3"] = $translate->translate("Only My Networks");
                        $browseDefaulNetwork = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.default.show', 0);

                        if (!isset($_GET['view_view']) && !empty($browseDefaulNetwork)) {
                            $value_deault = 3;
                        } elseif (isset($_GET['view_view'])) {
                            $value_deault = $_GET['view_view'];
                        }
                    }
                }
                $this->addElement('Select', 'view_view', array(
                    'label' => 'View',
                    'order' => ++$order,
                    'multiOptions' => $show_multiOptions,
                    'onchange' => 'searchSitenews();',
                    'value' => $value_deault,
                ));
            }
        }

        if (Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.category.enabled', 1)) {
            $row = $this->_searchForm->getFieldsOptions('sitenews_news', 'category');
            if (!empty($row) && !empty($row->display)) {
                
                if (!$this->_widgetSettings['showAllCategories']) {
                    $categories = Engine_Api::_()->getDbTable('categories', 'sitenews')->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'sponsored' => 0, 'cat_depandancy' => 1, 'limit' => 0, 'orderBy' => 'category_name', 'havingNews' => 1));
                } else {
                    $categories = Engine_Api::_()->getDbTable('categories', 'sitenews')->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'sponsored' => 0, 'cat_depandancy' => 1, 'orderBy' => 'category_name'));
                }

                if (count($categories) != 0) {
                    $categories_prepared[0] = "";
                    foreach ($categories as $category) {
                        $categories_prepared[$category->category_id] = $translate->translate($category->category_name);
                    }

                    if (Engine_API::_()->seaocore()->checkSitemobileMode('fullsite-mode')) {
                        $onChangeEvent = " addOptions(this.value, 'cat_dependency', 'subcategory_id', 0);";
                        $categoryFiles = 'application/modules/Sitenews/views/scripts/_newsSubCategory.tpl';
                    } else {
                        $onChangeEvent = "sm4.core.category.set(this.value, 'subcategory');";
                        $categoryFiles = 'application/modules/Sitenews/views/sitemobile/scripts/_subCategory.tpl';
                    }
                    $this->addElement('Select', 'category_id', array(
                        'label' => 'Category',
                        'order' => $this->_searchForm['category_id']['order'],
                        'multiOptions' => $categories_prepared,
                        'onchange' => $onChangeEvent,
                    ));

                    $this->addElement('Select', 'subcategory_id', array(
                        'RegisterInArrayValidator' => false,
                        'order' => $this->_searchForm['category_id']['order'] + 1,
                        'decorators' => array(array('ViewScript', array(
                                    'showAllCategories' => $this->_widgetSettings['showAllCategories'],
                                    'viewScript' => $categoryFiles,
                                    'class' => 'form element')))
                    ));

                    $this->addElement('Select', 'subsubcategory_id', array(
                        'RegisterInArrayValidator' => false,
                        'order' => $this->_searchForm['category_id']['order'] + 1,
                        'decorators' => array(array('ViewScript', array(
                                    'showAllCategories' => $this->_widgetSettings['showAllCategories'],
                                    'viewScript' => $categoryFiles,
                                    'class' => 'form element')))
                    ));
                }
            }
        }

        $this->addElement('Hidden', 'page', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'tag', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'tag_id', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'start_date', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'end_date', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'categoryname', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'subcategoryname', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'subsubcategoryname', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'Latitude', array(
            'order' => $i++,
        ));

        $this->addElement('Hidden', 'Longitude', array(
            'order' => $i++,
        ));

        $this->addDisplayGroup(array('orderby', 'view_view', 'category_id', 'subcategory_id', 'subsubcategory_id'), 'grp1');

        return $this;
    }

}
