<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: NotificationSettings.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Form_NotificationSettings extends Engine_Form {

    public function init() {

        $this->setTitle('Notification and Email Settings')
                ->setDescription('How do you want to get notified about this RSS Feed ?')
                ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
                ->setAttrib('name', 'notifications');

        $this->addElement('Checkbox', 'email', array(
            'description' => 'Email Notifications',
            'label' => "Send email notifications when a news is added to this RSS Feed.",
            'onclick' => 'showEmailAction()',
            'value' => 1,
        ));

        $this->addElement('Checkbox', 'notification', array(
            'description' => 'Site Notifications',
            'label' => "Send site notifications when a news is added to this RSS Feed.",
            'onclick' => 'showNotificationAction()',
            'value' => 1,
        ));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'decorators' => array('ViewHelper'),
            'type' => 'submit',
            'ignore' => true,
        ));
        $this->addElement('Cancel', 'cancel', array(
            'prependText' => ' or ',
            'label' => 'cancel',
            'link' => true,
            'href' => '',
            'onclick' => 'parent.Smoothbox.close();',
            'decorators' => array(
                'ViewHelper'
            ),
        ));

        $this->addDisplayGroup(array(
            'submit',
            'cancel'
                ), 'buttons');
    }

}
