<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Plugin_Core {

    public function onStatistics($event) {
        $table = Engine_Api::_()->getDbTable('news', 'sitenews');
        $select = new Zend_Db_Select($table->getAdapter());
        $select->from($table->info('name'), 'COUNT(*) AS count');
        $event->addResponse($select->query()->fetchColumn(0), 'sitenews');
    }

    public function onUserDeleteBefore($event) {
        $payload = $event->getPayload();
        if ($payload instanceof User_Model_User) {
            // Delete news
            $sitenewsTable = Engine_Api::_()->getDbtable('news', 'sitenews');
            $sitenewsSelect = $sitenewsTable->select()->where('owner_id = ?', $payload->getIdentity());
            foreach ($sitenewsTable->fetchAll($sitenewsSelect) as $sitenews) {
                $sitenews->delete();
            }
            // Delete subscriptions
            $subscriptionsTable = Engine_Api::_()->getDbtable('subscriptions', 'sitenews');
            $subscriptionsTable->delete(array(
                'user_id = ?' => $payload->getIdentity(),
            ));
            $subscriptionsTable->delete(array(
                'subscriber_user_id = ?' => $payload->getIdentity(),
            ));
        }
    }

}
