<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_AdminSettingsController extends Core_Controller_Action_Admin {

    public function readmeAction(){
        return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
    }

    public function indexAction() {
        include_once APPLICATION_PATH .'/application/modules/Sitenews/controllers/license/license1.php';
    }

    public function faqAction() {
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenews_admin_main', array(), 'sitenews_admin_main_faq');
        $this->view->faq_type = $this->_getParam('faq_type', 'general');
    }

    public function rssSettingsAction() {
        
        include_once APPLICATION_PATH .'/application/modules/Sitenews/controllers/license/license2.php';
        if(empty($sitenews_rss_setting) || empty($rss_setting)){
            
            $this->_helper->content->setNoRender();
            return;
        }
        $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenews_admin_main', array(), 'sitenews_admin_main_settings');
        $this->view->navigationGeneral = $navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenews_admin_main_settings', array(), 'sitenews_admin_main_settings_rss');
        $this->view->form = $form = new Sitenews_Form_Admin_RssSettings();
        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }
        $values = $form->getValues();

        foreach ($values as $key => $value) {
            Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
        }

        $form->addNotice('Your changes have been saved.');
    }

    //ACTION FOR NEWS SEARCH FORM TAB
    public function newsFormSearchAction() {

        include_once APPLICATION_PATH .'/application/modules/Sitenews/controllers/license/license2.php';
        if(empty($sitenews_setting_search_news) || empty($setting_search_news)){
            
            $this->_helper->content->setNoRender();
            return;
        }
                
        //GET NAVIGATION
        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitenews_admin_main', array(), 'sitenews_admin_main_formsearch');

        //GET SEARCH TABLE
        $tableSearchForm = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore');

        //CHECK POST
        if ($this->getRequest()->isPost()) {

            //BEGIN TRANSCATION
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();

            $values = $_POST;
            $rowCategory = $tableSearchForm->getFieldsOptions('sitenews', 'category_id');
            $rowLocation = $tableSearchForm->getFieldsOptions('sitenews', 'location');
            $defaultCategory = 0;
            $defaultAddition = 0;
            $count = 1;
            try {
                foreach ($values['order'] as $key => $value) {
                    $multiplyAddition = $count * 5;
                    $tableSearchForm->update(array('order' => $defaultAddition + $defaultCategory + $key + $multiplyAddition + 1), array('searchformsetting_id = ?' => (int) $value));

                    if (!empty($rowCategory) && $value == $rowCategory->searchformsetting_id) {
                        $defaultCategory = 1;
                        $defaultAddition = 10000000;
                    }
                    $count++;
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }

        $select = $tableSearchForm->select()
                ->from($tableSearchForm->info('name'))
                ->where('module = ?', 'sitenews_news')
                ->order('order');

        $this->view->searchForm = $searchForm = $tableSearchForm->fetchAll($select);
    }

    //ACTION FOR DISPLAY/HIDE FIELDS OF SEARCH FORM
    public function displayFormAction() {

        $field_id = $this->_getParam('id');
        $name = $this->_getParam('name');
        $display = $this->_getParam('display');

        if (!empty($field_id)) {

            if ($name == 'location' && $display == 0) {
                Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitenews_rss', 'name = ?' => 'proximity'));
            }

            Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitenews_rss', 'searchformsetting_id = ?' => (int) $field_id));
        }
        $this->_redirect('admin/sitenews/settings/form-search');
    }

    //ACTION FOR DISPLAY/HIDE FIELDS OF SEARCH FORM
    public function displayNewsFormAction() {

        $field_id = $this->_getParam('id');
        $name = $this->_getParam('name');
        $display = $this->_getParam('display');

        if (!empty($field_id)) {

            if ($name == 'location' && $display == 0) {
                Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitenews_news', 'name = ?' => 'proximity'));
            }

            Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->update(array('display' => $display), array('module = ?' => 'sitenews_news', 'searchformsetting_id = ?' => (int) $field_id));
        }
        $this->_redirect('admin/sitenews/settings/news-form-search');
    }

    public function categoriesAction() {
        
        include_once APPLICATION_PATH .'/application/modules/Sitenews/controllers/license/license2.php';
        if(empty($sitenews_setting_categories) || empty($setting_categories)){
            
            $this->_helper->content->setNoRender();
            return;
        }

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenews_admin_main', array(), 'sitenews_admin_main_categories');
        //GET TASK
        $this->view->getCategoriesTempInfo = $getCategoriesTempInfo = true;

        if (isset($_POST['task'])) {
            $task = $_POST['task'];
        } elseif (isset($_GET['task'])) {
            $task = $_GET['task'];
        } else {
            $task = "main";
        }

        $local_language = $this->view->locale()->getLocale()->__toString();
        $local_language = explode('_', $local_language);
        $this->view->language = $local_language[0];

        //GET CATEGORIES TABLE
        $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');
        $tableCategoryName = $tableCategory->info('name');

        //GET STORAGE API
        $this->view->storage = Engine_Api::_()->storage();

        //GET News TABLE
        $tableSitenews = Engine_Api::_()->getDbtable('news', 'sitenews');

        if ($task == "changeorder") {
            $divId = $_GET['divId'];
            $sitenewsorder = explode(",", $_GET['sitenewsorder']);
            //RESORT CATEGORIES
            if ($divId == "categories") {
                for ($i = 0; $i < count($sitenewsorder); $i++) {
                    $category_id = substr($sitenewsorder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            } elseif (substr($divId, 0, 7) == "subcats") {
                for ($i = 0; $i < count($sitenewsorder); $i++) {
                    $category_id = substr($sitenewsorder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            } elseif (substr($divId, 0, 11) == "treesubcats") {
                for ($i = 0; $i < count($sitenewsorder); $i++) {
                    $category_id = substr($sitenewsorder[$i], 4);
                    $tableCategory->update(array('cat_order' => $i + 1), array('category_id = ?' => $category_id));
                }
            }
        }
        
        $categories = array();
        $category_info = $tableCategory->getCategories(array('fetchColumns' => array('category_id', 'category_name', 'cat_order', 'file_id', 'sponsored', 'photo_id', 'banner_id'), 'sponsored' => 0, 'cat_depandancy' => 1));

        foreach ($category_info as $value) {
            $sub_cat_array = array();
            $subcategories = $tableCategory->getSubCategories(array('category_id' => $value->category_id, 'fetchColumns' => array('category_id', 'category_name', 'file_id', 'cat_order', 'sponsored', 'photo_id', 'banner_id')));

            foreach ($subcategories as $subresults) {
                $subsubcategories = $tableCategory->getSubCategories(array('category_id' => $subresults->category_id, 'fetchColumns' => array('category_id', 'category_name', 'cat_order', 'file_id', 'sponsored', 'banner_id')));
                $treesubarrays[$subresults->category_id] = array();

                foreach ($subsubcategories as $subsubcategoriesvalues) {

                    //GET TOTAL NEWS COUNT
                    $subsubcategory_sitenews_count = $tableSitenews->getNewsCount(array('category_id' => $subsubcategoriesvalues->category_id, 'columnName' => 'subsubcategory_id'));


                    $treesubarrays[$subresults->category_id][] = $treesubarray = array(
                        'tree_sub_cat_id' => $subsubcategoriesvalues->category_id,
                        'tree_sub_cat_name' => $subsubcategoriesvalues->category_name,
                        'count' => $subsubcategory_sitenews_count,
                        'file_id' => $subsubcategoriesvalues->file_id,
                        'order' => $subsubcategoriesvalues->cat_order);
                }

                //GET TOTAL NEWS COUNT
                $subcategory_sitenews_count = $tableSitenews->getNewsCount(array('category_id' => $subresults->category_id, 'columnName' => 'subcategory_id'));
                $sub_cat_array[] = $tmp_array = array(
                    'sub_cat_id' => $subresults->category_id,
                    'sub_cat_name' => $subresults->category_name,
                    'tree_sub_cat' => $treesubarrays[$subresults->category_id],
                    'count' => $subcategory_sitenews_count,
                    'file_id' => $subresults->file_id,
                    'order' => $subresults->cat_order);
            }

            //GET TOTAL NEWS COUNT
            $category_sitenews_count = $tableSitenews->getNewsCount(array('category_id' => $value->category_id, 'columnName' => 'category_id'));

            $categories[] = $category_array = array('category_id' => $value->category_id,
                'category_name' => $value->category_name,
                'order' => $value->cat_order,
                'count' => $category_sitenews_count,
                'file_id' => $value->file_id,
                'sub_categories' => $sub_cat_array);
        }

        $this->view->categories = $categories;

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $this->view->category_id = $category_id = $request->getParam('category_id', 0);
        $perform = $request->getParam('perform', 'add');

        $cat_dependency = 0;
        $subcat_dependency = 0;
        if ($category_id) {
            $category = Engine_Api::_()->getItem('sitenews_category', $category_id);
            if ($category && empty($category->cat_dependency)) {
                $cat_dependency = $category->category_id;
            } elseif ($category && !empty($category->cat_dependency)) {
                $cat_dependency = $category->category_id;
                $subcat_dependency = $category->category_id;
            }
        }

        if (($perform == 'add') && !empty($getCategoriesTempInfo)) {
            $this->view->form = $form = new Sitenews_Form_Admin_Newscategories_Add();

            //CHECK POST
            if (empty($getCategoriesTempInfo) || !$this->getRequest()->isPost()) {
                return;
            }

            //CHECK VALIDITY
            if (empty($getCategoriesTempInfo) || !$form->isValid($this->getRequest()->getPost())) {

                if (empty($_POST['category_name'])) {
                    $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
                }
                return;
            }

            //PROCESS
            $values = $form->getValues();
            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                $row_info = $tableCategory->fetchRow($tableCategory->select()->from($tableCategoryName, 'max(cat_order) AS cat_order'));
                $cat_order = $row_info['cat_order'] + 1;

                //GET CATEGORY TITLE
                $category_name = str_replace("'", "\'", trim($values['category_name']));

                $values['cat_order'] = $cat_order;
                $values['category_name'] = $category_name;
                $values['cat_dependency'] = $cat_dependency;
                $values['subcat_dependency'] = $subcat_dependency;
                $row = $tableCategory->createRow();
                $row->setFromArray($values);

                //UPLOAD ICON

                if (isset($_FILES['icon'])) {
                    $newsFileIcon = $row->setPhoto($form->icon);
                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($newsFileIcon->file_id)) {
                        $row->file_id = $newsFileIcon->file_id;
                    }
                }

                //UPLOAD CATEGORY PHOTO
                if (isset($_FILES['photo'])) {

                    $photoFile = $row->setPhoto($form->photo, true);

                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($photoFile->file_id)) {
                        $row->photo_id = $photoFile->file_id;
                    }
                }

                if (isset($_FILES['banner'])) {
                    $newsFileIcon = $row->setPhoto($form->banner);
                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($newsFileIcon->file_id)) {
                        $row->banner_id = $newsFileIcon->file_id;
                    }
                }

                $category_id = $row->save();
                if (empty($cat_dependency) && empty($subcat_dependency)) {
                    Engine_Api::_()->sitenews()->categoriesPageCreate(array(0 => $category_id));
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }

            return $this->_helper->redirector->gotoRoute(array('module' => 'sitenews', 'action' => 'categories', 'controller' => 'settings', 'category_id' => $category_id, 'perform' => 'edit'), 'admin_default', true);
        } else if (!empty($getCategoriesTempInfo)) {
            $this->view->form = $form = new Sitenews_Form_Admin_Newscategories_Edit();
            $category = Engine_Api::_()->getItem('sitenews_category', $category_id);
            $form->populate($category->toArray());

            //CHECK POST
            if (empty($getCategoriesTempInfo) || !$this->getRequest()->isPost()) {
                return;
            }

            //CHECK VALIDITY
            if (empty($getCategoriesTempInfo) || !$form->isValid($this->getRequest()->getPost())) {

                if (empty($_POST['category_name'])) {
                    $form->addError($this->view->translate("Category Name * Please complete this field - it is required."));
                }
                return;
            }
            $values = $form->getValues();

            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                //GET CATEGORY TITLE
                $category_name = str_replace("'", "\'", trim($values['category_name']));

                $category->category_name = $category_name;
                // $category->sponsored = $values['sponsored'];
                $category->category_slug = $values['category_slug'];
 $category->meta_title = $values['meta_title'];
                $category->meta_description = $values['meta_description'];
                $category->meta_keywords = $values['meta_keywords'];
                $category->sponsored = $values['sponsored'];
                $category->banner_title = $values['banner_title'];
                $category->banner_url_window = $values['banner_url_window'];
                $category->banner_description = $values['banner_description'];
                $cat_dependency = $category->cat_dependency;
                $subcat_dependency = $category->subcat_dependency;
                if ($category_id && empty($subcat_dependency) && !empty($cat_dependency)) {
                    $cat_dependency = $cat_dependency;
                    $subcat_dependency = 0;
                } elseif ($category_id && !empty($subcat_dependency) && !empty($cat_dependency)) {
                    $cat_dependency = $cat_dependency;
                    $subcat_dependency = $subcat_dependency;
                }

                $category->cat_dependency = $cat_dependency;
                $category->subcat_dependency = $subcat_dependency;

                //UPLOAD ICON

                if (isset($_FILES['icon'])) {
                    $previous_file_id = $category->file_id;
                    $newsFileIcon = $category->setPhoto($form->icon);
                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($newsFileIcon->file_id)) {

                        //DELETE PREVIOUS CATEGORY ICON
                        if ($previous_file_id) {
                            $file = Engine_Api::_()->getItem('storage_file', $previous_file_id);
                            $file->delete();
                        }

                        $category->file_id = $newsFileIcon->file_id;
                        $category->save();
                    }
                }

                //UPLOAD CATEGORY PHOTO
                if (isset($_FILES['photo'])) {
                    $previous_photo_id = $category->photo_id;
                    $photoFile = $category->setPhoto($form->photo, true);

                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($photoFile->file_id)) {
                        $category->photo_id = $photoFile->file_id;

                        //DELETE PREVIOUS CATEGORY ICON
                        if ($previous_photo_id) {
                            $file = Engine_Api::_()->getItem('storage_file', $previous_photo_id);
                            $file->delete();
                        }
                    }
                }


                //UPLOAD CATEGORY PHOTO
                if (isset($_FILES['banner'])) {
                    $previous_photo_id = $category->banner_id;
                    $photoFile = $category->setPhoto($form->banner, true);

                    //UPDATE FILE ID IN CATEGORY TABLE
                    if (!empty($photoFile->file_id)) {
                        $category->banner_id = $photoFile->file_id;

                        //DELETE PREVIOUS CATEGORY ICON
                        if ($previous_photo_id) {
                            $file = Engine_Api::_()->getItem('storage_file', $previous_photo_id);
                            $file->delete();
                        }
                    }
                }

                $category->save();

                if (isset($values['removeicon']) && !empty($values['removeicon'])) {

                    $previous_icon_id = $category->file_id;

                    if ($previous_icon_id) {
                        //UPDATE FILE ID IN CATEGORY TABLE
                        $category->file_id = 0;
                        $category->save();

                        //DELETE CATEGORY ICON
                        $file = Engine_Api::_()->getItem('storage_file', $previous_icon_id);
                        $file->delete();
                    }
                }

                if (isset($values['removephoto']) && !empty($values['removephoto'])) {
                    //DELETE CATEGORY ICON
                    $file = Engine_Api::_()->getItem('storage_file', $category->photo_id);

                    //UPDATE FILE ID IN CATEGORY TABLE
                    $category->photo_id = 0;
                    $category->save();
                    $file->delete();
                }

                if (isset($values['removebanner']) && !empty($values['removebanner'])) {
                    //DELETE CATEGORY ICON
                    $file = Engine_Api::_()->getItem('storage_file', $category->banner_id);

                    //UPDATE FILE ID IN CATEGORY TABLE
                    $category->banner_id = 0;
                    $category->save();
                    $file->delete();
                }

                if (empty($cat_dependency) && empty($subcat_dependency)) {
                    Engine_Api::_()->sitenews()->categoriesPageCreate(array(0 => $category_id));
                }
                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }

            return $this->_helper->redirector->gotoRoute(array('module' => 'sitenews', 'action' => 'categories', 'controller' => 'settings', 'category_id' => $category_id, 'perform' => 'edit'), 'admin_default', true);
        }
    }

    //Action for Categories Mapping.
    public function mappingNewsCategoryAction() {

        //SET LAYOUT
        $this->_helper->layout->setLayout('admin-simple');

        //GET CATEGORY ID AND OBJECT
        $this->view->catid = $catid = $this->_getParam('category_id');
        $category = Engine_Api::_()->getItem('sitenews_category', $catid);

        //CREATE FORM
        $this->view->form = $form = new Sitenews_Form_Admin_Settings_News_Mapping();

        $this->view->close_smoothbox = 0;

        if (!$this->getRequest()->isPost()) {
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            return;
        }

        if ($this->getRequest()->isPost()) {

            //GET FORM VALUES
            $values = $form->getValues();

            $db = Engine_Db_Table::getDefaultAdapter();
            $db->beginTransaction();
            try {

                //GET NEWS TABLE
                $tableSitenews = Engine_Api::_()->getDbtable('news', 'sitenews');

                //GET CATEGORY TABLE
                $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');

                //ON CATEGORY DELETE
                $rows = $tableCategory->getSubCategories(array('category_id' => $catid, 'fetchColumns' => array('category_id')));
                foreach ($rows as $row) {
                    $row->delete();
                }


                //RSS TABLE CATEGORY DELETE WORK
                if (isset($values['new_category_id']) && !empty($values['new_category_id'])) {
                    $tableSitenews->update(array('category_id' => $values['new_category_id']), array('category_id = ?' => $catid));
                } else {

                    $selectNews = $tableSitenews->select()
                            ->from($tableSitenews->info('name'))
                            ->where('category_id = ?', $catid);

                    foreach ($tableSitenews->fetchAll($selectNews) as $news) {
                        $news->delete();
                    }
                }
                $page_id = $db->select()
                        ->from('engine4_core_pages', 'page_id')
                        ->where('name = ?', "sitenews_categories-home_category_" . $catid)
                        ->limit(1)
                        ->query()
                        ->fetchColumn();

                $content_ids = $db->select()
                        ->from('engine4_core_content', 'content_id')
                        ->where('page_id = ?', $page_id)
                        ->query()
                        ->fetchAll();
                foreach ($content_ids as $content_id) {
                    $content = $content_id['content_id'];
                    $db->query("DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`content_id` = $content");
                }
                $category->delete();

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();
                throw $e;
            }
        }

        $this->view->close_smoothbox = 1;
    }

    public function addCategoryAction() {
        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');

        // Generate and assign form
        $form = $this->view->form = new Sitenews_Form_Admin_Category();
        $form->setAction($this->view->url(array()));
        // Check post
        if (!$this->getRequest()->isPost()) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }
        if (!$form->isValid($this->getRequest()->getPost())) {
            $this->renderScript('admin-settings/form.tpl');
            return;
        }
        // Process
        $values = $form->getValues();

        $categoryTable = Engine_Api::_()->getItemTable('sitenews_category');
        $db = $categoryTable->getAdapter();
        $db->beginTransaction();

        $viewer = Engine_Api::_()->user()->getViewer();

        try {
            $categoryTable->insert(array(
                'user_id' => $viewer->getIdentity(),
                'category_name' => $values['label'],
            ));

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function getNewsWidgetParamsAction() {
        $content_id = isset($_GET['content_id']) ? $_GET['content_id'] : 0;

        $toValues = $toValuesArray = array();
        $params = array('starttime' => '', 'endtime' => '');
        $toValuesString = '';
        if ($content_id) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');
            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('content_id = ?', $content_id)
                    ->where('name = ?', 'sitenews.special-news')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
                if (isset($params['toValues']) && !empty($params['toValues'])) {
                    $toValues = $params['toValues'];
                    if (!empty($toValues)) {
                        $toValues = explode(',', $toValues);
                        $toValues = array_unique($toValues);
                        $toValuesString = implode(',', $toValues);
                        $toValuesArray = array();
                        foreach ($toValues as $key => $id) {
                            $news = Engine_Api::_()->getItem('sitenews_news', $id);
                            if ($news instanceof Core_Model_Item_Abstract) {
                                $toValuesArray[$key]['id'] = $id;
                                $toValuesArray[$key]['title'] = $news->getTitle();
                            }
                        }
                    }
                }
            }
        }
        $this->view->toValuesArray = $toValuesArray;
        $this->view->toValuesString = $toValuesString;
    }

    public function getRssWidgetParamsAction() {
        $content_id = isset($_GET['content_id']) ? $_GET['content_id'] : 0;

        $toValues = $toValuesArray = array();

        $toValuesString = '';
        if ($content_id) {

            //GET CONTENT TABLE
            $tableContent = Engine_Api::_()->getDbtable('content', 'core');
            $tableContentName = $tableContent->info('name');
            //GET CONTENT
            $params = $tableContent->select()
                    ->from($tableContentName, array('params'))
                    ->where('content_id = ?', $content_id)
                    ->where('name = ?', 'sitenews.list-rss-sitenews')
                    ->query()
                    ->fetchColumn();

            if (!empty($params)) {
                $params = Zend_Json_Decoder::decode($params);
                if (isset($params['toValues']) && !empty($params['toValues'])) {
                    $toValues = $params['toValues'];
                    if (!empty($toValues)) {
                        $toValues = explode(',', $toValues);
                        $toValues = array_unique($toValues);
                        $toValuesString = implode(',', $toValues);
                        $toValuesArray = array();
                        foreach ($toValues as $key => $id) {
                            $rss = Engine_Api::_()->getItem('sitenews_rss', $id);
                            if ($rss instanceof Core_Model_Item_Abstract) {
                                $toValuesArray[$key]['id'] = $id;
                                $toValuesArray[$key]['title'] = $rss->getTitle();
                            }
                        }
                    }
                }
            }
        }
        $this->view->toValuesArray = $toValuesArray;
        $this->view->toValuesString = $toValuesString;
    }

    //ACTION FOR GETTING THE MEMBER WHICH CAN BE CLAIMED THE PAGE
    function getNewsAction() {
        //GET NEWS TABLE
        $sitenewsTable = Engine_Api::_()->getDbtable('news', 'sitenews');
        $sitenewsTableName = $sitenewsTable->info('name');

        //MAKE QUERY
        $select = $sitenewsTable->select()
                ->where('title  LIKE ? ', '%' . $this->_getParam('text') . '%')
                ->order('title ASC')
                ->limit($this->_getParam('limit', 40));

        //FETCH RESULTS
        $usersitenews = $sitenewsTable->fetchAll($select);
        $data = array();
        $mode = $this->_getParam('struct');

        if ($mode == 'text') {
            foreach ($usersitenews as $sitenews) {
                $content_photo = $this->view->itemPhoto($sitenews, 'thumb.icon');
                $data[] = array(
                    'id' => $sitenews->news_id,
                    'label' => $sitenews->title,
                    'photo' => $content_photo
                );
            }
        } else {
            foreach ($usersitenews as $sitenews) {
                $content_photo = $this->view->itemPhoto($sitenews, 'thumb.icon');
                $data[] = array(
                    'id' => $sitenews->news_id,
                    'label' => $sitenews->title,
                    'photo' => $content_photo
                );
            }
        }
        return $this->_helper->json($data);
    }

    function getRssAction() {
        //GET NEWS TABLE
        $rssTable = Engine_Api::_()->getDbtable('rss', 'sitenews');
        $rssTableName = $rssTable->info('name');

        //MAKE QUERY
        $select = $rssTable->select()
                ->where('title  LIKE ? ', '%' . $this->_getParam('text') . '%')
                ->order('title ASC')
                ->limit($this->_getParam('limit', 40));

        //FETCH RESULTS
        $userrss = $rssTable->fetchAll($select);
        $data = array();
        $mode = $this->_getParam('struct');

        if ($mode == 'text') {
            foreach ($userrss as $rss) {
                $content_photo = $this->view->itemPhoto($rss, 'thumb.icon');
                $data[] = array(
                    'id' => $rss->rss_id,
                    'label' => $rss->title,
                    'photo' => $content_photo
                );
            }
        } else {
            foreach ($userrss as $rss) {
                $content_photo = $this->view->itemPhoto($rss, 'thumb.icon');
                $data[] = array(
                    'id' => $rss->rss_id,
                    'label' => $rss->title,
                    'photo' => $content_photo
                );
            }
        }
        return $this->_helper->json($data);
    }

    public function deleteCategoryAction() {

        $this->_helper->layout->setLayout('admin-simple');
        $category_id = $this->_getParam('category_id');

        $this->view->category_id = $category_id;

        //GET CATEGORIES TABLE
        $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');

        //GET CHANNEL TABLE
        $tableSitenews = Engine_Api::_()->getDbtable('news', 'sitenews');

        if ($this->getRequest()->isPost()) {

            //SITENEWS TABLE SUB-CATEGORY DELETE WORK
            $tableSitenews->update(array('subcategory_id' => 0), array('subcategory_id = ?' => $category_id));

            $tableCategory->delete(array('category_id = ?' => $category_id));


            //GET URL
            $url = $this->_helper->url->url(array('action' => 'categories', 'controller' => 'settings', 'perform' => 'add', 'category_id' => 0));
            $this->_forward('success', 'utility', 'core', array(
                'smoothboxClose' => 10,
                'parentRedirect' => $url,
                'parentRedirectTime' => 1,
                'messages' => array(Zend_Registry::get('Zend_Translate')->_(''))
            ));
        }

        $this->renderScript('admin-settings/delete-category.tpl');
    }

    public function editCategoryAction() {
        // In smoothbox
        $this->_helper->layout->setLayout('admin-simple');
        $category_id = $this->_getParam('id');
        $this->view->news_id = $this->view->category_id = $id;
        $categoriesTable = Engine_Api::_()->getDbtable('categories', 'sitenews');
        $category = $categoriesTable->find($category_id)->current();

        if (!$category) {
            return $this->_forward('success', 'utility', 'core', array(
                        'smoothboxClose' => 10,
                        'parentRefresh' => 10,
                        'messages' => array('')
            ));
        } else {
            $category_id = $category->getIdentity();
        }

        $form = $this->view->form = new Sitenews_Form_Admin_Category();
        $form->setAction($this->getFrontController()->getRouter()->assemble(array()));
        $form->setField($category);

        if (!$this->getRequest()->isPost()) {
            // Output
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        if (!$form->isValid($this->getRequest()->getPost())) {
            // Output
            $this->renderScript('admin-settings/form.tpl');
            return;
        }

        // Process
        $values = $form->getValues();

        $db = $categoriesTable->getAdapter();
        $db->beginTransaction();

        try {
            $category->category_name = $values['label'];
            $category->save();

            $db->commit();
        } catch (Exception $e) {
            $db->rollBack();
            throw $e;
        }

        return $this->_forward('success', 'utility', 'core', array(
                    'smoothboxClose' => 10,
                    'parentRefresh' => 10,
                    'messages' => array('')
        ));
    }

    public function setTemplateAction() {

        include_once APPLICATION_PATH .'/application/modules/Sitenews/controllers/license/license2.php';
        if(empty($sitenews_set_template) || empty($set_template)){
            
            $this->_helper->content->setNoRender();
            return;
        }

        $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenews_admin_main', array(), 'sitenews_admin_main_template');

        $this->view->form = $form = new Sitenews_Form_Admin_Template();
        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $values = $form->getValues();
            
            if($values['sitenews_pagestemplate'][0] == 'selectAll') {
                unset($values['sitenews_pagestemplate'][0]);
            }
            
            $tableNameContent = Engine_Api::_()->getDbtable('content', 'core');
            $header_page_id = Engine_Api::_()->sitenews()->getWidgetizedPageId(array('name' => 'header'));
            $main_content_id = $tableNameContent->select()
                    ->from($tableNameContent->info('name'), 'content_id')
                    ->where('name =?', 'main')
                    ->where('page_id =?', $header_page_id)
                    ->query()
                    ->fetchColumn();
            $db = Engine_Db_Table::getDefaultAdapter();
            if (!empty($main_content_id)) {
                $content_id = $tableNameContent->select()
                        ->from($tableNameContent->info('name'), 'content_id')
                        ->where('name =?', 'core.html-block')
                        ->where('page_id =?', $header_page_id)
                        ->where('params like (?)', '%jQuery.noConflict()%')->query()
                        ->fetchColumn();

                if (!$content_id) {
                    $db->insert('engine4_core_content', array(
                        'type' => 'widget',
                        'name' => 'core.html-block',
                        'page_id' => $header_page_id,
                        'parent_content_id' => $main_content_id,
                        'order' => 1,
                        'params' => '{"title":"","data":"<script type=\"text\/javascript\"> \r\nif(typeof(window.jQuery) !=  \"undefined\") {\r\njQuery.noConflict();\r\n}\r\n<\/script>","nomobile":"0","name":"core.html-block"}'
                    ));
                }
            }

            $templateApi = Engine_Api::_()->getApi('settemplate', 'sitenews');
            $coreSettings = Engine_Api::_()->getApi('settings', 'core');
            if (Engine_Api::_()->seaocore()->getCurrentActivateTheme()) {
                $coreSettings->setSetting('sitenewsshow.navigation.tabs', 7);
            } else {
                $coreSettings->setSetting('sitenewsshow.navigation.tabs', 6);
            }
            foreach ($values as $key => $value) {
                $coreSettings->setSetting($key, $value);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsHomePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsHomePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsBrowsePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsBrowsePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsPinboardPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsPinboardPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsMapPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsMapPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsListPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsListPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsCreatePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsCreatePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsEditPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsEditPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsManagePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsManagePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsViewPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsViewPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssCreatePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssCreatePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssViewPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssViewPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssManagePage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssManagePage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssListPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssListPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssTagcloudPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssTagcloudPage(true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addNewsTagcloudPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addNewsTagcloudPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addCategoryPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addCategoryPage(true, true);
            }

            if (!empty($values['sitenews_pagestemplate']) && in_array('addRssEditPage', $values['sitenews_pagestemplate'])) {
                $templateApi->addRssEditPage(true, true);
            }

            $form->addNotice('Your changes have been saved.');
        }
    }

}
