<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$routeStartP = "news";
$routeStartS = "news";
$module = null;
$controller = null;
$action = null;
$getURL = null;
$request = Zend_Controller_Front::getInstance()->getRequest();
if (!empty($request)) {
    $module = $request->getModuleName(); // Return the current module name.
    $action = $request->getActionName();
    $controller = $request->getControllerName();
    $getURL = $request->getRequestUri();
}
if (empty($request) || !($module == "default" && ( strpos( $getURL, '/install') !== false))) {
    $routeStartP = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.manifestUrlP', "news");
    $routeStartS = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.news.manifestUrlS', "news");
}

return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitenews',
        'version' => '5.8.0p3',
        'path' => 'application/modules/Sitenews',
        'title' => 'News / RSS Importer and Aggregator Plugin',
        'description' => 'This plugin lets you create news and RSS feeds in your site.',
        'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' =>
        array(
            'class' => 'Engine_Package_Installer_Module',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitenews/settings/install.php',
            'class' => 'Sitenews_Installer',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitenews',
        ),
        'files' =>
        array(
            'application/languages/en/sitenews.csv',
            'application/modules/Activity/Model/Helper/ItemSeaoChild.php'
        ),
    ),
    // Items
    'items' =>
    array(
        'sitenews_category',
        'sitenews_news',
        'sitenews_rss',
        'sitenews_photo',
        'sitenews_album',
        'sitenews_blacklisturl',
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        // Public
        'sitenews_specific' => array(
            'route' => $routeStartP.'/:action/:news_id/*',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'index',
            ),
            'reqs' => array(
                'news_id' => '\d+',
                'action' => '(delete|edit|multi-delete)',
            ),
        ),
        'sitenews_rss_specific' => array(
            'route' => 'rss/:action/:rss_id/*',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'rss_id' => '\d+',
                'action' => '(delete|edit|fetch-news-feed|fetch)',
            ),
        ),
        'rss_create' => array(
            'route' => 'rss/create',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'feed',
            ),
        ),
        'sitenews_general' => array(
            'route' => 'rss/:action/*',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'index',
            ),
            'reqs' => array(
                'action' => '(index|upload-photo|manage|list-rss|feed|change-status|categories|sub-category|subsub-category|validateurl|multi-delete|browse|get-search-rss|pinboard|tagscloud)',
            ),
        ),
        'sitenews_news_general' => array(
            'route' => $routeStartP.'/:action/*',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'index',
            ),
            'reqs' => array(
                'action' => '(create|create-barred|index|browse|manage|sub-category|subsub-category|categories|get-search-news|map|pinboard|tagscloud)',
            ),
        ),
        'sitenews_entry_view' => array(
            'route' => $routeStartP.'-view/:user_id/:news_id/:slug',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'user_id' => '\d+',
                'news_id' => '\d+'
            ),
        ),
        'sitenews_rss_view' => array(
            'route' => 'rss/:rss_id/:slug/:page',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'rss-view',
                'slug' => '',
                'page' => '',
            ),
            'reqs' => array(
                'rss_id' => '\d+'
            ),
        ),
        'sitenews_news_browse' => array(
            'route' => $routeStartP.'/browse/:rss',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'browse',
            ),
            'reqs' => array(
                'rss' => '\d+',
            ),
        ),
        'sitenews_news_general_category' => array(
            'route' => $routeStartP.'/:action/category/:categoryname/:category_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'browse',
            ),
            'reqs' => array(
                'category_id' => '\d+',
            ),
        ),
        'sitenews_news_general_subcategory' => array(
            'route' => $routeStartP.'/:action/category/:categoryname/:category_id/:subcategoryname/:subcategory_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'browse',
            ),
        ),
        'sitenews_news_general_subsubcategory' => array(
            'route' => $routeStartP.'/:action/category/:categoryname/:category_id/:subcategoryname/:subcategory_id/:subsubcategoryname/:subsubcategory_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'browse',
            ),
        ),
        'sitenews_rss_general_category' => array(
            'route' => 'rss/:action/category/:categoryname/:category_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'browse',
            ),
            'reqs' => array(
                'category_id' => '\d+',
            ),
        ),
        'sitenews_rss_general_subcategory' => array(
            'route' => 'rss/:action/category/:categoryname/:category_id/:subcategoryname/:subcategory_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'index',
                'action' => 'browse',
            ),
        ),
        'sitenews_category_home' => array(
            'route' => $routeStartP.'/category/:categoryname/:category_id',
            'defaults' => array(
                'module' => 'sitenews',
                'controller' => 'news',
                'action' => 'category-home',
            ),
            'reqs' => array(
                'category_id' => '\d+',
            ),
        ),
    ),
);
?>