<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-07-12 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_CategoriesWithiconGridViewController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_cat_grid_icon = Zend_Registry::isRegistered('sitenews_cat_grid_icon') ? Zend_Registry::get('sitenews_cat_grid_icon') : null;
        if(empty($sitenews_cat_grid_icon))
            return $this->setNoRender();        
        $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');
        $tableNews = Engine_Api::_()->getDbtable('news', 'sitenews');
        $this->view->columnWidth = $this->_getParam('columnWidth', 268);
        $this->view->columnHeight = $this->_getParam('columnHeight', 260);
        $showAllCategories = $this->_getParam('showAllCategories', 0);
        $orderBy = $this->_getParam('orderBy', 'catOrder');
        $categoriesID = array(
                'catOrder' => 'cat_order',
                'categoryName' => 'category_name'
            );
        $orderBy = $categoriesID[$orderBy];
        $this->view->showIcon = $this->_getParam('showIcon', 1);
        $this->view->storage = Engine_Api::_()->storage();
        $havingNews = !$showAllCategories;

        // GET ALL CATEGORIES
        $categories = $tableCategory->getNewsCategories(array('fetchColumns' => array('category_id', 'cat_dependency', 'category_name', 'cat_order', 'file_id', 'photo_id'), 'cat_depandancy' => 1, 'havingNews' => $havingNews, 'orderBy' => $orderBy));
        $count = count($categories);
        if ($count == 0)
            return $this->setNoRender();

        $categoryParams = array();
        foreach ($categories as $category) {
            $tempCategoryParams['category_id'] = $category->getIdentity();
            $tempCategoryParams['title'] = $category->getTitle();
            $tempCategoryParams['order'] = $category->cat_order;
            $tempCategoryParams['file_id'] = $category->file_id;
            $tempCategoryParams['photo_id'] = $category->photo_id;
            $tempCategoryParams['count'] = !empty($count) ? $tableNews->getNewsCount(array('category_id' => $category->category_id, 'columnName' => 'category_id', 'foruser' => 1)) : false;
            $categoryParams[] = $tempCategoryParams;
        }
        
        
        $this->view->categoryParams = $categoryParams;
    }

}
