<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_MyRssController extends Seaocore_Content_Widget_Abstract {

    protected $_childCount;

    public function indexAction() {
        
        $sitenews_my_rss = Zend_Registry::isRegistered('sitenews_my_rss') ? Zend_Registry::get('sitenews_my_rss') : null;

        if(empty($sitenews_my_rss))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');

        if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.allow', 1)) {
            return $this->setNoRender();
        }
        if (Engine_Api::_()->core()->hasSubject('user') && Engine_Api::_()->core()->getSubject('user')) {
            $viewer = Engine_Api::_()->core()->getSubject('user');
        } else
            $viewer = Engine_Api::_()->user()->getViewer();
        if (!$viewer->getIdentity()) {
            return $this->setNoRender();
        }
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params = $request->getParams();
        $this->view->defaultViewType = $params['defaultViewType'] = $this->_getParam('defaultViewType', 'newsView');
        if (!isset($params['viewFormat']))
            $this->view->viewFormat = $params['viewFormat'] = $params['defaultViewType'];
        else
            $this->view->viewFormat = $params['viewFormat'];

        $page = $this->_getParam('page', 1);
        $this->view->newRSS = $newRSS = $params['newRSS'];
        
        $this->view->latest_rss_id = $latest_rss_id = $params['latest_rss_id'];
        $this->view->topNavigationLink = $params['topNavigationLink'] = $this->_getParam('topNavigationLink', array('news', 'rss', 'createNews', 'createRss'));
        $this->view->rssNavigationLink = $params['rssNavigationLink'] = $this->_getParam('rssNavigationLink');
        $this->view->viewType = $params['viewType'] = $this->_getParam('viewType');
        $this->view->searchButton = $params['searchButton'] = $this->_getParam('searchButton', 1);
        $this->view->listViewWidth = $params['listViewWidth'] = $this->_getParam('listViewWidth', 324);
        $this->view->listViewHeight = $params['listViewHeight'] = $this->_getParam('listViewHeight', 328);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 324);
        $this->view->rssOption = $params['rssOption'] = $this->_getParam('rssOption');
        $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);
        $this->view->itemCountPerPage = $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->controllerName = $params['controller'];
        $this->view->actionName = $params['action'];
        $this->view->is_ajax = $params['is_ajax'] = $this->_getParam('is_ajax', false);

        $this->view->memberLevelRssView = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'sitenews_rss','view');
        
        if (empty($this->view->topNavigationLink) || !is_array($this->view->topNavigationLink))
            $this->view->topNavigationLink = $params['topNavigationLink'] = array();

        if (empty($this->view->rssOption) || !is_array($this->view->rssOption))
            $this->view->rssOption = $params['rssOption'] = array();

        if (empty($this->view->rssNavigationLink) || !is_array($this->view->rssNavigationLink))
            $this->view->rssNavigationLink = $params['rssNavigationLink'] = array();

        if (count($this->view->rssNavigationLink) <= 0)
            return $this->setNoRender();

        if (empty($this->view->viewType) || !is_array($this->view->viewType))
            $this->view->viewType = $params['viewType'] = array();
        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->newsViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->newsViewWidth);
        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $thumbnailType;
        $newsSize['width'] = $this->view->gridViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->gridViewWidth);
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $thumbnailType;
        $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->tab = $request->getParam('tab', null);
        $this->view->canUploadNews = Engine_Api::_()->authorization()->isAllowed('sitenews_news', $viewer, 'create');
        $this->view->canCreateRss = Engine_Api::_()->authorization()->isAllowed('sitenews_rss', $viewer, 'create');
        $params['user'] = $viewer->getType();
        $params['user_id'] = $viewer->getIdentity();
        $this->view->params = $params;

        $params['myNews'] = true;
        $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('rss', 'sitenews')->getRssPaginator($params);
        //FIND TOTAL NO. OF RECORDS
        $this->_childCount = $paginator->getTotalItemCount();
    }

    public function getChildCount() {
        return $this->_childCount;
    }

}
