<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_NewsBannerController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_news_banner = Zend_Registry::isRegistered('sitenews_news_banner') ? Zend_Registry::get('sitenews_news_banner') : null;
        if(empty($sitenews_news_banner))
            return $this->setNoRender();

        $templateApi = Engine_Api::_()->getApi('settemplate', 'sitenews');
        $getCurrentThemeSetting = $templateApi->setLayoutAccordingToTheme();
        $this->view->widthTheme = $getCurrentThemeSetting;
        $param = array();
        $this->view->bannerHeight = $param['bannerHeight'] = $this->_getParam('bannerHeight', 450);
        $this->view->bannerWidth = $bannerWidth = $this->_getParam('bannerWidth', 323);
        $this->view->imageSpace = $imageSpace = $this->_getParam('imageSpace', 7);
        if ($this->_getParam('bannerWidth')) {
            $this->view->bannerWidth = ($bannerWidth <= 323) ? $this->_getParam('bannerWidth') : 323;
        }
        if ($this->_getParam('bannerWidth') && $this->_getParam('imageSpace')) {
            $total = ($imageSpace * 4) + $bannerWidth;
            $extra = ($total - 335) / 4;
            $this->view->imageSpace = ($total <= 335) ? $this->_getParam('imageSpace') : ($imageSpace - $extra);
        }
        $this->view->category_id = $param['category_id'] = $this->_getParam('category_id');
        
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation');
        
        $this->view->subcategory_id = $param['subcategory_id'] = $this->_getParam('subcategory_id');
        $this->view->subsubcategory_id = $param['subsubcategory_id'] = $this->_getParam('subsubcategory_id');
        $this->view->popularType = $param['orderby'] = $this->_getParam('popularType', 'featured');
        $param['rss'] = $this->_getParam('rss', 0);
        $this->view->interval = $param['interval'] = $this->_getParam('interval', 3500);
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption');
        
        $this->view->params = $param;
        $newsTable = Engine_Api::_()->getDbtable('news', 'sitenews');
        $this->view->totalNews = $newsCount = $newsTable->select()
                ->from($newsTable->info('name'), 'count(news_id)')
                ->query()
                ->fetchColumn();

        // paginator
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->newsBySettings($param);
        if ($paginator->getTotalItemCount() <= 0 && $newsCount != 0) {
            return $this->setNoRender();
        }
        $paginator->setItemCountPerPage(5);
        $this->view->totalCount = $count = $paginator->getTotalItemCount();
    }

}
