<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_NewsWithCategoriesSlideshowController extends Engine_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_cat_slideshow = Zend_Registry::isRegistered('sitenews_cat_slideshow') ? Zend_Registry::get('sitenews_cat_slideshow') : null;
        if(empty($sitenews_cat_slideshow))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $param = array();
        $this->view->categoryids = $param['categoryids'] = $categoryids = $this->_getParam('categoryids');
        $this->view->category_id = $category_id = $param['category_id'] = $this->_getParam('category_id','');
        $this->view->subcategoryids = $param['subcategoryids'] = $this->_getParam('subcategoryids');
        $this->view->categoryCountInSingleRow = 8;//$this->_getParam('categoryCountInSingleRow');
        $this->view->showPagination = $param['showPagination'] = $this->_getParam('showPagination', 0);
        $this->view->interval = $param['interval'] = $this->_getParam('interval', 3500);
        $this->view->slideshow_width = $param['slideshow_width'] = $this->_getParam('slideshow_width', 1000);
        $this->view->slideshow_height = $param['slideshow_height'] = $this->_getParam('slideshow_height', 500);
        $this->view->titleTruncation = $param['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->descriptionTruncation = $param['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 100);
        $newsWithCategoriesCarousel = Zend_Registry::isRegistered('newsWithCategoriesCarousel') ? Zend_Registry::get('newsWithCategoriesCarousel') : null;
        $this->view->newsOption = $this->_getParam('newsOption');
        $this->view->carouselType = $param['carouselType'] = $this->_getParam('carouselType');
        $param['groupby'] = 'category_id';
        $this->view->popularType = $param['orderby'] = $this->_getParam('popularType', 'creation_date');
        $param['popularType'] = $this->_getParam('popularType', 'mostRecent');
        $this->view->itemCount = $this->view->itemLimit = $param['rowLimit'] = $this->_getParam('itemCount', 5);
        $this->view->rss = $param['rss'] = $this->_getParam('rss', 0);
        $this->view->categoryAtTop = $param['categoryAtTop'] = $this->_getParam('categoryAtTop', 1);
        $this->view->viewType = $param['viewType'] = $this->_getParam('viewType', 'listWithPhoto');
        $this->view->newsWidth = $this->_getParam('newsWidth', 200);
        $this->view->newsHeight = $this->_getParam('newsHeight', 120);
        $categoriesArray = array();
        $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');
        if ($this->_getParam('categoryids')) {
            $categories = $tableCategory->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'cat_dependency' => 1, 'category_id' => $categoryids));
        } else {
            $categories = $tableCategory->getCategories(array('fetchColumns' => array('category_id', 'category_name'), 'sponsored' => 0, 'cat_depandancy' => 1));
        }

        foreach ($categories as $category) {
            $subcategoriesArray = $this->getSubCategory($category->category_id);
            $categoriesArray[$category->category_id] = array(
                'category' => $category,
                'subcategories' => $subcategoriesArray,
            );
        }
        $this->view->categoriesArray = $categoriesArray;
        $this->view->requestAllParams = $requestAllParams = Zend_Controller_Front::getInstance()->getRequest()->getParams();
        $this->view->params = $param;
        $element = $this->getElement();
        $widgetTitle = $element->getTitle();
        if (empty($widgetTitle))
            $widgetTitle = "";
        if ($this->view->category_id) {
            $this->view->category = $category = Engine_Api::_()->getItem('sitenews_category', $this->view->category_id);
            if ($category)
                $link = $this->view->htmlLink($this->view->category->getHref(), " + " . $this->view->translate('See all %s news', $this->view->category->getTitle()));
        } else {
            $link = $this->view->htmlLink(array('route' => 'sitenews_news_general', 'action' => 'browse'), " + " . $this->view->translate('See all news'));
        }
        try {
            if ($this->view->showLink == 1)
                $element->setTitle(sprintf($widgetTitle . " " . $link));
            // List List featured
            $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($param);
            if ($paginator->getTotalItemCount() <= 0 && empty($category_id)) {
                return $this->setNoRender();
            }
            $paginator->setItemCountPerPage($this->_getParam('itemCount', 5));
            $this->view->totalCount = $count = $paginator->getTotalItemCount();
        } catch (Exception $e) {
            echo $e;
            die;
        }
    }

    protected function getSubCategory($category_id) {
        $tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');
        $subcategoriesArray = array();
        $subcategories = $tableCategory->getSubCategories(array('category_id' => $category_id, 'fetchColumns' => array('category_id', 'category_name', 'cat_order', 'cat_dependency', 'category_slug')));

        foreach ($subcategories as $subcategory) {
            $subcategoriesArray[$subcategory->category_id] = array(
                'subcategory' => $subcategory,
            );
        }

        return $subcategoriesArray;
    }

}
