<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_pinboardBrowseNewsSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_pinboard_browse = Zend_Registry::isRegistered('sitenews_pinboard_browse') ? Zend_Registry::get('sitenews_pinboard_browse') : null;
        if(empty($sitenews_pinboard_browse))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $this->view->params = array_merge($this->_getAllParams(), $request->getParams());
        if (!isset($this->view->params['noOfTimes']) || empty($this->view->params['noOfTimes']))
            $this->view->params['noOfTimes'] = 1000;

        if ($this->_getParam('autoload', true)) {
            $this->view->autoload = true;

            if ($this->_getParam('is_ajax_load', false)) {
                $this->view->is_ajax_load = true;
                $this->view->autoload = false;
                if ($this->_getParam('contentpage', 1) > 1)
                    $this->getElement()->removeDecorator('Title');
                $this->getElement()->removeDecorator('Container');
            } else {
                //  $this->view->layoutColumn = $this->_getParam('layoutColumn', 'middle');
                $this->getElement()->removeDecorator('Title');
                //return;
            }
        } else {
            $this->view->is_ajax_load = $this->_getParam('is_ajax_load', false);
            if ($this->_getParam('contentpage', 1) > 1) {
                $this->getElement()->removeDecorator('Title');
                $this->getElement()->removeDecorator('Container');
            }
        }

        $params = $this->view->params;
        $sitenewsNewsList = Zend_Registry::isRegistered('sitenewsNewsList') ? Zend_Registry::get('sitenewsNewsList') : null;
        $this->view->newsOption = $params['newsOption'] = $this->_getParam('newsOption');
        $this->view->itemCountPerPage = $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $params['itemCount'] = $params['itemCountPerPage'];
        $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->userComment = $this->_getParam('userComment', 1);
        $this->view->defaultLoadingImage = $params['defaultLoadingImage'] = $this->_getParam('defaultLoadingImage', 1);
        $this->view->itemWidth = $params['itemWidth'] = $this->_getParam('itemWidth', 237);
        $this->view->withoutStretch = $params['withoutStretch'] = $this->_getParam('withoutStretch', 1);
        $this->view->truncationLocation = $params['truncationLocation'] = $this->_getParam('truncationLocation', 35);
        $this->view->locationDetection = $this->view->detactLocation = $params['detactLocation'] = $this->_getParam('detactLocation', 0);

        if ($this->view->detactLocation) {
            $this->view->detactLocation = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.location', 1);
        }

        if (empty($this->view->newsOption) || !is_array($this->view->newsOption)) {
            $this->view->newsOption = $params['newsOption'] = array();
        }

        $this->view->defaultLocationDistance = 1000;
        $this->view->latitude = 0;
        $this->view->longitude = 0;

        if ($this->view->detactLocation) {
            $this->view->defaultLocationDistance = $params['defaultLocationDistance'] = $this->_getParam('defaultLocationDistance', 1000);
            $this->view->latitude = $params['latitude'] = $this->_getParam('latitude', 0);
            $this->view->longitude = $params['longitude'] = $this->_getParam('longitude', 0);
        }

        $params['rss'] = $this->_getParam('rss');

        if (!isset($params['category_id']))
            $params['category_id'] = 0;

        if (!isset($params['subcategory_id']))
            $params['subcategory_id'] = 0;

        if (!isset($params['subsubcategory_id']))
            $params['subsubcategory_id'] = 0;

        if (empty($params['category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('category_id');
            $params['subcategory_id'] = $this->_getParam('subcategory_id');
            $params['subsubcategory_id'] = $this->_getParam('subsubcategory_id');
        }

        //GET CATEGORYID AND SUBCATEGORYID
        $this->view->categoryName = '';
        if ($this->view->category_id) {
            $this->view->categoryName = $params['categoryname'] = Engine_Api::_()->getItem('sitenews_category', $this->view->category_id)->category_name;
            if ($this->view->subcategory_id) {
                $this->view->subCategoryName = $params['subcategoryname'] = Engine_Api::_()->getItem('sitenews_category', $this->view->subcategory_id)->category_name;
            }

            if ($this->view->subsubcategory_id) {
                $this->view->subsubCategoryName = $params['subsubcategoryname'] = Engine_Api::_()->getItem('sitenews_category', $this->view->subsubcategory_id)->category_name;
            }
        }
        //FORM GENERATION
        $widgetSettings = array(
            'locationDetection' => $this->view->locationDetection,
            'showAllCategories' => 1,
        );


        $form = new Sitenews_Form_Search_NewsSearch(array('widgetSettings' => $widgetSettings));
        $this->view->params = $params;

        if (!empty($params)) {
            $form->populate($params);
        }

        $this->view->formValues = $form->getValues();
        $params = array_merge($params, $form->getValues());

        $requestedAllParams = $this->_getAllParams();
        if (isset($requestedAllParams['hidden_news_category_id']) && !empty($requestedAllParams['hidden_news_category_id'])) {
            $this->view->category_id = $params['category_id'] = $this->_getParam('hidden_news_category_id');
            $this->view->subcategory_id = $params['subcategory_id'] = $this->_getParam('hidden_news_subcategory_id');
            $this->view->subsubcategory_id = $params['subsubcategory_id'] = $this->_getParam('hidden_news_subsubcategory_id');
        }

        $request = Zend_Controller_Front::getInstance()->getRequest();
        $params['newsType'] = $contentType = $request->getParam('newsType', null);
        if (empty($contentType)) {
            $params['newsType'] = $params['newsType'] = $this->_getParam('newsType', 'All');
        }
        $this->view->newsType = $params['newsType'];

        // FIND USERS' FRIENDS
        $viewer = Engine_Api::_()->user()->getViewer();

        if (!empty($params['view_view']) && $params['view_view'] == 1) {
            //GET AN ARRAY OF FRIEND IDS
            $friends = $viewer->membership()->getMembers();
            $ids = array();
            foreach ($friends as $friend) {
                $ids[] = $friend->user_id;
            }
            $params['users'] = $ids;
        }


        $orderby = $this->_getParam('view_count', 0);
        if ($orderby == 1)
            $paras['orderInterval'] = 'view_count';
        else
            $paras['orderInterval'] = 'creation_date';

        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->itemWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->itemWidth);
        $this->view->thumbnailType = $params['thumbnailType'] = $thumbnailType;
        $this->view->params = $params;
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/pinboard-browse-news-sitenews';
        $this->view->message = 'No News found in this search criteria.';
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->getNewsPaginator($params, $customFieldValues);
        $this->view->totalCount = $paginator->getTotalItemCount();
        $paginator->setItemCountPerPage($params['itemCountPerPage']);
        $paginator->setCurrentPageNumber($this->_getParam('contentpage', 1));

        $this->view->canCreate = Engine_Api::_()->authorization()->isAllowed('sitenews_news', null, 'create');

        $this->view->countPage = $paginator->count();

        if ($this->view->params['noOfTimes'] > $this->view->countPage)
            $this->view->params['noOfTimes'] = $this->view->countPage;

        $this->view->show_buttons = $this->_getParam('show_buttons', array("favourite", "linkedin", "googleplus", "comment", "like", 'facebook', 'twitter'));
    }

}
