<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_ProfileBreadcrumbController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {

        $sitenews_profile_breadcrumb = Zend_Registry::isRegistered('sitenews_profile_breadcrumb') ? Zend_Registry::get('sitenews_profile_breadcrumb') : null;
        if(empty($sitenews_profile_breadcrumb))
            return $this->setNoRender();

        //DONT RENDER IF SUBJECT IS NOT SET
        if (!Engine_Api::_()->core()->hasSubject()) {
            return $this->setNoRender();
        }

        //GET SUBJECT
        $this->view->news = $news = Engine_Api::_()->core()->getSubject();

        //GET CATEGORY TABLE
        $this->view->tableCategory = Engine_Api::_()->getDbtable('categories', 'sitenews');
        if (!empty($news->category_id)) {
            $this->view->category_name = $this->view->tableCategory->getCategory($news->category_id)->category_name;

            if (!empty($news->subcategory_id)) {
                $this->view->subcategory_name = $this->view->tableCategory->getCategory($news->subcategory_id)->category_name;

                if (!empty($news->subsubcategory_id)) {
                    $this->view->subsubcategory_name = $this->view->tableCategory->getCategory($news->subsubcategory_id)->category_name;
                }
            }
        }
    }

}
