<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_RssSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_rss_sitenews = Zend_Registry::isRegistered('sitenews_rss_sitenews') ? Zend_Registry::get('sitenews_rss_sitenews') : null;
        if(empty($sitenews_rss_sitenews))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');

        if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenews.rss.allow', 1)) {
            return $this->setNoRender();
        }

        $this->view->showEditDeleteOption = true;

        if (Engine_Api::_()->core()->hasSubject('user') && Engine_Api::_()->core()->getSubject('user')) {
            $viewer = Engine_Api::_()->core()->getSubject('user');

            $this->view->showEditDeleteOption = false;
        } else
            $viewer = Engine_Api::_()->user()->getViewer();

        if (!$viewer->getIdentity()) {
            return $this->setNoRender();
        }


        $params = Zend_Controller_Front::getInstance()->getRequest()->getParams();
        $this->view->newRSS = $newRSS = $params['newRSS'];
        $this->view->latest_rss_id = $latest_rss_id = $params['latest_rss_id'];
        //FIND THE PAGE NUMBER
        if (isset($params['page']) && !empty($params['page']))
            $this->view->page = $page = $params['page'];
        else
            $this->view->page = $page = 1;

        $viewer_id = $this->view->viewerId = $viewer->getIdentity();
        $level_id = Engine_Api::_()->user()->getViewer()->level_id;
        $this->view->can_create = Engine_Api::_()->authorization()->getPermission($level_id, 'sitenews_rss', 'create');

        // ASSIGNING THE PARAMETER
        $this->view->is_ajax_load = $this->_getParam('loaded_by_ajax', false);
        $this->view->viewFormat = $params['viewFormat'] = $this->_getParam('viewFormat', 'newsView');
        $this->view->is_ajax = $this->_getParam('is_ajax', '');
        $this->view->showContent = $params['show_content'] = $this->_getParam('show_content', 2);
        $params['itemCountPerPage'] = $this->_getParam('itemCountPerPage', 12);
        $this->view->order = $params['order'] = $this->_getParam('order');
        $params['owner'] = $viewer;
        $params['owner_id'] = $viewer->getIdentity();
        $this->view->rssOption = $params['rssOption'] = $this->_getParam('rssOption');
        $this->view->newsViewWidth = $params['newsViewWidth'] = $this->_getParam('newsViewWidth', 150);
        $this->view->newsViewHeight = $params['newsViewHeight'] = $this->_getParam('newsViewHeight', 150);
        $this->view->gridViewWidth = $params['gridViewWidth'] = $this->_getParam('gridViewWidth', 150);
        $this->view->newsViewThumbnailType = $params['newsViewThumbnailType'] = $this->_getParam('newsViewThumbnailType', 'thumb.normal');
        $this->view->gridViewThumbnailType = $params['gridViewThumbnailType'] = $this->_getParam('gridViewThumbnailType', 'thumb.normal');
        $this->view->titleTruncation = $params['titleTruncation'] = $this->_getParam('titleTruncation', 22);
        $this->view->listDescription = $this->_getParam('listDescription', 1);
        $this->view->gridDescription = $this->_getParam('gridDescription', 0);
        $this->view->descriptionTruncation = $params['descriptionTruncation'] = $this->_getParam('descriptionTruncation', 200);
        $this->view->widgetPath = 'widget/index/mod/sitenews/name/rss-sitenews';
        $this->view->isViewMoreButton = true;
        // $this->view->id = $params['idenity'] = $this->_getParam('identity');
        $this->view->message = "You have not added any RSS.";

        if (isset($params['search']) && !empty($params['search']))
            $this->view->message = 'You have not created a RSS with this criteria.';

        if (is_null($this->view->rssOption)) {
            $this->view->rssOption = array();
        }

        $this->view->rssOption[] = 'owner';
        $params['rssOption'] = $this->view->rssOption;
        $this->view->params = $params;
        $params['paginator'] = 1;
        $params['myNews'] = true;
        $paginator = $this->view->paginator = Engine_Api::_()->getDbTable('rss', 'sitenews')->getRssPaginator($params);
        //FIND TOTAL NO. OF RECORDS
        $this->view->totalCount = $paginator->getTotalItemCount();
        //SET THE NO. OF RECORDS PER PAGE
        $paginator->setItemCountPerPage($params['itemCountPerPage']);
        //SET THE CURRENT PAGE NO.
        $paginator->setCurrentPageNumber($page);
    }

}
