<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_SearchNewsSitenewsController extends Seaocore_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_search_sitenews = Zend_Registry::isRegistered('sitenews_search_sitenews') ? Zend_Registry::get('sitenews_search_sitenews') : null;
        if(empty($sitenews_search_sitenews))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $this->view->params = $params = $request->getParams();
        //FORM CREATION
        $this->view->viewType = $this->_getParam('viewType', 'vertical');
        $this->view->whatWhereWithinmile = $this->_getParam('whatWhereWithinmile', 0);
        $this->view->advancedSearch = $this->_getParam('advancedSearch', 0);
        $this->view->showAllCategories = $this->_getParam('showAllCategories', 1);
        $this->view->locationDetection = $this->_getParam('locationDetection', 0);

        $widgetSettings = array(
            'viewType' => $this->view->viewType,
            'whatWhereWithinmile' => $this->view->whatWhereWithinmile,
            'advancedSearch' => $this->view->advancedSearch,
            'showAllCategories' => $this->view->showAllCategories,
            'locationDetection' => $this->view->locationDetection,
        );

        $this->view->form = $form = new Sitenews_Form_Search_NewsSearch(array('widgetSettings' => $widgetSettings));
        $viewFormat = $params['viewFormat'] = $request->getParam('viewFormat', 'gridView');
        $orderBy = $request->getParam('orderby', null);
// print_r($params); die('die in widget controller');
        if (empty($orderBy)) {
            $order = Engine_Api::_()->sitenews()->showSelectedNewsBrowseBy($this->view->identity);
            if (isset($form->orderby))
                $form->orderby->setValue("$order");
        }

        else {
            $params['orderby'] = $orderBy;
        }

        if (!isset($params['category_id']))
            $params['category_id'] = 0;

        if (!isset($params['subcategory_id']))
            $params['subcategory_id'] = 0;

        if (!isset($params['subsubcategory_id']))
            $params['subsubcategory_id'] = 0;

        $this->view->category_id = $category_id = $params['category_id'];
        $this->view->subcategory_id = $subcategory_id = $params['subcategory_id'];
        $this->view->subsubcategory_id = $subsubcategory_id = $params['subsubcategory_id'];
        $this->view->categoryInSearchForm = Engine_Api::_()->getDbTable('searchformsetting', 'seaocore')->getFieldsOptions('sitenews_news', 'category_id');

        if (!empty($params))
            $form->populate($params);

        $categories = Engine_Api::_()->getDbtable('categories', 'sitenews')->getCategories(array('fetchColumns' => array('category_id', 'category_name', 'category_slug'), 'sponsored' => 0, 'cat_depandancy' => 1));
        $categories_slug[0] = "";
        if (count($categories) != 0) {
            foreach ($categories as $category) {
                $categories_slug[$category->category_id] = $category->getCategorySlug();
            }
        }
        $this->view->categories_slug = $categories_slug;
    }

}
