<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenews
 * @copyright  Copyright 2016-2017 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2017-01-01 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenews_Widget_SpecialNewsController extends Engine_Content_Widget_Abstract {

    public function indexAction() {
        
        $sitenews_special_news = Zend_Registry::isRegistered('sitenews_special_news') ? Zend_Registry::get('sitenews_special_news') : null;
        if(empty($sitenews_special_news))
            return $this->setNoRender();

        $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenews/View/Helper', 'Sitenews_View_Helper');
        $starttime = $this->_getParam('starttime');
        $endtime = $this->_getParam('endtime');
        $currenttime = date('Y-m-d H:i:s');

        if (!empty($starttime) && $currenttime < $starttime) {
            return $this->setNoRender();
        }

        if (!empty($endtime) && $currenttime > $endtime) {
            return $this->setNoRender();
        }

        $params = array();
        $params['news_ids'] = $this->_getParam('toValues', array());
        if (!empty($params['news_ids'])) {
            $params['news_ids'] = explode(',', $params['news_ids']);
            $params['news_ids'] = array_unique($params['news_ids']);

            if (!empty($params['news_ids']) && Count($params['news_ids']) <= 0) {
                return $this->setNoRender();
            }
        } else {
            return $this->setNoRender();
        }

        $params['limit'] = $this->_getParam('itemCount');
        $this->view->gridViewWidth = $this->_getParam('columnWidth', 250);
        $this->view->gridViewHeight = $this->_getParam('columnHeight', 200);
        $this->view->titleTruncation = $this->_getParam('titleTruncation', 22);
        $this->view->newsInfo = $this->_getParam('newsInfo');
        $this->view->itemCount = $params['limit'];
        //GET NEWS
        $this->view->paginator = $paginator = Engine_Api::_()->getDbTable('news', 'sitenews')->newsBySettings($params);

        if ($paginator->getTotalItemCount() <= 0) {
            return $this->setNoRender();
        }

        $paginator->setItemCountPerPage($params['limit']);
        $newsSize = array();
        $newsSize['thumb.normal'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normal.news.width', 375);
        $newsSize['thumb.large'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('normallarge.news.width', 720);
        $newsSize['thumb.main'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.news.height', 1600);
        $newsSize['width'] = $this->view->gridViewWidth;
        $thumbnailType = Engine_Api::_()->getApi('core', 'sitenews')->findThumbnailType($newsSize, $this->view->gridViewWidth);
        $this->view->thumbnailType = $thumbnailType;
    }

}
