<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Api_Core extends Core_Api_Abstract
{
  private $_contentAreasByName = array();

  // Auto subscribe the users by admin
  public function autosubscribe($subscriber_type, $category_id) 
  {
    // Get all the subscribers
    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategories = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');

  	// Get the table of users according to the users
  	if ($subscriber_type['existing']) {
  		$userTable = Engine_Api::_()->getDbtable('users', 'user');
  		$type = 'member';
  	
      $userTableName = $userTable->info('name');
    	// Auto subscribed for the categories which are enabled
    	$usersSelect = $userTable->select()
    		->from($userTableName, array('user_id'))
    		->query();

  	 $usersData = $usersSelect->fetchAll();
    	foreach($usersData as $users => $userInfo) {
        $select = $userTable->select()
            ->setIntegrityCheck(false)
            ->from($userTable, 'user_id')
            ->join($subscriberTableName, "$subscriberTableName.resource_type = '$type' AND $subscriberTableName.resource_id = $userTableName.user_id", 'subscriber_id')
            ->where('user_id = ?', $userInfo['user_id']);
        $selectData = $select->query()->fetchAll();
         
    		if ($selectData) {
          // insert the value for subscribe categories
          $subscategory = $subscribeCategories->createRow();
          $subscategory->subscriber_id = $selectData[0]['subscriber_id'];
          $subscategory->category_id = $category_id;
          $subscategory->save();
    		} else {
          $subscriberTable->insert(array(
            'resource_id' => $userInfo['user_id'], 
            'resource_type' => $type,
            'creation_date' => date('Y-m-d H:i:s'),
          ));
          $subscriber_id = $subscriberTable->getAdapter()->lastInsertId();

          $subscategory = $subscribeCategories->createRow();
          $subscategory->subscriber_id = $subscriber_id;
          $subscategory->category_id = $category_id;
          $subscategory->save();

    		}
    	}
    }

    if ($subscriber_type['guest']) {
      $guestUserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
      $type = 'guest';
      $guestUserTableName = $guestUserTable->info('name');
      // Auto subscribed for the categories which are enabled
      $userSelect = $guestUserTable->select()
        ->from($guestUserTableName, array('user_id'))
        ->query();

     $userData = $userSelect->fetchAll();
      foreach($userData as $user => $usersInfo) {
        $selectt = $guestUserTable->select()
            ->setIntegrityCheck(false)
            ->from($guestUserTable, 'user_id')
            ->join($subscriberTableName, "$subscriberTableName.resource_type = '$type' AND $subscriberTableName.resource_id = $guestUserTableName.user_id", 'subscriber_id')
            ->where('user_id = ?', $usersInfo['user_id']);
        $selectDatas = $selectt->query()->fetchAll();
         
        if ($selectDatas) {
          // insert the value for subscribe categories
          $subscategory = $subscribeCategories->createRow();
          $subscategory->subscriber_id = $selectDatas[0]['subscriber_id'];
          $subscategory->category_id = $category_id;
          $subscategory->save();
        } else {
          $subscriberTable->insert(array(
            'resource_id' => $usersInfo['user_id'], 
            'resource_type' => $type,
            'creation_date' => date('Y-m-d H:i:s'),
          ));
          $subscriber_id = $subscriberTable->getAdapter()->lastInsertId();

          $subscategory = $subscribeCategories->createRow();
          $subscategory->subscriber_id = $subscriber_id;
          $subscategory->category_id = $category_id;
          $subscategory->save();

        }
      }
    }
  }

  // set photo
  public function setPhoto($photo) {

    if ($photo instanceof Zend_Form_Element_File) {
      $file = $photo->getFileName();
    } else if (is_array($photo) && !empty($photo['tmp_name'])) {
      $file = $photo['tmp_name'];
    } else if (is_string($photo) && file_exists($photo)) {
      $file = $photo;
    } else {
      return;
    }

    if (empty($file))
      return;

    //GET PHOTO DETAILS
    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';
    $mainName = $path . '/' . $name;

    //GET VIEWER ID
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $photo_params = array(
        'parent_id' => $viewer_id,
        'parent_type' => "sitenewsletter",
    );

    //RESIZE IMAGE WORK
    $image = Engine_Image::factory();
    $image->open($file);
    $image->open($file)
            ->resample(0, 0, $image->width, $image->height, $image->width, $image->height)
            ->write($mainName)
            ->destroy();

    try {
      $photoFile = Engine_Api::_()->storage()->create($mainName, $photo_params);
    } catch (Exception $e) {
      if ($e->getCode() == Storage_Api_Storage::SPACE_LIMIT_REACHED_CODE) {
        echo $e->getMessage();
        exit();
      }
    }
    return $photoFile;
  }

  // Delete previous photo from storage
  public function deletePreviousFile($photo) 
  {
    // Delete previous file
    $previous_photo_id = Engine_Api::_()->getApi('settings', 'core')->getSetting($photo, 0);
    if(!empty($previous_photo_id)) {
      $table = Engine_Api::_()->getItemTable('storage_file');
      $select = $table->select()
         ->from($table->info('name'), 'file_id')
        ->where('file_id = ?', $previous_photo_id);                                                
      $rows = $table->fetchAll($select)->toArray();
      if(!empty($rows)) {
        $file_id = $rows[0]['file_id'];                
        $file = Engine_Api::_()->getItem('storage_file', $file_id);
        $file->delete();
      }
      Engine_Api::_()->getApi('settings', 'core')->removeSetting($photo);
    }
  }

  // Get subscribed users level id
  public function getSubscribedLevelid() {
    // Select the member level for subscribed users.
    $subscribers = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $select = $subscribers->select()->query()->fetchAll();
    $level_id = array();
    foreach ($select as $id => $values) {
      // Get level id
      if ($values['resource_type'] == 'member') {
        $user = Engine_Api::_()->getItem('user', $values['resource_id']);
        array_push($level_id, $user->level_id);
      } 
    }
    return array_unique($level_id);
  }

  // Get subscribed users networks
  public function getSubscribedNetwork() {
    $subscribeTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscribeTableName = $subscribeTable->info('name');

    $tableMembershipTable = Engine_Api::_()->getDbtable('membership', 'network');
    $tableMembershipName = $tableMembershipTable->info('name');

    $select = $tableMembershipTable->select()
            ->setIntegrityCheck(false)
            ->from($tableMembershipTable, 'resource_id')
            ->joinLeft($subscribeTableName, "$subscribeTableName.resource_type = 'member' AND $tableMembershipName.user_id = $subscribeTableName.resource_id", 'resource_id as id')
            ->group('resource_id');
    $selectData = $select->query()->fetchAll();
    
    $networks = array();
    foreach ($selectData as $key => $value) {
      $network = Engine_Api::_()->getItem('network', $value['resource_id']);
      $networks[$value['resource_id']] = $network->title;
    }
    return $networks;
  }

  // Get subscribed users profile types
  public function getSubscribedProfileTypes() {
    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
    $profileFields = array();
    if (count($topStructure) == 1 && $topStructure[0]->getChild()->type == 'profile_type'){
      $profileTypeField = $topStructure[0]->getChild();
      $options = $profileTypeField->getElementParams('user');
      // print_r($options['options']['data-field-id']);die;

      $subscribers = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
      $select = $subscribers->select()->query()->fetchAll();
      $profile_type = array();
      foreach ($select as $id => $values) {
        // Get level id
        if ($values['resource_type'] == 'member') {
          $user = Engine_Api::_()->getItem('user', $values['resource_id']);
          $data = Engine_Api::_()->fields()->getFieldsValues($user);
          if(!empty($data->toArray()))
            array_push($profile_type, $data[0]['value']);
        } 
      }

      if (isset($options['options']['multiOptions']) && !empty($options['options']['multiOptions']) && is_array($options['options']['multiOptions'])) {
        // Make exist profile fields array.
        foreach ($options['options']['multiOptions'] as $key => $value) {
          if (!empty($key) && in_array($key, array_unique($profile_type))) {
            $profileFields[$key] = $value;
          }
        }
      }
    }
    return $profileFields;
  }

  // Get subscribed email ids
  public function getSubscribeEmails($category_ids) {

    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryTableName = $subscribeCategoryTable->info('name');
    foreach ($category_ids as $key => $category_id) {
      $select = $subscriberTable->select()
              ->setIntegrityCheck(false)
              ->from($subscriberTable, array('resource_id', 'resource_type'))
              ->join($subscribeCategoryTableName, "$subscriberTableName.subscriber_id = $subscribeCategoryTableName.subscriber_id AND $subscribeCategoryTableName.category_id = $category_id", null);
      $selectData = $select->query()->fetchAll();
    }

    foreach ($selectData as $key => $value) {
      if ($value['resource_type'] == 'guest')
        $emails[] = Engine_Api::_()->getItem('sitenewsletter_guestuser', $value['resource_id'])->email;
      else
        $emails[] = Engine_Api::_()->getItem('user', $value['resource_id'])->email;
    }
    return $emails;
  }

  // Get subscribed users munually 
  public function getMunualEmails($subscriber_ids) {
    foreach ($subscriber_ids as $subscriber_id) {
      $subscriber = Engine_Api::_()->getItem('sitenewsletter_subscriber', $subscriber_id);
      $user_id = $subscriber->resource_id;
      $type = $subscriber->resource_type;
      if ($type == 'guest')
        $emails[] = Engine_Api::_()->getItem('sitenewsletter_guestuser', $user_id)->email;
      else
        $emails[] = Engine_Api::_()->getItem('user', $user_id)->email;
    }
    return $emails;
  }

  // Get subscribed level email ids
  public function getMemberEmails($level_id, $category_ids) {
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $userTable->info('name');

    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryTableName = $subscribeCategoryTable->info('name');
    foreach ($category_ids as $key => $category_id) {
    
      $select = $userTable->select()
              ->setIntegrityCheck(false)
              ->from($userTable, 'email')
              ->where('level_id = ?', $level_id)
              ->join($subscriberTableName, "$subscriberTableName.resource_type = 'member' AND $userTableName.user_id = $subscriberTableName.resource_id", 'subscriber_id')
              ->join($subscribeCategoryTableName, "$subscriberTableName.subscriber_id = $subscribeCategoryTableName.subscriber_id AND $subscribeCategoryTableName.category_id = $category_id", 'subscribecategory_id')
              ->group('email');
      $selectData = $select->query()->fetchAll();

      foreach ($selectData as $key => $value) {
        $emails[] = $value['email'];
      }
    }
    return $emails;
  }

  // Get subscribed network email ids
  public function getNetworkEmails($network_id, $category_ids) {
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $userTable->info('name');

    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryTableName = $subscribeCategoryTable->info('name');

    $networkTable = Engine_Api::_()->getDbtable('membership', 'network');
    $networkTableName = $networkTable->info('name');

    foreach ($category_ids as $key => $category_id) {
      $select = $userTable->select()
              ->setIntegrityCheck(false)
              ->from($userTable, 'email')
              ->join($networkTableName, "$networkTableName.resource_id = $network_id AND $userTableName.user_id = $networkTableName.user_id")
              ->join($subscriberTableName, "$subscriberTableName.resource_type = 'member' AND $userTableName.user_id = $subscriberTableName.resource_id")
              ->join($subscribeCategoryTableName, "$subscriberTableName.subscriber_id = $subscribeCategoryTableName.subscriber_id AND $subscribeCategoryTableName.category_id = $category_id", 'subscribecategory_id')
              ->group('email');
      $selectData = $select->query()->fetchAll();

      foreach ($selectData as $key => $value) {
        $emails[] = $value['email'];
      }  
    }
    return $emails;
  }

  // Get subscribed guest users email ids
  public function getGuestuserEmails($category_ids) {
    $guestuserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
    $guestuserTableName = $guestuserTable->info('name');

    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryTableName = $subscribeCategoryTable->info('name');

    foreach ($category_ids as $key => $category_id) {
      $select = $guestuserTable->select()
              ->setIntegrityCheck(false)
              ->from($guestuserTable, 'email')
              ->join($subscriberTableName, "$subscriberTableName.resource_type = 'guest' AND $guestuserTableName.user_id = $subscriberTableName.resource_id")
              ->join($subscribeCategoryTableName, "$subscriberTableName.subscriber_id = $subscribeCategoryTableName.subscriber_id AND $subscribeCategoryTableName.category_id = $category_id", 'subscribecategory_id')
              ->group('email');
      $selectData = $select->query()->fetchAll();

      foreach ($selectData as $key => $value) {
        $emails[] = $value['email'];
      }
    }
    return $emails;        
  }

  // Get subscribed profile types email ids
  public function getProfiletypeEmails($profile_type, $category_ids) {
    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
    $profileFields = array();
    $fieldValuesTable = Engine_Api::_()->fields()->getTable('user', 'values');
    $fieldValuesTableName = $fieldValuesTable->info('name');
    if (count($topStructure) == 1 && $topStructure[0]->getChild()->type == 'profile_type'){
      $profileTypeField = $topStructure[0]->getChild();
      $options = $profileTypeField->getElementParams('user');
      $field_id = $options['options']['data-field-id'];
    }
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $userTable->info('name');

    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberTableName = $subscriberTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryTableName = $subscribeCategoryTable->info('name');

    foreach ($category_ids as $key => $category_id) {
      $select = $userTable->select()
              ->setIntegrityCheck(false)
              ->from($userTable, 'email')
              ->join($subscriberTableName, "$subscriberTableName.resource_type = 'member' AND $userTableName.user_id = $subscriberTableName.resource_id")
              ->join($subscribeCategoryTableName, "$subscriberTableName.subscriber_id = $subscribeCategoryTableName.subscriber_id AND $subscribeCategoryTableName.category_id = $category_id", 'subscribecategory_id')
              ->join($fieldValuesTableName, "$fieldValuesTableName.item_id = $userTableName.user_id AND $fieldValuesTableName.field_id = $field_id AND $fieldValuesTableName. value = $profile_type")
              ->group('email');
      $selectData = $select->query()->fetchAll();

      foreach ($selectData as $key => $value) {
        $emails[] = $value['email'];
      }
    }
    return $emails;
  }

  public function truncateText($string, $limit) {
    if (empty($limit)) {
      $limit = 16;
    }
    //RETURN TRUNCATED STRING
    $string = strip_tags($string);
    return ( Engine_String::strlen($string) > $limit ? Engine_String::substr($string, 0, ($limit - 3)) . '...' : $string );
  }
}