<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Subscriber.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Form_Admin_Subscriber_Edit extends Sitenewsletter_Form_Admin_Subscriber_Add
{
  protected $_item;

  public function getItem()
  {
    return $this->_item;
  }

  public function setItem($item)
  {
    $this->_item = $item;
    return $this;
  }

  public function init()
  {
    parent::init();
    $this->setTitle('Edit Subscriber');
    $this->setDescription('Please choose the types of newsletters this subscriber should receive.');

    $data = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter')->getCategoriesId($this->_item->subscriber_id);

    // Get email ids of subscribers
    if ($this->_item->resource_type == 'guest') {
      $emailid = Engine_Api::_()->getItem('sitenewsletter_guestuser', $this->_item->resource_id)->getEmail();
    } else {
      $user = Engine_Api::_()->getItem('user', $this->_item->resource_id);
      $emailid = $user->email;
    }
    $this->removeElement('type');
    $this->emailid->setValue($emailid);
    $this->emailid->setAttrib('readonly', 'readonly');

    $this->category_id->setValue($data);
    // $this->type->setValue($this->_item->resource_type);
    // $this->type->setAttrib('disable', ['guest', 'member', 'list']);
  
    $this->submit->setLabel('Edit');

  }
}