<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Add.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Form_Admin_Template_Add extends Engine_Form 
{
  public function init() {

    $this
        ->setTitle('Template Settings')
        ->setDescription('')
        ->setAttrib('enctype', 'multipart/form-data');

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

    //SELECT TEMPLATE NAME
    $templateTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    $templates = $templateTable->select()->query()->fetchAll();
    foreach ($templates as $id => $template) {
      if($template['name'] != 'header' && $template['name'] != 'footer') {
        $id = $template['template_id'];
        $availableTemplates[$id] = $template['displayname'];
      }
    }

    $this->addElement('Select', 'template_id', array(
      'label' => 'Choose Template',
      'description' => ' Choose the template to which you want to apply below settings.',
      'multiOptions' => $availableTemplates,
    ));

    // HEADING FOR HEADING SETTINGS
    $this->addElement('Dummy', 'headersettings', array(
      'decorators' => array(array('ViewScript', array(
      'viewScript' => '_formElementsHeading.tpl',
        'heading' => 'Heading Settings',
        'class' => 'form element'
      ))),
    ));

    $this->addElement('Text', 'fontsize', array(
      'label' => 'Font Size',
      'description' => "Set the font size for headings of template. [Note: Font size is set in pixel.]",
      'value' => 24,
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(2)),
        array('LessThan', true, array(76)),
      ),
    ));

    $this->addElement('Text', 'fontcolor', array(
      'decorators' => array(array('ViewScript', array(
        'viewScript' => '_formImagerainbowFontColor.tpl',
        'class' => 'form element',
        'value' => '#610000'
      ))),
    ));

    // HEADING FOR HEADING SETTINGS
    $this->addElement('Dummy', 'bodysettings', array(
      'decorators' => array(array('ViewScript', array(
      'viewScript' => '_formElementsHeading.tpl',
        'heading' => 'Body Settings',
        'class' => 'form element'
      ))),
    ));

    $this->addElement('Text', 'body_fontsize', array(
      'label' => 'Font Size',
      'description' => "Set the font size for body of the template. [Note: Font size is set in pixel.]",
      'value' => 16,
      'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(2)),
        array('LessThan', true, array(76)),
      ),
    ));

    $this->addElement('Text', 'body_fontcolor', array(
      'decorators' => array(array('ViewScript', array(
        'viewScript' => '_formImagerainbowBodyFontColor.tpl',
        'class' => 'form element',
        'value' => '#610000'
      ))),
    ));

    // TEMPLATE BACKGROUND COLOR
    $this->addElement('Text', 'body_bgcolor', array(
      'decorators' => array(array('ViewScript', array(
        'viewScript' => '_templateBackgroundColor.tpl',
        'class' => 'form element',
        'value' => '#FFFFFF'
      )))
    ));

    $this->addElement('Button', 'submit', array(
      'label' => 'Create',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}
