<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Categories.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Model_DbTable_Campaigns extends Engine_Db_Table
{
  protected $_rowClass = 'Sitenewsletter_Model_Campaign';

  public function getCampaigns() {
    // Select the campaigns which are completed
    $stmt = $this->select()
        ->from($this, array('campaign_id', 'subject'))
        ->where('status = ?', 'completed')
        ->order('subject ASC')
        ->query();
    $data = array('global' => 'Overall statistics of all the campaigns');

    foreach( $stmt->fetchAll() as $campaigns ) {
      if (Engine_Api::_()->getDbtable('statistics', 'sitenewsletter')->checkCampaigns($campaigns['campaign_id'])) {
        $data[$campaigns['campaign_id']] = $campaigns['subject'];
      }
    }
    return $data;
  }
}