<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Subscribes.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Model_DbTable_Subscribers extends Engine_Db_Table 
{
  protected $_rowClass = "Sitenewsletter_Model_Subscriber";
    
  public function isSubscribed($user_id, $user_type) {
    $tableName = $this->info('name');
    $select = $this->select();
    $data = $select->from($tableName, 'resource_id')
      ->where('resource_id = ?', $user_id)
      ->where('resource_type = ?', $user_type)
      ->query()
      ->fetchColumn();
    if( $data ) {
      return true;
    }
    return false;
  }
  
  public function getEmailList() {
    $tableName = $this->info('name');
    $select = $this->select()
      ->from($tableName, 'email');
    foreach( $select->query()->fetchAll(Zend_Db::FETCH_COLUMN, 0) as $email ) {
      $emails[] = $email;
    }
    return $emails;
  }

  public function getSubscriberId($resource_id, $resource_type) {
    $subscriber_id = $this->select()
        ->from($this, 'subscriber_id')
        ->where('resource_id = ?', $resource_id)
        ->where('resource_type = ?', $resource_type)
        ->query()
        ->fetchColumn();

    return $subscriber_id;
  }
}