<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Plugin_Menus
{

  public function canShow()
  {
    // Check subject
    
    if( !Engine_Api::_()->core()->hasSubject('user') ) {
      return false;
    }
    // Check viewer
    $viewer = Engine_Api::_()->user()->getViewer();
    if( !$viewer || !$viewer->getIdentity() ) {
      return false;
    }
    $subscribeTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $select = $subscribeTable->select()
            ->where('resource_id = ?', $viewer->getIdentity())
            ->where('resource_type = ?', 'member');
    $subscriber = $subscribeTable->fetchRow($select);

    if (empty($subscriber['subscriber_id'])) {
      return false;
    }
    $level_id = $viewer->level_id;
    $allow_subscribe = Engine_Api::_()->authorization()->getPermission($level_id, 'sitenewsletter', 'allow_subscribe');
    if( empty($allow_subscribe) ) {
      return false;
    }

    $categoryTable = Engine_Api::_()->getDbtable('categories', 'sitenewsletter');
    $categories = $categoryTable->getEnabledCategories();
    if (count($categories) <= 1) {
      return false;
    }

    return true;
  }

  // core_main
  public function onMenuInitialize_NewsletterHeaderHome($row)
  {
    $viewer = Engine_Api::_()->user()->getViewer();
    $request = Zend_Controller_Front::getInstance()->getRequest();
    $route = array(
      'route' => 'default',
    );

    if( $viewer->getIdentity() ) {
      $route['route'] = 'user_general';
      $route['params'] = array(
        'action' => 'home',
      );
      if( 'user' == $request->getModuleName() &&
        'index' == $request->getControllerName() &&
        'home' == $request->getActionName() ) {
        $route['active'] = true;
      }
    }
    if( !empty($row->params['icon']) ) {
      return array_merge($row->params, $route);
    }
    return $route;
  }
}