<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminCampaignsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_AdminCampaignsController extends Core_Controller_Action_Admin
{
	public function indexAction() 
	{
		// Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_campai');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main_campai', array(), 'sitenewsletter_admin_main_campaign_active');
    
    $table = Engine_Api::_()->getItemTable('sitenewsletter_campaign');
    $table_name = $table->info('name');
    $select = $table->select()
            ->from($table_name)
            ->where('status = ?', 'activated')
            ->order('template_id DESC');
    $this->view->activePaginator = $activePaginator = Zend_Paginator::factory($select);
    // Set item count per page and current page number
    $activePaginator->setItemCountPerPage(10);
    $activePaginator->setCurrentPageNumber($this->_getParam('page', 1));

    $selectDrafted = $table->select()
            ->from($table_name)
            ->where('status = ?', 'drafted')
            ->where('type = ?', 'draft')
            ->order('template_id DESC');


		$this->view->draftedPaginator = $draftedPaginator = Zend_Paginator::factory($selectDrafted);
    // Set item count per page and current page number
    $draftedPaginator->setItemCountPerPage(10);
    $draftedPaginator->setCurrentPageNumber($this->_getParam('page', 1));
	}

	public function createCampaignsAction()
	{
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_campai');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main_campai', array(), 'sitenewsletter_admin_main_campaign_active');
      
		 // Generate and assign form
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Campaigns_Create();
    $form->setAction($this->view->url(array()));

    // Check post
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    // Process
    $values = $form->getValues();
    $values['type'] = 'draft';
    if (empty($values['subscriber_id'])) {
      unset($values['subscriber_id']);
    }
    if ($values['target_user']!= 'member_level') {
      unset($values['level']);
      unset($values['level_id']);
    }
    if ($values['target_user']!= 'network_level') {
      unset($values['network']);
      unset($values['network_id']);
    }
    if ($values['target_user']!= 'profile_type') {
      unset($values['profile']);
      unset($values['profile_type']);
    }

    $values['category_id'] = Zend_Json::encode($values['category_id']);

    if ($values['type'] == 'draft') {
      $status = array('status' => 'drafted');
      $values = array_merge($values, $status);
    }
    $campaignTable = Engine_Api::_()->getDbtable('campaigns', 'sitenewsletter');
    $db = $campaignTable->getAdapter();
    $db->beginTransaction();

    try {
      $row = $campaignTable->createRow();
      $row->setFromArray($values);
      $row->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    if ($values['type'] == 'draft') {
      $form->addNotice('Your changes have been saved.');
    }

    $this->_helper->redirector->gotoRoute(array('action' => 'index'));
	}

  public function getContentAction() {
    $campaign_id = $this->_getParam('campaign_id');
    $type = $this->_getParam('type', null);
    $campaign = Engine_Api::_()->getItem('sitenewsletter_campaign', $campaign_id);
    if (empty($type) && ($campaign->type == 'schedule' || $campaign->type == 'draft')) {
      $campaign->status = 'activated';
      $campaign->save();
    }

    $category = Zend_Json::decode($campaign->category_id);
    if (!empty($type) && $type == 'test') {
      $testEmails = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter_test_email');
      $emails = explode(",", $testEmails);
    } else {
      $target_user = $campaign->target_user;
      switch($target_user) {
        case 'all':
          $emails = Engine_Api::_()->sitenewsletter()->getSubscribeEmails($category);
          break;

        case 'manually':
          $emails = Engine_Api::_()->sitenewsletter()->getMunualEmails(explode(",", $campaign->subscriber_ids));
          break;

        case 'member_level':
          $emails = Engine_Api::_()->sitenewsletter()->getMemberEmails($campaign->level_id, $category);
          break;

        case 'network_level':
          $emails = Engine_Api::_()->sitenewsletter()->getNetworkEmails($campaign->network_id, $category);
          break;

        case 'profile_type':
          $emails = Engine_Api::_()->sitenewsletter()->getProfiletypeEmails($campaign->profile_type, $category);
          break;

        case 'guest_users':
          $emails = Engine_Api::_()->sitenewsletter()->getGuestuserEmails($category);
          break;
      }
    }

    $emailCount = count($emails);
    $maxWidth = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter.template.width', 700);
    $content = Engine_Content::getInstance();
    $content->getView()->baseUrl();

    $old_storage = $content->getStorage();

    Zend_Controller_Front::getInstance()->getResponse()->setBody($campaign->body);

    $contentTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    
    $template_name = Engine_Api::_()->getItem('sitenewsletter_template', $campaign->template_id);
    $content->setStorage($contentTable);
   
    $header = $content->render('header');
    $contentBody = $content->render($campaign->template_id);
    $footer = $content->render('footer');
    $content->setStorage($old_storage);

    $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
    $view = Zend_Registry::get('Zend_View');
    $subject = $campaign->subject;

    $sentEmailCount = 0;
    foreach ($emails as $reciever_email) {
      $tracker = $this->view->absoluteUrl($this->view->baseUrl('tracker_mail.php?id='.$campaign_id.'&log=true&email='.$reciever_email));
      $message = '';
      $message .= '<div style="max-width:'.$maxWidth.'px; margin:auto; border:1px solid #ddd;">';
      $message .= '<img alt="" src="'.$tracker.'" width="1" height="1" border="0" />';
      $message .= $header. $contentBody.$footer;
      $message .= '</div>';
      $dom = new DomDocument();
      @$dom->loadHTML($message);
      $urls = $dom->getElementsByTagName('a');
      foreach ($urls as $url)
      {
        $href = $url->getAttribute('href');
        if (substr_count($href, $content->getView()->baseUrl('admin/sitenewsletter/statistics/refer-count'))) {
          $newhref = $href.'&id='.$campaign_id.'&mail='.$reciever_email;
          $url->setAttribute('href', $newhref);
        } elseif (substr_count($href, $content->getView()->baseUrl())) {
          $newhref = $this->view->absoluteUrl($href);
          $url->setAttribute('href', $newhref);
        } else
          continue;
      }
      $message = $dom->saveHTML();

      $view = Zend_Registry::get('Zend_View');
      $link = $view->absoluteUrl(Zend_Controller_Front::getInstance()->getRouter()->assemble(array(
                    'module' => 'sitenewsletter',
                    'controller' => 'subscribe',
                    'action' => 'unsubscribe',
                    'token' => base64_encode(time() . ":" . $reciever_email)
                        ), 'unsubscribe', true));
      $button = "<div style='max-width:700px; margin:auto; text-align:center;'><a href=$link style='color:blue;'>Unsubscribe from this newsletter</a></div>";
      $sentEmails = Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, 'NEWSLETTER_SEND_NOTIFICATION', array(
          'subject' => $subject,
          'message' => $message,
          'unsubscribe_link' => $button,
          'email' => $email,
          'queue' => false
        )
      );
      if ($sentEmails) {
        $sentEmailCount = ++$sentEmailCount;
      }
      $session = new Zend_Session_Namespace('stopcampaigns');
      if (isset($session) && isset($session->stop) && $session->stop) {
        exit;
      }
    }

    if (isset($session->stop))
      $session->unsetAll();

    if ($type != 'test') {
      if($sentEmailCount == $emailCount) {
        $campaign->status = 'completed';
        $campaign->email_count = $sentEmailCount;
        $campaign->total_email = $emailCount;
        $campaign->save();
      } else {
        $campaign->status = 'failed';
        $campaign->save();
      }
    }

    if ($this->_getParam('viaPublish', false)) {
      Zend_Controller_Front::getInstance()->getResponse()->setBody('');
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 1000,
        'parentRefresh'=> 1000,
        'messages' => array('Newsletter published successfully.')
      ));
    }

    return $this->_redirect('admin/sitenewsletter/campaigns/completed');
  
  }

  public function testCampaignsAction() {
    $campaign_id = $this->_getParam('campaign_id');
    $type = $this->_getParam('type', null);
    $campaign = Engine_Api::_()->getItem('sitenewsletter_campaign', $campaign_id);

    $category = Zend_Json::decode($campaign->category_id);
    $testEmails = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter_test_email');
    $view = Zend_Registry::get('Zend_View');
    if (empty($testEmails)) {
      $url = $view->baseUrl() . '/admin/sitenewsletter/settings';
      echo $message = 'Please <a href="'.$url.'">click here</a> to add test email id inorder to test this campaign.';
      return ;
    }
    $emails = explode(",", $testEmails);
    
    $emailCount = count($emails);
    $maxWidth = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitenewsletter.template.width', 700);
    $content = Engine_Content::getInstance();
    $content->getView()->baseUrl();

    $old_storage = $content->getStorage();
    Zend_Controller_Front::getInstance()->getResponse()->setBody($campaign->body);

    $contentTable = Engine_Api::_()->getDbtable('templates', 'sitenewsletter');
    
    $template_name = Engine_Api::_()->getItem('sitenewsletter_template', $campaign->template_id);
    $content->setStorage($contentTable);
   
    $header = $content->render('header');
    $contentBody = $content->render($campaign->template_id);
    $footer = $content->render('footer');
    $content->setStorage($old_storage);

    $email = Engine_Api::_()->getApi('settings', 'core')->core_mail_from;
    $view = Zend_Registry::get('Zend_View');
    $subject = $campaign->subject;
    $sentEmailCount = 0;
    foreach ($emails as $reciever_email) {
      if (preg_match('/\s/',$reciever_email)) {
        $reciever_email = preg_replace('/\s+/','',$reciever_email);
      }
      $message = '';
      $message .= '<div style="max-width:'.$maxWidth.'px; margin:auto; border:1px solid #ddd;">';
      $message .= $header. $contentBody.$footer;
      $message .= '</div>';
      $dom = new DomDocument();
      @$dom->loadHTML($message);
      $urls = $dom->getElementsByTagName('a');
      foreach ($urls as $url)
      {
        $href = $url->getAttribute('href');
        if (substr_count($href, $content->getView()->baseUrl('admin/sitenewsletter/statistics/refer-count'))) {
          $linkArray = explode('?',$href);
          $newhref = explode('=', $linkArray[1]);
          $url->setAttribute('href', $newhref[1]);
        } elseif (substr_count($href, $content->getView()->baseUrl())) {
          $newhref = $this->view->absoluteUrl($href);
          $url->setAttribute('href', $newhref);
        } else
          continue;
      }
      $message = $dom->saveHTML();

      $view = Zend_Registry::get('Zend_View');
      $button = "<div style='max-width:700px; margin:auto; text-align:center;'><p>- - - This is a test version of the newsletter. - - -</p></div>";
      $sentEmails = Engine_Api::_()->getApi('mail', 'core')->sendSystem($reciever_email, 'NEWSLETTER_SEND_NOTIFICATION', array(
          'subject' => $subject,
          'message' => $message,
          'unsubscribe_link' => $button,
          'email' => $email,
          'queue' => false
        )
      );
      if ($sentEmails) {
        $sentEmailCount = ++$sentEmailCount;
      }
      $session = new Zend_Session_Namespace('stopcampaigns');
      if (isset($session) && isset($session->stop) && $session->stop) {
        exit;
      }
    }

    if (isset($session->stop))
      $session->unsetAll();

    return $this->_redirect('admin/sitenewsletter/campaigns/index');
  }

  public function stopAction() {
    $id = $this->_getParam('campaign_id');
    if ($id) {
      return $this->_redirect('admin/sitenewsletter/campaigns/index');
    }
    $session = new Zend_Session_Namespace('stopcampaigns');
    $session->stopcampaign = true;
  }

  public function publishAction() {
    // In smoothbox
    $campaign_id = $this->_getParam('campaign_id');
    $this->_helper->layout->setLayout('admin-simple');

    $this->view->form = $form = new Sitenewsletter_Form_Admin_Campaigns_Publish();

    if( !$this->getRequest()->isPost() ) {
      return;
    }
    // Check validitiy
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    if (($_POST['type'] == 'schedule') && empty($_POST['scheduled_date']['date'])) {
      $form->addError($this->view->translate("Please complete this field - it is required."));
      return;
    }
    
    $values = $form->getValues();
    $campaign = Engine_Api::_()->getItem('sitenewsletter_campaign', $campaign_id);

    // Process
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    $status = $values['type'] == 'publish' ? 'activated' : 'drafted';
    try {
      $campaign->type = $values['type'];
      $campaign->scheduled_date = $values['scheduled_date'];
      $campaign->timezone = $values['timezone'];
      $campaign->status = $status;
      $campaign->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    if ($values['type'] == 'publish') {
      return $this->_forward('get-content', null, null, array('campaign_id' => $campaign_id, 'viaPublish' => true));
    } else {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 1000,
        'parentRefresh'=> 1000,
        'messages' => array('Your settings have been saved.')
      ));
    }
  }

  public function completedAction() {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_campai');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main_campai', array(), 'sitenewsletter_admin_main_campaign_completed');
    // Get the params
    $order = $this->_getParam('order');
    $id = $this->_getParam('id');
    
    $page = $this->_getParam('page', 1);

    $table = Engine_Api::_()->getDbtable('campaigns', 'sitenewsletter');
    $select = $table->select();

    $select->where('status = ?', 'completed');

    // Set up select info
    $select->order(( !empty($id) ? $id : 'campaign_id' ) . ' ' . ( !empty($order) ? $order : 'DESC' ));

    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
    $this->view->order = $order;
  }

  public function scheduledAction() {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_campai');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main_campai', array(), 'sitenewsletter_admin_main_campaign_scheduled');
    // Get the params
    $order = $this->_getParam('order');
    $id = $this->_getParam('id');
    
    $page = $this->_getParam('page', 1);

    $table = Engine_Api::_()->getDbtable('campaigns', 'sitenewsletter');
    $select = $table->select();

    $select->where('type = ?', 'schedule');
    $select->where('status = ?', 'drafted');

    // Set up select info
    $select->order(( !empty($id) ? $id : 'campaign_id' ) . ' ' . ( !empty($order) ? $order : 'DESC' ));

    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(10);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
    $this->view->order = $order;
  }

  public function rescheduleAction() {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $campaign_id = $this->_getParam('campaign_id', null);
    $this->view->campaign_id = $campaign_id;
    
    $campaignsTable = Engine_Api::_()->getDbtable('campaigns', 'sitenewsletter');
    $campaign = $campaignsTable->find($campaign_id)->current();
    if( !$campaign ) {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 1000,
        'parentRefresh'=> 1000,
        'messages' => array('Campaign rescheduled successfully.')
      ));
    } else {
      $campaign_id = $campaign->getIdentity();
    }
    
    $params = $campaign->toArray();
    $this->view->type = $params['type'];
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Campaigns_Reschedule();
    $form->populate($params);
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    
    if (($_POST['type'] == 'schedule') && empty($_POST['scheduled_date']['date'])) {
      $form->addError($this->view->translate("Please complete this field - it is required."));
      return;
    }
    
    $values = $form->getValues();

    // Process
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    $status = $values['type'] == 'publish' ? 'activated' : 'drafted';
    $scheduled_date = $values['type'] == 'publish' ? '0000-00-00 00:00:00' : $values['scheduled_date'];
    try {
      $campaign->type = $values['type'];
      $campaign->scheduled_date = $scheduled_date;
      $campaign->timezone = $values['timezone'];
      $campaign->status = $status;
      $campaign->save();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    if ($values['type'] == 'publish') {
      return $this->_forward('get-content', null, null, array('campaign_id' => $campaign_id, 'viaPublish' => true));
    } else {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 1000,
        'parentRefresh'=> 1000,
        'messages' => array('Your settings have been saved.')
      ));
    }
  }

  public function editAction()
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_campai');
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitenewsletter_admin_main_campai', array(), 'sitenewsletter_admin_main_campaign_active');
    
     $campaign_id = $this->_getParam('campaign_id', null);
    $this->view->campaign_id = $campaign_id;
    
    $campaignsTable = Engine_Api::_()->getDbtable('campaigns', 'sitenewsletter');
    $campaign = $campaignsTable->find($campaign_id)->current();
    if( !$campaign ) {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh'=> 10,
        'messages' => array('')
      ));
    } else {
      $campaign_id = $campaign->getIdentity();
    }
    
    $params = $campaign->toArray();
    $this->view->target_user = $params['target_user'];
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Campaigns_Edit();
    $params['category_id'] = Zend_Json::decode($params['category_id']);
    $form->populate($params);
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    
    $values = $form->getValues();
    $values['type'] = $params['type'];
    if (empty($values['subscriber_ids'])) {
      unset($values['subscriber_ids']);
    }
    if (empty($values['emails'])) {
      unset($values['emails']);
    }
    if ($values['target_user']!= 'member_level') {
      unset($values['level']);
      unset($values['level_id']);
    }
    if ($values['target_user']!= 'network_level') {
      unset($values['network']);
      unset($values['network_id']);
    }
    if ($values['target_user']!= 'profile_type') {
      unset($values['profile']);
      unset($values['profile_type']);
    }
    $values['category_id'] = Zend_Json::encode($values['category_id']);
    //BEGIN TRANSACTION
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();

    try {
      $campaign->setFromArray($values);
      $campaign->save();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    $form->addNotice('Your changes have been saved.');
    $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }

  public function deleteAction() {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $campaign_id = $this->_getParam('campaign_id');
    $this->view->campaign_id = $campaign_id;
    $campaign = Engine_Api::_()->getItem('sitenewsletter_campaign', $campaign_id);

    if( !$this->getRequest()->isPost() ) {
      return;
    }
    
    // Process
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    
    try {
      $campaign->delete();  
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    
    return $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 1000,
      'parentRefresh'=> 1000,
      'messages' => array('Campaign deleted successfully.')
    ));
  }

   //ACTION FOR EMAIL 
  public function getSubscriberAction() {
    $id = $this->_getParam('category_id');
    $title = $this->_getParam('text', null);
    $limit = $this->_getParam('limit', 40);
    $enabled = $this->_getParam('enabled');
    
    $userTable = Engine_Api::_()->getDbtable('users', 'user');
    $userTableName = $userTable->info('name');
    
    $subscriberTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $subscriberName = $subscriberTable->info('name');

    $guestUserTable = Engine_Api::_()->getDbtable('guestusers', 'sitenewsletter');
    $guestUserName = $guestUserTable->info('name');

    $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribecategories', 'sitenewsletter');
    $subscribeCategoryName = $subscribeCategoryTable->info('name');

    $data = array();
    $category_ids = explode(",", $id);
    foreach ($category_ids as $key => $category_id) {
      
      $select = $subscriberTable->select()
              ->setIntegrityCheck(false)
              ->from($subscriberName)
              ->joinLeft($userTableName, "$subscriberName.resource_type = 'member' AND $subscriberName.resource_id = $userTableName.user_id AND $userTableName.enabled = $enabled",'email as email1')
              ->joinLeft($guestUserName, "$subscriberName.resource_type = 'guest' AND $subscriberName.resource_id = $guestUserName.user_id",'email as email2')
              ->join($subscribeCategoryName, "$subscriberName.subscriber_id = $subscribeCategoryName.subscriber_id AND $subscribeCategoryName.category_id = $category_id")
              ->limit($limit)
              ->order($subscriberName.'.creation_date DESC');
      $users = $subscriberTable->fetchAll($select);
      
      foreach ($users as $user) {
        if (empty($user->email1))
          $email = $user->email2;
        else
          $email = $user->email1;
        $data[] = array(
            'id' => $user->subscriber_id,
            'label' => $email
        );
      }
    }

    $data = array_unique($data,SORT_REGULAR);
    return $this->_helper->json($data);
  }

  public function uploadPhotoAction() {
    $viewer = Engine_Api::_()->user()->getViewer();

    $this->_helper->layout->disableLayout();

    if( !$this->_helper->requireUser()->checkRequire() )
    {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Max file size limit exceeded (probably).');
      return;
    }

    if( !$this->getRequest()->isPost() )
    {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid request method');
      return;
    }
    if( !isset($_FILES['userfile']) || !is_uploaded_file($_FILES['userfile']['tmp_name']) )
    {
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('Invalid Upload');
      return;
    }

    $db = Engine_Api::_()->getDbtable('photos', 'album')->getAdapter();
    $db->beginTransaction();

    try
    {
      $viewer = Engine_Api::_()->user()->getViewer();

      $photoTable = Engine_Api::_()->getDbtable('photos', 'album');
      $photo = $photoTable->createRow();
      $photo->setFromArray(array(
        'owner_type' => 'user',
        'owner_id' => $viewer->getIdentity()
      ));
      $photo->save();

      $photo->setPhoto($_FILES['userfile']);

      $this->view->status = true;
      $this->view->name = $_FILES['userfile']['name'];
      $this->view->photo_id = $photo->photo_id;
      $this->view->photo_url = $this->view->absoluteUrl($photo->getPhotoUrl());

      $table = Engine_Api::_()->getDbtable('albums', 'album');
      $album = $table->getSpecialAlbum($viewer, 'sitenewsletter');

      $photo->album_id = $album->album_id;
      $photo->save();

      if( !$album->photo_id )
      {
        $album->photo_id = $photo->getIdentity();
        $album->save();
      }

      $auth = Engine_Api::_()->authorization()->context;
      $auth->setAllowed($photo, 'everyone', 'view',    true);
      $auth->setAllowed($photo, 'everyone', 'comment', true);
      $auth->setAllowed($album, 'everyone', 'view',    true);
      $auth->setAllowed($album, 'everyone', 'comment', true);


      $db->commit();

    } catch( Album_Model_Exception $e ) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = $this->view->translate($e->getMessage());
      throw $e;
      return;

    } catch( Exception $e ) {
      $db->rollBack();
      $this->view->status = false;
      $this->view->error = Zend_Registry::get('Zend_Translate')->_('An error occurred.');
      throw $e;
      return;
    }
  }
}


