<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminTemplateController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_AdminTemplateController extends Core_Controller_Action_Admin
{
	public function indexAction() 
	{   
		// Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_layout');

    // Get sub navigation
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main_layout', array(), 'sitenewsletter_admin_main_layout_template');

    $table = Engine_Api::_()->getDbTable('templateslayouts', 'sitenewsletter');
    $table_name = $table->info('name');
    $select = $table->select()
            ->from($table_name)
            ->order('template_id DESC');
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    // Set item count per page and current page number
    $paginator->setItemCountPerPage(10);
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));

	}

  public function addTemplateAction()
  {
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_layout');

    // Get sub navigation
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main_layout', array(), 'sitenewsletter_admin_main_layout_template');
    $this->view->type = 1;

    // Generate and assign form
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Template_Add();
    $form->setAction($this->view->url(array()));

    // Check post
    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    // Process
    $values = $form->getValues();
    $templateTable = Engine_Api::_()->getDbTable('templateslayouts', 'sitenewsletter');
    
    $templateslayouts = $templateTable->fetchRow($templateTable->select()->from($templateTable->info('name'), 'templateslayout_id')->where('template_id = ?', $values['template_id']));

    if ($templateslayouts->templateslayout_id) {
      $form->addError('Settings already exist for this template, so, you can go back and edit those settings.');
      return;
    }
    
    $db = $templateTable->getAdapter();
    $db->beginTransaction();

    try {
      $template = $templateTable->createRow();
      $template->setFromArray($values);
      $template->save();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    return $this->_redirect('admin/sitenewsletter/template');
  }

    public function editTemplateAction() 
  { 
    // Get navigation
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main', array(), 'sitenewsletter_admin_main_layout');

    // Get sub navigation
    $this->view->subNavigation = $subNavigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitenewsletter_admin_main_layout', array(), 'sitenewsletter_admin_main_layout_template');
      
    $template_id = $this->_getParam('id', null);
    $this->view->template_id = $template_id;
    
    $templatesTable = Engine_Api::_()->getDbtable('templateslayouts', 'sitenewsletter');
    $template = $templatesTable->find($template_id)->current();
    if( !$template ) {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh'=> 10,
        'messages' => array('')
      ));
    } else {
      $template_id = $template->getIdentity();
    }
    
    $params = $template->toArray();
    $form = $this->view->form = new Sitenewsletter_Form_Admin_Template_Edit(array('bodybgcolor' => $template->body_bgcolor, 'fontcolor' => $template->fontcolor, 'bodyfontcolor' => $template->body_fontcolor));
    $form->populate($params);
    $form->setAction($this->getFrontController()->getRouter()->assemble(array()));

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }
    
    $values = $form->getValues();

    //BEGIN TRANSACTION
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();

    try {
      $template->template_id = $values['template_id'];
      $template->fontcolor = $values['fontcolor'];
      $template->fontsize = $values['fontsize'];
      $template->body_fontsize = $values['body_fontsize'];
      $template->body_fontcolor = $values['body_fontcolor'];
      $template->body_bgcolor = $values['body_bgcolor'];
      $template->save();

      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    return $this->_redirect('admin/sitenewsletter/template');
  }

  public function deleteTemplateAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $template_id = $this->_getParam('id');
    $this->view->template_id = $template_id;
    $templateTable = Engine_Api::_()->getDbtable('templateslayouts', 'sitenewsletter');
    $template = $templateTable->find($template_id)->current();
    
    if( !$template ) {
      return $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh'=> 10,
        'messages' => array('')
      ));
    } else {
      $template_id = $template->getIdentity();
    }
    
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    
    // Process
    $db = $templateTable->getAdapter();
    $db->beginTransaction();
    
    try {
      $template->delete();
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }
    
    return $this->_forward('success', 'utility', 'core', array(
      'smoothboxClose' => 10,
      'parentRefresh'=> 10,
      'messages' => array('')
    ));
  }
}