<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SettingsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_SettingsController extends Core_Controller_Action_User
{
  public function init()
  {
    
    //Can specifiy custom id
    $id = $this->_getParam('id', null);
    $subject = null;
    if( null === $id )
    {
      $subject = Engine_Api::_()->user()->getViewer();
      Engine_Api::_()->core()->setSubject($subject);
    }
    else
    {
      $subject = Engine_Api::_()->getItem('user', $id);
      Engine_Api::_()->core()->setSubject($subject);
    }

    // Set up require's
    $this->_helper->requireUser();
    $this->_helper->requireSubject();
    $this->_helper->requireAuth()->setAuthParams(
      $subject,
      null,
      'edit'
    );
      
    //Render
    $this->_helper->content
        // ->setNoRender()
        ->setEnabled()
        ;
  }

  public function updateCategoriesAction()
  {
    $user = Engine_Api::_()->core()->getSubject();

    $subscribeTable = Engine_Api::_()->getDbtable('subscribers', 'sitenewsletter');
    $select = $subscribeTable->select()
            ->where('resource_id = ?', $user->getIdentity())
            ->where('resource_type = ?', 'member');
    $subscriber = $subscribeTable->fetchRow($select);

    $this->view->form = $form = new Sitenewsletter_Form_Settings_Categories(array(
      'item' => $subscriber['subscriber_id']
    ));
    // Check request
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    // Check data
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $values = $form->getValues();

	  //Process form
	  $subscribeCategoryTable = Engine_Api::_()->getDbtable('subscribeCategories', 'sitenewsletter');
	  $db = $subscribeCategoryTable->getAdapter();
    
    // Save
    $db->beginTransaction();

    try {
      
      $selectData = $subscribeCategoryTable->select()
        ->from($subscribeCategoryTable->info('name'), array('category_id'))
        ->where('subscriber_id = ?', $subscriber['subscriber_id']);
      foreach ($selectData->query()->fetchAll() as $category_ids) {
        $subscribeCategoryTable->delete(array(
          'category_id = ?' => $category_ids['category_id'],
          'subscriber_id = ?' => $subscriber['subscriber_id'],
        ));
      }

      foreach ($values['categories'] as $key => $value) {
        $subscribeCategoryTable->insert(array(
          'category_id' => $value,
          'subscriber_id' => $subscriber['subscriber_id'],
        ));
      }
      $db->commit();
    } catch( Exception $e ) {
      $db->rollBack();
      throw $e;
    }

    $form->addNotice(Zend_Registry::get('Zend_Translate')->_('Settings were successfully saved.'));
  }
}