<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$searchApi = Engine_Api::_()->getApi('search', 'core');
$availableTypes = $searchApi->getAvailableTypes();
if (is_array($availableTypes) && count($availableTypes) > 0) {
  $options = array('' => 'Everything');
  foreach ($availableTypes as $index => $type) {
    $options[$type] = strtoupper('ITEM_TYPE_' . $type);
  }
} else {
  $options = array('' => 'Everything');
}
$typeElement = array(
  'Select',
  'type',
  array(
    'label' => 'Type',
    'multiOptions' => $options,
    'RegisterInArrayValidator' => false,
));

$popularTypeArray = array(
  // 'creation' => 'Recently Created',
  'like' => 'Most Liked',
  'comment' => 'Most Commented',
);

$titleTruncation = array(
    'Text',
    'titleTruncation',
    array(
        'label' => 'Truncation limit for title.',
        'value' => 100,
    ),
    'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0)),
    ),
);

$itemCount = array(
    'Text',
    'itemCount',
    array(
        'label' => 'Count items in widget',
        'value' => 10,
    ),
    'validators' => array(
        array('Int', true),
        array('GreaterThan', true, array(0)),
    ),
);

return array(
  array(
    'title' => 'Subscribe to Newsletter',
    'description' => 'Subscribe the newsletter.',
    'category' => 'Newsletter / Marketing Plugin',
    'type' => 'widget',
    'name' => 'sitenewsletter.newsletter-subscribe',
    'defaultParams' => array(
        'title' => '',
    ),
  ),
  array(
    'title' => 'Template Header',
    'description' => 'Show the site-wide header.',
    'category' => 'Newsletter / Marketing Plugin',
    'type' => 'widget',
    'name' => 'sitenewsletter.template-header',
    'requirements' => array(
      'header-footer',
    ),
  ),
  array(
    'title' => 'Template Footer',
    'description' => 'Show the site-wide footer.',
    'category' => 'Newsletter / Marketing Plugin',
    'type' => 'widget',
    'name' => 'sitenewsletter.template-footer',
    'requirements' => array(
      'header-footer',
    ),
  ),
  array(
    'title' => 'Random / Popular Items',
    'description' => 'Displays Items based on the Popularity / Sorting Criteria and other settings that you choose for this widget. You can place this widget multiple times on a page with different popularity criterion chosen for each placement.',
    'category' => 'Newsletter / Marketing Plugin',
    'type' => 'widget',
    'autoEdit' => true,
    'name' => 'sitenewsletter.list-popular-items',
    'defaultParams' => array(
      'title' => 'Popular Item Types',
      'itemCount' => 10,
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
        
        $typeElement,
        array(
          'Select',
          'popularType',
          array(
            'label' => 'Popularity / Sorting Criteria',
            'multiOptions' => array_merge($popularTypeArray, array('random' => 'Random')),
            'value' => 'random',
          )
        ),
        array(
          'Select',
          'interval',
          array(
            'label' => 'Popularity Duration (This duration will be applicable to the selected Popularity / Sorting Criteria:  Most Liked and Most Commented.)',
            'multiOptions' => array('week' => '1 Week', 'month' => '1 Month', 'overall' => 'Overall'),
            'value' => 'overall',
          )
        ),
        $titleTruncation,     
        $itemCount,
      )
    ),
  ),
  array(
    'title' => 'Track Link / Go to Action Button',
    'description' => 'You can add a link/URL which you want to be visited by the target users in this widget. It can be seen/tracked from statistics section how many users visited that link. For better tracking, we recommend you place only one widget inside a template.',
    'category' => 'Newsletter / Marketing Plugin',
    'type' => 'widget',
    'autoEdit' => true,
    'name' => 'sitenewsletter.track-link',
    'defaultParams' => array(
      'title' => '',
    ),
    'requirements' => array(
      'no-subject',
    ),
    'adminForm' => array(
      'elements' => array(
        array(
          'Hidden',
          'title',
          array(
          )
        ),
        array(
          'Text',
          'linkName',
          array(
            'label' => 'Link Name',
          ),
        ),
        array(
          'Text',
          'link',
          array(
            'label' => 'Link',
          ),
        ),
      )
    ),
  ),
);