<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitenewsletter_Widget_ListPopularItemsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $this->view->addHelperPath(APPLICATION_PATH . '/application/modules/Sitenewsletter/View/Helper', 'Sitenewsletter_View_Helper');
    $element = $this->getElement();
    $this->view->widgetTitle = $element->getTitle();
    $element->setTitle('');
    $coreApi = Engine_Api::_()->getApi('settings', 'core');
    $params = array();

    $contentTable = Engine_Api::_()->getDbtable('content', 'sitenewsletter');
    $content = $contentTable->fetchRow($contentTable->select()->from($contentTable->info('name'), array('template_id'))->where('content_id = ?', $this->view->identity));

    $templateTable = Engine_Api::_()->getDbtable('templateslayouts', 'sitenewsletter');
    $settings = $templateTable->fetchRow($templateTable->select()->from($templateTable->info('name'), array('fontsize', 'fontcolor'))->where('template_id = ?', $content->template_id));
    if (empty($settings->fontcolor) || empty($settings->fontsize)) {
        $font = 16;
        $color = '#000000';
      } else {
        $font = $settings->fontsize;
        $color = $settings->fontcolor;
      }
    $this->view->color = $color;
    $this->view->size = $font;

    $this->view->titleTruncation = $this->_getParam('titleTruncation', 16);

    $this->view->type = $type = $params['type'] = (string) $this->_getParam('type', null);
    $params['itemCount'] = $this->_getParam('itemCount', 10);

    $params['popularType'] = $this->_getParam('popularType', 'random');
    $params['interval'] = $interval = $this->_getParam('interval', 'week');
    switch ($params['popularType']) {
      case 'comment':
        $params['orderby'] = 'comment_count';
        break;
      case 'like':
        $params['orderby'] = 'like_count';
        break;
      case 'creation':
        $params['orderby'] = 'creation_date';
        break;
      case 'random':
        $params['orderby'] = 'random';
        break;
    }

    $this->view->params = $params;

    // Build base query
    $table = Engine_Api::_()->getDbtable('search', 'core');
    $tableName = $table->info('name');
    $db = $table->getAdapter();
    $select = $table->select()
            ->setIntegrityCheck(false)
            ->from($tableName);

    // Filter by item types
    $availableTypes = Engine_Api::_()->getItemTypes();
    if( $type && in_array($type, $availableTypes) ) {
      $select->where($tableName.'.type = ?', $type);
    } else {
      $select->where($tableName.'.type IN(?)', $availableTypes);
    }        

    $sqlTimeStr = '';
    $interval = '';
    if (isset($params['interval']) && !empty($params['interval'])) {
      $interval = $params['interval'];
      $current_time = date("Y-m-d H:i:s");
      if ($interval == 'week') {
        $time_duration = date('Y-m-d H:i:s', strtotime('-7 days'));
        $sqlTimeStr = ".creation_date BETWEEN " . "'" . $time_duration . "'" . " AND " . "'" . $current_time . "'";
      } elseif ($interval == 'month') {
        $time_duration = date('Y-m-d H:i:s', strtotime('-1 months'));
        $sqlTimeStr = ".creation_date BETWEEN " . "'" . $time_duration . "'" . " AND " . "'" . $current_time . "'" . "";
      }
    }
    $results = array();
    
      if (isset($params['orderby']) && !empty($params['orderby'])) {
      switch ($params['orderby']) {
        case 'like_count':
            $popularityTable = Engine_Api::_()->getDbtable('likes', 'core');
            $popularityTableName = $popularityTable->info('name');

            $select = $select->joinLeft($popularityTableName, $popularityTableName . '.resource_id = ' . $tableName . '.id', array("COUNT(resource_id) as total_count"));
            if (!empty($type)) {
              $select->where($popularityTableName . '.resource_type = ?', $type);
            }
            $select->order("total_count DESC");
          break;
        case 'comment_count':
            $popularityTable = Engine_Api::_()->getDbtable('comments', 'core');
            $popularityTableName = $popularityTable->info('name');

            $select = $select->joinLeft($popularityTableName, $popularityTableName . '.resource_id = ' . $tableName . '.id', array("COUNT(resource_id) as total_count"));
            if (!empty($type)) {
              $select->where($popularityTableName . '.resource_type = ?', $type);
            }
            $select->order("total_count DESC");

          if (($interval == 'week') || ($interval == 'month')) {
            $select->where($popularityTableName . "$sqlTimeStr");
          }
          break;
        case 'random':
          $select->order('Rand()');
          break;
      }
    }

    $select->limit($params['itemCount']);
    $this->view->results = $select->query()->fetchAll();

    if (count($select->query()->fetchAll()) <= 0) {
      return $this->setNoRender();
    }
  }
}