<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitenewsletter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitenewsletter_Widget_TemplateHeaderController extends Engine_Content_Widget_Abstract
{
  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()
      ->getApi('menus', 'core')
      ->getNavigation('newsletter_header');

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->view->header = $coreSettings->getSetting('sitenewsletter.header.enable', 1);
    
    $id = $coreSettings->getSetting('sitenewsletter.site.header.logo');
    $this->view->logo = $this->getPhotoUrl($id);
    $this->view->headersite = $coreSettings->getSetting('sitenewsletter.header.site', 0);
    $this->view->bg = $coreSettings->getSetting('sitenewsletter.header.background', 1);
  	$sitename = $coreSettings->getSetting('sitenewsletter.sitename');
  	$this->view->bgcolor = $coreSettings->getSetting('sitenewsletter.header.bgcolor', '#cccccc');
  	$bgimage_id = $coreSettings->getSetting('sitenewsletter.header.bgimage');
    $this->view->bgimage = $this->getPhotoUrl($bgimage_id);
    $this->view->color = $coreSettings->getSetting('sitenewsletter.header.color', '#000000');

  }

  public function getPhotoUrl($file_id, $type = null)
  {
    // $coreSettings = Engine_Api::_()->getApi('settings', 'core');
   
    if( empty($file_id) ) {
      return "no file id";
    }
    $file = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, $type);

    if( !$file ) {
      return "no file";
    }
    return $file->map();
  }
}