<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagealbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagealbum_Widget_ListPhotosTabsViewController extends Engine_Content_Widget_Abstract {

  public function indexAction() {
    $this->view->is_ajax = $is_ajax = $this->_getParam('isajax', '');
    $this->view->category_id = $category_id = $this->_getParam('category_id',0);
    $this->view->showViewMore = $this->_getParam('showViewMore', 1);
    if (empty($is_ajax)) {
      $this->view->tabs = $tabs = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitepagealbum', 'type' => 'photos', 'enabled' => 1));
      $count_tabs = count($tabs);
      if (empty($count_tabs)) {
        return $this->setNoRender();
      }
      $activeTabName = $tabs[0]['name'];
    }

    $this->view->marginPhoto = $this->_getParam('margin_photo', 12);
    $this->view->showLightBox = Engine_Api::_()->sitepage()->canShowPhotoLightBox();
    $tablePage = Engine_Api::_()->getDbtable('pages', 'sitepage'); 
    $tablePageName = $tablePage->info('name');
    $parentTable = Engine_Api::_()->getItemTable('sitepage_album');
    $parentTableName = $parentTable->info('name');
    $table = Engine_Api::_()->getItemTable('sitepage_photo');
    $tableName = $table->info('name');
    $select = $table->select()
										->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tablePageName, "$tablePageName.page_id = $tableName.page_id", array('title AS page_title', 'photo_id as page_photo_id'));
    $select = $select
              ->where($tablePageName . '.closed = ?', '0')
              ->where($tablePageName . '.approved = ?', '1')
              ->where($tablePageName . '.declined = ?', '0')
              ->where($tablePageName . '.draft = ?', '1');
    if(!empty($category_id)) {
      $select->where($tablePageName . '.	category_id =?', $category_id);
    }
    if (Engine_Api::_()->sitepage()->hasPackageEnable()) {
      $select->where($tablePageName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    if (!Engine_Api::_()->sitepage()->isLessThan417AlbumModule()) {
      $select->joinLeft($parentTableName, $parentTableName . '.album_id=' . $tableName . '.album_id', null);
    } else {
      $select->joinLeft($parentTableName, $parentTableName . '.album_id=' . $tableName . '.collection_id', null);
    }
    $select->where($parentTableName . '.search = ?', true);

    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepagealbum.hide.autogenerated', 1)) {
			$select->where($parentTableName. '.default_value'.'= ?', 0);
			$select->where($parentTableName . ".type is Null");
    } 

    $paramTabName = $this->_getParam('tabName', '');
    if (!empty($paramTabName))
      $activeTabName = $paramTabName;

    $activeTab = Engine_Api::_()->getItemTable('seaocore_tab')->getTabs(array('module' => 'sitepagealbum', 'type' => 'photos', 'enabled' => 1, 'name' => $activeTabName));

    $this->view->activTab = $activTab = $activeTab['0'];
    $type = null;
    switch ($activTab->name) {
      case 'recent_pagephotos':
        $type = 'creation_date';
        break;
      case 'liked_pagephotos':
        $type = 'like_count';
        $select->order($tableName . '.like_count DESC');
        break;
      case 'viewed_pagephotos':
        $type = 'view_count';
        $select->order($tableName . '.view_count DESC');
        break;
      case 'commented_pagephotos':
        $type = 'comment_count';
        $select->order($tableName . '.comment_count DESC');
        break;
      case 'featured_pagephotos':
        $type = 'featured';
        $select->where($tableName . '.featured = ?', 1);
        $select->order('Rand()');
        break;
      case 'random_pagephotos':
        $select->order('Rand()');
        break;
    }
    if ($activTab->name != 'featured_pagephotos' && $activTab->name != 'random_pagephotos') {
      $select->order($tableName . '.photo_id DESC');
    }

    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
//     if (($paginator->getTotalItemCount() <= 0)) {
//       return $this->setNoRender();
//     }
    $paginator->setItemCountPerPage($activTab->limit);
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));
    $this->view->count = $paginator->getTotalItemCount();
    $this->view->params = $params = array();
    if ($this->view->showLightBox && !empty($type)) {
      $this->view->params = $params = array('type' => $type, 'count' => $paginator->getTotalItemCount(), 'title' => $activTab->getTitle() . " Photos");
    }
    $this->view->canCreate = Engine_Api::_()->authorization()->isAllowed('sitepagealbum', null, 'create');
  }

}

?>