<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagealbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagealbum_Widget_ListPopularAlbumsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

    $category_id = $this->_getParam('category_id',0);
    // Should we consider views or comments popular?
    $popularType = $this->_getParam('popularType', 'comment');
    if (!in_array($popularType, array('comment', 'view', 'like'))) {
      $popularType = 'comment';
    }
    $this->view->popularType = $popularType;
    $this->view->popularCol = $popularCol = $popularType . '_count';
    //$popularAlbum = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitealbum.badgeviewer', null);
    // Get paginator
    $tablePage = Engine_Api::_()->getDbtable('pages', 'sitepage');
    $tablePageName = $tablePage->info('name');
    $table = Engine_Api::_()->getItemTable('sitepage_album');
    $tableName = $table->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($tableName)
                    ->joinLeft($tablePageName, "$tablePageName.page_id = $tableName.page_id", array('title AS page_title', 'photo_id as page_photo_id'))
                    ->order($popularCol . ' DESC');
    $select = $select
              ->where($tablePageName . '.closed = ?', '0')
              ->where($tablePageName . '.approved = ?', '1')
              ->where($tablePageName . '.declined = ?', '0')
              ->where($tablePageName . '.draft = ?', '1');
    if(!empty($category_id)) {
      $select->where($tablePageName . '.	category_id =?', $category_id);
    }
    if (Engine_Api::_()->sitepage()->hasPackageEnable()) {
      $select->where($tablePageName . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }  

    if(!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepagealbum.hide.autogenerated', 1) ) {
			$select->where($tableName. '.default_value'.'= ?', 0);
			$select->where($tableName . ".type is Null");
    } 

    //if (!Engine_Api::_()->sitealbum()->canShowSpecialAlbum())
      //$select->where('type IS NULL');
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);

    // Set item count per page and current page number
    $paginator->setItemCountPerPage($this->_getParam('itemCountPerPage', 4));
    $paginator->setCurrentPageNumber($this->_getParam('page', 1));

    // Do not render if nothing to show
    if (($paginator->getTotalItemCount() <= 0)) {
      return $this->setNoRender();
    }
  }

}