<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagetwitter
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingscontroller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagetwitter_Form_Admin_Global extends Engine_Form
{
  public function init()
  {
    // Set form attributes
    $this->setTitle('Global Settings');

    //GET DECORATORS
    $this->loadDefaultDecorators();

    //GET DESCRIPTION
    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Please %1sclick here%2s to generate the code for Twitter Profile Widgets of Pages on your site. If you have placed the Twitter Updates widget in the Tabbed container on Page Profile, then the suggested dimensions are: W1 X H1 pixels; for widget location in sidebar, the suggested dimensions are: W2 X H2 pixels. Paste the generated code in the below text-area."), '<a href="https://twitter.com/about/resources/widgets/widget_profile" target="_blank">', '</a>');

    // init site description
    $this->addElement('Textarea', 'sitepagetwitter_feeds_code', array(
      'label' => 'Twitter Profile Widget Code',
      'description' => $description,
      'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepagetwitter.feeds.code'),
    ));
    $this->sitepagetwitter_feeds_code->getDecorator('Description')->setOptions(array('placement'=> 'PREPEND', 'escape' => false));

    //Add submit button
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}

?>