<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Add.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitepagewishlist_Form_Add extends Engine_Form {

  public function init() {

    $this->setTitle('Add To Wish Lists')
				->setDescription('Select your Wish Lists to which you want to add this Page. You can also create a new Wish List below.')
				->setAttrib('id', 'form-upload-wishlist')
				->setAttrib('enctype', 'multipart/form-data')
				->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

		$page_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('page_id', null);
    $wishlistIdsDatas = Engine_Api::_()->getDbtable('pages', 'sitepagewishlist')->pageWishlists($page_id);

    if (!empty($wishlistIdsDatas)) {
      $wishlistIdsDatas = $wishlistIdsDatas->toArray();
      $wishlistIds = array();
      foreach ($wishlistIdsDatas as $wishlistIdsData) {
        $wishlistIds[] = $wishlistIdsData['wishlist_id'];
      }
    }

    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $wishlistDatas = Engine_Api::_()->getDbtable('wishlists', 'sitepagewishlist')->getUserWishlists($viewer_id);

    if (!empty($wishlistDatas)) {
      foreach ($wishlistDatas as $wishlistData) {
        if (in_array($wishlistData->wishlist_id, $wishlistIds)) {
          $this->addElement('Checkbox', 'inWishlist_' . $wishlistData->wishlist_id, array(
              'label' => $wishlistData->title,
              'value' => 1,
          ));
        } else {
          $this->addElement('Checkbox', 'wishlist_' . $wishlistData->wishlist_id, array(
              'label' => $wishlistData->title,
              'value' => 0,
          ));
        }
      }

      $this->addElement('Checkbox', 'wishlist_new', array(
          'decorators' => array('ViewHelper', array('Label', array('placement' => 'APPEND'),
                  array('HtmlTag', array('tag' => 'div', 'style' => 'float:left;'))))
      ));

      $this->addElement('Text', 'wishlist_new_title', array(
          'value' => 'My New Wish List',
          'title' => 'Enter the name of your Wish List. You will next be able to choose its privacy.',
          'decorators' => array('ViewHelper',
              array('HtmlTag', array('tag' => 'div', 'style' => 'float:left;')))
      ));

      $this->addDisplayGroup(array('wishlist_new', 'wishlist_new_title'), 'group');
      $button_group = $this->getDisplayGroup('group');
      $button_group->setDecorators(array(
          'FormElements',
          'Fieldset',
          array('HtmlTag', array('tag' => 'div', 'style' => 'width:100%;;float:left;'))
      ));
    }

    $this->addElement('Button', 'submit', array(
        'label' => 'Save',
        'ignore' => true,
        'decorators' => array('ViewHelper'),
        'type' => 'submit'
    ));

    $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
    $url = $view->url(array('page_url' => Engine_Api::_()->sitepage()->getPageUrl($page_id)), 'sitepage_entry_view', true);

    $this->addElement('Cancel', 'cancel', array(
        'prependText' => ' or ',
        'label' => 'cancel',
        'link' => true,
        'href' => $url,
        'decorators' => array(
            'ViewHelper'
        ),
    ));

    $this->addDisplayGroup(array(
        'submit',
        'cancel'
            ), 'buttons', array(
        'decorators' => array(
            'FormElements',
            'DivDivDivWrapper',
        ),
    ));
  }

}
?>