<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Level.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepagewishlist_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract {

  public function init() {
    parent::init();

    $this->setTitle('Member Level Settings')
				->setDescription('These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level below.');

    $this->addElement('Radio', 'view', array(
        'label' => 'Allow Viewing of Wish lists?',
        'description' => 'Do you want to let members view wish lists?',
        'multiOptions' => array(
            2 => 'Yes, allow members to view all wish lists, even private ones.',
            1 => 'Yes, allow viewing of wish lists.',
            0 => 'No, do not allow wish lists to be viewed.',
        ),
        'value' => ( $this->isModerator() ? 2 : 1 ),
    ));

    if (!$this->isModerator()) {
      unset($this->view->options[2]);
    }

    if (!$this->isPublic()) {

      $this->addElement('MultiCheckbox', 'auth_view', array(
          'label' => 'Wish Lists View Privacy',
          'description' => 'Do you want to let members view wish lists? This is useful if you want members to be able to view wish lists, but only certain levels to be able to view wish lists.',
          'multiOptions' => array(
              'everyone' => 'Everyone',
              'registered' => 'All Registered Members',
              'owner_network' => 'Friends and Networks',
              'owner_member_member' => 'Friends of Friends',
              'owner_member' => 'Friends Only',
              'owner' => 'Just Me'
          )
      ));
    }
  }

}
?>