<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Wishlists.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitepagewishlist_Model_DbTable_Wishlists extends Engine_Db_Table {

  protected $_rowClass = 'Sitepagewishlist_Model_Wishlist';


	public function dashboardWishlists($page_id) {

		//RETURN IF PAGE ID IS EMPTY
		if(empty($page_id)) {
			return;
		}

		//GET WISHLIST PAGE TABLE
		$wishlistPageTable = Engine_Api::_()->getDbtable('pages', 'sitepagewishlist');
		$wishlistPageTableName = $wishlistPageTable->info('name');

		//GET WISHLIST TABLE NAME
		$wishlistTableName = $this->info('name');

		//MAKE QUERY
		$select = $this->select()
									->setIntegrityCheck(false)
									->from($wishlistTableName)
									->join($wishlistPageTableName, "$wishlistPageTableName.wishlist_id = $wishlistTableName.wishlist_id", array('page_id'))
									->where($wishlistPageTableName.'.page_id = ?', $page_id);

		//RETURN RESULTS
		return Zend_Paginator::factory($select);
	}

	public function userWishlists($viewer_id, $pagination = 0, $total_item = 0) {

		//RETURN IF VIEWER ID IS EMPTY
		if(empty($viewer_id)) {
			return;
		}

		//GET WISHLIST PAGE TABLE
		$wishlistPageTable = Engine_Api::_()->getDbtable('pages', 'sitepagewishlist');
		$wishlistPageTableName = $wishlistPageTable->info('name');

		//GET WISHLIST TABLE
		$wishlistTableName = $this->info('name');

		//MAKE QUERY
		$select = $this->select()
										->setIntegrityCheck(false)
										->from($wishlistTableName)
										->joinLeft($wishlistPageTableName, "$wishlistPageTableName.wishlist_id = $wishlistTableName.wishlist_id", array("COUNT($wishlistPageTableName.wishlist_id) AS total_item"))
										->where('owner_id = ?', $viewer_id)
										->group($wishlistTableName . '.wishlist_id')
										->order('wishlist_id DESC');

		//RETURN RESULTS
		if(!empty($pagination)) {
			return Zend_Paginator::factory($select);
		}
		else {
			if(!empty($total_item)) {
				$select = $select->limit($total_item);
			}
			return $this->fetchAll($select);
		}
	}

	public function getUserWishlists($viewer_id) {

		//RETURN IF VIEWER ID IS EMPTY
		if(empty($viewer_id)) {
			return;
		}

		//MAKE QUERY
		$select = $this->select()->where('owner_id = ?', $viewer_id);

		//RETURN RESULTS
    return $this->fetchAll($select);
	}
}
?>