<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManage.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitepagewishlist_AdminManageController extends Core_Controller_Action_Admin {

  //ACTION FOR MANAGE PLAYLISTS
  public function manageAction() {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitepagewishlist_admin_main', array(), 'sitepagewishlist_admin_main_manage');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Sitepagewishlist_Form_Admin_Manage_Filter();

    //GET CURRENT PAGE NUMBER
    $page = $this->_getParam('page', 1);

    //GET USER TABLE NAME
    $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');

		//GET WISHLIST PAGE TABLE
    $wishlistPageTable = Engine_Api::_()->getDbtable('pages', 'sitepagewishlist');
    $wishlistPageTableName = $wishlistPageTable->info('name');

    //MAKE QUERY
    $tableWishlist = Engine_Api::_()->getDbtable('wishlists', 'sitepagewishlist');
    $tableWishlistName = $tableWishlist->info('name');
    $select = $tableWishlist->select()
                    ->setIntegrityCheck(false)
                    ->from($tableWishlistName)
                    ->joinLeft($wishlistPageTableName, "$wishlistPageTableName.wishlist_id = $tableWishlistName.wishlist_id", array("COUNT($wishlistPageTableName.wishlist_id) AS total_item"))
                    ->joinLeft($tableUserName, "$tableWishlistName.owner_id = $tableUserName.user_id", 'username')
                    ->group($tableWishlistName . '.wishlist_id');

    //GET VALUES
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array('order' => 'wishlist_id', 'order_direction' => 'DESC'), $values);

		if(!empty($_POST['user_name'])) { $user_name = $_POST['user_name']; } elseif(!empty($_GET['user_name']) && !isset($_POST['post_search'])) { $user_name = $_GET['user_name']; }  else { $user_name = '';}

		if(!empty($_POST['wishlist_name'])) { $wishlist_name = $_POST['wishlist_name']; } elseif(!empty($_GET['wishlist_name'])  && !isset($_POST['post_search'])) { $wishlist_name = $_GET['wishlist_name']; } else { $wishlist_name = '';}

		if(!empty($_POST['page_name'])) { $page_name = $_POST['page_name']; } elseif(!empty($_GET['page_name'])  && !isset($_POST['post_search'])) { $page_name = $_GET['page_name']; } elseif($this->_getParam('page_name', '') && !isset($_POST['post_search'])) { $page_name = $this->_getParam('page_name', '');} else { $page_name = '';}

		//SEARCHING
    $this->view->user_name = $values['user_name'] = $user_name;
    $this->view->wishlist_name = $values['wishlist_name'] = $wishlist_name;
		$this->view->page_name = $values['page_name'] = $page_name;

		if (!empty($user_name)) {
			$select->where($tableUserName . '.username  LIKE ?', '%' . $user_name . '%');
		}
		if (!empty($wishlist_name)) {
			$select->where($tableWishlistName . '.title  LIKE ?', '%' . $wishlist_name . '%');
		}
		if (!empty($page_name)) {
			$tablePageName = Engine_Api::_()->getDbTable('pages', 'sitepage')->info('name');
			$select->joinLeft($tablePageName, "$wishlistPageTableName.page_id = $tablePageName.page_id", array('title AS page_title'))
							->where($tablePageName.'.title  LIKE ?', '%' . $page_name . '%');
		}

    //ASSIGN VALUES TO THE TPL
		$this->view->formValues = array_filter($values);
    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'wishlist_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //GET PAGINATOR
    $this->view->paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(100);
    $this->view->paginator->setCurrentPageNumber($page);
  }

 //ACTION FOR SHOWING PAGES WHICH ARE ADDED IN WISHLISTS
  public function favouritePagesAction() {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitepagewishlist_admin_main', array(), 'sitepagewishlist_admin_main_favourite');

    //FORM GENERATION  
    $this->view->formFilter = $formFilter = new Sitepagewishlist_Form_Admin_Manage_Filter();

    //GET CURRENT PAGE NUMBER
    $page = $this->_getParam('page', 1);

		//PAGE TABLE
		$pageTable = Engine_Api::_()->getDbtable('pages', 'sitepage');
    $pageTableName = $pageTable->info('name');

		//GET WISHLIST PAGE TABLE
    $wishlistPageTable = Engine_Api::_()->getDbtable('pages', 'sitepagewishlist');
    $wishlistPageTableName = $wishlistPageTable->info('name');

    //MAKE QUERY
    $select = $pageTable->select()
                    ->setIntegrityCheck(false)
                    ->from($pageTable, array('page_id', 'title', 'page_url'))
                    ->joinLeft($wishlistPageTableName, "$pageTableName.page_id = $wishlistPageTableName.page_id", array("COUNT($wishlistPageTableName.wishlist_id) AS total_item"))
                    ->group($wishlistPageTableName . '.page_id');

    //SET VALUES
    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }

    foreach ($values as $key => $value) {
      if (null === $value) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array('order' => 'total_item', 'order_direction' => 'DESC'), $values);

    //ASSIGN VALUES TO THE TPL
		$this->view->formValues = array_filter($values);
    $this->view->assign($values);

    $select->order((!empty($values['order']) ? $values['order'] : 'total_item' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //GET PAGINATOR
    $this->view->paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(50);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  //ACTION FOR DELETE THE WISHLIST
  public function deleteAction() {

		//SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

		//GET WISHLIST ID
    $this->view->wishlist_id = $wishlist_id = $this->_getParam('wishlist_id');

    if ($this->getRequest()->isPost()) {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();
      try {

				//DELETE WISHLIST CONTENT
				Engine_Api::_()->sitepagewishlist()->deleteContent($wishlist_id);

        $db->commit();
      } catch (Exception $e) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('')
      ));
    }
    $this->renderScript('admin-manage/delete.tpl');
  }

  //ACTION FOR MULTI DELETE WISHLIST
  public function multiDeleteAction() {

    if ($this->getRequest()->isPost()) {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key => $value) {
        if ($key == 'delete_' . $value) {

          //GET WISHLIST ID
          $wishlist_id = (int) $value;

					//DELETE WISHLIST CONTENT
          Engine_Api::_()->sitepagewishlist()->deleteContent($wishlist_id);
        }
      }
    }
    return $this->_helper->redirector->gotoRoute(array('action' => 'manage'));
  }

}
?>