<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettings.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitepagewishlist_AdminSettingsController extends Core_Controller_Action_Admin {

  //ACTION FOR GLOBAL SETTINGS
  public function indexAction() {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitepagewishlist_admin_main', array(), 'sitepagewishlist_admin_main_settings');

		//FORM GENERATION
    $this->view->form = $form = new Sitepagewishlist_Form_Admin_Settings_Global();

		//SAVE VALUES
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();
      foreach ($values as $key => $values) {
        if ($key != 'submit') {
          Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $values);
        }
      }
      $this->_helper->redirector->gotoRoute(array('route' => 'admin-default', 'action' => 'index', 'controller' => 'settings'));
    }
  }

	//ACTION FOR LEVEL SETTINGS
  public function levelAction() {

		//GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitepagewishlist_admin_main', array(), 'sitepagewishlist_admin_main_level');

    //GET LEVEL OBJECT
    if (null !== ($id = $this->_getParam('id'))) {
      $level = Engine_Api::_()->getItem('authorization_level', $id);
    } else {
      $level = Engine_Api::_()->getItemTable('authorization_level')->getDefaultLevel();
    }

    if (!$level instanceof Authorization_Model_Level) {
      throw new Engine_Exception('missing level');
    }

    //GET LEVEL ID
    $level_id = $id = $level->level_id;

    //FORM GENERATION
    $this->view->form = $form = new Sitepagewishlist_Form_Admin_Settings_Level(array(
                'public' => ( in_array($level->type, array('public')) ),
                'moderator' => ( in_array($level->type, array('admin', 'moderator')) ),
            ));

		//SET LEVEL ID IN FORM
    $form->level_id->setValue($level_id);

		//GET PERMISSION TABLE
    $permissionsTable = Engine_Api::_()->getDbtable('permissions', 'authorization');
    $form->populate($permissionsTable->getAllowed('sitepagewishlist_wishlist', $level_id, array_keys($form->getValues())));

    //FORM VALIDATION
    if (!$this->getRequest()->isPost() || !$form->isValid($this->getRequest()->getPost())) {
      return;
    }

    //GET VALUES FROM FORM
    $values = $form->getValues();

    $db = $permissionsTable->getAdapter();
    $db->beginTransaction();

    try {
      //SET PERMISSIONS
      if (isset($values['auth_comment'])) {
        $values['auth_view'] = (array) @$values['auth_view'];
      }

      $permissionsTable->setAllowed('sitepagewishlist_wishlist', $level_id, $values);

      //COMMIT
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    $form->addNotice('Your changes have been saved.');
  }

  //ACTION FOR FAQ
  public function faqAction() {

    //GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitepagewishlist_admin_main', array(), 'sitepagewishlist_admin_main_faq');
  }

  public function readmeAction() {
    
  }

}
?>