<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepagewishlist
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: manifest.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

return array(
    'package' =>
    array(
        'type' => 'module',
        'name' => 'sitepagewishlist',
        'version' => '5.4.1',
        'path' => 'application/modules/Sitepagewishlist',
        'title' => 'Directory / Pages - Wish Lists Extension',
        'description' => 'Directory / Pages - Wish Lists Extension',
      'author' => '<a href="http://www.socialapps.tech" style="text-decoration:underline;" target="_blank">SocialApps.tech</a>',
        'callback' =>
        array(
            'class' => 'Engine_Package_Installer_Module',
        ),
        'actions' =>
        array(
            0 => 'install',
            1 => 'upgrade',
            2 => 'refresh',
            3 => 'enable',
            4 => 'disable',
        ),
        'callback' => array(
            'path' => 'application/modules/Sitepagewishlist/settings/install.php',
            'class' => 'Sitepagewishlist_Installer',
        ),
        'directories' =>
        array(
            0 => 'application/modules/Sitepagewishlist',
        ),
        'files' =>
        array(
            0 => 'application/languages/en/sitepagewishlist.csv',
        ),
    ),
    // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteBefore',
            'resource' => 'Sitepagewishlist_Plugin_Core',
        ),
    ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitepagewishlist_wishlist'
    ),
    // Routes --------------------------------------------------------------------
    'routes' => array(
        'sitepagewishlist_general' => array(
            'route' => 'wishlists/:action/*',
            'defaults' => array(
                'module' => 'sitepagewishlist',
                'controller' => 'index',
								'action' => 'browse'
            ),
            'reqs' => array(
                'action' => '(browse|manage|create|edit|remove|dashboard-wishlist)',
            ),
        ),
        'sitepagewishlist_view' => array(
            'route' => 'wishlists/view/:wishlist_id/:slug',
            'defaults' => array(
                'module' => 'sitepagewishlist',
                'controller' => 'index',
                'action' => 'view',
                'slug' => '',
            ),
            'reqs' => array(
                'wishlist_id' => '\d+'
            )
        ),
    ),
);
?>