<?php
/**
* SocialEngine
*
* @category Application_Extensions
* @package Sitepoll
* @copyright Copyright 2019-2020 BigStep Technologies Pvt. Ltd.
* @license http://www.socialengineaddons.com/license/
* @version 2019-08-10 9:40:21Z SocialEngineAddOns $
* @author SocialEngineAddOns
*/
class Sitepoll_AdminManageController extends Core_Controller_Action_Admin {
	public function indexAction() {
    //GET NAVIGATION
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
		->getNavigation('sitepoll_admin_main', array(), 'sitepoll_admin_main_manage');

		if ($this->getRequest()->isPost()) {
			$values = $this->getRequest()->getPost();
			foreach ($values as $key => $value) {
				if ($key == 'delete_' . $value) {
					$poll = Engine_Api::_()->getItem('sitepoll_poll', $value);
					if(!empty($poll))
						$poll->delete();
				}
			}
		}


    //FORM GENERATION
		$this->view->formFilter = $formFilter = new Sitepoll_Form_Admin_Manage_Filter();

    //GET POLL ID
		$page = $this->_getParam('page', 1);

    //MAKE QUERY
		$tableUser = Engine_Api::_()->getItemTable('user')->info('name');

		$tablePoll = Engine_Api::_()->getDbtable('polls', 'sitepoll');
		$tablePollName = $tablePoll->info('name');

		$select = $tablePoll->select()
		->setIntegrityCheck(false)
		->from($tablePollName)
		->joinLeft($tableUser, "$tablePollName.parent_id = $tableUser.user_id", 'username');

		$values = array();

		if ($formFilter->isValid($this->_getAllParams())) {
			$values = $formFilter->getValues();
		}
		foreach ($values as $key => $value) {

			if (null == $value) {
				unset($values[$key]);
			}
		}

    	//SEARCHING
		$this->view->owner = '';
		$this->view->title = '';
		$this->view->sponsored = '';
		$this->view->approved = '';
		$this->view->featured = '';
		$this->view->status = '';
		$this->view->pollbrowse = '';
		$this->view->category_id = '';

		

		$values = array_merge(array(
			'order' => 'poll_id',
			'order_direction' => 'DESC',
		), $values);

    	//GET USERNAME
		if (!empty($_POST['owner'])) {
			$user_name = $_POST['owner'];
		} elseif (!empty($_GET['owner'])) {
			$user_name = $_GET['owner'];
		} else {
			$user_name = '';
		}

    //GET TITLE
		if (!empty($_POST['title'])) {
			$poll_name = $_POST['title'];
		} elseif (!empty($_GET['title'])) {
			$poll_name = $_GET['title'];
		} elseif ($this->_getParam('title', '')) {
			$poll_name = $this->_getParam('title', '');
		} else {
			$poll_name = '';
		}

    //SEARCHING
		$this->view->owner = $values['owner'] = $user_name;
		$this->view->title = $values['title'] = $poll_name;

		if (!empty($poll_name)) {
			$select->where($tablePollName . '.title  LIKE ?', '%' . $poll_name . '%');
		}

		if (!empty($user_name)) {
			$select->where($tableUser . '.displayname  LIKE ?', '%' . $user_name . '%');
		}

		if (isset($_POST['search'])) {

			if (!empty($_POST['sponsored'])) {
				$this->view->sponsored = $_POST['sponsored'];
				$_POST['sponsored']--;

				$select->where($tablePollName . '.sponsored = ? ', $_POST['sponsored']);
			}

      		// FINDING STATUS
			if (!empty($_POST['poll_status'])) {

				$this->view->poll_status = $_POST['poll_status'];
				switch ($this->view->poll_status) {
					case 1:
					$select->where($tablePollName . '.approve_date  IS NULL');
					break;
					case 2:
					$select->where($tablePollName . '.status = ? ', 'Active')
					->where($tablePollName . '.approved = ? ', 1)
					->where($tablePollName . '.declined  = ? ', 0);

					break;
					case 3:
					$select->where($tablePollName . '.approve_date  IS NOT NULL');
					$select->where($tablePollName . '.approved = ? ', 0)
					->where($tablePollName . '.declined  = ? ', 0);
					break;
					case 4:
					$select->where($tablePollName . '.declined  = ? ', 1);
					break;
				}
			}
		}
		if (!empty($_POST['featured'])) {
			$this->view->featured = $_POST['featured'];
			$_POST['featured']--;
			$select->where($tablePollName . '.featured = ? ', $_POST['featured']);
		}
		if (!empty($_POST['status'])) {
			$this->view->status = $_POST['status'];
			$_POST['status']--;
			$select->where($tablePollName . '.is_closed = ? ', $_POST['status']);
		}

		$this->view->formValues = array_filter($values);
		$this->view->assign($values);

		$select->order((!empty($values['order']) ? $values['order'] : 'poll_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

		
    	//MAKE PAGINATOR
		$this->view->paginator = $paginator = Zend_Paginator::factory($select);
		$this->view->paginator->setItemCountPerPage(50);
		$this->view->paginator = $paginator->setCurrentPageNumber($page);
	}

  	//DELETE ACTION FOR ADMIN
	public function deleteAction(){
    	// In smoothbox
		$this->_helper->layout->setLayout('admin-simple');
		$id = $this->_getParam('id');
		$poll_id=$this->_getParam('id');
		$this->view->poll_id=$id;

		// get item
		$poll=Engine_Api::_()->getItem('sitepoll_poll', $poll_id);
		// Get Viewer
		$viewer = Engine_Api::_()->user()->getViewer();
		// Get Owner
		$owner = Engine_Api::_()->getItem("user" , $poll->user_id);
			
    	// Check post
		if( $this->getRequest()->isPost() ) {
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();

			$option = Engine_Api::_()->getDbtable('polls', 'sitepoll');
			$report = Engine_Api::_()->getDbtable('reports', 'sitepoll');
			try {
				$defaultParams = array(
					'ssl' => ( _ENGINE_SSL ? 'https://' : 'http://' ),
                    'host' => $_SERVER['HTTP_HOST'],
                    'email' => $owner->email,
                     'title'=>$poll['title']
                 );
                Engine_Api::_()->getApi('mail', 'core')->sendSystem($viewer, 'notify_sitepoll_poll_delete',$defaultParams);
				$poll = Engine_Api::_()->getItem('sitepoll_poll', $id);
				$pku=$poll['title'];
				$viewer = Engine_Api::_()->user()->getViewer();
				$owner = Engine_Api::_()->getItem("user" , $poll->user_id);
				$poll->delete();

				Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($owner, $viewer, $viewer, 'sitepoll_poll_delete');
				$db->commit();
			}

			catch( Exception $e ){
				$db->rollBack();
				throw $e;
			}

			$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRefresh'=> 10,
				'messages' => array('')
			));
		}

    // Output
		$this->renderScript('admin-manage/delete.tpl');
	}

  //VIEW POLL DETAIL
	public function detailAction() {

		$id = $this->_getParam('id');

    //DATA FROM POLL TABLE
		$tablePoll = Engine_Api::_()->getDbtable('polls', 'sitepoll');
		$tablePollName = $tablePoll->info('name');

		$select = $tablePoll->select()
		->setIntegrityCheck(false)
		->from($tablePollName)
		->where($tablePollName . '.poll_id = ?', $id)
		->limit(1);
		$this->view->sitepollDetail = $detail = $tablePoll->fetchRow($select);
		$this->view->category_id = $category_id = $detail['category_id'];
		$row = Engine_Api::_()->getDbTable('categories', 'sitepoll')->getCategory($category_id);
		if (!empty($row->category_name)) {
			$this->view->category_name = $row->category_name;
		}  
	}

  	// ACTION FOR WINNER
	public function winnerAction() {
		$translate = Zend_Registry::get('Zend_Translate');
		$poll_id=$this->_getParam('id');

    	// DATA FROM OPTION TABLE
		$options=Engine_Api::_()->getDbtable('options','sitepoll')->getpollOption($poll_id);
		$img_path=array();
		$text_option=array();
		$option_id=array();
		$votes=array();
		foreach($options as $option) {
			$text=$option['poll_option'];
			$text_option[]=$text;
			$votes[]=$option['votes'];
			$option_id[]=$option['option_id'];
			if($option['photo_option']!=0) {
				$photo_id=$option['photo_option'];
				$storage_file = Engine_Api::_()->getItem('storage_file', $photo_id);
				$src=$storage_file->map();
				$img_path[]=$src;
			}
		}

    // TO CALCULATE MAX VOTE
		$max=max($votes);
		$sum=array_sum($votes);
		$sum=array_sum($votes);
		$optionArray=array();
		$optionSrc=array();
		$optionVotes=array();
		foreach($votes as $key=>$vote) {
			if($vote==$max && $max!=0) {
				if(!empty($text_option[$key])) {
					$optionArray[]=$text_option[$key];
					unset($text_option[$key]);
				}
				$optionVotes[]=$votes[$key];
				unset($votes[$key]);
				if(!empty($img_path)){
					$optionSrc[]=$img_path[$key];
					unset($img_path[$key]);
				}
			}
			$arr2 = array_values($text_option);
			$img2= array_values($img_path);
			$votes2= array_values($votes);
		}
		
   // TO SEND DATA TO tpl
		$this->view->option_id=$option_id;
		$this->view->sum=$sum;
		$this->view->text_option=$arr2;
		$this->view->img_path=$img2;
		$this->view->optionVotes=$optionVotes;
		$this->view->votes=$votes2;
		$this->view->optionArray=$optionArray;
		$this->view->optionSrc=$optionSrc;
		$this->view->max=$max;
		
	}
}
