<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Fcm.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Form_Admin_Fcm extends Engine_Form {

    public function init() {
        // Set time zone
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);

        $this
                ->setTitle('FCM Configuration')
                ->setDescription('Below, you can configure FCM settings to start sending browser push notifications for your website. To do so, please create a project from <a href="https://firebase.google.com/?pli=1" target="_blank"> FCM Developer </a> page, and fill the below fields. <br><br>
			Go to this URL for steps to configure FCM on your SocialEngine website: <a href="https://youtu.be/eI0-sE6IqAU" target="_blank">https://youtu.be/eI0-sE6IqAU</a>');

        $this->loadDefaultDecorators();
        $this->getDecorator('Description')->setOption('escape', false);

        $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $URL = $view->baseUrl() . "/admin/files";

        $desc_apikey = sprintf('Enter ‘Project Server Key’ you get while registering firebase project for your website.');
        $this->addElement('Text', 'sitepushnotification_apikey', array(
            'label' => 'Project Server Key',
            'description' => $desc_apikey,
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.apikey', ''),
        ));
        $this->sitepushnotification_apikey->getDecorator('Description')->setOptions(array('placement' =>
            'PREPEND', 'escape' => false));

        $desc_fcmauth = sprintf(' Enter the snippet you get while registering firebase project for your website.');
        $this->addElement('Textarea', 'sitepushnotification_fcmauth', array(
            'label' => 'Firebase Snippet',
            'description' => $desc_fcmauth,
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitepushnotification.fcmauth', ''),
        ));
        $this->sitepushnotification_fcmauth->getDecorator('Description')->setOptions(array('placement' =>
            'PREPEND', 'escape' => false));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}
