<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Search.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Form_Admin_Search extends Engine_Form {

    public function init() {
        // Set time zone
        $timezone = Engine_Api::_()->getApi('settings', 'core')->core_locale_timezone;
        date_default_timezone_set($timezone);

        $this->setAttrib('class', 'global_form_box');

        //SPECIFIC USERS SELECT
        $this->addElement('Text', 'users_data', array(
            'label' => 'Choose Users',
            'autocomplete' => 'off'));

        Engine_Form::addDefaultDecorators($this->users_data);

        // Init to Values
        $this->addElement('Hidden', 'toValues', array(
             'order' => 900,
            'validators' => array(
                'NotEmpty'
            ),
            'filters' => array(
                'HtmlEntities'
            ),
        ));
        Engine_Form::addDefaultDecorators($this->toValues);

        $usertype = array('all_users' => 'All Subscribers',
            'logged_in' => 'Logged in Subscribers',
            'non_loggedin' => Engine_Api::_()->getApi('core', 'sitepushnotification')->translateType('non_loggedin')
        );

        // Search by user type
        $this->addElement('Select', 'usertype', array(
            'label' => 'Browse By',
            'multiOptions' => $usertype,
            'value' => 'all_users'
        ));

        $delivered = array('all_notifications' => 'All Notifications',
            'unsent_notifications' => 'Unsent Notifications',
            'sent_notifications' => 'Sent Notifications'
        );

        // Search by user type
        $this->addElement('Select', 'delivered', array(
            'label' => 'Browse By Notifications',
            'multiOptions' => $delivered,
            'value' => 'all_notifications'
        ));


        // Form field for selecting time duration of sent notifications
        $min_time = new Engine_Form_Element_CalendarDateTime('min_time');
        $min_time->useMilitaryTime;
        $min_time->setLabel("Select min date");
        $min_time->setValue('2016-01-01 14:00:00');
        $min_time->setAllowEmpty(false);
        $this->addElement($min_time);

        // Form field for selecting time duration of sent notifications
        $max_time = new Engine_Form_Element_CalendarDateTime('max_time');
        $max_time->useMilitaryTime;
        $max_time->setLabel("Select max date");
        $max_time->setValue(date("Y-m-d H:i:s"));
        $max_time->setAllowEmpty(false);
        $this->addElement($max_time);

        $this->addElement('Button', 'search', array(
            'label' => 'Search',
            'type' => 'submit',
        ));
    }

}
