<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Logo.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Form_Admin_Widget_Logo extends Engine_Form
{
  public function init()
  {
    parent::init();
    
    // Set form attributes
    $this
      ->setTitle('Browser Push Notifications')
      ->setDescription('Displays browser push notification pop-up for users to be able to subscribe the push notification service.');

    // Get available files
    $logoOptions = array('' => 'Default logo');
    $imageExtensions = array('gif', 'jpg', 'jpeg', 'png');

    $it = new DirectoryIterator(APPLICATION_PATH . '/public/admin/');
    foreach( $it as $file ) {
      if( $file->isDot() || !$file->isFile() ) continue;
      $basename = basename($file->getFilename());
      if( !($pos = strrpos($basename, '.')) ) continue;
      $ext = strtolower(ltrim(substr($basename, $pos), '.'));
      if( !in_array($ext, $imageExtensions) ) continue;
      $logoOptions['public/admin/' . $basename] = $basename;
    }

    $label = sprintf(Zend_Registry::get('Zend_Translate')->_("Site Logo for Push Notification <br/>[Note: You can upload the site logo from <a href=\"admin/files\" target=\"_parent\">File Media Manager</a>.]"));
    $this->addElement('Select', 'push_logo', array(
      'label' => $label,
      'multiOptions' => $logoOptions,
    ));
    $this->push_logo->addDecorator('Label', array('placement' => 'PREPEND', 'class' => 'optional', 'escape' => false));
  }
}