<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitepushnotification
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Notifications.php 6590 2016-3-3 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitepushnotification_Model_DbTable_Notifications extends Engine_Db_Table {
    protected $_rowClass = 'Sitepushnotification_Model_Notification';
    public function getNotificationsSelect($params = array(), $select = null) {

        $table = Engine_Api::_()->getDbtable('notifications', 'sitepushnotification');
        $rName = $table->info('name');

        $select = $table->select()
                ->order(!empty($params['orderby']) ? $params['orderby'] . ' DESC' : $rName . '.creation_date DESC' );

        return $select;
    }

    public function getNotificationsPaginator($params = array(), $select = null) {
        $paginator = Zend_Paginator::factory($this->getNotificationsSelect($params));
        return $paginator;
    }

    public function getNotificationData($device_id) {
        $rName = $this->info('name');
        $select = $this->select('payload')
                ->where($rName . '.device_id = ?', $device_id)
                ->where($rName . '.delivered = ?', '0')
                ->limit(5)
                ->query();

        $result = $select->fetchAll();
        return $result;
    }

    public function updateNotificationStatus($device_id) {
        $this->update(
                array('delivered' => '1',), array('`device_id` = ? ' => $device_id));
    }

    public function getUsers($text, $limit) {

        $userTable = Engine_Api::_()->getDbtable('users', 'user');
        $userTableName = $userTable->info('name');
        $notificationTableName = $this->info('name');
        $select = $userTable->select()
                ->from($userTableName)
                ->join($notificationTableName, $userTableName . '.user_id = ' . $notificationTableName . '.uid', null);
        $titleColumn = Engine_Api::_()->getApi('core', 'sitepushnotification')->getUserTitleColumn();
        
        if (null !== $text)
            $select->where('`' . $userTableName . "`.`$titleColumn` LIKE ?", '%' . $text . '%');

        if (0 < ($limit))
            $select->limit($limit);

        $select->group($userTableName . '.user_id');

        return $userTable->fetchAll($select);
    }

    public function deleteByPushId($notification_id) {
        $this->delete(array(
            'notification_id = ?' => $notification_id,
        ));
    }

}
