<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siterecaptcha
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2016-05-18 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siterecaptcha_Api_Core extends Core_Api_Core {

    public function getCaptchaOptions(array $params = array()) {
        return array_merge(array(
            'label' => 'Human Verification',
            'secretKey' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siterecaptcha.secret.key"),
            'siteKey' => Engine_Api::_()->getApi('settings', 'core')->getSetting("siterecaptcha.site.key"),
            'theme' => 'white',
            'lang' => Zend_Registry::get('Locale')->getLanguage(),
            'tabindex' => (isset($params['tabindex']) ? $params['tabindex'] : null ),
            'ssl' => constant('_ENGINE_SSL')   // Fixed Captcha does not work well when ssl is enabled on website
                ), $params);
    }

    public function getKeySettings() {

        $secretKey = Engine_Api::_()->getApi('settings', 'core')->getSetting("siterecaptcha.secret.key");
        $siteKey = Engine_Api::_()->getApi('settings', 'core')->getSetting("siterecaptcha.site.key");

        if ($secretKey && $siteKey) {
            return true;
        } else {
            return false;
        }
    }

    public function isRecaptchaFileRelatedChanges() {
        $isRecaptchaFileRelatedChangesDone = false;
        $changeExist = false;
        $file = APPLICATION_PATH . "/application/modules/User/Form/Signup/Account.php";
        $isRecaptchaFileRelatedChangesDone = $this->checkRecaptchaWord($file);

        if ($isRecaptchaFileRelatedChangesDone) {
            $changeExist1 = true;
        } else {
            $changeExist1 = false;
        }

        $file = APPLICATION_PATH . "/application/modules/User/Form/Login.php";
        $isRecaptchaFileRelatedChangesDone = $this->checkRecaptchaWord($file);
        if ($isRecaptchaFileRelatedChangesDone) {
            $changeExist2 = true;
        } else {
            $changeExist2 = false;
        }

        $file = APPLICATION_PATH . "/application/modules/Core/Form/Comment/Create.php";
        $isRecaptchaFileRelatedChangesDone = $this->checkRecaptchaWord($file);
        if ($isRecaptchaFileRelatedChangesDone) {
            $changeExist3 = true;
        } else {
            $changeExist3 = false;
        }

        $file = APPLICATION_PATH . "/application/modules/Activity/Form/Comment.php";
        $isRecaptchaFileRelatedChangesDone = $this->checkRecaptchaWord($file);
        if ($isRecaptchaFileRelatedChangesDone) {
            $changeExist4 = true;
        } else {
            $changeExist4 = false;
        }

        $file = APPLICATION_PATH . "/application/modules/Invite/Form/Invite.php";
        $isRecaptchaFileRelatedChangesDone = $this->checkRecaptchaWord($file);
        if ($isRecaptchaFileRelatedChangesDone) {
            $changeExist5 = true;
        } else {
            $changeExist5 = false;
        }
        
        if($changeExist1 && $changeExist2 && $changeExist3 && $changeExist4 && $changeExist5) {
            return true;
        } else {
            return false;
        }

        
    }

    public function checkRecaptchaWord($file) {
        if (file_exists($file) && is_readable($file)) {
            $rowContent = file_get_contents($file);
            if (strstr($rowContent, 'recaptcha')) {
                return true;
            }
        }

        return false;
    }

}
