<?php

/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Create.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    Core
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Core_Form_Comment_Create extends Engine_Form {

    public function init() {
        $this->clearDecorators()
                ->addDecorator('FormElements')
                ->addDecorator('Form')
                ->setAttribs(array('class' => 'seaocore_form_comment'))
                ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

        //$allowed_html = Engine_Api::_()->getApi('settings', 'core')->core_general_commenthtml;
        // Member Level specific 
        $viewer = Engine_Api::_()->user()->getViewer();
        $allowed_html = "";
        if ($viewer->getIdentity()) {
            $allowed_html = Engine_Api::_()->getDbtable('permissions', 'authorization')->getAllowed('user', $viewer->level_id, 'commentHtml');
        }
        $this->addElement('Textarea', 'body', array(
            'rows' => 1,
            'decorators' => array(
                'ViewHelper'
            ),
            'filters' => array(
                new Engine_Filter_Html(array('AllowedTags' => $allowed_html)),
                //new Engine_Filter_HtmlSpecialChars(),
                //new Engine_Filter_EnableLinks(),
                new Engine_Filter_Censor(),
            ),
        ));

        if (Engine_Api::_()->getApi('settings', 'core')->core_spam_comment) {
            if (Engine_Api::_()->hasModuleBootstrap('siterecaptcha')) {
                Zend_Registry::get('Zend_View')->recaptcha($this);
            } else {
                $this->addElement('captcha', 'captcha', Engine_Api::_()->core()->getCaptchaOptions(array(
                )));
            }
        }

        $this->addElement('Button', 'submit', array(
            'type' => 'submit',
            'ignore' => true,
            'label' => 'Post Comment',
            'decorators' => array(
                'ViewHelper',
            )
        ));

        $this->addElement('Hidden', 'type', array(
            'order' => 990,
            'validators' => array(
            // @todo won't work now that item types can have underscores >.>
            // 'Alnum'
            ),
        ));

        $this->addElement('Hidden', 'identity', array(
            'order' => 991,
            'validators' => array(
                'Int'
            ),
        ));
    }

}
