<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siterecaptcha
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2016-05-18 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siterecaptcha_Plugin_Core extends Zend_Controller_Plugin_Abstract {

    public function onRenderLayoutDefault($event, $mode = null) {
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');
        $sitereCaptchaEnabled = Zend_Registry::isRegistered('siterecaptcha_enabled') ? Zend_Registry::get('siterecaptcha_enabled') : null;
        if (!empty($sitereCaptchaEnabled) && (Engine_Api::_()->siterecaptcha()->getKeySettings())) {
            $view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
            $view->headScript()
                    ->appendFile("https://www.google.com/recaptcha/api.js?onload=CaptchaCallback&render=explicit");
            $recaptchapublic = $coreSettings->getSetting("siterecaptcha.site.key");
            // Populate some settings
            $settings = Engine_Api::_()->getApi('settings', 'core');
            $config = (array) $settings->core_spam;
            $loginCaptcha = $config['login'];
            $signupCaptcha = $config['signup'];
            $contactCaptcha = $config['contact'];
            $inviteCaptcha = $config['invite'];
            $commentCaptcha = $config['comment'];
            $staticPageEnabled = Engine_Api::_()->hasModuleBootstrap('sitestaticpage') ? 1 : 0;
            $zend_recaptcha = Zend_Registry::isRegistered('Zend_Recaptcha_Value') ? Zend_Registry::get('Zend_Recaptcha_Value') : null;
            $captchaStatic = $staticPageEnabled ? $zend_recaptcha : 0; 
           
            //$loginCaptcha = 
            $script = <<<EOF
                    var sitekey = '$recaptchapublic';
                    
                    var loginCaptcha = '$loginCaptcha';
                    var signupCaptcha = '$signupCaptcha';
                    var contactCaptcha = '$contactCaptcha';
                    var inviteCaptcha = '$inviteCaptcha';
                    var commentCaptcha = '$commentCaptcha';
                    
                    var CaptchaCallback = function(){
                    
                   if($$('.stpage_cont_body').length > 0 && '$captchaStatic' && $$('.stpage_cont_body').getElements('.g-recaptcha')[0].length > 0) { 
                      grecaptcha.render($$('.stpage_cont_body').getElements('.g-recaptcha')[0][0], {'sitekey' : sitekey});
                    }
                    
                    if($('user_form_login') && $('user_form_login').length > 0 && loginCaptcha == 1) {  
                            var y = document.querySelectorAll("[id='user_form_login']");
                            var i;
                            if(y.length > 0) {
                                for (i = 0; i < y.length; i++) {

                                    grecaptcha.render(y[i].getElements('.g-recaptcha')[0], {'sitekey' : sitekey});
                                }
                            }
                        }
                    
                    if($('feedback_create') && $('feedback_create').length > 0 ) {  
                            var y = document.querySelectorAll("[id='feedback_create']");
                            var i;
                            if(y.length > 0) {
                                for (i = 0; i < y.length; i++) {

                                    grecaptcha.render(y[i].getElements('.g-recaptcha')[0], {'sitekey' : sitekey});
                                }
                            }
                        }
                    
                        if($('signup_account_form') && $('signup_account_form').length > 0 && signupCaptcha == 1) {  
                            var x = document.querySelectorAll("[id='signup_account_form']");
                            var i;
                            if(x.length > 0) {
                                for (i = 0; i < x.length; i++) {

                                    grecaptcha.render(x[i].getElements('.g-recaptcha')[0], {'sitekey' : sitekey});
                                }
                            }
                        }
                    
                    if($('invite_form') && $('invite_form').getElements('.global_form').length > 0 && inviteCaptcha == 1) {               
                            $('invite_form').getElements('.g-recaptcha').each(function(index, el) {
                                grecaptcha.render(index, {'sitekey' : sitekey});
                            });
                        }
                    
                    if($('core_form_contact') && $('core_form_contact').length > 0 && (contactCaptcha == 1 || contactCaptcha == 2)) {              
                            $('core_form_contact').getElements('.g-recaptcha').each(function(index, el) {
                                grecaptcha.render(index, {'sitekey' : sitekey});
                            });
                        }
                    
                    if($$('.seaocore_form_comment').length > 0 && commentCaptcha == 1) {
                            $$('.seaocore_form_comment').getElements('.g-recaptcha').each(function(index, el) {
                    if(index[el]) {
                                grecaptcha.render(index[el], {'sitekey' : sitekey});
                    }
                            });
                        }
                    
};
EOF;
            $view->headScript()
                    ->appendScript($script);
        }
    }

    public function onRenderLayoutDefaultSimple($event) {
        return $this->onRenderLayoutDefault($event, 'simple');
    }

    public function onRenderLayoutMobileDefault($event) {
        // Forward
        return $this->onRenderLayoutDefault($event);
    }

    public function onRenderLayoutMobileDefaultSimple($event) {
        // Forward
        return $this->onRenderLayoutDefault($event);
    }

}
