<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siterecaptcha
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 2016-05-18 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siterecaptcha_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {
        $PRODUCT_TYPE = 'siterecaptcha';
        $PLUGIN_TITLE = 'Siterecaptcha';
        $PLUGIN_VERSION = '5.4.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'No CAPTCHA reCAPTCHA - Spam Protection';
        $PRODUCT_TITLE = 'No CAPTCHA reCAPTCHA - Spam Protection';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.8.10p6';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod))
                include_once $file_path;
        }

        parent::onPreinstall();
    }

    function onInstall() {
        $db = $this->getDb();

        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='siterecaptcha';");

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitemobile')
                ->where('enabled = ?', 1);
        $is_sitemobile_object = $select->query()->fetchObject();
        if (!empty($is_sitemobile_object)) {
            $db->query("INSERT IGNORE INTO `engine4_sitemobile_modules` (`name`, `visibility`, `integrated`, `enable_mobile`, `enable_tablet`) VALUES ('siterecaptcha', '1', '1', '1', '1')");
        }

        $select = new Zend_Db_Select($db);
        $select
                ->from('engine4_core_modules')
                ->where('name = ?', 'sitestaticpage')
                ->where('enabled = ?', 1);
        $is_sitestaticpage_object = $select->query()->fetchObject();
        if (!empty($is_sitestaticpage_object)) {
            $engine4StaticPageFieldOptions = $db->query("SHOW TABLES LIKE 'engine4_sitestaticpage_page_fields_options'")->fetch();
            if ($engine4StaticPageFieldOptions) {
                $sitestaticpage_recaptcha_column = $db->query("SHOW COLUMNS FROM engine4_sitestaticpage_page_fields_options LIKE 'recaptcha'")->fetch();
                if (empty($sitestaticpage_recaptcha_column)) {
                    $db->query("ALTER TABLE `engine4_sitestaticpage_page_fields_options` ADD `recaptcha` TINYINT( 1 ) DEFAULT NULL");
                }
            }
        }

        parent::onInstall();
    }

}
