<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteseo
 * @copyright  Copyright 2017-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Installer.php 2017-04-28 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Siteseo_Installer extends Engine_Package_Installer_Module {

    public function onPreinstall() {
        parent::onPreinstall();
        $this->placeWidgets();
    }

    function onInstall() {
        $db = $this->getDb();
        parent::onInstall();
    }

    public function placeWidgets() {
        $db = $this->getDb();

        // PLACE SCHEMA MARKUP WIDGET
        $select = new Zend_Db_Select($db);
        $select
        ->from('engine4_core_pages')
        ->where('name = ?', 'footer')
        ->limit(1);
        $info = $select->query()->fetch();

        if (empty($info))
            return false;

        $page_id = $info['page_id'];
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_content')
        ->where('name = ?', 'siteseo.schema-markup')
        ->where('page_id = ?', $page_id)
        ->where('type = ?', 'widget')
        ->limit(1);
        $info = $select->query()->fetch();

        if (!empty($info))
            return false;

        $select = new Zend_Db_Select($db);
        $select
        ->from('engine4_core_content')
        ->where('name = ?', 'main')
        ->where('page_id = ?', $page_id)
        ->where('type = ?', 'container')
        ->limit(1);
        $info = $select->query()->fetch();

        if ($info) {
            $container_id = $info['content_id'];
            // Insert content
            $db->insert('engine4_core_content', array(
                'type' => 'widget',
                'name' => 'siteseo.schema-markup',
                'page_id' => $page_id,
                'parent_content_id' => $container_id,
                'order' => 10,
                ));
        }
    }
}
