<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions 
 * @package    Seaocore
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2010-11-18 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitesetup_Api_Core extends Core_Api_Abstract 
{ 
	private $_sitesetupLog;

	public function getLog() 
	{
		if($this->_sitesetupLog != null){
			return $this->_sitesetupLog;
		}
		$log = new Zend_Log(); 
		try {
			$log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/sitesetup.log'));
		} catch( Exception $e ) {
			$log->addWriter(new Zend_Log_Writer_Null());
		}
		$this->_sitesetupLog = $log;
		return $this->_sitesetupLog;
	}
	//RETURN THE ARRAY OF MODULES NAME FOR THE SITESETUP MODULE
	public function getModulesArray() 
	{
		$not_include = array('activity', 'authorization', 'announcement', 'messages', 'core', 'fields', 'invite', 'network', 'payment', 'storage', 'user', 'bigstep', 'sitesetup', 'seaocore', 'sitecore');

		$modulesTable = Engine_Api::_()->getDbTable('modules', 'core');
		$moduleTableName = $modulesTable->info('name');
		$select = $modulesTable->select()
		->from($moduleTableName, array('name', 'title'))
		->where($moduleTableName . '.name not in(?)', $not_include);
		$contentModule = $select->query()->fetchAll();
		foreach ($contentModule as $modules) {
			$contentModuleArray[$modules['name']] = $modules['title'];
		}
		return $contentModuleArray;
	}

	public function getDisabledModulesArray() 
	{
		$doNotRemoveModules = array('album', 'forum', 'video', 'poke');
        $modulesTable = Engine_Api::_()->getDbtable('modules', 'core');
        $modules = $modulesTable->select()
                ->from($modulesTable, 'name')
                ->where('enabled = ?', false)
                ->where('name NOT IN(?)', $doNotRemoveModules)
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);
		return $modules;
	}

	public function getModulesArrayDisabledMarked($modules = array()) 
	{
		$modulesArray = array();
		if (empty($modules)) {
			return $modulesArray;
		}
		$coreModulesTable = Engine_Api::_()->getDbtable('modules', 'core');
		foreach ($modules as $module => $title) {  
			if(!$coreModulesTable->isModuleEnabled($module)) {
				$modulesArray[$module] = "(DISABLED) ".$title;
			} else {
				$modulesArray[$module] = $title;
			}
		} 
		return $modulesArray;
	}
	public function getSiteName()
	{ 
		$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
        $siteServer = explode('//', $view->serverUrl())[1];
        if($siteServer == 'localhost') {
			$requestUri = explode('/', $_SERVER['REQUEST_URI'])[1];
	        $siteServer = $siteServer."/".$requestUri;
        }
        return $siteServer;
	}
	public function demoSocialengineaddons($final_query, $siteTitle) 
	{
		//DELETION OF SOME WIDGETS WHICH ARE RELATED TO THE SOCIALENGINEADDONS AVAILABLE AT LANDING PAGE AND HEADER
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12411 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12425 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12384 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 11738 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12291 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12369 LIMIT 1;';
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12367 LIMIT 1;'; 
		$final_query .= ' 
		UPDATE `engine4_core_content` SET `name` = "advancedslideshow.fullwidth1-advancedslideshows" WHERE `engine4_core_content`.`content_id` ="7989" LIMIT 1 ;
		DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "siteevent.special-events" AND `engine4_core_content`.`page_id` = "3";
		DELETE FROM `engine4_core_content` WHERE `engine4_core_content`.`name` = "sitepage.recently-popular-random-sitepage" AND `engine4_core_content`.`page_id` = "3";
		UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="41" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;
		UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="42" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;
		UPDATE `engine4_core_content` SET `name` = "core.content", `params` = "" WHERE `engine4_core_content`.`page_id` ="40" AND `engine4_core_content`.`name` ="sitestaticpage.html-blocks" LIMIT 1 ;
		DELETE FROM `engine4_core_pages` WHERE `engine4_core_pages`.`page_id` = "544" LIMIT 1;
		';

		//REPLACE THE TITLE AND DESCRIPTION FROM THE LANDING PAGE
		$final_query .= 'UPDATE `engine4_core_pages` SET `title` = "'. $siteTitle .'", `title` = "'. $params['site_description'] .'"  WHERE `engine4_core_pages`.`page_id` = 3 LIMIT 1;';
		// DELETE THE MENU Static Pages
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2772" LIMIT 1;';
		// DELETE THE MENU Facebook 
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "637" LIMIT 1;';
		// DELETE THE MENU Sitereview 
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1218" LIMIT 1;';
		// DELETE THE MENU FAQ
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1219" LIMIT 1;';
		// DELETE THE MENU BUSINESS
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "1454" LIMIT 1;';

		// DELETE THE MENU Events - Home - Template 1,2,3
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2612" LIMIT 1;';
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2614" LIMIT 1;';
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "2619" LIMIT 1;';

		//REMOVE THE POKE, SUGGESTIONS, AND ADVANCED SLIDESHOW CUSTOM MENUS
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "634" LIMIT 1;';
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "636" LIMIT 1;';
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "635" LIMIT 1;';

		//REMOVE THE DEMOS MENU FROM MAIN DEMO
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3651" LIMIT 1;';
		//REMOVE THE GO TO SEAO MENU FROM FOOTER OF MAIN DEMO
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3557" LIMIT 1;';
		//REMOVE THE "ADVANCED PLUGINS" MENU FROM MAIN DEMO
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3199" LIMIT 1;';
		return $final_query;
	}
	public function demoVideosSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Buy From SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE THE MENU "Buy Theme" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4381" LIMIT 1;';
		//DELETE THE MENU "Captivate Theme" from main menu dropdown
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3923" LIMIT 1;';
		return $final_query;
	}
	public function demoSellTicketsSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Buy From SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE BUY NOW LINK FROM HEADER
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 12670 LIMIT 1;';
		return $final_query;
	}
	public function demoPhotoalbumsSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Buy From SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE BUY NOW LINK FROM HEADER
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 13952 LIMIT 1;';
		return $final_query;
	}
	public function demoCrowdfundingSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Buy From SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE THE MENU "Buy Theme" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4381" LIMIT 1;';
		return $final_query;
	}
	public function demoMobiledemoSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Buy From SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE THE MENU "Purchase Mobile Apps" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4253" LIMIT 1;';
		//DELETE THE MENU "Android App" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4254" LIMIT 1;';
		//DELETE THE MENU "iOS App" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4255" LIMIT 1;';
		//DELETE SITEVIDEO RELATED WIDGET FROM LANDING PAGE, HAVING SOCIALENGINE LINK
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 14934 LIMIT 1;';
		//DELETE SOCIALENGINEADDONS RELATED DWIDGET FROM THE LANDING PAGE
		$final_query .= 'DELETE  FROM `engine4_core_content` WHERE `content_id` = 14955 LIMIT 1;';
		return $final_query;
	}

	public function demoFacelightSocialengineaddons($final_query) 
	{
		//DELETE THE MENU "Go to SocialEngineAddOns" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3557" LIMIT 1;';
		//DELETE THE MENU "SocialEngineAddons" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "5992" LIMIT 1;';
		return $final_query;
	}

	public function demoSocialMedia($final_query) 
	{
		//DELETE THE MENU " Buy From SocialApps.tech" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "3867" LIMIT 1;';
		//DELETE THE MENU " Buy Theme" LINK FROM FOOTER
		$final_query .= 'DELETE FROM `engine4_core_menuitems` WHERE `engine4_core_menuitems`.`id` = "4381" LIMIT 1;';
		 
		return $final_query;
	}

	public function demoContest($final_query) 
	{
		//CONTEST DEMO HAVE NOTTHING THAT WE HAVE TO REMOVE, IN FUTURE IS THERE IS ANY THINGS THAT WE WANT TO REMOVE, THAN WE CAN ADD QUERY FOR THE SAME HERE 
		return $final_query;
	}

	public function demoTwitter($final_query) 
	{
		//CONTEST DEMO HAVE NOTTHING THAT WE HAVE TO REMOVE, IN FUTURE IS THERE IS ANY THINGS THAT WE WANT TO REMOVE, THAN WE CAN ADD QUERY FOR THE SAME HERE 
		return $final_query;
	}
}
