<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitealbum
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitesetup_Form_Admin_Demo extends Engine_Form {

    protected $_moduleArrayDisabledMarked; 
    protected $_notPurchasedPlugins; 
    protected $_advancedMenuEnabled; 
    protected $_hostName; 

    public function getModuleArrayDisabledMarked() {
      return $this->_moduleArrayDisabledMarked;
    }
    public function setModuleArrayDisabledMarked($moduleArrayDisabledMarked) {
      $this->_moduleArrayDisabledMarked = $moduleArrayDisabledMarked;
      return $this;
    }

    public function getNotPurchasedPlugins() {
      return $this->_notPurchasedPlugins;
    }
    public function setNotPurchasedPlugins($notPurchasedPlugins) {
      $this->_notPurchasedPlugins = $notPurchasedPlugins;
      return $this;
    }

    public function getAdvancedMenuEnabled() {
      return $this->_advancedMenuEnabled;
    }
    public function setAdvancedMenuEnabled($advancedMenuEnabled) {
      $this->_advancedMenuEnabled = $advancedMenuEnabled;
      return $this;
    }
    public function setHostName($hostName) {
      $this->_hostName = $hostName;
      return $this;
    } 
    public function init() {  
 
        $this->setTitle("Make Copy Of Demo ".$this->_hostName)
                ->setDescription("Fill the following information carefully");
        $this->addElement('Text', 'site_title', array(
            'label' => 'Site Title',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'CORE_FORM_ADMIN_SETTINGS_GENERAL_SITETITLE_DESCRIPTION'
        ));

        $this->addElement('Textarea', 'site_description', array(
            'label' => 'Site Description',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'description' => 'CORE_FORM_ADMIN_SETTINGS_GENERAL_SITEDESCRIPTION_DESCRIPTION'
        ));

        $this->addElement('Text', 'site_admin_email', array(
            'label' => 'Admin Email Id',
            'autocomplete' => 'off',
            'required' => true,
            'allowEmpty' => false,
            'validators' => array(
                array('NotEmpty', true),
                array('EmailAddress', true),
            ),
            'description' => 'Please enter correct admin email id. Ex: admin@siteurl.com'
        ));

        $this->addElement('radio', 'sitesetup_password_change', array(
            'label' => 'Admin Password',
            'description' => "Do you want to change the admin password",
            'value' => '0',
            'onclick' => 'adminPasswordChange(this.value)',
            'multiOptions' => array("1" => "Yes", "0" => "No"),
        ));

        // Password
        $this->addElement('Password', 'sitesetup_admin_password', array(
          'label' => 'Password',
          'description' => '',
        ));

        // Password confirm
        $this->addElement('Password', 'sitesetup_admin_password_confirm', array(
          'label' => 'Password Again',
          'description' => 'Confirm password',
        )); 
        //SHOW THE ADVANCEC MENE RELATED OPTION ONLY IN CASE IF MAIN DEMO
        if($this->_advancedMenuEnabled) {
            $this->addElement('radio', 'sitesetup_advanced_menu', array(
                'label' => 'Advanced Menu',
                'description' => "Select the Menu",
                'value' => '1',
                'multiOptions' => array("1" => "Yes", "0" => "No"),
            ));
        } 

        $this->addElement('Text', 'google_location_key', array(
            'label' => 'Google Places API Key',
            'autocomplete' => 'off', 
            'description' => 'Please enter a valid Google Places API Key of client site.'
        ));  

        $this->addElement('MultiCheckbox', 'modules_name', array(
            'description' => 'Select modules name which <b>you do not</b> want to install on site setup. Note: Module title shown with (DISABLED) text are installed but disabled on the site',
            'label' => 'Select Modules',
            'multiOptions' => $this->_moduleArrayDisabledMarked,
            'value' => $this->_notPurchasedPlugins
        ));
        $this->modules_name->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::PREPEND, 'escape' => false)); 

        // Element: submit
        $this->addElement('Button', 'submit', array(
            'label' => 'Submit',
            'type' => 'submit',
            'ignore' => true
        ));
    }

}