<?php
// FIRST READ OUT ALL BELOW MENTION LINES CAREFULLY. IF YOU NOT READ THESE LINES THEN YOU WILL RESPONSIABLE FOR ANY KIND OF ERRORS ON SITE. 
// HIT THE SITE_URL/admin/sitesetup2/userdelete TO DELETE THE USERS.
//PLEASE NOTE: SOME USERS WILL NOT DELETE THOSE USERS ARE LISTED IN THE sitesetup2/externals/demo-users.json
//if you want to keep some more users than you have to add in the users json file
// NOTE: IF YOU FOUND THIS TYPE URL (SITE_URL/admin/sitesetup2/userdelete?page_reload=2) AFTER HIT THEN REMOVE "?page_reload=2" AND HIT AGAIN.

class Sitesetup2_AdminUserdeleteController extends Core_Controller_Action_Admin {

   
    public function indexAction() 
    {  
        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        }  

        //DELETE THE ENTRIES IN THE TABLE RELATED DISABLED MODULES, TO AVOID UNKNOWN RESOURCE TYPE ERR
        $modulesTable = Engine_Api::_()->getDbtable('modules', 'core');
        $modulesTableName = $modulesTable->info('name');
        $select = $modulesTable->select()->from($modulesTableName, array("name"))
                                ->where("enabled = ?", 0);
        $results = $modulesTable->fetchAll($select);
        $disabledModulesItems = array();
        foreach ($results->toArray() as $value) { 
            if(file_exists(APPLICATION_PATH . '/application/modules/'.ucfirst($value["name"]).'/settings/manifest.php')) {
                $manifestArray = include APPLICATION_PATH . '/application/modules/'.ucfirst($value["name"]).'/settings/manifest.php'; 
                if(!empty($manifestArray['items'])) { 
                    $disabledModulesItems = array_merge($disabledModulesItems, $manifestArray['items']); 
                }
            } 
        }  
        if(!empty($disabledModulesItems)) {
            $actionTable = Engine_Api::_()->getDbtable('actions', 'activity');
            $attachmentsTable = Engine_Api::_()->getDbtable('attachments', 'activity');
            $likeTable = Engine_Api::_()->getDbtable('likes', 'core');
            $commentTable = Engine_Api::_()->getDbtable('comments', 'core');

            $actionTable->delete(array("object_type IN(?)" => $disabledModulesItems)); 
            $attachmentsTable->delete(array("type IN(?)" => $disabledModulesItems)); 
            $likeTable->delete(array("resource_type IN(?)" => $disabledModulesItems)); 
            
            $commentTableName = $commentTable->info('name');
            $select = $commentTable->select()->from($commentTableName, 'comment_id')
                                    ->where("resource_type IN(?)", $disabledModulesItems);
            $comments = $commentTable->fetchAll($select);
            //DELETE THE LIKES ON DELETED COMMENTS
            foreach ($comments as $comment) {
                $likeTable->delete(array("resource_type = ?" => "core_comment", "resource_id = ?" => $comment->comment_id)); 
            } 
            $commentTable->delete(array("resource_type IN(?)" => $disabledModulesItems)); 
        }
        
        set_time_limit(0);
        $usertable = Engine_Api::_()->getDbtable('users', 'user');
        $totalPages = $usertable->select()
                        ->from($usertable->info('name'), array('count(*) as count'))
                        ->query()->fetchColumn();
        $limit = 100;
        $reload_count = round($totalPages / $limit);
        $page_reload = $this->_getParam('page_reload', 1);
        $offset = ($page_reload - 1) * $limit;

        //THIS FILE HAS ALL DEMOS USERS, WE DO NOT DELETE THESE USERS
        $doNotDeleteUsers = json_decode(file_get_contents(APPLICATION_PATH. '/application/modules/Sitesetup2/externals/demo-users.json'), true);
        $doNotDeleteUsersArray = array();
        $hostName = Engine_Api::_()->getApi('settings', 'core')->getSetting('demo.host.name'); 
        if(!empty($hostName) && isset($doNotDeleteUsers[$hostName])) {
            $doNotDeleteUsersArray = $doNotDeleteUsers[$hostName];
        }
        
        if(empty($doNotDeleteUsersArray)) {
            die("All user will be deleted. Please add some user's email ID in the externals/demo-users.json file to skip them or comment this condition from code if you want to delete all users");
        }

        $select = $usertable->select()
                ->from($usertable->info('name'), array('email', 'user_id', 'level_id'))
                ->where('user_id != ?', '1');
                if(!empty($doNotDeleteUsersArray)) {
                    $select->where('email NOT IN(?)', $doNotDeleteUsersArray);
                }
                $select->limit($limit, $offset);
        $users = $usertable->fetchAll($select);

        if (isset($_GET['page_reload']) || $page_reload) {
            foreach ($users->toarray() as $user_id) {
                $user = Engine_Api::_()->getItem('user', (int) $user_id['user_id']);
                if ($user->level_id != 1) {
                    $user->delete(); 
                }
            }
            if ($page_reload < $reload_count) {
                $page_reload++;
                $this->_redirect("admin/sitesetup2/userdelete?page_reload=$page_reload");
            }
        } 
        echo "User's has been deleted succesfully !! Please check and confirm once by visiting the 'Manage Users' section from admin panel.";
        die;
    }



    public function deleteOrdersAction() 
    { 

        $viewer = Engine_Api::_()->user()->getViewer();
        if (empty($viewer) || empty($viewer->level_id) || ($viewer->level_id != 1)) {
            return;
        } 
        //Order deletion related events tickets orders  
        $siteeventEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteevent');
        if($siteeventEnabled) {
            $eventTable = Engine_Api::_()->getDbtable('events', 'siteevent');
            $eventIds = (array) $eventTable->select()
            ->from($eventTable->info('name'), 'event_id')
            ->query()
            ->fetchAll(Zend_Db::FETCH_COLUMN);
        
            $ticketEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteeventticket');
            if($ticketEnabled) {
                $orderTable = Engine_Api::_()->getDbtable('orders', 'siteeventticket');
                if(!empty($eventIds)) {
                    $eventOrderIds = (array) $orderTable->select()
                    ->from($orderTable->info('name'), 'order_id')
                    ->where('event_id NOT IN(?)', $eventIds)
                    ->query()
                    ->fetchAll(Zend_Db::FETCH_COLUMN);

                    $orderTable->delete(array("event_id NOT IN(?)" => $eventIds));

                    if(!empty($eventOrderIds)) {
                        Engine_Api::_()->getDbTable('buyerdetails', 'siteeventticket')
                        ->delete(array("order_id IN(?)" => $eventOrderIds));
                        Engine_Api::_()->getDbtable('orderTickets', 'siteeventticket')
                        ->delete(array("order_id IN(?)" => $eventOrderIds));
                        Engine_Api::_()->getDbtable('transactions', 'siteeventticket')
                        ->delete(array("order_id IN(?)" => $eventOrderIds));
                    }
                }
            }
        } 
        //order deletion related store products
        $storeEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestore');
        if($storeEnabled) {
            $storeTable = Engine_Api::_()->getDbtable('stores', 'sitestore');
            $storeIds = (array) $storeTable->select()
            ->from($storeTable->info('name'), 'store_id')
            ->query()
            ->fetchAll(Zend_Db::FETCH_COLUMN);
       
            $orderTable = Engine_Api::_()->getDbtable('orders', 'sitestoreproduct');
            if(!empty($storeIds)) {
                $productOrderIds = (array) $orderTable->select()
                ->from($orderTable->info('name'), 'order_id')
                ->where('store_id NOT IN(?)', $storeIds)
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);

                $orderTable->delete(array("store_id NOT IN(?)" => $storeIds));

                if(!empty($productOrderIds)) {
                    Engine_Api::_()->getDbtable('orderaddresses', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                    Engine_Api::_()->getDbtable('OrderComments', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                    Engine_Api::_()->getDbtable('orderdownloads', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                    Engine_Api::_()->getDbtable('orderdownpayments', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                    Engine_Api::_()->getDbtable('orderProducts', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                    Engine_Api::_()->getDbtable('shippingtrackings', 'sitestoreproduct')
                    ->delete(array("order_id IN(?)" => $productOrderIds));
                }
            }
         }

        //topics and posts deletion if the siteforum is installed
        $siteforumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('siteforum');
        if($siteforumEnabled) {
            $userTable = Engine_Api::_()->getDbTable('users', 'user');
            $userIds = (array) $userTable->select()
            ->from($userTable->info('name'), 'user_id')
            ->query()
            ->fetchAll(Zend_Db::FETCH_COLUMN);
        
            $topicTable = Engine_Api::_()->getDbtable('topics', 'siteforum');
            if(!empty($userIds)) {
                $topicIDs = (array) $topicTable->select()
                ->from($topicTable->info('name'), 'topic_id')
                ->where('user_id NOT IN(?)', $userIds)
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);

                $topicTable->delete(array("user_id NOT IN(?)" => $userIds));

                if(!empty($topicIDs)) {
                    //Delete the posts of the deleted topics
                    Engine_Api::_()->getDbTable('posts', 'siteforum')
                    ->delete(array("topic_id IN(?)" => $topicIDs)); 
                }

                //DELETE THE POSTS OF THE DELETED USERS
                Engine_Api::_()->getDbTable('posts', 'siteforum')
                ->delete(array("user_id NOT IN(?)" => $userIds)); 

            }
        }

        //topics and posts deletion if the forum is installed
        $forumEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('forum');
        if($forumEnabled) {
            $userTable = Engine_Api::_()->getDbTable('users', 'user');
            $userIds = (array) $userTable->select()
            ->from($userTable->info('name'), 'user_id')
            ->query()
            ->fetchAll(Zend_Db::FETCH_COLUMN);
      
            $topicTable = Engine_Api::_()->getDbTable('topics', 'forum');
            if(!empty($userIds)) {
                $topicIDs = (array) $topicTable->select()
                ->from($topicTable->info('name'), 'topic_id')
                ->where('user_id NOT IN(?)', $userIds)
                ->query()
                ->fetchAll(Zend_Db::FETCH_COLUMN);

                $topicTable->delete(array("user_id NOT IN(?)" => $userIds));

                if(!empty($topicIDs)) {
                    //Delete the posts of the deleted topics
                    Engine_Api::_()->getDbtable('posts', 'forum')
                    ->delete(array("topic_id IN(?)" => $topicIDs)); 
                }

                //DELETE THE POSTS OF THE DELETED USERS
                Engine_Api::_()->getDbTable('posts', 'forum')
                ->delete(array("user_id NOT IN(?)" => $userIds)); 
            } 
        }

        die("Unusefull Data has been Deleted from the tables");
    }   

}
