<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteshortcut
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Level.php 10100 2013-10-24 23:09:16Z guido $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Siteshortcut
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteshortcut_Form_Admin_Settings_Level extends Authorization_Form_Admin_Level_Abstract
{
  public function init()
  {
    parent::init();

    // My stuff
    $this
      ->setTitle('Member Level Settings')
      ->setDescription("These settings are applied on a per member level basis. Start by selecting the member level you want to modify, then adjust the settings for that level.");


    if( $this->isPublic() ) {
      return;
    }

    // Element: create
    $this->addElement('Radio', 'add', array(
      'label' => 'Allow to Add Shortcuts',
      'description' => 'Do you want to allow the members of this member level to add shortcuts?',
      'multiOptions' => array(
        1 => 'Yes, allow to add shortcuts.',
        0 => 'No, do not allow to add shortcuts.'
      ),
      'value' => 1,
    ));
    // Element: create
    $this->addElement('Radio', 'auto', array(
      'label' => 'Allow to View Automatic Shortcuts',
      'description' => 'Do you want to allow the members of this member level to view automatic shortcuts?',
      'multiOptions' => array(
        1 => 'Yes, allow to view automatic shortcuts.',
        0 => 'No, do not allow to view automatic shortcuts.'
      ),
      'value' => 1,
    ));
  }

}
