<?php

/**
 * SocialEngine
 *
 * @category   Application_Theme
 * @package    Siteshortcut
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: ShortcutController.php 2017-12-15 00:00:00 SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteshortcut_IndexController extends Core_Controller_Action_Standard
{
  public function addToShortcutAction()
  {
    // If the user is not logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( empty($viewer->getIdentity()) ) {
      return $this->_helper->json(array('status' => false));
    }
    $resource_type = $this->_getParam('resource_type');
    $resource_id = $this->_getParam('resource_id');
    if( empty($resource_type) && empty($resource_id) ) {
      return $this->_helper->json(array('status' => false));
    }
    Engine_Api::_()->getDbTable('shortcuts', 'siteshortcut')->addToShortcut(
      array(
        'resource_type' => $resource_type,
        'resource_id' => $resource_id,
        'user_id' => $viewer->getIdentity()
    ));
    return $this->_helper->json(array('status' => true, 'action' => 'added'));
  }

  public function removeFromShortcutAction()
  {
    // If the user is not logged in
    $viewer = Engine_Api::_()->user()->getViewer();
    if( empty($viewer->getIdentity()) ) {
      return $this->_helper->json(array('status' => false));
    }
    $resource_type = $this->_getParam('resource_type');
    $resource_id = $this->_getParam('resource_id');
    if( empty($resource_type) && empty($resource_id) ) {
      return $this->_helper->json(array('status' => false));
    }
    Engine_Api::_()->getDbTable('shortcuts', 'siteshortcut')->deleteFromShortcut(
      array(
        'resource_type =?' => $resource_type,
        'resource_id =?' => $resource_id,
        'user_id =?' => $viewer->getIdentity()
    ));
    return $this->_helper->json(array('status' => true, 'action' => 'removed'));
  }

}
