<?php
/**
 * SocialEngine
 *
 * @category   Application_Module
 * @package    Siteshortcut
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    faq_help.tpl 2015-09-10 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Siteshortcut_Installer extends Engine_Package_Installer_Module
{

  protected $_installConfig = array(
    'sku' => 'siteshortcut',
  );

  public function onInstall()
  {
    $this->_addUserHomeContent();
    parent::onInstall();
  }

  protected function _addUserHomeContent()
  {
    if( $this->_databaseOperationType == 'upgrade' ) {
      return;
    }
    //
    // install content areas
    //
    $db = $this->getDb();
    $select = new Zend_Db_Select($db);

    // profile page
    $select
      ->from('engine4_core_pages')
      ->where('name = ?', 'user_index_home')
      ->limit(1);
    $pageId = $select->query()->fetchObject()->page_id;
    // siteshortcut.user-shortcuts
    // Check if it's already been placed
    $select = new Zend_Db_Select($db);
    $select
      ->from('engine4_core_content')
      ->where('page_id = ?', $pageId)
      ->where('type = ?', 'widget')
      ->where('name = ?', 'siteshortcut.user-shortcuts')
    ;
    $info = $select->query()->fetch();

    if( empty($info) ) {

      // container_id (will always be there)
      // middle_id (will always be there)
      $select = new Zend_Db_Select($db);
      $select
        ->from('engine4_core_content')
        ->where('page_id = ?', $pageId)
        ->where('type = ?', 'container')
        ->where('name = ?', 'left')
        ->limit(1);
      $leftId = $select->query()->fetchObject()->content_id;
      if( empty($leftId) ) {
        $select = new Zend_Db_Select($db);
        $select
          ->from('engine4_core_content')
          ->where('page_id = ?', $pageId)
          ->where('type = ?', 'container')
          ->where('name = ?', 'right')
          ->limit(1);
        $leftId = $select->query()->fetchObject()->content_id;
      }
      if( empty($leftId) ) {
        return;
      }
      // tab on profile
      $db->insert('engine4_core_content', array(
        'page_id' => $pageId,
        'type' => 'widget',
        'name' => 'siteshortcut.user-shortcuts',
        'parent_content_id' => $leftId,
        'order' => 3,
        'params' => '{"title":"Shortcuts"}',
      ));
    }
  }

}

?>
