<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteslideshow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 6590 2010-08-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteslideshow_Api_Core extends Core_Api_Abstract
{
	
	const THUMB_WIDTH = 80;
  const THUMB_HEIGHT = 51;
  
	public function createImage($params, $file)
  {
    if( $file instanceof Storage_Model_File ) {
      	$params['file_id'] = $file->getIdentity();
    }
		else {
      //GET IMAGE INFO AND RESIZE
      $name = basename($file['tmp_name']);
      $path = dirname($file['tmp_name']);
      $extension = ltrim(strrchr($file['name'], '.'), '.');

      $mainName = $path . '/m_' . $name . '.' . $extension;
      $thumbName = $path . '/t_' . $name . '.' . $extension;
     
      //GET SLIDESHOW HIGHT
    	$height = Engine_Api::_()->getApi('settings', 'core')->siteslideshow_height;
    
    	//GET SLIDESHOW WIDTH
    	$width = Engine_Api::_()->getApi('settings', 'core')->siteslideshow_width;
      
		$resize_slides = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.slide.resize', 1);      
      
      if($resize_slides) {
        $image = Engine_Image::factory();
        $image->open($file['tmp_name'])
              ->resize($width, $height)
                ->write($mainName)
                ->destroy();

        $image = Engine_Image::factory();
        $image->open($file['tmp_name'])
              //->resize(self::THUMB_WIDTH, self::THUMB_HEIGHT)
              ->resize($width, $height)
              ->write($thumbName)
              ->destroy();
      }
      else {
        $image = Engine_Image::factory();
        $image->open($file['tmp_name'])
              //->resize($width, $height)
                ->write($mainName)
                ->destroy();

        $image = Engine_Image::factory();
        $image->open($file['tmp_name'])
              //->resize(self::THUMB_WIDTH, self::THUMB_HEIGHT)
              ->write($thumbName)
              ->destroy();          
      }
      
      $image_params = array(
        'parent_id' => 5,
        'parent_type' => 'siteslideshow',
      );

      $imageFile = Engine_Api::_()->storage()->create($mainName, $image_params);
      $thumbFile = Engine_Api::_()->storage()->create($thumbName, $image_params);

      $imageFile->bridge($thumbFile, 'thumb.normal');

      $params['file_id'] = $imageFile->file_id;
      $params['image_id'] = $imageFile->file_id;       
    }

    $row = Engine_Api::_()->getDbtable('images', 'siteslideshow')->createRow();
    $row->setFromArray($params);
    $row->extension = $extension;
    $row->save();
    return $row;
  }

	public function deleteDirectory($dir) {
		@chmod($dir, 0777);
		if (is_dir($dir)) {
			$objects = scandir($dir);
			foreach ($objects as $object) {
				if ($object != "." && $object != "..") {
					if (filetype($dir."/".$object) == "dir") {
						Engine_Api::_()->siteslideshow()->deleteDirectory($dir."/".$object);
					}
					else {
						@unlink($dir."/".$object);
					}
				}
			}
			reset($objects);
			@rmdir($dir);
		} 
	}
}
?>