<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteslideshow
 * @copyright  Copyright 2009-2010 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSlideshowsController.php 6590 2010-08-31 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteslideshow_AdminSlideshowsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
		//GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      	 ->getNavigation('siteslideshow_admin_main', array(), 'siteslideshow_admin_main_slideshows');

		//GET SLIDESHOW TYPE
		$type = $this->_getParam('type');
		if(!empty($type)) {
      $slide_type = $type;
    } 
		else {
      $slide_type = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteslideshow.type');
    }
 	 
		//GET BASE URL
		$base = Zend_Controller_Front::getInstance()->getBaseUrl();
		$this->view->preview_base_url = "http://".$_SERVER['HTTP_HOST'].  $base."/";

		$this->view->form = $form = new Siteslideshow_Form_Admin_Slideshow();

    if (!empty($form->siteslideshow_type)) {
    	 $form->siteslideshow_type->setValue($slide_type);
    }

		//REMOVE siteslideshow_color1 AND siteslideshow_color2 FIELD FROM FORM IF SLIDE TYPE IS NOT EQUAL TO FLASH
		if($slide_type != 'flas') {
			$form->removeElement('siteslideshow_color1');
			$form->removeElement('siteslideshow_color2');
		}

		//REMOVE siteslideshow_transition FIELD FROM FORM IF SLIDE TYPE IS NOT EQUAL TO PUSH
		if($slide_type != 'push' && $slide_type != 'fold') { 
			$form->removeElement('siteslideshow_transition1');
			$form->removeElement('siteslideshow_overlap');
		}

		if($slide_type == 'flom' ) {
			$form->removeElement('siteslideshow_transition1');
			$form->removeElement('siteslideshow_delay');
			$form->removeElement('siteslideshow_duration');
			$form->removeElement('siteslideshow_color1');
			$form->removeElement('siteslideshow_color2');
			$form->removeElement('siteslideshow_overlap');
			$form->removeElement('siteslideshow_random');
			$form->removeElement('siteslideshow_start_index');
			$form->removeElement('siteslideshow_title');
			$form->removeElement('siteslideshow_controller');
			$form->removeElement('siteslideshow_thumb');
			$form->removeElement('siteslideshow_backcolor');
			$form->removeElement('siteslideshow_bordcolor');
			$form->removeElement('siteslideshow_bordactive');
		}
		else {
			$form->removeElement('siteslideshow_blinds');
			$form->removeElement('siteslideshow_interval');
			$form->removeElement('siteslideshow_progressbar');
		}

		//IF FOR IS SUBMITTED SUCCESSFULLY
		if( $this->getRequest()->isPost()&& $form->isValid($this->getRequest()->getPost())) {

			$values = $this->getRequest()->getPost();
			$siteslideshow_admin_tab = 'slideshow_settings';
				
			//IF ADMIN CLICK ON SET DEFAUTL BUTTON THAN SET DEFATULT VALUES
			if(isset($_POST['default']) == 1) {
				$form->removeElement('siteslideshow_color1');
				$form->removeElement('siteslideshow_color2');
				$form->removeElement('siteslideshow_transition1');
				$form->removeElement('siteslideshow_overlap');

				//$values['siteslideshow_field_cat'] = 1;
				$values['siteslideshow_visibility'] = 2;
				$values['siteslideshow_height'] = 250;
				$values['siteslideshow_width'] = 523;
				$values['siteslideshow_target'] = 0;
				$values['siteslideshow_type'] = 'fadd';
				$values['siteslideshow_backcolor'] = '#ffffff';
				$values['siteslideshow_bordcolor'] = '#DDDDDD';
				$values['siteslideshow_bordactive'] = '#E9F4FA';
				$values['siteslideshow_caption'] = 1;
				$values['siteslideshow_position_caption'] = 1;
				$values['siteslideshow_colorback_caption'] = '#000000';
				$values['siteslideshow_controller'] = 1;
				$values['siteslideshow_delay'] = 2000;
				$values['siteslideshow_duration'] = 750;
				$values['siteslideshow_thumb'] = 1;
				$values['siteslideshow_title'] = 1;
				$values['siteslideshow_random'] = 0;
				$values['siteslideshow_start_index'] = 0;
			}
			else { //ELSE GET SELECTED VALUES
				$values = $this->getRequest()->getPost();
				
				if($values['siteslideshow_type'] != 'flom')
				{
					$is_error = 0;
					$table   = Engine_Api::_()->getDbTable('images', 'siteslideshow');
					$select  = $table->select()
													->setIntegrityCheck(false)
													->from($table->info('name'));
					$paginator = Zend_Paginator::factory($select);
					$total_images = $paginator->getTotalItemCount();

					if($total_images > 0) {
						if($values['siteslideshow_random'] == 0 && (($values['siteslideshow_start_index']) > ($total_images - 1) || ($values['siteslideshow_start_index']) < 0))
							$is_error = 1;

						if ($is_error == 1) {
							$error = $this->translate('The starting index cannot be negative and can at maximum be one less that the number of slides.');
							$error = Zend_Registry::get('Zend_Translate')->_($error);
							$form->getDecorator('errors')->setOption('escape', false);
							$form->addError($error);
							return;
						}
					}
				}
			}
			//POPULATE FORM
			$form->populate($values);
		
			//SAVE VALUES IN DATABASE
			include_once(APPLICATION_PATH ."/application/modules/Siteslideshow/controllers/license/license2.php");
		}
  }
  
	//ACTION FOR PREVIEW OF SLIDESHOW ON CURRENTLY SELECTED FIELDS
  public function previewAction()
  {
		//GET PREVIEW IMAGES
  	$this->_helper->layout->setLayout('admin-simple');
  	$table   = Engine_Api::_()->getDbTable('images', 'siteslideshow');
    $select  = $table->select()
										 ->setIntegrityCheck(false)
										 ->from($table->info('name'))
										 ->where('enabled = ?', 1)
										 ->order('order ASC')
										 ->order('image_id DESC');
    
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->total_images = $paginator->getTotalItemCount();
		$paginator->setItemCountPerPage(5000);

		//CORE MODULE VERSION
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
		$this->view->oldversion = 0;
    if($coreversion < '4.2.2') {
			$this->view->oldversion = 1;
    }

		if( $this->view->total_images == 0) {
			$this->view->error = 2;
			return;
		}

		if($_GET['type'] != 'flom') {
			//GET THUMBNAIL BORDER COLOR
			$this->view->start_index = $_GET['start_index'];

			//GET RANDOM SETTING
			$random = $_GET['random'];
			if($random && $this->view->total_images > 1) {
				$this->view->random = 'true';
			}
			else {
				$this->view->random = 'false';
			}

			if($random == 0 && (($this->view->total_images-1) < ($this->view->start_index) || $this->view->start_index < 0)) {
				$this->view->error = 1;
				return;
			}
		}

    if( $this->view->total_images <= 0 ) {
      return $this->setNoRender();
    }
    
    //GET SLIDESHOW HIGHT
    $this->view->height = $_GET['height'];
    
    //GET SLIDESHOW WIDTH
    $this->view->width = $_GET['width'];

		//GET TARGET SETTING
		$this->view->target = $_GET['target'];

		$this->view->thumb_width = (int)($this->view->width/$this->view->total_images);

		//GET CAPTION SETTING
		$caption = $_GET['caption'];
		if($caption) {
			$this->view->caption = 'true';
		}
		else {
			$this->view->caption = 'false';
		}

		//GET CAPTION POSITION
		$this->view->position_caption = $_GET['position_caption'];

		//GET CAPTION BACKGROUND COLOR
		$this->view->colorback_caption = urldecode($_GET['colorback_caption']);

		//GET TYPE OF SLIDE SHOW
    $this->view->type = $_GET['type'];

		if($this->view->type == 'flom') {
			$this->view->blinds = $_GET['blinds'];
			$this->view->interval = $_GET['interval'];
			$progressbar = $_GET['progressbar'];
			if($progressbar) {
				$this->view->progressbar = 'true';
			}
			else {
				$this->view->progressbar = 'false';
			}
		}
		else {
			//GET THUMBNAIL BACKGROUND COLOR
			$this->view->thumb_back_color = urldecode($_GET['thumb_back_color']);

			//GET THUMBNAIL BORDER COLOR
			$this->view->thumb_bord_color = urldecode($_GET['thumb_bord_color']);

			//GET ACTIVE THUMBNAIL BOARDER COLOR
			$this->view->thumb_bord_active = urldecode($_GET['thumb_bord_active']);

			//IF SLIDETYPE IS FLASH THAN GET COLOR ALSO
			if($_GET['type'] == 'flas') {
				$this->view->color1 = urldecode($_GET['color1']);
				$this->view->color2 = urldecode($_GET['color2']);
			}

			//IF SLIDETYPE IS PUSH AND FOLD THAN ADD TRANSITION TYPE
			if($_GET['type'] == 'fold' || $_GET['type'] == 'push') {
				$this->view->transition = $_GET['transition'];

				//GET OVERLAP SETTING
				$overlap = $_GET['overlap'];
				if($overlap) {
					$this->view->overlap = 'true';
				}
				else {
					$this->view->overlap = 'false';
				}
			}
			
			//GET CONTROLLER SETTING
			$controller = $_GET['controller'];
			if($controller) {
				$this->view->controller = 'true';
			}
			else {
				$this->view->controller = 'false';
			}
			
			//GET DEALY TIME
			$this->view->delay = $_GET['delay'];
			
			//GET DURATION TIME
			$this->view->duration = $_GET['duration'];

			//GET THUMBNAIL SETTING
			$thumb = $_GET['thumb'];
			if($thumb) {
				$this->view->thumb = 'true';
			}
			else {
				$this->view->thumb = 'false';
			}
			
			//GET TITLE SETTING
			$title = $_GET['title'];
			if($title) {
				$this->view->title = 'true';
			}
			else {
				$this->view->title = 'false';
			}
		}
  }
  
	//ACTION FOR DEMO OF SLIDESHOW
  public function demoAction()
  {
		//GET NAVIGATION
  	$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      	 ->getNavigation('siteslideshow_admin_main', array(), 'siteslideshow_admin_main_demo');
    
		//GENERATE FORM
    $this->view->form = $form = new Siteslideshow_Form_Admin_Demo();

		//CORE MODULE VERSION
    $coremodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('core');
    $coreversion = $coremodule->version;
		$this->view->oldversion = 0;
    if($coreversion < '4.2.2') {
			$this->view->oldversion = 1;
    } 
		
		//GET SLIDESHOW TYPE
		$slide_type = $this->_getParam('type');
		if(!empty($slide_type)) {
			$this->view->type = $slide_type;
		}
		else {
			$this->view->type = 'fadd';
		}

		$this->view->height = 275;
		$this->view->width = 938;
		$this->view->caption = 'true';

		if($this->view->type == 'flom') {
			$this->view->blinds = 24;
			$this->view->interval = 8000;
			$this->view->progressbar = 'true';
		}
		else {
			//CHECHK THAT THUMBNAIL IS VISIBLE OR NOT
			$show_thumb = $this->_getParam('thumb');
			if(!empty($slide_type)) {
				if($show_thumb)
					$this->view->thumb = 'false';
				else
					$this->view->thumb = 'true';
			}
			else {
				$this->view->thumb = 'true';
			}
			//SET OTHER DEFAULT SETTING
			$this->view->visibility = 2;
			$this->view->controller = 'true';
			$this->view->delay = 2000;
			$this->view->duration = 750;
			$this->view->title = 'true';
			$this->view->overlap = 'true';
			$this->view->random = 'false';
			$this->view->color1 = '#EC2415';
			$this->view->color2 = '#7EBBFF';
			$this->view->start_index = 0;
			$this->view->thumb_back_color = '#ffffff';
			$this->view->thumb_bord_color = '#DDDDDD';
			$this->view->thumb_bord_active = '#E9F4FA';
			$this->view->thumb_width = 188;
			$values['siteslideshow_thumb'] = $this->_getParam('thumb');
		}
		//ADD THIS TWO VALUES IN $values ARRAY TO SHOW PREFIELD
		$values['siteslideshow_type'] = $this->_getParam('type');
		
		//POPULATE FORM
		$form->populate($values);
			
    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
    	$values = $form->getValues();

			//CHECK THAT WHICH TYPE OF SLIDESHOW WE HAVE TO SHOW AND THUMBNAIL IS VISIBLE OR NOT
			$type = $values['siteslideshow_type'];
			if($type == 'floom') {
				$this->_redirect('admin/siteslideshow/slideshows/demo/type/'.$type);
			}
			else {
				$thumb = $values['siteslideshow_thumb'];
				$this->_redirect('admin/siteslideshow/slideshows/demo/type/'.$type.'/thumb/'.$thumb);
			}
		}
  }
}
?>
