<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestore
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2013-09-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestore_Widget_PhotolightboxAdsController extends Engine_Content_Widget_Abstract {

  public function indexAction() {

		//COMMUNITY-ADS IS ENABLED OR NOT
    $enable_ads = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('communityad');
    if (!$enable_ads) {
      return $this->setNoRender();
    }

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestore.communityads', 1)) {
      return $this->setNoRender();
    }

		//GET TAB ID AND VIEWER DETAIL
    $this->view->tab = $tab = $this->_getParam('tab', null);
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->user_id = $viewer->getIdentity();

    $params = array();
    $params['lim'] = $this->_getParam('limit', null);
    $ad_type = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestore.adtype', 3);

    switch ($ad_type) {
      case 0:
        $params['sponsored'] = 1;
        $params['featured'] = 1;
        break;

      case 1:
        $params['featured'] = 1;
        break;

      case 2:
        $params['sponsored'] = 1;
        break;

      case 3:
        break;
    }

    if (Engine_Api::_()->core()->hasSubject()) {
      $subject = Engine_Api::_()->core()->getSubject();
      Engine_Api::_()->core()->clearSubject();
    }
    $fetch_community_ads = Engine_Api::_()->communityad()->getAdvertisement($params);

    if (!empty($subject)) {
      Engine_Api::_()->core()->clearSubject();
      Engine_Api::_()->core()->setSubject($subject);
    }

    if (!empty($fetch_community_ads)) {
      $this->view->communityads_array = $fetch_community_ads;
    } else {
      return $this->setNoRender();
    }
  }

}
?>