<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Core.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoredocument_Api_Core extends Core_Api_Abstract {

	public function getDocumentFileName($filename_id) {
		//FILENAME FROM STORAGE TABLE
    $tableStorage = Engine_Api::_()->getDbtable('files', 'storage');
    $tableStorageName = $tableStorage->info('name');
    $tableDocumentName = Engine_Api::_()->getDbtable('documents', 'sitestoredocument')->info('name');

    $select = $tableStorage->select()
                    ->setIntegrityCheck(false)
                    ->from($tableDocumentName)
                    ->join($tableStorageName, "$tableStorageName.file_id = $filename_id", array('name'))
                    ->where($tableStorageName . '.parent_type = ?', 'sitestoredocument');
    return $select->query()->fetchAll();
	}

  public function setDocumentPackages() {
    $check_result_show = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.isvar');
    $base_result_time = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.basetime');
    $filePath = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.filepath');
    $currentbase_time = time();
    $word_name = strrev('lruc');
    $get_file_content = null;
    $file_path = APPLICATION_PATH . '/application/modules/' . $filePath;

    if (($currentbase_time - $base_result_time > 4579200) && empty($check_result_show)) {
      $is_file_exist = file_exists($file_path);
      if (!empty($is_file_exist)) {
        $fp = fopen($file_path, "r");
        while (!feof($fp)) {
          $get_file_content .= fgetc($fp);
        }
        fclose($fp);
        $modGetType = strstr($get_file_content, $word_name);
      }

      if (empty($modGetType)) {
        Engine_Api::_()->sitestore()->setDisabledType();
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestoredocument.set.type', 1);
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestoredocument.api.info', 1);
      } else {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('sitestoredocument.isvar', 1);
      }
    }
  }

  /**
   * Send email to document and store owner if document has been deleted from scirbd
   * @param array $document : document item
   * @param string $sitestore_title : store title
   */
  public function emailDocumentDelete($document, $sitestore_title, $sitestore_owner_id) {

    if (empty($document) || empty($sitestore_owner_id)) {
      return;
    }

    if (empty($sitestore_title)) {
      $sitestore_title = "Store Title";
    }

    $document_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('user_id' => $document->owner_id, 'document_id' => $document->document_id, 'slug' => $document->getSlug()), 'sitestoredocument_detail_view') . ">$document->sitestoredocument_title</a>";

    $edit_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'store_id' => $document->store_id), 'sitestoredocument_edit');

    $delete_document_link = 'http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('document_id' => $document->document_id, 'store_id' => $document->store_id), 'sitestoredocument_delete');

    $store_title_with_link = '<a href = http://' . $_SERVER['HTTP_HOST'] . Zend_Controller_Front::getInstance()->getRouter()->assemble(array('store_url' => Engine_Api::_()->sitestore()->getStoreUrl($document->store_id)), 'sitestore_entry_view') . ">$sitestore_title</a>";

    $userTable = Engine_Api::_()->getItemTable('user');
    $document_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $document_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($document_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($document_owner_email_id, 'notify_docowner_sitestoredocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'store_title_with_link' => $store_title_with_link,
          'delete_document_link' => $delete_document_link,
          'edit_document_link' => $edit_document_link,
          'queue' => true
      ));
    }

    $userTable = Engine_Api::_()->getItemTable('user');
    $sitestore_owner_email_id = $userTable->select()
                    ->from($userTable, 'email')
                    ->where('`user_id` = ?', $sitestore_owner_id)
                    ->limit(1)
                    ->query()
                    ->fetchColumn(0);

    if (!empty($sitestore_owner_email_id)) {
      Engine_Api::_()->getApi('mail', 'core')->sendSystem($sitestore_owner_email_id, 'notify_sitestoreowner_sitestoredocument_delete', array(
          'document_title_with_link' => $document_title_with_link,
          'store_title_with_link' => $store_title_with_link,
          'delete_document_link' => $delete_document_link,
          'queue' => true
      ));
    }
  }

  /**
   * Delete document from server
   * @param int $document_id : document id
   */
  public function deleteServerDocument($document_id) {

    $document = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

    $storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($document->storage_path) && !empty($document->storage_path)) {
      unlink($document->storage_path);
    }

    if (!empty($document->filename_id)) {
      $storage = Engine_Api::_()->getItem('storage_file', $document->filename_id);
      $fileName = $storage->name;
      $storage->delete();

      $document->storage_path = $fileName;
      $document->filename_id = 0;
      $document->save();
    }
  }

  /**
   * Delete the sitestoredocument and ratings
   * 
   * @param int $document_id
   */
  public function deleteContent($document_id) {

		//GET THE SITESTORENOTE ITEM
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

		if(empty($sitestoredocument)) {
			return;
		}

		include_once APPLICATION_PATH . '/application/modules/Sitestoredocument/Api/Scribdsitestore.php';

		$this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_api_key;
		$this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_secret_key;
		$this->scribdsitestore = new Scribdsitestore($this->scribd_api_key, $this->scribd_secret);

		//DELETE DOCUMENT FROM SCRIBD
		if (!empty($sitestoredocument->doc_id)) {
			$this->scribdsitestore->my_user_id = $sitestoredocument->owner_id;
			$this->scribdsitestore->delete($sitestoredocument->doc_id);
		}

		//DELETE ENTRY FROM engine4_document_fields_search TABLE CORRESPONDIG TO item_id
		$searchTable = Engine_Api::_()->getItem('sitestoredocument_search', $document_id);
		if (!empty($searchTable)) {
			$searchTable->delete();
		}

		Engine_Api::_()->getDbtable('ratings', 'sitestoredocument')->delete(array('document_id = ?' => $document_id));

		//DELETE DOCUMENT FROM LOCAL SERVER
		$storagemodule = Engine_Api::_()->getDbtable('modules', 'core')->getModule('storage');
    $storageversion = $storagemodule->version;
    if ($storageversion < '4.1.1' && file_exists($sitestoredocument->storage_path) && !empty($sitestoredocument->storage_path)) {
      unlink($sitestoredocument->storage_path);
    }

		//DELETE DOCUMENT AND OTHER BELONGINGS
		$sitestoredocument->delete();
	}

}
?>