<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestore
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoredocument_Plugin_Menus {

  public function canViewDocuments() {

    if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.document.show.menu', 1)) {
      return false;
    }

    $table = Engine_Api::_()->getDbtable('documents', 'sitestoredocument');
    $rName = $table->info('name');
    $table_stores = Engine_Api::_()->getDbtable('stores', 'sitestore');
    $rName_stores = $table_stores->info('name');
    $select = $table->select()
                    ->setIntegrityCheck(false)
                    ->from($rName_stores, array(''))
                    ->join($rName, $rName . '.store_id = ' . $rName_stores . '.store_id')
                    ->where($rName .'.approved = ?', 1)
										->where($rName .'.draft = ?', 0)
										->where($rName .'.status = ?', 1)
										->where($rName .'.search = ?', 1);
    $select = $select
                    ->where($rName_stores . '.closed = ?', '0')
                    ->where($rName_stores . '.approved = ?', '1')
                    ->where($rName_stores . '.search = ?', '1')
                    ->where($rName_stores . '.declined = ?', '0')
                    ->where($rName_stores . '.draft = ?', '1');
    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
      $select->where($rName_stores . '.expiration_date  > ?', date("Y-m-d H:i:s"));
    }
    $row = $table->fetchAll($select);
    $count = count($row);
    if (empty($count)) {
      return false;
    }
    return true;
  }

   //ADD STORE DOCUMENT LISTING LINK
  public function onMenuInitialize_SitestoredocumentGutterStore() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITESTOREDOCUMENT SUBJECT
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);   

    if ($sitestoredocument->getType() !== 'sitestoredocument_document') {
      return false;
    }

   $store_url = $sitestore->getHref(array('tab' => $tab_selected_id));

    //RETURN BACK TO STORE LINK
    return array(
        'class' => 'buttonlink  icon_sitestoredocument_back',
        'uri' =>  $store_url
        
    );
  }

	//ADD STORE DOCUMENT PUBLISH LINK
  public function onMenuInitialize_SitestoredocumentGutterPublish() {

		//GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITESTOREDOCUMENT SUBJECT
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitestoredocument->getType() !== 'sitestoredocument_document' || empty($viewer_id) || empty($sitestoredocument->draft)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) || ($viewer_id != $sitestoredocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitestoredocument_publish',
        'route' => 'sitestoredocument_publish',
        'params' => array(
            'document_id' => $sitestoredocument->getIdentity(),
						'tab' => $tab_selected_id
        ),
    );
  }

	//ADD STORE DOCUMENT EDIT LINK
  public function onMenuInitialize_SitestoredocumentGutterEdit($row) {

		 //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
   
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);

    //GETTING THE SITEPAG SUBJECT
    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitestoredocument->getType() !== 'sitestoredocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitestoredocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitestoredocument_edit',
        'route' => 'sitestoredocument_edit',
        'params' => array(
						'document_id' => $sitestoredocument->getIdentity(),
						'store_id' => $sitestoredocument->store_id,
						'tab' => $tab_selected_id
        ),
    );
  }


//ADD STORE DOCUMENT SUGGESTION LINK	
  public function onMenuInitialize_SitestoredocumentGutterSuggest($row) {

		$sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $store_subject = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);      

		// Start: Show "Suggest to Frind" link.
    $store_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestore');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitestore')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitestore')->deleteSuggestion($viewer_id, 'store_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'store_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitestoredocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
        if ($store_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $store_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($store_subject->closed) && !empty($store_subject->approved) && empty($store_subject->declined) && !empty($store_subject->draft) && empty($store_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitestore', 'document_sugg_link');
      }
    }
    else {
     return false;   
  
    }
 
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    if( empty($documentSuggLink) && !empty($sitestoredocument->draft) && empty($sitestoredocument->approved) && empty($sitestoredocument->status) )  {
      return false;
    }
 
    // End: "Suggest to Friend" link work

   return array(
				'class' => 'buttonlink icon_store_friend_suggestion smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'suggestion',
						'controller' => 'index',
						'action' => 'switch-popup',
						'modContentId' => $sitestoredocument->document_id,
						'modName' => 'store_document',
						'format' => 'smoothbox',
				),
    );
  }


//ADD DOCUMENT DELETE LINK
  public function onMenuInitialize_SitestoredocumentGutterDelete() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITESTORE SUBJECT
    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);   

    //START MANAGE-ADMIN CHECK
		$isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitestoredocument->getType() !== 'sitestoredocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_edit) && ($viewer_id != $sitestoredocument->owner_id)) {
			return false;
		}

    return array(
        'class' => 'buttonlink  icon_sitestoredocument_delete',
        'route' => 'sitestoredocument_delete',
        'params' => array(
								'document_id' => $sitestoredocument->getIdentity(),
								'store_id' => $sitestoredocument->store_id,
								'tab' => $tab_selected_id
        ),
    );
  }


  //ADD DOCUMENT OF THE DAY LINK
  public function onMenuInitialize_SitestoredocumentGutterDocumentofday() {

    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();    
 
    //GETTING THE TAB ID
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    //GETTING THE SITESTORE SUBJECT
    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);   

    $allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $allowView = $auth->isAllowed($sitestore, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitestore, 'registered', 'view') === 1 ? true : false;
    } 

    if(empty($allowView)) {
      return false;
   }

    return array(
				'class' => 'buttonlink item_icon_sitestoredocument_detail smoothbox',
				'route' => 'default',
				'params' => array(
						'module' => 'sitestoredocument',
						'controller' => 'index',
						'action' => 'add-document-of-day',
						'document_id' => $sitestoredocument->document_id,
						'format' => 'smoothbox',
				),
    );
  }


  //ADD STORE DOCUMENT ADD LINK
  public function onMenuInitialize_SitestoredocumentGutterAdd() {
   
    //GETTING THE VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();      
    $tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);  
		$sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));

    $sitestore = Engine_Api::_()->getItem('sitestore_store', $sitestoredocument->store_id);  
 
    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore, 'sdcreate');
    if (empty($isManageAdmin)) {
      $can_create = 0;
    } else {
      $can_create = 1;
    }
    //END MANAGE-ADMIN CHECK

    if ($sitestoredocument->getType() !== 'sitestoredocument_document' || empty($viewer_id)) {
      return false;
    }

    //USER IS ALLOWED FOR DELETE OR NOT
		if(empty($can_create)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitestoredocument_new',
        'route' => 'sitestoredocument_create',
        'params' => array(
								'store_id' => $sitestoredocument->store_id,
								'tab' => $tab_selected_id
        ),
    );
  }


	//ADD DOCUMENT SHARE LINK
  public function onMenuInitialize_SitestoredocumentGutterShare() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

		//SHARING IS ALLOWED OR NOT
    $can_share = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.share', 1);

		//CAN SHARE OR NOT
    if (empty($sitestoredocument) || empty($viewer_id) || $sitestoredocument->draft == 1 || empty($sitestoredocument->approved) || $sitestoredocument->status != 1 || empty($can_share)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_share',
        'route' => 'default',
        'params' => array(
            'module' => 'activity',
            'controller' => 'index',
            'action' => 'share',
            'type' => 'sitestoredocument_document',
            'id' => $sitestoredocument->getIdentity(),
            'format' => 'smoothbox',
        ),
    );
  }

	//ADD DOCUMENT DOWNLOAD LINK
  public function onMenuInitialize_SitestoredocumentGutterDownload($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitestoredocument) || empty($viewer_id)) {
      return false;
    }

		//DOWNLOAD IS ALLOWED OR NOT FOR THIS LEVEL
		$view_download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.download.allow', 1);
		if(empty($view_download_allow) || empty($sitestoredocument->download_allow)) {
			return false;
		}

		//GET SCRIBD DETAIL
    $scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_api_key;
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_secret_key;
    $scribd = new Scribdsitestore($scribd_api_key, $scribd_secret);

    //SET SCRIBD USER ID
    $scribd->my_user_id = $sitestoredocument->owner_id;

		//DOCUMENT FORMAT FOR THIS LEVEL
		$download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.download.format', 'pdf');
		$link = '';
		try {
			$link = $scribd->getDownloadUrl($sitestoredocument->doc_id, $download_format);
			$link = trim($link['download_link']);
		} catch (Exception $e) {
			$this->view->excep_message = $message = $e->getMessage();
			$this->view->excep_error = 1;
		}

		if(empty($link)) {
			return false;
		}

    return array(
        'class' => 'buttonlink icon_sitestoredocument_download',
				'uri' => $link,
				'target' => '_blank'
    );
  }

	//ADD DOCUMENT EMAIL LINK
  public function onMenuInitialize_SitestoredocumentGutterEmail($row) {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

		//AUTORIZATION CHECKS
    if (empty($sitestoredocument) || empty($viewer_id) || $sitestoredocument->status != 1) {
      return false;
    }

		//EMAIL IS ALLOWED OR NOT
		$view_email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.email.allow', 1);
		if(empty($view_email_allow) || empty($sitestoredocument->email_allow)) {
			return false;
		}

    return array(
        'class' => 'buttonlink smoothbox icon_sitestoredocuments_email',
        'route' => 'default',
        'params' => array(
            'module' => 'sitestoredocument',
            'controller' => 'index',
            'action' => 'email',
            'id' => $sitestoredocument->getIdentity(),
        ),
    );
  }


	//ADD DOCUMENT REPORT LINK
  public function onMenuInitialize_SitestoredocumentGutterReport() {

		//GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
		$viewer_id = $viewer->getIdentity();

		//GET OBJECT
		$document_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id');
    $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $document_id);

		//CAN REPORT OR NOT
    if (empty($viewer_id) || empty($sitestoredocument)) {
      return false;
    }

		//REPORTING IS ALLOWED OR NOT
    $report = (int) Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.report', 1);
    if (empty($report)) {
      return false;
    }

    return array(
        'class' => 'smoothbox buttonlink seaocore_icon_report',
        'route' => 'default',
        'params' => array(
            'module' => 'core',
            'controller' => 'report',
            'action' => 'create',
            'subject' => $sitestoredocument->getGuid(),
            'format' => 'smoothbox',
        ),
    );
  }

}
?>