<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminFieldsController.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoredocument_AdminFieldsController extends Fields_Controller_AdminAbstract {

  protected $_fieldType = 'sitestoredocument_document';
  protected $_requireProfileType = false;

  //ACTION FOR SHOW CUSTOM FIELDS
  public function indexAction() {

    $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_admin_main', array(), 'sitestore_document_admin_main_settings');
     $this->view->navigationSubStore = Engine_Api::_()->getApi('menus', 'core')->getNavigation('sitestore_document_admin_main', array(), 'sitestoredocument_admin_sub_settings');
    
    //GET NAVIGATION
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                    ->getNavigation('sitestoredocument_admin_main', array(), 'sitestoredocument_admin_main_fields');
    include APPLICATION_PATH . '/application/modules/Sitestoredocument/controllers/license/license2.php';
  }

  //ACTION FOR CREATE CUSTOM FIELDS
  public function fieldCreateAction() {

    parent::fieldCreateAction();

    //REMOVE STUFF ONLY RELAVENT TO PROFILE QUESTIONS
    $form = $this->view->form;

    if ($form) {
      $form->setTitle('Add Store Document Question');

      $form->removeElement('show');

      $display = $form->getElement('display');
      $display->setLabel('Show on document store?');
      $display->setOptions(array('multiOptions' => array(
              1 => 'Show on document store',
              0 => 'Hide on document store'
              )));

      //$search = $form->getElement('search');
      $form->addElement('hidden', 'search', array(
          'label' => 'Show on the search options?',
          'multiOptions' => array(
              1 => 'Hide on the search options',
              0 => 'Show on the search options'
          ),
          'value' => 1,
      ));
    }
  }

  //ACTION FOR EDIT CUSTOM FIELDS
  public function fieldEditAction() {

    parent::fieldEditAction();

    //REMOVE STUFF ONLY RELAVENT TO PROFILE QUESTIONS
    $form = $this->view->form;

    if ($form) {
      $form->setTitle('Edit Store Document Question');

      $form->removeElement('show');

      $display = $form->getElement('display');
      $display->setLabel('Show on document store?');
      $display->setOptions(array('multiOptions' => array(
              1 => 'Show on document store',
              0 => 'Hide on document store'
              )));

      //$search = $form->getElement('search');
      $form->addElement('hidden', 'search', array(
          'label' => 'Show on the search options?',
          'multiOptions' => array(
              1 => 'Hide on the search options',
              0 => 'Show on the search options'
          ),
          'value' => 1,
      ));
    }
  }

}
?>