<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$isActive = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.isActivate', 0);
if ( empty($isActive) ) {
  return;
}

$categories = Engine_Api::_()->getDbTable('categories', 'sitestore')->getCategories();
if (count($categories) != 0) {
  $categories_prepared[0] = "";
  foreach ($categories as $category) {
    $categories_prepared[$category->category_id] = $category->category_name;
  }
}

$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => 'Store Profile Documents',
        'description' => 'This widget forms the Documents tab on the Store Profile and displays the documents of the Store. It should be placed in the Tabbed Blocks area of the Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.profile-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Documents',
        ),
    ),
    array(
        'title' => 'Store Profile Recent Documents',
        'description' => 'Displays list of Store’s recent documents. This widget should be placed on Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.recent-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Recent Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Store Profile Popular Documents',
        'description' => 'Displays list of store’s most viewed documents. This widget should be placed on Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.popular-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Store Profile Most Commented Documents',
        'description' => 'Displays list of store’s most commented documents. This widget should be placed on the Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.comment-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Store Profile Most Liked Documents',
        'description' => 'Displays list of store’s most liked documents. This widget should be placed on the Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.like-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Store Profile Top Rated Documents',
        'description' => 'Displays list of store’s top rated documents. This widget should be placed on Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.rate-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    array(
        'title' => 'Store Profile Featured Documents',
        'description' => 'Displays list of store’s featured documents. This widget should be placed on Store Profile.',
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.featurelist-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),

    array(
        'title' => 'Recent Documents',
        'description' => 'Displays the recent documents of the site.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homerecent-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Recent Documents'
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
	array(
		'title' => 'Store Document Social Share Buttons Buttons',
		'description' => "Contains Social Sharing buttons and enables users to easily share Store Documents on their favorite Social Networks. This widget should be placed on the Store Document View Page. You can customize the code for social sharing buttons from Global Settings of this plugin by adding your own code generated from: <a href='http://www.addthis.com' target='_blank'>http://www.addthis.com</a>",
		'category' => 'Stores',
		'type' => 'widget',
		'name' => 'sitestoredocument.socialshare-sitestoredocuments',
		'defaultParams' => array(
				'title' => 'Social Share',
				'titleCount' => true,
		),
    'requirements' => array(
      'subject' => 'sitestoredocument',
    ),
		'adminForm' => array(
			'elements' => array(
				array(
						'Hidden',
						'nomobile',
						array(
								'label' => '',
                                'order' => 1009
						)
				),
			),
		),
	),
    array(
        'title' => 'Recent Documents from Store',
        'description' => 'Displays recent Store Documents corresponding to the Store of which the document is being viewed. You can choose the number of entries to be shown. This widget should be placed on Store Document View Page.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.viewrecent-sitestoredocuments',
        'defaultParams' => array(
            'title' => ''
        ),
         'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

    array(
			'title' => 'Search Store Documents form',
			'description' => 'Displays the form for searching Store Documents on the basis of various filters. You can edit the fields to be available in this form.',
			'category' => 'Stores',
			'type' => 'widget',
			'name' => 'sitestoredocument.search-sitestoredocument',
			'defaultParams' => array(
					'title' => '',
          'search_column' => array("0" => "1", "1" => "2", "2" => "3", "3" => "4", "4" => '5', "5" => "6"),
					'titleCount' => true,

			),
			'adminForm' => array(
              'elements' => array(
							array(
									'MultiCheckbox',
									'search_column',
									array(
											'label' => 'Choose the fields that you want to be available in the Search Store Documents form widget.',
											'multiOptions' => array("1" => "Show","2" => "Browse By", "3" => "Store Title", "4" => "Document Title", "5" => "Store Category", "6" => "Document Category"),
									),
							),
					),
			)
    ),

     array(
        'title' => 'Store Documents',
        'description' => 'Displays the list of Documents from Stores created on your community. This widget should be placed in the widgetized Store Documents store. Results from the Search Store Documents form are also shown here.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.sitestore-document',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 20,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
            ),
        ),
    ),
    
    array(
        'title' => 'Sponsored Documents',
        'description' => 'Displays the Documents from Paid Stores. You can choose the number of entries to be shown.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.sitestore-sponsoreddocument',
        'defaultParams' => array(
            'title' => 'Sponsored Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'itemCount',
                    array(
                        'label' => 'Count',
                        'description' => '(number of documents to show)',
                        'value' => 3,
												'validators' => array(
													array('Int', true),
													array('GreaterThan', true, array(0)),
												),
                    ),
                ),
                array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
						    ),
            ),
        ),
    ),
 
    array(
        'title' => 'Featured Documents',
        'description' => "Displays Featured Store Documents. You can mark Store Documents as Featured from the “Manage Store Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homefeaturelist-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
   
//     array(
//         'title' => 'Highlighted Documents',
//         'description' => "Displays Highlighted Store Documents. You can mark Store Documents as Highlighted from the “Manage Store Documents” section in the Admin Panel of this extension. You can choose the number of entries to be shown.",
//         'category' => 'Stores',
//         'type' => 'widget',
//         'name' => 'sitestoredocument.homehighlightlist-sitestoredocuments',
//         'defaultParams' => array(
//             'title' => 'Highlighted Documents',
//             'titleCount' => true,
//         ),
//         'adminForm' => array(
// 					'elements' => array(
// 						array(
// 								'Text',
// 								'itemCount',
// 								array(
// 										'label' => 'Count',
// 										'description' => '(number of documents to show)',
// 										'value' => 3,
// 										'validators' => array(
// 											array('Int', true),
// 											array('GreaterThan', true, array(0)),
// 										),
// 								),
// 						),
// 					),
//         ),
//     ),

    array(
        'title' => 'Most Commented Documents',
        'description' => "Displays the Most Commented Store Documents. You can choose the number of entries to be shown.",
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homecomment-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Commented Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
    
     array(
        'title' => 'Most Popular Documents',
        'description' => "Displays the Most Viewed Store Documents. You can choose the number of entries to be shown.",
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homepopular-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Popular Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),
 
    array(
        'title' => 'Most Liked Documents',
        'description' => "Displays the Most Liked Store Documents. You can choose the number of entries to be shown.",
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homelike-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Most Liked Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

    array(
        'title' => 'Top Rated Documents',
        'description' => "Displays the Top Rated Store Documents. You can choose the number of entries to be shown.",
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.homerate-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Top Rated Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    ),

	array(
			'title' => 'Store Document View',
			'description' => "This widget should be placed on the Store Document View Page.",
      'category' => 'Stores',
			'type' => 'widget',
			'name' => 'sitestoredocument.document-content',
			'defaultParams' => array(
					'title' => '',
					'titleCount' => true,
			),
	),

  array(
			'title' => 'Store Document View Options',
			'description' => 'Displays various action link options to users viewing a Store Document. This Widget should be placed on the Store Document View Page in the right column, below the Store Document\'s Owner Photo.',
			'category' => 'Stores',
			'type' => 'widget',
			'name' => 'sitestoredocument.options-documents',
			'requirements' => array(
				'subject' => 'sitestoredocument_document',
			),
	),

  array(
			'title' => 'Store Document\'s Owner Photo',
			'description' => 'Displays store owner\'s photo with store owner\'s name to users viewing Store Document. This widget should be placed on Store Document View Page.',
			'category' => 'Stores',
			'type' => 'widget',
			'name' => 'sitestoredocument.document-owner-photo-documents',
			'requirements' => array(
				'subject' => 'sitestoredocument_document',
			),
	),

  array(
        'title' => 'Document of the Day',
        'description' => 'Displays the Document of the Day as selected by the Admin from the widget settings section of Stores / Marketplace - Documents Extension.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.document-of-the-day',
        'defaultParams' => array(
            'title' => 'Document of the Day'
        ),
    ),

     array(
        'title' => 'Store’s Featured Documents Slideshow',
        'description' => 'Displays featured documents in an attractive slideshow. You can set the count of the number of documents to show in this widget. If the total number of documents featured are more than that count, then the documents to be displayed will be sequentially picked up.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.featured-documents-slideshow',
        'isPaginated' => true,
        'defaultParams' => array(
            'title' => 'Featured Documents',
            'itemCountPerStore' => 10,
        ),
        'adminForm' => array(
					'elements' => array(
							array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
			),
    ),

    array(
        'title' => 'Store’s Featured Documents Carousel',
        'description' => 'This widget contains an attractive AJAX based carousel, showcasing the featured documents on the site. Multiple settings of this widget makes it highly configurable.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.featured-documents-carousel',
        'defaultParams' => array(
            'title' => 'Featured Documents',
        ),
        'adminForm' => array(
            'elements' => array(
                array(
										'Select',
										'category_id',
										array(
												'label' => 'Category',
												'multiOptions' => $categories_prepared,
										)
								),
                array(
                    'Radio',
                    'vertical',
                    array(
                        'label' => 'Carousel Type',
                        'multiOptions' => array(
                            '0' => 'Horizontal',
                            '1' => 'Vertical',
                        ),
                        'value' => 0,
                    )
                ),
                array(
                    'Text',
                    'inOneRow',
                    array(
                        'label' => 'Documents in a Row',
                        'description' => '(number of documents to show in one row. Note: This field is applicable only when you have selected ‘Horizontal’ in ‘Carousel Type’ field.)',
                        'value' => 3,
                    )
                ),
                array(
                    'Text',
                    'noOfRow',
                    array(
                        'label' => 'Rows',
                        'description' => '(number of rows in one view)',
                        'value' => 2,
                    )
                ),
                array(
                    'Text',
                    'interval',
                    array(
                        'label' => 'Speed',
                        'description' => '(transition interval between two slides in millisecs)',
                        'value' => 250,
                    )
                ),
            ),
        ),
    ),

    array(
        'title' => 'Store’s Ajax based Tabbed widget for Documents',
        'description' => 'Displays the Recent, Most Liked, Most Viewed, Most Commented and Featured Documents in separate AJAX based tabs. Settings for this widget are available in the Widget Settings section of Stores / Marketplace - Documents Extension.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.list-documents-tabs-view',
        'defaultParams' => array(
            'title' => 'Documents',
            'margin_photo'=>12,
            'showViewMore'=>1
        ),
         'adminForm' => array(
            'elements' => array(
                array(
                    'Text',
                    'margin_photo',
                    array(
                        'label' => 'Horizontal Margin between Elements',
                        'description' => '(Horizontal margin in px between consecutive elements in this widget. You might want to change this value if the content of this widget is not coming properly on your site because of the column width in your theme.)',
                        'value' => 12,
                    )
                ),
                 array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							  ),
                 array(
                  'Radio',
                  'showViewMore',
                  array(
                      'label' => 'Show "View More" link',
                      'multiOptions' => array(
                          '1' => 'Yes',
                          '0' => 'No',
                      ),
                  )
              )
            ),
        ),
    ),
 
    array(
        'title' => 'Browse Documents',
        'description' => 'Displays the link to view Store’s Documents Browse store.',
        'category' => 'Stores',
        'type' => 'widget',
        'name' => 'sitestoredocument.sitestoredocumentlist-link',
        'defaultParams' => array(
            'title' => '',
            'titleCount' => true,
        ),
    ),

    array(
        'title' => 'Store Profile Highlighted Documents',
        'description' => "Displays list of store's highlighted documents. This widget should be placed on the Store Profile.",
        'category' => 'Store Profile',
        'type' => 'widget',
        'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
        'defaultParams' => array(
            'title' => 'Highlighted Store Documents',
            'titleCount' => true,
        ),
        'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of documents to show)',
										'value' => 3,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
					),
        ),
    ),

     array(
    'title' => 'Top Creators : Store Documents',
    'description' => 'Displays the Stores which have the most number of Store Documents added in them. Motivates Store Admins to add more content on your website.',
    'category' => 'Stores',
    'type' => 'widget',
    'name' => 'sitestoredocument.topcreators-sitestoredocument',
   // 'isPaginated' => true,
    'defaultParams' => array(
      'title' => 'Top Creators',
    ),
     'adminForm' => array(
					'elements' => array(
						array(
								'Text',
								'itemCount',
								array(
										'label' => 'Count',
										'description' => '(number of elements to show)',
										'value' => 5,
										'validators' => array(
											array('Int', true),
											array('GreaterThan', true, array(0)),
										),
								),
						),
            array(
									'Select',
									'category_id',
									array(
											'label' => 'Category',
											'multiOptions' => $categories_prepared,
									)
							),
					),
        ),
    'requirements' => array(
      'subject' => 'sitestoredocument',
    ),
  ),

)
?>