<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content_user.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
return array(
    array(
        'title' => $view->translate('Store Profile Documents'),
        'description' => $view->translate('Forms the Documents tab of your Store and shows the documents of your Store. It should be placed in the Tabbed Blocks area of the Store Profile.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.profile-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Recent Documents'),
        'description' => $view->translate('Displays recent documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.recent-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Recent Documents'),
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Popular Documents'),
        'description' => $view->translate('Displays popular documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.popular-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Popular Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Most Commented Documents'),
        'description' => $view->translate('Displays most commented documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.comment-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Commented Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Most Liked Documents'),
        'description' => $view->translate('Displays most liked documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.like-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Most Liked Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Top Rated Documents'),
        'description' => $view->translate('Displays top rated documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.rate-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Top Rated Documents'),
            'titleCount' => true,
        ),
    ),
    array(
        'title' => $view->translate('Store Profile Featured Documents'),
        'description' => $view->translate('Displays featured documents of your Store.'),
        'category' => $view->translate('Store Profile'),
        'type' => 'widget',
        'name' => 'sitestoredocument.featurelist-sitestoredocuments',
        'defaultParams' => array(
            'title' => $view->translate('Featured Documents'),
            'titleCount' => true,
        ),
    ),
    array(
			'title' => $view->translate('Store Profile Highlighted Documents'),
			'description' => $view->translate("Displays list of store's highlighted documents. This widget should be placed on the Store Profile."),
			'category' => $view->translate('Store Profile'),
			'type' => 'widget',
			'name' => 'sitestoredocument.highlightlist-sitestoredocuments',
			'defaultParams' => array(
					'title' => $view->translate('Highlighted Store Documents'),
					'titleCount' => true,
			),
			'adminForm' => array(
				'elements' => array(
					array(
							'Text',
							'itemCount',
							array(
									'label' => $view->translate('Count'),
									'description' => $view->translate('(number of documents to show)'),
									'value' => 3,
									'validators' => array(
										array('Int', true),
										array('GreaterThan', true, array(0)),
									),
							),
					),
				),
			),
    ),
)
?>