<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoredocument_Widget_DocumentContentController extends Seaocore_Content_Widget_Abstract {

  public function indexAction() {

    //SET SCRIBD API AND SCECRET KEY
    $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_api_key;
    $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_secret_key;
    $this->scribdsitestore = new Scribdsitestore($this->scribd_api_key, $this->scribd_secret);

      //GET LOGGED IN USER INFORMATION
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //GET USER LEVEL
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = Engine_Api::_()->user()->getViewer()->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET DOCUMNET MODEL
    $this->view->sitestoredocument = $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'));
    if (empty($sitestoredocument)) {
      return $this->setNoRender();
    }

    $this->view->store_id = $sitestoredocument->store_id;

    //SET STORE SUBJECT
    $sitestore_subject = null;
    //if (!Engine_Api::_()->core()->hasSubject()) {
      $store_id = $sitestoredocument->store_id;
      if (null !== $store_id) {
        $store_subject = $sitestore_subject = Engine_Api::_()->getItem('sitestore_store', $store_id);
//         if ($sitestore_subject && $sitestore_subject->getIdentity()) {
//           Engine_Api::_()->core()->setSubject($sitestore_subject);
//         }
      }
    //}
    $this->view->sitestore_subject = $sitestore_subject;
    $this->view->tab_selected_id = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab');

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitestore()->allowPackageContent($sitestore_subject->package_id, "modules", "sitestoredocument")) {
        return $this->setNoRender();
      }
    } else {
      $isStoreOwnerAllow = Engine_Api::_()->sitestore()->isStoreOwnerAllow($sitestore_subject, 'sdcreate');
      if (empty($isStoreOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //START MANAGE-ADMIN CHECK
  
    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'comment');
    if (empty($isManageAdmin)) {
      $this->view->can_comment = 0;
    } else {
      $this->view->can_comment = 1;
    }

    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'edit');
    if (empty($isManageAdmin)) {
      $can_edit = 0;
    } else {
      $can_edit = 1;
    }

    $this->view->allowView = false;
    if (!empty($viewer_id) && $viewer->level_id == 1) {
      $auth = Engine_Api::_()->authorization()->context;
      $this->view->allowView = $auth->isAllowed($sitestore_subject, 'everyone', 'view') === 1 ? true : false ||$auth->isAllowed($sitestore_subject, 'registered', 'view') === 1 ? true : false;
    } 

    //END MANAGE-ADMIN CHECK
    //DESTROY THE PREVIOUS SUBJECT
   // Engine_Api::_()->core()->clearSubject();

    if (($can_edit != 1 && $viewer_id != $sitestoredocument->owner_id) && ($sitestoredocument->draft == 1 || $sitestoredocument->status != 1 || $sitestoredocument->approved != 1 || $sitestoredocument->search != 1)) {
      return $this->setNoRender();
    }

		//SSL WORK
		$this->view->https = 0;
		if (!empty($_SERVER["HTTPS"]) && 'on' == strtolower($_SERVER["HTTPS"])) {
			$this->view->https = 1;
    }
		$this->view->manifest_path = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.manifestUrl', "store-documents");

    //CHECK THAT VIEWER CAN RATE THE DOCUMENT OR NOT
    $this->view->can_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.rating', 1);

    //GET OWNER INFORMATION
    $this->view->owner = $owner = $sitestoredocument->getOwner();

    //GET CURRENT URL
    $front = Zend_Controller_Front::getInstance();
		if(!empty($this->view->https)) {
			$curr_url = 'https://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
		else {
			$curr_url = 'http://' . $_SERVER['HTTP_HOST'] . $front->getRequest()->getRequestUri();
		}
    $this->view->curr_url = urlencode((string) $curr_url);

    //INCREMENT IN NUMBER OF VIEWS
    $owner = $sitestoredocument->getOwner();
    if (!$owner->isSelf($viewer)) {
      $sitestoredocument->views++;
    }

    //SET SCRIBD USER ID
    $this->scribdsitestore->my_user_id = $sitestoredocument->owner_id;
    Engine_Api::_()->sitestoredocument()->setDocumentPackages();

    $stat = null;
    if (!empty($sitestoredocument->doc_id)) {
      try {
        $stat = trim($this->scribdsitestore->getConversionStatus($sitestoredocument->doc_id));
      } catch (Exception $e) {
        $message = $e->getMessage();
        $this->view->excep_error = 1;
        $this->view->excep_message = $message;
      }
    }

    //CHECK VIEWER CAN DOWNLOAD AND EMAIL THIS DOCUMENT OR NOT
    if (!empty($viewer_id)) {
      $download_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.download.allow', 1);
      $download_format = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.download.format', 'pdf');
      $this->view->email_allow = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.email.allow', 1);
    } else {
      $download_allow = 0;
      $download_format = 0;
      $this->view->email_allow = 0;
    }

    if (!empty($viewer_id)) {
      if ($download_allow && $stat == 'DONE' && $sitestoredocument->download_allow) {
        try {
          $link = $this->scribdsitestore->getDownloadUrl($sitestoredocument->doc_id, $download_format);
        } catch (Exception $e) {
          $message = $e->getMessage();
          $this->view->excep_error = 1;
          $this->view->excep_message = $message;
        }
        $this->view->link = trim($link['download_link']);
        $sitestoredocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.include.full.text', 1);
        if ($sitestoredocument_include_full_text == 1) {
          $doc_full_text = $sitestoredocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    } else { //WE SHOW FULL TEXT IN CASE OF NONLOGGEDIN USER IF DOCUMENT IS AVAILABLE FOR DOWNLOADING  AND ADMIN HAD ALLOWED FOR FULL TEXT IN GLOBAL SETTINGS
      if ($stat == 'DONE') {
        $sitestoredocument_include_full_text = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.include.full.text', 1);
        $sitestoredocument_visitor_fulltext = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.visitor.fulltext', 1);
        if ($sitestoredocument_include_full_text == 1 && $sitestoredocument_visitor_fulltext == 1 && $sitestoredocument->download_allow) {
          $doc_full_text = $sitestoredocument->fulltext;
          $this->view->doc_full_text = $doc_full_text;
        }
      }
    }

    //IF STAT IS DONE THAN UPDATE DOCUMENT STATUS AND OTHER INFORMATION
    if ($stat == 'DONE') {
      try {
        //GETTING DOCUMENT'S FULL TEXT
        $texturl = $this->scribdsitestore->getDownloadUrl($sitestoredocument->doc_id, 'txt');
        if ($sitestoredocument->status != 1) {
          $texturl = trim($texturl['download_link']);
          $file_contents = file_get_contents($texturl);
          if (empty($file_contents)) {
            $site_url = $texturl;
            $ch = curl_init();
            $timeout = 0; //SET ZERO FOR NO TIMEOUT
            curl_setopt($ch, CURLOPT_URL, $site_url);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

            ob_start();
            curl_exec($ch);
            curl_close($ch);
            $file_contents = ob_get_contents();
            ob_end_clean();
          }
          $full_text = $file_contents;

          $setting = $this->scribdsitestore->getSettings($sitestoredocument->doc_id);
          $thumbnail_url = trim($setting['thumbnail_url']);

          //UPDATING DOCUMENT STATUS AND FULL TEXT
          $sitestoredocument->fulltext = $full_text;
          $sitestoredocument->thumbnail = $thumbnail_url;
          $sitestoredocument->status = 1;

          //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
          if ($sitestoredocument->draft == 0 && $sitestoredocument->approved == 1 && $sitestoredocument->status == 1 && $sitestoredocument->search == 1 && $sitestoredocument->activity_feed == 0) {
            $api = Engine_Api::_()->getDbtable('actions', 'activity');
            $creator = Engine_Api::_()->getItem('user', $sitestoredocument->owner_id);
            $activityFeedType = null;
            if (Engine_Api::_()->sitestore()->isStoreOwner($sitestore_subject) && Engine_Api::_()->sitestore()->isFeedTypeStoreEnable())
              $activityFeedType = 'sitestoredocument_admin_new';
            elseif ($sitestore_subject->all_post || Engine_Api::_()->sitestore()->isStoreOwner($sitestore_subject))
              $activityFeedType = 'sitestoredocument_new';

            if ($activityFeedType) {
              $action = $api->addActivity($creator, $sitestore_subject, $activityFeedType);
              Engine_Api::_()->getApi('subCore', 'sitestore')->deleteFeedStream($action);
            }
            //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
            if ($action != null) {
              $api->attachActivity($action, $sitestoredocument);
              $sitestoredocument->activity_feed = 1;
              $sitestoredocument->save();
            }
            
            //STORE DOCUMENT CREATE NOTIFICATION AND EMAIL WORK
            if(Engine_Api::_()->getDbtable('modules', 'core')->getModule('store')) {
							$sitestoreVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('store')->version;
							if (!empty($action)) {
								Engine_Api::_()->store()->sendNotificationEmail($sitestoredocument, $action, 'sitestoredocument_create', 'SITESTOREDOCUMENT_CREATENOTIFICATION_EMAIL');
								
								$isStoreAdmins = Engine_Api::_()->getDbtable('manageadmins', 'sitestore')->isStoreAdmins($viewer->getIdentity(), $store_id);
								if (!empty($isStoreAdmins)) {
									//NOTIFICATION FOR ALL FOLLWERS.
									Engine_Api::_()->store()->sendNotificationToFollowers($sitestoredocument, $action, 'sitestoredocument_create');
								}
							}
            }
          }
        }
      } catch (Exception $e) {
        if ($sitestoredocument->status != 3 && $e->getCode() == 619) {
          $sitestoredocument->status = 3;

          //SEND EMAIL TO DOCUMENT OWNER IF STORE DOCUMENT HAS BEEN DELETED FROM SCRIBD
          Engine_Api::_()->sitestoredocument()->emailDocumentDelete($sitestoredocument, $sitestore_subject->title, $sitestore_subject->owner_id);
        }
      }
      $sitestoredocument->save();
    } elseif ($stat == 'ERROR') {
      if ($sitestoredocument->status != 2) {
        $sitestoredocument->status = 2;
        $sitestoredocument->save();
      }
    } else {
      $sitestoredocument->save();
    }

    //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
    $sitestoredocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.save.local.server', 1);
    if ($sitestoredocument_save_local_server == 0 && ($sitestoredocument->status == 1 || $sitestoredocument->status == 2)) {
      Engine_Api::_()->sitestoredocument()->deleteServerDocument($sitestoredocument->document_id);
    }

    //SETTING PARAMETERS FOR SECURE DOCUMENT
    if ($viewer->getIdentity() == 0) {
      $uid = mt_rand(1000, 100000);
    } else {
      $uid = $viewer->getIdentity();
    }
    $scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_secret_key;
    $sessionId = session_id();
    $signature = md5($scribd_secret . 'document_id' . $sitestoredocument->doc_id . 'session_id' . $sessionId . 'user_identifier' . $uid);
    $this->view->uid = $uid;
    $this->view->sessionId = $sessionId;
    $this->view->signature = $signature;
    $this->view->download_allow = $download_allow;

    //RATING WORK
    $this->view->rating_count = Engine_Api::_()->getDbTable('ratings', 'sitestoredocument')->countRating($sitestoredocument->getIdentity());
    $this->view->sitestoredocument_rated = Engine_Api::_()->getDbTable('ratings', 'sitestoredocument')->previousRated($sitestoredocument->getIdentity(), $viewer->getIdentity());

    //CUSTOM FIELD WORK
    $view = $this->view;
    $view->addHelperPath(APPLICATION_PATH . '/application/modules/Fields/View/Helper', 'Fields_View_Helper');
    $this->view->fieldStructure = $fieldStructure = Engine_Api::_()->fields()->getFieldsStructurePartial($sitestoredocument);

    // Start: Show "Suggest to Frind" link.
    $store_flag = 0;
    $viewer_id = Engine_Api::_()->user()->getViewer()->getIdentity();
    $is_moduleEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitestore');
    $is_suggestion_enabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('suggestion');
    $isSupport = Engine_Api::_()->getApi('suggestion', 'sitestore')->isSupport();
    // Here we are delete this documemt suggestion if viewer have.

    if (!empty($is_suggestion_enabled)) {
      if (!empty($is_moduleEnabled)) {
        Engine_Api::_()->getApi('suggestion', 'sitestore')->deleteSuggestion($viewer_id, 'store_document', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 'store_document_suggestion');
      }

      $SuggVersion = Engine_Api::_()->getDbtable('modules', 'core')->getModule('suggestion')->version;
      $versionStatus = strcasecmp($SuggVersion, '4.1.7p1');
      if ($versionStatus >= 0) {
        $modContentObj = Engine_Api::_()->suggestion()->getSuggestedFriend('sitestoredocument', Zend_Controller_Front::getInstance()->getRequest()->getParam('document_id'), 1,null);
        if (!empty($modContentObj)) {
          $contentCreatePopup = @COUNT($modContentObj);
        }
      }

      if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
        if ($store_subject->expiration_date <= date("Y-m-d H:i:s")) {
          $store_flag = 1;
        }
      }
      if (!empty($contentCreatePopup) && !empty($isSupport) && empty($store_subject->closed) && !empty($store_subject->approved) && empty($store_subject->declined) && !empty($store_subject->draft) && empty($store_flag) && !empty($viewer_id) && !empty($is_suggestion_enabled)) {
        $this->view->documentSuggLink = Engine_Api::_()->suggestion()->getModSettings('sitestore', 'document_sugg_link');
      }
    }
    // End: "Suggest to Friend" link work
  }

}
?>