<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoredocument
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-05-05 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
include_once APPLICATION_PATH . '/application/modules/Sitestoredocument/Api/Scribdsitestore.php';

class Sitestoredocument_Widget_ProfileSitestoredocumentsController extends Engine_Content_Widget_Abstract {

  protected $_childCount;

  public function indexAction() {

    //GET VIEWER
    $viewer = Engine_Api::_()->user()->getViewer();
    $this->view->viewer_id = $viewer_id = $viewer->getIdentity();

    //SET NO RENDER IF NO SUBJECT
    if (!Engine_Api::_()->core()->hasSubject()) {
      return $this->setNoRender();
    }

    //GET VIEWER INFORMATION
    if (!empty($viewer_id)) {
      $this->view->level_id = $level_id = $viewer->level_id;
    } else {
      $this->view->level_id = $level_id = 0;
    }

    //GET SUBJECT
    if(Engine_Api::_()->core()->getSubject()->getType() == 'sitestore_store') {
    	$this->view->sitestore_subject = $sitestore_subject = Engine_Api::_()->core()->getSubject('sitestore_store');
    }
    else {
      $this->view->sitestore_subject = $sitestore_subject = Engine_Api::_()->core()->getSubject()->getParent();
    }
 

    $this->view->store_id = $store_id = $sitestore_subject->store_id;

    //PACKAGE BASE PRIYACY START
    if (Engine_Api::_()->sitestore()->hasPackageEnable()) {
      if (!Engine_Api::_()->sitestore()->allowPackageContent($sitestore_subject->package_id, "modules", "sitestoredocument")) {
        return $this->setNoRender();
      }
    } else {
      $isStoreOwnerAllow = Engine_Api::_()->sitestore()->isStoreOwnerAllow($sitestore_subject, 'sdcreate');
      if (empty($isStoreOwnerAllow)) {
        return $this->setNoRender();
      }
    }
    //PACKAGE BASE PRIYACY END
    //TOTAL DOCUMENT
    $documentCount = Engine_Api::_()->sitestore()->getTotalCount($store_id, 'sitestoredocument', 'documents');
    $documentCreate = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'sdcreate');

    //START MANAGE-ADMIN CHECK
    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'view');
    if (empty($isManageAdmin)) {
      return $this->setNoRender();
    }

    $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'edit');
    if (empty($isManageAdmin)) {
      $this->view->can_edit = $can_edit = 0;
    } else {
      $this->view->can_edit = $can_edit = 1;
    }

    if (empty($documentCreate) && empty($documentCount) && empty($can_edit) && !(Engine_Api::_()->sitestore()->showTabsWithoutContent())) {
      return $this->setNoRender();
    }

    $sitestoredocument_feedtype = Zend_Registry::isRegistered('sitestoredocument_feedtype') ? Zend_Registry::get('sitestoredocument_feedtype') : null;
    if (empty($sitestoredocument_feedtype)) {
      return $this->setNoRender();
    }
    //END MANAGE-ADMIN CHECK
    //SSL WORK
    $this->view->https = 0;
    if (!empty($_SERVER["HTTPS"]) && 'on' == strtolower($_SERVER["HTTPS"])) {
      $this->view->https = 1;
    }
    $this->view->manifest_path = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.manifestUrl', "store-documents");

    //GET DOCUMENT TABLE
    $documentTable = Engine_Api::_()->getDbtable('documents', 'sitestoredocument');

    //Getting the tab id from the content table.
    $layout = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestore.layoutcreate', 0);
    $this->view->widgets = $widgets = Engine_Api::_()->sitestore()->getwidget($layout, $store_id);
    $this->view->content_id = Engine_Api::_()->sitestore()->GetTabIdinfo('sitestoredocument.profile-sitestoredocuments', $store_id, $layout);
    $this->view->module_tabid = $currenttabid = Zend_Controller_Front::getInstance()->getRequest()->getParam('tab', null);
    $isajax = $this->_getParam('isajax', null);
    $this->view->isajax = $isajax;
    $this->view->showtoptitle = $showtoptitle = Engine_Api::_()->sitestore()->showtoptitle($layout, $store_id);
    if (!empty($isajax) || ($currenttabid == $this->view->identity) || ($widgets == 0)) {

      $this->view->identity_temp = Zend_Controller_Front::getInstance()->getRequest()->getParam('identity_temp', $currenttabid);
      $this->view->show_content = true;

      //GET SEARCHING PARAMETERS
      $this->view->store = $store = $this->_getParam('store', 1);
      $this->view->search = $search = $this->_getParam('search');
      $this->view->selectbox = $selectbox = $this->_getParam('selectbox');
      $this->view->checkbox = $checkbox = $this->_getParam('checkbox');

      $values = array();
      $values['orderby'] = '';
      if (!empty($search)) {
        $values['search'] = $search;
      }
      if (!empty($selectbox) && $selectbox == 'featured') {
        $values['featured'] = 1;
        $values['orderby'] = 'document_id';
      } elseif (!empty($selectbox) && $selectbox == 'highlighted') {
        $values['highlighted'] = 1;
        $values['orderby'] = 'document_id';
      } elseif (!empty($selectbox)) {
        $values['orderby'] = $selectbox;
      }
      if (!empty($checkbox) && $checkbox == 1) {
        $values['owner_id'] = $viewer_id;
      }

      //START MANAGE-ADMIN CHECK
      $isManageAdmin = Engine_Api::_()->sitestore()->isManageAdmin($sitestore_subject, 'sdcreate');
      if (empty($isManageAdmin) && empty($can_edit)) {
        $this->view->can_create = 0;
      } else {
        $this->view->can_create = 1;
      }
      //END MANAGE-ADMIN CHECK
      //MAKE FEATURED OR NOT
      $this->view->canMakeHighlighted = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.featured', 1);

      //START CAROUSEL WORK
      //CHECK THAT CAROUSEL IS VIEABLE OR NOT
      $this->view->show_carousel = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.carousel', 1);
      if (!empty($this->view->show_carousel)) {

        //FETCH DOCUMENTS
        $params = array();
        $params['store_id'] = $store_id;
        $params['highlighted'] = 1;
        $params['limit'] = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.number.carousel', 15);
        $this->view->highlightedDocuments = $highlightDocuments = $documentTable->widgetDocumentsData($params);

        $this->view->total_highlightedDocuments = Count($highlightDocuments);
      }
      //END CAROUSEL WORK
      //BLOCK FOR UPDATING CONVERSION STATUS OF THE DOCUMENT
      $this->scribd_api_key = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_api_key;
      $this->scribd_secret = Engine_Api::_()->getApi('settings', 'core')->sitestoredocument_secret_key;
      $this->scribdsitestore = new Scribdsitestore($this->scribd_api_key, $this->scribd_secret);

      //FETCH DOCUMENTS
      $params = array();
      $params['store_id'] = $store_id;
      $params['profile_store_widget'] = 1;
      $doc_forUpdate = $documentTable->widgetDocumentsData($params);
      $stat="";

      foreach ($doc_forUpdate as $value) {

        if (empty($value->doc_id)) {
          continue;
        }

        $this->scribdsitestore->my_user_id = $value->owner_id;

        try {
          $stat = trim($this->scribdsitestore->getConversionStatus($value->doc_id));
        } catch (Exception $e) {
          $message = $e->getMessage();
        }

        if ($stat == 'DONE') {
          try {
            //GETTING DOCUMENT'S FULL TEXT
            $texturl = $this->scribdsitestore->getDownloadUrl($value->doc_id, 'txt');
            //for some reason, the URL comes back with leading and trailing spaces
            $texturl = trim($texturl['download_link']);

            $file_contents = file_get_contents($texturl);
            if (empty($file_contents)) {
              $site_url = $texturl;
              $ch = curl_init();
              $timeout = 0; // set to zero for no timeout
              curl_setopt($ch, CURLOPT_URL, $site_url);
              curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);

              ob_start();
              curl_exec($ch);
              curl_close($ch);
              $file_contents = ob_get_contents();
              ob_end_clean();
            }
            $full_text = $file_contents;

            $setting = $this->scribdsitestore->getSettings($value->doc_id);
            $thumbnail_url = trim($setting['thumbnail_url']);

            //UPDATING DOCUMENT STATUS AND FULL TEXT
            $value->fulltext = $full_text;
            $value->thumbnail = $thumbnail_url;
            $value->status = 1;
            $value->save();
          } catch (Exception $e) {
            if ($e->getCode() == 619) {
              $value->status = 3;
              $value->save();

              //SEND EMAIL TO DOCUMENT OWNER IF STORE DOCUMENT HAS BEEN DELETED FROM SCRIBD
              Engine_Api::_()->sitestoredocument()->emailDocumentDelete($value, $sitestore_subject->title, $sitestore_subject->owner_id);
            }
          }

          //ADD ACTIVITY ONLY IF DOCUMENT IS PUBLISHED
          $sitestoredocument = Engine_Api::_()->getItem('sitestoredocument_document', $value->document_id);
          if ($sitestoredocument->draft == 0 && $sitestoredocument->approved == 1 && $sitestoredocument->status == 1 && $sitestoredocument->search == 1 && $sitestoredocument->activity_feed == 0) {
            $api = Engine_Api::_()->getDbtable('actions', 'activity');
            $creator = Engine_Api::_()->getItem('user', $sitestoredocument->owner_id);
           // $action = $api->addActivity($creator, $sitestore_subject, 'sitestoredocument_new');
            $activityFeedType = null;
            if (Engine_Api::_()->sitestore()->isStoreOwner($sitestore_subject,$creator) && Engine_Api::_()->sitestore()->isFeedTypeStoreEnable())
              $activityFeedType = 'sitestoredocument_admin_new';
            elseif ($sitestore_subject->all_post || Engine_Api::_()->sitestore()->isStoreOwner($sitestore_subject,$creator))
              $activityFeedType = 'sitestoredocument_new';

            if ($activityFeedType) {
              $action = Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($creator, $sitestore_subject, $activityFeedType);
              Engine_Api::_()->getApi('subCore', 'sitestore')->deleteFeedStream($action);
            }
            //MAKE SURE ACTION EXISTS BEFORE ATTACHING THE DOUCMENT TO THE ACTIVITY
            if ($action != null) {
              $api->attachActivity($action, $sitestoredocument);
              $sitestoredocument->activity_feed = 1;
              $sitestoredocument->save();
            }
          }
        } elseif ($stat == 'ERROR') {
          $value->status = 2;
          $value->save();
        }

        //DELETE DOCUMENT FROM SERVER IF ALLOWED BY ADMIN AND HAS STATUS ONE OR TWO
        $sitestoredocument_save_local_server = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.save.local.server', 1);
        if ($sitestoredocument_save_local_server == 0 && ($value->status == 1 || $value->status == 2)) {
          Engine_Api::_()->sitestoredocument()->deleteServerDocument($value->document_id);
        }
      }

      //CHECK THAT RATING IS VIEABLE OR NOT
      $this->view->show_rate = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoredocument.rating', 1);

      //FETCH DOCUMENTS
      $values['store_id'] = $store_id;
      if ($can_edit == 1) {
        $values['show_document'] = 0;
        $this->view->paginator = $paginator = $documentTable->getSitestoredocumentsPaginator($values);
      } else {
        $values['show_document'] = 1;
        $values['document_owner_id'] = $viewer_id;
        $this->view->paginator = $paginator = $documentTable->getSitestoredocumentsPaginator($values);
      }

      //10 DOCUMENTS PER STORE
      $paginator->setItemCountPerPage(10);
      $this->view->paginator->setCurrentPageNumber($store);

      //ADD NUMBER OF DOCUMENTS IN TAB
      if ($this->_getParam('titleCount', false) && $paginator->getTotalItemCount() > 0) {
        $this->_childCount = $paginator->getTotalItemCount();
      }
    } else {
      $this->view->show_content = false;
      $this->view->identity_temp = $this->view->identity;

      $values = array();
      //$values['orderby'] = 'document_id';
      $values['store_id'] = $store_id;
      $values['show_count'] = 1;
      if ($can_edit == 1) {
        $values['show_document'] = 0;
        $paginator = $documentTable->getSitestoredocumentsPaginator($values);
      } else {
        $values['show_document'] = 1;
        $values['document_owner_id'] = $viewer_id;
        $paginator = $documentTable->getSitestoredocumentsPaginator($values);
      }

      $this->_childCount = $paginator->getTotalItemCount();
    }
  }

  public function getChildCount() {
    return $this->_childCount;
  }

}

?>