<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoreintegration_Form_Admin_Global extends Engine_Form {
    
  public function init() {

    $this->setTitle('Global Settings')
         ->setDescription('These settings affect all members in your community.');

    $apiSettings = Engine_Api::_()->getApi('settings', 'core');
    $coreModule = Engine_Api::_()->getDbtable( 'modules' , 'core' );

    $listEnabled = $coreModule->isModuleEnabled('list');
    $sitebusinessEnabled = $coreModule->isModuleEnabled('sitebusiness');
		$sitepageEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');
		$sitereviewEnabled = $coreModule->isModuleEnabled('sitereview') ;
		$sitereviewlistingtypeEnabled = $coreModule->isModuleEnabled('sitereviewlistingtype') ;
		$sitegroupEnabled = $coreModule->isModuleEnabled('sitegroup');
		$documentEnabled = $coreModule->isModuleEnabled('document');
		
	  if (!empty($sitepageEnabled) && !empty($sitebusinessEnabled) && !empty($sitegroupEnabled) && (!empty($sitereviewEnabled) || !empty($listEnabled))) {
			$title = "Addable Listings / Pages / Businesses / Groups";
			$options1 = "Their own Listings / Pages / Businesses / Groups";
			$options2 = "Page Admins’ Listings / Pages / Businesses / Groups";
			$options3 = "All Listings / Pages / Businesses / Groups";
			$Description = "Choose the Listings / Pages / Businesses / Groups that would be available to Store Admins for adding to their Stores.";
		} elseif (!empty($sitepageEnabled) && (!empty($sitereviewEnabled) || !empty($listEnabled))) {
			$title = "Addable Listings / Pages";
			$options1 = "Their own Listings / Pages";
			$options2 = "Page Admins’ Listings / Pages";
			$options3 = "All Listings / Pages";
			$Description = "Choose the Listings / Pages that would be available to Store Admins for adding to their Stores.";
		} elseif (!empty($sitereviewEnabled) || !empty($listEnabled)) {
			$title = "Addable Listings";
			$options1 = "Their own Listings";
			$options2 = "Store Admins’ Listings";
			$options3 = "All Listings";
			$Description = "Choose the Listings that would be available to Store Admins for adding to their Stores.";
		} elseif($sitepageEnabled) {
			$title = "Addable Pages";
			$options1 = "Their own Pages";
			$options2 = "Page Admins’ Pages";
			$options3 = "All Pages";
			$Description = "Choose the Pages that would be available to Page Admins for adding to their Stores.";
		} elseif($sitebusinessEnabled) {
			$title = "Addable Businesses";
			$options1 = "Their own Businesses";
			$options2 = "Page Admins’ Businesses";
			$options3 = "All Businesses";
			$Description = "Choose the Businesses that would be available to Page Admins for adding to their Stores.";
		} elseif($sitegroupEnabled) {
			$title = "Addable Groups";
			$options1 = "Their own Groups";
			$options2 = "Page Admins’ Groups";
			$options3 = "All Groups";
			$Description = "Choose the Groups that would be available to Page Admins for adding to their Stores.";
		}

		if (!empty($options1) && !empty($options2) && !empty($options3)) {
			$this->addElement( 'Radio' , 'sitestore_addable_integration' , array (
				'label' => "$title",
				'description' => "$Description",
				'multiOptions' => array (
					1 => "$options1" ,
					2 => "$options2" ,
					0 => "$options3"
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.addable.integration' , 1),
			)) ;
    }

    if (!empty($sitepageEnabled)) {
			$this->addElement( 'Radio' , 'sitestore_page_integration' , array (
				'label' => 'Adding Pages',
				'description' => 'Do you want to enable adding of Pages from "Directory / Pages Plugin" to Stores / Marketplace - Ecommerce?',
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.page.integration' , 0 ),
			)) ;
		}
		
		if (!empty($sitebusinessEnabled)) {
			$this->addElement( 'Radio' , 'sitestore_business_integration' , array (
				'label' => 'Adding Businesses',
				'description' => 'Do you want to enable adding of Businesses from "Directory / Businesses Plugin" to Stores / Marketplace - Ecommerce?',
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.business.integration' , 0 ),
			)) ;
		}
    
    if (!empty($sitegroupEnabled)) {
			$this->addElement( 'Radio' , 'sitestore_group_integration' , array (
				'label' => 'Adding Groups',
				'description' => 'Do you want to enable adding of Groups from "Groups / Communities" to Stores / Marketplace - Ecommerce?',
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.group.integration' , 0 ),
			)) ;
		}

    if (!empty($listEnabled)) {
			$this->addElement( 'Radio' , 'sitestore_list_integration' , array (
				'label' => 'Adding Listings',
				'description' => "Do you want to enable adding of Listings from “Listings / Catalog Showcase Plugin” to Stores / Marketplace - Ecommerce?",
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.list.integration' , 0 ),
			)) ;
		}

		if (!empty($documentEnabled)) {
			$this->addElement( 'Radio' , 'sitestore_document_integration' , array (
				'label' => 'Adding Documents',
				'description' => 'Do you want to enable adding of Documents from "Documents / Scribd iPaper Plugin" to Stores / Marketplace - Ecommerce?',
				'multiOptions' => array (
					1 => 'Yes' ,
					0 => 'No'
				) ,
				'value' => $apiSettings->getSetting( 'sitestore.document.integration' , 0 ),
			)) ;
		}

		if (!empty($sitereviewEnabled) && !empty($sitereviewlistingtypeEnabled)) {
			$pluginName = 'Multiple Listing Types Plugin';
		} else {
			$pluginName = 'Multiple Listing Types Plugin Core (Reviews & Ratings Plugin)';
		}
		
		if (!empty($sitereviewEnabled)) {
		
			$listingTypeTable = Engine_Api::_()->getDbTable('listingtypes', 'sitereview');
			$listingTypeTableName = $listingTypeTable->info('name');
			
			$select = $listingTypeTable->select()->from($listingTypeTableName, array('title_singular', 'listingtype_id'));
			$listingTypeDatas = $listingTypeTable->fetchAll($select)->toArray();

			foreach ($listingTypeDatas as $key) {
				$this->addElement('Radio', "sitestore_sitereview_listing_" . $key['listingtype_id'], array(
					'label' => "Adding " .$key['title_singular']." Listings", 
					'description' => 'Do you want to enable adding of ' .$key['title_singular']. ' Listings from "' . $pluginName . '" to Stores / Marketplace - Ecommerce?',
					'multiOptions' => array(
						1 => 'Yes',
						0 => 'No',
					),
					'value' => $apiSettings->getSetting( "sitestore.sitereview.listing." . $key['listingtype_id'] , 0),
				));
			}
		}
		
		if (empty($sitepageEnabled) && empty($sitebusinessEnabled) && empty($sitegroupEnabled) && empty($sitereviewEnabled) && empty($listEnabled)) {
		
			$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;
			$URL = $view->baseUrl() . "/admin/sitestoreintegration/settings";
      $click = '<a href="' . $URL . '" target="_blank">Click here</a>';
      
	    $description = sprintf("Note: Comming Soon...",  $click);
	    
	    
			$description = "<div class='tip'><span>" . $description . "</span></div>" ;
			$this->addElement( 'Dummy' , 'resource_type' , array (
			'description' => $description ,
			) ) ;
			$this->resource_type->addDecorator( 'Description' , array ( 'placement' => Zend_Form_Decorator_Abstract::PREPEND , 'escape' => false ));
			
		}
		
    if (!empty($sitepageEnabled) || !empty($sitebusinessEnabled) || !empty($sitegroupEnabled) || !empty($sitereviewEnabled) || !empty($listEnabled)) {
		
			$this->addElement('Button', 'submit', array(
					'label' => 'Save Changes',
					'type' => 'submit',
					'ignore' => true
			));
    }
  }
}