<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreintegration
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: content.php 2012-31-12 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
$view = Zend_Registry::isRegistered('Zend_View') ? Zend_Registry::get('Zend_View') : null;

$sitepageEnabled = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitepage');
$sitereviewEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitereview') ;
$sitereviewlistingtypeEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('sitereviewlistingtype') ;
$listEnabled = Engine_Api::_()->getDbtable( 'modules' , 'core' )->isModuleEnabled('list');
$description ='';
$title='';
if (!empty($sitepageEnabled) && (!empty($sitereviewEnabled) || !empty($listEnabled))) {
$title = "Listing / Page Profile Linked Stores (selected content)";
$description = "This widget displays listings / pages added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
} elseif (!empty($sitereviewEnabled) || !empty($listEnabled)) {
$title = "Listing Profile Linked Stores (selected content)";
$description = "This widget displays listings added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
} elseif($sitepageEnabled) {
$title = "Page Profile Linked Stores (selected content)";
$description = "This widget displays pages added from a selected content module, which you can choose from the settings of this widget, to the Store currently being viewed. You can place this widget multiple times on Store Profile page with different content modules chosen for each placement. It is recommended to place this widget in the Tabbed Blocks area of the Store Profile page.";
}



$contentWidgetNames[] =   array(
	'title' => $view->translate('Store Profile Listings (selected content)'),
	'description' => $view->translate("$description"),
	'category' => $view->translate('Store Profile'),
	'type' => 'widget',
	'autoEdit' => true,
	'name' => 'sitestoreintegration.profile-items',
	'adminForm' => 'Sitestoreintegration_Form_Admin_Integration',
	'defaultParams' => array(
			'title' => $view->translate('Store Profile Integration'),
	),
);

$contentWidgetNames[] =   array(
	'title' => $view->translate("$title"),
	'description' => $view->translate('This widget displays all the Stores to which the selected content module is added, as chosen by you from the settings of this widget. It is recommended to place this widget in the Tabbed Blocks area of the selected content module’s Profile store.'),
	'category' => $view->translate('Store Profile'),
	'type' => 'widget',
	'autoEdit' => true,
	'name' => 'sitestoreintegration.mixprofile-items',
	'adminForm' => 'Sitestoreintegration_Form_Admin_ProfileIntegration',
	'defaultParams' => array(
			'title' => $view->translate('Related Stores'),
	),
);
return $contentWidgetNames;
