<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestoreproduct
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Upload.php 2013-09-02 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestoreproduct_Form_Photo_Upload extends Engine_Form {

  public function init() {

    $sitestoreproduct = Engine_Api::_()->getItem('sitestoreproduct_product', Zend_Controller_Front::getInstance()->getRequest()->getParam('product_id', null));

    $this
            ->setTitle('Add New Photos')
            ->setDescription("Choose photos on your computer to add to this product. (2MB maximum). The recommended dimension for the photos of this product is: 400 x 500 pixels to enable image zoom feature when users mouse-over on photos displayed on this product's profile page.")
            ->setAttrib('id', 'form-upload')
            ->setAttrib('class', 'global_form sitestoreproduct_form_upload')
            ->setAttrib('name', 'albums_create')
            ->setAttrib('enctype', 'multipart/form-data')
            ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()));

    $uploadUrl = Zend_Controller_Front::getInstance()->getRouter()->assemble(array()) . '?ul=1';
    $deleteUrl = $this->getView()->url(array('module' => 'sitestoreproduct', 'controller' => 'photo', 'action' => 'remove'), 'default');
    $this->addElement('SeaoFancyUpload', 'file', array(
        'url' =>  $uploadUrl,
        'deleteUrl' =>  $deleteUrl,
        'accept' => 'image/*',
    ));

    $this->addElement('Button', 'submit', array(
        'label' => 'Save Photos',
        'type' => 'submit',
    ));
  }

}