<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitestorereservation
 * @copyright  Copyright 2013-2014 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2014-03-24 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitestorereservation_AdminSettingsController extends Core_Controller_Action_Admin {

  public function indexAction() {
    //GET NAVIGATION
    $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')
				->getNavigation('sitestore_admin_main', array(), 'sitestore_admin_main_services');
    
    $directPayment = Engine_Api::_()->sitestoreproduct()->isDirectPaymentEnable();
        
    $this->view->form = $form = new Sitestorereservation_Form_Admin_Global(array('directPayment' => $directPayment));
    $settings = Engine_Api::_()->getApi('settings', 'core');
    
    if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
      $values = $form->getValues();      

      // IF PAYMENT GOES TO SITE AND IF SITE HAS NOT ENABLED PAYPAL OR 2CHECKOUT BUT SELECTED THESE GATEWAY FROM SETTING, THEN SHOW ERROR MESSAGE
      if( empty($directPayment) && (!empty($values['sitestorereservation_defaultpaymentgateway']) || !empty($values['sitestorereservation_remainingpaymentgateway'])) ){
        // CHECK PAYPAL AND 2CHECKOUT IN DEFAULT DOWN PAYMENT GATEWAY
        foreach( $values['sitestorereservation_defaultpaymentgateway'] as $gateway ) {
          if( $gateway == '2checkout' )
            $twoCheckoutEnable = true;
          if( $gateway == 'paypal' )
            $paypalEnable = true;
        }

        foreach( $values['sitestorereservation_remainingpaymentgateway'] as $gateway ) {
          if( $gateway == '2checkout' )
            $twoCheckoutEnable = true;
          if( $gateway == 'paypal' )
            $paypalEnable = true;
        }
        
        // FETCH SITE HAS ENABLED PAYPAL AND 2CHECKOUT GATEWAY OR NOT
        $gateway_table = Engine_Api::_()->getDbtable('gateways', 'payment');
        $enable_gateway = $gateway_table->select()
                ->from($gateway_table->info('name'), array('gateway_id', 'plugin'))
                ->where('enabled = 1')
                ->query()
                ->fetchAll();

        if( !empty($enable_gateway) && (!empty($twoCheckoutEnable) || !empty($paypalEnable)) ) {
          foreach( $enable_gateway as $gateway ) {
            if( $gateway['plugin'] == 'Payment_Plugin_Gateway_PayPal' )
              $sitePaypalEnable = true;
              
            if( $gateway['plugin'] == 'Payment_Plugin_Gateway_2Checkout' )
              $site2CheckoutEnable = true;
          }
        }
        
        if( empty($sitePaypalEnable) && !empty($paypalEnable) )
          $paypalError = true;
        if( empty($site2CheckoutEnable) && !empty($twoCheckoutEnable) )
          $twoCheckoutError = true;

        if( !empty($paypalError) || !empty($twoCheckoutError) ) {
          if( !empty($paypalError) && !empty($twoCheckoutError) )
            $errorMessage = sprintf(Zend_Registry::get('Zend_Translate')->_('You have not enabled PayPal and 2Checkout payment gateway for your site. So you can\'t select these gateway. click %1$shere%2$s to enable them.'), "<a href='" . $this->view->url(array('module' => 'payment', 'controller' => 'gateway', 'action' => 'index'), 'admin_default', true)."' target='_blank'>", "</a>");
          elseif( empty($paypalError) && !empty($twoCheckoutError) )
            $errorMessage = sprintf(Zend_Registry::get('Zend_Translate')->_('You have not enabled 2Checkout payment gateway for your site. So you can\'t select 2Checkout gateway. click %1$shere%2$s to enable 2Checkout payment gateway.'), "<a href='" . $this->view->url(array('module' => 'payment', 'controller' => 'gateway', 'action' => 'index'), 'admin_default', true)."' target='_blank'>", "</a>");
          elseif( !empty($paypalError) && empty($twoCheckoutError) )
            $errorMessage = sprintf(Zend_Registry::get('Zend_Translate')->_('You have not enabled PayPal payment gateway for your site. So you can\'t select PayPal gateway. click %1$shere%2$s to enable PayPal payment gatewat.'), "<a href='" . $this->view->url(array('module' => 'payment', 'controller' => 'gateway', 'action' => 'index'), 'admin_default', true)."' target='_blank'>", "</a>");
          
          $form->getDecorator('errors')->setOption('escape', false);
          $form->addError($errorMessage);
          return;
        }
      }
      
      if( !empty($values['sitestorereservation_pricerange']) ){
        $values['sitestorereservation_pricerange'] = serialize($values['sitestorereservation_pricerange']);
      }
      
      if( !empty($values['sitestorereservation_defaultpaymentgateway']) ){
        $values['sitestorereservation_defaultpaymentgateway'] = serialize($values['sitestorereservation_defaultpaymentgateway']);
      }
      
      if( !empty($values['sitestorereservation_remainingpaymentgateway']) ){
        $values['sitestorereservation_remainingpaymentgateway'] = serialize($values['sitestorereservation_remainingpaymentgateway']);
      }
      
      if( !empty($values['sitestorereservation_store_as_service']) ){
        $values['sitestore_virtual_product_shipping'] = 0;
        $coreMenuitems = Engine_Api::_()->getDbtable('menuitems', 'core');
        $shippingMethodTabId = $coreMenuitems->select()->from($coreMenuitems->info('name'), 'id')
                ->where("name = 'sitestore_dashboard_shippingmethods'")
                ->where("module = 'sitestore'")
                ->where("enabled = 1")
                ->query()
                ->fetchColumn();
        
        if( !empty($shippingMethodTabId) ) {
          $coreMenuitems->update(array("enabled" => 0), array("name = 'sitestore_dashboard_shippingmethods' AND module = 'sitestore'"));
        }
      } else if( isset($values['sitestorereservation_store_as_service']) && empty($values['sitestorereservation_store_as_service']) ) {
        $values['sitestore_virtual_product_shipping'] = 1;
      }
      
      foreach ($values as $key => $value) {
        $settings->setSetting($key, $value);
      }
    }
  }
}
