<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class Sitestories_Model_DbTable_Mutestories extends Engine_Db_Table {

    protected $_name = 'sitestories_mutestories';
    protected $_rowClass = 'Sitestories_Model_Mutestory';

    public function getMuteStories() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $smuteTable = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $sName = $smuteTable->info('name');
        $mName = $this->info('name');
        $currentDate = date('Y-m-d H:i:s');

        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
        $select = $smuteTable->select()
                ->setIntegrityCheck(false)
                ->from($sName)
                ->join($mName, "$mName.story_id = $sName.story_id", array())
                ->where($sName.'.create_date >= ?', $pastDate)
                ->where($sName.'.mute_story = ?', 1)
                ->where("$mName.user_id=?", $viewer->getIdentity())
                ->order($sName.".create_date DESC");
        return Zend_Paginator::factory($select);
    }

    public function getMuteStoriesCount($user) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $smuteTable = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $sName = $smuteTable->info('name');
        $mName = $this->info('name');
        
        $currentDate = date('Y-m-d H:i:s');
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
        
        $result = $smuteTable->select()
                ->setIntegrityCheck(false)
                ->from($sName)
                ->join($mName, "$mName.story_id = $sName.story_id", array())
                ->where($sName.'.create_date >= ?', $pastDate)
                ->where($sName.'.mute_story = ?', 1)
                ->where("$mName.user_id=?", $viewer->getIdentity())
                ->order($sName.".create_date DESC")
                ->limit(1)
                ->query()->fetchAll();
       
        return $result;
    }
    
    
    public function getMuteStoriesId() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $smuteTable = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $sName = $smuteTable->info('name');
        $mName = $this->info('name');
        $currentDate = date('Y-m-d H:i:s');
        $muteIds=0;
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
        $result = $smuteTable->select()
                ->setIntegrityCheck(false)
                ->from($sName,array('story_id'))
                ->join($mName, "$mName.story_id = $sName.story_id", array())
                ->where($sName.'.create_date >= ?', $pastDate)
                ->where($sName.'.mute_story = ?', 1)
                ->where("$mName.user_id=?", $viewer->getIdentity())
                ->order($sName.".create_date DESC")
                 ->query()->fetchAll();
        foreach ($result as $row) {
          $muteIds = $muteIds.','.$row['story_id'];
        }
        $str = $this->getTrimStr($muteIds);
        return $str;
    }
    
    public function getTrimStr($str) {
        $str = trim($str, ',');
        if (empty($str)) {
            return 0;
        } else {
            $str = trim($str, ",");
            return $str;
        }
    }
  
  public function isMuteStoryByUser($story = null) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $currentDate = date('Y-m-d H:i:s');
        $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
        $select = $this->select()
                ->where('story_id = ?', $story->getIdentity())
                ->where('user_id=?', $viewer->getIdentity())
                ->limit(1);
        $result = $this->fetchRow($select);
        if (!empty($result))
            return 1;
        else
            return 0;
    }
}
?>