<?php

class Sitestories_Model_DbTable_Userprivacies extends Engine_Db_Table {

    protected $_name = 'sitestories_userprivacy';
    protected $_rowClass = 'Sitestories_Model_Userprivacy';

    //return user privacy status
    public function getUserStoryPrivacyStatus($user_id){
        if (empty($user_id))
            return;
        $select = $this->select()->from($this->info('name'),'privacy_status')->where('user_id =?', $user_id);
        $privacy = $this->fetchRow($select);
        if(empty($privacy)){
            $privacyObj = $this->createUserPrivacy($user_id);
            return $privacyObj->privacy_status;
        }
        return $privacy['privacy_status'];
    }

    public function createUserPrivacy($user_id,$privacy_status = 'everyone'){
        $row = $this->createRow();
        $row->user_id = $user_id;
        $row->privacy_status = $privacy_status;
        $row->save();
        return $row; 
    }

    // retun object of user privacy 
    public function getUserPrivacy($user_id){
        $privacyData = $this->fetchRow($this->select()->where('user_id = ?',$user_id));
        if(empty($privacyData)){
            $privacyObj = $this->createUserPrivacy($user_id);
            return $privacyObj;
        }
        return $privacyData;
    }

    //This function checks, viewer can view user's story or not!!
    public function checkUserViewPrivacy($user, $viewer){
        if($user->getIdentity() == $viewer->getIdentity())
            return 1;
        $userPrivacy = $this->getUserPrivacy($user->getIdentity());
        switch ($userPrivacy->privacy_status) {
            case 'everyone':
                return 1;
                break;
            case 'friends':
                $select = $user->membership()->getMembersOfSelect();
                $friends = $paginator = Zend_Paginator::factory($select);
                $ids = array();
                foreach( $friends as $friend ) {
                  $ids[] = $friend->resource_id;
                }
                if(in_array($viewer->getIdentity(), $ids)){
                    return 1;
                }
                break;
            case 'custom':
                if(in_array($viewer->getIdentity(), explode(',', $userPrivacy->params))){
                    return 1;
                }
                break;
            default:
                return 0;
        }

        return 0;


    }

}