<?php


class Sitestories_Plugin_Task_Cleanup extends Core_Plugin_Task_Abstract {

  public function execute() {

    $this->_updateExpiredStories();
  }

  private function _updateExpiredStories()
  {
    $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
    $currentDate = date('Y-m-d H:i:s');
    $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
    $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
	  //LIST OF STORIES WHICH ARE EXPIRED NOW 
    $select = $table->select()
      ->where('create_date <= ?', $pastDate);

    foreach( $table->fetchAll($select) as $row) {
        $row->delete();
    }
  }

}
