<?php

class Sitestories_StoryController extends Siteapi_Controller_Action_Standard {

    /*
     * story Ownner id
     */
   protected $_owner_ids=array();
   
    public function init() {
        try{
            $isSitestoriesEnable = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_enable_stories');
            if(empty($isSitestoriesEnable))
            {
                $this->respondWithError('unauthorized', 'story_disabled');
            }
            if (0 !== ($story_id = (int) $this->getRequestParam('story_id')) && null !== ($subject = Engine_Api::_()->getItem('sitestories_story', $story_id)))
            Engine_Api::_()->core()->setSubject($subject);
            Engine_Api::_()->getApi('Core', 'siteapi')->setView();
            Engine_Api::_()->getApi('Core', 'siteapi')->setLocal();
            Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();
        }
        catch (Exception $e)
        {
      
        }
    }

    public function createAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if (empty($viewer_id))
            $this->respondWithError('unauthorized');

        if ($this->getRequest()->isGet()) {
            //advanced activity feed
            $response = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getStoryForm();
            $this->respondWithSuccess($response);
        } else if ($this->getRequest()->isPost()) {
            $values = $data = $_REQUEST;
            $type = $this->_getParam('type','');
            $description = $this->_getParam('description','');
            $description = str_ireplace("\n", "<br>", $description);
            $media_rgb = $this->_getParam('media_rgb','');
            $values = @array_merge($values, array(
                        'owner_type' => $viewer->getType(),
                        'owner_id' => $viewer->getIdentity(),
            ));

            $date = new DateTime(date('Y-m-d H:i:s'), new DateTimeZone('UTC'));
            $createDate = $date->format('Y-m-d H:i:s');
            $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
            $pastDate = date('Y-m-d H:i:s', strtotime('+' . $days . ' day', strtotime($createDate)));
            $expiryDate = $pastDate;
            $values['create_date'] = $createDate;
            $values['expiry_date'] = $expiryDate;
            $values['privacy'] = $privacyStatus = Engine_Api::_()->getDbtable('userprivacies', 'sitestories')->getUserStoryPrivacyStatus($viewer_id);

            $db = Engine_Api::_()->getDbtable('stories', 'sitestories')->getAdapter();
            $db->beginTransaction();
            try {
                $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
                $i = 0;
                if($type == 'text'){
                    $backgroundImage = $this->_getParam('background_file');
                    $color = $this->_getParam('color');
                    $file_id = $this->_getParam('banner_id');
                    $backgroundColor = $this->_getParam('backgroundColor');
                    if(empty($backgroundImage)){
                        $this->respondWithError('unauthorized','Background is not Found. Please select Background');
                    }
                    $params['background'] = $backgroundImage; 

                    $params['color'] = $color;
                    $params['background-color'] = $backgroundColor;
                    $params['file_id'] = $file_id;
                    $values = @array_merge($values, array('description' => $description,'type' => $type, 'params' => Zend_Json::encode($params)));
                    
                    $story = $table->createRow();
                    $story->setFromArray($values);
                    $story->save();
                    
                }elseif (empty($_FILES['filedata'])) {
                    foreach ($_FILES as $storyPhoto) {
                        if (!empty($i)) {
                            $values['description'] = $values['description' . $i];
                        }
                        $i++;
                        $values['type'] = 'image';
                        $story = $table->createRow();
                        $story->setFromArray($values);
                        $story->save();
                        $story = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->setPhoto($storyPhoto, $story);
                    }
                }else {
                    if (isset($_FILES['filedata']) && !empty($_FILES['filedata'])) {

                        if (!is_uploaded_file($_FILES['filedata']['tmp_name']))
                            $this->respondWithError("invalid_upload");

                        $values['type'] = 'video';
                        $story = $table->createRow();
                        $story->setFromArray($values);
                        $story->save();

                        $illegal_extensions = array('php', 'pl', 'cgi', 'html', 'htm', 'txt');
                        if (!in_array(pathinfo($_FILES['filedata']['name'], PATHINFO_EXTENSION), $illegal_extensions)) {
                            if ($_FILES['filedata'] instanceof Storage_Model_File) {
                                $params['file_id'] = $_FILES['filedata']->getIdentity();
                            } else {
                                // create video item
                                $file_ext = pathinfo($_FILES['filedata']['name']);
                                $file_ext = $file_ext['extension'];
                                $story->code = $file_ext;
                                $story->save();

                                // Channel video in temporary storage object for ffmpeg to handle
                                $storage = Engine_Api::_()->getItemTable('storage_file');
                                $storageObject = $storage->createFile($_FILES['filedata'], array(
                                    'parent_id' => $story->getIdentity(),
                                    'parent_type' => $story->getType(),
                                    'user_id' => $story->owner_id,
                                ));

                                // Remove temporary file
                                @unlink($_FILES['tmp_name']);

                                $story->file_id = $storageObject->file_id;
                                $story->save();
                            }
                        } else {
                            $this->respondWithError("invalid_upload");
                        }
                    }

                    //Upload thumbnail for story................
                    $thumbnailCreated=0;
                    if (!empty($_FILES['video_thumbnail'])) {
                        $story = Engine_Api::_()->getApi('Siteapi_Core', 'advancedactivity')->setPhoto($_FILES['video_thumbnail'], $story);
                        $thumbnailCreated =1;
                    }
                    
                    if($_FILES['video_overlay_image']){
                       Engine_Api::_()->getApi('Siteapi_Core', 'advancedactivity')->setPhoto($_FILES['video_overlay_image'],$story,false);
                    }

                    //...........................................
                    // Add to jobs
                    $file_ext = pathinfo($_FILES['filedata']['name']);
                    $file_ext = $file_ext['extension'];

                    if(empty($thumbnailCreated)){
                        if (strtolower($file_ext) == 'mp4' || Engine_Api::_()->getApi('settings', 'core')->getSetting('sitevideo.html5', true)) {
                            Engine_Api::_()->getDbtable('jobs', 'core')->addJob('siteapi_sitevideo_encode', array(
                                'video_id' => $story->getIdentity(),
                                'type' => 'mp4',
                                "subject_type" => $story->getType()
                            ));
                        } else {
                            Engine_Api::_()->getDbtable('jobs', 'core')->addJob('siteapi_sitevideo_encode', array(
                                'video_id' => $story->getIdentity(),
                                'type' => 'flv',
                                "subject_type" => $story->getType()
                            ));
                        }
                    }
                }

                $db->commit();
                $response['response']['story_id'] = $story->getIdentity();
                $this->respondWithSuccess($response);
            } catch (Exception $ex) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    public function browseAction() {
        $subject = $user = Engine_Api::_()->user()->getViewer();
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        $user_id = $user->getIdentity();
        if (empty($user_id))
            $this->respondWithError('unauthorized');
        try {
            $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
            $muteTable = Engine_Api::_()->getDbtable('muteusers', 'sitestories');
            $limit = (int) $this->getRequestParam('limit', 20);
            $page = (int) $this->getRequestParam('page', 1);
            $paginator = $table->getStoryPaginator($subject);
            $paginator->setItemCountPerPage($limit);
            $paginator->setCurrentPageNumber($page);
            $bodyResponse = array();
            $bodyResponse['totalItemCount'] = $paginator->getTotalItemCount();
            $storyCount = $muteTable->getMuteUserCount();
            $bodyResponse['muteStoryCount'] = $storyCount;
            $response = array();
            $response[] = $this->_getYourStory($user);
            $owner_ids = array();

            foreach ($paginator as $story) {
                if ($story->owner_id == $user_id) {
                    continue;
                }
                //Manage stories who's privacy is custom.
                if($story->privacy == 'custom'){
                    $userPrivacy= Engine_Api::_()->getDbtable('userprivacies','sitestories')->getUserPrivacy($story->owner_id);
                    if(!in_array($user->getIdentity(), explode(',', $userPrivacy->params))){
                        continue;
                    }
                }
                $owner_ids[] = $story->owner_id;
                $browseStory = $story->toArray();
                $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestories')->getTotalStoryCount($story->owner_id);
                $browseStory["owner_title"] = $story->getOwner()->getTitle();

                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
                $browseStory = array_merge($browseStory, $getContentImages);
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
                $browseStory = array_merge($browseStory, $getContentImages);

                if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                    $tempArray = $this->_getBannerImages($browseStory);
                    $browseStory = array_merge($browseStory, $tempArray);     
                }

                if ($story->file_id) {
                    $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                    $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
                } else {
                    $browseStory['videoUrl'] = '';
                }

                $browseStory['gutterMenu'] = $this->_browseGutterMenus($story);
                $response[] = $browseStory;
            }
        } catch (Exception $ex) {
            
        }

        if (count($response) < 5) {
            $browseStory = array();
            $response = $this->_getEveryoneStory($response);

            if (count($response) > 4) {
                $response = $this->MuteUserStories($response);
                $bodyResponse['response'] = $response;
                $bodyResponse['totalItemCount'] = count($response);
                $this->respondWithSuccess($bodyResponse);
            }

            $response = $this->MuteUserStories($response);

            $select = $subject->membership()->getMembersOfSelect();
            $friends = $paginator = Zend_Paginator::factory($select);
            $paginator->setItemCountPerPage(40);
            $paginator->setCurrentPageNumber(1);
            $i = 0;
             $owner_ids = array_merge($owner_ids,$this->_owner_ids);
            foreach ($friends as $friend) {
                if (in_array($friend->resource_id, $owner_ids))
                    continue;
                if ($i == 4)
                    break;
                $user = Engine_Api::_()->getItem('user', $friend->resource_id);
                $browseStory["owner_title"] = $user->getTitle();
                $browseStory["owner_id"] = $user->getIdentity();
                $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestories')->getTotalStoryCount($user->user_id);
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($user, true);
                $browseStory = array_merge($browseStory, $getContentImages);
                $response[] = $browseStory;
                $i++;
            }
        }
        else {
            $response = $this->MuteUserStories($response);
        }
        $bodyResponse['response'] = $response;
        $this->respondWithSuccess($bodyResponse);

    }

    public function viewAction() {
        $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $viewer = Engine_Api::_()->user()->getViewer();
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        if (Engine_Api::_()->core()->hasSubject())
            $story = Engine_Api::_()->core()->getSubject();

        if (empty($story)) {
            $this->respondWithError('no_record');
        }
        if ($story->isOwner($viewer)) {
            $user_id = $viewer->getIdentity();
        } else {
            $user_id = $story->owner_id;
        }
        if (empty($user_id))
            $this->respondWithError('unauthorized');

        $isSendMessage = 0;
        if (!$story->isOwner($viewer)) {
            try {
                $isSendMessage = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->isAllowMessage($viewer, $story);
            } catch (Exception $ex) {
                $isSendMessage = 0;
            }
        } else {
            $isSendMessage = 1;
        }

        $stories = $limit = (int) $this->getRequestParam('limit', 200);
        $page = (int) $this->getRequestParam('page', 1);
        $paginator = $table->getUserStory($user_id, $isSendMessage);
        $paginator->setItemCountPerPage($limit);
        $paginator->setCurrentPageNumber($page);

        foreach ($paginator as $story) {
            $browseStory = $story->toArray();
            $browseStory["owner_title"] = $story->getOwner()->getTitle();
            $browseStory["description"] = str_ireplace( array("<br>","<br />","<br/>"), "\n", $browseStory["description"] );
            $browseStory["isSendMessage"] = $isSendMessage;
            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
            $browseStory = array_merge($browseStory, $getContentImages);

            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
            $browseStory = array_merge($browseStory, $getContentImages);

            $isViewed = 1;
            if (!$story->isOwner($viewer)) {
                $isViewed = $this->_isViewerStory($story, $viewer);
                if (!$isViewed) {
                    $story->view_count++;
                    $story->save();
                    $this->_addViewerDetails($story, $viewer);
                }
            }
            if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                $tempArray = $this->_getBannerImages($browseStory);
                $browseStory = array_merge($browseStory, $tempArray);     
            }
            $browseStory['isViewed'] = $isViewed;
            if (!$story->isOwner($viewer)) {
                if ($story->privacy == 'owner') {
                    $browseStory['authView'] = 0;
                } else {
                    $browseStory['authView'] = 1;
                }
            } else {
                $browseStory['authView'] = 1;
            }
            if ($story->file_id) {
                $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
            } else {
                $browseStory['videoUrl'] = '';
            }

            $browseStory['gutterMenu'] = $this->_gutterMenus($story);
            $response[] = $browseStory;
        }

        $this->respondWithSuccess($response);    
    }

    public function getViewerAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $story = Engine_Api::_()->core()->getSubject();
        
        if (empty($story))
            $this->respondWithError('no_record');
        try {
            $table = Engine_Api::_()->getDbtable('viewers', 'sitestories');
            $storyViewers = $table->select()
                    ->where('object_id = ?', $story->getIdentity());

            $paginator = Zend_Paginator::factory($storyViewers);

            $limit = (int) $this->getRequestParam('limit', 20);
            $page = (int) $this->getRequestParam('page', 1);
            $paginator->setItemCountPerPage($limit);
            $paginator->setCurrentPageNumber($page);
            $users['totalItemCount'] = $paginator->getTotalItemCount();
            
            foreach ($paginator as $storyViewer) {
                $user = Engine_Api::_()->getItem('user', $storyViewer->subject_id);
                $tempUser = Engine_Api::_()->getApi('Core', 'siteapi')->validateUserArray($user);

                // Add images
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($user);
                $tempUser = array_merge($tempUser, $getContentImages);
                $users['response'][] = $tempUser;
            }
            $this->respondWithSuccess($users);
        } catch (Exception $ex) {
            
        }
    }

        public function editAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (Engine_Api::_()->core()->hasSubject())
            $story = Engine_Api::_()->core()->getSubject();

        // RETURN IF NO SUBJECT AVAILABLE.
        if (empty($story))
            $this->respondWithError('no_record');


        if (empty($viewer_id))
            $this->respondWithError('unauthorized');
        
        if(!($viewer_id == $story->owner_id || $viewer->isAdmin()))
            $this->respondWithError('unauthorized');

        if ($this->getRequest()->isGet()) {
            //advanced activity feed
            $response['form'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getStoryForm();
            $response['formValues'] = $story->toArray();
            $privacyStatus = Engine_Api::_()->getDbtable('userprivacies', 'sitestories')->getUserStoryPrivacyStatus($viewer->getIdentity());
            $response['formValues']['privacy'] = $privacyStatus;

            $this->respondWithSuccess($response);
        } else if ($this->getRequest()->isPost()) {
            $values = $data = $_REQUEST;
            $db = Engine_Api::_()->getDbtable('stories', 'sitestories')->getAdapter();
            $db->beginTransaction();
            try {
                $story->setFromArray($values);
                $story->save();
                $db->commit();
                $response = array();
                $response['description'] = $story->description;
                $updateArray = array(
                  "privacy_status" => $values['privacy']
                );
                //Update User Privacy
                $privacyTable = Engine_Api::_()->getDbtable('userprivacies', 'sitestories');
                $privacyTable->update($updateArray, array("user_id =?" => $viewer_id));

                $this->respondWithSuccess($response);
            } catch (Exception $ex) {
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    public function deleteAction() {
        // Validate request methods

        $this->validateRequestMethod('DELETE');

        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        if (empty($viewer_id))
            $this->respondWithError('unauthorized');

        if (Engine_Api::_()->core()->hasSubject())
            $story = Engine_Api::_()->core()->getSubject();

        // RETURN IF NO SUBJECT AVAILABLE.
        if (empty($story))
            $this->respondWithError('no_record');

        if(!($viewer_id == $story->owner_id || $viewer->isAdmin()))
            $this->respondWithError('unauthorized');

        $db = $story->getTable()->getAdapter();
        $db->beginTransaction();
        try {   
            if (Engine_Api::_()->getItem('storage_file', $story->file_id))
                Engine_Api::_()->getItem('storage_file', $story->file_id)->remove();

            if (Engine_Api::_()->getItem('storage_file', $story->photo_id) && $story->photo_id)
                Engine_Api::_()->getItem('storage_file', $story->photo_id)->remove();

            Engine_Api::_()->getDbtable('viewers', 'sitestories')->delete(array(
                'object_id = ?' => $story->story_id,
            ));

            $story->delete();
            $db->commit();
            $this->successResponseNoContent('no_content', true);
        } catch (Exception $ex) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    public function viewerCountAction() {
        $this->validateRequestMethod('POST');
        $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $viewer = Engine_Api::_()->user()->getViewer();
        if (Engine_Api::_()->core()->hasSubject())
            $story = Engine_Api::_()->core()->getSubject();

        if (empty($story)) {
            $this->respondWithError('no_record');
        }

        if (!$story->isOwner($viewer)) {
            $isViewed = $this->_isViewerStory($story, $viewer);
            if (!$isViewed) {
                $story->view_count++;
                $story->save();
                $this->_addViewerDetails($story, $viewer);
            }
        }
        $this->successResponseNoContent('no_content', true);
    }

    public function mutestoryBrowseAction() {
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        $viewer = $user = Engine_Api::_()->user()->getViewer();
        $user_id = $user->getIdentity();
        if (empty($user_id))
            $this->respondWithError('unauthorized');
        try {
            $table = Engine_Api::_()->getDbtable('muteusers', 'sitestories');
            $paginator = $table->getMuteUserStories();
            $limit = (int) $this->getRequestParam('limit', 20);
            $page = (int) $this->getRequestParam('page', 1);
            $paginator->setItemCountPerPage($limit);
            $paginator->setCurrentPageNumber($page);
            $response['totalItemCount'] = $paginator->getTotalItemCount();

            foreach ($paginator as $story) {
                $browseStory = $story->toArray();
                $browseStory["owner_title"] = $story->getOwner()->getTitle();
                $isSendMessage = 0;
                if (!$story->isOwner($viewer)) {
                    try {
                        $isSendMessage = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->isAllowMessage($viewer, $story);
                    } catch (Exception $ex) {
                        $isSendMessage = 0;
                    }
                } else {
                    $isSendMessage = 1;
                }
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
                $browseStory = array_merge($browseStory, $getContentImages);

                $browseStory["isSendMessage"] = $isSendMessage;
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
                $browseStory = array_merge($browseStory, $getContentImages);

                if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                    $tempArray = $this->_getBannerImages($browseStory);
                    $browseStory = array_merge($browseStory, $tempArray);     
                }

                $isViewed = 1;
                if (!$story->isOwner($viewer)) {
                    $isViewed = $this->_isViewerStory($story, $viewer);
                }
                $browseStory['isViewed'] = $isViewed;
                if (!$story->isOwner($viewer)) {
                    if ($story->privacy == 'owner') {
                        $browseStory['authView'] = 0;
                    } else {
                        $browseStory['authView'] = 1;
                    }
                } else {
                    $browseStory['authView'] = 1;
                }
                if ($story->file_id) {
                    $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                    $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
                } else {
                    $browseStory['videoUrl'] = '';
                }

                $browseStory['gutterMenu'] = $this->_gutterMenus($story);
                $response['response'][] = $browseStory;
            }

            $this->respondWithSuccess($response);
        } catch (Exception $ex) {
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    public function muteStoryAction() {
        try {
            $this->validateRequestMethod('POST');
            //Variable Declaration

            $params = array();
            $viewer = Engine_Api::_()->user()->getViewer();
            if (Engine_Api::_()->core()->hasSubject())
                $story = Engine_Api::_()->core()->getSubject();
            $is_mute = $this->getRequestParam('is_mute', 0);
            $db = Engine_Api::_()->getDbtable('muteusers', 'sitestories')->getAdapter();
            $db->beginTransaction();

            $muteusersTable = Engine_Api::_()->getDbtable('muteusers', 'sitestories');
            if (empty($story)) {
                $this->respondWithError('no_record');
            }

            $params['muted_user_id'] = $story->owner_id;
            $params['user_id'] = $viewer->getIdentity();

            if (!empty($is_mute)) {
                $muteusersTable->muteUser($params);
            } else {
                $muteusersTable->unMuteUser($params);
            }

            $db->commit();
            $this->successResponseNoContent('no_content', true);
        } catch (Exception $ex) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    private function _getYourStory($user = array()) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        if (empty($user))
            return;
        $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $result = $table->getyourStory($user->user_id);
        $total = $result->getTotalItemCount();

        if ($total > 0) {
            foreach ($result as $story) {
                $browseStory = $story->toArray();

                $browseStory["owner_title"] = Engine_Api::_()->getApi('Core', 'siteapi')->translate('Your Story');
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
                $browseStory = array_merge($browseStory, $getContentImages);

                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
                $browseStory = array_merge($browseStory, $getContentImages);

                if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                    $tempArray = $this->_getBannerImages($browseStory);
                    $browseStory = array_merge($browseStory, $tempArray);     
                }
                $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestories')->getTotalStoryCount($story->owner_id);
                if ($story->file_id) {
                    $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                    $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
                } else {
                    $browseStory['videoUrl'] = '';
                }
                $browseStory['gutterMenu'] = $this->_gutterMenus($story);
                break;
            }
        } else {
            $browseStory["owner_title"] = Engine_Api::_()->getApi('Core', 'siteapi')->translate('Your Story');
            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($user, true);
            $browseStory = array_merge($browseStory, $getContentImages);
        }

        return $browseStory;
    }

    private function _addViewerDetails($story, $viewer) {
        if (empty($story) || empty($viewer)) {
            return;
        }
        $db = Engine_Api::_()->getDbtable('viewers', 'sitestories')->getAdapter();
        $db->beginTransaction();
        try {
            $table = Engine_Api::_()->getDbtable('viewers', 'sitestories');
            $row = $table->select()
                    ->where('subject_id =?', $viewer->getIdentity())
                    ->where('object_id = ?', $story->getIdentity())
                    ->query()
                    ->fetchAll();
            $rowCount = count($row);
            if ($rowCount == 0) {
                $values['subject_id'] = $viewer->getIdentity();
                $values['subject_type'] = $viewer->getType();
                $values['object_id'] = $story->getIdentity();
                $values['object_type'] = $story->getType();
                $row = $table->createRow();
                $row->setFromArray($values);
                $row->save();
                $db->commit();
            }
        } catch (Exception $ex) {
            $db->rollBack();
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    private function _isViewerStory($story, $viewer) {
        try {
            $table = Engine_Api::_()->getDbtable('viewers', 'sitestories');
            $row = $table->select()
                    ->where('subject_id =?', $viewer->getIdentity())
                    ->where('object_id = ?', $story->getIdentity())
                    ->query()
                    ->fetchAll();
            $rowCount = count($row);
            if ($rowCount > 0) {
                return 1;
            } else
                return 0;
        } catch (Exception $ex) {
            
        }
    }

    protected function _process($video, $type = 'mp4', $compatibilityMode = false) {
        $tmpDir = $this->getTmpDir();
        if (!Zend_Registry::isRegistered('Zend_Translate'))
            Engine_Api::_()->getApi('Core', 'siteapi')->setTranslate();

        Engine_Api::_()->getApi('Core', 'siteapi')->setView();
        // Prepare information
        $owner = $video->getOwner();

        // Pull video from storage system for encoding
        $storageObject = $this->getStorageObject($video);
        $originalPath = $this->getOriginalPath($storageObject);

        $outputPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vconverted.' . $type;
        $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormalthumb.jpg';

        $thumbNormalLargePath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormallargethumb.jpg';
        $thumbMainPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vmainthumb.jpg';
        $width = 480;
        $height = 386;

        $videoCommand = $this->buildVideoCmd($video, $width, $height, $type, $originalPath, $outputPath, $compatibilityMode);

        // Prepare output header
        $output = PHP_EOL;
        $output .= $originalPath . PHP_EOL;
        $output .= $outputPath . PHP_EOL;
        $output .= $thumbPath . PHP_EOL;

        // Prepare logger
        $log = new Zend_Log();
        $log->addWriter(new Zend_Log_Writer_Stream(APPLICATION_PATH . '/temporary/log/sitevideo.log'));

        // Execute video encode command
        $videoOutput = $output .
                $videoCommand . PHP_EOL .
                shell_exec($videoCommand);

        // Log
        if ($log) {
            $log->log($videoOutput, Zend_Log::INFO);
        }

        // Check for failure
        $success = $this->conversionSucceeded($video, $videoOutput, $outputPath);
        // Failure
        if (!$success) {
            if (!$compatibilityMode) {
                $this->_process($video, true);
                return;
            }

            // Write to additional log in dev
            if (APPLICATION_ENV == 'development') {
                file_put_contents($tmpDir . '/' . $video->story_id . '.txt', $videoOutput);
            }

            $this->respondWithError('unauthorized', 'encoding failed');
        }

        // Success
        else {
            // Get duration of the video to caculate where to get the thumbnail
            $duration = $this->getDuration($videoOutput);

            // Log duration
            if ($log) {
                $log->log('Duration: ' . $duration, Zend_Log::INFO);
            }

            // Fetch where to take the thumbnail
            $thumb_splice = $duration / 2;

            $thumbMainSuccess = $this->generateMainThumbnail($outputPath, $output, $thumb_splice, $thumbMainPath, $log);

            // Save video and thumbnail to storage system
            $params = array(
                'parent_id' => $video->getIdentity(),
                'parent_type' => $video->getType(),
                'user_id' => $video->owner_id
            );

            $db = $video->getTable()->getAdapter();
            $db->beginTransaction();

            try {
                $storageObject->setFromArray($params);
                //$storageObject->store($outputPath);

                if ($thumbMainSuccess) {
                    $thumbMainSuccessRow = Engine_Api::_()->storage()->create($thumbMainPath, array_merge($params, array('type' => 'thumb.main')));
                }

                $thumbPath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormalthumb.jpg';

                $thumbNormalLargePath = $tmpDir . DIRECTORY_SEPARATOR . $video->getIdentity() . '_vnormallargethumb.jpg';

                $image = Engine_Image::factory();
                $image->open($thumbMainPath)
                        ->resize(720, 720)
                        ->write($thumbNormalLargePath)
                        ->destroy();

                $image = Engine_Image::factory();
                $image->open($thumbMainPath)
                        ->resize(375, 375)
                        ->write($thumbPath)
                        ->destroy();
                Engine_Api::_()->storage()->create($thumbNormalLargePath, array_merge($params, array('type' => 'thumb.large')));
                $thumbNormalSuccessRow = Engine_Api::_()->storage()->create($thumbPath, array_merge($params, array('type' => 'thumb.normal')));

                $db->commit();
            } catch (Exception $e) {
                $db->rollBack();

                // delete the files from temp dir
                unlink($originalPath);
                unlink($outputPath);

                if ($thumbSuccess) {
                    unlink($thumbPath);
                }

                $video->save();

                $this->notifyOwner($video, $owner);

                throw $e; // throw
            }

            // Video processing was a success!
            // Save the information
            if ($thumbMainSuccess) {
                $video->photo_id = $thumbMainSuccessRow->file_id;
            }

            $video->duration = $duration;
            $video->save();

            // delete the files from temp dir
            unlink($originalPath);
            unlink($outputPath);
            unlink($thumbPath);
            unlink($thumbMainPath);
            unlink($thumbNormalLargePath);
        }
    }

    private function generateMainThumbnail($outputPath, $output, $thumb_splice, $thumbPath, $log) {
        set_time_limit(0);
        $ffmpeg_path = $this->getFFMPEGPath();
        // Thumbnail process command
        $thumbCommand = $ffmpeg_path . ' '
                . '-i ' . escapeshellarg($outputPath) . ' '
                . '-f image2' . ' '
                . '-ss ' . $thumb_splice . ' '
                . '-vframes 1' . ' '
                . '-v 2' . ' '
                . '-y ' . escapeshellarg($thumbPath) . ' '
                . '2>&1';

        // Process thumbnail
        $thumbOutput = $output .
                $thumbCommand . PHP_EOL .
                shell_exec($thumbCommand);

        // Log thumb output
        if ($log) {
            $log->log($thumbOutput, Zend_Log::INFO);
        }

        // Check output message for success
        $thumbSuccess = true;
        if (preg_match('/video:0kB/i', $thumbOutput)) {
            $thumbSuccess = false;
        }
        $mainHeight = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.video.height', 1600);
        $mainWidth = Engine_Api::_()->getApi('settings', 'core')->getSetting('main.video.height', 1600);
        // Resize thumbnail
        if ($thumbSuccess) {
            try {
                $image = Engine_Image::factory();
                $image->open($thumbPath)
                        ->resize($mainHeight, $mainWidth)
                        ->write($thumbPath)
                        ->destroy();
            } catch (Exception $e) {
                
            }
        }

        return $thumbSuccess;
    }

    private function getTmpDir() {
        // Check the video temporary directory
        $tmpDir = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary' .
                DIRECTORY_SEPARATOR . 'sitevideo';
        if (!is_dir($tmpDir) && !mkdir($tmpDir, 0777, true)) {
            return;
        }

        if (!is_writable($tmpDir)) {
            return;
        }
        return $tmpDir;
    }

    private function getStorageObject($video) {
        // Pull video from storage system for encoding
        $storageObject = Engine_Api::_()->getItem('storage_file', $video->file_id);

        if (!$storageObject) {
            $this->respondWithError('internal_server_error', "Video storage file was missing");
        }
        return $storageObject;
    }

    private function getOriginalPath($storageObject) {
        $originalPath = $storageObject->temporary();
        if (!file_exists($originalPath)) {
            $this->respondWithError('internal_server_error', "Could not pull to temporary file");
        }
        return $originalPath;
    }

    private function buildVideoCmd($video, $width, $height, $type, $originalPath, $outputPath, $compatibilityMode = false) {

        $ffmpeg_path = $this->getFFMPEGPath();

        $videoCommand = $ffmpeg_path . ' '
                . '-i ' . escapeshellarg($originalPath) . ' '
                . '-ab 64k' . ' '
                . '-ar 44100' . ' '
                . '-qscale 5' . ' '
                . '-r 25' . ' ';

        if ($type == 'mp4')
            $videoCommand .= '-vcodec libx264' . ' '
                    . '-acodec aac' . ' '
                    . '-strict experimental' . ' '
                    . '-preset veryfast' . ' '
                    . '-f mp4' . ' '
            ;
        else
            $videoCommand .= '-vcodec flv -f flv ';

        if ($compatibilityMode) {
            $videoCommand .= "-s ${width}x${height}" . ' ';
        } else {
            $filters = $this->getVideoFilters($video, $width, $height);
            $videoCommand .= '-vf "' . $filters . '" ';
        }

        $videoCommand .= '-y ' . escapeshellarg($outputPath) . ' '
                . '2>&1';
        return $videoCommand;
    }

    private function conversionSucceeded($video, $videoOutput, $outputPath) {
        $success = true;
        // Unsupported format

        if (preg_match('/Unknown format/i', $videoOutput) || preg_match('/Unsupported codec/i', $videoOutput) || preg_match('/patch welcome/i', $videoOutput) || preg_match('/Audio encoding failed/i', $videoOutput) || !is_file($outputPath) || filesize($outputPath) <= 0) {
            $success = false;
        }

        // This is for audio files
        else if (preg_match('/video:0kB/i', $videoOutput)) {
            $success = false;
        }

        return true;
    }

    private function notifyOwner($video, $owner) {
        $translate = Zend_Registry::get('Zend_Translate');
        $language = !empty($owner->language) && $owner->language != 'auto' ? $owner->language : null;

        $notificationMessage = '';
        $exceptionMessage = 'Unknown encoding error.';

        if ($video->status == 3) {
            $exceptionMessage = 'Video format is not supported by FFMPEG.';
            $notificationMessage = 'Video conversion failed. Video format is not supported by FFMPEG. Please try %1$sagain%2$s.';
        } else if ($video->status == 5) {
            $exceptionMessage = 'Audio-only files are not supported.';
            $notificationMessage = 'Video conversion failed. Audio files are not supported. Please try %1$sagain%2$s.';
        } else if ($video->status == 7) {
            $notificationMessage = 'Video conversion failed. You may be over the site upload limit.  Try %1$suploading%2$s a smaller file, or delete some files to free up space.';
        }

        $notificationMessage = $translate->translate(sprintf($notificationMessage, '', ''), $language);

        Engine_Api::_()->getDbtable('notifications', 'activity')
                ->addNotification($owner, $owner, $video, 'sitevideo_processed_failed', array(
                    'message' => $notificationMessage,
                    'message_link' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage'), 'sitevideo_general', true),
        ));

        return $exceptionMessage;
    }

    private function getDuration($videoOutput) {
        $duration = 0;

        if (preg_match('/Duration:\s+(.*?)[.]/i', $videoOutput, $matches)) {
            list($hours, $minutes, $seconds) = preg_split('[:]', $matches[1]);
            $duration = ceil($seconds + ($minutes * 60) + ($hours * 3600));
        }

        return $duration;
    }

    private function getVideoFilters($video, $width, $height) {
        $filters = "scale=$width:$height";
        if ($video->rotation > 0) {
            $filters = "pad='max(iw,ih*($width/$height))':ow/($width/$height):(ow-iw)/2:(oh-ih)/2,$filters";

            if ($video->rotation == 180)
                $filters = "hflip,vflip,$filters";
            else {
                $transpose = array(90 => 1, 270 => 2);

                if (empty($transpose[$video->rotation]))
                    return;
                $filters = "transpose=${transpose[$video->rotation]},$filters";
            }
        }

        return $filters;
    }

    private function getFFMPEGPath() {
        set_time_limit(0);
        // Check we can execute
        if (!function_exists('shell_exec')) {
            return;
        }

        if (!function_exists('exec')) {
            return;
        }
        $coreSettings = Engine_Api::_()->getApi('settings', 'core');

        // Make sure FFMPEG path is set
        $ffmpeg_path = $coreSettings->getSetting('sitevideo.ffmpeg.path', $coreSettings->getSetting('sitevideo.ffmpeg.path', ''));
        if (!$ffmpeg_path) {
            return;
        }

        // Make sure FFMPEG can be run
        if (!@file_exists($ffmpeg_path) || !@is_executable($ffmpeg_path)) {
            $output = null;
            $return = null;
            exec($ffmpeg_path . ' -version', $output, $return);

            if ($return > 0) {
                return;
            }
        }

        return $ffmpeg_path;
    }

    public function handleIframelyInformation($uri) {
        $iframelyDisallowHost = Engine_Api::_()->getApi('settings', 'core')->getSetting('video_iframely_disallow');
        if (parse_url($uri, PHP_URL_SCHEME) === null) {
            $uri = "http://" . $uri;
        }
        $uriHost = Zend_Uri::factory($uri)->getHost();
        if ($iframelyDisallowHost && in_array($uriHost, $iframelyDisallowHost)) {
            return;
        }
        $config = Engine_Api::_()->getApi('settings', 'core')->core_iframely;
        $iframely = Engine_Iframely::factory($config)->get($uri);
        if (!in_array('player', array_keys($iframely['links']))) {
            return;
        }
        $information = array('thumbnail' => '', 'title' => '', 'description' => '', 'duration' => '');
        if (!empty($iframely['links']['thumbnail'])) {
            $information['thumbnail'] = $iframely['links']['thumbnail'][0]['href'];
            if (parse_url($information['thumbnail'], PHP_URL_SCHEME) === null) {
                $information['thumbnail'] = str_replace(array('://', '//'), '', $information['thumbnail']);
                $information['thumbnail'] = "http://" . $information['thumbnail'];
            }
        }

        if (!isset($information['thumbnail']) || empty($information['thumbnail'])) {
            $page_content = file_get_contents($uri);
            $dom_obj = new DOMDocument();
            $dom_obj->loadHTML($page_content);
            $meta_val = null;

            foreach ($dom_obj->getElementsByTagName('meta') as $meta) {

                if ($meta->getAttribute('property') == 'og:image') {

                    $information['thumbnail'] = $meta->getAttribute('content');
                }
            }
        }

        if (!empty($iframely['meta']['title'])) {
            $information['title'] = $iframely['meta']['title'];
        }
        if (!empty($iframely['meta']['description'])) {
            $information['description'] = $iframely['meta']['description'];
        }
        if (!empty($iframely['meta']['duration'])) {
            $information['duration'] = $iframely['meta']['duration'];
        }
        $information['code'] = $iframely['html'];
        return $information;
    }

    private function _gutterMenus($story) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        $owner = $story->getOwner();
        $owner_id = $owner->getIdentity();
        $menus = array();

        if ($owner_id == $viewer_id) {
            $menus[] = array(
                'label' => $this->translate('Delete'),
                'name' => 'delete',
                'url' => 'advancedactivity/story/delete/' . $story->getIdentity()
            );
            if (empty($story->file_id)) {
                $menus[] = array(
                    'label' => $this->translate('Save Photo'),
                    'name' => 'save',
                );
            } else {
                $menus[] = array(
                    'label' => $this->translate('Download Video'),
                    'name' => 'save_video',
                );
            }
            
        } else {
            $menus[] = array(
                'label' => $this->translate('Report Story'),
                'name' => 'report',
                'url' => 'advancedactivity/story/report-story/' . $story->getIdentity(),
            );
            $mute_story = Engine_Api::_()->getDbtable('muteusers', 'sitestories')->isMuteStoryByUser($story);
            if (empty($mute_story)) {
                $menus[] = array(
                    'label' => sprintf($this->translate('Mute %s'), $story->getOwner()->getTitle()),
                    'name' => 'mute',
                    'url' => 'advancedactivity/story/mute-story/' . $story->getIdentity(),
                    'urlParams' => array(
                        "is_mute" => 1
                    )
                );
            } else {
                $menus[] = array(
                    'label' => sprintf($this->translate('Unmute %s'), $story->getOwner()->getTitle()),
                    'name' => 'mute',
                    'url' => 'advancedactivity/story/mute-story/' . $story->getIdentity(),
                    'urlParams' => array(
                        "is_mute" => 0
                    )
                );
            }
        }
        return $menus;
    }

    //get Every one story
    private function _getEveryoneStory($response) {
        $viewer = Engine_Api::_()->user()->getViewer();
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        $viewer_id = $viewer->getIdentity();
        $table = Engine_Api::_()->getDbtable('stories', 'sitestories');
        $paginator = $table->getEveryoneStory($viewer);
        $paginator->setItemCountPerPage(50);
        $paginator->setCurrentPageNumber(1);
        foreach ($paginator as $story) {
            if ($story->owner_id == $viewer_id) {
                continue;
            }
            $browseStory = $story->toArray();
            $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestories')->getTotalStoryCount($story->owner_id);
            $browseStory["owner_title"] = $story->getOwner()->getTitle();

            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
            $browseStory = array_merge($browseStory, $getContentImages);

            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
            $browseStory = array_merge($browseStory, $getContentImages);

            if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                $tempArray = $this->_getBannerImages($browseStory);
                $browseStory = array_merge($browseStory, $tempArray);     
            }

            if ($story->file_id) {
                $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
            } else {
                $browseStory['videoUrl'] = '';
            }
            $browseStory['gutterMenu'] = $this->_browseGutterMenus($story);
            $response[] = $browseStory;
        }

        return $response;
    }

    public function MuteUserStories($response = array()) {
        $table = Engine_Api::_()->getDbtable('muteusers', 'sitestories');
        $viewer = Engine_Api::_()->user()->getViewer();
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        $results = $table->getMuteUserStories(1);
        foreach ($results as $story) {
            $this->_owner_ids[]= $story->owner_id;
            $browseStory = $story->toArray();
            $browseStory["total_stories"] = Engine_Api::_()->getDbtable('stories', 'sitestories')->getTotalStoryCount($story->owner_id);
            $browseStory["owner_title"] = $story->getOwner()->getTitle();
            $browseStory["isMute"] = 1;
            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story);
            $browseStory = array_merge($browseStory, $getContentImages);

            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($story, true);
            $browseStory = array_merge($browseStory, $getContentImages);

            if(!empty($browseStory['type']) && $browseStory['type'] == 'text'){
                $tempArray = $this->_getBannerImages($browseStory);
                $browseStory = array_merge($browseStory, $tempArray);     
            }

            if ($story->file_id) {
                $browseStory['videoUrl'] = Engine_Api::_()->getApi('Siteapi_Core', 'sitestories')->getVideoUrl($story);
                $browseStory['video_overlay_image'] = $this->_getVideoFilterImage($story);
            } else {
                $browseStory['videoUrl'] = '';
            }

            //Gutter Menu
            $browseStory['gutterMenu'] = $this->_browseGutterMenus($story);
            $response[] = $browseStory;
        }
        return $response;
    }

    public function _browseGutterMenus($story) {
        $menus = array();
        $mute_story = Engine_Api::_()->getDbtable('muteusers', 'sitestories')->isMuteStoryByUser($story);
        if (empty($mute_story)) {
            $menus[] = array(
                'label' => sprintf($this->translate('Mute %s'), $story->getOwner()->getTitle()),
                'name' => 'mute',
                'url' => 'stories/story/mute-story/' . $story->getIdentity(),
                'urlParams' => array(
                    "is_mute" => 1
                )
            );
        } else {
            $menus[] = array(
               'label' => sprintf($this->translate('Unmute %s'), $story->getOwner()->getTitle()),
                'name' => 'mute',
                'url' => 'stories/story/mute-story/' . $story->getIdentity(),
                'urlParams' => array(
                    "is_mute" => 0
                )
            );
        }

        return $menus;
    }
    
    private function _getVideoFilterImage($story){
        //Video Filter Work..............
        try
        {
            $select = Engine_Api::_()->getItemTable('storage_file')->select()
            ->where('parent_type = ?', 'advancedactivity_story_filter')
            ->where('parent_id = ?', $story->getIdentity())
            ->limit(1);
            $filterImage = Engine_Api::_()->getItemTable('storage_file')->fetchRow($select);
            if(!empty($filterImage)){
            $filterImage = Engine_Api::_()->getApi('Siteapi_Feed', 'advancedactivity')->getPhotoUrl($filterImage);
            return $filterImage;
            }

        } 
        catch (Exception $ex) 
        {

        }
    }

    public function bannerAction() {
        $table = Engine_Api::_()->getDbTable('banners', 'sitestories');
        try {
            $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
            $api = Engine_Api::_()->getApi('settings', 'core');
            $limit = $this->_getParam('limit',10);
            $page = $this->_getParam('page',1);
            $order = $this->_getParam('order', 'random');
            $select = $table->select()
                    ->where('enabled =? ', 1)
                    ->where('startdate <= now()')
                    ->limit($limit);
            if ($order !== 'random') {
                $select->order('order ASC');
            } else {
                $select->order('Rand()');
            }
            $banners = $table->fetchAll($select);
            $data = array();
            $dataHighlighted = array();
            foreach ($banners as $banner) {
                if ($banner->enddate != '0000-00-00' && $banner->enddate < date('Y-m-d')) {
                    continue;
                }
                $bannersFormat = array();
                $bannersFormat['banner_id'] = $banner->file_id;
                $bannersFormat['image'] = 'none';
                if (!empty($banner->file_id)) {
                    $file = Engine_Api::_()->getDbtable('files', 'storage')->getFile($banner->file_id);
                    $bannersFormat['image'] = $file ? 'url(' . $file->getHref() . ')' : 'none';
                    $bannersFormat['feed_banner_url'] = $file ? $file->getHref() : 'none';
                    $bannersFormat['feed_banner_url'] = strstr($bannersFormat['feed_banner_url'], 'http') ? $bannersFormat['feed_banner_url'] : $getHost . $bannersFormat['feed_banner_url'];
                } else if ($banner->gradient) {
                    continue;
                }
                $bannersFormat['background-color'] = $banner->background_color;
                $bannersFormat['color'] = $banner->color;
                $bannersFormat['highlighted'] = $banner->highlighted;
                if ($banner->highlighted) {
                    $dataHighlighted[] = $bannersFormat;
                    continue;
                }
                $data[] = $bannersFormat;
            }

            $response = array_merge($dataHighlighted, $data);
            $this->respondWithSuccess($response);
        } catch (Exception $ex) {
            $this->respondWithValidationError('internal_server_error', $ex->getMessage());
        }
    }

    public function reportStoryAction(){
        $story_id = $this->_getParam('story_id');
        if(empty($story_id)){
            $this->respondWithError('unauthorized', 'No Story Found!!');
        }
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();
        if(!$viewer_id){
            $this->respondWithError('unauthorized');
        }

        if ($this->getRequest()->isGet()) {
            $this->respondWithSuccess(Engine_Api::_()->getApi('Siteapi_Core', 'core')->getReportForm());
        } else if ($this->getRequest()->isPost()) {
            $data["report_type"] = $this->getRequestParam("category");
            $data["report_description"] = $this->getRequestParam("description");
 
            $reportsTable = Engine_Api::_()->getDbtable('reports','sitestories');
            $db = $reportsTable->getAdapter();
            $db->beginTransaction();
            try{
                $row = $reportsTable->createRow();
                $row->user_id = $viewer_id;
                $row->setFromArray($data);
                $row->story_id = $story_id;
                $row->save();
                $db->commit();
                $this->successResponseNoContent('no_content');
            }catch(Exception $ex){
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    public function viewRepliesAction() {
        $viewer = Engine_Api::_()->user()->getViewer();
        $convTable= Engine_Api::_()->getItemTable('messages_conversation');
        $convName= $convTable->info('name'); 
        $select = $convTable->getInboxSelect($viewer);
        $countSelect = $select;
        $replyName = Engine_Api::_()->getDbtable('replies', 'sitestories')->info('name');
        $page = $this->_getParam('page',1);
        $story_id = $this->_getParam('story_id',0);
        
        $select
        ->join($replyName, "`{$replyName}`.`conversation_id` = `{$convName}`.`conversation_id`", null)
        ->where("`{$replyName}`.`story_id` = ?", $this->_getParam('story_id',0))
        ->group("$convName.conversation_id");
        
        $paginator = Zend_Paginator::factory($select);
        $items_per_page = $this->_getParam('limit',10);
        $paginator->setItemCountPerPage($items_per_page);
        $paginator->setCurrentPageNumber($page);
        foreach($paginator as $conversation){
            $converArr = $conversation->toArray();
            $message = $conversation->getInboxMessage($viewer);
            $recipient = $conversation->getRecipientInfo($viewer);
            $resource = "";
            $sender   = "";
            if( $conversation->hasResource() && ($resource = $conversation->getResource()) ) {
              $sender = $resource;
            } else if( $conversation->recipients > 1 ) {
              $sender = $viewer;
            } else {
              foreach( $conversation->getRecipients() as $tmpUser ) {
                if( $tmpUser->getIdentity() != $viewer->getIdentity() ) {
                  $sender = $tmpUser;
                }
              }
            }
            if( (!isset($sender) || !$sender) && $viewer->getIdentity() !== $conversation->user_id ){
              $sender = Engine_Api::_()->user()->getUser($conversation->user_id);
            }
            if( !isset($sender) || !$sender ) {
              $sender = new User_Model_User(array());
            }

            // Add images
            $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($sender);
            $converArr = array_merge($converArr, $getContentImages);

            if( !empty($resource) )
                $converArr['displayname'] = $resource->toString();
            elseif( $conversation->recipients == 1 )
                $converArr['displayname'] = $sender->getTitle();
            
            $content = preg_replace("/<img[^>]+\>/i", "", $message->body); 
            $content = str_ireplace("<br>", "", $content);
    
            $converArr['message'] = $content;
            $converArr['date'] = $message->date;
            $conversationArr[] = $converArr;
                
        }

        if(isset($conversationArr) && !empty($conversationArr))
            $response['response'] = $conversationArr;

        $this->respondWithSuccess($response); 
    }

    public function storiesPrivacyAction(){
        //ONLY LOGGED IN USER CAN CREATE
        if (!$this->_helper->requireUser()->isValid())
            $this->respondWithError('unauthorized');

        //USER CAN CREATE ONLY WHEN PLUGIN IS ACTIVE
        $settings = Engine_Api::_()->getApi('settings', 'core');
        $isPluginActive= $settings->getSetting('sitestories.enable.stories', 0);
        if(!$isPluginActive){
          $this->respondWithError('unauthorized');
        }

        //GET VIEWER
        $viewer = Engine_Api::_()->user()->getViewer();
        $viewer_id = $viewer->getIdentity();

        //GET USER CURRUNT PRIVACY
        $privacyTable = Engine_Api::_()->getDbtable('userprivacies', 'sitestories');
        $privacyData = $privacyTable->getUserPrivacy($viewer_id);
        $privacy_status = $privacyData->privacy_status; 
        
        if ($this->getRequest()->isGet()) {
            //advanced activity feed
            $response['privacy'] = $privacy_status;

            $this->respondWithSuccess($response);
        } else if ($this->getRequest()->isPost()) {
            //update array
            $updateArray = array(
              "privacy_status" => $_REQUEST['stories_privacy']
            );

            $currentDate = date('Y-m-d H:i:s');
            $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
            $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
              
            // Process
            $db = $privacyTable->getAdapter();
            $db->beginTransaction();
            try{
                //Update User Privacy
                $privacyTable->update($updateArray, array("user_id =?" => $viewer_id));
                Engine_Api::_()->getDbtable('stories','sitestories')->update(array('privacy' => $_REQUEST['stories_privacy']),array("enable = ?" => 1,"owner_id = ?" => $viewer_id, "create_date >= ?" => $pastDate));
                $db->commit();
                $this->successResponseNoContent('no_content');
            }catch(Exception $ex){
                $db->rollBack();
                $this->respondWithValidationError('internal_server_error', $ex->getMessage());
            }
        }
    }

    public function suggestAction() {
        // Validate request methods
        $this->validateRequestMethod();
        $viewer = Engine_Api::_()->user()->getViewer();

        if ($viewer->getIdentity()) {
            $data = array();
            $table = Engine_Api::_()->getItemTable('user');
            $tableGroup = Engine_Api::_()->getDbtable('groups', 'calendar');
          
            $select = Engine_Api::_()->getDbtable('users', 'user')->select();
            $select->where('user_id <> ?', $viewer->user_id);

            if (0 < ($limit = (int) $this->getRequestParam('limit', 10))) {
                $select->limit($limit);
            }

            if (null !== ($text = $this->getRequestParam('to'))) {
                $select->where('`' . $table->info('name') . '`.`displayname` LIKE ?', '%' . $text . '%');
            }
            $select->where('`' . $table->info('name') . '`.`user_id` <> ?', $viewer->getIdentity());
            $select->order("{$table->info('name')}.displayname ASC");

            $ids = array();
            foreach ($select->getTable()->fetchAll($select) as $user) {
                $tempData['type'] = 'user';
                $tempData['id'] = $user->getIdentity();
                $tempData['guid'] = $user->getIdentity().'1111';
                $tempData['label'] = $user->getTitle();

                // Add images
                $getContentImages = Engine_Api::_()->getApi('Core', 'siteapi')->getContentImage($user);
                $tempData = array_merge($tempData, $getContentImages);

                $data[] = $tempData;
            }
            $this->respondWithSuccess($data);
        } 
    }
    private function _getBannerImages($browseStory){
        $params = Zend_Json::decode($browseStory['params'],true);

        $file_id = $params['file_id'];
        $getHost = Engine_Api::_()->getApi('Core', 'siteapi')->getHost();
        
        $file = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, 'thumb.main');
        $file1 = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, 'thumb.icon');
        $file2 = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, 'thumb.profile');
        $file3 = Engine_Api::_()->getItemTable('storage_file')->getFile($file_id, 'thumb.normal');
       
        if (!empty($file)) {
            $tempArray = array(
                "image" => strstr($file->map(), 'http') ? $file->map() : $getHost . $file->map(),
                "image_icon" => strstr($file1->map(), 'http') ? $file1->map() : $getHost . $file1->map(),
                "image_profile" => strstr($file2->map(), 'http') ? $file2->map() : $getHost . $file2->map(),
                "image_normal" => strstr($file3->map(), 'http') ? $file3->map() : $getHost . $file3->map()
            );
            
        }
        return $tempArray;
    }
}
?>