<?php


class Sitestoriesweb_Model_DbTable_Muteusers extends Engine_Db_Table {

    protected $_name = 'sitestories_muteusers';
    protected $_rowClass = 'Sitestoriesweb_Model_Muteuser';

    //Return all user Ids
    public function getMuteUserIds() {
        $muteIds = 0;
        $viewer = Engine_Api::_()->user()->getViewer();
        $muteUserTableName = $this->info('name');
        $select = $this->select()
        ->from($muteUserTableName, array('muted_user_id'))
        ->where('user_id = ?', $viewer->getIdentity())
        ->where('muted_user_id != ?', $viewer->getIdentity())
        ;

        $result = $this->fetchAll($select);
        foreach ($result as $row) {
            $muteIds = $muteIds . ',' . $row['muted_user_id'];
        }
        return $muteIds;
    }

    //Mute user
    public function muteUser($params) {
        $viewer = Engine_Api::_()->user()->getViewer();
        //check if user all ready muted...
        $select = $this->select()
        ->where('muted_user_id = ?', $params['muted_user_id'])
        ->where('user_id = ?', $params['user_id']);

        $result = $this->fetchRow($select);
        if ($result)
            return false;
        $muteuser = $this->createRow();
        $muteuser->setFromArray($params);
        $muteuser->save();
        return $muteuser;
    }

    //Unmute user 
    public function unMuteUser($params = array()) {
        if (empty($params))
            return false;
        $muteUserTableName = $this->info('name');
        $viewer = Engine_Api::_()->user()->getViewer();
        $this->delete(array(
            'muted_user_id = ?' => $params['muted_user_id'],
            'user_id = ?' => $viewer->getIdentity()
        ));
    }

}

?>