<?php

class Sitestoriesweb_AdminManageController extends Core_Controller_Action_Admin
{

  public function indexAction()
  { 
    $story_id = $this->_getParam('id');
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitestoriesweb_admin_main', array(), 'sitestoriesweb_admin_main_manage');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Sitestoriesweb_Form_Admin_Manage_Filter();

    $subject = Engine_Api::_()->user()->getViewer();   
    if ($this->getRequest()->isPost())
    {
      $values = $this->getRequest()->getPost();
      foreach ($values as $key=>$value) {
        if ($key == 'delete_' . $value)
        {
          $stories = Engine_Api::_()->getItem('sitestoriesweb_story', $value);
          $stories->delete();
        }
      }
    }
    $currentDate = date('Y-m-d H:i:s');
    $days = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestories_max_allowed_days', 1);
    $pastDate = date('Y-m-d H:i:s', strtotime('-' . $days . ' day', strtotime($currentDate)));
    $page = $this->_getParam('page',1);
   

    //MAKE QUERY
    $tableUser = Engine_Api::_()->getItemTable('user')->info('name');

    $tablestories = Engine_Api::_()->getDbtable('stories', 'sitestoriesweb');
    $tableStoriesName = $tablestories->info('name');

    $select = $tablestories->select()
      ->setIntegrityCheck(false)
      ->from($tableStoriesName)
      ->joinLeft($tableUser, "$tableStoriesName.owner_id = $tableUser.user_id", 'displayname')
      ->order("story_id DESC");
              

    // Process form
    $values = array();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    }

    foreach( $values as $key => $value ) {
      if( null === $value ) {
        unset($values[$key]);
      }
    }

    $values = array_merge(array(
    'order' => 'story_id',
    'order_direction' => 'DESC',
      ), $values);

    $this->view->assign($values);
   
    if( !empty($values['displayname']) ) {
     $select->where('displayname LIKE ?', '%' . $values['displayname'] . '%');
    }

    if( isset($values['type']))
    {
      if($values['type'] == 0 ) {
        $select->where('file_id = ?', 0)->where($tableStoriesName.'.photo_id != ?',0);
      }
      else if($values['type'] == 1 )
      {
        $select->where('type = ?', 'text');
      }elseif ($values['type'] == 2) {
        $select->where('file_id > ?', 0 );
      }
    }

    if( isset($values['enable']))
    {
      if($values['enable'] == 0 ) {
        $select->where('enable = ?', 1 );
      }
      else if($values['enable'] == 1 )
      {
        $select->where('enable = ?', 0 );
      }
    }
    
    // Filter out junk
    $valuesCopy = array_filter($values);
    
    // Make paginator
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(25);
    $this->view->paginator = $paginator->setCurrentPageNumber( $page );
    $this->view->formValues = $valuesCopy;

  }


  public function deleteAction()
  {
    // In smoothbox
    $this->_helper->layout->setLayout('admin-simple');
    $id = $this->_getParam('id');
    
    $this->view->story_id=$id;
    // Check post
    if( $this->getRequest()->isPost())
    {
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      $story = Engine_Api::_()->getItem('sitestoriesweb_story',$id);

      try {
        if (Engine_Api::_()->getItem('storage_file', $story->file_id))
          Engine_Api::_()->getItem('storage_file', $story->file_id)->remove();

        if ($story->photo_id && Engine_Api::_()->getItem('storage_file', $story->photo_id))
          Engine_Api::_()->getItem('storage_file', $story->photo_id)->remove();

        Engine_Api::_()->getDbtable('stories', 'sitestoriesweb')->delete(array(
            'story_id = ?' => $id,
        ));
        $db->commit();

      }

      catch( Exception $e )
      {
        $db->rollBack();
        throw $e;
      }

      return $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 2000,
          'parentRefresh'=> 2000 ,
          'messages' => array('Your story has been deleted')
      ));
    }
    
  }

  //ACTION FOR ENABLE/DISABLE STORIES
  public function enableAction() {
    $story_id = $this->_getParam('id');
    $table = Engine_Api::_()->getDbTable('stories','sitestoriesweb');
    $select = $table->select()->where('story_id = ?',$story_id);
    $story = $table->fetchRow($select);
    $story->enable = !$story->enable;
    $story->save();
    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
  }
}
?>