<?php return array (
  'package' => 
  array (
    'type' => 'module',
    'name' => 'sitestoriesweb',
    'version' => '5.7.0',
    'path' => 'application/modules/Sitestoriesweb',
    'title' => 'Web User Stories Plugin',
    'description' => 'Web Stories are a free, open-web, visual storytelling format for the web, enabling you to easily create visual narratives with engaging animations and immerse your Users in great and fast-loading full-screen experiences. Web Stories represents a new way to obtain a significant amount of traffic.',
    'author' => 'SocialApps.tech',
    'callback' => 
    array (
      'path' => 'application/modules/Sitestoriesweb/settings/install.php',
      'class' => 'Sitestoriesweb_Installer',
      'priority' => 1560,
    ),
    'actions' => 
    array (
      0 => 'install',
      1 => 'upgrade',
      2 => 'refresh',
      3 => 'enable',
      4 => 'disable',
    ),
    'directories' => 
    array (
      0 => 'application/modules/Sitestoriesweb',
    ),
    'files' => 
    array (
      0 => 'application/languages/en/sitestoriesweb.csv',
    ),
  ),
  // Hooks ---------------------------------------------------------------------
    'hooks' => array(
        array(
            'event' => 'onUserDeleteAfter',
            'resource' => 'Sitestoriesweb_Plugin_Core',
        ),
        array(
          'event' => 'onItemDeleteBefore',
          'resource' => 'Sitestoriesweb_Plugin_Core',
        ),
      ),
    // Items ---------------------------------------------------------------------
    'items' => array(
        'sitestoriesweb_story',
        'sitestoriesweb_Viewer',
        'sitestoriesweb_mutestory',
        'sitestoriesweb_muteuser'
      ),

  // Routes  -------------------------------------------------------------------
  'routes' => array(
    // Public
    'stories_general' => array(
      'route' => 'stories/:action/*',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'stories',
        'action' => 'create',
      ),
      'reqs' => array(
        'action' => '(create|stories-privacy|get-members|remove-custom-ids)',
      ),
    ),

    'stories_view' => array(
      'route' => 'stories/view/:owner_id/*',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'stories',
        'action' => 'index',
        'owner_id' => '0',
      ),
      'reqs' => array(
        // 'action' => '(index)',
        'owner_id' => '\d+',
      ),
    ),

    'sitestories_messages' => array(
      'route' => 'stories/compose-message',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'message',
        'action' => 'compose',
      ),
    ),

    'sitestories_messageView' => array(
      'route' => 'stories/view-messages/*',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'message',
        'action' => 'view',
      ),
    ),

    'stories_browse' => array(
      'route' => 'stories/browse/:action/*',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'index',
      ),
    ),
    'stories_banner' => array(
      'route' => 'stories/load-banners',
      'defaults' => array(
          'module' => 'sitestoriesweb',
          'controller' => 'banners',
          'action' => 'load-banners',
      ),
      'reqs' => array(
          'controller' => '\D+',
          'action' => '\D+',
      )
    ),
    'stories_specific' => array(
      'route' => 'stories/:action/:story_id/*',
      'defaults' => array(
        'module' => 'sitestoriesweb',
        'controller' => 'index',
        'action' => 'delete',
      ),
      'reqs' => array(
          'action' => '(delete)',  
      ),
    ),
  ),
); ?>