<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Reminderemail.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Form_Admin_Reminderemail extends Engine_Form
{
  public function init()
  {
    $this
      ->setTitle('Reminders Emails')
      ->setDescription('This page contains settings for automatic reminder emails for subscriptions. You can also send sample emails to yourself to see the content.');

    $durationOptions = array(
    	'1.day' => '1 Day',
    	'2.day' => '2 Days',
    	'3.day' => '3 Days',
    	'1.week' => '1 Week',
    	'2.week' => '2 Weeks',
    	'1.month' => '1 Month',
    	);

    $values_before = json_decode(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.expired.mail.duration', ''));

    $values_after = json_decode(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.mail.send.after', ''));

    $this->addElement('Radio', 'sitesubscription_email_reminder', array(
        'label' => 'Automatic Reminder Emails',
          'description' => 'Do you want the site to send automatic reminder emails to users for the plans they have subscribed? (The content of this email template can be customized from the Mail Templates section in the settings)',
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.email.reminder', '1'),
          'multiOptions' => array(
            1 => 'Yes', 
            0 => 'No', 
            ),
      ));

    $this->addElement('Multiselect', 'sitesubscription_expired_mail_duration', array(
        'label' => ' Duration of Reminder Email',
          'description' => 'Select the duration before which an reminder email will be sent to the users who have subscribed the plans.',
          'value' => $values_before,
          'multiOptions' => $durationOptions,
      ));

   	// $this->addElement('Radio', 'sitesubscription_email_eventafter', array(
    //     'label' => 'Automatic Subscription Expired Email',
    //       'description' => 'Do you want the site to send automatic subscription expired emails after the subscription expires? (The content of this email template can be customized from the Email Templates section in the Settings?)',
    //       'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.email.eventafter', '1'),
    //       'multiOptions' => array(
    //         1 => 'Yes', 
    //         0 => 'No', 
    //         ),
    //   ));

   	// $this->addElement('Multiselect', 'sitesubscription_mail_send_after', array(
    //     'label' => 'Duration of Subscription Expired Email',
    //       'description' => 'Select the duration for the subscription expired email to be sent to the users whose subscriptions are expired.',
    //       'value' => $values_after,
    //       'multiOptions' => $durationOptions,
    //   ));

   	$this->addElement('Checkbox', 'sitesubscription_enable_testemail', array(
        'label' => 'Send me email for testing',
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.enable.testemail', '0'),
        'onclick' => 'showTestEmail()',
      ));

   	$this->addElement('Text', 'sitesubscription_testemail', array(
        'label' => 'Email ID for Testing ',
          'validators' => array(
                array('EmailAddress', true),
            ),
          'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.testemail', ''),
      ));


    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'ignore' => true
    ));
  }
}