<?php

class Sitesubscription_Form_Admin_Settings_Global extends Engine_Form {

    // IF YOU WANT TO SHOW CREATED ELEMENT ON PLUGIN ACTIVATION THEN INSERT THAT ELEMENT NAME IN THE BELOW ARRAY.
    public $_SHOWELEMENTSBEFOREACTIVATE = array("submit_lsetting", "environment_mode", );

    public function init() {

        $productType = 'sitesubscription';

        $this->setTitle('Global Settings')
             ->setDescription('These base settings will affect all the members in your community.');        
        
        
        // ELEMENT FOR LICENSE KEY
        $this->addElement('Text', $productType . '_lsettings', array(
            'label' => 'Enter License key',
            'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialApps.tech from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting($productType . '.lsettings'),
        ));

        if (APPLICATION_ENV == 'production') {
            $this->addElement('Checkbox', 'environment_mode', array(
                'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few stores of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
                'description' => 'System Mode',
                'value' => 1,
            ));
        } else {
            $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
        }

        $this->addElement('Button', 'submit_lsetting', array(
            'label' => 'Activate Your Plugin Now',
            'type' => 'submit',
            'ignore' => true
        ));

        $this->addElement('Radio', 'sitesubscription_profile_mapping', array(
            'label' => 'Enable Profile-type Mapping ',
              'description' => 'Do you want to map your subscriptions to member profile-types? By this your site members are required to choose subscription plans before sign-up. (This will be helpful in case if you want to show member profile-types according to the subscription plans.)',
              'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.profile.mapping', '2'),
              'multiOptions' => array(
                1 => 'Yes', 
                2 => 'No', 
                ),
        ));

        $this->addElement('Select', 'sitesubscription_header_enabled', array(
                'label' => 'Tagline',
                'description' => 'Do you want to show any Tagline to your users at the header of subscription packages selection page? <a title="Preview - Tagline" href="application/modules/Sitesubscription/externals/images/tagline_preview.png" target="_blank" class="seaocore_icon_view" > </a> ',
                'multiOptions' => array(
                    '1' => "Yes",
                    '0' => "No",
                ),
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.header.enabled', '0'),
            ));
        $this->sitesubscription_header_enabled->getDecorator('Description')->setOption('escape', false);

        $this->addElement('Textarea','sitesubscription_header_title',array(
            'label' => 'Tagline Text',
            'description' => 'Enter the text for the Tagline you want to show to your users at the header of subscription packages selection page.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.header.title', ''),
          ));

        $this->addElement('Text','sitesubscription_header_color',array(
            'decorators' => array(array('ViewScript',array(
                'viewScript' => "_headerColorPicker.tpl",
                'name' => 'sitesubscription_header_color',
                'label' => 'Header Background Color',
                'desc' => 'Select background color for header text.',
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.header.color', '#A9A9A9'),
                ))),
            ));
        $this->sitesubscription_header_color->getDecorator('ViewScript')->setOption('value',Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.header.color', '#A9A9A9'));


        $this->addElement('Textarea','sitesubscription_header_description',array(
            'label' => 'Tagline Description',
            'description' => 'Enter the text for the Tagline Description to show at the header of subscription packages selection page.',
            'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.header.description', ''),
          ));

        $this->addElement('Select', 'sitesubscription_footer_enabled', array(
                'label' => 'Terms & Conditions / Notes',
                'description' => 'Do you want to show any Terms & Conditions / Notes to your users at the bottom of subscription packages selection page? <a title="Preview - Terms & Conditions" href="application/modules/Sitesubscription/externals/images/footer_preview.png" target="_blank" class="seaocore_icon_view" > </a>',
                'multiOptions' => array(
                    1 => "Yes",
                    0 => "No",
                ),
                'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.footer.enabled', '0'),
            ));
        $this->sitesubscription_footer_enabled->getDecorator('Description')->setOption('escape', false);
        
        $this->addElement('Textarea', 'sitesubscription_footer_text', array(
            'label' => 'Terms & Conditions / Notes Text',
            'description' => "Enter the text for the Terms & Conditions / Notes you want to show to your users at the bottom of subscription packages selection page.",
            // 'allowEmpty' => true,
            // 'attribs' => array('rows' => 180, 'cols' => 350, 'style' => 'width:740px; max-width:740px;height:858px;'),
            // 'editorOptions' => $editorOptions,
            // 'filters' => array(new Engine_Filter_Censor(),new Engine_Filter_Html(), ),
        ));
        $this->sitesubscription_footer_text->setValue(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.footer.text', ''));

        $this->addElement('Button', 'submit', array(
            'label' => 'Save Changes',
            'type' => 'submit',
            'ignore' => true
        ));          
    }

}
