<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Fields.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Model_DbTable_Fields extends Engine_Db_Table
{
	protected $_rowClass = 'Sitesubscription_Model_Field';

	public function getFields($structureType = null)
	{
		if ($structureType == null)
			return false;

		$rows = $this->select()
					->order('feature_order ASC')
					->where('`structure_type` = ?',$structureType)
					->query()
					->fetchAll();

		return $rows;
	}

	public function addNewField($params)
	{
		$lastFiled = $this->select()->order('feature_order DESC')->where('`structure_type` = ?',$params['structure_type'])->limit(1)->query()->fetch();
		$order = ( $lastFiled['feature_order'] == null || $lastFiled['feature_order'] == 0 ) ? 1 : ++$lastFiled['feature_order'];
		$params['feature_order'] = $order;
		$params['feature_label'] = Engine_Api::_()->getApi('core','sitesubscription')->toJsonReadableFormat($params['feature_label']);
		$row = $this->insert($params);
		return $row;
	}

	public function updateFields($params = null)
	{
		$db = $this->getAdapter();
    	$db->beginTransaction();
		try {
			foreach ($params as $field_id => $field_name) {
				$field_name = Engine_Api::_()->getApi('core','sitesubscription')->toJsonReadableFormat($field_name);
				$this->update(array(
				      'feature_label' => $field_name,
				    ), array(
				      '`field_id` = ?' => $field_id,
				    ));
			}
			$db->commit();
		}	catch (Exception $e) {
	      $db->rollback();
	      throw $e;
		}
	}

}