<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Subscriptions.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Model_DbTable_Subscriptions extends Engine_Db_Table
{
	protected $_name = "payment_subscriptions";
	protected $_rowClass = 'Sitesubscription_Model_Subscription';

	public function getMailRecipients($time = null, $duration = null) {

      if (empty($time)) {
        return;
      }

      $now = date('Y-m-d h:m:s');
      $date = null; $subscriptions = null;

      if ($time == "before") {
        $status = "status = 'active' OR status = 'trial'";
        $operator = "+";
      } elseif ($time == "after") {
        $status = "status = 'expired'";
        $operator = "-";
      } elseif ($time = "now") {
        $date = "expiration_date between '".date('Y-m-d 00:00:00')."' and '".date('Y-m-d 23:59:59')."'";
        $status = "status = 'expired' OR status = 'active' OR status = 'trial' "; 
      } else
        return null;


      switch ($duration) {
        case '1.day':
          $date_string = $now.$operator.' 1 days';
          break;

        case '2.day':
          $date_string = $now.$operator.' 2 days';
          break;

        case '3.day':
          $date_string = $now.$operator.' 3 days';
          break;

        case '1.week':
          $date_string = $now.$operator.' 1 weeks';
          break;

        case '2.week':
          $date_string = $now.$operator.' 2 weeks';
          break;

        case '1.month':
          $date_string = $now.$operator.' 1 months';
          break;
        
        case null:
          break;
      }

      if (empty($date)) {
        $date_upperbound = date('Y-m-d 23:59:59',strtotime($date_string));
        $date_lowerbound = date('Y-m-d 00:00:00',strtotime($date_string));
        $date = "expiration_date between '".$date_lowerbound."' and '".$date_upperbound."'";
      }

      $query = $this->select()
        ->where($status)
        ->where($date)
        ;
      $subscriptions = $query->query()->fetchAll();

      return $subscriptions;
    }


    public function getSubscribers($package_id = null) {
      if ($package_id == null) 
        return false;

      $subscribers = $this->select('user_id')
                ->where('package_id = ?',$package_id)
                ->where('status IN(?)',array('active','trial'))
                ->query()
                ->fetchAll();

      foreach ($subscribers as $value) {
        $array_subs[] = $value['user_id'];
      }
      return $array_subs;
    }

    public function setTrialSubscription($subscription_id = null, $package = null)
    {
      if (!empty($subscription_id) && !empty($package)) {
        $trial_duration = $package['trial_duration'];
        $trial_duration_type = $package['trial_duration_type'];

        switch ($trial_duration_type) {
          case 'day':
            $expiration_date = date('Y-m-d H:i:s', strtotime("+$trial_duration days"));
            break;
          
          default:
            return;
        }
        
        $this->update(array(
                    'status' => 'trial',
                    'active' => 1,
                    'expiration_date' => $expiration_date
                  ), array(
                    '`subscription_id` = ?' => $subscription_id,
                  ));
      }
    }

    public function getUserSubscription($user_id = null) 
    {
      if ($user_id == null) 
        return false;

      $subscriber = $this->select()
                  ->where('user_id = ?',$user_id)
                  ->where('status IN(?)',array('active','trial'))
                  ->where('active = 1')
                  ->query()
                  ->fetch();
                  
      return $subscriber['package_id'];
    }

    public function getMembersCount($package_id = null)
    {
      if ($package_id == null) 
        return false;

      $memberCounts = array();
      $memberCounts = $this->select()
          ->where('package_id = ?', $package_id)
          ->where('active = ?', true)
          ->where('status IN(?)',array('active','trial'))
          ->query()
          ->fetchAll();

      return count($memberCounts);
    }
}