<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Expiretrialsubscriptions.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Plugin_Task_Expiretrialsubscriptions extends Core_Plugin_Task_Abstract
{
	public function execute()
  {
  	$subscriptionsTable = Engine_Api::_()->getDbtable('subscriptions', 'payment');

    // Get subscriptions that have finished their trial period
    $select = $subscriptionsTable->select()
      ->where('expiration_date <= ?', new Zend_Db_Expr('NOW()'))
      ->where('status = ?', 'trial')
      ->order('subscription_id ASC')
      ->limit(10)
      ;

    foreach( $subscriptionsTable->fetchAll($select) as $subscription ) 
    {
      $package = $subscription->getPackage();
      // Check if the package has an trial duration
      $interval = $trial_duration = $package->trial_duration;
      $trial_duration_type = $package->trial_duration_type;

      if ($trial_duration = 0 || !in_array($trial_duration_type, array('day', 'week', 'month' ,'year')) ) {
        return;
      }

      $subscription->status = 'expired';
      $subscription->active = 0;
      $subscription->save(); 

      // It's expired
      Engine_Api::_()->getApi('core', 'sitesubscription')->sendMails($subscription->getUser(),'subscription_trial_expired',$time);
    }
  }
}