<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Sendremindermails.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Plugin_Task_Sendreminderemails extends Core_Plugin_Task_Abstract
{
  public function execute()
  {
  	if (!Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.email.reminder', '0')) {
      return;
    }

    $site_title = $_SERVER['HTTP_HOST'];
    // Get reminder mails settings
    $mail_at = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.email.eventafter', '1');
    $mail_before = json_decode(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.expired.mail.duration', '1'));
    // $mail_after = json_decode(Engine_Api::_()->getApi('settings', 'core')->getSetting('sitesubscription.mail.send.after', '1'));

    if ($mail_at)
      $this->sendReminderEmails("now");
    // if ($mail_after)
      // $this->sendReminderEmails("after",$mail_after);
    if ($mail_before)
      $this->sendReminderEmails("before",$mail_before);
  }

  public function sendReminderEmails( $send_at = null , $options_enabled = null) {
      if ( empty($send_at) || empty($options_enabled) ) 
        return;

      // if ( $send_at == "after")
      //   $email_template = "subscription_expiring_after";
      elseif ( $send_at = "before")
        $email_template = "subscription_expiring_before";
      elseif ( $send_at = "now" ) {
        // Send reminder emails to users whose plan is going to expire today
        $subscribers = Engine_Api::_()->getDbtable('subscriptions','sitesubscription')-> getMailRecipients("now");
        if($subscribers != null)
        {
          foreach ($subscribers as $subscriber) {
            $user = Engine_Api::_()->user()->getUser($subscriber['user_id']);
            $this->sendMails($user,'subscription_expiring_today',$now);
          }
        }
        return;
      } else
        return;

      foreach ($options_enabled as $value) {
        $time = $this->getLaymanFormat($value);
        $subscribers = Engine_Api::_()->getDbtable('subscriptions','sitesubscription')-> getMailRecipients($send_at,$value);

        if($subscribers != null)
        {
          foreach ($subscribers as $subscriber) {
            $user = Engine_Api::_()->user()->getUser($subscriber['user_id']);
            Engine_Api::_()->getApi('core', 'sitesubscription')->sendMails($user,$email_template,$time);
          }
        }
      }
    }

    public function getLaymanFormat($time = null) {
      if (empty($time))
        return;

      switch ($time) {
        case '1.day':
          $layman_format = "1 Day";
          break;

        case '2.day':
          $layman_format = "2 Days";
          break;

        case '3.day':
          $layman_format = "3 Days";
          break;

        case '1.week':
          $layman_format = "1 Week";
          break;

        case '2.week':
          $layman_format = "2 Week";
          break;

        case '1.month':
          $layman_format = "1 Month";
          break;
        
        default:
          return false;
      }

      return $layman_format;
    }

}