<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminManageController.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_AdminManageController extends Core_Controller_Action_Admin
{
	// Action for admin-side manage subscriptions page.
	public function indexAction()
	{
        
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_manage_plans) || empty($manage_plans)){
            
            $this->_helper->content->setNoRender();
            return;
        }
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_plans');

	    // Make form
	    $this->view->formFilter = $formFilter = new Payment_Form_Admin_Package_Filter();

	    // Process form
	    if( $formFilter->isValid($this->_getAllParams()) ) {
	      // if( null === $this->_getParam('enabled') ) {
	      //   $formFilter->populate(array('enabled' => 1));
	      // }
	      $filterValues = $formFilter->getValues();
	    } else {
	      $filterValues = array(
	        'enabled' => 1,
	      );
	      // $formFilter->populate(array('enabled' => 1));
	    }

	    $this->view->filterValues = $filterValues;

	    // Get the package order 
	    $packageOrder = array();
	    $packageOrderTable = Engine_Api::_()->getDbtable('packageorder','sitesubscription');
	    $packageOrderTableName = $packageOrderTable->info('name');
	    $packageOrder = $packageOrderTable->select()->query()->fetchAll();

	    // Initialize select
	    $this->view->packageTable = $packageTable = Engine_Api::_()->getDbtable('packages', 'payment');
	    $tableName  = $packageTable->info('name');

	    $db = Zend_Db_Table::getDefaultAdapter();
    	$select = $db->select();
    	$select->from($tableName);

	    if (!empty($packageOrder)) {
	 	    $select->joinLeft($packageOrderTableName,"`$tableName`.package_id = `$packageOrderTableName`.package_id",array("$packageOrderTableName.order"));
	     	$select->order("$packageOrderTableName.order ASC");
	    }

	    // Add filter values
	    if( !empty($filterValues['query']) ) {
	      $select->where($tableName.'.title LIKE ?', '%' . $filterValues['query'] . '%');
	    }
	    if( !empty($filterValues['level_id']) ) {
	      $select->where($tableName.'.level_id = ?', $filterValues['level_id']);
	    }
	    if( isset($filterValues['enabled']) && '' != $filterValues['enabled'] ) {
	      $select->where($tableName.'.enabled = ?', $filterValues['enabled']);
	    }
	    if( isset($filterValues['signup']) && '' != $filterValues['signup'] ) {
	      $select->where($tableName.'.signup = ?', $filterValues['signup']);
	    }

	    $this->view->enabled = '0';
	    if ( empty($this->_getParam('enabled')) && empty($this->_getParam('level_id')) && empty($this->_getParam('signup')) && empty($this->_getParam('query')) ) {
	    	$this->view->enabled = '1';
	    }
	    $this->view->packages = $packages = $select->query()->fetchAll();

	    // Get member totals for each plan
	    $memberCounts = array();
	    foreach( $packages as $item ) {
	    	$item = $packageTable->find($item['package_id'])->current();
	      	$memberCounts[$item->package_id] = Engine_Api::_()->getDbtable('subscriptions','sitesubscription')->getMembersCount($item->package_id);
	    }
	    $this->view->memberCounts = $memberCounts;

	    $this->view->popularplan = Engine_Api::_()->getDbtable('settings', 'core')->getSetting('sitesubscription.popularplan');

	    // Get the mapped packages with profile types 
	    $this->view->enableMapping = $enableMapping = Engine_Api::_()->getDbtable('settings', 'core')->getSetting('sitesubscription.profile.mapping','0');
	    if ($enableMapping == 1) {
	    	$topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');

	        if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
		      $profileTypeField = $topStructure[0]->getChild();
		      $options = $profileTypeField->getOptions();
		  	}
	        foreach ($options as $value) {
	        	$profileTypes[$value->option_id] = $value->label;
	        }

	        $array = Engine_Api::_()->getDbTable('profiletypemapping','sitesubscription')->getMappedPackages();
	        foreach ($array as $value) {
	        	$mappedPackages[$value['package_id']] = $profileTypes[$value['option_id']];
	        }

	        $this->view->mappedPackages = $mappedPackages; 
	    }
	}

	// Action for admin-side manage-transactions page.
	public function transactionsAction()
	{
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_transactions) || empty($transactions)){
            
            $this->_helper->content->setNoRender();
            return;
        }
        		
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_transactions');

        // Make form
	    $this->view->formFilter = $formFilter = new Payment_Form_Admin_Transaction_Filter();
	    $formFilter->removeElement('type');

	    // Get all orders of subscription payment
	    $orderTable = Engine_Api::_()->getDbtable('orders','payment');
	    $orderSelect = $orderTable->select()
	    				->where('source_type = ?', 'payment_subscription')
	    				->query()
	    				->fetchAll()
	    				;
	    foreach ($orderSelect as $order) {
	    	$subs_orders[] = $order['order_id'];
	    }

	    if (empty($subs_orders))
	    	$subs_orders[] = '0';

	    // Process form
	    if( $formFilter->isValid($this->_getAllParams()) ) {
	      $filterValues = $formFilter->getValues();
	    } else {
	      $filterValues = array();
	    }
	    if( empty($filterValues['order']) ) {
	      $filterValues['order'] = 'transaction_id';
	    }
	    if( empty($filterValues['direction']) ) {
	      $filterValues['direction'] = 'DESC';
	    }
	    $this->view->filterValues = $filterValues;
	    $this->view->order = $filterValues['order'];
	    $this->view->direction = $filterValues['direction'];

	    // Initialize select
	    $transactionsTable = Engine_Api::_()->getDbtable('transactions', 'payment');
	    $transactionSelect = $transactionsTable->select()
	      ;

	    // Add filter values
	      $transactionSelect->where('order_id IN(?)', $subs_orders);
	    if( !empty($filterValues['gateway_id']) ) {
	      $transactionSelect->where('gateway_id = ?', $filterValues['gateway_id']);
	    }
	    if( !empty($filterValues['state']) ) {
	      $transactionSelect->where('state = ?', $filterValues['state']);
	    }
	    if( !empty($filterValues['query']) ) {
	      $transactionSelect
	        ->from($transactionsTable->info('name'))
	        ->joinLeft('engine4_users', 'engine4_users.user_id=engine4_payment_transactions.user_id', null)
	        ->where('(gateway_transaction_id LIKE ? || ' .
	            'gateway_parent_transaction_id LIKE ? || ' .
	            'gateway_order_id LIKE ? || ' .
	            'displayname LIKE ? || username LIKE ? || ' .
	            'email LIKE ?)', '%' . $filterValues['query'] . '%');
	        ;
	    }
	    if( ($user_id = $this->_getParam('user_id', @$filterValues['user_id'])) ) {
	      $this->view->filterValues['user_id'] = $user_id;
	      $transactionSelect->where('engine4_payment_transactions.user_id = ?', $user_id);
	    }
	    if( !empty($filterValues['order']) ) {
	      if( empty($filterValues['direction']) ) {
	        $filterValues['direction'] = 'DESC';
	      }
	      $transactionSelect->order($filterValues['order'] . ' ' . $filterValues['direction']);
	    }

	    $this->view->paginator = $paginator = Zend_Paginator::factory($transactionSelect);
	    $paginator->setCurrentPageNumber($this->_getParam('page', 1));

	    // Preload info
	    $gatewayIds = array();
	    $userIds = array();
	    $orderIds = array();
	    foreach( $paginator as $transaction ) {
	      if( !empty($transaction->gateway_id) ) {
	        $gatewayIds[] = $transaction->gateway_id;
	      }
	      if( !empty($transaction->user_id) ) {
	        $userIds[] = $transaction->user_id;
	      }
	      if( !empty($transaction->order_id) ) {
	        $orderIds[] = $transaction->order_id;
	      }
	    }

	    $gatewayIds = array_unique($gatewayIds);
	    $userIds = array_unique($userIds);
	    $orderIds = array_unique($orderIds);

	    // Preload gateways
	    $gateways = array();
	    if( !empty($gatewayIds) ) {
	      foreach( Engine_Api::_()->getDbtable('gateways', 'payment')->find($gatewayIds) as $gateway ) {
	        $gateways[$gateway->gateway_id] = $gateway;
	      }
	    }
	    $this->view->gateways = $gateways;

	    // Preload users
	    $users = array();
	    if( !empty($userIds) ) {
	      foreach( Engine_Api::_()->getItemTable('user')->find($userIds) as $user ) {
	        $users[$user->user_id] = $user;
	      }
	    }
	    $this->view->users = $users;

	    // Preload orders
	    $orders = array();
	    if( !empty($orderIds) ) {
	      foreach( Engine_Api::_()->getDbtable('orders', 'payment')->find($orderIds) as $order ) {
	        $orders[$order->order_id] = $order;
	      }
	    }
	    $this->view->orders = $orders;

	    // Preload subscriptions
	    if( !empty($orders) ) {
	      foreach( $orders as $order_id => $order ) {
	        $subscriptions[$order_id] = Engine_Api::_()->getDbtable('subscriptions', 'payment')->find($order->source_id)->current();
	      }
	    }
	    $this->view->subscriptions = $subscriptions;

	    // Preload packages 
	    $table = Engine_Api::_()->getDbtable('packages', 'payment');
	    $select = $table->select()->query()->fetchAll();
	    foreach ($select as $value) {
	    	$packages[$value['package_id']] = $value;
	    }
	    $this->view->packages = $packages;

	    // Preload discount usages 
	    if ( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecoupon') ) {
	    	$table = Engine_Api::_()->getDbtable('usages', 'sitecoupon');
	    	$select = $table->select()->query()->fetchAll();
	    	foreach ($select as $value) {
	    		$coupons[$value['order_id']] = $value;
	    	}
	    	$this->view->coupons = $coupons;
	    } else
	    	$this->view->coupons = array();
	    	    // Preload discount usages 
	    if ( Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitecredit') ) {
	    	$table = Engine_Api::_()->getDbtable('credits', 'sitecredit');
	    	$select = $table->select()->where('type = ?','subscription')->query()->fetchAll();
	    	$creditValue=Engine_Api::_()->getApi('settings', 'core')->getSetting('sitecredit.value',100);
	    	foreach ($select as $value) {
	    		$credits[$value['type_id']] = abs($value['credit_point'])/$creditValue;
	    	}
	    	$this->view->credits = $credits;
	    } else
	    	$this->view->credits = array();
	    
	}

	// Action for viewing transaction details. Nested in admin-side manage-transactions page.
	public function detailsAction()
	{

		// Missing transaction
	    if( !($transaction_id = $this->_getParam('transaction_id')) ||
	        !($transaction = Engine_Api::_()->getItem('payment_transaction', $transaction_id)) ) {
	      return;
	    }

	    $this->view->transaction = $transaction;
	    $this->view->gateway = Engine_Api::_()->getItem('payment_gateway', $transaction->gateway_id);
	    $this->view->order = Engine_Api::_()->getItem('payment_order', $transaction->order_id);
	    $this->view->user = Engine_Api::_()->getItem('user', $transaction->user_id);
	}

	// Action for viewing transaction details. Nested in admin-side manage-transactions page.
	public function subscriptionDetailsAction()
  	{
    	if( !($subscription_id = $this->_getParam('subscription_id')) ||
        	!($subscription = Engine_Api::_()->getItem('payment_subscription', $subscription_id)) ) {
      	return;
    }

    $this->view->subscription = $subscription;
    $this->view->user = $user = $subscription->getUser();
    $this->view->package = $package = $subscription->getPackage();
    if( !empty($user->level_id) ) {
      $this->view->actualLevel = Engine_Api::_()->getItem('authorization_level', $user->level_id);
    }
    $this->view->level = $package->getLevel();

    // get any relevant orders
    $ordersRaw = Engine_Api::_()->getDbtable('orders', 'payment')->fetchAll(array(
      'source_type = ?' => 'payment_subscription',
      'source_id = ?' => $subscription->subscription_id,
    ));

    $orders = array();
    $orderIds = array();
    foreach( $ordersRaw as $order ) {
      $orders[$order->order_id] = $order;
      $orderIds[] = $order->order_id;
    }
    $this->view->orders = $orders;

    // get any relevant transactions and orders
    if( !empty($orderIds) ) {
      $this->view->transactions = $transactions = Engine_Api::_()->getDbtable('transactions', 'payment')->fetchAll(array(
        'order_id IN(?)' => $orderIds,
      ));
    }

    // Get gateways
    $gateways = array();
    foreach( Engine_Api::_()->getDbtable('gateways', 'payment')->fetchAll() as $gateway ) {
      $gateways[$gateway->gateway_id] = $gateway;
    }
    $this->view->gateways = $gateways;
  }

  	// Action for admin-side FAQ page.
	public function faqAction()
	{
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_faq');
	}

	// Action for admin-side add-plan page. Nested in admin-side manage-subscriptions page.
	public function addPlanAction()
	{
        
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_add_plan) || empty($add_plan)){
            
            $this->_helper->content->setNoRender();
            return;
        }		
		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_plans');

        // Make form
	    $this->view->form = $form = new Sitesubscription_Form_Admin_Addplan();

	    $recurrenceOptions = $this->getRecurrenceOption();
        $form->getElement('recurrence')
                ->setMultiOptions($recurrenceOptions['multiOptions']);
        $form->getElement('recurrence')->options['forever'] = 'One-time';
        $this->view->gateways = $recurrenceOptions['gateways'];
        $this->view->supportedBillingIndex = $recurrenceOptions['supportedBillingIndex'] ;

	    // Check method/data
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	    	
	      return;
	    }

	    // Process
	    $values = $form->getValues();

	    $tmp = $values['recurrence'];
	    unset($values['recurrence']);
	    if( empty($tmp) || !is_array($tmp) ) {
	      $tmp = array(null, null);
	    }
	    $values['recurrence'] = (int) $tmp[0];
	    $values['recurrence_type'] = $tmp[1];

	    $tmp = $values['duration'];
	    unset($values['duration']);
	    if( empty($tmp) || !is_array($tmp) ) {
	      $tmp = array(null, null);
	    }
	    $values['duration'] = (int) $tmp[0];
	    $values['duration_type'] = $tmp[1];

	    /*
	    $tmp = $values['trial_duration'];
	    unset($values['trial_duration']);
	    if( empty($tmp) || !is_array($tmp) ) {
	      $tmp = array(null, null);
	    }
	    $values['trial_duration'] = (int) $tmp[0];
	    $values['trial_duration_type'] = $tmp[1];
	     * 
	     */

	    if ($values['enable_trial'] == '1')
	    {
    		$values['trial_duration'] = (int) $values['trial_duration'];
	    	$values['trial_duration_type'] = 'day';
    	}

	    if ($values['recurrence_type'] == 'forever' || (float) $values['price'] == 0.00 || $values['enable_trial'] == '0')
	    {
	    	$values['trial_duration'] = 0;
	    	$values['trial_duration_type'] = null;
	    } else if( (float) $values['trial_duration'] == 0.00 ) {
	    	$errorMessages[] = ('Trial duration cannot be zero.');
	    }

	    if( !empty($values['default']) && (float) $values['price'] > 0 ) {
	      	$errorMessages[] =('Only a free plan may be the default plan.');
	    }

	    if (!empty($errorMessages)) {
	    	foreach ($errorMessages as $message)
	    		$form->addError($message);
	    	return;
	    }

	    $packageTable = Engine_Api::_()->getDbtable('packages', 'payment');
	    $db = $packageTable->getAdapter();
	    $db->beginTransaction();

	    try {
	      // Update default
	      if( !empty($values['default']) ) {
	        $packageTable->update(array(
	          'default' => 0,
	        ), array(
	          '`default` = ?' => 1,
	        ));
	      }

	      // Create package
	      $package = $packageTable->createRow();
	      $package->setFromArray($values);
	      $package->save();

	      // Create package in gateways?
	      if( !$package->isFree() ) {
	        $gatewaysTable = Engine_Api::_()->getDbtable('gateways', 'payment');
	        foreach( $gatewaysTable->fetchAll(array('enabled = ?' => 1)) as $gateway ) {
	          $gatewayPlugin = $gateway->getGateway();
	          // Check billing cycle support
	          if( !$package->isOneTime() ) {
	            $sbc = $gateway->getGateway()->getSupportedBillingCycles();
	            if( !in_array($package->recurrence_type, array_map('strtolower', $sbc)) ) {
	              continue;
	            }
	          }
	          if( method_exists($gatewayPlugin, 'createProduct') ) {
	            $gatewayPlugin->createProduct($package->getGatewayParams());
	          }
	        }
	      }

	      $db->commit();
	    } catch( Exception $e ) {
	      $db->rollBack();
	      throw $e;
	    }

	    // Redirect
	    return $this->_helper->redirector->gotoRoute(array('action' => 'index'));
	}

	// Action for admin-side edit-subscription page. Nested in admin-side manage-subscriptions page.
	public function editSubscriptionAction()
	{
        
        include_once APPLICATION_PATH .'/application/modules/Sitesubscription/controllers/license/license2.php';
        if(empty($sitesubscription_edit_plan) || empty($edit_plan)){
            
            $this->_helper->content->setNoRender();
            return;
        }

		$this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
                ->getNavigation('sitesubscription_admin_main', array(), 'sitesubscription_admin_manage_plans');
                
		// Get package
	    if( null === ($packageIdentity = $this->_getParam('package_id')) ||
	        !($package = Engine_Api::_()->getDbtable('packages', 'payment')->find($packageIdentity)->current()) ) {
	      throw new Engine_Exception('No package found');
	    }
	    
	    // Make form
	    $this->view->form = $form = new Sitesubscription_Form_Admin_Editplan();

	    // Populate form
	    $values = $package->toArray();
	   
	    $values['recurrence'] = array($values['recurrence'], $values['recurrence_type']);
	    $values['duration'] = array($values['duration'], $values['duration_type']);
	    //$values['trial_duration'] = array($values['trial_duration'], $values['trial_duration_type']);
	    
	    //unset($values['recurrence']);
	    // unset($values['recurrence_type']);
	    //unset($values['duration']);
	    // unset($values['duration_type']);
	    //unset($values['trial_duration']);
	    //unset($values['trial_duration_type']);

	    $otherValues = array(
	      'price' => $values['price'],
	      'recurrence' => $values['recurrence'],
	      'duration' => $values['duration'],
	    );

	    if($values['trial_duration'] != 0)
	    	$values['enable_trial'] = '1';
	    
	    $form->populate($values);

	    // Check method/data
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

	    if( !$form->isValid($this->getRequest()->getPost()) ) {
	      return;
	    }

	    // Hack em up
	    $form->populate($otherValues);

	    // Process
	    $values = $form->getValues();
	    
	    // $tmp = $values['recurrence'];
	    // unset($values['recurrence']);
	    // if( empty($tmp) || !is_array($tmp) ) {
	    //   $tmp = array(null, null);
	    // }
	    // $values['recurrence'] = (int) $tmp[0];
	    // $values['recurrence_type'] = $tmp[1];

	    // $tmp = $values['duration'];
	    // unset($values['duration']);
	    // if( empty($tmp) || !is_array($tmp) ) {
	    //   $tmp = array(null, null);
	    // }
	    // $values['duration'] = (int) $tmp[0];
	    // $values['duration_type'] = $tmp[1];

	    // $tmp = $values['trial_duration'];
	    // unset($values['trial_duration']);
	    // if( empty($tmp) || !is_array($tmp) ) {
	    //   $tmp = array(null, null);
	    // }
	    // $values['trial_duration'] = (int) $tmp[0];
	    // $values['trial_duration_type'] = $tmp[1];
	    
	    unset($values['price']);
	    unset($values['recurrence']);
	    unset($values['recurrence_type']);
	    unset($values['duration']);

	    if( (float) $values['trial_duration'] == 0.00 && $values['enable_trial'] == '1') {
	      return $form->addError('Trial duration cannot be zero.');
	    }

	    if ($values['enable_trial'] == '1')
	    {
    		$values['trial_duration'] = (int) $values['trial_duration'];
	    	$values['trial_duration_type'] = 'day';
    	}

	    if ($values['enable_trial'] == '0')
	    {
	    	$values['trial_duration'] = 0;
	    	$values['trial_duration_type'] = null;
	    }
	    
	    if( !empty($values['default']) && (float) $values['price'] > 0 ) {
	      return $form->addError('Only a free plan may be the default plan.');
	    }
	    
	    $packageTable = Engine_Api::_()->getDbtable('packages', 'payment');
	    $db = $packageTable->getAdapter();
	    $db->beginTransaction();

	    try {
	      
	      // Update default
	      if( !empty($values['default']) ) {
	        $packageTable->update(array(
	          'default' => 0,
	        ), array(
	          '`default` = ?' => 1,
	        ));
	      }
	      
	      // Update package
	      $package->setFromArray($values);
	      $package->save();
	      
	      // Create package in gateways?
	      if( !$package->isFree() ) {
	        $gatewaysTable = Engine_Api::_()->getDbtable('gateways', 'payment');
	        foreach( $gatewaysTable->fetchAll(array('enabled = ?' => 1)) as $gateway ) {
	          $gatewayPlugin = $gateway->getGateway();
	          // Check billing cycle support
	          if( !$package->isOneTime() ) {
	            $sbc = $gateway->getGateway()->getSupportedBillingCycles();
	            if( !in_array($package->recurrence_type, array_map('strtolower', $sbc)) ) {
	              continue;
	            }
	          }
	          if( !method_exists($gatewayPlugin, 'createProduct') ||
	              !method_exists($gatewayPlugin, 'editProduct') ||
	              !method_exists($gatewayPlugin, 'detailVendorProduct') ) {
	            continue;
	          }
	          // If it throws an exception, or returns empty, assume it doesn't exist?
	          try {
	            $info = $gatewayPlugin->detailVendorProduct($package->getGatewayIdentity());
	          } catch( Exception $e ) {
	            $info = false;
	          }
	          // Create
	          if( !$info ) {
	            $gatewayPlugin->createProduct($package->getGatewayParams());
	          }
	          // Edit
	          else {
	            $gatewayPlugin->editProduct($package->getGatewayIdentity(), $package->getGatewayParams());
	          }
	        }
	      }
	      
	      $db->commit();
	    } catch( Exception $e ) {
	      $db->rollBack();
	      throw $e;
	    }

	    $form->addNotice('Your changes have been saved.');
	}

	// Action for setting popular plan. Nested in admin-side manage-subscriptions page. Called via ajax request.
	public function setPopularPlanAction()
	{
	    if( !$this->getRequest()->isPost() ) {
	      return;
	    }

		$package_id = $this->_getParam('package_id');
		Engine_Api::_()->getDbtable('settings', 'core')->setSetting('sitesubscription.popularplan', $package_id);

		exit(1);
	}

	// Action for setting order of the packages and features row. Nested in admin-side manage-transactions and subscription-fields page. Called via ajax request.
	public function orderItemsAction()
	{
		$data =  $this->getRequest()->getParams();
		if ($data['item'] == 'packages') 
		{
			$orderTable = Engine_Api::_()->getDbtable('packageorder','sitesubscription');

			foreach ($data as $package_id => $order) {
				if (substr($package_id,0,8) == 'package_') {
					$id = substr($package_id, 8);
					$flag = $orderTable->select()->where('`package_id` = ?',$id)->query()->fetch();
					$db = $orderTable->getAdapter();
					$db->beginTransaction();
					if ($flag == null) 
					{
						try {
							$row = $orderTable->createRow();
					        $row->setFromArray(array('package_id' => (int) $id, 'order' => $order));
					        $row->save();
					        $db->commit();
						} catch( Exception $e ) {
					      $db->rollBack();
					      throw $e;
					    }
					}
					else
					{
						try {
							$orderTable->update(array('order' => $order,), array('`package_id` = ?' => $id,));
							$db->commit();
						} catch( Exception $e ) {
					      $db->rollBack();
					      throw $e;
					    }
					}
				}
			}
		}
		if ($data['item'] == 'fields') 
		{
			$fieldsTable = Engine_Api::_()->getDbtable('fields','sitesubscription');
			foreach ($data as $field_id => $order) {
				if (substr($field_id,0,6) == 'field_') {
					$id = substr($field_id,6);
					$flag = $fieldsTable->find($id)->current();
					$db = $fieldsTable->getAdapter();
					$db->beginTransaction();
					if ($flag == null) 
					{
						try {
							$row = $fieldsTable->createRow();
					        $row->setFromArray(array('field_id' => (int) $id, 'feature_order' => $order));
					        $row->save();
					        $db->commit();
						} catch( Exception $e ) {
					      $db->rollBack();
					      throw $e;
					    }
					    var_dump(array('field_id' => (int) $id, 'feature_order' => $order));
					}
					else
					{
						try {
							$fieldsTable->update(array('feature_order' => $order,), array('`field_id` = ?' => $id,));
							$db->commit();
						} catch( Exception $e ) {
					      $db->rollBack();
					      throw $e;
					    }
					}
				}
			}
		}

		exit();
	}

	public function getRecurrenceOption() 
    {
      //GET SUPPORTED BILLING CYCLES
      $gateways = array();
      $supportedBillingCycles = array();
      $partiallySupportedBillingCycles = array();
      $fullySupportedBillingCycles = null;
      $gatewaysTable = Engine_Api::_()->getDbtable('gateways', 'payment');

      foreach ($gatewaysTable->fetchAll() as $gateway) {
          $gatewaySupportedBillingCycles = $gateway->getGateway()->getSupportedBillingCycles();
          $gateways[$gateway->gateway_id] = $gateway->title;
          $supportedBillingIndex[$gateway->title] = $gatewaySupportedBillingCycles;
          $supportedBillingCycles[$gateway->gateway_id] = $gatewaySupportedBillingCycles;
          $partiallySupportedBillingCycles = array_merge($partiallySupportedBillingCycles, $supportedBillingCycles[$gateway->gateway_id]);
      }
      $partiallySupportedBillingCycles = array_unique($partiallySupportedBillingCycles);
      $multiOptions = array_combine(array_map('strtolower', $partiallySupportedBillingCycles), $partiallySupportedBillingCycles);
      unset($multiOptions['one-time']);

      $return_array['multiOptions'] = $multiOptions;
      $return_array['supportedBillingIndex'] = $supportedBillingIndex;
      $return_array['gateways'] = $gateways;

      return $return_array;
    }
}