<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitesubscription
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2017-03-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitesubscription_Installer extends Engine_Package_Installer_Module
{
	
    public function onPreinstall() {
        
        error_reporting(E_ALL);
        ini_set('display_errors', 1);

        $getErrorMsg = $this->getVersion();
        if (!empty($getErrorMsg)) {
            return $this->_error($getErrorMsg);
        }

        $PRODUCT_TYPE = 'sitesubscription';
        $PLUGIN_TITLE = 'Sitesubscription';
        $PLUGIN_VERSION = '5.9.1';
        $PLUGIN_CATEGORY = 'plugin';
        $PRODUCT_DESCRIPTION = 'SEAO - Advanced Member Subscriptions Plugin - Configure Plans, Layout and Mapping with Profile Types / Member Levels allows more control over subscriptions and offers an attractive user interface.';
        $PRODUCT_TITLE = 'Advanced Member Subscriptions Plugin - Configure Plans, Layout and Mapping with Profile Types / Member Levels';
        $_PRODUCT_FINAL_FILE = 0;
        $SocialEngineAddOns_version = '4.9.4p13';
        $file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
        $is_file = @file_exists($file_path);
        if (empty($is_file)) {
            include APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
        } else {
            $db = $this->getDb();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
            $is_Mod = $select->query()->fetchObject();
            if (empty($is_Mod))
                include_once $file_path;
        }

        parent::onPreinstall();
    }

    private function getVersion() {
        error_reporting(E_ALL);
        ini_set('display_errors', 1);
        
        $db = $this->getDb();

        $errorMsg = '';
        $finalModules = $getResultArray = array();
        $base_url = Zend_Controller_Front::getInstance()->getBaseUrl();

        $modArray = array(
            'sitemenu' => '4.8.13p5',
        );

        foreach ($modArray as $key => $value) {
            $isMod = $db->query("SELECT * FROM  `engine4_core_modules` WHERE  `name` LIKE  '" . $key . "'")->fetch();
            if (!empty($isMod) && !empty($isMod['version'])) {
                $isModSupport = $this->checkVersion($isMod['version'], $value);
                if (empty($isModSupport)) {
                    $finalModules['modName'] = $key;
                    $finalModules['title'] = $isMod['title'];
                    $finalModules['versionRequired'] = $value;
                    $finalModules['versionUse'] = $isMod['version'];
                    $getResultArray[] = $finalModules;
                }
            }
        }

        foreach ($getResultArray as $modArray) {
            $errorMsg .= '<div class="tip"><span>Note: Your website does not have the latest version of "' . $modArray['title'] . '". Please upgrade "' . $modArray['title'] . '" on your website to the latest version available in your SocialEngineAddOns Client Area to enable its integration with "Advanced Member Subscriptions Plugin - Configure Plans, Layout and Mapping with Profile Types / Member Levels".<br/> Please <a href="' . $base_url . '/manage">Click here</a> to go Manage Packages.</span></div>';
        }

        return $errorMsg;
    }

    function checkVersion($databaseVersion, $checkDependancyVersion) {
        if (strcasecmp($databaseVersion, $checkDependancyVersion) == 0)
            return -1;
        $databaseVersionArr = explode(".", $databaseVersion);
        $checkDependancyVersionArr = explode('.', $checkDependancyVersion);
        $fValueCount = $count = count($databaseVersionArr);
        $sValueCount = count($checkDependancyVersionArr);
        if ($fValueCount > $sValueCount)
            $count = $sValueCount;
        for ($i = 0; $i < $count; $i++) {
            $fValue = $databaseVersionArr[$i];
            $sValue = $checkDependancyVersionArr[$i];
            if (is_numeric($fValue) && is_numeric($sValue)) {
                $result = $this->compareValues($fValue, $sValue);
                if ($result == -1) {
                    if (($i + 1) == $count) {
                        return $this->compareValues($fValueCount, $sValueCount);
                    } else
                        continue;
                }
                return $result;
            }
            elseif (is_string($fValue) && is_numeric($sValue)) {
                $fsArr = explode("p", $fValue);
                $result = $this->compareValues($fsArr[0], $sValue);
                return $result == -1 ? 1 : $result;
            } elseif (is_numeric($fValue) && is_string($sValue)) {
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fValue, $ssArr[0]);
                return $result == -1 ? 0 : $result;
            } elseif (is_string($fValue) && is_string($sValue)) {
                $fsArr = explode("p", $fValue);
                $ssArr = explode("p", $sValue);
                $result = $this->compareValues($fsArr[0], $ssArr[0]);
                if ($result != -1)
                    return $result;
                $result = $this->compareValues($fsArr[1], $ssArr[1]);
                return $result;
            }
        }
    }

    public function compareValues($firstVal, $secondVal) {
        $num = $firstVal - $secondVal;
        return ($num > 0) ? 1 : ($num < 0 ? 0 : -1);
    }
    
    function onInstall() {
        
        $db = $this->getDb();
        $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitesubscription';");
        
        if($this->_targetVersion == '4.8.13p1' && $this->_currentVersion == '4.8.13'){
        
            $db = Engine_Db_Table::getDefaultAdapter();
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_content')->where('name = ?','sitesubscription.check-subscription');
            $widget = $db->fetchRow($select);

            if(empty($widget)){

                $select = new Zend_Db_Select($db);
                $select->from('engine4_core_pages')
                        ->where('name = ?', 'header')
                        ->limit(1);
                $page_id = $select->query()->fetchObject()->page_id;
                if (!empty($page_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_content = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'widget')
                            ->where('name = ?', 'sitesubscription.check-subscription')
                            ->limit(1);
                    $content_id = $select_content->query()->fetchObject()->content_id;
                    if (empty($content_id)) {
                        $select = new Zend_Db_Select($db);
                        $select_top = $select
                                ->from('engine4_core_content')
                                ->where('page_id = ?', $page_id)
                                ->where('type = ?', 'container')
                                ->where('name = ?', 'main')
                                ->limit(1);
                        $top_id = $select_top->query()->fetchObject()->content_id;
                        if (!empty($top_id)) {
                            $db->query(" INSERT IGNORE INTO `engine4_core_content` (`page_id`, `type`, `name` ,`parent_content_id` ,`order` ,`params`) VALUES (".$page_id.", 'widget', 'sitesubscription.check-subscription', ".$top_id.", 0, ''); ");
                        }
                    }
                }                
            }
        } else if($this->_currentVersion == '4.8.13p1' || $this->_currentVersion == '4.8.13'){
            $this->upgradep1orbase();
        } else if($this->_currentVersion == '4.8.13p2' || $this->_currentVersion == '4.8.13p1' || $this->_currentVersion == '4.8.13'){
            $this->updateTemplate1();
            $this->addLayout0();
        } 
        $this->updateTemplate0();
        parent::onInstall();
    }

    // update the json values in temaplate 1
    public function updateTemplate1()
    {
        $db = Engine_Db_Table::getDefaultAdapter();

        $db->query(' UPDATE `engine4_sitesubscription_templates` SET `template_values`="{\"template_bgcolor\":{\"value\":\"FFEEC9\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bgcolor\",\"order\":2,\"label\":\"Template Background Color\",\"description\":\"Select the background color for whole template.\"}]],\"order\":2} },\"template_packagename_price_bgcolor_normal\":{\"value\":\"03A9F4\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_packagename_price_bgcolor_normal\",\"order\":3,\"label\":\"Package Name and Price Block Background Color (Normal)\",\"description\":\"Select the background color for package name and price block for normal package\"}]],\"order\":3} },\"template_packagename_price_bgcolor_popular\": {\"value\":\"FF9600\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_packagename_price_bgcolor_popular\",\"order\":4,\"label\":\"Package Name and Price Block Background Color (Popular)\",\"description\":\"Select the background color for package name and price block for popular package\"}]],\"order\":4} },\"template_packagename_price_textcolor\": {\"value\":\"fff\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_packagename_price_textcolor\",\"order\":5,\"label\":\"Package Name and Price Text Color\",\"description\":\"Select text color for package name and price block.\"}]],\"order\":5} },\"template_packagename_price_textsize\":{\"value\":\"24\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Package Name and Price\", \"order\":6,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\",\"16\":\"16\",\"17\":\"17\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"} } },\"template_packagename_price_textfamily\":{\"value\":\"Georgia\", \"type\":\"Select\", \"options\": {\"label\":\"Font family of Package Name and Price\", \"order\":7,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_packagename_price_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Package Name and Price\", \"order\":8,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } },\"template_mostpopularblock_text\": {\"value\":\"Most Popular Package !!\", \"type\":\"Text\", \"options\": {\"label\":\"Text for Most Popular Package\" , \"order\":9, \"description\":\"Enter the text that will be displayed upon moat popular package block.\" } }, \"template_mostpopularblock_bgcolor\":{\"value\":\"03A9F4\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_mostpopularblock_bgcolor\",\"order\":10,\"label\":\"Background Color for \'Most Popular\' Block\",\"description\":\"Select the background color for the \'most popular\' block.\"}]],\"order\":10 } },\"template_mostpopularblock_textsize\": {\"value\":\"18\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of \'Most Popular\' Block\", \"order\":11,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\",\"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_mostpopularblock_textfamily\": {\"value\":\"Georgia\", \"type\":\"Select\", \"options\": {\"label\":\"Font family of \'Most Popular\' Block\", \"order\":12,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_mostpopularblock_textstyle\":{\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of \'Most Popular\' Block\", \"order\":13,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_mostpopularblock_textcolor\":{\"value\":\"fff\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\", {\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_mostpopularblock_textcolor\",\"order\":14,\"label\":\"Text Color for \'Most Popular\' Block\",\"description\":\"Select the text color for the \'most popular\' block.\"}]],\"order\":14 } },\"template_feature_textsize\":{\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Features\", \"order\":15,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\", \"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_feature_textfamily\":{\"value\":\"Arial\", \"type\":\"Select\", \"options\": {\"label\":\"Font family of Features\", \"order\":16,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_feature_textstyle\": {\"value\":\"normal\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Features\", \"order\":17,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_button_text\": {\"value\":\"Buy Package\", \"type\":\"Text\", \"options\": {\"label\":\"Text on the Button\" , \"order\":18, \"description\":\"Enter the text that will be displayed on select package button (size in em).\"} }, \"template_button_textsize\": {\"value\":\"1.3\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Button Text\", \"order\":19,\"description\":\"\",\"multiOptions\":{\"1.0\":\"1.0\",\"1.1\":\"1.1\",\"1.2\":\"1.2\",\"1.3\":\"1.3\",\"1.4\":\"1.4\",\"1.5\":\"1.5\",\"1.6\":\"1.6\",\"1.7\":\"1.7\", \"1.8\":\"1.8\", \"1.9\":\"1.9\",\"2.0\":\"2.0\"} } },\"template_button_textfamily\": {\"value\":\"Arial\", \"type\":\"Select\", \"options\": {\"label\":\"Font family of Button Text\", \"order\":20,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_button_textstyle\":{\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Button Text\", \"order\":21,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } }}" WHERE `template_id`=1 ;');
    }

        // update the json values in temaplate 0
    public function updateTemplate0()
    {
        $db = Engine_Db_Table::getDefaultAdapter();

        $db->query(' UPDATE `engine4_sitesubscription_templates` SET `template_values`="{\"template_packagename_textcolor\": {\"value\":\"000000\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_packagename_textcolor\",\"order\":2,\"label\":\"Package Name Text Color\",\"description\":\"Select text color for package name.\"}]],\"order\":2} },\"template_packagename_textsize\":{\"value\":\"20\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Package Name\",\"order\":3,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"} } },\"template_packagename_textfamily\":{\"value\":\"Georgia\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Package Name\",\"order\":4,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_packagename_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Package Name\",\"order\":5,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } },\"template_mostpopularblock_text\": {\"value\":\"Most Popular Package !!\", \"type\":\"Text\", \"options\": {\"label\":\"Text for Most Popular Package\" ,\"order\":6, \"description\":\"Enter the headline text that will be displayed for most popular package.\"} },\"template_mostpopularblock_textcolor\":{\"value\":\"000000\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_mostpopularblock_textcolor\",\"order\":7,\"label\":\"Text Color for \'Most Popular\' Block\",\"description\":\"Select the text color for the \'most popular\' block.\"}]],\"order\":7 } },\"template_mostpopularblock_textsize\": {\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of \'Most Popular\' Block\",\"order\":8,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_mostpopularblock_textfamily\": {\"value\":\"Century Gothic\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of \'Most Popular\' Block\",\"order\":9,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_mostpopularblock_textstyle\":{\"value\":\"normal\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of \'Most Popular\' Block\",\"order\":10,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_bgcolor_normal\":{\"value\":\"ffffff\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bgcolor_normal\",\"order\":11,\"label\":\"Background Color for Normal Packages\",\"description\":\"Select the background color for normal packages.\"}]],\"order\":11} },\"template_bgcolor_popular\":{\"value\":\"fcbc92\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bgcolor_popular\",\"order\":12,\"label\":\"Background Color for Popular Packages\",\"description\":\"Select the background color for popular packages.\"}]],\"order\":12} },\"template_bordercolor_popular\":{\"value\":\"ea5c00\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bordercolor_popular\",\"order\":13,\"label\":\"Border Color for Popular Package Block\",\"description\":\"Select the border color for popular package block.\"}]],\"order\":13} },\"template_feature_textsize\":{\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Features\",\"order\":14,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_feature_textfamily\":{\"value\":\"Times New Roman\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Features\",\"order\":15,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_feature_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Features\",\"order\":16,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_price_textcolor_popular\": {\"value\":\"ffffff\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_textcolor_popular\",\"order\":17,\"label\":\"Price Text Color ( Popular )\",\"description\":\"Select the text color for popular package price text.\"}]],\"order\":17 } },\"template_price_bgcolor_popular\": {\"value\":\"ff8739\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_bgcolor_popular\",\"order\":18,\"label\":\"Price Background Color ( Popular )\",\"description\":\"Select the background color for popular package price block .\"}]],\"order\":18 } },\"template_price_textcolor_normal\": {\"value\":\"0dadf6\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_textcolor_normal\",\"order\":19,\"label\":\"Price Text Color ( Normal )\",\"description\":\"Select the text color for normal package price text.\"}]],\"order\":19 } },\"template_price_bgcolor_normal\": {\"value\":\"f2f0f0\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_bgcolor_normal\",\"order\":20,\"label\":\"Price Background Color ( Normal )\",\"description\":\"Select the text color for normal package price text.\"}]],\"order\":20 } },\"template_price_textsize\":{\"value\":\"24\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Price\",\"order\":21,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}}}, \"template_price_textfamily\":{\"value\":\"Georgia\",\"type\":\"Select\", \"options\": {\"label\":\"Font Family of Price\",\"order\":22,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_price_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Price Text\",\"order\":23,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_button_text\": {\"value\":\"Buy Package !!\", \"type\":\"Text\", \"options\": {\"label\":\"Text on the Button\" ,\"order\":24, \"description\":\"Enter the text that will be displayed on select package button.\"} },\"template_button_textsize\": {\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Button Text\",\"order\":25,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"} } },\"template_button_textfamily\": {\"value\":\"Arial\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Button Text\",\"order\":26,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_button_textstyle\":{\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Button Text\",\"order\":27,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } }}" WHERE `template_id`=0 ;');
    }

    // insert db entries for layout 6
    public function addLayout0()
    {
        $db = Engine_Db_Table::getDefaultAdapter();
        
        // Insert entries in layouts table 
        $db->query('SET sql_mode="NO_AUTO_VALUE_ON_ZERO";' );
        $db->query('INSERT IGNORE INTO `engine4_sitesubscription_layouts` (`layout_id` ,`layout_name`, `structure_type`, `enabled`, `default` ) VALUES (0, "Layout 0", "type2", 1, 1);');

        // Insert entries in templates table 
        $db->query('INSERT IGNORE INTO `engine4_sitesubscription_templates` ( `template_id`,`template_name`, `template_values`, `layout`, `active`, `default`) VALUES (0, "Template Zero", "{\"template_packagename_textcolor\": {\"value\":\"000000\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_packagename_textcolor\",\"order\":2,\"label\":\"Package Name Text Color\",\"description\":\"Select text color for package name.\"}]],\"order\":2} },\"template_packagename_textsize\":{\"value\":\"20\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Package Name\",\"order\":3,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"} } },\"template_packagename_textfamily\":{\"value\":\"Georgia\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Package Name\",\"order\":4,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_packagename_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Package Name\",\"order\":5,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } },\"template_mostpopularblock_text\": {\"value\":\"Most Popular Package !!\", \"type\":\"Text\", \"options\": {\"label\":\"Text for Most Popular Package\" ,\"order\":6, \"description\":\"Enter the headline text that will be displayed for most popular package.\"} },\"template_mostpopularblock_textcolor\":{\"value\":\"000000\", \"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_mostpopularblock_textcolor\",\"order\":7,\"label\":\"Text Color for \'Most Popular\' Block\",\"description\":\"Select the text color for the \'most popular\' block.\"}]],\"order\":7 } },\"template_mostpopularblock_textsize\": {\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of \'Most Popular\' Block\",\"order\":8,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_mostpopularblock_textfamily\": {\"value\":\"Century Gothic\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of \'Most Popular\' Block\",\"order\":9,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_mostpopularblock_textstyle\":{\"value\":\"normal\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of \'Most Popular\' Block\",\"order\":10,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_bgcolor_normal\":{\"value\":\"ffffff\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bgcolor_normal\",\"order\":11,\"label\":\"Background Color for Normal Packages\",\"description\":\"Select the background color for normal packages.\"}]],\"order\":11} },\"template_bgcolor_popular\":{\"value\":\"fcbc92\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bgcolor_popular\",\"order\":12,\"label\":\"Background Color for Popular Packages\",\"description\":\"Select the background color for popular packages.\"}]],\"order\":12} },\"template_bordercolor_popular\":{\"value\":\"ea5c00\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_bordercolor_popular\",\"order\":13,\"label\":\"Border Color for Popular Package Block\",\"description\":\"Select the border color for popular package block.\"}]],\"order\":13} },\"template_feature_textsize\":{\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Features\",\"order\":14,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}} },\"template_feature_textfamily\":{\"value\":\"Times New Roman\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Features\",\"order\":15,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"} } },\"template_feature_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Features\",\"order\":16,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_price_textcolor_popular\": {\"value\":\"ffffff\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_textcolor_popular\",\"order\":17,\"label\":\"Price Text Color ( Popular )\",\"description\":\"Select the text color for popular package price text.\"}]],\"order\":17 } },\"template_price_bgcolor_popular\": {\"value\":\"ff8739\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_bgcolor_popular\",\"order\":18,\"label\":\"Price Background Color ( Popular )\",\"description\":\"Select the background color for popular package price block .\"}]],\"order\":18 } },\"template_price_textcolor_normal\": {\"value\":\"0dadf6\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_textcolor_normal\",\"order\":19,\"label\":\"Price Text Color ( Normal )\",\"description\":\"Select the text color for normal package price text.\"}]],\"order\":19 } },\"template_price_bgcolor_normal\": {\"value\":\"f2f0f0\",\"type\":\"Text\", \"options\": {\"decorators\":[[\"ViewScript\",{\"viewScript\":\"_colorpicker.tpl\",\"class\":\"form element colorPickerElement\",\"element_name\":\"template_price_bgcolor_normal\",\"order\":20,\"label\":\"Price Background Color ( Normal )\",\"description\":\"Select the text color for normal package price text.\"}]],\"order\":20 } },\"template_price_textsize\":{\"value\":\"24\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Price\",\"order\":21,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"}}}, \"template_price_textfamily\":{\"value\":\"Georgia\",\"type\":\"Select\", \"options\": {\"label\":\"Font Family of Price\",\"order\":22,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_price_textstyle\": {\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Price Text\",\"order\":23,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"}} },\"template_button_text\": {\"value\":\"Buy Package !!\", \"type\":\"Text\", \"options\": {\"label\":\"Text on the Button\" ,\"order\":24, \"description\":\"Enter the text that will be displayed on select package button.\"} },\"template_button_textsize\": {\"value\":\"16\",\"type\":\"Select\", \"options\": {\"label\":\"Font Size of Button Text\",\"order\":25,\"description\":\"\",\"multiOptions\":{\"8\":\"8\",\"9\":\"9\",\"10\":\"10\",\"11\":\"11\",\"12\":\"12\",\"13\":\"13\",\"14\":\"14\",\"15\":\"15\", \"16\":\"16\",\"17\":\"17\",\"18\":\"18\",\"19\":\"19\",\"20\":\"20\",\"21\":\"21\",\"22\":\"22\",\"23\":\"23\",\"24\":\"24\",\"25\":\"25\",\"26\":\"26\",\"27\":\"27\",\"28\":\"28\",\"29\":\"29\",\"30\":\"30\",\"31\":\"31\",\"32\":\"32\",\"33\":\"33\",\"34\":\"34\",\"35\":\"35\"} } },\"template_button_textfamily\": {\"value\":\"Arial\", \"type\":\"Select\", \"options\": {\"label\":\"Font Family of Button Text\",\"order\":26,\"description\":\"\",\"multiOptions\":{\"Andale Mono\":\"Andale Mono\",\"Arial\":\"Arial\",\"Arial Black\":\"Arial Black\",\"Book Antiqua\":\"Book Antiqua\",\"Comic Scan MS\":\"Comic Scan MS\",\"Courier New\":\"Courier New\",\"Georgia\":\"Georgia\",\"Helvetica\":\"Helvetica\",\"Impact\":\"Impact\",\"Symbol\":\"Symbol\",\"Tahoma\":\"Tahoma\",\"Terminal\":\"Terminal\",\"Times New Roman\":\"Times New Roman\",\"Trebuchet MS\":\"Trebuchet MS\",\"Verdana\":\"Verdana\",\"Webdings\":\"Webdings\",\"Wingdings\":\"Wingdings\",\"Century Gothic\":\"Century Gothic\"}} },\"template_button_textstyle\":{\"value\":\"bold\",\"type\":\"Select\", \"options\": {\"label\":\"Font Style of Button Text\",\"order\":27,\"description\":\"\",\"multiOptions\":{\"bold\":\"Bold\",\"italic\":\"Italic\",\"normal\":\"Normal\"} } }}", 0, 0, 1); ');
    }

    // delete upgrade subscriptions mini menu insert user setting menu
    public function upgradep1orbase()
    {
        $db = Engine_Db_Table::getDefaultAdapter();
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_menuitems')->where('name = ?','core_mini_upgrade')->limit(1);
        $menuItem = $select->query()->fetchObject()->id;
        if(!empty($menuItem)) {
            $db->delete('engine4_core_menuitems', array(
                'name = ?'=>'core_mini_upgrade',
            ));
        }

        $db->query('INSERT IGNORE INTO `engine4_core_menuitems` ( `name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES ( "user_settings_subscription", "sitesubscription", "Upgrade Subscriptions", "Sitesubscription_Plugin_Menus", "{\"route\":\"default\",\"module\":\"sitesubscription\",\"controller\":\"subscription\", \"action\" : \"upgrade-subscription\"}", "user_settings", "", "1", "0", "999") ');
    }

    public function onEnable()
    {
        $db = $this->getDb();
        try{
        
            $db->beginTransaction();
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled`=0 WHERE `name`='user_settings_payment' ");
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled`=1 WHERE `name`='user_settings_subscription' ");

            // Put check-subscription widget at header
            $select = new Zend_Db_Select($db);
            $select->from('engine4_core_pages')
                    ->where('name = ?', 'header')
                    ->limit(1);
            $page_id = $select->query()->fetchObject()->page_id;
            if (!empty($page_id)) {
                $select = new Zend_Db_Select($db);
                $select_content = $select
                        ->from('engine4_core_content')
                        ->where('page_id = ?', $page_id)
                        ->where('type = ?', 'widget')
                        ->where('name = ?', 'sitesubscription.check-subscription')
                        ->limit(1);
                $content_id = $select_content->query()->fetchObject()->content_id;
                if (empty($content_id)) {
                    $select = new Zend_Db_Select($db);
                    $select_top = $select
                            ->from('engine4_core_content')
                            ->where('page_id = ?', $page_id)
                            ->where('type = ?', 'container')
                            ->where('name = ?', 'main')
                            ->limit(1);
                    $top_id = $select_top->query()->fetchObject()->content_id;
                    if (!empty($top_id)) {
                        $db->query(" INSERT IGNORE INTO `engine4_core_content` (`page_id`, `type`, `name` ,`parent_content_id` ,`order` ,`params`) VALUES (".$page_id.", 'widget', 'sitesubscription.check-subscription', ".$top_id.", 0, ''); ");
                    }
                }
            }

            $signupProcess = $db->query(' SELECT * FROM `engine4_user_signup` order by `order` ASC ')->fetchAll();
            $db->query(' TRUNCATE `engine4_user_signup`; ');

            foreach ($signupProcess as $key => $process) {
                
                if($process['class'] == 'User_Plugin_Signup_Fields')
                    $process['class'] = str_replace('User', 'Sitesubscription', $process['class']);

                if($process['class'] == 'Payment_Plugin_Signup_Subscription')
                    $process['class'] = str_replace('Payment', 'Sitesubscription', $process['class']);

                $db->query("INSERT IGNORE INTO `engine4_user_signup` (`class`, `order`, `enable`) VALUES ('".$process['class']."', ".$process['order'].", ".$process['enable'].") ");
            }            
            $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitequicksignup_signup'")->fetch();
            if (!empty($table_exist)) {
                $quickSignupProcess = $db->query(' SELECT * FROM `engine4_sitequicksignup_signup` order by `order` ASC ')->fetchAll();
                $db->query(' TRUNCATE `engine4_sitequicksignup_signup`; ');

                foreach ($quickSignupProcess as $key => $process) {
                    
                    if($process['class'] == 'Payment_Plugin_Signup_Subscription')
                       $process['class'] = str_replace('Payment', 'Sitesubscription', $process['class']);

                    $db->query("INSERT IGNORE INTO `engine4_sitequicksignup_signup` (`class`, `order`, `enable`) VALUES ('".$process['class']."', ".$process['order'].", ".$process['enable'].") ");
                }
            }
            parent::onEnable();
            $db->commit();
        }catch(Exception $e){

            $db->rollback();
            $errorMsg .= '<div class="tip"><span>Error: '.$e->getMessage().'</span></div>';
            $this->_error($errorMsg);
        }
            
    }

    public function onDisable()
    {
        $db = $this->getDb();
        try{
        
            $db->beginTransaction();
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled`=1 WHERE `name`='user_settings_payment' ");
            $db->query("UPDATE `engine4_core_menuitems` SET `enabled`=0 WHERE `name`='user_settings_subscription' ");
            $db->query(" DELETE FROM `engine4_core_content` WHERE `name`='sitesubscription.check-subscription' ");

            $signupProcess = $db->query(' SELECT * FROM `engine4_user_signup` order by `order` ASC ')->fetchAll();
            $db->query(' TRUNCATE `engine4_user_signup`; ');

            foreach ($signupProcess as $key => $process) {
                
                if($process['class'] == 'Sitesubscription_Plugin_Signup_Fields')
                    $process['class'] = str_replace('Sitesubscription', 'User', $process['class']);

                if($process['class'] == 'Sitesubscription_Plugin_Signup_Subscription')
                    $process['class'] = str_replace('Sitesubscription', 'Payment', $process['class']);

                $db->query("INSERT IGNORE INTO `engine4_user_signup` (`class`, `order`, `enable`) VALUES ('".$process['class']."', ".$process['order'].", ".$process['enable'].") ");
            }            
            $table_exist = $db->query("SHOW TABLES LIKE 'engine4_sitequicksignup_signup'")->fetch();
            if (!empty($table_exist)) {
                $quickSignupProcess = $db->query(' SELECT * FROM `engine4_sitequicksignup_signup` order by `order` ASC ')->fetchAll();
                $db->query(' TRUNCATE `engine4_sitequicksignup_signup`; ');

                foreach ($quickSignupProcess as $key => $process) {
                    
                    if($process['class'] == 'Sitesubscription_Plugin_Signup_Subscription')
                       $process['class'] = str_replace('Sitesubscription', 'Payment', $process['class']);

                    $db->query("INSERT IGNORE INTO `engine4_sitequicksignup_signup` (`class`, `order`, `enable`) VALUES ('".$process['class']."', ".$process['order'].", ".$process['enable'].") ");
                }
            }
            parent::onDisable();
            $db->commit();
        }catch(Exception $e){

            $db->rollback();
            $errorMsg .= '<div class="tip"><span>Error: '.$e->getMessage().'</span></div>';
            $this->_error($errorMsg);
        }        
    }

}