<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: SocialLinks.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_Form_SocialLinks extends Engine_Form {

  public function init() {

    $tempLogoOptions = Engine_Api::_()->sitetheme()->getImages(array());

    $this->addElement('Dummy', 'facebook', array(
                  'label' => '1. Facebook'
              )
    );

    $this->addElement('Text', 'facebook_url', array(
            'label' => 'Url',
            'value' => 'http://www.facebook.com/'
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/facebook.png' => 'Default Facebook Icon');
    $this->addElement('Select', 'facebook_default_icon', array(
          'label' => 'Default Image Icon',
          'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
          'value' => '',
      ));

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/overfacebook.png' => 'Mouse-over Facebook Icon');
    $this->addElement('Select', 'facebook_hover_icon', array(
            'label' => 'Mouse-over Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $this->addElement('Text', 'facebook_title', array(
            'label' => 'HTML Title',
            'value' => 'Like us on Facebook'
        )
    );

    $this->addElement('Dummy', 'pinterest', array(
            'label' => '2. Pinterest'
        )
    );

    $this->addElement('Text', 'pinterest_url', array(
            'label' => 'Url',
            'value' => 'https://www.pinterest.com/'
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/pinterest.png' => 'Default Pinterest Icon');
    $this->addElement('Select', 'pinterest_default_icon',array(
            'label' => 'Default Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/overpinterest.png' => 'Mouse-over Pinterest Icon');
    $this->addElement('Select', 'pinterest_hover_icon', array(
            'label' => 'Mouse-over Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $this->addElement('Text', 'pinterest_title', array(
            'label' => 'HTML Title',
            'value' => 'Pinterest'
        )
    );

    $this->addElement('Dummy', 'twitter', array(
            'label' => '3. Twitter'
        )
    );

    $this->addElement('Text', 'twitter_url', array(
            'label' => 'Url',
            'value' => 'https://www.twitter.com/'
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/twitter.png' => 'Default Twitter Icon');
    $this->addElement('Select', 'twitter_default_icon', array(
            'label' => 'Default Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/overtwitter.png' => 'Mouse-over Twitter Icon');
    $this->addElement('Select', 'twitter_hover_icon', array(
          'label' => 'Mouse-over Image Icon',
          'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
          'value' => ''
      )
    );

    $this->addElement('Text', 'twitter_title', array(
            'label' => 'HTML Title',
            'value' => 'Follow us on Twitter'
        )
    );

    $this->addElement('Dummy', 'youtube', array(
            'label' => '4. Youtube'
        )
    );

    $this->addElement('Text', 'youtube_url', array(
            'label' => 'Url',
            'value' => 'http://www.youtube.com/'
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/youtube.png' => 'Default Youtube Icon');
    $this->addElement('Select', 'youtube_default_icon', array(
            'label' => 'Default Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/overyoutube.png' => 'Mouse-over Youtube Icon');
    $this->addElement('Select', 'youtube_hover_icon', array(
            'label' => 'Mouse-over Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $this->addElement('Text', 'youtube_title', array(
            'label' => 'HTML Title',
            'value' => 'Youtube'
        )
    );
    
    $this->addElement('Dummy', 'linkedin', array(
            'label' => '4. LinkedIn'
        )
    );

    $this->addElement('Text', 'linkedin_url', array(
            'label' => 'Url',
            'value' => 'https://www.linkedin.com/'
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/linkedin.png' => 'Default LinkedIn Icon');
    $this->addElement('Select', 'linkedin_default_icon', array(
            'label' => 'Default Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $defaultLogoOptions = array('application/modules/Sitetheme/externals/images/overlinkedin.png' => 'Mouse-over LinkedIn Icon');
    $this->addElement('Select', 'linkedin_hover_icon', array(
            'label' => 'Mouse-over Image Icon',
            'multiOptions' => array_merge($defaultLogoOptions, $tempLogoOptions),
            'value' => ''
        )
    );

    $this->addElement('Text', 'linkedin_title', array(
            'label' => 'HTML Title',
            'value' => 'LinkedIn'
        )
    );
  }
}