<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Menus.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitetheme_Plugin_Menus {
  
  public function isLogin(){
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    if(empty ($viewer_id)){
      return false;
    }   
    return true;
  }
  
  
  // FOOTER MENUS FUNCTIONS
  
    public function canViewProducts($row) {

    $sitestoreproductPluginObj = new Sitestoreproduct_Plugin_Menus();
    $canViewProducts = $sitestoreproductPluginObj->canViewSitestoreproducts($row);

    if( !empty($canViewProducts) )
    {
      if( $row->name == 'sitetheme_footer_popularitems' )
      {
        $actionName = 'home';
      }
      else if( $row->name == 'sitetheme_footer_newestitems' )
      {
        $actionName = 'index';
      }
      
      return array(
        'route' => 'sitestoreproduct_general',
        'action' => $actionName,
//        'icon' => $row->params['icon'],
        'name' => $row->label
      );
    }
  }
  
  public function canViewOffers($row)
  {
    $sitestoreofferPluginObj = new Sitestoreoffer_Plugin_Menus();
    $canViewOffers = $sitestoreofferPluginObj->canViewOffers();
    
    if( !empty($canViewOffers) )
    {
      return array(
        'route' => 'sitestoreoffer_home',
        'action' => 'home',
//        'icon' => $row->params['icon'],
        'name' => $row->label
      );
    }
  }
  
  public function canViewWishlist($row)
  {
    $sitestoreproductPluginObj = new Sitestoreproduct_Plugin_Menus();
    $canViewWishlist = $sitestoreproductPluginObj->canViewWishlist($row);
    
    if( !empty($canViewWishlist) )
    {
      return array(
        'route' => 'sitestoreproduct_wishlist_general',
        'action' => "browse",
//        'icon' => $row->params['icon'],
        'label' => $row->label
      );
    }
  }
  
  public function canCreateStores($row) {

    $sitestorePluginObj = new Sitestore_Plugin_Menus();
    $canCreateStores = $sitestorePluginObj->canCreateSitestores();
    
    if( !empty($canCreateStores) )
    {
      return array(
        'route' => 'sitestoreproduct_general',
//        'icon' => $row->params['icon'],
        'name' => $row->label,
        'action' => 'startup',
      );
    }
  }
  
  public function canViewStores($row) {

    $sitestorePluginObj = new Sitestore_Plugin_Menus();
    $canViewStores = $sitestorePluginObj->canViewSitestores($row);

    if( !empty($canViewStores) )
    {
      if( $row->name == 'sitetheme_footer_bestsellingstore' )
      {
        $actionName = 'home';
      }
      else if( $row->name == 'sitetheme_footer_allstores' )
      {
        $actionName = 'index';
      }
      
      return array(
        'route' => 'sitestore_general',
        'action' => $actionName,
//        'icon' => $row->params['icon'],
        'label' => $row->label
      );
    }
  }
  
  public function canViewBrosweReview($row)
  {
    $sitestoreproductPluginObj = new Sitestoreproduct_Plugin_Menus();
    $canViewBrosweReview = $sitestoreproductPluginObj->canViewBrosweReview($row);
    
    if( !empty($canViewBrosweReview) )
    {
      return array(
        'route' => 'sitestoreproduct_review_browse',
        'action' => "browse",
//        'icon' => $row->params['icon'],
        'label' => $row->label
      );
    }
  }
  
  public function canViewSitereviews($row) {
    
    $sitereviewPluginObj = new Sitereview_Plugin_Menus();
    $canViewSitereviews = $sitereviewPluginObj->canViewSitereviews($row);

    if( !empty($canViewSitereviews) )
    {
      return array(
        'route' => 'sitereview_general_listtype_'.$row->params['listingtype_id'],
        'name' => $row->label,
        'action' => 'home',
      );
    }
    
    return false;
  }
  
  public function canViewEditors($row)
  {
    $sitestoreproductPluginObj = new Sitestoreproduct_Plugin_Menus();
    $canViewEditors = $sitestoreproductPluginObj->canViewEditors($row);
    
    if( !empty($canViewEditors) )
    {
      return array(
        'route' => 'sitestoreproduct_editor_general',
        'action' => "home",
//        'icon' => $row->params['icon'],
        'label' => $row->label
      );
    }
  }
  
  public function canViewSitefaqs($row) {

    $sitefaqPluginObj = new Sitefaq_Plugin_Menus();
    $canViewSitefaqs = $sitefaqPluginObj->canViewSitefaqs();
    
    if( !empty($canViewSitefaqs) )
    {
      return array(
        'route' => 'sitefaq_general',
//        'icon' => $row->params['icon'],
        'name' => $row->label,
        'action' => 'home',
      );
    }
  }
  
  public function canViewBlogs($row) {
    
    $blogPluginObj = new Blog_Plugin_Menus();
    $canViewBlogs = $blogPluginObj->canViewBlogs();

    if( !empty($canViewBlogs) )
    {
      return array(
        'route' => 'blog_general',
        'name' => $row->label,
//        'action' => 'home',
      );
    }
    
    return false;
  }


  public function footerLink($row) {
    
      return array(
      'route' => 'sitestoreproduct_general',
      'icon' => $row->params['icon'],
      'name' => $row->label,
      'action' => 'home',
    );
  }
  
  
  
  
  
  
  
  
  
  

  
  

  
  

  public function canViewBlog($row)
  {
    $isBlogModuleExist = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('blog');
    
    if( !empty($isBlogModuleExist) )
      return true;
    return false;
   
  }
  
  public function homePage($row)
  {
    $sitestoreproductPluginObj = new Sitestoreproduct_Plugin_Menus();
    $route = $sitestoreproductPluginObj->canViewCategories($row);

    if( !empty($route) && @is_array($route) )
    {
      $route['icon'] = $row->params['icon'];
      return $route;
    }
    
    return false;
  }

  public function categoryUrl($row) {
    $name = $row->name;
    
    if( @strstr($name, 'sitestoreproduct_category') )
    {
      $categoryId = @end(@explode('_', $name));
      
      $categoryObj = Engine_Api::_()->getItem('sitestoreproduct_category', $categoryId);
      if( empty($categoryId) || empty($categoryObj) )
        return false;
      return array(
          'uri' => $categoryObj->getHref(),
          'name' => $name,
//          'icon' => $row->params['icon'],
      );
    }
  }
  
  public function onMenuInitialize_SitethemeMiniFriendRequest($row) {
    $viewer = Engine_Api::_()->user()->getViewer();

    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'icon' => $row->params['icon'],
          'name' => $row->name,
          'action' => 'friend-request',
          'newFriendRequestCount' => Engine_Api::_()->getDbtable('updates', 'sitetheme')->getNewUpdatesCount($viewer, array('type' => 'friend_request'))
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniMessage($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $viewer->getIdentity();
    if (empty($viewer_id))
      return false;

    // Get permission setting
    $permission = Engine_Api::_()->authorization()->getPermission($viewer->level_id, 'messages', 'create');
    if (Authorization_Api_Core::LEVEL_DISALLOW === $permission)
      return false;

    return array(
        'label' => $row->label,
        'icon' => $row->params['icon'],
        'name' => $row->name,
        'action' => 'message',
        'newMessageCount' => Engine_Api::_()->getDbtable('updates', 'sitetheme')->getUnreadMessageCount($viewer),
    );
  }

  public function onMenuInitialize_SitethemeMiniNotification($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'icon' => $row->params['icon'],
          'name' => $row->name,
          'action' => 'notification',
          'newNotificationCount' => Engine_Api::_()->getDbtable('updates', 'sitetheme')->getNewUpdatesCount($viewer, array('isNotification' => 'true'))
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniSettings($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'icon' => $row->params['icon'],
          'name' => $row->name,
          'action' => 'setting',
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniProfile($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    $isProfileImage = true;
		
    if( $viewer->getPhotoUrl('thumb.icon') )
       $profileImageUrl = $viewer->getPhotoUrl('thumb.icon');
    else
    {
      $profileImageUrl = $row->params['icon'];
      $isProfileImage = false;
    }
		
    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'uri' => $viewer->getHref(),
          'icon' => $profileImageUrl,
          'name' => $row->name,
          'isProfileImage' => $isProfileImage,
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniAdmin($row) {
    // @todo check perms
    if (Engine_Api::_()->getApi('core', 'authorization')->isAllowed('admin', null, 'view')) {
      return array(
          'label' => $row->label,
          'route' => 'admin_default',
          'class' => 'no-dloader',
          'icon' => $row->params['icon'],
          'name' => $row->name,
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniCart($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity())
      $level_id = $viewer->level_id;
    else
      $level_id = Engine_Api::_()->getDbtable('levels', 'authorization')->fetchRow(array('type = ?' => "public"))->level_id;

    $isBuyAllow = Engine_Api::_()->authorization()->getPermission($level_id, 'sitestore_store', "allow_buy");

    if (!empty($isBuyAllow)) {
      $update_cart_notification = Engine_Api::_()->getApi('settings', 'core')->getSetting('sitestoreproduct.cart.update', 1);

      if (!empty($update_cart_notification)) {
        $viewer_id = $viewer->getIdentity();
        $cartProductCounts = 0;

        if (empty($viewer_id)) {
          $session = new Zend_Session_Namespace('sitestoreproduct_viewer_cart');
          if (!empty($session->sitestoreproduct_guest_user_cart)) {
            $tempUserCart = array();
            $tempUserCart = @unserialize($session->sitestoreproduct_guest_user_cart);

            foreach ($tempUserCart as $values) {
              if (isset($values['config']) && is_array($values['config']))
                foreach ($values['config'] as $quantity) {
                  $cartProductCounts += $quantity['quantity'];
                }
              else
                $cartProductCounts += $values['quantity'];
            }
          }
        }
        else
          $cartProductCounts = Engine_Api::_()->getDbtable('carts', 'sitestoreproduct')->getProductCounts();


        return array(
            'label' => $row->label,
            'class' => 'no-dloader',
            'icon' => $row->params['icon'],
            'name' => $row->name,
            'action' => 'get-cart-products',
            'itemCount' => $cartProductCounts
        );
      }
      else
        return false;
    }
    return false;
  }

  public function onMenuInitialize_SitethemeMiniSignup($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!$viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'route' => 'user_signup',
//          'icon' => $row->params['icon'],
          'name' => $row->name,
      );
    }

    return false;
  }

  public function onMenuInitialize_SitethemeMiniLogin($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if (!$viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'route' => 'user_login',
//          'icon' => $row->params['icon'],
          'name' => 'sitetheme_mini_auth_login',
          'params' => array(
              // Nasty hack
              'return_url' => '64-' . base64_encode($_SERVER['REQUEST_URI']),
          ),
      );
    }
  }
  
  public function onMenuInitialize_SitethemeMiniLogout($row) {
    $viewer = Engine_Api::_()->user()->getViewer();
    if ($viewer->getIdentity()) {
      return array(
          'label' => $row->label,
          'route' => 'user_logout',
          'class' => 'no-dloader',
//          'icon' => $row->params['icon'],
          'name' => 'sitetheme_mini_auth_logout',
      );
    }
  }
}