<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetheme
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2013-11-22 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetheme_AdminSettingsController extends Core_Controller_Action_Admin {

  public function __call($method, $params) {
    /*
     * YOU MAY DISPLAY ANY ERROR MESSAGE USING FORM OBJECT.
     * YOU MAY EXECUTE ANY SCRIPT, WHICH YOU WANT TO EXECUTE ON FORM SUBMIT.
     * REMEMBER:
     *    RETURN TRUE: IF YOU DO NOT WANT TO STOP EXECUTION.
     *    RETURN FALSE: IF YOU WANT TO STOP EXECUTION.
     */
    if ( !empty($method) && $method == 'Sitetheme_Form_Htmlblock' ) {
      
    }
    return true;
  }

  public function indexAction() {
    if ( isset($_POST['sitetheme_lsettings']) ) {
      $_POST['sitetheme_lsettings'] = trim($_POST['sitetheme_lsettings']);
    }

    $this->view->isThemeActivate = Engine_Api::_()->sitetheme()->isThemeActivate("shoppinghub");
    include APPLICATION_PATH . '/application/modules/Sitetheme/controllers/license/license1.php';
  }

  public function readmeAction() {
    
  }

  //ACTION FOR FAQ
  public function faqAction() {

    //TABS CREATION
    $this->view->navigationStore = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitetheme_admin_main', array(), 'sitetheme_admin_main_faq');
  }

  public function placeCustomizationFileAction() {
    if ( $this->getRequest()->isPost() ) {
      $global_directory_name = APPLICATION_PATH . '/application/themes/shoppinghub';
      @chmod($global_directory_name, 0777);

      if ( !is_readable($global_directory_name) ) {
        $this->view->error_message = "<span style='color:red'>Note: You do not have readable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: <b>" . $global_directory_name . "</b></span>";
        return;
      }

      $global_settings_file = $global_directory_name . '/customization.css';
      $is_file_exist = @file_exists($global_settings_file);
      if ( empty($is_file_exist) ) {
        @chmod($global_directory_name, 0777);
        if ( !is_writable($global_directory_name) ) {
          $this->view->error_message = "<span style='color:red'>Note: You do not have writable permission on the path below, please give 'chmod 777 recursive permission' on it to continue with the installation process : <br /> 
Path Name: " . $global_directory_name . "</span>";
          return;
        }

        $fh = @fopen($global_settings_file, 'w');
        @fwrite($fh, '/* ADD CUSTOM STYLE */');
        @fclose($fh);

        @chmod($global_settings_file, 0777);
      }

      $this->_forward('success', 'utility', 'core', array(
          'smoothboxClose' => 10,
          'parentRefresh' => 10,
          'messages' => array('File Succesfully Created.')
      ));
    }
  }

  public function placeHtaccessFileAction() {
    if ( $this->getRequest()->isPost() ) {
      $successfullyAdded = false;
      $getFileContent = '<FilesMatch ".(ttf|otf|woff)$">
    Header set Access-Control-Allow-Origin "*"
</FilesMatch>';

      $global_directory_name = APPLICATION_PATH . '/application/themes/shoppinghub';
      $global_settings_file = $global_directory_name . '/.htaccess';
      $is_file_exist = @file_exists($global_settings_file);

      // IF FILE NOT EXIST THEN CREATE NEW .HTACCESS FILE THERE.
      if ( empty($is_file_exist) ) {
        if ( is_dir($global_directory_name) ) {
          @mkdir($global_directory_name, 0777);

          $fh = @fopen($global_settings_file, 'w') or die('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/shoppinghub' . '" and then try again.');
          @fwrite($fh, $getFileContent);
          @fclose($fh);

          @chmod($global_settings_file, 0777);
          $successfullyAdded = true;
        }
      } else {
        if ( !is_writable($global_settings_file) ) {
          @chmod($global_settings_file, 0777);
          if ( !is_writable($global_settings_file) ) {
            $form->addError('Unable to create .htaccess file; please give the CHMOD 777 recursive permission to the directory "' . APPLICATION_PATH . '/application/themes/shoppinghub' . '" and then try again.');
            return;
          }
        }
        $successfullyAdded = @file_put_contents($global_settings_file, $getFileContent);
      }

      if ( !empty($successfullyAdded) ) {
        $this->_forward('success', 'utility', 'core', array(
            'smoothboxClose' => 10,
            'parentRefresh' => 10,
            'messages' => array('File Succesfully Created.')
        ));
      }
    }
  }

}
