<?php

/**
 * SocialEngine
 *
 * @category   Application_Module
 * @package    Sitetour
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    Core.php 2015-09-10 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetour_Api_Core extends Core_Api_Abstract
{

  private $_contentAreasByName = array();

  public function getPageWidgetLists($page_id, $ignoreWidgets = array())
  {
    $contentAreasNameList = $this->getNameListOfContentAreas();
    $contentTable = Engine_Api::_()->getDbtable('content', 'core');
    $select = $contentTable->select()
      ->where('page_id =?', $page_id)
      ->where('type =?', 'widget')
      ->group('name');
    $widgetOptions = array();
    foreach( $contentTable->fetchAll($select) as $content ) {
      if( in_array($content->content_id, $ignoreWidgets) || in_array($content->name, array('core.container-tabs'))  || !isset($contentAreasNameList[$content->name])) {
        continue;
      }
      $widgetOptions[$content->content_id] = $contentAreasNameList[$content->name] . (!empty($content->params['title']) ? ' (' . preg_replace('#<script(.*?)>(.*?)</script>#is', '', $content->params['title']) . ')' : '');
    }
    return $widgetOptions;
  }

  public function getNameListOfContentAreas()
  {
    if( !empty($this->_contentAreasByName) ) {
      return $this->_contentAreasByName;
    }
    $contentAreas = array();

    // From modules
    $modules = Zend_Controller_Front::getInstance()->getControllerDirectory();
    foreach( $modules as $module => $path ) {
      $contentManifestFile = dirname($path) . '/settings/content.php';
      if( !file_exists($contentManifestFile) )
        continue;
      $ret = include $contentManifestFile;
      $contentAreas = array_merge($contentAreas, (array) $ret);
    }

    // From widgets
    $it = new DirectoryIterator(APPLICATION_PATH . '/application/widgets');
    foreach( $it as $dir ) {
      if( !$dir->isDir() || $dir->isDot() )
        continue;
      $path = $dir->getPathname();
      $contentManifestFile = $path . '/' . 'manifest.php';
      if( !file_exists($contentManifestFile) )
        continue;
      $ret = include $contentManifestFile;
      if( !is_array($ret) )
        continue;
      array_push($contentAreas, $ret);
    }
    foreach( $contentAreas as $content ) {
      $this->_contentAreasByName[$content['name']] = preg_replace('#<script(.*?)>(.*?)</script>#is', '', $content['title']);
    }

    return $this->_contentAreasByName;
  }

}

?>
