<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetour
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Collections.php 6590 2016-07-07 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitetour_Model_DbTable_Tours extends Engine_Db_Table
{

  protected $_rowClass = 'Sitetour_Model_Tour';
  protected $_serializedColumns = array('params');

  /**
   * Gets a select object for the user's classified entries
   *
   * @param Core_Model_Item_Abstract $user The user to get the messages for
   * @return Zend_Db_Table_Select
   */
  public function getToursSelect($params = array())
  {
    $select = $this->select();
    if( isset($params['enabled']) ) {
      $select->where('enabled =?', $params['enabled']);
    }
    $order = !empty($params['orderDesc']) ? 'DESC' : 'ASC';
    $orderby = !empty($params['orderby']) ? $params['orderby'] : 'tour_id';
    $select->order($orderby . ' ' . $order);
//    $select->where("start_time <= FROM_UNIXTIME(?)", time());
//    $select->where("end_time > FROM_UNIXTIME(?)", time());
    return $select;
  }

  public function getToursPaginator($params = array())
  {
    $paginator = Zend_Paginator::factory($this->getToursSelect($params));
    if( !empty($params['page']) ) {
      $paginator->setCurrentPageNumber($params['page']);
    }
    if( !empty($params['limit']) ) {
      $paginator->setItemCountPerPage($params['limit']);
    }
    return $paginator;
  }

  public function getTourByPageName($pageName)
  {
    return $this->fetchRow($this->select()->where('page_name = ?', $pageName));
  }

  public function getPageNames()
  {
    return $this->getToursSelect()
        ->from($this->info('name'), "page_name")
        ->query()
        ->fetchAll(Zend_Db::FETCH_COLUMN);
  }

}
