<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSiteTutorialController.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitetutorial_AdminSiteTutorialController extends Core_Controller_Action_Admin
{
	//ACTION FOR GLOBAL SETTINGS
  public function manageAction()
  { 
		//GET NAVIGATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
            ->getNavigation('sitetutorial_admin_main', array(), 'sitetutorial_admin_main_sitetutorial');

    //FORM GENERATION
    $this->view->formFilter = $formFilter = new Sitetutorial_Form_Admin_Question_Filter();
    $page = $this->_getParam('page', 1);

		//GET CATEGORY TABLE
		$tableCategory = Engine_Api::_()->getDbTable('categories', 'sitetutorial');
		$tableCategoryName = $tableCategory->info('name');

		//GET USER TABLE NAME
    $tableUserName = Engine_Api::_()->getItemTable('user')->info('name');

		//GET HELP TABLE
		$this->view->helpTable = Engine_Api::_()->getDbtable('helps', 'sitetutorial');

		//GET TUTORIAL TABLE
    $tableSitetutorial = Engine_Api::_()->getDbtable('tutorials', 'sitetutorial');
    $tableSitetutorialName = $tableSitetutorial->info('name');

		//MAKE QUERY
    $select = $tableSitetutorial->select()
            ->setIntegrityCheck(false)
            ->from($tableSitetutorialName)
            ->joinLeft($tableUserName, "$tableSitetutorialName.owner_id = $tableUserName.user_id", 'username');

    $values = array();

    if ($formFilter->isValid($this->_getAllParams())) {
      $values = $formFilter->getValues();
    }
    foreach ($values as $key => $value) {

      if (null == $value) {
        unset($values[$key]);
      }
    }

    //SEARCHING
    $this->view->owner = '';
    $this->view->title = '';
    $this->view->approved = '';
    $this->view->featured = '';
    $this->view->status = '';
    $this->view->category_id = '';
    $this->view->subcategory_id = '';
    $this->view->subsubcategory_id = '';

    $values = array_merge(array(
        'order' => 'tutorial_id',
        'order_direction' => 'DESC',
            ), $values);

		if(!empty($_POST['owner'])) { $user_name = $_POST['owner']; } elseif(!empty($_GET['owner'])) { $user_name = $_GET['owner']; }  else { $user_name = '';}

		if(!empty($_POST['title'])) { $page_name = $_POST['title']; } elseif(!empty($_GET['title'])) { $page_name = $_GET['title']; } elseif($this->_getParam('title', '')) { $page_name = $this->_getParam('title', '');} else { $page_name = '';}

		//SEARCHING
    $this->view->owner = $values['owner'] = $user_name;
		$this->view->title = $values['title'] = $page_name; 

		if (!empty($page_name)) {
			$select->where($tableSitetutorialName . '.title  LIKE ?', '%' . $page_name . '%');
		}    

		if (!empty($user_name)) {
			$select->where($tableUserName . '.displayname  LIKE ?', '%' . $user_name . '%');
		}

    if (isset($_POST['search'])) {

      if (!empty($_POST['featured'])) {
        $this->view->featured = $_POST['featured'];
        $_POST['featured']--;
        $select->where($tableSitetutorialName . '.featured = ? ', $_POST['featured']);
      }

      if (!empty($_POST['approved'])) {
        $this->view->approved = $_POST['approved'];
        $_POST['approved']--;
        $select->where($tableSitetutorialName . '.approved = ? ', $_POST['approved']);
      }

      if (!empty($_POST['draft'])) {
        $this->view->draft = $_POST['draft'];
        $_POST['draft']--;
        $select->where($tableSitetutorialName . '.draft = ? ', $_POST['draft']);
      }

      if (!empty($_POST['status'])) {
        $this->view->status = $_POST['status'];
        $_POST['status']--;
        $select->where($tableSitetutorialName . '.closed = ? ', $_POST['status']);
      }
      
      if (!empty($_POST['category_id']) && empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'] )) {
        $this->view->category_id = $_POST['category_id'];
        $select->where($tableSitetutorialName . '.category_id LIKE ? ', '%"'.$_POST['category_id'].'"%');
      } 
			elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && empty($_POST['subsubcategory_id'] )) {
        $this->view->category_id = $_POST['category_id'];
        $subcategory_id = $this->view->subcategory_id = $_POST['subcategory_id'];

        $selectcategory = $tableCategory->select()
																->from($tableCategoryName, 'category_name')
																->where("(category_id = $subcategory_id)");
        $row = $tableCategory->fetchRow($selectcategory);

        if (!empty($row->category_name)) {
          $this->view->subcategory_name = $row->category_name;
        }

        $select->where($tableSitetutorialName . '.category_id LIKE ? ', '%"'.$_POST['category_id'].'"%')
                ->where($tableSitetutorialName . '.subcategory_id LIKE ? ', '%"'.$_POST['subcategory_id'].'"%');
      }
      elseif (!empty($_POST['category_id']) && !empty($_POST['subcategory_id']) && !empty($_POST['subsubcategory_id'])) {
        
        $this->view->category_id = $_POST['category_id'];
        $subcategory_id = $this->view->subcategory_id = $_POST['subcategory_id'];
        $subsubcategory_id = $this->view->subsubcategory_id = $_POST['subsubcategory_id'];

        $row = $tableCategory->getCategory($subcategory_id);
        if (!empty($row->category_name)) {
          $this->view->subcategory_name = $row->category_name;
        }
        $row = $tableCategory->getCategory($subsubcategory_id);
        if (!empty($row->category_name)) {
          $this->view->subsubcategory_name = $row->category_name;
        }
        $select->where($tableSitetutorialName . '.category_id LIKE ? ', '%"'.$_POST['category_id'].'"%')
                ->where($tableSitetutorialName . '.subcategory_id LIKE ? ', '%"'.$_POST['subcategory_id'].'"%')
                ->where($tableSitetutorialName . '.subsubcategory_id LIKE ? ', '%"'.$_POST['subsubcategory_id'].'"%');;
      }
    }

		//SEND FORM VALUES TO TPL
    $this->view->formValues = array_filter($values);
    $this->view->assign($values);

		//SEND ORDER DIRECTION TO TPL
		$this->view->order_direction = !empty($values['order_direction']) ? $values['order_direction'] : 'DESC';

    $select->order((!empty($values['order']) ? $values['order'] : 'tutorial_id' ) . ' ' . (!empty($values['order_direction']) ? $values['order_direction'] : 'DESC' ));

    //MAKE PAGINATOR
    $this->view->paginator = $paginator = Zend_Paginator::factory($select);
    $this->view->paginator->setItemCountPerPage(50);
    $this->view->paginator = $paginator->setCurrentPageNumber($page);
	}

	//ACTION FOR MAKE THE TUTORIAL APPROVED/DIS-APPROVED
  public function approvedAction() {

		//GET TUTORIAL ID
  	$tutorial_id = $this->_getParam('tutorial_id');

		//BEGIN TRANSCATION
   	$db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

			//GET TUTORIAL OBJECT
     	$sitetutorial = Engine_Api::_()->getItem('sitetutorial_tutorial', $tutorial_id);
     	if($sitetutorial->approved == 0) {
   		  $sitetutorial->approved = 1;	
   		}
   		else {
   			$sitetutorial->approved = 0;
   		}

			//SAVE CHANGES AND COMMIT
   		$sitetutorial->save();
 			$db->commit();
	 	}
   	catch( Exception $e ){
     $db->rollBack();
     throw $e;
   	}

		//REDIRECT
  	$this->_redirect('admin/sitetutorial/site-tutorial/manage');   
 	}

	//ACTION FOR MAKE THE TUTORIAL FEATURED/UNFEATURED
  public function featuredAction() {

		//GET TUTORIAL ID
  	$tutorial_id = $this->_getParam('tutorial_id');

		//BEGIN TRANSCATION
   	$db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

			//GET TUTORIAL OBJECT
     	$sitetutorial = Engine_Api::_()->getItem('sitetutorial_tutorial', $tutorial_id);
     	if($sitetutorial->featured == 0) {
   		  $sitetutorial->featured = 1;	
   		}
   		else {
   			$sitetutorial->featured = 0;
   		}

			//SAVE CHANGES AND COMMIT
   		$sitetutorial->save();
 			$db->commit();
	 	}
   	catch( Exception $e ){
     $db->rollBack();
     throw $e;
   	}

		//REDIRECT
  	$this->_redirect('admin/sitetutorial/site-tutorial/manage');   
 	}

	//ACTION FOR SET THE TUTORIAL WEIGHT
  public function weightAction() {

		//SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

		//GET TUTORIAL ID
  	$tutorial_id = $this->_getParam('tutorial_id');

		$this->view->form = $form = new Sitetutorial_Form_Admin_Sitetutorial_Weight();

    if( !$this->getRequest()->isPost() ) {
      return;
    }

    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

		//BEGIN TRANSCATION
   	$db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {

			//GET TUTORIAL OBJECT
     	$sitetutorial = Engine_Api::_()->getItem('sitetutorial_tutorial', $tutorial_id);
   		$sitetutorial->weight = $_POST['weight'];

			//SAVE CHANGES AND COMMIT
   		$sitetutorial->save();
 			$db->commit();
	 	}
   	catch( Exception $e ){
     $db->rollBack();
     throw $e;
   	}

		$this->_forward('success', 'utility', 'core', array(
				'smoothboxClose' => 10,
				'parentRefresh'=> 10,
				'messages' => array('')
		));   
 	}

  //ACTION FOR DELETE THE TUTORIAL
  public function deleteAction()
  {
		//SET LAYOUT
		$this->_helper->layout->setLayout('admin-simple');

		//GET TUTORIAL ID
		$this->view->tutorial_id = $tutorial_id = $this->_getParam('tutorial_id');

		if( $this->getRequest()->isPost()){

			//DELETE TUTORIAL OBJECT
			Engine_Api::_()->getItem('sitetutorial_tutorial', $tutorial_id)->delete();

			$this->_forward('success', 'utility', 'core', array(
			   'smoothboxClose' => 10,
			   'parentRefresh'=> 10,
			   'messages' => array('')
			));
   	}
		$this->renderScript('admin-site-tutorial/delete.tpl');
	}
 
  //ACTION FOR MULTI DELETE TUTORIALS
  public function multiDeleteAction()
  {
    if ($this->getRequest()->isPost()) {

			//GET FORM VALUES
      $values = $this->getRequest()->getPost();
      foreach ($values as $key=>$value) {
        if ($key == 'delete_' . $value) {

        	//GET TUTORIAL ID
          $tutorial_id = (int)$value;

					//DELETE TUTORIAL OBJECT
					Engine_Api::_()->getItem('sitetutorial_tutorial', $tutorial_id)->delete();
        }
      }
    }

		//REDIRECT
    return $this->_helper->redirector->gotoRoute(array('action' => 'manage'));
  }

}