<?php

$db = Zend_Db_Table_Abstract::getDefaultAdapter();

$db->query("
  INSERT IGNORE INTO `engine4_core_mailtemplates` (`type`, `module`, `vars`) VALUES
	('SITETUTORIAL_QUESTION_NOTIFICATION_EMAIL', 'sitetutorial', '[host],[email],[site_title],[question]'),
  ('SITETUTORIAL_QUESTION_ANSWER_EMAIL', 'sitetutorial', '[host],[email],[site_title],[question],[answer]');
");

$db->query('
  INSERT IGNORE INTO `engine4_core_menuitems` (`name`, `module`, `label`, `plugin`, `params`, `menu`, `submenu`, `enabled`, `custom`, `order`) VALUES
  ("sitetutorial_admin_main_level", "sitetutorial", "Member Level Settings", "", \'{"route":"admin_default","module":"sitetutorial","controller":"settings", "action":"level"}\', "sitetutorial_admin_main", "", 1, 0, 2),
  ("sitetutorial_admin_main_categories", "sitetutorial", "Categories", "", \'{"route":"admin_default","module":"sitetutorial","controller":"settings", "action":"categories"}\', "sitetutorial_admin_main", "", 1, 0, 3),
  ("sitetutorial_admin_main_fields", "sitetutorial", "Custom Fields", "", \'{"route":"admin_default","module":"sitetutorial","controller":"fields"}\', "sitetutorial_admin_main", "", 1, 0, 4),
  ("sitetutorial_admin_main_form_search", "sitetutorial", "Search Form Settings", "", \'{"route":"admin_default","module":"sitetutorial","controller":"settings","action":"form-search"}\', "sitetutorial_admin_main", "", 1, 0, 5),
  ("sitetutorial_admin_main_import", "sitetutorial", "Import", "", \'{"route":"admin_default","module":"sitetutorial","controller":"import"}\', "sitetutorial_admin_main", "", 1, 0, 6),
  ("sitetutorial_admin_main_helpful", "sitetutorial", "Helpful Settings", "", \'{"route":"admin_default","module":"sitetutorial","controller":"settings","action":"helpful-report"}\', "sitetutorial_admin_main", "", 1, 0, 7),
  ("sitetutorial_admin_main_sitetutorial", "sitetutorial", "Manage Tutorials", "", \'{"route":"admin_default","module":"sitetutorial","controller":"site-tutorial", "action":"manage"}\', "sitetutorial_admin_main", "", 1, 0, 8),
  ("sitetutorial_admin_main_question", "sitetutorial", "User Questions", "", \'{"route":"admin_default","module":"sitetutorial","controller":"question", "action":"manage"}\', "sitetutorial_admin_main", "", 1, 0, 9),
  ("sitetutorial_core_main", "sitetutorial", "Tutorials", \'Sitetutorial_Plugin_Menus::canViewSitetutorials\', \'{"route":"sitetutorial_general","action":"home","icon":"fa-question-circle-o"}\', "core_footer", "", 1, 0, 3);
');

$isTutorialRow = $db->query('SELECT * FROM `engine4_core_menuitems` WHERE `name` LIKE "core_main_sitetutorial" LIMIT 1')->fetchAll();
if( !empty($isTutorialRow) ) {
  $db->query('UPDATE `engine4_core_menuitems` SET `enabled` = "1" WHERE `engine4_core_menuitems`.`name` ="core_main_sitetutorial" LIMIT 1 ;');
}

//UPLOAD CATEGORY ICONS
Engine_Api::_()->getDbTable('categories', 'sitetutorial')->iconUpload(0);

//START TUTORIAL HOME PAGE
$page_id = $db->select()
				->from('engine4_core_pages', 'page_id')
				->where('name = ?', 'sitetutorial_index_home')
				->limit(1)
				->query()
				->fetchColumn();

//CREATE PAGE IF NOT EXIST
if (!$page_id) {
  //CREATE PAGE
  $db->insert('engine4_core_pages', array(
	  'name' => 'sitetutorial_index_home',
	  'displayname' => 'Tutorial Home Page',
	  'title' => 'Tutorial Home Page',
	  'description' => 'This page lists Tutorials.',
	  'custom' => 0,
  ));
  $page_id = $db->lastInsertId();

  //TOP CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'top',
	  'page_id' => $page_id,
	  'order' => 1,
  ));
  $top_container_id = $db->lastInsertId();

  //MAIN CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'main',
	  'page_id' => $page_id,
	  'order' => 2,
  ));
  $main_container_id = $db->lastInsertId();

  //INSERT TOP-MIDDLE
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'middle',
	  'page_id' => $page_id,
	  'parent_content_id' => $top_container_id,
  ));
  $top_middle_id = $db->lastInsertId();

  //MAIN NAVIGATION WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.navigation-sitetutorials',
	  'parent_content_id' => $top_middle_id,
	  'order' => 3,
	  'params' => '',
  ));

  //MAIN-MIDDLE CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'middle',
	  'page_id' => $page_id,
	  'parent_content_id' => $main_container_id,
	  'order' => 2,
  ));
  $main_middle_id = $db->lastInsertId();

  //RIGHT CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'right',
	  'page_id' => $page_id,
	  'parent_content_id' => $main_container_id,
	  'order' => 1,
  ));
  $right_container_id = $db->lastInsertId();

  //ZERO TUTORIALs MESSAGE WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.zero-sitetutorials',
	  'parent_content_id' => $main_middle_id,
	  'order' => 10,
	  'params' => '',
  ));

  //SEARCH BOX WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.search-box-sitetutorials',
	  'parent_content_id' => $main_middle_id,
	  'order' => 11,
	  'params' => '{"title":"","blur_text":"Enter a keyword or question","titleCount":"true"}',
  ));

  //CATEGORIZED TUTORIAL WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.categories-tutorials-sitetutorials',
	  'parent_content_id' => $main_middle_id,
	  'order' => 12,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

  //TOP RATED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 15,
	  'params' => '{"title":"Top Rated Tutorials","popularity":"rating"}',
  ));

  //FEATURED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 16,
	  'params' => '{"title":"Featured Tutorials","popularity":"RAND()","featured":"1"}',
  ));

  //MOST HELPFUL TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 17,
	  'params' => '{"title":"Most Helpful Tutorials","popularity":"helpful"}',
  ));

  //MOST LIKED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 18,
	  'params' => '{"title":"Most Liked Tutorials","popularity":"like_count"}',
  ));

  //MOST RECENT TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 19,
	  'params' => '{"title":"Most Recent Tutorials","popularity":"creation_date"}',
  ));

  //POPULAR TAGS WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tagcloud-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 20,
  ));
}

//START TUTORIAL BROWSE PAGE
$page_id = $db->select()
				->from('engine4_core_pages', 'page_id')
				->where('name = ?', 'sitetutorial_index_browse')
				->limit(1)
				->query()
				->fetchColumn();

//CREATE PAGE IF NOT EXIST
if (!$page_id) {
  //CREATE PAGE
  $db->insert('engine4_core_pages', array(
	  'name' => 'sitetutorial_index_browse',
	  'displayname' => 'Tutorial Browse Page',
	  'title' => 'Tutorial Browse Page',
	  'description' => 'This page lists Tutorials.',
	  'custom' => 0,
  ));
  $page_id = $db->lastInsertId();

  //TOP CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'top',
	  'page_id' => $page_id,
	  'order' => 1,
  ));
  $top_container_id = $db->lastInsertId();

  //MAIN CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'main',
	  'page_id' => $page_id,
	  'order' => 2,
  ));
  $main_container_id = $db->lastInsertId();

  //INSERT TOP-MIDDLE
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'middle',
	  'page_id' => $page_id,
	  'parent_content_id' => $top_container_id,
  ));
  $top_middle_id = $db->lastInsertId();

  //MAIN NAVIGATION WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.navigation-sitetutorials',
	  'parent_content_id' => $top_middle_id,
	  'order' => 3,
	  'params' => '',
  ));

  //MAIN-MIDDLE CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'middle',
	  'page_id' => $page_id,
	  'parent_content_id' => $main_container_id,
	  'order' => 2,
  ));
  $main_middle_id = $db->lastInsertId();

  //BROWSE TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.browse-sitetutorials',
	  'parent_content_id' => $main_middle_id,
	  'order' => 3,
	  'params' => '',
  ));

  //RIGHT CONTAINER
  $db->insert('engine4_core_content', array(
	  'type' => 'container',
	  'name' => 'right',
	  'page_id' => $page_id,
	  'parent_content_id' => $main_container_id,
	  'order' => 1,
  ));
  $right_container_id = $db->lastInsertId();

  //SEARCH FORM WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.sidebar-categories-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 14,
	  'params' => '',
  ));

  //SEARCH FORM WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.search-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 15,
	  'params' => '',
  ));

  //MOST COMMENTED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 18,
	  'params' => '{"title":"Most Commented Tutorials","popularity":"comment_count"}',
  ));

  //MOST RECENT TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 18,
	  'params' => '{"title":"Most Recent Tutorials","popularity":"creation_date"}',
  ));

  //MOST VIEWED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tutorials-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 18,
	  'params' => '{"title":"Most Viewed Tutorials","popularity":"view_count"}',
  ));

  //POPULAR TAGS WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.tagcloud-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => 19,
  ));
}
//END TUTORIAL BROWES PAGE

//START TUTORIAL VIEW PAGE WORK
$select = new Zend_Db_Select($db);
$select
		->from('engine4_core_pages')
		->where('name = ?', 'sitetutorial_index_view')
		->limit(1);

$info = $select->query()->fetch();

if (empty($info)) {
  //CREATE PAGE IF NOT EXIST
  $db->insert('engine4_core_pages', array(
	  'name' => 'sitetutorial_index_view',
	  'displayname' => 'Tutorial View Page',
	  'title' => 'Tutorial View Page',
	  'description' => 'This is the Tutorial view page.',
	  'custom' => 0,
	  'layout' => 'default',
  ));
  $page_id = $db->lastInsertId('engine4_core_pages');

  //MAIN CONTAINER
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'container',
	  'name' => 'main',
	  'parent_content_id' => null,
	  'order' => 2,
	  'params' => '',
  ));
  $main_container_id = $db->lastInsertId('engine4_core_content');

  //RIGHT CONTAINER
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'container',
	  'name' => 'right',
	  'parent_content_id' => $main_container_id,
	  'order' => 5,
	  'params' => '',
  ));
  $right_container_id = $db->lastInsertId('engine4_core_content');

  //MAIN MIDDLE CONTAINER
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'container',
	  'name' => 'middle',
	  'parent_content_id' => $main_container_id,
	  'order' => 6,
	  'params' => '',
  ));
  $main_middle_container_id = $db->lastInsertId('engine4_core_content');

  //TUTORIAL VIEWER WINDOW WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.sitetutorial-view-sitetutorials',
	  'parent_content_id' => $main_middle_container_id,
	  'order' => 3,
	  'params' => '',
  ));

  //TUTORIAL COMMENT WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'core.comments',
	  'parent_content_id' => $main_middle_container_id,
	  'order' => 4,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

	$order = 5;

  //TUTORIAL RATING WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.featured-view-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

  //TUTORIAL RATING WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.ratings-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

  //TUTORIAL OWNER PHOTO WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.options-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '',
  ));

  //TUTORIAL INFORMATION WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.information-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

  //CATEGORIES WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.sidebar-categories-view-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '',
  ));

  //SOCIAL SHARE BUTTONS WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.socialshare-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '',
  ));

  //RELATED TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.related-tutorials-view-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '{"title":"Related Tutorials","related":"tags","titleCount":"true"}',
  ));

  //SAME CATEGORIES TUTORIALs WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.related-tutorials-view-sitetutorials',
	  'parent_content_id' => $right_container_id,
	  'order' => $order++,
	  'params' => '{"title":"Same Categories Tutorials","related":"categories","titleCount":"true"}',
  ));

}
//END TUTORIAL VIEW PAGE WORK

//START TUTORIAL MANAGE PAGE WORK
$select = new Zend_Db_Select($db);
$select
	->from('engine4_core_pages')
	->where('name = ?', 'sitetutorial_index_manage')
	->limit(1);
$info = $select->query()->fetch();

if( empty($info) ) {

	//CREATE PAGE IF NOT EXIST
	$db->insert('engine4_core_pages', array(
		'name' => 'sitetutorial_index_manage',
		'displayname' => 'Tutorial Manage Page',
		'title' => 'Tutorial Manage Page',
		'description' => 'This is the manage Tutorials page.',
		'custom' => 0,
		'layout' => 'default',
	));
	$page_id = $db->lastInsertId('engine4_core_pages');

	//CONTAINERS
	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'container',
			'name' => 'main',
			'parent_content_id' => Null,
			'order' => 2,
			'params' => '',
	));
	$container_id = $db->lastInsertId('engine4_core_content');

	//INSERT MAIN - MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'container',
			'name' => 'middle',
			'parent_content_id' => $container_id,
			'order' => 6,
			'params' => '',
	));
	$middle_id = $db->lastInsertId('engine4_core_content');

	//INSERT MAIN - RIGHT CONTAINER
	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'container',
			'name' => 'right',
			'parent_content_id' => $container_id,
			'order' => 5,
			'params' => '',
	));
	$right_id = $db->lastInsertId('engine4_core_content');

	//INSERT TOP CONTAINER
	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'container',
			'name' => 'top',
			'parent_content_id' => Null,
			'order' => 1,
			'params' => '',
	));
	$top_id = $db->lastInsertId('engine4_core_content');

	//INSERT TOP- MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'container',
			'name' => 'middle',
			'parent_content_id' => $top_id,
			'order' => 6,
			'params' => '',
	));
	$top_middle_id = $db->lastInsertId('engine4_core_content');

	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.navigation-sitetutorials',
		'parent_content_id' => $top_middle_id,
		'order' => 3,
		'params' => '',
	));

	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'widget',
			'name' => 'sitetutorial.search-sitetutorials',
			'parent_content_id' => $right_id,
			'order' => 3,
			'params' => '{"title":"","titleCount":"true"}',
	));

	$db->insert('engine4_core_content', array(
			'page_id' => $page_id,
			'type' => 'widget',
			'name' => 'sitetutorial.manage-sitetutorials',
			'parent_content_id' => $middle_id,
			'order' => 2,
			'params' => '',
	));
}
//END TUTORIAL MANAGE PAGE WORK

//START MOBILE TUTORIAL HOME PAGE WORK
$select = new Zend_Db_Select($db);
$select
	->from('engine4_core_pages')
	->where('name = ?', 'sitetutorial_index_mobi-home')
	->limit(1);
	;
$info = $select->query()->fetch();

if( empty($info) ) {
	//CREATE PAGE IF NOT EXIST
	$db->insert('engine4_core_pages', array(
		'name' => 'sitetutorial_index_mobi-home',
		'displayname' => 'Mobile Tutorial Home Page',
		'title' => 'Mobile Tutorial Home Page',
		'description' => 'This is the mobile Tutorials home page.',
		'custom' => 0,
		'layout' => 'default',
	));
	$page_id = $db->lastInsertId('engine4_core_pages');

	//MAIN CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'main',
		'parent_content_id' => null,
		'order' => 1,
		'params' => '',
	));
	$main_container_id = $db->lastInsertId('engine4_core_content');

	//MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'middle',
		'parent_content_id' => $main_container_id,
		'order' => 2,
		'params' => '',
	));
	$middle_container_id = $db->lastInsertId('engine4_core_content');

	//MAIN NAVIGATION WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.navigation-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 3,
		'params' => '',
	));

  //SEARCH BOX WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.mobi-search-box-sitetutorials',
	  'parent_content_id' => $middle_container_id,
	  'order' => 4,
	  'params' => '{"title":"","titleCount":"true"}',
  ));

  //ZERO TUTORIALs MESSAGE WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'sitetutorial.zero-sitetutorials',
	  'parent_content_id' => $middle_container_id,
	  'order' => 5,
	  'params' => '',
  ));

	//HOME TUTORIALS WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.mobi-home-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 6,
		'params' => '',
	));
}
//END MOBILE TUTORIAL HOME PAGE WORK

//START MOBILE TUTORIAL BROWSE PAGE WORK
$select = new Zend_Db_Select($db);
$select
	->from('engine4_core_pages')
	->where('name = ?', 'sitetutorial_index_mobi-browse')
	->limit(1);
$info = $select->query()->fetch();

if( empty($info) ) {
	//CREATE PAGE IF NOT EXIST
	$db->insert('engine4_core_pages', array(
		'name' => 'sitetutorial_index_mobi-browse',
		'displayname' => 'Mobile Tutorial Browse Page',
		'title' => 'Mobile Tutorial Browse Page',
		'description' => 'This is the mobile browse Tutorials page.',
		'custom' => 0,
		'layout' => 'default',
	));
	$page_id = $db->lastInsertId('engine4_core_pages');

	//MAIN CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'main',
		'parent_content_id' => null,
		'order' => 1,
		'params' => '',
	));
	$main_container_id = $db->lastInsertId('engine4_core_content');

	//MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'middle',
		'parent_content_id' => $main_container_id,
		'order' => 2,
		'params' => '',
	));
	$middle_container_id = $db->lastInsertId('engine4_core_content');

	//MAIN NAVIGATION WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.navigation-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 3,
		'params' => '',
	));

	//SEARCH FORM WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.search-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 4,
		'params' => '',
	));

	//BROWSE TUTORIALS WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.mobi-browse-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 5,
		'params' => '',
	));
}
//END MOBILE TUTORIAL BROWSE PAGE WORK

//START MOBILE TUTORIAL VIEW PAGE WORK
$select = new Zend_Db_Select($db);
$select
	->from('engine4_core_pages')
	->where('name = ?', 'sitetutorial_index_mobi-view')
	->limit(1);
	;
$info = $select->query()->fetch();

if( empty($info) ) {
	//CREATE PAGE IF NOT EXIST
	$db->insert('engine4_core_pages', array(
		'name' => 'sitetutorial_index_mobi-view',
		'displayname' => 'Mobile Tutorial View Page',
		'title' => 'Mobile Tutorial View Page',
		'description' => 'This is the mobile view Tutorial page.',
		'custom' => 0,
		'layout' => 'default',
	));
	$page_id = $db->lastInsertId('engine4_core_pages');

	//MAIN CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'main',
		'parent_content_id' => null,
		'order' => 1,
		'params' => '',
	));
	$main_container_id = $db->lastInsertId('engine4_core_content');

	//MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'middle',
		'parent_content_id' => $main_container_id,
		'order' => 2,
		'params' => '',
	));
	$middle_container_id = $db->lastInsertId('engine4_core_content');

	//VIEW TUTORIALS WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.sitetutorial-view-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 3,
		'params' => '',
	));

  //TUTORIAL COMMENT WIDGET
  $db->insert('engine4_core_content', array(
	  'page_id' => $page_id,
	  'type' => 'widget',
	  'name' => 'core.comments',
	  'parent_content_id' => $main_middle_container_id,
	  'order' => 4,
	  'params' => '{"title":"","titleCount":"true"}',
  ));
}
//END MOBILE TUTORIAL VIEW PAGE WORK

//START TUTORIAL MANAGE PAGE WORK
$select = new Zend_Db_Select($db);
$select
	->from('engine4_core_pages')
	->where('name = ?', 'sitetutorial_index_mobi-manage')
	->limit(1);
$info = $select->query()->fetch();

if( empty($info) ) {
	//CREATE PAGE IF NOT EXIST
	$db->insert('engine4_core_pages', array(
		'name' => 'sitetutorial_index_mobi-manage',
		'displayname' => 'Mobile Tutorial Manage Page',
		'title' => 'Mobile Tutorial Manage Page',
		'description' => 'This is the mobile manage Tutorial page.',
		'custom' => 0,
		'layout' => 'default',
	));
	$page_id = $db->lastInsertId('engine4_core_pages');

	//MAIN CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'main',
		'parent_content_id' => null,
		'order' => 1,
		'params' => '',
	));
	$main_container_id = $db->lastInsertId('engine4_core_content');

	//MIDDLE CONTAINER
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'container',
		'name' => 'middle',
		'parent_content_id' => $main_container_id,
		'order' => 2,
		'params' => '',
	));
	$middle_container_id = $db->lastInsertId('engine4_core_content');

	//MAIN NAVIGATION WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.navigation-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 3,
		'params' => '',
	));

	//SEARCH FORM WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.search-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 4,
		'params' => '',
	));

	//BROWSE TUTORIALS WIDGET
	$db->insert('engine4_core_content', array(
		'page_id' => $page_id,
		'type' => 'widget',
		'name' => 'sitetutorial.manage-sitetutorials',
		'parent_content_id' => $middle_container_id,
		'order' => 5,
		'params' => '',
	));
}
//END MOBILE TUTORIAL BROWSE PAGE WORK