<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitetutorial
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: install.php 6590 2012-18-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Sitetutorial_Installer extends Engine_Package_Installer_Module
{

  function onPreInstall() {
	$PRODUCT_TYPE = 'sitetutorial';
	$PLUGIN_TITLE = 'Sitetutorial';
	$PLUGIN_VERSION = '5.4.1';
	$PLUGIN_CATEGORY = 'plugin';
	$PRODUCT_DESCRIPTION = 'Tutorials Plugin';
	$_PRODUCT_FINAL_FILE = 0;
	$_BASE_FILE_NAME = 0;
	$PRODUCT_TITLE = 'Tutorials Plugin';
	$SocialEngineAddOns_version = '4.8.5';
	$file_path = APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/ilicense.php";
	$is_file = file_exists($file_path);
	if (empty($is_file)) {
	  include_once APPLICATION_PATH . "/application/modules/$PLUGIN_TITLE/controllers/license/license3.php";
	} else {
	  if (!empty($_PRODUCT_FINAL_FILE)) {
		include_once APPLICATION_PATH . '/application/modules/' . $PLUGIN_TITLE . '/controllers/license/' . $_PRODUCT_FINAL_FILE;
	  }
	  $db = $this->getDb();
	  $select = new Zend_Db_Select($db);
	  $select->from('engine4_core_modules')->where('name = ?', $PRODUCT_TYPE);
	  $is_Mod = $select->query()->fetchObject();
	  if( empty($is_Mod) ) {
	    include_once $file_path;
	  }
	}
	parent::onPreInstall();
  }

  public function onInstall()
  {
		$db = $this->getDb();

		//UPDATE ICON ENTRIES
		$select = new Zend_Db_Select($db);
		$select
			->from('engine4_core_modules')
			->where('name = ?', 'sitetutorial')
			->where('version < ?', '4.2.4p1');
		$is_enabled = $select->query()->fetchObject();

		if($is_enabled) {

			$categories = $db->select()
											->from('engine4_sitetutorial_categories', array('category_id', 'file_id'))
											->where('file_id != ?', 0)
											->query()
											->fetchAll();

			foreach($categories as $category)
			{
				$category_id = $category['category_id'];
				$file_id = $category['file_id'];
				$db->query("UPDATE `engine4_storage_files` SET `parent_type` = 'sitetutorial_category', parent_id = $category_id WHERE `file_id` = $file_id AND `parent_type` = 'sitetutorial_tutorial'");
			}
		}

		//START MAKE CHANGES IN engine4_communityad_tutorials TABLE
		$table_exist = $db->query("SHOW TABLES LIKE 'engine4_communityad_tutorials'")->fetch();
		if (!empty($table_exist)) {

			$column_exist = $db->query("SHOW COLUMNS FROM engine4_communityad_tutorials LIKE 'import'")->fetch();
			if (empty($column_exist)) {
				$db->query("ALTER TABLE `engine4_communityad_tutorials` ADD `import` TINYINT( 1 ) NOT NULL DEFAULT '0'");
			}
		}

    $db->query("UPDATE  `engine4_seaocores` SET  `is_activate` =  '1' WHERE  `engine4_seaocores`.`module_name` ='sitetutorial';");
    
    $categoriesTable = $db->query('SHOW TABLES LIKE \'engine4_sitetutorial_categories\'')->fetch();
		if (!empty($categoriesTable)) {
 
			$catDependencyIndex = $db->query("SHOW INDEX FROM `engine4_sitetutorial_categories` WHERE Key_name = 'cat_dependency'")->fetch();     
      if(empty($catDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_sitetutorial_categories` ADD INDEX ( `cat_dependency` )");
      }    
      
			$subcatDependencyIndex = $db->query("SHOW INDEX FROM `engine4_sitetutorial_categories` WHERE Key_name = 'subcat_dependency'")->fetch();     
      if(empty($subcatDependencyIndex)) {
        $db->query("ALTER TABLE `engine4_sitetutorial_categories` ADD INDEX ( `subcat_dependency` )");
      }       
    }

    $tutorialTable = $db->query('SHOW TABLES LIKE \'engine4_sitetutorial_tutorials\'')->fetch();
    if(!empty($tutorialTable)) {
        $featuredIndex = $db->query("SHOW INDEX FROM `engine4_sitetutorial_tutorials` WHERE Key_name = 'featured'")->fetch();   
        if(empty($featuredIndex)) {
          $db->query("ALTER TABLE `engine4_sitetutorial_tutorials` ADD INDEX ( `featured` )");
        }   

        $searchIndex = $db->query("SHOW INDEX FROM `engine4_sitetutorial_tutorials` WHERE Key_name = 'search'")->fetch();
        if(empty($searchIndex)) {
            $db->query("ALTER TABLE `engine4_sitetutorial_tutorials` ADD INDEX (`search`, `draft` , `approved`)");
        }
    }        
    
    parent::onInstall();
  }

}
