<?php
/*
 * Set specific configuration variables here
 */
return array(
  /*
    |--------------------------------------------------------------------------
    | Image Driver
    |--------------------------------------------------------------------------
    | Avatar use Intervention Image library to process image.
    | Meanwhile, Intervention Image supports "GD Library" and "Imagick" to process images
    | internally. You may choose one of them according to your PHP
    | configuration. By default PHP's "GD Library" implementation is used.
    |
    | Supported: "gd", "imagick"
    |
   */
  'driver' => 'gd',
  // Initial generator class
  'generator' => 'Laravolt\Avatar\Generator\DefaultGenerator',
  // Whether all characters supplied must be replaced with their closest ASCII counterparts
  'ascii' => false,
  // Image shape: circle or square
  'shape' => 'circle',
  // Image width, in pixel
  'width' => 100,
  // Image height, in pixel
  'height' => 100,
  // Number of characters used as initials. If name consists of single word, the first N character will be used
  'chars' => 2,
  // font size
  'fontSize' => 48,
  // convert initial letter in uppercase
  'uppercase' => false,
  // Fonts used to render text.
  // If contains more than one fonts, randomly selected based on name supplied
  'fonts' => array(
    APPLICATION_PATH_MOD . '/Siteuseravatar/Avatar/fonts/OpenSans-Bold.ttf',
    APPLICATION_PATH_MOD . '/Siteuseravatar/Avatar/fonts/OpenSans-Regular.ttf',
    APPLICATION_PATH_MOD . '/Siteuseravatar/Avatar/fonts/OpenSans-Semibold.ttf',
    APPLICATION_PATH_MOD . '/Siteuseravatar/Avatar/fonts/rockwell.ttf',
    APPLICATION_PATH_MOD . '/Siteuseravatar/Avatar/fonts/cac_champagne.ttf'
  ),
  // List of foreground colors to be used, randomly selected based on name supplied
  'foregrounds' => array(
    '#FFFFFF',
  ),
  // List of background colors to be used, randomly selected based on name supplied
  'backgrounds' => array(
    '#f44336',
    '#E91E63',
    '#9C27B0',
    '#673AB7',
    '#3F51B5',
    '#2196F3',
    '#03A9F4',
    '#00BCD4',
    '#009688',
    '#4CAF50',
    '#8BC34A',
    '#CDDC39',
    '#FFC107',
    '#FF9800',
    '#FF5722',
  ),
  'border' => array(
    'size' => 1,
    // border color, available value are:
    // 'foreground' (same as foreground color)
    // 'background' (same as background color)
    // or any valid hex ('#aabbcc')
    'color' => 'background',
  ),
);
