<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteusercoverphoto
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Main.php 6590 2013-06-03 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteusercoverphoto_Form_Photo_Upload extends Engine_Form
{

  public function init()
  {
    // Init form
    $this
      ->setTitle('Add New Photos')
      ->setDescription('Choose photos on your computer to add to collage album.')
      ->setAttrib('id', 'form-upload')
      ->setAttrib('name', 'albums_create')
      ->setAttrib('enctype', 'multipart/form-data')
      ->setAction(Zend_Controller_Front::getInstance()->getRouter()->assemble(array()))
    ;

    // Init file

    $uploadUrl = Zend_Controller_Front::getInstance()->getRouter()->assemble(array()) . '?ul=1';
    // $deleteUrl = $this->getView()->url(array('module'=>'album', 'controller' => 'photo', 'action'=>'delete'), 'default');
    $this->addElement('SeaoFancyUpload', 'file', array(
        'url' =>  $uploadUrl,
        // 'deleteUrl' =>  $deleteUrl,
        'accept' => 'image/*',
    ));

    // Init submit
    $this->addElement('Button', 'upload', array(
      'label' => 'Upload Photos',
      'onclick' => 'javascript:uploadPhotos();',
      'type' => 'button',
    ));
  }

  public function clearAlbum()
  {
    $this->getElement('album')->setValue(0);
  }

  public function saveValues($user)
  {
    $setPhoto = false;
    $values = $this->getValues();

    $albumTable = Engine_Api::_()->getDbtable('albums', 'album');
    $album = $albumTable->getSpecialAlbum($user, 'featured_cover');
    $album->title = 'Collage Cover Photos';
    $album->cover_params = Zend_Json_Encoder::encode(array('top' => '0', 'left' => 0));

    if( isset($album->view_privacy) ) {
      $album->view_privacy = 'everyone';
    }

    $album->save();

    if( !$album->photo_id ) {
      $setPhoto = true;
    }

    foreach( $values['file'] as $photoId ) {
      $photo = Engine_Api::_()->getItem("album_photo", $photoId);
      if( !($photo instanceof Core_Model_Item_Abstract) || !$photo->getIdentity() )
        continue;

      if( $setPhoto ) {
        $album->photo_id = $photoId;
        $album->save();
        $setCover = false;
      }

      $photo->album_id = $album->album_id;
      $photo->order = $photoId;
      $photo->save();
    }

    return $album;
  }

}
