<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    siteuserexport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: addtemplates.php 9772 2012-08-30 22:25:06Z matthew $
 * @author     SocialEngineAddons
 */

class Siteuserexport_Form_Admin_Manage_Addtemplates extends Engine_Form {

	public function init() {

		$getProfileTypes = Engine_Api::_()->getApi('Core', 'siteuserexport')->getProfileTypes();

		if (!empty($getProfileTypes)) {
			reset($getProfileTypes);
			$option_id = key($getProfileTypes);
		}

		$templateResult = Engine_Api::_()->getDbtable('templates', 'siteuserexport')->getTemplates($option_id);

		$templates = array('0' => 'No, create new template');
		foreach ($templateResult as $key => $label) {
			$templates[$key] = $label;
		}

		$this->setMethod('POST')
			->setTitle('Create New Template')
			->setDescription("Add name for the new template below.")
			->setAttrib('class', 'global_form_smoothbox');

		// Add label
		$this->addElement('Text', 'label', array(
			'label' => 'Template Label',
			'required' => true,
			'allowEmpty' => false,
		));

		$this->addElement('Select', 'option_id', array(
			'label' => 'Select Profile Type',
			'onchange' => 'showTemplate();',
			'multiOptions' => $getProfileTypes,
		));

		// Duplicate Existing
		$this->addElement('Select', 'duplicate', array(
			'label' => 'Duplicate Existing Template?',
			'required' => true,
			'allowEmpty' => false,
			'multiOptions' => $templates,
		));

		// Add submit
		$this->addElement('Button', 'submit', array(
			'label' => 'Add Template',
			'type' => 'submit',
			'decorators' => array(
				'ViewHelper',
			),
		));

		// Add cancel
		$this->addElement('Cancel', 'cancel', array(
			'label' => 'cancel',
			'link' => true,
			'onclick' => 'parent.Smoothbox.close();',
			'prependText' => ' or ',
			'decorators' => array(
				'ViewHelper',
			),
		));

		$this->addDisplayGroup(array('submit', 'cancel'), 'buttons');
	}
}
