<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    Siteuserexport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Exportuser.php 9747 2012-07-26 02:08:08Z john $
 * @author     SocialEngineAddons
 */

class Siteuserexport_Form_Admin_Manage_Exportuser extends Engine_Form {


	public $_optionId;

	public function setoptionId( $name ) {
		$this->_optionId = $name ;
	}
	public function getoptionId() {
		return $this->_optionId ;
	}

	public function init() {

		$this->setTitle('Export Users Information');

		$levels = Engine_Api::_()->getDbtable('levels', 'authorization')->getLevelsAssoc();
		$levelMultiOptions = array(0 => 'All Levels');
		foreach ($levels as $key => $value) {
			if ($value != 'Public') {
				$levelMultiOptions[$key] = $value;
			}
		}

		$getProfileTypes = Engine_Api::_()->getApi('Core', 'siteuserexport')->getProfileTypes();

		$this->addElement('Select', 'level_id', array(
			'label' => 'Member Level',
			'multiOptions' => $levelMultiOptions,
		));

		$this->addElement('Select', 'approved', array(
			'label' => 'Approval Status',
			'multiOptions' => array(
				'-1' => 'All',
				'0' => 'Not Approved',
				'1' => 'Approved',
			),
			'value' => -1,
		));

		$this->addElement('Select', 'enabled', array(
			'label' => 'Enable Status',
			'multiOptions' => array(
				'-1' => 'All',
				'0' => 'Disabled',
				'1' => 'Enabled',
			),
			'value' => -1,
		));

		// --------------------------------------------------

		$start = new Engine_Form_Element_CalendarDateTime('start_time');
		$start->setLabel("Signed Up From");
		$start->setAttrib('loadedbyAjax', 'TRUE');
		$start->setAllowEmpty(true);
		$start->setRequired(false);

		$this->addElement($start);

		// End time
		$end = new Engine_Form_Element_CalendarDateTime('end_time');
		$translate = Zend_Registry::get('Zend_Translate');
		$to = $translate->translate("Signed Up To");

		$end->setLabel($to);
		$end->setAttrib('loadedbyAjax', 'TRUE');
		$end->setAllowEmpty(true);
		$end->setRequired(false);

		$this->addElement($end);

		$this->addElement('Select', 'option_id', array(
			'label' => 'Profile Type',
			'onchange' => 'showTemplate();',
			'multiOptions' => $getProfileTypes,
		));

		$templates = Engine_Api::_()->getDbtable('templates', 'siteuserexport')->getTemplates( $this->_optionId );

		$this->addElement('Dummy', 'plaintext', array(
			'label' => 'Select Template',
			'description' => 'There is no template created for the selected Profile Type.',
			'ignore' => true,

		));

		$this->plaintext
			->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::APPEND, 'escape' => false));

		$this->addElement('Select', 'template_id', array(
			'label' => 'Select Template',
			'multiOptions' => $templates,
		));

		$this->addElement('Select', 'file_formate', array(
			'label' => 'File Format',
			'multiOptions' => array('csv' => 'CSV', 'excel' => 'Excel', 'json' => 'JSON'),
			'value' => 'csv',
		));

		$this->addElement('Text', 'file_name', array(
			'label' => 'File Name',
			'maxlength' => 30,
			'value' => 'User_Report',
			'description' => 'Enter the name for the file being exported. [If left blank, default name will be given to the exported file.]',
		));

		$this->file_name
			->addDecorator('Description', array('placement' => Zend_Form_Decorator_Abstract::APPEND, 'escape' => false));

		$this->addElement('button', 'download', array(
			'label' => 'Download',
			'type' => 'submit',
		));

	}
}