<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserexport
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2011-11-15 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserexport_AdminSettingsController extends Core_Controller_Action_Admin {

	public function manageTemplatesAction() {

		$settings = Engine_Api::_()->getApi('settings', 'core');
		$viewer = Engine_Api::_()->user()->getViewer();
		$userId = $viewer->getIdentity();

		$this->view->profileType = $getProfileTypes = Engine_Api::_()->getApi('Core', 'siteuserexport')->getProfileTypes();

		//TABS CREATION
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
			->getNavigation('siteuserexport_admin_main', array(), 'siteuserexport_admin_main_managetemplates');

		$templates = Engine_Api::_()->getDbtable('templates', 'siteuserexport')->getTemplates(0, 'all');

		if ($this->_getParam('option_id')) {
			$this->view->option_id = $option_id = $this->_getParam('option_id');
		}

		$template_id = 0;
		if ($this->_getParam('template_id')) {
			$this->view->template_id = $template_id = $this->_getParam('template_id');
		} else {
			foreach ($templates as $key => $value) {
				$template_id = $key;
				break;
			}
			if (!empty($template_id)) {
				$this->view->template_id = $template_id;
			}

		}

		$templateFields = Engine_Api::_()->getDbtable('templates', 'siteuserexport')->getTemplatefields($template_id);

		$option_id = $templateFields['option_id'];
		unset($templateFields['option_id']);

		$this->view->decodedFields = $templateFields;

		$userExportApi = Engine_Api::_()->getApi('Core', 'siteuserexport');
		$fields = $userExportApi->getFields($option_id);
		$this->view->fields = $fields;

		$this->view->templates = $templates;

		$form = new Siteuserexport_Form_Admin_Manage_Managetemplates(array('templateId' => $template_id, 'optionId' => $option_id));

		if ($form->getElement('template_id')) {
			$form->getElement('template_id')->setValue($template_id);
		}

		$this->view->form = $form;

		if ($this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) && $this->getRequest()->getPost()) {

			$values = $form->getValues();

			$fieldArray = array();
			foreach ($fields as $key => $value) {
				$id = 'fields_' . $key;
				$valueId = 'edited_' . $key;

				if ($values[$id] == 1) {
					$fieldArray[$key] = $values[$valueId];
				}
			}

			if (empty($fieldArray)) {
				$form->addError('Please select atleast one information field to be displayed in the report generated using this template.');
				return;
			}

			// save fields

			$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');
			$fieldsEncoded = Zend_Json::encode($fieldArray);

			$templateTable->update(array('fields' => $fieldsEncoded), array('template_id = ?' => $values['template_id']));

			return $this->_helper->redirector->gotoRoute(array('action' => 'manage-templates', 'controller' => 'settings', 'module' => 'siteuserexport', 'template_id' => $template_id, 'saved' => 1), "admin_default", true);
		}

		if ($this->_getParam('saved')) {
			$form->addNotice('Your changes have been saved.');
		}

	}

	public function exportUserAction() // export user
	{

		//TABS CREATION
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
			->getNavigation('siteuserexport_admin_main', array(), 'siteuserexport_admin_main_exportuser');

		$option_id = $this->_getParam( 'option_id', null );
		$formFilter = new Siteuserexport_Form_Admin_Manage_Exportuser( array( 'optionId' => $option_id ) );

		$this->view->formFilter = $formFilter;
		$viewer = Engine_Api::_()->user()->getViewer();

		$page = $this->_getParam('page', 1);

		if (!$this->getRequest()->isPost()) {
			return;
		}

		$postedValue = $this->getRequest()->getPost();

		if (!empty($postedValue['start_time']['date'])) {
			$postedValue['start_time']['hour'] = 1;
			$postedValue['start_time']['minute'] = 0;
			$postedValue['start_time']['ampm'] = 'AM';
		}

		if (!empty($postedValue['end_time']['date'])) {
			$postedValue['end_time']['hour'] = 1;
			$postedValue['end_time']['minute'] = 0;
			$postedValue['end_time']['ampm'] = 'AM';
		}

		if (!$formFilter->isValid($postedValue)) {
			return;
		}

		$values = $formFilter->getValues();

		if (empty($values['template_id'])) {
			$formFilter->addError('Please select Template!');
			return;
		}

		$params = $values;

		// setting data according to database format.
		if ((substr($params['start_time'], 0, 10) != "0000-00-00") && (substr($params['end_time'], 0, 10) != "0000-00-00")) {

			$startDate = $params['start_time'];
			$endDate = $params['end_time'];

			$oldTz = date_default_timezone_get();
			date_default_timezone_set($viewer->timezone);
			$start_date_timestamp = strtotime($startDate);
			$end_date_timestamp = strtotime($endDate);

			date_default_timezone_set($oldTz);
			$params['end_time'] = date('Y-m-d', $end_date_timestamp);
			$params['start_time'] = date('Y-m-d', $start_date_timestamp);

			if ($start_date_timestamp > $end_date_timestamp) {
				return $formFilter->addError('Please select valid Date range.');
			}
		} else {
			if (substr($params['start_time'], 0, 10) == "0000-00-00") {
				unset($params['start_time']);
			}

			if (substr($params['end_time'], 0, 10) == "0000-00-00") {
				unset($params['end_time']);
			}
		}

		$userExportApi = Engine_Api::_()->getApi('Core', 'siteuserexport');
		$userData = $userExportApi->getUserData($params);

		if (empty($userData)) {
			return $formFilter->addNotice('There is no user registered under this filter criteria.');
		}

		if ($params['enabled'] == -1) {
			unset($params['enabled']);
		}

		if ($params['approved'] == -1) {
			unset($params['approved']);
		}

		if (!empty($params['start_time'])) {
			$sDate = $params['start_time'];
			$params['start_time'] = strtotime($sDate);
		}

		if (!empty($params['end_time'])) {
			$eDate = $params['end_time'];
			$params['end_time'] = strtotime($eDate);
		}

		$this->view->filterParams = $params;

		$paramString = Zend_Json::encode($params);

		return $this->_helper->redirector->gotoRoute(array('module' => 'siteuserexport', 'controller' => 'settings', 'action' => 'get-file', 'params' => $paramString), "admin_default", true);

	}

	public function faqAction() {
		$this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
			->getNavigation('siteuserexport_admin_main', array(), 'siteuserexport_admin_main_faq');
	}

	public function getFileAction() {

		$params = $this->_getParam('params');
		$filterParams = Zend_Json::decode($params);

		if (!empty($filterParams['start_time'])) {
			$filterParams['start_time'] = date('Y-m-d', $filterParams['start_time']);
		}

		if (!empty($filterParams['end_time'])) {
			$filterParams['end_time'] = date('Y-m-d', $filterParams['end_time']);
		}

		$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');
		$templateData = $templateTable->getTemplateFields($filterParams['template_id']);

		$filterParams['option_id'] = $templateData['option_id'];
		unset($templateData['option_id']);
		$filterParams['fields'] = $fields = $templateData;

		$userExportApi = Engine_Api::_()->getApi('Core', 'siteuserexport');
		$data = $userExportApi->getFieldsValue($filterParams);

		$this->view->fields = $fields;
		$this->view->values = $data;
		$csvTpl = 'csvFile';
		$excelTpl = 'excelFile';
		$jsonTpl = 'jsonFile';

		$fileType = $filterParams['file_formate'];

		if ($fileType == 'csv') {

			$header = $fields;
			$fieldValuesArray = $data;

			$csvHeader = '';
			foreach ($header as $headerElement) {
				$csvHeader .= '"' . $headerElement . '",';
			}
			$csvHeader .= "\n";

			$csvRow = '';

			foreach ($fieldValuesArray as $fieldValues) {
				if(empty($header['u1'])) {
			        unset($fieldValues['user_id']);
			    }
				foreach ($fieldValues as $value) {
					$csvRow .= '"' . $value . '",';
				}
				$csvRow .= "\n";
			}

			$this->view->header = $csvHeader;
			$this->view->row = $csvRow;

			if (!empty($filterParams['file_name'])) {
				$this->view->fileName = $filterParams['file_name'] . ".csv";
			} else {
				$this->view->fileName = "User_Report.csv";
			}

			return $this->render($csvTpl);

		} elseif ($fileType == 'excel') {
			if (!empty($filterParams['file_name'])) {
				$this->view->fileName = $filterParams['file_name'] . ".xls";
			} else {
				$this->view->fileName = "User_Report.xls";
			}
			return $this->render($excelTpl);
		} else {
			if (!empty($filterParams['file_name'])) {
				$this->view->fileName = $filterParams['file_name'] . ".json";
			} else {
				$this->view->fileName = "User_Report.json";
			}
			return $this->render($jsonTpl);
		}
	}

	public function addTemplateAction() {

		$this->_helper->layout->setLayout('admin-simple');

		$viewer = Engine_Api::_()->user()->getViewer();

		$this->view->form = $form = new Siteuserexport_Form_Admin_Manage_Addtemplates();
		// Check post
		if ($this->getRequest()->isPost()) {
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();

			$templateParams = $this->_getAllParams();

			$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');
			if (!empty($templateParams['duplicate'])) {
				$templatefields = $templateTable->select()
					->from($templateTable->info('name'), array('fields'))
					->where('template_id = ?', $templateParams['duplicate'])
					->query()
					->fetchAll(Zend_Db::FETCH_COLUMN);

				$fields = json_decode($templatefields[0]);

			} else {
				$userExportApi = Engine_Api::_()->getApi('Core', 'siteuserexport');
				$fields = $userExportApi->getFields($templateParams['option_id']);
			}

			try
			{

				$templates = $templateTable->getTemplates();

				if (in_array($templateParams['label'], $templates)) {
					return $form->addNotice('Please select different label, template is already exist with this label.');
				}
				// create new template in the database

				$row = $templateTable->createRow();
				$row->template_lable = $templateParams['label'];
				$row->option_id = $templateParams['option_id'];
				$row->fields = json_encode($fields);
				$row->creation_date = date("Y-m-d H:i:s");
				$row->save();
				$db->commit();

			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}

			return $this->_forward('success', 'utility', 'core', array(
				'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage-templates', 'controller' => 'settings', 'module' => 'siteuserexport'), 'admin_default', true),
				'messages' => array('Template has been added successfully.'),
			));
		}

		$this->renderScript('admin-settings/add-template.tpl');

	}

	public function renameTemplateAction() {
		$this->_helper->layout->setLayout('admin-simple');
		$template_id = $this->_getParam('template_id');
		$this->view->template_id = $template_id;

		$viewer = Engine_Api::_()->user()->getViewer();
		$userId = $viewer->getIdentity();

		$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');
		$templateLable = $templateTable->select()
			->from($templateTable->info('name'), array('template_lable'))
			->where('template_id = ?', $template_id)
			->query()
			->fetchAll(Zend_Db::FETCH_COLUMN);

		$form = new Siteuserexport_Form_Admin_Manage_Renametemplate();
		$form->getElement('label')->setValue($templateLable[0]);

		$this->view->form = $form;

		// Check post
		if ($this->getRequest()->isPost()) {
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();

			$params = $this->_getAllParams();

			try
			{
				$templates = $templateTable->getTemplates();

				if (in_array($params['label'], $templates)) {
					return $form->addNotice('Please select different label, template is already exist with this label.');
				}

				$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');

				$templateTable->update(array('template_lable' => $params['label']), array('template_id =?' => $params['template_id']));

				$db->commit();
			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}

			return $this->_forward('success', 'utility', 'core', array(
				'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage-templates', 'controller' => 'settings', 'module' => 'siteuserexport'), 'admin_default', true),
				'messages' => array('Template has been renamed successfully.'),
			));
		}

		$this->renderScript('admin-settings/rename-template.tpl');

	}

	public function deleteTemplateAction() {
		$this->_helper->layout->setLayout('admin-simple');
		$template_id = $this->_getParam('template_id');
		$this->view->template_id = $template_id;
		// Check post
		if ($this->getRequest()->isPost()) {
			$db = Engine_Db_Table::getDefaultAdapter();
			$db->beginTransaction();

			try
			{
				$templateTable = Engine_Api::_()->getDbtable('templates', 'siteuserexport');
				$db->delete($templateTable->info('name'), array(
					'template_id = ?' => $template_id,
				));

				$db->commit();
			} catch (Exception $e) {
				$db->rollBack();
				throw $e;
			}

			return $this->_forward('success', 'utility', 'core', array(
				'parentRedirect' => Zend_Controller_Front::getInstance()->getRouter()->assemble(array('action' => 'manage-templates', 'controller' => 'settings', 'module' => 'siteuserexport'), 'admin_default', true),
				'messages' => array('Template has been deleted successfully.'),
			));
		}

		// Output
		$this->renderScript('admin-settings/delete-template.tpl');

	}

	public function getTemplatesAction() {
		$option_id = $this->_getParam('option_id');

		$templates = Engine_Api::_()->getDbtable('templates', 'siteuserexport')->getTemplates($option_id);

		$this->view->templates = Zend_Json::encode($templates);

		$this->_helper->viewRenderer->setNoRender(true);
		$this->_helper->layout->disableLayout();

	}
}
?>