<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserexport
 * @copyright  Copyright 2017-2018 BigStep Technologies Pvt. Ltd.
 * @license http://www.socialengineaddons.com/license/
 * @version $Id: install.php 2010-10-25 9:40:21Z SocialEngineAddOns $
 * @author  SocialEngineAddOns
 */

class Siteuserexport_Installer extends Engine_Package_Installer_Module {

	function onInstall() {

		//GET DB
		$db = $this->getDb();

		parent::onInstall();

		$select = new Zend_Db_Select($db);

		// get profile type;

		$tableOption = "engine4_user_fields_options";
		$select = $db->select()
			->from($tableOption, array('option_id'))
			->where("$tableOption.field_id = ?", 1);

		$data = $db->fetchAll($select);

		$profileTypes = array();
		foreach ($data as $value) {
			$profileTypes[] = $value['option_id'];
		}

		$profile_fields = array();
		foreach ($profileTypes as $option_id) {

			$tableMaps = "engine4_user_fields_maps";
			$select = $db->select()
				->from($tableMaps, array('child_id'))
				->where("$tableMaps.option_id = ?", $option_id)
				->where("$tableMaps.field_id = ?", 1);

			$data = $db->fetchAll($select);

			$fields = array();
			foreach ($data as $value) {
				$fields[] = $value['child_id'];
			}

			$tableName = "engine4_user_fields_meta";
			$select = $db->select()
				->from($tableName, array('field_id', 'label'))
				->where("$tableName.type != ?", 'heading')
				->where("$tableName.display = ?", 1)
				->where("$tableName.field_id IN (?)", $fields);

			$data = $db->fetchAll($select);

			$profileFields = array();
			foreach ($data as $value) {
				$profileFields[$value['field_id']] = $value['label'];
			}
			$profile_fields[$option_id] = $profileFields;
		}
		$count = 1;
		$date = "'" . date("Y-m-d H:i:s") . "'";
		foreach ($profile_fields as $option_id => $fields) {
			$userTableFields = array('u1' => 'user_id', 'u2' => 'email', 'u3' => 'username', 'u4' => 'displayname', 'u5' => 'status', 'u6' => 'language', 'u7' => 'timezone', 'u8' => 'level_id', 'u9' => 'enabled', 'u10' => 'verified', 'u11' => 'approved', 'u12' => 'creation_date', 'u13' => 'modified_date', 'u14' => 'lastlogin_date');
			$value = '';
			foreach ($fields as $key => $field) {
				$userTableFields[$key] = $field;
			}
			$value = "'" . Zend_Json::encode($userTableFields) . "'";
			$templateName = "'" . 'Default Template_' . $count . "'";

			$db->query("INSERT IGNORE INTO `engine4_siteuserexport_templates`(`template_id`, `option_id`,`template_lable`, `fields`, `creation_date`) VALUES ($count, $option_id, $templateName, $value, $date)");
			$count++;
		}
	}
}

?>
