<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitereview
 * @copyright  Copyright 2012-2013 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Language.php 6590 2013-04-01 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserimport_Api_Language extends Core_Api_Abstract {

  protected $_languagePath;
  protected $_defaultLanguagePath;
//   protected $_defalutFileName = 'sitereview_listingtype_genral.csv';
  protected $_fileNamePre = "siteuserimport_";
  protected $_hasUnlinkFlag = true;

  public function __construct() {
    $this->_languagePath = APPLICATION_PATH . '/application/languages';
    $this->_defaultLanguagePath = APPLICATION_PATH . '/application/modules/Siteuserimport/settings/languages';
  }

//   public function getDataWithoutKeyPhase() {
//     return array('text_overview' => 'Overview', 'text_Where_to_Buy' => 'Where to Buy', 'text_tags' => 'Tags', 'text_listings' => 'Listings', 'text_listing' => 'Listing', 'text_posted' => 'Posted', 'text_post' => 'Post', 'text_stores' => 'Stores', 'text_store' => 'Store');
//   }

  public function hasDirectoryPermissions() {
    $flage = false;
    $test = new Engine_Sanity(array(
                'basePath' => APPLICATION_PATH,
                'tests' => array(
                    array(
                        'type' => 'FilePermission',
                        'name' => 'Language Directory Permissions',
                        'path' => 'application/languages',
                        'value' => 7,
                        'recursive' => true,
                        'messages' => array(
                            'insufficientPermissions' => 'Language file for this listing type could not be overwritten. because you do not have write permission chmod -R 777 recursively to the directory "/application/languages/". Please login in over your Cpanel or FTP and give the recursively write permission to this directory and try again.',
                        ),
                    ),
                ),
            ));
    $test->run();
    foreach ($test->getTests() as $stest) {
      $errorLevel = $stest->getMaxErrorLevel();
      if (empty($errorLevel))
        $flage = true;
    }
    return $flage;
  }

}