
<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Create.php 10168 2014-04-17 16:29:36Z andres $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteuserimport_Form_Admin_AddDataBulkForm extends Engine_Form
{
	protected $_profileType ;

	public function setProfileType($params) 
	{  
	  $this->_profileType = $params;
	}

	public function init()
	{
		$this->setTitle('Add Dummy Users')
         	 ->setDescription("Below, you can add dummy members on your site. These dummy members will get created with all the required fields like Name, Birthday, Email Address, Gender, Password, Timezone, Profile Photo etc. You can also select the Domain Name which you want to show at the end of the email address of the dummy members.[Note: Default profile type for these dummy users will be ‘Regular Member’.]")
             ->setAttrib('id', 'add_dummy_user');
		// Add a radio bution to number of male here

	    // Element: profile_type
	    $tabindex = 1;  

        $this->addElement('text','loader',array(
			        'order'=>$tabindex,
			        'tabIndex'=>$tabindex++,
			        'required' => false,
			        'decorators' => array(
			            	array(
			                	'HtmlTag', array(
			                    'tag'  => 'div',
			                    'class' => 'loader',
			                    'style' => 'display:none',
			                	)
			            	)
			        	)
			    	)
				);        
        
        $this->addElement('text','status',array(
					        'order'=>$tabindex,
					        'tabIndex'=>$tabindex++,
					        'decorators' => array(
					            	array(
					                	'HtmlTag', array(
					                    'tag'  => 'div',
					                    'class' => 'status',
					                	)
					            	)
					        	)
					    	)
						);
	    
	    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
	    if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ){
	      	
	      	$profileTypeField = $topStructure[0]->getChild();
	      	$options = $profileTypeField->getOptions();
	    	
	      	$this->addElement('Hidden', 'downloadCustom', array(
				'decorators' => array(array('ViewScript', array(
				'viewScript' => '_downloadCustomDummyData.tpl',
								))),
				'order'=>$tabindex++,
	       ));
	      
	      if( count($options) > 1 ) {
	        $options = $profileTypeField->getElementParams('user');
	       
	        unset($options[ 'options' ][ 'order' ]);
	        unset($options[ 'options' ][ 'multiOptions' ][ '0' ]);
	        $this->addElement('Select', 'profile_type', array_merge($options[ 'options' ], array(
	              'required'  => true,
	              'allowEmpty'  => false,
	              'order'=>$tabindex,
	              'tabindex'  => $tabindex++,
	              'value' => $this->_profileType,
	              'onchange' =>'changeProfile(this.value)',
	              'description' => 'Select Profile Type' ,
	           )));
	        $this->profile_type->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	        $selectElement = $this->getElement('profile_type');
	        $selectElement->removeMultiOption('');  

	      } else if( count($options) ==  1 ) {
	        $this->addElement('Hidden', 'profile_type', array(
	          	
	          	'value' => $options[0]->option_id,
              	'order' => $tabindex,
            	'tabindex'  => $tabindex++,
	       	));
	      }
	    }



	    // Check if payment method is set or not for signin.
	    $getPayMentPlugin = Engine_Api::_()->getDbtable('signup', 'user');
	    $sqlquery = $getPayMentPlugin->select()
	         ->from($getPayMentPlugin->info('name'))
	         ->where( 'class like ?', 'Payment_Plugin_Signup_Subscription');

        $getPayMentPluginRow = $getPayMentPlugin->fetchRow($sqlquery);	    
        // if ( $getPayMentPluginRow->enable == 1 ) {  //we will show the plans even if subscription is disabled from signup process, commented at the time of certification
		    // Get available subscriptions
		    $packagesTable = Engine_Api::_()->getDbtable('packages', 'payment');
		    $packagesSelect = $packagesTable
		      ->select()
		      ->from($packagesTable)
		      ->where('enabled = ?', true)
		      //->where('price = ?', 0.0)
		      ;

		    $multiOptionsPayment = array();
		    $getFreePackage = $packagesTable->fetchAll($packagesSelect);
		    if( count( $getFreePackage ) >0 ) {
		    	$setDefaultPayment = $getFreePackage[0]->package_id;
			    foreach( $getFreePackage as $package ) {
			      $multiOptionsPayment[$package->package_id] = $package->title
			        . ' (' . $package->getPackageDescription() . ')'
			        ;
			    }
		      $this->addElement('Radio', 'package_id', array(
		        'label' => 'Choose Plan:',
		        'order'=>$tabindex,
		        'value' => $setDefaultPayment,
		        'tabIndex'=>$tabindex++,		        
		        'required' => true,
		        'allowEmpty' => false,
		        'description' => 'Please select a subscription plan from the list below. We suggest you select a free plan to add new members, so that those members are never disabled.',
		        'multiOptions' => $multiOptionsPayment,
		      ));
		      $this->package_id->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
		    }

        // }


	    $addCheckBox = $this->addElement('radio', 'type_of_insertion',array(
		   	'label'  => 'Number of Members to Add',
		   	'required'  =>true,
		   	'value' => 1,
		   	'description' => 'Select the number of dummy members you want to add on your website.',
		   	'multiOptions'  => array(
		   		'1' => 'Add 50 male users',
		   		'2' => 'Add 50 female users',
		   		'3' => 'Add 100 male and female users',
 		   	),
		   	'tabindex'  =>$tabindex,
		   	'order' => $tabindex++, 
		));
	    $this->type_of_insertion->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	    $this->type_of_insertion->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	    // Element: passconf
	    $this->addElement('Text', 'domainName', array(
	        'label'  => 'Domain Name',
	        'description'  => "Enter the domain name which you want to show with the email id’s of the dummy members. Domain Name will be added at the end of an email id, for example, email id of a member is ‘abcd’ and domain name is ‘mydomain.com’ then complete email address will be ‘abcd@mydomain.com’.",
	        'required'  => true,
	        'value' => $_SERVER['HTTP_HOST'],
	        'allowEmpty'  => false,
	          'order'  =>$tabindex,
	        'validators'  => array(
	          array('NotEmpty', true),
	       ),
	        'tabindex'  => $tabindex++,
	    ));

       //dc(get_class_methods(Zend_Form_Decorator));
	    $elementDecorators = array(
                                array('Description', array( 'tag' => 'h3', 'placement' => 'append','class'=>'eDesc')),                                
                                array('HtmlTag', array( 'tag' => 'div', 'class'=>'heading'))
		);

        $this->addElement('text','heading',array(
					        'order'=>$tabindex,
					        'tabIndex'=>$tabindex++,
					        'decorators' => $elementDecorators,
					    	)
						);
        $this->heading->setDescription('Please select the type of dummy data you want to map with this field.');

	    $this->domainName->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	    $profileId = $this->_profileType;
	    $formElementLabel = $this->getDynamicElement($profileId);

	    $fname = APPLICATION_PATH ."/public/siteuserimport".DIRECTORY_SEPARATOR ."default_user". DIRECTORY_SEPARATOR ."default_user_csv_file.csv";
	    @chmod($fname, 0777);
	    $fp = fopen($fname, "r");    
	    if ((!$fp)) {
	      echo "$fname File opening error";
	      exit;
	    }

	    $index = 0;
	    while ($buffer = fgets($fp, 5000)) {
	      $explode_array[ $index++ ] = explode('|', $buffer);
	      if( $index > 0) {
	      	break ;
	      }
	    }
	    $index = 0;
	    // Get array key for corrosponding Dynamic field as well as get name of that field.
	    $csvFileKeyWithValue['selectLabel'] = 'Select';
	    foreach ($explode_array[0] as $csvHeadingKey => $csvHeadingValue ) {

	    	if( strpos($csvHeadingValue, "Profile Address") !== false || strpos($csvHeadingValue, "Show Varified Icon On Member Profile") !== false || strpos($csvHeadingValue, "User Cover Photo") !== false || strpos($csvHeadingValue, "Select Member Level") !== false || strpos($csvHeadingValue, "Verification") !== false || strpos($csvHeadingValue, "User Profile Photo") !== false || strpos($csvHeadingValue, "Password") !== false || strpos($csvHeadingValue, "Email Address") !== false || strpos($csvHeadingValue, "Password Again") !== false || strpos($csvHeadingValue, "Password") !== false || strpos($csvHeadingValue, "Timezone") !== false ) {
	    		continue;
	    	}
	    	$csvFileKeyWithValue[ $csvHeadingKey ] = $csvHeadingValue;
	    	$index++;
	    }

	  	$index = 0;
	    // Get First row data from csv file.
	    foreach ( $csvFileKeyWithValue as $key => $value) {
	    	$csvFileKeyWithValue[ $key ] = trim(explode( ':', $value)[0]);
	    }
	    
	    foreach ( $formElementLabel as $key => $value) {
	    	if( !preg_match('/^1_[0-9]+_[0-9]+$/', $key ) ) {
			   
	    		$this->addElement('Select', $key, array(
							'decorators' => array(array('ViewScript', array(
								'viewScript' => '_dynamicNoOptionElement.tpl',
								'key' => $key,
								'label'=>$value,
								'tabIndex' => $tabindex,
								))),
							'order'=>$tabindex++,
	       		));	
			    continue;
	    	}
		    
		    $this->addElement('Select', $key, array(
		        'label'  => $value,
		        'value' => 'selectLabel',
		        'multiOptions' => $csvFileKeyWithValue,
		        'order'  => $tabindex,
		        'tabindex'  => $tabindex++,
		        
		       )
		    );
		    $dynamicElement = $this->$key;
		    $dynamicElement->getDecorator('Description')->setOptions(array("placement"=>"APPEND"));
	    }


	    // Element: language
	    // Languages
	    $translate = Zend_Registry::get('Zend_Translate');
	    $languageList = $translate->getList();
	    // Prepare default langauge
	    $defaultLanguage = Engine_Api::_()->getApi('settings', 'core')->getSetting('core.locale.locale', 'en');
	    if( !in_array($defaultLanguage, $languageList) ) {
	      if( $defaultLanguage ==  'auto' && isset($languageList[ 'en' ]) ) {
	        $defaultLanguage = 'en';
	      } else {
	        $defaultLanguage = null;
	      }
	    }

	    // Prepare language name list
	    $localeObject = Zend_Registry::get('Locale');
	    $languageNameList = array();
	    $languageDataList = Zend_Locale_Data::getList($localeObject, 'language');
	    $territoryDataList = Zend_Locale_Data::getList($localeObject, 'territory');

	    foreach( $languageList as $localeCode ) {
	      $languageNameList[$localeCode] = Zend_Locale::getTranslation($localeCode, 'language', $localeCode);
	      if( empty($languageNameList[$localeCode]) ) {
	        list($locale, $territory) = explode('_', $localeCode);
	        $languageNameList[$localeCode] = "{$territoryDataList[$territory]} {$languageDataList[$locale]}";
	      }
	    }
	    $languageNameList = array_merge(array(
	      $defaultLanguage  => $defaultLanguage
	   ), $languageNameList);

	    if(count($languageNameList)>1){
	      $this->addElement('Select', 'language', array(
	        'label'  => 'Language',
	          'order'  => $tabindex,
	        'multiOptions'  => $languageNameList,
	        'Description'  => 'Select language',
	        'tabindex'  => $tabindex++,
	     ));
	      $this->language->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));
	    }

	    $settings = Engine_Api::_()->getApi('settings', 'core');
	    $this->addElement('Select', 'timezone', array(
	      'label'  => 'Timezone',
	      'value'  => $settings->getSetting('core.locale.timezone'),
	      'multiOptions'  => array(
	        'US/Pacific'  => '(UTC-8) Pacific Time (US & Canada)',
	        'US/Mountain'  => '(UTC-7) Mountain Time (US & Canada)',
	        'US/Central'  => '(UTC-6) Central Time (US & Canada)',
	        'US/Eastern'  => '(UTC-5) Eastern Time (US & Canada)',
	        'America/Halifax'  => '(UTC-4)  Atlantic Time (Canada)',
	        'America/Anchorage'  => '(UTC-9)  Alaska (US & Canada)',
	        'Pacific/Honolulu'  => '(UTC-10) Hawaii (US)',
	        'Pacific/Samoa'  => '(UTC-11) Midway Island, Samoa',
	        'Etc/GMT-12'  => '(UTC-12) Eniwetok, Kwajalein',
	        'Canada/Newfoundland'  => '(UTC-3:30) Canada/Newfoundland',
	        'America/Buenos_Aires'  => '(UTC-3) Brasilia, Buenos Aires, Georgetown',
	        'Atlantic/South_Georgia'  => '(UTC-2) Mid-Atlantic',
	        'Atlantic/Azores'  => '(UTC-1) Azores, Cape Verde Is.',
	        'Europe/London'  => 'Greenwich Mean Time (Lisbon, London)',
	        'Europe/Berlin'  => '(UTC+1) Amsterdam, Berlin, Paris, Rome, Madrid',
	        'Europe/Athens'  => '(UTC+2) Athens, Helsinki, Istanbul, Cairo, E. Europe',
	        'Europe/Moscow'  => '(UTC+3) Baghdad, Kuwait, Nairobi, Moscow',
	        'Iran'  => '(UTC+3:30) Tehran',
	        'Asia/Dubai'  => '(UTC+4) Abu Dhabi, Kazan, Muscat',
	        'Asia/Kabul'  => '(UTC+4:30) Kabul',
	        'Asia/Yekaterinburg'  => '(UTC+5) Islamabad, Karachi, Tashkent',
	        'Asia/Calcutta'  => '(UTC+5:30) Bombay, Calcutta, New Delhi',
	        'Asia/Katmandu'  => '(UTC+5:45) Nepal',
	        'Asia/Omsk'  => '(UTC+6) Almaty, Dhaka',
	        'Indian/Cocos'  => '(UTC+6:30) Cocos Islands, Yangon',
	        'Asia/Krasnoyarsk'  => '(UTC+7) Bangkok, Jakarta, Hanoi',
	        'Asia/Hong_Kong'  => '(UTC+8) Beijing, Hong Kong, Singapore, Taipei',
	        'Asia/Tokyo'  => '(UTC+9) Tokyo, Osaka, Sapporto, Seoul, Yakutsk',
	        'Australia/Adelaide'  => '(UTC+9:30) Adelaide, Darwin',
	        'Australia/Sydney'  => '(UTC+10) Brisbane, Melbourne, Sydney, Guam',
	        'Asia/Magadan'  => '(UTC+11) Magadan, Solomon Is., New Caledonia',
	        'Pacific/Auckland'  => '(UTC+12) Fiji, Kamchatka, Marshall Is., Wellington',
	     ),
	      'Description'  => 'Select timezone',
	      'tabindex'  => $tabindex,
	      'order'  => $tabindex++,
	   ));
	    $this->timezone->getDecorator('Description')->setOption('placement', 'append');
	    $this->domainName->getDecorator('Description')->setOptions(array('placement'  => 'APPEND'));

	    //Element member level
	    $tableMember = Engine_Api::_()->getDbtable('levels', 'authorization');
		    // $db1 = $tableMember->getAdapter();
		    $sqlquery = $tableMember->select()
		         ->from($tableMember->info('name'))
		         ->where('type != ?', 'public');
	        $userIdIs =  $tableMember->fetchAll($sqlquery);
	        $memberLevels = array();
	        // get default member level useing default level.

	        foreach( $userIdIs as $key  => $values)
	        {
	        	$profilekey = $values[ 'level_id' ];
	        	$memberLevels[$profilekey] = $values[ 'title' ];
	        	if( $values[ 'flag'] == 'default') {
	        		$defaultMemberLevel = $profilekey ;
	        	}
	        }
	    $memberLevel = $this->addElement('Select', 'member_level',array(
							   	'label'  => 'Select Member Level',
							   	'value' => $defaultMemberLevel,
							   	'multiOptions'  => $memberLevels,
							   	'Description'  => 'Enter level of member for which you want to create account.',
							   	'required'  =>true,
							   	'tabindex'  =>$tabindex,
							   	'order'  => $tabindex++,
	   	)); 
	 	$this->member_level->getDecorator('Description')->setOption('placement', 'append');


	    $this->addElement('Button', 'submitButton', array(
      		'label'  => 'Create Members',
      		'type'  => 'button',
      		'onClick' => 'manageSubmit()',
      		'tabindex' => $tabindex,
      		'order'  => $tabindex++,
   		));

	}

	public function getDynamicElement( $profileId )
	{
		//Get all dynamic fields name
		$levelId = 1;
		$form = new Siteuserimport_Form_Admin_Addnewuserinformation( 
		                                array(   
		                                        'profileType' => $profileId,
		                                        'memberLevel'=> $levelId,
		                                )
		                              );		
		
		$formElementKey = array();
		$formElementLabel = array();
		foreach( $form->getElements() as $key => $getElementLabel ) {

			if( $getElementLabel->helper != "formHeading" && preg_match('/^[0-9]+_[0-9]+_[0-9]+$/', $key )  ) {
				$formElementLabel[ $key ] = $getElementLabel->getLabel();
			}
		}
		
		return $formElementLabel ;
	}

}