
<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Create.php 10168 2014-04-17 16:29:36Z andres $
 * @author     Jung
 */

/**
 * @category   Application_Extensions
 * @package    Siteuserimport
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteuserimport_Form_Admin_CreateCsvFile extends Engine_Form
{
	
	public function init()
	{
	    $tabIndex = 1;
	    $settings = Engine_Api::_()->getApi('settings', 'core');
	    // Init form
	    $this->setTitle('Download Example CSV Template File')
	    	->setDescription("From here, you can download the CSV template file with respect to the profile type available on your website.");
	    $this->setAttrib('id', 'create_file');
	
	    // Element: profile_type
	    $topStructure = Engine_Api::_()->fields()->getFieldStructureTop('user');
	    if( count($topStructure) ==  1 && $topStructure[0]->getChild()->type ==  'profile_type' ) {
	      $profileTypeField = $topStructure[0]->getChild();
	      $options = $profileTypeField->getOptions();
	      

	      if( count($options) > 1 ) {
	        $options = $profileTypeField->getElementParams('user');
	       
	        unset($options[ 'options' ][ 'order' ]);
	        unset($options[ 'options' ][ 'multiOptions' ][ '0' ]);
	        $this->addElement('Select', 'profile_type', array_merge($options[ 'options' ], array(
	              'required'  => true,
	              'allowEmpty'  => false,
	              'tabindex'  => 1, 
	              'value' => $this->_profileType,
	           )));
	        $selectElement = $this->getElement('profile_type');
	        $selectElement->removeMultiOption('');  

	      } else if( count($options) ==  1 ) {
	        $this->addElement('Hidden', 'profile_type', array(
	          'value'  => $options[0]->option_id,
	          'order' => 20456,
	       ));
	      }
	    }

    	$this->addElement('Button', 'submitButton', array(
      		'label'  => 'Download',
      		'type'  => 'button',
      		'onclick' => 'manageSubmit()',
      		'tabindex'  =>3,
      		'order'  => 10000,
   		));
	 

	}

	}