<?php
/**
 * SocialEngine
 *
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Users.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Core
 * @package    User
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Siteuserimport_Model_DbTable_Users extends Engine_Db_Table
{
  protected $_name = 'users';

  
  // Set cover photo here for user.
  /**
   *  @param Get Photo
   *  @param Get User 
   * @return Photo Id 
   */
  

  // set a drop down for all static element users.
  public function setSelectDropdown( $selectedOption,$uniqueId,$errorClass, $key,  $options, $name, $checkError = true )
  {

    // For time zone.
    if( $key == 'timezone') {
     return $this->getTimezoneField( $selectedOption,$uniqueId,$errorClass );
    } 

    // other options
    $field = '<select name="'.$name.'" class="data_'.$uniqueId. ' '.$errorClass.'"' .'id= "data_'.$uniqueId. '_'.$name. '">';
    $field.='<option value=" "> Select </option>';
    foreach($options as $key=>$value):
      
      //$selected = trim(strtolower($key)) == trim(strtolower($selectedOption)) ? ' selected="selected" ':'';
      if( $checkError == true ) {
        if( !empty(trim( strtolower( $value ))) && !empty(trim( strtolower( $selectedOption ))) && strpos( trim( strtolower( $value )), trim( strtolower( $selectedOption )) ) !== false ) {
          $selected = ' selected="selected" ' ;
        } else {
          $selected = '';
        }          
      } else {
        $selected = trim(strtolower($key)) == trim(strtolower($selectedOption)) ? ' selected="selected" ':'';
      }

      /*if($selected=='selected'){
      }*/
      $field.='<option value="'.$key.'" '.$selected.'>'.$value.'</option>';
    endforeach;
    $field .= '</select>';
    return $field;

  }

  public function getTimezoneField($selectedOption,$uniqueId,$errorClass){

      /*$errorClass = '';
      if(empty($selectedOption)){
        $errorClass = 'error';
      }*/

      $field = '<select name="timezone" class="data_'.$uniqueId. ' '.$errorClass.'" '. 'id= "data_'.$uniqueId. '_timezone" >';
      foreach($this->getTimezones() as $key=>$value):
        
        $selected = trim(strtolower($key)) == trim(strtolower($selectedOption)) ? ' selected="selected" ':'';
        if($selected=='selected'){
        }
        $field.='<option value="'.$key.'" '.$selected.'>'.$value.'</option>';
      endforeach;
      $field .= '</select>';
      return $field;
  }
  public function getTimezones(){
    
    return  array(
                  ''=>'Select',
                  'US/Pacific' => '(UTC-8) Pacific Time (US & Canada)',
                  'US/Mountain' => '(UTC-7) Mountain Time (US & Canada)',
                  'US/Central' => '(UTC-6) Central Time (US & Canada)',
                  'US/Eastern' => '(UTC-5) Eastern Time (US & Canada)',
                  'America/Halifax' => '(UTC-4) Atlantic Time (Canada)',
                  'America/Anchorage' => '(UTC-9) Alaska (US & Canada)',
                  'Pacific/Honolulu' => '(UTC-10) Hawaii (US)',
                  'Pacific/Samoa' => '(UTC-11) Midway Island, Samoa',
                  'Etc/GMT-12' => '(UTC-12) Eniwetok, Kwajalein',
                  'Canada/Newfoundland' => '(UTC-3:30) Canada/Newfoundland',
                  'America/Buenos_Aires' => '(UTC-3) Brasilia, Buenos Aires, Georgetown',
                  'Atlantic/South_Georgia' => '(UTC-2) Mid-Atlantic',
                  'Atlantic/Azores' => '(UTC-1) Azores, Cape Verde Is.',
                  'Europe/London' => 'Greenwich Mean Time (Lisbon, London)',
                  'Europe/Berlin' => '(UTC+1) Amsterdam, Berlin, Paris, Rome, Madrid',
                  'Europe/Athens' => '(UTC+2) Athens, Helsinki, Istanbul, Cairo, E. Europe',
                  'Europe/Moscow' => '(UTC+3) Baghdad, Kuwait, Nairobi, Moscow',
                  'Iran' => '(UTC+3:30) Tehran',
                  'Asia/Dubai' => '(UTC+4) Abu Dhabi, Kazan, Muscat',
                  'Asia/Kabul' => '(UTC+4:30) Kabul',
                  'Asia/Yekaterinburg' => '(UTC+5) Islamabad, Karachi, Tashkent',
                  'Asia/Dili' => '(UTC+5:30) Bombay, Calcutta, New Delhi',
                  'Asia/Katmandu' => '(UTC+5:45) Nepal',
                  'Asia/Omsk' => '(UTC+6) Almaty, Dhaka',
                  'India/Cocos' => '(UTC+6:30) Cocos Islands, Yangon',
                  'Asia/Krasnoyarsk' => '(UTC+7) Bangkok, Jakarta, Hanoi',
                  'Asia/Hong_Kong' => '(UTC+8) Beijing, Hong Kong, Singapore, Taipei',
                  'Asia/Tokyo' => '(UTC+9) Tokyo, Osaka, Sapporto, Seoul, Yakutsk',
                  'Australia/Adelaide' => '(UTC+9:30) Adelaide, Darwin',
                  'Australia/Sydney' => '(UTC+10) Brisbane, Melbourne, Sydney, Guam',
                  'Asia/Magadan' => '(UTC+11) Magadan, Soloman Is., New Caledonia',
                  'Pacific/Auckland' => '(UTC+12) Fiji, Kamchatka, Marshall Is., Wellington',
            );
  }
  public function setProfilePhoto($type, $photo, $getFileId = null, $userId ){

    if($type == 'importUsers'){
      
      $archiveProfilePhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$getFileId. DIRECTORY_SEPARATOR . "profile_photo/";
      $getSubDirInfo = array();
      if( is_dir($archiveProfilePhoto) ) {
        $getSubDirInfo = scandir($archiveProfilePhoto) ;
      }
      foreach ($getSubDirInfo as $dirKey => $subDir ) {

          if ( $subDir === '.' or $subDir === '..') continue;
          if (is_dir($archiveProfilePhoto . $subDir )) {
              $getProfilePhotoFile = $archiveProfilePhoto  . $subDir  ;
              break ;
          }
      }
      @chmod( $archiveProfilePhoto, 0777);
      // check if photo is present or not   
      if( ! file_exists( $getProfilePhotoFile.'/'.$photo ) ) {
          throw new User_Model_Exception( 'File is not found their');
      }
      $file = $getProfilePhotoFile.'/'.$photo;
      $path = $archiveProfilePhoto ;
    
    }elseif($type == 'dummyUsers'){
      
      $archiveProfilePhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."default_user". DIRECTORY_SEPARATOR . "profile_photo/";     
      @chmod(APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."default_user",0777);
      @chmod($archiveProfilePhoto,0777);
      @chmod($archiveProfilePhoto."profile_photo.zip");
      if(file_exists( $archiveProfilePhoto. DIRECTORY_SEPARATOR ."profile_photo.zip" )) {
         
        $zip = new ZipArchive;
        $res = $zip->open( $archiveProfilePhoto."profile_photo.zip" );
        $zip->extractTo( $archiveProfilePhoto );
        
        $zip->close();
        $getSubDirInfo = array();
        if(is_dir($archiveProfilePhoto)) {
          $getSubDirInfo = scandir($archiveProfilePhoto) ;
        }
        foreach ($getSubDirInfo as $dirKey => $subDir ) {
          if ( $subDir === '.' or $subDir === '..') continue;
          if (is_dir($archiveProfilePhoto . $subDir )) {
              $getProfilePhotoFile = $archiveProfilePhoto  . $subDir  ;
              break ;
          }
        }
        
      @chmod( $getProfilePhotoFile, 0777);
      }   
      if( ! file_exists( $getProfilePhotoFile.'/'.$photo ) ) {
        
          throw new User_Model_Exception( 'File is not found their');
      }
      
      $file = $getProfilePhotoFile.'/'.$photo;
      $path = $archiveProfilePhoto;
    
    }elseif($type == 'singleUserForm'){
      
      if( $photo instanceof Zend_Form_Element_File ) {
        $file = $photo->getFileName( );
        $fileName = $file;
      } else if( $photo instanceof Storage_Model_File ) {
        $file = $photo->temporary( );
        $fileName = $photo->name;
      } else if( $photo instanceof Core_Model_Item_Abstract && !empty( $photo->file_id) ) {
        $tmpRow = Engine_Api::_( )->getItem( 'storage_file', $photo->file_id);
        $file = $tmpRow->temporary( );
        $fileName = $tmpRow->name;
      } else if( is_array( $photo) && !empty( $photo[ 'tmp_name' ]) ) {
        $file = $photo[ 'tmp_name' ];
        $fileName = $photo[ 'name' ];
      } else if( is_string( $photo) && file_exists( $photo) ) {
        $file = $photo;
        $fileName = $photo;
      } else {
        throw new User_Model_Exception( 'invalid argument passed to setProfilePhoto');
      }
      if( !$fileName ) {
        $fileName = $file;
      }

      $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    }

    return $this->savePhoto($file,$path, $userId);
  }

  // save photo and returns photo id
  public function savePhoto($file, $path, $userId) 
  {
        
    // Get photo from given location.
    $name = basename( $file );
    $fileName = $file ;
    $extension = ltrim( strrchr( basename( $file ), '.' ), '.' );
    $base = rtrim( substr( basename( $fileName ), 0, strrpos( basename( $file ), '.' )), '.');
    
    $params = array( 
      'parent_type'  => 'user',
      'parent_id'  => $userId,
      'user_id'  => $userId,
      'name'  => basename( $file ),
    );

    // Save
    $filesTable = Engine_Api::_( )->getDbtable( 'files', 'storage');

    // Resize image ( main)
    $mainPath = $path . DIRECTORY_SEPARATOR . $base . '_m.' . $extension;
    $image = Engine_Image::factory( );
    $image->open( $file)
      ->autoRotate( )
      ->resize( 720, 720)
      ->write( $mainPath)
      ->destroy( );

    // Resize image ( profile)
    $profilePath = $path . DIRECTORY_SEPARATOR . $base . '_p.' . $extension;
    $image = Engine_Image::factory( );
    $image->open( $file )
      ->autoRotate( )
      ->resize( 200, 400)
      ->write( $profilePath)
      ->destroy( );

    // Resize image ( normal)
    $normalPath = $path . DIRECTORY_SEPARATOR . $base . '_in.' . $extension;
    $image = Engine_Image::factory( );
    $image->open( $file )
      ->autoRotate( )
      ->resize( 140, 160 )
      ->write( $normalPath )
      ->destroy( );

    // Resize image ( icon)
    $squarePath = $path . DIRECTORY_SEPARATOR . $base . '_is.' . $extension;
    $image = Engine_Image::factory( );
    $image->open( $file)
      ->autoRotate( );

    $size = min( $image->height, $image->width);
    $x = ( $image->width - $size) / 2;
    $y = ( $image->height - $size) / 2;

    $image->resample( $x, $y, $size, $size, 48, 48)
      ->write( $squarePath)
      ->destroy( );

    // Store
    $iMain = $filesTable->createFile( $mainPath, $params);
    $iProfile = $filesTable->createFile( $profilePath, $params);
    $iIconNormal = $filesTable->createFile( $normalPath, $params);
    $iSquare = $filesTable->createFile( $squarePath, $params);

    $iMain->bridge( $iProfile, 'thumb.profile');
    $iMain->bridge( $iIconNormal, 'thumb.normal');
    $iMain->bridge( $iSquare, 'thumb.icon');
    // Remove temp files
    @unlink( $mainPath);
    @unlink( $profilePath);
    @unlink( $normalPath);
    @unlink( $squarePath);


    $photoid = $iMain->toArray( );
   
    return $photoid[ 'file_id' ];

  }

  
  // Saving cover photo for a user profile.
  public function setProfileCoverPhoto( $type, $photo ,$photoObject, $getFileId = NULL ){
      if($type == 'singleUserForm'){
            
        if ( $photo instanceof Zend_Form_Element_File) {
            $file = $photo->getFileName( );
            $fileName = $file;
        } else if ( $photo instanceof Storage_Model_File) {
            $file = $photo->temporary( );
            $fileName = $photo->name;
        } else if ( $photo instanceof Core_Model_Item_Abstract && !empty( $photo->file_id)) {
            $tmpRow = Engine_Api::_( )->getItem( 'storage_file', $photo->file_id);
            $file = $tmpRow->temporary( );
            $fileName = $tmpRow->name;
        } else if ( is_array( $photo) && !empty( $photo[ 'tmp_name' ])) {
            $file = $photo[ 'tmp_name' ];
            $fileName = $photo[ 'name' ];
        } else if ( is_string( $photo) && file_exists( $photo)) {
            $file = $photo;
            $fileName = $photo;
        } else {
            throw new User_Model_Exception( 'invalid argument passed to setProfileCoverPhoto');
        }

        if ( !$fileName) {
            $fileName = $file;
        }
        $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

      }elseif($type == 'importUsers'){

        $archiveCoverPhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."fileimport_".$getFileId. DIRECTORY_SEPARATOR . "cover_photo/";

        $getSubDirInfo = scandir($archiveCoverPhoto) ;
      
        foreach ($getSubDirInfo as $dirKey => $subDir ) {
          # code...
            if ( $subDir === '.' or $subDir === '..') continue;

            if (is_dir($archiveCoverPhoto . $subDir )) {
                $getCoverPhotoFile = $archiveCoverPhoto  . $subDir  ;
                break ;
            }
        }

        @chmod( $getCoverPhotoFile, 0777);
        // check if photo is present or not     
        if( ! file_exists( $getCoverPhotoFile.'/'.$photo ) ) {
            throw new User_Model_Exception( 'File is not found their');
        }
        $fileName = $photo;
        $file = $getCoverPhotoFile.'/'.$photo;
        $path = $archiveCoverPhoto;

      }elseif($type == 'dummyUsers'){
        
        $archiveCoverPhoto = APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."default_user". DIRECTORY_SEPARATOR . "cover_photo/";
        @chmod(APPLICATION_PATH . "/public/siteuserimport" . DIRECTORY_SEPARATOR ."default_user",0777);
        @chmod($archiveCoverPhoto,0777);
        @chmod($archiveCoverPhoto."cover_photo.zip");      
        if(file_exists( $archiveCoverPhoto. DIRECTORY_SEPARATOR ."cover_photo.zip" )) {
           @chmod($archiveCoverPhoto."cover_photo.zip", 0777);
          $zip = new ZipArchive;
          $res = $zip->open( $archiveCoverPhoto."cover_photo.zip" );
          $zip->extractTo( $archiveCoverPhoto );
          $zip->close();
          $getSubDirInfo = scandir($archiveCoverPhoto) ;
          foreach ($getSubDirInfo as $dirKey => $subDir ) {
             
            if ( $subDir === '.' or $subDir === '..') continue;
            if (is_dir($archiveCoverPhoto . $subDir )) {
                $getoverPhotoFile = $archiveCoverPhoto  . $subDir  ;
                break ;
            }
          }
          @chmod( $getoverPhotoFile, 0777);
        }   
        if( ! file_exists( $getoverPhotoFile.'/'.$photo ) ) {
            throw new User_Model_Exception( 'File is not found their');
        }
        $fileName = $photo;
        $file = $getoverPhotoFile.'/'.$photo;
        $path = $archiveCoverPhoto;
      }

    $name = basename( $file);
    $extension = ltrim( strrchr( $fileName, '.'), '.');
    $base = rtrim( substr( basename( $fileName), 0, strrpos( basename( $fileName), '.')), '.');
    
    $coverPhotoAttempt = str_replace( 'www.', '', strtolower( $_SERVER[ 'HTTP_HOST' ]));
    $isCoverAttempt = Engine_Api::_( )->getApi( 'settings', 'core')->getSetting( 'siteusercoverphoto.isattempt', false);
    $getCoverType = Engine_Api::_( )->getApi( 'settings', 'core')->getSetting( 'siteusercoverphoto.get.type', false);
    $coverphotoAttemptLtype = Engine_Api::_( )->getApi( 'settings', 'core')->getSetting( 'siteusercoverphoto.attempt.ltype', false);


    $filesTable = Engine_Api::_( )->getDbtable( 'files', 'storage');
    $coreSettings = Engine_Api::_( )->getApi( 'settings', 'core');
    $mainHeight = $coreSettings->getSetting( 'main.photo.height', 1600);
    $mainWidth = $coreSettings->getSetting( 'main.photo.width', 1600);

    // Resize image ( main)
    $mainPath = $path . DIRECTORY_SEPARATOR . $base . '_m.' . $extension;
    $image = Engine_Image::factory( );
    // Add autorotation for uploded images. It will work only for SocialEngine-4.8.9 Or more then.
    $hasVersion = $this->usingLessVersion( 'core', '4.8.9');
    if( !empty( $hasVersion)) {
    $image->open( $file)
            ->resize( $mainWidth, $mainHeight)
            ->write( $mainPath)
            ->destroy( );
    } else {
        $image->open( $file)
               ->autoRotate( )
            ->resize( $mainWidth, $mainHeight)
            ->write( $mainPath)
            ->destroy( );
    }
    
    $normalHeight = $coreSettings->getSetting( 'normal.photo.height', 375);
    $normalWidth = $coreSettings->getSetting( 'normal.photo.width', 375);
    // Resize image ( normal)
    $normalPath = $path . DIRECTORY_SEPARATOR . $base . '_in.' . $extension;
    
    $image = Engine_Image::factory( );
    if( !empty( $hasVersion)) {
    $image->open( $file)
            ->resize( $normalWidth, $normalHeight)
            ->write( $normalPath)
            ->destroy( );
    } else {
      $image->open( $file)
            ->autoRotate( )
            ->resize( $normalWidth, $normalHeight)
            ->write( $normalPath)
            ->destroy( );  
    }
        
    $coverPath = $path . DIRECTORY_SEPARATOR . $base . '_c.' . $extension;
    $image = Engine_Image::factory( );
    if( !empty( $hasVersion)) {
    $image->open( $file)
            ->resize( 1500, 1500)
            ->write( $coverPath)
            ->destroy( );
    } else {
        $image->open( $file)
            ->autoRotate( )
            ->resize( 1500, 1500)
            ->write( $coverPath)
            ->destroy( );
    }

    if ( empty( $isCoverAttempt) && $getCoverType !=  $coverphotoAttemptLtype) {
        Engine_Api::_( )->getApi( 'settings', 'core')->setSetting( 'siteusercoverphoto.getalbumtype', 0);
        Engine_Api::_( )->getApi( 'settings', 'core')->setSetting( 'siteusercoverphoto.webcamtype', 0);
        Engine_Api::_( )->getApi( 'settings', 'core')->setSetting( 'siteusercoverphoto.elementinfo', 0);
        Engine_Api::_( )->getApi( 'settings', 'core')->setSetting( 'siteusercoverphoto.album.set', 0);
        $requestListType = Engine_Api::_( )->getApi( 'settings', 'core')->getSetting( 'siteusercoverphoto.request.mod', false);
        $requestListType = !empty( $requestListType) ? @unserialize( $requestListType) : array( );
        $requestListType[] = $coverPhotoAttempt;
        Engine_Api::_( )->getApi( 'settings', 'core')->setSetting( 'siteusercoverphoto.request.mod', @serialize( $requestListType));
    }

    //if ( empty( $cover_photo_preview)) {
    $params = array( 
        'parent_type'  => $photoObject->getType( ),
        'parent_id'  => $photoObject->getIdentity( ),
        'user_id'  => $photoObject->owner_id,
        'name'  => basename( $fileName),
   );
   
   try {
        $iMain = $filesTable->createFile( $mainPath, $params);
        $iIconNormal = $filesTable->createFile( $normalPath, $params);
        $iMain->bridge( $iIconNormal, 'thumb.normal');
        $iCover = $filesTable->createFile( $coverPath, $params);
        $iMain->bridge( $iCover, 'thumb.cover');
    } catch ( Exception $e) {
        @unlink( $mainPath);
        @unlink( $normalPath);
        @unlink( $coverPath);
       if ( $e->getCode( ) ==  Storage_Model_DbTable_Files::SPACE_LIMIT_REACHED_CODE) {
         throw new Album_Model_Exception( $e->getMessage( ), $e->getCode( ));
       } else {
         throw $e;
       }
    }
    
    @unlink( $mainPath);
    @unlink( $normalPath);
    @unlink( $coverPath);
    
    $photoObject->modified_date = date( 'Y-m-d H:i:s');
    $photoObject->file_id = $iMain->file_id;
    $photoObject->save( );
    
    if ( !empty( $tmpRow)) {
        $tmpRow->delete( );
    }
    return $photoObject;      
  }

  /*
   * If have less then version then return true otherwise false.
   */

  public function usingLessVersion($pluginName, $productVersion) {
      $getModule = Engine_Api::_()->getDbtable('modules', 'core')->getModule($pluginName);
      if (!empty($getModule) && isset($getModule->version)) {
          $running_version = $getModule->version;

          $shouldUpgrade = false;
          if (!empty($running_version) && !empty($productVersion)) {
              $temp_running_verion_2 = $temp_product_verion_2 = 0;
              if (strstr($productVersion, "p")) {
                  $temp_starting_product_version_array = @explode("p", $productVersion);
                  $temp_product_verion_1 = $temp_starting_product_version_array[0];
                  $temp_product_verion_2 = $temp_starting_product_version_array[1];
              } else {
                  $temp_product_verion_1 = $productVersion;
              }
              $temp_product_verion_1 = @str_replace(".", "", $temp_product_verion_1);


              if (strstr($running_version, "p")) {
                  $temp_starting_running_version_array = @explode("p", $running_version);
                  $temp_running_verion_1 = $temp_starting_running_version_array[0];
                  $temp_running_verion_2 = $temp_starting_running_version_array[1];
              } else {
                  $temp_running_verion_1 = $running_version;
              }
              $temp_running_verion_1 = @str_replace(".", "", $temp_running_verion_1);

              if (($temp_running_verion_1 < $temp_product_verion_1) || (($temp_running_verion_1 == $temp_product_verion_1) && ($temp_running_verion_2 < $temp_product_verion_2))) {
                  $shouldUpgrade = true;
              }
          }
      }

      return $shouldUpgrade;
  }
  
  public function setUserAsVerified( $resource_id )
  {
    //TO CHECK USER IS LOGGED IN OR NOT
    $this->_viewer = Engine_Api::_()->user()->getViewer();
    $viewer_id = $this->_viewer->getIdentity();

    //GET THE VALUE OF RESOURCE ID ,RESOURCE TYPE AND RESOURCR TITLE
    $resource = Engine_Api::_()->getItem('user', $resource_id);

    //TO CHECK ADMIN HAS ALLOWED TO VERIFY OR NOT
    $siteverify_allow_verify = Zend_Registry::isRegistered('siteverify_allow_verify') ? Zend_Registry::get('siteverify_allow_verify') : null;
    $allow_verify = Engine_Api::_()->authorization()->getPermission($resource->level_id, 'siteverify_verify', 'allow_verify');
    $verifyOptions = (array) Engine_Api::_()->authorization()->getAdapter('levels')->getAllowed('siteverify_verify', $resource, 'auth_verify');
    
    $siteverifyManageType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.manage.type', 1);
    $siteverifyInfoType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.info.type', 1);
    $hostType = str_replace('www.', '', strtolower($_SERVER['HTTP_HOST']));
   
    $tempHostType = $tempSitemenuLtype = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.global.view', 0);
    $siteverifyLtype = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.lsettings', null);
    $siteverifyGlobalType = Engine_Api::_()->getApi('settings', 'core')->getSetting('siteverify.global.type', 0);

    if (empty($siteverify_allow_verify) || empty($allow_verify) || !in_array($this->_viewer->level_id, $verifyOptions)) {
      return;
    }

    //DUMP ALL THE VALUE IN AN ARRAY
    $values = array();
    $values['resource_type'] = 'user';
    $values['resource_id'] = $resource_id;
    $values['poster_type'] = "user";
    $values['poster_id'] = $viewer_id;
    $values['comments'] = " ";

    //GET THE VERIFY COUNT ,VERIFY LIMIT, ALLOW UNVERIFY AND IS COMMENT .
    $verifyTableObj = Engine_Api::_()->getDbtable('verifies', 'siteverify');
    $authorizationApi = Engine_Api::_()->authorization();

    $verify_count = $verifyTableObj->getVerifyCount($resource_id);

      $verify_count = ++$verify_count; //OTHERWISE VERIFYCOUNT WILL BE INCREASED.
    
    if(empty($siteverifyGlobalType)) {
      for ($check = 0; $check < strlen($hostType); $check++) {
        $tempHostType += @ord($hostType[$check]);
      }

      for ($check = 0; $check < strlen($siteverifyLtype); $check++) {
        $tempSitemenuLtype += @ord($siteverifyLtype[$check]);
      }
    }
    
    if((empty($siteverifyGlobalType)) && (($siteverifyManageType != $tempHostType) || ($siteverifyInfoType != $tempSitemenuLtype)))
      return;

    //TO INSERT DATA IN VERIFY TABLE
    $db = Engine_Db_Table::getDefaultAdapter();
    $db->beginTransaction();
    try {
      $verify = $verifyTableObj->createRow();
      $verify->setFromArray($values);
      $verify->save();
      // NOTIFICATION AND ACTIVITY FEED WORK
        // Engine_Api::_()->getDbtable('notifications', 'activity')->addNotification($resource, $this->_viewer, $verify, 'siteverify_new');


      //Add data in activity fields
       // if ( $user->verified && ( $user->enabled || $user->approved ) ) {
          // Engine_Api::_()->getDbtable('actions', 'activity')->addActivity($this->_viewer, $resource, 'siteverify_new');
      //  }
        
            
      if((empty($siteverifyGlobalType)) && (($siteverifyManageType != $tempHostType) || ($siteverifyInfoType != $tempSitemenuLtype))) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting('siteverify.viewtypeinfo.type', 0);
      }
      
      // Commit
      $db->commit();
    } catch (Exception $e) {
      $db->rollBack();
      throw $e;
    }
    return ;
  }
}