<?php

class Siteuserkyc_Api_Allow extends Authorization_Model_DbTable_Allow {


	public function isAllowed( $resource, $role, $action = 'view' ) {

		// Resource must be an instance of Core_Model_Item_Abstract
		if ( !($resource instanceof Core_Model_Item_Abstract) ) {
			// We have nothing to say about generic permissions
			return Authorization_Api_Core::LEVEL_IGNORE;
		}
		// Role must be an instance of Core_Model_Item_Abstract
		if ( !($role instanceof Core_Model_Item_Abstract) ) {
			// Disallow access to unknown role types
			return Authorization_Api_Core::LEVEL_DISALLOW;
		}
		// Owner can do what they want with the resource
		if ( $role === 'owner' ) {
			return Authorization_Api_Core::LEVEL_ALLOW;
		}
		if ( $action != 'view' ) {
			// work is done only for view other options are not done
			return Authorization_Api_Core::LEVEL_IGNORE;
		}

		// Now check if role has permission to view resource or not
		$resourceOwner = $resource->getOwner();
		if ( empty( $resourceOwner ) || empty($resourceOwner->getIdentity()) || $role->getIdentity() != $resourceOwner->getIdentity() ) {
			return Authorization_Api_Core::LEVEL_DISALLOW;
		}
		return Authorization_Api_Core::LEVEL_ALLOW;
	}


}