<?php
class Siteuserkyc_Form_Admin_MemberSetting extends Engine_Form {

	protected $_engineApi = null;
	protected $_allowedmemberLevel = array();


    public function init() {

    	$this->_engineApi = Engine_Api::_();
		$this->setMethod('post')->setName('manage_siteuser_kyc_setting')
			 ->setDescription('These settings affect all members in your community.');

		$order = 1;

		$memberLevels = $this->_engineApi->siteuserkyc()->getMemberLevelOptions();
		$this->addElement( 'MultiCheckbox', 'allowedmemberlevel', 
							array( 'label' => 'Select Member Levels',
							       'description' => 'Please select member levels for which uploading document option should be present.',
							       'multiOptions' => $memberLevels,
							       'order' => $order++,
					    		)
						);
		$this->allowedmemberlevel->getDecorator('Description')->setOption('placement', 'PREPEND');
		$this->allowedmemberlevel->setValue( array_keys($memberLevels));

		$this->addElement( 'Select', 'autoapproveddocument', 
							array( 'label' => 'Auto Approve of Documents',
							       'description' => 'Do you want documents to be automatically approved?',
							       'multiOptions' => array( 'yes' => 'Yes', 'no' => 'No' ),
							       'order' => $order++,
							       'onchange' => 'javascript:hide_Others()'
					    		)
						);
		$this->autoapproveddocument->getDecorator('Description')->setOption('placement', 'PREPEND');

		$this->addElement( 'Text', 'users_data', 
							array(	'label' => 'Choose Verifiers',
            						'description' => 'Select the members who can verify documents. You can choose the admin-level members only. If you have selected auto approve as “NO” and no admin members are added. Superadmin is allowed to verify the members.',
            						'order' => $order++,
            						'autocomplete' => 'off')
						);
		$this->users_data->getDecorator('Description')->setOption( 'placement', 'PREPEND' );

        // Init to Values
        $this->addElement( 'Hidden', 'toValues', 
        					array(	'value' => '',
						            'order' => $order++,
						            'validators' => array( 'NotEmpty' ),
						            'filters' => array( 'HtmlEntities' ),
						        )
        				);
        Engine_Form::addDefaultDecorators($this->toValues);

        $alloweddocuments = array( 'id_proof' => 'ID Proof', 'driving_license' => 'Driving License', 'passport' => 'Passport' );
		$this->addElement( 'MultiCheckbox', 'alloweddocumentlist', 
							array( 'label' => 'Allowed Documents',
							       'description' => 'Please select the documents that should be allowed for KYC.',
							       'multiOptions' => $alloweddocuments,
							       'order' => $order++,
								   'required' => true,
      							   'allowEmpty' => false,
					    		)
						);
		$this->alloweddocumentlist->getDecorator('Description')->setOption('placement', 'PREPEND');
		$this->alloweddocumentlist->setValue( array_keys($alloweddocuments)) ;

    	// Add submit
    	$this->addElement('Button', 'submit', array( 'label' => 'Save Changes', 'type' => 'submit', 'ignore' => true, 'order' => $order++ ) );

    }

}
