<?php

class Siteuserkyc_AdminSettingsController extends Core_Controller_Action_Admin {

	protected $_engineApi = null;
	protected $_coreSetting = null;
	protected $_siteuserkyc = null;


	public function init() {

		$this->_engineApi = Engine_Api::_();
		$this->_coreSetting = $this->_engineApi->getApi('settings', 'core');
		$this->_siteuserkyc = $this->_engineApi->siteuserkyc();
	}


	public function indexAction() {

		$allowedAdmins = $this->_siteuserkyc->getAllowedAdmins();
		$this->view->form = $form = new Siteuserkyc_Form_Admin_MemberSetting( );

		$this->view->users_dataObject = array();
		if ( $this->getRequest()->isPost() ) {

			if ( !$form->isValid($this->getRequest()->getPost()) ) {
				return;
			}
			$data = $form->getValues();
			$this->_siteuserkyc->setKycAdminSetting($data);
			if (!empty($data['toValues'])) {
				$allowedAdmins = explode( ",",$data['toValues'] );
				$users_dataObject = $this->_siteuserkyc->getAdmins( '', count($allowedAdmins), $allowedAdmins );
			}
			$form->addNotice('Your changes have been saved.');
		} else {
			if ( !empty($allowedAdmins) ) {
				$allowedAdmins = explode(',', $allowedAdmins);
				$users_dataObject = $this->_siteuserkyc->getAdmins( '', count($allowedAdmins), $allowedAdmins );
			}
			$form->populate( $this->_siteuserkyc->getKycAdminSetting() );
		}
		if ( !empty($users_dataObject) ) {
			foreach( $users_dataObject as $singleUser ) {
				$temp = $singleUser->toArray();
				$temp['label'] = $singleUser->getTitle();
				array_push($this->view->users_dataObject, $temp);
			}
		}

	}


	public function getitemAction() {

		$toValues = $this->_getParam('toValues', null);
		$toValues = empty($toValues) ? array() : explode(',', $toValues);

		$data = array();
        $text = $this->_getParam('value');
        $limit = 10;

        $allFcmUsers =$this->_siteuserkyc->getAdmins( $text, $limit, null, $toValues );
        foreach ($allFcmUsers as $fcmUser) {
        	$temp = array(  'id' => $fcmUser->getIdentity(),
							'label' => $fcmUser->getTitle(),
							'photo' => $this->view->itemPhoto($fcmUser, 'thumb.icon'),
							'url' => $fcmUser->getHref(),
			            );
        	array_push( $data, $temp );
        }

        if ($this->_getParam('sendNow', true)) {
            return $this->_helper->json($data);
        } else {
            $this->_helper->viewRenderer->setNoRender(true);
            $data = Zend_Json::encode($data);
            $this->getResponse()->setBody($data);
        }
	}


	public function faqAction() {
		// This will display site faq
	}


}