<?php

class Siteuserkyc_Installer extends Engine_Package_Installer_Module {

	public function onInstall() {

		parent::onInstall();
		$db = $this->getDb();
        $select = new Zend_Db_Select($db);
        $select->from('engine4_core_menuitems')->where( "name = 'user_settings_document' AND module = 'siteuserkyc'" );
        $isExist = $select->query()->fetchObject();
        if (!empty($isExist)) {
            $db->query("UPDATE `engine4_core_menuitems` SET `plugin` = 'Siteuserkyc_Plugin_Menus::canManageDocument' WHERE `name` = 'user_settings_document' AND `module` = 'siteuserkyc'");
        }
		// Insert page
		$defaultData = $db->select()->from('engine4_core_settings', 'value')->where( "name = 'siteuserkyc.adminmembersetting' ")->limit(1)->query()->fetchColumn();

		if ( empty($defaultData) ) {
			$memberLevels = $db->select()->from( 'engine4_authorization_levels', 'level_id' )->where( "type != 'public'" )->query()->fetchAll();
			$memberLevels = ( empty($memberLevels) || count($memberLevels) < 1 ) ? array() : array_column($memberLevels, 'level_id' );
			$defaultData = array( 'allowedmemberlevel' => $memberLevels,
									'autoapproveddocument' => 'yes',
									'alloweddocumentlist' => array( '0' => 'id_proof', '1' => 'driving_license', '2' => 'passport' )
								);
			$defaultData = json_encode($defaultData);
			$db->insert( 'engine4_core_settings', array( 'name' => 'siteuserkyc.adminmembersetting', 'value' => $defaultData ) );
		}

		$pageId = $db->select()->from('engine4_core_pages', 'page_id')->where('name = ?', 'siteuserkyc_index_manage')->limit(1)->query()->fetchColumn();
		if( !$pageId ) {
			$db->insert('engine4_core_pages', array(	'name' => 'siteuserkyc_index_manage',
														'displayname' => 'User Identity Verification / KYC Plugin',
														'title' => 'Manage KYC Document',
														'description' => 'This page is User Identity Verification / KYC Plugin.',
														'custom' => 0,
					) );

			$pageId = $db->lastInsertId();

			// Insert top
			$db->insert( 'engine4_core_content', array( 'type' => 'container', 'name' => 'top', 'page_id' => $pageId, 'order' => 1, ) );
			$topId = $db->lastInsertId();
			// Insert main
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'main','page_id' => $pageId, 'order' => 2 ) );
			$mainId = $db->lastInsertId();
			// Insert top-middle
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'middle','page_id' => $pageId, 'parent_content_id' => $topId ) );
			$topMiddleId = $db->lastInsertId();
			// Insert main-middle
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'middle','page_id' => $pageId, 'parent_content_id' => $mainId, 'order' => 2 ) );
			$mainMiddleId = $db->lastInsertId();
			// Insert menu
			$db->insert( 'engine4_core_content', array( 'type' => 'widget', 'name' => 'user.settings-menu', 'page_id' => $pageId, 'parent_content_id' => $topMiddleId, 'order' => 1 ) );
			// Insert content
			$db->insert( 'engine4_core_content', array( 'type' => 'widget', 'name' => 'core.content', 'page_id' => $pageId, 'parent_content_id' => $mainMiddleId, 'order' => 1, ) );
		}


		$pageId = $db->select()->from('engine4_core_pages', 'page_id')->where('name = ?', 'siteuserkyc_index_preview')->limit(1)->query()->fetchColumn();
		if( !$pageId ) {
			$db->insert('engine4_core_pages', array(	'name' => 'siteuserkyc_index_preview',
														'displayname' => 'User Identity Verification / KYC Preview',
														'title' => 'User KYC Document',
														'description' => 'This page is User Identity Verification / KYC Plugin.',
														'custom' => 0,
					) );

			$pageId = $db->lastInsertId();

			// Insert top
			$db->insert( 'engine4_core_content', array( 'type' => 'container', 'name' => 'top', 'page_id' => $pageId, 'order' => 1, ) );
			$topId = $db->lastInsertId();
			// Insert main
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'main','page_id' => $pageId, 'order' => 2 ) );
			$mainId = $db->lastInsertId();
			// Insert top-middle
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'middle','page_id' => $pageId, 'parent_content_id' => $topId ) );
			$topMiddleId = $db->lastInsertId();
			// Insert main-middle
			$db->insert( 'engine4_core_content', array( 'type' => 'container','name' => 'middle','page_id' => $pageId, 'parent_content_id' => $mainId, 'order' => 2 ) );
			$mainMiddleId = $db->lastInsertId();
			// Insert menu
			$db->insert( 'engine4_core_content', array( 'type' => 'widget', 'name' => 'user.settings-menu', 'page_id' => $pageId, 'parent_content_id' => $topMiddleId, 'order' => 1 ) );
			// Insert content
			$db->insert( 'engine4_core_content', array( 'type' => 'widget', 'name' => 'core.content', 'page_id' => $pageId, 'parent_content_id' => $mainMiddleId, 'order' => 1, ) );
		}

	}

}