<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteuserurl
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminSettingsController.php 2011-11-15 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteuserurl_AdminSettingsController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    $settings = Engine_Api::_()->getApi('settings', 'core');

    //TABS CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteuserurl_admin_main', array(), 'siteuserurl_admin_main_global');

    $this->view->form = $form = new Siteuserurl_Form_Admin_Settings_Global();
    $values = array();

    if( $this->getRequest()->isPost() && $form->isValid($this->_getAllParams()) ) {
      $values = $form->getValues();
      foreach( $values as $key => $value ) {
        Engine_Api::_()->getApi('settings', 'core')->setSetting($key, $value);
      }
      $form->addNotice('Your changes have been saved.');
    }
    $siteuserurlEnabled = $settings->getSetting('siteuserurl.enabled', 1);
    $profileSortUrlLevels = $settings->getSetting('siteuserurl.profileSortUrlLevel', array());
    if( $siteuserurlEnabled == 1 || ($siteuserurlEnabled == 3 && $profileSortUrlLevels) ) {
      $db = Zend_Db_Table_Abstract::getDefaultAdapter();
      $select = $db->select()
        ->from('engine4_users', 'username');
      if( $siteuserurlEnabled == 3 && $profileSortUrlLevels ) {
        $select->where('level_id IN(?)', $profileSortUrlLevels);
      }
      $usernames = $select->query()
        ->fetchAll(Zend_Db::FETCH_COLUMN);
      $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
      $bannedUsernames = $bannedUsernamesTable->select()
        ->from($bannedUsernamesTable, 'username')
        ->query()
        ->fetchAll(Zend_Db::FETCH_COLUMN);
      $this->view->conflictUsernames = array_intersect($usernames, $bannedUsernames);
    }
  }

  public function bannedUsernameAction()
  {

    //TABS CREATION
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteuserurl_admin_main', array(), 'siteuserurl_admin_main_bannedurl');

    $this->view->formFilter = $formFilter = new Siteuserurl_Form_Admin_Manage_Filter();
    $values = array();
    if( $formFilter->isValid($this->_getAllParams()) ) {
      $values = $formFilter->getValues();
    }

    foreach( $values as $key => $value ) {
      if( null === $value ) {
        unset($values[$key]);
      }
    }

    if( isset($_POST['search']) ) {
      if( !empty($_POST['word']) ) {
        $this->view->word = $_POST['word'];
        $values['word'] = $_POST['word'];
      }
    }

    $values = array_merge(array(
      'order' => 'bannedusername_id',
      'order_direction' => 'DESC',
      ), $values);

    $this->view->assign($values);

    $moduleTable = Engine_Api::_()->getDbtable('modules', 'core');
    $select = $moduleTable->select()->where('enabled = ?', 1);
    $enableAllModules = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);

    $db = Zend_Db_Table_Abstract::getDefaultAdapter();
    $usernames = $db->select()
      ->from('engine4_users', 'username')
      ->query()
      ->fetchAll(Zend_Db::FETCH_COLUMN);

    $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
    $bannedUsernames = $bannedUsernamesTable->select()
      ->from($bannedUsernamesTable, 'username')
      ->query()
      ->fetchAll(Zend_Db::FETCH_COLUMN);
    $routs = array();
    foreach( $enableAllModules as $moduleName ) {
      $file_path = APPLICATION_PATH . "/application/modules/" . ucfirst($moduleName) . "/settings/manifest.php";
      if( @file_exists($file_path) ) {
        $ret = include $file_path;
        $is_exist = array();
        if( isset($ret['routes']) ) {
          foreach( $ret['routes'] as $item ) {
            $route = $item['route'];
            $route_array = explode('/', $route);
            $route_url = strtolower($route_array[0]);
            if( !empty($route_url) ) {
              if( !(in_array($route_url, $bannedUsernames)) ) {
                if( !(in_array($moduleName, $routs)) ) {
                  $routs[] = $moduleName;
                }
              }
            }
          }
        }
      }
    }
    $this->view->unbannedModules = null;

    if( !empty($routs) ) {
      $this->view->unbannedModules = $routs;
    }

    $conflictUsernames = array_intersect($usernames, $bannedUsernames);
    $this->view->conflictUsernames = null;

    if( !empty($conflictUsernames) ) {
      $this->view->conflictUsernames = $conflictUsernames;
    }

    // Load all words

    $this->view->paginator = $paginator = Engine_Api::_()->getApi('core', 'siteuserurl')->getwords($values);
    $page = $this->_getParam('page', 1);
    $this->view->paginator->setItemCountPerPage(500);
    $this->view->paginator->setCurrentPageNumber($page);
  }

  public function createUrlAction()
  {

    // Get form
    $this->view->form = $form = new Siteuserurl_Form_Admin_Settings_Blockurl();

    // Load all words
    $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {

      // Process
      $db = Engine_Api::_()->getDbtable('settings', 'core')->getAdapter();
      $db->beginTransaction();

      try {
        $values = $form->getValues();

        // Save Banned Words
        $bannedWordsNew = preg_split('/\s*[,\n]+\s*/', $values['bannedwords']);

        $words = array_map('strtolower', array_filter(array_values($bannedWordsNew)));

        $data = $bannedUsernamesTable->select()
          ->from($bannedUsernamesTable, 'username')
          ->query()
          ->fetchAll(Zend_Db::FETCH_COLUMN);
        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $usernames = $db->select()
          ->from('engine4_users', 'username')
          ->query()
          ->fetchAll(Zend_Db::FETCH_COLUMN);
        if( in_array($words[0], $data) ) {
          $form->addError(Zend_Registry::get('Zend_Translate')->_('This Username is already banned.'));
          return;
        }
        if( in_array($words[0], $usernames) ) {
          $form->addError(Zend_Registry::get('Zend_Translate')->_('You cannot ban this Username as it is already being used by your site user. If you still want to ban this Username then please go to “Manage” → “Members” section in the admin panel of SocialEngine and edit that Username. Now, you will be able to ban this Username.
        '));
          return;
        }

        foreach( $bannedWordsNew as $word ) {
          $bannedUsername = array('username' => $word);
          $bannedUsernamesTable->insert($bannedUsername);
        }
        $db->commit();
        //$form->addNotice('Your changes have been saved.');
      } catch( Exception $e ) {
        $db->rollback();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function editUrlAction()
  {
    // Get form
    $this->view->form = $form = new Siteuserurl_Form_Admin_Settings_EditBlockurl();
    $url_id = $this->_getParam('id');
    $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
    $data = $bannedUsernamesTable->select()
      ->from($bannedUsernamesTable)
      ->where('bannedusername_id =?', $url_id)
      ->query()
      ->fetchAll();
    $form->populate(array('bannedwords' => $data[0]['username']));

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {

      // Process
      $db = Engine_Api::_()->getDbtable('settings', 'core')->getAdapter();
      $db->beginTransaction();


      try {
        $values = $form->getValues();
        // Save Banned Words
        $bannedWordsNew = preg_split('/\s*[,\n]+\s*/', $values['bannedwords']);

        $words = array_map('strtolower', array_filter(array_values($bannedWordsNew)));

        $data = $bannedUsernamesTable->select()
          ->from($bannedUsernamesTable, 'username')
          ->where('bannedusername_id !=?', $url_id)
          ->query()
          ->fetchAll(Zend_Db::FETCH_COLUMN);

        $db = Zend_Db_Table_Abstract::getDefaultAdapter();
        $usernames = $db->select()
          ->from('engine4_users', 'username')
          ->query()
          ->fetchAll(Zend_Db::FETCH_COLUMN);
        if( in_array($words[0], $usernames) ) {
          $form->addError(Zend_Registry::get('Zend_Translate')->_('There exist a username with this name please edit that username first.'));
          return;
        }

        if( in_array($words[0], $data) ) {
          $form->addError(Zend_Registry::get('Zend_Translate')->_('This URL already exists.'));
          return;
        }
        $bannedUsernamesTable->update(array('username' => $words[0]), array('bannedusername_id = ?' => $url_id));
        $db->commit();
      } catch( Exception $e ) {
        $db->rollback();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function deleteUrlAction()
  {

    //SET LAYOUT
    $this->_helper->layout->setLayout('admin-simple');

    //GET CATEGORY ID AND CHECK VALIDATION
    $this->view->id = $id = $this->_getParam('id');

    if( empty($id) ) {
      die('No identifier specified');
    }
    if( $this->getRequest()->isPost() ) {

      //BEGIN TRANSACTION
      $db = Engine_Db_Table::getDefaultAdapter();
      $db->beginTransaction();

      try {
        $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
        $selectdata = $bannedUsernamesTable->select()
          ->where('bannedusername_id =?', $id);
        $result_url = $bannedUsernamesTable->fetchRow($selectdata);
        $result_url->delete();
        //COMMIT
        $db->commit();
      } catch( Exception $e ) {
        $db->rollBack();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function addUrlAction()
  {

    // Get form
    $this->view->form = $form = new Siteuserurl_Form_Admin_Settings_Addurl();

    if( $this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost()) ) {
      $bannedUsernamesTable = Engine_Api::_()->getDbtable('bannedUsernames', 'core');
      // Process
      $db = Engine_Api::_()->getDbtable('settings', 'core')->getAdapter();
      $db->beginTransaction();


      try {
        $values = $form->getValues();

        $moduleTable = Engine_Api::_()->getDbtable('modules', 'core');
        $select = $moduleTable->select()->where('enabled = ?', 1);
        $enableModules = $select->query()->fetchAll(Zend_Db::FETCH_COLUMN);

        if( in_array($values['module_name'], $enableModules) ) {
          $file_path = APPLICATION_PATH . "/application/modules/" . ucfirst($values['module_name']) . "/settings/manifest.php";
          if( @file_exists($file_path) ) {
            $ret = include $file_path;
            $is_exist = array();
            if( isset($ret['routes']) ) {
              foreach( $ret['routes'] as $item ) {
                $route = $item['route'];
                $route_array = explode('/', $route);
                $route_url = strtolower($route_array[0]);

                $data = $bannedUsernamesTable->select()
                  ->from($bannedUsernamesTable, 'bannedusername_id')
                  ->where('username =?', $route_url)
                  ->query()
                  ->fetchAll(Zend_Db::FETCH_COLUMN);
                if( empty($data) ) {
                  if( !empty($route_url) && !in_array($route_url, $is_exist) ) {
                    $db->query("INSERT IGNORE INTO `engine4_core_bannedusernames` (`bannedusername_id`, `username`) VALUES ('','" . $route_url . "')");
                  }
                } else {
                  $bannedUsernamesTable->update(array('username' => $route_url), array('bannedusername_id = ?' => $data[0]));
                }
                $is_exist[] = $route_url;
              }
            }
          }
        }

        /* data = $bannedUsernamesTable->select()
          ->from($bannedUsernamesTable, 'word')
          ->where('word !=?',$values[])
          ->query()
          ->fetchAll(Zend_Db::FETCH_COLUMN); */
        $bannedUsernamesTable->update(array('username' => $words[0]), array('bannedusername_id = ?' => $url_id));
        $db->commit();
      } catch( Exception $e ) {
        $db->rollback();
        throw $e;
      }
      $this->_forward('success', 'utility', 'core', array(
        'smoothboxClose' => 10,
        'parentRefresh' => 10,
        'messages' => array('')
      ));
    }
  }

  public function faqAction()
  {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('siteuserurl_admin_main', array(), 'siteuserurl_admin_main_faq');
  }

}

?>