<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevideoview
 * @copyright  Copyright 2011-2012 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Global.php 2012-06-028 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevideoview_Form_Admin_Global extends Engine_Form {

  public function init() {

    $this
            ->setTitle('Global Settings')
            ->setDescription('These settings affect all members in your community.');

    $this->addElement('Text', 'sitevideoview_lsettings', array(
        'label' => 'Enter License key',
        'description' => "Please enter your license key that was provided to you when you purchased this plugin. If you do not know your license key, please contact the Support Team of SocialEngineAddOns from the Support section of your Account Area.(Key Format: XXXXXX-XXXXXX-XXXXXX )",
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitevideoview.lsettings'),
    ));

    if (APPLICATION_ENV == 'production') {
      $this->addElement('Checkbox', 'environment_mode', array(
          'label' => 'Your community is currently in "Production Mode". We recommend that you momentarily switch your site to "Development Mode" so that the CSS of this plugin renders fine as soon as the plugin is installed. After completely installing this plugin and visiting few pages of your site, you may again change the System Mode back to "Production Mode" from the Admin Panel Home. (In Production Mode, caching prevents CSS of new plugins to be rendered immediately after installation.)',
          'description' => 'System Mode',
          'value' => 1,
      ));
    } else {
      $this->addElement('Hidden', 'environment_mode', array('order' => 990, 'value' => 0));
    }

    // Add submit button
    $this->addElement('Button', 'submit_lsetting', array(
        'label' => 'Activate Your Plugin Now',
        'type' => 'submit',
        'ignore' => true
    ));
    
    //COLOR VALUE FOR BACKGROUND COLOR
    $this->addElement('Text', 'sitevideoview_lightbox_bgcolor', array(
        'decorators' => array(
            array('ViewScript', array(
                    'viewScript' => 'admin-settings/rainbow-color/_formImagerainbowLightBoxBg.tpl',
                    'class' => 'form element'
            )))
    ));
    
    //COLOR VALUE FOR BACKGROUND COLOR
    $this->addElement('Text', 'sitevideoview_lightbox_fontcolor', array(
        'decorators' => array(
            array('ViewScript', array(
                    'viewScript' => 'admin-settings/rainbow-color/_formImagerainbowLightBoxFont.tpl',
                    'class' => 'form element'
            )))
    ));
    
    $this->addElement('Radio', 'sitevideoview_gotovideo', array(
        'label' => '"Go to Video" Button',
        'description' => 'Do you want the button of "Go to Video" to be shown in the Video Lightbox Viewer?',
        'multiOptions' => array(
            1 => 'Yes',
            0 => 'No'
        ),
        'value' => Engine_Api::_()->getApi('settings', 'core')->getSetting('sitevideoview.gotovideo', 1),
    ));    

    // Element: submit
    $this->addElement('Button', 'submit', array(
        'label' => 'Save Changes',
        'type' => 'submit',
        'ignore' => true
    ));
  }

}

?>