<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevod
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: 4.10.3 2018-09-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevod_Plugin_Core
{

  public function onStorageFileCreateAfter($event)
  {
    $this->processForUpoald($event);
  }

  public function onStorageFileUpdateAfter($event)
  {
    $this->processForUpoald($event);
  }

  private function processForUpoald($event)
  {
    $payload = $event->getPayload();
    if( !($payload instanceof Storage_Model_File) ) {
      return;
    }
    if( !$payload->extension || !in_array(strtolower($payload->extension), array('mp4')) ) {
      return;
    }

    if( empty($payload->storage_path) || !in_array('storage_path', $payload->getModifiedFieldsName()) ) {
      return;
    }

/*    $params = $payload->toArray();
    $params['status'] = Sitevod_Api_Core::STREAM_INITIAL_STATUS;
    $table = Engine_Api::_()->getDbtable('stream', 'sitevod');
    $table->delete(array('file_id = ?' => $payload->getIdentity()));
    $row = $table->createRow();
    $row->setFromArray($params);
    $row->save();
    Engine_Api::_()->getDbtable('jobs', 'core')->addJob('sitevod_stream_uplaod', array(
      'stream_id' => $row->getIdentity(),
    ));
 * 
 */
  }

}