<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevod
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: 4.10.3 2018-09-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevod_Service_StreamS3 extends Storage_Service_S3
{

  public function getBaseUrl()
  {
    // Make url
    if( !$this->_baseUrl ) {
      // Map to S3 bucket directly
      return (_ENGINE_SSL ? 'https://' : 'http://') . $this->_bucket . '.s3.amazonaws.com/';
    } else {
      // Map to baseUrl (cloudfront)
      return rtrim($this->_baseUrl, '/') . '/';
    }
  }

  /**
   * Removes the file
   *
   * @param Storage_Model_DbRow_File $model The file for operation
   */
  public function remove(Storage_Model_File $model)
  {
    if( !empty($model->storage_path) ) {
      try {
        $this->_remove($model->storage_path);
      } catch( Exception $e ) {
        throw $e;
      }
    }
  }

  public function removeFile($path)
  {
    $this->_remove($path);
  }

  private function _remove($path)
  {
    $prefix = explode('/', trim($path, '/'))[0];
    if( empty($prefix) ) {
      return;
    }
    $finalList = array();
    $params = array(
      'prefix' => $prefix,
      'marker' => 0,
      'max-keys' => 100
    );
    $list = $this->_internalService->getObjectsByBucket($this->_bucket, $params);
    foreach( $list as $l ) {
      if( strpos($l, $prefix) === 0 ) {
        $path = $this->_bucket . '/' . $l;
        $this->_internalService->removeObject($path);
        $finalList[] = $l;
      }
    }
  }

}