<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Sitevod
 * @copyright  Copyright 2018-2019 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: 4.10.3 2018-09-08 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Sitevod_AdminServicesController extends Core_Controller_Action_Admin
{
  public function indexAction()
  {
    $this->view->navigation = $navigation = Engine_Api::_()->getApi('menus', 'core')
      ->getNavigation('sitevod_admin_main', array(), 'sitevod_admin_main_services');
    $this->view->notFoundServices = $this->checkServicesLibrary();
  }

  public function downloadAction()
  {
    $service = $this->_getParam('service');
    Engine_Api::_()->sitevod()
      ->downloadFiles($service);
    return $this->_helper->redirector->gotoRoute(array('module' => 'sitevod', 'controller' => 'services', 'action' => 'index'), 'admin_default', true);
  }

  private function checkServicesLibrary()
  {
    $results = array();
    if( !file_exists(APPLICATION_PATH . '/application/libraries/SEAO/aws/Aws/S3/S3Client.php') ) {
      $results[] = 'amazon';
    }
    return $results;
  }
}
