<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteyoutube
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteyoutube_Form_Admin_Settings_Configure extends Engine_Form
{

  public function init()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Configure Pages")))
      ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can configure pages and can create backup of pages. If you want to get the previous set up of landing page and other sections of your website, you can configure it from here.")));

    $this->addElement('Radio', 'siteyoutube_landing_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Landing Page',
      'description' => "Do you want Landing Page setup of Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the Landing Page as default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous setup of Landing Page which was present before the installation of this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.landing.page.layout', 1),
    ));

    $this->addElement('Radio', 'siteyoutube_header_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Header',
      'description' => "Do you want Header as Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the header as in default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous Header which was present before the installation of this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.header.page.layout', 1),
    ));

    $this->addElement('Radio', 'siteyoutube_footer_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Footer',
      'description' => "Do you want Footer as the Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the Footer as in default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous Footer which was before the installation of this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.footer.page.layout', 1),
    ));

    $this->addElement('Radio', 'siteyoutube_login_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Login Page',
      'description' => "Do you want the Login page setup of Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the Login page as default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous setup of the Login page which was before the installation of this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.login.page.layout', 1),
    ));

    $this->addElement('Radio', 'siteyoutube_login_required_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Login Required Page',
      'description' => "Do you want the Login Required Page setup of Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the Login Required Page as default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous setup of Login Required Page which was before the installation of this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.login.required.page.layout', 1),
    ));

    $this->addElement('Radio', 'siteyoutube_signup_page_layout', array(
      'label' => 'Ultimate YouTube Clone Theme Sign Up Page',
      'description' => "Do you want Sign Up Page setup of Ultimate YouTube Clone Theme? If you choose ‘Yes’ you will get the Sign Up Page as default setup of Ultimate YouTube Clone Theme. If chosen ‘No’, you will get the previous setup of Sign Up Page which was before the installation of this this theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('siteyoutube.signup.page.layout', 1),
    )); 
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
