<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    youtubeclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Layout.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteyoutube_Form_Admin_Settings_Landingpage_Landing extends Engine_Form
{

  public function init()
  {
    $description = sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can manage information widget of Landing Page."));
    $this->setTitle("Manage Landing Page");
    $this->setDescription("$description");
  
    $this->loadDefaultDecorators();
    $this->getDecorator('Description')->setOption('escape', false);

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setAttrib('id', 'form-information');

    // // Get available files
    // $logoOptions = array('' => 'Text-only (No logo)');
    // $backgroundOptions = array('' => 'Default Image');
    // $imageExtensions = array('gif', 'jpg', 'jpeg', 'png');

    // $files = Engine_Api::_()->getDbtable('files', 'core')->fetchAll();

    // foreach ($files as $file) {
    //     $basename = $file->name;
    //     $ext = $file->extension;
    //     if (!in_array($ext, $imageExtensions))
    //         continue;
    //     $logoOptions[$file->storage_path] = $basename;
    //     $backgroundOptions[$file->storage_path] = $basename;
    // }
    $this->addElement('Text', 'youtubeclone_info_main_title', array(
      'label' => 'Enter the Title text',
      'description' => 'Enter Title for information widget.',
      'value' => $coreSettings->getSetting('youtubeclone.info.main.title', 'Why Choose Us'),
    ));

    $this->addElement('Text', 'youtubeclone_info_title1', array(
      'label' => 'Add First Title',
      'value' => $coreSettings->getSetting("youtubeclone.info.title1", "Easy Login / Signup"),
    ));

    $this->addElement('Text', 'youtubeclone_info_description1', array(
      'label' => 'Add First Description',
      'value' => $coreSettings->getSetting('youtubeclone.info.description1', 'You can easily sign up on our community or simply login, if you already have an account to get started !'),
    ));

    $this->addElement('Text', 'youtubeclone_info_logo1', array(
      'label' => 'Add First Icon',
      'value' => $coreSettings->getSetting('youtubeclone.info.logo1', 'fa-sign-in'),
    ));



    $this->addElement('Text', 'youtubeclone_info_title2', array(
      'label' => 'Add Second Title',
      'value' => $coreSettings->getSetting("youtubeclone.info.title2", "Eye Catching Community"),
    ));

    $this->addElement('Text', 'youtubeclone_info_description2', array(
      'label' => 'Add Second Description',
      'value' => $coreSettings->getSetting('youtubeclone.info.description2', 'A community with pleasant UI and effects catches users attention very quickly and helps in user engagement.'),
    ));
    $this->addElement('Text', 'youtubeclone_info_logo2', array(
      'label' => 'Add Second  Icon',
      'value' => $coreSettings->getSetting('youtubeclone.info.logo2', 'fa-eye'),
    ));


    $this->addElement('Text', 'youtubeclone_info_title3', array(
      'label' => 'Add Third Title',
      'value' => $coreSettings->getSetting("youtubeclone.info.title3", "Videos, Channels & Playlists"),
    ));

    $this->addElement('Text', 'youtubeclone_info_description3', array(
      'label' => 'Add Third Description',
      'value' => $coreSettings->getSetting('youtubeclone.info.description3', 'Share videos, channels, playlists with your friends, family, & with the whole world.'),
    ));
    $this->addElement('Text', 'youtubeclone_info_logo3', array(
      'label' => 'Add Third Icon',
      'value' => $coreSettings->getSetting('youtubeclone.info.logo3', 'fa-file-video-o'),
    ));


    $this->addDisplayGroup( array('youtubeclone_info_title1', 'youtubeclone_info_description1', 'youtubeclone_info_logo1'), 'youtubeclone_landing_stats_block1');

    $this->addDisplayGroup( array('youtubeclone_info_title2', 'youtubeclone_info_description2', 'youtubeclone_info_logo2'), 'youtubeclone_landing_stats_block2');

    $this->addDisplayGroup( array('youtubeclone_info_title3', 'youtubeclone_info_description3', 'youtubeclone_info_logo3'), 'youtubeclone_landing_stats_block3');
    

    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
?>
