<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Siteyoutube
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Subscriptions.php 2015-06-04 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Siteyoutube_Model_Service extends Core_Model_Item_Abstract
{

  protected $_searchTriggers = false;

  public function setPhoto($photo)
  {
    if( $photo instanceof Zend_Form_Element_File ) {
      $file = $photo->getFileName();
    } else if( is_array($photo) && !empty($photo['tmp_name']) ) {
      $file = $photo['tmp_name'];
    } else if( is_string($photo) && file_exists($photo) ) {
      $file = $photo;
    } else {
      throw new Engine_Exception('invalid argument passed to setPhoto');
    }

    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    $thumb_file = $path . '/in_' . $name;
    $image = Engine_Image::factory();
    $image->open($file)
      ->resize(64, 64)
      ->write($thumb_file)
      ->destroy();
    try {
      $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
        'parent_type' => 'siteyoutube_service',
        'parent_id' => $this->getIdentity()
      ));
      // Remove temp file
      @unlink($thumb_file);
    } catch( Exception $e ) {
      
    }

    $this->file_id = $thumbFileRow->file_id;
    $this->save();

    return $this;
  }

}