<?php
/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Travel
 * @copyright  Copyright 2006-2020 Webligo Developments
 * @license    https://socialengine.com/eula
 * @version    $Id: Categories.php 9747 2012-07-26 02:08:08Z john $
 * @author     Donna
 */

/**
 * @category   Application_Extensions
 * @package    Travel
 * @copyright  Copyright 2006-2020 Webligo Developments
 * @license    https://socialengine.com/eula
 */
class Travel_Model_DbTable_Categories extends Engine_Db_Table
{
  protected $_rowClass = 'Travel_Model_Category';

  public function getCategoriesAssoc()
  {
    $stmt = $this->select()
        ->from($this, array('category_id', 'category_name'))
        ->order('category_name ASC')
        ->query();

    $data = array();
    foreach( $stmt->fetchAll() as $category ) {
      $data[$category['category_id']] = $category['category_name'];
    }

    return $data;
  }

  public function getUserCategoriesAssoc($user)
  {
    if( $user instanceof User_Model_User ) {
      $user = $user->getIdentity();
    } else if( !is_numeric($user) ) {
      return array();
    }

    $stmt = $this->getAdapter()
        ->select()
        ->from('engine4_travel_categories', array('category_id', 'category_name'))
        ->joinLeft('engine4_travel_travels', "engine4_travel_travels.category_id = engine4_travel_categories.category_id")
        ->group("engine4_travel_categories.category_id")
        ->where('engine4_travel_travels.owner_id = ?', $user)
        ->where('engine4_travel_travels.draft = ?', "0")
        ->order('category_name ASC')
        ->query();

    $data = array();
    foreach( $stmt->fetchAll() as $category ) {
      $data[$category['category_id']] = $category['category_name'];
    }

    return $data;
  }
}
