<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Settings.php 2018-04-05 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Twitterclone_Form_Admin_Settings_Configure extends Engine_Form
{

  public function init()
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $this->setTitle(sprintf(Zend_Registry::get('Zend_Translate')->_("Configure Pages")))
      ->setDescription(sprintf(Zend_Registry::get('Zend_Translate')->_("Here you can configure pages and can create backup of pages. If you want to get the previous set up of landing page and other sections of your website, you can configure it from here.")));

    $this->addElement('Radio', 'twitterclone_landing_page_layout', array(
      'label' => 'Ultimate Twitter Clone Landing Page',
      'description' => "Do you want Landing Page setup of Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the Landing Page as default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous setup of Landing Page which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.landing.page.layout', 1),
    ));

    $this->addElement('Radio', 'twitterclone_header_page_layout', array(
      'label' => 'Ultimate Twitter Clone Header',
      'description' => "Do you want Header as Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the header as in default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous Header which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.header.page.layout', 1),
    ));

    $this->addElement('Radio', 'twitterclone_footer_page_layout', array(
      'label' => 'Ultimate Twitter Clone Footer',
      'description' => "Do you want Footer as Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the Footer as in default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous Footer which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.footer.page.layout', 1),
    ));

    $this->addElement('Radio', 'twitterclone_login_page_layout', array(
      'label' => 'Ultimate Twitter Clone Login Page',
      'description' => "Do you want Login page setup of Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the Login page as default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous setup of Login page which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.login.page.layout', 1),
    ));

    $this->addElement('Radio', 'twitterclone_login_required_page_layout', array(
      'label' => 'Ultimate Twitter Clone Login Required Page',
      'description' => "Do you want Login Required Page setup of Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the Login Required Page as default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous setup of Login Required Page which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.login.required.page.layout', 1),
    ));

    $this->addElement('Radio', 'twitterclone_signup_page_layout', array(
      'label' => 'Ultimate Twitter Clone Sign Up Page',
      'description' => "Do you want Sign Up Page setup of Ultimate Twitter Clone Theme? If you choose ‘Yes’ you will get the Sign Up Page as default setup of Ultimate Twitter Clone Theme. If chosen ‘No’, you will get the previous setup of Sign Up Page which was before the installation of Ultimate Twitter Clone Theme.",
      'multiOptions' => array(
        1 => 'Yes',
        0 => 'No'
      ),
      'value' => $coreSettings->getSetting('twitterclone.signup.page.layout', 1),
    )); 
    $this->addElement('Button', 'submit', array(
      'label' => 'Save Changes',
      'type' => 'submit',
      'decorators' => array(
        'ViewHelper',
      ),
    ));
  }

}
