<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2015-2018 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: AdminLayoutController.php 2018-05-15 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */

class Twitterclone_AdminLandingPageController extends Core_Controller_Action_Admin
{
  public function rightLayoutAction()
  {

    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_main', array(), 'twitterclone_admin_landingpage');
    $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_landingpage', array(), 'twitterclone_admin_landingpage_slider');

    //MAKE FORM
    $this->view->form = $form = new Twitterclone_Form_Admin_Settings_Landingpage_Landing();

    // Check method/data
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $values = $form->getValues();

    foreach( $values as $key => $value ) {
      if ( $coreSettings->hasSetting( $key, $value ) ) {
          $coreSettings->removeSetting($key);
      }
      $coreSettings->setSetting($key, $value);
    }
    $form->addNotice('Your changes have been saved.');

  }

  public function leftLayoutAction()
  {
    $this->view->navigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_main', array(), 'twitterclone_admin_landingpage');
    $this->view->subNavigation = Engine_Api::_()->getApi('menus', 'core')->getNavigation('twitterclone_admin_landingpage', array(), 'twitterclone_admin_landingpage_text_banner');

    //MAKE FORM
    $this->view->form = $form = new Twitterclone_Form_Admin_Settings_Landingpage_TextBanner();

    // Check method/data
    if( !$this->getRequest()->isPost() ) {
      return;
    }
    if( !$form->isValid($this->getRequest()->getPost()) ) {
      return;
    }

    $this->saveValues($form);
  }

  public function saveValues($form)
  {
    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $values = $form->getValues();
    foreach( $values as $key => $value ) {
      $coreSettings->setSetting($key, $value);
    }
    $form->addNotice('Your changes have been saved.');
  }

  public function setPhoto($photo, $parent_id = null, $parent_type = null) {
    if ($photo instanceof Zend_Form_Element_File) {
        $file = $photo->getFileName();
    } else if (is_array($photo) && !empty($photo['tmp_name'])) {
        $file = $photo['tmp_name'];
    } else if (is_string($photo) && file_exists($photo)) {
        $file = $photo;
    } else {
        throw new Engine_Exception('invalid argument passed to setPhoto');
    }

    $name = basename($file);
    $path = APPLICATION_PATH . DIRECTORY_SEPARATOR . 'temporary';

    $thumb_file = $path . '/in_' . $name;
    $image = Engine_Image::factory();

    $image->open($file)
                  ->resize(64, 64)
                  ->write($thumb_file)
                  ->destroy();
    try {
        $thumbFileRow = Engine_Api::_()->storage()->create($thumb_file, array(
            'parent_type' => $parent_type,
            'parent_id' => $parent_id
        )); 
        // Remove temp file
        @unlink($thumb_file); 
    } catch (Exception $e) {
        
    }

    $file_id = $thumbFileRow->file_id;
    return $file_id;
  }
}
