<?php


/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Twitterclone
 * @copyright  Copyright 2010-2011 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    $Id: Controller.php 2011-08-026 9:40:21Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Twitterclone_Widget_headerController extends Engine_Content_Widget_Abstract
{

  public function indexAction()
  {
    $request = Zend_Controller_Front::getInstance()->getRequest();
    if (($request->getModuleName() == 'core' && $request->getControllerName() == 'index' && $request->getActionName() == 'index')||($request->getControllerName() == 'signup' && $request->getActionName() == 'index')) {
        $this->setNoRender();
        return;
    }

    $coreSettings = Engine_Api::_()->getApi('settings', 'core');
    $logoPath = $coreSettings->getSetting('twitterclone.header.logo.image', '');
    $this->view->logoData = array('logo' => $logoPath);
    $this->view->showMenu = true;

    $isSitemenuEnable = Engine_Api::_()->getDbtable('modules', 'core')->isModuleEnabled('sitemenu');
    $pageIdentity = join('-', array(
      $request->getModuleName(),
      $request->getControllerName(),
      $request->getActionName()
    ));

    $themes = Engine_Api::_()->getDbtable('themes', 'core')->fetchAll();
    $activeTheme = $themes->getRowMatching('active', 1);

    $deafultHeaderOptions = array(
      'logo',
      'mini_menu',
      'main_menu',
      'search_box',
    );
    $this->view->loggedInWidgets = $coreSettings->getSetting('twitterclone.header.loggedin.widgets', $deafultHeaderOptions);
    $this->view->loggedOutWidgets = $coreSettings->getSetting('twitterclone.header.loggedout.widgets', $deafultHeaderOptions);
    $this->view->fixedMenu = $fixedMenu = $coreSettings->getSetting('twitterclone.header.menu.fixed', 0);
    $this->view->headerClass = 'twitterclone_fullheader_fixed';
    if( $isSitemenuEnable ) {
      $desktopMenuCount = $coreSettings->getSetting('twitterclone.header.desktop.totalmenu', 6);
      $truncationLimit = 200;
      $showIcons = $coreSettings->getSetting('twitterclone.header.minimenu.design', 1);
      $this->view->menuPosition = $coreSettings->getSetting('twitterclone.header.menu.position', 1);

      $this->view->menuParams = array(
        'sitemenu_on_logged_out' => 1,
        'sitemenu_is_fixed' => 1,
      );

      $this->view->miniMenuParams = array(
        'sitemenu_show_icon' => $showIcons,
        'sitemenu_show_in_mini_options' => 6,//IN CASE OF 6 ADV MENU SEARCH BAR WILL NOT BE SHOWN IN HEADER
        'sitemenu_location_box_width' => '' //set the width blank to override width of Sitemenu/widgets/menu-mini/index.tpl line 447 
      );
    }
  }

}
