<?php

/**
 * SocialEngine
 *
 * @category   Application_Widget
 * @package    Weather
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 * @version    $Id: Controller.php 9747 2012-07-26 02:08:08Z john $
 * @author     John
 */

/**
 * @category   Application_Widget
 * @package    Weather
 * @copyright  Copyright 2006-2010 Webligo Developments
 * @license    http://www.socialengine.com/license/
 */
class Widget_ThemecolorsController extends Engine_Content_Widget_Abstract
{

  protected $_allowedThemes = array();

  public function indexAction()
  {

    $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
    $themeName = $themeTable->select()
      ->from($themeTable->info('name'), 'name')
      ->where('active = ?', 1)
      ->query()
      ->fetchColumn()
    ;
    $themes = array();
    $this->view->cookieName = $cookieName = $themeName . '_seao_theme_color';
    $activeColorThemeInfo = array();

    foreach( glob(APPLICATION_PATH . '/application/themes/' . $themeName . '/*', GLOB_ONLYDIR) as $dir ) {
      if( file_exists("$dir/manifest.php") && is_readable("$dir/manifest.php") && file_exists("$dir/theme.css") && is_readable("$dir/theme.css") ) {
        $name = basename($dir);
        $meta = include("$dir/manifest.php");
        $themes[$name] = $meta;
        if( !empty($_COOKIE[$cookieName]) && $_COOKIE[$cookieName] == $name ) {
          $activeColorThemeInfo[$name] = $meta;
        }
      }
    }
    $this->view->themes = $themes;
    if( empty($themes) ) {
      return $this->setNoRender();
    }
    $this->view->widgetParams = $this->_getAllParams();

    $layout = $this->view->layout();
    foreach( $activeColorThemeInfo as $colorName => $activeMeta ) {
      $themeColorName = $themeName . '/' . $colorName;
      $themes = array();
      foreach( $layout->themes as $key => $theme ) {
        if( $theme == $themeName ) {
          $theme = $themeColorName;
        }
        $themes[$key] = $theme;
      }
      $layout->themes = $themes;
      $themesInfo = $layout->themesInfo;
      $themesInfo[$theme] = $activeMeta;
      $layout->themesInfo = $themesInfo;
      Zend_Registry::set('Themes', $themesInfo);
    }
  }

  public function chooseAction()
  {
    $themeColor = $this->_getParam('color');
    if( !$themeColor ) {
      return;
    }
    $format = $this->_getParam('format', '');
    $themeTable = Engine_Api::_()->getDbtable('themes', 'core');
    $themeName = $themeTable->select()
      ->from($themeTable->info('name'), 'name')
      ->where('active = ?', 1)
      ->query()
      ->fetchColumn()
    ;
    $name = $themeName . '_seao_theme_color';
    $_COOKIE[$name] = $themeColor;
    setcookie($name, $themeColor, 0, _ENGINE_R_BASE);
    $this->view->status = true;
    if( !$format ) {
       $redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('redirector');
       $redirector->gotoUrl($this->view->baseUrl());
    }
  }

}