<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    PagesSitereviewBlogsCategories.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_BlogsSitereviewCategories extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_toTableTruncate = false;
    protected $_priority = 5001;
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'blog_category';
        $this->_toTable = 'engine4_sitereview_categories';
        $this->_warningMessage = array("key" => 'escape', 'value' => '');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON BLOG LISTING
        if ($this->getParam('import_blog_seblog') == 1)
            return false;

        $listingtype_id = $this->getParam('listingtypes');

        if ($listingtype_id == 0)
            return false;

        //MAKING CATEGORY ARRAY FOR INSERTION
        $newData = array();
        $newData['category_name'] = $this->getPharseLabel($data['name']);
        //$newData['cat_order'] = $data['ordering'];
        $newData['listingtype_id'] = $listingtype_id;
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_marketplace_category` (
  `category_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `name_url` varchar(255) DEFAULT NULL,
  `time_stamp` int(10) unsigned NOT NULL DEFAULT '0',
  `used` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`category_id`),
  KEY `parent_id` (`parent_id`,`is_active`),
  KEY `is_active` (`is_active`,`name_url`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */

/*
 * CREATE TABLE IF NOT EXISTS `engine4_classified_categories` (
  `category_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) unsigned NOT NULL,
  `category_name` varchar(128) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`category_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
 */