<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    PagesSitegroupsCategories.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_PagesSitegroupCategories extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_fromWhere = array('type_id=?' => 3);
    protected $_priority = 4001;
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_truncateTable($this->getToDb(), 'engine4_sitegroup_profilemaps');
        $this->_fromTable = $this->getFromPrefix() . 'pages_category';
        $this->_toTable = 'engine4_sitegroup_categories';
        $this->_warningMessage = array("key" => 'groupkit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Groups Blogs, PHPfox Groups Music and PHPfox Groups Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install <a target="_blank" href="http://www.socialengineaddons.com/socialengine-groups-communities-plugin" >Groups - Product Kit </a> on your SocialEngine PHP site to fix this warning. ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON GROUP COMMUNITY PLUGIN
        if ($this->getParam('import_group_segroup', 1) == 1)
            return false;

        //MAKING CATEGORY ARRAY FOR INSERTION
        $newData = array();
        $newData['category_id'] = $data['category_id'];
        $newData['category_name'] = $this->getPharseLabel($data['name']);
        $newData['cat_order'] = $data['ordering'];
        //MAP COTEGORY WITH DEFAULT PROFILE TYPE
        $this->getToDb()->insert('engine4_sitegroup_profilemaps', array(
            'category_id' => $data['category_id'],
            'profile_type' => 1
        ));
        return $newData;
    }

}

/*
 
 */