<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SeaocoreUserInfo.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SeaocoreUserInfo extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_priority = 1100;
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'user_featured';
        $this->_toTable = 'engine4_seaocore_userinfo';
        $this->_warningMessage = array("key" => 'escape', 'value' => '');
    }

    protected function _translateRow(array $data, $key = null) {

        //MAKING RATING ARRAY FOR INSERTION
        $rating = $this->getMemberRating($data['user_id']);
        $newData = array(
            'user_id' => $data['user_id'],
            'rating_avg' => $rating,
            'rating_users' => $rating,
            'review_count' => 0
        );
        if ($this->_columnExist($this->getToTable(), 'featured')) {
            $featured = $this->isMemberFeatured($data['user_id']);
            $newData['featured'] = $featured;
        }
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_user_featured` (
  `user_id` int(10) unsigned NOT NULL,
  `ordering` tinyint(2) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

 */


/*
 * CREATE TABLE IF NOT EXISTS `engine4_seaocore_userinfo` (
`userinfo_id` int(11) NOT NULL,
  `user_id` int(32) NOT NULL,
  `rating_avg` float NOT NULL,
  `rating_users` float NOT NULL,
  `review_count` int(11) NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `sponsored` tinyint(3) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */