<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    VideoRating.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitealbumRatings extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_priority = 90;
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'photo_rating';
        $this->_toTable = 'engine4_sitealbum_ratings';
        $this->_warningMessage = array("key" => 'sitealbum', 'value' => '<span style="font-weight:bolder;">Warning:</span> Your PHPfox Featured Album and Album ratings content are not migrated into SocialEngine PHP. You may ignore this warning or you can install <a target="_blank" href="http://www.socialengineaddons.com/socialengine-advanced-photo-albums-plugin" >Advanced Photo Albums Plugin </a> on your SocialEngine PHP site to fix this warning. ', 'class' => 'Advanced Photo Albums');
    }

    protected function _translateRow(array $data, $key = null) {

        //CHECKING PHOTO EXIST OR NOT.
        $isPhotoExist = $this->getToDb()->select()->from('engine4_album_photos', 'photo_id')
                ->where('photo_id = ?', $data['photo_id'])
                ->query()
                ->fetchColumn(0);
        if ($isPhotoExist === false)
            return false;
        //MAKING RATING ARRAY FOR INSERTION
        $newData = array();
        $newData['resource_id'] = $data['photo_id'];
        $newData['resource_type'] = 'album_photo';
        $newData['user_id'] = $data['user_id'];
        $newData['rating'] = (int) $data['rating'] / 2;
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_video_rating` (
  `rate_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `rating` decimal(4,2) NOT NULL DEFAULT '0.00',
  `time_stamp` int(10) unsigned NOT NULL,
  PRIMARY KEY (`rate_id`),
  KEY `item_id` (`item_id`,`user_id`),
  KEY `item_id_2` (`item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */


/*
 * CREATE TABLE IF NOT EXISTS `engine4_video_ratings` (
  `video_id` int(10) unsigned NOT NULL,
  `user_id` int(9) unsigned NOT NULL,
  `rating` tinyint(1) unsigned DEFAULT NULL,
  PRIMARY KEY (`video_id`,`user_id`),
  KEY `INDEX` (`video_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
 */