<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitegroupvideoVideos.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitegroupvideoVideos extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_fromWhere = array('in_process=?' => 0);
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'video';
        $this->_toTable = 'engine4_sitegroupvideo_videos';
        $this->_warningMessage = array("key" => 'groupkit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Groups Blogs, PHPfox Groups Music and PHPfox Groups Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install <a target="_blank" href="http://www.socialengineaddons.com/socialengine-groups-communities-plugin" >Groups - Product Kit </a> on your SocialEngine PHP site to fix this warning. ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON GROUP COMMUNITY PLUGIN
        if ($this->getParam('import_group_segroup', 1) == 1)
            return false;
        $pageId = $data['item_id'];
        //CHECKING FOR GROUP VIDEO , IF NOT THEN RETURN FALSE.
        if ($data['module_id'] == 'pages') {
            $type_id = $this->getFromDb()->select()
                    ->from($this->getfromPrefix() . 'pages', 'type_id')
                    ->where('page_id = ?', $data['item_id'])
                    ->query()
                    ->fetchColumn();
        } else if ($data['module_id'] == 'event') {
            $pageInfo = $this->getFromDb()->select()
                    ->from($this->getfromPrefix() . 'event', null)
                    ->join($this->getfromPrefix() . 'pages', $this->getfromPrefix() . 'event.item_id=' . $this->getfromPrefix() . 'pages.page_id', array('page_id', 'type_id'))
                    ->where('event_id = ?', $data['item_id'])
                    ->where($this->getfromPrefix() . 'event.module_id = ?', 'pages')
                    ->where($this->getfromPrefix() . 'event.item_id <> ?', 0)
                    ->query()
                    ->fetch();
            if ($pageInfo) {
                $pageId = $pageInfo['page_id'];
                $type_id = $pageInfo['type_id'];
            } else
                return false;
        } else
            return false;

        if ($type_id != 3)
            return false;

        $newData = array();

        //GET VIDEO URL
        $video_url = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'video_embed', 'video_url')
                ->where('video_id = ?', $data['video_id'])
                ->query()
                ->fetchColumn();

        //GET RATING
        $rating = $data['total_score'];

        //Get Owner UserId
        $userId = $this->getFromDb()->query("SELECT  " . $this->getfromPrefix() . "pages.user_id FROM " . $this->getfromPrefix() . "user left join  " . $this->getfromPrefix() . "pages on page_id=profile_page_id where profile_page_id<>0 and  " . $this->getfromPrefix() . "user.user_id=" . $data['user_id'])
                ->fetchColumn(0);
        if ($userId)
            $data['user_id'] = $userId;

        //GET VIDEO DESCRIITION
        $description = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'video_text', 'text')
                ->where('video_id = ?', $data['video_id'])
                ->query()
                ->fetchColumn();

        //MAKING VIDEO ARRAY FOR INSERTION
        $newData['video_id'] = $data['video_id'];
        $newData['group_id'] = $pageId;
        $newData['search'] = 1;
        $newData['owner_id'] = $data['user_id'];
        $newData['creation_date'] = $this->_translateTime($data['time_stamp']);
        $newData['modified_date'] = $this->_translateTime($data['time_stamp']);
        $newData['view_count'] = $data['total_view'];
        $newData['comment_count'] = $data['total_comment'];
        $newData['rating'] = $rating ? (int) ($rating / 2) : 0;
        $newData['status'] = 1;
        $newData['like_count'] = $data['total_like'];
        $newData['featured'] = $data['is_featured'];

        //CHECKING VIDEO SOURCE AND PREPARING ARRAY ACCOURDING TO THAT.
        if ($video_url && (strpos($video_url, 'vimeo') || (strpos($video_url, 'youtube') || strpos($video_url, 'youtu.be'))) && $data['is_stream'] == 1) {

            if (strpos($video_url, 'vimeo')) {
                $pathInfo = @pathinfo($video_url);
                $video_code = $pathInfo['basename'];
                $newData['code'] = $video_code;
                $newData['type'] = 2;
                $vimeodata = simplexml_load_file("http://vimeo.com/api/v2/video/" . $video_code . ".xml");
                $newData['title'] = '';
                $newData['description'] = '';
                $newData['duration'] = '';
                if (!is_null($vimeodata) && !is_null($vimeodata->video)) {
                    $newData['title'] = ($vimeodata->video->title);
                    $newData['description'] = $vimeodata->video->description;
                    $newData['duration'] = $vimeodata->video->duration;
                }
            } elseif (strpos($video_url, 'youtube') || strpos($video_url, 'youtu.be')) {
                $new_code = @pathinfo($video_url);
                $youtube = "http://www.youtube.com/oembed?url=" . $video_url;
                $ydata = @file_get_contents($youtube);
                $decoded_data = json_decode($ydata);
                $newData['title'] = (is_null($decoded_data) || is_null($decoded_data->title)) ? '' : ($decoded_data->title);
                $url = preg_replace("/#!/", "?", $video_url);
                $newData['type'] = 1;
                // get v variable from the url
                $arr = array();
                $arr = @parse_url($url);
                if ($arr['host'] === 'youtu.be') {
                    $ydata = explode("?", $new_code['basename']);
                    $code = $ydata[0];
                    $newData['code'] = $code;
                } else {
                    $parameters = $arr["query"];
                    parse_str($parameters, $decoded_data);

                    $code = $decoded_data['v'];
                    if ($code == "") {
                        $code = $new_code['basename'];
                    }
                    $newData['code'] = $code;
                }
            }
        } else if ($data['is_stream'] == 0) {
            $newData['type'] = 3;
            $newData['code'] = '';
            $newData['title'] = is_null($data['title']) ? '' : ($data['title']);
            $newData['description'] = $description ? $description : '';
            //list($minutes, $seconds) = preg_split('[:]', $data['duration']);
            $minutes = 0;
            $seconds = 0;
            $dArr = explode(':', $data['duration']);
            if (count($dArr) >= 2) {
                $minutes = $dArr[0];
                $seconds = $dArr[1];
            } else if (count($dArr) == 1) {
                $minutes = $dArr[0];
                $seconds = 0;
            }
            $duration = ceil($seconds + ($minutes * 60));
            $newData['duration'] = $duration;
            if ($data['destination']) {
                $file = $this->getFromPath() . DIRECTORY_SEPARATOR . 'file/video' . DIRECTORY_SEPARATOR . $data['destination'];
                //CREATING THE FILE OF THIS VIDEO
                try {
                    $file_id = $this->_translateFile($file, array(
                        'parent_type' => 'video',
                        'parent_id' => $data['video_id'],
                        'user_id' => $data['user_id'],
                            ), true);
                } catch (Exception $e) {
                    $file_id = null;
                    $this->_warning($e->getMessage(), 1);
                }

                $newData['file_id'] = $file_id;
            }
        }
        $newData['duration'] = (!isset($newData['duration']) || is_null($newData['duration'])) ? '' : $newData['duration'];
        $newData['description'] = (!isset($newData['description']) || is_null($newData['description'])) ? '' : $newData['description'];

        //CREATING THE MAIN VIDEO PHOTO IF EXIST.
        if ($data['image_path']) {
            $des = explode('%s', $this->getFromPath() . DIRECTORY_SEPARATOR . 'file/pic/video' . DIRECTORY_SEPARATOR . $data['image_path']);
            $file = $des[0];
                if (isset($des[1])) {
                    $file = $this->getPhotoUrl($des[0], $des[1]);
                    if (empty($file))
                        $file = $des[0] . $des[1];
                }
            
            //$file = $des[0] . '_120' . $des[1];
            if ($file) {
                //CREATING THE FILE FOR THIS PHOTO
                try {
                    if ($this->getParam('resizePhotos', true)) {
                        $file_id = $this->_translatePhoto($file, array(
                            'parent_type' => 'sitegroupvideo_video',
                            'parent_id' => $data['video_id'],
                            'user_id' => $data['user_id'],
                        ));
                    } else {
                        $file_id = $this->_translateFile($file, array(
                            'parent_type' => 'sitegroupvideo_video',
                            'parent_id' => $data['video_id'],
                            'user_id' => $data['user_id'],
                                ), true);
                    }
                } catch (Exception $e) {
                    $file_id = null;
                    $this->_warning($e->getMessage(), 1);
                }

                $newData['photo_id'] = $file_id;
            }
        }

        //PRIVACY
        try {
            $this->_insertPrivacy('sitegroupvideo_video', $data['video_id'], 'view', $this->_translateVideoPrivacy($data['privacy']));
            $this->_insertPrivacy('sitegroupvideo_video', $data['video_id'], 'comment', $this->_translateVideoPrivacy($data['privacy_comment']));
        } catch (Exception $e) {
            $this->_error('Problem adding privacy options for object id ' . $data['video_id'] . ' : ' . $e->getMessage());
        }

        //SEARCH
        if (@$newData['search']) {
            $this->_insertSearch('sitegroupvideo_video', @$newData['video_id'], @$newData['title'], @$newData['description']);
        }

        return $newData;
    }

}

/*
CREATE TABLE IF NOT EXISTS `phpfox_video` (
  `video_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `in_process` tinyint(1) NOT NULL DEFAULT '0',
  `is_stream` tinyint(1) NOT NULL DEFAULT '0',
  `is_featured` tinyint(1) NOT NULL DEFAULT '0',
  `is_spotlight` tinyint(1) NOT NULL DEFAULT '0',
  `is_sponsor` tinyint(1) NOT NULL DEFAULT '0',
  `view_id` tinyint(1) NOT NULL DEFAULT '0',
  `module_id` varchar(75) DEFAULT NULL,
  `item_id` int(10) unsigned NOT NULL DEFAULT '0',
  `privacy` tinyint(1) NOT NULL DEFAULT '0',
  `privacy_comment` tinyint(1) NOT NULL DEFAULT '0',
  `title` varchar(255) DEFAULT NULL,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `parent_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `destination` varchar(75) DEFAULT NULL,
  `server_id` tinyint(1) NOT NULL DEFAULT '0',
  `file_ext` varchar(10) DEFAULT NULL,
  `duration` varchar(8) DEFAULT NULL,
  `resolution_x` varchar(4) DEFAULT NULL,
  `resolution_y` varchar(4) DEFAULT NULL,
  `image_path` varchar(75) DEFAULT NULL,
  `image_server_id` tinyint(1) NOT NULL DEFAULT '0',
  `total_comment` int(10) unsigned NOT NULL DEFAULT '0',
  `total_like` int(10) unsigned NOT NULL DEFAULT '0',
  `total_dislike` int(10) unsigned NOT NULL DEFAULT '0',
  `total_score` decimal(4,2) NOT NULL DEFAULT '0.00',
  `total_rating` int(10) unsigned NOT NULL DEFAULT '0',
  `time_stamp` int(10) unsigned NOT NULL DEFAULT '0',
  `total_view` int(10) unsigned NOT NULL DEFAULT '0',
  `is_viewed` tinyint(1) NOT NULL DEFAULT '0',
  `custom_v_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`video_id`),
  KEY `in_process` (`in_process`),
  KEY `user_id` (`user_id`),
  KEY `view_id` (`view_id`),
  KEY `in_process_2` (`in_process`,`view_id`,`item_id`,`privacy`),
  KEY `in_process_3` (`in_process`,`view_id`,`item_id`,`user_id`),
  KEY `in_process_4` (`in_process`,`view_id`,`item_id`,`privacy`,`title`),
  KEY `in_process_5` (`in_process`,`view_id`,`item_id`,`privacy`,`user_id`),
  KEY `in_process_6` (`in_process`,`view_id`,`privacy`,`title`),
  KEY `custom_v_id` (`custom_v_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */


/*
CREATE TABLE IF NOT EXISTS `phpfox_video_category` (
  `category_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `time_stamp` int(10) unsigned NOT NULL DEFAULT '0',
  `used` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`category_id`),
  KEY `parent_id` (`parent_id`,`is_active`),
  KEY `is_active` (`is_active`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_video_category_data` (
  `video_id` int(10) unsigned NOT NULL,
  `category_id` int(10) unsigned NOT NULL,
  KEY `category_id` (`category_id`),
  KEY `video_id` (`video_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
 */

/*
 * 
CREATE TABLE IF NOT EXISTS `engine4_sitegroupvideo_videos` (
`video_id` int(11) unsigned NOT NULL,
  `group_id` int(11) NOT NULL,
  `title` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `description` text COLLATE utf8_unicode_ci NOT NULL,
  `search` tinyint(1) NOT NULL DEFAULT '1',
  `owner_id` int(11) NOT NULL,
  `creation_date` datetime NOT NULL,
  `modified_date` datetime NOT NULL,
  `view_count` int(11) unsigned NOT NULL DEFAULT '1',
  `comment_count` int(11) unsigned NOT NULL DEFAULT '0',
  `type` tinyint(1) NOT NULL,
  `code` varchar(150) COLLATE utf8_unicode_ci NOT NULL,
  `photo_id` int(11) unsigned DEFAULT NULL,
  `rating` float NOT NULL,
  `like_count` int(11) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `highlighted` tinyint(1) NOT NULL,
  `featured` tinyint(1) NOT NULL,
  `file_id` int(11) unsigned NOT NULL,
  `duration` int(9) unsigned NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */