<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitememberRatings.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitememberRatings extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_priority = 1000;

    protected function _initPre() {
        $this->_truncateTable($this->getToDb(), 'engine4_sitemember_reviews');
        $this->_truncateTable($this->getToDb(), 'engine4_sitemember_reviewdescriptions');
        $this->_fromTable = $this->getFromPrefix() . 'user_rating';
        $this->_toTable = 'engine4_sitemember_ratings';
        $this->_warningMessage = array("key" => 'sitemember', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Member rating content are not migrated into SocialEngine PHP. You may ignore this warning or you can install <a target="_blank" href="http://www.socialengineaddons.com/socialengine-advanced-members-plugin-better-browse-search-user-reviews-ratings-location" >Advanced Members Plugin - Better Browse & Search, User Reviews, Ratings & Location plugin </a> on your SocialEngine PHP site to fix this warning. ');
    }

    protected function _translateRow(array $data, $key = null) {

        //PREPARING ARRAY FOR MEMBER REVIEW
        $reviewData = array(
            'type' => 'user',
            'resource_id' => $data['item_id'],
            'resource_type' => 'user',
            'owner_id' => $data['user_id'],
            'title' => '',
            'body' => '',
            'creation_date' => $this->_translateTime($data['time_stamp']),
            'modified_date' => $this->_translateTime($data['time_stamp']),
            'pros' => '',
            'cons' => '',
            'body_pages' => '',
            'update_reason' => ''
        );
        // INSERTION OF MEMBER REVIEW
        $this->getToDb()->insert('engine4_sitemember_reviews', $reviewData);
        $reviewId = $this->getToDb()->lastInsertId();
        $this->_insertUserInfo($data['item_id']);
        //MAKING RATING ARRAY FOR INSERTION
        $newData = array();
        $newData['review_id'] = $reviewId;
        $newData['resource_id'] = $data['item_id'];
        $newData['resource_type'] = 'user';
        $newData['user_id'] = $data['user_id'];
        $newData['rating'] = (int) ($data['rating'] / 2);
        $newData['type'] = 'user';
        $newData['ratingparam_id'] = 0;
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_user_rating` (
`rate_id` int(10) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `rating` decimal(4,2) NOT NULL DEFAULT '0.00',
  `time_stamp` int(10) unsigned NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

 */


/*
 * CREATE TABLE IF NOT EXISTS `engine4_sitemember_ratings` (
`rating_id` int(11) NOT NULL,
  `review_id` int(11) NOT NULL,
  `resource_id` int(11) NOT NULL,
  `resource_type` varchar(64) COLLATE utf8_unicode_ci NOT NULL,
  `user_id` int(11) NOT NULL,
  `ratingparam_id` int(11) NOT NULL,
  `rating` tinyint(1) DEFAULT NULL,
  `type` enum('user') COLLATE utf8_unicode_ci DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */