<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitepageeventCategories.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitepageeventCategories extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'event_category';
        $this->_toTable = 'engine4_sitepageevent_categories';
        $this->_warningMessage = array("key" => 'pagekit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Pages Blogs, PHPfox Pages Music and PHPfox Pages Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install<a target="_blank" href="http://www.socialengineaddons.com/socialengine-directory-pages-plugin" > Directory / Pages and Essential Extensions - Product Kit</a>  on your SocialEngine PHP site to fix this warning.  ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON DIRECTORY/PAGES PLUGIN
        if ($this->getParam('import_group_sepage', 1) == 1)
            return false;

        //MAKING CATEGORY ARRAY FOR INSERTION
        $newData = array();
        $newData['category_id'] = $data['category_id'];
        $newData['title'] = $this->getPharseLabel($data['name']);
        return $newData;
    }

}

/*
 *
CREATE TABLE IF NOT EXISTS `engine4_sitepageevent_categories` (
`category_id` int(11) unsigned NOT NULL,
  `title` varchar(64) COLLATE utf8_unicode_ci NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */

/*
 * 
CREATE TABLE IF NOT EXISTS `phpfox_event_category` (
`category_id` mediumint(8) unsigned NOT NULL,
  `parent_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `name_url` varchar(255) DEFAULT NULL,
  `time_stamp` int(10) unsigned NOT NULL DEFAULT '0',
  `used` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;

 */