<?php

/**
 * SocialEngine
 *
 * @category   Application_Extensions
 * @package    Phpfoximporter
 * @copyright  Copyright 2015-2016 BigStep Technologies Pvt. Ltd.
 * @license    http://www.socialengineaddons.com/license/
 * @version    SitepagevideoRatings.php 2015-07-30 00:00:00Z SocialEngineAddOns $
 * @author     SocialEngineAddOns
 */
class Install_Import_Phpfox_SitepagevideoRatings extends Install_Import_Phpfox_Abstract {

    protected $_fromTable = '';
    protected $_toTable = '';
    protected $_warningMessage = array();

    protected function _initPre() {
        $this->_fromTable = $this->getFromPrefix() . 'video_rating';
        $this->_toTable = 'engine4_sitepagevideo_ratings';
        $this->_warningMessage = array("key" => 'pagekit', 'value' => '<span style="font-weight:bolder;">Warning:</span>  Your PHPfox Pages Blogs, PHPfox Pages Music and PHPfox Pages Videos content are not migrated into SocialEngine PHP. You may ignore this warning or you can install<a target="_blank" href="http://www.socialengineaddons.com/socialengine-directory-pages-plugin" > Directory / Pages and Essential Extensions - Product Kit</a>  on your SocialEngine PHP site to fix this warning.  ');
    }

    protected function _translateRow(array $data, $key = null) {

        //RETURN FALSE IF USER NOT SELECTED TO INSERT DATA INSIDE THE SOCIAL ENGINE ADDON DIRECTORY/PAGES PLUGIN
        if ($this->getParam('import_group_sepage', 1) == 1)
            return false;
        $type_id = $this->getFromDb()->select()
                ->from($this->getfromPrefix() . 'video', null)
                ->join($this->getfromPrefix() . 'pages', $this->getfromPrefix() . 'pages.page_id=' . $this->getfromPrefix() . 'video.item_id', 'type_id')
                ->where($this->getfromPrefix() . 'video.video_id = ?', $data['item_id'])
                ->where($this->getfromPrefix() . 'video.module_id = ?', 'pages')
                ->query()
                ->fetchColumn();

        if (empty($type_id) || $type_id == 3)
            return false;
        //MAKING RATING ARRAY FOR INSERTION
        $newData = array();
        $newData['video_id'] = $data['item_id'];
        $newData['user_id'] = $data['user_id'];
        $newData['rating'] = (int) ($data['rating'] / 2);
        return $newData;
    }

}

/*
 * CREATE TABLE IF NOT EXISTS `phpfox_video_rating` (
  `rate_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `item_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `rating` decimal(4,2) NOT NULL DEFAULT '0.00',
  `time_stamp` int(10) unsigned NOT NULL,
  PRIMARY KEY (`rate_id`),
  KEY `item_id` (`item_id`,`user_id`),
  KEY `item_id_2` (`item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
 */


/*
 * 
CREATE TABLE IF NOT EXISTS `engine4_sitepagevideo_ratings` (
  `video_id` int(10) unsigned NOT NULL,
  `user_id` int(9) unsigned NOT NULL,
  `rating` tinyint(1) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

 */